///////////////////////////////////////////////////////////////////////////
//                                                                       //
// Copyright (c) 1997 ISO/IEC All Rights Reserved                        //
//                                                                       //
// This software module was developed by                                 //
//                                                                       //
// CSELT (Centro Studi e Laboratori Telecomunicazioni S.p.A)             //
//                                                                       //
// in the course of development of the MPEG-4 standard. This software    //
// module is an implementation of a part of one or more MPEG-4 tools as  //
// specified by the MPEG-4 standard.                                     //
//                                                                       //
// The copyright of this software belongs to ISO/IEC. ISO/IEC gives use  //
// of the MPEG-4 standard free license to use this  software module or   //
// modifications thereof for hardware or software products claiming      //
// conformance to the MPEG-4 standard.                                   //
//                                                                       //
// Those intending to use this software module in hardware or software   //
// products are advised that use may infringe existing  patents. The     //
// original developers of this software module and their companies, the  //
// subsequent editors and their companies, and ISO/IEC have no liability //
// and ISO/IEC have no liability for use of this software module or      //
// modification thereof in an implementation.                            //
//                                                                       //
///////////////////////////////////////////////////////////////////////////
//
// File: StreamInfo.h
//
// Author: Matthew Leditschke, Gianluca Di Cagno  gianluca.dicagno@cselt.it
//
// Description:
//   The definition of a class which encapsulates all of the details
//   of an audio stream that is being played by the SGI based
//   audio renderer.
//
// Created: August, 1997.
//
// Modified:
//
///////////////////////////////////////////////////////////////////////////




class AudioSource;


class StreamInfo
{
public:
	DWORD m_startTime;				// When to start playing this buffer
	AudioSource* m_pAudioSrc;		// Pointer to the node to get data from
	DWORD m_bytesPerSample;

	// Constructor, set default values
	StreamInfo(AudioSource* pSrc, DWORD startTime,
			   DWORD bitsPerSample, WORD numChannels)
	{
		m_startTime = startTime;
		m_pAudioSrc = pSrc;
		m_bytesPerSample = bitsPerSample * numChannels / 8;
	}
}; /* class StreamInfo */
