//////////////////////////////////////////////////////////////////////////////
//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
//
// File:  AnchorProxy.cpp
//
// Author:  Gianluca Di Cagno  gianluca.dicagno@cselt.it
//
// Modified: 
//
// Description:
//   The implementation of the proxy object used by the presenter
//   to handle the Anchor node.
//
// Created: January 1999.
//
//
///////////////////////////////////////////////////////////////////////////


#include "defs.h"
#include "MediaObj.h"
#include "Presenter.h"
#include "nodes.h"
#include "AnchorProxy.h"

#ifdef	  ACTIVEX_COMPONENT
#include "Mpeg4Cselt2DActivex.h"

#elif defined (NETSCAPE_PLUGIN)

#else
#include "MPEG4Player.h"
#include "MPEG4PlayerDoc.h"
#include "MPEG4PlayerView.h"



#endif




// =====================================================================

//
// Presenter::InitAnchor
//
// Initialise the proxy data structure and attach it to the render data
// pointer of the given media object node.
//

AnchorProxy* Presenter::InitAnchor(Anchor* pObj)
{
	return new  AnchorProxy(pObj);
}


// =====================================================================

//
// AnchorProxy::~AnchorProxy
//
//  

AnchorProxy::~AnchorProxy()
{
	
}

// =====================================================================

//
// AnchorProxy::PreRender
//
// PreRender the children in the order specified by the Anchor
// order field.
// 
//

void AnchorProxy::PreRender(Effects &effects)
{
	
	int length= GroupNodeProxy::GetObject()->GetChildCount();
	 
	 effects.m_pHandler=(class UserEventHandlerProxy *) this;

	 for (int i = 0; i <length; i++)
		GetChild(i)->PreRender(effects);
	 
	 effects.m_pHandler=NULL;
} /* AnchorProxy::PreRender */

BOOL AnchorProxy::OnUserEvent(EventInfo const* pEvent)
{
		
	// If the button is first pressed, then generate an
	// isActive = TRUE event, and grab all movement events
	if ((pEvent->m_event == EVENT_MOUSE_DOWN)/* && (!m_mouseDown)*/)
		{
			//m_mouseDown = TRUE;
			CString urlString ( (LPCSTR )GetAnchor()->GetUrl(0)->urlValue);
		
			GetView() -> PostMessage(WM_NAVIGATE, NULL,(LPARAM)(LPCSTR )GetAnchor()->GetUrl(0)->urlValue);
			
		}
	return TRUE;
	
}
	



// =====================================================================
