//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
//
// File:  AnchorProxy.h
//
// Author: Gianluca Di Cagno  gianluca.dicagno@cselt.it
//
// Modified:
//
// Description:
//   Anchor node implementation class
//   
//
// Created: January 1999
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef ANCHOR_PROXY_H
#define ANCHOR_PROXY_H


#include "GroupNodeProxy.h"
#include "UserEventHandlerProxy.h"


class AnchorProxy : public GroupNodeProxy,UserEventHandlerProxy
{
public:
	AnchorProxy(MediaObject* pMO): GroupNodeProxy(pMO),UserEventHandlerProxy(pMO){}; 
	~AnchorProxy();
	
	// Return a pointer to the Anchor node that this node is the proxy for
	Anchor* GetAnchor() const { return (Anchor*)GroupNodeProxy::GetObject(); }

	// Functions inherited from the base classes
	void PreRender(Effects &effects);

	BOOL IsFinished() const { return TRUE; }
	BOOL OnUserEvent(EventInfo const* pEvent);
private:

};

#endif // ANCHOR_PROXY_H
