//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
//
// File:  Background2DProxy.h
//
// Author: Matthew Leditschke 
//
// Modified: Gianluca Di Cagno  gianluca.dicagno@cselt.it
//
// Description:
//   The definition of the proxy object used by the presenter
//   to render the Background2D node.
//
// Created: September, 1997.
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef BACKGROUND2D_PROXY_H
#define BACKGROUND2D_PROXY_H

//#include "bindable.h"
#include "DrawableImage.h"

class BindableStack; 
class Background2DProxy : public DrawableImage
{
public:
	Background2DProxy(MediaObject* pMO);
	~Background2DProxy();
    void DeleteObject(); 

	// Return a pointer to the Background2D node that this node is the proxy for
	Background2D* GetBackground2D() const { return (Background2D*)GetObject(); }

	// Functions inherited from the base classes
	//float GetDrawingOrder() const { return BACKGROUND_DEPTH; }
	void PreRender(Effects & effects);
	void Draw(BRect const* pClipBRect,DrawableContext *pDrawableContext);
	//DrawableContext * InitBackgroundContext(Effects &effects);
	BindableStack * GetStack();//{return GetVisualRenderer()->GetBackgroundStack();}

	DrawableContext * GetContext() {return &m_context;}
	void UpdateBoundingRect(DrawableContext * pContext);
	BRect *GetScreenBRect() {return &m_screenBRect;}
	// Private implementation details
private:
	BOOL m_firstTime;
	DrawableContext m_context;
	Color3f m_previousBackColor;
	BRect m_screenBRect;
};


#endif // BACKGROUND2D_PROXY_H
