//////////////////////////////////////////////////////////////////////////////
//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
//
// File:  Bindable.cpp
//
// Author: Gianluca Di Cagno 
//
// 
//
// Description:
//   
//
// Created: February, 2000.
//
//
///////////////////////////////////////////////////////////////////////////


#include "defs.h"
#include "Bindable.h"
//#include "Nodes-CSELT.h"
//#include "Background2DProxy.h"


// ========================================================================

//
// BindableStack::LinearSearch
//
// very simple linear search of the stack for a bindable node

BindableObject *BindableStack::LinearSearch(BindableNode *Bindable)
{
 	for ( BindableObject *pBindable=m_Top;pBindable;pBindable=pBindable->m_Next)
	  if(pBindable->m_Bindable==Bindable)
		  return pBindable;
	return NULL;
}
	

BOOL BindableStack::RemoveBindable(BindableNode *Bindable)
{
	BindableObject *ToRemove=LinearSearch(Bindable);
	if(ToRemove)
	{
		BindableObject * Previous = ToRemove->m_Prev;
		BindableObject * Next = ToRemove->m_Next;
		//Connect previous and next
		
		if (Previous)
			Previous->m_Next= Next;
		if(Next)
			Next->m_Prev=Previous;
		--m_StackLength;
		
		if(m_Top==ToRemove)
			m_Top=Next;
		if(m_Last==ToRemove)
			m_Last=Previous;
		
		delete ToRemove;
		
		return TRUE;
	}
	return FALSE;
}

BOOL BindableStack::MoveToTop(BindableNode *Bindable)
{
		BindableObject *ToMoveOnTop=LinearSearch(Bindable);
		if(ToMoveOnTop)
		{
			BindableObject * Previous = ToMoveOnTop->m_Prev;
			BindableObject * Next = ToMoveOnTop->m_Next;
			//Connect previous and next
			if (Previous)
				Previous->m_Next= Next;
			if(Next)
				Next->m_Prev=Previous;
			//New top			
			m_Top->m_Prev=ToMoveOnTop;
			ToMoveOnTop->m_Next=m_Top;
			//he's the top..
			ToMoveOnTop->m_Prev=NULL;
			m_Top=ToMoveOnTop;
			return TRUE;
		}
		return FALSE;
}

BOOL BindableStack::AddBindable(BindableNode *Bindable)
{
//check if the stack is empty!!!!
	
	BindableObject * ToAdd=new BindableObject;
	ToAdd->m_Bindable=Bindable;
	
	if(m_StackLength==0)
	{
		m_Last=m_Top=ToAdd;
		ToAdd->m_Next=ToAdd->m_Prev=NULL;
	}
	else
	{
		m_Last->m_Next=ToAdd;
		ToAdd->m_Prev=m_Last;
		// we have a new Last, welcome.
		m_Last=ToAdd;
	}
	++m_StackLength;
	
	return TRUE;
}
