//////////////////////////////////////////////////////////////////////////////
//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
//
// File:  Bindable.h
//
// Author: Gianluca Di Cagno 
//
// 
//
// Description:
//   
//
// Created: February, 2000.
//
//
///////////////////////////////////////////////////////////////////////////
#ifndef BINDABLE_H
#define BINDABLE_H


#include "defs.h"
//#include "Nodes-CSELT.h"
#include "Background2DProxy.h"

typedef Background2DProxy BindableNode;

class BindableObject
{
	friend class BindableStack;
	BindableObject(): m_Next(NULL),m_Prev(NULL),m_Bindable(NULL){}

	BindableNode * m_Bindable;
	BindableObject * m_Next;
	BindableObject * m_Prev;

};

class BindableStack
{
	
	BindableObject * m_Top;
	BindableObject * m_Last;
	int m_StackLength;
public :
	BindableStack(): m_StackLength(0),m_Last(NULL),m_Top(NULL){}
	BindableObject *LinearSearch(BindableNode *Bindable);
	BOOL RemoveBindable(BindableNode *Bindable);
	BOOL MoveToTop(BindableNode *Bindable);	
	BOOL AddBindable(BindableNode *Bindable);
	BindableNode* GetTop() {return m_Top->m_Bindable;}
//	BOOL Pop();
	BOOL IsOnTop(BindableNode *Bindable){if(Bindable==m_Top->m_Bindable)return TRUE;else return FALSE;}
	BOOL IsEmpty(){return !m_StackLength;}
};
#endif