///////////////////////////////////////////////////////////////////////////
//                                                                       //
// Copyright (c) 1997 ISO/IEC All Rights Reserved                        //
//                                                                       //
// This software module was developed by                                 //
//                                                                       //
// CSELT (Centro Studi e Laboratori Telecomunicazioni S.p.A)             //
//                                                                       //
// in the course of development of the MPEG-4 standard. This software    //
// module is an implementation of a part of one or more MPEG-4 tools as  //
// specified by the MPEG-4 standard.                                     //
//                                                                       //
// The copyright of this software belongs to ISO/IEC. ISO/IEC gives use  //
// of the MPEG-4 standard free license to use this  software module or   //
// modifications thereof for hardware or software products claiming      //
// conformance to the MPEG-4 standard.                                   //
//                                                                       //
// Those intending to use this software module in hardware or software   //
// products are advised that use may infringe existing  patents. The     //
// original developers of this software module and their companies, the  //
// subsequent editors and their companies, and ISO/IEC have no liability //
// and ISO/IEC have no liability for use of this software module or      //
// modification thereof in an implementation.                            //
//                                                                       //
///////////////////////////////////////////////////////////////////////////
//
// File:  FontStyle2DProxy.h
//
// Authors: Antonio Arena, CSELT, arena@kim.cselt.it
//			Franco Casalino, CSELT, Franco.Casalino@cselt.it
//
// Description:
//   The definition of the proxy object used by the presenter
//   to render the FontStyle2D node.
//
// Created: September, 1997.
//
// Modified:
//
///////////////////////////////////////////////////////////////////////////


#ifndef FONT_STYLE2D_PROXY_H
#define FONT_STYLE2D_PROXY_H


#include "Traversable.h"


class FontStyle2DProxy : public Traversable
{
public:
	FontStyle2DProxy(MediaObject* pMO) : Traversable(pMO) {}

	// Return a pointer to the FontStyle2D node that this node is the proxy for
	FontStyle2D* GetFontStyle2D() const
	{ return (FontStyle2D*)GetObject(); }

	// Functions inherited from the base class
	void PreRender(Effects & /*effects*/) {}
	BOOL IsFinished() const { return TRUE; }
};


#endif // FONT_STYLE2D_PROXY_H
