//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
//
// File:  FormProxy.h
//
// Author: Gianluca Di Cagno  gianluca.dicagno@cselt.it
//
// Modified:
//
// Description:
//   Form node implementation class
//   
//
// Created: February 1999
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef FORM_PROXY_H
#define FORM_PROXY_H


#include "GroupNodeProxy.h"
#include "DrawableContext.h"
#include "Constraint.h"

class FormProxy : public GroupNodeProxy
{
public:
	FormProxy(MediaObject* pMO); 
	~FormProxy();
	
	DECLARE_CONSTRAINT(AL);
	DECLARE_CONSTRAINT(AH);
	DECLARE_CONSTRAINT(AR);
	DECLARE_CONSTRAINT(AT);
	DECLARE_CONSTRAINT(AV);
	DECLARE_CONSTRAINT(AB);

	DECLARE_CONSTRAINT(SH);
	DECLARE_CONSTRAINT(SHin);
	DECLARE_CONSTRAINT(SV);
//	DECLARE_CONSTRAINT(SVin);


	// Return a pointer to the Form node that this node is the proxy for
	Form* GetForm() const { return (Form*)GroupNodeProxy::GetObject(); }

	// Functions inherited from the base classes
	void PreRender(Effects &effects);
	BOOL IsFinished() const { return TRUE; }
	void ApplyConstraint(ZString zsConstraint,const int * iSetOfNodes,int iSetLength);
	static void StoreFactory(int i,ConstraintsFactoryBase*pFactory) {TheConstraintsFactory[i]=pFactory;}
	int	 GetNumberOfFormChildren() {return m_numberOfContexts-1;}
	BOOL GetNextSetFromGroupsIndex(const int *&pSetOfNodes,int &iNumberOfObjects);	
	BOOL GetGroupsFieldByIndex(const int *& pGroups,int &iNumberOfChildren,int index);
	void CreateFormContext(Effects &effects);
	void CreateJointGroupsAndGroupsIndexList(const int * pGroups,int &iNumberOfChildren);
private:
	 
	int m_formWidth,m_formHeight;
	int m_nAllocatedLength,m_nLength;
	 static ConstraintsFactoryBase	 *TheConstraintsFactory[];

	 	// a list of pointers to child DrawableContext useful for processing 
	// layout and form information.
	int *m_IndexOfChildrenToApply;
	 
};

#endif // Form_PROXY_H
