//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
//
// File:  GroupNodeProxy.h
//
// Author: Matthew Leditschke 
//
// Modified: Gianluca Di Cagno  gianluca.dicagno@cselt.it
//
// Description:
//   The definition of a class which encapsulates all of the features
//   of a node which are common to nodes which have children.
//
// Created: September, 1997.
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef GROUP_NODE_PROXY_H
#define GROUP_NODE_PROXY_H


#include "Traversable.h"


class GroupNodeProxy : public Traversable
{
public:
	GroupNodeProxy(MediaObject* pMO) : Traversable(pMO), m_drawableContextList(NULL),
									   m_numberOfContexts(0), m_ContextListSize(0){}

	// Return a pointer to the GroupNode node that is the base class of
	// the node that this is the proxy for
	//MediaObject* GetGroupNode() const { return (MediaObject*)GetObject(); }
	Traversable* GetChild(int n)
	{ return (Traversable*)(*GetObject()->GetChildrenField())[n]->GetRenderingObject(); }
	Traversable* GetChild(int n) const
	{ return (Traversable*)(*GetObject()->GetChildrenField())[n]->GetRenderingObject(); }
	
	// Functions inherited from the base class
	virtual void UpdateTimeSensor();
	BOOL IsFinished() const;
	void AddToDrawableContextList(DrawableContext* pDrawableContext);	

  virtual void SetFlexTime(const PresenterContext &pcCurrentTime); // #GB:

	// Methods to be called only by classes deriving from this class
protected:
	void PreRenderChildren(Effects & effects);
	

	DrawableContext * *m_drawableContextList;
	int m_numberOfContexts;
	int m_ContextListSize;
	DrawableContext  m_drawableContext;
};


#endif // GROUP_NODE_PROXY_H
