///////////////////////////////////////////////////////////////////////////////////
//                                                                               //
// Copyright (c) 1997 ISO/IEC All Rights Reserved                                //
//                                                                               //
// This software module was developed by                                         //
//                                                                               //
// CSELT (Centro Studi e Laboratori Telecomunicazioni S.p.A) (ESPRIT MPEG-4 PC)  //
//                                                                               //
// in the course of development of the MPEG-4 standard. This software module is  //
// an implementation of a part of one or more MPEG-4 tools as specified by the   //
// MPEG-4 standard.                                                              //
//                                                                               //
// The copyright of this software belongs to ISO/IEC. ISO/IEC gives use of the   //
// MPEG-4 standard free license to use this  software module or modifications    //
// thereof for hardware or software products claiming conformance to the         //
// MPEG-4 standard.                                                              //
//                                                                               //
// Those intending to use this software module in hardware or software           //
// products are advised that use may infringe existing  patents. The             //
// original developers of this software module and their companies, the          //
// subsequent editors and their companies, and ISO/IEC have no liability         //
// and ISO/IEC have no liability for use of this software module or              //
// modification thereof in an implementation.                                    //
//                                                                               //
///////////////////////////////////////////////////////////////////////////////////
#include "defs.h"
#include "Nodes-CSELT.h"
#include "InlineProxy.h"

#include "GroupProxy.h"

InlineProxy* Presenter::InitInline(InlineImp* pObj)
{
	return new InlineProxy(pObj); 
}

void InlineProxy ::PreRender(Effects & effects )
{
	Root* pGroupNode = ((InlineImp*) GetObject ()) -> GetScene() ;
	if (pGroupNode)
		((Traversable*)pGroupNode ->GetRenderingObject()) -> PreRender (effects);
} 

BOOL InlineProxy :: Render  (NodeField *, void *pContext)
{
	if ( ((InlineImp*)GetInline())->GetScene() == NULL_OBJECT)
		return TRUE;
	return ((InlineImp*)GetInline())->GetScene() -> Render  ((PresenterContext *)pContext);
}

// Ananda - function called really often so...
void InlineProxy::UpdateTimeSensor()
{

	
	
	MediaObject* pGroupNode = ((InlineImp*) GetObject ()) -> GetScene() ;

   if (pGroupNode == NULL)
			return;

   MFGenericNode *pChildren   = pGroupNode->GetChildrenField();
   int            nNbChildren = pChildren->GetLength();

	for (int i = 0; i < nNbChildren; i++)
	{
		MediaObject* p= (*pChildren)[i];
		Traversable* trav = (Traversable*) p->GetRenderingObject();
		trav->UpdateTimeSensor();
	}
}

/*
void InlineProxy :: UpdateTimeSensor()
{
	GroupNode* pGroupNode = ((InlineImp*) GetObject ()) -> m_pSubScene;
	if (pGroupNode == NULL)
			return;
	for (int i = 0; i < pGroupNode->GetChildren().GetLength(); i++)
	{
		MediaObject* p= pGroupNode->GetChildren()[i];
		Traversable* trav = (Traversable*) p->GetRenderingObject(&pGroupNode->GetChildren()); 
		
	
		//Traversable* trav = GetChild(i);
		trav->UpdateTimeSensor();
	}
}
*/
/* InlineProxy::UpdateTimeSensor */

