//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
//
// File:  LinePropertiesProxy.h
//
// Author: Gialuca Di Cagno,CSELT 
//
// Modified: Gianluca.DiCagno@cselt.it
//
// Description:
//   The definition of the proxy object used by the presenter
//   to render the LineProperties node.
//
// Created: November, 1997.
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef LINEPROPERTIES_PROXY_H
#define LINEPROPERTIES_PROXY_H





class LinePropertiesProxy : public Traversable
{
public:
	LinePropertiesProxy(MediaObject* pMO) : Traversable(pMO) {}

	// Return a pointer to the LineProperties node that this node is the proxy for

	LineProperties* GetLineProperties() const { return (LineProperties * )GetObject(); }

	// Functions inherited from the base class

	void PreRender(Effects & /*effects*/) {} 
	BOOL IsFinished() const { return TRUE; }
};


#endif // LINEPROPERTIES_PROXY_H
