#ifndef _libMPEG4dec_h
#define _libMPEG4dec_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Decoder
FILE:       JPEGDec.h
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Definition of JPEGDecoder (simulation)
-------------------------------------------------------------------------*/
#include "Decoder.h"
#include "Caps.h"
#include "libMPEG4dec.h"


class MPEG4Decoder : public Decoder
{
public:
	virtual FORMAT SetFormat (Capabilities *pPresentationCapabilities);
	virtual int GetOptimalInputSize () ;
	virtual int GetOptimalOutputSize () ;
	virtual int GetRecommendedInputBufferSize () ;
	virtual int GetRecommendedOutputBufferSize () ;
	virtual BOOL Decode (
		LPBYTE pInput,
		int nInputLength,
		LPBYTE pOutput,
		int &rnOutputLength
	);
public:
	MPEG4Decoder (class Executive *pExecutive);
	~MPEG4Decoder();

private:
	Mpeg4DecoderHandle m_decoderHandle;
	Mpeg4DecoderFrame m_decoderFrame;
	BOOL m_firstCall;
	BOOL m_lastReturnValue;

};

#endif // _libMPEG4dec_h
