// MPEG4PlayerDoc.h : interface of the CMPEG4PlayerDoc class
//
/////////////////////////////////////////////////////////////////////////////
enum BROWSER{HTML,MPEG,UNKNOWN};

class CMPEG4PlayerDoc : public CDocument
{


protected: // create from serialization only
	CMPEG4PlayerDoc();
	DECLARE_DYNCREATE(CMPEG4PlayerDoc)

// Attributes
public:
	// The name of the file being read from
	CString m_fileName;

	// TRUE if a file has been opened, FALSE once it is closed
	BOOL m_fileOpened;
	BOOL m_webFileOpened;

// Operations
public:
	void CloseDocument();
	BOOL OpenDocument();
	BOOL DocumentNeedsOpening();
	BOOL IsFileOpen() const { return m_fileOpened; }
	BROWSER AnalyzeUrl(const CString);	

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMPEG4PlayerDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual void OnCloseDocument();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMPEG4PlayerDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMPEG4PlayerDoc)
	afx_msg void OnFileRestart();
	afx_msg void OnUpdateFileRestart(CCmdUI* pCmdUI);
	afx_msg void OnFileOpenNetwork();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
