// MPEG4PlayerView.cpp : implementation of the CMPEG4PlayerView class
//

#include "defs.h"
#include "Im1defs.h"
#include "trace.h"
#include "Presenter.h"
#include "MPEG4Player.h"
#include "MPEG4PlayerDoc.h"
#include "MPEG4PlayerView.h"
#include <webbrowser2.h>  

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMPEG4PlayerView

IMPLEMENT_DYNCREATE(CMPEG4PlayerView, CView)

BEGIN_MESSAGE_MAP(CMPEG4PlayerView, CView)
	//{{AFX_MSG_MAP(CMPEG4PlayerView)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_SYSCHAR()
	ON_WM_SYSDEADCHAR()
	ON_WM_SYSKEYDOWN()
	ON_WM_SYSKEYUP()
	ON_WM_CHAR()
	ON_WM_DEADCHAR()
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()
	ON_MESSAGE(WM_SCENE_FINISHED,  OnSceneFinished)
	ON_MESSAGE(WM_NON_FATAL_ERROR, OnNonFatalError)
	ON_MESSAGE(WM_DDRAW_PROBLEM, OnDDrawProblem)
	ON_WM_PAINT()
	ON_WM_CREATE()
	ON_MESSAGE(WM_WEB_NAVIGATE, OnWebNavigate)
	ON_MESSAGE(WM_NAVIGATE, OnNavigate)
	ON_MESSAGE(	WM_WEB_HIDE, OnWebHide)
	ON_COMMAND(ID_GO_FORWARD, OnGoForward)
	ON_COMMAND(ID_CONTINUE, OnContinue)
	ON_COMMAND(ID_PAUSE, OnPause)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



BEGIN_EVENTSINK_MAP(CMPEG4PlayerView, CView)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 102 /* StatusTextChange */, OnStatusTextChange, VTS_BSTR)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 108 /* ProgressChange */, OnProgressChange, VTS_I4 VTS_I4)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 105 /* CommandStateChange */, OnCommandStateChange, VTS_I4 VTS_BOOL)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 106 /* DownloadBegin */, OnDownloadBegin, VTS_NONE)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 104 /* DownloadComplete */, OnDownloadComplete, VTS_NONE)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 113 /* TitleChange */, OnTitleChange, VTS_BSTR)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 252 /* NavigateComplete2 */, NavigateComplete2, VTS_DISPATCH VTS_PVARIANT)
	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 250 /* BeforeNavigate2 */, BeforeNavigate2, VTS_DISPATCH VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PBOOL)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 112 /* PropertyChange */, OnPropertyChange, VTS_BSTR)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 251 /* NewWindow2 */, OnNewWindow2, VTS_PDISPATCH VTS_PBOOL)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 253 /* OnQuit */, OnQuit, VTS_NONE)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 254 /* OnVisible */, OnVisible, VTS_BOOL)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 255 /* OnToolBar */, OnToolBar, VTS_BOOL)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 256 /* OnMenuBar */, OnMenuBar, VTS_BOOL)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 257 /* OnStatusBar */, OnStatusBar, VTS_BOOL)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 258 /* OnFullScreen */, OnFullScreen, VTS_BOOL)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 260 /* OnTheaterMode */, OnTheaterMode, VTS_BOOL)
END_EVENTSINK_MAP()



/////////////////////////////////////////////////////////////////////////////
// CMPEG4PlayerView construction/destruction

CMPEG4PlayerView::CMPEG4PlayerView() : shiftKey_changed(0), altKey_changed(0), controlKey_changed(0), leftButton_pressed(FALSE)
{
	// TODO: add construction code here
}

CMPEG4PlayerView::~CMPEG4PlayerView()
{
 delete GetApp()->m_pBrowser;
}

BOOL CMPEG4PlayerView::PreCreateWindow(CREATESTRUCT& cs)
{

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMPEG4PlayerView drawing

void CMPEG4PlayerView::OnDraw(CDC* /*pDC*/)
{
	CMPEG4PlayerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	TRACE_PRINT("In CMPEG4PlayerView::OnDraw():\n");

	//Don't redraw the mpeg-4 client area if html 
	//browser is active
	if(!GetApp()->m_pBrowser->IsWindowVisible( ))

		// At this stage I'll redraw the entire window, rather than just
		// that part which has changed
		if(GetApp()->GetExecutive())
		GetApp()->GetExecutive()->Paint(NULL);
	
	

} /* CMPEG4PlayerView::OnDraw */



/////////////////////////////////////////////////////////////////////////////
// CMPEG4PlayerView diagnostics

#ifdef _DEBUG
void CMPEG4PlayerView::AssertValid() const
{
	CView::AssertValid();
}

void CMPEG4PlayerView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMPEG4PlayerDoc* CMPEG4PlayerView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMPEG4PlayerDoc)));
	return (CMPEG4PlayerDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMPEG4PlayerView message handlers

void CMPEG4PlayerView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();

	// The first time that this is called, the Executive needs to
	// be created
	if (GetApp()->GetExecutive() == NULL)
		GetApp()->CreateExecutive(m_hWnd);
}

/////////////////////////////////////////////////////////////////////////////

void CMPEG4PlayerView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// Determine if the CTRL and/or the SHIFT keys are pressed
	UINT ctrlKeys = 0;
	if (nFlags & MK_CONTROL)
		ctrlKeys |= CK_CONTROL;
	if (nFlags & MK_SHIFT)
		ctrlKeys |= CK_SHIFT;

	// Pass this message onto the executive
	if(GetApp()->GetExecutive())
		GetApp()->GetExecutive()->OnUserEvent(EVENT_MOUSE_MOVE,
										  point.x, point.y,
										  ctrlKeys);

	GetApp()->GetMouseDevice()->DataReceive_Ind(point.x,point.y,leftButton_pressed);

} /* CMPEG4PlayerView::OnMouseMove */

/////////////////////////////////////////////////////////////////////////////


void CMPEG4PlayerView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// Determine if the CTRL and/or the SHIFT keys are pressed
	UINT ctrlKeys = 0;
	if (nFlags & MK_CONTROL)
		ctrlKeys |= CK_CONTROL;
	if (nFlags & MK_SHIFT)
		ctrlKeys |= CK_SHIFT;

	// Pass this message onto the executive
	GetApp()->GetExecutive()->OnUserEvent(EVENT_MOUSE_DOWN,
										  point.x, point.y,
										  ctrlKeys);

	leftButton_pressed = TRUE;
	GetApp()->GetMouseDevice()->DataReceive_Ind(point.x,point.y,leftButton_pressed);

} /* CMPEG4PlayerView::OnLButtonDown */


/////////////////////////////////////////////////////////////////////////////

void CMPEG4PlayerView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// Determine if the CTRL and/or the SHIFT keys are pressed
	UINT ctrlKeys = 0;
	if (nFlags & MK_CONTROL)
		ctrlKeys |= CK_CONTROL;
	if (nFlags & MK_SHIFT)
		ctrlKeys |= CK_SHIFT;

	// Pass this message onto the executive
	GetApp()->GetExecutive()->OnUserEvent(EVENT_MOUSE_UP,
										  point.x, point.y,
										  ctrlKeys);

	leftButton_pressed = FALSE;
	GetApp()->GetMouseDevice()->DataReceive_Ind(point.x,point.y,leftButton_pressed);

} /* CMPEG4PlayerView::OnLButtonUp */


/////////////////////////////////////////////////////////////////////////////

//
// CMPEG4PlayerView::OnSceneFinished
//
// Call the OnSceneFinished() member in the application.
//

LONG CMPEG4PlayerView::OnSceneFinished(WPARAM /*wParam*/, LPARAM /*lParam*/)
{
	GetApp()->OnSceneFinished();
	return 0;
} /* CMPEG4PlayerView::OnSceneFinished */


/////////////////////////////////////////////////////////////////////////////

LONG CMPEG4PlayerView::OnNonFatalError(WPARAM wParam, LPARAM /*lParam*/)
{
	static LPCSTR szError [] =
	{
		"INVALID STREAM_TYPE",
		"STREAM_TYPE COLLISION",
		"NO BIFS STREAM",
		"SCENE PARSING ERROR",
		"OD PARSING ERROR",
		"OD UPDATE NOT SUPPORTED",
		"ODID COLLISION",
		"UNKNOWN ODID",
		"UPDATE ESD NOT SUPPORTED",
		"REMOVE ESD NOT SUPPORTED",
		"UNKNOWN DECODER TYPE",
		"INCOMPATIBLE DECODER TYPE",
		"NO STREAM",
		"NO STREAM_TYPE",
		"REMOTE OD REQUIRES URL",
		"UNKNOWN URL PROTOCOL",
		"BUFFER TOO SMALL",
		"DECODER SETUP FAILURE",
		"REMOTE OD REQUIRES NEW SESSION",
		"REMOTE OD FLAG REQUIRED",
		"OPEN STREAM FAILED",
		"DELETE CHANNEL FAILED",
		"DATA TRANSMISSION ERROR",
		"INVALID URL",
		"IPMP NOT AVAILABLE",
		"NO ACCESS TO PROTECTED STREAM",
		"MISSING DESCRIPTOR",
		"TOO MANY DESCRIPTORS",
		"INITIAL OBJECT DESCRIPTOR NOT FOUND",
		"NO SLCONFIG INFO",
		"ERROR IN PARSING INITIAL OBJECT DESCRIPTOR",
		"BIFS UPDATE REQUEST DOES NOT MATCH SCENE",
		"MULTIPLE ACCESS OF A SINGLE STREAM NOT PERMITTED",
		"IPMP STREAM ALREADY IN USE",
		"INVALID BIFS CONFIG",
		"CANNOT_ALTER_REMOTE_OD",
		"TRYING_TO_UPDATE_UNKNOWN_OD",
		"TRYING_TO_REMOVE_UNKNOWN_ESD",
		"OCI_PARSING_ERROR",
		"SERVICE_DETACH_FAILED",
		"SEND_COMMAND_FAILED",
		"UNEXPECTED_SERVICE_DETACH",
		"UNEXPECTED_CHANNEL_DELETE",
		"DMIF_FILTER_NOT_FOUND"
   };

	MessageBox(szError[wParam-1],"Problem",MB_OK);



 return 0L;
}
LONG CMPEG4PlayerView::OnDDrawProblem(WPARAM /*wParam*/, LPARAM lParam)
{
	
	
	GetApp()->GetExecutive()->Stop();
	

	MessageBox((char *)(lParam),"Fatal Error, press ok to close the player",MB_OK);
	
	delete [] (char *) (lParam) ;

	::PostQuitMessage(1);
	return 0L;
}


/////////////////////////////////////////////////////////////////////////////

void CMPEG4PlayerView::OnPaint() 
{
	if((Presenter*)GetApp()->GetExecutive())
		((Presenter*)GetApp()->GetExecutive()->GetPresenter())->AskScreenAccess();
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	OnPrepareDC(&dc);
	OnDraw(&dc);
	// Do not call CView::OnPaint() for painting messages
	if((Presenter*)GetApp()->GetExecutive())
		((Presenter*)GetApp()->GetExecutive()->GetPresenter())->ReleaseScreenAccess();
}

//html browser creation

int CMPEG4PlayerView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here

	//html browser control init default size
	
	CRect rect(0,0,640,480);
	


	GetApp()->m_pBrowser = new CWebBrowser2;
	
	ASSERT (GetApp()->m_pBrowser);
	
	//the webBrowser control must be created as VISIBLE
	//see BUG: WebBrowser Control Destroyed When Hidden
	//		Last reviewed: March 10, 1998
	//		Article ID: Q182111 
	// in the MICROSOFT DEVELOPER NETWORK INFO. 
	
	if (!(GetApp()->m_pBrowser->Create(NULL,NULL,WS_VISIBLE,rect,this,AFX_IDW_PANE_FIRST)))
	{
		TRACE("failed to create browser\n");
		delete GetApp()->m_pBrowser;
		GetApp()->m_pBrowser = NULL;
	}
	
	::ShowWindow( GetApp()->m_pBrowser->GetSafeHwnd(), SW_HIDE );

	return 0;
}
/////////////////////////////////////////////////////////////////////////////
//general navigate request (it can be MPEG-4 or HTML) 

LONG CMPEG4PlayerView::OnNavigate(WPARAM /*wParam*/, LPARAM lParam)
{
	GetDocument()->m_fileName= (LPCSTR)lParam; 
	GetDocument()->OpenDocument();
	 return 0L;
}
////////////////////////////////////////////////////////////////////////////
//html navigate request

LONG CMPEG4PlayerView::OnWebNavigate(WPARAM /*wParam*/, LPARAM lParam)
{

  ::ShowWindow( GetApp()->m_pBrowser->GetSafeHwnd(), SW_SHOWNORMAL );
   GetApp()->m_pBrowser -> Navigate((LPCSTR)lParam,NULL,NULL,NULL,NULL);

   return 0L;
}
////////////////////////////////////////////////////////////////////////////
//hide the html control
LONG CMPEG4PlayerView::OnWebHide(WPARAM /*wParam*/, LPARAM /*lParam*/)
{
	::ShowWindow( GetApp()->m_pBrowser->GetSafeHwnd(), SW_HIDE );
	 return 0L;
}

//hide html browser control 
		

//Events fired by the webbrowser control



/////////////////////////////////////////////////////////////////////////////
// CMPEG4PlayerView web browser control message handlers
// The events are fired from the control up to the parent window
// This is useful to catch urls before the browser processes them. 
void CMPEG4PlayerView::BeforeNavigate2(LPDISPATCH /* pDisp */, VARIANT* URL,
		VARIANT* /*Flags*/, VARIANT* /*TargetFrameName*/,
		VARIANT* /*PostData*/, VARIANT* /*Headers*/, BOOL* Cancel)
{
  	
	CString szURL((URL->bstrVal));
	
	//Find out the type of the url

	BROWSER eKind=GetDocument()->AnalyzeUrl(szURL);
	
	if(eKind==MPEG)
	{
		//pass it to the MPEG-4 Player 
		GetApp()->GetExecutive()->Start(szURL);
		
		//abort html navigation
		*Cancel=TRUE;   
		//hide web browser control
		PostMessage(WM_WEB_HIDE, NULL,NULL);
	
	}
	
}


void CMPEG4PlayerView::OnGoForward() 
{
	// TODO: Add your command handler code here
	GetApp()->OnGoForward();	
}

void CMPEG4PlayerView::OnContinue() 
{
	
}

void CMPEG4PlayerView::OnPause() 
{
	
}

// CC 010123
void CMPEG4PlayerView::OnSysChar(UINT nChar, UINT , UINT ){
	ZString s("ALT_");
	s += GetCharString(nChar);

	GetApp()->GetKeyboardDevice()->DataReceive_Ind(s);

	::DefWindowProc(m_hWnd,GetCurrentMessage()->message,GetCurrentMessage()->wParam,GetCurrentMessage()->lParam);
}

void CMPEG4PlayerView::OnSysDeadChar(UINT nChar, UINT , UINT ){

	ZString s("ALT_");
	s += GetCharString(nChar);
	GetApp()->GetKeyboardDevice()->DataReceive_Ind(s);

	::DefWindowProc(m_hWnd,GetCurrentMessage()->message,GetCurrentMessage()->wParam,GetCurrentMessage()->lParam);
}

void CMPEG4PlayerView::OnSysKeyUp(UINT nChar, UINT , UINT ){
	int virtKey = GetCurrentMessage()->wParam;
	
	// Web3D Behavior
	UINT nActionKeyRelease = GetActionKey(virtKey);
	switch(virtKey) {
	case VK_SHIFT:			
		shiftKey_changed = 0;
		break;
	case VK_CONTROL:		
		controlKey_changed = 0;
		break;
	case VK_MENU:			
		altKey_changed = 0;
		break;
	}
	GetApp()->GetWeb3DKeySensorDevice()->DataReceive_Ind(0,nChar,0,nActionKeyRelease,shiftKey_changed,controlKey_changed,altKey_changed);
	// end 

	ZString s("ALT");
	ZString s1 = GetString(virtKey);
	if (!(s1 == (ZString)"ALT")) {
		s += (ZString)"_" + s1 + (ZString)"_RELEASED";
	} else {
		s += (ZString)"_RELEASED";
	}
	GetApp()->GetKeyboardDevice()->DataReceive_Ind(s);

	::DefWindowProc(m_hWnd,GetCurrentMessage()->message,GetCurrentMessage()->wParam,GetCurrentMessage()->lParam);
}

void CMPEG4PlayerView::OnSysKeyDown(UINT nChar, UINT , UINT ){
	int virtKey = GetCurrentMessage()->wParam;


	// Web3D Behavior
	UINT nActionKeyPress = GetActionKey(virtKey);
	switch(virtKey) {
	case VK_SHIFT:			
		shiftKey_changed = 1;
		break;
	case VK_CONTROL:		
		controlKey_changed = 1;
		break;
	case VK_MENU:			
		altKey_changed = 1;
		break;
	}
	GetApp()->GetWeb3DKeySensorDevice()->DataReceive_Ind(nChar,0,nActionKeyPress,0,shiftKey_changed,controlKey_changed,altKey_changed);
	// end 
	
	
	ZString s("ALT");
	ZString s1 = GetString(virtKey);
	if (!(s1 == (ZString)"ALT")) {
		s += (ZString)"_" + s1 + (ZString)"_PRESSED";
	} else {
		s += (ZString)"_PRESSED";
	}
	GetApp()->GetKeyboardDevice()->DataReceive_Ind(s);

	::DefWindowProc(m_hWnd,GetCurrentMessage()->message,GetCurrentMessage()->wParam,GetCurrentMessage()->lParam);
}


void CMPEG4PlayerView::OnChar(UINT nChar, UINT , UINT )
{
	ZString s = GetCharString(nChar);
	GetApp()->GetKeyboardDevice()->DataReceive_Ind(s);

	::DefWindowProc(m_hWnd,GetCurrentMessage()->message,GetCurrentMessage()->wParam,GetCurrentMessage()->lParam);
}


void CMPEG4PlayerView::OnDeadChar(UINT nChar, UINT , UINT ){

	ZString s = GetCharString(nChar);
	GetApp()->GetKeyboardDevice()->DataReceive_Ind(s);

	::DefWindowProc(m_hWnd,GetCurrentMessage()->message,GetCurrentMessage()->wParam,GetCurrentMessage()->lParam);
}

void CMPEG4PlayerView::OnKeyDown(UINT nChar, UINT , UINT )
{
	int virtKey = GetCurrentMessage()->wParam;

	// Web3D Behavior
	UINT nActionKeyPress = GetActionKey(virtKey);
	switch(virtKey) {
	case VK_SHIFT:			
		shiftKey_changed = 1;
		break;
	case VK_CONTROL:		
		controlKey_changed = 1;
		break;
	case VK_MENU:			
		altKey_changed = 1;
		break;
	}
	GetApp()->GetWeb3DKeySensorDevice()->DataReceive_Ind(nChar,0,nActionKeyPress,0,shiftKey_changed,controlKey_changed,altKey_changed);
	// end 
	
	ZString s = GetString(virtKey);
	s += "_PRESSED";
	GetApp()->GetKeyboardDevice()->DataReceive_Ind(s);

	::DefWindowProc(m_hWnd,GetCurrentMessage()->message,GetCurrentMessage()->wParam,GetCurrentMessage()->lParam);
}

void CMPEG4PlayerView::OnKeyUp(UINT nChar, UINT , UINT )
{
	int virtKey = GetCurrentMessage()->wParam;

	// Web3D Behavior
	UINT nActionKeyRelease = GetActionKey(virtKey);
	switch(virtKey) {
	case VK_SHIFT:			
		shiftKey_changed = 0;
		break;
	case VK_CONTROL:		
		controlKey_changed = 0;
		break;
	case VK_MENU:			
		altKey_changed = 0;
		break;
	}
	GetApp()->GetWeb3DKeySensorDevice()->DataReceive_Ind(0,nChar,0,nActionKeyRelease,shiftKey_changed,controlKey_changed,altKey_changed);
	// end 

	ZString s = GetString(virtKey);
	s += "_RELEASED";
	GetApp()->GetKeyboardDevice()->DataReceive_Ind(s);

	::DefWindowProc(m_hWnd,GetCurrentMessage()->message,GetCurrentMessage()->wParam,GetCurrentMessage()->lParam);
}

UINT CMPEG4PlayerView::GetActionKey(UINT nVirtKey) {
	UINT nActionKey = 0;
	switch (nVirtKey) {
	case VK_HOME:
		nActionKey = 1000;
		break;
	case VK_END:
		nActionKey = 1001;
		break;
	case VK_PRIOR:
		nActionKey = 1002;
		break;
	case VK_NEXT:
		nActionKey = 1003;
		break;
	case VK_UP:
		nActionKey = 1004;
		break;
	case VK_DOWN:
		nActionKey = 1005;
		break;
	case VK_LEFT:
		nActionKey = 1006;
		break;
	case VK_RIGHT:
		nActionKey = 1007;
		break;
	case VK_F1:
		nActionKey = 1008;
		break;
	case VK_F2:
		nActionKey = 1009;
		break;
	case VK_F3:
		nActionKey = 1010;
		break;
	case VK_F4:
		nActionKey = 1011;
		break;
	case VK_F5:
		nActionKey = 1012;
		break;
	case VK_F6:
		nActionKey = 1013;
		break;
	case VK_F7:
		nActionKey = 1014;
		break;
	case VK_F8:
		nActionKey = 1015;
		break;
	case VK_F9:
		nActionKey = 1016;
		break;
	case VK_F10:
		nActionKey = 1017;
		break;
	case VK_F11:
		nActionKey = 1018;
		break;
	case VK_F12:
		nActionKey = 1019;
		break;
	}
	return nActionKey;
}

ZString CMPEG4PlayerView::GetCharString(UINT nChar) {
	ZString s("");
	switch (nChar) {
	case 0x01:
		s = "CTRL_A";
		break;
	case 0x02:
		s = "CTRL_B";
		break;
	case 0x03:
		s = "CTRL_C";
		break;
	case 0x04:
		s = "CTRL_D";
		break;
	case 0x05:
		s = "CTRL_E";
		break;
	case 0x06:
		s = "CTRL_F";
		break;
	case 0x07:
		s = "CTRL_G";
		break;
	case 0x08:
		s = "BS";
		break;
	case 0x09:
		s = "TAB";
		break;
	case 0x0A:
		s = "LF";
		break;
	case 0x0B:
		s = "CTRL_K";
		break;
	case 0x0C:
		s = "CTRL_L";
		break;
	case 0x0D:
		s = "CR";
		break;
	case 0x0E:
		s = "CTRL_N";
		break;
	case 0x0F:
		s = "CTRL_O";
		break;
	case 0x10:
		s = "CTRL_P";
		break;
	case 0x11:
		s = "CTRL_Q";
		break;
	case 0x12:
		s = "CTRL_R";
		break;
	case 0x13:
		s = "CTRL_S";
		break;
	case 0x14:
		s = "CTRL_T";
		break;
	case 0x15:
		s = "CTRL_U";
		break;
	case 0x16:
		s = "CTRL_V";
		break;
	case 0x17:
		s = "CTRL_W";
		break;
	case 0x18:
		s = "CTRL_X";
		break;
	case 0x19:
		s = "CTRL_Y";
		break;
	case 0x1A:
		s = "CTRL_Z";
		break;
	case 0x1B:
		s = "ESCAPE";
		break;
	default:
		s = CString(nChar);
	}
	return s;
}

ZString CMPEG4PlayerView::GetString(UINT virtKey) {
	
	ZString s("");
	switch (virtKey) {
	case VK_CLEAR:			// 0C clear key  
		s = "CLEAR";
		break;
	case VK_SHIFT:			// 10 shift key  
		s = "SHIFT";
		break;
	case VK_CONTROL:		// 11 ctrl key  
		s = "CTRL";
		break;
	case VK_MENU:			// 12 alt key  
		s = "ALT";
		break;
	case VK_CAPITAL:		// 14 caps lock key  
		s = "CAPS";
		break;
	case VK_SELECT:			// 29 select key  
		s = "SELECT";
		break;
	case VK_EXECUTE:		// 2B execute key  
		s = "EXECUTE";
		break;
	case VK_SNAPSHOT:		// 2C print screen key  
		s = "SNAPSHOT";
		break;
	case VK_HELP:			// 2F help key  
		s = "HELP";
		break;
	case VK_LWIN:			// 5B Left Windows key (Microsoft Natural Keyboard)  
		s = "LWIN";
		break;
	case VK_RWIN:			// 5C Right Windows key (Microsoft Natural Keyboard)  
		s = "RWIN";
		break;
	case VK_APPS:			// 5D Applications key (Microsoft Natural Keyboard)  
		s = "APPS";
		break;
	case VK_NUMPAD0:		// 60 Numeric keypad 0 key  
		s = "NUMPAD0";
		break;
	case VK_NUMPAD1:		// 61 Numeric keypad 1 key  
		s = "NUMPAD1";
		break;
	case VK_NUMPAD2:		// 62 Numeric keypad 2 key  
		s = "NUMPAD2";
		break;
	case VK_NUMPAD3:		// 63 Numeric keypad 3 key  
		s = "NUMPAD3";
		break;
	case VK_NUMPAD4:		// 64 Numeric keypad 4 key  
		s = "NUMPAD4";
		break;
	case VK_NUMPAD5:		// 65 Numeric keypad 5 key  
		s = "NUMPAD5";
		break;
	case VK_NUMPAD6:		// 66 Numeric keypad 6 key  
		s = "NUMPAD6";
		break;
	case VK_NUMPAD7:		// 67 Numeric keypad 7 key  
		s = "NUMPAD7";
		break;
	case VK_NUMPAD8:		// 68 Numeric keypad 8 key  
		s = "NUMPAD8";
		break;
	case VK_NUMPAD9:		// 69 Numeric keypad 9 key  
		s = "NUMPAD9";
		break;
	case VK_MULTIPLY:		// 6A Multiply key  
		s = "MULTIPLY";
		break;
	case VK_ADD:			// 6B Add key  
		s = "ADD";
		break;
	case VK_SEPARATOR:		// 6C Separator key  
		s = "SEPARATOR";
		break;
	case VK_SUBTRACT:		// 6D Subtract key  
		s = "SUBSTRACT";
		break;
	case VK_DECIMAL:		// 6E Decimal key  
		s = "DECIMAL";
		break;
	case VK_DIVIDE:			// 6F Divide key  
		s = "DIVIDE";
		break;
	case VK_NUMLOCK:		// 90 num lock key  
		s = "NUMLOCK";
		break;
	case VK_SCROLL:			// 91 scroll lock key  	
		s = "SCROLL";
		break;
	case VK_PAUSE:			// 13 pause key  
		s = "PAUSE";
		break;
	case VK_PRIOR:			// 21 page up key  
		s = "PRIOR";
		break;
	case VK_NEXT:			// 22 page down key  
		s = "NEXT";
		break;
	case VK_END:			// 23 end key  
		s = "END";
		break;
	case VK_HOME:			// 24 home key  
		s = "HOME";
		break;
	case VK_LEFT:			// 25 left arrow key  
		s = "LEFT";
		break;
	case VK_UP:				// 26 up arrow key  
		s = "UP";
		break;
	case VK_RIGHT:			// 27 right arrow key  
		s = "RIGHT";
		break;
	case VK_DOWN:			// 28 down arrow key  
		s = "DOWN";
		break;
	case VK_INSERT:			// 2D ins key  
		s = "INSERT";
		break;
	case VK_DELETE:			// 2E del key  
		s = "DELETE";
		break;
	case VK_F1:				// 70 f1 key  
		s = "F1";
		break;
	case VK_F2:				// 71 f2 key  
		s = "F2";
		break;
	case VK_F3:				// 72 f3 key  
		s = "F3";
		break;
	case VK_F4:				// 73 f4 key  
		s = "F4";
		break;
	case VK_F5:				// 74 f5 key  
		s = "F5";
		break;
	case VK_F6:				// 75 f6 key  
		s = "F6";
		break;
	case VK_F7:				// 76 f7 key  
		s = "F7";
		break;
	case VK_F8:				// 77 f8 key  
		s = "F8";
		break;
	case VK_F9:				// 78 f9 key  
		s = "F9";
		break;
	case VK_F10:			// 79 f10 key  
		s = "F10";
		break;
	case VK_F11:			// 7A f11 key  
		s = "F11";
		break;
	case VK_F12:			// 7B f12 key  
		s = "F12";
		break;
	default:
		s = GetCharString(virtKey);
	}
	return s;
}
