//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
// MainFrm.cpp : implementation of the CMainFrame class
//

#include "defs.h"
#include "MPEG4Player.h"
#include "MainFrm.h"
#include "presenter.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_VIEW_TOOLBAR, OnViewToolbar)
	ON_COMMAND(ID_VIEW_STATUS_BAR, OnViewStatusBar)
	ON_WM_SIZE()
	
	//Address Edit Box
	ON_CBN_SELENDOK(AFX_IDW_TOOLBAR + 1,OnNewAddress)
	ON_COMMAND(IDOK, OnNewAddressEnter)
	ON_MESSAGE(WM_SETSIZE,OnSetSize)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}
#ifdef OLD_INTERFACE
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

#ifdef USE_TOOLBAR
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
#endif

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

#ifdef USE_TOOLBAR
	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
#endif

	return 0;
}

#endif

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
    
    

	// Determine how large to make the window to fit in the required
	// client area
	RECT rect;
	rect.left = ::GetSystemMetrics(SM_CXSCREEN) / 4;
	rect.right = 640;
	rect.top = ::GetSystemMetrics(SM_CYSCREEN) / 4;
	rect.bottom = 480;
	AdjustWindowRectEx(&rect, cs.style, TRUE, cs.dwExStyle);

	// Still need to allow for the height of the toolbar and status bar

	// Set the size and placement of the window
    cs.cy = rect.bottom; 
    cs.cx = rect.right; 
    cs.y = rect.top; 
    cs.x = rect.left;

	return CFrameWnd::PreCreateWindow(cs);
} /* CMainFrame::PreCreateWindow */


/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


/////////////////////////////////////////////////////////////////////////////

//
// Set the size of the client area to the given size.
//

void CMainFrame::SetSize(UINT width, UINT height)
{
	// Determine how large to make the window to fit in the required
	// client area
	RECT winRect;
	winRect.left = 0;
	winRect.right = width;
	winRect.top = 0;
	winRect.bottom = height;
	AdjustWindowRectEx(&winRect, GetStyle(), TRUE, GetExStyle());
	winRect.bottom -= winRect.top;
	winRect.right -= winRect.left;

	// It seems to need a few extra pixels added to the height
	// (there should be a better way to do this)
	winRect.bottom += 2;
	winRect.right += 4;
	// Allow for the height of the toolbar
	RECT barRect;
	#ifdef USE_TOOLBAR
	
	if(::IsWindow(m_wndReBar.m_hWnd))
	{
		CReBarCtrl* pReBar = &m_wndReBar.GetReBarCtrl();
	
		
		if (pReBar != NULL)
		{
			pReBar->GetClientRect(&barRect);
			winRect.bottom += barRect.bottom;
			winRect.bottom+=2;
		}
	}
	#endif
/*
	CControlBar* pBar = GetControlBar(ID_VIEW_TOOLBAR);
	GetClientRect(&barRect);

	RECT barRect;
	if (pBar != NULL)
	{
		pBar->GetClientRect(&barRect);
		winRect.bottom += barRect.bottom;
	}*/
	CControlBar* pBar;
	// Allow for the height of the status bar
	pBar = GetControlBar(ID_VIEW_STATUS_BAR);
	if (pBar != NULL)
	{
		pBar->GetClientRect(&barRect);
		winRect.bottom += barRect.bottom;
		winRect.bottom+=2;
	}
	 
	// Set the new size the window
	RECT rctScreen;
	GetDesktopWindow() -> GetWindowRect (&rctScreen);
	winRect.left = (rctScreen.right - winRect.right) / 2;
	winRect.top = (rctScreen.bottom - winRect.bottom) / 2;
	SetWindowPos(NULL, winRect.left, winRect.top, winRect.right, winRect.bottom,
				 SWP_NOZORDER | SWP_SHOWWINDOW);

} /* CMainFrame::SetSize */


/////////////////////////////////////////////////////////////////////////////

//
// These functions keep the client area the same size when the toolbar
// and status bar are toggled on and off.
//

void CMainFrame::AdjustWindowSize(UINT nID)
{
	CFrameWnd::OnBarCheck(nID);

	// Get the height of the toolbar
	CControlBar* pBar = GetControlBar(nID);
	if (pBar != NULL)
	{
		// Get the dimensions of the toolbar
		RECT toolbarRect;
		pBar->GetClientRect(&toolbarRect);

		// Get the dimensions of the window
		RECT winRect;
		GetWindowRect(&winRect);
		winRect.right -= winRect.left;
		winRect.bottom -= winRect.top;

		// Change the size of the window to keep the active area the same
		if (pBar->GetStyle() & WS_VISIBLE)
			winRect.bottom += toolbarRect.bottom;
		else
			winRect.bottom -= toolbarRect.bottom;

		SetWindowPos(NULL, NULL, NULL, winRect.right, winRect.bottom,
					 SWP_NOMOVE | SWP_NOZORDER | SWP_SHOWWINDOW);
	}
} /* CMainFrame::AdjustWindowSize */


void CMainFrame::OnViewToolbar() 
{
	AdjustWindowSize(ID_VIEW_TOOLBAR);
}

void CMainFrame::OnViewStatusBar() 
{
	AdjustWindowSize(ID_VIEW_STATUS_BAR);
}


/////////////////////////////////////////////////////////////////////////////

void CMainFrame::OnSize(UINT nType, int cx, int cy) 
{
	CFrameWnd::OnSize(nType, cx, cy);
	//the direct draw surface is also to be resized
	//we subtract the height of the tool and the status bar
	//from the windo height and then resize the surface
	RECT barRect;
	#ifdef USE_TOOLBAR
	CReBarCtrl* pReBar;
	if(::IsWindow(m_wndReBar.m_hWnd))
	{
		pReBar= &m_wndReBar.GetReBarCtrl();
	
	
		if (pReBar != NULL)
		{
			pReBar->GetClientRect(&barRect);
			cy -= barRect.bottom;
		}
	}
	#endif
	CControlBar* pBar;
	// Allow for the height of the status bar
	pBar = GetControlBar(ID_VIEW_STATUS_BAR);
	if (pBar != NULL)
	{
		pBar->GetClientRect(&barRect);
		cy -= barRect.bottom+2;
	}
	
	if((cx<=0)||(cy<=0))
		return;
	
	//resize direct draw surface
	Executive *pExecutive=GetApp()->GetExecutive();
	if(pExecutive!=NULL)
	{
		(((Presenter*)pExecutive->GetPresenter()))->AskScreenAccess();
		((Presenter*)pExecutive->GetPresenter())->GetVisualRenderer()->SetScreenSize(cx,cy);
		((Presenter*)pExecutive->GetPresenter())->ReleaseScreenAccess();
	}
	//if the browser control is active then resize it too
	if (::IsWindow(GetApp()->m_pBrowser->m_hWnd))
	{
		// need to push non-client borders out of the client area
		CRect rect;
		rect.left=0;
		rect.top=0;
		rect.right=cx-4;
		rect.bottom=cy-4;
	/*	GetClientRect(rect);
		::AdjustWindowRectEx(rect,
				WS_VISIBLE, FALSE, WS_EX_WINDOWEDGE); */
		GetApp()->m_pBrowser->SetWindowPos(NULL, rect.left, rect.top,
			rect.Width(),rect.Height(), SWP_NOACTIVATE | SWP_NOZORDER);
		
	}

}





int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	CImageList img;
	CString str;

	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
#ifdef USE_TOOLBAR
	if (!m_wndReBar.Create(this))
	{
		TRACE0("Failed to create rebar\n");
		return -1;      // fail to create
	}

	if (!m_wndToolBar.CreateEx(this))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	// set up toolbar properties
	m_wndToolBar.GetToolBarCtrl().SetButtonWidth(50, 150);
	m_wndToolBar.GetToolBarCtrl().SetExtendedStyle(TBSTYLE_EX_DRAWDDARROWS);

	img.Create(IDB_HOTTOOLBAR, 22, 0, RGB(255, 0, 255));
	m_wndToolBar.GetToolBarCtrl().SetHotImageList(&img);
	img.Detach();
	img.Create(IDB_COLDTOOLBAR, 22, 0, RGB(255, 0, 255));
	m_wndToolBar.GetToolBarCtrl().SetImageList(&img);
	img.Detach();
	m_wndToolBar.ModifyStyle(0, TBSTYLE_FLAT | TBSTYLE_TRANSPARENT);
	m_wndToolBar.SetButtons(NULL, 9);

	// set up each toolbar button
	m_wndToolBar.SetButtonInfo(0, ID_GO_BACK, TBSTYLE_BUTTON, 0);
	str.LoadString(IDS_BACK);
	m_wndToolBar.SetButtonText(0, str);
	m_wndToolBar.SetButtonInfo(1, ID_GO_FORWARD, TBSTYLE_BUTTON, 1);
	str.LoadString(IDS_FORWARD);
	m_wndToolBar.SetButtonText(1, str);
	m_wndToolBar.SetButtonInfo(2, ID_VIEW_STOP, TBSTYLE_BUTTON, 2);
	str.LoadString(IDS_STOP);
	m_wndToolBar.SetButtonText(2, str);
	//m_wndToolBar.SetButtonInfo(3, ID_VIEW_REFRESH, TBSTYLE_BUTTON, 3);
	m_wndToolBar.SetButtonInfo(3, ID_GO_REPLAY, TBSTYLE_BUTTON, 3);
	str.LoadString(IDS_REFRESH);
	m_wndToolBar.SetButtonText(3, str);
	m_wndToolBar.SetButtonInfo(4, ID_GO_START_PAGE, TBSTYLE_BUTTON, 4);
	str.LoadString(IDS_HOME);
	m_wndToolBar.SetButtonText(4, str);
	m_wndToolBar.SetButtonInfo(5, ID_GO_SEARCH_THE_WEB, TBSTYLE_BUTTON, 5);
	str.LoadString(IDS_SEARCH);
	m_wndToolBar.SetButtonText(5, str);
	m_wndToolBar.SetButtonInfo(6, ID_FAVORITES_DROPDOWN, TBSTYLE_BUTTON | TBSTYLE_DROPDOWN, 6);
	str.LoadString(IDS_FAVORITES);
	m_wndToolBar.SetButtonText(6, str);
	m_wndToolBar.SetButtonInfo(7, ID_FILE_PRINT, TBSTYLE_BUTTON, 7);
	str.LoadString(IDS_PRINT);
	m_wndToolBar.SetButtonText(7, str);
	m_wndToolBar.SetButtonInfo(8, ID_FONT_DROPDOWN, TBSTYLE_BUTTON | TBSTYLE_DROPDOWN, 8);
	str.LoadString(IDS_FONT);
	m_wndToolBar.SetButtonText(8, str);

	CRect rectToolBar;

	// set up toolbar button sizes
	m_wndToolBar.GetItemRect(0, &rectToolBar);
	m_wndToolBar.SetSizes(rectToolBar.Size(), CSize(30,20));

	// create a combo box for the address bar
#ifdef USE_ADDRESSBAR
	if (!m_wndAddress.Create(CBS_DROPDOWN | WS_CHILD, CRect(0, 0, 200, 120), this, AFX_IDW_TOOLBAR + 1))
	{
		TRACE0("Failed to create combobox\n");
		return -1;      // fail to create
	}
#endif


	// add the toolbar, animation, and address bar to the rebar
	m_wndReBar.AddBar(&m_wndToolBar);
//	m_wndReBar.AddBar(&m_wndAnimate, NULL, NULL, RBBS_FIXEDSIZE | RBBS_FIXEDBMP);
	/* Commenting out the address bar because this is not needed in some applications */
#ifdef USE_ADDRESSBAR
	str.LoadString(IDS_ADDRESS);
	m_wndReBar.AddBar(&m_wndAddress, str, NULL, RBBS_FIXEDBMP | RBBS_BREAK);
#endif
	// set up min/max sizes and ideal sizes for pieces of the rebar
	REBARBANDINFO rbbi;

	rbbi.cbSize = sizeof(rbbi);
	rbbi.fMask = RBBIM_CHILDSIZE | RBBIM_IDEALSIZE | RBBIM_SIZE;
	rbbi.cxMinChild = rectToolBar.Width();
	rbbi.cyMinChild = rectToolBar.Height();
	rbbi.cx = rbbi.cxIdeal = rectToolBar.Width() * 9;
	m_wndReBar.GetReBarCtrl().SetBandInfo(0, &rbbi);
	rbbi.cxMinChild = 0;

#ifdef USE_ADDRESSBAR
	CRect rectAddress;

	rbbi.fMask = RBBIM_CHILDSIZE | RBBIM_IDEALSIZE;
	m_wndAddress.GetEditCtrl()->GetWindowRect(&rectAddress);
	rbbi.cyMinChild = rectAddress.Height() + 10;
	rbbi.cxIdeal = 200;
	m_wndReBar.GetReBarCtrl().SetBandInfo(2, &rbbi);
#endif

	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_FIXED);
#endif	
	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}
/*
// set up Favorites menu
	TCHAR           sz[MAX_PATH];
	TCHAR           szPath[MAX_PATH];
	HKEY            hKey;
	DWORD           dwSize;
	CMenu*          pMenu;

	// first get rid of bogus submenu items.
	pMenu = GetMenu()->GetSubMenu(3);
	while(pMenu->DeleteMenu(0, MF_BYPOSITION));

	// find out from the registry where the favorites are located.
	if(RegOpenKey(HKEY_CURRENT_USER, _T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\User Shell Folders"), &hKey) != ERROR_SUCCESS)
	{
		TRACE0("Favorites folder not found\n");
		return 0;
	}
	dwSize = sizeof(sz);
	RegQueryValueEx(hKey, _T("Favorites"), NULL, NULL, (LPBYTE)sz, &dwSize);
	ExpandEnvironmentStrings(sz, szPath, MAX_PATH);
	RegCloseKey(hKey);

	BuildFavoritesMenu(szPath, 0, pMenu);*/
	return 0;
}

void CMainFrame::OnNewAddressEnter()
{
	// gets called when an item is entered manually into the edit box portion
	// of the Address combo box.
	// navigate to the newly selected location and also add this address to the
	// list of addresses in the combo box.
#ifdef USE_ADDRESSBAR
	CString str;

	m_wndAddress.GetEditCtrl()->GetWindowText(str);
	
	COMBOBOXEXITEM item;

	item.mask = CBEIF_TEXT;
	item.iItem = -1;
	item.pszText = (LPTSTR)(LPCTSTR)str;
	m_wndAddress.InsertItem(&item);
#endif
}
void CMainFrame::OnNewAddress()
{
	// gets called when an item in the Address combo box is selected
	// just navigate to the newly selected location.
#ifdef USE_ADDRESSBAR
	CString str;

	m_wndAddress.GetLBText(m_wndAddress.GetCurSel(), str);
#endif
}
void CMainFrame::OnSetSize(WPARAM wParam, LPARAM lParam)
{
	
	SetSize(LOWORD (lParam),HIWORD( lParam));
}
