//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
//
// File:  Nodes-CSELT.h
//
// Author: Matthew Leditschke
//
// Modified: Gianluca Di Cagno  gianluca.dicagno@cselt.it
//           Boris Felts bfelts@envivio.com
//
// Description:
//   The file includes the header files of all of the nodes that have
//   been incorporated into the CSELT 2D player.  These classes extend
//   the classes defined in the Core in Nodes.h.
//	 This Nodes just create the proxy for the nodes. If you want the core to create
//   only one proxy for each def node return NULL when the third parameter of
//   the CreateRenderingObject is FALSE.
// Created: August, 1997.
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef NODES_CSELT_H
#define NODES_CSELT_H


#include "StreamCo.h"
#include "Nodes.h"
#include "conditional.h"
#include "bifs.h"
#include "Executiv.h"
#include "Presenter.h"
#include "Root.h"
#include "inline.h"
#include "ScriptImp.h" //BF Script
#define eventIn		 public:
#define exposedField public:
#define eventOut	 public:
#define field		 public:

#include "../FlexTime/TemporalTransformImpFlex.h" //PAB+:
#include "../FlexTime/TemporalGroupImpFlex.h"  //PAB+:
//#include "InlineImpPlayer.h"  //PAB+:


// ======================================================================

class AnchorCSELT : public Anchor
{

    RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitAnchor(this);

	}
	//void OnUpdate () {GetRenderingObject()->SetUpdate(TRUE);}
};


// ======================================================================

class AppearanceCSELT : public Appearance
{

    RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitAppearance(this);

	}
};


// ======================================================================

class AudioSourceCSELT : public AudioSource
{
	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitAudioSource(this);
	}
//	~AudioSourceCSELT(){RemoveRenderingObject();}
};


// ======================================================================

class Background2DCSELT : public Background2D
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitBackground2D(this);
	}
};

// ======================================================================

class BitmapCSELT : public Bitmap
{
	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitBitmap(this);
	}


};

// ======================================================================

class CircleCSELT : public Circle
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitCircle(this);
	}
};


// ======================================================================

class ColorCSELT : public Color
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitColor(this);
	}
};


// ======================================================================

class ColorInterpolatorCSELT : public ColorInterpolator
{

	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitColorInterpolator(this);
	}
};


// ======================================================================

class Coordinate2DCSELT : public Coordinate2D
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitCoordinate2D(this);
	}
};

// ======================================================================

class CoordinateInterpolator2DCSELT : public CoordinateInterpolator2D
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitCoordinateInterpolator2D(this);
	}
};
// ======================================================================

class Curve2DCSELT : public Curve2D
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitCurve2D(this);
	}
};

// ======================================================================

class DiscSensorCSELT : public DiscSensor
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitDiscSensor(this);
	}
};

// ======================================================================

class FontStyleCSELT : public FontStyle
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitFontStyle(this);
	}
};

// ======================================================================

class FormCSELT : public Form
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitForm(this);
	}
};

// ======================================================================

class GroupCSELT : public Group
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitGroup(this);
	}
};
/*GDC removed after Zvi inlineimpflex removal
//PAB-: class InlineCSELT : public InlineImp
class InlineCSELT : public InlineImpPlayer //PAB+:
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitInline(this);
	}
};*/


class InlineCSELT : public InlineImp
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitInline(this);
	}
};

// ======================================================================

class IndexedLineSet2DCSELT : public IndexedLineSet2D
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitIndexedLineSet2D(this);
	}
};


// ======================================================================

class LayoutCSELT : public Layout
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitLayout(this);
	}
};

class Layer2DCSELT : public Layer2D
{
	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitLayer2D(this);
	}
};

// =====================================================================

class LinePropertiesCSELT : public LineProperties
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitLineProperties(this);
	}
};
// ======================================================================

class Material2DCSELT : public Material2D
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitMaterial2D(this);
	}
};

// ======================================================================

class MovieTextureCSELT : public MovieTexture
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitMovieTexture(this);
	}
//	~MovieTextureCSELT(){RemoveRenderingObject();}
};

// ======================================================================

class MatteTextureCSELT : public MatteTexture
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitMatteTexture(this);
	}
//	~MovieTextureCSELT(){RemoveRenderingObject();}
};

// ======================================================================

class OrderedGroupCSELT : public OrderedGroup
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitOrderedGroup(this);
	}
};
// ======================================================================

class ValuatorCSELT : public Valuator
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitValuator(this);
	}
};






// ======================================================================

class PlaneSensor2DCSELT : public PlaneSensor2D
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitPlaneSensor2D(this);
	}
};

// ======================================================================

class PointSet2DCSELT : public PointSet2D
{

	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitPointSet2D(this);
	}
};


// ======================================================================

class PositionInterpolator2DCSELT : public PositionInterpolator2D
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitPositionInterpolator2D(this);
	}
};

// ======================================================================

class ProximitySensor2DCSELT : public ProximitySensor2D
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitProximitySensor2D(this);
	}
};



// ======================================================================


class RectangleCSELT : public Rectangle
{



	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitRectangle(this);
	}
};


// ======================================================================

class ScalarInterpolatorCSELT : public ScalarInterpolator
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitScalarInterpolator(this);
	}
};





// ======================================================================

class ShapeCSELT : public Shape
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitShape(this);
	}
};


// ======================================================================

class Sound2DCSELT : public Sound2D
{

	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitSound2D(this);
	}
};

// ======================================================================

class ScriptCSELT: public ScriptImp
{

	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitScript(this);
	}
};


// ======================================================================

class SwitchCSELT : public Switch
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitSwitch(this);
	}
};


// ======================================================================

class TextCSELT : public Text
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitText(this);
	}
};


// ======================================================================

// ======================================================================

class ImageTextureCSELT : public ImageTexture
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitImageTexture(this);
	}
};

class TermCapCSELT : public TermCap
{
	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitTermCap(this);
	}
};


class TimeSensorCSELT : public TimeSensor
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitTimeSensor(this);
	}
};


// ======================================================================

class TouchSensorCSELT : public TouchSensor
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitTouchSensor(this);
	}
};


// ======================================================================

class Transform2DCSELT : public Transform2D
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitTransform2D(this);
	}
};





// ======================================================================

class ConditionalCSELT : public Conditional
{

	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitConditional(this);
	}
};

// ======================================================================


class WorldInfoCSELT : public WorldInfo
{

	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitWorldInfo(this);
	}
};

// ======================================================================

class SynthesizedTextureCSELT : public SynthesizedTexture
{


	RenderingObject *CreateRenderingObject (MediaObject *)
	{
		return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitSynthesizedTexture(this);
	}
};

// ======================================================================


//PAB+: TemporalTransformCSELT
class TemporalTransformCSELT : public TemporalTransformImpFlex
{
  RenderingObject *CreateRenderingObject (MediaObject *)
  {
    return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitTemporalTransform(this);
  }
};

// PAB+: TemporalGroupCSELT
class TemporalGroupCSELT : public TemporalGroupImpFlex
{
  RenderingObject *CreateRenderingObject (MediaObject *)
  {
    return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitTemporalGroup(this);
  }
};

#endif // NODES_CSELT_H
