// PlayListImpl.h: interface for the PlayListImpl class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PLAYLISTIMPL_H__91E5C960_8D3B_11D3_9EB6_00104BB656F0__INCLUDED_)
#define AFX_PLAYLISTIMPL_H__91E5C960_8D3B_11D3_9EB6_00104BB656F0__INCLUDED_

//{{AFX_INCLUDES()
#include "datagrid.h"
#include "msflexgrid.h"
//}}AFX_INCLUDES

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CPlayListDlg dialog

class CPlayListDlg : public CDialog
{
public:
	void ReadPLFromFile(char *); // read in memory the playlist pointed to by the filename passed as a parameter
	int m_numberOfMP4; // number of single MP4 files loaded added to the current playlist
	int m_numberOfM4U; // number of single M4U playlist files added to the current playlist
	bool m_modifiedPL; // false when the current playlist has been modified without being saved
	HKEY m_hSection;   // registry key where we store the last playlist
	int m_currentTrack;// stores the index of the track that is currently played
	void init(bool);   // if empty == true initializes an empty playlist, else read playlist name from registry
	CPlayListDlg();
	~CPlayListDlg();

// Dialog Data
	//{{AFX_DATA(CPlayListDlg)
	enum { IDD = IDD_PLAYLISTBOX };
	CMSFlexGrid	m_playList;
	BOOL	m_loop;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPlayListDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CPlayListDlg)
	afx_msg void OnButtonAdd();
	afx_msg void OnButtonDel();
	afx_msg void OnButtonDown();
	afx_msg void OnButtonUp();
	afx_msg void OnInfos();
	afx_msg void OnButtonSave();
	virtual void OnOK();
	afx_msg void OnButtonHelp();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

class PlayListImpl  
{
public:
	void showDialog();
	bool hasPreviousTrack();
	bool hasNextTrack();
	CString getCurrentTrack();
	CString getPreviousTrack();
	CString getNextTrack();
	void init();
	PlayListImpl();
	virtual ~PlayListImpl();

protected:
	CPlayListDlg* playListDlg;
private:
	bool initialized;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PLAYLISTIMPL_H__91E5C960_8D3B_11D3_9EB6_00104BB656F0__INCLUDED_)
