//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
//
// File:  PointSet2DProxy.h
//
// Author: Antonio Arena
//
// Modified:
//
// Description:
//   The definition of the proxy object used by the presenter
//   to handle the PointSet2DProxy node.
//
// Created: September, 1997.
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef POINTSET2D_PROXY_H
#define POINTSET2D_PROXY_H


#include "GeometryNode.h"


class PointSet2DProxy : public GeometryNode
{
public:
	PointSet2DProxy(MediaObject* pMO);
	~PointSet2DProxy();

	// Return a pointer to the PointSet2D node that this node is the proxy for
	PointSet2D* GetPointSet2D() const
	{ return (PointSet2D*)GetObject(); }
	// Return a pointer to the Coordinate2D node contained in this node
	Coordinate2D* GetCoordinate2D() const
	{ return (Coordinate2D*)(GetPointSet2D()->coord); }
	// Return a pointer to the Color node contained in this node
	Color* GetColorNode() const
	{ return (Color*)(MediaObject*)(GetPointSet2D()->color); }

	// Functions inherited from the base classes
	virtual void PreRender(Effects &effects);
	virtual void Draw(BRect const* pClipBRect, DrawableContext * pContext);


	// Private implementation details
private:
	PointF* m_lpPoints;
	int m_nLength;
	int m_nAllocatedLength;
};


#endif // POINTSET2D_PROXY_H
