/***********************************************************************
This software module was originally developed by Mikael Bourges-Sevenier
(Mindego Inc.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Mindego Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Mikael Bourges-Sevenier at mikael@mindego.com.
----------------------------------------------------------------------*/

#ifndef __PositionInterpolator4DProxy_h__
#define __PositionInterpolator4DProxy_h__

#include "Traversable.h"

class PositionInterpolator4DProxy : public Traversable
{
public:
  PositionInterpolator4DProxy(MediaObject * poNode)  : Traversable(poNode) {}

  // Return a pointer to the PositionInterpolator4D node that this node is the proxy for
  PositionInterpolator4D* GetPositionInterpolator4D() const
	{ return (PositionInterpolator4D*)GetObject(); }

  // Functions inherited from the base classes
	void PreRender(Effects &) {}
	BOOL IsFinished() const { return TRUE; }
};

#endif // __PositionInterpolator4DProxy_h__
