//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
//
// File:  Proximity2DSensor.h
//
// Author: Gianluca Di Cagno, CSELT, Gianluca.DiCagno@cselt.it
//
// Modified:
//
// Description:
//   The definition of the proxy object used by the presenter
//   to handle the ProximitySensor2D node.
//
// Created: December, 1997.
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef PROXIMITY_SENSOR_2D_PROXY_H
#define PROXIMITY_SENSOR_2D_PROXY_H


#include "UserEventHandlerProxy.h"
#include "brect.h"


class ProximitySensor2DProxy : public UserEventHandlerProxy
{
public:
	ProximitySensor2DProxy(MediaObject* pMO) : UserEventHandlerProxy(pMO),
		m_JustEntered(FALSE),m_LastUpdateTime(0xffffffff),m_InRegion(FALSE){}
		 
	

	// Return a pointer to the ProximitySensor2D node that this node is the proxy for
	ProximitySensor2D* GetProximitySensor2D() const
	{ return (ProximitySensor2D*)GetObject(); }

	// Functions inherited from the base classes
	BOOL OnUserEvent(EventInfo const* pEvent);
	virtual void PreRender(Effects &);
	BOOL IsFinished() const;
	

private:
	
    BRect m_sensedRegion;
	BOOL m_JustEntered,m_InRegion;
	DWORD m_LastUpdateTime;
};


#endif // PROXIMITY_SENSOR_2D_PROXY_H
