//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
//
// File:  ShapeProxy.cpp
//
// Authors: Antonio Arena, CSELT, arena@kim.cselt.it
//			Franco Casalino, CSELT, Franco.Casalino@cselt.it
//
// Modified:
//
// Description:
//   The implementation of the proxy object used by the presenter
//   to render the Shape node.
//
// Created: September, 1997.
//
//
///////////////////////////////////////////////////////////////////////////


#include "defs.h"
#include "Nodes-CSELT.h"
#include "ShapeProxy.h"
#include "AppearanceProxy.h"
#include "GeometryNode.h"
#include "trace.h"


// =====================================================================

//
// Presenter::InitShape
//
// Initialise the proxy data structure and attach it to the render data
// pointer of the given media object node.
//

ShapeProxy* Presenter::InitShape(Shape* pObj)
{
		return new  ShapeProxy(pObj);
}


// =====================================================================

//
// ShapeProxy::PreRender
//
// Add the transform parameters of this node to the given effects, and
// then apply the PreRender method to all of the children of this node.
//

void ShapeProxy::PreRender(Effects & effects)
{
	GeometryNode* pGeometryProxy;
	
	MediaObject* pMediaObject=GetGeometry();
	
	if(pMediaObject)
	{
		pGeometryProxy=(GeometryNode*)(pMediaObject)->GetRenderingObject();
		effects.m_pAppearance=(Appearance*)(MediaObject*) GetShape()->appearance;
		effects.m_pShapeProxy=this;
		if (pGeometryProxy) pGeometryProxy->PreRender(effects);
	}

} /* ShapeProxy::PreRender */



