//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
//
// File:  SoundProxy.h
//
// Authors: Matthew Leditschke 
//
// Modified: Gianluca Di Cagno  gianluca.dicagno@cselt.it 
//           Ananda Allys France Telecom
//
// Description:
//   The definition of the proxy object used by the presenter
//   to handle the Sound node.
//
// Created: October, 1997.
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef SOUND_2D_PROXY_H
#define SOUND_2D_PROXY_H


#include "Traversable.h"
#include "AudioSourceProxy.h"

class Sound2DProxy : public Traversable
{
public:
	Sound2DProxy(MediaObject* pMO) : Traversable(pMO) {m_pAudioSourceProxy=NULL;}
	//added to detect if has been deleteted- thread problem
	~Sound2DProxy();
	//RenderingObject preDeletion
	void DeleteObject();
	// Return a pointer to the Sound2D node that this node is the proxy for
	Sound2D* GetSound2D() const { return (Sound2D*)GetObject(); }

	// Functions inherited from the base class
	void PreRender(Effects & effects);
	BOOL IsFinished() const;

	// Return a pointer to the audio node associated with this node
	MediaObject* GetAudioNode() const
	{ return (MediaObject*)(GetSound2D()->source); }
private:  AudioSourceProxy * m_pAudioSourceProxy;
};


#endif // SOUND_2D_PROXY_H
