/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/

#ifndef SYNTHESIZEDTEXTURE_PROXY_H
#define SYNTHESIZEDTEXTURE_PROXY_H


#include "DrawableImage.h"

class CSt;


class SynthesizedTextureProxy : public DrawableImage
{
public:
	SynthesizedTextureProxy(MediaObject* pMO);
	~SynthesizedTextureProxy();
	 void DeleteObject();


	// Return a pointer to the MovieTexture node that this node is the proxy for
	SynthesizedTexture* GetSynthesizedTexture() const { return (SynthesizedTexture*)GetObject(); }

	// Functions inherited from the base classes
	virtual BOOL NeedsDrawing(DrawableContext * pContext);
	virtual void Draw(BRect const* pClipBRect,DrawableContext * pContext);

	void PreRender(Effects & ){}
	void PreRender(Effects & effects,DrawableContext* pContext);
	void OnEndOfStream();
	BOOL GetOpenStreamFlag(){return m_OpenStreamIsBeingUsed; }
	void ResetOpenStreamFlag() {m_OpenStreamIsBeingUsed=FALSE;}


// ST
	int	LoadStream(DrawableContext * pContext);

	void	UpdateTranslation();
	void	UpdateRotation();
	void	UpdateLoop();

private:
	BOOL m_firstTimeAtStartTime;
	BOOL m_firstTimeAtStopTime;
	BOOL m_endOfTimeReached;
	double m_startTime;
	int m_timesStarted;
	//TRUE if the associated decoder is still active
	BOOL m_OpenStreamIsBeingUsed;

	// Private implementation details

	// ST
	CSt	*m_st;
	void *m_im;

	SrcRGBAImage *m_image;
};


#endif // MOVIETEXTURE_PROXY_H
