//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
//
// File:  TermCapProxy.cpp
//
// Author: Gianluca Di Cagno  gianluca.dicagno@cselt.it
//
// Modified:
//
// Description:
//   The implementation of the proxy object used by the presenter
//   to handle the TermCap node.
//
// Created: February 1999.
//
//
///////////////////////////////////////////////////////////////////////////


#include "defs.h"
#include "MediaObj.h"
#include "nodes.h"
#include "TermCapProxy.h"
#include "Presenter.h"


// =====================================================================

//
// Presenter::InitTermCap
//
// Initialise the proxy data structure and attach it to the render data
// pointer of the given media object node.
//

TermCapProxy* Presenter::InitTermCap(TermCap* pObj)
{
	return new  TermCapProxy(pObj);
}

// =====================================================================

//
// Presenter::Query
//
// Detect the terminal capability  
// 



void TermCapProxy::Query(int capability)
{
	switch (capability)
	{		
		case 0:  
			GetTermCap()->value=GetFrameRate();
			break;
		case 1:
			GetTermCap()->value=GetColorDepth();
			break;
		case 2:
			GetTermCap()->value=GetScreenSize();
			break;
		default:;
	}
}


// =====================================================================
//
//  TermCapProxy::GetFrame
//
//  gets the current frame rate 
//
 
int TermCapProxy::GetFrameRate()
{

		float fps = GetPresenter()->GetActualFrameRate();
		
		if (fps<=0)
			return 0;
		if (fps<5) 
			return 1;
		if ((fps>=5) && (fps<10))
			return 2;
		if ((fps>=10) && (fps<20))
			return 3;
		if ((fps>=20) && (fps<40))
			return 4;
		if (fps>=40)
			return 5;
		
		return 0;
}
// =====================================================================
//
//  TermCapProxy::GetGraphicsHardware
//
//  detects the acceleration board
//


int TermCapProxy::GetGraphicsHardware()
{
	return 0;
}

// =====================================================================
//
//  TermCapProxy::GetGraphicsHardware
//
//  detects the acceleration board
//



int TermCapProxy::GetAudioOutputFormat()
{
	return 0;
}
// =====================================================================
//
//  TermCapProxy::GetMaximumAudioSamplingRate
//
//  detects the audio maximum Sampling rate
//

int TermCapProxy::GetMaximumAudioSamplingRate()
{
   return 0;

}
// =====================================================================
//
//  TermCapProxy::GetSpatialAudioCapability
//
// 
//
int TermCapProxy::GetSpatialAudioCapability()
{
	return 0;
}
// =====================================================================
//
//  TermCapProxy::GetCPULoad
//
//  
//

int TermCapProxy::GetCPULoad()
{

	 return 0;

}
// =====================================================================
//
//  TermCapProxy::GetAvailableRam
//
//  
//


int TermCapProxy::GetAvailableRam()
{

	return 0;
 
}
// =====================================================================
//
//  TermCapProxy::GetColorDepth
//
//  
//
int TermCapProxy::GetColorDepth()
{

	return 0;
} /*GetColorDepth*/
// =====================================================================
//
//  TermCapProxy::GetScreenSize
//
//  
//
int TermCapProxy::GetScreenSize()
{

	 int screenSize =GetPresenter()->GetVisualRenderer()->GetScreenWidth();
	 
	 if (screenSize<0)
		 return 0;
	 
	 if(screenSize<200)
		 return 1;
	 if((screenSize>=200)&&(screenSize<400))
		 return 2;	
	 if((screenSize>=400)&&(screenSize<800))
		 return 3;	
	 if((screenSize>=800)&&(screenSize<1600))
		 return 4;	
	  if(screenSize>=1600)
		 return 5;	

	 return 0;		
}  /*GetScreenSize*/