//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
//
// File:  TextProxy.h
//
// Authors: Matthew Leditschke 
//
// Modified: Gianluca Di Cagno  gianluca.dicagno@cselt.it
// 
// Description:
//   The definition of the proxy object used by the presenter
//   to render the Text2D node.
//
// Created: September, 1997.
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef TEXT_PROXY_H
#define TEXT_PROXY_H


#include "DrawableText.h"


class TextProxy : public DrawableText
{
public:
	TextProxy(MediaObject* pMO) : DrawableText(pMO) {}

	// Return a pointer to the Text2D node that this node is the proxy for
	Text* GetText() const { return (Text*)GetObject(); }

	// Functions inherited from the base class
	virtual void PreRender(Effects & effects);
	virtual void Draw(BRect const* pClipBRect,DrawableContext *pContext);

	FontStyle *GetFontStyle() const { 
		MediaObject *pNode = GetText()->fontStyle;
		if (pNode->GetNodeCode() == CODE_FontStyle) return (FontStyle*)pNode;
		return NULL;
	}

	int GetLength(int index) const
	{ 
		if(index<GetText()->length.GetLength())
					return (int)GetText()->length[index];
		else return -1;
			

	}
	
};


#endif // TEXT_PROXY_H
