//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
//
// File:  TimeSensorProxy.h
//
// Author: Matthew Leditschke 
//
// Modified: Gianluca Di Cagno  gianluca.dicagno@cselt.it
//
// Description:
//   The definition of the proxy object used by the presenter
//   to handle the TimeSensor node.
//
// Created: September, 1997.
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef TIME_SENSOR_PROXY_H
#define TIME_SENSOR_PROXY_H


#include "Traversable.h"


class TimeSensorProxy : public Traversable
{
public:
	TimeSensorProxy(MediaObject* pMO);

	// Return a pointer to the TimeSensor node that this node is the proxy for
	TimeSensor* GetTimeSensor() const
	{ return (TimeSensor*)GetObject(); }

	// Functions inherited from the base classes
	void UpdateTimeSensor();
	void PreRender(Effects &) {}
	BOOL IsFinished() const;


	// Private implementation details
private:
	BOOL m_isActive;
	BOOL m_prevEnabled;
	BOOL m_prevActive;
	BOOL m_endOfTimeReached;
	double m_cycleStartTime;

	// Local copies of the TimeSensor values which cannot be changed
	// once the node is active
	double m_startTime;
	double m_cycleInterval;
	BOOL m_enabled;
	BOOL m_loop;
};


#endif // TIME_SENSOR_PROXY_H
