//This software module was originally developed by Panasonic Singapore      //
//Laboratories and CSELT in the course of development of the MPEG-4 Systems //
//(ISO/IEC 14496-1) standard.                                               //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. Panasonic Singapore Laboratories   //
//and CSELT S.pA. retains full right to use the code for his/her own        //
//purpose, assign or donate the code to a third party and to inhibit third  //
//parties from using the code for non MPEG-4 Systems (ISO/IEC 14496-1)      //
//conforming products. This copyright notice must be included in all copies //
//or derivative works.                                                      //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
//
// File:  ValuatorProxy.h
//
// Author: Law Chee Yong Panasonic Singapore Laboratories 
//
// Modified: Gianluca Di Cagno gianluca.dicagno@cselt.it
//
// Description:
//   The definition of the proxy object used by the presenter
//   to render the Valuator node.
//
// Created: February, 1998.
//
// Modified:
//
///////////////////////////////////////////////////////////////////////////


#ifndef VALUATOR_PROXY_H
#define VALUATOR_PROXY_H


#include "Traversable.h"


class ValuatorProxy : public Traversable
{

public:
	ValuatorProxy(MediaObject* pMO): Traversable(pMO) {};

	// Return a pointer to the Valuator node that this node is the proxy for
	Valuator* GetValuator() const { return (Valuator*)GetObject(); }

	// Functions inherited from the base classes
	void Print(FILE* outfile, int depth) const{};
	void PreRender(Effects & effects){};
    BOOL IsFinished() const { return TRUE; }  
	void Assign();
	void StoreInValues(float x,float y=0.0,float z=0.0,float w=0.0);
private:
	
	 float m_pfIn[4], m_pfOut[4];

};


#endif // VALUATOR_PROXY_H
