//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
//
// File:  WorldInfoProxy.cpp
//
// Author: Matthew Leditschke 
//
// Modified: Gianluca Di Cagno  gianluca.dicagno@cselt.it
//
// Description:
//   The implementation of the proxy object used by the presenter
//   to handle the WorldInfo node.
//
// Created: October, 1997.
//
//
///////////////////////////////////////////////////////////////////////////


#include "defs.h"
#include "MediaObj.h"

#include "nodes.h"
#include "WorldInfoProxy.h"
#include "Presenter.h"


#ifdef	  ACTIVEX_COMPONENT
//#include "Mpeg4Cselt2DActivex.h"

#elif defined (NETSCAPE_PLUGIN)

#else
#include "MPEG4Player.h"
#include "MPEG4PlayerDoc.h"
#include "MPEG4PlayerView.h"

#endif



// =====================================================================

//
// Presenter::InitWorldInfo
//
// Initialise the proxy data structure and attach it to the render data
// pointer of the given media object node.
//

WorldInfoProxy* Presenter::InitWorldInfo(WorldInfo* pObj)
{
	return new  WorldInfoProxy(pObj);
}

void WorldInfoProxy::PreRender(Effects& effects)
{
	DWORD dwUpdateTime;

	if(effects.isSwitchedOn)	
		if((dwUpdateTime=GetWorldInfo()->GetUpdateTime())!=m_LastUpdateTime)
		{
			
			m_LastUpdateTime=dwUpdateTime;
	#ifdef STAND_ALONE
			WorldInfo *pTempWI = GetWorldInfo();
			if (!strcmp(pTempWI->info[0], "MAD EOF"))
			{
				// playlist management: go to the next track
				if (!m_bGoneForward && GetApp()->m_playList && GetApp()->m_playList->hasNextTrack())
				{
						GetView() -> PostMessage(WM_COMMAND, MAKEWPARAM(ID_GO_FORWARD,0), NULL);
						m_bGoneForward = true;
				}
			}
	#endif
			GetPresenter()->GetExecutive()->GetScene()->SetWorldInfo(GetWorldInfo());
		}
		
	
}


// =====================================================================
