//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
//
// File: custom.h
//
// Author: Matthew Leditschke
//
// Modified:
//
// Description:
//   The definition of the macros which are used to customise the
//   definition and implementation of some of the Core classes.
//
// Created: September, 1997.
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef CUSTOM_H
#define CUSTOM_H


#define CUSTOMIZE_EXECUTIVE_DECLARATION \
public : BOOL m_ExecutiveStartCalled; \
	Application * GetApp()	{ return m_pApp;} 
#define CUSTOMIZE_EXECUTIVE_CONSTRUCTOR \
	m_ExecutiveStartCalled=FALSE;
#define CUSTOMIZE_EXECUTIVE_DESTRUCTOR
#define CUSTOMIZE_EXECUTIVE_START \
 m_ExecutiveStartCalled=TRUE;

#define CUSTOMIZE_MEDIAOBJECT_DECLARATION \
private: \
	void *m_pPresenterData; \
public: \
	virtual void RegisterObject() { m_pPresenterData = NULL; } \
	void *GetPresenterData () const { return m_pPresenterData; } \
	void SetPresenterData (void* pPresData) \
		{ m_pPresenterData = pPresData; }

#define CUSTOMIZE_MEDIAOBJECT_CONSTRUCTOR
#define CUSTOMIZE_MEDIAOBJECT_DESTRUCTOR \
	((Presenter*)GetExecutive()->GetPresenter())->DeleteObject(this);

#define CUSTOMIZE_MEDIAOBJECT_INITIALIZATION \
	RegisterObject();

#define CUSTOMIZE_STREAMCONSUMER_DECLARATION \
public: \
	const struct Url* GetUrl(int i ){if (url.GetLength()>i)return &url[i];else return NULL;} 


#define CUSTOMIZE_STREAMCONSUMER_CONSTRUCTOR
#define CUSTOMIZE_STREAMCONSUMER_DESTRUCTOR

#define CUSTOMIZE_GROUPNODE_DECLARATION
#define CUSTOMIZE_GROUPNODE_INITIALIZATION
#define CUSTOMIZE_ROOT_DECLARATION

#define CUSTOMIZE_PRESENTER_DECLARATION
#define CUSTOMIZE_AUDIORENDERER_DECLARATION
#define CUSTOMIZE_VISUALRENDERER_DECLARATION

#define eventIn		 public:
#define exposedField public:
#define eventOut	 public:
// PORTING to Java 2
//#define field         public:
#define FIELD         public:

#endif // CUSTOM_H
