//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
//
// File: DrawableContext.cpp
//
// Authors: Gianluca Di Cagno <CSELT, gianluca.dicagno@cselt.it>
//
// Modified:
//
// Description:
//   The implementation of context methods for drawable nodes.
//
// Created: November 1998.
//
//
///////////////////////////////////////////////////////////////////////////


#include "defs.h"
#include "Nodes.h"
#include "DrawableNode.h"
#include "Trace.h"




void DrawableContext::UpdateBoundingRect()
{
/*	//look in the previous BRect list there is a BRect equal to the Rect to Draw, if so
	// don't draw the object.
	m_needsDrawing= !((DrawableNode *) m_pDrawable)->LookInPreviousBBoxList(&m_boundingRect);*/

	//Build the clippedBoundingRect, intersection of the bounding rect and the 
	//clipping rect
	m_clippedBoundingRect=m_boundingRect;
	if(!m_clippingRect.IsEmpty())
		m_clippedBoundingRect.Intersection(m_clippingRect);

	//look in the previous BRect list there is a BRect equal to the Rect to Draw, if so
	// don't draw the object.
	m_needsDrawing= !((DrawableNode *) m_pDrawable)->LookInPreviousBBoxList(&m_boundingRect/*m_clippedBoundingRect*/);

  
}


void DrawableContext::BuildRefreshRect(BRect * pToBeRefreshed)
{
	
	((DrawableNode*) m_pDrawable)->GetPreviousBRectToRefresh(pToBeRefreshed);

}




// should be const.

const BOOL DrawableContext::NeedsDrawing() 
{
	if(((DrawableNode *) m_pDrawable)->NeedsDrawing(this))
	{
		TRACE_PRINT("Node needs drawing by its proxy \n");
		return TRUE;
	}
	TRACE_PRINT1("Node DrawableContext m_needsDrawing %d\n",m_needsDrawing);
	return	m_needsDrawing;
}

void DrawableContext::ResetVisitsList() {((DrawableNode *) m_pDrawable)->ResetVisitsList();}