//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
//
// File:  LayoutProxy.h
//
// Author: Gianluca Di Cagno  gianluca.dicagno@cselt.it
//
// Modified: Frederic Bouilhaguet ENST
//
// Description:
//   Layout node implementation class
//   
//
// Created: March 1999
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef Layout_PROXY_H
#define Layout_PROXY_H


#include "GroupNodeProxy.h"
#include "DrawableContext.h"
#include "Constraint.h"

class LayoutProxy : public GroupNodeProxy
{
public:
	LayoutProxy(MediaObject* pMO); 
	~LayoutProxy();
	
	

	// Return a pointer to the Layout node that this node is the proxy for
	Layout* GetLayout() const { return (Layout*)GroupNodeProxy::GetObject(); }

	// Functions inherited from the base classes
	void PreRender(Effects &effects);
	BOOL IsFinished() const { return TRUE; }

	int	 GetNumberOfLayoutChildren() {return m_numberOfContexts-1;}
	void CreateLayoutContext(Effects &effects);
	void ApplyFormats();
	void ScrollObjects();
	void  GetMaxChildrenHeight(int &maxHeight,int &maxAscent,int &maxDescent,int &maxWidth);
	const char * GetJustify(int i) const;
private:
	 
	DWORD m_LastUpdateTime;
	int   m_LayoutWidth,m_LayoutHeight;
	int   m_nLength;
	int   m_nAllocatedLength;
	int * m_previousPos;
	int	  m_nScrolledOut;
	BOOL  m_AllScrolledOut;

	int m_maxAscent;
	int m_maxDescent;
	int m_maxHeight;
	int m_maxWidth;
	// children width included space between them
	int m_ChildrenWidth;
	int m_ChildrenHeight;
	int m_step;
	DWORD m_startTime;


	 
};

#endif // Layout_PROXY_H
