/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  BIFS Decoder/ Compositor / Presenter
FILE:       MediaObj.cpp
AUTHOR:     Mikael Bourges-Sevenier (France Telecom)
OVERVIEW:   Implementation of animation streams methods
-------------------------------------------------------------------------*/
#include "defs.h"

#ifdef ANIMATION

#include <assert.h>
#include "MediaObj.h"
#include "Executiv.h"
#include "BifsDec.h"
#include "Route.h"
#include "NodeFld.h"
#include "bifs.h"
#include "Root.h"
#include "Quantize.h"
#include "Nodes.h"

// MBS: this node code should never be used. Each node has code >= 0
#include "AnimStreamDec.h"
//int MediaObject::nodeCode = -1;		// ZL: ???

/*-----------------------------------------------------------------
added by MBS for animation streams
-----------------------------------------------------------------*/
void MediaObject::parseAnimationMask(AnimationStreamDecoder *pAS) 
{
    int numDynFields=GetBifsBounds()->m_nTotalDyns;
    animatedFields.Expand(numDynFields);
    
    int i;
#ifdef TRACE_ENCODING
    ZString buf;
#endif

    for(i=0;i<numDynFields;i++) {
		//FTRD - begin - 7/10/2001 
        animatedFields[i]=pAS->readBit("isAnimField");
		//FTRD - end - 7/10/2001 
#ifdef TRACE_ENCODING
	buf += animatedFields[i]+48; // convert digit to ASCII char
#endif
    }

    for(i=0;i<numDynFields;i++) {
        if(animatedFields[i]) {
            const BifsFieldTable *ft=GetBifsDynEntry(i);
             //FTRD - begin - 20/11/2001 
			GetField(ft)->setBounds((float*)ft->m_fMin,(float*)ft->m_fMax);
			 //FTRD - begin - 20/11/2001 
			GetField(ft)->parseAnimationMask(pAS,ft->m_AnimationType);

        }
    }
}

void MediaObject::animate(AnimationStreamDecoder *pAS,BOOL intra) 
{
    int numDynFields=GetBifsBounds()->m_nTotalDyns;
    for(int i=0;i<numDynFields;i++)
      if(animatedFields[i]) {

		  //FTRD - begin - 7/10/2001 
		  TRACEP(stderr,"\t\tMaskID (%d)",i);
		  //FTRD - end - 7/10/2001 

			
		  const BifsFieldTable *pEntry = GetBifsDynEntry(i);
		  BOOL ret = GetField(pEntry)->animate(pAS,intra);
		  UpdateField(pEntry, ret);
		  
    }
}

#endif ANIMATION
