/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Optibase Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Optibase Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1998.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Zvi Lifshitz at zvil@csi.com.
----------------------------------------------------------------------*/

/*-------------------------------------------------------------------------
Project General utlities
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Binary to Base64 converter
FILE:       main.cpp
AUTHOR:     Zvi Lifshitz (Optibase Ltd.)
OVERVIEW:   A console application that converts a binary file to Base64
-------------------------------------------------------------------------*/
#include <ZTL.h>
#include <io.h>


int main (int argc, char **argv)
{
	FILE *fBin, *fB64;
	int nNameLength;

	if (argc < 2)
	{	printf ("Missing file name\n");
		return -1;
	}
	ZString stFileName (*++argv);

	/*-----------------------------------------------------------------
	Open the input file
	-----------------------------------------------------------------*/
	nNameLength = stFileName.GetLength ();
	LPCSTR szExt = strrchr (stFileName, '.');
	if (szExt && !strchr (szExt, '\\'))
		nNameLength -= strlen (szExt);
	if ((fBin = fopen (stFileName, "rb")) == NULL)
	{	printf ("Cannot open %s\n", (LPCSTR) stFileName);
		return -1;
	}

	/*-----------------------------------------------------------------
	Output file name extension is "b64"
	-----------------------------------------------------------------*/
	stFileName.Cut (nNameLength);
	stFileName += ".b64";
	if ((fB64 = fopen (stFileName, "w")) == NULL)
	{	printf ("Cannot open %s\n", (LPCSTR) stFileName);
		fclose (fBin);
		return -1;
	}

	/*-------------------------------------------------------------
	Read the file, convert it, and write the converted file
	-------------------------------------------------------------*/
	ZString stInput, stOutput;
	while (!feof (fBin))
	{	stInput.FRead (fBin, 57);
		ZBin2Base64 (stInput, stOutput);
		stOutput.FWrite (fB64);
		putc ('\n', fB64);
	}
	
	fclose (fBin);
	fclose (fB64);
	return 0;
}