


#include<stdlib.h>
#include<stdio.h>
#include<string.h>

#include "define.h"
#include "BifaError.h"

#include "XmlParser.h"
#include <dom/DOM.hpp>

#include "BinaryWriter.h"
#include "AnimQP.h"






AnimQP::AnimQP()
{
	m_type = 0;
	m_useDefault = false;
	m_useLowerEfficientCoding = NULL;
	m_useUpperEfficientCoding = NULL;
	m_lowerBound = NULL;
	m_upperBound = NULL;
	m_nbBound = 0;
	m_IminInt = 0;
	m_Pmin = NULL;
	m_InbBits = 0;
	m_PnbBits = 0;

}

AnimQP::~AnimQP()
{
	if (m_lowerBound)
		delete [] m_lowerBound;

	if (m_upperBound)
		delete [] m_upperBound;
	if (m_useLowerEfficientCoding)
		delete [] m_useLowerEfficientCoding;
	if (m_useUpperEfficientCoding)
		delete [] m_useUpperEfficientCoding;
	if (m_Pmin)
		delete [] m_Pmin;

}

void AnimQP::setType(int type)
{
	
	m_type = type;
	switch (m_type )
	{
	case 1: 
		m_nbPmin =3;
		m_nbBound =3;

		break;
	case 2: 
		m_nbPmin =2;
		m_nbBound =2;
		break;
	case 4:
	case 6:
	case 7:
	case 8:
	case 9:
	case 10:
	case 11:
	case 12:
	case 13:
		m_nbPmin =1;
		m_nbBound =1;
		break;
	default: 
		char buffer[16];
		sprintf(buffer,"type : %d",type);
		BifaError::error(2004,buffer);
	}
}

int	AnimQP::getType()
{
	return m_type;
}

void AnimQP::setUseDefault(bool usedef)
{
	
	if (m_type != 4 && m_type !=8 && usedef)
	{
		char buffer[16];
		sprintf(buffer,"type : %d",m_type);
		BifaError::error(0005,buffer);
		return;
	}
	m_useDefault = usedef;
	
}

bool AnimQP::getUseDefault()
{
	return m_useDefault;
}

void AnimQP::setUseLowerEfficientCoding(bool* uselower, int nbbound)
{
	
	if ((m_type==6) || (m_type==9) || (m_type==10) || (m_type==13) )
	{
		char buffer[16];
		sprintf(buffer,"type : %d ",m_type);
		BifaError::error(0006,buffer);
		return;
	}
	
	if (nbbound != m_nbBound)
	{
		char buffer[16];
		sprintf(buffer,"( %d != %d )",m_nbBound,nbbound);
		BifaError::error(2007,buffer);
		return;
	}
	m_useLowerEfficientCoding = new bool[m_nbBound];
	memcpy(m_useLowerEfficientCoding,uselower,sizeof(bool)*nbbound);
}

bool* AnimQP::getUseLowerEfficientCoding()
{
	return m_useLowerEfficientCoding;
}

void AnimQP::setUseUpperEfficientCoding(bool* useupper, int nbbound)
{
	
	if ((m_type==6) || (m_type==9) || (m_type==10) || (m_type==13) )
	{
		char buffer[16];
		sprintf(buffer,"type : %d ",m_type);
		BifaError::error(0006,buffer);
		return;
	}
	
	if (nbbound != m_nbBound)
	{
		char buffer[16];
		sprintf(buffer,"( %d != %d )",m_nbBound,nbbound);
		BifaError::error(2007,buffer);
		return;
	}
	m_useUpperEfficientCoding = new bool[m_nbBound];
	memcpy(m_useUpperEfficientCoding,useupper,sizeof(bool)*nbbound);
}

bool* AnimQP::getUseUpperEfficientCoding()
{
	return m_useUpperEfficientCoding;
}

void AnimQP::setLowerBound(float* lowerbound, int nbbound)
{
	if (m_lowerBound)
		delete m_lowerBound;

	
	if ((m_type==6) || (m_type==9) || (m_type==10) || (m_type==13) )
	{
		char buffer[16];
		sprintf(buffer,"type : %d ",m_type);
		BifaError::error(0006,buffer);
		return;
	}
	
	if (nbbound != m_nbBound)
	{
		char buffer[16];
		sprintf(buffer,"( %d != %d )",m_nbBound,nbbound);
		BifaError::error(2007,buffer);
		return;
	}
	m_lowerBound = new float[m_nbBound];
	memcpy(m_lowerBound,lowerbound,sizeof(float)*nbbound);
}

float* AnimQP::getLowerBound()
{
	return m_lowerBound;
}

void AnimQP::setUpperBound(float* upperbound, int nbbound)
{
	if (m_upperBound)
		delete m_upperBound;

	
	if ((m_type==6) || (m_type==9) || (m_type==10) || (m_type==13) )
	{
		char buffer[16];
		sprintf(buffer,"type : %d ",m_type);
		BifaError::error(0006,buffer);
		return;
	}
	
	if (nbbound != m_nbBound)
	{
		char buffer[16];
		sprintf(buffer,"( %d != %d )",m_nbBound,nbbound);
		BifaError::error(2007,buffer);
		return;
	}
	m_upperBound = new float[m_nbBound];
	memcpy(m_upperBound,upperbound,sizeof(float)*m_nbBound);
}

float* AnimQP::getUpperBound()
{
	return m_upperBound;
}

int AnimQP::getNbBound()
{
	return m_nbBound;
}

void AnimQP::setIminInt(int iminint)
{
	
	if (m_type!=13)
	{
		char buffer[16];
		sprintf(buffer,"type : %d",m_type);
		BifaError::error(8,buffer);
		return;
	}
	m_IminInt = iminint;
	
}

int AnimQP::getIminInt()
{
	return m_IminInt;
}

void	AnimQP::setPmin(int *pmin,int nbPmin)
{
	
	if (nbPmin && (m_nbBound != nbPmin))
	{
		char buffer[16];
		sprintf(buffer,"( %d != %d )",m_nbBound,nbPmin);
		BifaError::error(2007,buffer);
		return;
	}

	if (m_Pmin)
		delete [] m_Pmin;

	m_Pmin = new int[m_nbPmin];
	memcpy(m_Pmin,pmin,sizeof(int)*m_nbPmin);
	
}

int*	AnimQP::getPmin()
{
	return m_Pmin;
}


int		AnimQP::getNbPmin()
{
	return m_nbPmin;
}

void	AnimQP::updatePmin(int *pmin)
{
	
	for (int i=0; i<m_nbPmin;i++)
		m_Pmin[i] = (pmin[i]<m_Pmin[i])?pmin[i]:m_Pmin[i];
}

void AnimQP::setInbBits(int inbbits)
{
	m_InbBits = inbbits;
}

int	AnimQP::getInbBits()
{
	return m_InbBits;
}
void AnimQP::setPnbBits(int pnbbits)
{
	
	if (pnbbits>14)
	{
		char buffer[16];
		sprintf(buffer,"PnbBits : %d > 14",pnbbits);
		BifaError::error(9,buffer);
		m_PnbBits = 13;
		return;
	}
	m_PnbBits = pnbbits;
}

int	AnimQP::getPnbBits()
{
	return m_PnbBits;
}


void AnimQP::writeMask(BinaryWriter * binWriter)
{
	
	binWriter->write((unsigned int)m_type,4,"type");
	switch(m_type)
	{
	case 4: 
	case 8: 
		binWriter->write(m_useDefault,1,"useDefault");
	case 1: 
	case 2: 
	case 11:
	case 12:
	case 7: 
		if (!m_useDefault)
		{
			char buffer[16];
			
			for (int i=0; i<m_nbBound;i++)
			{
				
				binWriter->write(m_useLowerEfficientCoding[i],1,"useEfficientCoding");
				sprintf(buffer,"%0.3f",m_lowerBound[i]);
				if (m_useLowerEfficientCoding[i])
						
						binWriter->writeEfficientFloat(m_lowerBound[i],"Imin",buffer);
					else
						
						binWriter->write(m_lowerBound[i],"Imin",buffer);
			}
			
			for (i=0; i<m_nbBound;i++)
			{
				
				binWriter->write(m_useUpperEfficientCoding[i],1,"useEfficientCoding");
				sprintf(buffer,"%0.3f",m_upperBound[i]);
					if (m_useUpperEfficientCoding[i])
						
						binWriter->writeEfficientFloat(m_upperBound[i],"Imax",buffer);
					else
						
						binWriter->write(m_upperBound[i],"Imax",buffer);
			}
		}
		break;
	case 13: 
		char buffer[16];
		sprintf(buffer,"%d",m_IminInt);
		binWriter->write((unsigned int)m_IminInt,32,"IminInt",buffer);
		break;
	}
	char buffer[32];
	
	sprintf(buffer,"%d",m_InbBits);
	binWriter->write((unsigned int)m_InbBits,5,"INbBits",buffer);

	for (int i=0;i<m_nbPmin;i++)
	{
		
		sprintf(buffer,"%d %d",(m_Pmin[i]+(1<<m_InbBits)),m_Pmin[i]);
		binWriter->write((unsigned int)(m_Pmin[i]+(1<<m_InbBits)),m_InbBits+1,"Pmin",buffer);
	}

	
	binWriter->write((unsigned int)m_PnbBits,4,"PNbBits");
}


void AnimQP::writeBifa(BinaryWriter * binWriter)
{

	
	if ( (m_lowerBound && m_upperBound) || m_IminInt)
	{
		
		binWriter->write(true,1,"IMinMax");

		switch(m_type)
		{
		case 4: 
		case 8: 
			binWriter->write(m_useDefault,1,"useDefault");
		case 1:
		case 2:
		case 11:
		case 12:
		case 7:
			if (!m_useDefault)
			{
				char buffer[16];
				
				for (int i=0; i<m_nbBound;i++)
				{	
					
					binWriter->write(m_useLowerEfficientCoding[i],1,"useEfficientCoding");
					sprintf(buffer,"%0.3f",m_lowerBound[i]);
					if (m_useLowerEfficientCoding[i])
						
						binWriter->writeEfficientFloat(m_lowerBound[i],"Imin",buffer);
					else
						
						binWriter->write(m_lowerBound[i],"Imin",buffer);
				}
				
				for (i=0; i<m_nbBound;i++)
				{
					
					binWriter->write(m_useUpperEfficientCoding[i],1,"useEfficientCoding");
					sprintf(buffer,"%0.3f",m_upperBound[i]);
					if (m_useUpperEfficientCoding[i])
						
						binWriter->writeEfficientFloat(m_upperBound[i],"Imax",buffer);
					else
						
						binWriter->write(m_upperBound[i],"Imax",buffer);
				}
			}
			break;
		case 13: 
			char buffer[16];
			sprintf(buffer,"%d",m_IminInt);
			binWriter->write((unsigned int)m_IminInt,32,"IminInt",buffer);
			break;
		}
	}
	else
		
		binWriter->write(false,1,"IMinMax");

	char buffer[32];

	if (m_InbBits)
	{
		
		binWriter->write(true,1,"hasINbBits");
		
		sprintf(buffer,"%d",m_InbBits);
		binWriter->write((unsigned int)m_InbBits,5,"INbBits",buffer);
	}
	else
		
		binWriter->write(false,1,"hasINbBits");
	
	if (m_Pmin)
	{
		
		binWriter->write(true,1,"PMinMax");
		for (int i=0;i<m_nbPmin;i++)
		{
			
			sprintf(buffer,"%d %d",(m_Pmin[i]+(1<<m_InbBits)),m_Pmin[i]);
			binWriter->write((unsigned int)(m_Pmin[i]+(1<<m_InbBits)),m_InbBits+1,"Pmin",buffer);
		}
	}
	else
		
		binWriter->write(false,1,"PMinMax");
	
	if (m_PnbBits)
	{
		
		binWriter->write(true,1,"hasPNbBits");
		binWriter->write((unsigned int)m_PnbBits,4,"PNbBits");
	}
	else
		
		binWriter->write(false,1,"hasPNbBits");
	
}


void AnimQP::nbBitsToWrite(int &bits)
{
	if ( (m_lowerBound && m_upperBound) || m_IminInt)
	{
		
		bits+=1;
		switch(m_type)
		{
		case 4: 
		case 8: 
			
			bits+=1;
		case 1: 
		case 2: 
		case 11:
		case 12:
		case 7: 
			if (!m_useDefault)
			{
				
				for (int i=0; i<m_nbBound;i++)
				{
					
					bits+=1;
					if (m_useLowerEfficientCoding[i])
						
						bits+=BinaryWriter::nbBitsEfficientFloat(m_lowerBound[i]);
					else
						
						bits+=32;
				}
				for (i=0; i<m_nbBound;i++)
				{
					
					bits+=1;
					if (m_useUpperEfficientCoding[i])
						
						bits+=BinaryWriter::nbBitsEfficientFloat(m_upperBound[i]);
					else
						
						bits+=32;
				}
			}
			break;
		case 13: 
			bits+=32;
			break;
		}
	}
	else
		
		bits+=1;

	
	bits+=1;
	if (m_InbBits)
		
		bits+=5;
	
	bits+=1;
	if (m_Pmin)
		for (int i=0;i<m_nbPmin;i++)
			
			bits+=(m_InbBits+1);
	
	bits+=1;
	if (m_PnbBits)
		
		bits+=4;
		
}


void AnimQP::parse(DOM_Element *node)
{
	DOMString str;
	
	str = node->getAttribute(XMTATTR_TYPE);
	if (str.length())
	{
		TRACEP("\t\t\t type(%s)\n",str.transcode());
		int type;
		sscanf(str.transcode(),"%d",&type);
		setType(type);
	}
	
	str = node->getAttribute(XMTATTR_USEDEFAULT);
	if (str.length())
	{
			TRACEP("\t\t\t useDefalut(%s)\n",str.transcode());
		if (str.equals("true"))
			setUseDefault(true);
		else
			setUseDefault(false);
	}
	
	str = node->getAttribute(XMTATTR_USELOWERBOUNDEFFICENTCODING);
	if (str.length())
	{
		TRACEP("\t\t\t useLowerBoundEfficientCoding(%s)\n",str.transcode());
		int nbElm=0;
		char * buffer =strdup(str.transcode());
		XmlParser::getCleanBuffer(buffer,nbElm);
		
		char * buff = buffer;
		
		bool * lowerBound = new bool[nbElm];
		
		for (int i=0;i<nbElm;i++)
		{
			if (!strncmp("true",buff,4))
				lowerBound[i] = true;
			else
				lowerBound[i] = false;
			char* tmp = strchr(buff,' ');
			buff = tmp+1;
		}
		setUseLowerEfficientCoding(lowerBound,nbElm);
		delete [] lowerBound;
		free(buffer);


	}
	
	str = node->getAttribute(XMTATTR_USEUPPERBOUNDEFFICENTCODING);
	if (str.length())
	{
		TRACEP("\t\t\t useUpperBoundEfficientCoding(%s)\n",str.transcode());
		int nbElm=0;
		char * buffer =strdup(str.transcode());
		XmlParser::getCleanBuffer(buffer,nbElm);
		
		char * buff = buffer;
		
		bool * upperBound = new bool[nbElm];
		
		for (int i=0;i<nbElm;i++)
		{
			if (!strncmp("true",buff,4))
				upperBound[i] = true;
			else
				upperBound[i] = false;
			char* tmp = strchr(buff,' ');
			buff = tmp+1;
		}
		setUseUpperEfficientCoding(upperBound,nbElm);
		delete [] upperBound;
		free(buffer);
	}
	
	str = node->getAttribute(XMTATTR_LOWERBOUND);
	if (str.length())
	{
		TRACEP("\t\t\t lowerBound(%s)\n",str.transcode());
		int nbElm=0;
		char * buffer =strdup(str.transcode());
		XmlParser::getCleanBuffer(buffer,nbElm);
		
		char * buff = buffer;
		
		float * lowerBound = new float[nbElm];
		
		char *tmp = buff;
		for (int i=0; i<nbElm; i++)
		{
			while(*tmp && (*tmp != ' ')) 
				tmp++;
			*tmp = '\0';
			sscanf(buff,"%f",&(lowerBound[i]));
			buff = ++tmp;
		}
		setLowerBound(lowerBound,nbElm);
		delete []lowerBound;
		free(buffer);
	}
	
	str = node->getAttribute(XMTATTR_UPPERBOUND);
	if (str.length())
	{
		TRACEP("\t\t\t upperBound(%s)\n",str.transcode());
		int nbElm=0;
		char * buffer =strdup(str.transcode());
		XmlParser::getCleanBuffer(buffer,nbElm);
		
		char * buff = buffer;
		
		float * upperBound = new float[nbElm];
		char *tmp = buff;
		
		for (int i=0; i<nbElm; i++)
		{
			while(*tmp && (*tmp != ' ')) 
				tmp++;
			*tmp = '\0';
			sscanf(buff,"%f",&(upperBound[i]));
			buff = ++tmp;
		}
		setUpperBound(upperBound,nbElm);
		delete [] upperBound;
		free(buffer);
	}
	
	str = node->getAttribute(XMTATTR_IMININT);
	if (str.length())
	{
		TRACEP("\t\t\t IminInt(%s)\n",str.transcode());
		int imin;
		sscanf(str.transcode(),"%d",&imin);
		setIminInt(imin);
	}
	
	str = node->getAttribute(XMTATTR_INBBITS);
	if (str.length())
	{
		TRACEP("\t\t\t InbBits(%s)\n",str.transcode());
		int inbbits;
		sscanf(str.transcode(),"%d",&inbbits);
		setInbBits(inbbits);
	}
	
	str = node->getAttribute(XMTATTR_PNBBITS);
	if (str.length())
	{
		TRACEP("\t\t\t PnbBits(%s)\n",str.transcode());
		int pnbbits;
		sscanf(str.transcode(),"%d",&pnbbits);
		setPnbBits(pnbbits);
	}
	
	str = node->getAttribute(XMTATTR_PMIN);
	if (str.length())
	{
		TRACEP("\t\t\t Pmin(%s)\n",str.transcode());
		
		int nbElm=0;
		char * buffer =strdup(str.transcode());
		XmlParser::getCleanBuffer(buffer,nbElm);
		
		char * buff = buffer;
		
		int * pmin = new int[nbElm];
		char *tmp = buff;
		
		for (int i=0; i<nbElm; i++)
		{
			while(*tmp && (*tmp != ' ')) 
				tmp++;
			*tmp = '\0';
			sscanf(buff,"%d",&(pmin[i]));
			buff = ++tmp;
		}
		setPmin(pmin,nbElm);
		delete [] pmin;
		free(buffer);
	}
}

