



#if !defined(AFX_ANIMATIONFIELD_H__7BFEA1CF_907C_4B8D_9C68_4CBA1EF10BF8__INCLUDED_)
#define AFX_ANIMATIONFIELD_H__7BFEA1CF_907C_4B8D_9C68_4CBA1EF10BF8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif 

#include "define.h"

class BinaryWriter;
class AnimationFrameData;
class AnimQP;
class BifaQuantizer;
class DOM_Element;


class AnimationField  
{
public:
	
	AnimationField( AnimationFrameData* AFD, BifaQuantizer* bquant=NULL);
	
	virtual ~AnimationField();
	
	
	void				setMaskID(int maskid);
	
	int					getMaskID();
	
	void				setID(int ID);
	
	int					getID();

	
	void				setAnimQP(AnimQP* aqp);
	
	AnimQP*				getAnimQP();

	
	void				setNbMField(int nbfield);
	
	int					getNbMField();

	
	int					quantizeFloat(float min, float max, int nbBits, float val);
	
	float				unQuantizeFloat(float IMin, float IMax, int INbBits,int vq);
	
	int					quantizeInt(int min, int max, int nbBits, int val);
	
	int					unQuantizeInt(int IMin, int IMax, int INbBits,int vq);
	
	float*				unQuantizeRotation(int vq[3],int nBits, int direction, int orientation);
	
	float*				unQuantizeNormal(int vq[2],int nBits, int direction, int orientation);

	
	bool				isIntra();

	
	virtual int*		getQuantValue();
	
	virtual int*		getEncodedValue();
	
	virtual int			getNbQuantValue();

	
	virtual void		parse(DOM_Element* node);

	
	virtual void		quantizeValue(BifaQuantizer * pBifaQuant) = 0;
	
	virtual void		deltaValue(AnimationField * pPrec) = 0;
	
	virtual void		shiftValue(BifaQuantizer * pBifaQuant, int* minvalue) = 0;
	
	virtual void		encodeValue(BifaQuantizer * pBifaQuant, bool flush=false) = 0;
	
	virtual void		calcMinValue(int ** minValue) = 0;

	
	int					getNbBits(int k);


	
	virtual void	write(FILE *file);
	
	virtual void	write(BinaryWriter * binWriter);
	
	virtual void	nbBitsToWrite(int &bits);

protected:
	
	AnimationFrameData* m_animationFrameData;
	
	int					m_maskID;
	
	int					m_ID;
	
	AnimQP*				m_animQP;
	
	int					m_nbMField;
	
	int	*				m_encodedValue;
	
	int	*				m_nbaacbits;
	
	int	*				m_quantValue;
	
	int	*				m_shiftedValue;
	
	int					m_nbQuantValue;
	
	BifaQuantizer * m_bifaquantizer;

	
	
};

#endif 
