



#if !defined(AFX_ANIMATIONFRAME_H__21889E39_9AA4_4D52_BE0D_0E4D1BE45396__INCLUDED_)
#define AFX_ANIMATIONFRAME_H__21889E39_9AA4_4D52_BE0D_0E4D1BE45396__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif 

#include <stdio.h>

#include "define.h"

class BinaryWriter;
class SkipFrame;
class FrameRate;
class AnimationFrameData;
class DOM_Element;

class AnimationFrame  
{
public:
	
	AnimationFrame( float begin);
	
	virtual ~AnimationFrame();

	
	void				setAnimationStartCode(int animstartcode);
	
	int					getAnimationStartCode();

	
	float				getBegin();

	
	void				setIsIntra(bool isintra);
	
	bool				getIsIntra();

	
	void				setTimeCode(int timecode);
	
	int					getTimeCode();
	

	
	int					addAnimationFrameData(AnimationFrameData * afd);
	
	AnimationFrameData* getAnimationFrameData(int i);
	
	int					getNbAnimationFrameData();

	
	void				setSkipFrame(SkipFrame* skipframe);
	
	SkipFrame*			getSkipFrame();

	
	void				setFrameRate(FrameRate* framerate);
	
	FrameRate*			getFrameRate();

	
	void				setNumNode(int num);
	
	int					getNumNode();

	
	void				parse(DOM_Element* node);

	
	void	write(FILE *file);
	
	void	write(BinaryWriter * binWriter);
	
	void	nbBitsToWrite(int &bits);



protected:
	
	float				m_begin; 
	
	int					m_animationStarCode;
	
	bool				m_isIntra;
	
	int					m_timecode;

	
	AnimationFrameData* m_tabAFD[MAXOBJECT];
	
	int					m_nbAFD;
	
	SkipFrame*			m_skipFrame;
	
	FrameRate*			m_frameRate;
	
	int					m_numNode;

};

#endif 
