


#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "XmlParser.h"
#include <dom/DOM.hpp>

#include "BinaryWriter.h"
#include "BifsConfig.h"
#include "ElementaryMask.h"
#include "AnimationMask.h"






AnimationMask::AnimationMask(BifsConfig * bfg) : m_bifsConfig(bfg)
{

	
	memset(m_tabEM,NULL,sizeof(ElementaryMask*)*MAXOBJECT);
	m_nbEM = 0;

	
	m_bifsConfig->addAnimationMask(this);

}


AnimationMask::~AnimationMask()
{
	if (m_tabEM)
		for (int i=0; i<m_nbEM; i++)
			delete m_tabEM[i];
}


BifsConfig* AnimationMask::getBifsConfig()
{
	return m_bifsConfig;
}


int AnimationMask::addElementaryMask(ElementaryMask *EM)
{
	m_tabEM[m_nbEM] = EM;
	return m_nbEM++;
}


ElementaryMask* AnimationMask::getElementaryMask(int i)
{
	if (i>=0 && i<m_nbEM)
		return m_tabEM[i];

	
	return NULL;
}


int AnimationMask::getNbElementaryMask()
{
	return m_nbEM;
}


void AnimationMask::write(BinaryWriter * binWriter)
{
	binWriter->log("# BIFSAnim Track BIFSConfig");
	for (int i=0; i<m_nbEM; i++)
	{
		
		m_tabEM[i]->write(binWriter);
		
		if (i<(m_nbEM-1))
			binWriter->write(true,1,"moreMasks");
	}
	
	binWriter->write(false,1,"moreMasks");
}


void AnimationMask::parse(DOM_Element* node)
{
}
