












#include <stdlib.h>
#include <stdio.h>



#include "ArithEncoder.h"

bool ArithEncoder::reset()
{
	low=0;
	high=TOP;
	zerocount=0;
	m_bitcount=0;
	m_opposite_bits=0;
	return true;
}

void ArithEncoder::encodeAndUpdate(int val, ArithModel &model, char * str,int &bits)
{


	int a_obits=m_opposite_bits;
	encode(val,model,str);
	bits= m_bitcount + m_opposite_bits - a_obits;
	update(val,model);
}

void ArithEncoder::encodeAndUpdate(int val, ArithModel &model)
{
	encode(val,model);
	update(val,model);
}
	
void ArithEncoder::encode(int index, ArithModel &model,char * text)
{
	
	encode(index,model);
	text;
}

void ArithEncoder::encode(int index, ArithModel &model)
{
	m_lastvalue =0;
	m_lastnbbits =0;

	length=high-low+1;
	high = low - 1 + ( length * model.getCumulFreq(index)) / model.getCumulFreq(0);
	low  += (length * model.getCumulFreq(index+1)) / model.getCumulFreq(0);
	m_bitcount=0;
	for (;;)
	{
		if (high<Q2) bit_opp_bits(false,"Encoding");
		else if (low>=Q2) 
			{
				bit_opp_bits(true,"Encoding");
				low -= Q2;
				high -= Q2;
			}
			else 
				if ( low>= Q1 && high < Q3 )
				{
					m_opposite_bits++;
					low -= Q1;
					high -= Q1;
				}
				else break;
			
		low *= 2;
		high = 2 * high +1;
	}
}

int ArithEncoder::flush()
{
	m_bitcount=0;
	m_opposite_bits++;
	int retValue=1+m_opposite_bits;
	if (low<Q1) bit_opp_bits(false,"AAE flush");
	else bit_opp_bits(true,"AAE flush");
	reset();
	return retValue;
}

void ArithEncoder::bit_opp_bits(bool bit,char *  str)
{
	bit_in_psc_layer(bit,str);
	while (m_opposite_bits> 0) 
	{
		bit_in_psc_layer(!bit,str);
		m_opposite_bits--;
	}
}

void ArithEncoder::bit_in_psc_layer(bool bit,char* str)
{
	if (zerocount == ZEROMAX )
	{

		addBit(true);
		zerocount=0;
		fprintf(stderr,"[Message]ArithEncoder : marker bit!%s\n",str);
	}

	addBit(bit);
	zerocount=bit?0:zerocount+1;
}

void ArithEncoder::addBit(bool bit)
{
	
	m_lastvalue<<=1;
	m_lastnbbits++;

	if (bit)
		m_lastvalue|=1;
	else
		m_lastvalue|=0;

}

	
void ArithEncoder::getLastValue(int& val, int&nbbits)
{
	val = m_lastvalue;
	nbbits = m_lastnbbits;
}