



#if !defined(AFX_BIFAQUANTIZER_H__30411678_55D8_4121_8C7C_47F74B4CE510__INCLUDED_)
#define AFX_BIFAQUANTIZER_H__30411678_55D8_4121_8C7C_47F74B4CE510__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif 

class ArithModel;
class ArithEncoder;
class AnimationField;
class AnimQP;





class BifaQuantizer
{
public:
	
	BifaQuantizer( int nodeID, int ID, int nbAnimationFrame);
	
	virtual ~BifaQuantizer();

	
	int				getNodeID();	
	
	int				getID();

	
	void			setInitialAnimQp(AnimQP* aqp);
	
	void			setAnimQp(AnimQP* aqp);

	
	void			setType(int type);
	
	void			setIndexList(int* indexlist, int nbindex);
	
	void			setIsTotal(bool istotal);
	
	void			setRandomAccess(bool randomaccess);

	
	int				addAnimationField(AnimationField* afd);
	
	AnimationField*	getAnimationField(int i);
	
	int				getNbAnimationField();
	
	int				getAnimationType();

	AnimQP*			getAnimQP();

	
	void			quantize();

	
	void			encode(int i,bool reset = false, bool flush=false);

	
	int				encodeAndUpdate(int val,int indexModel, int nbModel, int& bits, bool flush=false);

	
	static ArithEncoder	m_ArithEncoder;

protected:
	
	int				m_ID;
	
	int				m_nodeID;
	
	int				m_nbAnimationFrame;
	
	ArithModel**	m_tabArithModel;
	
	int				m_nbArithModel;

	
	AnimQP*			m_initialAnimQP;
	
	AnimQP*			m_animQP;
	
	int				m_type;
	
	int*			m_indexList;
	
	int				m_nbIndex;
	
	bool			m_isTotal;
	
	bool			m_randomAccess;
	
	AnimationField** m_tabAFD;
	
	int				m_nbAFD;




};

#endif 
