


#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "define.h"

#include "XmlParser.h"
#include <dom/DOM.hpp>

#include "BinaryWriter.h"
#include "FrameRate.h"






FrameRate::FrameRate(int framerate , int second , int freqoffset) : m_frameRate(framerate) , m_second(second) ,m_frequencyOffset(freqoffset)
{
}


FrameRate::~FrameRate()
{

}

void FrameRate::setFrameRate(int framerate)
{
	m_frameRate = framerate;
}

int	FrameRate::getFrameRate()
{
	return m_frameRate;
}

void FrameRate::setSecond(int second)
{
	m_second = second;
}

int	FrameRate::getSecond()
{
	return m_second;
}

void FrameRate::setFrequencyOffset(int freqoffest)
{
	m_frequencyOffset = freqoffest;
}

int	FrameRate::getTrequencyOffset()
{
	return m_frequencyOffset;
}


void FrameRate::write(BinaryWriter * binWriter)
{
	binWriter->write((unsigned int)m_frameRate,8,"frameRate");
	binWriter->write((unsigned int)m_second,4,"seconds");
	binWriter->write((unsigned int)m_frequencyOffset,1,"frequencyOffset");
}


void FrameRate::nbBitsToWrite(int &bits)
{
	
	bits += 13;
}


void FrameRate::parse(DOM_Element* node)
{
	DOMString str;
	
	str = node->getAttribute(XMTATTR_FRAMERATE);
	if (str.length())
	{
		TRACEP("\t\t\t FrameRate(%s)\n",str.transcode());
		int framerate;
		sscanf(str.transcode(),"%d",&framerate);
		setFrameRate(framerate);
	}
	
	str = node->getAttribute(XMTATTR_SECONDS);
	if (str.length())
	{
		TRACEP("\t\t\t seconds(%s)\n",str.transcode());
		int second;
		sscanf(str.transcode(),"%d",&second);
		setSecond(second);
	}
	
	str = node->getAttribute(XMTATTR_FREQUENCYOFFSET);
	if (str.length())
	{
		TRACEP("\t\t\t FrequencyOffset(%s)\n",str.transcode());
		int freqoffset;
		sscanf(str.transcode(),"%d",&freqoffset);
		setFrequencyOffset(freqoffset);
	}
	
}
