
#if !defined(_defs_h)	
#define _defs_h

#ifdef BIFSCAR
#define BIFSDEC
#endif

#ifdef SERVER
#define MUX
#endif

#ifdef MUX
#define BIFSENC
#endif

#ifndef BIFSENC
#define BIFSDEC
#endif

#if defined(BIFSDEC) && !defined(BIFSCAR)
#define PLAYER
#endif

#if defined(BIFSENC) && !defined(MUX) && !defined (BIFSCAR)
#define ENCODER
#endif

#if defined(BIFSENC) && !defined(TRACE_ENCODING)
#define TRACE_ENCODING
#endif

#ifdef BIFSENC
#define PREDICTIVE
#endif

typedef const unsigned char *LPCBYTE;

#ifdef WIN32

#pragma warning(disable: 4201)  
#pragma warning(disable: 4514)  
#pragma warning(disable: 4226)  
#pragma warning(disable: 4244)  
#pragma warning(disable: 4355)  
#pragma warning(disable: 4710)  
#pragma warning(disable: 4800)  

#define STOREINT(n, pBuf) (* (int *) (pBuf) = n)
#define LOADINT(pBuf) (* (int *) (pBuf))
#define STOREWORD(n, pBuf) (* (WORD *) (pBuf) = n)
#define LOADWORD(pBuf) (* (WORD *) (pBuf))
#define STOREDWORD(n, pBuf) (* (DWORD *) (pBuf) = n)
#define LOADDWORD(pBuf) (* (DWORD *) (pBuf))

#if defined(BUILD_CSELT_APP) || defined(OSMOSE) || defined(PLAYER3D)
	#ifndef STAND_ALONE
		#include "StdAfx.h"
	#endif
#include <afxwin.h>             
#include <afxext.h>             
#include "mmsystem.h"
#include <afxdisp.h>            

#ifndef _AFX_NO_AFXCMN_SUPPORT

#include <afxcmn.h>             

#endif	

#else	

#include <windows.h>       
#include <stdio.h>

#endif	

#define COMPLAIN(a) OutputDebugString(a)
#define M_PI 3.1415926535

#define ALMOST_ZERO 1e-10

#ifndef TRACE

inline void TRACE (const char* a, ...)
{
	va_list marker;
	char buf[1024];

	va_start(marker, a);
	vsprintf(buf, a, marker);
	OutputDebugString(buf);
	va_end(marker);
}

#endif	

#else	

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>

typedef char *LPSTR;
typedef const char* LPCSTR;
typedef short WORD;
typedef char BYTE;
typedef struct tagRect {int left, top, width, height;} RECT;

#ifndef BOOL
typedef int BOOL;
#endif	

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif	

#define min(a,b) ((a)>(b)?(b):(a))
#define max(a,b) ((a)<(b)?(b):(a))

#define LOBYTE(w)           ((BYTE)(w))
#define HIBYTE(w)           ((BYTE)(((WORD)(w) >> 8) & 0xFF))
#define LOWORD(l)           ((WORD)(l))
#define HIWORD(l)           ((WORD)(((DWORD)(l) >> 16) & 0xFFFF))
#define MAKEWORD(a, b)      ((WORD)(((BYTE)(a)) | ((WORD)((BYTE)(b))) << 8))
#define MAKELONG(a, b)      ((LONG)(((WORD)(a)) | ((DWORD)((WORD)(b))) << 16))

#define STOREWORD(n, pBuf) \
	((pBuf) [0] = LOBYTE (n), (pBuf) [1] = HIBYTE (n))

#define STOREDWORD(n, pBuf) \
	(	STOREWORD (LOWORD (n, (pBuf)), \
		STOREWORD (HIWORD (n, (pBuf) + sizeof (WORD) \
	)

#define STOREINT(n, pBuf) STOREDWORD (n, pBuf)

#define LOADWORD(pBuf) MAKEWORD ((pBuf) [0], (pBuf) [1])

#define LOADDWORD(pBuf) \
	MAKELONG (LOADWORD (pBuf), LOADWORD ((pBuf) + sizeof (WORD))

#define LOADINT(pBuf) LOADDWORD (pBuf)

#define COMPLAIN(a) printf(a)

#endif	

#ifndef ASSERT
#ifdef _DEBUG
#define ASSERT(n) assert(n)
#else
#define ASSERT(n)
#endif
#endif

#ifndef VERIFY
#ifdef _DEBUG
#define VERIFY(n) assert(n)
#else
#define VERIFY(n) n
#endif
#endif


#define min3(a,b,c) ((a)<(b)?min(a,c):min(b,c))
#define max3(a,b,c) ((a)>(b)?max(a,c):max(b,c))

#endif                                      
