/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1998.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Zvi Lifshitz at zvil@csi.com.
----------------------------------------------------------------------*/

#if !defined(_EncOD_h)	// Sentry, use file only if it's not already included.
#define _EncOD_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  BIFS/OD Encoder
FILE:       EncOD.h
AUTHOR:     Zvi Lifshitz (Triton R&D Ltd.)
OVERVIEW:   Declare extensions for the OD classes, used for extended
			implementation of OD encoding.
-------------------------------------------------------------------------*/
#include "ODP.h"
//#ifdef _SAIT_3DTG_MP4VIDEO_
#include "../IM1Decoders/MP4Video/MediaParser/SaitStream.h"
//#endif _SAIT_3DTG_MP4VIDEO_

class ODEncoder;

class ObjectDescriptorUpdateEnc : public ObjectDescriptorUpdate
{
private:
	virtual void PreEncode (SDLBaseClass *pField);
};

class ES_DescriptorUpdateEnc : public ES_DescriptorUpdate
{
private:
	virtual void PreEncode (SDLBaseClass *pField);
};

class ES_DescriptorRemoveEnc : public ES_DescriptorRemove
{
private:
	virtual void PreEncode (SDLBaseClass *pField);
};

class IPMP_DescriptorUpdateEnc : public IPMP_DescriptorUpdate
{
private:
	virtual void PreEncode (SDLBaseClass *pField);
};

class ObjectDescriptorEnc : public ObjectDescriptor
{
private:
	virtual void PreEncode (SDLBaseClass *pField);
	ObjectDescriptor *ReplaceByScriptOD ();
};

class InitialObjectDescriptorEnc : public InitialObjectDescriptor
{
private:
	virtual void PreEncode (SDLBaseClass *pField);
};

class ES_DescriptorEnc : public ES_Descriptor
{
private:
	virtual void PreEncode (SDLBaseClass *pField);

//#ifdef _SAIT_3DTG_MP4VIDEO_
// by D.S.CHO
private:
	class StreamDSI *m_pStream;
	FILE *m_fStream;

	static StreamDsiFactoryBase *m_pFactories [40];
	static int m_nFactoriesAvailable;
public:
	static void RegisterFactory (StreamDsiFactoryBase *pFactory);
//~by D.S.CHO
//#endif _SAIT_3DTG_MP4VIDEO_
};

//#ifdef _SAIT_3DTG_MP4VIDEO_
// by D.S.CHO
class DecoderSpecificInfoStringEnc : public DecoderSpecificInfoString
{
private:
	virtual void PreEncode (SDLBaseClass *pField);
};
//~by D.S.CHO
//#endif _SAIT_3DTG_MP4VIDEO_

class DecoderConfigDescriptorEnc : public DecoderConfigDescriptor
{
private:
	virtual void PreEncode (SDLBaseClass *pField);
};

class ContentIdentificationDescriptorEnc : public ContentIdentificationDescriptor
{
private:
	virtual void PreEncode (SDLBaseClass *pField);
};

class KeyWordDescriptorEnc : public KeyWordDescriptor
{
private:
	virtual void PreEncode (SDLBaseClass *pField);
};  

class ExpandedTextualDescriptorEnc : public ExpandedTextualDescriptor
{
private:
	virtual void PreEncode (SDLBaseClass *pField);
};

class ContentCreatorNameDescriptorEnc : public ContentCreatorNameDescriptor
{
private:
	virtual void PreEncode (SDLBaseClass *pField);
};  

class OCICreatorNameDescriptorEnc : public OCICreatorNameDescriptor
{
private:
	virtual void PreEncode (SDLBaseClass *pField);
};  

// NHK	990702
class SmpteCameraPositionDescriptorEnc : public SmpteCameraPositionDescriptor
{
private:
	virtual void PreEncode (SDLBaseClass *pField);
};

class SLConfigDescriptorEnc : public SLConfigDescriptor
{
private:
	virtual void PreEncode (SDLBaseClass *pField);
};

class BIFSConfigEnc : public BIFSConfig
{
private:
	virtual void PreEncode (SDLBaseClass *pField);
};

class BIFSv2ConfigEnc : public BIFSv2Config
{
private:
	virtual void PreEncode (SDLBaseClass *pField);
};

// AudioSpecificConfigEnc added by giorgio.zoia@epfl.ch  2000-01-20

class AudioSpecificConfigEnc : public AudioSpecificConfig
{
private:
	virtual void PreEncode (SDLBaseClass *pField);
};

// GeneralAudioConfig added by gew@iis.fhg.de 990512
class GeneralAudioConfigEnc : public GeneralAudioConfig
{
private:
	virtual void PreEncode (SDLBaseClass *pField);
};

#endif                                      // _EncOD_h sentry.
