/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Optibase Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Optibase Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1997.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Zvi Lifshitz at zvil@csi.com.
----------------------------------------------------------------------*/

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  BIFS Encoder
FILE:       Parser.cpp
AUTHOR:     Zvi Lifshitz (Optibase Ltd.)
OVERVIEW:   Implementation of Parser, the base class for classes that parse tokens.
-------------------------------------------------------------------------*/
#include "defs.h"
#include "Parser.h"

/*-----------------------------------------------------------------
Define the list of reserved tokens
-----------------------------------------------------------------*/
LPCSTR Parser :: m_reserved [] = 
{
	"",
	"{",
	"}",
	"[",
	"]",
	",",
	".",
	"",
	"USE",
	"DEF",
	"FALSE",
	"TRUE",
	"ROUTE",
	"TO",
	"AT",
	"RAP",
	"INSERT",
	"REPLACE",
	"DELETE",
	"APPEND",
	"LAST",
	"SCENE",
	"BY",
	/*extended commands*/
	"GLOBALQUANT",
	"INSERTPROTO",
	"DELETEPROTO",
	"DELETEEX",
	"UPDATENODE",
	"MULTIPLEREPLACE",
	/*end extended commands*/
	"UPDATE",
	"REMOVE",
	"OD",
	"ESD",
	"IN",
	"IPMPD",
	"IPMPDX",
	"FROM",
	"FILE",
	"PROTO",
	"EXTERNPROTO",
	"FIELD", "EXPOSEDFIELD", "EVENTIN", "EVENTOUT",
	"SFBOOL", "SFFLOAT", "SFTIME", "SFINT32", "SFSTRING",
	"SFVEC3F", "SFVEC2F", "SFCOLOR", "SFROTATION", "SFIMAGE", "SFNODE",
	"MFBOOL", "MFFLOAT", "MFTIME", "MFINT32", "MFSTRING",
	"MFVEC3F", "MFVEC2F", "MFCOLOR", "MFROTATION", "MFIMAGE", "MFNODE",
	"IS",
	"PREDICTIVE", //AC 19991121
	"NULL",
	"OCI_EVENT",
	"EXECUTE"
};		

/*-----------------------------------------------------------------
Check if a string is a reserved symbol
-----------------------------------------------------------------*/
TOKEN_CODE Parser :: GetSymbol (LPCSTR szToken)
{
	for (int i = TID_LEFT_BRACE; i < TID_NUMBER_OF_RESERVED; i++)
		if (!stricmp (szToken, m_reserved [i]))
			return (TOKEN_CODE) i;
	return TID_UNKNOWN;
}