/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Optibase Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Optibase Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1997.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Zvi Lifshitz at zvil@csi.com.
----------------------------------------------------------------------*/

#if !defined(_VrmlPars_h)	// Sentry, use file only if it's not already included.
#define _VrmlPars_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  BIFS Encoder
FILE:       VrmlPars.h
AUTHOR:     Zvi Lifshitz (Optibase Ltd.)
OVERVIEW:   Declaration of VRMLParser, the class that parses tokens from input files
			in VRML format
-------------------------------------------------------------------------*/
#include "Parser.h"

class VRMLParser : public Parser
{	
private:
	void Scan ();
	int GetChar ();

public:
	virtual bool Init (LPCSTR szFileName);
	virtual void Shutdown ();
	virtual void GetToken (TokenInfo *pInfo);
	virtual LPCSTR GetLine () const {return m_szLine;}
	virtual void GetString (ZString &str);

private:
	FILE *m_fInput;
	ZString m_szRootFile;
	int m_cNext, m_nInputOffset, m_nInputLength, m_nLineNumber;
	TOKEN_CODE m_code;
	char m_szLine [500];
	ZString m_string;
};

#endif                                      // _VrmlPars_h sentry.
