/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Optibase Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Optibase Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2002.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Zvi Lifshitz at zvil@csi.com.
----------------------------------------------------------------------*/
#if !defined(_BifsGen_h)	// Sentry, use file only if it's not already included.
#define _BifsGen_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  MUW
FILE:       BifsGen.h
AUTHOR:     Zvi Lifshitz (Optibase Ltd.)
OVERVIEW:   Declarations of BifsGenerator. A class that encodes scene memory image to BIFS
-------------------------------------------------------------------------*/
#include "SysCoder.h"

class Root;
class Proto;
class NodeField;
class MediaObject;

class BifsGenerator : public SysCoder
{
private:

public:
	void GenerateNodeDeletion (int nID);
	void GenerateRouteDeletion (int nID);
	void GenerateSceneReplace (Root *pScene);
	int GetNodeIDBits () {return m_nNodeIDbits;}
	int GetRouteIDBits () {return m_nRouteIDbits;}
	int GetProtoIDBits () {return m_nProtoIDbits;}
	BifsGenerator (
		int nNodeIDbits,
		int nRouteIDbits,
		int nProtoIDbits,
		FILE *fList,
		LPCSTR szListTitle,
		int flags,
		int version,
		FILE *fLogs = NULL
	);
	void EncodeString (const ZString &string);
	void SetProto (Proto *pProto) {m_pProto = pProto;}
	Proto *GetProto () const {return m_pProto;}
	int GetEncodeCounter () const {return m_nEncodeCounter;}
	void IncreaseCounter () {++m_nEncodeCounter;}

private:
	int m_nNodeIDbits, m_nRouteIDbits, m_nProtoIDbits;
	Proto *m_pProto;
	int m_nEncodeCounter;
};

#endif                                      // _BifsGen_h sentry.
