/***********************************************************************
    This software module  was  originally  developed by Zvi  Lifshitz
    (Triton R&D Ltd.) and  Mikael Bourges-Sevenier (France Telecom CNET)
    in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
    standard.  This software module is an implementation of a part of
    one or more MPEG-4 Systems (ISO/IEC 14496-1) tools  as  specified
    by  the  MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC gives
    users of the MPEG-4 Systems (ISO/IEC 14496-1)  free  license  to
    this software module or modifications thereof for use in hardware
    or software products claiming conformance to the  MPEG-4  Systems
    (ISO/IEC 14496-1). Those intending to use this software module in
    hardware or software  products  are  advised  that  its  use  may
    infringe   existing  patents.  The  original  developer  of  this
    software module and his/her company, the subsequent  editors  and
    their  companies,  and  ISO/IEC have no liability for use of this
    software module or modifications thereof  in  an  implementation.
    Copyright  is not released for non MPEG-4 Systems (ISO/IEC 14496-
    1) conforming  products.  Triton R&D Ltd. and France  Telecom  CNET
    retain  full  right to use the code for their own purpose, assign
    or donate the code to a third party and to inhibit third  parties
    from  using  the  code  for  non MPEG-4 Systems (ISO/IEC 14496-1)
    conforming products. This copyright notice must  be  included  in
    all copies or derivative works. Copyright  1997.
************************************************************************/

/**************************************************************************
 * Project Im1Player
 * INTERNATIONAL STANDARD ORGANIZATION
 * ISO/IEC JTC1/SC29/WG11
 * 
 * SUBSYSTEM: BIFS Encoder/Decoder
 * FILE:      NodeCode.h
 * AUTHOR:    Mikael Bourges-Sevenier (Mindego Inc.)
 * OVERVIEW:  Node code for node data type tables.
 * 
 * Comment:   Automatically generated on Fri Apr 07 09:16:03 PDT 2006
 *            by parsing the MPEG-4 node templates files.
 *            Contact: mikael@mindego.com
 *
 **************************************************************************/
#if !defined(_NodeCode_h) // Sentry, use file only if it's not already included
#define _NodeCode_h

/*-----------------------------------------------------------------
  Define node codes for 189 nodes
-----------------------------------------------------------------*/
enum {
	CODE_version1,	// version 1
	CODE_Anchor = CODE_version1,
	CODE_AnimationStream,
	CODE_Appearance,
	CODE_AudioBuffer,
	CODE_AudioClip,
	CODE_AudioDelay,
	CODE_AudioFX,
	CODE_AudioMix,
	CODE_AudioSource,
	CODE_AudioSwitch,
	CODE_Background,
	CODE_Background2D,
	CODE_Billboard,
	CODE_Bitmap,
	CODE_Box,
	CODE_Circle,
	CODE_Collision,
	CODE_Color,
	CODE_ColorInterpolator,
	CODE_CompositeTexture2D,
	CODE_CompositeTexture3D,
	CODE_Conditional,
	CODE_Cone,
	CODE_Coordinate,
	CODE_Coordinate2D,
	CODE_CoordinateInterpolator,
	CODE_CoordinateInterpolator2D,
	CODE_Curve2D,
	CODE_Cylinder,
	CODE_CylinderSensor,
	CODE_DirectionalLight,
	CODE_DiscSensor,
	CODE_ElevationGrid,
	CODE_Expression,
	CODE_Extrusion,
	CODE_Face,
	CODE_FaceDefMesh,
	CODE_FaceDefTables,
	CODE_FaceDefTransform,
	CODE_FAP,
	CODE_FDP,
	CODE_FIT,
	CODE_Fog,
	CODE_FontStyle,
	CODE_Form,
	CODE_Group,
	CODE_ImageTexture,
	CODE_IndexedFaceSet,
	CODE_IndexedFaceSet2D,
	CODE_IndexedLineSet,
	CODE_IndexedLineSet2D,
	CODE_Inline,
	CODE_LOD,
	CODE_Layer2D,
	CODE_Layer3D,
	CODE_Layout,
	CODE_LineProperties,
	CODE_ListeningPoint,
	CODE_Material,
	CODE_Material2D,
	CODE_MovieTexture,
	CODE_NavigationInfo,
	CODE_Normal,
	CODE_NormalInterpolator,
	CODE_OrderedGroup,
	CODE_OrientationInterpolator,
	CODE_PixelTexture,
	CODE_PlaneSensor,
	CODE_PlaneSensor2D,
	CODE_PointLight,
	CODE_PointSet,
	CODE_PointSet2D,
	CODE_PositionInterpolator,
	CODE_PositionInterpolator2D,
	CODE_ProximitySensor2D,
	CODE_ProximitySensor,
	CODE_QuantizationParameter,
	CODE_Rectangle,
	CODE_ScalarInterpolator,
	CODE_Script,
	CODE_Shape,
	CODE_Sound,
	CODE_Sound2D,
	CODE_Sphere,
	CODE_SphereSensor,
	CODE_SpotLight,
	CODE_Switch,
	CODE_TermCap,
	CODE_Text,
	CODE_TextureCoordinate,
	CODE_TextureTransform,
	CODE_TimeSensor,
	CODE_TouchSensor,
	CODE_Transform,
	CODE_Transform2D,
	CODE_Valuator,
	CODE_Viewpoint,
	CODE_VisibilitySensor,
	CODE_Viseme,
	CODE_WorldInfo,
	CODE_version2,	// version 2
	CODE_AcousticMaterial = CODE_version2,
	CODE_AcousticScene,
	CODE_ApplicationWindow,
	CODE_BAP,
	CODE_BDP,
	CODE_Body,
	CODE_BodyDefTable,
	CODE_BodySegmentConnectionHint,
	CODE_DirectiveSound,
	CODE_Hierarchical3DMesh,
	CODE_MaterialKey,
	CODE_PerceptualParameters,
	CODE_version3,	// version 3
	CODE_TemporalTransform = CODE_version3,
	CODE_TemporalGroup,
	CODE_ServerCommand,
	CODE_version4,	// version 4
	CODE_InputSensor = CODE_version4,
	CODE_MatteTexture,
	CODE_MediaBuffer,
	CODE_MediaControl,
	CODE_MediaSensor,
	CODE_version5,	// version 5
	CODE_BitWrapper = CODE_version5,
	CODE_CoordinateInterpolator4D,
	CODE_DepthImage,
	CODE_FFD,
	CODE_Implicit,
	CODE_XXLFM_Appearance,
	CODE_XXLFM_BlendList,
	CODE_XXLFM_FrameList,
	CODE_XXLFM_LightMap,
	CODE_XXLFM_SurfaceMapList,
	CODE_XXLFM_ViewMapList,
	CODE_MeshGrid,
	CODE_NonLinearDeformer,
	CODE_NurbsCurve,
	CODE_NurbsCurve2D,
	CODE_NurbsSurface,
	CODE_OctreeImage,
	CODE_XXParticles,
	CODE_XXParticleInitBox,
	CODE_XXPlanarObstacle,
	CODE_XXPointAttractor,
	CODE_PointTexture,
	CODE_PositionAnimator,
	CODE_PositionAnimator2D,
	CODE_PositionInterpolator4D,
	CODE_ProceduralTexture,
	CODE_Quadric,
	CODE_SBBone,
	CODE_SBMuscle,
	CODE_SBSegment,
	CODE_SBSite,
	CODE_SBSkinnedModel,
	CODE_SBVCAnimation,
	CODE_ScalarAnimator,
	CODE_SimpleTexture,
	CODE_SolidRep,
	CODE_SubdivisionSurface,
	CODE_SubdivSurfaceSector,
	CODE_WaveletSubdivisionSurface,
	CODE_version6,	// version 6
	CODE_Clipper2D = CODE_version6,
	CODE_ColorTransform,
	CODE_XEllipse,
	CODE_LinearGradient,
	CODE_PathLayout,
	CODE_RadialGradient,
	CODE_SynthesizedTexture,
	CODE_TransformMatrix2D,
	CODE_Viewport,
	CODE_XCurve2D,
	CODE_XFontStyle,
	CODE_XLineProperties,
	CODE_version7,	// version 7
	CODE_AdvancedAudioBuffer = CODE_version7,
	CODE_AudioChannelConfig,
	CODE_DepthImageV2,
	CODE_MorphShape,
	CODE_MultiTexture,
	CODE_MultiTextureCoordinate,
	CODE_PointTextureV2,
	CODE_SBVCAnimationV2,
	CODE_SimpleTextureV2,
	CODE_SurroundingSound,
	CODE_Transform3DAudio,
	CODE_WideSound,
	CODE_FootPrintSet,
	CODE_FootPrint,
	CODE_BuildingPart,
	CODE_Roof,
	CODE_Facade,
	CODE_Shadow
};
#endif                                 // _NodeCode_h sentry.
/* End of automatically generated file */
