/***********************************************************************
    This software module  was  originally  developed by Zvi  Lifshitz
    (Triton R&D Ltd.) and  Mikael Bourges-Sevenier (France Telecom CNET)
    in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
    standard.  This software module is an implementation of a part of
    one or more MPEG-4 Systems (ISO/IEC 14496-1) tools  as  specified
    by  the  MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC gives
    users of the MPEG-4 Systems (ISO/IEC 14496-1)  free  license  to
    this software module or modifications thereof for use in hardware
    or software products claiming conformance to the  MPEG-4  Systems
    (ISO/IEC 14496-1). Those intending to use this software module in
    hardware or software  products  are  advised  that  its  use  may
    infringe   existing  patents.  The  original  developer  of  this
    software module and his/her company, the subsequent  editors  and
    their  companies,  and  ISO/IEC have no liability for use of this
    software module or modifications thereof  in  an  implementation.
    Copyright  is not released for non MPEG-4 Systems (ISO/IEC 14496-
    1) conforming  products.  Triton R&D Ltd. and France  Telecom  CNET
    retain  full  right to use the code for their own purpose, assign
    or donate the code to a third party and to inhibit third  parties
    from  using  the  code  for  non MPEG-4 Systems (ISO/IEC 14496-1)
    conforming products. This copyright notice must  be  included  in
    all copies or derivative works. Copyright  1997.
************************************************************************/

/**************************************************************************
 * Project Im1Player
 * INTERNATIONAL STANDARD ORGANIZATION
 * ISO/IEC JTC1/SC29/WG11
 * 
 * SUBSYSTEM: BIFS Encoder/Decoder
 * FILE:      NodeTabl.cpp
 * AUTHOR:    Mikael Bourges-Sevenier (Mindego Inc.)
 * OVERVIEW:  Node Data Type tables.
 * 
 * Comment:   Automatically generated on Fri Apr 07 09:16:03 PDT 2006
 *            by parsing the MPEG-4 node templates files.
 *            Contact: mikael@mindego.com
 *
 **************************************************************************/
#include "defs.h"
#include "Im1defs.h"
#include "Nodes.h"
#include "CrNodes.h"

/* Here are 53 node data types. */
/* and 35 tables have only one node: 
 *    SFBAPNode, SFBDPNode, SFBackground2DNode, 
 *    SFBackground3DNode, SFBaseMeshNode, SFBlendListNode, 
 *    SFBodyDefTableNode, SFBodySegmentConnectionHintNode, SFColorNode, 
 *    SFCoordinate2DNode, SFCoordinateNode, SFExpressionNode, 
 *    SFFAPNode, SFFDPNode, SFFITNode, 
 *    SFFaceDefMeshNode, SFFaceDefTablesNode, SFFaceDefTransformNode, 
 *    SFFogNode, SFFrameListNode, SFLightMapNode, 
 *    SFNavigationInfoNode, SFNormalNode, SFParticleInitializerNode, 
 *    SFPerceptualParameterNode, SFSBBoneNode, SFSBMuscleNode, 
 *    SFSBSegmentNode, SFSBSiteNode, SFSubdivSurfaceSectorNode, 
 *    SFSurfaceMapNode, SFViewMapNode, SFViewpointNode, 
 *    SFViewportNode, SFVisemeNode
 */

/* In SF2DNode, we have 58 nodes defined. */
const int SF2DNode :: m_nodeTable[]={
// version 1
	Anchor :: nodeCode,
	AnimationStream :: nodeCode,
	Background2D :: nodeCode,
	ColorInterpolator :: nodeCode,
	Conditional :: nodeCode,
	CoordinateInterpolator2D :: nodeCode,
	DiscSensor :: nodeCode,
	Face :: nodeCode,
	Form :: nodeCode,
	Group :: nodeCode,
	Inline :: nodeCode,
	LOD :: nodeCode,
	Layer2D :: nodeCode,
	Layer3D :: nodeCode,
	Layout :: nodeCode,
	OrderedGroup :: nodeCode,
	PlaneSensor2D :: nodeCode,
	PositionInterpolator2D :: nodeCode,
	ProximitySensor2D :: nodeCode,
	QuantizationParameter :: nodeCode,
	ScalarInterpolator :: nodeCode,
	Script :: nodeCode,
	Shape :: nodeCode,
	Sound2D :: nodeCode,
	Switch :: nodeCode,
	TermCap :: nodeCode,
	TimeSensor :: nodeCode,
	TouchSensor :: nodeCode,
	Transform2D :: nodeCode,
	Valuator :: nodeCode,
	WorldInfo :: nodeCode,
// version 2
	ApplicationWindow :: nodeCode,
	Body :: nodeCode,
// version 3
	TemporalTransform :: nodeCode,
	TemporalGroup :: nodeCode,
	ServerCommand :: nodeCode,
// version 4
	InputSensor :: nodeCode,
	MatteTexture :: nodeCode,
	MediaBuffer :: nodeCode,
	MediaControl :: nodeCode,
	MediaSensor :: nodeCode,
// version 5
	BitWrapper :: nodeCode,
	PositionAnimator2D :: nodeCode,
	SBBone :: nodeCode,
	SBMuscle :: nodeCode,
	SBSegment :: nodeCode,
	SBSite :: nodeCode,
	SBSkinnedModel :: nodeCode,
	SBVCAnimation :: nodeCode,
	ScalarAnimator :: nodeCode,
// version 6
	Clipper2D :: nodeCode,
	ColorTransform :: nodeCode,
	PathLayout :: nodeCode,
	TransformMatrix2D :: nodeCode,
	Viewport :: nodeCode,
// version 7
	MorphShape :: nodeCode,
	SBVCAnimationV2 :: nodeCode,
	Transform3DAudio :: nodeCode
};

const int SF2DNode :: m_nodeVersionLength[] = {31, 2, 3, 5, 9, 5, 3};

/* In SF3DNode, we have 92 nodes defined. */
const int SF3DNode :: m_nodeTable[]={
// version 1
	Anchor :: nodeCode,
	AnimationStream :: nodeCode,
	Background :: nodeCode,
	Background2D :: nodeCode,
	Billboard :: nodeCode,
	Collision :: nodeCode,
	ColorInterpolator :: nodeCode,
	Conditional :: nodeCode,
	CoordinateInterpolator :: nodeCode,
	CoordinateInterpolator2D :: nodeCode,
	CylinderSensor :: nodeCode,
	DirectionalLight :: nodeCode,
	DiscSensor :: nodeCode,
	Face :: nodeCode,
	Fog :: nodeCode,
	Form :: nodeCode,
	Group :: nodeCode,
	Inline :: nodeCode,
	LOD :: nodeCode,
	Layer2D :: nodeCode,
	Layer3D :: nodeCode,
	Layout :: nodeCode,
	ListeningPoint :: nodeCode,
	NavigationInfo :: nodeCode,
	NormalInterpolator :: nodeCode,
	OrderedGroup :: nodeCode,
	OrientationInterpolator :: nodeCode,
	PlaneSensor :: nodeCode,
	PlaneSensor2D :: nodeCode,
	PointLight :: nodeCode,
	PositionInterpolator :: nodeCode,
	PositionInterpolator2D :: nodeCode,
	ProximitySensor2D :: nodeCode,
	ProximitySensor :: nodeCode,
	QuantizationParameter :: nodeCode,
	ScalarInterpolator :: nodeCode,
	Script :: nodeCode,
	Shape :: nodeCode,
	Sound :: nodeCode,
	Sound2D :: nodeCode,
	SphereSensor :: nodeCode,
	SpotLight :: nodeCode,
	Switch :: nodeCode,
	TermCap :: nodeCode,
	TimeSensor :: nodeCode,
	TouchSensor :: nodeCode,
	Transform :: nodeCode,
	Transform2D :: nodeCode,
	Valuator :: nodeCode,
	Viewpoint :: nodeCode,
	VisibilitySensor :: nodeCode,
	WorldInfo :: nodeCode,
// version 2
	AcousticScene :: nodeCode,
	Body :: nodeCode,
	DirectiveSound :: nodeCode,
// version 3
	TemporalTransform :: nodeCode,
	TemporalGroup :: nodeCode,
	ServerCommand :: nodeCode,
// version 4
	InputSensor :: nodeCode,
	MatteTexture :: nodeCode,
	MediaBuffer :: nodeCode,
	MediaControl :: nodeCode,
	MediaSensor :: nodeCode,
// version 5
	BitWrapper :: nodeCode,
	CoordinateInterpolator4D :: nodeCode,
	DepthImage :: nodeCode,
	FFD :: nodeCode,
	OctreeImage :: nodeCode,
	XXParticles :: nodeCode,
	PositionAnimator :: nodeCode,
	PositionAnimator2D :: nodeCode,
	PositionInterpolator4D :: nodeCode,
	SBBone :: nodeCode,
	SBMuscle :: nodeCode,
	SBSegment :: nodeCode,
	SBSite :: nodeCode,
	SBSkinnedModel :: nodeCode,
	SBVCAnimation :: nodeCode,
	ScalarAnimator :: nodeCode,
	WaveletSubdivisionSurface :: nodeCode,
// version 6
	Clipper2D :: nodeCode,
	ColorTransform :: nodeCode,
	PathLayout :: nodeCode,
	TransformMatrix2D :: nodeCode,
	Viewport :: nodeCode,
// version 7
	DepthImageV2 :: nodeCode,
	MorphShape :: nodeCode,
	SBVCAnimationV2 :: nodeCode,
	SurroundingSound :: nodeCode,
	Transform3DAudio :: nodeCode,
	WideSound :: nodeCode,
	FootPrintSet :: nodeCode,
	FootPrint :: nodeCode,
	BuildingPart :: nodeCode,
	Roof :: nodeCode,
	Facade :: nodeCode,
	Shadow :: nodeCode
};

const int SF3DNode :: m_nodeVersionLength[] = {52, 3, 3, 5, 17, 5, 12};

/* In SFAppearanceNode, we have 2 nodes defined. */
const int SFAppearanceNode :: m_nodeTable[]={
// version 1
	Appearance :: nodeCode,
// version 5
	XXLFM_Appearance :: nodeCode
};

const int SFAppearanceNode :: m_nodeVersionLength[] = {1, 0, 0, 0, 1, 0, 0};

/* In SFAudioNode, we have 9 nodes defined. */
const int SFAudioNode :: m_nodeTable[]={
// version 1
	AudioBuffer :: nodeCode,
	AudioClip :: nodeCode,
	AudioDelay :: nodeCode,
	AudioFX :: nodeCode,
	AudioMix :: nodeCode,
	AudioSource :: nodeCode,
	AudioSwitch :: nodeCode,
// version 7
	AdvancedAudioBuffer :: nodeCode,
	AudioChannelConfig :: nodeCode
};

const int SFAudioNode :: m_nodeVersionLength[] = {7, 0, 0, 0, 0, 0, 2};

/* In SFDepthImageNode, we have 2 nodes defined. */
const int SFDepthImageNode :: m_nodeTable[]={
// version 5
	DepthImage :: nodeCode,
// version 7
	DepthImageV2 :: nodeCode
};

const int SFDepthImageNode :: m_nodeVersionLength[] = {0, 0, 0, 0, 1, 0, 1};

/* In SFDepthTextureNode, we have 4 nodes defined. */
const int SFDepthTextureNode :: m_nodeTable[]={
// version 5
	PointTexture :: nodeCode,
	SimpleTexture :: nodeCode,
// version 7
	PointTextureV2 :: nodeCode,
	SimpleTextureV2 :: nodeCode
};

const int SFDepthTextureNode :: m_nodeVersionLength[] = {0, 0, 0, 0, 2, 0, 2};

/* In SFFontStyleNode, we have 2 nodes defined. */
const int SFFontStyleNode :: m_nodeTable[]={
// version 1
	FontStyle :: nodeCode,
// version 6
	XFontStyle :: nodeCode
};

const int SFFontStyleNode :: m_nodeVersionLength[] = {1, 0, 0, 0, 0, 1, 0};

/* In SFGeometryNode, we have 30 nodes defined. */
const int SFGeometryNode :: m_nodeTable[]={
// version 1
	Bitmap :: nodeCode,
	Box :: nodeCode,
	Circle :: nodeCode,
	Cone :: nodeCode,
	Curve2D :: nodeCode,
	Cylinder :: nodeCode,
	ElevationGrid :: nodeCode,
	Extrusion :: nodeCode,
	IndexedFaceSet :: nodeCode,
	IndexedFaceSet2D :: nodeCode,
	IndexedLineSet :: nodeCode,
	IndexedLineSet2D :: nodeCode,
	PointSet :: nodeCode,
	PointSet2D :: nodeCode,
	Rectangle :: nodeCode,
	Sphere :: nodeCode,
	Text :: nodeCode,
// version 2
	Hierarchical3DMesh :: nodeCode,
// version 5
	BitWrapper :: nodeCode,
	Implicit :: nodeCode,
	MeshGrid :: nodeCode,
	NonLinearDeformer :: nodeCode,
	NurbsCurve :: nodeCode,
	NurbsCurve2D :: nodeCode,
	NurbsSurface :: nodeCode,
	Quadric :: nodeCode,
	SolidRep :: nodeCode,
	SubdivisionSurface :: nodeCode,
// version 6
	Ellipse :: nodeCode,
	XCurve2D :: nodeCode
};

const int SFGeometryNode :: m_nodeVersionLength[] = {17, 1, 0, 0, 10, 2, 0};

/* In SFInfluenceNode, we have 2 nodes defined. */
const int SFInfluenceNode :: m_nodeTable[]={
// version 5
	XXPlanarObstacle :: nodeCode,
	XXPointAttractor :: nodeCode
};

const int SFInfluenceNode :: m_nodeVersionLength[] = {0, 0, 0, 0, 2, 0, 0};

/* In SFLinePropertiesNode, we have 2 nodes defined. */
const int SFLinePropertiesNode :: m_nodeTable[]={
// version 1
	LineProperties :: nodeCode,
// version 6
	XLineProperties :: nodeCode
};

const int SFLinePropertiesNode :: m_nodeVersionLength[] = {1, 0, 0, 0, 0, 1, 0};

/* In SFMaterialNode, we have 4 nodes defined. */
const int SFMaterialNode :: m_nodeTable[]={
// version 1
	Material :: nodeCode,
	Material2D :: nodeCode,
// version 2
	AcousticMaterial :: nodeCode,
	MaterialKey :: nodeCode
};

const int SFMaterialNode :: m_nodeVersionLength[] = {2, 2, 0, 0, 0, 0, 0};

/* In SFStreamingNode, we have 5 nodes defined. */
const int SFStreamingNode :: m_nodeTable[]={
// version 1
	AnimationStream :: nodeCode,
	AudioClip :: nodeCode,
	AudioSource :: nodeCode,
	Inline :: nodeCode,
	MovieTexture :: nodeCode
};

const int SFStreamingNode :: m_nodeVersionLength[] = {5, 0, 0, 0, 0, 0, 0};

/* In SFTemporalNode, we have 2 nodes defined. */
const int SFTemporalNode :: m_nodeTable[]={
// version 3
	TemporalTransform :: nodeCode,
	TemporalGroup :: nodeCode
};

const int SFTemporalNode :: m_nodeVersionLength[] = {0, 0, 2, 0, 0, 0, 0};

/* In SFTextureCoordinateNode, we have 2 nodes defined. */
const int SFTextureCoordinateNode :: m_nodeTable[]={
// version 1
	TextureCoordinate :: nodeCode,
// version 7
	MultiTextureCoordinate :: nodeCode
};

const int SFTextureCoordinateNode :: m_nodeVersionLength[] = {1, 0, 0, 0, 0, 0, 1};

/* In SFTextureNode, we have 11 nodes defined. */
const int SFTextureNode :: m_nodeTable[]={
// version 1
	CompositeTexture2D :: nodeCode,
	CompositeTexture3D :: nodeCode,
	ImageTexture :: nodeCode,
	MovieTexture :: nodeCode,
	PixelTexture :: nodeCode,
// version 4
	MatteTexture :: nodeCode,
// version 5
	ProceduralTexture :: nodeCode,
// version 6
	LinearGradient :: nodeCode,
	RadialGradient :: nodeCode,
	SynthesizedTexture :: nodeCode,
// version 7
	MultiTexture :: nodeCode
};

const int SFTextureNode :: m_nodeVersionLength[] = {5, 0, 0, 1, 1, 3, 1};

/* In SFTextureTransformNode, we have 2 nodes defined. */
const int SFTextureTransformNode :: m_nodeTable[]={
// version 1
	TextureTransform :: nodeCode,
// version 6
	TransformMatrix2D :: nodeCode
};

const int SFTextureTransformNode :: m_nodeVersionLength[] = {1, 0, 0, 0, 0, 1, 0};

/* In SFTopNode, we have 4 nodes defined. */
const int SFTopNode :: m_nodeTable[]={
// version 1
	Group :: nodeCode,
	Layer2D :: nodeCode,
	Layer3D :: nodeCode,
	OrderedGroup :: nodeCode
};

const int SFTopNode :: m_nodeVersionLength[] = {4, 0, 0, 0, 0, 0, 0};

/* In SFWorldNode, we have 184 nodes defined. */
const int SFWorldNode :: m_nodeTable[]={
// version 1
	Anchor :: nodeCode,
	AnimationStream :: nodeCode,
	Appearance :: nodeCode,
	AudioBuffer :: nodeCode,
	AudioClip :: nodeCode,
	AudioDelay :: nodeCode,
	AudioFX :: nodeCode,
	AudioMix :: nodeCode,
	AudioSource :: nodeCode,
	AudioSwitch :: nodeCode,
	Background :: nodeCode,
	Background2D :: nodeCode,
	Billboard :: nodeCode,
	Bitmap :: nodeCode,
	Box :: nodeCode,
	Circle :: nodeCode,
	Collision :: nodeCode,
	Color :: nodeCode,
	ColorInterpolator :: nodeCode,
	CompositeTexture2D :: nodeCode,
	CompositeTexture3D :: nodeCode,
	Conditional :: nodeCode,
	Cone :: nodeCode,
	Coordinate :: nodeCode,
	Coordinate2D :: nodeCode,
	CoordinateInterpolator :: nodeCode,
	CoordinateInterpolator2D :: nodeCode,
	Curve2D :: nodeCode,
	Cylinder :: nodeCode,
	CylinderSensor :: nodeCode,
	DirectionalLight :: nodeCode,
	DiscSensor :: nodeCode,
	ElevationGrid :: nodeCode,
	Expression :: nodeCode,
	Extrusion :: nodeCode,
	Face :: nodeCode,
	FaceDefMesh :: nodeCode,
	FaceDefTables :: nodeCode,
	FaceDefTransform :: nodeCode,
	FAP :: nodeCode,
	FDP :: nodeCode,
	FIT :: nodeCode,
	Fog :: nodeCode,
	FontStyle :: nodeCode,
	Form :: nodeCode,
	Group :: nodeCode,
	ImageTexture :: nodeCode,
	IndexedFaceSet :: nodeCode,
	IndexedFaceSet2D :: nodeCode,
	IndexedLineSet :: nodeCode,
	IndexedLineSet2D :: nodeCode,
	Inline :: nodeCode,
	LOD :: nodeCode,
	Layer2D :: nodeCode,
	Layer3D :: nodeCode,
	Layout :: nodeCode,
	LineProperties :: nodeCode,
	ListeningPoint :: nodeCode,
	Material :: nodeCode,
	Material2D :: nodeCode,
	MovieTexture :: nodeCode,
	NavigationInfo :: nodeCode,
	Normal :: nodeCode,
	NormalInterpolator :: nodeCode,
	OrderedGroup :: nodeCode,
	OrientationInterpolator :: nodeCode,
	PixelTexture :: nodeCode,
	PlaneSensor :: nodeCode,
	PlaneSensor2D :: nodeCode,
	PointLight :: nodeCode,
	PointSet :: nodeCode,
	PointSet2D :: nodeCode,
	PositionInterpolator :: nodeCode,
	PositionInterpolator2D :: nodeCode,
	ProximitySensor2D :: nodeCode,
	ProximitySensor :: nodeCode,
	QuantizationParameter :: nodeCode,
	Rectangle :: nodeCode,
	ScalarInterpolator :: nodeCode,
	Script :: nodeCode,
	Shape :: nodeCode,
	Sound :: nodeCode,
	Sound2D :: nodeCode,
	Sphere :: nodeCode,
	SphereSensor :: nodeCode,
	SpotLight :: nodeCode,
	Switch :: nodeCode,
	TermCap :: nodeCode,
	Text :: nodeCode,
	TextureCoordinate :: nodeCode,
	TextureTransform :: nodeCode,
	TimeSensor :: nodeCode,
	TouchSensor :: nodeCode,
	Transform :: nodeCode,
	Transform2D :: nodeCode,
	Valuator :: nodeCode,
	Viewpoint :: nodeCode,
	VisibilitySensor :: nodeCode,
	Viseme :: nodeCode,
	WorldInfo :: nodeCode,
// version 2
	AcousticMaterial :: nodeCode,
	AcousticScene :: nodeCode,
	ApplicationWindow :: nodeCode,
	BAP :: nodeCode,
	BDP :: nodeCode,
	Body :: nodeCode,
	BodyDefTable :: nodeCode,
	BodySegmentConnectionHint :: nodeCode,
	DirectiveSound :: nodeCode,
	Hierarchical3DMesh :: nodeCode,
	MaterialKey :: nodeCode,
	PerceptualParameters :: nodeCode,
// version 3
	TemporalTransform :: nodeCode,
	TemporalGroup :: nodeCode,
	ServerCommand :: nodeCode,
// version 4
	InputSensor :: nodeCode,
	MatteTexture :: nodeCode,
	MediaBuffer :: nodeCode,
	MediaControl :: nodeCode,
	MediaSensor :: nodeCode,
// version 5
	BitWrapper :: nodeCode,
	CoordinateInterpolator4D :: nodeCode,
	DepthImage :: nodeCode,
	FFD :: nodeCode,
	Implicit :: nodeCode,
	XXLFM_Appearance :: nodeCode,
	XXLFM_BlendList :: nodeCode,
	XXLFM_FrameList :: nodeCode,
	XXLFM_LightMap :: nodeCode,
	XXLFM_SurfaceMapList :: nodeCode,
	XXLFM_ViewMapList :: nodeCode,
	MeshGrid :: nodeCode,
	NonLinearDeformer :: nodeCode,
	NurbsCurve :: nodeCode,
	NurbsCurve2D :: nodeCode,
	NurbsSurface :: nodeCode,
	OctreeImage :: nodeCode,
	XXParticles :: nodeCode,
	XXParticleInitBox :: nodeCode,
	XXPlanarObstacle :: nodeCode,
	XXPointAttractor :: nodeCode,
	PointTexture :: nodeCode,
	PositionAnimator :: nodeCode,
	PositionAnimator2D :: nodeCode,
	PositionInterpolator4D :: nodeCode,
	ProceduralTexture :: nodeCode,
	Quadric :: nodeCode,
	SBBone :: nodeCode,
	SBMuscle :: nodeCode,
	SBSegment :: nodeCode,
	SBSite :: nodeCode,
	SBSkinnedModel :: nodeCode,
	SBVCAnimation :: nodeCode,
	ScalarAnimator :: nodeCode,
	SimpleTexture :: nodeCode,
	SolidRep :: nodeCode,
	SubdivisionSurface :: nodeCode,
	SubdivSurfaceSector :: nodeCode,
	WaveletSubdivisionSurface :: nodeCode,
// version 6
	Clipper2D :: nodeCode,
	ColorTransform :: nodeCode,
	Ellipse :: nodeCode,
	LinearGradient :: nodeCode,
	PathLayout :: nodeCode,
	RadialGradient :: nodeCode,
	SynthesizedTexture :: nodeCode,
	TransformMatrix2D :: nodeCode,
	Viewport :: nodeCode,
	XCurve2D :: nodeCode,
	XFontStyle :: nodeCode,
	XLineProperties :: nodeCode,
// version 7
	AdvancedAudioBuffer :: nodeCode,
	AudioChannelConfig :: nodeCode,
	DepthImageV2 :: nodeCode,
	MorphShape :: nodeCode,
	MultiTexture :: nodeCode,
	MultiTextureCoordinate :: nodeCode,
	PointTextureV2 :: nodeCode,
	SBVCAnimationV2 :: nodeCode,
	SimpleTextureV2 :: nodeCode,
	SurroundingSound :: nodeCode,
	Transform3DAudio :: nodeCode,
	WideSound :: nodeCode,
	FootPrintSet :: nodeCode,
	FootPrint :: nodeCode,
	BuildingPart :: nodeCode,
	Roof :: nodeCode,
	Facade :: nodeCode,
	Shadow :: nodeCode	
};

const int SFWorldNode :: m_nodeVersionLength[] = {100, 12, 3, 5, 39, 12, 18};

template <NodeType type> int SFNodeType<type> :: GetNodeTableSize () const
{
	return sizeof ( m_nodeTable ) / sizeof (int);
}

const int SFGenericNode :: m_nodeVersions [] = {
	CODE_version1, 
	CODE_version2, 
	CODE_version3, 
	CODE_version4, 
	CODE_version5, 
	CODE_version6, 
	CODE_version7
};

/*-----------------------------------------------------------------
Make sure each necessary SFxxxNode class is instantiated.
(This code is never called, it is here to make sure the linker gets
everything intantiated).
-----------------------------------------------------------------*/
void IntantiateTemplateInstances () {
	SF2DNode sf2dnode;
	SF3DNode sf3dnode;
	SFAppearanceNode sfappearancenode;
	SFAudioNode sfaudionode;
	SFDepthImageNode sfdepthimagenode;
	SFDepthTextureNode sfdepthtexturenode;
	SFFontStyleNode sffontstylenode;
	SFGeometryNode sfgeometrynode;
	SFInfluenceNode sfinfluencenode;
	SFLinePropertiesNode sflinepropertiesnode;
	SFMaterialNode sfmaterialnode;
	SFStreamingNode sfstreamingnode;
	SFTemporalNode sftemporalnode;
	SFTextureCoordinateNode sftexturecoordinatenode;
	SFTextureNode sftexturenode;
	SFTextureTransformNode sftexturetransformnode;
	SFTopNode sftopnode;
	SFWorldNode sfworldnode;
}
/* End of automatically generated file */
