/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1998.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Zvi Lifshitz at zvil@csi.com.
----------------------------------------------------------------------*/

#if !defined(_OCIDec_h)	// Sentry, use file only if it's not already included.
#define _OCIDec_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  OCI Decoder / Encoder
FILE:       OCIDec.h
AUTHOR:     Zvi Lifshitz (Triton R&D Ltd.)
OVERVIEW:   Declarations of OCIDecoder - the class for decoding
			OCI streams.
-------------------------------------------------------------------------*/

#include "ODCoder.h"
#include "ODP.h"

class Executive;

class OCIDecoder : public ODCoder
{
public:
	OCIDecoder (
		Executive *pExecutive,
		FILE *fList,
		LPCSTR szListTitle,
		int flags,
		int version
	) :
		ODCoder (fList, szListTitle, flags, version),
		m_pExecutive (pExecutive)
	{}

private:
	virtual void ParseFrame (LPCBYTE pData, int nLength, DWORD dwTS);
	void ParseOCIFrame (DWORD dwTS);
	virtual void Error (int);
	virtual void EndOfUnit ();

private:
	Executive *m_pExecutive;
};

class OCI_EventImp : public OCI_Event
{

public:
	void Commit (ClockReference *pClock, DWORD dwTS);
};

class MediaTimeDescriptorImp : public MediaTimeDescriptor
{
private:	
	virtual void Commit (
		int nEventID,
		bool bAbsoluteTimeFlag,
		long nStartingTime,
		long nDuration,
		ClockReference *pClock,
		DWORD dwTS
	);
};

#endif                                      // _OCIDec_h sentry.
