/*-------------------------------------------------------------------------
Project Im1Player/ Mux
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  OD Decoder/ Encoder
FILE:       ODDecoder_SLExtension.cpp
AUTHOR:     Alexandre Cotarmanac'h Echevarria
			France Telecom R&D
E-MAIL:		alexandre.cotarmanach@francetelecom.com
OVERVIEW:   Checks whether extension is allowed.
-------------------------------------------------------------------------*/


#include "defs.h"

#include "ODDec.h"
#include "Inline.h"
#include "odtags.h"
#include "ODImp.h"
/*-------------------------------------------------------------------------
AcceptsSLExtension
--------------------------------------------------------------------------*/
bool ODDecoder::AcceptsSLExtension() const
{
	bool ret=false;
	if (m_pSource)
	{
		ObjectDescriptorImp * pIOD = m_pSource->GetOD();
		if (pIOD->GetTag() == TAG_InitialObjectDescriptor)
		{
			if (pIOD->ODProfileLevelIndication>0x01)
			{
				ret=true;
			}
			else
			{
				
				printf ("OD parsing error : invalid ODProfileLevelIndication for SLExtension\n");
			}
		}
	}
	return ret;
}
/*------------------------------------------------------------------------*/