/***********************************************************************
This software module was originally developed by Ji Ming (Panasonic Singapore
Laboratories) and Zvi Lifshitz (Optibase Ltd.) in the course of development
of the MPEG-4 Systems (ISO/IEC 14496-1) standard. This software module is an
implementation of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools
as specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Panasonic Singapore Laboratories and
Optibase Ltd. retain full right to use the code for their own purposes,
assign or donate the code to a third party and to inhibit third parties from
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
This copyright notice must be included in all copies or derivative works.
Copyright  2002.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Ji Ming at mji@psl.com.sg
----------------------------------------------------------------------*/

/*-------------------------------------------------------------------------
Project Im1Player/ Mux
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  OD Decoder/ Encoder
FILE:       odipmpx.cpp
AUTHORS:    Ji Ming (Panasonic Singapore Laboratories Pte Ltd.)
			Zvi Lifshitz (Optibase Ltd.)
OVERVIEW:   Implementation of parsing/encoding of descriptors of OD stream for version 3
-------------------------------------------------------------------------*/

#include "defs.h"
//#include "odipmpx.h"
#include "ODIPMPX.h" // SOLARIS PORTING - typo
#include "IPMP_Messages.h"
#include "odtags.h"
#include "CrSdl.h"

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_MessageBase)
	OD_IMPLEMENT_FIELD (IPMP_MessageBase, Version)
	OD_IMPLEMENT_FIELD (IPMP_MessageBase, MessageID)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_MessageBase)

OD_IMPLEMENT_ABSTRACT_DESCRIPTOR_START (IPMP_Data_BaseClass)
	OD_IMPLEMENT_EXTENSION (IPMP_OpaqueData)
	OD_IMPLEMENT_EXTENSION (IPMP_AudioWatermarkingInit)
	OD_IMPLEMENT_EXTENSION (IPMP_VideoWatermarkingInit)
	OD_IMPLEMENT_EXTENSION (IPMP_SelectiveDecryptionInit)
	OD_IMPLEMENT_EXTENSION (IPMP_KeyData)
	OD_IMPLEMENT_EXTENSION (IPMP_SendAudioWatermark)
	OD_IMPLEMENT_EXTENSION (IPMP_SendVideoWatermark)
	OD_IMPLEMENT_EXTENSION (IPMP_RightsData)
	OD_IMPLEMENT_EXTENSION (IPMP_Secure_Container)
	OD_IMPLEMENT_EXTENSION (IPMP_AddToolNotificationListener)
	OD_IMPLEMENT_EXTENSION (IPMP_RemoveToolNotificationListener)
	OD_IMPLEMENT_EXTENSION (IPMP_InitAuthentication)
	OD_IMPLEMENT_EXTENSION (IPMP_MutualAuthentication)
	OD_IMPLEMENT_EXTENSION (IPMP_UserQuery)
	OD_IMPLEMENT_EXTENSION (IPMP_UserQueryResponse)
	OD_IMPLEMENT_EXTENSION (IPMP_ToolParamCapabilitiesQuery)
	OD_IMPLEMENT_EXTENSION (IPMP_ToolParamCapabilitiesResponse)
	OD_IMPLEMENT_EXTENSION (IPMP_GetTools)
	OD_IMPLEMENT_EXTENSION (IPMP_GetToolsResponse)
	OD_IMPLEMENT_EXTENSION (IPMP_GetToolContext)
	OD_IMPLEMENT_EXTENSION (IPMP_GetToolContextResponse)
	OD_IMPLEMENT_EXTENSION (IPMP_ConnectTool)
	OD_IMPLEMENT_EXTENSION (IPMP_DisconnectTool)
	OD_IMPLEMENT_EXTENSION (IPMP_NotifyToolEvent)
	OD_IMPLEMENT_EXTENSION (IPMP_CanProcess)
	OD_IMPLEMENT_EXTENSION (User_Initialize)
	OD_IMPLEMENT_EXTENSION (User_Initialized)
OD_IMPLEMENT_ABSTRACT_DESCRIPTOR_END (IPMP_Data_BaseClass)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_ToolListDescriptor)
	OD_IMPLEMENT_FIELD (IPMP_ToolListDescriptor, ipmpTools)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_ToolListDescriptor)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_Tool)
	OD_IMPLEMENT_FIELD (IPMP_Tool, isAltGroup)
	OD_IMPLEMENT_FIELD (IPMP_Tool, isParametric)
	OD_IMPLEMENT_FIELD (IPMP_Tool, reserved)

	OD_IMPLEMENT_FIELD (IPMP_Tool, IPMP_ToolID)
	OD_IMPLEMENT_FIELD (IPMP_Tool, numAlternates)
	OD_IMPLEMENT_FIELD (IPMP_Tool, specificToolID)
	OD_IMPLEMENT_FIELD (IPMP_Tool, toolParamDescr)
	OD_IMPLEMENT_FIELD (IPMP_Tool, numURLs)
	OD_IMPLEMENT_FIELD (IPMP_Tool, ToolURL)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_Tool)

OD_IMPLEMENT_DESCRIPTOR_START (IPMPToolES_DecoderConfig)
	OD_IMPLEMENT_FIELD (IPMPToolES_DecoderConfig, IPMP_ToolID)
	OD_IMPLEMENT_FIELD (IPMPToolES_DecoderConfig, Tool_Format_ID)
	OD_IMPLEMENT_FIELD (IPMPToolES_DecoderConfig, Tool_Package_ID)
OD_IMPLEMENT_DESCRIPTOR_END (IPMPToolES_DecoderConfig)

OD_IMPLEMENT_DESCRIPTOR_START (ByteArray)
	OD_IMPLEMENT_FIELD (ByteArray, array)
OD_IMPLEMENT_DESCRIPTOR_END (ByteArray)
