/***********************************************************************
This software module was originally developed by Ji Ming (Panasonic Singapore
Laboratories) and Zvi Lifshitz (Optibase Ltd.) in the course of development
of the MPEG-4 Systems (ISO/IEC 14496-1) standard. This software module is an
implementation of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools
as specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Panasonic Singapore Laboratories and
Optibase Ltd. retain full right to use the code for their own purposes,
assign or donate the code to a third party and to inhibit third parties from
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
This copyright notice must be included in all copies or derivative works.
Copyright  2002.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Ji Ming at mji@psl.com.sg
----------------------------------------------------------------------*/

#if !defined(_odipmpx_h)	// Sentry, use file only if it's not already included.
#define _odipmpx_h

/*-------------------------------------------------------------------------
Project Im1Player/ Mux
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  OD Decoder/ Encoder
FILE:       odipmpx.h
AUTHORS:    Ji Ming (Panasonic Singapore Laboratories Pte Ltd.)
			Zvi Lifshitz (Optibase Ltd.)
			
OVERVIEW:   Declarations of descriptors of OD stream (for IPMPX)
-------------------------------------------------------------------------*/

#include "sdl.h"
#include "sdldef.h"
#include "ODP.h"

class IPMP_MessageBase : public BaseDescriptor
{	OD_DECLARE_DESCRIPTOR
public:
	// Constructor
	IPMP_MessageBase() { Version = 0x01; }

	// Members
	SDLInt<8>	Version;
	SDLInt<16>	MessageID;

};

// Bitstream message base class
/*class IPMP_Data_BaseClass : public IPMP_MessageBase
{	OD_DECLARE_ABSTRACT_DESCRIPTOR
public:
	// Member methods
	virtual IPMP_Data_BaseClass* Copy() = 0;

};
*/

//jimmy, IPMPX stuff

class IPMP_ToolListDescriptor : public BaseDescriptor
{
	OD_DECLARE_DESCRIPTOR
public:
	SDLClassArray<class IPMP_Tool, 0, 255> ipmpTools;
};

class IPMP_Tool : public BaseDescriptor
{
	OD_DECLARE_DESCRIPTOR	//this is not a descriptor class, but we want to use SDL anyway

public:
	SDLLongInt<128> IPMP_ToolID;
	SDLInt<1> isAltGroup;
	SDLInt<1> isParametric;
	SDLInt<6> reserved;	//=0b111111

	SDLInt<8> numAlternates;
	SDLArray<128> specificToolID;
	SDLString toolParamDescr;
	SDLInt<8> numURLs;
	// SOLARIS PORTING - Added parameters
	SDLClassArray<class ByteArray, 0, 255> ToolURL;
public:
	IPMP_Tool () : reserved (0x3f) {}

private:
	virtual void DescEncDec (ODCoder *pODCoder, OPTYPE op);
};

class IPMPToolES_DecoderConfig: public DecoderSpecificInfo
{
	OD_DECLARE_DESCRIPTOR

public:
	SDLLongInt<128> IPMP_ToolID;
	SDLInt<32> Tool_Format_ID;
	SDLInt<16> Tool_Package_ID;
};

class ByteArray : public SDLDescriptor
{
	OD_DECLARE_DESCRIPTOR

public:
	ByteArray() : SDLDescriptor (true) {}

	// Member
	SDLArray<8>  array;
};

#endif                                      // _odipmpx_h sentry.
// SOLARIS PORTING - Added a new line
