/***********************************************************************
This software module was originally developed by Ji Ming (Panasonic Singapore
Laboratories) and Zvi Lifshitz (Optibase Ltd.) in the course of development
of the MPEG-4 Systems (ISO/IEC 14496-1) standard. This software module is an
implementation of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools
as specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Panasonic Singapore Laboratories and
Optibase Ltd. retain full right to use the code for their own purposes,
assign or donate the code to a third party and to inhibit third parties from
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
This copyright notice must be included in all copies or derivative works.
Copyright  2002.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Ji Ming at mji@psl.com.sg
----------------------------------------------------------------------*/

/*-------------------------------------------------------------------------
Project Im1-2D for IPMPX (IPMP Extension)
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  OD Decoder/ Encoder
FILE:       odipmpxencdec.cpp
AUTHOR:     Ji Ming (Panasonic Singapore Laboratories)
OVERVIEW:   Implementation of parsing/encoding of descriptors (IPMPX) of OD stream
-------------------------------------------------------------------------*/

#include "defs.h"
#include "ODIPMPX.h"
#include "ODCoder.h"

void IPMP_Tool :: DescEncDec (ODCoder *pCoder, OPTYPE op)
{
	IPMP_ToolID.EncDec (pCoder, this, op);
	isAltGroup.EncDec (pCoder, this, op);
	isParametric.EncDec (pCoder, this, op);
	reserved.EncDec (pCoder, this, op);

	if (isAltGroup) {
		numAlternates.EncDec (pCoder, this, op);
		specificToolID.EncDecArray(pCoder, this, op, numAlternates);
	} 
	if (isParametric) {
		toolParamDescr.EncDec (pCoder, this, op);
	}
	numURLs.EncDec (pCoder, this, op);
	if (numURLs>0) {
		ToolURL.EncDecArray (pCoder, this, op, numURLs);
	}
}
