/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Optibase Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Optibase Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1998.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Zvi Lifshitz at zvil@csi.com.
----------------------------------------------------------------------*/

/*-------------------------------------------------------------------------
Project Im1Player/ Mux
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  OD Decoder/ Encoder
FILE:       odp5.cpp
AUTHOR:     Zvi Lifshitz (Optibase Ltd.)
OVERVIEW:   Implementation of parsing/encoding of descriptors of OD stream for version 5
-------------------------------------------------------------------------*/

#include "defs.h"
#include "odp5.h"
#include "odtags.h"
#include "IPMP_Messages.h"
#include "CrSdl.h"

OD_IMPLEMENT_DESCRIPTOR_START (BIFSConfigEx)
	OD_IMPLEMENT_FIELD (BIFSConfigEx, extBIFSConfig)
OD_IMPLEMENT_DESCRIPTOR_END (BIFSConfigEx)

OD_IMPLEMENT_ABSTRACT_DESCRIPTOR_START (ExtendedBIFSConfig)
	OD_IMPLEMENT_EXTENSION (MUBIFSConfig)
OD_IMPLEMENT_ABSTRACT_DESCRIPTOR_END (ExtendedBIFSConfig)

OD_IMPLEMENT_DESCRIPTOR_START (MUBIFSConfig)
	OD_IMPLEMENT_FIELD (MUBIFSConfig, useNames)
	OD_IMPLEMENT_FIELD (MUBIFSConfig, use3DMeshCoding)
	OD_IMPLEMENT_FIELD (MUBIFSConfig, usePredictiveMFField)
	OD_IMPLEMENT_FIELD (MUBIFSConfig, nodeIDbits)
	OD_IMPLEMENT_FIELD (MUBIFSConfig, routeIDbits)
	OD_IMPLEMENT_FIELD (MUBIFSConfig, protoIDbits)
	OD_IMPLEMENT_FIELD (MUBIFSConfig, zoneIDbits)
	OD_IMPLEMENT_FIELD (MUBIFSConfig, clientIDbits)
	OD_IMPLEMENT_FIELD (MUBIFSConfig, maxUpdates)
	OD_IMPLEMENT_FIELD (MUBIFSConfig, requestIDbits)
	OD_IMPLEMENT_FIELD (MUBIFSConfig, requestTypebits)
	OD_IMPLEMENT_FIELD (MUBIFSConfig, acknowledgeTypebits)
	OD_IMPLEMENT_FIELD (MUBIFSConfig, commandTypebits)
OD_IMPLEMENT_DESCRIPTOR_END (MUBIFSConfig)
