/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Optibase Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Optibase Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1998.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Zvi Lifshitz at zvil@csi.com.
----------------------------------------------------------------------*/

#if !defined(_odp5_h)	// Sentry, use file only if it's not already included.
#define _odp5_h

/*-------------------------------------------------------------------------
Project Im1Player/ Mux
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  OD Decoder/ Encoder
FILE:       odp5.h
AUTHOR:     Zvi Lifshitz (Optibase Ltd.)
OVERVIEW:   Declarations of descriptors of OD stream (for version 5)
-------------------------------------------------------------------------*/

#include "sdl.h"
#include "sdldef.h"
#include "ODP.h"

class BIFSConfigEx : public DecoderSpecificInfo
{
	OD_DECLARE_DESCRIPTOR

public:
	SDLClass<class ExtendedBIFSConfig, 1>  extBIFSConfig;
};

class ExtendedBIFSConfig : public BaseDescriptor
{
	OD_DECLARE_ABSTRACT_DESCRIPTOR
};

class MUBIFSConfig : public BIFSConfig
{
	OD_DECLARE_DESCRIPTOR

public:
	SDLInt<1> useNames;
	SDLInt<4> zoneIDbits;
	SDLInt<5> clientIDbits;
	SDLInt<32> maxUpdates;
	SDLInt<5> requestIDbits;
	SDLInt<5> requestTypebits;
	SDLInt<5> acknowledgeTypebits;
	SDLInt<4> commandTypebits;
};

#endif                                      // _odp5_h sentry.