/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Optibase Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Optibase Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1998.
************************************************************************

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Backchannel
FILE:       SrvCmd.cpp
AUTHOR:     Zvi Lifshitz (Optibase Ltd.)
OVERVIEW:   Implementation of ServerCommandImp
-------------------------------------------------------------------------*/

#include "defs.h"
#include "SrvCmd.h"
#include "ODP.h"
#include "SysCoder.h"

/*-------------------------------------------------------------
A bachchannel is opened by the constructor
-------------------------------------------------------------*/
ServerCommandImp :: ServerCommandImp ()
{
	OpenStream ();
}

/*-------------------------------------------------------------
The backchannel is closed by the constructor
-------------------------------------------------------------*/
ServerCommandImp :: ~ServerCommandImp ()
{
	CloseStream ();
}

/*-------------------------------------------------------------
A decoder must be created for all nodes derived from StreamConsumer. In this
case the only purpose of the 'decoder' will be to siganl that this is a back channel
-------------------------------------------------------------*/
Decoder *ServerCommandImp :: CreateDecoder (
	DecoderConfigDescriptor *pConfig,
	QoS_Descriptor *,
	Decoder *pCurrentDecoder
)
{	
	if (pCurrentDecoder != NULL)
		return pCurrentDecoder;

	if (pConfig ->upStream)	
		return new ServerCommandDecoder;
	return NULL;
}



/*-------------------------------------------------------------
Is called when isActive is set to TRUE
-------------------------------------------------------------*/
void ServerCommand :: Ontrigger()
{
	((ServerCommandImp*)this) -> Ontrigger ();
}

/*-------------------------------------------------------------
Implementation of Ontrigger. 
-------------------------------------------------------------*/
void ServerCommandImp :: Ontrigger()
{
	if ((Bool) enable)
	{	SysCoder sysCoder (NULL, NULL, NULL, 0, 0);
		sysCoder.EncodeInt (GetID (), 16, NULL);
		sysCoder.EncodeSFString (command);
		sysCoder.Align ();
		WriteToStream ((LPBYTE) sysCoder.GetData (), sysCoder.GetDataLength ());
	}
}
