/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Optibase Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Optibase Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1998.
************************************************************************/

#if !defined(_SrvCmd_h)	// Sentry, use file only if it's not already included.
#define _SrvCmd_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Backchannel
FILE:       SrvCmd.h
AUTHOR:
OVERVIEW:   Declarations of ServerCommandImp
-------------------------------------------------------------------------*/

#include "Decoder.h"
#include "Nodes.h"

class DecoderConfigDescriptor;
class QoS_Descriptor;

/*-------------------------------------------------------------
Overload ServerCommand
-------------------------------------------------------------*/
class ServerCommandImp : public ServerCommand
{
private:
	virtual Decoder *CreateDecoder (
		DecoderConfigDescriptor *pConfig,
		QoS_Descriptor *,
		Decoder *pCurrentDecoder
	);

public:
	ServerCommandImp ();
	~ServerCommandImp ();
	void ServerCommandImp :: Ontrigger();
};

/*-------------------------------------------------------------
Declare the ServerCommand "decoder". Actually the only purpose of this decoder
is not signal that this is a back channel
-------------------------------------------------------------*/
class ServerCommandDecoder : public Decoder
{
private:
	virtual void QueryInterface (const char*, const void*, void*& r_pSink) {r_pSink = NULL;}
	virtual const char* GetInfo () {return NULL;}
	virtual BOOL SetFormat (Capabilities &, DecoderParams &decoderParams)
	{
		decoderParams.m_nCBSize = 0;
		decoderParams.m_nDBSize = 0;
		decoderParams.m_bBackChannel = true;
		return true;
	}
	virtual void Start () {}
	virtual void Stop () {}
	virtual void Terminate () {}
	virtual BOOL Setup (const BYTE *, int, int) {return true;}
	virtual int GetOptimalOutputSize () {return 0;}
	virtual void SetInputStream (int, MediaStream *) {}
	virtual void SetOutputStream (int, MediaStream *) {}
	virtual void SetStream (MediaStream *, Executive *, Root *) {}
	virtual int GetDataOffset  (const LPBYTE) {return 0;}
	virtual DWORD GetAttributes (ATTRIBUTE_CODE , const LPBYTE) {return 0;}
	// MPGJ
	virtual void SetExecutive(class Executive *){}
	// MPGJ
};

#endif                                      // _SrvCmd_h sentry.
