/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1998.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Zvi Lifshitz at zvil@csi.com.
----------------------------------------------------------------------*/

#if !defined(_odtags_h)	// Sentry, use file only if it's not already included.
#define _odtags_h

/*-------------------------------------------------------------------------
Project Im1Player/ Mux
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  OD Decoder
FILE:       odtags.h
AUTHOR:     Zvi Lifshitz (Triton R&D Ltd.)
OVERVIEW:   Definitions of tags used by the OD parser/encoder
-------------------------------------------------------------------------*/

/*-------------------------------------------------------------
Internal list of codes to uniquely identify each descriptor
-------------------------------------------------------------*/
typedef enum
{
	CODE_BaseCommand,
	CODE_ObjectDescriptorUpdate,
	CODE_ObjectDescriptorRemove,
	CODE_ES_DescriptorUpdate,
	CODE_ES_DescriptorRemove,
	CODE_IPMP_DescriptorUpdate,
	CODE_IPMP_DescriptorRemove,
	CODE_ObjectDescriptor,
	CODE_InitialObjectDescriptor,
	CODE_ES_Descriptor,
	CODE_DecoderConfigDescriptor,
	CODE_DecoderSpecificInfo,
	CODE_AFXConfig,
	CODE_AFXExtDescriptor,
	CODE_PosInterpCompDecoderSpecific,
	CODE_OriInterpCompDecoderSpecific,
	CODE_CoordInterpCompDecoderSpecific,
// 2004-12-27, GyeongJa Jang <-
	//CODE_DIBRDecoderSpecific,
	CODE_OctreeImageDecoderSpecific,
// 2004-12-27, GyeongJa Jang ->
	CODE_A3DMCDecoderSpecific,
	CODE_MeshGridDecoderSpecificInfo,
	CODE_WMDecoderSpecificInfo,
	CODE_BBADecoderSpecific, //MP
// 2004-12-27, GyeongJa Jang <-
// 2004-07-15, Shinjun {
	//CODE_PTCompDecoderSpecific,
	CODE_PointTextureCompDecoderSpecific,
// 2004-07-15, Shinjun }
// 2004-12-27, GyeongJa Jang ->
//ory DMLAB 2007 01 07
	CODE_A3DMCExtensionDecoderSpecific,
//~ory DMLAB
	CODE_FPSetDecoderSpecificInfo,
//INT KM 2007 12 03
	CODE_FAMCDecoderSpecific,
//INT KM
	CODE_SLConfigDescriptor,
	CODE_ContentIdentificationDescriptor,
	CODE_SupplementaryContentIdentificationDescriptor,
	CODE_IPI_DescrPointer,
	CODE_IPMP_DescriptorPointer,
	CODE_IPMP_Descriptor,
	CODE_QoS_Descriptor,
	CODE_QoS_Qualifier,
	CODE_QoS_Qualifier_MAX_DELAY,
	CODE_QoS_Qualifier_PREF_MAX_DELAY,
	CODE_QoS_Qualifier_LOSS_PROB,
	CODE_QoS_Qualifier_MAX_GAP_LOSS,
	CODE_QoS_Qualifier_MAX_AU_SIZE,
	CODE_QoS_Qualifier_AVG_AU_SIZE,
	CODE_QoS_Qualifier_MAX_AU_RATE,
	CODE_QoS_Qualifier_REBUFFERING_RATIO,
	CODE_ExtensionDescriptor,
	CODE_RegistrationDescriptor,
	CODE_OCI_Descriptor,
	CODE_ContentClassificationDescriptor,
	CODE_KeyWordDescriptor,
	CODE_RatingDescriptor,
	CODE_LanguageDescriptor,
	CODE_ShortTextualDescriptor,
	CODE_ExpandedTextualDescriptor,
	CODE_ContentCreatorNameDescriptor,
	CODE_ContentCreationDateDescriptor,
	CODE_OCICreatorNameDescriptor,
	CODE_OCICreationDateDescriptor,
	CODE_OCIDecoderConfiguration,
	CODE_BIFSConfig,
	CODE_BIFSv2Config,
	CODE_JPEG_DecoderConfig,
	CODE_MuxInfo,
	CODE_MuxCodeSlot,
	CODE_MuxCodeTableElement,
	CODE_MuxCodeTable,
	CODE_DecoderSpecificInfoString,
	CODE_SmpteCameraPositionDescriptor,	// NHK 990702
	CODE_MediaTimeDescriptor,
	CODE_SL_PacketHeader,
	CODE_AudioSpecificConfig, 
	CODE_GeneralAudioConfig,  // gew@iis.fhg.de 990512
	CODE_StructuredAudioConfig,
	CODE_CELP_DecoderConfig,
	CODE_OCI_Event,
	CODE_SegmentDescriptor,
	CODE_RegistrationDescr,
	CODE_ES_ID_Inc,
	CODE_ES_ID_Ref,
	CODE_MP4_IOD,
	CODE_MP4_OD,
	CODE_IPL_DescrPointerRef,
	CODE_ExtendedProfileLevelDescr,
	CODE_profileLevelIndicationIndexDescriptor,
	CODE_UIConfig,						// CC 010122
	CODE_ObjectDescriptorExecute,
	//jimmy, IPMPX stuff
	CODE_IPMP_ToolListDescriptor,
	CODE_IPMP_Tool,
	
	// hide by Liao Xuan, out of date
	//CODE_IPMP_ToolDescriptorUpdate,
	//CODE_IPMP_ToolDescriptorPointer,
	//CODE_IPMP_ToolDescriptor,
	// End: hide by Liao Xuan

	CODE_IPMPToolES_DecoderConfig,
	CODE_IPMPDecoderConfiguration,
	// by Liao Xuan
	CODE_IPMP_TrustSecurityMetadata,//add
	CODE_IPMP_ToolAPI_Config, //add
	// End: by Liao Xuan 
	//end of IPMPX stuff
	//AC:20021009 - SL extension CODEs -- begin
	CODE_AbstractSLConfig,
	CODE_SLExtensionDescriptor,
	CODE_ExtSLConfigDescr,
	CODE_DependencyPointer,
	CODE_MarkerDescriptor,
	//AC:20021009 - SL extension CODEs -- end
	// Craig, IPMP messages.
	CODE_IPMP_OpaqueData,
	CODE_IPMP_AudioWatermarkingInit,
	CODE_IPMP_VideoWatermarkingInit,
	CODE_IPMP_SelectiveDecryptionInit,
	CODE_IPMP_KeyData,
	CODE_IPMP_SendAudioWatermark,
	CODE_IPMP_SendVideoWatermark,
	CODE_IPMP_RightsData,
	CODE_IPMP_Secure_Container,
	CODE_IPMP_AddToolNotificationListener,
	CODE_IPMP_RemoveToolNotificationListener,
	CODE_IPMP_InitAuthentication,
	CODE_IPMP_MutualAuthentication,
	CODE_IPMP_UserQuery,
	CODE_IPMP_UserQueryResponse,
	CODE_IPMP_ParamtericDescription,
	CODE_IPMP_ToolParamCapabilitiesQuery,
	CODE_IPMP_ToolParamCapabilitiesResponse,
	CODE_IPMP_GetTools,
	CODE_IPMP_GetToolsResponse,
	CODE_IPMP_GetToolContext,
	CODE_IPMP_GetToolContextResponse,
	CODE_IPMP_ConnectTool,
	CODE_IPMP_DisconnectTool,
	CODE_IPMP_NotifyToolEvent,
	CODE_IPMP_CanProcess,
	CODE_User_Initialize,
	CODE_User_Initialized,
	//CODE_IPMP_StreamDataUpdate, needed? from Zvi's update . IG
	CODE_IPMP_Message,
	CODE_IPMP_ToolES_AU,

	CODE_ByteArray,
	CODE_ParametricDescriptor,
	CODE_BufferInfoStructure,
	CODE_FieldStructure,
	CODE_AlgorithmDescriptor,
	CODE_KeyDescriptor,
	CODE_Certificate,
	CODE_DTArray,

	//by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	//CODE_RTArray,//hide, out of date class
	CODE_OptionArray,
	CODE_QTArray,//added
	CODE_DateClass,//added
	CODE_TrustSpecification,//added
	CODE_TrustedTool,//added
	//End: by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	
	//MU
	CODE_BIFSConfigEx,
	CODE_MUBIFSConfig,
	//end MU
	//CODE_AltText,
	CODE_AltText, // SOLARIS PORTING - removed the additional ,
	// End IPMP messages
#if defined SAIT_CONFORMANCE_2003
	CODE_PNG_DecoderConfig,
#endif SAIT_CONFORMANCE_2003
	CODE_JPEG2000_DecoderConfig,


	// mar 20061121:
	// This code HAS to be the last one in the list
	// as it represents the number of descriptors
	CODE_NumberDescriptors

} OD_CODES;

typedef enum
{
	TAGMIN_BaseCommand = 0,
	TAGMAX_BaseCommand = 0XFF,
	TAG_BaseCommand = 0,
	TAG_ObjectDescriptorUpdate = 0x01,
	TAG_ObjectDescriptorRemove = 0x02,
	TAG_ES_DescriptorUpdate = 0x03,
	TAG_ES_DescriptorRemove = 0x04,
	TAG_IPMP_DescriptorUpdate = 0x05,
	TAG_IPMP_DescriptorRemove = 0x06,
	TAG_ObjectDescriptorExecute = 0x08,
	
	/******************* Class Tags for Descriptors**********************/
	TAG_ObjectDescriptor = 0x01,
	TAG_InitialObjectDescriptor = 0x02,
	TAG_ES_Descriptor = 0x03,
	TAG_DecoderConfigDescriptor = 0x04,
	TAG_DecoderSpecificInfo = 0x05,
	TAG_SLConfigDescriptor = 0x06,
	TAGMIN_IP_IdentificationDataSet = 0x07,
	TAGMAX_IP_IdentificationDataSet = 0x08,
	TAG_ContentIdentificationDescriptor = 0x07,
	TAG_SupplementaryContentIdentificationDescriptor = 0x08,
	TAG_IPI_DescrPointer = 0x09,
	TAG_IPMP_DescriptorPointer = 0x0A,
	TAG_IPMP_Descriptor = 0x0B,
	TAG_QoS_Descriptor = 0x0C,
	TAG_RegistrationDescriptor = 0x0D,
	TAG_ES_ID_Inc = 0x0E,
	TAG_ES_ID_Ref = 0x0F,
	TAG_MP4_IOD = 0x10,
	TAG_MP4_OD = 0x11,
	TAG_IPL_DescrPointerRef = 0x12,
	TAG_ExtendedProfileLevelDescr = 0x13,
	TAG_profileLevelIndicationIndexDescriptor = 0x14,
   
	// begin -- OCI extentions tags
	TAG_OCI_Descriptor = 0,
	TAGMIN_OCI_Descriptor = 0x40,
	
	//by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	//TAGMAX_OCI_Descriptor = 0x66,// out-of-date
	TAGMAX_OCI_Descriptor = 0x5F, 
	//by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	
	TAG_ContentClassificationDescriptor = 0x40,
	TAG_KeyWordDescriptor = 0x41,
	TAG_RatingDescriptor = 0x42,
	TAG_LanguageDescriptor = 0x43,
	TAG_ShortTextualDescriptor = 0x44,
	TAG_ExpandedTextualDescriptor = 0x45,
	TAG_ContentCreatorNameDescriptor = 0x46,
	TAG_ContentCreationDateDescriptor = 0x47,
	TAG_OCICreatorNameDescriptor = 0x48,
	TAG_OCICreationDateDescriptor = 0x49,
	TAG_SmpteCameraPositionDescriptor = 0x4a,	// NHK 990702
	TAG_SegmentDescriptor = 0x4B,
	TAG_MediaTimeDescriptor = 0x4C,
	// end -- OCI extention tags
	
	// Begin -- IPMP tools tags
	TAG_IPMP_ToolListDescriptor = 0x60,
	TAG_IPMP_Tool = 0x61,

	/********** Added by Liao Xuan,UK NB Comments *******/
	TAG_IPMP_ToolParamDescr = 0x62,
	/********** End:Added by Liao Xuan,UK NB Comments ***/

	TAG_IPMPToolES_DecoderConfig = TAG_DecoderSpecificInfo,
	TAG_IPMPDecoderConfiguration = TAG_DecoderSpecificInfo,
	// End -- IPMP tools tags.

	TAG_AFXConfig = TAG_DecoderSpecificInfo,	// AFX
	TAGMIN_AFXExtDescriptor = 0x00,	// AFX
	TAGMAX_AFXExtDescriptor = 0x64,	// AFX
	TAG_A3DMCDecoderSpecific = 0x00,	// 3D Mesh Coding
	TAG_MeshGridDecoderSpecificInfo = 0x01,	// MeshGrid
	TAG_WMDecoderSpecificInfo = 0x02,	// WaveletSuibdivisionSurface
	TAG_CoordInterpCompDecoderSpecific = 0x03,	// CoordinateInterpolator Compression
	TAG_OriInterpCompDecoderSpecific = 0x04,	// OrientationInterpolator Compression
	TAG_PosInterpCompDecoderSpecific = 0x05,	// PositionInterpolator Compression
// 2004-12-27, GyeongJa Jang <-
	//	TAG_DIBRDecoderSpecific = 0x06,	// Depth Image-Based Representation
		TAG_OctreeImageDecoderSpecific = 0x06, // OctreeImage Compression
// 2004-12-27, GyeongJa Jang ->
	TAG_BBADecoderSpecific = 0x07, // Bone-based Animation // MP
// 2004-12-27, GyeongJa Jang <-
// 2004-07-15, Shinjun {
	//TAG_PTCompDecoderSpecific = 0x08, // PointTexture Compression
	TAG_PointTextureCompDecoderSpecific = 0x08, // PointTexture Compression
// 2004-07-15, Shinjun }
// 2004-12-27, GyeongJa Jang ->
//ory DMLAB 2007 01 07 3D Mesh Coding Extension
	TAG_A3DMCExtensionDecoderSpecific = 0x09,
//~ory DMLAB
    TAG_FPSetDecoderSpecificInfo = 0x0A,
//INT KM 2007 12 03
    TAG_FAMCDecoderSpecific = 0x0B,
//INT KM
	TAGMIN_DecoderSpecificInfo = TAG_DecoderSpecificInfo,
	TAGMAX_DecoderSpecificInfo = TAG_DecoderSpecificInfo,
	TAG_DecoderSpecificInfoString = TAG_DecoderSpecificInfo,
	TAG_OCIDecoderConfiguration = TAG_DecoderSpecificInfo,
	TAG_BIFSConfig = TAG_DecoderSpecificInfo,
	TAG_BIFSv2Config = TAG_DecoderSpecificInfo,
	TAG_JPEG_DecoderConfig = TAG_DecoderSpecificInfo,
	TAG_AudioSpecificConfig = TAG_DecoderSpecificInfo,  // giorgio.zoia@epfl.ch
	TAG_GeneralAudioConfig = TAG_DecoderSpecificInfo,   // giorgio.zoia@epfl.ch
	TAG_StructuredAudioConfig = TAG_DecoderSpecificInfo,    // giorgio.zoia@epfl.ch
	TAG_CELP_DecoderConfig = TAG_DecoderSpecificInfo,   // giorgio.zoia@epfl.ch
	TAG_BIFSConfigEx = TAG_DecoderSpecificInfo,			// zl: version 5
	TAGMIN_ExtendedBIFSConfig = 1,						// zl: version 5
	TAGMAX_ExtendedBIFSConfig = 0xff,					// zl: version 5
	TAG_MUBIFSConfig = 1,								// zl: version 5
	
	//AC:20021009 - SL extension TAGs -- begin
	TAG_ExtSLConfigDescr=0x64,
	TAG_DependencyPointer=0x67,
	TAG_MarkerDescriptor=0x68,
	//AC:20021009 - SL extension TAGs -- end

	TAGMIN_QoS_Qualifier = 1,
	TAGMAX_QoS_Qualifier = 0xff,
	TAG_QoS_Qualifier_MAX_DELAY = 0x01,
	TAG_QoS_Qualifier_PREF_MAX_DELAY = 0x02,
	TAG_QoS_Qualifier_LOSS_PROB = 0x03,
	TAG_QoS_Qualifier_MAX_GAP_LOSS = 0x04,
	TAG_QoS_Qualifier_REBUFFERING_RATIO = 0x05,
	TAG_QoS_Qualifier_MAX_AU_SIZE = 0x41,
	TAG_QoS_Qualifier_AVG_AU_SIZE = 0x42,
	TAG_QoS_Qualifier_MAX_AU_RATE = 0x43,
	TAG_ExtensionDescriptor = 0,
	/********** Changed by Liao Xuan, according to UK NB Comments ***/
	/* Tag not following latest spec								*/
	//TAGMIN_ExtensionDescriptor = 0x80,
	TAGMIN_ExtensionDescriptor = 0x60,
	/**********End: Changed by Liao Xuan,according to UK NB Comments*/
	TAGMAX_ExtensionDescriptor = 0xfe,

	TAG_MuxInfo,
	TAG_MuxCodeSlot,
	TAG_MuxCodeTableElement,
	TAG_MuxCodeTable,
	TAG_SL_PacketHeader,
	TAG_OCI_Event = 0,
	TAG_UIConfig = TAG_DecoderSpecificInfo,	// CC 010122
#if defined SAIT_CONFORMANCE_2003
	TAG_PNG_DecoderConfig = TAG_DecoderSpecificInfo,
#endif SAIT_CONFORMANCE_2003
	TAG_JPEG2000_DecoderConfig = TAG_DecoderSpecificInfo
} OD_TAGS;

#endif                                      // _odtags_h sentry.
