/******************************************************************************
*  SOFTWARE LICENSE AND CONDITIONS
*
*  This software module was originally developed by Kambiz Asrar Haghighi 
*  and Yasser Pourmohammadi (University of British Columbia) in the course of 
*  development of  the streaming functionality for MPEG-4 using the DMIF
*  (ISO/IEC 14496-6) standard. This software module is an implementation 
*  of a part of one or more MPEG-4 tools as specified by MPEG-4. 
*  
*  Users of the MPEG-4 may use the software source code or modifications 
*  thereof only for hardware or software products related to MPEG-4 evaluation
*  and testing.  The use of the source code for any purpose other than 
*  evaluation and testing, including the use of derivative works for the 
*  generation of commercial products, is strictly prohibited.
*  
*  The original developer of this software module and his/her company, 
*  the subsequent editors and their companies, and ISO/IEC have no 
*  liability for use of this software module or modifications thereof 
*  in an implementation. Copyright is not released for non MPEG-4 
*  conforming products. UBC retains full right to use the code for 
*  his/her own purpose, assign or donate the code to a third party and 
*  to inhibit third parties from using the code for non MPEG-4 conforming 
*  products. This copyright notice must be included in all copies or 
*  derivative works.
*
*  Contact:
*
*  Kambiz Asrar Haghighi                 email: kambiz@interchange.ubc.ca
*  Yasser Pourmohammadi                  email: yasserp@ece.ubc.ca
*  Professor Hussein M. Alnuweiri
*  UBC Signal Processing and Multimedia Group
*  http://spmg.ece.ubc.ca/research/MPEG4
*  Vancouver BC Canada V6T1Z4                  
*
*  Copyright  2000  University of British Columbia, Canada
********************************************************************************/
#if !defined (DNTCP_H)
#define DNTCP_H


#include <stdlib.h>
#include <process.h>
#include "DN.h"
#include "messages.h"
#include "common.h"

// function prototypes

// supplementary functions
SOCKADDR_IN SetDestAddress( LPCSTR calledAddress);
__int16 bindSockettoPort(SOCKET sigSocket);

class DN_TCP_CLASS : public DN_CLASS{
public:
   unsigned long int transactionId; 
   DN_TCP_CLASS(){
      transactionId = 0;};
private:
   virtual BOOL DN_SessionSetup( long double networkSessionId,LPCSTR calledAddress,LPCSTR callingAddress,
                        __int8 compatibilityDescriptorIn, __int16 *response, __int8 *compatibilityDescriptorOut );
   virtual BOOL DN_SessionRelease(long double networkSessionId, __int16 reason, __int16 *response/*out*/);

   // DN Service Functions
   virtual BOOL DN_ServiceAttach(long double networkSessionId, __int16 serviceId,
                        const char * serviceName, ddDataClass * ddDataIn, __int16 *response, ddDataClass * ddDataOut);
   virtual BOOL DN_ServiceDetach(long double networkSessionId, __int16 serviceId, __int16 reason, __int16 *response);

   virtual BOOL DN_ChannelAdd(long double networkSessionId,__int16 serviceId,GenericMsgLoop * ReqLoop ,/*loop(CAT, channelDescriptor, direction, ddDataIn());*/
                 GenericMsgLoop * RespLoop /*loop(response, TAT, ddDataOut())*/);
   
   // DN_Transmux Functions
   virtual BOOL DN_TransMuxSetup(long double networkSessionId, GenericMsgLoop * TMReqLoop, GenericMsgLoop * TMConfLoop);
   
   virtual BOOL DN_UserCommand(long double networkSessionId, ddDataClass *ddDataIn, GenericMsgLoop * CATLoop);

   virtual BOOL DN_UserCommandAck(long double networkSessionId, ddDataClass * ddData, GenericMsgLoop * CATLoop, __int16 *response, ddDataClass * ddDataOut);

   virtual BOOL DN_ChannelAdded(long double networkSessionId,__int16 serviceId, GenericMsgLoop * ReqLoop /* loop(CAT, qoschannelDescriptor, direction, TAT, ddDataIn())*/,
                  GenericMsgLoop * CnfLoop /* OUT: loop(response, ddDataOut())*/ );
   
   virtual BOOL DN_ChannelDelete(long double networkSessionId,GenericMsgLoop * CATReasonLoop, GenericMsgLoop * Resploop);

   virtual BOOL DN_TransMuxConfig(long double networkSessionId, GenericMsgLoop * TMReqLoop, GenericMsgLoop * TMCnfLoop);

   virtual BOOL DN_TransMuxRelease(long double networkSessionId, GenericMsgLoop *TATLoop, GenericMsgLoop * RespLoop);
};


#endif  // DNTCP_H