/******************************************************************************
*  SOFTWARE LICENSE AND CONDITIONS
*
*  This software module was originally developed by Kambiz Asrar Haghighi 
*  and Yasser Pourmohammadi (University of British Columbia) in the course of 
*  development of  the streaming functionality for MPEG-4 using the DMIF
*  (ISO/IEC 14496-6) standard. This software module is an implementation 
*  of a part of one or more MPEG-4 tools as specified by MPEG-4. 
*  
*  Users of the MPEG-4 may use the software source code or modifications 
*  thereof only for hardware or software products related to MPEG-4 evaluation
*  and testing.  The use of the source code for any purpose other than 
*  evaluation and testing, including the use of derivative works for the 
*  generation of commercial products, is strictly prohibited.
*  
*  The original developer of this software module and his/her company, 
*  the subsequent editors and their companies, and ISO/IEC have no 
*  liability for use of this software module or modifications thereof 
*  in an implementation. Copyright is not released for non MPEG-4 
*  conforming products. UBC retains full right to use the code for 
*  his/her own purpose, assign or donate the code to a third party and 
*  to inhibit third parties from using the code for non MPEG-4 conforming 
*  products. This copyright notice must be included in all copies or 
*  derivative works.
*
*  Contact:
*
*  Kambiz Asrar Haghighi                 email: kambiz@interchange.ubc.ca
*  Yasser Pourmohammadi                  email: yasserp@ece.ubc.ca
*  Professor Hussein M. Alnuweiri
*  UBC Signal Processing and Multimedia Group
*  http://spmg.ece.ubc.ca/research/MPEG4
*  Vancouver BC Canada V6T1Z4                  
*
*  Copyright  2000  University of British Columbia, Canada
********************************************************************************/
#include "..\remoteinstance.h"
#include "DN.h"

// This Function should redirect each listenning thread to a separate object,so that different threads 
// don't run in the same function simultaneously

extern NetSessionListClass NetSessionList; 

void userPlaneThreadProc(void *valueofPtr)
{
   
   Upmesg  * upmessage;
   upmessage = (struct Upmesg *)(valueofPtr);

   ListenerClass * pListenerObj = createListenerObj();
   pListenerObj->begin(upmessage->pService, upmessage->TAT);
   delete valueofPtr;
}


void ListenerClass::begin(RemoteInstance * pService, __int16 TAT)
{
   char buf[3000];
   int iReturn;
   __int16 destPort;
   DWORD destIP;
   SOCKET UPSocket;
   SOCKADDR_IN accept_sin;
   int accept_sin_len = sizeof(accept_sin);
   NetSessionList.getUPInfo(TAT,&destIP,&destPort,&UPSocket);
   SOCKET initialSockValue = UPSocket;

   accept_sin.sin_family = AF_INET;
   accept_sin.sin_addr.s_addr = htonl(INADDR_ANY);
   accept_sin.sin_port = htons(TAT);

   while(UPSocket == initialSockValue)
   {
      iReturn = recvfrom(UPSocket,buf,3000,NULL,(struct sockaddr *) &accept_sin, 
                 (int*)&accept_sin_len);
      if (iReturn == SOCKET_ERROR)
      {
         if (WSAGetLastError() != 10038) { // added for graceful closing of socket
            TCHAR szError[100];                 // Error message string
            wsprintf (szError, TEXT("recvfrom failed. Error: %d"), 
                    WSAGetLastError ());
            MessageBox (NULL, szError, TEXT("Error"), MB_OK);
         }
         break;
      }
      else if (iReturn == 0)
      {
         MessageBox (NULL, TEXT("Connection closed gracefully"), TEXT("Server"),MB_OK);
      }
      else
      {  
         pService->DNI_DataReceive_Ind(buf);
      }
         
   }

}

ListenerClass * createListenerObj(){
      return new ListenerClass;
   }
