/******************************************************************************
*  SOFTWARE LICENSE AND CONDITIONS
*
*  This software module was originally developed by Yasser Pourmohammadi and 
*  Kambiz Asrar Haghighi (University of British Columbia) in the course of 
*  development of  the streaming functionality for MPEG-4 using the DMIF
*  (ISO/IEC 14496-6) standard. This software module is an implementation 
*  of a part of one or more MPEG-4 tools as specified by MPEG-4. 
*  
*  Users of the MPEG-4 may use the software source code or modifications 
*  thereof only for hardware or software products related to MPEG-4 evaluation
*  and testing.  The use of the source code for any purpose other than 
*  evaluation and testing, including the use of derivative works for the 
*  generation of commercial products, is strictly prohibited.
*  
*  The original developer of this software module and his/her company, 
*  the subsequent editors and their companies, and ISO/IEC have no 
*  liability for use of this software module or modifications thereof 
*  in an implementation. Copyright is not released for non MPEG-4 
*  conforming products. UBC retains full right to use the code for 
*  his/her own purpose, assign or donate the code to a third party and 
*  to inhibit third parties from using the code for non MPEG-4 conforming 
*  products. This copyright notice must be included in all copies or 
*  derivative works.
*
*  Contact:
*
*  Kambiz Asrar Haghighi                 email: kambiz@interchange.ubc.ca
*  Yasser Pourmohammadi                  email: yasserp@ece.ubc.ca
*  Professor Hussein M. Alnuweiri
*  UBC Signal Processing and Multimedia Group
*  http://spmg.ece.ubc.ca/research/MPEG4
*  Vancouver BC Canada V6T1Z4                  
*
*  Copyright  2000  University of British Columbia, Canada
********************************************************************************/

//General Definitions
#define MAX_MESSAGE_LENGTH 300


// Response Definitions
#define RESPONSE_GOOD		0x0000
#define RESPONSE_NOTSOGOOD	0x0001

// Reason Definitions
#define REASON_NORMAL   0x0000
#define REASON_ERROR    0x0001


// MessageID's
#define SESSIONSETUPREQUEST   0x0010
#define SESSIONSETUPCONFIRM   0x0011

#define SESSIONRELEASEREQUEST 0x0020
#define SESSIONRELEASECONFIRM 0x0021

#define SERVICEATTACHREQUEST  0x0030
#define SERVICEATTACHCONFIRM  0x0031

#define SERVICEDETACHREQUEST  0x0040
#define SERVICEDETACHCONFIRM  0x0041

#define TRANSMUXSETUPREQUEST  0x0050
#define TRANSMUXSETUPCONFIRM  0x0051

#define TRANSMUXRELEASEREQUEST  0x0060
#define TRANSMUXRELEASECONFIRM  0x0061

#define CHANNELADDREQUEST  0x0070
#define CHANNELADDCONFIRM  0x0071

#define CHANNELADDEDREQUEST   0x0080
#define CHANNELADDEDCONFIRM   0x0081

#define CHANNELDELETEREQUEST  0x0090
#define CHANNELDELETECONFIRM  0x0091

#define TRANSMUXCONFIGREQUEST  0x00A0
#define TRANSMUXCONFIGCONFIRM  0x00A1

#define USERCOMMAND  0x00B0

#define USERCOMMANDACKREQUEST 0x00C0
#define USERCOMMANDACKCONFIRM 0x00C1
/*
USER DEFINED MESSAGE ID'S MUST BE IN THE RANGE OF 0x2000 AND 0x3FFF
*/


// Direction Codes
#define DIRECTION_DOWNSTREAM 0X01
#define DIRECTION_UPSTREAM 0X02
               
#define IPDESCRIPTOR_TYPE 0X09
#define TCPPROTOCOL_TYPE 0x01
#define UDPPROTOCOL_TYPE 0x02


///////////////////////////////////////////////////////////////////////////////
// ddData .............--------------------------------------------------------
///////////////////////////////////////////////////////////////////////////////
#define UUDATADESCRIPTOR               0x1             
#define BYPASSFLEXMUXDESCRIPTOR        0x2
#define MPEG4SYSTEMSFLEXMUXDESCRIPTOR  0x3
#define MPEG4SYSTEMSMUMCODEDESCRIPTOR  0x4

