/**************************************************************************
 * Project Im1Player
 * INTERNATIONAL STANDARD ORGANIZATION
 * ISO/IEC JTC1/SC29/WG11
 * 
 * SUBSYSTEM: DMIF
 * FILE:      DMXChannel.h
 * AUTHOR:    Mauro Rossi (CSELT)
 * OVERVIEW:  Declarations of DMXChannel.
 * 
 **************************************************************************/

#ifndef _dmx_channel_h_
#define _dmx_channel_h_

#include "Channel.h"
#include "TDxI_Sink.h"
#include "mpg4dmif.h"

class DMXChannel : public Channel
{
public:
	DMXChannel(TDxI_Sink* pSnk = NULL, UINT nChid = 0);
	virtual ~DMXChannel();

	virtual void DPIC_ChannelDelete_Cnf(
		const RESPONSE	eResponse
	);
	virtual void DPIC_PacketReceived_Ind(
		const BYTE*	pStreamData,
		const int	nStreamDataLength,
		const BOOL	bErr
	);
	virtual unsigned __int64 GetTotalPayload() const;
	virtual DWORD			 GetTotalFmxPackets() const;
public:
	void		SetChNum(int nFmxChNum);
	int			GetChNum();
	int			SetQos(QOSSTREAM sQos);	//Copies the QosStream.
	QOSSTREAM	GetQos() const;			//Gets a pointer to the Qos.
	void		PlayChannel();
	void		PauseChannel();
	void		SetChId(UINT nChid);
	UINT		GetChId();

public:
	bool					m_bUseSlcd;
	struct SLConfigDesc		m_slcd;

protected : 
	int m_nFmxChNum; 

private:
	UINT				m_nChId;
	TDxI_Sink*			m_pSink;
	QOSSTREAM			m_sQosStream;
	bool				m_bPlayingChannel;
	unsigned __int64	m_nTotalPayloadBytes;
	DWORD				m_nTotalFmxPackets;
};

#endif _dmx_channel_h_



