/**************************************************************************
 * Project Im1Player
 * INTERNATIONAL STANDARD ORGANIZATION
 * ISO/IEC JTC1/SC29/WG11
 * 
 * SUBSYSTEM: DMIF
 * FILE:      FlexDemux.h
 * AUTHOR:    Mauro Rossi (CSELT)
 * OVERVIEW:  Declarations of FlexDemux.
 * 
 **************************************************************************/

#if !defined(_FlexDemux_h)	// Sentry, use file only if it's not already included.
#define _FlexDemux_h

#include <iostream.h>

#include "FlexMuxTool.h"
#include "DemuxInterface.h"
#include "DPI.h"


class DMXChannel;
class TDxI_Sink;

class FlexDemux : public DemuxInterface
{
public:
	virtual void DPIC_ChannelDelete_Cnf (
		const RESPONSE	eResponse
		) {eResponse;};
	virtual void DPIC_PacketReceived_Ind (
		const BYTE*		pStreamData,
		const int		nStreamDataLength,
		const BOOL		bErr
	);
	virtual unsigned __int64 GetTotalPayload() const;
	virtual DWORD			 GetTotalFmxPackets() const;
public:
	FlexDemux ();
	~FlexDemux();
	virtual bool AddFlexmuxChannel(TDxI_Sink* r_pSnk,const UINT v_nChid,const QOSSTREAM r_qosStream,const int v_nFmxChNum,const BYTE* pAppInfo,const int nAppInfoLength);
	virtual void DeleteFlexmuxChannel(int nFmxInfo);
	virtual bool isEmpty();
	virtual void PlayChannel(int nFmxInfo);
	virtual void PauseChannel(int nFmxInfo);

	void UpdateMuxCodeTableElements(const LinearMuxCodeTable &muxCodeTable);
	UINT GetDMXChannelPtr(const int nFmxInfo);
	int	 GetIndexOf(UINT p_nChId);

private:
	ZArray<DMXChannel*>	m_channelTable;
	LinearMuxCodeTable		m_muxCodeTable;
private:
	void DemuxMuxCodePacket(LinearMuxCodeTableElement &mcte,const BYTE* pStreamData,const int nLength);
	friend ostream& operator<<(ostream& s, FlexDemux& m) ;
};

inline ostream& operator<<(ostream& s, FlexDemux& m) 
{
	s << "_____FLEX_DEMUX__________________"<<endl;
	s << "CHANNELs: "<<endl;
	for(int i=0;i < m.m_channelTable.GetLength();i++)
	{
		if(m.m_channelTable[i] != NULL)
			s<<i<<") "<<m.m_channelTable[i]<<endl;
	}
	s << "---------------------------------"<<endl;
	return s;
}



#endif                                      // _FlexDemux_h sentry.
