
/*------------------------------------------------------------------------------*/
/*										*/
/*										*/
/*  This software module was originally developed by                            */
/*        Prem Kalra, MIRALab, University of Geneva                             */
/*  and edited by                                                               */
/*        Igor Pandzic, MIRALab, University of Geneva                           */
/*        Marc Escher, MIRALab, University of Geneva                            */
/*        Pierre Beylot, MIRALab, University of Geneva                          */
/*  in the course of development of the MPEG-4 Video (ISO/IEC 14496-2).	        */
/*  This software module is an implementation of a part of one or more	        */
/*  MPEG-4 Video (ISO/IEC 14496-2) tools as specified by the MPEG-4 Video       */
/*  (ISO/IEC 14496-2). ISO/IEC gives users of the                               */
/*  MPEG-4 Video (ISO/IEC 14496-2) free license to this software module or	*/
/*  modifications thereof for use in hardware or software products claiming 	*/
/*  conformance to the MPEG-4 Video (ISO/IEC 14496-2). Those intending to use	*/
/*  this software module in hardware or software products are advised that	*/
/*  its use may infringe existing patents. The original developer of this	*/
/*  software module and his/her company, the subsequent editors and their	*/
/*  companies, and ISO/IEC have no liability for use of this software		*/
/*  module or modifications thereof. Copyright is not released for non		*/
/*  MPEG-4 Video (ISO/IEC 14496-2) conforming products.                         */
/*  MIRALab, University of Geneva retains full right to use the code for its    */
/*  own purpose, assign or donate the code to a third party and to inhibit      */
/*  third parties from using the code for non MPEG-4 Video (ISO/IEC 14496-2)    */
/*  conforming products. This copyright notice must be included in all copies   */
/*  or derivative works. Copyright (c) (1997).			      		*/
/*										*/
/*										*/
/*------------------------------------------------------------------------------*/

#include "RegMan.h"

typedef struct {
  VECTOR_3D X0;
  VECTOR_3D S_vect;
  VECTOR_3D T_vect;
  VECTOR_3D U_vect;
} SM_ffd_parameters;

typedef struct {
  VECTOR_3D center;
  float radius;
  float height;
} SM_effd_cylinder;

typedef struct {
  float (* func)();
} def_func;

typedef struct {
   VECTOR_2D point2d;
} DEF_FUNC;
 
extern float
SMGD_Box_get_maxcoord(SM_Surface_ptr, int);

extern float
SMGD_Box_get_mincoord(SM_Surface_ptr, int);

extern void
SMGD_Box_set_vertex(SM_Surface_Controlbox_ptr, int, VECTOR_3D);

extern void
SMGD_Box_get_vertex(SM_Surface_Controlbox_ptr, int, VECTOR_3D);

extern void
SMGD_Box_draw_picked(SM_Surface_Controlbox_ptr,int);

extern void
SMGD_Box_find_quadrilateral(VECTOR_3D,double,int,VECTOR_3D,VECTOR_3D,VECTOR_3D,
                            VECTOR_3D);

extern void
SMGD_controlbox_draw_picking(SM_Surface_Controlbox_ptr);


extern void
SMGD_controlbox_origin_get(SM_Surface_Controlbox_ptr, VECTOR_3D);

extern void
SMGD_box_maxmin_point_get(SM_Surface_Controlbox_ptr, VECTOR_3D, VECTOR_3D);

extern void
SMGD_controlbox_vertex_indices_get(SM_Surface_Controlbox_ptr,int, 
                                   int *,int *, int *);
extern void
SMGD_surface_controlbox_recreate(SM_Surface_Controlbox_ptr *,
                                 SM_Surface_Controlbox_ptr *,int,int,int);

extern void
SMGD_surface_box_create(SM_Surface_ptr,SM_Surface_Controlbox_ptr,
                        SM_Surface_Controlbox_ptr,int,int,int);

extern void
SMGD_region_box_create(SM_Surface_ptr, SM_Region_List_ptr, SM_Region_Name,
                SM_Region_Controlbox_ptr,SM_Region_Controlbox_ptr,int,int,int);

extern void
SMGD_draw_control_box(SM_Surface_Controlbox_ptr);

extern void
SMGD_draw_plane(SM_Surface_Controlbox_ptr,int,int);

extern void
SMGD_pickdraw_control_plane(SM_Surface_Controlbox_ptr,int);

extern BOOL
SMGD_control_cylinder_index_get(SM_Region_Controlcylinder_ptr,int,int,int,int *);

extern void
SMGD_controlcylinder_draw_picking(SM_Region_Controlcylinder_ptr);

extern void
SMGD_draw_control_cylinder(SM_Region_Controlcylinder_ptr);

/*------------------------ scale -----------------------------*/
extern void
SMGD_scale_point(VECTOR_3D,VECTOR_3D,VECTOR_3D);

extern void
SMGD_scale_surface(SM_Surface_ptr,VECTOR_3D);

extern void
SMGD_scale_region(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,VECTOR_3D);

extern void
SMGD_scale_face_region(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,VECTOR_3D);

extern void
SMGD_scale_object_controlbox(SM_Surface_Controlbox_ptr,VECTOR_3D);

extern void
SMGD_scale_object_control_plane(SM_Surface_Controlbox_ptr,int,VECTOR_3D,int);

extern void
SMGD_scale_object_control_point(SM_Surface_Controlbox_ptr,int,VECTOR_3D,VECTOR_3D);


/*------------------------ translate  --------------------------*/
extern void
SMGD_translate_point(VECTOR_3D,VECTOR_3D,VECTOR_3D);

extern void
SMGD_translate_surface(SM_Surface_ptr,VECTOR_3D);

extern void
SMGD_translate_region(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,VECTOR_3D);

extern void
SMGD_translate_face_region(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,VECTOR_3D);

extern void
SMGD_translate_object_controlbox(SM_Surface_Controlbox_ptr,VECTOR_3D);

extern void
SMGD_translate_object_control_plane(SM_Surface_Controlbox_ptr,int,VECTOR_3D,int);

extern void
SMGD_translate_object_control_point(SM_Surface_Controlbox_ptr,int,VECTOR_3D,VECTOR_3D);

/*------------------------ rotate  --------------------------*/
extern void
SMGD_rotate_point(VECTOR_3D,int,double,VECTOR_3D);

extern void
SMGD_rotate_surface(SM_Surface_ptr,int,double);

extern void
SMGD_rotate_region(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,int,double);

extern void
SMGD_rotate_face_region(SM_Surface_ptr,VECTOR_3D,SM_Region_List_ptr,SM_Region_Name,int,double);

extern void
SMGD_rotate_try_face_region(SM_Surface_ptr,SM_Surface_ptr,VECTOR_3D,SM_Region_List_ptr,SM_Region_Name,int,double);

extern void
SMGD_rotate_object_controlbox(SM_Surface_Controlbox_ptr,int,double);

extern void
SMGD_rotate_object_control_plane(SM_Surface_Controlbox_ptr,int,int,double,int);

extern void
SMGD_rotate_object_control_point(SM_Surface_Controlbox_ptr,int,int,double,VECTOR_3D);

extern void
SMGD_rotate_arbaxis_matrix(VECTOR_3D,VECTOR_3D,double,MATRIX_H3D);

extern void
SMGD_rotate_arbaxis_point(VECTOR_3D,MATRIX_H3D,VECTOR_3D);

/*------------------------ Circular -------------------------*/

extern void
SMGD_circular_point(VECTOR_3D, int, double, VECTOR_3D);

extern void
SMGD_circular_object_control_plane(SM_Surface_Controlbox_ptr,int,int,double);

/*------------------------ shear ----------------------------*/
extern void
SMGD_shear_point(VECTOR_3D,double,int,VECTOR_3D);

extern void
SMGD_shear_surface(SM_Surface_ptr,double,int);

extern void
SMGD_shear_region(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double,int);

extern void
SMGD_shear_face_region(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double,int);

extern void
SMGD_shear_object_controlbox(SM_Surface_Controlbox_ptr,double,int);

extern void
SMGD_shearmin_region(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double,int);

extern void
SMGD_shearmin_face_region(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double,int);

extern void
SMGD_shearmax_region(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double,int);

extern void
SMGD_shearcenter_point(VECTOR_3D,double,int,VECTOR_3D,VECTOR_3D,VECTOR_3D);

extern void
SMGD_shearcenter_region(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double,int);

extern void
SMGD_shearcenter_face_region(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double,int);

extern void
SMGD_shearmin_object_controlbox(SM_Surface_Controlbox_ptr,double,int);

extern void
SMGD_shear_object_control_plane(SM_Surface_Controlbox_ptr,int,double,int,int);

extern void
SMGD_shear_object_control_point(SM_Surface_Controlbox_ptr,int,double,int,VECTOR_3D);

/*------------------------- shift ---------------------------*/
extern void
SMGD_shift_point(VECTOR_3D,double,int,VECTOR_3D);

extern void
SMGD_shift_surface(SM_Surface_ptr,double,int);

extern void
SMGD_shift_region(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double,int);

extern void
SMGD_shift_face_region(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double,int);

extern void
SMGD_shift_object_controlbox(SM_Surface_Controlbox_ptr,double,int);

extern void
SMGD_shift_object_control_plane(SM_Surface_Controlbox_ptr,int,double,int,int);

extern void
SMGD_shift_object_control_point(SM_Surface_Controlbox_ptr,int,double,int,VECTOR_3D);

/*------------------------ taper ----------------------------*/
extern void
SMGD_taper_point(VECTOR_3D,double,double,int,float (*)(float,float,float),VECTOR_3D);

extern void
SMGD_taper_surface(SM_Surface_ptr,int,float (*)(float,float,float));

extern void
SMGD_taper_region(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,int,float (*)(float,float,float));

extern void
SMGD_taper_object_controlbox(SM_Surface_Controlbox_ptr,int,float (*)(float,float,float));

extern void
SMGD_taper_object_control_plane(SM_Surface_Controlbox_ptr,int,int,float (*)(float,float,float),int);

extern void
SMGD_taper_object_control_point(SM_Surface_Controlbox_ptr,int,int,float (*)(float,float,float),VECTOR_3D);

/*------------------------ twist ----------------------------*/
extern void
SMGD_twist_point(VECTOR_3D,double,double,int,float (*)(float,float,float),VECTOR_3D);

extern void
SMGD_twist_surface(SM_Surface_ptr,int,float (*)(float,float,float));

extern void
SMGD_twist_region(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,int,float (*)(float,float,float));

extern void
SMGD_twist_object_controlbox(SM_Surface_Controlbox_ptr,int,float (*)(float,float,float));

extern void
SMGD_twist_object_control_plane(SM_Surface_Controlbox_ptr,int,int,float (*)(float,float,float),int);

extern void
SMGD_twist_object_control_point(SM_Surface_Controlbox_ptr,int,int,float (*)(float,float,float),VECTOR_3D);

/*----------------------  bend ------------------------------*/
extern void
SMGD_get_bending_parameters(double,double,double,VECTOR_2D,VECTOR_2D,
                            float *,float *,float *);

extern void
SMGD_bend_point(VECTOR_3D,double,double,int,double,VECTOR_3D);

extern void
SMGD_bend_surface(SM_Surface_ptr,int,double,VECTOR_2D,VECTOR_2D);

extern void
SMGD_bend_region(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,
                           int,double,VECTOR_2D,VECTOR_2D);

extern void
SMGD_bend_object_controlbox(SM_Surface_Controlbox_ptr,int,double,VECTOR_2D,VECTOR_2D);

extern void
SMGD_bend_object_control_plane(SM_Surface_Controlbox_ptr,int,int,double,VECTOR_2D,VECTOR_2D,int);

extern void
SMGD_bend_object_control_point(SM_Surface_Controlbox_ptr,int,int,double,VECTOR_2D,VECTOR_2D,VECTOR_3D);

/*------------------------ stretch -----------------------------*/
extern void
SMGD_stretch_point(VECTOR_3D,double,int,VECTOR_3D);

extern void
SMGD_stretch_surface(SM_Surface_ptr,double,int);

extern void
SMGD_stretch_region(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double,int);

extern void
SMGD_stretch_object_controlbox(SM_Surface_Controlbox_ptr,double,int);

extern void
SMGD_stretch_object_control_plane(SM_Surface_Controlbox_ptr,int,double,int,int);

/*------------------------ compress -----------------------------*/
extern void
SMGD_compress_point(VECTOR_3D,double,int,VECTOR_3D);

extern void
SMGD_compress_surface(SM_Surface_ptr,double,int);

extern void
SMGD_compress_region(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double,int);

extern void
SMGD_compress_object_controlbox(SM_Surface_Controlbox_ptr,double,int);

extern void
SMGD_compress_object_control_plane(SM_Surface_Controlbox_ptr,int,double,int,int);

/*--------------------- freeform ------------------------------*/
extern int
SMGD_factorial(int);
 
extern float
SMGD_power_int(double,int);

extern float
SMGD_burnstein(int, int, double);

extern void
SMGD_surface_freeform_apply(SM_Surface_ptr,SM_ffd_parameters,
                            SM_Surface_Controlbox_ptr);

extern void
SMGD_region_freeform_apply(SM_Surface_ptr,SM_Region_List_ptr,
        SM_Region_Name,SM_ffd_parameters,SM_Surface_Controlbox_ptr);

extern void
SMGD_region_face_freeform_apply(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,
        SM_Region_Name,SM_ffd_parameters,SM_Surface_Controlbox_ptr);


extern void
SMGD_region_index_freeform_apply(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,
                           int,SM_ffd_parameters,SM_Surface_Controlbox_ptr);

extern void
SMGD_region_cylinder_freeform_apply(SM_Surface_ptr,SM_Region_List_ptr,
        SM_Region_Name,SM_effd_cylinder,SM_Region_Controlcylinder_ptr);

/*------------------- force ------------------------------------*/
extern void
SMGD_surface_force_apply(SM_Surface_ptr,SM_Surface_Controlbox_ptr,
                         SM_Surface_Controlbox_ptr);

extern void
SMGD_region_force_apply(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,
              SM_Region_Controlbox_ptr,SM_Region_Controlbox_ptr);

extern BOOL
SMGD_get_perpendicular_distance(VECTOR_3D, VECTOR_3D, VECTOR_3D, float *);

extern  void
SMGD_radialforce_apply(SM_Surface_ptr,SM_Surface_Controlbox_ptr,
                       SM_Surface_Controlbox_ptr);
/*----- shape------- */
extern void
Shape_surface_freeform_apply(SM_Surface_ptr, 
                            SM_Surface_Controlbox_ptr);
extern void
Shape_neutral_face_stu_get(SM_Surface_ptr, int, int, int);

extern void
SMGD_ffd_init( SM_Surface_Controlbox_ptr,SM_ffd_parameters *);

