
/*------------------------------------------------------------------------------*/
/*										*/
/*										*/
/*  This software module was originally developed by                            */
/*        Prem Kalra, MIRALab, University of Geneva                             */
/*  and edited by                                                               */
/*        Igor Pandzic, MIRALab, University of Geneva                           */
/*        Marc Escher, MIRALab, University of Geneva                            */
/*        Pierre Beylot, MIRALab, University of Geneva                          */
/*  in the course of development of the MPEG-4 Video (ISO/IEC 14496-2).	        */
/*  This software module is an implementation of a part of one or more	        */
/*  MPEG-4 Video (ISO/IEC 14496-2) tools as specified by the MPEG-4 Video       */
/*  (ISO/IEC 14496-2). ISO/IEC gives users of the                               */
/*  MPEG-4 Video (ISO/IEC 14496-2) free license to this software module or	*/
/*  modifications thereof for use in hardware or software products claiming 	*/
/*  conformance to the MPEG-4 Video (ISO/IEC 14496-2). Those intending to use	*/
/*  this software module in hardware or software products are advised that	*/
/*  its use may infringe existing patents. The original developer of this	*/
/*  software module and his/her company, the subsequent editors and their	*/
/*  companies, and ISO/IEC have no liability for use of this software		*/
/*  module or modifications thereof. Copyright is not released for non		*/
/*  MPEG-4 Video (ISO/IEC 14496-2) conforming products.                         */
/*  MIRALab, University of Geneva retains full right to use the code for its    */
/*  own purpose, assign or donate the code to a third party and to inhibit      */
/*  third parties from using the code for non MPEG-4 Video (ISO/IEC 14496-2)    */
/*  conforming products. This copyright notice must be included in all copies   */
/*  or derivative works. Copyright (c) (1997).			      		*/
/*										*/
/*										*/
/*------------------------------------------------------------------------------*/


#include "DefMan.h"

typedef struct {
   int index;
   VECTOR_3D point;
} AU_point, *AU_point_ptr;

typedef struct {
   int size;
   AU_point_ptr vlist;
} AU_pointlist, *AU_pointlist_ptr;

extern void
AU_neutral_face_set(void);

extern AU_pointlist_ptr
AU_pointlist_new(void);

extern void
AU_pointlist_dispose(AU_pointlist_ptr);

extern void
AU_set_pointlist(SM_Surface_ptr,SM_Region_List_ptr,int,AU_pointlist_ptr);

extern BOOL
AU_get_apoint(AU_pointlist_ptr,int,VECTOR_3D);

extern void
AU_face_ffd_init(SM_Region_Controlbox_ptr,SM_ffd_parameters *);

extern void
AU_face_region_reset(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,int);

extern void
AU_eye_move_horizontal(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_eye_move_vertical(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_eye_move_out(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_eye_brow_raise(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,int,double);

extern void
AU_eye_brow_hori(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_jaw_move_lower(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_jaw_move_hori(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern BOOL
AU_jaw_lower_postproc(SM_Surface_ptr,SM_Region_List_ptr,int,
                      AU_pointlist_ptr,VECTOR_3D,VECTOR_3D);
/*
extern
AU_jaw_lower_postproc(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,int);
*/
extern void
AU_nose_comp_exp(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_nose_raise(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_mouth_comp_exp(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,int,double);

extern void
AU_mouth_apply_dispvect(SM_Region_Controlbox_ptr,double,int,int);

extern void
AU_mouth_find_dispvect(SM_Region_Controlbox_ptr,double,int);

extern void
AU_mouth_risorius(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_mouth_beak(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_lip_lower_raiser(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_cheek_puff_squeeze(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_cheek_find_dispvect(SM_Region_Controlbox_ptr,double,int);

extern void
AU_cheek_zygo(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_cheek_lift(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_cheek_lower_cornerlip(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_eyelid_lower_updown(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern BOOL 
AU_find_inside_triangle(SM_Surface_ptr,int,VECTOR_3D);

extern BOOL 
AU_find_ray_intersection(SM_Surface_ptr,VECTOR_3D,VECTOR_3D,int,VECTOR_3D);

extern BOOL
AU_eye_intersection(SM_Surface_ptr,SM_Region_List_ptr,VECTOR_3D,VECTOR_3D,
                    SM_Region_Name);
extern void
AU_region_outline_set(SM_Surface_ptr,SM_Region_List_ptr,int);

extern void
find_determinant(VECTOR_3D,VECTOR_3D,VECTOR_3D,float *);

extern BOOL
cramer_solver(VECTOR_3D,VECTOR_3D,VECTOR_3D,VECTOR_3D,float *,float *,float *);

extern BOOL
get_sphere_center(VECTOR_3D,VECTOR_3D,VECTOR_3D,VECTOR_3D,VECTOR_3D,float *);

extern void
AU_eyelid_upper_updown(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double,
                      VECTOR_3D,VECTOR_3D);

extern void
AU_eyelid_upper_updown_OLD(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double,
                      VECTOR_3D,VECTOR_3D);

extern void
AU_head_center_set(SM_Surface_ptr,SM_Region_List_ptr);

extern void
AU_head_nod(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_head_turn(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_head_roll(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_tongue_pan(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_tongue_lift(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_tongue_out(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_chin_depress(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_lip_lower_side_depress(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_lip_lower_depress(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,double);

extern void
AU_mouth_squeeze_cornerlip(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,int,double);

extern void
AU_lip_upper_tighten(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_lip_lower_tighten(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_lip_upper_press(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_lip_lower_press(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_lip_upper_suck(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_lip_lower_suck(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_lip_suck(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,double);

extern float
AU_gaze_point_tilt_angle_get(VECTOR_3D,VECTOR_3D);

extern float
AU_gaze_point_pan_angle_get(VECTOR_3D,VECTOR_3D);

extern void
AU_head_track_tilt(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_head_track_pan(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_head_track(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,VECTOR_3D);

extern void
AU_eye_track(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,VECTOR_3D);

extern BOOL 
AU_eye_hole_center_get(SM_Surface_ptr, SM_Region_List_ptr, int, VECTOR_3D);

extern void
AU_eye_origin_get(SM_Surface_ptr,SM_Region_List_ptr,int,VECTOR_3D);

extern void
AU_eye_brow_right_hori(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_eye_brow_left_hori(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern AU_pointlist_ptr
AU_pointlist_new(void);

extern void
AU_mouth_squeeze_part_cornerlip(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,int,double);

extern void
AU_eye_dilate_pupil(SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_jaw_thrust(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_nose_l_comp_exp(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_nose_r_comp_exp(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_nose_bend(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_tongue_lift_tip(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_tongue_roll(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_raise_ear(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);

extern void
AU_pull_ear(SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr,SM_Region_Name,double);


