
/*------------------------------------------------------------------------------*/
/*										*/
/*										*/
/*  This software module was originally developed by                            */
/*        Prem Kalra, MIRALab, University of Geneva                             */
/*  and edited by                                                               */
/*        Igor Pandzic, MIRALab, University of Geneva                           */
/*        Marc Escher, MIRALab, University of Geneva                            */
/*        Pierre Beylot, MIRALab, University of Geneva                          */
/*  in the course of development of the MPEG-4 Video (ISO/IEC 14496-2).	        */
/*  This software module is an implementation of a part of one or more	        */
/*  MPEG-4 Video (ISO/IEC 14496-2) tools as specified by the MPEG-4 Video       */
/*  (ISO/IEC 14496-2). ISO/IEC gives users of the                               */
/*  MPEG-4 Video (ISO/IEC 14496-2) free license to this software module or	*/
/*  modifications thereof for use in hardware or software products claiming 	*/
/*  conformance to the MPEG-4 Video (ISO/IEC 14496-2). Those intending to use	*/
/*  this software module in hardware or software products are advised that	*/
/*  its use may infringe existing patents. The original developer of this	*/
/*  software module and his/her company, the subsequent editors and their	*/
/*  companies, and ISO/IEC have no liability for use of this software		*/
/*  module or modifications thereof. Copyright is not released for non		*/
/*  MPEG-4 Video (ISO/IEC 14496-2) conforming products.                         */
/*  MIRALab, University of Geneva retains full right to use the code for its    */
/*  own purpose, assign or donate the code to a third party and to inhibit      */
/*  third parties from using the code for non MPEG-4 Video (ISO/IEC 14496-2)    */
/*  conforming products. This copyright notice must be included in all copies   */
/*  or derivative works. Copyright (c) (1997).			      		*/
/*										*/
/*										*/
/*------------------------------------------------------------------------------*/



#define ELVIS 0
#define BLINK 1
#define MARY 2
short ACTOR = ELVIS;

#define P_VALUE   0
#define C_VALUE   1
#define MAX_VALUE 2
#define MIN_VALUE 3

float 
 actor_max_eye_movevert,
 actor_min_eye_movevert,
 actor_max_eye_browraise,
 actor_min_eye_browraise,
 actor_max_upeyelid_down,
 actor_min_upeyelid_down,
 actor_max_mouth_compexp,
 actor_min_mouth_compexp,
 actor_max_cheek_puffsqueeze,
 actor_min_cheek_puffsqueeze,
 actor_max_cheek_zygo,
 actor_min_cheek_zygo,
 actor_max_head_nod,
 actor_min_head_nod,
 actor_max_head_roll,
 actor_min_head_roll, 
 actor_max_jaw_lower,
 actor_min_jaw_lower; 

float
    lefteye_movehori[4],
    lefteye_movevert[4],
    lefteye_browraise[4],
    lefteye_browraise_l[4],
    lefteye_browraise_m[4],
    lefteye_browraise_r[4],
    lefteye_browhori[4],
    lefteye_moveout[4],
    righteye_movehori[4],
    righteye_movevert[4],
    righteye_browraise[4],
    righteye_browraise_l[4],
    righteye_browraise_m[4],
    righteye_browraise_r[4],
    righteye_browhori[4],
    righteye_moveout[4],
    jaw_lower[4],
    jaw_hori[4],
    chin_depress[4],
    uppermouth_lipraise[4],
    lowermouth_lipraise[4],
    uppermouth_lipriso[4],
    lowermouth_lipriso[4],
    mouth_compexp[4],
    mouth_left_compexp[4],
    mouth_right_compexp[4],
    nose_compexp[4],
    nose_raise[4],
    leftcheek_puffsqueeze[4],
    rightcheek_puffsqueeze[4],
    leftcheek_zygo[4],
    rightcheek_zygo[4],
    leftcheek_lift[4],
    rightcheek_lift[4],
    leftcheek_lower[4],
    rightcheek_lower[4],
    mouth_beak[4],
    mouth_suck[4],
    mouth_squeeze_left[4],
    mouth_squeeze_right[4],
    mouth_squeeze[4],
    lefteye_llidup[4],
    lefteye_uliddown[4],
    righteye_llidup[4],
    righteye_uliddown[4],
    head_turn[4],
    head_nod[4],
    head_roll[4], 
    tongue_pan[4], 
    tongue_out[4], 
    tongue_lift[4],
    tongue_lift_tip[4],
    tongue_roll[4],
    jaw_thrust[4],
    eye_dilate_l_pupil[4],
    eye_dilate_r_pupil[4],
    nose_bend[4],
    nose_l_compexp[4],
    nose_r_compexp[4],
    raise_l_ear[4],
    raise_r_ear[4],
    pull_l_ear[4],
    pull_r_ear[4];
    


VECTOR_3D actor_eye_p1, actor_eye_p2;

void Face_set_intiale_parameters(void);

void Face_set_intiale_parameters()
{
  int i;

    for (i=0; i<=1; i++) {
     lefteye_movehori[i]=0.0;
     lefteye_movevert[i]=0.0;
     lefteye_browraise[i]=0.0;
     lefteye_browraise_l[i]=0.0;
     lefteye_browraise_m[i]=0.0;
     lefteye_browraise_r[i]=0.0;
     lefteye_browhori[i]=0.0;
     lefteye_moveout[i]=0.0;
     righteye_movehori[i]=0.0;
     righteye_movevert[i]=0.0;
     righteye_browraise[i]=0.0;
     righteye_browraise_l[i]=0.0;
     righteye_browraise_m[i]=0.0;
     righteye_browraise_r[i]=0.0;
     righteye_browhori[i]=0.0;
     righteye_moveout[i]=0.0;
     jaw_lower[i]=0.0;
     jaw_hori[i]=0.0;
     chin_depress[i]=0.0;
     uppermouth_lipraise[i]=0.0;
     lowermouth_lipraise[i]=0.0;
     uppermouth_lipriso[i]=0.0;
     lowermouth_lipriso[i]=0.0;
     mouth_compexp[i]=0.0;
     mouth_left_compexp[i]=0.0;
     mouth_right_compexp[i]=0.0;
     nose_compexp[i]=0.0;
     nose_raise[i]=0.0;
     leftcheek_puffsqueeze[i]=0.0;
     rightcheek_puffsqueeze[i]=0.0;
     leftcheek_zygo[i]=0.0;
     rightcheek_zygo[i]=0.0;
     leftcheek_lift[i]=0.0;
     rightcheek_lift[i]=0.0;
     leftcheek_lower[i]=0.0;
     rightcheek_lower[i]=0.0;
     mouth_beak[i]=0.0;
     mouth_suck[i]=0.0;
     mouth_squeeze_left[i]=0.0;
     mouth_squeeze_right[i]=0.0;
     mouth_squeeze[i]=0.0;
     lefteye_llidup[i]=0.0;
     lefteye_uliddown[i]=0.0;
     righteye_llidup[i]=0.0;
     righteye_uliddown[i]=0.0;
     head_turn[i]=0.0;
     head_nod[i]=0.0;
     head_roll[i]=0.0;
     tongue_pan[i]=0.0;
     tongue_lift[i]=0.0;
     tongue_out[i]=0.0;
     tongue_lift_tip[i]=0.0;
     tongue_roll[i]=0.0;
     jaw_thrust[i]=0.0;
     eye_dilate_l_pupil[i]=0.0;
     eye_dilate_r_pupil[i]=0.0;
     nose_bend[i]=0.0;
     nose_l_compexp[i]=0.0;
     nose_r_compexp[i]=0.0;
     raise_l_ear[i]=0.0;
     raise_r_ear[i]=0.0;
     pull_l_ear[i]=0.0;
     pull_r_ear[i]=0.0;
    }    
}

void Face_put_actor_maxmin_values(void);

void Face_put_actor_maxmin_values()
{

FILE *infile;
char dummy[100];

    if (infile = fopen("face.parm", "r")) {
	fscanf(infile, "%s %f\n", dummy, &actor_max_eye_movevert);
	fscanf(infile, "%s %f\n", dummy, &actor_min_eye_movevert);
	fscanf(infile, "%s %f\n", dummy, &actor_max_eye_browraise);
	fscanf(infile, "%s %f\n", dummy, &actor_min_eye_browraise);
	fscanf(infile, "%s %f\n", dummy, &actor_max_upeyelid_down);
	fscanf(infile, "%s %f\n", dummy, &actor_min_upeyelid_down);
	fscanf(infile, "%s %f\n", dummy, &actor_max_mouth_compexp);
	fscanf(infile, "%s %f\n", dummy, &actor_min_mouth_compexp);
	fscanf(infile, "%s %f\n", dummy, &actor_max_cheek_puffsqueeze);
	fscanf(infile, "%s %f\n", dummy, &actor_min_cheek_puffsqueeze);
	fscanf(infile, "%s %f\n", dummy, &actor_max_cheek_zygo);
	fscanf(infile, "%s %f\n", dummy, &actor_min_cheek_zygo);
	fscanf(infile, "%s %f\n", dummy, &actor_max_head_nod);
	fscanf(infile, "%s %f\n", dummy, &actor_min_head_nod);
	fscanf(infile, "%s %f\n", dummy, &actor_max_head_roll);
	fscanf(infile, "%s %f\n", dummy, &actor_min_head_roll);
	fscanf(infile, "%s %f\n", dummy, &actor_max_jaw_lower);
	fscanf(infile, "%s %f\n", dummy, &actor_min_jaw_lower);
	fclose(infile);
    }
    else {
    switch (ACTOR) {
     case ELVIS : 
       actor_max_eye_movevert = 1.0;   
       actor_min_eye_movevert = 1.0;
       actor_max_eye_browraise = 0.8;
       actor_min_eye_browraise = 0.4;
       actor_max_upeyelid_down = 1.2;
       actor_min_upeyelid_down = 0.8;
       actor_max_mouth_compexp = 1.0;
       actor_min_mouth_compexp = 1.0;
       actor_max_cheek_puffsqueeze = 1.0;
       actor_min_cheek_puffsqueeze = 1.0;
       actor_max_cheek_zygo = 0.8;
       actor_min_cheek_zygo = 0.8;
       actor_max_head_nod = 1.0;
       actor_min_head_nod = 1.0;
       actor_max_head_roll = 1.0;
       actor_min_head_roll = 1.0;
       actor_max_jaw_lower = 1.0;
       actor_min_jaw_lower = 0.4;
       V3D_INIT(actor_eye_p1,-10.465831,1.814178,8.298168);
       V3D_INIT(actor_eye_p2,-4.101777,1.658233,9.507004);
     break;
     case BLINK : 
     /* for Lucy */
       actor_max_eye_movevert = 0.6;   
       actor_min_eye_movevert = 0.6;
       actor_max_eye_browraise = 0.2;
       actor_min_eye_browraise = 0.2;
       actor_max_upeyelid_down = 1.9;
       actor_min_upeyelid_down = 1.5;
       actor_max_mouth_compexp = 0.7;
       actor_min_mouth_compexp = 0.7;
       actor_max_cheek_puffsqueeze = 0.7;
       actor_min_cheek_puffsqueeze = 0.7;
       actor_max_cheek_zygo = 0.5;
       actor_min_cheek_zygo = 0.5;
       actor_max_head_nod = 0.7;
       actor_min_head_nod = 0.7;
       actor_max_head_roll = 0.5;
       actor_min_head_roll = 0.5;
       actor_max_jaw_lower = 1.0;
       actor_min_jaw_lower = 0.4;
       V3D_INIT(actor_eye_p1,-13.48100,7.348259,11.933690);
       V3D_INIT(actor_eye_p2,-4.5968,7.033859,12.579900);
     break;
     case MARY : 
       actor_max_eye_movevert = 0.6;   
       actor_min_eye_movevert = 0.6;
       actor_max_eye_browraise = 0.8;
       actor_min_eye_browraise = 0.4;
       actor_max_upeyelid_down = 1.0;
       actor_min_upeyelid_down = 1.0;
       actor_max_mouth_compexp = 0.7;
       actor_min_mouth_compexp = 0.7;
       actor_max_cheek_puffsqueeze = 0.7;
       actor_min_cheek_puffsqueeze = 0.7;
       actor_max_cheek_zygo = 0.7;
       actor_min_cheek_zygo = 1.0;
       actor_max_head_nod = 1.0;
       actor_min_head_nod = 1.0;
       actor_max_head_roll = 0.5;
       actor_min_head_roll = 0.5;
       actor_max_jaw_lower = 1.0;
       actor_min_jaw_lower = 1.0;
       V3D_INIT(actor_eye_p1,-13.48100,7.348259,11.933690);
       V3D_INIT(actor_eye_p2,-4.5968,7.033859,12.579900);
     break;
     default :
     break;
  }
  }

}


/*------------------------------------------------------------*/

void Face_set_maxmin_limits(void);

void Face_set_maxmin_limits()

{
    lefteye_movehori[MAX_VALUE]=1.0;
    lefteye_movehori[MIN_VALUE]=1.0;

    lefteye_movevert[MAX_VALUE]=1.0 * actor_max_eye_movevert;
    lefteye_movevert[MIN_VALUE]=1.0 * actor_min_eye_movevert;

    lefteye_browraise[MAX_VALUE]=1.0 * actor_max_eye_browraise;
    lefteye_browraise[MIN_VALUE]=1.0 * actor_min_eye_browraise;

    lefteye_browraise_l[MAX_VALUE]=1.0 * actor_max_eye_browraise;
    lefteye_browraise_l[MIN_VALUE]=1.0 * actor_min_eye_browraise;

    lefteye_browraise_m[MAX_VALUE]=1.0 * actor_max_eye_browraise;
    lefteye_browraise_m[MIN_VALUE]=1.0 * actor_min_eye_browraise;

    lefteye_browraise_r[MAX_VALUE]=1.0 * actor_max_eye_browraise;
    lefteye_browraise_r[MIN_VALUE]=1.0 * actor_min_eye_browraise;

    lefteye_browhori[MAX_VALUE]=1.0;
    lefteye_browhori[MIN_VALUE]=1.0;

    lefteye_moveout[MAX_VALUE]=1.0;
    lefteye_moveout[MIN_VALUE]=1.0;
    
    righteye_movehori[MAX_VALUE]=1.0;
    righteye_movehori[MIN_VALUE]=1.0;

    righteye_movevert[MAX_VALUE]=1.0 * actor_max_eye_movevert;
    righteye_movevert[MIN_VALUE]=1.0 * actor_min_eye_movevert;

    righteye_browraise[MAX_VALUE]=1.0 * actor_max_eye_browraise;
    righteye_browraise[MIN_VALUE]=1.0 * actor_min_eye_browraise;

    righteye_browraise_l[MAX_VALUE]=1.0 * actor_max_eye_browraise;
    righteye_browraise_l[MIN_VALUE]=1.0 * actor_min_eye_browraise;

    righteye_browraise_m[MAX_VALUE]=1.0 * actor_max_eye_browraise;
    righteye_browraise_m[MIN_VALUE]=1.0 * actor_min_eye_browraise;

    righteye_browraise_r[MAX_VALUE]=1.0 * actor_max_eye_browraise;
    righteye_browraise_r[MIN_VALUE]=1.0 * actor_min_eye_browraise;

    righteye_browhori[MAX_VALUE]=1.0;
    righteye_browhori[MIN_VALUE]=1.0;

    righteye_moveout[MAX_VALUE]=1.0;
    righteye_moveout[MIN_VALUE]=1.0;

    jaw_lower[MAX_VALUE]=1.0 * actor_max_jaw_lower;
    jaw_lower[MIN_VALUE]=1.0 * actor_min_jaw_lower;

    jaw_hori[MAX_VALUE]=1.0;
    jaw_hori[MIN_VALUE]=1.0;

    chin_depress[MAX_VALUE]=1.0;
    chin_depress[MIN_VALUE]=1.0;

    uppermouth_lipraise[MAX_VALUE]=1.0;
    uppermouth_lipraise[MIN_VALUE]=1.0;

    lowermouth_lipraise[MAX_VALUE]=1.0;
    lowermouth_lipraise[MIN_VALUE]=1.0;

    uppermouth_lipriso[MAX_VALUE]=1.0;
    uppermouth_lipriso[MIN_VALUE]=1.0;

    lowermouth_lipriso[MAX_VALUE]=1.0;
    lowermouth_lipriso[MIN_VALUE]=1.0;

    mouth_compexp[MAX_VALUE]=1.0 * actor_max_mouth_compexp;
    mouth_compexp[MIN_VALUE]=1.0 * actor_min_mouth_compexp;

    mouth_left_compexp[MAX_VALUE]=1.0;
    mouth_left_compexp[MIN_VALUE]=1.0;

    mouth_right_compexp[MAX_VALUE]=1.0;
    mouth_right_compexp[MIN_VALUE]=1.0;

    nose_compexp[MAX_VALUE]=1.0 * 0.8;
    nose_compexp[MIN_VALUE]=1.0 * 0.8;

    nose_raise[MAX_VALUE]=1.0;
    nose_raise[MIN_VALUE]=1.0;


    leftcheek_puffsqueeze[MAX_VALUE]=1.0 * actor_max_cheek_puffsqueeze;
    leftcheek_puffsqueeze[MIN_VALUE]=1.0 * actor_min_cheek_puffsqueeze;

    rightcheek_puffsqueeze[MAX_VALUE]=1.0 * actor_max_cheek_puffsqueeze;
    rightcheek_puffsqueeze[MIN_VALUE]=1.0 * actor_min_cheek_puffsqueeze;

    leftcheek_zygo[MAX_VALUE]=1.0 * actor_max_cheek_zygo;
    leftcheek_zygo[MIN_VALUE]=1.0 * actor_min_cheek_zygo;

    rightcheek_zygo[MAX_VALUE]=1.0 * actor_max_cheek_zygo;
    rightcheek_zygo[MIN_VALUE]=1.0 * actor_min_cheek_zygo;

    leftcheek_lift[MAX_VALUE]=1.0;
    leftcheek_lift[MIN_VALUE]=1.0;

    rightcheek_lift[MAX_VALUE]=1.0;
    rightcheek_lift[MIN_VALUE]=1.0;

    leftcheek_lower[MAX_VALUE]=1.0;
    leftcheek_lower[MIN_VALUE]=1.0;

    rightcheek_lower[MAX_VALUE]=1.0;
    rightcheek_lower[MIN_VALUE]=1.0;

    mouth_beak[MAX_VALUE]=1.0 * 0.5;
    mouth_beak[MIN_VALUE]=1.0 * 0.5;

    mouth_suck[MAX_VALUE]=1.0;
    mouth_suck[MIN_VALUE]=1.0;

    mouth_squeeze[MAX_VALUE]=1.0;
    mouth_squeeze[MIN_VALUE]=1.0;

    mouth_squeeze_left[MAX_VALUE]=1.0;
    mouth_squeeze_left[MIN_VALUE]=1.0;

    mouth_squeeze_right[MAX_VALUE]=1.0;
    mouth_squeeze_right[MIN_VALUE]=1.0;

    lefteye_llidup[MAX_VALUE]=1.0;
    lefteye_llidup[MIN_VALUE]=1.0;

    lefteye_uliddown[MAX_VALUE]=1.0 * actor_max_upeyelid_down;
    lefteye_uliddown[MIN_VALUE]=1.0 * actor_min_upeyelid_down;

    righteye_llidup[MAX_VALUE]=1.0;
    righteye_llidup[MIN_VALUE]=1.0;

    righteye_uliddown[MAX_VALUE]=1.0 * actor_max_upeyelid_down;
    righteye_uliddown[MIN_VALUE]=1.0 * actor_min_upeyelid_down;

    head_turn[MAX_VALUE]=1.0;
    head_turn[MIN_VALUE]=1.0;

    head_nod[MAX_VALUE]=1.0;
    head_nod[MIN_VALUE]=1.0;

    head_roll[MAX_VALUE]=1.0 * actor_max_head_roll;
    head_roll[MIN_VALUE]=1.0 * actor_min_head_roll;
    
    tongue_pan[MAX_VALUE]=1.0;
    tongue_pan[MIN_VALUE]=1.0;
    
    tongue_lift[MIN_VALUE]=1.0;
    tongue_lift[MAX_VALUE]=1.0;
    
    tongue_out[MIN_VALUE]=1.0;
    tongue_out[MAX_VALUE]=1.0;

    tongue_lift_tip[MIN_VALUE]=1.0;
    tongue_lift_tip[MAX_VALUE]=1.0;

    tongue_roll[MIN_VALUE]=1.0;
    tongue_roll[MAX_VALUE]=1.0;

    jaw_thrust[MIN_VALUE]=1.0;
    jaw_thrust[MAX_VALUE]=1.0;

    eye_dilate_l_pupil[MIN_VALUE]=1.0;
    eye_dilate_l_pupil[MAX_VALUE]=1.0;

    eye_dilate_r_pupil[MIN_VALUE]=1.0;
    eye_dilate_r_pupil[MAX_VALUE]=1.0;

    nose_bend[MIN_VALUE]=1.0;
    nose_bend[MAX_VALUE]=1.0;

    nose_l_compexp[MIN_VALUE]=1.0;
    nose_l_compexp[MAX_VALUE]=1.0;

    nose_r_compexp[MIN_VALUE]=1.0;
    nose_r_compexp[MAX_VALUE]=1.0;

    raise_l_ear[MIN_VALUE]=1.0;
    raise_l_ear[MAX_VALUE]=1.0;

    raise_r_ear[MIN_VALUE]=1.0;
    raise_r_ear[MAX_VALUE]=1.0;

    pull_l_ear[MIN_VALUE]=1.0;
    pull_l_ear[MAX_VALUE]=1.0;

    pull_r_ear[MIN_VALUE]=1.0;
    pull_r_ear[MAX_VALUE]=1.0;
}
/*---------------------------------------------------------------*/
void Face_print_initial_parameters()
/** Debugging **/
{
  int i;

    for (i=0; i<=3; i++) {
     printf(" 1 %f \n",lefteye_movehori[i]);
     printf(" 2 %f \n",lefteye_movevert[i]);
     printf(" 3 %f \n",lefteye_browraise[i]);
     printf(" 4 %f \n",lefteye_browraise_l[i]);
     printf(" 5 %f \n",lefteye_browraise_m[i]);
     printf(" 6 %f \n",lefteye_browraise_r[i]);
     printf(" 7 %f \n",lefteye_browhori[i]);
     printf(" 8 %f \n",lefteye_moveout[i]);
     printf(" 9 %f \n",righteye_movehori[i]);
     printf(" 10 %f \n",righteye_movevert[i]);
     printf(" 11 %f \n",righteye_browraise[i]);
     printf(" 12 %f \n",righteye_browraise_l[i]);
     printf(" 13 %f \n",righteye_browraise_m[i]);
     printf(" 14 %f \n",righteye_browraise_r[i]);
     printf(" 15 %f \n",righteye_browhori[i]);
     printf(" 16 %f \n",righteye_moveout[i]);
     printf(" 17 %f \n",jaw_lower[i]);
     printf(" 18 %f \n",jaw_hori[i]);
     printf(" 19 %f \n",uppermouth_lipraise[i]);
     printf(" 20 %f \n",lowermouth_lipraise[i]);
     printf(" 21 %f \n",uppermouth_lipriso[i]);
     printf(" 22 %f \n",lowermouth_lipriso[i]);
     printf(" 23 %f \n",mouth_compexp[i]);
     printf(" 24 %f \n",mouth_left_compexp[i]);
     printf(" 25 %f \n",mouth_right_compexp[i]);
     printf(" 26 %f \n",nose_compexp[i]);
     printf(" 27 %f \n",nose_raise[i]);
     printf(" 28 %f \n",leftcheek_puffsqueeze[i]);
     printf(" 29 %f \n",rightcheek_puffsqueeze[i]);
     printf(" 30 %f \n",leftcheek_zygo[i]);
     printf(" 31 %f \n",rightcheek_zygo[i]);
     printf(" 32 %f \n",leftcheek_lift[i]);
     printf(" 33 %f \n",rightcheek_lift[i]);
     printf(" 34 %f \n",leftcheek_lower[i]);
     printf(" 35 %f \n",rightcheek_lower[i]);
     printf(" 36 %f \n",mouth_beak[i]);
     printf(" 37 %f \n",lefteye_llidup[i]);
     printf(" 38 %f \n",lefteye_uliddown[i]);
     printf(" 39 %f \n",righteye_llidup[i]);
     printf(" 40 %f \n",righteye_uliddown[i]);
     printf(" 41 %f \n",head_turn[i]);
     printf(" 42 %f \n",head_nod[i]);
     printf(" 43 %f \n",head_roll[i]);
     printf(" 44 %f \n",tongue_pan[i]);
     printf(" 45 %f \n",tongue_lift[i]);
     printf(" 46 %f \n",tongue_out[i]);
    }    

}

/*-----------------------------------------------------------------*/

void Face_adjust_parameter_values(slider_value,mpa_parameters)
float slider_value;
float mpa_parameters[4];
{
     if (slider_value < 0.0) 
       slider_value *= mpa_parameters[MIN_VALUE];
     else
       slider_value *= mpa_parameters[MAX_VALUE];
     mpa_parameters[C_VALUE] = slider_value - mpa_parameters[P_VALUE];

}


/*--------------------------------------------------------------------*/

