
/*------------------------------------------------------------------------------*/
/*										*/
/*										*/
/*  This software module was originally developed by                            */
/*        Prem Kalra, MIRALab, University of Geneva                             */
/*  and edited by                                                               */
/*        Igor Pandzic, MIRALab, University of Geneva                           */
/*        Marc Escher, MIRALab, University of Geneva                            */
/*        Pierre Beylot, MIRALab, University of Geneva                          */
/*  in the course of development of the MPEG-4 Video (ISO/IEC 14496-2).	        */
/*  This software module is an implementation of a part of one or more	        */
/*  MPEG-4 Video (ISO/IEC 14496-2) tools as specified by the MPEG-4 Video       */
/*  (ISO/IEC 14496-2). ISO/IEC gives users of the                               */
/*  MPEG-4 Video (ISO/IEC 14496-2) free license to this software module or	*/
/*  modifications thereof for use in hardware or software products claiming 	*/
/*  conformance to the MPEG-4 Video (ISO/IEC 14496-2). Those intending to use	*/
/*  this software module in hardware or software products are advised that	*/
/*  its use may infringe existing patents. The original developer of this	*/
/*  software module and his/her company, the subsequent editors and their	*/
/*  companies, and ISO/IEC have no liability for use of this software		*/
/*  module or modifications thereof. Copyright is not released for non		*/
/*  MPEG-4 Video (ISO/IEC 14496-2) conforming products.                         */
/*  MIRALab, University of Geneva retains full right to use the code for its    */
/*  own purpose, assign or donate the code to a third party and to inhibit      */
/*  third parties from using the code for non MPEG-4 Video (ISO/IEC 14496-2)    */
/*  conforming products. This copyright notice must be included in all copies   */
/*  or derivative works. Copyright (c) (1997).			      		*/
/*										*/
/*										*/
/*------------------------------------------------------------------------------*/


#ifndef PARSER_MODULE
#define PARSER_MODULE


#include "stdio.h"
#include "string.h"
#include "malloc.h"

#ifndef BOOL
#define BOOL int
#endif

#ifndef NO
#define NO 0
#define YES 1
#endif

typedef int Parser_List_Level;

typedef struct {
    FILE *unix_file;
    BOOL end_of_file;
    Parser_List_Level list_level_count;
} Parser_File;


extern BOOL
parser_next_token(Parser_File *, char *, int);

extern BOOL
parser_end_of_file(Parser_File *);

extern BOOL
parser_end_of_list(Parser_File *, Parser_List_Level);

extern BOOL
parser_correct_list(Parser_File *, Parser_List_Level);


extern BOOL
parser_read_identifier(Parser_File *, Parser_List_Level, char *);

extern BOOL
parser_read_string(Parser_File *, Parser_List_Level, char *);

extern BOOL
parser_read_float(Parser_File *, Parser_List_Level, float *);

extern BOOL
parser_read_int(Parser_File *, Parser_List_Level, int *);


extern void
parser_bgn_list(Parser_File *, Parser_List_Level *);

extern void
parser_end_list(Parser_File *, Parser_List_Level);

extern Parser_File *
parser_open_file(char *);

extern void
parser_close_file(Parser_File *);

static BOOL
parser_end_token(int,int);

static BOOL
is_num(int);

static BOOL
is_digit(int);

static BOOL
is_alpha(int);

static BOOL
endset(int,int);

static int
is_set(int);

static BOOL
is_separator(int);

static BOOL
is_begin_list(int);

static double 
char_to_double(char*);

#endif

