
/*------------------------------------------------------------------------------*/
/*										*/
/*										*/
/*  This software module was originally developed by                            */
/*        Prem Kalra, MIRALab, University of Geneva                             */
/*  and edited by                                                               */
/*        Igor Pandzic, MIRALab, University of Geneva                           */
/*        Marc Escher, MIRALab, University of Geneva                            */
/*        Pierre Beylot, MIRALab, University of Geneva                          */
/*  in the course of development of the MPEG-4 Video (ISO/IEC 14496-2).	        */
/*  This software module is an implementation of a part of one or more	        */
/*  MPEG-4 Video (ISO/IEC 14496-2) tools as specified by the MPEG-4 Video       */
/*  (ISO/IEC 14496-2). ISO/IEC gives users of the                               */
/*  MPEG-4 Video (ISO/IEC 14496-2) free license to this software module or	*/
/*  modifications thereof for use in hardware or software products claiming 	*/
/*  conformance to the MPEG-4 Video (ISO/IEC 14496-2). Those intending to use	*/
/*  this software module in hardware or software products are advised that	*/
/*  its use may infringe existing patents. The original developer of this	*/
/*  software module and his/her company, the subsequent editors and their	*/
/*  companies, and ISO/IEC have no liability for use of this software		*/
/*  module or modifications thereof. Copyright is not released for non		*/
/*  MPEG-4 Video (ISO/IEC 14496-2) conforming products.                         */
/*  MIRALab, University of Geneva retains full right to use the code for its    */
/*  own purpose, assign or donate the code to a third party and to inhibit      */
/*  third parties from using the code for non MPEG-4 Video (ISO/IEC 14496-2)    */
/*  conforming products. This copyright notice must be included in all copies   */
/*  or derivative works. Copyright (c) (1997).			      		*/
/*										*/
/*										*/
/*------------------------------------------------------------------------------*/




/* 100 == EYES */
/* eye balls horizontal movement */
#define MPA_101 101
#define MPA_102 102
#define MPA_103 103
/* eye balls vertical movement   */
#define MPA_111 111
#define MPA_112 112
#define MPA_113 113
/* eye upper eye lid movement    */
#define MPA_121 121
#define MPA_122 122
#define MPA_123 123
/* eye lower eye lid movement    */
#define MPA_131 131 
#define MPA_132 132
#define MPA_133 133
/* eye brows vertical movement   */
#define MPA_141 141
#define MPA_142 142              
#define MPA_143 143 

#define MPA_1441 1441
#define MPA_1442 1442
#define MPA_1443 1443

#define MPA_1451 1451
#define MPA_1452 1452
#define MPA_1453 1453

#define MPA_1461 1461
#define MPA_1462 1462
#define MPA_1463 1463

/* eye brows horizontal movement */  
#define MPA_151 151
#define MPA_152 152
#define MPA_153 153

/* eye ball out movement */  
#define MPA_161 161
#define MPA_162 162
#define MPA_163 163

/* dilate pupil (l, r, both) */
#define MPA_171 171
#define MPA_172 172
#define MPA_173 173

/* 200 == JAW  */
/* open jaw movement            */          
#define MPA_201 201 
/* left-right movement of the jaw */
#define MPA_202 202
/* depress chin */
#define MPA_203 203
/* jaw thrust */
#define MPA_204 204

/* 300 == CHEEK  */
/* cheek zygomatic movement      */
#define MPA_301 301
#define MPA_302 302
#define MPA_303 303
/* cheek puff/squeeze movement   */
#define MPA_311 311
#define MPA_312 312
#define MPA_313 313
/* cheek lift movement   */
#define MPA_321 321
#define MPA_322 322
#define MPA_323 323
/* cheek lower movement   */
#define MPA_331 331
#define MPA_332 332
#define MPA_333 333

/* 400 == MOUTH/LIPS */
/*  mouth/lips vertical movement  */
#define MPA_401 401
#define MPA_402 402
#define MPA_403 403
/*  mouth/lip risorius movement   */
#define MPA_411 411
#define MPA_412 412
#define MPA_413 413
/*  mouth beak  */
#define MPA_421 421
/*  mouth comp/exp */
#define MPA_431 431
#define MPA_4311 4311
#define MPA_4312 4312
/* mouth suck */
#define MPA_441 441
/* mouth corner squeeze */
#define MPA_451 451
#define MPA_4511 4511
#define MPA_4512 4512

/* 500 == NOSE */
/* nose comp/exp movement (both,l,r)*/
#define MPA_501 501 
#define MPA_502 502 
#define MPA_503 503 

/* nose elvation movement */
#define MPA_511 511
/* nose bend (left/right) movement */
#define MPA_521 521
/* 600 == HEAD */
/* head turning movement */
#define MPA_601 601
/* head nodding movemtn  */
#define MPA_611 611      
/* head rolling movement */
#define MPA_621 621  

/* 700 == TONGUE */
/* tongue lifting movement */
#define MPA_701 701
/* tongue pan movement */
#define MPA_702 702
/* tongue protrusion */
#define MPA_703 703
/* tongue bending, lifting just the tip */
#define MPA_704 704
/* tongue roll, in the shape of letter U */
#define MPA_705 705

/* 800 == EARS */
/* ear raising movement (l,r,both) */
#define MPA_801 801
#define MPA_802 802
#define MPA_803 803
/* ear pull forward movement (l,r,both) */
#define MPA_811 811
#define MPA_812 812
#define MPA_813 813

#define SCRIPT_TOTAL_MPAS 81



void Face_adjusted_parameter_values_get(double,float*,float*);

void Face_adjusted_parameter_values_get(in_value,out_value,mpa_parameters)
float in_value, *out_value;
float mpa_parameters[4];
{
   float value;

     if (in_value < 0.0) 
       value = in_value * mpa_parameters[MIN_VALUE];
     else
       value = in_value * mpa_parameters[MAX_VALUE];
     mpa_parameters[C_VALUE] = value - mpa_parameters[P_VALUE];
     *out_value = value;
}


/*--------------------------------------------------------------------*/

void Script_apply_mpa(int,double,SM_Surface_ptr,SM_Surface_ptr,SM_Region_List_ptr);

void Script_apply_mpa(int which_mpa,double intensity,SM_Surface_ptr the_surface,SM_Surface_ptr the_face,SM_Region_List_ptr the_region_list)
{

  SM_Region_Name the_name;
  float my_intensity;

      switch (which_mpa) {
        case MPA_101 : 
           strcpy(the_name,"left_eye");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,lefteye_movehori);
           AU_eye_move_horizontal(the_surface,the_region_list,
                     the_name,lefteye_movehori[C_VALUE]);
           lefteye_movehori[P_VALUE] = my_intensity;
           lefteye_movehori[C_VALUE] = 0.0;
        break;
        case MPA_102 :
           strcpy(the_name,"right_eye");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,righteye_movehori);
           AU_eye_move_horizontal(the_surface,the_region_list,
                     the_name,righteye_movehori[C_VALUE]);
           righteye_movehori[P_VALUE] = my_intensity;
           righteye_movehori[C_VALUE] = 0.0;            
        break;
        case MPA_103 :
          strcpy(the_name,"left_eye");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,lefteye_movehori);
          AU_eye_move_horizontal(the_surface,the_region_list,
                     the_name,lefteye_movehori[C_VALUE]);
          lefteye_movehori[P_VALUE] = my_intensity;
          lefteye_movehori[C_VALUE] = 0.0;

          righteye_movehori[C_VALUE] = my_intensity - righteye_movehori[P_VALUE];
          strcpy(the_name,"right_eye");
          AU_eye_move_horizontal(the_surface,the_region_list,
                     the_name,righteye_movehori[C_VALUE]);
          righteye_movehori[P_VALUE] = my_intensity;
          righteye_movehori[C_VALUE] = 0.0;
        break;
        case MPA_111 :
          strcpy(the_name,"left_eye");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,lefteye_movevert);
          AU_eye_move_vertical(the_surface,the_region_list,
                     the_name,lefteye_movevert[C_VALUE]);
          lefteye_movevert[P_VALUE] = my_intensity;
          lefteye_movevert[C_VALUE] = 0.0;
        break;
        case MPA_112 :
          strcpy(the_name,"right_eye");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,righteye_movevert);
          AU_eye_move_vertical(the_surface,the_region_list,
                     the_name,righteye_movevert[C_VALUE]);
          righteye_movevert[P_VALUE] = my_intensity;
          righteye_movevert[C_VALUE] = 0.0;
        break;
        case MPA_113 :
          strcpy(the_name,"left_eye");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,lefteye_movevert);
          AU_eye_move_vertical(the_surface,the_region_list,
                     the_name,lefteye_movevert[C_VALUE]);
          lefteye_movevert[P_VALUE] = my_intensity;
          lefteye_movevert[C_VALUE] = 0.0;

          righteye_movevert[C_VALUE] = my_intensity - righteye_movevert[P_VALUE];
          strcpy(the_name,"right_eye");
          AU_eye_move_vertical(the_surface,the_region_list,
                     the_name,righteye_movevert[C_VALUE]);
          righteye_movevert[P_VALUE] = my_intensity;
          righteye_movevert[C_VALUE] = 0.0;
        break;
        case MPA_121 :
          strcpy(the_name,"left_upeyelid");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,lefteye_uliddown);
          AU_eyelid_upper_updown(the_surface,the_region_list,
                     the_name,lefteye_uliddown[C_VALUE],actor_eye_p1,actor_eye_p2);
          lefteye_uliddown[P_VALUE] = my_intensity;
          lefteye_uliddown[C_VALUE] = 0.0;
        break;
        case MPA_122 :
          strcpy(the_name,"right_upeyelid");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,righteye_uliddown);
          AU_eyelid_upper_updown(the_surface,the_region_list,
                     the_name,righteye_uliddown[C_VALUE],actor_eye_p1,actor_eye_p2);
          righteye_uliddown[P_VALUE] = my_intensity;
          righteye_uliddown[C_VALUE] = 0.0;
        break;
        case MPA_123 :
          strcpy(the_name,"left_upeyelid");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,lefteye_uliddown);
          AU_eyelid_upper_updown(the_surface,the_region_list,
                     the_name,lefteye_uliddown[C_VALUE],actor_eye_p1,actor_eye_p2);
          lefteye_uliddown[P_VALUE] = my_intensity;
          lefteye_uliddown[C_VALUE] = 0.0;
          righteye_uliddown[C_VALUE] = my_intensity - righteye_uliddown[P_VALUE];
          strcpy(the_name,"right_upeyelid");
          AU_eyelid_upper_updown(the_surface,the_region_list,
                     the_name,righteye_uliddown[C_VALUE],actor_eye_p1,actor_eye_p2);
          righteye_uliddown[P_VALUE] = my_intensity;
          righteye_uliddown[C_VALUE] = 0.0;
        break;
        case MPA_131 :
          strcpy(the_name,"left_loweyelid");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,lefteye_llidup);
          AU_eyelid_lower_updown(the_surface,the_face,the_region_list,
                     the_name,lefteye_llidup[C_VALUE]);
          lefteye_llidup[P_VALUE] = my_intensity;
          lefteye_llidup[C_VALUE] = 0.0;
        break;
        case MPA_132 :
          strcpy(the_name,"right_loweyelid");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,righteye_llidup);
          AU_eyelid_lower_updown(the_surface,the_face,the_region_list,
                     the_name,righteye_llidup[C_VALUE]);
          righteye_llidup[P_VALUE] = my_intensity;
          righteye_llidup[C_VALUE] = 0.0;
        break;
        case MPA_133 :
          strcpy(the_name,"left_loweyelid");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,lefteye_llidup);
          AU_eyelid_lower_updown(the_surface,the_face,the_region_list,
                     the_name,lefteye_llidup[C_VALUE]);
          lefteye_llidup[P_VALUE] = my_intensity;
          lefteye_llidup[C_VALUE] = 0.0;

          righteye_llidup[C_VALUE] = my_intensity - righteye_llidup[P_VALUE];
          strcpy(the_name,"right_loweyelid");
          AU_eyelid_lower_updown(the_surface,the_face,the_region_list,
                     the_name,righteye_llidup[C_VALUE]);
          righteye_llidup[P_VALUE] = my_intensity;
          righteye_llidup[C_VALUE] = 0.0;
        break;
        case MPA_141 :
          strcpy(the_name,"left_eyebrow");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,lefteye_browraise);
          AU_eye_brow_raise(the_surface,the_face,the_region_list,
                     the_name,0,lefteye_browraise[C_VALUE]);
          lefteye_browraise[P_VALUE] = my_intensity;
          lefteye_browraise[C_VALUE] = 0.0;
        break;
        case MPA_142 :
          strcpy(the_name,"right_eyebrow");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,righteye_browraise);
          AU_eye_brow_raise(the_surface,the_face,the_region_list,
                     the_name,0,righteye_browraise[C_VALUE]);
          righteye_browraise[P_VALUE] = my_intensity;
          righteye_browraise[C_VALUE] = 0.0;
        break;
        case MPA_143 :
          strcpy(the_name,"left_eyebrow");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,lefteye_browraise);
          AU_eye_brow_raise(the_surface,the_face,the_region_list,
                     the_name,0,lefteye_browraise[C_VALUE]);
          lefteye_browraise[P_VALUE] = my_intensity;
          lefteye_browraise[C_VALUE] = 0.0;

          strcpy(the_name,"right_eyebrow");
          righteye_browraise[C_VALUE] = my_intensity - righteye_browraise[P_VALUE]; 

          AU_eye_brow_raise(the_surface,the_face,the_region_list,
                     the_name,0,righteye_browraise[C_VALUE]);
          righteye_browraise[P_VALUE] = my_intensity;
          righteye_browraise[C_VALUE] = 0.0;
        break;
        case MPA_151 :
          strcpy(the_name,"left_eyebrow");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,lefteye_browhori);
          AU_eye_brow_hori(the_surface,the_face,the_region_list,
                     the_name,lefteye_browhori[C_VALUE]);
          lefteye_browhori[P_VALUE] = my_intensity;
          lefteye_browhori[C_VALUE] = 0.0;
        break;
        case MPA_152 :
          strcpy(the_name,"right_eyebrow");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,righteye_browhori);
          AU_eye_brow_hori(the_surface,the_face,the_region_list,
                     the_name,righteye_browhori[C_VALUE]);
          righteye_browhori[P_VALUE] = my_intensity;
          righteye_browhori[C_VALUE] = 0.0;
        break;
        case MPA_153 :
          strcpy(the_name,"left_eyebrow");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,lefteye_browhori);
          AU_eye_brow_hori(the_surface,the_face,the_region_list,
                     the_name,lefteye_browhori[C_VALUE]);
          lefteye_browhori[P_VALUE] = my_intensity;
          lefteye_browhori[C_VALUE] = 0.0;

          strcpy(the_name,"right_eyebrow");
          righteye_browhori[C_VALUE] = my_intensity - righteye_browhori[P_VALUE];
          AU_eye_brow_hori(the_surface,the_face,the_region_list,
                     the_name,righteye_browhori[C_VALUE]);
          righteye_browhori[P_VALUE] = my_intensity;
          righteye_browhori[C_VALUE] = 0.0;
        break;

        case MPA_161 :
          strcpy(the_name,"left_eye");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,lefteye_moveout);
          AU_eye_move_out(the_surface,the_region_list,
                     the_name,lefteye_moveout[C_VALUE]);
          lefteye_moveout[P_VALUE] = my_intensity;
          lefteye_moveout[C_VALUE] = 0.0;
        break;
        case MPA_162 :
          strcpy(the_name,"right_eye");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,righteye_moveout);
          AU_eye_move_out(the_surface,the_region_list,
                     the_name,righteye_moveout[C_VALUE]);
          righteye_moveout[P_VALUE] = my_intensity;
          righteye_moveout[C_VALUE] = 0.0;
        break;
        case MPA_163 :
          strcpy(the_name,"left_eye");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,lefteye_moveout);
          AU_eye_move_out(the_surface,the_region_list,
                     the_name,lefteye_moveout[C_VALUE]);
          lefteye_moveout[P_VALUE] = my_intensity;
          lefteye_moveout[C_VALUE] = 0.0;

          strcpy(the_name,"right_eye");
          righteye_moveout[C_VALUE] = my_intensity - righteye_moveout[P_VALUE];
          AU_eye_move_out(the_surface,the_region_list,
                     the_name,righteye_moveout[C_VALUE]);
          righteye_moveout[P_VALUE] = my_intensity;
          righteye_moveout[C_VALUE] = 0.0;
        break;

        case MPA_171 :
          strcpy(the_name,"left_pupil");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,eye_dilate_l_pupil);
          AU_eye_dilate_pupil(the_surface,the_region_list,
                     the_name,eye_dilate_l_pupil[C_VALUE]);
          eye_dilate_l_pupil[P_VALUE] = my_intensity;
          eye_dilate_l_pupil[C_VALUE] = 0.0;
        break;
        case MPA_172 :
          strcpy(the_name,"right_pupil");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,eye_dilate_r_pupil);
          AU_eye_dilate_pupil(the_surface,the_region_list,
                     the_name,eye_dilate_r_pupil[C_VALUE]);
          eye_dilate_r_pupil[P_VALUE] = my_intensity;
          eye_dilate_r_pupil[C_VALUE] = 0.0;
        break;
        case MPA_173 :
          strcpy(the_name,"left_pupil");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,eye_dilate_l_pupil);
          AU_eye_dilate_pupil(the_surface,the_region_list,
                     the_name,eye_dilate_l_pupil[C_VALUE]);
          eye_dilate_l_pupil[P_VALUE] = my_intensity;
          eye_dilate_l_pupil[C_VALUE] = 0.0;

          strcpy(the_name,"right_pupil");
          eye_dilate_r_pupil[C_VALUE] = my_intensity - eye_dilate_r_pupil[P_VALUE];
          AU_eye_dilate_pupil(the_surface,the_region_list,
                     the_name,eye_dilate_r_pupil[C_VALUE]);
          eye_dilate_r_pupil[P_VALUE] = my_intensity;
          eye_dilate_r_pupil[C_VALUE] = 0.0;
        break;

        case MPA_201 :
          strcpy(the_name,"jaw");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,jaw_lower);
          AU_jaw_move_lower(the_surface,the_face,the_region_list,the_name,
                       jaw_lower[C_VALUE]);
          jaw_lower[P_VALUE] = my_intensity;
          jaw_lower[C_VALUE] = 0.0;
        break;
        case MPA_202 :
          strcpy(the_name,"jaw");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,jaw_hori);
          AU_jaw_move_hori(the_surface,the_face,the_region_list,the_name,
                       jaw_hori[C_VALUE]);
          jaw_hori[P_VALUE] = my_intensity;
          jaw_hori[C_VALUE] = 0.0;
        break;
        case MPA_203 :
          strcpy(the_name,"chin");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,chin_depress);
          AU_chin_depress(the_surface,the_face,the_region_list,the_name,
                       chin_depress[C_VALUE]);
          AU_lip_lower_depress(the_surface,the_face,the_region_list,
                       chin_depress[C_VALUE]);
          chin_depress[P_VALUE] = my_intensity;
          chin_depress[C_VALUE] = 0.0;
        break;
        case MPA_204 :
          strcpy(the_name,"jaw");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,jaw_thrust);
          AU_jaw_thrust(the_surface,the_face,the_region_list,the_name,
                       jaw_thrust[C_VALUE]);
          jaw_thrust[P_VALUE] = my_intensity;
          jaw_thrust[C_VALUE] = 0.0;
        break;
        case MPA_301 :
           strcpy(the_name,"left_zygo");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,leftcheek_zygo);
           AU_cheek_zygo(the_surface,the_face,the_region_list,
                     the_name,leftcheek_zygo[C_VALUE]);
           leftcheek_zygo[P_VALUE] = my_intensity;
           leftcheek_zygo[C_VALUE] = 0.0;
        break;
        case MPA_302 :
           strcpy(the_name,"right_zygo");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,rightcheek_zygo);
           AU_cheek_zygo(the_surface,the_face,the_region_list,
                     the_name,rightcheek_zygo[C_VALUE]);
           rightcheek_zygo[P_VALUE] = my_intensity;
           rightcheek_zygo[C_VALUE] = 0.0;
        break;
        case MPA_303 :
           strcpy(the_name,"left_zygo");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,leftcheek_zygo);
           AU_cheek_zygo(the_surface,the_face,the_region_list,
                     the_name,leftcheek_zygo[C_VALUE]);
           leftcheek_zygo[P_VALUE] = my_intensity;
           leftcheek_zygo[C_VALUE] = 0.0;

           strcpy(the_name,"right_zygo");
           rightcheek_zygo[C_VALUE] = my_intensity - rightcheek_zygo[P_VALUE];
           AU_cheek_zygo(the_surface,the_face,the_region_list,
                     the_name,rightcheek_zygo[C_VALUE]);
           rightcheek_zygo[P_VALUE] = my_intensity;
           rightcheek_zygo[C_VALUE] = 0.0;
        break;
        case MPA_311 :
           strcpy(the_name,"left_cheek");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,leftcheek_puffsqueeze);
           AU_cheek_puff_squeeze(the_surface,the_face,the_region_list,
                     the_name,leftcheek_puffsqueeze[C_VALUE]);
           leftcheek_puffsqueeze[P_VALUE] = my_intensity;
           leftcheek_puffsqueeze[C_VALUE] = 0.0;
        break;
        case MPA_312 :
           strcpy(the_name,"right_cheek");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,rightcheek_puffsqueeze);
           AU_cheek_puff_squeeze(the_surface,the_face,the_region_list,
                     the_name,rightcheek_puffsqueeze[C_VALUE]);
           rightcheek_puffsqueeze[P_VALUE] = my_intensity;
           rightcheek_puffsqueeze[C_VALUE] = 0.0;
        break;
        case MPA_313 :
           strcpy(the_name,"left_cheek");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,leftcheek_puffsqueeze);
           AU_cheek_puff_squeeze(the_surface,the_face,the_region_list,
                     the_name,leftcheek_puffsqueeze[C_VALUE]);
           leftcheek_puffsqueeze[P_VALUE] = my_intensity;
           leftcheek_puffsqueeze[C_VALUE] = 0.0;

           strcpy(the_name,"right_cheek");
           rightcheek_puffsqueeze[C_VALUE] = my_intensity - rightcheek_puffsqueeze[P_VALUE];
           AU_cheek_puff_squeeze(the_surface,the_face,the_region_list,
                     the_name,rightcheek_puffsqueeze[C_VALUE]);
            rightcheek_puffsqueeze[P_VALUE] = my_intensity;
           rightcheek_puffsqueeze[C_VALUE] = 0.0;
        break;
        case MPA_321 :
           strcpy(the_name,"left_cheek");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,leftcheek_lift);
           AU_cheek_lift(the_surface,the_face,the_region_list,
                     the_name,leftcheek_lift[C_VALUE]);
           leftcheek_lift[P_VALUE] = my_intensity;
           leftcheek_lift[C_VALUE] = 0.0;
        break;
        case MPA_322 :
           strcpy(the_name,"right_cheek");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,rightcheek_lift);
           AU_cheek_lift(the_surface,the_face,the_region_list,
                     the_name,rightcheek_lift[C_VALUE]);
           rightcheek_lift[P_VALUE] = my_intensity;
           rightcheek_lift[C_VALUE] = 0.0;
        break;
        case MPA_323 :
           strcpy(the_name,"left_cheek");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,leftcheek_lift);
           AU_cheek_lift(the_surface,the_face,the_region_list,
                     the_name,leftcheek_lift[C_VALUE]);
           leftcheek_lift[P_VALUE] = my_intensity;
           leftcheek_lift[C_VALUE] = 0.0;

           strcpy(the_name,"right_cheek");
           rightcheek_lift[C_VALUE] = my_intensity - rightcheek_lift[P_VALUE];
           AU_cheek_lift(the_surface,the_face,the_region_list,
                     the_name,rightcheek_lift[C_VALUE]);
           rightcheek_lift[P_VALUE] = my_intensity;
           rightcheek_lift[C_VALUE] = 0.0;
        break;

        case MPA_401 :
           strcpy(the_name,"upper_lip");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,uppermouth_lipraise);
           AU_lip_lower_raiser(the_surface,the_face,the_region_list,
                                   the_name,-uppermouth_lipraise[C_VALUE]);
           uppermouth_lipraise[P_VALUE] = my_intensity;
           uppermouth_lipraise[C_VALUE] = 0.0;
       break;
        case MPA_402 :
           strcpy(the_name,"lower_lip");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,lowermouth_lipraise);
           AU_lip_lower_raiser(the_surface,the_face,the_region_list,
                                   the_name,lowermouth_lipraise[C_VALUE]);
           lowermouth_lipraise[P_VALUE] = my_intensity;
           lowermouth_lipraise[C_VALUE] = 0.0;
        break;
        case MPA_403 :
           strcpy(the_name,"upper_lip");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,uppermouth_lipraise);
           AU_lip_lower_raiser(the_surface,the_face,the_region_list,
                                   the_name,-uppermouth_lipraise[C_VALUE]);
           uppermouth_lipraise[P_VALUE] = my_intensity;
           uppermouth_lipraise[C_VALUE] = 0.0;

           strcpy(the_name,"lower_lip");
           lowermouth_lipraise[C_VALUE] = my_intensity - lowermouth_lipraise[P_VALUE];
           AU_lip_lower_raiser(the_surface,the_face,the_region_list,
                                   the_name,lowermouth_lipraise[C_VALUE]);
           lowermouth_lipraise[P_VALUE] = my_intensity;
           lowermouth_lipraise[C_VALUE] = 0.0;
        break;
        case MPA_411 :
           strcpy(the_name,"upper_lip");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,uppermouth_lipriso);
           AU_mouth_risorius(the_surface,the_face,the_region_list,
                                   the_name,uppermouth_lipriso[C_VALUE]);
           uppermouth_lipriso[P_VALUE] = my_intensity;
           uppermouth_lipriso[C_VALUE] = 0.0;
        break;
        case MPA_412 :
           strcpy(the_name,"lower_lip");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,lowermouth_lipriso);
           AU_mouth_risorius(the_surface,the_face,the_region_list,
                                   the_name,lowermouth_lipriso[C_VALUE]);
           lowermouth_lipriso[P_VALUE] = my_intensity;
           lowermouth_lipriso[C_VALUE] = 0.0;
        break;
        case MPA_413 :
           strcpy(the_name,"upper_lip");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,uppermouth_lipriso);
           AU_mouth_risorius(the_surface,the_face,the_region_list,
                                   the_name,uppermouth_lipriso[C_VALUE]);
           uppermouth_lipriso[P_VALUE] = my_intensity;
           uppermouth_lipriso[C_VALUE] = 0.0;

           strcpy(the_name,"lower_lip");
           lowermouth_lipriso[C_VALUE] = my_intensity - lowermouth_lipriso[P_VALUE];
           AU_mouth_risorius(the_surface,the_face,the_region_list,
                                   the_name,lowermouth_lipriso[C_VALUE]);
           lowermouth_lipriso[P_VALUE] = my_intensity;
           lowermouth_lipriso[C_VALUE] = 0.0;
        break;
        case MPA_421 :
           strcpy(the_name,"mouth");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,mouth_beak);
           AU_mouth_beak(the_surface,the_face,the_region_list,
                               the_name,mouth_beak[C_VALUE]);
           mouth_beak[P_VALUE] = my_intensity;
           mouth_beak[C_VALUE] = 0.0;
        break;
        case MPA_431 :
           strcpy(the_name,"mouth");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,mouth_compexp);
           AU_mouth_comp_exp(the_surface,the_face,the_region_list,
                               the_name,0,mouth_compexp[C_VALUE]);
           mouth_compexp[P_VALUE] = my_intensity;
           mouth_compexp[C_VALUE] = 0.0;
	break;
        case MPA_4311 :
           strcpy(the_name,"mouth");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,mouth_left_compexp);
           AU_mouth_comp_exp(the_surface,the_face,the_region_list,
                               the_name,1,mouth_left_compexp[C_VALUE]);
           mouth_left_compexp[P_VALUE] = my_intensity;
           mouth_left_compexp[C_VALUE] = 0.0;
	break;
        case MPA_4312 :
           strcpy(the_name,"mouth");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,mouth_right_compexp);
           AU_mouth_comp_exp(the_surface,the_face,the_region_list,
                               the_name,2,mouth_right_compexp[C_VALUE]);
           mouth_right_compexp[P_VALUE] = my_intensity;
           mouth_right_compexp[C_VALUE] = 0.0;
	break;
        case MPA_441 :
           Face_adjusted_parameter_values_get(intensity,&my_intensity,mouth_suck);
           AU_lip_suck(the_surface,the_face,the_region_list, 
                       mouth_suck[C_VALUE]);
           mouth_suck[P_VALUE] = my_intensity;
           mouth_suck[C_VALUE] = 0.0;
        break;
        case MPA_451 :
           Face_adjusted_parameter_values_get(intensity,&my_intensity,mouth_squeeze);
           AU_mouth_squeeze_cornerlip(the_surface,the_face,the_region_list,0, 
                       mouth_squeeze[C_VALUE]);
           mouth_squeeze[P_VALUE] = my_intensity;
           mouth_squeeze[C_VALUE] = 0.0;
        break;
        case MPA_4511 :
           Face_adjusted_parameter_values_get(intensity,&my_intensity,mouth_squeeze_left);
           AU_mouth_squeeze_cornerlip(the_surface,the_face,the_region_list,1, 
                       mouth_squeeze_left[C_VALUE]);
           mouth_squeeze_left[P_VALUE] = my_intensity;
           mouth_squeeze_left[C_VALUE] = 0.0;
        break;
        case MPA_4512 :
           Face_adjusted_parameter_values_get(intensity,&my_intensity,mouth_squeeze_right);
           AU_mouth_squeeze_cornerlip(the_surface,the_face,the_region_list,2, 
                       mouth_squeeze_right[C_VALUE]);
           mouth_squeeze_right[P_VALUE] = my_intensity;
           mouth_squeeze_right[C_VALUE] = 0.0;
        break;
	
        case MPA_501 :
           strcpy(the_name,"nose");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,nose_compexp);
           AU_nose_comp_exp(the_surface,the_face,the_region_list,the_name,
                       nose_compexp[C_VALUE]);
           nose_compexp[P_VALUE] = my_intensity;
           nose_compexp[C_VALUE] = 0.0;
        break;
        case MPA_502 :
           strcpy(the_name,"nose");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,nose_l_compexp);
           AU_nose_l_comp_exp(the_surface,the_face,the_region_list,the_name,
                       nose_l_compexp[C_VALUE]);
           nose_l_compexp[P_VALUE] = my_intensity;
           nose_l_compexp[C_VALUE] = 0.0;
        break;
        case MPA_503 :
           strcpy(the_name,"nose");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,nose_r_compexp);
           AU_nose_r_comp_exp(the_surface,the_face,the_region_list,the_name,
                       nose_r_compexp[C_VALUE]);
           nose_r_compexp[P_VALUE] = my_intensity;
           nose_r_compexp[C_VALUE] = 0.0;
        break;
        case MPA_511 :
           strcpy(the_name,"nose");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,nose_raise);
           AU_nose_raise(the_surface,the_face,the_region_list,the_name,
                       nose_raise[C_VALUE]);
           nose_raise[P_VALUE] = my_intensity;
           nose_raise[C_VALUE] = 0.0;
        break;
        case MPA_521 :
           strcpy(the_name,"nose");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,nose_bend);
           AU_nose_bend(the_surface,the_face,the_region_list,the_name,
                       nose_bend[C_VALUE]);
           nose_bend[P_VALUE] = my_intensity;
           nose_bend[C_VALUE] = 0.0;
        break;
        case MPA_601 :
           strcpy(the_name,"head");
           Face_adjusted_parameter_values_get(intensity,&my_intensity, head_turn);
           AU_head_turn(the_surface,the_region_list,the_name,
                       head_turn[C_VALUE]);
           head_turn[P_VALUE] = my_intensity;
           head_turn[C_VALUE] = 0.0;
        break;
        case MPA_611 :
           strcpy(the_name,"head");
           Face_adjusted_parameter_values_get(intensity,&my_intensity, head_nod);
           AU_head_nod(the_surface,the_region_list,the_name,
                       head_nod[C_VALUE]);
           head_nod[P_VALUE] = my_intensity;
           head_nod[C_VALUE] = 0.0;
        break;
        case MPA_621 :
           strcpy(the_name,"head");
           Face_adjusted_parameter_values_get(intensity,&my_intensity, head_roll);
           AU_head_roll(the_surface,the_region_list,the_name,
                       head_roll[C_VALUE]);
           head_roll[P_VALUE] = my_intensity;
           head_roll[C_VALUE] = 0.0;
        break;

        case MPA_1441 :
          strcpy(the_name,"left_eyebrow");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,lefteye_browraise_l);
          AU_eye_brow_raise(the_surface,the_face,the_region_list,
                     the_name,1,lefteye_browraise_l[C_VALUE]);
          lefteye_browraise_l[P_VALUE] = my_intensity;
          lefteye_browraise_l[C_VALUE] = 0.0;
        break;
        case MPA_1442 :
          strcpy(the_name,"right_eyebrow");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,righteye_browraise_l);
          AU_eye_brow_raise(the_surface,the_face,the_region_list,
                     the_name,1,righteye_browraise_l[C_VALUE]);
          righteye_browraise_l[P_VALUE] = my_intensity;
          righteye_browraise_l[C_VALUE] = 0.0;
        break;
        case MPA_1443 :
          strcpy(the_name,"left_eyebrow");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,lefteye_browraise_l);
          AU_eye_brow_raise(the_surface,the_face,the_region_list,
                     the_name,1,lefteye_browraise_l[C_VALUE]);
          lefteye_browraise_l[P_VALUE] = my_intensity;
          lefteye_browraise_l[C_VALUE] = 0.0;

          strcpy(the_name,"right_eyebrow");
          righteye_browraise_l[C_VALUE] = my_intensity - righteye_browraise_l[P_VALUE];
          AU_eye_brow_raise(the_surface,the_face,the_region_list,
                     the_name,1,righteye_browraise_l[C_VALUE]);
          righteye_browraise_l[P_VALUE] = my_intensity;
          righteye_browraise_l[C_VALUE] = 0.0;
        break;
        case MPA_1451 :
          strcpy(the_name,"left_eyebrow");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,lefteye_browraise_m);
          AU_eye_brow_raise(the_surface,the_face,the_region_list,
                     the_name,2,lefteye_browraise_m[C_VALUE]);
          lefteye_browraise_m[P_VALUE] = my_intensity;
          lefteye_browraise_m[C_VALUE] = 0.0;
        break;
        case MPA_1452 :
          strcpy(the_name,"right_eyebrow");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,righteye_browraise_m);
          AU_eye_brow_raise(the_surface,the_face,the_region_list,
                     the_name,2,righteye_browraise_m[C_VALUE]);
          righteye_browraise_m[P_VALUE] = my_intensity;
          righteye_browraise_m[C_VALUE] = 0.0;
        break;
        case MPA_1453 :
          strcpy(the_name,"left_eyebrow");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,lefteye_browraise_m);
          AU_eye_brow_raise(the_surface,the_face,the_region_list,
                     the_name,2,lefteye_browraise_m[C_VALUE]);
          lefteye_browraise_m[P_VALUE] = my_intensity;
          lefteye_browraise_m[C_VALUE] = 0.0;

          strcpy(the_name,"right_eyebrow");
          righteye_browraise_m[C_VALUE] = my_intensity - righteye_browraise_m[P_VALUE];
          AU_eye_brow_raise(the_surface,the_face,the_region_list,
                     the_name,2,righteye_browraise_m[C_VALUE]);
          righteye_browraise_m[P_VALUE] = my_intensity;
          righteye_browraise_m[C_VALUE] = 0.0;
        break;
        case MPA_1461 :
          strcpy(the_name,"left_eyebrow");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,lefteye_browraise_r);
          AU_eye_brow_raise(the_surface,the_face,the_region_list,
                     the_name,3,lefteye_browraise_r[C_VALUE]);
          lefteye_browraise_r[P_VALUE] = my_intensity;
          lefteye_browraise_r[C_VALUE] = 0.0;
        break;
        case MPA_1462 :
          strcpy(the_name,"right_eyebrow");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,righteye_browraise_r);
          AU_eye_brow_raise(the_surface,the_face,the_region_list,
                     the_name,3,righteye_browraise_r[C_VALUE]);
          righteye_browraise_r[P_VALUE] = my_intensity;
          righteye_browraise_r[C_VALUE] = 0.0;
        break;
        case MPA_1463 :
          strcpy(the_name,"left_eyebrow");
          Face_adjusted_parameter_values_get(intensity,&my_intensity,lefteye_browraise_r);
          AU_eye_brow_raise(the_surface,the_face,the_region_list,
                     the_name,3,lefteye_browraise_r[C_VALUE]);
          lefteye_browraise_r[P_VALUE] = my_intensity;
          lefteye_browraise_r[C_VALUE] = 0.0;

          strcpy(the_name,"right_eyebrow");
          righteye_browraise_r[C_VALUE] = my_intensity - righteye_browraise_r[P_VALUE];
          AU_eye_brow_raise(the_surface,the_face,the_region_list,
                     the_name,3,righteye_browraise_r[C_VALUE]);
          righteye_browraise_r[P_VALUE] = my_intensity;
          righteye_browraise_r[C_VALUE] = 0.0;
        break;

        case MPA_331 :
           strcpy(the_name,"left_zygo");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,leftcheek_lower);
           AU_cheek_lower_cornerlip(the_surface,the_face,the_region_list,
                     the_name,leftcheek_lower[C_VALUE]);
           leftcheek_lower[P_VALUE] = my_intensity;
           leftcheek_lower[C_VALUE] = 0.0;
        break;
        case MPA_332 :
           strcpy(the_name,"right_zygo");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,rightcheek_lower);
           AU_cheek_lower_cornerlip(the_surface,the_face,the_region_list,
                     the_name,rightcheek_lower[C_VALUE]);
           rightcheek_lower[P_VALUE] = my_intensity;
           rightcheek_lower[C_VALUE] = 0.0;
        break;
        case MPA_333 :
           strcpy(the_name,"left_zygo");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,leftcheek_lower);
           AU_cheek_lower_cornerlip(the_surface,the_face,the_region_list,
                     the_name,leftcheek_lower[C_VALUE]);
           leftcheek_lower[P_VALUE] = my_intensity;
           leftcheek_lower[C_VALUE] = 0.0;

           strcpy(the_name,"right_zygo");
           rightcheek_lower[C_VALUE] = my_intensity - rightcheek_lower[P_VALUE];
           AU_cheek_lower_cornerlip(the_surface,the_face,the_region_list,
                     the_name,rightcheek_lower[C_VALUE]);
           rightcheek_lower[P_VALUE] = my_intensity;
           rightcheek_lower[C_VALUE] = 0.0;
        break;

        default :
        break;

        case MPA_701 :
           strcpy(the_name,"tongue");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,tongue_lift);
           AU_tongue_lift(the_surface,the_face,the_region_list,
                     the_name,tongue_lift[C_VALUE]);
           tongue_lift[P_VALUE] = my_intensity;
           tongue_lift[C_VALUE] = 0.0;
        break;
        case MPA_702 :
           strcpy(the_name,"tongue");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,tongue_pan);
           AU_tongue_pan(the_surface,the_face,the_region_list,
                     the_name,tongue_pan[C_VALUE]);
           tongue_pan[P_VALUE] = my_intensity;
           tongue_pan[C_VALUE] = 0.0;
        break;
        case MPA_703 :
           strcpy(the_name,"tongue");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,tongue_out);
           AU_tongue_out(the_surface,the_face,the_region_list,
                     the_name,tongue_out[C_VALUE]);
           tongue_out[P_VALUE] = my_intensity;
           tongue_out[C_VALUE] = 0.0;
        break;
        case MPA_704 :
           strcpy(the_name,"tongue");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,tongue_lift_tip);
           AU_tongue_lift_tip(the_surface,the_face,the_region_list,
                     the_name,tongue_lift_tip[C_VALUE]);
           tongue_lift_tip[P_VALUE] = my_intensity;
           tongue_lift_tip[C_VALUE] = 0.0;
        break;
        case MPA_705 :
           strcpy(the_name,"tongue");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,tongue_roll);
           AU_tongue_roll(the_surface,the_face,the_region_list,
                     the_name,tongue_roll[C_VALUE]);
           tongue_roll[P_VALUE] = my_intensity;
           tongue_roll[C_VALUE] = 0.0;
        break;

        case MPA_801 :
           strcpy(the_name,"left_ear");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,raise_l_ear);
           AU_raise_ear(the_surface,the_face,the_region_list,
                     the_name,raise_l_ear[C_VALUE]);
           raise_l_ear[P_VALUE] = my_intensity;
           raise_l_ear[C_VALUE] = 0.0;
        break;
        case MPA_802 :
           strcpy(the_name,"right_ear");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,raise_r_ear);
           AU_raise_ear(the_surface,the_face,the_region_list,
                     the_name,raise_r_ear[C_VALUE]);
           raise_r_ear[P_VALUE] = my_intensity;
           raise_r_ear[C_VALUE] = 0.0;
        break;
        case MPA_803 :
           strcpy(the_name,"left_ear");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,raise_l_ear);
           AU_raise_ear(the_surface,the_face,the_region_list,
                     the_name,raise_l_ear[C_VALUE]);
           raise_l_ear[P_VALUE] = my_intensity;
           raise_l_ear[C_VALUE] = 0.0;

           strcpy(the_name,"right_ear");
	   raise_r_ear[C_VALUE] = my_intensity - raise_r_ear[P_VALUE];
           AU_raise_ear(the_surface,the_face,the_region_list,
                     the_name,raise_r_ear[C_VALUE]);
           raise_r_ear[P_VALUE] = my_intensity;
           raise_r_ear[C_VALUE] = 0.0;
        break;

        case MPA_811 :
           strcpy(the_name,"left_ear");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,pull_l_ear);
           AU_pull_ear(the_surface,the_face,the_region_list,
                     the_name,pull_l_ear[C_VALUE]);
           pull_l_ear[P_VALUE] = my_intensity;
           pull_l_ear[C_VALUE] = 0.0;
        break;
        case MPA_812 :
           strcpy(the_name,"right_ear");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,pull_r_ear);
           AU_pull_ear(the_surface,the_face,the_region_list,
                     the_name,pull_r_ear[C_VALUE]);
           pull_r_ear[P_VALUE] = my_intensity;
           pull_r_ear[C_VALUE] = 0.0;
        break;
        case MPA_813 :
           strcpy(the_name,"left_ear");
           Face_adjusted_parameter_values_get(intensity,&my_intensity,pull_l_ear);
           AU_pull_ear(the_surface,the_face,the_region_list,
                     the_name,pull_l_ear[C_VALUE]);
           pull_l_ear[P_VALUE] = my_intensity;
           pull_l_ear[C_VALUE] = 0.0;

           strcpy(the_name,"right_ear");
	   pull_r_ear[C_VALUE] = my_intensity - pull_r_ear[P_VALUE];
           AU_pull_ear(the_surface,the_face,the_region_list,
                     the_name,pull_r_ear[C_VALUE]);
           pull_r_ear[P_VALUE] = my_intensity;
           pull_r_ear[C_VALUE] = 0.0;
        break;
       }
}
