// -*- c++ -*-

// This software module was originally developed by Igor Pandzic (MIRALab,
// University of Geneva) and Karl Anders ygard (Telenor R&D) in the course
// of development of the MPEG-4 Systems standard (ISO/IEC 14496-1).  This
// software module is an implementation of a part of one or more MPEG-4
// Systems tools as specified by the MPEG-4 Systems standard.  ISO/IEC
// gives users of the MPEG-4 Systems standard free license to this software
// module or modifications thereof for use in hardware or software products
// claiming conformance to the MPEG-4 Systems standard.  Those intending to
// use this software module in hardware or software products are advised
// that its use may infringe existing patents.  The original developer of
// this software module and his/her company, the subsequent editors and
// their companies, and ISO/IEC have no liability for use of this software
// module or modifications thereof in an implementation.  Copyright is not
// released for non MPEG-4 Systems conforming products.  The original
// developer retains full right to use the code for his/her own purpose,
// assign or donate the code to a third party and to inhibit third parties
// from using the code for non MPEG-4 Systems conforming products.  This
// copyright notice must be included in all copies or derivative works.
//
// For more information or to receive an up to date version of this module,
// mail karlo@nta.no or check <http://televr.fou.telenor.no/compositor/>.
//
// Copyright 1997, 1998.

#if !defined __FBACLASS_H__ // Sentry, use file only if it's not already included.
#define __FBACLASS_H__

#include "DecoderImp.h"
#include "Caps.h"

extern "C"
{
  #include "sim.h"
}

class FbaClass : public DecoderImp
{
	virtual MediaFormat SetFormat 
    (Capabilities * pPresentationCapabilities);
	virtual int GetOptimalInputSize () 
  { return 69; }
	virtual int GetOptimalOutputSize ();
	virtual int GetRecommendedInputBufferSize ()
  { return GetOptimalInputSize() * 8; }
	virtual int GetRecommendedOutputBufferSize () 
  { return GetOptimalOutputSize() * 8; }

  FOP_DATA moFopData;
  BOP_DATA moBopData;

public:
	FbaClass () : 
      DecoderImp () {};

  virtual BOOL Init();

  virtual void Run();

  virtual BOOL Decode(
		LPBYTE pucInput,
		int iInputLength,
		LPBYTE pucOutput,
		int & riOutputLength);

};

#endif  // __FBACLASS_H__
