/*************************************************************************

This software module developed by 

        Tolga K. Capin (capin@lig.di.epfl.ch), EPFL DI-LIG
	Joaquim Esmerado (jle@lig.di.epfl.ch), EPFL DI-LIG
        Kayvon Pirestani (kayvon@cs.cmu.edu),  EPFL DI-LIG

in the course of development of the MPEG-4 Video (ISO/IEC 14496-2). 
This software module is an implementation of a part of one or more MPEG-4 Video
tools as specified by the MPEG-4 Video. ISO/IEC gives users of the MPEG-4 Video
free license to this software module or modifications thereof for use in 
hardware or software products claiming conformance to the MPEG-4 Video. Those 
intending to use this software module in hardware or software products are advised 
that its use may infringe existing patents. The original developer of this software 
module and his/her company, the subsequent editors and their companies, and ISO/IEC 
have no liability for use of this software module or modifications thereof in an 
implementation. Copyright is not released for non MPEG-4 Video conforming 
products. EPFL-LIG retains full right to use the code for his/her own 
purpose, assign or donate the code to a third party and to inhibit third parties from 
using the code for non <MPEG standard> conforming products. This copyright notice 
must be included in all copies or derivative works. Copyright (c) 1997.
 
Module Name:    fba_object_plane.c

Abstract:       Code face/body animation frame

Update:         April-1997
                July-1997
                August-1997
                Nov-1997 

Remarks:        see RCS log at end of encode.c
*************************************************************************/

/* 
 *  $Id: common.h,v 1.1.1.1 2003/12/24 00:43:55 mikeseven Exp $
 * 
 *     Common functions header file
 */
#ifndef _common_h
#define _common_h

#include <stdlib.h>
#include <stdio.h>

#ifdef CPLUSPLUS
extern "C" {
#endif

#ifndef min
#define min(a, b)       ((a) < (b) ? (a) : (b))
#define max(a, b)       ((a) < (b) ? (b) : (a))
#endif // min

#define LOG_BUFSIZE  4096

/* 
 * Example parameter macro for log():
 *
 *     #define LP      1, 1, stdout, __FILE__
 *
 */

#define LOG_PARAMS bool_t DEBUG, bool_t USE_FNAME, FILE *output, char *fname

#define true 1
#define false 0

/*
typedef enum { true, false} bool_t;
*/
typedef int bool_t;

void err_exit(LOG_PARAMS, const char *format, ...);
void LOG(LOG_PARAMS, const char *format, ...);
void kscanf(char *string, const char *format, void *arg);

#ifdef CPLUSPLUS
}
#endif

#endif 
