//=============================================================================
//  This software module was originally developed by IBM Research (T.J. Watson)
//  in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1) 
//  standard. This software module is an implementation of a part of one or 
//  more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 
//  Systems (ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 
//  Systems (ISO/IEC 14496-1) free license to this software module or 
//  modifications thereof for use in hardware or software products claiming 
//  conformance to the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use
//  this software module in hardware or software products are advised that its
//  use may infringe existing patents. The original developer of this software 
//  module and his/her company, the subsequent editors and their companies, and
//  ISO/IEC have no liability for use of this software module or modifications 
//  thereof in an implementation. Copyright is not released for non MPEG-4 
//  Systems (ISO/IEC 14496-1) conforming products. IBM retain full right to use
//  the code for their own purpose, assign or donate the code to a third party 
//  and to inhibit third parties from using the code for non MPEG-4 Systems 
//  (ISO/IEC 14496-1) conforming products. This copyright notice must be 
//  included in all copies or derivative works. Copyright  1999-2000.
//=============================================================================
//  IBM  TJ Watson Research, USA
//-----------------------------------------------------------------------------
//  FLEXTIMEBASE.H
//
//  Contact   :
//    Dr. Michelle Kim ( mykim@us.ibm.com )
//
//  Overview  :
//    Declaration of FlexTimeBase
//
//=============================================================================  
#ifndef FLEXTIMEBASE_H__INCLUDED
#define FLEXTIMEBASE_H__INCLUDED


class FlexTimeMgr;
class TemporalGroupImpFlex;
class TemporalTransformImpFlex;

class FlexTimeBase
{
private:
  FlexTimeMgr *m_pftmManager;

public:
  FlexTimeBase() { m_pftmManager=NULL; }
  void SetFlexTimeMgr(FlexTimeMgr *pftm) { m_pftmManager=pftm; }
  virtual FlexTimeMgr *GetFlexTimeMgr() const 
  {
    assert(m_pftmManager);
    return m_pftmManager;
  }

  virtual bool IsClass(const char * /*pszClassName*/) const {return NULL; }
  virtual TemporalGroupImpFlex* GetTG() { return NULL; }
  virtual TemporalTransformImpFlex* GetTT() { return NULL; }
};
#endif // FLEXTIMEBASE_H__INCLUDED