//=============================================================================
//  This software module was originally developed by IBM Research (T.J. Watson)
//  in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1) 
//  standard. This software module is an implementation of a part of one or 
//  more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 
//  Systems (ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 
//  Systems (ISO/IEC 14496-1) free license to this software module or 
//  modifications thereof for use in hardware or software products claiming 
//  conformance to the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use
//  this software module in hardware or software products are advised that its
//  use may infringe existing patents. The original developer of this software 
//  module and his/her company, the subsequent editors and their companies, and
//  ISO/IEC have no liability for use of this software module or modifications 
//  thereof in an implementation. Copyright is not released for non MPEG-4 
//  Systems (ISO/IEC 14496-1) conforming products. IBM retain full right to use
//  the code for their own purpose, assign or donate the code to a third party 
//  and to inhibit third parties from using the code for non MPEG-4 Systems 
//  (ISO/IEC 14496-1) conforming products. This copyright notice must be 
//  included in all copies or derivative works. Copyright  1999-2000.
//=============================================================================
//  IBM  TJ Watson Research, USA
//-----------------------------------------------------------------------------
//  PRESENTERFLEX.H
//
//  Contact   :
//    Dr. Michelle Kim ( mykim@us.ibm.com )
//
//  Overview  :
//    Declaration of a FlexTime Presenter 
//    Players implementing FlexTime should derive their Presenter from this one
//    rather than directly from PresenterBase.
//
//=============================================================================  


#ifndef PRESENTERFLEX_H__INCLUDED
#define PRESENTERFLEX_H__INCLUDED

#include "../core/PresBase.h"

class Executive;

class PresenterFlex : public PresenterBase
{
public:
  PresenterFlex(Executive* pExecutive, HWND hWnd);
  virtual ~PresenterFlex();
 /* //PAB: this should be private and only part of the core/FlexTime, but to accomodate the  
	Render() implementation of CSELTPlayer (they have the loop redone in there...) 
	I make it protected and call it over there. 
	Actually We may want to provide the same kind of call in the renderer*/
protected: //PAB+:
	//JLF: returns true if scene state has changed
	bool PresenterDrivenEvents ();

private:	// ZL: Create FlexTimeMgrs here
	virtual FlexTimeMgr* CreateFlexTimeMgr ();
	virtual void DeleteFlexTimeMgr (FlexTimeMgr *pFlexTimeMgr);
	
private:
  int m_iCycleCount; 
};

#endif // PRESENTERFLEX_H__INCLUDED