//=============================================================================
//  This software module was originally developed by IBM Research (T.J. Watson)
//  in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1) 
//  standard. This software module is an implementation of a part of one or 
//  more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 
//  Systems (ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 
//  Systems (ISO/IEC 14496-1) free license to this software module or 
//  modifications thereof for use in hardware or software products claiming 
//  conformance to the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use
//  this software module in hardware or software products are advised that its
//  use may infringe existing patents. The original developer of this software 
//  module and his/her company, the subsequent editors and their companies, and
//  ISO/IEC have no liability for use of this software module or modifications 
//  thereof in an implementation. Copyright is not released for non MPEG-4 
//  Systems (ISO/IEC 14496-1) conforming products. IBM retain full right to use
//  the code for their own purpose, assign or donate the code to a third party 
//  and to inhibit third parties from using the code for non MPEG-4 Systems 
//  (ISO/IEC 14496-1) conforming products. This copyright notice must be 
//  included in all copies or derivative works. Copyright  1999-2000.
//=============================================================================
//  IBM  TJ Watson Research, USA
//-----------------------------------------------------------------------------
//  SPRING.CPP
//
//  Contact   :
//    Dr. Michelle Kim ( mykim@us.ibm.com )
//
//  Overview  :
//    Implementation of a variable-length arc (a Spring) of a TCN
//
//=============================================================================  

#include "Defs.h"
#include <assert.h>
#include "FlexTimeBase.h"
#include "../FlexTime/FlexTimeConnection.h"  
#include "Spring.h"



//-----------------------------------------------------------------------------
// I add the Id, in order to be able to use it for the TCN.
// I could also use the pointer instead ...
//-----------------------------------------------------------------------------
Spring::Spring()                  
{
	m_dFeasMin =        .0;
	m_dFeasMax =        .0;
	m_nStartVertexId =	NOT_CONNECTED;
	m_nEndVertexId =	NOT_CONNECTED;
}
/*
FlexTimeConnection *Spring::SetStartVertex(FlexTimeConnection *pVertex)
{
	return m_pStartVertex = pVertex;
}

FlexTimeConnection *Spring::SetEndVertex(FlexTimeConnection *pVertex)
{
	return m_pEndVertex = pVertex;
}
*/
/*
int Spring::GetStartVertexId()
{
	if (m_pStartVertex == NULL) return NOT_CONNECTED;
	return m_pStartVertex->GetId();
}

int Spring::GetEndVertexId()
{
	if (m_pEndVertex == NULL) return NOT_CONNECTED;
	return m_pEndVertex->GetId();
}
*/