//=============================================================================
//  This software module was originally developed by IBM Research (T.J. Watson)
//  in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1) 
//  standard. This software module is an implementation of a part of one or 
//  more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 
//  Systems (ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 
//  Systems (ISO/IEC 14496-1) free license to this software module or 
//  modifications thereof for use in hardware or software products claiming 
//  conformance to the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use
//  this software module in hardware or software products are advised that its
//  use may infringe existing patents. The original developer of this software 
//  module and his/her company, the subsequent editors and their companies, and
//  ISO/IEC have no liability for use of this software module or modifications 
//  thereof in an implementation. Copyright is not released for non MPEG-4 
//  Systems (ISO/IEC 14496-1) conforming products. IBM retain full right to use
//  the code for their own purpose, assign or donate the code to a third party 
//  and to inhibit third parties from using the code for non MPEG-4 Systems 
//  (ISO/IEC 14496-1) conforming products. This copyright notice must be 
//  included in all copies or derivative works. Copyright  1999-2000.
//=============================================================================
//  IBM  TJ Watson Research, USA
//-----------------------------------------------------------------------------
//  SPRING.H
//
//  Contact   :
//    Dr. Michelle Kim ( mykim@us.ibm.com )
//
//  Overview  :
//    Declaration of a variable-length arc (a Spring) of a TCN
//
//=============================================================================  


#ifndef SPRING_H__INCLUDED
#define SPRING_H__INCLUDED

class FlexTimeConnection;

class Spring 
{
private:
	double m_dFeasMin, m_dFeasMax;

protected:
	int m_nStartVertexId, m_nEndVertexId;

public:
	Spring();
  virtual ~Spring(){};

	virtual double GetFeasibleMin() {return m_dFeasMin;}
	virtual double GetFeasibleMax() {return m_dFeasMax;}
	virtual double SetFeasibleMin(double dFeasMin) { return m_dFeasMin = dFeasMin;}
	virtual double SetFeasibleMax(double dFeasMax) { return m_dFeasMax = dFeasMax;}

	virtual int GetStartVertexId() {return m_nStartVertexId;}
	virtual int GetEndVertexId() {return m_nEndVertexId;}
};
#define NOT_CONNECTED -1
#endif // SPRING_H__INCLUDED