/******************************************************************************
 * This software module was originally developed by Agfa Monotype Corporation
 * in the course of development of the ISO/IEC 14996-18 standard for reference 
 * purposes and its performance may not have been optimized. This software 
 * module is an implementation of font compression technology as specified 
 * by the ISO/IEC 14996-18 standard.
 * 
 * ISO/IEC gives users a free copyright license to this software module or
 * modifications thereof for use in products claiming conformance to 
 * ISO/IEC 14996-18 International Standard. ISO/IEC gives users the same free
 * license to this software module or modifications thereof for research 
 * purposes and further ISO/IEC standardization.
 * 
 * Those intending to use this software module in products are advised that
 * its use may infringe existing patents and that this license does not grant 
 * rights under any patents. ISO/IEC have no liability for use of this 
 * software module or modifications thereof.
 * 
 * No license is granted and copyright is not released for products that do 
 * not conform to ISO/IEC 14996-18 International Standard.
 * 
 * Agfa Monotype Corporation retains full right to modify and use the code for
 * its own purpose, assign or donate the code to a third party and to inhibit 
 * third parties from using the code for products that do not conform to
 * audiovisual and image-coding related ITU recommendations and 
 * ISO/IEC International Standards. All rights not expressly granted to the 
 * software module or modifications thereof are reserved by 
 * Agfa Monotype Corporation.
 * 
 * This copyright notice must be included in all copies or derivative works.
 * Copyright (c) ISO/IEC 2003. All rights reserved.
 ******************************************************************************/

/*
 * File:				CONFIG.H
 * Revision history
 * $Log: Config.h,v $
 * Revision 1.1  2004/02/10 22:01:09  vladlev
 * Initial version
 *
 */

/*** make SURE these typedefs/defines are right on your system ***/
typedef char CHAR;				/* signed 8 bit integer */
typedef unsigned char BYTE;		/* unsigned 8 bit integer */
typedef short SHORT;			/* signed 16 bit integer */
typedef unsigned short USHORT;	/* unsigned 16 bit integer */
typedef int LONG;				/* signed 32 bit integer */
typedef unsigned int ULONG;		/* unsigned 32 bit integer */

#define SIZEOF_LONG 4			/* in bytes ... sizeof(long) */
/*** make SURE these typedefs/defines are right on your system ***/

/* define for debugging tests and printing */
#undef DEBUG
//#define DEBUG


/* Define for a Mac (etc), undefine on a PC (etc) */
#undef BIG_ENDIAN

/* define to enable RA_DisplayMessage */
#define ENABLE_DISPLAY

/* the maximum length of a symbol ... must be <256
* values longer than 64 don't seem to help file size much 
* and add MUCH time to the compress phase
*/
#define MAX_SYMBOL_LENGTH 64


/*** SOME BOOK KEEPING STUFF ... DON'T CHANGE ANYTHING BELOW ***/
#define TABLE_BITS 10  /* how many bits to use in the table -- 10 seems about right */
#define NEXT_MASK   (1<<TABLE_BITS)-1
#define TABLE_SIZE (1<<TABLE_BITS)

#ifndef DEBUG
#undef assert
#define assert(test) NULL
#else
#include <assert.h>
#endif

#ifndef false
#define false 0
#endif

#ifndef true
#define true 1
#endif

