/******************************************************************************
 * This software module was originally developed by Agfa Monotype Corporation
 * in the course of development of the ISO/IEC 14996-18 standard for reference 
 * purposes and its performance may not have been optimized. This software 
 * module is an implementation of font compression technology as specified 
 * by the ISO/IEC 14996-18 standard.
 * 
 * ISO/IEC gives users a free copyright license to this software module or
 * modifications thereof for use in products claiming conformance to 
 * ISO/IEC 14996-18 International Standard. ISO/IEC gives users the same free
 * license to this software module or modifications thereof for research 
 * purposes and further ISO/IEC standardization.
 * 
 * Those intending to use this software module in products are advised that
 * its use may infringe existing patents and that this license does not grant 
 * rights under any patents. ISO/IEC have no liability for use of this 
 * software module or modifications thereof.
 * 
 * No license is granted and copyright is not released for products that do 
 * not conform to ISO/IEC 14996-18 International Standard.
 * 
 * Agfa Monotype Corporation retains full right to modify and use the code for
 * its own purpose, assign or donate the code to a third party and to inhibit 
 * third parties from using the code for products that do not conform to
 * audiovisual and image-coding related ITU recommendations and 
 * ISO/IEC International Standards. All rights not expressly granted to the 
 * software module or modifications thereof are reserved by 
 * Agfa Monotype Corporation.
 * 
 * This copyright notice must be included in all copies or derivative works.
 * Copyright (c) ISO/IEC 2003. All rights reserved.
 ******************************************************************************/

/*
 * File:						ERRCODES.H
 * Revision history
 * $Log: ERRCODES.H,v $
 * Revision 1.2  2004/03/01 22:31:55  vladlev
 * Added error code definitions
 *
 * Revision 1.1  2004/02/10 22:01:09  vladlev
 * Initial version
 *
 */
#define ERR_BITIO_end_of_file						 999
#define ERR_no_more_memory							1000
#define ERR_new_logical								1001
#define ERR_realloc_failed							1002
#define ERR_realloc_bad_pointer						1003
#define ERR_mem_dangling_pointers					1004
#define ERR_delete_bad_pointer						1005
#define ERR_mem_Create_Failed						1006
#define ERR_fopen									1007
#define ERR_fseek									1008
#define ERR_ftell									1009
#define ERR_fread									1010
#define ERR_fwrite									1011
#define ERR_fclose									1011
#define ERR_file_len_lessthan_0						1012
#define ERR_array_start_thrashed					1013
#define ERR_array_end_thrashed						1014
#define ERR_bad_version_number						1015
#define ERR_find_best_match_logical					1016
#define ERR_OutOfBoundsRead_In_InputFont			1017
#define ERR_hmtx_table_gone_or_to_short				1018
#define ERR_Convert_FONT_too_many_tables			1019
#define ERR_Convert_FONT_table_outside				1020
#define ERR_Convert_FONT_table_end_outside			1021
#define ERR_head_table_gone_or_to_short				1022
#define ERR_Convert_FONT_bad_magic					1023
#define ERR_Convert_FONT_unknown_glyphDataFormat	1024
#define ERR_fonts_are_different						1025
#define ERR_bad_magic_number						1026
#define ERR_hhea_table_gone_or_to_short				1027
#define ERR_maxp_table_gone_or_to_short				1028
#define ERR_loca_table_gone_or_to_short				1029
#define ERR_bad_token_code							1030






