/******************************************************************************
 * This software module was originally developed by Agfa Monotype Corporation
 * in the course of development of the ISO/IEC 14996-18 standard for reference 
 * purposes and its performance may not have been optimized. This software 
 * module is an implementation of font compression technology as specified 
 * by the ISO/IEC 14996-18 standard.
 * 
 * ISO/IEC gives users a free copyright license to this software module or
 * modifications thereof for use in products claiming conformance to 
 * ISO/IEC 14996-18 International Standard. ISO/IEC gives users the same free
 * license to this software module or modifications thereof for research 
 * purposes and further ISO/IEC standardization.
 * 
 * Those intending to use this software module in products are advised that
 * its use may infringe existing patents and that this license does not grant 
 * rights under any patents. ISO/IEC have no liability for use of this 
 * software module or modifications thereof.
 * 
 * No license is granted and copyright is not released for products that do 
 * not conform to ISO/IEC 14996-18 International Standard.
 * 
 * Agfa Monotype Corporation retains full right to modify and use the code for
 * its own purpose, assign or donate the code to a third party and to inhibit 
 * third parties from using the code for products that do not conform to
 * audiovisual and image-coding related ITU recommendations and 
 * ISO/IEC International Standards. All rights not expressly granted to the 
 * software module or modifications thereof are reserved by 
 * Agfa Monotype Corporation.
 * 
 * This copyright notice must be included in all copies or derivative works.
 * Copyright (c) ISO/IEC 2003. All rights reserved.
 ******************************************************************************/

/*
 * File:						canonical.h
 * Revision history
 * $Log: canonical.h,v $
 * Revision 1.1  2004/02/10 22:01:11  vladlev
 * Initial version
 *
 */
#ifndef __CANONICAL__
#define __CANONICAL__
typedef struct {
	LONG index;		/* the new token number */
	LONG num;		/* the original token number */
	BYTE *string;	/* pointer to the token data */
	LONG count;		/* number of occurances */
	LONG offset;	/* <0 for inferred offsets, >=0 for explicit offsets */
	ULONG code;		/* the huffman code (0's on entry is OK) */
	BYTE length;	/* length of the token data */
	BYTE bits;		/* bit length of the huffman code */
	SHORT pad;		/* to a 32 bit boundary */
	} TOKENS;

/* prototypes */
void make_canonical();
void assemble_tokens(MTX_RA_COMP *t);
void write_canonical_header(MTX_RA_COMP *t, BITIO *out, LONG n_tokens, TOKENS **list);
int EncodeData( MTX_RA_COMP *t, LONG byteCount, CHAR *bitStreamName);
int get_next_token(MTX_RA_DECOMP *r);

#endif /* __CANONICAL__ */