/******************************************************************************
 * This software module was originally developed by Agfa Monotype Corporation
 * in the course of development of the ISO/IEC 14996-18 standard for reference 
 * purposes and its performance may not have been optimized. This software 
 * module is an implementation of font compression technology as specified 
 * by the ISO/IEC 14996-18 standard.
 * 
 * ISO/IEC gives users a free copyright license to this software module or
 * modifications thereof for use in products claiming conformance to 
 * ISO/IEC 14996-18 International Standard. ISO/IEC gives users the same free
 * license to this software module or modifications thereof for research 
 * purposes and further ISO/IEC standardization.
 * 
 * Those intending to use this software module in products are advised that
 * its use may infringe existing patents and that this license does not grant 
 * rights under any patents. ISO/IEC have no liability for use of this 
 * software module or modifications thereof.
 * 
 * No license is granted and copyright is not released for products that do 
 * not conform to ISO/IEC 14996-18 International Standard.
 * 
 * Agfa Monotype Corporation retains full right to modify and use the code for
 * its own purpose, assign or donate the code to a third party and to inhibit 
 * third parties from using the code for products that do not conform to
 * audiovisual and image-coding related ITU recommendations and 
 * ISO/IEC International Standards. All rights not expressly granted to the 
 * software module or modifications thereof are reserved by 
 * Agfa Monotype Corporation.
 * 
 * This copyright notice must be included in all copies or derivative works.
 * Copyright (c) ISO/IEC 2003. All rights reserved.
 ******************************************************************************/

/*
 * File:					err.h
 * Revision history
 * $Log: err.h,v $
 * Revision 1.1  2004/03/04 21:10:45  vladlev
 * IType font engine API - Initial version
 *
 *
 */

#ifndef __ERR__
#define __ERR__

#ifndef jmp_buf
#include <setjmp.h>
#endif


/* no error */
#define SUCCESS						  0
#define NO_ERR						  0


/* file errors */
#define ERR_FILE_CREATE				101
#define ERR_FILE_OPEN				102
#define ERR_FILE_CLOSE				103
#define ERR_FILE_SEEK				104
#define ERR_FILE_TELL				105
#define ERR_FILE_READ				106
#define ERR_FILE_WRITE				107

/* memory errors */
#define ERR_MALLOC_FAIL				201
#define ERR_REALLOC_FAIL			202
#define ERR_FREE_FAIL				203
#define ERR_FREE_BAD_PTR			204
#define ERR_REALLOC_BAD_PTR			205
#define ERR_RESIZE_FAIL				206

/* SFNT/LFNT ERRORS */
#define ERR_FONT_NOT_FOUND			301
#define ERR_NO_CURRENT_SFNT			302
#define ERR_NO_CURRENT_LFNT			303
#define ERR_BAD_LFNT				304

/* TT errors */
#define ERR_CMAP_BAD_VERSION		401
#define ERR_CMAP_UNSUPPORTED		402
#define ERR_NOT_A_TTF				403
#define ERR_BAD_TTC_INDEX			404
#define ERR_TABLE_NOT_FOUND			405
#define ERR_BAD_GLYF_INDEX			406
#define ERR_BAD_GLYF_FORMAT			407
#define NULL_KEY_ERR				408
#define NULL_INPUT_PTR_ERR			409
#define NULL_MEMORY_BASES_ERR		410
#define VOID_FUNC_PTR_BASE_ERR		411
#define OUT_OFF_SEQUENCE_CALL_ERR	412
#define NULL_SFNT_DIR_ERR			413
#define NULL_OUTPUT_PTR_ERR			414
#define INVALID_GLYPH_INDEX			415
#define UNDEFINED_INSTRUCTION_ERR	416
#define TRASHED_MEM_ERR				417
#define POINTS_DATA_ERR				418
#define CONTOUR_DATA_ERR			419
#define BAD_MAGIC_ERR				420
#define OUT_OF_RANGE_SUBTABLE		421
#define UNKNOWN_COMPOSITE_VERSION	422
#define CLIENT_RETURNED_NULL		423
#define MISSING_SFNT_TABLE			424
#define UNKNOWN_CMAP_FORMAT			425
#define EBLC_VERSION				426
#define EBLC_NO_METRICS				427
#define EBLC_COMP_SIZE				428
#define ERR_INDEX_FORMAT			429
#define	ERR_ACT3_DISK				430		/* only support RAM/ROM this time */
#define	ERR_ACT3_UNDEF				431		/* go #define ACT3 ... */
#define ERR_STIK_UNDEF				432		/* go #define STIK ... */
#define ERR_CCC_UNDEF				433		/* go #define CCC  ... */

/* random errors */
#define ERR_NULL_STATE				501
#define ERR_SCALE_LIMIT				502
#define ERR_SCALE_DEGENERATE		503
#define ERR_HEAP_CORRUPT			504
#define ERR_NO_MATCHING				505
#define ERR_OBJECT_TYPE				506
#define ERR_BAD_RAC_FILE			507

#define ERR_CHAR_TYPE				601
#define ERR_BYTE_TYPE				602
#define ERR_SHORT_TYPE				603
#define ERR_USHORT_TYPE				604
#define ERR_LONG_TYPE				605
#define ERR_ULONG_TYPE				606
#define ERR_SIZEOF_LONG				607
#define ERR_BYTE_ORDER				608
#define ERR_INT_64					609
#define ERR_FONT_IN_USE				610
#define ERR_BAD_PHASE				611
#define ERR_BAD_EFFECT				612
#define ERR_BAD_PERCENT				613

#define NOT_DEFINED                         (SHORT)0xFFFF

#endif /* __ERR__ */
