/******************************************************************************
 * This software module was originally developed by Agfa Monotype Corporation
 * in the course of development of the ISO/IEC 14996-18 standard for reference 
 * purposes and its performance may not have been optimized. This software 
 * module is an implementation of font compression technology as specified 
 * by the ISO/IEC 14996-18 standard.
 * 
 * ISO/IEC gives users a free copyright license to this software module or
 * modifications thereof for use in products claiming conformance to 
 * ISO/IEC 14996-18 International Standard. ISO/IEC gives users the same free
 * license to this software module or modifications thereof for research 
 * purposes and further ISO/IEC standardization.
 * 
 * Those intending to use this software module in products are advised that
 * its use may infringe existing patents and that this license does not grant 
 * rights under any patents. ISO/IEC have no liability for use of this 
 * software module or modifications thereof.
 * 
 * No license is granted and copyright is not released for products that do 
 * not conform to ISO/IEC 14996-18 International Standard.
 * 
 * Agfa Monotype Corporation retains full right to modify and use the code for
 * its own purpose, assign or donate the code to a third party and to inhibit 
 * third parties from using the code for products that do not conform to
 * audiovisual and image-coding related ITU recommendations and 
 * ISO/IEC International Standards. All rights not expressly granted to the 
 * software module or modifications thereof are reserved by 
 * Agfa Monotype Corporation.
 * 
 * This copyright notice must be included in all copies or derivative works.
 * Copyright (c) ISO/IEC 2003. All rights reserved.
 ******************************************************************************/

/*
 * File:						ra_ttf_it.h
 * Revision history
 * $Log: ra_ttf_it.h,v $
 * Revision 1.1  2004/03/04 21:10:45  vladlev
 * IType font engine API - Initial version
 *
 *
 */

/*
 * converts between TTF and CTF formats
 */


#ifndef __RA_TTF__
#define __RA_TTF__

typedef struct {
	ULONG glyf_OffsetStart;		/* Offset to first byte. */
    ULONG glyf_OffsetEnd;		/* One past the last byte .*/
    SHORT headerLength;
    ULONG uncmpSize;
    ULONG cmpSize;
    MTX_TABLE_COMPRESS *tc;
	BYTE *cmpStart;               /* Compressed font start (after the header) */
    BYTE *cmpEnd;                 /* just past the last byte of compressed data */
	} MTX_RA_TT_Decomp;

/* prototypes */
MTX_RA_TT_Decomp *MTX_RA_TT_Create( _DS_ BYTE *compressedData);
int MTX_TT_Converter( BYTE *nameIn, BYTE *nameOut, int TT_TO_CT );
MTX_RA_TT_Decomp *MTX_RA_TT_ReadRom( _DS_ MTX_RA_TT_Decomp *t, BYTE* data );
ULONG MTX_RA_TT_getUncompressedFileSize(VOID * t);	
BYTE *MTX_RA_Get_TTF_FragmentPtr(_DS_ MTX_RA_TT_Decomp *t, ULONG position, ULONG *byteCountPtr );
VOID MTX_RA_ReleaseTTF_Fragment(_DS_ MTX_RA_TT_Decomp *t, VOID * data );
VOID MTX_RA_TT_Destroy(_DS_ MTX_RA_TT_Decomp *t);

#endif /* __RA_TTF__ */
