#ifndef __H263CLASS_H__
#define __H263CLASS_H__

#include "defs.h"

#include "DecoderImp.h"

#include "H263Decoder.h"
#include "bitio.h"

extern 
  void getpicture(
    bitiob& inbuf, 
    int *framenum, 
    unsigned char *frame[3], 
    H263Dec* dec);

class H263Class : public DecoderImp
{
private:
  int miHeight;
  int miWidth;

  BOOL mbInitialised;

  H263Dec * mpoDecoder;
  unsigned char * mapucFrame[3];
  unsigned char * mpucBuffer;
  bitiob * mpoInbuf;

#ifdef H263DUMP
  FILE * mpoFileDump;
#endif // H263DUMP

public:
  H263Class();
  ~H263Class();
// WIN-SOL release
  virtual bool Init();
  virtual void Run();
  virtual BOOL Decode(
    unsigned char * pucInput,
    int iInputLength,
    unsigned char * pucOutput,
    int & riOutputLength);
  virtual int GetOptimalOutputSize () 
  { return miHeight * miWidth * 3 + 4; }
  
  static void Yuv422ToRgb(
    unsigned char* rgbdata,
    unsigned char* yptr,
    unsigned char* uptr,
    unsigned char* vptr,
    int lumcols, int lumrows);
  static struct yuvconvtable {
    int u1;
    int u2;
    int v1;
    int v2;
  } convtab[256];
  static int cliptab[768];
};

#endif // ! __H263CLASS_H__
