/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(VDOnet Corp.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. VDOnet Corp. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1998.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Zvi Lifshitz at zvil@vdo.net or zvil@compuserve.com.
----------------------------------------------------------------------*/

#ifndef _DEC_LIB_H
#define _DEC_LIB_H

#include <windows.h>
#include <mmsystem.h>


////////////////////////////////////////////////////////////
//    D  e  f  i  n  e  s                                

////////////////////////////////////////////////////////////
// FOURCC types used by this dlls
#define FOURCC_H263             mmioFOURCC('H','2','6','3')
#define FOURCC_H261             mmioFOURCC('H','2','6','1')
#define FOURCC_VDOW             mmioFOURCC('V','D','O','W')
#define FOURCC_vdow             mmioFOURCC('v','d','o','w')
#define FOURCC_VDO3             mmioFOURCC('V','D','O','3')
#define FOURCC_vdo3             mmioFOURCC('v','d','o','3')
#define FOURCC_CYUV             mmioFOURCC('c','y','u','v')
#define fYVU9                   mmioFOURCC('Y','V','U','9')
#define fYV12                   mmioFOURCC('Y','V','1','2')
#define fYUY2                   mmioFOURCC('Y','U','Y','2')
#define fyuy2                   mmioFOURCC('y','u','y','2')
#define FOURCC_UYVY             mmioFOURCC('U','Y','V','Y')
#define fty2d                   mmioFOURCC('t','y','2','d')
#define fI420                   mmioFOURCC('I','4','2','0')
//BI_RGB from windows 


//////////////////////////////////////////////////////////////
// define of Errors
//
#define DECFRAME_OK_ERROR_MSG         0
#define DECFRAME_SKIP_ERROR_MSG       1
#define DECFRAME_DECODE_ERROR_MSG     2
#define DECFRAME_BADSIZE_ERROR_MSG    3
#define DECFRAME_HURRYUP_ERROR_MSG    4

typedef struct _TDecodeObject
{
	DWORD		    m_InputFourcc;
	DWORD			m_OutputFourcc;
	DecodeInst		m_DecodeInst;
	DWORD           m_DoLowRes;
	BOOL			m_HurryUp;
	unsigned char	*m_pCompressedData;
	unsigned char   *m_RGBLow;
}
TDecodeObject;


////////////DLL Functions
// MyCFuncs.h
#ifdef __cplusplus
extern "C" {  // only need to export C interface if
              // used by C++ source code
#endif

BOOL InitDecodedObject(BITMAPINFOHEADER  *lpbiSrc, 
	     			   BITMAPINFOHEADER  *lpbiDst,
				       TDecodeObject     *pDecodeObject);


////////////////////////////////////////////////////////////////////////////////////////////////////////////
//int DecodeFrame( BITMAPINFOHEADER  *lpbiSrc, pointer on input bitmap header
//				   BITMAPINFOHEADER  *lpbiDst, pointer on output bitmap header
//				   unsigned char     *lpDst,	 
//				   TDecodeObject     *pDecodeObject, pointer on DecodeObject 
//				   BOOL				bIsOrderToSkip,  Order to Skip Frame in case it's is B-FRAME 
//													 For H263 -ever FALSE
//				   BOOL				bIsOrderToFlip,  Flip in any case without checking output format 
//				   BOOL				bIsHurryUp,      Hurry UP is actual only for P-Frames they will only decoding
//													 without YUV2RBG transformation,
//				   char             LevelNum         //1 -for h263  )	
//
//
int DecodeFrame( BITMAPINFOHEADER  *lpbiSrc, 
				 BITMAPINFOHEADER  *lpbiDst,
				 unsigned char     *lpDst,
				 TDecodeObject     *pDecodeObject,
				 BOOL				bIsOrderToSkip,
				 BOOL				bIsOrderToFlip,
				 BOOL				bIsHurryUp    ,
				 char               LevelNum          );

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//void CloseDecodedObject(TDecodeObject     *pDecodeObject);
//
// THIS FUNCTION CLOSE INSTANCE AND FREE MEMORY 

void CloseDecodedObject(TDecodeObject     *pDecodeObject);

#ifdef __cplusplus
}
#endif

#endif