#include <stdio.h>
#include "cifsenc.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include "MPG_IfsQ_C.h"


unsigned char* CIFSEncoder::Encode(FILE* ptCurrent, int bitsPerColor, int bitsPerNormal,
				  int bitsPerCoord, int bitsPerTexCoord, int erMode, int packetSize, int boundaryPrediction)
{
	if(ptCurrent != NULL)
		pFile = ptCurrent;
	else {
		printf("error\n");
		exit(0);
	}

	int coordPrediction    =  2;
	int normalPrediction   =  0;
	int colorPrediction    =  1;
	int texCoordPrediction =  1;
	
	bool hierarchicalMode  = false;
	bool saveClsFile       = false;
	bool saveWrlLevels     = false;
	
	bool success=true;
	if(bitsPerCoord<1       || bitsPerCoord>31)      error("bitsPerCoord");
	if(bitsPerNormal<3      || bitsPerNormal>31)     error("bitsPerNormal");
	if(bitsPerColor<1       || bitsPerColor>31)      error("bitsPerColor");
	if(bitsPerTexCoord<1    || bitsPerTexCoord>31)   error("bitsPerTexCoord");
	
	if(coordPrediction<0    || coordPrediction>2)    error("coordPrediction");
	if(normalPrediction<0   || normalPrediction>2)   error("normalPrediction");
	if(colorPrediction<0    || colorPrediction>2)    error("colorPrediction");
	if(texCoordPrediction<0 || texCoordPrediction>2) error("texCoordPrediction");
	
	if(erMode < 0 || erMode >1) error("error resilience mode");  
	if(packetSize<0) error("Packet size");
	if(boundaryPrediction<0 || boundaryPrediction>1) error("boundary prediction"); 
	
	MPG_IfsQ_C ifs;
	success = ifs.read(pFile);
	if(!success) error("parsing input file");

	MPG_OutputStream ostrm;
	MPG_OutputStream t_ostrm;       
	success = ifs.compress(ostrm, t_ostrm,                           
						bitsPerCoord, coordPrediction,
						bitsPerNormal, normalPrediction,
						bitsPerColor, colorPrediction,
						bitsPerTexCoord, texCoordPrediction,
						erMode, packetSize, boundaryPrediction, 
						NULL, NULL, NULL);
	if(success==false) error("compressing");

	unsigned char* test = ostrm.GetBufferUChar();
			
	return test;
}

void CIFSEncoder::error(const char *msg)
{
  fprintf(stderr,"error : %s\n",(msg)?msg:"");
  exit(-1);
}



	