#if !defined(_cifsdec_h_)	// Sentry, use file only if it's not already included.
#define _cifsdec_h_

// SOWOO 20021210
//#include "MPG_IfsQ_E.h"
class MPG_IfsQ_E;
// SOWOO end

class CIFSDecoder { 
private:
	//MPG_IfsQ_E cifs;
	MPG_IfsQ_E& cifs;
	MPG_IfsQ_E* pCIFS;
	unsigned char* pbuf;

public:
	int    *pCoordIdx;
	float  *pCoord;
	int    *pColorIndex;
	float  *pColor;
	int    *pNormalIndex;
	float  *pNormal;
	int    *pTexCoordIndex;
	float  *pTexCoord;

public:
	CIFSDecoder();
	~CIFSDecoder();

	void PutBuffer(unsigned char* p) { pbuf = p;};
	unsigned char* Decode(int &m_nLastBytes, int &m_nLastBits, int &m_nlength, int tsize);
	bool Decode(char *urlname);
	bool DecodeWithBuffer(char* pBuffer, int nLength = -1);	// SOWOO 20021210
	void error(const char *msg);

	MPG_IfsQ_E* GetCIFS() { return pCIFS; } // SOWOO 20030108

	CIFSDecoder& operator = (const CIFSDecoder&) { }	// this will be implemented later

#if defined SAIT_CONFORMANCE_2003
	void setValues(unsigned char *pData);	// JHAHN 20030628
	void write(char* fileName, int ID = -1);
#endif SAIT_CONFORMANCE_2003

	bool	GetCcw();
	bool	GetConvex();
	float	GetCreaseAngle();
	bool	GetSolid();
	int		GetCoordIdx();
	int		GetCoord();
	bool	GetColorPerVertex();
	int		GetColorIndex();
	int		GetColor();
	bool	GetNormalPerVertex();
	int		GetNormalIndex();
	int		GetNormal();
	int		GetTexCoordIndex();
	int		GetTexCoord();

};

#endif
