//-------------------------------------------------------------------------
//  
//  Copyright (C) IBM Corporation, 1996, 1997, 1998, 1999
//  Licensed Materials, Program Property of IBM
//  
//  This software module is an implementation of a part of one or more
//  MPEG-4 tools as specified by the MPEG-4 standard (ISO/IEC 14492).
//  ISO/IEC gives users of the MPEG-4 standard free license to this
//  software module or modifications thereof for use in hardware or
//  software products claiming conformance to the MPEG-4 standard.  Those
//  intending to use this software module in hardware or software products
//  are advised that its use may infringe existing patents.  The original
//  developer of this software module and his/her company, the subsequent
//  editors and their companies, and ISO/IEC have no liability for use of
//  this software module or modifications thereof in an implementation.
//  Copyright is not released for non MPEG-4 conforming products.  IBM
//  Corp. retains full right to use the code for his/her own purpose,
//  assign or donate the code to a third party and to inhibit third
//  parties from using the code for non MPEG-4 conforming products.  This
//  copyright notice must be included in all copies or derivative works.
//  
//  AUTHORS:
//    Gabriel Taubin
//    Andre Gueziec
//    Claudio Silva
//    Ioana Martin
//  
//  IBM T. J. Watson Research Center
//  P.O.Box 704
//  Yorktown Heights, New York 10598
//  
//  BASED ON EARLIER IMPLEMENTATION OF
//  VRML COMPRESSED BINARY FORMAT PROPOSAL BY:
//    Gabriel Taubin
//    Bill Horn
//    Francis Lazarus
// 
//-------------------------------------------------------------------------

#ifndef _MPG_IfsQ_E_h_
#define _MPG_IfsQ_E_h_

#include "MPG_IfsQ.h"

class MPG_IfsQ_E : public MPG_IfsQ {

public:

	inline      ~MPG_IfsQ_E();
	inline       MPG_IfsQ_E();

	// functions to expand input stream

	bool  expand(MPG_InputStream& istrm, bool saveWrlLevels);
	
};

inline MPG_IfsQ_E::~MPG_IfsQ_E()
{}

inline MPG_IfsQ_E::MPG_IfsQ_E():MPG_IfsQ()
{}

#endif // _MPG_IfsQ_E_h_
