#if !defined(_cifsdecext_h_)	// Sentry, use file only if it's not already included.
#define _cifsdecext_h_

// SOWOO 20021210
class MPG_IfsQ_E_EXT;
// SOWOO end

class CIFSDecoderExt { 
private:
	MPG_IfsQ_E_EXT& cifs;
	MPG_IfsQ_E_EXT* pCIFS;
	unsigned char* pbuf;

public:
	int    *pCoordIdx;
	float  *pCoord;
	int    *pColorIndex;
	float  *pColor;
	int    *pNormalIndex;
	float  *pNormal;
	int    *pTexCoordIndex;
	float  *pTexCoord;

public:
	CIFSDecoderExt();
	~CIFSDecoderExt();

	void PutBuffer(unsigned char* p) { pbuf = p;};
	unsigned char* Decode(int &m_nLastBytes, int &m_nLastBits, int &m_nlength, int tsize);
	bool Decode(char *urlname);
	bool DecodeWithBuffer(char* pBuffer, int nLength = -1);	// SOWOO 20021210
	void error(const char *msg);

	MPG_IfsQ_E_EXT* GetCIFS() { return pCIFS; } // SOWOO 20030108

	CIFSDecoderExt& operator = (const CIFSDecoderExt&) { }	// this will be implemented later

#if defined _3DMCEXT_CONFORMANCE_
	void setValues(unsigned char *pData);	
	void write(char* fileName, int ID = -1);
#endif _3DMCEXT_CONFORMANCE_

	bool	GetCcw();
	bool	GetConvex();
	float	GetCreaseAngle();
	bool	GetSolid();
	int		GetCoordIdx();
	int		GetCoord();
	bool	GetColorPerVertex();
	int		GetColorIndex();
	int		GetColor();
	bool	GetNormalPerVertex();
	int		GetNormalIndex();
	int		GetNormal();
	int		GetTexCoordIndex();
	int		GetTexCoord();

};
#endif
