// P_MPG_State.h

#ifndef _p_mpg_state_h
#define _p_mpg_state_h

//#include "MPG_IfsQ_E.h"
#include "MPG_Loops.h"
#include "MPG_SPolygon.h"
#include "MPG_VGraph.h"

class P_MPG_State
{
public:
	P_MPG_State(int nTriangles = 0);
	void SetState(int nTriangles, 
		int nV0, int nV1, int nVcls0, int nVcls1,
		bool newMol, bool newMobl, bool newCC, bool newTri,
		int mol_id, int lastTriangle, int prev_marching_pattern, 
		int prev_polygon_edge, int triangulated, int nPE, int nF,
		int nC, int nCoord, int nNormal, int nColor, int nTexCoord,
		int iP, int iR, int iL, int iO, int iF, int iFp, int iC,
		int cRp, int cR, int cLp, int cL, int cO, int nVcc, int iRun);
	void GetState(int& nTriangles, 
		int& nV0, int& nV1, int& nVcls0, int& nVcls1,
		bool& newMol, bool& newMobl, bool& newCC, bool& newTri,
		int& mol_id, int& lastTriangle, int& prev_marching_pattern, 
		int& prev_polygon_edge, int& triangulated, int& nPE, int& nF,
		int& nC, int& nCoord, int& nNormal, int& nColor, int& nTexCoord,
		int& iP, int& iR, int& iL, int& iO, int& iF, int& iFp, int& iC,
		int& cRp, int& cR, int& cLp, int& cL, int& cO, int& nVcc, int& iRun);
	void SetNVertices(int nV0, int nV1, int nVcls0, int nVcls1);
	void GetNVertices(int& nV0, int& nV1, int& nVcls0, int& nVcls1);

private:
	int _nTriangles;
	int _nV0;		// number of vertices so far without current cc
	int _nV1;		// number of vertices so far with current cc
	int _nVcls0;		// number of vertices before clustering
	int _nVcls1;     // number of vertices after clustering

	bool _newMol;
	bool _newMobl;
	bool _newCC;
	bool _newTri;
	int  _mol_id;
	int  _lastTriangle;

	int  _prev_marching_pattern; 
	int  _prev_polygon_edge;
	int  _triangulated;

	int  _nPE; 
	int  _nF; 
	int  _nC;
	int  _nCoord; 
	int  _nNormal; 
	int  _nColor; 
	int  _nTexCoord;
	int  _iP; 
	int  _iR; 
	int  _iL; 
	int  _iO;
	int  _iF; 
	int  _iFp; 
	int  _iC; 
	int  _cRp; 
	int  _cR; 
	int  _cLp;
	int  _cL; 
	int  _cO;
	int  _nVcc;
	int _iRun;
};

#endif