// ProgressiveExpand.h : main header file for the PROGRESSIVEEXPAND application
//

#if !defined(AFX_PROGRESSIVEEXPAND_H__7B610A0A_E383_11D2_A3EB_006094EB1C5E__INCLUDED_)
#define AFX_PROGRESSIVEEXPAND_H__7B610A0A_E383_11D2_A3EB_006094EB1C5E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

#include "P_MPG_IfsQ_E.h"
#include "MPG_Stream.h"
#include "ANG_Arcball.h"

#include <GL/gl.h>

/////////////////////////////////////////////////////////////////////////////
// CProgressiveExpandApp:
// See ProgressiveExpand.cpp for the implementation of this class
//

class CProgressiveExpandApp : public CWinApp
{
public:
	int _timerON;

	CProgressiveExpandApp();
	void SetModelName(CString name);
	CString& GetModelName();
	int GetNTriangles();
	void DrawOpenGL();
	void FillInIfs(P_MPG_IfsQ_E* ifs);

	Arcball& GetArcball();
	void SetArcball(Arcball& ball);
	void SetRotAngle(float r);
	float GetRotAngle();
	void SetRotAxis(float x, float y, float z);
	float *GetRotAxis();

	void SetPolygonMode(GLenum pm);
	GLenum GetPolygonMode();

	inline P_MPG_IfsQ_E* GetIfs() { return _ifs; };
	inline MPG_InputStream* GetInputStream() { return _istrm; }

	inline void GetViewParams(float& width, float& height, 
		float& depth, float& cx, float& cy, 
		float& cz) { width = _width; height = _height; depth = _depth; 
		cx = _cx; cy = _cy; cz = _cz; }

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CProgressiveExpandApp)
	public:
	virtual BOOL InitInstance();
	virtual void ParseCommandLine(CCommandLineInfo& rCmdInfo);
	//}}AFX_VIRTUAL

// Implementation
	//{{AFX_MSG(CProgressiveExpandApp)
	afx_msg void OnAppAbout();
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	CString _modelName;
	int _nTriangles;
	float _width, _height, _depth;
	float _cx, _cy, _cz;

	P_MPG_IfsQ_E* _ifs;
	MPG_InputStream* _istrm;

	GLenum _polygonMode;

	Arcball _ball;
	float _rotAngle;
	float _rotAxis[3];
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PROGRESSIVEEXPAND_H__7B610A0A_E383_11D2_A3EB_006094EB1C5E__INCLUDED_)
