//-------------------------------------------------------------------------
// 
// Copyright (C) IBM Corporation & Samsung Electronics Co. LTD., 1996, 1997, 1998, 1999
// Licensed Materials, Program Property of IBM & Samsung.
// 
// This software module is an implementation of a part of one or more
// MPEG-4 tools as specified by the MPEG-4 standard (ISO/IEC 14496).
// ISO/IEC gives users of the MPEG-4 standard (ISO/IEC 14496) free
// license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4
// standard (ISO/IEC 14496).  Those intending to use this software module
// in hardware or software products are advised that its use may infringe
// existing patents.  The original developer of this software module and
// his/her company, the subsequent editors and their companies, and
// ISO/IEC have no liability for use of this software module or
// modifications thereof in an implementation.  Copyright is not released
// for non MPEG-4 standard (ISO/IEC 14496) conforming products.  IBM
// Corp. & Samsung Electronics Co. LTD retains full right to use the code 
// for his/her own purpose, assign or donate the code to a third party and
// to inhibit third parties from using the code for non MPEG-4 standard 
// (ISO/IEC 14496) conforming products. This copyright notice must be included
// in all copies or derivative works.
// 
//  AUTHORS:
//    Gabriel Taubin
//    Andre Gueziec
//    Claudio Silva
//    Ioana Martin
//  
//  IBM T. J. Watson Research Center
//  P.O.Box 704
//  Yorktown Heights, New York 10598
//  
//  BASED ON EARLIER IMPLEMENTATION OF
//  VRML COMPRESSED BINARY FORMAT PROPOSAL BY:
//    Gabriel Taubin
//    Bill Horn
//    Francis Lazarus
//
//  Functionality : Error Resilience
//
//  Sungjin Kim  (sunjin@sait.samsung.co.kr)
//  Mahn-Jin Han  (manjini@sait.samsung.co.kr)
//  Mun-Sup Song (mssong@sait.samsung.co.kr)  
//
//  Signal Processing Lab. Samsung A.I.T. 
//-------------------------------------------------------------------------

#ifndef _MPG_IfsQ_EXT_C_h_
#define _MPG_IfsQ_EXT_C_h_

#include "MPG_IfsQ_EXT.h"

class MPG_IfsQ_EXT_C : public MPG_IfsQ_EXT {

public:

  inline      ~MPG_IfsQ_EXT_C();
  inline       MPG_IfsQ_EXT_C();
// DMLAB (200606) - UPDATE
         bool  compress(MPG_OutputStream& ostrm,
			 MPG_OutputStream& t_ostrm,  
			 int bitsPerCoord       = 12, //10,
			 int coordPrediction    =  0,
			 int bitsPerNormal      = 13, //9,
			 int normalPrediction   =  0,
			 int bitsPerColor       =  5, //6,
			 int colorPrediction    =  0, 
			 int bitsPerTexCoord    =  9, //10,
			 int texCoordPrediction =  0,
			 int erMode = 0,               
			 int PacketSize = 180,         
			 int boundaryPrediction = 0,   
			 bool hierarchicalMode   = false,
			 bool saveClsFile        = false,
			 bool saveWrlLevels      = false,
			 int  img_flag = false,
			 int img_u = 0,
			 int img_v = 0,
			 bool vertex_order_flag   =  0,
			 bool face_order_flag     =  0,
			 bool face_order_per_CC_flag = 0,
			 bool vertex_order_per_CC_flag = 0
			 );
};
// ~DMLAB (200606)
inline MPG_IfsQ_EXT_C::~MPG_IfsQ_EXT_C()
{}

inline MPG_IfsQ_EXT_C::MPG_IfsQ_EXT_C():MPG_IfsQ_EXT()
{}

#endif // _MPG_IfsQ_EXT_C_h_
