/***********************************************************************
This software module was originally developed by Ioan Alexandru Salomie
(Vrije Universiteit Brussel VUB) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. VUB retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Ioan Alexandru Salomie at iasalomi@etro.vub.ac.be.
----------------------------------------------------------------------*/

#if !defined(AFX_AFX_H__02853C51_899E_4951_86F5_23ACBEA01F92__INCLUDED_)
#define AFX_AFX_H__02853C51_899E_4951_86F5_23ACBEA01F92__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DecoderImp.h"
#include "ODP.h"
#include "Nodes.h"

#include "../../OpenGL/AFX/AfxStreamProxy.h"

#define AFX_3DMC 0;
#define AFX_MG	 1;
#define AFX_WSS  2;
#define AFX_CI   3;
#define AFX_OI   4;
#define AFX_PI   5;
#define AFX_DIBR 6;
#define AFX_BBA  7;
// 2004-07-15, Shinjun {
#define AFX_PT   8;
// 2004-07-15, Shinjun }
//ory DMLAB 2007 01 07
#define AFX_3DMCEXT 9;
//~ory DMLAB
#define AFX_FP   10;
//INT KM 2007 12 03
#define AFX_FAMC 11;
//INT KM

class AFXTemplate
{
public:
  AFXTemplate() { m_pProxy = NULL; };

	virtual BOOL Setup (AFXExtDescriptor *pSpecificInfo) = 0;
	virtual BOOL Decode (LPBYTE pInput, int nInputLength, LPBYTE pOutput, int &rnOutputLength) = 0;
	virtual int GetOptimalOutputSize () = 0;
  virtual void SetRenderingObject(AfxStreamProxy *pProxy)
  {
    ASSERT(pProxy != NULL);
    m_pProxy = pProxy;
  }

  inline AfxStreamProxy* GetProxy() {	//PG
		return m_pProxy;
  }

//protected:
  AfxStreamProxy * m_pProxy;
};

class AFXDecoder : public DecoderImp
{
public:
	AFXDecoder();
	virtual ~AFXDecoder();

	AFXTemplate *GetDecoder() { return m_pDecoder; };

	// INT KM 2007 12 06
	inline void SetIFS(IndexedFaceSet * ifs){m_ifs = ifs;};
	void ConvertIFS ();
	// INT KM 2007 12 06


protected:
	virtual BOOL Setup (const BYTE * pSpecificInfo, int nSpecificInfoLength, int nESNumber);
	virtual bool Configure (const BYTE *specificInfo, int nInfoLength, AFXConfig &afxConfig);
	virtual BOOL SetFormat (Capabilities &formatOptions, DecoderParams &decoderParams);
	virtual int GetOptimalOutputSize ();
	virtual BOOL Decode (LPBYTE pInput, int nInputLength, LPBYTE pOutput, int &rnOutputLength);
	virtual int GetDataOffset  (const LPBYTE pFrame);
	virtual DWORD GetAttributes (ATTRIBUTE_CODE code, const LPBYTE pFrame);
	virtual void Terminate ();
  virtual void Finish() {}; // derived classes can do the clean-up here
	virtual void Run ();


private:
	FILE *m_fDump;
	AFXTemplate *m_pDecoder;
	int decoderType;
	// INT KM 2007 12 06
	IndexedFaceSet * m_ifs;
	// INT KM 2007 12 06
};

#endif // !defined(AFX_AFX_H__02853C51_899E_4951_86F5_23ACBEA01F92__INCLUDED_)
