/********************************************************************************/
/* This software module was developped by										*/

/*	   Marius Preda (MP), marius.preda@int-evry.fr,								*/
/*                        Institut National des Telecommunications, France		*/

/* in the course of development of the MPEG-4 standard (Part 16 AFX).			*/
/* This software module is an implementation of a part of one or				*/
/* more MPEG-4 tools as specified by the										*/
/* MPEG-4 standard. ISO/IEC gives users of the MPEG-4 standard					*/
/* free license to this software module or modifications thereof				*/
/* for use in hardware or software products claiming conformance				*/
/* to the MPEG-4 standard. Those intending to use this software					*/
/* module in hardware or software products are advised that its					*/
/* use may infringe existing patents. The original developer of					*/
/* this software module and his company, the subsequent							*/
/* editors and their companies, and ISO/IEC have no liability					*/
/* for use of this software module or modifications thereof in					*/
/* an implementation. Copyright is not released for non							*/
/* MPEG-4 standard conforming products. INT ARTEMIS								*/
/* retain full right to use the code for their own purposes,					*/
/* assign or donate the code to a third party and to inhibit					*/
/* third parties from using the code for non MPEG-4 standard					*/
/* conforming products. This copyright notice must be included					*/
/* in all copies or derivative works.    										*/
/* Copyright (c)2002 - 2005														*/
/********************************************************************************/

#ifndef _C_MORPH_HEADER_
#define _C_MORPH_HEADER_

#include<stdio.h>

class CMorphMask {
public:
	bool *isWeightChanged;
	inline Free(){
			free(isWeightChanged);
	}

};

class CMorphData{
public:
	int *Weights;
	inline Free(){
			free(Weights);
	}
};

class CMorph
{
public:

	int morphIdentifier;
	int NumberWeights;
	bool isInCurrentFrame;
	bool canBePredicted;
	CMorphMask morphMask;
	CMorphData morphData;

	int *morphDataExchange;// morphIdentifier, NumberWeights, isDCT, morphMask[0], morphData[0], ...
						   // morphMask[n], morphData[n],
	
	CMorphData *morphDCTData;

	CMorphData morphDataPreviousFrame;
	CMorphData morphDataIMax, morphDataIMin;
	CMorphData morphDataPMax, morphDataPMin;

	CMorphData Irange_max, Irange_min;
  	CMorphData range_max , range_min;

	CMorph *prec;
	CMorph *suiv;

// operations
	inline bool isWeightsChanged(){
		for (int i=0;i<NumberWeights;i++)
			if (morphMask.isWeightChanged[i])
				return true;
		return false;
	}

	CMorph(int bID);
	CMorph();
	~CMorph();

	void AllocMorph();
	void AllocMorph(int nw);
	void AllocMinMaxMorph();
	void AllocPrevMorph();
	void AllocDCTMorph();
	void FreeMorph();
	void FreeMinMaxMorph();
	void FreePrevMorph();
	void FreeDCTMorph();
	int GetSize();
	int GetSizeExchange();
	void LoadDataExchange();

};


CMorph *getnodindexi(int index,CMorph * &first,CMorph* &last);
CMorph *getnodIDi(int ID,CMorph* &first,CMorph* &last);

void innod(CMorph*p,CMorph* &first,CMorph* &last);
void outnod(CMorph * p,CMorph* &first,CMorph* &last);
void freeliste(CMorph* &first,CMorph* &last);
void affiche_liste(CMorph*first);



#endif
