/********************************************************************************/
/* This software module was developped by										*/

/*	   Marius Preda (MP), marius.preda@int-evry.fr,								*/
/*                        Institut National des Telecommunications, France		*/

/* in the course of development of the MPEG-4 standard (Part 16 AFX).			*/
/* This software module is an implementation of a part of one or				*/
/* more MPEG-4 tools as specified by the										*/
/* MPEG-4 standard. ISO/IEC gives users of the MPEG-4 standard					*/
/* free license to this software module or modifications thereof				*/
/* for use in hardware or software products claiming conformance				*/
/* to the MPEG-4 standard. Those intending to use this software					*/
/* module in hardware or software products are advised that its					*/
/* use may infringe existing patents. The original developer of					*/
/* this software module and his company, the subsequent							*/
/* editors and their companies, and ISO/IEC have no liability					*/
/* for use of this software module or modifications thereof in					*/
/* an implementation. Copyright is not released for non							*/
/* MPEG-4 standard conforming products. INT ARTEMIS								*/
/* retain full right to use the code for their own purposes,					*/
/* assign or donate the code to a third party and to inhibit					*/
/* third parties from using the code for non MPEG-4 standard					*/
/* conforming products. This copyright notice must be included					*/
/* in all copies or derivative works.    										*/
/* Copyright (c)2002 - 2005														*/
/********************************************************************************/
// BBADecoderShortVersionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BBADecoderShortVersion.h"
#include "BBADecoderShortVersionDlg.h"
#include "BBATypeDefs.h"
#include "BBADecoder.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBBADecoderShortVersionDlg dialog

CBBADecoderShortVersionDlg::CBBADecoderShortVersionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBBADecoderShortVersionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBBADecoderShortVersionDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBBADecoderShortVersionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBBADecoderShortVersionDlg)
	DDX_Control(pDX, IDC_PROGRESS1, m_progress);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBBADecoderShortVersionDlg, CDialog)
	//{{AFX_MSG_MAP(CBBADecoderShortVersionDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_LOAD_BBA_STREAM, OnLoadFbaStream)
	ON_BN_CLICKED(IDC_DECODE_SAVE_BBA, OnDecodeSaveFba)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBBADecoderShortVersionDlg message handlers

BOOL CBBADecoderShortVersionDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	m_progress.SetRange(1,100);
	m_progress.SetStep(1);

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBBADecoderShortVersionDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBBADecoderShortVersionDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBBADecoderShortVersionDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBBADecoderShortVersionDlg::OnLoadFbaStream() 
{
	// TODO: Add your control notification handler code here

	CFileDialog MyFileDialog(TRUE,NULL,NULL,OFN_HIDEREADONLY,"BBA streams (*.bbas)|*.bbas;*.bbas|All files (*.*)|*.*||",NULL);
	MyFileDialog.DoModal();
	m_fbaStreamName=MyFileDialog.GetFileName();
	CEdit *myedit=(CEdit *)GetDlgItem(IDC_EDIT_BBA_STREAM_NAME);
	myedit->SetSel(0,200,true);
	myedit->ReplaceSel(m_fbaStreamName,false);

}


void CBBADecoderShortVersionDlg::OnDecodeSaveFba() 
{
	// TODO: Add your control notification handler code here

	BBADecoder myDecoder;

	int i, n=0, n_bap=0, inb;
	  int sc;
	  unsigned int PTS=0;
	  FILE *infp, *bbafp;

	  myDecoder.init();

	  /* read whole stream from a file into the buffer */
	  infp = fopen(m_fbaStreamName.GetBuffer(255), "rb");
	  myDecoder.initStream(infp);
	  fclose(infp);

	  
	  bbafp = fopen(m_fbaStreamName+".bba", "w");
	

	  CEdit *myedit=(CEdit *)GetDlgItem(IDC_EDIT_BAP_FILE_NAME);
	  myedit->SetSel(0,200,true);
	  myedit->ReplaceSel(m_fbaStreamName+".bap",false);


	  myDecoder.initbits();
	  sc = myDecoder.getbits(32);

	  int fr=0;
	  if (sc!=BBA_OBJECT_START_CODE){
		  AfxMessageBox("start code not found");
		  return;
	  }
	  do {
		myDecoder.decode_bba_object_plane_header();
		myDecoder.decode_bba_object_plane_data();
		myDecoder.WriteDecodedData(bbafp);
		fr++;
		m_progress.StepIt();
	  }
	  while(myDecoder.nextbits_bytealigned()!=BBA_OBJECT_END_CODE);
	  m_progress.OffsetPos(100);

	fclose(bbafp);


}
