/********************************************************************************/
/* This software module was developped by										*/

/*	   Marius Preda (MP), marius.preda@int-evry.fr,								*/
/*                        Institut National des Telecommunications, France		*/

/* in the course of development of the MPEG-4 standard (Part 16 AFX).			*/
/* This software module is an implementation of a part of one or				*/
/* more MPEG-4 tools as specified by the										*/
/* MPEG-4 standard. ISO/IEC gives users of the MPEG-4 standard					*/
/* free license to this software module or modifications thereof				*/
/* for use in hardware or software products claiming conformance				*/
/* to the MPEG-4 standard. Those intending to use this software					*/
/* module in hardware or software products are advised that its					*/
/* use may infringe existing patents. The original developer of					*/
/* this software module and his company, the subsequent							*/
/* editors and their companies, and ISO/IEC have no liability					*/
/* for use of this software module or modifications thereof in					*/
/* an implementation. Copyright is not released for non							*/
/* MPEG-4 standard conforming products. INT ARTEMIS								*/
/* retain full right to use the code for their own purposes,					*/
/* assign or donate the code to a third party and to inhibit					*/
/* third parties from using the code for non MPEG-4 standard					*/
/* conforming products. This copyright notice must be included					*/
/* in all copies or derivative works.    										*/
/* Copyright (c)2002 - 2005														*/
/********************************************************************************/
// BBAEncoderShortVersionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BBAEncoderShortVersion.h"
#include "BBAEncoderShortVersionDlg.h"
#include "BBATypeDefs.h"
#include "BBAEncoder.h"
#include "BBAFileUtil.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();


// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBBAEncoderShortVersionDlg dialog

CBBAEncoderShortVersionDlg::CBBAEncoderShortVersionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBBAEncoderShortVersionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBBAEncoderShortVersionDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	dimBufferIN=0;
	gqs=1;
	p2qs=0;
	qs=gqs*2^p2qs;

}

void CBBAEncoderShortVersionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBBAEncoderShortVersionDlg)
	DDX_Control(pDX, IDC_PROGRESS1, m_progress);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBBAEncoderShortVersionDlg, CDialog)
	//{{AFX_MSG_MAP(CBBAEncoderShortVersionDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUT_LOAD_BAP, OnButLoadBap)
	ON_BN_CLICKED(IDC_BUTTON_ENCODE, OnButtonEncode)
	ON_BN_CLICKED(IDC_RADIO_DCT, OnRadioDct)
	ON_BN_CLICKED(IDC_RADIO_FRAME_BASED, OnRadioFrameBased)
	ON_EN_CHANGE(IDC_EDIT_QUANT_STEP, OnChangeEditQuantStep)
	ON_BN_CLICKED(IDC_BUTTON_SAVE, OnButtonSave)
	ON_EN_CHANGE(IDC_EDIT_QUANT_STEP_POW2, OnChangeEditQuantStepPow2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBBAEncoderShortVersionDlg message handlers

BOOL CBBAEncoderShortVersionDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	m_progress.SetRange(1,100);
	m_progress.SetStep(1);
	
	CSpinButtonCtrl *psp1=(CSpinButtonCtrl *) GetDlgItem (IDC_SPIN_QUANT_STEP);
	CEdit *ped1=(CEdit *) GetDlgItem (IDC_EDIT_QUANT_STEP);
	psp1->SetBuddy(ped1);
	ped1->SetWindowText(CString(gqs));

	CSpinButtonCtrl *psp2=(CSpinButtonCtrl *) GetDlgItem (IDC_SPIN_QUANT_STEP_POW2);
	CEdit *ped2=(CEdit *) GetDlgItem (IDC_EDIT_QUANT_STEP_POW2);
	psp2->SetBuddy(ped2);
	ped2->SetWindowText(CString(p2qs));

	CButton *pb=(CButton*)GetDlgItem(IDC_RADIO_FRAME_BASED);
	pb->SetCheck(1);
	myEncoder.coding_type=PREDICTIVE_CODING_TYPE;

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBBAEncoderShortVersionDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBBAEncoderShortVersionDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBBAEncoderShortVersionDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBBAEncoderShortVersionDlg::OnButLoadBap() 
{
	// TODO: Add your control notification handler code here
	CFileDialog MyFileDialog(TRUE,NULL,NULL,OFN_HIDEREADONLY,"BBA file (*.bba)|*.bba;*.bba|All files (*.*)|*.*||",NULL);
	MyFileDialog.DoModal();
	CString m_bapStreamName=MyFileDialog.GetFileName();
	if (m_bapStreamName!=""){
		CEdit *myedit=(CEdit *)GetDlgItem(IDC_EDIT_BAP_FILE);
		myedit->SetSel(0,200,true);
		myedit->ReplaceSel(m_bapStreamName,false);
		m_bapFile=fopen(m_bapStreamName.GetBuffer(200),"ra");
		fseek(m_bapFile,0L,SEEK_END);
		fileLenght=ftell(m_bapFile);
		rewind(m_bapFile);		
	}

}


int CBBAEncoderShortVersionDlg::LoadBufferIN(int nrOfFrames)
{
	int i;
	long position=ftell(m_bapFile);
	
	//if (position>=fileLenght) return 1;

	char *aline=(char*)malloc(LOG_BUFSIZE*sizeof(char));

	for (i=0;i<nrOfFrames;i++){
		fgets(aline,LOG_BUFSIZE,m_bapFile);
		while ((aline[0]=='#')||(aline[0]=='h')){
			position=ftell(m_bapFile);
			fgets(aline,LOG_BUFSIZE,m_bapFile);
		}
		//if(feof(m_bapFile)) return 1; // for mask
		//AfxMessageBox(aline);
		fgets(aline,LOG_BUFSIZE,m_bapFile);
		//if(feof(m_bapFile)) return 2; //  for data
		//AfxMessageBox(aline);
	}
	free (aline);
	long position2=ftell(m_bapFile);
	fseek(m_bapFile, position, SEEK_SET);
	long dim=position2-position;
	
	if (dimBufferIN!=0)
		free(bufferIN);

	dimBufferIN=dim;
	bufferIN=(unsigned char *)malloc(dimBufferIN*sizeof(unsigned char));
	if (bufferIN == NULL ) {
		AfxMessageBox("memory error");
		return 1;
	}
	
	for (i=0; i<dimBufferIN; i++)
		bufferIN[i]=getc(m_bapFile);

	fseek(m_bapFile, position2, SEEK_SET);
//	char test[50];
//	sprintf(test,"position2=%d,lg=%d",position2,fileLenght);
//	AfxMessageBox(test);
	if (position2+2*NUM_BAPS>=fileLenght) return 1;

	return 0;

}
/*
void CBBAEncoderShortVersionDlg::GetNextBufferIN(int nrOfFrames){
	
	int i;
	long position=ftell(m_bapFile);
	
	char *aline=(char*)malloc(LOG_BUFSIZE*sizeof(char));

	for (i=0;i<nrOfFrames;i++){
		fgets(aline,LOG_BUFSIZE,m_bapFile); // for mask
		fgets(aline,LOG_BUFSIZE,m_bapFile); //  for data
	}
	long position2=ftell(m_bapFile);
	
	fseek(m_bapFile, position, SEEK_SET);
	long dim=position2-position;
	if (dimBufferIN!=0)
		free(bufferIN);

	bufferIN=(unsigned char *)malloc(dim*sizeof(unsigned char));
	dimBufferIN=dim;
	for (i=0; i<dim; i++)
		bufferIN[i]=getc(m_bapFile);

	fseek(m_bapFile, position, SEEK_SET);

}		
*/
void CBBAEncoderShortVersionDlg::OnButtonEncode() 
{
	// TODO: Add your control notification handler code here
//	BOP_DATA bop_data;
//	BOP_DATA bop_data_next;
//	FOP_DATA fop_data;
	unsigned int PTS;
//FILE *bapfile;	

	//////////////////////////initialisation//////////////////////
	myEncoder.init();
	if (myEncoder.coding_type==DCT_CODING_TYPE) 
		myEncoder.DCTInit();
	else 
		if (myEncoder.coding_type==PREDICTIVE_CODING_TYPE)
			myEncoder.ArithmeticInit();
	
	myEncoder.PutBBAStartCode();

    //////////////////////////end initialisation//////////////////////
	bool endf=false;
	int i=0;
	char test[2000];
	myEncoder.bbah=ReadBBAurlHeader(m_bapFile);
	bool first=true;
	myEncoder.bbaop.is_intra=true; // always the first frame is intra
	while(!endf){//!feof(m_bapFile)){		
		if (1) // a real application shall dynamically update the IPP... sequence wrt data to encode
			myEncoder.bbaop.is_intra=true;
		else 
			myEncoder.bbaop.is_intra=false;
		i++;
		m_progress.StepIt();
		if (myEncoder.coding_type==PREDICTIVE_CODING_TYPE){
			if (LoadBufferIN(1)>0) endf=true;
				myEncoder.ReadAFrame(bufferIN);
				myEncoder.SetMinMax();
				myEncoder.AllocThePlane();
				myEncoder.LoadThePlane();
				myEncoder.ConfigureEncoder();
				myEncoder.encode_bba_object_plane_header();
				myEncoder.encode_bba_object_plane_data();
				myEncoder.UnLoadThePlane();
				myEncoder.FreeThePlane();
		}	
		else 
			if (myEncoder.coding_type==DCT_CODING_TYPE){
				// inside a segment the frames must have the same mask
				if (LoadBufferIN(SEG_LENGTH)>0) 
					endf=true;
				myEncoder.ReadASegment(bufferIN);
				myEncoder.AllocThePlaneSegment();
				myEncoder.LoadThePlaneSegment();
//				myEncoder.CheckIsIntraSegment();
				myEncoder.ConfigureEncoder();
				myEncoder.encode_bba_object_plane_header();
				myEncoder.encode_bba_object_plane_data();
				myEncoder.UnLoadThePlaneSegment();
				myEncoder.FreeThePlaneSegment();

//				bapfile=fopen("ccc.txt","a");
//				myEncoder.bap_write1Segment(0, bapfile);
//				fclose(bapfile);
			}
		else {
			AfxMessageBox("no encoding method selected");
			return;
		}
	}
	myEncoder.NextStartCode();
	myEncoder.PutBBAEndCode();
	m_progress.SetPos(100);


}

void CBBAEncoderShortVersionDlg::OnRadioDct() 
{
	// TODO: Add your control notification handler code here
	myEncoder.coding_type=DCT_CODING_TYPE;
}

void CBBAEncoderShortVersionDlg::OnRadioFrameBased() 
{
	// TODO: Add your control notification handler code here
		myEncoder.coding_type=PREDICTIVE_CODING_TYPE;

}

void CBBAEncoderShortVersionDlg::OnChangeEditQuantStep() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
int bba_pred_scale_tmp[32] = { 0,  1,   2,  3,   5,   7,   9,  11,  14,  17,  20,  23,  27,  31,  35,  39,
									43, 47, 52, 57,  62,  67,  72,  77,  82,  88,  94, 100, 106, 113, 120, 127};
int bba_DCT_scale_tmp[32] = { 0, 1, 2, 3, 5, 7, 8, 10, 12, 15, 18, 21, 25, 30, 35, 42, 
								50, 60, 72, 87, 105, 128, 156, 191, 234, 288, 355, 439, 543, 
								674, 836, 1023 };

	CEdit *pedit=(CEdit*)GetDlgItem(IDC_EDIT_QUANT_STEP);
	int q=myEncoder.bbaop.bba_quant;
	char test[10];
	pedit->GetLine(0,test,10);
	int a=atoi(test);
	if (a<1) a=1;
	if (a>31) a=31;
	pedit->SetSel(0,10,true);
	sprintf(test,"%d",a);
	pedit->ReplaceSel(test,false);

	myEncoder.bbaop.bba_quant=a;

	if (myEncoder.coding_type==PREDICTIVE_CODING_TYPE)
		sprintf(test,"%d",(int)pow(2,myEncoder.bbaop.pow2quant)*bba_pred_scale_tmp[myEncoder.bbaop.bba_quant]);
	else 
		sprintf(test,"%d",(int)pow(2,myEncoder.bbaop.pow2quant)*bba_DCT_scale_tmp[myEncoder.bbaop.bba_quant]);
	//AfxMessageBox(test);
	CEdit *pedita=(CEdit *) GetDlgItem(IDC_EDIT_QUANTIZ_ALL);
	pedita->SetWindowText(test);

	
	

}


void CBBAEncoderShortVersionDlg::OnButtonSave() 
{
	// TODO: Add your control notification handler code here
	CFileDialog MyFileDialog(FALSE,NULL,NULL,OFN_HIDEREADONLY,"BBA stream (*.bba)|*.bba;*.bba|All files (*.*)|*.*||",NULL);
	MyFileDialog.DoModal();
	CString m_fbaStreamName=MyFileDialog.GetFileName();
	if (m_fbaStreamName!=""){
		if (MyFileDialog.GetFileExt()!="bba") m_fbaStreamName+=_T(".bba");
		CEdit *myedit=(CEdit *)GetDlgItem(IDC_EDIT_SAVE_BBA);
		myedit->SetSel(0,200,true);
		myedit->ReplaceSel(m_fbaStreamName,false);
		myEncoder.saveInFile(m_fbaStreamName.GetBuffer(200));
	}
}

void CBBAEncoderShortVersionDlg::OnChangeEditQuantStepPow2() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
int bba_pred_scale_tmp[32] = { 0,  1,   2,  3,   5,   7,   9,  11,  14,  17,  20,  23,  27,  31,  35,  39,
									43, 47, 52, 57,  62,  67,  72,  77,  82,  88,  94, 100, 106, 113, 120, 127};
int bba_DCT_scale_tmp[32] = { 0, 1, 2, 3, 5, 7, 8, 10, 12, 15, 18, 21, 25, 30, 35, 42, 
								50, 60, 72, 87, 105, 128, 156, 191, 234, 288, 355, 439, 543, 
								674, 836, 1023 };

	CEdit *pedit=(CEdit *) GetDlgItem(IDC_EDIT_QUANT_STEP_POW2);

	char test[10];

	
	pedit->GetLine(0,test,10);
	int a=atoi(test);
	if (a<0) a=0;
	if (a>7) a=7;
	pedit->SetSel(0,10,true);
	sprintf(test,"%d",a);
	pedit->ReplaceSel(test,false);
	p2qs=a;

	myEncoder.bbaop.pow2quant=p2qs;

	if (myEncoder.coding_type==PREDICTIVE_CODING_TYPE)
		sprintf(test,"%d",(int)pow(2,myEncoder.bbaop.pow2quant)*bba_pred_scale_tmp[myEncoder.bbaop.bba_quant]);
	else 
		sprintf(test,"%d",(int)pow(2,myEncoder.bbaop.pow2quant)*bba_DCT_scale_tmp[myEncoder.bbaop.bba_quant]);

	CEdit *pedita=(CEdit *) GetDlgItem(IDC_EDIT_QUANTIZ_ALL);
	pedita->SetWindowText(test);

}


