/********************************************************************************/
/* This software module was developped by										*/

/*	   Marius Preda (MP), marius.preda@int-evry.fr,								*/
/*                        Institut National des Telecommunications, France		*/

/* in the course of development of the MPEG-4 standard (Part 16 AFX).			*/
/* This software module is an implementation of a part of one or				*/
/* more MPEG-4 tools as specified by the										*/
/* MPEG-4 standard. ISO/IEC gives users of the MPEG-4 standard					*/
/* free license to this software module or modifications thereof				*/
/* for use in hardware or software products claiming conformance				*/
/* to the MPEG-4 standard. Those intending to use this software					*/
/* module in hardware or software products are advised that its					*/
/* use may infringe existing patents. The original developer of					*/
/* this software module and his company, the subsequent							*/
/* editors and their companies, and ISO/IEC have no liability					*/
/* for use of this software module or modifications thereof in					*/
/* an implementation. Copyright is not released for non							*/
/* MPEG-4 standard conforming products. INT ARTEMIS								*/
/* retain full right to use the code for their own purposes,					*/
/* assign or donate the code to a third party and to inhibit					*/
/* third parties from using the code for non MPEG-4 standard					*/
/* conforming products. This copyright notice must be included					*/
/* in all copies or derivative works.    										*/
/* Copyright (c)2002 - 2005														*/
/********************************************************************************/


/******************************************************************************
@doc

@module FileUtil.cpp -  Skin and Bones nodes|




Todo :

******************************************************************************/
#include "stdafx.h"
#include "BBAFileUtil.h" 
#include <iostream.h> 


void TestforTrash(FILE *fp)
{
  char  trash[BUFFER_SIZE];
  
  while(ungetc(getc(fp),fp) == '#') 
    fgets(trash,BUFFER_SIZE,fp);
  
}

int PassToNumber(FILE *fp) 
{
  int c;
  while(c = getc(fp), !((isdigit(c)) || (c==EOF) || (c=='-')) );
  return ungetc(c,fp);
}


int PassToNumberOrPar(FILE *fp) 
{
  int c;
  while(c = getc(fp), !((isdigit(c)) || (c==EOF) || (c=='-') || (c==']')));
  fseek(fp,-1,SEEK_CUR);
  if (c==']') return 1;
  else return 0;
}

int GetInt(FILE *fp)
{
  int get;
  PassToNumber(fp);
  fscanf(fp,"%d", &get);
  return get;
}


float GetFloat(FILE *fp)
{
  float get;
  PassToNumber(fp);
  fscanf(fp,"%f", &get);
  return get;
}

BBAheader ReadBBAurlHeader(FILE *myanimationfile){
	
	// myanimationfile already open
	
	BBAheader myh;

	myh.version=GetFloat(myanimationfile);
	myh.framerate=GetFloat(myanimationfile);


	char *buffer=new char[BBA_FILE_MAX_LINE];
	fgets(buffer,BBA_FILE_MAX_LINE,myanimationfile); // 
	delete buffer;

	return myh;
}
