/********************************************************************************/
/* This software module was developped by										*/

/*	   Marius Preda (MP), marius.preda@int-evry.fr,								*/
/*                        Institut National des Telecommunications, France		*/

/* in the course of development of the MPEG-4 standard (Part 16 AFX).			*/
/* This software module is an implementation of a part of one or				*/
/* more MPEG-4 tools as specified by the										*/
/* MPEG-4 standard. ISO/IEC gives users of the MPEG-4 standard					*/
/* free license to this software module or modifications thereof				*/
/* for use in hardware or software products claiming conformance				*/
/* to the MPEG-4 standard. Those intending to use this software					*/
/* module in hardware or software products are advised that its					*/
/* use may infringe existing patents. The original developer of					*/
/* this software module and his company, the subsequent							*/
/* editors and their companies, and ISO/IEC have no liability					*/
/* for use of this software module or modifications thereof in					*/
/* an implementation. Copyright is not released for non							*/
/* MPEG-4 standard conforming products. INT ARTEMIS								*/
/* retain full right to use the code for their own purposes,					*/
/* assign or donate the code to a third party and to inhibit					*/
/* third parties from using the code for non MPEG-4 standard					*/
/* conforming products. This copyright notice must be included					*/
/* in all copies or derivative works.    										*/
/* Copyright (c)2002 - 2005														*/
/********************************************************************************/

#ifndef __BBATYPEDEFS_H_
#define __BBATYPEDEFS_H_

#include <stdio.h>
#include <stdlib.h>
#include "CMuscle.h"
#include "CBone.h"
#include "CMorph.h"

#ifndef PI
#define PI 3.1415926
#endif

#define MARKER_BIT 1

#ifndef min
#define min(a, b)       ((a) < (b) ? (a) : (b))
#define max(a, b)       ((a) < (b) ? (b) : (a))
#endif 

#define LOG_BUFSIZE  4096
#define MAX_BITS_PER_FRAME	4096

//#define LOG_PARAMS bool_t DEBUG, bool_t USE_FNAME, FILE *output, char *fname
#define MY_DEBUG 0
#define MY_DEBUG_S 1

typedef int bool_t;


#define FDP_ID	0
#define	FAP_ID	1
#define BAP_ID	2
#define BDP_ID	3

#define NFAP	68
#define N_FAP_GROUP  10

#define RANGE_DELTA	60

#define FAP_PARAMSET_MASK       1
#define BAP_PARAMSET_MASK       2
#define FAP_BAP_PARAMSET_MASK	3

#define BBA_OBJECT_START_CODE			490 //257
#define BBA_OBJECT_PLANE_START_CODE     492 //259
#define BBA_OBJECT_END_CODE				491 //258

#define PREDICTIVE_CODING_TYPE          0 
#define DCT_CODING_TYPE                   1 

#define MAX_BAPS          30        /* Max no of BAPs that belong to any group */
#define BAP_NUM_GROUPS    24        /* Total no of BAP groups */
#define NUM_BAPS          296       /* Total no of BAPs */

#define SEG_LENGTH        16

#define MAX_NUM_EXTENDABLE_BAPS 256  /* 2^8 */
#define   q1    16384
#define   q2    32768
#define   q3    49152
#define   top   65535
#define SHORT_MIN	-32767
#define SHORT_MAX	32767


#define DEF_FRAME_RATE	30.0
#define DEBUG_BBA 0
#define ZEROMAX		22
#define	Max_frequency	16383
#define sign(x) 	((x) < 0 ? -1 : 1)
#define MAXINT 0x7FFFFFFF /*value to indicate interpolate fap*/
/*
typedef struct {
  unsigned char fap_mask[NFAP];
  int viseme_1, viseme_2, viseme_blend, viseme_def;
  int expression_1, expression_1_intensity;
  int expression_2, expression_2_intensity;
  int init_face, expression_def;
  int fap[NFAP];
} FOP_DATA;
*/

/*
typedef struct {
	bool *isControlPointOnXChanged, *isControlPointOnYChanged, *isControlPointOnZChanged;
	bool *isWheighOfControlPointChanged;
	bool *isKnotChanged;
}MuscleMaskType;
typedef struct {
	int *ControlPointOnX, *ControlPointOnY, *ControlPointOnZ;
	int *WheighOfControlPoint;
	int *Knot;
}MuscleDataType;
*/
/*
typedef struct {
  unsigned char bap_mask[NUM_BAPS];
  int bap[NUM_BAPS];
} BOP_DATA;
*/
/*
typedef struct 
{
  FOP_DATA *fop_data;
  bool_t is_time_code;
  int frame_rate, seconds, frequency_offset;
  int time_code_hours, time_code_minutes, marker_bit, time_code_seconds;
  int number_of_frames_to_skip;
  int fap_quant;
  int is_i_new_max, is_i_new_min, is_p_new_max, is_p_new_min;
  int fap_mask[NFAP];
  int fap_mask_type[N_FAP_GROUP];
  int fap_orig[NFAP], fap_Q[NFAP], fap_prev[NFAP], fap_diff[NFAP];
  int ve_orig[7], ve_prev[7], ve_diff[7];
  int viseme_blend_Q, expression_intensity1_Q, expression_intensity2_Q;
  int mask_index[11];
  int QP[NFAP];
  int IQP[NFAP];
  int Idefault_min[NFAP],Idefault_max[NFAP];
  int default_min[NFAP],default_max[NFAP];
  int  Irange_ve_max[7], Irange_ve_min[7];
  int  range_ve_max[7], range_ve_min[7];
  int *Ifreq_ve[7], *Icumul_ve[7];
  int *freq_ve[7], *cumul_ve[7];
  int  Irange_max[NFAP], Irange_min[NFAP];
  int  range_max[NFAP], range_min[NFAP];
  int *freq[NFAP], *cumul_freq[NFAP];
  int *Ifreq[NFAP], *Icumul_freq[NFAP];
  int suggested_gender;
  int coding_type;
  float *dctQP;
  float ** faps;
  int **visemes;
  int **expressions;
  float *dcPred;
  int **dc_table;
  int **ac_table;
  int **runlength_table;
  int **v_sel_table;
  int **v_blend_table;
  int **e_sel_table;
  int **e_intensity_table;
  int dc_table_size;
  int ac_table_size;
  int runlength_table_size;
  int v_sel_table_size;
  int v_blend_table_size;
  int e_sel_table_size;
  int e_intensity_table_size;
  float **idctMatrix;
} face_object_t;
*/
/*
typedef struct 
{
	int BoneIdentifier;
	BoneMaskType boneMask;
	BoneDataType boneData;

	BoneDataType boneDataIMax, boneDataIMin;
  	BoneDataType boneDataPMax ,boneDataPMin;

	inline PrintTheMask(){
		char test[200];
		sprintf(test, "%d %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d", 
						BoneIdentifier,
						boneMask.isTonXChanged, boneMask.isTonYChanged, boneMask.isTonZChanged,
						boneMask.isRonAx1Changed, boneMask.isRonAx2Changed, boneMask.isRonAx3Changed,
						boneMask.isSonXChanged, boneMask.isSonYChanged, boneMask.isSonZChanged,
						boneMask.isSOonAxXChanged,boneMask.isSOonAxYChanged,boneMask.isSOonAxZChanged, boneMask.isSOonValChanged,
						boneMask.isConXChanged, boneMask.isConYChanged, boneMask.isConZChanged);
		AfxMessageBox(test);
	}
	inline PrintTheData(){
		char test[200];
		sprintf(test, "%d, %d, %d,%d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d", 
						boneData.TonX, boneData.TonY, boneData.TonZ,
						boneData.RonAx1, boneData.RonAx2, boneData.RonAx3,
						boneData.SonX, boneData.SonY, boneData.SonZ,
						boneData.SOonAxX,boneData.SOonAxY,boneData.SOonAxZ, boneData.SOonVal,
						boneData.ConX, boneData.ConY, boneData.ConZ);
		AfxMessageBox(test);
	}

//	BoneDataType *Ifreq , *Icumul_freq;
//	BoneDataType *freq, *cumul_freq;

//	int BQP[NUM_BAPS];
//	int IBQP[NUM_BAPS];


//  int suggested_gender;
  /* DCT part */
	/*
  float *dctQP;
  float ** baps;
  float *dcPred;
  int **dc_table;
  int **ac_table;
  int **runlength_table;
  int dc_table_size;
  int ac_table_size;
  int runlength_table_size;
  float **idctMatrix;
  float **dctMatrix;
*/
/*
} bone_object_t;
*/
/*
typedef struct 
{
	int MuscleIdentifier;
	int NumberControlPoints;
	int NumberKnots;
	MuscleMaskType muscle_mask;
	MuscleDataType muscle_orig;

	MuscleMaskType muscle_mask_prev_frame;

	MuscleDataType Irange_max, Irange_min;
  	MuscleDataType range_max , range_min;

//	MuscleData *Ifreq , *Icumul_freq;
//	MuscleData *freq, *cumul_freq;

//	int BQP[NUM_BAPS];
//	int IBQP[NUM_BAPS];


//  int suggested_gender;
  /* DCT part */
/*  float *dctQP;
  float ** baps;
  float *dcPred;
  float **idctMatrix;
  float **dctMatrix;
  */
/*} muscle_object_t;
*/
typedef struct
{
  unsigned char *buf;
  unsigned char inbfr;
  int p;
  int incnt;
  int bitcnt;
  int bufsize;
  unsigned char outbfr;// for encoder
  int outcnt; // for encoder 
  int outframebits;

} bba_in_buffer;

typedef struct 
{
	bool *sbc_mask;
	bool *sbc_mask_prev;
	int *sbc_values;
	int *sbc_values_prev;

  bool is_intra;
  int bba_quant;
  int pow2quant;
  int noOfControllerTypes;
  int bba_object_coding_type;
  int KeyFrameIndex;

  bool is_time_code;
  bool is_frame_rate;
  bool skip_frames;
  int frame_rate, seconds, frequency_offset;
  int time_code_hours, time_code_minutes, marker_bit, time_code_seconds;
  int number_of_frames_to_skip;
  
  bba_in_buffer stream;
  
  CBone *firstBone;
  CBone *lastBone;
  CMuscle *firstMuscle;
  CMuscle *lastMuscle;
  CMorph *firstMorph;
  CMorph *lastMorph;


  int NumberOfBones;
  int NumberOfMuscles;
  int NumberOfMorphs;
  int NumberOfSBComponentsInPlane;

  // arithmetic based encoding //
  int is_i_new_max, is_i_new_min, is_p_new_max, is_p_new_min;

  int *Irange_max, *Irange_min;
  int *range_max , *range_min;
  
  int **Ifreq , **Icumul_freq;
  int **freq, **cumul_freq;

  int **sbc_DCTvalues;
  float **dctMatrix;
  int **dc_table;
  int **ac_table;
  int **runlength_table;
  int dc_table_size;
  int ac_table_size;
  int runlength_table_size;

  // end arithmetic based encoding //


} sb_object_plane_t;



//typedef struct nextexplink explink;
//typedef explink *vbdptr;/*7 bit vbdptr array index is viseme_blend*/
/*viseme/expression LUT variables -edp*/
//typedef struct nextexplink explink;
/*
struct nextexplink {
  explink *next;
  int expvals;
  int faps[NFAP];
};
typedef explink *vbdptr;
*/


#endif
