/***********************************************************************
This software module was originally developed by Marius PREDA
(INT - ARTEMIS ) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. INT/ARTEMIS retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2001
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Marius PREDA at marius.preda@int-evry.fr
----------------------------------------------------------------------*/

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Decoder
FILE:       BBADecoder.cpp
AUTHOR:     Marius PREDA (INT)
OVERVIEW:   Implementation of BBA Decoder- 
-------------------------------------------------------------------------*/
#include "StdAfx.h"
#include "BBADecoder.h"

#include "ODP.h"
#include "../../OpenGL/AFX/AfxStreamProxy.h"

/*-----------------------------------------------------------------
Constructor, destructor
-----------------------------------------------------------------*/
/*
BBADecoder :: BBADecoder()
{
}

BBADecoder :: ~BBADecoder()
{
  delete m_pDecSpecific;  
  m_pDecSpecific = NULL;
}
*/
/*-----------------------------------------------------------------
BBA object
-----------------------------------------------------------------*/

/*-----------------------------------------------------------------
Calculate the output size in bytes
-----------------------------------------------------------------*/
int BBADecoder :: GetOptimalOutputSize ()
{
	// value used for the allocate the composition buffer
	// several frames have to be in a composition buffer 
	int a=4*sizeof(int)+1024*sizeof(CBone)+1024*sizeof(CMuscle)+1024*sizeof(CMorph);
	
	return a;
}

/*-----------------------------------------------------------------
Parse the decoder specific info
-----------------------------------------------------------------*/
	
BOOL BBADecoder :: Setup (AFXExtDescriptor *pSpecific)
{
	// Init the BBA decoder

	    
	  m_bbaDecoderLib.init();

	  m_bbaDecoderLib.initbits();


  return TRUE;
}

/*-----------------------------------------------------------------
Terminate the decoding and clean-up
-----------------------------------------------------------------*/
/*
void BBADecoder :: Finish ()
{
  if (m_pProxy)
  {
    m_pProxy->SetDecoder(NULL);
    m_pProxy = NULL;
  }
}
*/
/*-------------------------------------------------------------
Decode one unit.
-------------------------------------------------------------*/

BOOL BBADecoder :: Decode (LPBYTE pInput, int nInputLength, LPBYTE pOutput, int &rnOutputLength)
{

//	unsigned int uiPts = 0;


/*
	int ret=m_bbaDecoderLib.bba_decoder(
		(unsigned char *)pInput, 
		0, 
		nInputLength,
		&bbaopdec,
		sizeof(sb_object_plane_t_decoded),
		&uiPts);
 	
	m_bbaDecoderLib.WriteDecodedData(pOutput, rnOutputLength);
*/
	int ret=m_bbaDecoderLib.bba_decoder(
		(unsigned char *)pInput, 
		0, 
		nInputLength,
		pOutput,
		rnOutputLength);

	
	return bool(1-ret);


}


