/*\   Programmed by Alexander Zhirkov <azh@graphics.cs.msu.su>
\*/
#ifdef SAIT_CONFORMANCE_2003

//---------------------------------------------------------------------------
#ifndef __BinaryArithmetic_H
#define __BinaryArithmetic_H
//---------------------------------------------------------------------------

#include <stdio.h>

typedef unsigned int unt;
typedef unsigned char uhr;
typedef unsigned short urd;
typedef double dbl;
typedef unsigned char byte;

#define forinc(i,n) for(i=0;i<(n);i++)
#define fordec(i,n) for(i=(n)-1;i>=0;i--)

#define ZEROCODES

class BStream{
	byte *Buf;
	int _i;
	byte _b;
	int Bit;
	void _putb(){
		Buf[pos++]=_b;
	}
	void _getb(){
		_b=Buf[pos++];
	}
public:
	int BufLen;
	int pos;
	BStream(void *buf,int buflen){
		Buf=(byte*)buf;				// just occupy the ptr
		BufLen=buflen;
		pos=0;_b=0;Bit=0;
		_i=0;
	}
	BStream(const BStream &strm_){
		Buf=strm_.Buf;
		_i=strm_._i;
		_b=strm_._b;
		Bit=strm_.Bit;
		BufLen=strm_.BufLen;
		pos=strm_.pos;
	}
	BStream operator =(const BStream &strm_){
		Buf=strm_.Buf;
		_i=strm_._i;
		_b=strm_._b;
		Bit=strm_.Bit;
		BufLen=strm_.BufLen;
		pos=strm_.pos;
		return *this;
	}
	bool operator == (const BStream &strm_){
		return (Buf==strm_.Buf) && _i==strm_._i && (_i==0 || _b==strm_._b) && pos==strm_.pos;
	}
	void write_bit(int bit){
		_i++;
		if(bit!=false) _b |= (1<<(8-_i));
		if(_i==8){
			_putb();
			_b = 0x00;
			_i = 0;
		}
	}
	int read_bit(){
		if(_i==0) {_getb();_i=8;}
		Bit = (_b&(1<<--_i))?true:false;
		return Bit;
	}
	void write_bits(int nbits, int mbi){
		bool bit = false;
		for(int i=0;i<nbits;i++){
			bit = (mbi & (1<<(nbits-i-1)))?true:false;
			write_bit(bit);
		}
	}
	int read_bits(int nbits){
		int mbi = 0;
		bool bit = false;
		for(int i=0;i<nbits;i++){
			bit=(bool)read_bit();
			mbi <<= 1;
			if(bit!=false) mbi |= 1;
		}
		return mbi;
	}
	void flush_bits(){
		if(_i!=0){
			_putb();
			_b = 0x00;
			_i = 0;
		}
	}
	void back(int bits){
		if(!bits) return;
		int bb;
		bb=pos*8-_i;
		bb-=bits;
		pos=bb/8; _i=0; _b=0;
		read_bits(bb%8);
	}
    void flush_bitsr(){
            while(_i) read_bit();
    }
};

struct BinaryArithmetic
{
	BStream *strm;

	int Pos(){if(!strm) return -1;return strm->pos;}
	int BufLen;

//-- local
        
	unt L,C,R,N,B0,B1;

    // for bitBStream
	unt  bits,ibit,bit;

    // coder
	unt low,high,length;
    int m_bitcount;

    // encoder
	int m_opposite_bits;
	int zerocount;
	void bit_in_psc_layer(int bit,char* str);
	int m_nbBits;
	int	m_lastvalue;
	int m_lastnbbits;

	void addBit(int bit);
	void bit_in_psc_layer(int bit);
	void bit_opp_bits(int bit);
	int reset();
	int flush();

	// decoder
    int  d_bits_used;
	unt  d_low, d_high, d_code_value, d_length;
    unt  d_bitcount;
	int  d_zerocount;
	int  d_Bit;
	int  d_opposite_bits;
  	unt  d_m_lastvalue;
	int  bit_out_psc_layer();
	void d_flush();
    int  d_reset();

};

void write_bit(BinaryArithmetic *rc,int n);
int read_bit(BinaryArithmetic *rc);

void Entropy_BinaryArithmeticEncodeInit(BinaryArithmetic*,BStream*);
int  Entropy_BinaryArithmeticEncodeClose(BinaryArithmetic*); // return number of writted bytes
void Entropy_BinaryArithmeticDecodeInit(BinaryArithmetic*,BStream*);
void Entropy_BinaryArithmeticDecodeClose(BinaryArithmetic*);

void BinaryArithmeticEncode(BinaryArithmetic *rc,unt p0, unt pcur, unt pall);
void BinaryArithmeticDecode(BinaryArithmetic *rc,unt p0, unt pcur, unt pall);
unt  BinaryArithmeticValue(BinaryArithmetic *rc,unt pall);

#endif

#endif