/********************************************************************************/
/* This software module was developped by										*/

/*	   Jerome Royan (MP), jerome.royan@francetelecom.com,						*/
/*                        France Telecom R&D, France							*/

/* in the course of development of the MPEG-4 standard (Part 16 AFX).			*/
/* This software module is an implementation of a part of one or				*/
/* more MPEG-4 tools as specified by the										*/
/* MPEG-4 standard. ISO/IEC gives users of the MPEG-4 standard					*/
/* free license to this software module or modifications thereof				*/
/* for use in hardware or software products claiming conformance				*/
/* to the MPEG-4 standard. Those intending to use this software					*/
/* module in hardware or software products are advised that its					*/
/* use may infringe existing patents. The original developer of					*/
/* this software module and his company, the subsequent							*/
/* editors and their companies, and ISO/IEC have no liability					*/
/* for use of this software module or modifications thereof in					*/
/* an implementation. Copyright is not released for non							*/
/* MPEG-4 standard conforming products. INT ARTEMIS								*/
/* retain full right to use the code for their own purposes,					*/
/* assign or donate the code to a third party and to inhibit					*/
/* third parties from using the code for non MPEG-4 standard					*/
/* conforming products. This copyright notice must be included					*/
/* in all copies or derivative works.    										*/
/* Copyright (c)2002 - 2005														*/
/********************************************************************************/

// FPESet.h: interface for the FPESet class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FPBuilding_H__93F1CF93_D37D_11D5_B9F1_000102A02E5B__INCLUDED_)
#define AFX_FPBuilding_H__93F1CF93_D37D_11D5_B9F1_000102A02E5B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FP.h"
#include "FPRoof.h"
#include "FPFacade.h"

#ifndef BYTE
typedef unsigned char BYTE;
#endif

#ifndef LPBYTE
typedef BYTE* LPBYTE;
#endif

typedef enum {COMPUTED, COMPUTING, NOCOMPUTED, VRMLCOMPUTED, VRMLREADING} state3D;

class FPBuilding : public FP
{
public:
	FPBuilding(void);
	virtual ~FPBuilding();

	FPBuilding & operator =(FPBuilding &in);

	inline state3D State3D() { return m_State3D; };
	inline void SetState3D (state3D state) { m_State3D=state; };

	inline ZArray<FPRoof*>* GetRoofs() const { return m_Roofs; };
	inline void SetRoofs(ZArray<FPRoof*>* roofs) { m_Roofs=roofs ;};
	
	inline ZArray<FPFacade*>* GetFacades() const { return m_Facades; };
	inline void SetFacades(ZArray<FPFacade*>* facades) { m_Facades=facades; };


	//! 3D Reconstruction
	void Reconstruction3D();
	inline float* GLWallVertices() { return m_WallVertices; };
	inline unsigned int** GLWallIndices() { return m_WallIndices; };


protected:
	ZString m_FacadeTextureURL;

	//! 3D Reconstruction (Vertex Array OpenGL)
	state3D m_State3D;
	float* m_WallVertices;
	unsigned int** m_WallIndices;

	ZArray<FPRoof*>* m_Roofs;					// array of roof slopes
	ZArray<FPFacade*>* m_Facades;	// array of facades (by ring)
};

#endif // !defined(AFX_FPBuilding_H__93F1CF93_D37D_11D5_B9F1_000102A02E5B__INCLUDED_)
