/********************************************************************************/
/* This software module was developped by										*/

/*	   Jerome Royan (JR),														*/

/* in the course of development of the MPEG-4 standard (Part 16 AFX).			*/
/* This software module is an implementation of a part of one or				*/
/* more MPEG-4 tools as specified by the										*/
/* MPEG-4 standard. ISO/IEC gives users of the MPEG-4 standard					*/
/* free license to this software module or modifications thereof				*/
/* for use in hardware or software products claiming conformance				*/
/* to the MPEG-4 standard. Those intending to use this software					*/
/* module in hardware or software products are advised that its					*/
/* use may infringe existing patents. The original developer of					*/
/* this software module and his company, the subsequent							*/
/* editors and their companies, and ISO/IEC have no liability					*/
/* for use of this software module or modifications thereof in					*/
/* an implementation. Copyright is not released for non							*/
/* MPEG-4 standard conforming products.											*/
/* Copyright (c)2002 - 2006														*/
/********************************************************************************/

// FPDecoderLib.h: interface for the FootPrintDecoder class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FPDECODER_H__93F1CF93_D37D_11D5_B9F1_000102A02E5B__INCLUDED_)
#define AFX_FPDECODER_H__93F1CF93_D37D_11D5_B9F1_000102A02E5B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FPSet.h"
#include "bitstream.h"
#include "..\AFX.h"
#ifndef BYTE
typedef unsigned char BYTE;
#endif

#ifndef LPBYTE
typedef BYTE* LPBYTE;
#endif

class FPDecoderLib  
{
public:
	FPDecoderLib();
	FPDecoderLib(FPSet* fpset);
	~FPDecoderLib(void);
	inline SetFPSet (FPSet* fpset) { m_pFPSet=fpset; };
	inline FPSet* GetFPSet (void) { return m_pFPSet; };

	BOOL Setup (AFXExtDescriptor *pSpecificInfo);

	BOOL DecodeFPSetStream (LPBYTE pInput, int nInputLength);
	BOOL DecodeFromBuffer (LPBYTE pInput, int nInputLength);
	
protected:
	BOOL DecodeSpecificInfo(mbitstream* bs);
	
	BOOL DecodeFPSetRefinement(mbitstream* bs);
	BOOL DecodeFPFacade(mbitstream* bs, FPFacade* pFacade);
	BOOL DecodeFootPrintSetMessage(mbitstream* bs);
	BOOL DecodeFootPrintMessage(mbitstream* bs);
	BOOL DecodeFPNewVertices(mbitstream* bs, int index, unsigned int& nbNewVertices, Vec2f** newVertices);
	BOOL DecodeIndexFootprintSet(mbitstream* bs, unsigned int& nbindices, unsigned int** indices, unsigned int& nbrings);
	BOOL DecodeFPBuildingParameters(mbitstream* bs, FPBuilding* pBuilding);
	BOOL DecodeRoofs(mbitstream* bs, FPBuilding* pBuilding);
	BOOL DecodeFacades(mbitstream* bs, FPBuilding* pBuilding);
	BOOL DecodeFPSwapNodes(mbitstream* bs, FPBuilding* pBuilding);



protected:
	FPSet* m_pFPSet;
	FPSetDecoderSpecificInfo* m_pDecSpecificInfo;
	unsigned int m_IndexNbBits;

};

#endif // !defined(AFX_FPDECODER_H__93F1CF93_D37D_11D5_B9F1_000102A02E5B__INCLUDED_)
