// FPOperations.cpp: implementation of the FPOperations class.
//
//////////////////////////////////////////////////////////////////////


#include "FPOperations.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

int FPOperations::RemoveColinearVertices(FP* input, FP* output, const FT colinear_threshold) const 
{
	output= new FP();
	ZArray<Vec2f*> newPoly ;
	int ring, i, nbPts, fstAngle, removedVertices= 0 ;
	const int nbRings = input->NbRings() ;
	Vec2f srcD, tgD, pt ;

	for (int num_ring= 0 ; num_ring < nbRings ; num_ring++) {
		Vec2f* ring= input->FootPrint()[num_ring] ;
		nbPts= input->NbVerticesByRing[num_ring];
		if (nbPts > 3) {

			// We search the first non-colinear vertex in the ring. This vertex will be the first vertex of the new polygon
			srcD=ring[0];
			tgD=ring[2] ;
			bool found= false ;
			pt=ring[1];
			for (i= 2 ; !found && i < nbPts ; i++) {
				if (!d.appartenance(pt, colinear_threshold)) {
					// Angle trouv.
					found= true ;
					fstAngle= i - 1 ;
				}
				else 
				{
					srcD=ring[(i+1) % nbPts] ;
					pt=ring[i];
				}
			}

			if (!found) fstAngle= 0 ; // on ne devrait jamais passer dans ce if !
			srcD=ring[fstAngle];
			tgd=ring[(fstAngle + 2) % nbPts];
			
			.AddPoint(srcD) ; // on sait que srcD est  un angle de poly.
			i= (fstAngle + 1) % nbPts ;
			while (i != fstAngle) {
				poly.GetPoint(pt, i) ;
				if (!d.appartenance(pt, colinear_threshold)) {
					newPoly.AddPoint(pt) ;
					srcD= pt ;
				}
				poly.GetPoint(pt, (i + 2) % nbPts) ;
				d= Droite2D(srcD, pt) ;
				i= (i + 1) % nbPts ;
			}

			removedVertices+= (nbPts - newPoly.GetNbPoints()) ;
			newPolygon.AddPolygon(newPoly) ;
		}
		else newPolygon.AddPolygon(poly) ;
	}

	if (removedVertices == 0) newPolygon= Polygon2D() ;

	return removedVertices ;
}
