/********************************************************************************/
/* This software module was developped by										*/

/*	   Jerome Royan (MP), jerome.royan@francetelecom.com,						*/
/*                        France Telecom R&D, France							*/

/* in the course of development of the MPEG-4 standard (Part 16 AFX).			*/
/* This software module is an implementation of a part of one or				*/
/* more MPEG-4 tools as specified by the										*/
/* MPEG-4 standard. ISO/IEC gives users of the MPEG-4 standard					*/
/* free license to this software module or modifications thereof				*/
/* for use in hardware or software products claiming conformance				*/
/* to the MPEG-4 standard. Those intending to use this software					*/
/* module in hardware or software products are advised that its					*/
/* use may infringe existing patents. The original developer of					*/
/* this software module and his company, the subsequent							*/
/* editors and their companies, and ISO/IEC have no liability					*/
/* for use of this software module or modifications thereof in					*/
/* an implementation. Copyright is not released for non							*/
/* MPEG-4 standard conforming products. INT ARTEMIS								*/
/* retain full right to use the code for their own purposes,					*/
/* assign or donate the code to a third party and to inhibit					*/
/* third parties from using the code for non MPEG-4 standard					*/
/* conforming products. This copyright notice must be included					*/
/* in all copies or derivative works.    										*/
/* Copyright (c)2002 - 2005														*/
/********************************************************************************/

// FPETriangulation.h: interface for the FPETriangulation class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FPETRIANGULATION_H__93F1CF93_D37D_11D5_B9F1_000102A02E5B__INCLUDED_)
#define AFX_FPETRIANGULATION_H__93F1CF93_D37D_11D5_B9F1_000102A02E5B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef BYTE
typedef unsigned char BYTE;
#endif

#ifndef LPBYTE
typedef BYTE* LPBYTE;
#endif

#include "../../../core/ztypes.h"
#include "../../../Include/Ztl.h"
#include <GL/gl.h>
#include <GL/glu.h>
#include <stdlib.h>
#include <stdio.h>

#ifndef CALLBACK 
#define CALLBACK
#endif

static struct triangulation_struct {
	GLenum roofTriangleType;
	bool isFirstSet;
	bool isSecondSet;
	bool pair;
	GLdouble firstSet[3];
	GLdouble secondSet[3];
	Vec3f triangles[3000];
	int current;
	int nbtriangles;
} triangulation;



void CALLBACK beginCB (GLenum type, void* call_data);

void CALLBACK endCB ();

void CALLBACK putVertexCB (void* v, void* call_data);

void triangule(ZArray<Vec3f> &contour, ZArray< ZArray< Vec3f > > &internContours, ZArray<Vec3f>& triangles); 

/*
class FPETriangulation 
{
public:
  
	FPETriangulation(void);
	~FPETriangulation();

	static 
	static void CALLBACK endCB ();
	static void CALLBACK putVertexCB (void* v, void* call_data);

	void triangule (ZArray<Vec3f> &contour, ZArray< ZArray< Vec3f > > &internContours);
	void triangles (ZArray<Vec3f>& triangles);

protected:	
  GLenum roofTriangleType;
  bool isFirstSet;
  bool isSecondSet;
  bool pair;
  GLdouble firstSet[3];
  GLdouble secondSet[3];
  ZArray<Vec3f> m_triangles;

};
*/
#endif // !defined(AFX_FPETRIANGULATION_H__93F1CF93_D37D_11D5_B9F1_000102A02E5B__INCLUDED_)
