/*----------------------------------------------------------------
	Projet : Visualisation Villes / Librairie gomtrique de base.
	Fichier: BBox2D.h
	Date 	 :
	A.C. 01/2001
	
	Commentaires:
	
-----------------------------------------------------------------*/









//


#if !defined(AFX_BBOX2D_H__232FF862_8996_45F3_AFEE_7C9BE5712E94__INCLUDED_)
#define AFX_BBOX2D_H__232FF862_8996_45F3_AFEE_7C9BE5712E94__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GeomDefs.h"
#include "Point2D.h"

class Point2D;

class BBox2D  
{
public:
	//! Constructeur par dfaut
	BBox2D();

	//! Constructeur
	/*!
	 * @param x_min : abscisse minimum de la boite englobante
	 * @param x_max : abscisse maximum de la boite englobante
	 * @param x_min : ordonne mimimum de la boite englobante
	 * @param x_min : ordonne maximum de la boite englobante
	!*/
	BBox2D(FT x_min, FT x_max, FT y_min, FT y_max); 

	//! Destructeur
	virtual ~BBox2D();

	//! Permet de modifier les coordonnes de la boite englobante
	/*!
	 * @param x_min : abscisse minimum de la boite englobante
	 * @param x_max : abscisse maximum de la boite englobante
	 * @param x_min : ordonne mimimum de la boite englobante
	 * @param x_min : ordonne maximum de la boite englobante
	!*/
	void Set(FT x_min, FT x_max, FT y_min, FT y_max);
	
	//! Retourne l'abscisse minimum de la boite englobante
	FT X_min() const;

	//! Retourne l'abscisse maximum de la boite englobante
	FT X_max() const;

	//! Retourne l'ordonne minimum de la boite englobante
	FT Y_min() const;

	//! Retourne l'ordonne maximum de la boite englobante
	FT Y_max() const;

	//! Retourne le centre de la boite englobante
	Point2D Center() const;

	//! Teste si une boite englobante b se trouve  l'interieur ou intersecte la boite englobante this.
	bool inside (const BBox2D & b) const;

	//! Teste si un point p se trouve  l'interieur de la boite englobante this.
	bool inside (const Point2D &p) const;
	
	//! Fusionne la boite englobante b avec this
	void CombineBox(const BBox2D & b);

	//! Calcul la distance d'un point p  la boite englobante this
	FT PointDistance(const Point2D & p) const;

protected:
	//! Abscisse max de la boite englobante
	FT x_max;
	//! Ordonnee max de la boite englobante
	FT y_max;
	//! Abscisse min de la boite englobante
	FT x_min;
	//! Ordonnee min de la boite englobante
	FT y_min;

};

#endif // !defined(AFX_BBOX2D_H__232FF862_8996_45F3_AFEE_7C9BE5712E94__INCLUDED_)
