/*----------------------------------------------------------------
	Projet : Visualisation Villes / Librairie gomtrique de base.
	Fichier: GeomDefs.h
	Date 	 :
	A.C. 01/2001
	
	Commentaires:
	
-----------------------------------------------------------------*/








/*----------------------------------------------------------------
							General definitions
	File : GeomDefs.h
-----------------------------------------------------------------*/
#ifndef __LIBGEOM_DEFS_H__
#define __LIBGEOM_DEFS_H__

#include <float.h>

#ifndef NULL										//NULL toujours dfini
#ifdef __cplusplus
#define NULL    0
#else
#define NULL    ((void *)0)
#endif
#endif

/*----------------------------------------------------------------
							Type Primitif
doit implmenter les oprations courantes != <= fabs
-----------------------------------------------------------------*/
typedef double FT;				// real type.
#define FT_MAX DBL_MAX;
#define FT_MIN -DBL_MAX;	
							
#include <math.h>

#define LIBGEOM_MIN_MAGNITUDE	1e-6				// nombre minimum
#define LIBGEOM_NULL_VALUE	1e-5				// valeur considre comme tant gale  0 (pour des flottants)

#define MIN(x,y) (x < y ? x : y)
#define MAX(x,y) (x > y ? x : y)


/*----------------------------------------------------------------
-----------------------------------------------------------------*/

 enum ORIENTATION
{
	LEFT,
	RIGHT,
	ON,
	CW,
	CCW
};

#define LIBGEOM_MAX_REFCOUNT	20000				// nombre max de rfrences  un objet

class LIBGeomException
{
public:
	LIBGeomException();
	LIBGeomException(const char * wh, int line);
};
class IllegalState :	public LIBGeomException
{
};
class IllegalArg :		public LIBGeomException
{
};


#endif

// #eof "$Id: GeomDefs.h,v 1.1 2006/10/20 14:14:55 granger Exp $"
