#ifndef __GEOM_STL_TYPEDEFS_H__
#define __GEOM_STL_TYPEDEFS_H__
//Liste des dfinitions utiliss pour STL qui se retrouvent sinon parpilles.
//#include "map.h"
/*
#ifndef __STL_USE_NEW_IOSTREAMS
#define  __STL_USE_NEW_IOSTREAMS
#endif
*/

/*----------------------------------------------------------------------------
				Includes STL
------------------------------------------------------------------------------*/
#ifdef _MSC_VER
#pragma warning(disable: 4786)
#endif

#include <list>
#include <utility>
#include <map>
#include <vector>
#include <set>
#include <string>
#include <iostream>
//#include <hash_map>

using namespace std;

/*----------------------------------------------------------------------------
				Includes Geom
	Nota : normalement, aucun de ces .h ne doit causer de pb car ils ne devrait
	pas y avoir de cycles des dpendance.
------------------------------------------------------------------------------*/
//#include "Building.h"
//#include "Triangle.h"
#include "Point2D.h"
#include "Point3D.h"
#include "Segment2D.h"
#include "GeomOperators.h"
//#include "Xstr.h"


/*----------------------------------------------------------------------------
				Typedefs STL
------------------------------------------------------------------------------*/

// Operateurs de comparaison

struct eq_point
{
  bool operator()(Point2D s1, Point2D s2) const
  {
    return (fabs(s1.x()-s2.x())<0.02 && fabs(s1.y()-s2.y())<0.02);
  }
};

struct lt_point
{
  bool operator()(Point2D a, Point2D b) const
  {
    return (a.x()<b.x()) || (a.x()==b.x() && a.y()<b.y());
  }
};

struct lt_seg
{
  bool operator()(Segment2D a, Segment2D b) const
  {
    return (a.source()<b.source() || (a.source()==b.source() && a.target()<b.target())); //TODO //!pcoval{}
  }
};

struct hash_point
{
  unsigned short operator()(const Point2D p) const
  {
	return ((unsigned short)((p.x()+p.y())/USHRT_MAX));
  }
};

struct lt_float
{
	bool operator()(int a, int b) const
	{
		return (a<b);
	}
};

typedef map<Point2D,int,struct lt_point> map2D;
typedef map<Segment2D,int, struct lt_seg> mapSeg2D;
typedef list<Point2D> list2D;
typedef pair<int,int> paire;
typedef list<paire>   listpaire;

class Polyline2D;
class Polygon2D;
class TextureFacade;
class Building;
class Segment2DClassifie;

typedef vector<Point2D>		POINT_VECTOR;
typedef vector<Point3D>     POINT3D_VECTOR;
typedef set<Point2D, struct lt_point> POINT_SET;
typedef vector<Segment2D>	SEGMENT_VECTOR;
typedef vector<Polygon2D*>	POLYGON_PT_VECTOR;
typedef vector<Polyline2D>	POLYLINE_VECTOR;
typedef vector<string> STRING_VECTOR;
typedef vector<TextureFacade> TEXFAC_VECTOR;
typedef vector<Segment2DClassifie> SEGMENT2DCLASSIFIE_VECTOR;

typedef POINT_VECTOR::iterator POINT_ITERATOR;
typedef POINT3D_VECTOR::iterator POINT3D_ITERATOR;
typedef POINT_SET::const_iterator POINT_SET_ITERATOR;
typedef SEGMENT_VECTOR::iterator SEGMENT_ITERATOR;
typedef POLYGON_PT_VECTOR::iterator POLYGON_PT_ITERATOR;
typedef POLYLINE_VECTOR::iterator POLYLINE_ITERATOR;
typedef STRING_VECTOR::iterator STRING_ITERATOR;
typedef SEGMENT2DCLASSIFIE_VECTOR::iterator SEGMENT2DCLASSIFIE_ITERATOR;


#endif // __GEOM_STL_TYPEDEFS_H__


// #eof "$Id: GeomSTLDefs.h,v 1.1 2006/10/20 14:14:56 granger Exp $"
