// Intersection.h: interface for the CIntersection class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_INTERSECTION_H__4B77CD23_C9A9_467F_A49E_2E89C8765E88__INCLUDED_)
#define AFX_INTERSECTION_H__4B77CD23_C9A9_467F_A49E_2E89C8765E88__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "point.h"
#include "vertex.h"

class CIntersection  
{
public:
	CIntersection();
	virtual ~CIntersection();

	CIntersection (CVertex &v);							
//	CIntersection (CVertex &v, bool bSecond);           
	
//	enum Type { CONVEX, NONCONVEX } type;

//	operator < (const CIntersection &i) const { return m_height < i.GetHeight(); }  // pro usporadani v prioritni fronte

	// ALB added
	bool operator > (const CIntersection &i) const { return m_height > i.GetHeight(); }  // pro usporadani v prioritni fronte
	operator == (const CIntersection &i) const { return m_point == i.GetPoint(); }

	virtual CPoint2D GetPoint(void) const;
	virtual CVertex* GetLeftVertex(void) const;
	virtual CVertex* GetRightVertex(void) const;
	virtual void SetLeftVertex(/*const*/ CVertex* vtx);
	virtual void SetRightVertex(/*const*/ CVertex* vtx);
	virtual FT GetHeight(void) const;
	virtual FT_IntersectionType GetType(void) const;
	virtual FT GetAltitudeOffset(void) const;
	virtual bool GetTruncatedFlag(void) const;

//	virtual void SetPoint(const CPoint2D in);


protected:
	CPoint2D	m_point;							// Souradnice pruseciku
	CVertex		*m_leftVertex, *m_rightVertex;		// 2 vrcholy, jejichz bisektory vytvorily tento prusecik
	FT			m_height;							// vzdalenost od nositelky
	FT_IntersectionType		m_type;
	FT			m_altitudeoffset;					// added for 3d construction
	bool		m_truncated;						// added for roof max height

	CVertex		m_firstVertex, m_secondVertex;		// added in case of truncated roof
};

#endif // !defined(AFX_INTERSECTION_H__4B77CD23_C9A9_467F_A49E_2E89C8765E88__INCLUDED_)
