// Point.h: interface for the CPoint class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_POINT_H__977277B3_36DE_44C5_837C_C54B4F527A41__INCLUDED_)
#define AFX_POINT_H__977277B3_36DE_44C5_837C_C54B4F527A41__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "geomdefs.h"

typedef enum Type { CONVEX, NONCONVEX }		FT_IntersectionType;

#define M_PI            3.14159265358979323846
#define MAXDOUBLE       1.797693E+308
#define INFINITY        MAXDOUBLE
//#define MIN_DIFF        0.0000005
#define MIN_DIFF        0.0005
//#define MIN_ANGLE_DIFF  0.0000005
#define MIN_ANGLE_DIFF  0.0005

#define ANGLE_SIMILAR(a,b) (NormalizedAngle (a) - NormalizedAngle (b) < MIN_ANGLE_DIFF && NormalizedAngle (b) - NormalizedAngle (a) < MIN_ANGLE_DIFF)
#define SIMILAR(a,b) ((a)-(b) < MIN_DIFF && (b)-(a) < MIN_DIFF)


class CPoint2D 
{
public:
//	CPoint2D();
	virtual ~CPoint2D();

    CPoint2D (void) : x (0), y (0) { }
    CPoint2D (FT X, FT Y) : x (X), y (Y) { }

    FT x, y;
  
	operator == (const CPoint2D &p) const;
    CPoint2D operator * (const FT &n) const { return CPoint2D (n*x, n*y); }
    int isInfinite (void) { return *this == CPoint2D (INFINITY, INFINITY); }
// ALB added
	operator != (const CPoint2D &p) const;

	// added for multiset
	bool operator < (const CPoint2D &p) const;
	
};



#endif // !defined(AFX_POINT_H__977277B3_36DE_44C5_837C_C54B4F527A41__INCLUDED_)
