/*----------------------------------------------------------------
	Projet : Visualisation Villes / Librairie gomtrique de base.
	Fichier: Point2D.h
	Date 	 :
	A.C. 01/2001
	
	Commentaires:
	
-----------------------------------------------------------------*/

#if !defined(AFX_POINT2D_H__83255805_9999_46CA_B84E_FB147CC7F69D__INCLUDED_)
#define AFX_POINT2D_H__83255805_9999_46CA_B84E_FB147CC7F69D__INCLUDED_

#include "BBox2D.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "GeomDefs.h"


class Point2D  
{
public:
	//! Constructeur par defaut
	Point2D();

	//! Destructeur
	virtual ~Point2D();
	
	//! Constructeur par recopie
	Point2D(const Point2D & s);

	//! Constructeur
	/*!
	 *  @param x : abscisse du point
	 *  @param y : ordonnee du point
	!*/
	Point2D(FT x, FT y);

	//! Operateur de recopie
	Point2D & operator =(const Point2D &in);

	//! Test d'galit
	virtual bool equal(const Point2D& in, FT precision);

	//! Test d'infriorit
	virtual bool operator <(const Point2D& in);
	
	//! Permet l'attribution d'une nouvelle abscisse au point
	virtual void setX(FT x);

	//! Permet l'attribution d'une nouvelle ordonnee au point
	virtual void setY(FT y);

	//! retourne l'abscisse du point
	virtual FT x() const;

	//! retourne l'ordonnee du point
	virtual FT y() const;

	FT operator [](int i) const;

	int dimension() const;

	//! determine si une implementation du point existe
	bool empty() const;

protected:
	Point2D * m_impl;
};

#endif // !defined(AFX_POINT2D_H__83255805_9999_46CA_B84E_FB147CC7F69D__INCLUDED_)
