// Point3D.h: interface for the Point3D class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_POINT3D_H__B4096D76_3BC7_4A25_ABBE_D4563730F13F__INCLUDED_)
#define AFX_POINT3D_H__B4096D76_3BC7_4A25_ABBE_D4563730F13F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GeomDefs.h"

class Point3D  
{
public:
	//! Constructeur par dfaut
	Point3D();
	
	//! Constructeur par recopie
	Point3D(const Point3D & s);

	//! Constructeur
	/*!
	 *  @param x : abscisse du point
	 *  @param y : ordonnee du point
	 *  @param z : hauteur du point
	!*/
	Point3D(FT x, FT y, FT z);
	
	//! Destructeur
	virtual ~Point3D();

	//! Operateur de recopie
	Point3D & operator =(const Point3D &in);

	//! Teste d'galite
	virtual bool equal(const Point3D& in, FT precision);
	
	//! Retourne l'abscisse du sommet
	virtual FT y() const;

	//! Retourne l'ordonnee du sommet
	virtual FT x() const;

	//! Retourne la hauteur du sommet
	virtual FT z() const;

	//! Permet de modifier mes coordonnees du sommet
	/*!
	 *  @param x : abscisse du point
	 *  @param y : ordonnee du point
	 *  @param z : hauteur du point
	!*/
	virtual void Set(FT x, FT y, FT z);

	//! Retourne la nime coordonne du sommet (i<3)
	FT operator [](int i) const;

	//! Retourne la dimension du sommet (3)
	int dimension() const;

protected:
	//! Pointeur vers l'implmentation du sommet 3D
	Point3D * m_impl;
};

#endif // !defined(AFX_POINT3D_H__B4096D76_3BC7_4A25_ABBE_D4563730F13F__INCLUDED_)
