/*----------------------------------------------------------------
	Projet : Visualisation Villes / Librairie gomtrique de base.
	Fichier: Polygon2DX.h
	Date 	 :
	A.C. 01/2001
	
	Commentaires:
	
-----------------------------------------------------------------*/









//


#if !defined(AFX_POLYGON2DX_H__0870503D_62B5_425B_9C59_8FFDC07FE8EE__INCLUDED_)
#define AFX_POLYGON2DX_H__0870503D_62B5_425B_9C59_8FFDC07FE8EE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Polygon2D.h"
#include "RefCount.h"

class Point2D;
class Polygon2DX   : public Polygon2D , public RefCount 
{
public:
	Polygon2DX(int nbPoints, Point2D * points);
	Polygon2DX(int nbRings,	Polygon2D * rings);
	Polygon2DX();
	virtual ~Polygon2DX();

	Polygon2DX(const Polygon2DX &);
	Polygon2DX(const Polyline2D & p);

	Polygon2D & operator =(const Polygon2DX &in);

	Polygon2D operator [](int i) const;

	virtual BBox2D bbox() const;

	virtual int GetNbRings() const;
	virtual POINT_VECTOR PointVector() ;
	virtual SEGMENT_VECTOR SegmentVector() ;
	virtual bool AddPoint(const Point2D &in);
	virtual bool AddPoints(int nbPoints,	Point2D *	pts);
	virtual bool InsertPoint(const Point2D &in,int pos);
	virtual bool InsertPoints(int nbPoints, Point2D * pts,int pos);
	virtual bool SuppressPoint(int pos, int nbPoints=1);
	virtual bool SuppressPoint(Point2D &p);
	virtual bool GetPoint(Point2D & out, int pos) const;
	virtual int GetNbPoints() const;
	virtual bool AddPolygon(const Polygon2D &p);
	virtual bool AddPolyline(const Polyline2D &p);
	virtual bool InsertPolygon(const Polygon2D & p, int pos );
	virtual bool SuppressPolygon(int pos, int nbPoly=1);
	virtual bool InsertPolyline(const Polyline2D & p, int pos );
	virtual bool SuppressPolyline(int pos, int nbPoly=1);

	virtual bool has_on(const Point2D &, int & pos, FT dist) const;
	virtual bool has_on(const Point2D & pt, int & num_ring , int & pos, FT dist) const;
	virtual bool HasPoint(const Point2D &pt, int &ring, int &pos) const;
	virtual FT SimpleArea() const;
	virtual FT HoledArea() const;
	virtual FT SimplePerimeter();
	virtual FT HoledPerimeter();
	virtual Point2D GravityCenter() const;
	virtual	void InverseOrientation();
	virtual Polygon2D dilate(FT epsilon) const;
	virtual Point2D getInsidePoint() const;

	virtual Polyline2D GetPolyline(int i) const;
	virtual POLYLINE_VECTOR GetPolylines() const;

	virtual FT DistanceFromPoint2D(const Point2D & p) const;
	virtual FT DistanceFromPolygon2D(const Polygon2D & p) const;
	virtual int PointInsideExternEnveloppe(const Point2D & p, FT precision=LIBGEOM_NULL_VALUE) const;
	virtual int PointInside(const Point2D & p, FT precision=LIBGEOM_NULL_VALUE) const;
	virtual int PolygonInsideExternEnveloppe(Polygon2D & p, FT precision=LIBGEOM_NULL_VALUE) const;
	virtual int PolygonInside(Polygon2D & p, FT precision=LIBGEOM_NULL_VALUE) const;
	virtual int SegmentInside(const Segment2D &seg, FT precision= LIBGEOM_NULL_VALUE) const ;
	virtual POLYLINE_POSITION PolygonPosition(const Polygon2D &p,
														  FT precision= LIBGEOM_NULL_VALUE) const ;
	virtual bool Adjacent(const Polygon2D &p) const;
	virtual int RemoveColinearVertices(Polygon2D &newPolygon, const FT colinear_threshold) const;

	// Retourne le numro du trou edjacent  l'enveloppe du polygone, -1 sinon
	virtual int HoleConnexeToEnveloppe() const;
	virtual int ConnexeHoles() const;


	// corrige un polygone qui  un trou adjacent  son enveloppe : n trous->n-1 trous
	virtual void CorrectHoleConnexeToEnveloppe(int num_hole);
	virtual void CorrectConnexeHoles(int num_hole);

	virtual bool IsConvex() const;
	virtual vector<Polygon2D> clipping() const;


protected:
	POLYLINE_VECTOR m_rings;
};

#endif // !defined(AFX_POLYGON2DX_H__0870503D_62B5_425B_9C59_8FFDC07FE8EE__INCLUDED_)
