// Polyline2DX.h: interface for the Polyline2DX class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_POLYLINE2DX_H__7313B365_634E_4E28_98B2_5772DAAD13E4__INCLUDED_)
#define AFX_POLYLINE2DX_H__7313B365_634E_4E28_98B2_5772DAAD13E4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GeomDefs.h"
#include "Polyline2D.h"
#include "RefCount.h"

class Polyline2DX : public Polyline2D , public RefCount 
{
public:
	Polyline2DX();
	virtual ~Polyline2DX();
	Polyline2DX(int nbPoints, Point2D * points);

	Polyline2DX(const Polyline2DX &);
	Polyline2D & operator =(const Polyline2DX &in);
	virtual Point2D operator [](int i) const;

	virtual BBox2D bbox() const;

	virtual POINT_VECTOR PointVector() const ;
	virtual SEGMENT_VECTOR SegmentVector() const;
	virtual bool AddPoint(const Point2D in);
	virtual bool AddPoints(int nbPoints,	Point2D *	pts);
	virtual bool InsertPoint(const Point2D in,int pos);
	virtual bool InsertPoints(int nbPoints, Point2D * pts,int pos);
	virtual bool SuppressPoint(int pos, int nbPoints=1);
	virtual bool SuppressPoint(Point2D & p);
	virtual bool GetPoint(Point2D & out, int pos) const;
	virtual int GetNbPoints() const;
	virtual bool has_on(const Point2D &, int &pos, FT dist) const;
	virtual bool HasPoint(const Point2D &pt, int &pos)const;
	virtual FT Area() const;
	virtual FT Perimeter();
	virtual Point2D GravityCenter() const;
	virtual	void InverseOrientation();
	virtual Polyline2D dilate(FT epsilon) const;
	virtual Point2D getInsidePoint();

	virtual FT DistanceFromPoint2D(const Point2D & p) const;
	virtual FT DistanceFromPolyline2D(const Polyline2D & p) const;
	virtual int PointInside(const Point2D & p, FT precision=LIBGEOM_NULL_VALUE) const;
	virtual int PolylineInside(Polyline2D & p, FT precision=LIBGEOM_NULL_VALUE) const;
	virtual POLYLINE_POSITION PolylinePosition(const Polyline2D &p,
											   FT precision= LIBGEOM_NULL_VALUE) const ;
	virtual int SegmentInside(const Segment2D &seg, FT precision= LIBGEOM_NULL_VALUE) const ;
	virtual bool Adjacent(Polyline2D &p);
	virtual vector<Polygon2D> clipping() const;	

protected:
	POINT_VECTOR m_points;
};

#endif // !defined(AFX_POLYLINE2DX_H__7313B365_634E_4E28_98B2_5772DAAD13E4__INCLUDED_)
