/*----------------------------------------------------------------
	Projet : Visualisation Villes / Librairie gomtrique de base.
	Fichier: Segment2D.h
	Date 	 :
	A.C. 01/2001
	
	Commentaires:
	
-----------------------------------------------------------------*/









//


#if !defined(AFX_SEGMENT2D_H__90AEA766_754B_4D4F_9C17_F006162FD68F__INCLUDED_)
#define AFX_SEGMENT2D_H__90AEA766_754B_4D4F_9C17_F006162FD68F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "GeomDefs.h"
#include "Droite2D.h"
#include "Point2D.h"

class Segment2D  
{
public:
	//! Constructeur par dfaut
	Segment2D();
	//! Constructeur
	/*!
	 *  @param s : le sommet d'origine du segment
	 *  @param t : le sommet cible du segment
	!*/
	Segment2D(Point2D s, Point2D t);

	//! Constructeur par recopie
	Segment2D(const Segment2D &);

	//! Destructeur par defaut
	virtual ~Segment2D();
	
	//! Operateur de recopie
	Segment2D & operator =(const Segment2D &s);

	//! Test d'galit
	virtual bool equal(const Segment2D& in, FT precision);

	//! Teste si un sommet appartient au segment
	/*!
	 *	@param p : le sommet test
	 *  @param dist : la prcision du calcul (par defaut 0.00001)
	!*/
	virtual bool has_on(const Point2D &p, FT dist=0.00001) const;
	
	
	bool is_degenerate() const;

	//! Retourne la longuer au carr du segment
	virtual FT squared_length() const;

	//! Retourne un sommet du segment : 0 pour le sommet d'origine, 1 pour le sommet cible
	Point2D vertex(int i) const;

	//! Retourne le sommet cible du segment
	virtual Point2D target() const;

	//! Retourne le sommet d'origine du segment
	virtual Point2D source() const;

	//! Retourne l'angle du segment [-pi; pi[
	virtual float angle() const;

	virtual bool appartenance(const Point2D &p, FT &t) const;
	virtual bool inclus(Droite2D &) const;
	
	//! Retourne le sommet d'origine pour 0, et le sommet cible pour 1
	Point2D operator [](int);

	//! Retourne la distance d'un point au segment
	virtual FT DistanceFromPoint(const Point2D &p) const;

	//! Calcul l'intersection de deux segments
	virtual int intersect(Segment2D &s, Point2D & intersect) const;


protected :
	Segment2D* m_impl;
};

#endif // !defined(AFX_SEGMENT2D_H__90AEA766_754B_4D4F_9C17_F006162FD68F__INCLUDED_)
