// Segment2DX.h: interface for the Segment2DX class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SEGMENT2DX_H__D703DEA4_461D_4645_8FCD_C9847720B02E__INCLUDED_)
#define AFX_SEGMENT2DX_H__D703DEA4_461D_4645_8FCD_C9847720B02E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GeomDefs.h"
#include "Segment2D.h"
#include "RefCount.h"

class Segment2DX : public Segment2D, public RefCount 
{
public:
	Segment2DX();
	virtual ~Segment2DX();

	Segment2DX(const Segment2D &);
	Segment2DX(Point2D s, Point2D t);
	Segment2D & operator =(const Segment2D &s);

	virtual bool equal(const Segment2D& in, FT precision);
	virtual bool appartenance(const Point2D &p, FT &t) const;

	virtual bool inclus(Droite2D &d) const;
	Point2D vertex(int i) const;
	virtual Point2D target() const;
	virtual Point2D source() const;
	virtual float angle() const;
	Point2D operator [](int);
	
	virtual bool has_on(const Point2D &p, FT dist) const;
	virtual bool is_degenerate() const;
	virtual FT squared_length() const;
	virtual FT DistanceFromPoint(const Point2D &p) const;
	virtual int intersect(Segment2D &s, Point2D & intersect) const;

protected :
	Point2D m_source;
	Point2D m_target;
};
#endif // !defined(AFX_SEGMENT2DX_H__D703DEA4_461D_4645_8FCD_C9847720B02E__INCLUDED_)
