// SkeletonLine.h: interface for the SkeletonLine class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SKELETONLINE_H__FBAD6F5E_4067_4894_A348_0C21DCFE4D1B__INCLUDED_)
#define AFX_SKELETONLINE_H__FBAD6F5E_4067_4894_A348_0C21DCFE4D1B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "vertex.h"

class CSkeletonLine  
{
public:
//	CSkeletonLine();
	virtual ~CSkeletonLine();

    CSkeletonLine (void) : m_ID (-1) { }
    CSkeletonLine (/*const*/ CVertex &l, /*const*/ CVertex &h) : lower (l), higher (h), m_ID (-1) { };
//	operator Segment (void) { return Segment (lower.vertex -> point, higher.vertex -> point); } // Jen pro ladeni

    class CSkeletonPoint
	{
	public:
		CSkeletonPoint (/*const*/ CVertex &v = CVertex (), CSkeletonLine *l = NULL, CSkeletonLine *r = NULL)
                : vertex (&v), left (l), right (r) { }
//		virtual ~CSkeletonPoint();
		
		/*const*/ CVertex *vertex;                // ukazatel na vrchol (obsahuje souradnice)
		CSkeletonLine *left, *right;          // kridla
		int leftID (void) const { if (!left) return -1; return left -> GetID(); }
		int rightID (void) const { if (!right) return -1; return right -> GetID(); }
		int vertexID (void) const { if (!vertex) return -1; return vertex -> GetID(); }
	} lower, higher;                     // dva body typu SkeletonPoint
	operator == (const CSkeletonLine &s) const
              { return higher.vertex -> GetID() == s.higher.vertex -> GetID()  && lower.vertex -> GetID()  == s.lower.vertex -> GetID() ; }
	operator < (const CSkeletonLine &) const { assert (false); return false; }     // kvuli STL, jinak se nepouziva


	virtual int GetID(void) const;

	virtual void SetID(const int in);

protected:
	int m_ID;                                // Cislo automaticky pridelovane pri vkladani do kostry

};

#endif // !defined(AFX_SKELETONLINE_H__FBAD6F5E_4067_4894_A348_0C21DCFE4D1B__INCLUDED_)
