/*----------------------------------------------------------------
Projet : Visualisation Villes / Librairie gomtrique de base.
Fichier: TriangulationX.h
Date 	 :
A.C. 01/2002

Commentaires:

-----------------------------------------------------------------*/


#ifndef __TRIANGULATIONX_H__
#define __TRIANGULATIONX_H__

#include "GeomDefs.h"
#include "RefCount.h"
#include "Triangulation.h"

#include "GeomSTLDefs.h"

enum _STATE
{
	INIT,
	BEGIN,
	END
};

//! Implmentation d'une triangulation
/*!
 *	Cette classe implmente la triangulation.
 */
class TriangulationX : public Triangulation , public RefCount
{
public:
	//! Constructeur par dfaut
	TriangulationX();

	//! Destructeur par dfaut
	virtual ~TriangulationX();

	//! Constructeur par copie
	/*!
	 *	\param Triangulation const ref.
	*/
	TriangulationX(const TriangulationX& );

	//! Oprateur d'assignation
	/*!
	 *	\param Triangulation const ref.
	*/
	TriangulationX& operator =(const TriangulationX& );

	//! Initialise la triangulation. Permet de commencer l'entre de paramtres.
	/*!
	*/
	virtual void Begin();
	//! On ne peut plus inclure des lts ds la triangulation aprs. Lance le calcul.
	/*!
	*/
	virtual void End();
	//! Ajoute un segment.
	/*!
	 * \param Segment2D  inclure.
	*/
	virtual void Push(Segment2D s);
	/*!
	 * \param Point2D  inclure.
	 * \param isHole ? est-ce un trou (faux par dfaut)?
	*/
	virtual void Push(Point2D p, bool isHole=false);

	virtual void SetOrientation(ORIENTATION o);

	virtual vector<Polygon2D> Triangles();

protected:
	int addPoint(Point2D p, bool isHole=false);
	enum _STATE			m_state;

	map2D				m_point2Index;
	mapSeg2D            m_segment2Index;
	listpaire			m_segments;
	POINT_VECTOR		m_points;
	POINT_VECTOR		m_holes;
	int					m_pointIndex;
	int					m_segmentIndex;
	ORIENTATION			m_orientation;
	vector<Polygon2D>	m_result;

};
#endif  // __TRIANGULATIONX_H__

// #eof "$Id: TriangulationX.h,v 1.1 2006/10/20 14:14:56 granger Exp $"
