/*----------------------------------------------------------------
	Projet : Visualisation Villes / Librairie gomtrique de base.
	Fichier: Vector2D.h
	Date 	 :
	A.C. 01/2001
	
	Commentaires:
	
-----------------------------------------------------------------*/









//


#if !defined(AFX_VECTOR2D_H__AF99C5E25_DEC5_4BEE_B60C_341C48209ED9__INCLUDED_)
#define AFX_VECTOR2D_H__AF99C5E25_DEC5_4BEE_B60C_341C48209ED9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "GeomDefs.h"
#include "Point2D.h"

class Vector2D  
{
public:
	Vector2D perpendicular(ORIENTATION o);
	FT operator*(Vector2D v) const;
	virtual bool normalise();
	FT squared_norm() const;

	Vector2D();
	Vector2D(FT x, FT y);
	Vector2D(Point2D p1, Point2D p2);
	Vector2D(const Vector2D &s);

	virtual ~Vector2D();
	Vector2D & operator =(const Vector2D &in);
	FT operator [](int i) const;
	
	virtual FT y() const;
	virtual FT x() const;

	int dimension() const;
	Vector2D	operator *(FT s) const;
	Vector2D	operator /(FT s) const;
	Vector2D	operator -(Vector2D &v) const;
	Vector2D	operator +(Vector2D &v) const;
	bool		operator==(Vector2D &v) const;
	bool		operator!=(Vector2D &v) const;

protected:
	Vector2D * m_impl;
};

#endif // !defined(AFX_VECTOR2D_H__AF99C5E25_DEC5_4BEE_B60C_341C48209ED9__INCLUDED_)
