// VectorGeom3D.h: interface for the VectorGeom3D class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VectorGeom3D_H__EAFBDC19_94BF_4D78_98FB_C0FF4676BD35__INCLUDED_)
#define AFX_VectorGeom3D_H__EAFBDC19_94BF_4D78_98FB_C0FF4676BD35__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GeomDefs.h"
#include "Point3D.h"

class VectorGeom3D  
{
public:
	VectorGeom3D();
	VectorGeom3D(FT x, FT y, FT z);
	VectorGeom3D(Point3D p1, Point3D p2);
	VectorGeom3D(const VectorGeom3D &s);

	virtual ~VectorGeom3D();

//	VectorGeom3D perpendicular(ORIENTATION o);
	FT operator*(VectorGeom3D v) const;
	virtual bool normalise();
	FT squared_norm() const;

	VectorGeom3D & operator =(const VectorGeom3D &in);
	FT operator [](int i) const;
	
	virtual FT x() const;
	virtual FT y() const;
	virtual FT z() const;

	int dimension() const;
	VectorGeom3D	operator *(FT s) const;
	VectorGeom3D	operator /(FT s) const;
	VectorGeom3D	operator -(VectorGeom3D &v) const;
	VectorGeom3D	operator +(VectorGeom3D &v) const;
	bool		operator==(VectorGeom3D &v) const;
	bool		operator!=(VectorGeom3D &v) const;

protected:
	VectorGeom3D * m_impl;
};

#endif // !defined(AFX_VectorGeom3D_H__EAFBDC19_94BF_4D78_98FB_C0FF4676BD35__INCLUDED_)
