#ifndef BITSTREAM
#define BITSTREAM
#include <fstream.h>
//#include <iostream.h>
//WIN32,_DEBUG,_MBCS,_LIB (default flags)

//!une classe permettant d'crire des fichiers au bit prs
class obitstream : public ofstream {

	//!le byte(8 bits) en cours de construction
	unsigned char m_newbyte;

	//!byte de masque puissance de 2 indiquant quel bit dans m_newbyte est utilis
	unsigned char m_bits;

public:
	//!constructeur
	obitstream();

	//!ecriture d'un bit dans m_newbyte
	void writebit(int bit);

	//!ecriture de n bits conscutifs placs dans un char bit (8 bits au maximum)
	void writenbit(unsigned char bit, short int n);

	//!ecriture de n bits conscutifs placs dans un short int bit (16 bits au maximum)
	void writenbit(unsigned short int bit, short int n);

	//!ecriture de n bits conscutifs placs dans un int bit (32 bits au maximum)
	void writenbit(unsigned int bit, short int n);

	//!ecriture d'un byte dans le fichiers
	void write(char i);

	//!ecriture d'un float en binaire dans le fichier
	void write(float f);

	//force l'criture du byte en cours de construction. 
	//void writecurrentbyte();

	//!fermeture fichier
	void close();

	//!reinitialisation obitstream
	void reset();

	void append(obitstream);
};


//!une classe permettant de lire des fichiers au bit prs
class ibitstream : public ifstream {

	//!le byte(8 bits) en cours de construction
	unsigned char m_newbyte;

	//!byte de masque puissance de 2 indiquant quel bit dans m_newbyte est utilis
	unsigned char m_bits;

public:
	//!constructeur
	ibitstream();

	//!lecture d'un bit.
	void readbit(int &bit);

	//lecture de n bits conscutifs placs dans un char bit (8 bits au maximum)
	void readnbit(unsigned char &bit, short int n);

	//lecture de n bit conscutifs placs dans un short int bit (16 bits au maximum)
	void readnbit(unsigned short int &bit, short int n);

	//lecture de n bit conscutifs placs dans un int bit (32 bits au maximum)
	void readnbit(unsigned int &bit, short int n);

	//lecture de n bit conscutifs placs dans un float (32 bits au maximum)
	void readnbit(float&, short int n);

	//!lecture d'un byte dans le fichiers
	void read(char &i);

	//!lecture d'un float en binaire dans le fichier
	void read(float &f);

	//!fermeture fichier
	void close();

	//!reinitialisation ibitstream
	void reset();
};


class mbitstream {

public:

	unsigned char *octets;
	int top;
	int offset;
	unsigned char tmp;
	
	mbitstream();
	mbitstream(unsigned char*);
	mbitstream(char*);//From a file
	void writebit(bool);
	void writenbit(unsigned char bits, int nbbits);
	void writenbit(unsigned short bits, int nbbits);
	void writenbit(unsigned int bits, int nbbits);
	void writenbit(float bits, int nbbits);
	bool readbit();
	void readbit(int&);
	void readnbit(unsigned short&, int);
	void readnbit(unsigned int&, int);
	void readnbit(float&, int);
	void dump(obitstream&);
	void dump(mbitstream&, int offset, int length);
	void dump(mbitstream&);
	inline int size() {return top*8+offset;}
	void reset();
	void close();
	

	//Quality check


};


#endif