/***********************************************************************
This software module was originally developed by Ioan Alexandru Salomie
(Vrije Universiteit Brussel VUB) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. VUB retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2001
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Jerome Royan at jerome.royan@francetelecom.com.
----------------------------------------------------------------------*/

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Decoder
FILE:       FootPrintDecoder.cpp
AUTHOR:     Jerome Royan (FranceTelecom R&D)
OVERVIEW:   Implementation of FootPrintDecoder - an object that servers as
			a template for development of decoder plug-ins.
-------------------------------------------------------------------------*/
#include "StdAfx.h"
//#include "Defs.h"
#include "FootPrintDecoder.h"
//#include "Nodes.h"
#include "ODP.h"
#include "../../OpenGL/AFX/AfxStreamProxy.h"

//#include <memory.h>


/*-----------------------------------------------------------------
Constructor, destructor
-----------------------------------------------------------------*/
FootPrintDecoder :: FootPrintDecoder()
{
}

FootPrintDecoder :: ~FootPrintDecoder()
{

}

/*-----------------------------------------------------------------
Calculate the output size in bytes
-----------------------------------------------------------------*/
int FootPrintDecoder :: GetOptimalOutputSize ()
{
  // decoding buffer
	return 10000000;
}

/*-----------------------------------------------------------------
Parse the decoder specific info
-----------------------------------------------------------------*/
	
BOOL FootPrintDecoder :: Setup (AFXExtDescriptor *pSpecificInfo)
{
  m_FPDec.Setup(pSpecificInfo);
  return TRUE;
}

/*-------------------------------------------------------------
Decode one unit.
-------------------------------------------------------------*/

BOOL FootPrintDecoder :: Decode (LPBYTE pInput, int nInputLength, LPBYTE pOutput, int &rnOutputLength)
{
	if (rnOutputLength < nInputLength)
	{
		rnOutputLength = nInputLength;  return FALSE;
	}

  try
  {
		m_FPDec.SetFPSet(((FootPrintSetProxy*) m_pProxy)->GetFPSet());
		m_FPDec.DecodeFPSetStream(pInput, nInputLength);
  }
  catch (CMemoryException *)
  {
    TRACE0("Memory allocation error\n");
  }

	return TRUE;
}

