/***********************************************************************
This software module was originally developed by Ioan Alexandru Salomie
(Vrije Universiteit Brussel VUB) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. VUB retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2001
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Ioan Alexandru Salomie at iasalomi@etro.vub.ac.be.
----------------------------------------------------------------------*/

#if !defined(_FootPrintDecoder_h)	// Sentry, use file only if it's not already included.
#define _FootPrintDecoder_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Decoder
FILE:       FootPrintDecoder.h
AUTHOR:     Jerome Royan (France Telecom R&D)
OVERVIEW:   Definition of FootPrintDecoder
-------------------------------------------------------------------------*/
#include "AFX.h"
#include "../../include/ztl.h"
#include "../../OpenGL/AFX/FP/FootPrintSetProxy.h"
#include "./FootPrint/FPDecoderLib.h"

class FootPrintDecoder : public AFXTemplate
{
public:
  FootPrintDecoder();
  ~FootPrintDecoder();

  virtual int GetOptimalOutputSize ();
  virtual BOOL Setup (AFXExtDescriptor *pSpecificInfo);
  virtual BOOL Decode (LPBYTE pInput, int nInputLength, LPBYTE pOutput, int &rnOutputLength);
 
public :
	FPDecoderLib m_FPDec;
};



#endif                                      // _FootPrintDecoder_h sentry.
