/***********************************************************************
This software module was originally developed by James D. K. Kim, 
Sang Oak Woo and Shin Jun Lee(Samsung Advance Institute of Technology)
in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
standard. This software module is an implementation of a part of one or
more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4
Systems (ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 
Systems (ISO/IEC 14496-1) free license to this software module or 
modifications thereof for use in hardware or software products claiming
conformance to the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to 
use this software module in hardware or software products are advised that
its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Samsung Advance Institute of Technology
retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using
the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
This copyright notice must be included in all copies or derivative works.
Copyright  2001
************************************************************************

For more information or to receive an up to date version of this module,
you may contact James D. K. Kim at jacobkim@sait.samsung.co.kr
----------------------------------------------------------------------*/

#if !defined ___ARITHMETIC_DECODER___
#define ___ARITHMETIC_DECODER___

#include "entropy.h"

void decodeUnaryAAC(
	CAC_QF& codec,
	int* nDecodedValue,
	SAIT_CAC& signContext, SAIT_CAC& valueContext
);

void decodeSQAAC(
	CAC_QF& codec,
	int* anDecodedValues, int qstep, 
	SAIT_CAC& signContext, SAIT_CAC& maxValueContext,
	SAIT_CAC& foundContext, SAIT_CAC& notFoundContext,
	int keynum, int start
);

// decode: aac values with sign
void decodeSignedAAC(CAC_QF& codec, int* nDecodedValue, int qstep, SAIT_CAC& signContext, SAIT_CAC* valueContext);

// decode: aac values without sign
void decodeUnsignedAAC(CAC_QF& codec, int* nDecodedValue, int qstep, SAIT_CAC* valueContext);

// decode: aac values with sign (using zero context after decoding the msb)
void decodeSignedQuasiAAC(CAC_QF& codec, int* nDecodedValue, int qstep, SAIT_CAC& signContext, SAIT_CAC* valueContext);

int getNbBits(int k);


#endif