/***********************************************************************
This software module was originally developed by James D. K. Kim, 
Sang Oak Woo and Shin Jun Lee(Samsung Advance Institute of Technology)
in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
standard. This software module is an implementation of a part of one or
more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4
Systems (ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 
Systems (ISO/IEC 14496-1) free license to this software module or 
modifications thereof for use in hardware or software products claiming
conformance to the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to 
use this software module in hardware or software products are advised that
its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Samsung Advance Institute of Technology
retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using
the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
This copyright notice must be included in all copies or derivative works.
Copyright  2001
************************************************************************

For more information or to receive an up to date version of this module,
you may contact James D. K. Kim at jacobkim@sait.samsung.co.kr
----------------------------------------------------------------------*/

// CompressedOrientationInterpolator.h: interface for the CompressedOrientationInterpolator class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMPRESSEDORIENTATIONINTERPOLATOR_H__A6D7167D_F4B4_42BF_A7E0_30403465F2B2__INCLUDED_)
#define AFX_COMPRESSEDORIENTATIONINTERPOLATOR_H__A6D7167D_F4B4_42BF_A7E0_30403465F2B2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "OriIKeyValueHeader.h"
#include "KeySelectionFlag.h"
#include "Key.h"
#include "OriIDPCMKeyValue.h"
#include "SFRotation.h"
#include "Entropy.h"


class CompressedOrientationInterpolator  
{
public:
	CompressedOrientationInterpolator();
	virtual ~CompressedOrientationInterpolator();

public:
	void decode(char* fileName);

#if defined SAIT_CONFORMANCE_2003
	void write(char* fileName, int defID = -1);
	void setValues(unsigned char* pData);
#else
	void write(char* fileName);
#endif SAIT_CONFORMANCE_2003

	// 20020711 for BitWrapper
	void decodeWithBuffer(char* buffer, int nLength = -1);

public:
	// Each class of decoding part 
	KeyHeader kHeader;
	OriIKeyValueHeader oriIKVHeader;
	KeySelectionFlag ksFlag;
	Key k;
	OriIDPCMKeyValue oriIDPCMKeyValue;

public:
	JWArray <double> dKey;
	JWArray <SFRotation> dKeyValue;

	// temporary value for error calculation
	JWArray <Quaternion> dKeyValueQuat;
};

#endif // !defined(AFX_COMPRESSEDORIENTATIONINTERPOLATOR_H__A6D7167D_F4B4_42BF_A7E0_30403465F2B2__INCLUDED_)
