/***********************************************************************
This software module was originally developed by James D. K. Kim, 
Sang Oak Woo and Shin Jun Lee(Samsung Advance Institute of Technology)
in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
standard. This software module is an implementation of a part of one or
more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4
Systems (ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 
Systems (ISO/IEC 14496-1) free license to this software module or 
modifications thereof for use in hardware or software products claiming
conformance to the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to 
use this software module in hardware or software products are advised that
its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Samsung Advance Institute of Technology
retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using
the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
This copyright notice must be included in all copies or derivative works.
Copyright ?2001
************************************************************************

For more information or to receive an up to date version of this module,
you may call Sang Oak Woo at sowoo@sait.samsung.co.kr
----------------------------------------------------------------------*/

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Interpolator Compression
FILE:       CompressedPositionInterpolator.h
AUTHOR:     Sang Oak Woo (SAMSUNG AIT)
OVERVIEW:   Implementation of Interpolator Compression
-------------------------------------------------------------------------*/

// ompressedPositionInterpolator.h: interface for the CompressedPositionInterpolator class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OMPRESSEDPOSITIONINTERPOLATOR_H__174DA657_46F9_48D8_A469_94562461D20D__INCLUDED_)
#define AFX_OMPRESSEDPOSITIONINTERPOLATOR_H__174DA657_46F9_48D8_A469_94562461D20D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "KeyHeader.h"
#include "PosIKeyValueHeader.h"
#include "KeySelectionFlag.h"
#include "Key.h"
#include "PosIKeyValue.h"

class CompressedPositionInterpolator  
{
public:
	CompressedPositionInterpolator();
	virtual ~CompressedPositionInterpolator();

public:
	void decode(char* fileName);

#if defined SAIT_CONFORMANCE_2003
	void write(char* fileName, int defID = -1);
	void setValues(unsigned char* pData);
#else
	void write(char* fileName);
#endif SAIT_CONFORMANCE_2003

	// 20020711 for BitWrapper
	void decodeWithBuffer(char* fileName, int nLength = -1);

public:
	// PDAM ̸ .
	KeyHeader kHeader;
	PosIKeyValueHeader posIKVHeader;
	KeySelectionFlag ksFlag;
	Key k;
	PosIKeyValue posIKV;

public:
	JWArray<double> key;
	JWArray<SFVec3f> keyValue;

protected:
	bool m_bIsDEF;
	char m_strDEF[256];
	int m_nKeyDigit;
	int m_nKeyValueDigit;
};

#endif // !defined(AFX_OMPRESSEDPOSITIONINTERPOLATOR_H__174DA657_46F9_48D8_A469_94562461D20D__INCLUDED_)
