// CCQ class
// Author: Shinjun Lee, Samsung AIT
// Date: 2001. 10. 17. Wed.
// 2nd revision: 2002. 1. 23. Wed.

#ifndef _CCQ_H_
#define _CCQ_H_

#include <iostream.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>

#define DPCM_T	1
#define DPCM_S	2
#define DPCM_TS	3

class CCQ
	{
  public:
	// circular quantize
	int quantize(int nValue, int nMin, int nMax)
		{
		int nLength = nMax - nMin + 1;
		int nComplement = 0;
		int nReturn = nValue;

		if(nValue < 0)
			nComplement = nValue + nLength;
		else
			nComplement = nValue - nLength;

		if(abs(nValue) > abs(nComplement))
			nReturn = nComplement;
		else if(abs(nValue) == abs(nComplement) && nValue / nComplement == -1)
			nReturn = abs(nValue);

		return nReturn;
		}

	// inverse circular quantize
	int inverseQuantize(int nValue, int nMin, int nMax, int nPrevious = 0)
		{
		int nLength = nMax - nMin + 1;
		int nComplement = 0;
		int nReturn = nValue;

		if(nValue < 0)
			nComplement = nValue + nLength;
		else
			nComplement = nValue - nLength;

		if(nMin <= nPrevious + nValue && nPrevious + nValue <= nMax)
			nReturn = nPrevious + nValue;
		else if(nMin <= nPrevious + nComplement && nPrevious + nComplement <= nMax)
			nReturn = nPrevious + nComplement;

		return nReturn;
		}

	// circular quantize: first value
	int quantizeFirstValue(int nValue, int nMin, int nMax)
		{
		int nLow = nValue - nMin;
		int nHigh = nValue - nMax - 1;

		if(abs(nLow) <= abs(nHigh))
			nValue = nLow;
		else
			nValue = nHigh;

		return nValue;
		}

	// inverse circular quantize: first value
	int inverseQuantizeFirstValue(int nValue, int nMin, int nMax)
		{
		if(nValue < 0)
			nValue = nValue + nMax + 1;
		else
			nValue = nValue + nMin;

		return nValue;
		}
	};

#endif // _CCQ_H_