// CParser.h
// Editor: Shinjun Lee, Samsung AIT
// Date: 2001-12-28

#ifndef _CPARSER_H_
#define _CPARSER_H_

#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>

class CParser
	{
private:
	char		m_szInputCIFile[_MAX_FNAME];	// input CI text file name

public:
	CParser(void)
		{
		strcpy(m_szInputCIFile, "");
		}

	// set: CI input file
	void setInputCIFile(char* szInputCIFile)
		{
		strcpy(m_szInputCIFile, szInputCIFile);
		}

	// read: key
	void readKey(double*& a_dKey, int& nNumberOfKey, int& nDigit_max)
		{
		ifstream fin;					// file variable
		char szLine[256];				// line buffer
		int nStateOfKey = 0;			// status
		streampos posIn = 0;			// file pointer
		char a_chSeps[] = " ,\t\n\r";	// separator
		char* pchToken = NULL;			// token
		char* pchDot = NULL;			// pointer of dot
		int nDigit = 0;					// key digit
		int nIndex = 0;					// index

		nNumberOfKey = 0;
		fin.open(m_szInputCIFile, ios::in | ios::nocreate | ios::binary);
		posIn = fin.tellg();
		while(!fin.fail() && !fin.eof())
			{
			if(pchToken == NULL)
				{
				fin.getline(szLine, 255, '\n');	 // read a line
				pchToken = strtok(szLine, a_chSeps);
				}
			else
				pchToken = strtok(NULL, a_chSeps);

			if(pchToken == NULL)
				continue;

			switch(nStateOfKey)
				{
				case 0:					// do until it finds "key" identifier
					if(!strcmp(pchToken, "key"))
						nStateOfKey++;
					else
						posIn = fin.tellg();
					break;

				case 1:
					if(!strcmp(pchToken, "["))
						nStateOfKey++;
					break;

				case 2:					// count the number of key
					if(!strcmp(pchToken, "]"))
						nStateOfKey++;
					else
						nNumberOfKey++;
					break;

				}
			if(nStateOfKey == 3)
				break;
			}
		if(fin.eof())
			{
			fin.close();
			fin.open(m_szInputCIFile, ios::in | ios::nocreate | ios::binary);
			}
		// allocate: data of key
		a_dKey = new double[nNumberOfKey];

		// read: data of key
		nIndex = 0;
		nDigit_max = 0;
		nStateOfKey = 0;
		pchToken = NULL;
		fin.seekg(posIn, ios::beg);
		while(!fin.fail() && !fin.eof())
			{
			if(pchToken == NULL)
				{
				fin.getline(szLine, 255, '\n'); // read a line
				pchToken = strtok(szLine, a_chSeps);
				}
			else
				pchToken = strtok(NULL, a_chSeps);

			if(pchToken == NULL)
				continue;

			switch(nStateOfKey)
				{
				case 0:					// do until it finds "key" identifier
					if(!strcmp(pchToken, "key"))
						nStateOfKey++;
					break;

				case 1:
					if(!strcmp(pchToken, "["))
						nStateOfKey++;
					break;

				case 2:					// count the number of key
					if(!strcmp(pchToken, "]"))
						nStateOfKey++;
					else
						{
						a_dKey[nIndex] = (double)atof(pchToken);
						nDigit = getDigit(pchToken);
						if(nDigit_max < nDigit)
							nDigit_max = nDigit;
						//cout << a_dKey[nIndex] << " ";
						nIndex++;
						}
					break;

				}
			if(nStateOfKey == 3)
				break;
			}

		fin.close();
		}

	// read: keyValue
	void readKeyValue(double*& a_dKeyValue, int nNumberOfKey, int& nNumberOfCoord, int& nDigit_max)
		{
		ifstream fin;					// file variable
		char szLine[256];				// line buffer
		int nStateOfKeyValue = 0;		// status
		streampos posIn = 0;			// file pointer
		char a_chSeps[] = " ,\t\n\r";	// separator
		char* pchToken = NULL;			// token
		char* pchDot = NULL;			// dot 
		int nDigit = 0;					// key digit
		int nIndex = 0;					// index
		int nNumberOfKeyValue = 0;		// the number of keyValue

		nNumberOfCoord = 0;
		fin.open(m_szInputCIFile, ios::in | ios::nocreate | ios::binary);
		posIn = fin.tellg();
		while(!fin.fail() && !fin.eof())
			{
			if(pchToken == NULL)
				{
				fin.getline(szLine, 255, '\n');	 // read a line
				pchToken = strtok(szLine, a_chSeps);
				}
			else
				pchToken = strtok(NULL, a_chSeps);

			if(pchToken == NULL)
				continue;

			switch(nStateOfKeyValue)
				{
				case 0:					// do until it finds "keyValue" identifier
					if(!strcmp(pchToken, "keyValue"))
						nStateOfKeyValue++;
					else
						posIn = fin.tellg();
					break;

				case 1:
					if(!strcmp(pchToken, "["))
						nStateOfKeyValue++;
					break;

				case 2:					// count the number of keyValue
					if(!strcmp(pchToken, "]"))
						nStateOfKeyValue++;
					else
						nNumberOfKeyValue++;
					break;

				}
			if(nStateOfKeyValue == 3)
				break;
			}
		if(fin.eof())
			{
			fin.close();
			fin.open(m_szInputCIFile, ios::in | ios::nocreate | ios::binary);
			}
		// allocate: data of keyValue
		nNumberOfCoord = nNumberOfKeyValue/nNumberOfKey/3;
		a_dKeyValue = new double[nNumberOfKey*nNumberOfCoord*3];

		// read: data of keyValue
		nIndex = 0;
		nDigit_max = 0;
		nStateOfKeyValue = 0;
		pchToken = NULL;
		fin.seekg(posIn, ios::beg);
		while(!fin.fail() && !fin.eof())
			{
			if(pchToken == NULL)
				{
				fin.getline(szLine, 255, '\n'); // read a line
				pchToken = strtok(szLine, a_chSeps);
				}
			else
				pchToken = strtok(NULL, a_chSeps);

			if(pchToken == NULL)
				continue;

			switch(nStateOfKeyValue)
				{
				case 0:					// do until it finds "keyValue" identifier
					if(!strcmp(pchToken, "keyValue"))
						nStateOfKeyValue++;
					break;

				case 1:
					if(!strcmp(pchToken, "["))
						nStateOfKeyValue++;
					break;

				case 2:					// count the number of keyValue
					if(!strcmp(pchToken, "]"))
						nStateOfKeyValue++;
					else
						{
						a_dKeyValue[nIndex] = atof(pchToken);
						nDigit = getDigit(pchToken);
						if(nDigit_max < nDigit)
							nDigit_max = nDigit;
						//cout << a_dKeyValue[nIndex] << " ";
						nIndex++;
						}
					break;

				}
			if(nStateOfKeyValue == 3)
				break;
			}
		fin.close();
		}

	// Transpose: source data -> target data which is transposed
	void transpose(double* a_dKeyValue_target, double* a_dKeyValue_source, int nNumberOfKey, int nNumberOfCoord)
		{
		double* a_dKeyValue = new double[nNumberOfKey*nNumberOfCoord*3];
		memcpy((void*)a_dKeyValue, (void*)a_dKeyValue_source, sizeof(double)*(nNumberOfKey*nNumberOfCoord*3));

		for(int j = 0; j < nNumberOfCoord; j++)
			{
			for(int i = 0; i < nNumberOfKey; i++)
				{
				for(int c = 0; c < 3; c++)
					{
					double dValue = a_dKeyValue[i*nNumberOfCoord*3+j*3+c];

					a_dKeyValue_target[j*nNumberOfKey*3+i*3+c] = dValue;
					//cout << dValue;
					//cout << ", ";
					}
				//cout << endl;
				}
			//cout << endl;
			}

		delete[] a_dKeyValue;
		}

private:
	// get: the valid digit of a number
	int getDigit(char* pchToken)
		{
		int nStrLen = strlen(pchToken);		// the length of a string
		int nPosStart = 0;					// position of start
		int nPosEnd = nStrLen-1;			// position of end
		int nDigit = 0;						// valid digit
		int i = 0;							// index

		// find: start position of the number
		for(i = 0; i < nStrLen; i++)
			{
			if('1' <= pchToken[i] && pchToken[i] <= '9')
				break;
			}
		nPosStart = i;

		// find: last position of the number
		for(i = nStrLen-1; i >= 0; i--)
			{
			if('1' <= pchToken[i] && pchToken[i] <= '9')
				break;
			}
		nPosEnd = i;

		// calculate: the valid digit of the number
		nDigit = 0;
		for(i = nPosStart; i <= nPosEnd; i++)
			{
			if('0' <= pchToken[i] && pchToken[i] <= '9')
				nDigit++;
			if(pchToken[i] == 'e' || pchToken[i] == 'E')
				break;
			}

		return nDigit;
		}
	};

#endif // _CPARSER_H_