/***********************************************************************
This software module was originally developed by James D. K. Kim, 
Sang Oak Woo and Shin Jun Lee(Samsung Advance Institute of Technology)
in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
standard. This software module is an implementation of a part of one or
more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4
Systems (ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 
Systems (ISO/IEC 14496-1) free license to this software module or 
modifications thereof for use in hardware or software products claiming
conformance to the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to 
use this software module in hardware or software products are advised that
its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Samsung Advance Institute of Technology
retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using
the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
This copyright notice must be included in all copies or derivative works.
Copyright  2001
************************************************************************

For more information or to receive an up to date version of this module,
you may contact James D. K. Kim at jacobkim@sait.samsung.co.kr
----------------------------------------------------------------------*/

// KeySelectionFlag.cpp: implementation of the KeySelectionFlag class.
//
//////////////////////////////////////////////////////////////////////

#include "defs.h"
//#include "stdafx.h"
#include "KeySelectionFlag.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

KeySelectionFlag::KeySelectionFlag()
{

}

KeySelectionFlag::~KeySelectionFlag()
{

}

void KeySelectionFlag::readBitstream(
	CAC_QF& codec, KeyHeader& kHeader, unsigned int bPreserveKey
)
{
	int i = 0;
	nNumOfKeyValue = 0;
	if(bPreserveKey == 1)
	{
		keyFlag.SetSize(kHeader.nNumberOfKey);

		for(i=0; i<kHeader.nNumberOfKey; i++)
		{
			//qf_decode(&keyFlag[i], keyFlagContext);
			keyFlag[i] = codec.decode(keyFlagContext);
			if(keyFlag[i] == 1)
				nNumOfKeyValue++;
		}
	}
	else
		nNumOfKeyValue = kHeader.nNumberOfKey;
}


void KeySelectionFlag::InitializeModel()
{
	keyFlagContext.reset();
}
