// CompressedOrientationInterpolator.h: interface for the CompressedOrientationInterpolator class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMPRESSEDORIENTATIONINTERPOLATOR_H__80FCEE35_BF65_42F3_91D1_B413F1072B33__INCLUDED_)
#define AFX_COMPRESSEDORIENTATIONINTERPOLATOR_H__80FCEE35_BF65_42F3_91D1_B413F1072B33__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "KeyHeader.h"
#include "OriIKeyValueHeader.h"
#include "KeySelectionFlag.h"
#include "Key.h"
#include "OriIDPCMKeyValue.h"
#include "SFRotation.h"
#include "Entropy.h"
#include "JWToken.h"
#include "JWInterpolator.h"
#include "SelectedKeyFrame.h"
#include "QuatError.h"

class CompressedOrientationInterpolator  
{
public:
	CompressedOrientationInterpolator();
	virtual ~CompressedOrientationInterpolator();

public:
	void encode(char* orgFileName, char* quantFileName, char* aacFileName, char* errorFileName,
				bool bPreserveKey, bool IsLinearKeyCoder, 
				bool bIsUnaryAAC_X, bool bIsUnaryAAC_Y, bool bIsUnaryAAC_Z,
				bool bKeyQuant, char chDPCM,
				JWArray<double> adThresholds, JWArray<int>anKQBits, JWArray<int> anKVQBits);


	double downsampling_with_QC(JWArray<Quaternion>& kvn,
								JWArray<double>& key,
								int key_count, 
								JWArray<double>& adThresholds,
								JWArray<CSelectedKeyFrame>& aKeyFrames);
	
	void interpolate_with_QC(JWArray<Quaternion>& kvn,
							 JWArray<Quaternion>& kvi,
							 JWArray<int>& keyFlag,
							 JWArray<double>& key,
							 int key_count); 

	void select_key_and_kv (JWArray<double>& key,
							JWArray<double>& q_key,
							JWArray<Quaternion>& keyValue,
							JWArray<Quaternion>& q_keyValue,
							JWArray<SFRotation>& InRot,
							JWArray<SFRotation>& q_InRot,
							int &n_q_key,
							JWArray<int>& keyFlag,
							int key_count);
	
public:
	// PDAM ̸ .
	KeyHeader kHeader;
	OriIKeyValueHeader oriIKVHeader;
	KeySelectionFlag ksFlag;
	Key k;
	OriIDPCMKeyValue oriIDPCMKeyValue;

public:
	JWArray <double> dKey;
	JWArray <SFRotation> dKeyValue;

	// temporary value for error calculation
	JWArray <Quaternion> dKeyValueQuat;

};

#endif // !defined(AFX_COMPRESSEDORIENTATIONINTERPOLATOR_H__80FCEE35_BF65_42F3_91D1_B413F1072B33__INCLUDED_)
