// JWDictionary.cpp: implementation of the JWDictionary class.
//
//////////////////////////////////////////////////////////////////////

#include "JWDictionary.h"
//#include "misc.h"

#include <fstream.h>
#include <math.h>

#if !defined AACTotal
#define AACTotal(codec) (codec._ostrm->Outbuf.nbits + codec._ostrm->Outbuf.nbytes*8)
#endif


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

JWDictionary::JWDictionary():
	m_nNumberOfValues(-1)
{

}

JWDictionary::~JWDictionary()
{

}


// DPCM  м, dictionary 
void JWDictionary::Encode(JWArray<int>& aValues)
{
/*	// 1.  bits 
	int nTotalBits = 0;

	for(int i=0; i<aValues.GetSize(); i++)
		nTotalBits += getNbBits(aValues[i]);

	m_a

	// 2. Ѿ߸
*/
	m_aKnockDownValues.Copy(aValues);

	m_nNumberOfValues = aValues.GetSize();
}

// DPCM  м, dictionary 
void JWDictionary::Encode(int* aValues, int nNum)
{
/*	// 1.  bits 
	int nTotalBits = 0;

	for(int i=0; i<aValues.GetSize(); i++)
		nTotalBits += getNbBits(aValues[i]);

	m_a

	// 2. Ѿ߸
*/
	m_aKnockDownValues.Copy(aValues, nNum);

	m_nNumberOfValues = nNum;
}



// Header Information Bitstream...
void JWDictionary::MakeBitstream_Header(CAC_QF& codec)
{
	// ? ƴϴ. ִ.
	int nBits = getNbBits(m_nNumberOfValues);

	codec._ostrm->putbits(nBits, 5);
	codec._ostrm->putbits(m_nNumberOfValues, nBits);

	codec._ostrm->putbits(m_nQBit, 5);
}


// encoding ͵ AAC  bitstream...
//void JWDictionary::MakeBitstream_AAC(CAC_QF& codec)
// Jameskim 20020425
void JWDictionary::MakeBitstream_AAC(CAC_QF& codec, CAC& kvUSignContext, CAC& kvUContext)
{
	//cac_KnockDown_context.reset();
	//cac_sign_context.reset();

	int nUsedBits = AACTotal(codec);
	int nUsedBits_OneSymbol;
	int nTotalInputSpace = 0;
	int
		nNumberOfOne = 0,
		nNumberOfZero = 0;

	int nBits;


	ofstream file;
	file.open("KnockDownEncoding.txt");

	for(int i=0; i<m_aKnockDownValues.GetSize(); i++)
	{
		nUsedBits_OneSymbol = AACTotal(codec);

		nBits = abs(m_aKnockDownValues[i]);

		for(int j=0; j<nBits; j++)
		{
			codec.encode(0, kvUContext);
			nNumberOfOne++;
		}

		codec.encode(1, kvUContext);

		// sign coding
		if(m_aKnockDownValues[i] != 0)
			codec.encode((m_aKnockDownValues[i]>0)? 0:1, kvUSignContext);

		nNumberOfZero++;

		nTotalInputSpace += nBits + 1;

		nUsedBits_OneSymbol = AACTotal(codec) - nUsedBits_OneSymbol;

		file << m_aKnockDownValues[i] << '\t';
		file << nUsedBits_OneSymbol << endl;
	}
	nUsedBits = AACTotal(codec) - nUsedBits;


	file.close();

	cout << " quatization space: ";
	cout << m_nNumberOfValues << '*' << m_nQBit << " = ";
	cout << m_nNumberOfValues*m_nQBit << endl;
	cout << " input space: " << nTotalInputSpace << " (";
	cout << "# of 1: " << nNumberOfOne << ", ";
	cout << "# of 0: " << nNumberOfZero << ')' << endl;
	cout << " encoding Bit : " << nUsedBits << endl;
	cout << "encoding ȿ: " << (float)nUsedBits/nTotalInputSpace*100 << endl;
}





//////////////////////////////////////////////
//
// Decoder  Լ!
// 
//////////////////////////////////////////////


// Decoder  Լ!
void JWDictionary::Decode(JWArray<int>& aValues)
{
}

// Header information decoding
void JWDictionary::BreakBitstream_Header(CAC_QF& codec)
{
	// ? ƴϴ. ִ.
	int nBits = codec._istrm->getbits(5);
	m_nNumberOfValues = codec._istrm->getbits(nBits);

	m_nQBit = codec._istrm->getbits(5);
}

// bitstream decoding
void JWDictionary::BreakBitstream_AAC(CAC_QF& codec)
{
}

// bitstream decoding & Decode
void JWDictionary::BreakBitstream_AAC_and_Decode(CAC_QF& codec, JWArray<int>& aValues)
{
	cac_KnockDown_context.reset();
	cac_sign_context.reset();


	aValues.SetSize(m_nNumberOfValues);

	int nOneBit;
	int nBits = -1;

	for(int i=0; i<m_nNumberOfValues; i++)
	{
		do {
			nOneBit = codec.decode(cac_KnockDown_context);
			nBits++;
		} while(nOneBit == 0);

		if(nBits != 0)
		{
			nOneBit = codec.decode(cac_sign_context);

			if(nOneBit == 0)
				aValues[i] = nBits;
			else
				aValues[i] = -nBits;
		}
		else
			aValues[i] = nBits;


		nBits = -1;
	}
}



int JWDictionary::getNbBits(int k)
{
	int j=1;
	while (k >= (1<<j) ) 
		j++;

	return j;
}

