// JWOrientationInterpolator.h: interface for the JWOrientationInterpolator class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_JWORIENTATIONINTERPOLATOR_H__E7602EF6_EC0D_45A3_8B01_E15449AE1012__INCLUDED_)
#define AFX_JWORIENTATIONINTERPOLATOR_H__E7602EF6_EC0D_45A3_8B01_E15449AE1012__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "JWInterpolator.h"
#include "SFRotation.h"


//typedef Rotation SFRotation;

class JWToken;

class JWOrientationInterpolator : public JWInterpolator  
{
public:
	JWOrientationInterpolator();
	virtual ~JWOrientationInterpolator();

public:
	void Parse(JWToken& token);
	void Write(ofstream& file);
	double Purify(double threshold, JWInterpolator*& pInterpolator);

	double DownSampling_With_QC(JWArray<Quaternion>& kvn, JWArray<int>& keyFlag, JWArray<double>& key,
			int key_count, double distortion_threshold);

	void Interpolate_With_QC(JWArray<Quaternion>& kvn, JWArray<Quaternion>& kvi, JWArray<int>& keyFlag,
			JWArray<double>& key, int key_count);

	void Select_Key_and_KV (JWArray<double>& key, JWArray<double>& q_key, JWArray<Quaternion>& keyValue,
			JWArray<Quaternion>& q_keyValue, JWArray<SFRotation>& InRot, JWArray<SFRotation>& q_InRot,
			int &n_q_key, JWArray<int>& keyFlag, int key_count);



	friend ofstream& operator << (ofstream& os, JWOrientationInterpolator& pI);



	// sowoo 2002.01.24 (Resampling)
	void Resampling(int nNumKey, int nDigit = -1);


public:
	void SetSize(int size);
	void Add(double key, void* keyValue);
	void SetKeyValue(int index, void* keyvalue) { m_aKeyValues[index] = *((SFRotation*)keyvalue); }
	void* GetKeyValues() { return (void *)&m_aKeyValues; }

protected:
	JWArray<SFRotation> m_aKeyValues;
};

#endif // !defined(AFX_JWORIENTATIONINTERPOLATOR_H__E7602EF6_EC0D_45A3_8B01_E15449AE1012__INCLUDED_)
