// JWToken.cpp: implementation of the JWToken class.
//
//////////////////////////////////////////////////////////////////////

#include "JWToken.h"
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

#define SetSymbolAndToken2(index, SYMBOL, TOKEN) \
	m_aSymbols[index] = SYMBOL;\
	m_aTokens[index] = ::strdup(#TOKEN);\
	index++


#define SetSymbolAndToken(index, SYMBOL) \
	m_aSymbols[index] = SYMBOL;\
	m_aTokens[index] = ::strdup(#SYMBOL);\
	index++


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

JWToken::JWToken():
	m_nLine(0), m_eSymbol(NONEOFTHEM),
	nNumberOfSymbols(13)
{
	::strcpy(m_strToken, "");

	// Symbol Token ʱȭ Ѵ.
	m_aSymbols.SetSize(nNumberOfSymbols);
	m_aTokens.SetSize(nNumberOfSymbols);

	int i=0;

	SetSymbolAndToken2(i, BRACE_CLOSE, });
	SetSymbolAndToken2(i, BRACE_OPEN, {);
	SetSymbolAndToken2(i, SQUAREBRACKET_CLOSE, ]);
	SetSymbolAndToken2(i, SQUAREBRACKET_OPEN, [);
	SetSymbolAndToken(i, children);
	SetSymbolAndToken(i, CoordinateInterpolator);
	SetSymbolAndToken(i, DEF);
	SetSymbolAndToken(i, Group);
	SetSymbolAndToken(i, key);
	SetSymbolAndToken(i, keyValue);
	SetSymbolAndToken(i, OrientationInterpolator);
	SetSymbolAndToken(i, PositionInterpolator);
	SetSymbolAndToken(i, USE);
}


JWToken::~JWToken()
{
	if(m_file.is_open())
		m_file.close();

	for(int i=0; i<nNumberOfSymbols; i++)
		delete m_aTokens[i];
}

bool JWToken::SetFile(char* fileName)
{
	m_file.open(fileName);

	if(!m_file.is_open())
		return false;

	return true;
}

char* JWToken::GetNextToken()
{
	char ch[2];
	char buffer[256];

	EatWhiteAndComment();

	::strcpy(buffer, "");
	ch[1] = NULL;
	while(true)
	{
		m_file.get(ch[0]);
		if(ch[0] == -1)
			return NULL;
		else if(!(::isalnum(ch[0]) || ch[0] == '_' || ch[0] == '-'))
			break;

		::strcat(buffer, ch);
	}


	if(::strcmp(buffer, "") == 0)
		::strcpy(buffer, ch);

	m_eSymbol = GetSymbol(buffer);

	::strcpy(m_strToken, buffer);
	return m_strToken;
}

Symbol JWToken::GetSymbol(char* token)
{
	for(int i=0; i<nNumberOfSymbols; i++)
	{
		if(::strcmp(token, m_aTokens[i]) == 0)
			return m_aSymbols[i];
	}

	return NONEOFTHEM;
}

double JWToken::GetRealNumber()
{
	char buffer[256];
	char ch[2];

	EatWhiteAndCommentAnd();

	::strcpy(buffer, "");
	ch[1] = NULL;
	while(true)
	{
		ch[0] = m_file.peek();
		if(ch[0] == -1)
			return NULL;

		if(!(::isdigit(ch[0]) || ch[0] == '.' || ch[0] == 'E' ||
			ch[0] == 'e' || ch[0] == '-'))
			break;

		m_file.get(ch[0]);
		::strcat(buffer, ch);
	}

	if(::strcmp(buffer, "") == 0)
	{
		GetNextToken();

		// ǹ   return
		return 0.0;
	}

	m_eSymbol = REALNUMBER;
	return ::atof(buffer);
}

void JWToken::EatWhiteAndComment()
{
	char ch;
	// 1. Parsingϱ  whilte space
	m_file.eatwhite();

	// 2. ',' ϱ
	ch = m_file.peek();

	while(ch == '#' || ch == ' ' || ch == '\n' || ch == '\t')
	{
		if(ch == -1)
			return ;

		if(ch == ',')
		{
			m_file.get(ch);
			if(ch == NULL)
				return ;

			m_file.eatwhite();
		}
		else if(ch == '#')
		{
			char buffer[1000];
			m_file.getline(buffer, 1000);
		}

		//    
		m_file.eatwhite();
		ch = m_file.peek();
	}
}

void JWToken::EatWhiteAndCommentAnd(char deli)
{
	char ch;
	// 1. Parsingϱ  whilte space
	m_file.eatwhite();

	// 2. ',' ϱ
	ch = m_file.peek();

	while(ch == '#' || ch == ' ' || ch == '\n' || ch == '\t' || ch == deli)
	{
		if(ch == -1)
			return ;

		if(ch == ',')
		{
			m_file.get(ch);
			if(ch == NULL)
				return ;

			m_file.eatwhite();
		}
		else if(ch == '#')
		{
			char buffer[1000];
			m_file.getline(buffer, 1000);
		}

		//    
		m_file.eatwhite();
		ch = m_file.peek();
	}
}
