// OriIDPCMKeyValue.cpp: implementation of the OriIDPCMKeyValue class.
//
//////////////////////////////////////////////////////////////////////

#include "OriIDPCMKeyValue.h"


#define M_PI				3.1415926535897932384338

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

OriIDPCMKeyValue::OriIDPCMKeyValue()
{
	m_prevQuat = new Quaternion;
}

OriIDPCMKeyValue::~OriIDPCMKeyValue()
{
	delete m_prevQuat;
}

void OriIDPCMKeyValue::InitializeModel()
{
	int i;

	kvXUSignContext.reset();  
	kvXUContext.reset();
	kvYUSignContext.reset();  
	kvYUContext.reset();
	kvZUSignContext.reset();  
	kvZUContext.reset();
	kvXSignContext.reset();
	for(i = 0;i < 32;i++)
		kvXContext[i].reset();
	kvYSignContext.reset();
	for(i = 0;i < 32;i++)
		kvYContext[i].reset();
	kvZSignContext.reset();
	for(i = 0;i < 32;i++)
		kvZContext[i].reset();
}


void OriIDPCMKeyValue::makeBitstream(CAC_QF& codec, 
						unsigned int x_keyvalue_flag,
						unsigned int y_keyvalue_flag,
						unsigned int z_keyvalue_flag,
						int* numBitsKV,
						bool bIsUnaryAAC_X, bool bIsUnaryAAC_Y, bool bIsUnaryAAC_Z,
						unsigned int nDPCMOrder)
{
	int i;
	//int keyValueAACTotal = 0;
	//int prevBitTotal = AACTotal();


	if(nDPCMOrder == 0)
	{
		// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
		//
		//
		//						KeyValue AAC Coder By Jameskim (1st DPCM)
		//
		//
		// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@	

		int	gnKeyValueBits_X = 0, gnKeyValueBits_Y = 0, gnKeyValueBits_Z = 0;

		int nNumberOfValues = DeltaKeyValue.GetSize();
		int* aX = new int[nNumberOfValues];
		int* aY = new int[nNumberOfValues];
		int* aZ = new int[nNumberOfValues];


		for(i=0; i<nNumberOfValues; i++)
		{
			aX[i] = (int) DeltaKeyValue[i].x;
			aY[i] = (int) DeltaKeyValue[i].y;
			aZ[i] = (int) DeltaKeyValue[i].z;
		}

		if(x_keyvalue_flag != 0)
		{
			//gnKeyValueBits_X = AACTotal();
			if(bIsUnaryAAC_X)
			{
				JWDictionary knockDownEncoder_X;
				knockDownEncoder_X.Encode(aX, nNumberOfValues);
				//knockDownEncoder_X.MakeBitstream_AAC(codec);
				knockDownEncoder_X.MakeBitstream_AAC(codec, kvXUSignContext, kvXUContext);
			}
			else
			{
				for(i = 0;i < DeltaKeyValue.GetSize();i++)
					encodeSignedAAC(codec, (int)DeltaKeyValue[i].x, numBitsKV[0],
									kvXSignContext, kvXContext);

			}
			//gnKeyValueBits_X = AACTotal() - gnKeyValueBits_X;
		}


		if(y_keyvalue_flag != 0)
		{
			//gnKeyValueBits_Y = AACTotal();
			if(bIsUnaryAAC_Y)
			{
				JWDictionary knockDownEncoder_Y;
				knockDownEncoder_Y.Encode(aY, nNumberOfValues);
				//knockDownEncoder_Y.MakeBitstream_AAC(codec);
				knockDownEncoder_Y.MakeBitstream_AAC(codec, kvYUSignContext, kvYUContext);
			}
			else
			{
				for(i = 0;i < DeltaKeyValue.GetSize();i++)
					encodeSignedAAC(codec, (int)DeltaKeyValue[i].y, numBitsKV[1],
									kvYSignContext, kvYContext);

			}
			//gnKeyValueBits_Y = AACTotal() - gnKeyValueBits_Y;
		}


		if(z_keyvalue_flag != 0)
		{
			//gnKeyValueBits_Z = AACTotal();
			if(bIsUnaryAAC_Z)
			{
				JWDictionary knockDownEncoder_Z;
				knockDownEncoder_Z.Encode(aZ, nNumberOfValues);
				//knockDownEncoder_Z.MakeBitstream_AAC(codec);
				knockDownEncoder_Z.MakeBitstream_AAC(codec, kvZUSignContext, kvZUContext);
			}
			else
			{
				for(i = 0;i < DeltaKeyValue.GetSize();i++)
					encodeSignedAAC(codec, (int)DeltaKeyValue[i].z, numBitsKV[2],
									kvZSignContext, kvZContext);
	
			}
			//gnKeyValueBits_Z = AACTotal() - gnKeyValueBits_Z;
		}

		//printf("AAC key value bit : %d\n\n", gnKeyValueBits_X+gnKeyValueBits_Y+gnKeyValueBits_Z);

		//keyValueAACTotal = gnKeyValueBits_X+gnKeyValueBits_Y+gnKeyValueBits_Z;
			
	}
	else if(nDPCMOrder == 1)
	{
		// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
		//
		//
		//						KeyValue AAC Coder By Jameskim (2nd DPCM)
		//
		//
		// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@	
		int	gnKeyValueBits_X = 0, gnKeyValueBits_Y = 0, gnKeyValueBits_Z = 0;

		int nNumberOfValues = DeltaKeyValue.GetSize();
		int* aX = new int[nNumberOfValues];
		int* aY = new int[nNumberOfValues];
		int* aZ = new int[nNumberOfValues];


		for(int i=0; i<nNumberOfValues; i++)
		{
			aX[i] = (int) DeltaKeyValue[i].x;
			aY[i] = (int) DeltaKeyValue[i].y;
			aZ[i] = (int) DeltaKeyValue[i].z;
		}

		if(x_keyvalue_flag != 0)
		{
			//gnKeyValueBits_X = AACTotal();
			if(bIsUnaryAAC_X)
			{
				JWDictionary knockDownEncoder_X;
				knockDownEncoder_X.Encode(aX, nNumberOfValues);
				//knockDownEncoder_X.MakeBitstream_AAC(codec);
				knockDownEncoder_X.MakeBitstream_AAC(codec, kvXUSignContext, kvXUContext);
			}
			else
			{
				for(i = 0;i < DeltaKeyValue.GetSize();i++)
					encodeSignedAAC(codec, (int)DeltaKeyValue[i].x, numBitsKV[0],
									kvXSignContext, kvXContext);
					
			}
			//gnKeyValueBits_X = AACTotal() - gnKeyValueBits_X;
		}


		if(y_keyvalue_flag != 0)
		{
			//gnKeyValueBits_Y = AACTotal();
			if(bIsUnaryAAC_Y)
			{
				JWDictionary knockDownEncoder_Y;
				knockDownEncoder_Y.Encode(aY, nNumberOfValues);
				//knockDownEncoder_Y.MakeBitstream_AAC(codec);
				knockDownEncoder_Y.MakeBitstream_AAC(codec, kvYUSignContext, kvYUContext);
			}
			else
			{
				for(i = 0;i < DeltaKeyValue.GetSize();i++)
					encodeSignedAAC(codec, (int)DeltaKeyValue[i].y, numBitsKV[1],
									kvYSignContext, kvYContext);
			}
			//gnKeyValueBits_Y = AACTotal() - gnKeyValueBits_Y;
		}


		if(z_keyvalue_flag != 0)
		{
			//gnKeyValueBits_Z = AACTotal();
			if(bIsUnaryAAC_Z)
			{
				JWDictionary knockDownEncoder_Z;
				knockDownEncoder_Z.Encode(aZ, nNumberOfValues);
				//knockDownEncoder_Z.MakeBitstream_AAC(codec);
				knockDownEncoder_Z.MakeBitstream_AAC(codec, kvZUSignContext, kvZUContext);
			}
			else
			{
				for(i = 0;i < DeltaKeyValue.GetSize();i++)
					encodeSignedAAC(codec, (int)DeltaKeyValue[i].z, numBitsKV[2],
									kvZSignContext, kvZContext);
			}
			//gnKeyValueBits_Z = AACTotal() - gnKeyValueBits_Z;
		}

		//printf("AAC key value bit : %d\n\n", gnKeyValueBits_X+gnKeyValueBits_Y+gnKeyValueBits_Z);

		//keyValueAACTotal = gnKeyValueBits_X+gnKeyValueBits_Y+gnKeyValueBits_Z;
	}
	else
	{
		printf(" ȣȭ 1 Ǵ 2 CPDM մϴ. \n");
		exit(0);
	}

	//return keyValueAACTotal;



}











void OriIDPCMKeyValue::encodingProcess(unsigned int nDPCMOrder, 
									   unsigned int nKVQBit, 
									   CSelectedKeyFrame selectedKeyFrame)
{

	m_prevQuat->s = 1.0;
	m_prevQuat->x = 0.0;
	m_prevQuat->y = 0.0;
	m_prevQuat->z = 0.0;

	//------------------------------------------------------------------------
	//
	// encoding and decoding first key value for using to compensate next coded key value
	//
	//------------------------------------------------------------------------
	IntraKeyValueCoding(selectedKeyFrame.GetSelectedQuaternions(), DPCMKeyValue, decodedKeyValue,
						nKVQBit, m_prevQuat);


	
	//------------------------------------------------------------------------
	//
	// DPCM of key values
	//
	//------------------------------------------------------------------------
	double dMaxS = 1.0;double dMaxX = 1.0;double dMaxY = 1.0;double dMaxZ = 1.0;
	CalculateDPCMKeyValue(selectedKeyFrame.GetSelectedQuaternions(), selectedKeyFrame.GetNumberOfSelectedKeys(),
							nKVQBit, dMaxS, dMaxX, dMaxY, dMaxZ,
							m_prevQuat, DPCMKeyValue, decodedKeyValue);



	//------------------------------------------------------------------------
	//
	// 2nd Circular DPCM of key values 
	//
	//------------------------------------------------------------------------
	if(nDPCMOrder == 1)
		CalculateReDPCMKeyValue(DPCMKeyValue, selectedKeyFrame.GetNumberOfSelectedKeys(),
								ReDPCMQKeyValue, nKVQBit);

}


void OriIDPCMKeyValue::IntraKeyValueCoding(JWArray<Quaternion> prevSelectedQuat,
										   JWArray<Quaternion>& dQKeyValue, 
										   JWArray<Quaternion>& endecodedQuat,
										   int m,
										   Quaternion* m_prevQuat)
{

	/////////////////////////////////////////////////////////////////////
	//  ù° Key value intra ڵѴ.
	Quaternion	Diff, Temp, Quant, DeQuant, InvDiff, IntraQuat;
	Quantizer	EnQuantizer;

	Temp = prevSelectedQuat[0];

	// jameksim 20011119
	if(Temp.s < 0.0)
	{
		Temp.s = -Temp.s;
		Temp.x = -Temp.x;
		Temp.y = -Temp.y;
		Temp.z = -Temp.z;
	}

	// Non-Linear Quantization
	Temp.s = (double)(4.0/M_PI * atan(Temp.s));
	Temp.x = (double)(4.0/M_PI * atan(Temp.x));
	Temp.y = (double)(4.0/M_PI * atan(Temp.y));
	Temp.z = (double)(4.0/M_PI * atan(Temp.z));

	int qv = 0;
	int value, sgn;

	qv= (Temp.s>=0? 1 : -1) * 
	EnQuantizer.Quantize(0, 1, m-1, (Temp.s >= 0 ? Temp.s : -Temp.s));
	Quant.s = qv;

	qv= (Temp.x>=0? 1 : -1) * 
	EnQuantizer.Quantize(0, 1, m-1, (Temp.x >= 0 ? Temp.x : -Temp.x));
	Quant.x = qv;

	qv= (Temp.y>=0? 1 : -1) * 
	EnQuantizer.Quantize(0, 1, m-1, (Temp.y >= 0 ? Temp.y : -Temp.y));
	Quant.y = qv;

	qv= (Temp.z>=0? 1 : -1) * 
	EnQuantizer.Quantize(0, 1, m-1, (Temp.z >= 0 ? Temp.z : -Temp.z));
	Quant.z = qv;

	IntraQuat = Quant;


	value = (int)Quant.s;
	sgn = ((value>=0)?1:-1);
	DeQuant.s = sgn * EnQuantizer.InvQuantize(0, 1, m-1,sgn*value);

	value = (int)Quant.x;
	sgn = ((value>=0)?1:-1);
	DeQuant.x = sgn * EnQuantizer.InvQuantize(0, 1, m-1,sgn*value);

	value = (int)Quant.y;
	sgn = ((value>=0)?1:-1);
	DeQuant.y = sgn * EnQuantizer.InvQuantize(0, 1, m-1,sgn*value);

	value = (int)Quant.z;
	sgn = ((value>=0)?1:-1);
	DeQuant.z = sgn * EnQuantizer.InvQuantize(0, 1, m-1,sgn*value);

	// Non-Linear DeQuantization
	DeQuant.s = tan(M_PI * DeQuant.s / 4.0);
	DeQuant.x = tan(M_PI * DeQuant.x / 4.0);
	DeQuant.y = tan(M_PI * DeQuant.y / 4.0);
	DeQuant.z = tan(M_PI * DeQuant.z / 4.0);

	DeQuant.Normalize();

	Temp = DeQuant;
	(*m_prevQuat) = DeQuant;

	dQKeyValue.Add(IntraQuat);
	endecodedQuat.Add(*m_prevQuat);
}

void OriIDPCMKeyValue::CalculateDPCMKeyValue(JWArray<Quaternion> prevSelectedQuat, 
												int nPrevSelectedKey,
												int m,
												double dMaxS,
												double dMaxX,
												double dMaxY,
												double dMaxZ,
												Quaternion* m_prevQuat,
												JWArray<Quaternion>& dQKeyValue, 
												JWArray<Quaternion>& endecodedQuat)
{
	int				i, j;
	Quaternion		tempQuat, m_dOrgDiff, m_dErrorDiff;
	double			tmpQuat[4] = {0.0, 0.0, 0.0, 0.0};
	double			deQuantValue[3] = {0.0, 0.0, 0.0};
	long int		quantValue[4] = {0, 0, 0, 0};
	double			tmpOrgQuat[4] = {0.0, 0.0, 0.0, 0.0};
	Quaternion*		m_diffQuat;
	Quaternion*		m_invDiffQuat;
	Quantizer		EnQuantizer;


	m_diffQuat = new Quaternion(1.0, 0.0, 0.0, 0.0);
	m_invDiffQuat = new Quaternion(1.0, 0.0, 0.0, 0.0);

	for(i = 1;i < nPrevSelectedKey;i++)
	{
		// complex conjugate
		m_prevQuat->Conjugate();

		// jameskim 20010619
		// Calculate rotational difference between previous decoded Quaternion
		// and previous original Quaternion 
		// E(i-1)
		m_dErrorDiff = prevSelectedQuat[i-1] * (*m_prevQuat);
		
	
		// Calculate rotational difference between previous decoded Quaternion
		// and current original Quaternion 
		// Q"(i)
		(*m_diffQuat) = prevSelectedQuat[i]*(*m_prevQuat);
		
		
		// Calculate rotational difference between previous original Quaternion
		// and current original Quaternion
		// Q'(i)
		tempQuat = prevSelectedQuat[i-1];
		tempQuat.Conjugate();
		m_dOrgDiff = prevSelectedQuat[i]*tempQuat;

	
		// Make m_dErrorDiff.s be positive
		if(m_dErrorDiff.s < 0.0)
		{
			m_dErrorDiff.s = -m_dErrorDiff.s;
			m_dErrorDiff.x = -m_dErrorDiff.x;
			m_dErrorDiff.y = -m_dErrorDiff.y;
			m_dErrorDiff.z = -m_dErrorDiff.z;
		}
	
		// Make m_dOrgDiff.s be positive
		if(m_dOrgDiff.s < 0.0)
		{
			m_dOrgDiff.s = -m_dOrgDiff.s;
			m_dOrgDiff.x = -m_dOrgDiff.x;
			m_dOrgDiff.y = -m_dOrgDiff.y;
			m_dOrgDiff.z = -m_dOrgDiff.z;
		}

		tmpQuat[0] = m_diffQuat->s;
		tmpQuat[1] = m_diffQuat->x;
		tmpQuat[2] = m_diffQuat->y;
		tmpQuat[3] = m_diffQuat->z;

		tmpOrgQuat[0] = m_dOrgDiff.s;
		tmpOrgQuat[1] = m_dOrgDiff.x;
		tmpOrgQuat[2] = m_dOrgDiff.y;
		tmpOrgQuat[3] = m_dOrgDiff.z;

		// Make m_diffQuat.s be positive
		if(tmpQuat[0] >= 0.0)
		{
			tmpQuat[0] = m_diffQuat->s;
			tmpQuat[1] = m_diffQuat->x;
			tmpQuat[2] = m_diffQuat->y;
			tmpQuat[3] = m_diffQuat->z;
		}
		else
		{
			tmpQuat[0] = -m_diffQuat->s;
			tmpQuat[1] = -m_diffQuat->x;
			tmpQuat[2] = -m_diffQuat->y;
			tmpQuat[3] = -m_diffQuat->z;
		}



		// jameskim 20010614 
		// Check if the directions of Q'(i) and Q"(i) are opposite
		double Fq = tmpQuat[1]*tmpOrgQuat[1] + tmpQuat[2]*tmpOrgQuat[2]
					+ tmpQuat[3]*tmpOrgQuat[3];
	
		// Check if the directions of E(i-1) and Q"(i) are opposite
		double Fd = tmpQuat[1]*m_dErrorDiff.x + tmpQuat[2]*m_dErrorDiff.y
					+ tmpQuat[3]*m_dErrorDiff.z;

		
		if(((Fq) < 0.0) && (Fd < 0.0))
		//if((Fq < 0.0) && (0.2 < 2.0*acos(fabs(tmpQuat[0]))) && (0.2 < 2.0*acos(fabs(tmpOrgQuat[0]))) )
		{

			tmpQuat[0] = pow(2.0, -(m-1));
			double norm3 = sqrt( pow(tmpQuat[1], 2.0) + pow(tmpQuat[2], 2.0) + pow(tmpQuat[3], 2.0) );
			tmpQuat[1] = -tmpQuat[1]/norm3;
			tmpQuat[2] = -tmpQuat[2]/norm3;
			tmpQuat[3] = -tmpQuat[3]/norm3;
		
			Quaternion normal;
			normal.s = tmpQuat[0];
			normal.x = tmpQuat[1];
			normal.y = tmpQuat[2];
			normal.z = tmpQuat[3];
			normal.Normalize();
			tmpQuat[0] = normal.s;
			tmpQuat[1] = normal.x;
			tmpQuat[2] = normal.y;
			tmpQuat[3] = normal.z;
		}



		//-----------------------------------------------------------------------------------
		// 
		// Quantize rotational difference Q"(i)
		// Exclude one component that have maximum entropy or is designated by the encoder
		// 
		//-----------------------------------------------------------------------------------
		double		q_error = DBL_MAX;
		double		prev_q_error = DBL_MAX;
		double		global_q_error = DBL_MAX;
		
		double		q0_hat = 0.0;
		double		prev_q0_hat = q0_hat;
		double		g_q0_hat = q0_hat;
		
		Quaternion	prev_Quat;
		Quaternion	g_Quat(0.0, 0.0, 0.0, 0.0);

		bool		ok = true;
		double		prev_deQuantValue[3];
		double		g_deQuantValue[3];
		
		Quaternion encoded_Quat;

		encoded_Quat.s = tmpQuat[0];
		encoded_Quat.x = tmpQuat[1];
		encoded_Quat.y = tmpQuat[2];
		encoded_Quat.z = tmpQuat[3];
		
		Quaternion decoded_Quat;
		Quaternion mo_QuantValue;

		// jameskim 20010430
		// Non-linear quantization
		double v[4] = {0.0, 0.0, 0.0, 0.0};
		for(j = 0;j < 4;j++)
		{
			v[j] = tmpQuat[j];
			tmpQuat[j] = (double)(4.0/M_PI * atan(v[j]));
		} 


		int tmp = 0;
		long int qv = 0;

		qv= (tmpQuat[0]>=0? 1 : -1) * 
		EnQuantizer.Quantize(0, dMaxS, m-1, (tmpQuat[0] >= 0 ? tmpQuat[0] : -tmpQuat[0]));
		quantValue[0] = qv;

		qv= (tmpQuat[1]>=0? 1 : -1) * 
		EnQuantizer.Quantize(0, dMaxX, m-1, (tmpQuat[1] >= 0 ? tmpQuat[1] : -tmpQuat[1]));
		quantValue[1] = qv;

		qv= (tmpQuat[2]>=0? 1 : -1) * 
		EnQuantizer.Quantize(0, dMaxY, m-1, (tmpQuat[2] >= 0 ? tmpQuat[2] : -tmpQuat[2]));
		quantValue[2] = qv;

		qv= (tmpQuat[3]>=0? 1 : -1) * 
		EnQuantizer.Quantize(0, dMaxZ, m-1, (tmpQuat[3] >= 0 ? tmpQuat[3] : -tmpQuat[3]));
		quantValue[3] = qv;

		
		Quaternion tmpKeyValue;
		tmpKeyValue.s = quantValue[0];
		tmpKeyValue.x = quantValue[1];
		tmpKeyValue.y = quantValue[2];
		tmpKeyValue.z = quantValue[3];

		do{
			// -1 ~ 1
			for(int p = -1;p < 2;p++)
			{
				for(int q = -1;q < 2;q++)
				{
					for(int r = -1;r < 2;r++)
					{

						mo_QuantValue.s = quantValue[0]; 
						mo_QuantValue.x = quantValue[1]+p; 
						mo_QuantValue.y = quantValue[2]+q; 
						mo_QuantValue.z = quantValue[3]+r; 

						// Non-linear Dequantize
						int value, sgn;

						value = (int)mo_QuantValue.x;
						sgn = ((value>=0)?1:-1);
						deQuantValue[0] = sgn * EnQuantizer.InvQuantize(0, dMaxX, m-1,sgn*value);

						value = (int)mo_QuantValue.y;
						sgn = ((value>=0)?1:-1);
						deQuantValue[1] = sgn * EnQuantizer.InvQuantize(0, dMaxY, m-1,sgn*value);

						value = (int)mo_QuantValue.z;
						sgn = ((value>=0)?1:-1);
						deQuantValue[2] = sgn * EnQuantizer.InvQuantize(0, dMaxZ, m-1,sgn*value);
						
						for(j = 0;j < 3;j++)
						{
							deQuantValue[j] = tan(M_PI * deQuantValue[j] / 4.0);
						}

						// Reconstruct q0
						double temp = 1 - (pow(deQuantValue[0], 2.0)+pow(deQuantValue[1], 2.0)
								+pow(deQuantValue[2], 2.0));

						// If q0 is real number
						if(temp >= 0.0)
						{
							decoded_Quat.s = sqrt(1.0 - (pow(deQuantValue[0], 2.0)+pow(deQuantValue[1], 2.0)
								+pow(deQuantValue[2], 2.0)));
							decoded_Quat.x = deQuantValue[0];
							decoded_Quat.y = deQuantValue[1];
							decoded_Quat.z = deQuantValue[2];

							decoded_Quat.Normalize();
							
							q_error = 2.0 * acos(encoded_Quat^decoded_Quat);

							if(q_error < prev_q_error)
							{
								prev_q_error = q_error;
										
								prev_Quat = mo_QuantValue;

								prev_q0_hat = decoded_Quat.s;
								prev_deQuantValue[0] = decoded_Quat.x;
								prev_deQuantValue[1] = decoded_Quat.y;
								prev_deQuantValue[2] = decoded_Quat.z;
							}
						}
					}
				}
			} //for loop p,q,r

			// Find quantized key value that produce global minimum error
			if(prev_q_error < global_q_error)
			{
				global_q_error = prev_q_error;
					
				g_Quat = prev_Quat;

				quantValue[0] = (int)g_Quat.s;
				quantValue[1] = (int)g_Quat.x;
				quantValue[2] = (int)g_Quat.y;
				quantValue[3] = (int)g_Quat.z;

				g_q0_hat = prev_q0_hat;
				g_deQuantValue[0] = prev_deQuantValue[0];
				g_deQuantValue[1] = prev_deQuantValue[1];
				g_deQuantValue[2] = prev_deQuantValue[2];
		
				q_error = DBL_MAX;
				prev_q_error = DBL_MAX;
			}
			else
			{
				ok = false;
			}


		}while(ok);

		// Exceptional handling i.e. q0 is not real number
		if((g_Quat.s == 0.0) && (g_Quat.x == 0.0) && (g_Quat.y == 0.0) && (g_Quat.z == 0.0))  
		{
			printf("sub optimal q0\n");
			getchar();
			exit(0);
			
			dQKeyValue.Add(tmpKeyValue);

			int value, sgn;

			value = (int)tmpKeyValue.x;
			sgn = ((value>=0)?1:-1);
			deQuantValue[0] = sgn * EnQuantizer.InvQuantize(0, dMaxX, m-1,sgn*value);

			value = (int)tmpKeyValue.y;
			sgn = ((value>=0)?1:-1);
			deQuantValue[1] = sgn * EnQuantizer.InvQuantize(0, dMaxY, m-1,sgn*value);

			value = (int)tmpKeyValue.z;
			sgn = ((value>=0)?1:-1);
			deQuantValue[2] = sgn * EnQuantizer.InvQuantize(0, dMaxZ, m-1,sgn*value);
			
			for(j = 0;j < 3;j++)
			{
				deQuantValue[j] = tan(M_PI * deQuantValue[j] / 4.0);
			}

			double temp = pow(2.0, -(m-1)); 

			m_invDiffQuat->s = temp;
			m_invDiffQuat->x = deQuantValue[0];
			m_invDiffQuat->y = deQuantValue[1];
			m_invDiffQuat->z = deQuantValue[2];
		}
		else
		{
			dQKeyValue.Add(g_Quat);

			m_invDiffQuat->s = g_q0_hat;
			m_invDiffQuat->x = g_deQuantValue[0];
			m_invDiffQuat->y = g_deQuantValue[1];
			m_invDiffQuat->z = g_deQuantValue[2];
		}


		m_invDiffQuat->Normalize();

		m_prevQuat->Conjugate();
		
		(*m_prevQuat) = (*m_invDiffQuat) * (*m_prevQuat) ;

		// Store decoded key values
		endecodedQuat.Add(*m_prevQuat);

	}//end of for loop

	delete m_diffQuat;
	delete m_invDiffQuat;
}


void OriIDPCMKeyValue::CalculateReDPCMKeyValue(JWArray<Quaternion> dQKeyValue, 
												int nPrevSelectedKey,
												JWArray<Quaternion>& ReDPCMQKeyValue,
								 				int m)
{
	int i;

	ReDPCMQKeyValue.SetSize(dQKeyValue.GetSize());

	ReDPCMQKeyValue[0] = dQKeyValue[0];
	ReDPCMQKeyValue[1] = dQKeyValue[1];


	//------------------------------------------------------------------------
	//
	// Circular DPCM
	//
	//------------------------------------------------------------------------
	for(i = 1;i < nPrevSelectedKey;i++)
	{
	
		// Make the range of 1st DPCMed key value be 0 ~ 2^(m)-2
		dQKeyValue[i].s += ((1 << (m-1))-1);
		dQKeyValue[i].x += ((1 << (m-1))-1);
		dQKeyValue[i].y += ((1 << (m-1))-1);
		dQKeyValue[i].z += ((1 << (m-1))-1);

		// check if all the key values are positive
		if(dQKeyValue[i].s < 0.0)
		{
			printf("NO!!!!");
			getchar();
		}
		if(dQKeyValue[i].x < 0.0)
		{
			printf("NO!!!!");
			getchar();
		}
		if(dQKeyValue[i].y < 0.0)
		{
			printf("NO!!!!");
			getchar();
		}
		if(dQKeyValue[i].z < 0.0)
		{
			printf("NO!!!!");
			getchar();
		}
	}

	for(i = 2;i < nPrevSelectedKey;i++)
	{
		ReDPCMQKeyValue[i].s = dQKeyValue[i].s - dQKeyValue[i-1].s;
		ReDPCMQKeyValue[i].x = dQKeyValue[i].x - dQKeyValue[i-1].x;
		ReDPCMQKeyValue[i].y = dQKeyValue[i].y - dQKeyValue[i-1].y;
		ReDPCMQKeyValue[i].z = dQKeyValue[i].z - dQKeyValue[i-1].z;
	}

	int OrgDPCM;
	for(i = 2;i < nPrevSelectedKey;i++)
	{

		if(ReDPCMQKeyValue[i].s >= 0.0)
			OrgDPCM = (int)ReDPCMQKeyValue[i].s - ((1 << m)-1);
		else
			OrgDPCM = (int)ReDPCMQKeyValue[i].s + ((1 << m)-1);
		
		if(abs(OrgDPCM) < abs((int)ReDPCMQKeyValue[i].s))
			ReDPCMQKeyValue[i].s = OrgDPCM;
		// jameskim 20011031
		// If ReDPCMed key value and its compliment have same magnitude and opposite sign,
		// positive one is selected for ReDPCMed key value
		else if(abs(OrgDPCM) == abs((int)ReDPCMQKeyValue[i].s))
		{
			if(OrgDPCM >= 0)
				ReDPCMQKeyValue[i].s = OrgDPCM;
		}


		if(ReDPCMQKeyValue[i].x >= 0.0)
			OrgDPCM = (int)ReDPCMQKeyValue[i].x - ((1 << m)-1);
		else
			OrgDPCM = (int)ReDPCMQKeyValue[i].x + ((1 << m)-1);
		
		if(abs(OrgDPCM) < abs((int)ReDPCMQKeyValue[i].x))
			ReDPCMQKeyValue[i].x = OrgDPCM;
		// jameskim 20011031
		else if(abs(OrgDPCM) == abs((int)ReDPCMQKeyValue[i].x))
		{
			if(OrgDPCM >= 0)
				ReDPCMQKeyValue[i].x = OrgDPCM;
		}


		if(ReDPCMQKeyValue[i].y >= 0.0)
			OrgDPCM = (int)ReDPCMQKeyValue[i].y - ((1 << m)-1);
		else
			OrgDPCM = (int)ReDPCMQKeyValue[i].y + ((1 << m)-1);
		
		if(abs(OrgDPCM) < abs((int)ReDPCMQKeyValue[i].y))
			ReDPCMQKeyValue[i].y = OrgDPCM;
		// jameskim 20011031
		else if(abs(OrgDPCM) == abs((int)ReDPCMQKeyValue[i].y))
		{
			if(OrgDPCM >= 0)
				ReDPCMQKeyValue[i].y = OrgDPCM;
		}


		if(ReDPCMQKeyValue[i].z >= 0.0)
			OrgDPCM = (int)ReDPCMQKeyValue[i].z - ((1 << m)-1);
		else
			OrgDPCM = (int)ReDPCMQKeyValue[i].z + ((1 << m)-1);
		
		if(abs(OrgDPCM) < abs((int)ReDPCMQKeyValue[i].z))
			ReDPCMQKeyValue[i].z = OrgDPCM;
		else if(abs(OrgDPCM) == abs((int)ReDPCMQKeyValue[i].z))
		{
			if(OrgDPCM >= 0)
				ReDPCMQKeyValue[i].z = OrgDPCM;
		}
	}
	// jameskim 20011012
}