// OriIDPCMKeyValue.h: interface for the OriIDPCMKeyValue class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ORIIDPCMKEYVALUE_H__D8EE47D6_175E_41AD_91BA_A22A8AD9094E__INCLUDED_)
#define AFX_ORIIDPCMKEYVALUE_H__D8EE47D6_175E_41AD_91BA_A22A8AD9094E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "JWTemplArray.h"
#include "Quaternion.h"
#include "Entropy.h"
#include "SelectedKeyFrame.h"
#include "Quantizer.h"
#include "JWDictionary.h"
#include "ArithmeticEncoder.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <float.h>

class OriIDPCMKeyValue  
{
public:
	OriIDPCMKeyValue();
	virtual ~OriIDPCMKeyValue();

public:
	void InitializeModel();
	void encodingProcess(unsigned int nDPCMOrder, unsigned int nKVQBit, CSelectedKeyFrame selectedKeyFrame);
	void IntraKeyValueCoding(JWArray<Quaternion> prevSelectedQuat,
							 JWArray<Quaternion>& dQKeyValue, 
							 JWArray<Quaternion>& endecodedQuat,
							 int m,
							 Quaternion* m_prevQuat);
	void CalculateDPCMKeyValue(JWArray<Quaternion> prevSelectedQuat, 
								int nPrevSelectedKey,
								int m,
								double dMaxS,
								double dMaxX,
								double dMaxY,
								double dMaxZ,
								Quaternion* m_prevQuat,
								JWArray<Quaternion>& dQKeyValue, 
								JWArray<Quaternion>& endecodedQuat);

	void CalculateReDPCMKeyValue(JWArray<Quaternion> dQKeyValue, 
									int nPrevSelectedKey,
									JWArray<Quaternion>& ReDPCMQKeyValue,
					 				int m);

	void makeBitstream(CAC_QF& codec, 
						unsigned int x_keyvalue_flag,
						unsigned int y_keyvalue_flag,
						unsigned int z_keyvalue_flag,
						int* numBitsKV,
						bool bIsUnaryAAC_X, bool bIsUnaryAAC_Y, bool bIsUnaryAAC_Z,
						unsigned int nDPCMOrder);


public:
	Quaternion*				m_prevQuat;
	JWArray <Quaternion>	decodedKeyValue;
	JWArray <Quaternion>	DPCMKeyValue;
	JWArray<Quaternion>		ReDPCMQKeyValue;	
	JWArray <Quaternion>	DeltaKeyValue;
	
	CAC						kvXUSignContext;
	CAC						kvXUContext;
	CAC						kvYUSignContext;
	CAC						kvYUContext;
	CAC						kvZUSignContext;
	CAC						kvZUContext;
	CAC						kvXSignContext;
	CAC						kvXContext[32];
	CAC						kvYSignContext;
	CAC						kvYContext[32];
	CAC						kvZSignContext;
	CAC						kvZContext[32];

};

#endif // !defined(AFX_ORIIDPCMKEYVALUE_H__D8EE47D6_175E_41AD_91BA_A22A8AD9094E__INCLUDED_)
