// OriIDPCMKeyValueHeader.cpp: implementation of the OriIDPCMKeyValueHeader class.
//
//////////////////////////////////////////////////////////////////////

#include "OriIDPCMKeyValueHeader.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

OriIDPCMKeyValueHeader::OriIDPCMKeyValueHeader()
{

}

OriIDPCMKeyValueHeader::~OriIDPCMKeyValueHeader()
{

}


void OriIDPCMKeyValueHeader::makeBitstream(CAC_QF& codec, 
											bool bIsUnaryAAC_X, bool bIsUnaryAAC_Y, bool bIsUnaryAAC_Z,
											unsigned int nKVDPCMOrder,
											unsigned int nKVQBit,
											OriIDPCMKeyValue& oriIDPCMKeyValue)
{
	//int prevBitTotal = AACTotal();
	int prevBitTotal = 0;
	int KVHeaderTotal = 0;
	int MinKV[3];//, numBitsKV[3];

	
	//////////////////////////////////////////////////////////////////////////////////
	// 1 Key Value DPCM .
	if(nKVDPCMOrder == 0)
	{
		// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
		//
		//
		//						KeyValue Header Coder By Jameskim (1st DPCM)
		//
		//
		// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

		// Write 9. ù° keyvalue intra .
		if((int)oriIDPCMKeyValue.DPCMKeyValue[0].s >= 0)
		{
			// jameskim 20011119
			//codec._ostrm->putbits(0, 1);
			codec._ostrm->putbits((int)oriIDPCMKeyValue.DPCMKeyValue[0].s, nKVQBit-1);
		}
		else
		{
			// jameskim 20011119
			//codec._ostrm->putbits(1, 1);
			codec._ostrm->putbits((int)(-1.0*oriIDPCMKeyValue.DPCMKeyValue[0].s), nKVQBit-1);
		}

		
		if((int)oriIDPCMKeyValue.DPCMKeyValue[0].x >= 0)
		{
			codec._ostrm->putbits(1, 1);
			codec._ostrm->putbits((int)oriIDPCMKeyValue.DPCMKeyValue[0].x, nKVQBit-1);
		}
		else
		{
			codec._ostrm->putbits(0, 1);
			codec._ostrm->putbits((int)(-1.0*oriIDPCMKeyValue.DPCMKeyValue[0].x), nKVQBit-1);
		}

		if((int)oriIDPCMKeyValue.DPCMKeyValue[0].y >= 0)
		{
			codec._ostrm->putbits(1, 1);
			codec._ostrm->putbits((int)oriIDPCMKeyValue.DPCMKeyValue[0].y, nKVQBit-1);
		}
		else
		{
			codec._ostrm->putbits(0, 1);
			codec._ostrm->putbits((int)(-1.0*oriIDPCMKeyValue.DPCMKeyValue[0].y), nKVQBit-1);
		}

		if((int)oriIDPCMKeyValue.DPCMKeyValue[0].z >= 0)
		{
			codec._ostrm->putbits(1, 1);
			codec._ostrm->putbits((int)oriIDPCMKeyValue.DPCMKeyValue[0].z, nKVQBit-1);
		}
		else
		{
			codec._ostrm->putbits(0, 1);
			codec._ostrm->putbits((int)(-1.0*oriIDPCMKeyValue.DPCMKeyValue[0].z), nKVQBit-1);
		}


		// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
		// Min/Max  ؼ ߿  ū  ϰ ̸ ǥϱ  bit + 1(sign)
		// ŭ  Ҵ bit Ѵ.
		//CompMinKV(dQKeyValue, 1, aKeyFrames[nT].GetNumberOfSelectedKeys(), MinKV, numBitsKV);
		CompMinKV(oriIDPCMKeyValue.DPCMKeyValue, 1, oriIDPCMKeyValue.DPCMKeyValue.GetSize(), MinKV, numBitsKV);
	

		MinKV[0] = 0; MinKV[1] = 0; MinKV[2] = 0;
		ShiftKV(oriIDPCMKeyValue.DeltaKeyValue, oriIDPCMKeyValue.DPCMKeyValue, MinKV, 1, oriIDPCMKeyValue.DPCMKeyValue.GetSize());

		// real QP ׻ key value ȭ bit Ƿ 
		// ȣȭǴ key value ȭ bit Ͽ ̺  
		// bit ȣȭѴ.
		int count = 0;
		count = getNbBits(nKVQBit);

		// jameskim 20011115
		//  ȣȭ Ǵ key value   ̶   ϳ  keyvalue AAC Ѵ.
		int tempValue = 0;
		
		tempValue = (int)oriIDPCMKeyValue.DeltaKeyValue[0].x;
		for(int i = 0;i < oriIDPCMKeyValue.DeltaKeyValue.GetSize();i++)
		{
			if(tempValue != (int)oriIDPCMKeyValue.DeltaKeyValue[i].x)
			{
				x_keyvalue_flag = 1;
				break;
			}
			x_keyvalue_flag = 0;
		}
		codec._ostrm->putbits(x_keyvalue_flag, 1);
		
		// key value   ̸....
		if(x_keyvalue_flag == 0)
		{
			// װ 0̳ 1̸....
			if(tempValue == 0 || tempValue == 1)
			{
				numBitsKV[0] = 1;
			}
			
			codec._ostrm->putbits(numBitsKV[0], count);

			if(numBitsKV[0] == 1)
			{
				codec._ostrm->putbits((int)oriIDPCMKeyValue.DeltaKeyValue[0].x, numBitsKV[0]);
			}
			else 
			{
				if((int)oriIDPCMKeyValue.DeltaKeyValue[0].x >= 0)
				{
					codec._ostrm->putbits(0, 1);
					codec._ostrm->putbits((int)oriIDPCMKeyValue.DeltaKeyValue[0].x, numBitsKV[0]-1);
				}
				else
				{
					codec._ostrm->putbits(1, 1);
					codec._ostrm->putbits((int)(-1.0*oriIDPCMKeyValue.DeltaKeyValue[0].x), numBitsKV[0]-1);
				}
			}
		}
		else
		{
			// jameskim 20011222
			codec._ostrm->putbits(bIsUnaryAAC_X, 1);
			if(!bIsUnaryAAC_X)
				codec._ostrm->putbits(numBitsKV[0], count);
		}


		tempValue = (int)oriIDPCMKeyValue.DeltaKeyValue[0].y;
		for(i = 0;i < oriIDPCMKeyValue.DeltaKeyValue.GetSize();i++)
		{
			if(tempValue != (int)oriIDPCMKeyValue.DeltaKeyValue[i].y)
			{
				y_keyvalue_flag = 1;
				break;
			}
			y_keyvalue_flag = 0;
		}
		codec._ostrm->putbits(y_keyvalue_flag, 1);
		// key value   ̸....
		if(y_keyvalue_flag == 0)
		{
			// װ 0̳ 1̸....
			if(tempValue == 0 || tempValue == 1)
			{
				numBitsKV[1] = 1;
			}
			codec._ostrm->putbits(numBitsKV[1], count);
			//codec._ostrm->putbits((int)oriIDPCMKeyValue.DeltaKeyValue[0].y, numBitsKV[1]);
			if(numBitsKV[1] == 1)
			{
				codec._ostrm->putbits((int)oriIDPCMKeyValue.DeltaKeyValue[0].y, numBitsKV[1]);
			}
			else
			{
				if((int)oriIDPCMKeyValue.DeltaKeyValue[0].y >= 0)
				{
					codec._ostrm->putbits(0, 1);
					codec._ostrm->putbits((int)oriIDPCMKeyValue.DeltaKeyValue[0].y, numBitsKV[1]-1);
				}
				else
				{
					codec._ostrm->putbits(1, 1);
					codec._ostrm->putbits((int)(-1.0*oriIDPCMKeyValue.DeltaKeyValue[0].y), numBitsKV[1]-1);
				}
			}
		}
		else
		{
			// jameskim 20011222
			codec._ostrm->putbits(bIsUnaryAAC_Y, 1);
			if(!bIsUnaryAAC_Y)
				codec._ostrm->putbits(numBitsKV[1], count);
		}


		tempValue = (int)oriIDPCMKeyValue.DeltaKeyValue[0].z;
		for(i = 0;i < oriIDPCMKeyValue.DeltaKeyValue.GetSize();i++)
		{
			if(tempValue != (int)oriIDPCMKeyValue.DeltaKeyValue[i].z)
			{
				z_keyvalue_flag = 1;
				break;
			}
			z_keyvalue_flag = 0;
		}
		codec._ostrm->putbits(z_keyvalue_flag, 1);
		// key value   ̸....
		if(z_keyvalue_flag == 0)
		{
			// װ 0̳ 1̸....
			if(tempValue == 0 || tempValue == 1)
			{
				numBitsKV[2] = 1;
			}
			codec._ostrm->putbits(numBitsKV[2], count);
			//codec._ostrm->putbits((int)oriIDPCMKeyValue.DeltaKeyValue[0].z, numBitsKV[2]);
			if(numBitsKV[2] == 1)
			{
				codec._ostrm->putbits((int)oriIDPCMKeyValue.DeltaKeyValue[0].z, numBitsKV[2]);
			}
			else
			{
				if((int)oriIDPCMKeyValue.DeltaKeyValue[0].z >= 0)
				{
					codec._ostrm->putbits(0, 1);
					codec._ostrm->putbits((int)oriIDPCMKeyValue.DeltaKeyValue[0].z, numBitsKV[2]-1);
				}
				else
				{
					codec._ostrm->putbits(1, 1);
					codec._ostrm->putbits((int)(-1.0*oriIDPCMKeyValue.DeltaKeyValue[0].z), numBitsKV[2]-1);
				}
			}
		}
		else
		{
			// jameskim 20011222
			codec._ostrm->putbits(bIsUnaryAAC_Z, 1);
			if(!bIsUnaryAAC_Z)
				codec._ostrm->putbits(numBitsKV[2], count);
		}



		printf(" AAC Էµ key value bit : KVx %d, KVy %d, KVz %d\n\n", numBitsKV[0], numBitsKV[1], numBitsKV[2]);
	}
	// jameskim 20010925
	else if(nKVDPCMOrder == 1)
	{
		// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
		//
		//
		//						KeyValue Header Coder By Jameskim (2nd DPCM)
		//
		//
		// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
		// Write 9. ù° keyvalue intra .
		if((int)oriIDPCMKeyValue.ReDPCMQKeyValue[0].s >= 0)
		{
			// jameskim 20011119
			//codec._ostrm->putbits(0, 1);
			codec._ostrm->putbits((int)oriIDPCMKeyValue.ReDPCMQKeyValue[0].s, nKVQBit-1);
		}
		else
		{
			// jameskim 20011119
			//codec._ostrm->putbits(1, 1);
			codec._ostrm->putbits((int)(-1.0*oriIDPCMKeyValue.ReDPCMQKeyValue[0].s), nKVQBit-1);
		}

		if((int)oriIDPCMKeyValue.ReDPCMQKeyValue[0].x >= 0)
		{
			codec._ostrm->putbits(1, 1);
			codec._ostrm->putbits((int)oriIDPCMKeyValue.ReDPCMQKeyValue[0].x, nKVQBit-1);
		}
		else
		{
			codec._ostrm->putbits(0, 1);
			codec._ostrm->putbits((int)(-1.0*oriIDPCMKeyValue.ReDPCMQKeyValue[0].x), nKVQBit-1);
		}

		if((int)oriIDPCMKeyValue.ReDPCMQKeyValue[0].y >= 0)
		{
			codec._ostrm->putbits(1, 1);
			codec._ostrm->putbits((int)oriIDPCMKeyValue.ReDPCMQKeyValue[0].y, nKVQBit-1);
		}
		else
		{
			codec._ostrm->putbits(0, 1);
			codec._ostrm->putbits((int)(-1.0*oriIDPCMKeyValue.ReDPCMQKeyValue[0].y), nKVQBit-1);
		}

		if((int)oriIDPCMKeyValue.ReDPCMQKeyValue[0].z >= 0)
		{
			codec._ostrm->putbits(1, 1);
			codec._ostrm->putbits((int)oriIDPCMKeyValue.ReDPCMQKeyValue[0].z, nKVQBit-1);
		}
		else
		{
			codec._ostrm->putbits(0, 1);
			codec._ostrm->putbits((int)(-1.0*oriIDPCMKeyValue.ReDPCMQKeyValue[0].z), nKVQBit-1);
		}


		if((int)oriIDPCMKeyValue.ReDPCMQKeyValue[1].x >= 0)
		{
			codec._ostrm->putbits(1, 1);
			codec._ostrm->putbits((int)oriIDPCMKeyValue.ReDPCMQKeyValue[1].x, nKVQBit-1);
		}
		else
		{
			codec._ostrm->putbits(0, 1);
			codec._ostrm->putbits((int)(-1.0*oriIDPCMKeyValue.ReDPCMQKeyValue[1].x), nKVQBit-1);
		}


		if((int)oriIDPCMKeyValue.ReDPCMQKeyValue[1].y >= 0)
		{
			codec._ostrm->putbits(1, 1);
			codec._ostrm->putbits((int)oriIDPCMKeyValue.ReDPCMQKeyValue[1].y, nKVQBit-1);
		}
		else
		{
			codec._ostrm->putbits(0, 1);
			codec._ostrm->putbits((int)(-1.0*oriIDPCMKeyValue.ReDPCMQKeyValue[1].y), nKVQBit-1);
		}


		if((int)oriIDPCMKeyValue.ReDPCMQKeyValue[1].z >= 0)
		{
			codec._ostrm->putbits(1, 1);
			codec._ostrm->putbits((int)oriIDPCMKeyValue.ReDPCMQKeyValue[1].z, nKVQBit-1);
		}
		else
		{
			codec._ostrm->putbits(0, 1);
			codec._ostrm->putbits((int)(-1.0*oriIDPCMKeyValue.ReDPCMQKeyValue[1].z), nKVQBit-1);
		}
		

		// Min/Max  ؼ ߿  ū  ϰ ̸ ǥϱ  bit + 1(sign)
		// ŭ  Ҵ bit Ѵ.
		int IsMoreTwoKV = 0;
		if(oriIDPCMKeyValue.ReDPCMQKeyValue.GetSize() > 2)
		{
			// jameskim 20011222
			IsMoreTwoKV = 1;
			codec._ostrm->putbits(IsMoreTwoKV, 1);

			//CompMinKV(ReDPCMQKeyValue, 2, nPrevSelectedKey, MinKV, numBitsKV);
			CompMinKV(oriIDPCMKeyValue.ReDPCMQKeyValue, 2, oriIDPCMKeyValue.ReDPCMQKeyValue.GetSize(), MinKV, numBitsKV);
			

			MinKV[0] = 0; MinKV[1] = 0; MinKV[2] = 0;
			ShiftKV(oriIDPCMKeyValue.DeltaKeyValue, oriIDPCMKeyValue.ReDPCMQKeyValue, MinKV, 2, oriIDPCMKeyValue.ReDPCMQKeyValue.GetSize());
			//ShiftKV(oriIDPCMKeyValue.DeltaKeyValue, ReDPCMQKeyValue, MinKV, 1, nPrevSelectedKey);


			// real QP ׻ key value ȭ bit Ƿ 
			// ȣȭǴ key value ȭ bit Ͽ ̺  
			// bit ȣȭѴ.
			int count = 0;
			count = getNbBits(nKVQBit);

			// jameskim 20011115
			//  ȣȭ Ǵ key value   ̶   ϳ  keyvalue AAC Ѵ.
			int tempValue = 0;
			
			tempValue = (int)oriIDPCMKeyValue.DeltaKeyValue[0].x;
			for(int i = 0;i < oriIDPCMKeyValue.DeltaKeyValue.GetSize();i++)
			{
				if(tempValue != (int)oriIDPCMKeyValue.DeltaKeyValue[i].x)
				{
					x_keyvalue_flag = 1;
					break;
				}
				x_keyvalue_flag = 0;
			}
			codec._ostrm->putbits(x_keyvalue_flag, 1);
			
			// key value   ̸....
			if(x_keyvalue_flag == 0)
			{
				// װ 0̳ 1̸....
				if(tempValue == 0 || tempValue == 1)
				{
					numBitsKV[0] = 1;
				}
				
				codec._ostrm->putbits(numBitsKV[0], count);
				//codec._ostrm->putbits((int)oriIDPCMKeyValue.DeltaKeyValue[0].x, numBitsKV[0]);
				if(numBitsKV[0] == 1)
				{
					codec._ostrm->putbits((int)oriIDPCMKeyValue.DeltaKeyValue[0].x, numBitsKV[0]);
				}
				else
				{
					if((int)oriIDPCMKeyValue.DeltaKeyValue[0].x >= 0)
					{
						codec._ostrm->putbits(0, 1);
						codec._ostrm->putbits((int)oriIDPCMKeyValue.DeltaKeyValue[0].x, numBitsKV[0]-1);
					}
					else
					{
						codec._ostrm->putbits(1, 1);
						codec._ostrm->putbits((int)(-1.0*oriIDPCMKeyValue.DeltaKeyValue[0].x), numBitsKV[0]-1);
					}
				}
			}
			else
			{
				// jameskim 20011222
				codec._ostrm->putbits(bIsUnaryAAC_X, 1);
				if(!bIsUnaryAAC_X)
					codec._ostrm->putbits(numBitsKV[0], count);
			}


			tempValue = (int)oriIDPCMKeyValue.DeltaKeyValue[0].y;
			for(i = 0;i < oriIDPCMKeyValue.DeltaKeyValue.GetSize();i++)
			{
				if(tempValue != (int)oriIDPCMKeyValue.DeltaKeyValue[i].y)
				{
					y_keyvalue_flag = 1;
					break;
				}
				y_keyvalue_flag = 0;
			}
			codec._ostrm->putbits(y_keyvalue_flag, 1);
			// key value   ̸....
			if(y_keyvalue_flag == 0)
			{
				// װ 0̳ 1̸....
				if(tempValue == 0 || tempValue == 1)
				{
					numBitsKV[1] = 1;
				}
				codec._ostrm->putbits(numBitsKV[1], count);
				//codec._ostrm->putbits((int)oriIDPCMKeyValue.DeltaKeyValue[0].y, numBitsKV[1]);
				if(numBitsKV[1] == 1)
				{
					codec._ostrm->putbits((int)oriIDPCMKeyValue.DeltaKeyValue[0].y, numBitsKV[1]);
				}
				else
				{
					if((int)oriIDPCMKeyValue.DeltaKeyValue[0].y >= 0)
					{
						codec._ostrm->putbits(0, 1);
						codec._ostrm->putbits((int)oriIDPCMKeyValue.DeltaKeyValue[0].y, numBitsKV[1]-1);
					}
					else
					{
						codec._ostrm->putbits(1, 1);
						codec._ostrm->putbits((int)(-1.0*oriIDPCMKeyValue.DeltaKeyValue[0].y), numBitsKV[1]-1);
					}
				}
			}
			else
			{
				// jameskim 20011222
				codec._ostrm->putbits(bIsUnaryAAC_Y, 1);
				if(!bIsUnaryAAC_Y)
					codec._ostrm->putbits(numBitsKV[1], count);
			}


			tempValue = (int)oriIDPCMKeyValue.DeltaKeyValue[0].z;
			for(i = 0;i < oriIDPCMKeyValue.DeltaKeyValue.GetSize();i++)
			{
				if(tempValue != (int)oriIDPCMKeyValue.DeltaKeyValue[i].z)
				{
					z_keyvalue_flag = 1;
					break;
				}
				z_keyvalue_flag = 0;
			}
			codec._ostrm->putbits(z_keyvalue_flag, 1);
			// key value   ̸....
			if(z_keyvalue_flag == 0)
			{
				// װ 0̳ 1̸....
				if(tempValue == 0 || tempValue == 1)
				{
					numBitsKV[2] = 1;
				}
				codec._ostrm->putbits(numBitsKV[2], count);
				//codec._ostrm->putbits((int)oriIDPCMKeyValue.DeltaKeyValue[0].z, numBitsKV[2]);
				if(numBitsKV[2] == 1)
				{
					codec._ostrm->putbits((int)oriIDPCMKeyValue.DeltaKeyValue[0].z, numBitsKV[2]);
				}
				else
				{
					if((int)oriIDPCMKeyValue.DeltaKeyValue[0].z >= 0)
					{
						codec._ostrm->putbits(0, 1);
						codec._ostrm->putbits((int)oriIDPCMKeyValue.DeltaKeyValue[0].z, numBitsKV[2]-1);
					}
					else
					{
						codec._ostrm->putbits(1, 1);
						codec._ostrm->putbits((int)(-1.0*oriIDPCMKeyValue.DeltaKeyValue[0].z), numBitsKV[2]-1);
					}
				}
			}
			else
			{
				// jameskim 20011222
				codec._ostrm->putbits(bIsUnaryAAC_Z, 1);
				if(!bIsUnaryAAC_Z)
					codec._ostrm->putbits(numBitsKV[2], count);
			}


			printf(" AAC Էµ key value bit : KVx %d, KVy %d, KVz %d\n\n", numBitsKV[0], numBitsKV[1], numBitsKV[2]);
		}
		else
		{
			// jameskim 20011222
			IsMoreTwoKV = 0;
			codec._ostrm->putbits(IsMoreTwoKV, 1);
		}
	}
}



void OriIDPCMKeyValueHeader::CompMinKV(JWArray<Quaternion> & qFArray, int begin, int end, int *MinKV, int *numBitsKV)
{
	int MaxKV[3];

	MinKV[0] = (int)qFArray[begin].x;
	MaxKV[0] = (int)qFArray[begin].x;

	MinKV[1] = (int)qFArray[begin].y;
	MaxKV[1] = (int)qFArray[begin].y;

	MinKV[2] = (int)qFArray[begin].z;
	MaxKV[2] = (int)qFArray[begin].z;

	
	for (int i=begin; i<end;i++)
	{
		if ((int)qFArray[i].x < MinKV[0]) 
			MinKV[0]=(int)qFArray[i].x;
		if ((int)qFArray[i].x > MaxKV[0]) 
			MaxKV[0]=(int)qFArray[i].x;
	}

	// 밪 ū    bit Ѵ.
	if(abs(MaxKV[0]) > abs(MinKV[0]))
		numBitsKV[0] = getNbBits(abs(MaxKV[0])) + 1; // 1   ? sign bit ...
	else
		numBitsKV[0] = getNbBits(abs(MinKV[0])) + 1;


	for (i=begin; i<end;i++)
	{
		if ((int)qFArray[i].y < MinKV[1]) 
			MinKV[1]=(int)qFArray[i].y;
		if ((int)qFArray[i].y > MaxKV[1]) 
			MaxKV[1]=(int)qFArray[i].y;
	}
	if(abs(MaxKV[1]) > abs(MinKV[1])) 
		numBitsKV[1] = getNbBits(abs(MaxKV[1])) + 1;
	else
		numBitsKV[1] = getNbBits(abs(MinKV[1])) + 1;



	for (i=begin; i<end;i++)
	{
		if ((int)qFArray[i].z < MinKV[2]) 
			MinKV[2]=(int)qFArray[i].z;
		if ((int)qFArray[i].z > MaxKV[2]) 
			MaxKV[2]=(int)qFArray[i].z;
	}
	if(abs(MaxKV[2]) > abs(MinKV[2]))
		numBitsKV[2] = getNbBits(abs(MaxKV[2])) + 1;
	else
		numBitsKV[2] = getNbBits(abs(MinKV[2])) + 1;

	printf("key value ȭ min/max  : minkv %d %d %d, maxkv %d %d %d\n", MinKV[0], MinKV[1], MinKV[2], MaxKV[0], MaxKV[1], MaxKV[2]);
}


void OriIDPCMKeyValueHeader::ShiftKV(JWArray<Quaternion> &d, JWArray<Quaternion> &q, 
					   int *PMin, int begin, int end)
{
	Quaternion tmp;

	for (int i=begin; i<end;i++)
	{
		tmp.s = 0.0;
		tmp.x = q[i].x - PMin[0];
		tmp.y = q[i].y - PMin[1];
		tmp.z = q[i].z - PMin[2];

		d.Add(tmp);
	}
}


int OriIDPCMKeyValueHeader::getNbBits(int k)
{
	int j=1;
	while (k >= (1<<j) ) 
		j++;

	return j;
}

