// OriIDPCMKeyValueHeader.h: interface for the OriIDPCMKeyValueHeader class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ORIIDPCMKEYVALUEHEADER_H__96E53306_1481_4C8B_BF9B_561AEACD3056__INCLUDED_)
#define AFX_ORIIDPCMKEYVALUEHEADER_H__96E53306_1481_4C8B_BF9B_561AEACD3056__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "OriIKeyValueCodingBit.h"
#include "OriIDPCMKeyValue.h"

class OriIDPCMKeyValueHeader  
{
public:
	OriIDPCMKeyValueHeader();
	virtual ~OriIDPCMKeyValueHeader();

public:

	void makeBitstream(CAC_QF& codec,
						bool bIsUnaryAAC_X, bool bIsUnaryAAC_Y, bool bIsUnaryAAC_Z,
						unsigned int nKVDPCMOrder,
						unsigned int nKVQBit,
						OriIDPCMKeyValue& oriIDPCMKeyValue);

	void CompMinKV(JWArray<Quaternion> & qFArray,
					int begin, int end, 
					int *MinKV, 
					int *numBitsKV);
	
	void ShiftKV(JWArray<Quaternion> &d,
					JWArray<Quaternion> &q, 
					   int *PMin, 
					   int begin, 
					   int end);

	int getNbBits(int k);

public:
	int				numBitsKV[3];
	// first intra key value
	unsigned int	firstQKV_S;
	unsigned int	nFirstXSign;
	unsigned int	firstQKV_X;
	unsigned int	nFirstYSign;
	unsigned int	firstQKV_Y;
	unsigned int	nFirstZSign;
	unsigned int	firstQKV_Z;

	// second intra key value
	unsigned int	nSecondXSign;
	unsigned int	secondQKV_X;
	unsigned int	nSecondYSign;
	unsigned int	secondQKV_Y;
	unsigned int	nSecondZSign;
	unsigned int	secondQKV_Z;

	// more than 2 key values
	bool			bIsMoreTwoKVs;
	
	// for check if all the key values are same
	unsigned int	x_keyvalue_flag;
	unsigned int	y_keyvalue_flag;
	unsigned int	z_keyvalue_flag;

	// 
	OriIKeyValueCodingBit oriIKVCodingBit_X;
	OriIKeyValueCodingBit oriIKVCodingBit_Y;
	OriIKeyValueCodingBit oriIKVCodingBit_Z;

};

#endif // !defined(AFX_ORIIDPCMKEYVALUEHEADER_H__96E53306_1481_4C8B_BF9B_561AEACD3056__INCLUDED_)
