// QuatError.cpp: implementation of the QuatError class.
//
//////////////////////////////////////////////////////////////////////




#include "QuatError.h"
#include "SFRotation.h"
#include "Quaternion.h"

//typedef	 SFRotation Rotation;

#include <math.h>
#include <string.h>
#include <stdlib.h>


#define MAX(x, y)       ( (x) < (y) ? (y) : (x) )
#define MIN(x, y)       ( (x) < (y) ? (x) : (y) )
#define ABS(x)          ( (x) < 0.0 ? -1.0*(x) : (x) ) // HELLO! //
#define DELTA			1.0E-50
// jameskim 20011126
#define SmallestNumber 1.0E-16                    // Modefied: 11.26


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
//extern int test;

QuatError::QuatError()
{
	srcfp = NULL;
	decfp = NULL;
	outfp = NULL;
	nBits = 0;
}

QuatError::QuatError(FILE* in_srcfp, FILE* in_decfp, FILE* in_outfp, int in_nBits)
{
	srcfp = in_srcfp;
	decfp = in_decfp;
	outfp = in_outfp;
	nBits = in_nBits;
}

QuatError::~QuatError()
{

}


void QuatError::MeasureError(void)
{
	double		peakError = 0.0;
	double		rmsError = 0.0;
	double		errorAngle = 0.0;
	int			totalKey = 0;
	int			nKey = 0;
	char		interpolator_type[1];
	int			i;
	int			dummyKey = 0;
	double		dummyKeyValue = 0.0;

	Quaternion	*m_pDecQuat, *m_pInQuat;
	SFRotation	*m_pDecRot, *m_pInRot;

	
	//Loop 
	while(!feof(srcfp) && !feof(decfp))
	{

		// src file д´
		//interpolator type ȮѴ
		fscanf(srcfp, "%s\n", interpolator_type);

		while(1)
		{
			//orientation interpolator   
			if( (strcmp("O", interpolator_type) == 0) || (strcmp("o", interpolator_type) == 0) )
			{
				//# of key о д
				fscanf(srcfp, "%d\n", &nKey);

				//# of keyŭ Rotation 迭 ´.
				m_pInRot = new SFRotation[nKey];
				
				//# of keyŭ Quaternion 迭 ´.
				m_pInQuat = new Quaternion[nKey];
				
				//key о .
				for(i = 0;i < nKey;i++)
					fscanf(srcfp, "%f\n", &dummyKey);

				//keyValue од
				for(i = 0;i < nKey;i++)
				{
					
					fscanf(srcfp, "%lf\n", &m_pInRot[i].x); 
					fscanf(srcfp, "%lf\n", &m_pInRot[i].y); 
					fscanf(srcfp, "%lf\n", &m_pInRot[i].z); 
					fscanf(srcfp, "%lf\n", &m_pInRot[i].theta); 
				}		

				//keyValue  Quaternion ȯѴ.
				for(i = 0;i < nKey;i++)
				{
					m_pInQuat[i].RotationToQuaternion(&m_pInRot[i]);
				}
				
				break;
			}
			else
			{
				//# of key о д
				fscanf(srcfp, "%f\n", &nKey);
				//key keyValue о .
				//key о .
				for(i = 0;i < nKey;i++)
					fscanf(srcfp, "%d\n", &dummyKey);
				//keyValue о .
				for(i = 0;i < nKey*4;i++)
				{
					fscanf(srcfp, "%lf\n", &dummyKeyValue); 
				}
				//ٽ ȭϿ inteprolator type  .
				fscanf(srcfp, "%s\n", interpolator_type);
			}
		}


		//̿ ϴ decoded file д´.
		//# of key о д
		int tmpKey = nKey;
		fscanf(decfp, "%d\n", &nKey);
		
		if(tmpKey != nKey)
		{
			printf("dismatched # of Key !!!\n");
			exit(0);
		}

		//# of keyŭ Rotation 迭 ´.
		m_pDecRot = new SFRotation[nKey];
		//# of keyŭ Quaternion 迭 ´.
		m_pDecQuat = new Quaternion[nKey];
				
		//keyValue од
		for(i = 0;i < nKey;i++)
		{
			
			fscanf(decfp, "%lf\n", &m_pDecRot[i].x); 
			fscanf(decfp, "%lf\n", &m_pDecRot[i].y); 
			fscanf(decfp, "%lf\n", &m_pDecRot[i].z); 
			fscanf(decfp, "%lf\n", &m_pDecRot[i].theta); 
		}		

		//keyValue  Quaternion ȯѴ.
		for(i = 0;i < nKey;i++)
		{
			m_pDecQuat[i].RotationToQuaternion(&m_pDecRot[i]);
		}
				

		//error Ѵ.
		
		for(i = 0;i < nKey;i++)
		{
			// ϴ quaternion error angle Ѵ.
			errorAngle = CalculateErrorAngle(m_pInQuat[i], m_pDecQuat[i]);
		
			//peak error Ѵ
			peakError = MAX(peakError, (2.0*sin(errorAngle/2.0)));

			//rms error  error angle  Ѵ.
			rmsError += 8.0 * sin(errorAngle/2.0) * sin(errorAngle/2.0) / 3.0;

		}

		totalKey += nKey;

		delete [] m_pDecRot;
		delete [] m_pDecQuat;
		delete [] m_pInRot;
		delete [] m_pInQuat;

	}
	//error angle  key   sqrtѴ(rms error)
	rmsError /= (double)totalKey;
	rmsError = sqrt(rmsError);
		
	//error Ѵ.
	fprintf(outfp, "%d", nBits);
	fprintf(outfp, "%E", peakError);
	fprintf(outfp, "%E\n", rmsError);
}

double QuatError::CalculateErrorAngle(Quaternion srcQuat, Quaternion decQuat)
{
	double errorAngle = 0.0;
	Quaternion	errorQuat(1.0, 0.0, 0.0, 0.0);

	srcQuat.Conjugate();

	errorQuat = decQuat * srcQuat;

	errorQuat.s = MAX(-1.0, errorQuat.s);
	errorQuat.s = MIN(1.0, errorQuat.s);

	// start jacobkim 20010107 
	// quaternion normalize   
	srcQuat.Conjugate();
	if((srcQuat.s == decQuat.s) && (srcQuat.x == decQuat.x) && (srcQuat.y == decQuat.y)
		&& (srcQuat.z == decQuat.z))
		return 0.0;
	else
		return(fabs(2.0 * acos(errorQuat.s)));

	//return(fabs(2.0 * acos(errorQuat.s)));
}


void QuatError::ComputeError(double & rms, double & peak, double & dur, int orgNKey,
							 JWArray<double>& orgKey, JWArray<Quaternion>& orgQuat, 
							 int decNKey, JWArray<double>& decKey, JWArray<Quaternion>& decQuat, int IdenticalArray)  // HELLO! //
{
	FILE *file;
	double MaxKey, MinKey;
	int input_key_counter = 0;
	int output_key_counter = 0;
	int tmp_key_counter;
	int sli_upper, sli_lower;
	int key_counter, NumberOfKeys;
	// jameskim 20010803
	double KeyNeck, ErrorAngleNeck;     // Neck !!
	double InputQuaternionNeck[4];      // Neck !!
	double OutputQuaternionNeck[4];     // Neck !!
	// end - jameskim 20010803


	MaxKey = 0.0;
	MinKey = 1.0;

	if ( !IdenticalArray ) NumberOfKeys = orgNKey + decNKey;// + 2;  HiJames //
	else                   NumberOfKeys = orgNKey;
	double* MixedKeys = (double *)calloc(NumberOfKeys, sizeof(double));
	double** InputQuaternions = (double **)calloc(NumberOfKeys, sizeof(double *));
	double** OutputQuaternions = (double **)calloc(NumberOfKeys, sizeof(double *));
	for ( key_counter = 0 ; key_counter < NumberOfKeys ; ++key_counter ) {
		InputQuaternions[key_counter] = (double *)calloc(4, sizeof(double));
		OutputQuaternions[key_counter] = (double *)calloc(4, sizeof(double));
	}


	if ( !IdenticalArray ) {
		input_key_counter = 0; output_key_counter = 0;                              //  HiJames //
		for ( key_counter = 0 ; key_counter < NumberOfKeys ; ++key_counter ) {      //  HiJames //
			if(input_key_counter == orgNKey)
			{
					MixedKeys[key_counter] = decKey[output_key_counter];                //  HiJames //
					OutputQuaternions[key_counter][0] = decQuat[output_key_counter].s;  //  HiJames //
					OutputQuaternions[key_counter][1] = decQuat[output_key_counter].x;  //  HiJames //
					OutputQuaternions[key_counter][2] = decQuat[output_key_counter].y;  //  HiJames //
					OutputQuaternions[key_counter][3] = decQuat[output_key_counter].z;  //  HiJames //
					InputQuaternions[key_counter][0] = -2.0;                            //  HiJames //
					InputQuaternions[key_counter][1] =  0.0;                            //  HiJames //
					InputQuaternions[key_counter][2] =  0.0;                            //  HiJames //
					InputQuaternions[key_counter][3] =  0.0;                            //  HiJames //
					++output_key_counter;
			}
			else if(output_key_counter == decNKey)
			{
					MixedKeys[key_counter] = orgKey[input_key_counter];                 //  HiJames //
					InputQuaternions[key_counter][0] = orgQuat[input_key_counter].s;    //  HiJames //
					InputQuaternions[key_counter][1] = orgQuat[input_key_counter].x;    //  HiJames //
					InputQuaternions[key_counter][2] = orgQuat[input_key_counter].y;    //  HiJames //
					InputQuaternions[key_counter][3] = orgQuat[input_key_counter].z;    //  HiJames //
					OutputQuaternions[key_counter][0] = -2.0;                           //  HiJames //
					OutputQuaternions[key_counter][1] =  0.0;                           //  HiJames //
					OutputQuaternions[key_counter][2] =  0.0;                           //  HiJames //
					OutputQuaternions[key_counter][3] =  0.0;                           //  HiJames //
					++input_key_counter;  
			}
			else
			{
				if ( orgKey[input_key_counter] < decKey[output_key_counter] ) {         //  HiJames //
					MixedKeys[key_counter] = orgKey[input_key_counter];                 //  HiJames //
					InputQuaternions[key_counter][0] = orgQuat[input_key_counter].s;    //  HiJames //
					InputQuaternions[key_counter][1] = orgQuat[input_key_counter].x;    //  HiJames //
					InputQuaternions[key_counter][2] = orgQuat[input_key_counter].y;    //  HiJames //
					InputQuaternions[key_counter][3] = orgQuat[input_key_counter].z;    //  HiJames //
					OutputQuaternions[key_counter][0] = -2.0;                           //  HiJames //
					OutputQuaternions[key_counter][1] =  0.0;                           //  HiJames //
					OutputQuaternions[key_counter][2] =  0.0;                           //  HiJames //
					OutputQuaternions[key_counter][3] =  0.0;                           //  HiJames //
					++input_key_counter;                                                //  HiJames //
				}                                                                       //  HiJames //
				else {                                                                  //  HiJames //
					MixedKeys[key_counter] = decKey[output_key_counter];                //  HiJames //
					OutputQuaternions[key_counter][0] = decQuat[output_key_counter].s;  //  HiJames //
					OutputQuaternions[key_counter][1] = decQuat[output_key_counter].x;  //  HiJames //
					OutputQuaternions[key_counter][2] = decQuat[output_key_counter].y;  //  HiJames //
					OutputQuaternions[key_counter][3] = decQuat[output_key_counter].z;  //  HiJames //
					InputQuaternions[key_counter][0] = -2.0;                            //  HiJames //
					InputQuaternions[key_counter][1] =  0.0;                            //  HiJames //
					InputQuaternions[key_counter][2] =  0.0;                            //  HiJames //
					InputQuaternions[key_counter][3] =  0.0;                            //  HiJames //
					++output_key_counter;                                               //  HiJames //
				}                                                                       //  HiJames //
			}
		}                                                                           //  HiJames //
		MinKey = MixedKeys[0];                                                      //  HiJames //
		MaxKey = MixedKeys[NumberOfKeys-1];                                         //  HiJames //



		file = fopen("jung.txt", "w");
		for(int kkk = 0 ;kkk < NumberOfKeys;kkk++)
		{
			if(OutputQuaternions[kkk][0] > 0.0)
			fprintf(file, "%g\t%g\t%g\t%g\t%g\t%g\t%g\t%g\t%g\n", MixedKeys[kkk], InputQuaternions[kkk][0],InputQuaternions[kkk][1],InputQuaternions[kkk][2],InputQuaternions[kkk][3],
				OutputQuaternions[kkk][0], OutputQuaternions[kkk][1], OutputQuaternions[kkk][2], OutputQuaternions[kkk][3]); 
			else
			fprintf(file, "%g\t%g\t%g\t%g\t%g\t%g\t%g\t%g\t%g\n", MixedKeys[kkk], InputQuaternions[kkk][0],InputQuaternions[kkk][1],InputQuaternions[kkk][2],InputQuaternions[kkk][3],
				-OutputQuaternions[kkk][0], -OutputQuaternions[kkk][1], -OutputQuaternions[kkk][2], -OutputQuaternions[kkk][3]); 

		}
		fclose(file);


/** HiJames
		for ( key_counter = 0 ; key_counter < orgNKey ; ++key_counter ) {
			MixedKeys[key_counter] = orgKey[input_key_counter];
			InputQuaternions[key_counter][0] = orgQuat[input_key_counter].s;
			InputQuaternions[key_counter][1] = orgQuat[input_key_counter].x;
			InputQuaternions[key_counter][2] = orgQuat[input_key_counter].y;
			InputQuaternions[key_counter][3] = orgQuat[input_key_counter].z;
			OutputQuaternions[key_counter][0] = -2.0;
			OutputQuaternions[key_counter][1] =  0.0;
			OutputQuaternions[key_counter][2] =  0.0;
			OutputQuaternions[key_counter][3] =  0.0;
			++input_key_counter;
			MaxKey = MAX(MixedKeys[key_counter], MaxKey);
			MinKey = MIN(MixedKeys[key_counter], MinKey);
		}
		for ( key_counter = 0 ; key_counter < decNKey ; ++key_counter ) {
			MixedKeys[key_counter+orgNKey] = decKey[output_key_counter];
			OutputQuaternions[key_counter+orgNKey][0] = decQuat[output_key_counter].s;
			OutputQuaternions[key_counter+orgNKey][1] = decQuat[output_key_counter].x;
			OutputQuaternions[key_counter+orgNKey][2] = decQuat[output_key_counter].y;
			OutputQuaternions[key_counter+orgNKey][3] = decQuat[output_key_counter].z;
			InputQuaternions[key_counter+orgNKey][0] = -2.0;
			InputQuaternions[key_counter+orgNKey][1] =  0.0;
			InputQuaternions[key_counter+orgNKey][2] =  0.0;
			InputQuaternions[key_counter+orgNKey][3] =  0.0;
			++output_key_counter;
			MaxKey = MAX(MixedKeys[key_counter+orgNKey], MaxKey);
			MinKey = MIN(MixedKeys[key_counter+orgNKey], MinKey);
		}HiJames **/
	}
	else {
		for ( key_counter = 0 ; key_counter < NumberOfKeys ; ++key_counter ) {
			MixedKeys[key_counter] = orgKey[key_counter];
			InputQuaternions[key_counter][0] = orgQuat[key_counter].s;
			InputQuaternions[key_counter][1] = orgQuat[key_counter].x;
			InputQuaternions[key_counter][2] = orgQuat[key_counter].y;
			InputQuaternions[key_counter][3] = orgQuat[key_counter].z;
			OutputQuaternions[key_counter][0] = decQuat[key_counter].s;
			OutputQuaternions[key_counter][1] = decQuat[key_counter].x;
			OutputQuaternions[key_counter][2] = decQuat[key_counter].y;
			OutputQuaternions[key_counter][3] = decQuat[key_counter].z;
			MaxKey = MAX(MixedKeys[key_counter], MaxKey);
			MinKey = MIN(MixedKeys[key_counter], MinKey);
		}
	}


	/*
	if(test >= 128)
	{
		for(int xxx = 0;xxx < orgNKey;xxx++)
			if((InputQuaternions[xxx][0] != OutputQuaternions[xxx+orgNKey][0]) ||
			(InputQuaternions[xxx][1] != OutputQuaternions[xxx+orgNKey][1]) ||
			(InputQuaternions[xxx][2] != OutputQuaternions[xxx+orgNKey][2]) ||
			(InputQuaternions[xxx][3] != OutputQuaternions[xxx+orgNKey][3]))
		{
			printf("ٸ after Է !!\n");
		}
	}
	*/

	if ( !IdenticalArray ) {
		// MixedKeys[  orgNKey+decNKey] = MinKey;  HiJames  //
		// MixedKeys[1+orgNKey+decNKey] = MaxKey;  HiJames  //
		// jameskim ...2001/04/15
		//MixedKeys[  orgNKey+decNKey] = 5.0;
		//MixedKeys[1+orgNKey+decNKey] = 5.0;
		
/** HiJames
		InputQuaternions[  orgNKey+decNKey][0] = -2.0;
		InputQuaternions[  orgNKey+decNKey][1] =  0.0;
		InputQuaternions[  orgNKey+decNKey][2] =  0.0;
		InputQuaternions[  orgNKey+decNKey][3] =  0.0;
		InputQuaternions[1+orgNKey+decNKey][0] = -2.0;
		InputQuaternions[1+orgNKey+decNKey][1] =  0.0;
		InputQuaternions[1+orgNKey+decNKey][2] =  0.0;
		InputQuaternions[1+orgNKey+decNKey][3] =  0.0;
		OutputQuaternions[  orgNKey+decNKey][0] = -2.0;
		OutputQuaternions[  orgNKey+decNKey][1] =  0.0;
		OutputQuaternions[  orgNKey+decNKey][2] =  0.0;
		OutputQuaternions[  orgNKey+decNKey][3] =  0.0;
		OutputQuaternions[1+orgNKey+decNKey][0] = -2.0;
		OutputQuaternions[1+orgNKey+decNKey][1] =  0.0;
		OutputQuaternions[1+orgNKey+decNKey][2] =  0.0;
		OutputQuaternions[1+orgNKey+decNKey][3] =  0.0;

		for ( key_counter = 0 ; key_counter < (NumberOfKeys-1) ; ++key_counter ) {
			for ( tmp_key_counter = (key_counter+1) ; tmp_key_counter < NumberOfKeys ; ++tmp_key_counter ) {
				if ( MixedKeys[tmp_key_counter] < MixedKeys[key_counter] ) {
				//if ( MixedKeys[tmp_key_counter] <= MixedKeys[key_counter] ) {
					DataSwapping(&MixedKeys[tmp_key_counter], &MixedKeys[key_counter]);
					DataSwapping(&InputQuaternions[tmp_key_counter][0], &InputQuaternions[key_counter][0]);
					DataSwapping(&InputQuaternions[tmp_key_counter][1], &InputQuaternions[key_counter][1]);
					DataSwapping(&InputQuaternions[tmp_key_counter][2], &InputQuaternions[key_counter][2]);
					DataSwapping(&InputQuaternions[tmp_key_counter][3], &InputQuaternions[key_counter][3]);
					DataSwapping(&OutputQuaternions[tmp_key_counter][0], &OutputQuaternions[key_counter][0]);
					DataSwapping(&OutputQuaternions[tmp_key_counter][1], &OutputQuaternions[key_counter][1]);
					DataSwapping(&OutputQuaternions[tmp_key_counter][2], &OutputQuaternions[key_counter][2]);
					DataSwapping(&OutputQuaternions[tmp_key_counter][3], &OutputQuaternions[key_counter][3]);
				}
			}
		}
Hijames **/

		//if( ((MixedKeys[135] - MixedKeys[136]) != 0) || ((MixedKeys[135] - MixedKeys[136]) != 0))
		//	printf("̷ ȵȴ !!!\n");
		
		// jameskim.. 2001/04/15
		//for ( key_counter = (NumberOfKeys-2) ; key_counter > 0 ; --key_counter ) 
		//{
		//		MixedKeys[key_counter] = MixedKeys[key_counter-1];
		//		InputQuaternions[key_counter][0] = InputQuaternions[key_counter-1][0];
		//		InputQuaternions[key_counter][1] = InputQuaternions[key_counter-1][1];
		//		InputQuaternions[key_counter][2] = InputQuaternions[key_counter-1][2];
		//		InputQuaternions[key_counter][3] = InputQuaternions[key_counter-1][3];
		//		OutputQuaternions[key_counter][0] = OutputQuaternions[key_counter-1][0];
		//		OutputQuaternions[key_counter][1] = OutputQuaternions[key_counter-1][1];
		//		OutputQuaternions[key_counter][2] = OutputQuaternions[key_counter-1][2];
		//		OutputQuaternions[key_counter][3] = OutputQuaternions[key_counter-1][3];
		//}

		//MixedKeys[0] = MinKey;
		//InputQuaternions[0][0] = -2.0;
		//InputQuaternions[0][1] =  0.0;
		//InputQuaternions[0][2] =  0.0;
		//InputQuaternions[0][3] =  0.0;
		//OutputQuaternions[0][0] = -2.0;
		//OutputQuaternions[0][1] =  0.0;
		//OutputQuaternions[0][2] =  0.0;
		//OutputQuaternions[0][3] =  0.0;
		//MixedKeys[1+orgNKey+decNKey] = MaxKey;
		
		if ( InputQuaternions[0][0] <= -2.0 ) {
			tmp_key_counter = 0;
			do {
				++tmp_key_counter;
			} while ( InputQuaternions[tmp_key_counter][0] <= -2.0 );
			InputQuaternions[0][0] = InputQuaternions[tmp_key_counter][0];
			InputQuaternions[0][1] = InputQuaternions[tmp_key_counter][1];
			InputQuaternions[0][2] = InputQuaternions[tmp_key_counter][2];
			InputQuaternions[0][3] = InputQuaternions[tmp_key_counter][3];
		}
		if ( InputQuaternions[NumberOfKeys-1][0] <= -2.0 ) {
			tmp_key_counter = NumberOfKeys - 1;
			do {
				--tmp_key_counter;
			} while ( InputQuaternions[tmp_key_counter][0] <= -2.0 );
			InputQuaternions[NumberOfKeys-1][0] = InputQuaternions[tmp_key_counter][0];
			InputQuaternions[NumberOfKeys-1][1] = InputQuaternions[tmp_key_counter][1];
			InputQuaternions[NumberOfKeys-1][2] = InputQuaternions[tmp_key_counter][2];
			InputQuaternions[NumberOfKeys-1][3] = InputQuaternions[tmp_key_counter][3];
		}
		if ( OutputQuaternions[0][0] <= -2.0 ) {
			tmp_key_counter = 0;
			do {
				++tmp_key_counter;
			} while ( OutputQuaternions[tmp_key_counter][0] <= -2.0 );
			OutputQuaternions[0][0] = OutputQuaternions[tmp_key_counter][0];
			OutputQuaternions[0][1] = OutputQuaternions[tmp_key_counter][1];
			OutputQuaternions[0][2] = OutputQuaternions[tmp_key_counter][2];
			OutputQuaternions[0][3] = OutputQuaternions[tmp_key_counter][3];
		}
		if ( OutputQuaternions[NumberOfKeys-1][0] <= -2.0 ) {
			tmp_key_counter = NumberOfKeys - 1;
			do {
				--tmp_key_counter;
			} while ( OutputQuaternions[tmp_key_counter][0] <= -2.0 );
			OutputQuaternions[NumberOfKeys-1][0] = OutputQuaternions[tmp_key_counter][0];
			OutputQuaternions[NumberOfKeys-1][1] = OutputQuaternions[tmp_key_counter][1];
			OutputQuaternions[NumberOfKeys-1][2] = OutputQuaternions[tmp_key_counter][2];
			OutputQuaternions[NumberOfKeys-1][3] = OutputQuaternions[tmp_key_counter][3];
		}

		for ( key_counter = 0 ; key_counter < NumberOfKeys ; ++key_counter ) {
			if ( InputQuaternions[key_counter][0] <= -2.0 ) {
				sli_upper = key_counter;
				sli_lower = key_counter;
				do {
					++sli_upper;
				} while ( InputQuaternions[sli_upper][0] <= -2.0 );
				do {
					--sli_lower;
				} while ( InputQuaternions[sli_lower][0] <= -2.0 );
			/*
					if(test >= 128)
						printf("key counter %d, lower %d, upper %d\n", key_counter, sli_lower, sli_upper);
			*/
				SphericalLinearInterpolator(InputQuaternions[key_counter],
											InputQuaternions[sli_lower],
											InputQuaternions[sli_upper],
											MixedKeys[key_counter],
											MixedKeys[sli_lower],
											MixedKeys[sli_upper]);
				/*
				if(test >= 128)
				{
					if( ( (InputQuaternions[key_counter][0] == InputQuaternions[sli_lower][0]) &&
						 (InputQuaternions[key_counter][1] == InputQuaternions[sli_lower][1]) &&
						 (InputQuaternions[key_counter][2] == InputQuaternions[sli_lower][2]) &&
						 (InputQuaternions[key_counter][3] == InputQuaternions[sli_lower][3]) )
						 ||
						( (InputQuaternions[key_counter][0] == InputQuaternions[sli_upper][0]) &&
						 (InputQuaternions[key_counter][1] == InputQuaternions[sli_upper][1]) &&
						 (InputQuaternions[key_counter][2] == InputQuaternions[sli_upper][2]) &&
						 (InputQuaternions[key_counter][3] == InputQuaternions[sli_upper][3]) )
					)
					{
						;
					}
					else
					{
						printf("̷ ȵȴ\n");
					}
				}
				*/
			}
			if ( OutputQuaternions[key_counter][0] <= -2.0 ) {
				sli_upper = key_counter;
				sli_lower = key_counter;
				do {
					++sli_upper;
				} while ( OutputQuaternions[sli_upper][0] <= -2.0 );
				do {
					--sli_lower;
				} while ( OutputQuaternions[sli_lower][0] <= -2.0 );
				/*
				if(test >= 128)
				{
					printf("key counter %d, lower %d, upper %d\n", key_counter, sli_lower, sli_upper);
					//printf("%g, %g, %g\n", MixedKeys[key_counter],
					//						MixedKeys[sli_lower],
					//						MixedKeys[sli_upper]);
				}
				*/
				SphericalLinearInterpolator(OutputQuaternions[key_counter],
											OutputQuaternions[sli_lower],
											OutputQuaternions[sli_upper],
											MixedKeys[key_counter],
											MixedKeys[sli_lower],
											MixedKeys[sli_upper]);
				/*
				if(test >= 128)
				{
					if( ( (InputQuaternions[key_counter][0] == OutputQuaternions[sli_lower][0]) &&
						 (InputQuaternions[key_counter][1] == OutputQuaternions[sli_lower][1]) &&
						 (InputQuaternions[key_counter][2] == OutputQuaternions[sli_lower][2]) &&
						 (InputQuaternions[key_counter][3] == OutputQuaternions[sli_lower][3]) )
						 ||
						( (InputQuaternions[key_counter][0] == OutputQuaternions[sli_upper][0]) &&
						 (InputQuaternions[key_counter][1] == OutputQuaternions[sli_upper][1]) &&
						 (InputQuaternions[key_counter][2] == OutputQuaternions[sli_upper][2]) &&
						 (InputQuaternions[key_counter][3] == OutputQuaternions[sli_upper][3]) )
					)
					{
						;
					}
					else
					{
						printf("̷ ȵȴ\n");
					}
				}
				*/
			}
		}
	}

	if(!IdenticalArray){
	//FILE *file;
	file = fopen("jung.txt", "a+");
	fprintf(file, "a\n");
	for(int kkk = 0 ;kkk < NumberOfKeys;kkk++)
		{
			if(OutputQuaternions[kkk][0] > 0.0)
			fprintf(file, "%g\t%g\t%g\t%g\t%g\t%g\t%g\t%g\t%g\n", MixedKeys[kkk], InputQuaternions[kkk][0],InputQuaternions[kkk][1],InputQuaternions[kkk][2],InputQuaternions[kkk][3],
				OutputQuaternions[kkk][0], OutputQuaternions[kkk][1], OutputQuaternions[kkk][2], OutputQuaternions[kkk][3]); 
			else
			fprintf(file, "%g\t%g\t%g\t%g\t%g\t%g\t%g\t%g\t%g\n", MixedKeys[kkk], InputQuaternions[kkk][0],InputQuaternions[kkk][1],InputQuaternions[kkk][2],InputQuaternions[kkk][3],
				-OutputQuaternions[kkk][0], -OutputQuaternions[kkk][1], -OutputQuaternions[kkk][2], -OutputQuaternions[kkk][3]); 

		}
		fprintf(file, "a\n");
	}

	double PeakError = 0.0;
	double NodeMeanError = 0.0;
	double TmpData, ErrorAngle1, ErrorAngle2;
	double TimeDuration;

	for ( key_counter = 0 ; key_counter < (NumberOfKeys-1) ; ++key_counter ) { // HELLO! //
		// jameskim 20010828 ʹ  key ̿ ־ error  Ѵ.
		if ( DELTA < (MixedKeys[key_counter+1]-MixedKeys[key_counter]) ) {
			// jameskim 20010803	
			ErrorAngle1 = InnerProduct(InputQuaternions[key_counter  ], OutputQuaternions[key_counter  ]);
			ErrorAngle2 = InnerProduct(InputQuaternions[key_counter+1], OutputQuaternions[key_counter+1]);
			if ( ErrorAngle1 < 0.0 ) ErrorAngle1 = -ErrorAngle1; ErrorAngle1 = acos(ErrorAngle1);
			if ( ErrorAngle2 < 0.0 ) ErrorAngle2 = -ErrorAngle2; ErrorAngle2 = acos(ErrorAngle2);
			KeyNeck = MixedKeys[key_counter+1] - MixedKeys[key_counter];
			if ( KeyNeck < DELTA ) {
				KeyNeck = MixedKeys[key_counter+1];
				ErrorAngleNeck = ( ErrorAngle1 + ErrorAngle2 ) / 2.0;
			}
			else {
				if ( (ErrorAngle1+ErrorAngle2) < DELTA ) {
					KeyNeck *= 0.5;
				}
				else {
					KeyNeck *= ErrorAngle1 / ( ErrorAngle1 + ErrorAngle2 );
				}
				KeyNeck += MixedKeys[key_counter];
				SphericalLinearInterpolator(&InputQuaternionNeck[0],
					InputQuaternions[key_counter],
					InputQuaternions[key_counter+1],
					KeyNeck,
					MixedKeys[key_counter],
					MixedKeys[key_counter+1]);

				
				if(key_counter == 297)
				{ 
					//printf("hi");
					key_counter = 297;
				}

				SphericalLinearInterpolator(&OutputQuaternionNeck[0],
					OutputQuaternions[key_counter],
					OutputQuaternions[key_counter+1],
					KeyNeck,
					MixedKeys[key_counter],
					MixedKeys[key_counter+1]);
				ErrorAngleNeck = InnerProduct(&InputQuaternionNeck[0], &OutputQuaternionNeck[0]);
				if ( ErrorAngleNeck < 0.0 ) ErrorAngleNeck = -ErrorAngleNeck; ErrorAngleNeck = acos(ErrorAngleNeck);
			}
			TmpData = ErrorAngle1 * ErrorAngle1 + ErrorAngleNeck * ErrorAngleNeck + ErrorAngle1 * ErrorAngleNeck;
			TmpData = 4.0 * ( KeyNeck - MixedKeys[key_counter] ) * TmpData / 3.0;
			NodeMeanError += TmpData;
			double Error1 = TmpData;

			TmpData = ErrorAngleNeck * ErrorAngleNeck + ErrorAngle2 * ErrorAngle2 + ErrorAngleNeck * ErrorAngle2;
			TmpData = 4.0 * ( MixedKeys[key_counter+1] - KeyNeck ) * TmpData / 3.0;
			NodeMeanError += TmpData;

			if(!IdenticalArray)
				fprintf(file, "%g\t%g\t%g\t%g\n", MixedKeys[key_counter], MixedKeys[key_counter+1], Error1, TmpData); 

			PeakError = MAX((2.0*ErrorAngle1), PeakError); // HELLO! //
			PeakError = MAX((2.0*ErrorAngle2), PeakError); // HELLO! //
			PeakError = MAX((2.0*ErrorAngleNeck), PeakError); // HELLO! //
		} // jameskim 20010828 end if

		//  end - jameskim 20010803	
		/*
		ErrorAngle1 = InnerProduct(InputQuaternions[key_counter  ], OutputQuaternions[key_counter  ]);

		ErrorAngle2 = InnerProduct(InputQuaternions[key_counter+1], OutputQuaternions[key_counter+1]);

		ErrorAngle1 = ABS(ErrorAngle1); ErrorAngle1 = acos(ErrorAngle1);
		ErrorAngle2 = ABS(ErrorAngle2); ErrorAngle2 = acos(ErrorAngle2);
		TmpData = ErrorAngle1 * ErrorAngle1 + ErrorAngle2 * ErrorAngle2 + ErrorAngle1 * ErrorAngle2;
		TmpData = 4.0 * ( MixedKeys[key_counter+1] - MixedKeys[key_counter] ) * TmpData / 3.0;





		NodeMeanError += TmpData;

		PeakError = MAX((2.0*ErrorAngle1), PeakError); // HELLO! //
		PeakError = MAX((2.0*ErrorAngle2), PeakError); // HELLO! //
		*/
		/*
		if(!IdenticalArray){
			fprintf(file, "%g\t%g\n", MixedKeys[key_counter], TmpData); 
		}
		*/
	}

	TimeDuration = MaxKey -	MinKey;

	
	rms = NodeMeanError;
	peak = PeakError;
	dur = TimeDuration;

	if(!IdenticalArray){
		fclose(file);
	}


	
	for ( key_counter = 0 ; key_counter < NumberOfKeys ; ++key_counter ) { // HELLO! //
		free(InputQuaternions[key_counter]);
		free(OutputQuaternions[key_counter]);
	}

	free(MixedKeys);
	free(InputQuaternions);
	free(OutputQuaternions);

}


void QuatError::DataSwapping(double *Data1, double *Data2)
{
	double TmpData;
	TmpData = *Data1;
	*Data1 = *Data2;
	*Data2 = TmpData;
	return;
}

double QuatError::Norm(double *SrcQuaternion)
{
	double TmpData;
	TmpData = SrcQuaternion[0] * SrcQuaternion[0]
	        + SrcQuaternion[1] * SrcQuaternion[1]
			+ SrcQuaternion[2] * SrcQuaternion[2]
			+ SrcQuaternion[3] * SrcQuaternion[3];
	if ( 1.0 <= TmpData ) return(1.0);
	return(sqrt(TmpData));
}


double QuatError::InnerProduct(double *SrcQuaternion1, double *SrcQuaternion2)
{
	double TmpData, norm1, norm2;

	if ( ( SrcQuaternion1[0] == SrcQuaternion2[0] ) &&
		 ( SrcQuaternion1[1] == SrcQuaternion2[1] ) &&
		 ( SrcQuaternion1[2] == SrcQuaternion2[2] ) && 
		 ( SrcQuaternion1[3] == SrcQuaternion2[3] ) )
	{
		return 1.0;
	}
	if ( ( SrcQuaternion1[0] == -SrcQuaternion2[0] ) &&  // HELLO! //
		 ( SrcQuaternion1[1] == -SrcQuaternion2[1] ) &&  // HELLO! //
		 ( SrcQuaternion1[2] == -SrcQuaternion2[2] ) &&  // HELLO! //
		 ( SrcQuaternion1[3] == -SrcQuaternion2[3] ) )   // HELLO! //
	{                                                    // HELLO! //
		return -1.0;                                     // HELLO! //
	}                                                    // HELLO! //
		
	norm1 = Norm(SrcQuaternion1);
	norm2 = Norm(SrcQuaternion2);
	TmpData = SrcQuaternion1[0] * SrcQuaternion2[0]
	        + SrcQuaternion1[1] * SrcQuaternion2[1]
			+ SrcQuaternion1[2] * SrcQuaternion2[2]
			+ SrcQuaternion1[3] * SrcQuaternion2[3];
	TmpData /= norm1 * norm2;
	if ( ( ABS(TmpData) <= ( norm1 * SmallestNumber ) ) || ( ABS(TmpData) <= ( norm2 * SmallestNumber ) ) ) TmpData = 0.0; // Modefied: 11.26
	if ( TmpData <= -1.0 ) return (-1.0);
	if ( 1.0 <= TmpData  ) return ( 1.0);
	return (TmpData);
}

void QuatError::SphericalLinearInterpolator(double *TargetQuaternion, double *LowerQuaternion, double *UpperQuaternion, double TargetTime, double LowerTime, double UpperTime)
{
	double phi, eta, norm, TimeDuration, weightL, weightU; // HELLO! //
	TimeDuration = UpperTime - LowerTime;
	if ( TimeDuration < DELTA ) {                          // HELLO! //
		TargetQuaternion[0] = LowerQuaternion[0];
		TargetQuaternion[1] = LowerQuaternion[1];
		TargetQuaternion[2] = LowerQuaternion[2];
		TargetQuaternion[3] = LowerQuaternion[3];
	}
	else {
		norm = InnerProduct(LowerQuaternion, UpperQuaternion);
		eta = ( TargetTime - LowerTime ) / TimeDuration;
		if ( eta < DELTA )
		{
			TargetQuaternion[0] = LowerQuaternion[0];
			TargetQuaternion[1] = LowerQuaternion[1];
			TargetQuaternion[2] = LowerQuaternion[2];
			TargetQuaternion[3] = LowerQuaternion[3];
		}
		else if ( (1-eta) < DELTA )                        // HELLO! //
		{
			TargetQuaternion[0] = UpperQuaternion[0];
			TargetQuaternion[1] = UpperQuaternion[1];
			TargetQuaternion[2] = UpperQuaternion[2];
			TargetQuaternion[3] = UpperQuaternion[3];
		}
		else
		{
			phi = acos(fabs(norm));
			if ( phi < DELTA ) {                       // HELLO! //
				TargetQuaternion[0] = UpperQuaternion[0];
				TargetQuaternion[1] = UpperQuaternion[1];
				TargetQuaternion[2] = UpperQuaternion[2];
				TargetQuaternion[3] = UpperQuaternion[3];
			}
			else {
				if ( /*((double)3.1415926535897932384338/2.0) < phi*/ norm < 0.0 ) {
				//if ( (3.1415926535897932384338/2.0) < phi ) {           // HELLO! //
					Quaternion temp;
					temp.s = - UpperQuaternion[0];
					temp.x = - UpperQuaternion[1];
					temp.y = - UpperQuaternion[2];
					temp.z = - UpperQuaternion[3];

					//phi = (double)3.1415926535897932384338 - phi;
					//phi = acos(0.0) - phi;
					weightL = sin((1.0-eta)*phi)/sin(phi);              // HELLO! //
					weightU = sin(     eta *phi)/sin(phi);              // HELLO! //
					TargetQuaternion[0] = LowerQuaternion[0] * weightL + temp.s * weightU; // HELLO! //
					TargetQuaternion[1] = LowerQuaternion[1] * weightL + temp.x * weightU; // HELLO! //
					TargetQuaternion[2] = LowerQuaternion[2] * weightL + temp.y * weightU; // HELLO! //
					TargetQuaternion[3] = LowerQuaternion[3] * weightL + temp.z * weightU; // HELLO! //
					//TargetQuaternion[0] = LowerQuaternion[0] * weightL - UpperQuaternion[0] * weightU; // HELLO! //
					//TargetQuaternion[1] = LowerQuaternion[1] * weightL - UpperQuaternion[1] * weightU; // HELLO! //
					//TargetQuaternion[2] = LowerQuaternion[2] * weightL - UpperQuaternion[2] * weightU; // HELLO! //
					//TargetQuaternion[3] = LowerQuaternion[3] * weightL - UpperQuaternion[3] * weightU; // HELLO! //




				}
				else {
					weightL = sin((1.0-eta)*phi)/sin(phi);              // HELLO! //
					weightU = sin(     eta *phi)/sin(phi);              // HELLO! //
					TargetQuaternion[0] = LowerQuaternion[0] * weightL + UpperQuaternion[0] * weightU; // HELLO! //
					TargetQuaternion[1] = LowerQuaternion[1] * weightL + UpperQuaternion[1] * weightU; // HELLO! //
					TargetQuaternion[2] = LowerQuaternion[2] * weightL + UpperQuaternion[2] * weightU; // HELLO! //
					TargetQuaternion[3] = LowerQuaternion[3] * weightL + UpperQuaternion[3] * weightU; // HELLO! //
				}
				norm = Norm(TargetQuaternion);
				TargetQuaternion[0] /= norm;
				TargetQuaternion[1] /= norm;
				TargetQuaternion[2] /= norm;
				TargetQuaternion[3] /= norm;
			}
		}
	}
	return;
}