// QuatError.h: interface for the QuatError class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_QUATERROR_H__9524865A_4A0B_4032_B538_8060E80F1BD4__INCLUDED_)
#define AFX_QUATERROR_H__9524865A_4A0B_4032_B538_8060E80F1BD4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <stdio.h>
#include "JWTemplArray.h"

class Quaternion;

class QuatError  
{
public:
	QuatError();
	QuatError(FILE* in_srcfp, FILE* in_decfp, FILE* in_outfp, int in_nBits);
	virtual ~QuatError();


//member fvariables
public:
	FILE*	srcfp;
	FILE*	decfp;
	FILE*	outfp;
	int		nBits;
//member functions
public:
	void MeasureError(void);
	double CalculateErrorAngle(Quaternion srcQuat, Quaternion decQuat);
	//void ComputeError(double &, double &, double &, int, JWArray<double>&, JWArray<Quaternion>&, 
	//			int, JWArray<double>&, JWArray<Quaternion>&);
	void ComputeError(double &, double &, double &, int, JWArray<double>&, JWArray<Quaternion>&, 
				int, JWArray<double>&, JWArray<Quaternion>&, int IdenticalArray);
	void DataSwapping(double *Data1, double *Data2);
	double Norm(double *SrcQuaternion);
	double InnerProduct(double *SrcQuaternion1, double *SrcQuaternion2);
	void SphericalLinearInterpolator(double *TargetQuaternion, double *LowerQuaternion,
		double *UpperQuaternion, double TargetTime, double LowerTime, double UpperTime);
	
};

#endif // !defined(AFX_QUATERROR_H__9524865A_4A0B_4032_B538_8060E80F1BD4__INCLUDED_)
