// Quaternion.h: interface for the Quaternion class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_QUATERNION_H__4FBBD18F_0CE8_4134_AF89_FCCFF71CB5CF__INCLUDED_)
#define AFX_QUATERNION_H__4FBBD18F_0CE8_4134_AF89_FCCFF71CB5CF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class SFRotation;

class Quaternion  
{
public:
	Quaternion(); // default ctor
	Quaternion(double in_s, double in_x, double in_y, double in_z); // customize initialization ctor
	Quaternion(const Quaternion& src);// copy ctor
	virtual ~Quaternion();

//member variables
public:
	double s;
	double x;
	double y;
	double z;

//member function
public:
	//Spherical Linear interpolation
	void Slerp(Quaternion* m_pDestQuat, double u, Quaternion* m_pResQuat);

	//Convert AngularDisplacement to UnitQuaternion 
	void RotationToQuaternion(SFRotation* m_pSrcRot);
	// quaternion ȯ theta ׻ -PI ~ +PI ̿ α 
	double RotationAngleTruncation(double theta);
	//complex conjugate
	void Conjugate(void);
	// normalize
	void Normalize(void);


//member operator
public:
	//Quaternion Multiplication Operator
	Quaternion operator* (const Quaternion &r_operand) const;   
	//Quaternion Addition Operator
	Quaternion operator+ (const Quaternion &r_operand) const;   
	//Quaternion Inner Product Operator
	double operator^ (const Quaternion &r_operand) const;   
	//Quaternion Equal Operator
	const Quaternion& operator= (const Quaternion &r_operand);   

};

#endif // !defined(AFX_QUATERNION_H__4FBBD18F_0CE8_4134_AF89_FCCFF71CB5CF__INCLUDED_)
