// SelectedKeyFrame.h: interface for the CSelectedKeyFrame class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SELECTEDKEYFRAME_H__07B84B7E_C4A9_4962_879F_02E9AE171D22__INCLUDED_)
#define AFX_SELECTEDKEYFRAME_H__07B84B7E_C4A9_4962_879F_02E9AE171D22__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "JWTemplArray.h"
#include "Quaternion.h"
#include "SFRotation.h"


class CSelectedKeyFrame  
{
public:
	CSelectedKeyFrame();
	virtual ~CSelectedKeyFrame();

	void Initialize();

public:
	void SetThreshold(double dThreshold) { m_dThreshold = dThreshold; }

	void SetOriginalKeys(JWArray<double>& adKeys)
	{
		m_adOriginalKeys.Copy(adKeys);
		m_nKey = m_adOriginalKeys.GetSize();
	}
	void SetSelectedKeys(JWArray<double>& adKeys, int nKey)
	{
		m_adSelectedKeys.Copy(adKeys);
		m_nSelectedKey = nKey;
	}

	void SetOriginalQuaternions(JWArray<Quaternion>& aQuats) { m_aQuatOriginalQuat.Copy(aQuats); }
	void SetSelectedQuaternions(JWArray<Quaternion>& aQuats) { m_aQuatSelectedQuat.Copy(aQuats); }

	void SetOriginalRotation(JWArray<SFRotation>& aRots) { m_aRotOriginalRot.Copy(aRots); }
	void SetSelectedRotation(JWArray<SFRotation>& aRots) { m_aRotSelectedRot.Copy(aRots); }

	void SetKeyFlag(JWArray<int>& aKeyFlag) { m_anKeyFlag.Copy(aKeyFlag); }
	void SetNotInterpolatoredIndex(JWArray<int>& aNotInterpIndex)
	{ m_anNotInterpolatedIndex.Copy(aNotInterpIndex); }



	int GetNumberOfSelectedKeys() { return m_nSelectedKey; }
	int GetNumberOfOriginalKeys() { return m_nKey; }
	double GetThreshold() { return m_dThreshold; }



	JWArray<double>& GetOriginalKeys() { return m_adOriginalKeys; }
	JWArray<double>& GetSelectedKeys() { return m_adSelectedKeys; }

	JWArray<Quaternion>& GetOriginalQuaternions() { return m_aQuatOriginalQuat; }
	JWArray<Quaternion>& GetSelectedQuaternions() { return m_aQuatSelectedQuat; }

	JWArray<SFRotation>& GetOriginalRotation() { return m_aRotOriginalRot; }
	JWArray<SFRotation>& GetSelectedRotation() { return m_aRotSelectedRot; }

	JWArray<int>& GetKeyFlag() { return m_anKeyFlag; }
	JWArray<int>& GetNotInterpolatoredIndex() { return m_anNotInterpolatedIndex; }



protected:
	double m_dThreshold;

	JWArray<double> m_adOriginalKeys;
	JWArray<double> m_adSelectedKeys;

	JWArray<Quaternion> m_aQuatOriginalQuat;
	JWArray<Quaternion> m_aQuatSelectedQuat;

	JWArray<SFRotation> m_aRotOriginalRot;
	JWArray<SFRotation> m_aRotSelectedRot;

	JWArray<int> m_anKeyFlag;
	JWArray<int> m_anNotInterpolatedIndex;

	int m_nSelectedKey;
	int m_nKey;

};

#endif // !defined(AFX_SELECTEDKEYFRAME_H__07B84B7E_C4A9_4962_879F_02E9AE171D22__INCLUDED_)
