/***********************************************************************
This software module was originally developed by James D. K. Kim, 
Sang Oak Woo and Shin Jun Lee(Samsung Advance Institute of Technology)
in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
standard. This software module is an implementation of a part of one or
more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4
Systems (ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 
Systems (ISO/IEC 14496-1) free license to this software module or 
modifications thereof for use in hardware or software products claiming
conformance to the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to 
use this software module in hardware or software products are advised that
its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Samsung Advance Institute of Technology
retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using
the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
This copyright notice must be included in all copies or derivative works.
Copyright  2001
************************************************************************

For more information or to receive an up to date version of this module,
you may contact James D. K. Kim at jacobkim@sait.samsung.co.kr
----------------------------------------------------------------------*/

// OriIDPCMKeyValue.h: interface for the OriIDPCMKeyValue class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ORIIDPCMKEYVALUE_H__1CBA7829_779F_4098_96E3_2BD16255E038__INCLUDED_)
#define AFX_ORIIDPCMKEYVALUE_H__1CBA7829_779F_4098_96E3_2BD16255E038__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <stdio.h>
#include "Entropy.h"
#include "KeySelectionFlag.h"
#include "OriIKeyValueHeader.h"
#include "OriIDPCMKeyValueHeader.h"
#include "JWTemplArray.h"
#include "Quaternion.h"
#include "SFRotation.h"
#include "Quantizer.h"
#include "QuatError.h"
//#include "arithmeticDecoder.h"

class OriIDPCMKeyValue  
{
public:
	OriIDPCMKeyValue();
	virtual ~OriIDPCMKeyValue();

public:
	void readBitstream(
		CAC_QF& codec,
		OriIDPCMKeyValueHeader& kvHeader,
		int nNumKV
	);

	void InitializeModel();

	void decodingProcess(
		KeyHeader& kHeader,
		KeySelectionFlag& ksFlag,
		OriIKeyValueHeader& oriIKVHeader,
		double* key,
		JWArray <SFRotation>& keyValue,
		JWArray <Quaternion>& keyValueQuat
	);

	void ICDPCM(
		int* curIDPCMKeyValue, 
		int deltaKeyValue, 
		int prevIDPCMKeyValue,
		int nKVQBit
	);

public:
	JWArray <Quaternion>	DeltaKeyValue;
	
	SAIT_CAC						kvXUSignContext;
	SAIT_CAC						kvXUContext;
	SAIT_CAC						kvYUSignContext;
	SAIT_CAC						kvYUContext;
	SAIT_CAC						kvZUSignContext;
	SAIT_CAC						kvZUContext;
	SAIT_CAC						kvXSignContext;
	SAIT_CAC						kvXContext[32];
	SAIT_CAC						kvYSignContext;
	SAIT_CAC						kvYContext[32];
	SAIT_CAC						kvZSignContext;
	SAIT_CAC						kvZContext[32];
};

#endif // !defined(AFX_ORIIDPCMKEYVALUE_H__1CBA7829_779F_4098_96E3_2BD16255E038__INCLUDED_)
