/***********************************************************************
This software module was originally developed by James D. K. Kim, 
Sang Oak Woo and Shin Jun Lee(Samsung Advance Institute of Technology)
in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
standard. This software module is an implementation of a part of one or
more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4
Systems (ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 
Systems (ISO/IEC 14496-1) free license to this software module or 
modifications thereof for use in hardware or software products claiming
conformance to the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to 
use this software module in hardware or software products are advised that
its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Samsung Advance Institute of Technology
retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using
the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
This copyright notice must be included in all copies or derivative works.
Copyright  2001
************************************************************************

For more information or to receive an up to date version of this module,
you may contact James D. K. Kim at jacobkim@sait.samsung.co.kr
----------------------------------------------------------------------*/

// OriIDPCMKeyValueHeader.cpp: implementation of the OriIDPCMKeyValueHeader class.
//
//////////////////////////////////////////////////////////////////////

//#include "stdafx.h"
#include "OriIDPCMKeyValueHeader.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

OriIDPCMKeyValueHeader::OriIDPCMKeyValueHeader()
{

}

OriIDPCMKeyValueHeader::~OriIDPCMKeyValueHeader()
{

}

void OriIDPCMKeyValueHeader::readBitstream(CAC_QF& codec, unsigned int nKVQBit, unsigned int nKVDPCMOrder)
{
	// first or second DPCM 
	// read first intra KV
	firstQKV_S = codec._istrm->getbits(nKVQBit-1);

	nFirstXSign = codec._istrm->getbits(1);
	firstQKV_X = codec._istrm->getbits(nKVQBit-1);

	nFirstYSign = codec._istrm->getbits(1);
	firstQKV_Y = codec._istrm->getbits(nKVQBit-1);

	nFirstZSign = codec._istrm->getbits(1);
	firstQKV_Z = codec._istrm->getbits(nKVQBit-1);

	// 2nd order DPCM
	// read first intra KV
	if(nKVDPCMOrder == 1)
	{
		nSecondXSign = codec._istrm->getbits(1);
		secondQKV_X = codec._istrm->getbits(nKVQBit-1);

		nSecondYSign = codec._istrm->getbits(1);
		secondQKV_Y = codec._istrm->getbits(nKVQBit-1);

		nSecondZSign = codec._istrm->getbits(1);
		secondQKV_Z = codec._istrm->getbits(nKVQBit-1);

		bIsMoreTwoKVs = (codec._istrm->getbits(1) == 0 ? (bool)false: (bool)true);
	}

	// read key value flag to check if all the key values are same
	if((nKVDPCMOrder == 0) || (bIsMoreTwoKVs == 1))
	{
		x_keyvalue_flag = codec._istrm->getbits(1);
		oriIKVCodingBit_X.readBitstream(codec, x_keyvalue_flag, nKVQBit);

		y_keyvalue_flag = codec._istrm->getbits(1);
		oriIKVCodingBit_Y.readBitstream(codec, y_keyvalue_flag, nKVQBit);

		z_keyvalue_flag = codec._istrm->getbits(1);
		oriIKVCodingBit_Z.readBitstream(codec, z_keyvalue_flag, nKVQBit);
	}
}