/***********************************************************************
This software module was originally developed by James D. K. Kim, 
Sang Oak Woo and Shin Jun Lee(Samsung Advance Institute of Technology)
in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
standard. This software module is an implementation of a part of one or
more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4
Systems (ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 
Systems (ISO/IEC 14496-1) free license to this software module or 
modifications thereof for use in hardware or software products claiming
conformance to the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to 
use this software module in hardware or software products are advised that
its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Samsung Advance Institute of Technology
retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using
the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
This copyright notice must be included in all copies or derivative works.
Copyright  2001
************************************************************************

For more information or to receive an up to date version of this module,
you may contact James D. K. Kim at jacobkim@sait.samsung.co.kr
----------------------------------------------------------------------*/

// OriIDPCMKeyValueHeader.h: interface for the OriIDPCMKeyValueHeader class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ORIIDPCMKEYVALUEHEADER_H__1F7C8E89_88D9_4034_9491_92ECCDC0B358__INCLUDED_)
#define AFX_ORIIDPCMKEYVALUEHEADER_H__1F7C8E89_88D9_4034_9491_92ECCDC0B358__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ArithmeticDecoder.h"
#include "OriIKeyValueCodingBit.h"
#include "Entropy.h"

class OriIDPCMKeyValueHeader  
{
public:
	OriIDPCMKeyValueHeader();
	virtual ~OriIDPCMKeyValueHeader();

public:
	void readBitstream(
		CAC_QF& codec, 
		unsigned int nKVQBit, 
		unsigned int nKVDPCMOrder
	);

public:
	// first intra key value
	unsigned int	firstQKV_S;
	unsigned int	nFirstXSign;
	unsigned int	firstQKV_X;
	unsigned int	nFirstYSign;
	unsigned int	firstQKV_Y;
	unsigned int	nFirstZSign;
	unsigned int	firstQKV_Z;

	// second intra key value
	unsigned int	nSecondXSign;
	unsigned int	secondQKV_X;
	unsigned int	nSecondYSign;
	unsigned int	secondQKV_Y;
	unsigned int	nSecondZSign;
	unsigned int	secondQKV_Z;

	// more than 2 key values
	bool			bIsMoreTwoKVs;
	
	// for check if all the key values are same
	unsigned int	x_keyvalue_flag;
	unsigned int	y_keyvalue_flag;
	unsigned int	z_keyvalue_flag;

	// 
	OriIKeyValueCodingBit oriIKVCodingBit_X;
	OriIKeyValueCodingBit oriIKVCodingBit_Y;
	OriIKeyValueCodingBit oriIKVCodingBit_Z;


};

#endif // !defined(AFX_ORIIDPCMKEYVALUEHEADER_H__1F7C8E89_88D9_4034_9491_92ECCDC0B358__INCLUDED_)
