#include "ArithmeticDecoder.h"

void encodeSignedAAC(CAC_QF& codec, int nValue, int qstep, CAC& signContext, CAC* valueContext)
	{
	int i;
	for(i=qstep-2; i >= 0; i--)
		{
		int val = (nValue >= 0) ? nValue : -nValue;
		int sgn = (nValue >= 0) ? 0 : 1;
		val >>= i;
		int bit = val & 0x1;

		codec.encode(bit, valueContext[i]);
		if(val==1)
			codec.encode(sgn, signContext);
		}
	}

// encode: aac values without sign
void encodeUnsignedAAC(CAC_QF& codec, int nValue, int qstep, CAC* valueContext)
	{
	int i;
	for(i=qstep-1; i >= 0; i--)
		{
		int val = (nValue >= 0) ? nValue : -nValue;
		val >>= i;
		int bit = val & 0x1;

		codec.encode(bit, valueContext[i]);
		}
	}
