// FloatingPointNumber.cpp: implementation of the FloatingPointNumber class.
//
//////////////////////////////////////////////////////////////////////

#include "FloatingPointNumber.h"
#include "FunctionsForDecoding.h"
#include <math.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

FloatingPointNumber::FloatingPointNumber()
{

}

FloatingPointNumber::~FloatingPointNumber()
{

}

void FloatingPointNumber::readBitstream(CAC_QF& codec, unsigned int nDigit, unsigned int nExponentBits,
		unsigned int bAllSameExponentSign, unsigned int nSameExponentSign)
{
	this->nDigit = nDigit;

	// if nDigit != 0
	if(nDigit != 0)
	{
		nSign = codec._istrm->getbit();

		int nBits = getNbBits((int) ::pow(10, nDigit) - 1);
		nMantissa = codec._istrm->getbits(nBits);

		nExponent = codec._istrm->getbits(nExponentBits);

		if(bAllSameExponentSign == 0)
			nExponentSign = codec._istrm->getbit();
		else
			nExponentSign = nSameExponentSign;
	}
}

void FloatingPointNumber::decodingProcess(float& fValue)
{
	if(nDigit != 0)
	{
		if(nExponentSign == 1)
			nExponent = -nExponent;

		fValue = (float) nMantissa/ (float) ::pow(10, nExponent);

		if(nSign == 1)
			fValue = -fValue;
	}
	else
		fValue = 0.0f;
}
