// JWDictionary.h: interface for the JWDictionary class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_JWDICTIONARY_H__E166FC80_2D02_4ACD_8AD4_0C859FE34447__INCLUDED_)
#define AFX_JWDICTIONARY_H__E166FC80_2D02_4ACD_8AD4_0C859FE34447__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "jwtemplarray.h"
#include "entropy.h"

class JWDictionary  
{
public:
	JWDictionary();
	virtual ~JWDictionary();

public:
	// DPCM  м, dictionary 
	void Encode(JWArray<int>& aValues);

	// DPCM  м, dictionary 
	void JWDictionary::Encode(int* aValues, int nNum);

	// Header Information Bitstream...
	void MakeBitstream_Header(CAC_QF& codec);

	// encoding ͵ AAC  bitstream...
	void MakeBitstream_AAC(CAC_QF& codec);

	// ȭ bit  ϱ
	void SetQBit(int nQP) { m_nQBit = nQP; }
	int GetQBit() { return m_nQBit; }

	void SetNumberOfValues(int n) { m_nNumberOfValues = n; }
	int GetNumberOfValues() { return m_nNumberOfValues; }


	// Decoder  Լ!
	void Decode(JWArray<int>& aValues);

	// Header information decoding
	void BreakBitstream_Header(CAC_QF& codec);

	// bitstream decoding
	void BreakBitstream_AAC(CAC_QF& codec);

	// bitstream decoding & Decode
	void BreakBitstream_AAC_and_Decode(CAC_QF& codec, JWArray<int>& aValues);

protected:
	// dictionary
	JWArray<int> m_aKnockDownValues;

	// ڵ value 
	int m_nNumberOfValues;

	// ڵ bit
	int m_nQBit;

	// context
	CAC cac_KnockDown_context;
	CAC cac_sign_context;

};

#endif // !defined(AFX_JWDICTIONARY_H__E166FC80_2D02_4ACD_8AD4_0C859FE34447__INCLUDED_)
