// JWInterpolator.h: interface for the JWInterpolator class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_JWINTERPOLATOR_H__5E3C6873_55FB_45E8_B72F_03285AA8C00E__INCLUDED_)
#define AFX_JWINTERPOLATOR_H__5E3C6873_55FB_45E8_B72F_03285AA8C00E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "JWTemplArray.h"
#include <string.h>

class JWToken;
class ofstream;

class JWInterpolator  
{
public:
	JWInterpolator();
	virtual ~JWInterpolator();

public:
	virtual void Parse(JWToken& token) = 0;
	// WriteԼ template ó    ! ߿ Ȯ !
	virtual void Write(ofstream& file) = 0;
	virtual double Purify(double threshold, JWInterpolator*& pInterpolator) = 0;

	virtual void Copy(JWInterpolator* pInterp) {}

	void SetDEF(char* name);
	char* GetDEF() { return (char*) m_strDEF; }
	virtual double CalculateDistortion(JWInterpolator* pInterp) = 0;

public:
	virtual void SetSize(int size) = 0;
	virtual void Add(double key, void* keyValue) = 0;
	void SetKey(int i, double key) { aKeys[i] = key; }
	void SetKeys(JWArray<double>& keys) { aKeys.Copy(keys); }
	JWArray<double>& GetKeys() { return aKeys; }
	virtual void SetKeyValue(int i, void* keyValue) = 0;
	virtual void SetKeyValues(void* keyValues) = 0;
	virtual void* GetKeyValues() = 0;
	virtual void SetKeyFrame(int i, double key, void* keyValue) = 0;

protected:
	JWArray<double> aKeys;

	bool m_bIsDEF;
	char m_strDEF[256];
};

#endif // !defined(AFX_JWINTERPOLATOR_H__5E3C6873_55FB_45E8_B72F_03285AA8C00E__INCLUDED_)
