

#ifndef __JWTemplArray__H__
#define __JWTemplArray__H__

#include <memory.h>
#include <malloc.h>
#include <assert.h>

#if !defined NULL
#define NULL 0
#endif

template<class type> class JWArray
{
public:
	JWArray();
	JWArray(const JWArray<type>& a);

	virtual ~JWArray();
	

public:
	// member functions

	// sowoo 2001.07.07 (FASTFAST)
	// ʱȭ  ʰų ʿ   Լ
	void	Initialize();

	bool	SetSize(int size);
	 int	GetSize()			{ return m_dSize; } ;
	 int	GetLength()			{ return m_dLength; } ;
	bool	Add(type instance);
	bool	InsertAt(int index, type instance);

	// sowoo 2001.09.06 (Add RemoveAt)
	// index ִ element  Լ
	void	RemoveAt(int index);

	bool	IsIn(type instance);


	// sowoo 2001.12.14 (  ä!)
	void Fill(type instance);


	bool	SetAt(int index, type instance);
	type	GetAt(int index) { return m_pData[index]; } ;
	void	RemoveAll()
	{
		if(m_pData == NULL)	return;

		::free((type*)m_pData);
//		delete [] m_pData;
		m_dSize = 0;
		m_pData = NULL;
		m_dNumOfIncrease = 1;
	} ;

	bool Append(const JWArray<type>& arr);
	bool Copy(const JWArray<type>& arr);
	bool Copy(type* arr, int num);

public:
	// operator overloading function
	type& operator[](int index) 
	{
		assert(m_dSize > index);
		return m_pData[index];
	};

	type operator[](int index) const
	{
		assert(m_dSize > index);
		return m_pData[index];
	};

private:
	bool IncreaseSize(int increaseby = 1);

protected:
	// member variables
	// Ҵ ޸ ũ
	int m_dSize;
	//  Ͱ Ǵ  
	type* m_pData;

private:
	int m_dNumOfIncrease;
};

template <class type>
JWArray<type>::JWArray():
	m_dSize(0),
	m_pData(NULL),
	m_dNumOfIncrease(1)
{
}

// sowoo 2001.12.14
template <class type>
void JWArray<type>::Fill(type instance)
{
	for(int i=0; i<m_dSize; i++)
		m_pData[i] = instance;
}


// sowoo 2001.09.06
template <class type>
bool JWArray<type>::IsIn(type instance)
{
	for(int i=0; i<m_dSize; i++)
	{
		if(m_pData[i] == instance)
			return true;
	}

	return false;
}


template <class type>
void JWArray<type>::Initialize()
{
	m_dSize = 0;
	m_pData = NULL;
	m_dNumOfIncrease = 1;
}

template <class type>
JWArray<type>::JWArray(const JWArray<type>& a):
	m_pData(NULL)
{
	SetSize(a.m_dSize);
	m_dNumOfIncrease = a.m_dNumOfIncrease;

	for(int i=0; i<m_dSize; i++)
	{
		m_pData[i] = a.m_pData[i];
	}
}


template <class type>
JWArray<type>::~JWArray()
{
	if(m_pData != NULL)
	{
		::free((type*)m_pData);
//		delete [] m_pData;
		m_pData = NULL;
	}
}

template <class type>
bool JWArray<type>::SetSize(int size)
{
	if(m_pData != NULL)
	{
		::free((type *)m_pData);
	}
	m_pData = (type*)::malloc(sizeof(type)*size);
//	m_pData = new type[size];
	m_dSize = size;
	m_dNumOfIncrease = size;
	return (m_pData != NULL);
}

template <class type>
bool JWArray<type>::Add(type instance)
{
	int tempSize = m_dSize;
	if(!IncreaseSize())
		return false;
	m_pData[tempSize] = instance;
	return true;
}

template <class type>
bool JWArray<type>::InsertAt(int index, type instance)
{
	assert(m_dSize > index);
	type* tempPointer;
	int prevSize;

	prevSize = m_dSize;

	if(!IncreaseSize())
		return false;

	tempPointer = (type*)::malloc(sizeof(type)*(prevSize - index));
//	tempPointer = new type[prevSize - index];
	::memcpy((type*)tempPointer, (type*)(&m_pData[index]), sizeof(type)*(prevSize - index));

	m_pData[index] = instance;
	::memcpy((type*)(m_pData + index + 1), (type*)tempPointer, sizeof(type)*(prevSize - index));

	::free((type*)tempPointer);
//	delete [] tempPointer;
	tempPointer = NULL;

	return true;
}

// sowoo 2001.09.06 (Add RemoveAt)
template <class type>
void JWArray<type>::RemoveAt(int index)
{
	// 1.   ִ ۾ΰ?
	assert(m_dSize > 0);
	type* tempPointer;

	// 2. size-1ŭ ޸ Ҵ
	tempPointer = (type*) ::malloc(sizeof(type) * (m_dSize-1));

	// 3. [start, index-1] !
	::memcpy((type*)tempPointer, (type*)(&m_pData[0]), sizeof(type)*(index));

	// 4. [index+1, end] !
	::memcpy((type*)tempPointer+index, (type*)(&m_pData[index+1]), sizeof(type)*(m_dSize-index-1));

	::free((type*)m_pData);


	// 5. tempPointer ° --> m_pData...
	//tempPointer = m_pData;
	m_pData = tempPointer;

	// 6.  ũ  !
	m_dSize--;
}


template <class type>
bool JWArray<type>::SetAt(int index, type instance)
{
	assert(m_dSize > index);
	m_pData[index] = instance;
	return true;
}

// private function zone

template <class type>
bool JWArray<type>::IncreaseSize(int increaseby)
{
	if(m_dSize == 0)
	{
//		m_pData = new type;
		m_pData = (type*)::malloc(sizeof(type)*1);
		m_dSize++;
		return true;
	}

	type* tempPointer;
	tempPointer = (type*)::malloc(sizeof(type)*m_dSize);
//	tempPointer = new type[m_dSize];
	assert(tempPointer != NULL);

	::memcpy((type*)tempPointer, (type*)m_pData, sizeof(type)*m_dSize);

	::free((type*)m_pData);
//	delete [] m_pData;
	m_pData = NULL;

	int prevSize = m_dSize;
	m_dSize += increaseby;
	m_pData = (type*)::malloc(sizeof(type)*m_dSize);
//	m_pData = new type[m_dSize];
	assert(m_pData != NULL);

	::memcpy((type*)m_pData, (type*)tempPointer, sizeof(type)*prevSize);

	::free((type*)tempPointer);
//	delete [] tempPointer;
	tempPointer = NULL;

	return true;
}


template <class type>
bool JWArray<type>::Append(const JWArray<type>& arr)
{
	int size = arr.m_dSize;

	for(int i=0; i<size; i++)
	{
		if(!Add(arr.m_pData[i]))
			return false;
	}

	return true;
}

template <class type>
bool JWArray<type>::Copy(const JWArray<type>& arr)
{
	RemoveAll();

	m_dSize = arr.m_dSize;
	m_dNumOfIncrease = arr.m_dNumOfIncrease;

	m_pData = (type*)::malloc(sizeof(type)*arr.m_dSize);
//	m_pData = new type[m_dSize];
	assert(m_pData != NULL);

	::memcpy((type*)m_pData, (type*)arr.m_pData, sizeof(type)*arr.m_dSize);

	return true;
}




template <class type>
bool JWArray<type>::Copy(type* arr, int num)
{
	RemoveAll();

	m_dSize = num;
	m_dNumOfIncrease = 1;

	m_pData = (type*)::malloc(sizeof(type)*num);
//	m_pData = new type[m_dSize];
	assert(m_pData != NULL);

	::memcpy((type*)m_pData, (type*)arr, sizeof(type)*num);

	return true;
}


// sowoo 2001.09.20 (Optimize Threshold)
template<class type>
int GetNumberOfThisFromArray(JWArray<type>& array, type instance)
{
	int nNumber = 0;

	for(int i=0; i<array.GetSize(); i++)
	{
		if(array[i] == instance)
			nNumber++;
	}

	return nNumber;
}


#endif