// JWToken.h: interface for the JWToken class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_JWTOKEN_H__DE3135E1_D6D7_4C4B_BCD1_6ECBFE440860__INCLUDED_)
#define AFX_JWTOKEN_H__DE3135E1_D6D7_4C4B_BCD1_6ECBFE440860__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <fstream.h>
#include "JWTemplArray.h"


//   symbol !
typedef enum _tagSymbol
{
	// IM1 Textual Format ϴ ͵!!!
	BRACE_CLOSE,
	BRACE_OPEN,
	SQUAREBRACKET_CLOSE,
	SQUAREBRACKET_OPEN,
	children,
	CoordinateInterpolator,
	DEF,
	Group,
	key,
	keyValue,
	OrientationInterpolator,
	PositionInterpolator,
	USE,

	// Parsing ʿ !!!
	REALNUMBER,
	INTEGER,
	USERDEFINED,
	NONEOFTHEM
} Symbol;


class JWToken  
{
public:
	JWToken();
	virtual ~JWToken();


public:
	JWArray<Symbol> m_aSymbols;
	JWArray<char*> m_aTokens;

public:
	bool SetFile(char* file);
	char* GetToken();
	Symbol GetSymbol(char* token);
	Symbol GetSymbol() { return m_eSymbol; }
	char* GetNextToken();
	operator int() const { return m_eSymbol; }
	operator char*() const { return (char*)m_strToken; }

	void EatWhiteAndComment();
	void EatWhiteAndCommentAnd(char deli = ',');
	double GetRealNumber();
	int GetInteger();
	char* GetIdentifier();

protected:
	char m_strToken[256];
	Symbol m_eSymbol;
	ifstream m_file;
	int nNumberOfSymbols;

	// Debug information
	int m_nLine;
};

#endif // !defined(AFX_JWTOKEN_H__DE3135E1_D6D7_4C4B_BCD1_6ECBFE440860__INCLUDED_)
