// KeySelectionFlag.cpp: implementation of the KeySelectionFlag class.
//
//////////////////////////////////////////////////////////////////////

#include "KeySelectionFlag.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

KeySelectionFlag::KeySelectionFlag()
{

}

KeySelectionFlag::~KeySelectionFlag()
{

}

void KeySelectionFlag::readBitstream(
	CAC_QF& codec, KeyHeader kHeader, unsigned int bPreserveKey
)
{
	nNumOfKeyValue = 0;
	if(bPreserveKey == 1)
	{
		keyFlag.SetSize(kHeader.nNumberOfKey);

		for(int i=0; i<kHeader.nNumberOfKey; i++)
		{
			//qf_decode(&keyFlag[i], keyFlagContext);
			keyFlag[i] = codec.decode(keyFlagContext);
			if(keyFlag[i] == 1)
				nNumOfKeyValue++;
		}
	}
	else
		nNumOfKeyValue = kHeader.nNumberOfKey;
}


void KeySelectionFlag::InitializeModel()
{
	keyFlagContext.reset();
}



//void KeySelectionFlag::encodingProcess(CSelectedKeyFrame selectedKeyFrame)
void KeySelectionFlag::encodingProcess(JWArray<int>& flag)
{
	// reference return ޴ , rederence  ԰ ÿ return޾ƾ
	// ,    ϰų Ҽ ְ   class   .
	//keyFlag = (JWArray<unsigned int>&)selectedKeyFrame.GetKeyFlag();

	
//	keyFlag.SetSize(selectedKeyFrame.GetKeyFlag().GetSize());
//	for(int i = 0;i < keyFlag.GetSize();i++)
//		keyFlag[i] = (unsigned int)selectedKeyFrame.GetKeyFlag()[i];
	keyFlag.SetSize(flag.GetSize());
	for(int i = 0;i < flag.GetSize();i++)
		keyFlag[i] = flag[i];

}

void KeySelectionFlag::makeBitstream(CAC_QF& codec, bool bPreserveKey)
{
	if(bPreserveKey)
	{
		for(int i = 0;i < keyFlag.GetSize();i++)
		{
			encodeKeyFlag(codec, 1, keyFlag[i]);
		}
	}
}


void KeySelectionFlag::encodeKeyFlag(CAC_QF& codec, int qstep, long int dQ)
{
	int i;
	for(i=qstep-1;i>=0;i--)
	{
		int val = (dQ >= 0) ? dQ : -dQ;
		val >>= i;
		int bit = val & 0x1;

		if(val<=1)
			codec.encode(bit,keyFlagContext);
		else
			codec.encode(bit,keyFlagContext);
	}
}
