// KeyValueMinMax.cpp: implementation of the KeyValueMinMax class.
//
//////////////////////////////////////////////////////////////////////

#include "KeyValueMinMax.h"
#include "FunctionsForDecoding.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

KeyValueMinMax::KeyValueMinMax()
{

}

KeyValueMinMax::~KeyValueMinMax()
{

}


void KeyValueMinMax::readBitstream(CAC_QF& codec, int nDigit)
{
	bUse32Float = codec._istrm->getbit();

	// if bUsed32Float == 0
	if(bUse32Float == 0)
	{
		nWhichAxis = codec._istrm->getbits(2);
		bAllSameMantissaDigitFlag = codec._istrm->getbit();

		if(bAllSameMantissaDigitFlag == 0)
		{
			nMantissaDigit_X = codec._istrm->getbits(4);
			nMantissaDigit_Y = codec._istrm->getbits(4);
			nMantissaDigit_Z = codec._istrm->getbits(4);
		}
		else
		{
			bSameKVDigitFlag = codec._istrm->getbit();

			if(bSameKVDigitFlag == 0)
				nMantissaDigit_X = codec._istrm->getbits(4);
			else
				nMantissaDigit_X = nDigit;

			nMantissaDigit_Y = nMantissaDigit_X;
			nMantissaDigit_Z = nMantissaDigit_X;
		}


		bMaxDigitFlag = codec._istrm->getbit();

		if(bMaxDigitFlag == 1)
			nMantissaDigit_M = codec._istrm->getbits(4);
		else
		{
			switch(nWhichAxis){
			case 0:
				nMantissaDigit_M = nMantissaDigit_X;
				break;
			case 1:
				nMantissaDigit_M = nMantissaDigit_Y;
				break;
			case 2:
				nMantissaDigit_M = nMantissaDigit_Z;
				break;
			default:
				// error!!!
				break;
			}
		}

		nExponentBits = codec._istrm->getbits(6);
		nExponentBits = getNbBits(nExponentBits);

		bAllSameExponentSign = codec._istrm->getbit();

		// if bAllSameExponentSign == 1
		if(bAllSameExponentSign == 1)
			nExponentSign = codec._istrm->getbit();

		fpnMin_X.readBitstream(codec, nMantissaDigit_X, 
			nExponentBits, bAllSameExponentSign, nExponentSign);
		fpnMin_Y.readBitstream(codec, nMantissaDigit_Y, 
			nExponentBits, bAllSameExponentSign, nExponentSign);
		fpnMin_Z.readBitstream(codec, nMantissaDigit_Z, 
			nExponentBits, bAllSameExponentSign, nExponentSign);
		fpnMax.readBitstream(codec, nMantissaDigit_M, 
			nExponentBits, bAllSameExponentSign, nExponentSign);
	}
	else
	{
		// if bUsed32Float == 1
		int nTemp;

		nTemp = codec._istrm->getbits(32);
		fMin_X = *((float*)&nTemp);

		nTemp = codec._istrm->getbits(32);
		fMin_Y = *((float*)&nTemp);

		nTemp = codec._istrm->getbits(32);
		fMin_Z = *((float*)&nTemp);

		nTemp = codec._istrm->getbits(32);
		fMax = *((float*)&nTemp);
	}
}


void KeyValueMinMax::decodingProcess()
{
	if(bUse32Float == 0)
	{
		fpnMin_X.decodingProcess(fMin_X);
		fpnMin_Y.decodingProcess(fMin_Y);
		fpnMin_Z.decodingProcess(fMin_Z);
		fpnMax.decodingProcess(fMax);
	}

	float RangeMax;
	switch(nWhichAxis){
	case 0:
		RangeMax = fMax - fMin_X;
		fMax_X = fMax;
		fMax_Y = RangeMax + fMin_Y;
		fMax_Z = RangeMax + fMin_Z;
		break;
	case 1:
		RangeMax = fMax - fMin_Y;
		fMax_X = RangeMax + fMin_X;
		fMax_Y = fMax;
		fMax_Z = RangeMax + fMin_Z;
		break;
	case 2:
		RangeMax = fMax - fMin_Z;
		fMax_X = RangeMax + fMin_X;
		fMax_Y = RangeMax + fMin_Y;
		fMax_Z = fMax;
		break;
	}
}