// KeyValueMinMax.h: interface for the KeyValueMinMax class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_KEYVALUEMINMAX_H__2377114F_E5A8_412C_A0CB_18792BCBE92E__INCLUDED_)
#define AFX_KEYVALUEMINMAX_H__2377114F_E5A8_412C_A0CB_18792BCBE92E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "entropy.h"
#include "FloatingPointNumber.h"

class KeyValueMinMax  
{
public:
	KeyValueMinMax();
	virtual ~KeyValueMinMax();

public:
	void readBitstream(CAC_QF& codec, int nDigit);
	void decodingProcess();

public:
	unsigned int bUse32Float;

	// if bUsed32Float == 0
	unsigned int nWhichAxis;
	unsigned int bAllSameMantissaDigitFlag;
	unsigned int nMantissaDigit_X;
	unsigned int nMantissaDigit_Y;
	unsigned int nMantissaDigit_Z;
	unsigned int bSameKVDigitFlag;

	unsigned int bMaxDigitFlag;
	unsigned int nMantissaDigit_M;
	unsigned int nExponentBits;
	unsigned int bAllSameExponentSign;

	// if bAllSameExponentSign == 1
	unsigned int nExponentSign;

	FloatingPointNumber fpnMin_X;
	FloatingPointNumber fpnMin_Y;
	FloatingPointNumber fpnMin_Z;
	FloatingPointNumber fpnMax;

	// if bUsed32Float == 1
	float fMin_X;
	float fMin_Y;
	float fMin_Z;
	float fMax;

	// for decoding process
public:
	float fMax_X;
	float fMax_Y;
	float fMax_Z;
};

#endif // !defined(AFX_KEYVALUEMINMAX_H__2377114F_E5A8_412C_A0CB_18792BCBE92E__INCLUDED_)
