// POSDECODER_PDAM.cpp : Defines the entry point for the console application.
//

#include <stdio.h>
#include <string.h>
#include <float.h>
#include "CompressedPositionInterpolator.h"
#include "JWInterpolator.h"
#include "JWPositionInterpolator.h"
#include "JWToken.h"
#include "FunctionsForEncoding.h"

int main(int argc, char* argv[])
{
	//  .
	// Formula1_Dummy_Car_A_Parents-POS-INTERP.txt Formula1_Dummy_Car_A_Parents-POS-INTERP k key sad bbb nnn n n
	// Formula1_Dummy_Car_A_Parents-POS-INTERP.txt Formula1_Dummy_Car_A_Parents-POS-INTERP k key sad uuu nnn n n

	// 1. arguement
	if(argc < 5)
	{
		cout << endl;
		cout << "PosEncoder [Input pos interp file] [Output name] [Param file] [Selection type] [Key preserve flag] [Order of DPCM] ";
		cout << "[AAC flag] [Intra coding flag] [KeyCoder flag] [Key quant flag]" << endl;
		cout << endl;
		cout << "\t 1) input pos interp file: PositionInterpolator file to be encoded" << endl;
		cout << "\t 2) output name: Output bitstream file name" << endl;
		cout << "\t 3) Quantization paramter file" << endl;
		cout << "\t 4) Selection type: Key & KeyValue Selection type (k=default/u/n/c/d/l)" << endl;
		cout << "\t 5) Key Preserve Flag: Key Preserving mode (k/?=default)" << endl;
		cout << "\t 6) Choose the Best Performance AAC/SAD/Entropy/DPCM (a/s/e/1/2)" << endl;
		cout << "\t 7) Use Unary AAC (uuu/nnn)" << endl;
		cout << "\t 8) Use Intra Coding (yyy/nnn=defalt)" << endl;
		cout << "\t 9) Use Linear KeyCoder (l/n=default)" << endl;
		cout << "\t10) Use Key Quant. Error Minization (k/n=default)" << endl;
		cout << "\t11) Resampling (#/n)" << endl;
		cout << "\t12) Resampling with digit (d/n)" << endl;
		cout << endl;

		cout << endl;
		cout << "Press Enter to continue..." << endl;
		getchar();

		return 1;
	}


	/*
	const int cnNUM_THRESHOLD = 30;
	int nNUM_THRESHOLD = cnNUM_THRESHOLD;
	double aThresholds[cnNUM_THRESHOLD] = {
		1, 0.8, 0.6, 0.4, 0.2, 0.1, // 6
		0.09, 0.08, 0.07, 0.06, 0.05, 0.04, 0.03, 0.02, 0.01, // 9
		0.009, 0.007, 0.005, 0.003, 0.001, // 5
		0.0009, 0.0007, 0.0005, 0.0003, 0.0001, // 5
		0.000075, 0.00005, 0.000025, 0.00001, 0 // 5
	};
	const int nNUM_KEY = 8;
	int aKQBits[nNUM_KEY] = {
		4, 6, 8, 10, 13, 15, 18, 20//, 25
	};
	const int nNUM_KEYVALUE = 18;
	int aKVQBits [nNUM_KEYVALUE] = {
		3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20//, 25
	};
	const int cnNUM_THRESHOLD = 1;
	int nNUM_THRESHOLD = cnNUM_THRESHOLD;
	double aThresholds[cnNUM_THRESHOLD] = {
		//0.0005
		0.001
	};
	const int nNUM_KEY = 1;
	int aKQBits[nNUM_KEY] = {
		10
	};
	const int nNUM_KEYVALUE = 1;
	int aKVQBits [nNUM_KEYVALUE] = {
		6
	};
	/*/
	JWArray<double> aThresholds_Temp;
	JWArray<int> aKQBits;
	JWArray<int> aKVQBits;


	ifstream file;
	file.open(argv[3]);

	if(file.fail())
	{
		cout << "There is no Quantization parameter file" << endl;

		return 1;
	}

	char buffer[1024];
	file.getline(buffer, 1024, '\n');

	if(strcmp(buffer, "THRESHOLD") == 0)
	{
		// read thresholds
		file.getline(buffer, 1024);
		while(strcmp(buffer, "KEY") != 0)
		{
			aThresholds_Temp.Add(atof(buffer));
			file.getline(buffer, 1024);
		}

		// read keys
		file.getline(buffer, 1024);
		while(strcmp(buffer, "KEYVALUE") != 0)
		{
			aKQBits.Add(atoi(buffer));
			file.getline(buffer, 1024);
		}

		// read keyvalue
		file.getline(buffer, 1024);
		while(!file.eof())
		{
			aKVQBits.Add(atoi(buffer));
			file.getline(buffer, 1024);
		}
		aKVQBits.Add(atoi(buffer));
	}
	else
	{
		cout << "Wrong Quantization paramter file" << endl;
		exit(0);
	}

	int nNUM_THRESHOLD = aThresholds_Temp.GetSize();
	int nNUM_KEY = aKQBits.GetSize();
	int nNUM_KEYVALUE = aKVQBits.GetSize();

	//
		double* aThresholds = new double[nNUM_THRESHOLD];
		for(int i=0; i<nNUM_THRESHOLD; i++)
			aThresholds[i] = aThresholds_Temp[i];

	file.close();
	//*/

	// key selection 
	bool bKeySelection = (argv[4][0] == 'k')? true: false;

	// sowoo 2001.09.21 (Key Preserve)
	bool bIsKeyPreserve = false;
	bIsKeyPreserve = (argv[5][0] == 'k')? true:false;

	// sowoo 2001.10.18
	// X, Y, Z component DPCM Ѵ.
	// AAC, SAD, Entropy   ֶǷ ϴ Flag .
	char chTypeOfBest;

	switch(argv[6][0]) {
	case 'a':
		chTypeOfBest = 'a';
		break;
	case 's':
		chTypeOfBest = 's';
		break;
	case 'e':
		chTypeOfBest = 'e';
		break;
	case '1':
		chTypeOfBest = '1';
		break;
	case '2':
		chTypeOfBest = '2';
		break;
	}


	bool bUnaryAAC_X, bUnaryAAC_Y, bUnaryAAC_Z;

	if(::strlen(argv[7]) < 3)
	{
		bUnaryAAC_X = (argv[7][0] == 'u')? true: false;
		bUnaryAAC_Y = bUnaryAAC_X;
		bUnaryAAC_Z = bUnaryAAC_X;
	}
	else
	{
		bUnaryAAC_X = (argv[7][0] == 'u')? true: false;
		bUnaryAAC_Y = (argv[7][1] == 'u')? true: false;
		bUnaryAAC_Z = (argv[7][2] == 'u')? true: false;
	}


	// sowoo 2001.11.01 (Intra?)
	// ù° ι° KeyValue intra coding ΰ?
	int nStartIndex_X, nStartIndex_Y, nStartIndex_Z;
	
	if(::strlen(argv[8]) < 3)
	{
		nStartIndex_X = (argv[8][0] == 'i')? 1: 0;
		nStartIndex_Y = nStartIndex_X;
		nStartIndex_Z = nStartIndex_X;
	}
	else
	{
		nStartIndex_X = (argv[8][0] == 'i')? 1: 0;
		nStartIndex_Y = (argv[8][1] == 'i')? 1: 0;
		nStartIndex_Z = (argv[8][2] == 'i')? 1: 0;
	}


	bool bLinearKeyCoder = (argv[9][0] == 'l')? true: false;

	bool bKeyQuant = (argv[10][0] == 'k')? true: false;



	// sowoo 2001.10.06 (IM1Text Format)
	JWInterpolator* pInterpolator = NULL;
	JWToken token;
	if(!token.SetFile(argv[1]))
	{
		cout << "There is no file as follows" << endl;
		cout << "File Name: " << argv[1] << endl;
		return 0;
	}
	ParseIM1Text(token, pInterpolator);

	JWPositionInterpolator positionInterpolator;


	// ⿡ Key Selectionϴ module !!!
	// Purify_P ִ κ  !!!
	// * INPUT: JWPositionInterpolator
	// * OUTPUT: X, Y, Z flag

	// 5.1.2 JWPositionInterpolator ConvertѴ.
	JWArray<double> x_kv;
	JWArray<double> y_kv;
	JWArray<double> z_kv;

	SFVec3f tempKV;
	JWArray<double>& aKeys = pInterpolator->GetKeys();
	JWArray<SFVec3f>& aKeyValues = *((JWArray<SFVec3f>*)pInterpolator->GetKeyValues());
	int size = aKeys.GetSize();

	x_kv.SetSize(size);
	y_kv.SetSize(size);
	z_kv.SetSize(size);

	for(i=0; i<size; i++)
	{
		tempKV.x = aKeyValues[i].x;
		tempKV.y = aKeyValues[i].y;
		tempKV.z = aKeyValues[i].z;

		x_kv[i] = tempKV.x;
		y_kv[i] = tempKV.y;
		z_kv[i] = tempKV.z;

		positionInterpolator.Add(aKeys[i], (void*) &tempKV);
	}

	// 5.1.1 ʿ  Ѵ.
	JWArray<JWArray<int> > aXs;
	JWArray<JWArray<int> > aYs;
	JWArray<JWArray<int> > aZs;

	aXs.SetSize(nNUM_THRESHOLD);
	aYs.SetSize(nNUM_THRESHOLD);
	aZs.SetSize(nNUM_THRESHOLD);

	for(int nT=0; nT<nNUM_THRESHOLD; nT++)
	{
		aXs[nT].Initialize();
		aYs[nT].Initialize();
		aZs[nT].Initialize();

		aXs[nT].SetSize(size);
		aYs[nT].SetSize(size);
		aZs[nT].SetSize(size);
	}


	int nKeyDigit = positionInterpolator.FindKeyDigit();
	int nKeyValueDigit = positionInterpolator.FindKeyValueDigit();

	cout << "# Of Keys: " << size << '\t';
	cout << "KeyDigit:" << nKeyDigit << '\t';
	cout << "KeyValueDigit:" << nKeyValueDigit << endl;


	///////////////////////////////////////////////////////////////
	//
	//	Resampling Routine
	//
	//				2002.01.24. SOWOO
	// 
	// 1) key  ,  key ũ Ǵ ۰...
	// 2) Ȯ ©? Key Digit?
	//
	///////////////////////////////////////////////////////////////

	if(argc > 11)
	{
		int nNumberOfKey_Resampling = 0;

		if(argc > 11)
			nNumberOfKey_Resampling = ::atoi(argv[11]);
		else
			nNumberOfKey_Resampling = -1;


		// sowoo 20020125
		bool bCuttingByDigit = false; 

		if(argc > 12)
			bCuttingByDigit = (argv[12][0] == 'd')? true: false;
		else
			bCuttingByDigit = false;

		int nTempDigit = 0;

		if(bCuttingByDigit)
			nTempDigit = nKeyDigit;
		else
			nTempDigit = -1;


		if(nNumberOfKey_Resampling > 0)
		{
			//  ִ  ī!
			JWPositionInterpolator resampledInterpolator;
			resampledInterpolator.Copy(&positionInterpolator);

			resampledInterpolator.Resampling(
				nNumberOfKey_Resampling, nTempDigit);

			char aBuffer[256];
			sprintf(aBuffer, "%s_Resampling_%d.txt", argv[2], nNumberOfKey_Resampling);

			// ӽ÷!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			resampledInterpolator.SetDEF("myPOSITION");

			WriteIM1Text(aBuffer, &resampledInterpolator, "#File=Resampled");

			return 1;
		}
	}
	///////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////


	///////////////////////////////////////////////////////////////
	//
	//	Key Selection Routine
	//
	///////////////////////////////////////////////////////////////
	if(bKeySelection)
	{
		positionInterpolator.SetKeySelectionType(KS_KeySelection);
		positionInterpolator.FindKeyFlag(aThresholds, nNUM_THRESHOLD, aXs, aYs, aZs);
	}
	else
	{
		// Selection  ʰ  !!!
		nNUM_THRESHOLD = 1;
		aThresholds[0] = 0.0;
		for(int i=0; i<aXs[0].GetSize(); i++)
		{
			aXs[0][i] = 1;
			aYs[0][i] = 1;
			aZs[0][i] = 1;
		}
	}


	////////////////////////////////////////////////////////////////////
	//
	//
	//	õ  ؼ,,, KeyDigit, KeyValueDigit
	//	Min/Max ã !
	//	, threshold Ǿ ־!
	//
	//
	////////////////////////////////////////////////////////////////////
	// digit    
	// 0, 0.25, 0.5, 0.75, 1 ==> 0, 1 ΰ selectin!
	// ̷  digit=1? 2? ==> 2 ƴѰ !
	//JWArray<int> aKeyDigits, aKeyValueDigits;
	JWArray<double>
		aX_MINs, aY_MINs, aZ_MINs,
		aX_MAXs, aY_MAXs, aZ_MAXs,
		aMaxDiffs;

	//aKeyDigits.SetSize(nNUM_THRESHOLD);
	//aKeyValueDigit.SetSize(nNUM_THRESHOLD);

	aX_MINs.SetSize(nNUM_THRESHOLD);
	aY_MINs.SetSize(nNUM_THRESHOLD);
	aZ_MINs.SetSize(nNUM_THRESHOLD);

	aX_MAXs.SetSize(nNUM_THRESHOLD);
	aY_MAXs.SetSize(nNUM_THRESHOLD);
	aZ_MAXs.SetSize(nNUM_THRESHOLD);

	aMaxDiffs.SetSize(nNUM_THRESHOLD);

	{
		//int nKeyDigit, nKeyValueDigit;
		double
			dX_MIN, dY_MIN, dZ_MIN,
			dX_MAX, dY_MAX, dZ_MAX;

		for(int nT=0; nT<nNUM_THRESHOLD; nT++)
		{
			//nKeyDigit = INT_MIN;
			//nKeyValueDigit = INT_MIN;

			dX_MIN = DBL_MAX;
			dY_MIN = DBL_MAX;
			dZ_MIN = DBL_MAX;

			dX_MAX = -DBL_MAX;
			dY_MAX = -DBL_MAX;
			dZ_MAX = -DBL_MAX;

			for(int i=0; i<size; i++)
			{
				if(aXs[nT][i] == 1)
				{
					if(x_kv[i] < dX_MIN)
						dX_MIN = x_kv[i];
					if(x_kv[i] > dX_MAX)
						dX_MAX = x_kv[i];
				}

				if(aYs[nT][i] == 1)
				{
					if(y_kv[i] < dY_MIN)
						dY_MIN = y_kv[i];
					if(y_kv[i] > dY_MAX)
						dY_MAX = y_kv[i];
				}

				if(aZs[nT][i] == 1)
				{
					if(z_kv[i] < dZ_MIN)
						dZ_MIN = z_kv[i];
					if(z_kv[i] > dZ_MAX)
						dZ_MAX = z_kv[i];
				}
			}

			aX_MINs[nT] = dX_MIN;
			aY_MINs[nT] = dY_MIN;
			aZ_MINs[nT] = dZ_MIN;

			aX_MAXs[nT] = dX_MAX;
			aY_MAXs[nT] = dY_MAX;
			aZ_MAXs[nT] = dZ_MAX;

			// ִ Range ãƶ!!!
			aMaxDiffs[nT] = aX_MAXs[nT] - aX_MINs[nT];

			if(aMaxDiffs[nT] < (aY_MAXs[nT] - aY_MINs[nT]))
				aMaxDiffs[nT] = aY_MAXs[nT] - aY_MINs[nT];
			if(aMaxDiffs[nT] < (aZ_MAXs[nT] - aZ_MINs[nT]))
				aMaxDiffs[nT] = aZ_MAXs[nT] - aZ_MINs[nT];
		}
	}





	///////////////////////////////////////////////////////////////
	// for loop   ٿ
	///////////////////////////////////////////////////////////////

	int nFirst = 0, nLast = nNUM_THRESHOLD;

	int nX, nY, nZ;

	for(nT=0; nT<nNUM_THRESHOLD; nT++)
	{
		// Key 2 õ   en/decoding !
		if((GetNumberOfThisFromArray(aXs[nT], 1) == 2) &&
			(GetNumberOfThisFromArray(aYs[nT], 1) == 2) &&
			(GetNumberOfThisFromArray(aZs[nT], 1) == 2))
			nFirst = nT;
		else
			break;
	}

	//   Ѱ  ѵ 
	nX = GetNumberOfThisFromArray(aXs[nNUM_THRESHOLD-1], 1);
	nY = GetNumberOfThisFromArray(aYs[nNUM_THRESHOLD-1], 1);
	nZ = GetNumberOfThisFromArray(aZs[nNUM_THRESHOLD-1], 1);

	for(nT=nNUM_THRESHOLD-1; nT>=0; nT--)
	{
		// Key  õ   en/decoding !
		// ! threshold '0'  ΰ õ   ֵ!!!
		// --> threshold '0'϶  ѵ  ϴ  !
		if((GetNumberOfThisFromArray(aXs[nT], 1) == nX) &&
			(GetNumberOfThisFromArray(aYs[nT], 1) == nY) &&
			(GetNumberOfThisFromArray(aZs[nT], 1) == nZ))
			nLast = nT+1;
		else
			break;
	}


	//////////////////////////////////////////////////////////////
	//
	//	: ȭ  ּȭ
	//  : ȭ Min/Max .
	//	
	//
	//	threshold min ٸ!!!!!
	//	^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
	//
	//////////////////////////////////////////////////////////////
	//
	//	̰ ѹ ã  ٽ ã ʾƵ ȴ.
	//  threshold ŭ min/max 
	//  keyValue ȭ bit ŭ search space !
	//
	//////////////////////////////////////////////////////////////
	if(bKeyQuant)
	{
		JWArray<double>
			* aBestMin_X = new JWArray<double> [nLast - nFirst + 1],
			* aBestMin_Y = new JWArray<double> [nLast - nFirst + 1],
			* aBestMin_Z = new JWArray<double> [nLast - nFirst + 1],

			* aBestMax_X = new JWArray<double> [nLast - nFirst + 1],
			* aBestMax_Y = new JWArray<double> [nLast - nFirst + 1],
			* aBestMax_Z = new JWArray<double> [nLast - nFirst + 1];

		for(i=0; i<(nLast - nFirst + 1); i++)
		{
			aBestMin_X[i].SetSize(nNUM_KEYVALUE);
			aBestMin_Y[i].SetSize(nNUM_KEYVALUE);
			aBestMin_Z[i].SetSize(nNUM_KEYVALUE);

			aBestMax_X[i].SetSize(nNUM_KEYVALUE);
			aBestMax_Y[i].SetSize(nNUM_KEYVALUE);
			aBestMax_Z[i].SetSize(nNUM_KEYVALUE);
		}


		double dTempMin_X, dTempMin_Y, dTempMin_Z, dTempMax;

		int* aQuantTemp = new int[size];


		JWArray<double> aX_Values, aY_Values, aZ_Values;



		ofstream minmaxFile;
		minmaxFile.open("Crash_Quantization_Error.txt");

		for(i=0; i<nNUM_KEYVALUE; i++)
		{
			//for(int nT=0; nT<(nLast - nFirst + 1); nT++)
			for(int nT=0; nT<(nLast - nFirst); nT++)
			{
				aX_Values.RemoveAll();
				aY_Values.RemoveAll();
				aZ_Values.RemoveAll();

				// Key Selection ؼ õ ѵ ϱ
				for(int j=0; j<size; j++)
				{
					if(aXs[nT+nFirst][j] == 1)
						aX_Values.Add(x_kv[j]);

					if(aYs[nT+nFirst][j] == 1)
						aY_Values.Add(y_kv[j]);

					if(aZs[nT+nFirst][j] == 1)
						aZ_Values.Add(z_kv[j]);
				}

				dTempMin_X = aX_MINs[i];
				dTempMin_Y = aY_MINs[i];
				dTempMin_Z = aZ_MINs[i];


				dTempMax = aMaxDiffs[i] + aX_MINs[i];
				QuantizeMM(aX_Values, aKVQBits[i], dTempMin_X, dTempMax, aQuantTemp);

				dTempMax = aMaxDiffs[i] + aY_MINs[i];
				QuantizeMM(aY_Values, aKVQBits[i], dTempMin_Y, dTempMax, aQuantTemp);

				dTempMax = aMaxDiffs[i] + aZ_MINs[i];
				QuantizeMM(aZ_Values, aKVQBits[i], dTempMin_Z, dTempMax, aQuantTemp);


				// 1. ȭ  ּȭϴ Min 
				aBestMin_X[nT][i] = dTempMin_X;
				aBestMin_Y[nT][i] = dTempMin_Y;
				aBestMin_Z[nT][i] = dTempMin_Z;

				// 2.   Max ٽ Ͽ ִ´.
				aBestMax_X[nT][i] = aMaxDiffs[i] + aBestMin_X[nT][i];
				aBestMax_Y[nT][i] = aMaxDiffs[i] + aBestMin_Y[nT][i];
				aBestMax_Z[nT][i] = aMaxDiffs[i] + aBestMin_Z[nT][i];

				// file  ?
				minmaxFile << aKVQBits[i] << '\t';
				minmaxFile << aThresholds[nT+nFirst] << '\t';
				minmaxFile << aX_Values.GetSize() << '\t';
				minmaxFile << aX_MINs[i] << '\t';
				minmaxFile << aY_MINs[i] << '\t';
				minmaxFile << aZ_MINs[i] << '\t';
				minmaxFile << aBestMin_X[nT][i] << '\t';
				minmaxFile << aBestMin_Y[nT][i] << '\t';
				minmaxFile << aBestMin_Z[nT][i] << '\t';
				minmaxFile << (aX_MINs[i] - aBestMin_X[nT][i]) << '\t';
				minmaxFile << (aY_MINs[i] - aBestMin_Y[nT][i]) << '\t';
				minmaxFile << (aZ_MINs[i] - aBestMin_Z[nT][i]) << endl;
			}
		}

		minmaxFile.close();
	}





	int nKQBit, nKVQBit;
	int nPrevX, nPrevY, nPrevZ;
	int nCurrX, nCurrY, nCurrZ;
	double dThreshold;

	char strBuffer[256];

	// 5.2 õ Key Ͽ Encoding
	for(int nK=0; nK<nNUM_KEY; nK++)
	{
		nKQBit = aKQBits[nK];

		cout << "Processing Key: " << nKQBit << endl;
		cout << "Processing KeyValue: ";

		for(int nKV=0; nKV<nNUM_KEYVALUE; nKV++)
		{
			nKVQBit = aKVQBits[nKV];

			// sowoo 2001.09.20 (Optimize Key&KeyValue Pairs)
			//if(!IsValidPairs(nKQBit, nKVQBit))
			//	continue;

			cout << nKVQBit << ",";
			cout.flush();

			nPrevX = -1;
			nPrevY = -1;
			nPrevZ = -1;


			//for(int nT=nFirst; nT<nLast; nT++)
			for(int nT=0; nT<nNUM_THRESHOLD; nT++)
			{
				dThreshold = aThresholds[nT];


				// sowoo 2001.09.20 (Optimize Threshold)
				// ٷ  threshold  key&keyValue  ִ ѵ  ʴ´.
				nCurrX = GetNumberOfThisFromArray(aXs[nT], 1);
				nCurrY = GetNumberOfThisFromArray(aYs[nT], 1);
				nCurrZ = GetNumberOfThisFromArray(aZs[nT], 1);

				// ٷ     !!!
				//  ؼ   ´.
				//if((nCurrX == nPrevX) && (nCurrY == nPrevY) && (nCurrZ == nPrevZ))
				//	continue;

				//   ƴ϶,  ϵ,   Ͽ ´.
				nPrevX = nCurrX;
				nPrevY = nCurrY;
				nPrevZ = nCurrZ;
				// end (Optimize Threshold)


				////////////////////////////////////////////////////////////
				//  element  encoding  .
				////////////////////////////////////////////////////////////
				CompressedPositionInterpolator compressedPosInterp;

				compressedPosInterp.SetKeyAndKeyValue(
					aKeys, x_kv, y_kv, z_kv,
					aXs[nT], aYs[nT], aZs[nT],
					bIsKeyPreserve
				);

				compressedPosInterp.SetMinMax(
					aX_MINs[nT], aY_MINs[nT], aZ_MINs[nT],
					aX_MAXs[nT], aY_MAXs[nT], aZ_MAXs[nT]
				);

				compressedPosInterp.SetQBit(nKQBit, nKVQBit);

				compressedPosInterp.SetDigit(nKeyDigit, nKeyValueDigit);

				compressedPosInterp.SetStartIndex(nStartIndex_X, nStartIndex_Y, nStartIndex_Z);

				compressedPosInterp.SetUnaryAAC(bUnaryAAC_X, bUnaryAAC_Y, bUnaryAAC_Z);

				compressedPosInterp.SetDPDMChoice(chTypeOfBest);

				compressedPosInterp.SetLinearKeyFlag(bLinearKeyCoder);

				compressedPosInterp.SetMinimieKeyQuantErrorFlag(bKeyQuant);

				compressedPosInterp.encode();

				// output encoded bitstream file name
				sprintf(strBuffer, 
					"%s_%02d_%02d_%g_%s_%s_%s_%s.aac",
					argv[2],
					nKQBit, nKVQBit, dThreshold,
					argv[5], argv[7], argv[9], argv[10]
				);

				compressedPosInterp.makeBitstream(strBuffer);

				// output encoded bitstream file name
				sprintf(strBuffer, 
					"%s_%02d_%02d_%g_%s_%s_%s_%s.tmp",
					argv[2],
					nKQBit, nKVQBit, dThreshold,
					argv[5], argv[7], argv[9], argv[10]
				);

				// ErrorMeasure Է  (.TMP)
				ofstream file;
				file.open(strBuffer);

				// filename kqp kvqp threshold etc.
				file << argv[2] << '\t';
				file << nKQBit << '\t';
				file << nKVQBit << '\t';
				file << compressedPosInterp.m_nTotalBits << '\t';
				file << dThreshold << '\t';
				file << argv[5] << '\t';
				file << argv[7] << '\t';
				file << argv[9] << '\t';
				file << argv[10] << '\t';
				file << compressedPosInterp.m_nKeyHeaderBits << '\t';
				file << compressedPosInterp.m_nKeyValueHeaderBits << '\t';
				file << compressedPosInterp.m_nKeySelectionFlagBits << '\t';
				file << compressedPosInterp.m_nKeyBits << '\t';
				file << compressedPosInterp.m_nKeyValueBits << endl;

				file.close();
			}
		}

		cout << endl;
	}

	return 0;
}

