// PosIKeyValue.h: interface for the PosIKeyValue class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_POSIKEYVALUE_H__96139878_055B_4122_BAD4_4FEC2E8F2F7A__INCLUDED_)
#define AFX_POSIKEYVALUE_H__96139878_055B_4122_BAD4_4FEC2E8F2F7A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "entropy.h"
#include "PosIKeyValueHeader.h"
#include "JWTemplArray.h"
#include "SFVec3f.h"

#include "JWTemplArray.h"
#include "SFVec3f.h"
#include "KeySelectionFlag.h"

class PosIKeyValue  
{
public:
	PosIKeyValue();
	virtual ~PosIKeyValue();

public:
	void readBitstream(
		CAC_QF& codec, PosIKeyValueHeader kvHeader, 
		int nNumberOfKeyValue
	);

	void decodingProcess(
		PosIKeyValueHeader kvHeader,
		KeySelectionFlag ksFlag,
		JWArray<double>& key,
		JWArray<SFVec3f>& keyValue
	);

	void InitializeModel();

public:
	int* keyValue_X;
	int* keyValue_Y;
	int* keyValue_Z;

	// model for arithmetic decoder
public:
	CAC kvXSignContext;
	CAC kvXUContext;
	CAC kvXMaxValueContext;
	CAC kvXFoundContext;
	CAC kvXNotFoundContext;

	CAC kvYSignContext;
	CAC kvYUContext;
	CAC kvYMaxValueContext;
	CAC kvYFoundContext;
	CAC kvYNotFoundContext;

	CAC kvZSignContext;
	CAC kvZUContext;
	CAC kvZMaxValueContext;
	CAC kvZFoundContext;
	CAC kvZNotFoundContext;
};

#endif // !defined(AFX_POSIKEYVALUE_H__96139878_055B_4122_BAD4_4FEC2E8F2F7A__INCLUDED_)
