// PosIKeyValueHeader.cpp: implementation of the PosIKeyValueHeader class.
//
//////////////////////////////////////////////////////////////////////

#include "PosIKeyValueHeader.h"
#include "FunctionsForDecoding.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

PosIKeyValueHeader::PosIKeyValueHeader()
{

}

PosIKeyValueHeader::~PosIKeyValueHeader()
{

}

void PosIKeyValueHeader::readBitstream(CAC_QF& codec)
{
	bPreserveKey = codec._istrm->getbit();
	nKVQBit = codec._istrm->getbits(5);
	x_keyvalue_flag = codec._istrm->getbit();
	y_keyvalue_flag = codec._istrm->getbit();
	z_keyvalue_flag = codec._istrm->getbit();
	nKVDigit = codec._istrm->getbits(4);

	int nBits = getNbBits(nKVQBit);

	// if x_keyvalue_flag == 1
	if(x_keyvalue_flag == 1)
	{
		nKVDPCMOrder_X = codec._istrm->getbit();
		bIsUnaryAAC_X = codec._istrm->getbit();

		if(bIsUnaryAAC_X != 1)
		{
			nKVCodingBit_X = codec._istrm->getbits(nBits);
			nStartIndex_X = codec._istrm->getbit();
		}
	}

	// if y_keyvalue_flag == 1
	if(y_keyvalue_flag == 1)
	{
		nKVDPCMOrder_Y = codec._istrm->getbit();
		bIsUnaryAAC_Y = codec._istrm->getbit();

		if(bIsUnaryAAC_Y != 1)
		{
			nKVCodingBit_Y = codec._istrm->getbits(nBits);
			nStartIndex_Y = codec._istrm->getbit();
		}
	}

	// if x_keyvalue_flag == 1
	if(z_keyvalue_flag == 1)
	{
		nKVDPCMOrder_Z = codec._istrm->getbit();
		bIsUnaryAAC_Z = codec._istrm->getbit();

		if(bIsUnaryAAC_Z != 1)
		{
			nKVCodingBit_Z = codec._istrm->getbits(nBits);
			nStartIndex_Z = codec._istrm->getbit();
		}
	}

	// if Intra coding is used
	if((nStartIndex_X == 1) && (x_keyvalue_flag == 1))
		firstKV_X = codec._istrm->getbits(nKVQBit);
	if((nStartIndex_Y == 1) && (y_keyvalue_flag == 1))
		firstKV_Y = codec._istrm->getbits(nKVQBit);
	if((nStartIndex_Z == 1) && (z_keyvalue_flag == 1))
		firstKV_Z = codec._istrm->getbits(nKVQBit);

	kvMinMax.readBitstream(codec, nKVDigit);
}


void PosIKeyValueHeader::decodingProcess()
{
	kvMinMax.decodingProcess();
}
