// PosIKeyValueHeader.h: interface for the PosIKeyValueHeader class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_POSIKEYVALUEHEADER_H__8344534A_F5EB_4196_8859_38F5A9C85CAD__INCLUDED_)
#define AFX_POSIKEYVALUEHEADER_H__8344534A_F5EB_4196_8859_38F5A9C85CAD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "entropy.h"
#include "KeyValueMinMax.h"
#include "JWTemplArray.h"
#include "SFVec3f.h"

class PosIKeyValueHeader  
{
public:
	PosIKeyValueHeader();
	virtual ~PosIKeyValueHeader();

public:
	void readBitstream(CAC_QF& codec);
	void decodingProcess();

public:
	unsigned int bPreserveKey;
	unsigned int nKVQBit;
	unsigned int x_keyvalue_flag;
	unsigned int y_keyvalue_flag;
	unsigned int z_keyvalue_flag;
	unsigned int nKVDigit;

	// if x_keyvalue_flag == 1
	unsigned int nKVDPCMOrder_X;
	unsigned int bIsUnaryAAC_X;
	unsigned int nKVCodingBit_X;
	unsigned int nStartIndex_X;

	// if y_keyvalue_flag == 1
	unsigned int nKVDPCMOrder_Y;
	unsigned int bIsUnaryAAC_Y;
	unsigned int nKVCodingBit_Y;
	unsigned int nStartIndex_Y;

	// if x_keyvalue_flag == 1
	unsigned int nKVDPCMOrder_Z;
	unsigned int bIsUnaryAAC_Z;
	unsigned int nKVCodingBit_Z;
	unsigned int nStartIndex_Z;

	// if Intra coding is used
	unsigned int firstKV_X;
	unsigned int firstKV_Y;
	unsigned int firstKV_Z;

	KeyValueMinMax kvMinMax;
};

#endif // !defined(AFX_POSIKEYVALUEHEADER_H__8344534A_F5EB_4196_8859_38F5A9C85CAD__INCLUDED_)
