// SFVec3f.h: interface for the SFVec3f class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SFVEC3F_H__3C612699_444B_4DE8_BA4F_10CAB0159255__INCLUDED_)
#define AFX_SFVEC3F_H__3C612699_444B_4DE8_BA4F_10CAB0159255__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <math.h>
#include <fstream.h>

class SFVec3f  
{
public:
	SFVec3f();
	virtual ~SFVec3f();

public:
	SFVec3f& operator = (const SFVec3f& value)
	{
		x = value.x;
		y = value.y;
		z = value.z;

		return *this;
	}

	double GetDistance(const SFVec3f& value)
	{
		double dX, dY, dZ;
		dX = x - value.x;
		dY = y - value.y;
		dZ = z - value.z;

		return ::sqrt(dX*dX + dY*dY + dZ*dZ);
	}

	friend ofstream& operator << (ofstream& os, SFVec3f& v)
	{
		os << v.x << ' ' << v.y << ' ' << v.z;
		return os;
	}

public:
	double x;
	double y;
	double z;
};

#endif // !defined(AFX_SFVEC3F_H__3C612699_444B_4DE8_BA4F_10CAB0159255__INCLUDED_)
