// SInterpolator.h: interface for the CSInterpolator class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SINTERPOLATOR_H__47696E2C_F014_4501_ADFD_82F8AEB691EF__INCLUDED_)
#define AFX_SINTERPOLATOR_H__47696E2C_F014_4501_ADFD_82F8AEB691EF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SAIT_Definitions.h"
#include <string.h>
#include <fstream.h>

class CSInterpolator  
{
public:
	CSInterpolator();
	virtual ~CSInterpolator();

public:
	int GetNumberOfKeys() { return m_paKeys->GetSize(); }
	void SetNumberOfKeys(int nNumKey) { m_nNumberOfKeys = nNumKey; }

	MFFloat& GetKeys() { return *m_paKeys; }

	void SetKeys(MFFloat& aKeys)
	{
		if(m_paKeys != NULL)
		{
			m_paKeys->Copy(aKeys);
		}
		else
		{
			m_paKeys = new MFFloat();
			m_paKeys->Copy(aKeys);
		}
	}

	void SetKeys(double* aKeys, int nSize)
	{
		if(m_paKeys != NULL)
			m_paKeys->SetSize(nSize);
		else
			m_paKeys = new MFFloat();

		for(int i=0; i<nSize; i++)
		{
			(*m_paKeys)[i] = aKeys[i];
		}
	}

	void* GetKeyValues() { return m_paKeyValues; }

	virtual void SetKeyValues(void* aKeyValues) {}


	void SetDEFName(char* defName) { ::strcpy(m_strDEF_Name, defName); }


	void ParseKeys(ifstream& file);
	virtual void ParseKeyValues(ifstream& file) {}

	// ٸ Interpolator      Ѵ.
	virtual void InsertPointWith(CSInterpolator* pInterpolator) {}


	// keyValue interpolationѴ.
	virtual void InterpolateKeyValue(
		double key1, double key2, double key, void* kv1, void* kv2, void* keyValue) {}

	virtual void InsertKey(int index, double key, void* keyValue) {}

	// sowoo 2001.09.19 (Write For Debugging)
	virtual void Write_For_Debugging(char* fileName) {}

	// sowoo 2001.10.08
	void SetSize(int size)
	{
		if(m_paKeys == NULL)
			m_paKeys = new MFFloat;
		if(m_paKeyValues == NULL)
			m_paKeyValues = (void*) (new MFVec3f);

		m_paKeys->SetSize(size);
		((MFVec3f*) m_paKeyValues)->SetSize(size);

		m_nNumberOfKeys = size;
	}

protected:
	MFFloat* m_paKeys;
	void* m_paKeyValues;
	int m_nNumberOfKeys;
	char m_strDEF_Name[256];
};

#endif // !defined(AFX_SINTERPOLATOR_H__47696E2C_F014_4501_ADFD_82F8AEB691EF__INCLUDED_)
