// SPositionInterpolator.h: interface for the CSPositionInterpolator class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SPOSITIONINTERPOLATOR_H__AADAA405_5B9D_49B4_A07F_A41EDBD6F0DF__INCLUDED_)
#define AFX_SPOSITIONINTERPOLATOR_H__AADAA405_5B9D_49B4_A07F_A41EDBD6F0DF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SInterpolator.h"

class CSPositionInterpolator : public CSInterpolator  
{
public:
	CSPositionInterpolator();
	virtual ~CSPositionInterpolator();

public:
	void SetKeyValues(void* aKeyValues)
	{
		if(m_paKeyValues != NULL)
		{
			((MFVec3f*)m_paKeyValues)->Copy(*(MFVec3f*)aKeyValues);
		}
		else
		{
			m_paKeyValues = new MFVec3f();
			((MFVec3f*)m_paKeyValues)->Copy(*(MFVec3f*)aKeyValues);
		}
	}

	void ParseKeyValues(ifstream& file);

	void InsertPointWith(CSInterpolator* pInterpolator);

	void InterpolateKeyValue(
		double key1, double key2, double key, void* kv1, void* kv2, void* keyValue);

	void InsertKey(int index, double key, void* keyValue);

	friend void MakePointsDouble(CSInterpolator*, CSInterpolator*);

	double GetMaxDistanceOfInterval() { return m_dMaxDistanceOfInterval; }
	double CalculateMaxDistanceOfInterval();

	double GetTotalLengthOfPath() { return m_dTotalLengthOfPath; }
	double CalculateTotalLengthOfPath();

	double GetTotalLengthOfPathOverBox() { return m_dTotalLengthOfPathOverBox; }
	double CalculateTotalLengthOfPathOverBox();


	// sowoo 2001.10.08 (Add Error Measure 6)
	double CalculateTwoPointsError();
	double GetTwoPointsError() { return m_dTwoPointsError; }

	SFVec3f& GetMin()
	{
		MFVec3f& aKeyValues = *((MFVec3f*) m_paKeyValues);

		for(int i=0; i<aKeyValues.GetSize(); i++)
		{
			if(aKeyValues[i].x < m_min.x)
				m_min.x = aKeyValues[i].x;

			if(aKeyValues[i].y < m_min.y)
				m_min.y = aKeyValues[i].y;

			if(aKeyValues[i].z < m_min.z)
				m_min.z = aKeyValues[i].z;
		}

		return m_min;
	}
	SFVec3f& GetMax()
	{
		MFVec3f& aKeyValues = *((MFVec3f*) m_paKeyValues);

		for(int i=0; i<aKeyValues.GetSize(); i++)
		{
			if(aKeyValues[i].x > m_max.x)
				m_max.x = aKeyValues[i].x;

			if(aKeyValues[i].y > m_max.y)
				m_max.y = aKeyValues[i].y;

			if(aKeyValues[i].z > m_max.z)
				m_max.z = aKeyValues[i].z;
		}

		return m_max;
	}


	// sowoo 2001.09.19 (Write For Debugging)
	void Write_For_Debugging(char* fileName);

protected:
	SFVec3f m_max;
	SFVec3f m_min;
	double m_dMaxDistanceOfInterval;
	double m_dTotalLengthOfPathOverBox;
	double m_dTotalLengthOfPath;

	// sowoo 2001.10.08 (Add Error Meausre 6)
	double m_dTwoPointsError;
};

#endif // !defined(AFX_SPOSITIONINTERPOLATOR_H__AADAA405_5B9D_49B4_A07F_A41EDBD6F0DF__INCLUDED_)
