// ompressedPositionInterpolator.h: interface for the CompressedPositionInterpolator class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OMPRESSEDPOSITIONINTERPOLATOR_H__174DA657_46F9_48D8_A469_94562461D20D__INCLUDED_)
#define AFX_OMPRESSEDPOSITIONINTERPOLATOR_H__174DA657_46F9_48D8_A469_94562461D20D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "KeyHeader.h"
#include "PosIKeyValueHeader.h"
#include "KeySelectionFlag.h"
#include "Key.h"
#include "PosIKeyValue.h"

class CompressedPositionInterpolator  
{
public:
	CompressedPositionInterpolator();
	virtual ~CompressedPositionInterpolator();

public:
	void decode(char* fileName);

	void makeBitstream(char* fileName);
	void encode();

	void write(char* fileName);


public:
	void SetKeyAndKeyValue(
		JWArray<double>& keys,
		JWArray<double>& keyValue_X, JWArray<double>& keyValue_Y, JWArray<double>& keyValue_Z,
		JWArray<int>& flag_X, JWArray<int>& flag_Y, JWArray<int>& flag_Z,
		bool bIsKeyPreserve
	);

	void SetMinMax(
		double dMin_X, double dMin_Y, double dMin_Z,
		double dMax_X, double dMax_Y, double dMax_Z
	);
	void SetDigit(int nKeyDigit, int nKeyValueDigit);

	void SetDPDMChoice(char choice);

	void SetQBit(int nKeyQBit, int nKeyValueQBit);

	void SetStartIndex(int nStartIndex_X, int nStartIndex_Y, int nStartIndex_Z);

	void SetUnaryAAC(bool bUnaryX, bool bUnaryY, bool bUnaryZ);

	void SetLinearKeyFlag(bool bLinearKeyCoder);

	void SetMinimieKeyQuantErrorFlag(bool bKeyQuant);

public:
	// PDAM ̸ .
	KeyHeader kHeader;
	PosIKeyValueHeader posIKVHeader;
	KeySelectionFlag ksFlag;
	Key k;
	PosIKeyValue posIKV;

public:
	JWArray<double> key;

	// for decoding
	JWArray<SFVec3f> keyValue;

	// for encoding
	JWArray<double> m_keyValue_X;
	JWArray<double> m_keyValue_Y;
	JWArray<double> m_keyValue_Z;

	JWArray<int> m_KeySelectionFlag;

	JWArray<int> m_aQuantValue_X;
	JWArray<int> m_aQuantValue_Y;
	JWArray<int> m_aQuantValue_Z;

protected:
	bool m_bIsDEF;
	char m_strDEF[256];
	int m_nKeyDigit;
	int m_nKeyValueDigit;

	double m_dMin_X, m_dMax_X;
	double m_dMin_Y, m_dMax_Y;
	double m_dMin_Z, m_dMax_Z;
	double m_dMaxDiff;

	bool m_bIsKeyPreserve;

	int m_nKeyQBit;
	int m_nKeyValueQBit;

	int m_nStartIndex_X;
	int m_nStartIndex_Y;
	int m_nStartIndex_Z;

	int m_nDPCMOrder_X;
	int m_nDPCMOrder_Y;
	int m_nDPCMOrder_Z;

	int m_nCodingBit_X;
	int m_nCodingBit_Y;
	int m_nCodingBit_Z;

	char m_chDPCMOrder;

	bool m_bKeyValueFlag_X;
	bool m_bKeyValueFlag_Y;
	bool m_bKeyValueFlag_Z;

	bool m_bUnaryAAC_X;
	bool m_bUnaryAAC_Y;
	bool m_bUnaryAAC_Z;

	bool m_bLinearKeyCoder;

	bool m_bKeyQuant;

public:
	int m_nKeyHeaderBits;
	int m_nKeyValueHeaderBits;
	int m_nKeySelectionFlagBits;
	int m_nKeyBits;
	int m_nKeyValueBits;
	int m_nTotalBits;
};

#endif // !defined(AFX_OMPRESSEDPOSITIONINTERPOLATOR_H__174DA657_46F9_48D8_A469_94562461D20D__INCLUDED_)
