#ifndef _ENTROPY_H_
#define _ENTROPY_H_

#include "stream.h"

struct AC_QEntry {
  unsigned short Qe;
  short          nMPS;
  short          nLPS;
  short          sMPS;
};

class CAC {
public:
	static struct AC_QEntry model[];
	static int	_shift;
	unsigned      Qe;
	short         index;
	short         MPS;
	
	~CAC();
	CAC(); 
	void reset();
	void update(int symbol); 
};

class CAC_QF {
protected:

  unsigned      C;
  unsigned      A;
  unsigned      C_high;
  int           count;
  int           first;
  int           bits;

  int           _ostrm_bits;
  int           _istrm_bits;
  


public:
	CInStream*	_istrm;
	COutStream*	_ostrm;

protected:
  int  get_byte();
  void put_byte(int);

  void hw_renorm_encode();
  void hw_renorm_decode();
  int  sw_renorm_decode();

  void hw_start_encode();
  void hw_encode(int, CAC &);
  void hw_encode(int);
  void hw_finish_encode();

  void hw_start_decode();
  int  hw_decode(CAC &);
  void hw_finish_decode();

  void sw_start_decode();
  int  sw_decode(CAC &);
  int  sw_decode();
  void sw_finish_decode();

public:
  CAC_QF(COutStream &o);  
  CAC_QF(CInStream &i);
  ~CAC_QF();
  int getOBits();
  int getIBits();
  void encode(int bit);
  void encode(int bit, CAC &qfPM);
  int decode();
  int decode(CAC &qfPM);
  void start_encode(void);
  void finish_encode(void);
  void start_decode(void);
  void finish_decode(void);
};

class CQF_Status {
public:
	static CAC endflag_context;
	static CAC key_context[32];
	static CAC keyVX_context[32];
	static CAC keyVY_context[32];
	static CAC keyVZ_context[32];
	static CAC keyVA_context[32];
	static CAC signflag_context;  //test1]
	static CAC quatIndex_context[2];
	// jameskim 20010315
	static CAC keysgn_context;
	static CAC keysgnVX_context;
	static CAC keysgnVY_context;
	static CAC keysgnVZ_context;
	// sowoo 2001.04.27
	static CAC key_flag_context;
	static CAC key_flagX_context;
	static CAC key_flagY_context;
	static CAC key_flagZ_context;

	// sowoo 2001.09.25 (Add KeyCoder)
	static CAC kc_sign_k_context;


	// sowoo 2001.11.12 (CQMM)
	static CAC misc_context[32];
	static CAC miscSign_context;

	// manjini 20010920 --> for successive quantization
	static CAC found_context;
	static CAC not_found_context;
	static CAC keyV_sign_context;
	static CAC max_val_context;



	// Dictionary selection flag: dictionary value or dictionary address
	static CAC ci_kv_Dic_method_flag_context;

	// Dictionary address
	static CAC ci_kv_Dic_address_context;

	// Dictionary last
	static CAC ci_kv_Dic_last_flag_context;

	// Dictionary one
	static CAC ci_kv_Dic_one_context;

	// Dictionary index
	static CAC ci_kv_Dic_index_context;

	// Key value: keyValue context (dictionary value)
	static CAC ci_kv_sign_context;
	static CAC ci_kv_keyValue_x_context[32];
	static CAC ci_kv_keyValue_y_context[32];
	static CAC ci_kv_keyValue_z_context[32];



	// 6 ϹǷ 3bit ̻  ʴ´.
	// indication index context
	static CAC indicationIndex_context[3];


	~CQF_Status();
	CQF_Status();
	static void reset();
};


#endif  //_ENTROPY_H_