
#include "functionsForDecoding.h"
#include <math.h>
#include <stdlib.h>

int getNbBits(int k)
{
	int j=1;
	while (k >= (1<<j) ) 
	{
		j++;
	}
	return j;
}


void Inverse_DPCM_CircularQuantize(
	int* aValues, int nSize, int nMax, int nStart
)
{
	int nValue, nPrevValue, nCircularValue;

	int* aFinalValues = new int[nSize];

	if(nStart == 0)
	{
		nPrevValue = 0;
	}
	else
	{
		aFinalValues[0] = aValues[0];
		nPrevValue = aValues[0];

		nStart = 1;
	}

	for(int i=nStart; i<nSize; i++)
	{
		nValue = aValues[i];

		if(nValue >= 0)
			nCircularValue = nValue - (nMax + 1);
		else
			nCircularValue = nValue + (nMax + 1);

		nValue = aValues[i] + nPrevValue;

		//  ۿ  쿡 ...
		//  .
		if(nValue < 0)
			nValue = nPrevValue + nCircularValue;
		if(nValue > nMax)
			nValue = nPrevValue + nCircularValue;

		//
		nPrevValue = nValue;
		aFinalValues[i] = nValue;
	}

	for(i=0; i<nSize; i++)
		aValues[i] = aFinalValues[i];

	delete[] aFinalValues;
}



void Inverse_Second_DPCM_CircularQuantize(
	int* aValues, int nSize, int nMax, int nStart
)
{
	int nValue, nPrevValue, nCircularValue;
	int nDiffValue, nPredValue;

	int* aFinalValues = new int[nSize];

	if(nStart == 0)
	{
		nPrevValue = 0;
		nDiffValue = 0;
	}
	else
	{
		aFinalValues[0] = aValues[0];

		nPrevValue = aValues[0];
		nDiffValue = aValues[0];

		nStart = 1;
	}

	for(int i=nStart; i<nSize; i++)
	{
		nPredValue = nDiffValue + nPrevValue;

		if(nPredValue > nMax)
		{
			nValue = nMax - aValues[i];

			//  ũ?
			if(nValue > nMax)
				nValue = nValue - (nMax + 1);
		}
		else if(nPredValue < 0)
			nValue = aValues[i];
		else
			nValue = aValues[i] + nPredValue;


		if(nValue >= 0)
			nCircularValue = nValue - (nMax + 1);
		else
			nCircularValue = nValue + (nMax + 1);


		//  ۿ  쿡 ...
		//  .
		if(nValue < 0)
			nValue = nCircularValue;
		if(nValue > nMax)
			nValue = nCircularValue;

		//
		nDiffValue = nValue - nPrevValue;
		nPrevValue = nValue;

		aFinalValues[i] = nValue;
	}


	for(i=0; i<nSize; i++)
		aValues[i] = aFinalValues[i];

	delete [] aFinalValues;
}


void Inverse_Quantize(
	int* aQuant, double* aOriginal, 
	int nNum, double dMin, double dMax, int nQBit, int nDigit
)
{
	double dValue;
	int nMaximum = (int) pow(2, nQBit) - 1;

	for(int i=0; i<nNum; i++)
	{
		dValue = (double) aQuant[i] / (double) nMaximum;
		dValue = dValue*(dMax - dMin) + dMin;

		aOriginal[i] = floor_keyValue(dValue, nDigit);
	}
}


double floor_keyValue(double value, int kv_digit)
{
	//////////////////////////////////////////////////
	//
	//			Original Value 7ڸ !!!
	//			꿡 ؼ   
	//
	//////////////////////////////////////////////////

	char buffer[50];
	_gcvt(value, kv_digit, buffer);
	value = atof(buffer);

	return value;
}


void InterpolatorSythesizer(
	double *kv_org, double *kv_ext, JWArray<unsigned int>& flag,
	int n_org, int n_q_key, JWArray<double>& key_final
)
{
	int i,j;
	double st, en, stv, env;
	double *kee;

	kee= new double[n_q_key];

	en=key_final[n_q_key-1]; env=kv_org[n_org-1];
	j=n_org-1;
	for(i=n_q_key-1;i>=0;i--)
	{
		if(flag[i]==1){
			env=kv_org[j];
			en=key_final[i];
			j--;
		}
		kv_ext[i]=env;
		kee[i]=en;
	}

   
    for(i=0;i<n_q_key;i++)
	{
		if (flag[i] == 1) // it is NOT to be interpolated.
		{
			st=kee[i];
			stv=kv_ext[i];
		}
		else // to be interpolated.
		{
			en=kee[i];
			env=kv_ext[i];

			if((en - st) == 0.0)
				kv_ext[i] = stv;
			else
				kv_ext[i]=(env - stv)*(key_final[i]-st)/(en-st) +stv;
		}
	}

	delete [] kee;
}