
#include <math.h>
#include <stdlib.h>
#include <fstream.h>
#include <limits.h>
#include <float.h>
#include "functionsForEncoding.h"
#include "JWPositionInterpolator.h"
#include "SInterpolator.h"
#include "SPositionInterpolator.h"
#include "SError.h"

#if !defined AACTotal_ENC
#define AACTotal_ENC() (codec._ostrm->Outbuf.nbytes) * 8 + (codec._ostrm->Outbuf.nbits)
#endif


int getNbBits(int);

// 10
const double dEPSILONERROR = 0.0000000001;


// ִ digit?
//const int cnMAX_CUTTING_DIGIT = 15;
const int cnMAX_DIGIT = 15;



void WriteIM1Text(char* fileName, JWInterpolator* pInterpolator, char* buffer)
{
	ofstream file;
	file.open(fileName);

	if(!file.is_open())
	{
		cout << "    . ̾~" << endl;
		cout << "File Name: " << fileName << endl;
		return;
	}

	// 1. Comment ۼѴ.
	file << buffer << endl << endl;

	// 2. Group .
	file << "Group {" << endl;
	file << '\t' << "children [" << endl;
	pInterpolator->Write(file);
	file << '\t' << ']' << endl;
	file << '}' << endl;

	file.close();
}


void ParseIM1Text(JWToken& token, JWInterpolator*& pInterpolator)
{
	bool bIsDEF = false;
	char buffer[256];

	token.GetNextToken();
	if(token == Group)
	{
		token.GetNextToken();
		if(token == BRACE_OPEN)
		{
			token.GetNextToken();
			if(token == children)
			{
				token.GetNextToken();
				if(token == SQUAREBRACKET_OPEN)
				{
					token.GetNextToken();
					
					// DEF ״ Ư ó !
					if(token == DEF)
					{
						// DEF Name о,
						token.GetNextToken();

						// DEF Name Ѵ.
						bIsDEF = true;
						::strcpy(buffer, token);

						// Node ̸ д´.
						token.GetNextToken();
					}

					switch(token)
					{
					case PositionInterpolator:
						// PositionInterpolator class ϰ,
						// Parsingϵ Ѵ.
						pInterpolator = new JWPositionInterpolator;
						pInterpolator->Parse(token);
						break;

					case OrientationInterpolator:
						//pInterpolator = new JWOrientationInterpolator;
						//pInterpolator->Parse(token);
						break;
					}

					if(bIsDEF)
						pInterpolator->SetDEF(buffer);
				}

				if(token == SQUAREBRACKET_CLOSE)
				{
					token.GetNextToken();
				}
			}
		}

		if(token == BRACE_CLOSE)
		{
		}
	}
}


void Quantize(
	double* aValues,
	int nSize,
	int nQBit,
	double dMin, double dMax, 
	int* aQuantValues
)
{
	for(int i=0; i<nSize; i++)
	{
		// 1. Min , 0
		if(aValues[i] < dMin)
			aQuantValues[i] = 0;
		// 2. Max ũ ִ밪!!!
		else if(aValues[i] > dMax)
			aQuantValues[i] = (1<<nQBit) - 1; //(int) (::pow(2, nQBit) - 1);

		// 3.   ϸ,
		else
			aQuantValues[i] = int((aValues[i] - dMin)/(dMax - dMin) * ((1<<nQBit) - 1) + 0.5);
	}
}

void Quantize(
	JWArray<double>& aValues,
	int nQBit,
	double dMin, double dMax, 
	JWArray<int>& aQuantValues
)
{
	int nSize = aValues.GetSize();

	for(int i=0; i<nSize; i++)
	{
		// 1. Min , 0
		if(aValues[i] < dMin)
			aQuantValues[i] = 0;
		// 2. Max ũ ִ밪!!!
		else if(aValues[i] > dMax)
			aQuantValues[i] = (1<<nQBit) - 1; //(int) (::pow(2, nQBit) - 1);

		// 3.   ϸ,
		else
			aQuantValues[i] = int((aValues[i] - dMin)/(dMax - dMin) * ((1<<nQBit) - 1) + 0.5);
	}
}

void Quantize(
	JWArray<double>& aValues,
	int nQBit,
	double dMin, double dMax, 
	int* aQuantValues
)
{
	int nSize = aValues.GetSize();

	for(int i=0; i<nSize; i++)
	{
		// 1. Min , 0
		if(aValues[i] < dMin)
			aQuantValues[i] = 0;
		// 2. Max ũ ִ밪!!!
		else if(aValues[i] > dMax)
			aQuantValues[i] = (1<<nQBit) - 1; //(int) (::pow(2, nQBit) - 1);

		// 3.   ϸ,
		else
			aQuantValues[i] = int((aValues[i] - dMin)/(dMax - dMin) * ((1<<nQBit) - 1) + 0.5);
	}
}

void QuantizeMM(
	JWArray<double>& aValues,
	int nQBit,
	double& dMin, double& dMax, 
	int* aQuantValues
)
{
	int nSize = aValues.GetSize();

	// 1. ȭ ݰ   exponent Ѵ.
	double dQuantSpace = (dMax - dMin) / (::pow(2, nQBit) - 1)/2;
	//int nExponent_QuantSpace = GetLargestDigit(dQuantSpace);

	// 2. Min(dMin) exponent ϰ
	int nDigit_Min = GetDigit(dMin);
	int nDigit_QS = ::GetLeadingZero(dQuantSpace) - ::GetLeadingZero(dMin);
	//nDigit_QS = (nDigit_QS>0)? nDigit_QS: 0;

	// 3. ȭ  exponent Ͽ ū  Ѵ.
	//nExponent_Min = (nExponent_QuantSpace > nExponent_Min)? nExponent_QuantSpace: nExponent_Min;

	int nMin = GetMantissa(dMin, nDigit_Min);
	int nExponent = GetLargestDigit(dMin);

	// Min 	= 0.0027227
	// Space 	= 0.0000667342  
		// ==> Slice  = 667, ̷  ̾Ƴ!!!
		// ⼭ 3 = GetDigit(0.0027227) - GetLeadingZero(0.0027227)
	//int nMinSlice = GetMantissa(dQuantSpace, nDigit_Min - nDigit_QS);
	//int nMinSlice = GetMantissa(dQuantSpace, (nDigit_QS>0)? nDigit_QS: 0);

   char *buffer;
   int decimal = 0, sign = 0;
   buffer = _fcvt(dQuantSpace, nExponent, &decimal, &sign );
   int nMinSlice = ::atoi(buffer);




	double dMin_Revised, dMax_Revised;
	double dBestMinValue, dBestMaxValue;
	double dError, dMinError = DBL_MAX;
	double* aDeQuantValues = new double[nSize];



	// 1. ȭ Ѵ.	// 2. ȭ Ѵ.	// 3. error Ѵ.
	Quantize(aValues, nQBit, dMin, dMax, aQuantValues);
	DeQuantize(aQuantValues, nSize, nQBit, dMin, dMax, aDeQuantValues);
	double dBaseError = QuantizationError(aDeQuantValues, aValues);


	dMinError = dBaseError;
	dBestMinValue = dMin;
	dBestMaxValue = dMax;
	dMax_Revised = dMax;

	for(int i=-nMinSlice; i<nMinSlice; i++)
	{
		dMin_Revised = (nMin + nMinSlice+i)/::pow(10, nExponent);

		if(GetDigit(dMin_Revised) > nDigit_Min)
			continue;



		// 1. ȭ Ѵ.
		Quantize(aValues, nQBit, dMin_Revised, dMax_Revised, aQuantValues);

		// 2. ȭ Ѵ.
		DeQuantize(aQuantValues, nSize, nQBit, dMin_Revised, dMax_Revised, aDeQuantValues);

		// 3. error Ѵ.
		dError = QuantizationError(aDeQuantValues, aValues);

		if(dMinError > dError)
		{
			// 1% ̻ ̱ Ѹ !!!
			if( (dBaseError - dError)/dBaseError > 0.01)
			{
				dMinError = dError;
				dBestMinValue = dMin_Revised;
				dBestMaxValue = dMax_Revised;
			}
		}
	}

	dMin = dBestMinValue;
	dMax = dMax_Revised;

	//   , ٽѹ ȭؾ Ѵ.
	Quantize(aValues, nQBit, dBestMinValue, dMax_Revised, aQuantValues);
}



int ChooseBest(
	JWArray<int>& aSelectedValues,
	char chType,
	int nStart, int nQBit,

	// sowoo 2001.11.08 (Intra Coding)
	//   ( )
	bool& bIsIntra
)
{
	int nMax;
	int i;//, j;
	bool bIs1stDPCM = false;

	int nNumberOfValues = aSelectedValues.GetSize();

	JWArray<int> a1stDPCMValues;
	JWArray<int> a2ndDPCMValues;

	a1stDPCMValues.SetSize(nNumberOfValues);
	a2ndDPCMValues.SetSize(nNumberOfValues);


	// sowoo 2001.11.08 (Intra Coding)
	bool bIs1st_Intra = false, bIs2nd_Intra = false;

	// 1. 1st/2nd DPCM   .
	//if(nStart == 0)
	//{
		//nMax = GetMax(aSelectedValues, 0);
		nMax = (int) pow(2, nQBit) - 1;
		DPCM_CircularQuantize(
			aSelectedValues, a1stDPCMValues, nMax, 0);

		Second_DPCM_CircularQuantize(
			aSelectedValues, a2ndDPCMValues, nMax, 0);
	//}
	// 1 intra   ٲٶ.
	// 
	/*
	else // if(nStart > 0)
	{
		nMax = GetMax(aSelectedValues, nNumberOfValues, 1);

		// sowoo 2001.11.08 (Intra Coding)
		if(aSelectedValues[0] > nMax)
			bIs1st_Intra = true;
		else
			bIs1st_Intra = false;

		DPCM_CircularQuantize(
			aSelectedValues, a1stDPCMValues, nNumberOfValues, nMax, bCQ, (bIs1st_Intra)? 1: 0);



		nMax = GetMax(aSelectedValues, nNumberOfValues, 2);

		if((aSelectedValues[0] > nMax) || (aSelectedValues[1] > nMax))
			bIs2nd_Intra = true;
		else
			bIs2nd_Intra = false;

		// PDAM4
		Second_DPCM_CircularQuantize(
			//aSelectedValues, a2ndDPCMValues, nNumberOfValues, nMax, bCQ, (bIs2nd_Intra)? 2: 0);
			aSelectedValues, a2ndDPCMValues, nNumberOfValues, nMax, bCQ, (bIs2nd_Intra)? 1: 0);
	}*/



	// 2.  type   ֻ  ϵ Ѵ.
	int nCount = 0;
	//double dEntropy;
	//int n1st_ExpectedBits, n2nd_ExpectedBits;
	int n1st_SAD = 0, n2nd_SAD = 0;

	switch(chType) {
	// 2.1 AAC Best 
	// Ǿ .
	case 'a':
		if(nStart == 0)
		{
		}
		else // if(nStart > 0)
		{
		}
		cout << "Choose AAC Best in ChooseBest() function is not implemented" << endl;
		break;

	// 2.2 SAD Best 
	case 's':
		for(i=0; i<nNumberOfValues; i++)
			n1st_SAD += abs(a1stDPCMValues[i]);

		for(i=0; i<nNumberOfValues; i++)
			n2nd_SAD += abs(a2ndDPCMValues[i]);

		bIs1stDPCM = n1st_SAD <= n2nd_SAD;
		break;

	// 2.3 Entropy Best ΰ
	case 'e':
		/*
		if(nStart == 0)
		{
			// sowoo 2001.10.16 (SAD, Entropy)
			dEntropy = GetEntropy(a1stDPCMValues, nNumberOfValues, nQBit, 0);
			n1st_ExpectedBits = (int) ((nNumberOfValues - 1) * dEntropy + 0.5);
			dEntropy = GetSignEntropy(a1stDPCMValues, nNumberOfValues, 0, nCount);
			n1st_ExpectedBits += (int) (nCount * dEntropy + 0.5);

			dEntropy = GetEntropy(a2ndDPCMValues, nNumberOfValues, nQBit, 0);
			n2nd_ExpectedBits = (int) ((nNumberOfValues - 1) * dEntropy + 0.5);
			dEntropy = GetSignEntropy(a2ndDPCMValues, nNumberOfValues, 0, nCount);
			n2nd_ExpectedBits += (int) (nCount * dEntropy + 0.5);
		}
		else // if(nStart > 0)
		{
			if(bIs1st_Intra)
			{
				// sowoo 2001.10.16 (SAD, Entropy)
				dEntropy = GetEntropy(a1stDPCMValues, nNumberOfValues, nQBit, 1);
				n1st_ExpectedBits = (int) ((nNumberOfValues - 1) * dEntropy + 0.5);
				dEntropy = GetSignEntropy(a1stDPCMValues, nNumberOfValues, 1, nCount);
				n1st_ExpectedBits += (int) (nCount * dEntropy + 0.5);

				// (Intra Coding)
				n1st_ExpectedBits += nQBit;
			}
			else
			{
				// sowoo 2001.10.16 (SAD, Entropy)
				dEntropy = GetEntropy(a1stDPCMValues, nNumberOfValues, nQBit, 0);
				n1st_ExpectedBits = (int) ((nNumberOfValues - 1) * dEntropy + 0.5);
				dEntropy = GetSignEntropy(a1stDPCMValues, nNumberOfValues, 0, nCount);
				n1st_ExpectedBits += (int) (nCount * dEntropy + 0.5);
			}

			if(bIs1st_Intra)
			{
				dEntropy = GetEntropy(a2ndDPCMValues, nNumberOfValues, nQBit, 2);
				n2nd_ExpectedBits = (int) ((nNumberOfValues - 1) * dEntropy + 0.5);
				dEntropy = GetSignEntropy(a2ndDPCMValues, nNumberOfValues, 2, nCount);
				n2nd_ExpectedBits += (int) (nCount * dEntropy + 0.5);

				// (Intra Coding)
				n2nd_ExpectedBits += 2*nQBit;
			}
			else
			{
				dEntropy = GetEntropy(a2ndDPCMValues, nNumberOfValues, nQBit, 0);
				n2nd_ExpectedBits = (int) ((nNumberOfValues - 1) * dEntropy + 0.5);
				dEntropy = GetSignEntropy(a2ndDPCMValues, nNumberOfValues, 0, nCount);
				n2nd_ExpectedBits += (int) (nCount * dEntropy + 0.5);
			}
		}

		bIs1stDPCM = n1st_ExpectedBits <= n2nd_ExpectedBits;
		*/
		break;

	case '1':
		bIs1stDPCM = true;
		break;

	case '2':
		bIs1stDPCM = false;
		break;
	}


	//////////////////////////////////////////////////////////////////////////////////
	//
	//	ù° ι°  intra coding ΰ?
	//
	//////////////////////////////////////////////////////////////////////////////////
	// ̰ ٽѹ  .
	if(nStart >= 1)
		bIsIntra = (bIs1stDPCM)? bIs1st_Intra: bIs2nd_Intra;
	else
		bIsIntra = false;

	// 3.  
	return (bIs1stDPCM == true)? 0: 1;
}



void DPCM_CircularQuantize(JWArray<int>& aValues, int nMax, int nStart)
{
	int nSize = aValues.GetSize();
	int nValue, nCircularValue;
	int nPrevValue;

	int* aFinalValues = new int[nSize];

	if(nStart == 0)
	{
		nPrevValue = 0;
	}
	else // if(nStart > 0)
	{
		aFinalValues[0] = aValues[0];
		nPrevValue = aValues[0];

		nStart = 1;
	}

	for(int i=nStart; i<nSize; i++)
	{
		nValue = aValues[i] - nPrevValue;

		// ,
		if(nValue >= 0)
			nCircularValue = nValue - (nMax + 1);
		else
			nCircularValue = nValue + (nMax + 1);

		//   Ѵ.
		if(abs(nValue) > abs(nCircularValue))
			nValue = nCircularValue;
		else if(abs(nValue) == abs(nCircularValue))
			nValue = abs(nValue);

		nPrevValue = aValues[i];
		aFinalValues[i] = nValue;
	}

	for(i=0; i<nSize; i++)
		aValues[i] = aFinalValues[i];

	delete[] aFinalValues;
}

void DPCM_CircularQuantize(
	JWArray<int>& aValues, JWArray<int>& aFinalValues, int nMax, int nStart)
{
	int nValue, nCircularValue;
	int nPrevValue;
	int nSize = aValues.GetSize();

	if(nStart == 0)
	{
		nPrevValue = 0;
	}
	else // if(nStart > 0)
	{
		aFinalValues[0] = aValues[0];
		nPrevValue = aFinalValues[0];

		nStart = 1;
	}

	for(int i=nStart; i<nSize; i++)
	{
		nValue = aValues[i] - nPrevValue;

		// ,
		if(nValue >= 0)
			nCircularValue = nValue - (nMax + 1);
		else
			nCircularValue = nValue + (nMax + 1);

		//   Ѵ.
		if(abs(nValue) > abs(nCircularValue))
			nValue = nCircularValue;
		else if(abs(nValue) == abs(nCircularValue))
			nValue = abs(nValue);

		nPrevValue = aValues[i];
		aFinalValues[i] = nValue;
	}
}

void Second_DPCM_CircularQuantize(JWArray<int>& aValues, int nMax, int nStart)
{
	int nSize = aValues.GetSize();
	int nValue, nCircularValue;
	int nPredValue, nDiffValue, nPrevValue;

	int* aFinalValues = new int[nSize];

	if(nStart == 0)
	{
		nPrevValue = 0;
		nDiffValue = 0;
	}
	else// if(nStart == 1)
	{
		aFinalValues[0] = aValues[0];

		nPrevValue = aValues[0];
		nDiffValue = aValues[0];

		nStart = 1;
	}

	for(int i=nStart; i<nSize; i++)
	{
		nPredValue = nDiffValue + nPrevValue;

		// 1. Smart 2nd DPCM
		if(nPredValue > nMax)
			nValue = nMax - aValues[i];
		else if (nPredValue < 0)
			nValue = aValues[i];
		else
			nValue = aValues[i] - nPredValue;


		// ,
		if(nValue >= 0)
			nCircularValue = nValue - (nMax + 1);
		else
			nCircularValue = nValue + (nMax + 1);

		//   Ѵ.
		if(abs(nValue) > abs(nCircularValue))
			nValue = nCircularValue;
		else if(abs(nValue) == abs(nCircularValue))
			nValue = abs(nValue);

		nDiffValue = aValues[i] - nPrevValue;
		nPrevValue = aValues[i];

		aFinalValues[i] = nValue;
	}


	for(i=0; i<nSize; i++)
		aValues[i] = aFinalValues[i];

	delete [] aFinalValues;
}


void Second_DPCM_CircularQuantize(
	JWArray<int>& aValues, JWArray<int>& aFinalValues, int nMax, int nStart)
{
	int nSize = aValues.GetSize();

	int nValue, nCircularValue;
	int nPredValue, nDiffValue, nPrevValue;

	if(nStart == 0)
	{
		nPrevValue = 0;
		nDiffValue = 0;
	}
	else // if(nStart > 0)
	{
		aFinalValues[0] = aValues[0];
		aFinalValues[1] = aValues[1];

		nPrevValue = aValues[1];
		nDiffValue = aValues[1] - aValues[0];

		nStart = 2;
	}

	for(int i=nStart; i<nSize; i++)
	{
		nPredValue = nDiffValue + nPrevValue;

		// 1. Smart 2nd DPCM
		if(nPredValue > nMax)
			nValue = nMax - aValues[i];
		else if (nPredValue < 0)
			nValue = aValues[i];
		else
			nValue = aValues[i] - nPredValue;

		// ,
		if(nValue >= 0)
			nCircularValue = nValue - (nMax + 1);
		else
			nCircularValue = nValue + (nMax + 1);

		//   Ѵ.
		if(abs(nValue) > abs(nCircularValue))
			nValue = nCircularValue;
		else if(abs(nValue) == abs(nCircularValue))
			nValue = abs(nValue);

		nDiffValue = aValues[i] - nPrevValue;
		nPrevValue = aValues[i];

		aFinalValues[i] = nValue;
	}
}


int GetDigit(double dValue)
{
	//////////////////////////////////////////////////
	//
	//			Original Value 7ڸ !!!
	//			꿡 ؼ   
	//
	//////////////////////////////////////////////////

	char buffer[50];
	_gcvt(dValue, cnMAX_DIGIT, buffer);
	dValue = atof(buffer);

	//
	//////////////////////////////////////////////////

	// "0.0"  ڸ̴.
	if(dValue == 0.0)
		return 0;

	int nFirstDigit, nLastDigit;

	nFirstDigit = GetLeadingZero(dValue);
	nLastDigit = GetLargestDigit(dValue);

	int nDigit = nLastDigit - nFirstDigit;

	// 7 ū    .
	//  floating-point number ϴ ȿڸ 6~7!
	// ƴ,  ̻   .
	return (nDigit > cnMAX_DIGIT)? cnMAX_DIGIT: nDigit;
}

int GetMantissa(double dValue, int nDigit)
{
	char* buffer;
	int nDummy1 = 0, nDummy2 = 0;

	buffer = _ecvt(dValue, nDigit, &nDummy1, &nDummy2);

	return ::atoi(buffer);
}

int GetLargestDigit(double key)
{
	//////////////////////////////////////////////////
	//
	//			Original Value 7ڸ !!!
	//			꿡 ؼ   
	//
	//////////////////////////////////////////////////

	char buffer[50];
	_gcvt(key, cnMAX_DIGIT, buffer);
	key = atof(buffer);

	//
	//////////////////////////////////////////////////

	double a;
	__int64 mult;
	double dmult;
	__int64 Ia;
	double e = dEPSILONERROR;
	int nLargestDigit;

	mult=1; dmult=0.1;
	nLargestDigit = 0;

	a = fabs(key);
	Ia = (__int64) (a + mult*e);

	// sowoo 2001.10.11 (Digit   ϱ)
	// "0.1" binary ǥ ⶧ ǵ  ʴ  .
	// 0.1 ϴ  ſ 10  scheme !
	if(a == 0.0)
		return 1;

	double dTemp = a - (double)Ia;

	if((dTemp == 0.0) || (dTemp < e))
	{
		while(true)
		{
			a = fabs(key);
			a *= dmult;
			Ia = (__int64) (a + e);
			dTemp = a - (double)Ia;

			if(dTemp > e)
				return nLargestDigit;

			dmult *= 0.1;
			nLargestDigit--;
		}
	}

	//while(a - (double) Ia > e*mult)
	while(dTemp > e*mult)
	{
		mult*=10;
		nLargestDigit++;
		a = fabs(key);
		a=(double) mult *a;
		Ia = (__int64) (a + mult*e);
		dTemp = a - (double)Ia;
	}

	return nLargestDigit;
}

int GetLeadingZero(double key)
{
	//////////////////////////////////////////////////
	//
	//			Original Value 7ڸ !!!
	//			꿡 ؼ   
	//
	//////////////////////////////////////////////////

	char buffer[50];
	_gcvt(key, cnMAX_DIGIT, buffer);
	key = atof(buffer);

	//
	//////////////////////////////////////////////////

	double a;
	double e = dEPSILONERROR;
	__int64 nMulti = 10;
	double dMulti = 0.1;
	int nCount = 0;

	double dTemp;

	// 1. 켱  ٲٰ,
	a = fabs(key);

	// 2. 0̰ų 0.1 ũ տ "0" .
	if(a >= 1.0)
	{
		nCount++;
		while(a*dMulti >= 1.0)
		{
			nCount++;
			dMulti *= 0.1;
		}

		return -nCount;
	}
	else if(a == 0.0)
		return 0;
	else if(a >= 0.1)
		return 0;
	else
	{
		nCount++;
		dTemp = a * nMulti;
		_gcvt(dTemp, 7, buffer);
		dTemp = ::atof(buffer);

		//while(a*nMulti < 0.1)
		while( dTemp < 0.1)
		{
			nCount++;
			nMulti *= 10;
			dTemp = a * nMulti;
			_gcvt(dTemp, 7, buffer);
			dTemp = ::atof(buffer);
		}

		return nCount;
	}
}


// sowoo 2001.10.15 (Circular Quantize)
int GetRealQBit(JWArray<int>& paValues, int nStart)
{
	int nSize = paValues.GetSize();
	int nMax = -INT_MAX;

	for(int i=nStart; i<nSize; i++)
	{
		if(nMax < abs(paValues[i]))
			nMax = abs(paValues[i]);
	}

	// ó Ͱ ٸ, QBit  ʿ䰡 .
	if(nMax == -INT_MAX)
		return 0;

	int nRealQBit = (int)(log(nMax)/log(2)) + 1;
	int nTest = (int) pow(2, nRealQBit);

	if(nTest == nMax)
		nRealQBit++;

	return nRealQBit;
}



void DeQuantize(
	int* aQuantValues,
	int nSize,
	int nQBit,
	double dMin, double dMax, 
	double* aDeQuantValues
)
{
	for(int i=0; i<nSize; i++)
	{
		aDeQuantValues[i] = aQuantValues[i]*(dMax - dMin)/(::pow(2, nQBit) - 1) + dMin;
	}
}


// sowoo 2002.02.04
void DeQuantize(
	JWArray<int>& aQuantValues,
	int nQBit,
	double dMin, double dMax, 
	JWArray<double>& aDeQuantValues
)
{
	int nSize = aQuantValues.GetSize();

	for(int i=0; i<nSize; i++)
	{
		aDeQuantValues[i] = aQuantValues[i]*(dMax - dMin)/(::pow(2, nQBit) - 1) + dMin;
	}
}




double QuantizationError(double* aValues, int nSize, double* aDeQuantValues)
{
	double a, b;
	double abs_a, abs_b;
	double dArea;
	double dTotalArea = 0, dPeakError = -DBL_MAX;

	double lamda = 0.0;

	for(int i=1; i<nSize; i++)
	{
		a = aValues[i-1] -  aDeQuantValues[i-1];
		b = aValues[i] - aDeQuantValues[i-1];

		abs_a = fabs(a);
		abs_b = fabs(b);

		if(a == 0.0 && b == 0.0)
			dArea = 0.0;
		else if(a*b > 0)
			// ٸ
			dArea = 0.5*(abs_a + abs_b);
		else
			// ġ
			dArea = 0.5*(abs_a*abs_a + abs_b*abs_b) / (abs_a + abs_b);

		if(dPeakError < abs_a)
			dPeakError = abs_a;
		if(dPeakError < abs_b)
			dPeakError = abs_b;

		dTotalArea += dArea;
	}

	return dTotalArea + lamda*dPeakError;
}



double QuantizationError(
	double* aDeQuantValues, JWArray<double>& aValues,

	// Key Ͽ  Ѵ.
	double* aDeQuantKeys, JWArray<double>& aKeys
)
{
	JWPositionInterpolator interpolatorOri;
	JWPositionInterpolator interpolatorDeQuant;

	SFVec3f tempKV;

	for(int i=0; i<aKeys.GetSize(); i++)
	{
		tempKV.x = aValues[i];
		tempKV.y = 0;
		tempKV.z = 0;

		interpolatorOri.Add(aKeys[i], (void*) &tempKV);

		tempKV.x = aDeQuantValues[i];
		tempKV.y = 0;
		tempKV.z = 0;

		interpolatorDeQuant.Add(aDeQuantKeys[i], (void*) &tempKV);
	}


	CSInterpolator* pInterpolator1 = new CSPositionInterpolator;
	CSInterpolator* pInterpolator2 = new CSPositionInterpolator;

	// We need converter JWPosition -> CSPosition
	Convert(pInterpolator1, &interpolatorOri);
	Convert(pInterpolator2, &interpolatorDeQuant);


	// 2001.08.08
	// 2.  ģ.
	pInterpolator1->InsertPointWith(pInterpolator2);
	pInterpolator2->InsertPointWith(pInterpolator1);


	CSError error;

	// 3.   Error Ѵ.
	EstimateError(pInterpolator1, pInterpolator2, error, 3); //::atoi(argv[4]));


	delete pInterpolator1;
	delete pInterpolator2;

	return error.rms;
}




double QuantizationError(double* aDeQuantValues, JWArray<double>& aValues)
{
	int nSize = aValues.GetSize();

	double a, b;
	double abs_a, abs_b;
	double dArea;
	double dTotalArea = 0, dPeakError = -DBL_MAX;

	double lamda = 0.0;

	for(int i=1; i<nSize; i++)
	{
		a = aValues[i-1] -  aDeQuantValues[i-1];
		b = aValues[i] - aDeQuantValues[i];

		abs_a = fabs(a);
		abs_b = fabs(b);

		if(a == 0.0 && b == 0.0)
			dArea = 0.0;
		else if(a*b > 0)
			// ٸ
			dArea = 0.5*(abs_a + abs_b);
		else
			// ġ
			dArea = 0.5*(abs_a*abs_a + abs_b*abs_b) / (abs_a + abs_b);

		if(dPeakError < abs_a)
			dPeakError = abs_a;
		if(dPeakError < abs_b)
			dPeakError = abs_b;

		dTotalArea += dArea;
	}

	return dTotalArea + lamda*dPeakError;
}





int GetMax(int* aValues, int nSize, int nStart)
{
	int nMax = -INT_MAX;

	for(int i=nStart; i<nSize; i++)
	{
		if(nMax < abs(aValues[i]))
			nMax = abs(aValues[i]);
	}

	return nMax;
}

int GetMin(int* aValues, int nSize, int nStart)
{
	int nMin = INT_MAX;

	for(int i=nStart; i<nSize; i++)
	{
		if(nMin > abs(aValues[i]))
			nMin = abs(aValues[i]);
	}

	return nMin;
}

int GetMax(JWArray<int>& aValues, int nStart)
{
	int nSize = aValues.GetSize();
	int nMax = -INT_MAX;

	for(int i=nStart; i<nSize; i++)
	{
		if(nMax < abs(aValues[i]))
			nMax = abs(aValues[i]);
	}

	return nMax;
}

int GetMin(JWArray<int>& aValues, int nStart)
{
	int nSize = aValues.GetSize();
	int nMin = INT_MAX;

	for(int i=nStart; i<nSize; i++)
	{
		if(nMin > abs(aValues[i]))
			nMin = abs(aValues[i]);
	}

	return nMin;
}



void Convert(CSInterpolator* pInterp1, JWInterpolator* pInterp2)
{
	MFFloat tempKeys;
	MFVec3f tempKeyValues;

	tempKeys.Initialize();
	tempKeyValues.Initialize();

	tempKeys.Copy(pInterp2->GetKeys());
	tempKeyValues.Copy(*((MFVec3f*) pInterp2->GetKeyValues()));

	pInterp1->SetKeys(tempKeys);
	pInterp1->SetKeyValues((void*) &tempKeyValues);

}



void EstimateError(
	CSInterpolator* pInterp1, CSInterpolator* pInterp2,
	CSError& error,
	int nNorm_type)
{
	double a, b, h;
	double abs_a, abs_b;
	int size = pInterp1->GetKeys().GetSize();
	double dArea, dTotalArea_X = 0.0, dTotalArea_Y = 0.0, dTotalArea_Z = 0.0;
	double dPeakArea = -DBL_MAX;
	double
		dMin_X = DBL_MAX, dMax_X = -DBL_MAX,
		dMin_Y = DBL_MAX, dMax_Y = -DBL_MAX,
		dMin_Z = DBL_MAX, dMax_Z = -DBL_MAX;


	MFFloat& rKey1 = pInterp1->GetKeys();
	MFFloat& rKey2 = pInterp2->GetKeys();
	MFVec3f& rKeyValues1 = *((MFVec3f*) pInterp1->GetKeyValues());
	MFVec3f& rKeyValues2 = *((MFVec3f*) pInterp2->GetKeyValues());



//ofstream file;
//file.open("LookAtError.txt");


	for(int i=0; i<size; i++)
	{
		/////////////////////////////////////////////
		// X, Y, Z Min/Max ã´.
		/////////////////////////////////////////////

		if(dMin_X > rKeyValues1[i].x)
			dMin_X = rKeyValues1[i].x;
		if(dMax_X < rKeyValues1[i].x)
			dMax_X = rKeyValues1[i].x;

		if(dMin_Y > rKeyValues1[i].y)
			dMin_Y = rKeyValues1[i].y;
		if(dMax_Y < rKeyValues1[i].y)
			dMax_Y = rKeyValues1[i].y;

		if(dMin_Z > rKeyValues1[i].z)
			dMin_Z = rKeyValues1[i].z;
		if(dMax_Z < rKeyValues1[i].z)
			dMax_Z = rKeyValues1[i].z;

		// Min/Max ϴ κп .
		if(i == size-1)
			break;


		/////////////////////////////////////////////
		// ̸ Ѵ.
		/////////////////////////////////////////////

		h = rKey1[i+1] - rKey1[i];

		// ̰ ٸ,  !
		if(h == 0.0)
			continue;


		/////////////////////////////////////////////
		// X
		/////////////////////////////////////////////

		a = rKeyValues1[i].x - rKeyValues2[i].x;
		b = rKeyValues1[i+1].x - rKeyValues2[i+1].x;

		abs_a = fabs(a);
		abs_b = fabs(b);

		if(a == 0.0 && b == 0.0)
			dArea = 0.0;
		else if(a*b > 0)
			// ٸ
			dArea = 0.5*(abs_a + abs_b)*h;
		else
			// ġ
			dArea = 0.5*(abs_a*abs_a + abs_b*abs_b)*h / (abs_a + abs_b);

		if(dPeakArea < abs_a)
			dPeakArea = abs_a;
		if(dPeakArea < abs_b)
			dPeakArea = abs_b;

		dTotalArea_X += dArea;



/*
file << rKey1[i] << '\t';
file << rKey1[i+1] << '\t';
file << rKeyValues1[i].x << '\t';
file << rKeyValues2[i].x << '\t';
file << dArea << endl;
*/
		/////////////////////////////////////////////
		// Y
		/////////////////////////////////////////////

		a = rKeyValues1[i].y - rKeyValues2[i].y;
		b = rKeyValues1[i+1].y - rKeyValues2[i+1].y;

		abs_a = fabs(a);
		abs_b = fabs(b);

		if(a == 0.0 && b == 0.0)
			dArea = 0.0;
		else if(a*b > 0)
			// ٸ
			dArea = 0.5*(abs_a + abs_b)*h;
		else
			// ġ
			dArea = 0.5*(abs_a*abs_a + abs_b*abs_b)*h/(abs_a+abs_b);

		if(dPeakArea < abs_a)
			dPeakArea = abs_a;
		if(dPeakArea < abs_b)
			dPeakArea = abs_b;

		dTotalArea_Y += dArea;


		/////////////////////////////////////////////
		// Z
		/////////////////////////////////////////////

		a = rKeyValues1[i].z - rKeyValues2[i].z;
		b = rKeyValues1[i+1].z - rKeyValues2[i+1].z;

		abs_a = fabs(a);
		abs_b = fabs(b);

		if(a == 0.0 && b == 0.0)
			dArea = 0.0;
		else if(a*b > 0)
			// ٸ
			dArea = 0.5*(abs_a+abs_b)*h;
		else
			// ġ
			dArea = 0.5*(abs_a*abs_a + abs_b*abs_b)*h/(abs_a+abs_b);

		if(dPeakArea < abs_a)
			dPeakArea = abs_a;
		if(dPeakArea < abs_b)
			dPeakArea = abs_b;

		dTotalArea_Z += dArea;
	}



//file.close();

	/////////////////////////////////////////////
	// Normalize
	/////////////////////////////////////////////
	double
		dDiff_Max = fabs(dMax_X - dMin_X),
		dDiff_Y = fabs(dMax_Y - dMin_Y),
		dDiff_Z = fabs(dMax_Z - dMin_Z);

	if(dDiff_Max < dDiff_Y)
		dDiff_Max = dDiff_Y;
	if(dDiff_Max < dDiff_Z)
		dDiff_Max = dDiff_Z;

	double dNormFactor = 3 * (rKey1[rKey1.GetSize()-1] - rKey1[0]) * dDiff_Max;

	if(dDiff_Max == 0.0 || dNormFactor == 0.0)
	{
		error.rms = 0.0;
		error.peak = 0.0;
	}
	else
	{
		error.rms = (dTotalArea_X + dTotalArea_Y + dTotalArea_Z) / dNormFactor;
		error.peak = dPeakArea / dDiff_Max;
	}
}



// sowoo 2001.10.12 (Min/Max Reduce)
void EncodeReducedMinMaxData(
	CAC_QF& codec, 
	double dXMin, double dYMin, double dZMin,
	double fMaxDiff,

	// sowoo 2001.11.24
	// ̹  KeyValueDigit  digit   ʴ´.
	int nKeyValueDigit,
	int nWhichAxis
)
{
	int nUsedBits = AACTotal_ENC();
	int nHeaderBits, nXMinBits, nYMinBits, nZMinBits, nDiffBits;
	int nBits;

	/////////////////////////////////////////////////
	//
	// Part 1. ʿ  Ѵ.
	//
	/////////////////////////////////////////////////

	// 1. Mantissa Digit(x, y, z) Ѵ.
	int nX_MantissaDigit, nY_MantissaDigit, nZ_MantissaDigit, nDiff_MantissaDigit;

	nX_MantissaDigit = GetDigit(dXMin);
	nY_MantissaDigit = GetDigit(dYMin);
	nZ_MantissaDigit = GetDigit(dZMin);
	nDiff_MantissaDigit = GetDigit(fMaxDiff);



	///////////////////////////////////////////////////
	//
	//	ҸǴ bit Ͽ 128̸̻,
	//	  .
	//
	///////////////////////////////////////////////////
	if(GetTotalMinMaxBits(
		nX_MantissaDigit, nY_MantissaDigit, nZ_MantissaDigit,
		nDiff_MantissaDigit) > 128)
	{
		// PDAM4
			// 0 1 ȯ
		codec._ostrm->putbit(1);

		float fTemp;

		fTemp = (float) dXMin;
		codec._ostrm->putbits(*((int*)&fTemp), 32);

		fTemp = (float) dYMin;
		codec._ostrm->putbits(*((int*)&fTemp), 32);

		fTemp = (float) dZMin;
		codec._ostrm->putbits(*((int*)&fTemp), 32);


		switch(nWhichAxis){
		case 0: // X
			fMaxDiff = fMaxDiff - dXMin;
			break;
		case 1: // Y
			fMaxDiff = fMaxDiff - dYMin;
			break;
		case 2: // Z
			fMaxDiff = fMaxDiff - dZMin;
			break;
		}

		fTemp = (float) fMaxDiff;
		codec._ostrm->putbits(*((int*)&fTemp), 32);


		return ;
	}
	else
	{
		// PDAM4
			// 0 1 ȯ...
		codec._ostrm->putbit(0);
	}



	// 3.1.0   max ?
	codec._ostrm->putbits(nWhichAxis, 2);




	bool bNeedDiffDigit = true;

	switch(nWhichAxis) {
	case 0: // X
		if(nDiff_MantissaDigit == nX_MantissaDigit)
		{
			bNeedDiffDigit = false;
			nDiff_MantissaDigit = nX_MantissaDigit;
		}
		break;
	case 1: // Y
		if(nDiff_MantissaDigit == nY_MantissaDigit)
		{
			bNeedDiffDigit = false;
			nDiff_MantissaDigit = nY_MantissaDigit;
		}
		break;
	case 2: // Z
		if(nDiff_MantissaDigit == nZ_MantissaDigit)
		{
			bNeedDiffDigit = false;
			nDiff_MantissaDigit = nZ_MantissaDigit;
		}
		break;
	}

	// 2. Exponent Digit Sign  Ѵ.
	int nX_ExponentDigit, nY_ExponentDigit, nZ_ExponentDigit, nDiff_ExponentDigit;
	int nX_ExponentSign, nY_ExponentSign, nZ_ExponentSign, nDiff_ExponentSign;

	nX_ExponentDigit = GetLargestDigit(dXMin);
	nY_ExponentDigit = GetLargestDigit(dYMin);
	nZ_ExponentDigit = GetLargestDigit(dZMin);
	nDiff_ExponentDigit = GetLargestDigit(fMaxDiff);

	nX_ExponentSign = (nX_ExponentDigit < 0)? 1: 0;
	nY_ExponentSign = (nY_ExponentDigit < 0)? 1: 0;
	nZ_ExponentSign = (nZ_ExponentDigit < 0)? 1: 0;
	nDiff_ExponentSign = (nDiff_ExponentDigit < 0)? 1: 0;


	/////////////////////////////////////////////////
	//
	// Part 2.   EncodingѴ.
	//
	/////////////////////////////////////////////////

	// 3. Float-Point Number ڵѴ.

nHeaderBits = AACTotal_ENC();
	// 3.1 [Header Coding *******************************************]

	// 3.1.1   Digit ϴ°?
	bool bAllSameDigit = false;

	GetDigitBits(nX_MantissaDigit, nY_MantissaDigit, nZ_MantissaDigit, bAllSameDigit);

	codec._ostrm->putbit((bAllSameDigit)? 1: 0);

	// 3.1.2  Digit ƴϸ, Digit ش.
	if(bAllSameDigit)
	{
		if(nKeyValueDigit == nX_MantissaDigit)
		{
			codec._ostrm->putbit(1);
		}
		else
		{
			codec._ostrm->putbit(0);
			//codec._ostrm->putbits(nX_MantissaDigit, 3);
			codec._ostrm->putbits(nX_MantissaDigit, 4);
		}

		nY_MantissaDigit = nX_MantissaDigit;
		nZ_MantissaDigit = nX_MantissaDigit;
	}
	else
	{
		//codec._ostrm->putbits(nX_MantissaDigit, 3);
		//codec._ostrm->putbits(nY_MantissaDigit, 3);
		//codec._ostrm->putbits(nZ_MantissaDigit, 3);
		codec._ostrm->putbits(nX_MantissaDigit, 4);
		codec._ostrm->putbits(nY_MantissaDigit, 4);
		codec._ostrm->putbits(nZ_MantissaDigit, 4);
	}

	// 3.1.2.1
	// Digit ̰ 2̸̻ Diff Digit  .
	// 2̸̻ 2bit̻ ̵   ִ.
	if(bNeedDiffDigit)
	{
		codec._ostrm->putbit(1);
		//codec._ostrm->putbits(nDiff_MantissaDigit, 3);
		codec._ostrm->putbits(nDiff_MantissaDigit, 4);
	}
	else
	{
		codec._ostrm->putbit(0);
		//nDiff_MantissaDigit = nX_MantissaDigit;
	}

	// 3.1.3 Exponent Digit
	int nLargestExponentDigit = abs(nX_ExponentDigit);

	if(nLargestExponentDigit < abs(nY_ExponentDigit))
		nLargestExponentDigit = abs(nY_ExponentDigit);
	if(nLargestExponentDigit < abs(nZ_ExponentDigit))
		nLargestExponentDigit = abs(nZ_ExponentDigit);
	if(nLargestExponentDigit < abs(nDiff_ExponentDigit))
		nLargestExponentDigit = abs(nDiff_ExponentDigit);

	// [0 ~ 38]   CodingϹǷ 6 bit
	codec._ostrm->putbits(nLargestExponentDigit, 6);

	// 3.1.4 Exponent Sign  ?
	bool bAllSameSign = false;

	if(nX_ExponentSign == nY_ExponentSign)
	{
		if(nX_ExponentSign == nZ_ExponentSign)
		{
			if(nX_ExponentSign == nDiff_ExponentSign)
			{
				bAllSameSign = true;
			}
		}
	}

	if(bAllSameSign)
	{
		//   Sign̴.
		codec._ostrm->putbit(1);

		//   sign Ѵ.
		codec._ostrm->putbit(nX_ExponentSign);
	}
	else
	{
		//   Sign ƴϴ.
		codec._ostrm->putbit(0);
	}
nHeaderBits = AACTotal_ENC() - nHeaderBits;


nXMinBits = AACTotal_ENC();
	// 3.2 [X MIN *******************************************]

	int nMantissa;
	int nExponent;

	// digit '0'̶  0.0 en/decoding϶ !
	if(nX_MantissaDigit != 0)
	{
		// 3.2.1 Sign Coding
		codec._ostrm->putbit((dXMin < 0)? 1: 0);

		// 3.2.2 Mantissa Coding
		nExponent = GetLargestDigit(dXMin);

		nMantissa = GetMantissa(dXMin, nX_MantissaDigit);
		nBits = (int) (log(pow(10, nX_MantissaDigit) - 1)/log(2) + 1);

		if(nMantissa < 0)
			nMantissa = -nMantissa;
		codec._ostrm->putbits(nMantissa, nBits);

		// 3.2.3 Exponent Coding
		nBits = getNbBits(nLargestExponentDigit);
		codec._ostrm->putbits(abs(nExponent), nBits);

		if(!bAllSameSign)
			codec._ostrm->putbit(nX_ExponentSign);
	}

nXMinBits = AACTotal_ENC() - nXMinBits;

nYMinBits = AACTotal_ENC();
	// 3.3 [Y MIN *******************************************]

	// digit '0'̶  0.0 en/decoding϶ !
	if(nY_MantissaDigit != 0)
	{
		// 3.3.1 Sign Coding
		codec._ostrm->putbit((dYMin < 0)? 1: 0);

		nExponent = GetLargestDigit(dYMin);

		// 3.3.2 Mantissa Coding
		nMantissa = GetMantissa(dYMin, nY_MantissaDigit);
		nBits = (int) (log(pow(10, nY_MantissaDigit) - 1)/log(2) + 1);

		if(nMantissa < 0)
			nMantissa = -nMantissa;
		codec._ostrm->putbits(nMantissa, nBits);

		// 3.3.3 Exponent Coding

		nBits = getNbBits(nLargestExponentDigit);
		codec._ostrm->putbits(abs(nExponent), nBits);

		if(!bAllSameSign)
			codec._ostrm->putbit(nY_ExponentSign);
	}

nYMinBits = AACTotal_ENC() - nYMinBits;

nZMinBits = AACTotal_ENC();
	// 3.4 [Z MIN *******************************************]

	// digit '0'̶  0.0 en/decoding϶ !
	if(nZ_MantissaDigit != 0)
	{
		// 3.4.1 Sign Coding
		codec._ostrm->putbit((dZMin < 0)? 1: 0);

		nExponent = GetLargestDigit(dZMin);

		// 3.4.2 Mantissa Coding
		nMantissa = GetMantissa(dZMin, nZ_MantissaDigit);
		nBits = (int) (log(pow(10, nZ_MantissaDigit) - 1)/log(2) + 1);

		if(nMantissa < 0)
			nMantissa = -nMantissa;
		codec._ostrm->putbits(nMantissa, nBits);

		// 3.4.3 Exponent Coding

		nBits = getNbBits(nLargestExponentDigit);
		codec._ostrm->putbits(abs(nExponent), nBits);

		if(!bAllSameSign)
			codec._ostrm->putbit(nZ_ExponentSign);
	}

nZMinBits = AACTotal_ENC() - nZMinBits;

nDiffBits = AACTotal_ENC();
	// 3.4 [Max Diff *******************************************]

	// digit '0'̶  0.0 en/decoding϶ !
	if(nDiff_MantissaDigit != 0)
	{
		// 3.4.1 Sign Coding
		codec._ostrm->putbit((fMaxDiff < 0)? 1: 0);

		nExponent = GetLargestDigit((double)fMaxDiff);

		// 3.4.2 Mantissa Coding
		nMantissa = GetMantissa(fMaxDiff, nDiff_MantissaDigit);
		nBits = (int) (log(pow(10, nDiff_MantissaDigit) - 1)/log(2) + 1);

		if(nMantissa < 0)
			nMantissa = -nMantissa;
		codec._ostrm->putbits(nMantissa, nBits);

		// 3.4.3 Exponent Coding

		nBits = getNbBits(nLargestExponentDigit);
		codec._ostrm->putbits(abs(nExponent), nBits);

		if(!bAllSameSign)
			codec._ostrm->putbit(nDiff_ExponentSign);
	}

nDiffBits = AACTotal_ENC() - nDiffBits;

nUsedBits = AACTotal_ENC() - nUsedBits;


//////////////////////////////////////////////////////////////
//
//				ϴ κ
//
//////////////////////////////////////////////////////////////

/*ofstream file;
file.open("MINMAX.TXT", ios::app);

//file << argv[2] << '\t';
file << dXMin << '\t';
file << dYMin << '\t';
file << dZMin << '\t';
file << fMaxDiff << '\t';
file << GetDigit(dXMin) << '\t';
file << nY_MantissaDigit << '\t';
file << nZ_MantissaDigit << '\t';
file << nDiff_MantissaDigit << '\t';
file << nHeaderBits << '\t';
file << nXMinBits << '\t';
file << nYMinBits << '\t';
file << nZMinBits << '\t';
file << nDiffBits << '\t';
file << 128 << '\t';
file << nUsedBits << endl;

file.close();

////////////////////////////////////////////
// 
// Verity Routine
//
////////////////////////////////////////////
/*
ofstream fileV;
fileV.open("VerifyMinMax.Encoder", ios::app);

fileV << dXMin << '\t';
fileV << dYMin << '\t';
fileV << dZMin << '\t';
fileV << fMaxDiff << endl;
*/
//
////////////////////////////////////////////

//exit(0);




	///////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////
	// __> to file
	ofstream file;
	file.open("PosIKVHeader_Encoder.txt", ios::app);


	if(GetTotalMinMaxBits(
		nX_MantissaDigit, nY_MantissaDigit, nZ_MantissaDigit,
		nDiff_MantissaDigit) > 128)
	{
		// PDAM4
			// 0 1 ȯ
		//codec._ostrm->putbit(1);
		file << "bUse32Float: " << 1 << endl;

		//float fTemp;

		//fTemp = (float) dXMin;
		//codec._ostrm->putbits(*((int*)&fTemp), 32);
		file << "dXMin: " << dXMin << endl;

		//fTemp = (float) dYMin;
		//codec._ostrm->putbits(*((int*)&fTemp), 32);
		file << "dYMin: " << dYMin << endl;

		//fTemp = (float) dZMin;
		//codec._ostrm->putbits(*((int*)&fTemp), 32);
		file << "dZMin: " << dZMin << endl;

		//fTemp = (float) fMaxDiff;
		//codec._ostrm->putbits(*((int*)&fTemp), 32);
		file << "fMaxDiff: " << fMaxDiff << endl;

		return ;
	}
	else
	{
		// PDAM4
			// 0 1 ȯ...
		//codec._ostrm->putbit(0);
		file << "bUse32Float: " << 0 << endl;
	}



	// 3.1.0   max ?
	//codec._ostrm->putbits(nWhichAxis, 2);
	file << "nWhichAxis: " << nWhichAxis << endl;

	//codec._ostrm->putbit((bAllSameDigit)? 1: 0);
	file << "bAllSameDigit: " << bAllSameDigit << endl;

	// 3.1.2  Digit ƴϸ, Digit ش.
	if(bAllSameDigit)
	{
		if(nKeyValueDigit == nX_MantissaDigit)
		{
			//codec._ostrm->putbit(1);
			file << "bSameDigit: " << 1 << endl;
		}
		else
		{
			//codec._ostrm->putbit(0);
			file << "bSameDigit: " << 0 << endl;
			//codec._ostrm->putbits(nX_MantissaDigit, 3);
			//codec._ostrm->putbits(nX_MantissaDigit, 4);
			file << "nX_MantissaDigit: " << nX_MantissaDigit << endl;
		}

		nY_MantissaDigit = nX_MantissaDigit;
		nZ_MantissaDigit = nX_MantissaDigit;
	}
	else
	{
		//codec._ostrm->putbits(nX_MantissaDigit, 3);
		//codec._ostrm->putbits(nY_MantissaDigit, 3);
		//codec._ostrm->putbits(nZ_MantissaDigit, 3);

		//codec._ostrm->putbits(nX_MantissaDigit, 4);
		file << "nX_MantissaDigit: " << nX_MantissaDigit << endl;

		//codec._ostrm->putbits(nY_MantissaDigit, 4);
		file << "nY_MantissaDigit: " << nY_MantissaDigit << endl;

		//codec._ostrm->putbits(nZ_MantissaDigit, 4);
		file << "nZ_MantissaDigit: " << nZ_MantissaDigit << endl;
	}

	// 3.1.2.1
	// Digit ̰ 2̸̻ Diff Digit  .
	// 2̸̻ 2bit̻ ̵   ִ.
	if(bNeedDiffDigit)
	{
		//codec._ostrm->putbit(1);
		file << "bMaxDigitFlag: " << 1 << endl;

		//codec._ostrm->putbits(nDiff_MantissaDigit, 3);
		//codec._ostrm->putbits(nDiff_MantissaDigit, 4);
		file << "nDiff_MantissaDigit: " << nDiff_MantissaDigit << endl;
	}
	else
	{
		//codec._ostrm->putbit(0);
		file << "bMaxDigitFlag: " << 0 << endl;
		//nDiff_MantissaDigit = nX_MantissaDigit;
	}

	// [0 ~ 38]   CodingϹǷ 6 bit
	//codec._ostrm->putbits(nLargestExponentDigit, 6);
	file << "nLargestExponentDigit: " << getNbBits(nLargestExponentDigit) << endl;

	if(bAllSameSign)
	{
		//   Sign̴.
		// codec._ostrm->putbit(1);
		file << "bAllSameSign: " << 1 << endl;

		//   sign Ѵ.
		//codec._ostrm->putbit(nX_ExponentSign);
		file << "nX_ExponentSign: " << nX_ExponentSign << endl;
	}
	else
	{
		//   Sign ƴϴ.
		//codec._ostrm->putbit(0);
		file << "bAllSameSign: " << 0 << endl;
	}

	/*
	// digit '0'̶  0.0 en/decoding϶ !
	if(nX_MantissaDigit != 0)
	{
		// 3.2.1 Sign Coding
		//codec._ostrm->putbit((dXMin < 0)? 1: 0);
		if(dXMin >= 0)
			file << "nSign: " << 0 << endl;
		else
			file << "nSign: " << 1 << endl;

		// 3.2.2 Mantissa Coding
		//nExponent = GetLargestDigit(dXMin);

		//nMantissa = GetMantissa(dXMin, nX_MantissaDigit);
		//nBits = (int) (log(pow(10, nX_MantissaDigit) - 1)/log(2) + 1);

		//if(nMantissa < 0)
		//	nMantissa = -nMantissa;
		//codec._ostrm->putbits(nMantissa, nBits);


		// 3.2.3 Exponent Coding
		nBits = getNbBits(nLargestExponentDigit);
		codec._ostrm->putbits(abs(nExponent), nBits);

		if(!bAllSameSign)
			codec._ostrm->putbit(nX_ExponentSign);
	}

	// digit '0'̶  0.0 en/decoding϶ !
	if(nY_MantissaDigit != 0)
	{
		// 3.3.1 Sign Coding
		codec._ostrm->putbit((dYMin < 0)? 1: 0);

		nExponent = GetLargestDigit(dYMin);

		// 3.3.2 Mantissa Coding
		nMantissa = GetMantissa(dYMin, nY_MantissaDigit);
		nBits = (int) (log(pow(10, nY_MantissaDigit) - 1)/log(2) + 1);

		if(nMantissa < 0)
			nMantissa = -nMantissa;
		codec._ostrm->putbits(nMantissa, nBits);

		// 3.3.3 Exponent Coding

		nBits = getNbBits(nLargestExponentDigit);
		codec._ostrm->putbits(abs(nExponent), nBits);

		if(!bAllSameSign)
			codec._ostrm->putbit(nY_ExponentSign);
	}

	// digit '0'̶  0.0 en/decoding϶ !
	if(nZ_MantissaDigit != 0)
	{
		// 3.4.1 Sign Coding
		codec._ostrm->putbit((dZMin < 0)? 1: 0);

		nExponent = GetLargestDigit(dZMin);

		// 3.4.2 Mantissa Coding
		nMantissa = GetMantissa(dZMin, nZ_MantissaDigit);
		nBits = (int) (log(pow(10, nZ_MantissaDigit) - 1)/log(2) + 1);

		if(nMantissa < 0)
			nMantissa = -nMantissa;
		codec._ostrm->putbits(nMantissa, nBits);

		// 3.4.3 Exponent Coding

		nBits = getNbBits(nLargestExponentDigit);
		codec._ostrm->putbits(abs(nExponent), nBits);

		if(!bAllSameSign)
			codec._ostrm->putbit(nZ_ExponentSign);
	}

nZMinBits = AACTotal_ENC() - nZMinBits;

nDiffBits = AACTotal_ENC();
	// 3.4 [Max Diff *******************************************]

	// digit '0'̶  0.0 en/decoding϶ !
	if(nDiff_MantissaDigit != 0)
	{
		// 3.4.1 Sign Coding
		codec._ostrm->putbit((fMaxDiff < 0)? 1: 0);

		nExponent = GetLargestDigit((double)fMaxDiff);

		// 3.4.2 Mantissa Coding
		nMantissa = GetMantissa(fMaxDiff, nDiff_MantissaDigit);
		nBits = (int) (log(pow(10, nDiff_MantissaDigit) - 1)/log(2) + 1);

		if(nMantissa < 0)
			nMantissa = -nMantissa;
		codec._ostrm->putbits(nMantissa, nBits);

		// 3.4.3 Exponent Coding

		nBits = getNbBits(nLargestExponentDigit);
		codec._ostrm->putbits(abs(nExponent), nBits);

		if(!bAllSameSign)
			codec._ostrm->putbit(nDiff_ExponentSign);
	}
	*/
	file.close();
	////////////////////////////////////////////////////////////////
}


int GetTotalMinMaxBits(
	int nDigit_X, int nDigit_Y, int nDigit_Z,
	int nDigit_diff
)
{
	int nTemp;

	nTemp = 4 + (int) (log(pow(10, nDigit_X) - 1)/log(2) + 1) + 7;
	nTemp += 4 + (int) (log(pow(10, nDigit_Y) - 1)/log(2) + 1) + 7;
	nTemp += 4 + (int) (log(pow(10, nDigit_Z) - 1)/log(2) + 1) + 7;
	nTemp += 4 + (int) (log(pow(10, nDigit_diff) - 1)/log(2) + 1) + 7;

	return nTemp;
}


// sowoo 2001.10.11 (Min/Max Reduce)
//  Ȯ  ƴϴ.
int GetDigitBits(int nXDigit, int nYDigit, int nZDigit, bool& bIsOneDigit)
{
	int nBits;
	int nMaxDigit = nXDigit, nMinDigit = nXDigit;

	if(nMaxDigit < nYDigit)
		nMaxDigit = nYDigit;
	if(nMaxDigit < nZDigit)
		nMaxDigit = nZDigit;

	if(nMinDigit > nYDigit)
		nMinDigit = nYDigit;
	if(nMinDigit > nZDigit)
		nMinDigit = nZDigit;

	if(nMinDigit == nMaxDigit)
	{
		// 1.  digit !!!
		nBits = 1;
		bIsOneDigit = true;

		return nBits;
	}
	else
	{
		bIsOneDigit = false;

		return 1 + 3 + 3;
/*		int nDiffDigit = nMaxDigit - nMinDigit;

		// 2. digit   ̵ .   ʴ´.
		if(nDiffDigit == 1)
		{
			nBits = 1;
			bIsOneDigit = true;

			return nBits;
		}

		nBits = 1 + 3 + 3;
*/	}

	return nBits;
}






///////////////////////////////////////////////////////
// manjini 20010920 start : for successive quantization


void encodeData_SQ(CAC_QF& codec, int qstep, JWArray<int>& pdQ, int start)
{
	int keynum = pdQ.GetSize();

	//  kV  mid, min, max  found(bool)   (array)
	// AAC context : found_context, not_found_context, keyV_sign_context, max_val_context --> entropy.h & cpp 
	int* range_mid = new int[keynum];
	int* range_min = new int[keynum];
	int* range_max = new int[keynum];
	bool* found = new bool[keynum];
	int* sign = new int[keynum];

	CQF_Status::found_context.reset();
	CQF_Status::not_found_context.reset();
	CQF_Status::keyV_sign_context.reset();
	CQF_Status::max_val_context.reset();

	int max_val = 0;
	int max_count = 1;

	bool all_level_done = false;	// true when all kV's have range 0
	int max_index = -1;				// records index of max, ==keynum ̸   ̻ ִٴ 

	unsigned int bit; //(0x0 or 0x1)

	int symcount;	// for counding symbol when MJH_DEBUG is defined

#ifdef MJH_DEBUG
	FILE *f = fopen("mjh_debug.txt", "a");
#endif

	// 6.1.1 : Max ϰ ڵѴ. (from interpolator.q_x_kvb (pdQ) array)
	for(int i=start; i<keynum; i++) {
		if (pdQ[i] < 0) {
			sign[i] = -1;
			pdQ[i] = pdQ[i] * -1;
		}
		else {
			sign[i] = 1;
		}

		if (pdQ[i] >= max_val) {
			if (pdQ[i] == max_val)
				max_count++;
			else {
				max_val = pdQ[i];
				max_count=1;
			}
		}
	}

	symcount=0;
#ifdef MJH_DEBUG2
		fprintf(f, "\nMaxval:");
#endif

//	codec._ostrm->putbits(max_val, qstep-1);
	for (int j=qstep-1; j>=0; j--) {
		bit = (max_val >> j) & 0x1;
		codec.encode(bit,CQF_Status::max_val_context);
		symcount++;

#ifdef MJH_DEBUG2
		fprintf(f, "%d", bit);
#endif
	}

	//MJH 20010924 : max value output
#ifdef MJH_DEBUG
	fprintf(f, "\t%d\t%d", max_val, symcount);
	symcount = 0;
#endif

#ifdef MJH_DEBUG2
		fprintf(f, "\nSign:");
#endif

	// min, max, found ʱȭ  sign encode 
	for(i=start; i<keynum; i++) {
		range_min[i] = 0;
		range_max[i] = max_val;
		found[i] = false;
		if (sign[i] == 1)
			bit = 0x0;
		else
			bit = 0x1;
		codec.encode(bit,CQF_Status::keyV_sign_context);
		symcount++;
#ifdef MJH_DEBUG2
		fprintf(f, "%d", bit);
#endif
	}

#ifdef MJH_DEBUG
	fprintf(f, "\t%d", symcount);
	symcount = 0;
#endif

#ifdef MJH_DEBUG2
		fprintf(f, "\nData:");
#endif

	// 6.1.2 : for each level, until all range is 0 (min==max), do...
	while (!all_level_done) {
		all_level_done = true;
		max_index = -1;

#ifdef MJH_DEBUG2
		fprintf(f, "\n");
#endif

		// 6.1.2.1 : for each kV
		for(i=start; i<keynum; i++) {
			// ȳ 鸸 Ѵ.
			if (range_max[i] != range_min[i]) {	
				all_level_done = false;

				// 6.1.2.1.1 : mid point Ѵ. -->  mid = (int)((max-min)/2) + 1 + min 
				range_mid[i] = (int)((range_max[i] - range_min[i])/2) + 1 + range_min[i];

				// 6.1.2.1.2 : get 0 or 1
				if (pdQ[i] >= range_mid[i])
					bit = 0x1;
				else
					bit = 0x0;

				// 6.1.2.1.3 : aac it using context according to found
				if (found[i])
					codec.encode(bit,CQF_Status::found_context);
				else
					codec.encode(bit,CQF_Status::not_found_context);

				symcount++;
#ifdef MJH_DEBUG2
		fprintf(f, "%d", bit);
#endif

				// 6.1.2.1.4 : update max, min, found
				if (bit) {
					if (max_count == 1 && range_max[i] == max_val) {
						if (max_index == -1)
							max_index = i;
						else
							max_index = keynum;
					}
					range_min[i] = range_mid[i];
					found[i] = true;
				}
				else {
					range_max[i] = range_mid[i]-1;
				}
			} //if (range_max[i] != range_min[i])
#ifdef MJH_DEBUG2
			else {
				fprintf(f, " ");
			}
#endif

		} //for(i=start; i<keynum; i++) 

		// if the maximum number is found, then code no more
		if (max_index >= 0 && max_index < keynum) {
			range_min[max_index] = range_max[max_index];
			max_count = 0;
		}

	} //while (!all_level_done)

#ifdef MJH_DEBUG
	fprintf(f, "\t%d", symcount);
	fclose(f);
#endif

	delete [] range_mid;
	delete [] range_min;
	delete [] range_max;
	delete [] found;
	delete [] sign;

}