#ifndef _STREAM_H_
#define _STREAM_H_

#include <malloc.h>
//#include "nodes.h"

#if !defined NULL
#define NULL 0
#endif

class CBuffer {
public:
	int				size;
	unsigned char*	buf;
	int				nbits;
	int				nbytes;

	~CBuffer();
	CBuffer();
};

class CInStream {
public:
	CBuffer Inbuf;
	char*	_Fname;
	int		num_node;

	//AAC sungjin
	unsigned char   _buf;
    int             _ibits;
	bool            _align;

	~CInStream();
	CInStream();
	//bool	openenc(bool bmode, char* fname, char* hname, CNode* inode);
	bool    opendec(char* fname);  //AAC sungjin 
	int		getbit();
	int		getbits(int n);
	int		lookbits(int n);
	int		getsize() {return Inbuf.size;};
	int		getnbits() {return Inbuf.nbits;};
	int		getnbytes() {return Inbuf.nbytes;};
	char	getbuf(int n) {return Inbuf.buf[n];};
	bool	getUChar(unsigned char& c);
	void	putsize(int n) {Inbuf.size=n;};
	void	putnbits(int n) {Inbuf.nbits=n;};
	void	putnbytes(int n) {Inbuf.nbytes=n;};
	void	bfree()
	{
		if(Inbuf.buf != NULL)
		{
			free(Inbuf.buf);
			Inbuf.buf = NULL;
		}
	};

	//AAC sungjin
	bool    get32BitFloat(float& x);
	bool    getMBitInt(int nbits, int& mbi);
	bool    getBitf(bool& bit);
	bool    flush();
};

class COutStream {
public:
	CBuffer Outbuf;
	char*	_Fname;
	unsigned char _buf;
	int           _ibits;
	bool          _align;

	~COutStream();
	COutStream();
	bool	openenc(char* fname);
	//bool    opendec(char* fname, int ci, CNode* inode);
	bool	close_enc();
	//bool	close_dec(int ci, CNode* inode);
	void	putbit(int b);
	void	putbits(int v, int n);
	int		getsize() {return Outbuf.size;};
	int		getnbits() {return Outbuf.nbits;};
	int		getnbytes() {return Outbuf.nbytes;};
	void	putsize(int n) {Outbuf.size=n;};
	void	putnbits(int n) {Outbuf.nbits=n;};
	void	putnbytes(int n) {Outbuf.nbytes=n;};
	void	putbuf(int n, unsigned char& c) {Outbuf.buf[n]=c;};
	bool	putUChar(unsigned char c);
	void	bfree() 
	{
		if(Outbuf.buf != NULL)
		{
			free(Outbuf.buf);
			Outbuf.buf = NULL;
		}
	};
	bool	put32BitFloat(float x);
	bool	putMBitInt(int nbits, int mbi);
	bool	putBitf(bool bit);

	//AAC sungjin
	bool    flush();
};

#endif //_STREAM_H_