/***********************************************************************
This software module was originally developed by James D. K. Kim, 
Sang Oak Woo and Shin Jun Lee(Samsung Advance Institute of Technology)
in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
standard. This software module is an implementation of a part of one or
more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4
Systems (ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 
Systems (ISO/IEC 14496-1) free license to this software module or 
modifications thereof for use in hardware or software products claiming
conformance to the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to 
use this software module in hardware or software products are advised that
its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Samsung Advance Institute of Technology
retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using
the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
This copyright notice must be included in all copies or derivative works.
Copyright ?2001
************************************************************************

For more information or to receive an up to date version of this module,
you may call Sang Oak Woo at sowoo@sait.samsung.co.kr
----------------------------------------------------------------------*/

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Interpolator Compression
FILE:       PosIKeyValueHeader.h
AUTHOR:     Sang Oak Woo (SAMSUNG AIT)
OVERVIEW:   Implementation of Interpolator Compression
-------------------------------------------------------------------------*/

// PosIKeyValueHeader.h: interface for the PosIKeyValueHeader class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_POSIKEYVALUEHEADER_H__8344534A_F5EB_4196_8859_38F5A9C85CAD__INCLUDED_)
#define AFX_POSIKEYVALUEHEADER_H__8344534A_F5EB_4196_8859_38F5A9C85CAD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "entropy.h"
#include "KeyValueMinMax.h"
#include "JWTemplArray.h"
#include "SFVec3f.h"

class PosIKeyValueHeader  
{
public:
	PosIKeyValueHeader();
	virtual ~PosIKeyValueHeader();

public:
	void readBitstream(CAC_QF& codec);
	void decodingProcess();

public:
	unsigned int bPreserveKey;
	unsigned int nKVQBit;
	unsigned int x_keyvalue_flag;
	unsigned int y_keyvalue_flag;
	unsigned int z_keyvalue_flag;
	unsigned int nKVDigit;

	// if x_keyvalue_flag == 1
	unsigned int nKVDPCMOrder_X;
	unsigned int bIsUnaryAAC_X;
	unsigned int nKVCodingBit_X;
	unsigned int nStartIndex_X;

	// if y_keyvalue_flag == 1
	unsigned int nKVDPCMOrder_Y;
	unsigned int bIsUnaryAAC_Y;
	unsigned int nKVCodingBit_Y;
	unsigned int nStartIndex_Y;

	// if x_keyvalue_flag == 1
	unsigned int nKVDPCMOrder_Z;
	unsigned int bIsUnaryAAC_Z;
	unsigned int nKVCodingBit_Z;
	unsigned int nStartIndex_Z;

	// if Intra coding is used
	unsigned int firstKV_X;
	unsigned int firstKV_Y;
	unsigned int firstKV_Z;

	KeyValueMinMax kvMinMax;
};

#endif // !defined(AFX_POSIKEYVALUEHEADER_H__8344534A_F5EB_4196_8859_38F5A9C85CAD__INCLUDED_)
