/***********************************************************************
This software module was originally developed by James D. K. Kim, 
Sang Oak Woo and Shin Jun Lee(Samsung Advance Institute of Technology)
in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
standard. This software module is an implementation of a part of one or
more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4
Systems (ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 
Systems (ISO/IEC 14496-1) free license to this software module or 
modifications thereof for use in hardware or software products claiming
conformance to the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to 
use this software module in hardware or software products are advised that
its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Samsung Advance Institute of Technology
retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using
the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
This copyright notice must be included in all copies or derivative works.
Copyright  2001
************************************************************************

For more information or to receive an up to date version of this module,
you may contact James D. K. Kim at jacobkim@sait.samsung.co.kr
----------------------------------------------------------------------*/

// QuatError.h: interface for the QuatError class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_QUATERROR_H__9524865A_4A0B_4032_B538_8060E80F1BD4__INCLUDED_)
#define AFX_QUATERROR_H__9524865A_4A0B_4032_B538_8060E80F1BD4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <stdio.h>
#include "JWTemplArray.h"

class Quaternion;

class QuatError  
{
public:
	QuatError();
	QuatError(FILE* in_srcfp, FILE* in_decfp, FILE* in_outfp, int in_nBits);
	virtual ~QuatError();


//member fvariables
public:
	FILE*	srcfp;
	FILE*	decfp;
	FILE*	outfp;
	int		nBits;
//member functions
public:
	double CalculateErrorAngle(Quaternion srcQuat, Quaternion decQuat);
	//void ComputeError(double &, double &, double &, int, JWArray<double>&, JWArray<Quaternion>&, 
	//			int, JWArray<double>&, JWArray<Quaternion>&);
	void ComputeError(double &, double &, double &, int, JWArray<double>&, JWArray<Quaternion>&, 
				int, JWArray<double>&, JWArray<Quaternion>&, int IdenticalArray);
	void DataSwapping(double *Data1, double *Data2);
	double Norm(double *SrcQuaternion);
	double InnerProduct(double *SrcQuaternion1, double *SrcQuaternion2);
	void SphericalLinearInterpolator(double *TargetQuaternion, double *LowerQuaternion,
		double *UpperQuaternion, double TargetTime, double LowerTime, double UpperTime);
	
};

#endif // !defined(AFX_QUATERROR_H__9524865A_4A0B_4032_B538_8060E80F1BD4__INCLUDED_)
