/***********************************************************************
This software module was originally developed by James D. K. Kim, 
Sang Oak Woo and Shin Jun Lee(Samsung Advance Institute of Technology)
in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
standard. This software module is an implementation of a part of one or
more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4
Systems (ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 
Systems (ISO/IEC 14496-1) free license to this software module or 
modifications thereof for use in hardware or software products claiming
conformance to the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to 
use this software module in hardware or software products are advised that
its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Samsung Advance Institute of Technology
retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using
the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
This copyright notice must be included in all copies or derivative works.
Copyright  2001
************************************************************************

For more information or to receive an up to date version of this module,
you may contact James D. K. Kim at jacobkim@sait.samsung.co.kr
----------------------------------------------------------------------*/

// Rotation.cpp: implementation of the Rotation class.
//
//////////////////////////////////////////////////////////////////////

//#include "stdafx.h"
#include "SFRotation.h"
#include "Quaternion.h"

#include <math.h>



#define DELTA			1.0E-50

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SFRotation::SFRotation()
{
	x = 0.0;
	y = 0.0;
	z = 0.0;
	theta = 0.0;
}

SFRotation::SFRotation(double in_x, double in_y, double in_z, double in_theta)
{
	x = in_x;
	y = in_y;
	z = in_z;
	theta = in_theta;
}


SFRotation::~SFRotation()
{

}


void SFRotation::QuaternionToRotation(Quaternion* m_pSrcQuat)
{
	theta = acos(m_pSrcQuat->s) * 2.0;
	
	double norm = sin(theta);
	if(fabs(norm) < DELTA)
	{
		x = 0.0;
		y = 1.0;
		z = 0.0;
		theta = 0.0;
	}
	else
	{
		x = m_pSrcQuat->x/sin(theta/2.0);
		y = m_pSrcQuat->y/sin(theta/2.0);
		z = m_pSrcQuat->z/sin(theta/2.0);
	}
}
