/***********************************************************************
This software module was originally developed by James D. K. Kim, 
Sang Oak Woo and Shin Jun Lee(Samsung Advance Institute of Technology)
in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
standard. This software module is an implementation of a part of one or
more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4
Systems (ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 
Systems (ISO/IEC 14496-1) free license to this software module or 
modifications thereof for use in hardware or software products claiming
conformance to the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to 
use this software module in hardware or software products are advised that
its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Samsung Advance Institute of Technology
retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using
the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
This copyright notice must be included in all copies or derivative works.
Copyright  2001
************************************************************************

For more information or to receive an up to date version of this module,
you may contact James D. K. Kim at jacobkim@sait.samsung.co.kr
----------------------------------------------------------------------*/

// Rotation.h: interface for the Rotation class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ROTATION_H__4A5FDAB7_3710_49B1_9C0D_61E046B9F909__INCLUDED_)
#define AFX_ROTATION_H__4A5FDAB7_3710_49B1_9C0D_61E046B9F909__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <fstream.h>

class Quaternion;

class SFRotation  
{
public:
	SFRotation();
	SFRotation(double in_x, double in_y, double in_z, double in_theta);
	virtual ~SFRotation();

//member variables
public:
	double x;
	double y;
	double z;
	double theta;

//memer functions
	//Convert Quaternion to AngularDisplacement 
	void QuaternionToRotation(Quaternion* m_pSrcQuat);

public:
	friend ofstream& operator << (ofstream& os, SFRotation& r)
	{
		os << r.x << ' ' << r.y << ' ' << r.z << ' ' << r.theta;
		return os;
	}
};

#endif // !defined(AFX_ROTATION_H__4A5FDAB7_3710_49B1_9C0D_61E046B9F909__INCLUDED_)
