/***********************************************************************
This software module was originally developed by James D. K. Kim, 
Sang Oak Woo and Shin Jun Lee(Samsung Advance Institute of Technology)
in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
standard. This software module is an implementation of a part of one or
more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4
Systems (ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 
Systems (ISO/IEC 14496-1) free license to this software module or 
modifications thereof for use in hardware or software products claiming
conformance to the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to 
use this software module in hardware or software products are advised that
its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Samsung Advance Institute of Technology
retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using
the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
This copyright notice must be included in all copies or derivative works.
Copyright ?2001
************************************************************************

For more information or to receive an up to date version of this module,
you may call Sang Oak Woo at sowoo@sait.samsung.co.kr
----------------------------------------------------------------------*/

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Interpolator Compression
FILE:       SFVEc3f.h
AUTHOR:     Sang Oak Woo (SAMSUNG AIT)
OVERVIEW:   Implementation of Interpolator Compression
-------------------------------------------------------------------------*/

// SFVec3f.h: interface for the SFVec3f class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SFVEC3F_H__3C612699_444B_4DE8_BA4F_10CAB0159255__INCLUDED_)
#define AFX_SFVEC3F_H__3C612699_444B_4DE8_BA4F_10CAB0159255__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <math.h>
#include <fstream.h>

class SFVec3f  
{
public:
	SFVec3f();
	virtual ~SFVec3f();

public:
	SFVec3f& operator = (const SFVec3f& value)
	{
		x = value.x;
		y = value.y;
		z = value.z;

		return *this;
	}

	double GetDistance(const SFVec3f& value)
	{
		double dX, dY, dZ;
		dX = x - value.x;
		dY = y - value.y;
		dZ = z - value.z;

		return ::sqrt(dX*dX + dY*dY + dZ*dZ);
	}

	friend ofstream& operator << (ofstream& os, SFVec3f& v)
	{
		os << v.x << ' ' << v.y << ' ' << v.z;
		return os;
	}

public:
	double x;
	double y;
	double z;
};

#endif // !defined(AFX_SFVEC3F_H__3C612699_444B_4DE8_BA4F_10CAB0159255__INCLUDED_)
