/***********************************************************************
This software module was originally developed by James D. K. Kim, 
Sang Oak Woo and Shin Jun Lee(Samsung Advance Institute of Technology)
in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
standard. This software module is an implementation of a part of one or
more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4
Systems (ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 
Systems (ISO/IEC 14496-1) free license to this software module or 
modifications thereof for use in hardware or software products claiming
conformance to the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to 
use this software module in hardware or software products are advised that
its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Samsung Advance Institute of Technology
retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using
the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
This copyright notice must be included in all copies or derivative works.
Copyright  2001
************************************************************************

For more information or to receive an up to date version of this module,
you may contact James D. K. Kim at jacobkim@sait.samsung.co.kr
----------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "defs.h"
//#include "stdafx.h"
#include "afxstream.h"

#define M_SIZE 1024

CBuffer::CBuffer() 
{}

CBuffer::~CBuffer() 
{}

///////////////////////////////////////////////////////////////////////////////////
/// Control Input Stream  /////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
CInStream::CInStream() 
{
	Inbuf.size=0;
	Inbuf.buf=NULL;
	Inbuf.nbits=0;
	Inbuf.nbytes=0;
	// Jameskim 20020501
	//_Fname=NULL;
	num_node = 0;

	//AAC sungjin
	_ibits=8;
	_buf = 0x00;
	_align = false;
}

CInStream::~CInStream() 
{
	// Jameskim 20020501
	//if(_Fname != NULL)
	//	free(_Fname);
}

//AAC sungjin
bool CInStream::opendec(char* fname)
{
	bool success = false;
	int i=1, t_size, ch;
		
	//read the binary key & keyValue file
	if( (Inbuf.buf=(unsigned char *)malloc(M_SIZE*sizeof(char)))==NULL)
		return success;
	//if(_Fname) 
	//	_Fname = NULL; 
	if(fname!=NULL)	{
		FILE *fp = fopen(fname,"rb");
		if(fp == NULL)
			return false;
		if(fp!=(FILE*)0) {
			// Jameskim 20020501
			//_Fname = strdup(fname);
			strcpy(_Fname, fname);
			while(!feof(fp)) {
				ch=fgetc(fp);
				Inbuf.buf[Inbuf.size++] = (unsigned char)ch;
				if((t_size=M_SIZE*i)==(getsize()+1)) {
					i++;
					if((Inbuf.buf=(unsigned char *)realloc(Inbuf.buf,(getsize()+1)+(M_SIZE*sizeof(char))))==NULL)
						return success; 
				}
			}
			success = true;
		} 
		fclose(fp);
	}
	return success;
}


// 20020711 for BitWrapper, by sowoo
bool CInStream::opendecWithBuffer(char* buffer, int nLength)
{
	bool bSuccess = false;
	int nSizeOfBuffer = 0;

	if(nLength != -1)
		nSizeOfBuffer = nLength;
	else
		nSizeOfBuffer = ::strlen(buffer) + 1;

	Inbuf.size = nSizeOfBuffer;
	if((Inbuf.buf = (unsigned char*) ::malloc(nSizeOfBuffer*sizeof(char))) == NULL)
		return bSuccess;

	::memcpy(Inbuf.buf, buffer, nSizeOfBuffer*sizeof(char));

	bSuccess = true;
	return bSuccess;
}

int CInStream::getbit() 
{
	int res = (Inbuf.buf[getnbytes()] >> (7-getnbits())) & 1;
	Inbuf.nbits++;
	if (getnbits() == 8) {
		putnbits(0);
		Inbuf.nbytes++;
	}
	return res;
}

int CInStream::getbits(int n) 
{
	int res = 0;
	for (int i=0; i<n; i++) {
		res <<= 1;
		res += getbit();
	}
	return res;
}

bool CInStream::getUChar(unsigned char& c)
{
	c = (getnbytes() < getsize()) ? Inbuf.buf[getnbytes()] : 0;
	Inbuf.nbytes++;
	return true;
}

//begin AAC sungjin
bool CInStream::get32BitFloat(float& x)
{
	int& ix = *(int*)(&x);
	return getMBitInt(32,ix);
}

bool CInStream::getMBitInt(int nbits, int& mbi)
{
 	mbi = 0;  // Most significant bit first
	bool bit = false;

	_align=false;
	_buf = 0x00;
	_buf |= Inbuf.buf[getnbytes()];
	_ibits = 8-Inbuf.nbits;
	for(int i=0;i<nbits;i++) {
		if(getBitf(bit)==false) return false;
		mbi <<= 1;
		if(bit!=false) mbi |= 1;
    }
	if(_align==false) {
		if(_ibits==8) {
			Inbuf.nbits = 8-_ibits;
			Inbuf.nbytes++;    
		} else {
			Inbuf.nbits = 8-_ibits;
		}
	} else {
		Inbuf.nbits = 8-_ibits;
	}
	_ibits=8;
	_buf = 0x00;
	_align = false;

	return true;
}

bool CInStream::getBitf(bool& bit)
{
	bool success = true;
	_align=false;
	if(_ibits==8) {
		Inbuf.nbytes++;   
		success = getUChar(_buf);
		Inbuf.nbytes--;   
	}
	if(!(success==false)) {
		bit = (_buf & (1<<--_ibits)) ? true : false; // MSB first, FJB 7/5/98
		if(_ibits==0) {
			_ibits=8;
			// CS 021799
			if(_buf == 0x00) {  
				Inbuf.nbytes++;   
				getUChar(_buf);
				Inbuf.nbytes--;   
				_ibits=7;         
				_align=true;
			}
		} 
    }
	return success;
}

bool CInStream::flush()
{
  if(_ibits!=8)
      _ibits = 8;

  return true;
}
//end AAC sungjin

///////////////////////////////////////////////////////////////////////////////////
/// Control Output Stream  ////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
COutStream::COutStream() 
{
	Outbuf.size=0;
	
	//if(Outbuf.buf != NULL)
	//{
	//	::free((unsigned char *)Outbuf.buf);
	//	Outbuf.buf = NULL;
	//}
	//Outbuf.buf= (unsigned char *)malloc(sizeof(unsigned char));
	
	Outbuf.buf= NULL;
	Outbuf.nbits=0;
	Outbuf.nbytes=0;
	_Fname=NULL;

	//AAC sungjin
	_ibits=8;
	_buf = 0x00;
	_align = false;
}

COutStream::~COutStream() 
{
	if(_Fname != NULL)
		free(_Fname);
}

bool COutStream::openenc(char* fname)
{
	if(fname!=NULL)
    {
		_Fname = strdup(fname);
		if( (Outbuf.buf=(unsigned char *)malloc(M_SIZE*sizeof(char)))==NULL)
			return false;
		memset(Outbuf.buf,0x0,M_SIZE);
		Outbuf.size = _msize(Outbuf.buf);
		return true;
    }
	return false;
}

bool COutStream::close_enc()
{
	bool success = false;
	if(_Fname!=NULL)
    {
		FILE *fp = fopen(_Fname,"wb");
		if(fp!=(FILE*)0)
		{
			int  nBytes = getnbytes()-1;
			int  nBytesWritten = fwrite(Outbuf.buf,1,nBytes,fp);
			success = (nBytesWritten<nBytes)?false:true;
			fclose(fp);
		}
    }
	return success;
}

/*
bool COutStream::opendec(char* fname, int ci, CNode* inode)
{
	if(fname!=NULL)
    {
		_Fname = strdup(fname);
		for(int i=0; i<ci; i++) {
			int nkey = inode[i]._Num;
			inode[i]._Key=new float[nkey];
			inode[i]._KeyValue=new CKValue[nkey];
		}
		return true;
    }
	return false;
}

bool COutStream::close_dec(int ci, CNode* inode)
{
	bool success = false;
	if(_Fname!=NULL)
    {
		FILE *fp = fopen(_Fname,"w");
		if(fp!=(FILE*)0)
		{
			int i, j;
			for(i=0; i<ci; i++) {
				switch(inode[i]._NodeCode) {
				case 0 : fprintf(fp,"PositionInterpolator { \n"); break;
				case 1 : fprintf(fp,"CoordinateInterpolator { \n"); break;
				case 2 : fprintf(fp,"OrientationInterpolator { \n"); break;
				case 3 : fprintf(fp,"S/N/C_Interpolator { \n"); break;
				default : break;
				}
				fprintf(fp,"Key [ \n");
				for(j=0; j<inode[i]._Num; j++) {
					if(j!=0 && j%3==0) fprintf(fp,"\n");
					fprintf(fp," %11.8f,",inode[i]._Key[j]);
				}
				fprintf(fp,"] \n\n");
				fprintf(fp,"KeyValue [ \n");
				for(j=0; j<inode[i]._Num; j++) {
					fprintf(fp," %11.6f",inode[i]._KeyValue[j].x);
					fprintf(fp," %11.6f",inode[i]._KeyValue[j].y);
					fprintf(fp," %11.6f",inode[i]._KeyValue[j].z);
					if(inode[i]._NodeCode==CODE_OrientationInterpolator)
						fprintf(fp," %11.6f",inode[i]._KeyValue[j].ang);
					else 
						fprintf(fp,", \n");
				}
				fprintf(fp,"] \n");
				fprintf(fp,"} \n\n");
			}
			success = true;
			fclose(fp);
		}
    }
	return success;
}
*/
void COutStream::putbit(int b) 
{
	if(getnbytes() == getsize())
	{
		Outbuf.buf=(unsigned char *)realloc(Outbuf.buf,getsize()+(M_SIZE*sizeof(char)));
		Outbuf.size = _msize(Outbuf.buf);
	}

	if(Outbuf.nbits == 0)
		Outbuf.buf[getnbytes()] &= 0x00;

	Outbuf.buf[getnbytes()] |= (b<<(7-getnbits()));   //MSB First
	//Outbuf.buf[getnbytes()] <<= 1;
	//Outbuf.buf[getnbytes()] |= b;
	Outbuf.nbits++;
	if (getnbits() == 8)
	{
		putnbits(0);
		Outbuf.nbytes++;
	}

	if (getnbytes() == getsize()) {
		Outbuf.buf=(unsigned char *)realloc(Outbuf.buf,getsize()+(M_SIZE*sizeof(char)));
		Outbuf.size = _msize(Outbuf.buf);
	}
}

void COutStream::putbits(int v, int n) 
{
	for (int i=0; i<n; i++)
		putbit((v >> (n-i-1)) & 1);
}

bool COutStream::putUChar(unsigned char c)
{
	if (getnbytes() == getsize()) {
		Outbuf.buf=(unsigned char *)realloc(Outbuf.buf,getsize()+(M_SIZE*sizeof(char)));
		Outbuf.size = _msize(Outbuf.buf);
	}

	Outbuf.buf[getnbytes()]=c;
	Outbuf.nbytes++;

	if (getnbytes() == getsize()) {
		Outbuf.buf=(unsigned char *)realloc(Outbuf.buf,getsize()+(M_SIZE*sizeof(char)));
		Outbuf.size = _msize(Outbuf.buf);
	}
	return true;
}

bool COutStream::put32BitFloat(float x)
{
	int ix = *(int*)(&x);
	return putMBitInt(32,ix);
}

bool COutStream::putMBitInt(int nbits, int mbi)
{
	// Most significant bit first
	bool bit = false;
	_align=false;
	_buf = 0x00;
	_buf |= Outbuf.buf[getnbytes()];
	_ibits = 8-Outbuf.nbits;  
	for(int i=0;i<nbits;i++) {
		bit = (mbi & (1<<(nbits-i-1)))?true:false;
		if(putBitf(bit)==false) return false;
    }
	if(_align==false) {
		putUChar(_buf);
		Outbuf.nbits = 8-_ibits;
		Outbuf.nbytes--;
	} else {
		if(_buf==0x80 && _ibits==7) {
			putUChar(_buf);
			Outbuf.nbits = 8-_ibits;
			Outbuf.nbytes--;
		} else {
			Outbuf.nbits=0;
		}
	}
	_align=false;
	_buf = 0x00;
	_ibits = 8;
	
	return true;
}

bool COutStream::putBitf(bool bit)
{
	--_ibits;
	if(bit!=false) 
		_buf |= (1<<_ibits); // MSB first FJB 7/5/98
	if(_ibits==0) {
		if(putUChar(_buf)==false) return false;
		// CS 021799
		if(_buf != 0x00) {
			_buf = 0x00;
			_ibits = 8;
		} else  {
			_buf = 0x80;
			_ibits = 7;	  	  
		}
		_align=true;
	} else {
		_align=false;
	}
	
	return true;
}

//AAC sungjin
bool COutStream::flush()
{
	if(_ibits!=8)
    {
		if(putUChar(_buf)==false) return false;
		_buf = 0x00;
		_ibits = 8;
    }
	return true;
}


