/***********************************************************************
This software module was originally developed by James D. K. Kim, 
Sang Oak Woo and Shin Jun Lee(Samsung Advance Institute of Technology)
in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
standard. This software module is an implementation of a part of one or
more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4
Systems (ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 
Systems (ISO/IEC 14496-1) free license to this software module or 
modifications thereof for use in hardware or software products claiming
conformance to the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to 
use this software module in hardware or software products are advised that
its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Samsung Advance Institute of Technology
retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using
the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
This copyright notice must be included in all copies or derivative works.
Copyright  2001
************************************************************************

For more information or to receive an up to date version of this module,
you may contact James D. K. Kim at jacobkim@sait.samsung.co.kr
----------------------------------------------------------------------*/

#ifndef _STREAM_H_
#define _STREAM_H_

#include <malloc.h>

#if !defined NULL
#define NULL 0
#endif

class CBuffer {
public:
	int				size;
	unsigned char*	buf;
	int				nbits;
	int				nbytes;

	~CBuffer();
	CBuffer();
};

class CInStream {
public:
	CBuffer Inbuf;
	// Jameskim 20020501
	//char*	_Fname;
	char	_Fname[4096];
	int		num_node;

	//AAC sungjin
	unsigned char   _buf;
    int             _ibits;
	bool            _align;

	~CInStream();
	CInStream();
	//bool	openenc(bool bmode, char* fname, char* hname, CNode* inode);
	bool    opendec(char* fname);  //AAC sungjin 

	// 20020710 for BitWrapper, sowoo
	bool opendecWithBuffer(char* buffer, int nLength = -1);

	int		getbit();
	int		getbits(int n);
	int		lookbits(int n);
	int		getsize() {return Inbuf.size;};
	int		getnbits() {return Inbuf.nbits;};
	int		getnbytes() {return Inbuf.nbytes;};
	char	getbuf(int n) {return Inbuf.buf[n];};
	bool	getUChar(unsigned char& c);
	void	putsize(int n) {Inbuf.size=n;};
	void	putnbits(int n) {Inbuf.nbits=n;};
	void	putnbytes(int n) {Inbuf.nbytes=n;};
	void	bfree()
	{
		if(Inbuf.buf != NULL)
		{
			free(Inbuf.buf);
			Inbuf.buf = NULL;
		}
	};

	//AAC sungjin
	bool    get32BitFloat(float& x);
	bool    getMBitInt(int nbits, int& mbi);
	bool    getBitf(bool& bit);
	bool    flush();
};

class COutStream {
public:
	CBuffer Outbuf;
	char*	_Fname;
	unsigned char _buf;
	int           _ibits;
	bool          _align;

	~COutStream();
	COutStream();
	bool	openenc(char* fname);
	//bool    opendec(char* fname, int ci, CNode* inode);
	bool	close_enc();
	//bool	close_dec(int ci, CNode* inode);
	void	putbit(int b);
	void	putbits(int v, int n);
	int		getsize() {return Outbuf.size;};
	int		getnbits() {return Outbuf.nbits;};
	int		getnbytes() {return Outbuf.nbytes;};
	void	putsize(int n) {Outbuf.size=n;};
	void	putnbits(int n) {Outbuf.nbits=n;};
	void	putnbytes(int n) {Outbuf.nbytes=n;};
	void	putbuf(int n, unsigned char& c) {Outbuf.buf[n]=c;};
	bool	putUChar(unsigned char c);
	void	bfree() 
	{
		if(Outbuf.buf != NULL)
		{
			free(Outbuf.buf);
			Outbuf.buf = NULL;
		}
	};
	bool	put32BitFloat(float x);
	bool	putMBitInt(int nbits, int mbi);
	bool	putBitf(bool bit);

	//AAC sungjin
	bool    flush();
};

#endif //_STREAM_H_