/***********************************************************************
This software module was originally developed by IBM Corporation & Samsung
Electronics Co. LTD., and modified by James D. K. Kim, Sang Oak Woo 
and Shin Jun Lee(Samsung Advance Institute of Technology)
in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
standard. This software module is an implementation of a part of one or
more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4
Systems (ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 
Systems (ISO/IEC 14496-1) free license to this software module or 
modifications thereof for use in hardware or software products claiming
conformance to the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to 
use this software module in hardware or software products are advised that
its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Samsung Advance Institute of Technology
retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using
the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
This copyright notice must be included in all copies or derivative works.
Copyright  2001
************************************************************************

For more information or to receive an up to date version of this module,
you may contact James D. K. Kim at jacobkim@sait.samsung.co.kr
----------------------------------------------------------------------*/

#ifndef _ENTROPY_H_
#define _ENTROPY_H_

#include "afxstream.h"

struct AC_QEntry {
  unsigned short Qe;
  short          nMPS;
  short          nLPS;
  short          sMPS;
};

class SAIT_CAC {
public:
	static struct AC_QEntry model[];
	static int	_shift;
	unsigned      Qe;
	short         index;
	short         MPS;
	
	~SAIT_CAC();
	SAIT_CAC(); 
	void reset();
	void update(int symbol); 
};

class CAC_QF {
protected:

  unsigned      C;
  unsigned      A;
  unsigned      C_high;
  int           count;
  int           first;
  int           bits;

  int           _ostrm_bits;
  int           _istrm_bits;
  


public:
	CInStream*	_istrm;
	COutStream*	_ostrm;

protected:
  int  get_byte();
  void put_byte(int);

  void hw_renorm_encode();
  void hw_renorm_decode();
  int  sw_renorm_decode();

  void hw_start_encode();
  void hw_encode(int, SAIT_CAC &);
  void hw_encode(int);
  void hw_finish_encode();

  void hw_start_decode();
  int  hw_decode(SAIT_CAC &);
  void hw_finish_decode();

  void sw_start_decode();
  int  sw_decode(SAIT_CAC &);
  int  sw_decode();
  void sw_finish_decode();

public:
  CAC_QF(COutStream &o);  
  CAC_QF(CInStream &i);
  ~CAC_QF();
  int getOBits();
  int getIBits();
  void encode(int bit);
  void encode(int bit, SAIT_CAC &qfPM);
  int decode();
  int decode(SAIT_CAC &qfPM);
  void start_encode(void);
  void finish_encode(void);
  void start_decode(void);
  void finish_decode(void);
};

#endif  //_ENTROPY_H_