/***********************************************************************
This software module was originally developed by Khaled MAMOU
(INT - ARTEMIS ) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. The author retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2007
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Khaled MAMOU at Khaled.Mamou@int-edu.eu
----------------------------------------------------------------------*/

#if !defined(_KMFAMCDecoder_h)	// Sentry, use file only if it's not already included.
#define _KMFAMCDecoder_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Decoder
FILE:       KMFAMCDecoder.h
AUTHOR:     Khaled MAMOU (INT)
OVERVIEW:   Definition of KMFAMCDecoder 
-------------------------------------------------------------------------*/
#include "AFX.h"
#include "..\AFX\FAMC\BaseFAMC\IndexedFaceSet.h"

#include "..\..\include\ztl.h"

class KMFAMCDecoder : public AFXTemplate
{
public:
public:
    KMFAMCDecoder();
    ~KMFAMCDecoder();

	BOOL SetFF ();
	virtual int GetOptimalOutputSize ();

	virtual BOOL Setup (AFXExtDescriptor *pSpecificInfo);
	virtual BOOL Decode (LPBYTE pInput, int nInputLength, LPBYTE pOutput, int &rnOutputLength);

public:
	FAMC_IndexedFaceSet m_ifs;
};

#endif                                      // 
