/***********************************************************************
This software module was originally developed by Ioan Alexandru Salomie
(Vrije Universiteit Brussel VUB) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. VUB retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Ioan Alexandru Salomie at iasalomi@etro.vub.ac.be.
----------------------------------------------------------------------*/

// MGErrMsg.cpp: implementation of the CMGErrMsg class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MGErrMsg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CStringArray CMGErrMsg::errMsg;
CMGErrMsg appErrorMsg;

CMGErrMsg::CMGErrMsg()
{
	if (errMsg.GetSize() == 0)
	{
		errMsg.Add("Expected MeshGrid stream header");
		errMsg.Add("Not enough flags");
		errMsg.Add("Not enough connectivity links");
		errMsg.Add("Not enough offset values");
		errMsg.Add("Wrong vertex reposition flag");
		errMsg.Add("Wrong connectivity");
		errMsg.Add("Memory allocation error");
		errMsg.Add("Inconsistent mesh description");
		errMsg.Add("Wrong number of levels");
		errMsg.Add("Wrong number of slices");
		errMsg.Add("Wrong number of vertices' refine bits");
		errMsg.Add("Wrong number of ROIs");
		errMsg.Add("Wrong number of Scale bits");
		errMsg.Add("Wrong Scale value");
		errMsg.Add("Wrong number of Quantization bits");
		errMsg.Add("Wrong number of Grid coding bits");
		errMsg.Add("Wrong number of Vertex counter bits");
		errMsg.Add("Wrong number of ROI bits");
		errMsg.Add("Wrong number of Tiles bits");
		errMsg.Add("Wrong number of Tiles");
		errMsg.Add("Wrong part identified in stream");
		errMsg.Add("Wrong parameters");
	}
}

const CString &CMGErrMsg::GetMessage(int msgIdx)
{
	if (msgIdx > errMsg.GetUpperBound())
		throw CMGDataException("Wrong error number specified.");
	else
		return errMsg[msgIdx];
}

