/***********************************************************************
This software module was originally developed by Ioan Alexandru Salomie
(Vrije Universiteit Brussel VUB) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. VUB retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Ioan Alexandru Salomie at iasalomi@etro.vub.ac.be.
----------------------------------------------------------------------*/

// MGErrMsg.h: interface for the CMGErrMsg class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MGERRMSG_H__8D540D27_AFD1_45DF_98EC_B614A1A9099B__INCLUDED_)
#define AFX_MGERRMSG_H__8D540D27_AFD1_45DF_98EC_B614A1A9099B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


inline void GetErrorMessage(CException *e, CString &error)
{
	LPTSTR str = error.GetBufferSetLength(512);
	UINT    nHelpContext;

	if (!e->GetErrorMessage(str, 512, &nHelpContext))
		error = "Unknown error occured.";
}

////////////////////////////////////////////////////////////////////////
//class CMGErrMsg
////////////////////////////////////////////////////////////////////////

class CMGErrMsg  
{
public:
	CMGErrMsg();
	~CMGErrMsg() {};

	enum {
				 EXPECT_HEADER, NOT_ENOUGH_FLAGS,
         NOT_ENOUGH_CONNECTIVITY, NOT_ENOUGH_OFFSETS,
         WRONG_REPOSITION_FLAG, WRONG_CONNECTIVITY,
         MEMORY_EXCEPTION, INCONSIST_DESCR,
         WRONG_NR_LEVELS, WRONG_NR_SLICES,
         WRONG_VERTEX_REFINE_BITS, WRONG_NR_ROIS,
         WRONG_NR_SCALE_BITS, WRONG_SCALE_VALUE,
         WRONG_NR_QUANT_BITS, WRONG_NR_GRID_BITS,
         WRONG_NR_VERTEX_BITS, WRONG_NRROI_BITS,
         WRONG_NRTILES_BITS, WRONG_NR_TILES,
         WRONG_PART_IDENTIFIER, WRONG_PARAMETERS
	};

	static const CString &GetMessage(int msgIdx);

protected:
	static CStringArray errMsg;
};

////////////////////////////////////////////////////////////////////////
//class CMGDataException
////////////////////////////////////////////////////////////////////////

class CMGDataException
{
public:
	CMGDataException(int msgIdx) { m_error = CMGErrMsg::GetMessage(msgIdx); };
	CMGDataException(LPCTSTR msg) { m_error = msg; };
	CMGDataException(const CString & msg) { m_error = msg; };
  CMGDataException(CException *e)  { ::GetErrorMessage(e, m_error); };

  void GetErrorMessage(CString &error) const { error = m_error; };
  const CString &GetErrorMessage() const { return m_error; };

protected:
	CString m_error;
};

#endif // !defined(AFX_MGERRMSG_H__8D540D27_AFD1_45DF_98EC_B614A1A9099B__INCLUDED_)
