/***********************************************************************
This software module was originally developed by Ioan Alexandru Salomie
(Vrije Universiteit Brussel VUB) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. VUB retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2001
************************************************************************

  For more information or to receive an up to date version of this module,
  you may contact Ioan Alexandru Salomie at iasalomi@etro.vub.ac.be.
----------------------------------------------------------------------*/

#if !defined(_MshGrd_h)	// Sentry, use file only if it's not already included.
#define _MshGrd_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

  SUBSYSTEM:  Decoder
  FILE:       MshGrd.h
  AUTHOR:     Ioan Alexandru Salomie (VUB)
  OVERVIEW:   Definition of MGDecoder 
-------------------------------------------------------------------------*/
#include "..\AFX.h"

class MeshGridDecoderSpecificInfo;

class MGDecoder : public AFXTemplate
{
public:
	MGDecoder() { m_pDecSpecificInfo = NULL; };
	
	int GetOptimalOutputSize ();
	BOOL Setup (AFXExtDescriptor *pSpecificInfo);
	BOOL Decode (LPBYTE pInput, int nInputLength, LPBYTE pOutput, int &rnOutputLength);
	
private:
	BOOL        m_bActive;
	
	int			m_level;
	bool		initMesh;
	
public:
	int         nLevels[3];
	int         nSlices[3];
	
public:
	MeshGridDecoderSpecificInfo *m_pDecSpecificInfo;
};

#endif                                      // _MshGrd_h sentry.
