/***********************************************************************
This software module was originally developed by Shinjun Lee
(SAMSUNG AIT) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. SAMSUNG AIT retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright ?2002.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Shinjun Lee at sjlee@sait.samsung.co.kr.
----------------------------------------------------------------------*/

// CCommandLineProcessor.h
// Author: Shinjun Lee, Samsung AIT
// Date: 2003-11-06 ~ 2003-11-27

#ifndef _CCOMMANDLINEPROCESSOR_H_
#define _CCOMMANDLINEPROCESSOR_H_

#include <iostream.h>
#include <stdlib.h>
#include <string.h>

class CCommandLineProcessor
	{
  private:
	// variables: file names
	char			m_szInputFile[_MAX_PATH];				// input file name
	char			m_szOutputFile[_MAX_PATH];				// output file name
	int				m_nPercentOfCutting;					// the percent of cutting nodes
	bool			m_bBoundingBoxWRL;						// the flag of bounding box wrl
	bool			m_bSpeedUp;								// the flag of speed up

  public:
	CCommandLineProcessor(void)
		{
		memset((void*)m_szInputFile, 0, _MAX_PATH);
		memset((void*)m_szOutputFile, 0, _MAX_PATH);
		m_nPercentOfCutting = 100;
		m_bBoundingBoxWRL = false;
		m_bSpeedUp = false;
		}

	~CCommandLineProcessor()
		{
		}

	// set: arguments
	void setArguments(int argc, char* argv[])
		{
		switch(argc)
			{
			case 6:
				if(!strcmp(_strlwr(argv[5]), "-box"))
					m_bBoundingBoxWRL = true;
				else if(!strcmp(_strlwr(argv[5]), "-s"))
					m_bSpeedUp = true;

			case 5:
				if(!strcmp(_strlwr(argv[4]), "-box"))
					m_bBoundingBoxWRL = true;
				else if(!strcmp(_strlwr(argv[4]), "-s"))
					m_bSpeedUp = true;

			case 4:
				m_nPercentOfCutting = atoi(argv[3]);
				if(m_nPercentOfCutting == 0)
					{
					m_nPercentOfCutting = 100;
					if(!strcmp(_strlwr(argv[3]), "-box"))
						m_bBoundingBoxWRL = true;
					else if(!strcmp(_strlwr(argv[3]), "-s"))
						m_bSpeedUp = true;
					}

			case 3:
				strcpy(m_szInputFile, argv[1]);
				strcpy(m_szOutputFile, argv[2]);
				break;
			}
		}

	// get: input file name
	char* getInputFile(void)
		{
		return m_szInputFile;
		}

	// get: output file name
	char* getOutputFile(void)
		{
		return m_szOutputFile;
		}

	// get: the percent of cutting nodes
	int getPercentOfCutting(void)
		{
		return m_nPercentOfCutting;
		}

	// get: the flag of bounding box wrl
	bool getBoundingBoxWRL(void)
		{
		return m_bBoundingBoxWRL;
		}

	// get: the flag of speed up
	bool getSpeedUp(void)
		{
		return m_bSpeedUp;
		}
	};

#endif _CCOMMANDLINEPROCESSOR_H_
