/***********************************************************************
This software module was originally developed by Shinjun Lee
(SAMSUNG AIT) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. SAMSUNG AIT retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright ?2002.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Shinjun Lee at sjlee@sait.samsung.co.kr.
----------------------------------------------------------------------*/

#ifndef _BITIO_H_
#define _BITIO_H_

#include <stdio.h>

#define		BYTE_SIZE		8

class cInStream
{
private:
	FILE *fp;
	unsigned char	_in_buffer;			    /* I/O buffer */
	unsigned char	_in_bit_ptr;				/* bits left in buffer */
	unsigned int	_bytes_input;       /* byte count */
public:
	cInStream(){};
	virtual ~cInStream(){};

	void open(const char *filename);
	void close();

	int getbit();
	void flushbit();
	unsigned int getvlc(int n_bits); // n_bits should be less than 32

	int getbytecount();
};

class cOutStream
{
private:
	FILE *fp;
	unsigned char _out_buffer;			  /* I/O buffer */
	int						_out_bits_to_go;		/* bits to fill buffer */
	unsigned int	_bytes_output;			/* byte count */

public:
	cOutStream(){};
	virtual ~cOutStream(){};

	void open(const char *filename);
	void close();

	void putbit(int n);
	void flushbit();
	void putvlc(unsigned int code, int n_bits); // n_bits should be less than 32

	int  getbytecount();
};

#endif		/* #ifndef BITIO_H */
