/***********************************************************************
This software module was originally developed by Sebastian Amengual
(Universidad Politecnica de Madrid, UPM) in the course of development of 
the MPEG-4 Systems (ISO/IEC 14496-1) standard. This software module is
an implementation of a part of one or more MPEG-4 Systems 
(ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems
(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems 
(ISO/IEC 14496-1) free license to this software module or modifications
thereof for use in hardware or software products claiming conformance to
the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this 
software module in hardware or software products are advised that its 
use may infringe existing patents. The original developer of this 
software module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software module
or modifications thereof in an implementation. Copyright is not 
released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
UPM retains full right to use the code for his/her own purpose, assign 
or donate the code to a third party and to inhibit third parties from 
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. This copyright notice must be included in all copies or 
derivative works. Copyright  2005
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Francisco Moran at fmb@gti.ssr.upm.es.
----------------------------------------------------------------------*/

/*-------------------------------------------------------------------------
Project Player3d
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  WaveSurfDecoder
FILE:       WaveSurf.h
AUTHOR:     Sebastian Amengual (UPM)
OVERVIEW:   Header file of WaveSurf.cpp.
-------------------------------------------------------------------------*/

#include "Nodes.h"

class SSNode;
class WSSNode;

class WaveSurf
{
public:
	WaveSurf(); 
	~WaveSurf();

public:
	bool Setup(unsigned nbx, unsigned nby, unsigned nbz, unsigned nol, unsigned lnb,
					   float xmx, float ymx, float zmx,
					   bool hsc, int wty, bool lif, bool ipt, bool ilc);
	bool SetMesh(float* xarray, float* yarray, float* zarray, int* cindex, int clength,int ilength); 

	bool SetStream(char* stream, int length);
	
	const float* GetCoord() const;

	const int* GetCoordIndex() const;

	int GetCoordLength() const;

	int GetCoordIndexLength() const;

private:
 
	SSNode *da_geom;
	WSSNode *da_w_geom;
	unsigned nbBPX, nbBPY, nbBPZ, numberOfLevels, lengthNbBits, wtype;
	float xmax, ymax, zmax;
	bool hasScaleCoeff, lift, isPartial, isInLocalCoordinates;
	char* strm;
	int strmlength;

};
