/***********************************************************************
This software module was originally developed by Yannick Maret (from the
Ecole Polytechnique Federale de Lausanne, EPFL, during a stay at the
Universidad Politecnica de Madrid, UPM) in the course of development of 
the MPEG-4 Systems (ISO/IEC 14496-1) standard. This software module is
an implementation of a part of one or more MPEG-4 Systems 
(ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems
(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems 
(ISO/IEC 14496-1) free license to this software module or modifications
thereof for use in hardware or software products claiming conformance to
the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this 
software module in hardware or software products are advised that its 
use may infringe existing patents. The original developer of this 
software module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software module
or modifications thereof in an implementation. Copyright is not 
released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
EPFL and UPM retain full right to use the code for his/her own purpose,
assign or donate the code to a third party and to inhibit third parties 
from using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. This copyright notice must be included in all copies or 
derivative works. Copyright  2003-2005
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yannick Maret at Yannick.Maret@a3.epfl.ch or Francisco
Moran at fmb@gti.ssr.upm.es.
----------------------------------------------------------------------*/

/*-------------------------------------------------------------------------
Project Player3d
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  WaveSurfDecoder
FILE:       _SSsConfig.h
AUTHOR:     Yannick Maret (EPFL, UPM)
OVERVIEW:   Subdvision surfaces library configuration file.
-------------------------------------------------------------------------*/

#ifndef _SSLIB_SUBDIVISION_SURFACE_CONFIG_INCLUDED_
#define _SSLIB_SUBDIVISION_SURFACE_CONFIG_INCLUDED_
// *** DEBUG MODE ***
// DO NOT MODIFY _DEBUG_SSLIB_ HERE, INSTEAD TO (NOT) TURN ON
// DEBUG MODE ADD (REMOVE) THE PREPROCESSOR _DEBUG_SSLIB_
#ifdef _DEBUG_SSLIB_
   // *** DBG INFO CONFIGURATION ***
   #define _SS_DBG_VERBOSE_BASE      0
   #define _SS_DBG_VERBOSE_MASK      0
   #define _SS_DBG_VERBOSE_TAGS      0
   #define _SS_DBG_VERBOSE_BS        0
   #define _SS_DBG_VERBOSE_WAV_COEFF 0
   #define _SS_DBG_VERBOSE_BS_READER 1
   #define _SS_DBG_VERBOSE_SPIHT     0
   #define _SS_DBG_VERBOSE_FOREST    0
   #define _SS_DBG_VERBOSE_QUANT     0
   // *** NOT TO CHANGE ***
   #define _TIME_SSLIB_              0
   
#else
   // *** NON-DEBUG CONFIGURATION ***
   #define _TIME_SSLIB_              1
   // *** NOT TO CHANGE ***
   #define _SS_DBG_VERBOSE_BASE      0
   #define _SS_DBG_VERBOSE_MASK      0
   #define _SS_DBG_VERBOSE_TAGS      0
   #define _SS_DBG_VERBOSE_BS        0
   #define _SS_DBG_VERBOSE_WAV_COEFF 0
   #define _SS_DBG_VERBOSE_BS_READER 0
   #define _SS_DBG_VERBOSE_SPIHT     0
   #define _SS_DBG_VERBOSE_FOREST    0
   #define _SS_DBG_VERBOSE_QUANT     0
#endif
   #define _SS_NEED_IO  _TIME_SSLIB_ || _DEBUG_SSLIB_
#endif _SSLIB_SUBDIVISION_SURFACE_CONFIG_INCLUDED_