/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(VDOnet Corp.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. VDOnet Corp. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1998.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Zvi Lifshitz at zvil@vdo.net or zvil@compuserve.com.
----------------------------------------------------------------------*/

#if !defined(_g723dec_h)	// Sentry, use file only if it's not already included.
#define _g723dec_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Decoder
FILE:       G723GDec.h
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Definition of G723Decoder (simulation)
-------------------------------------------------------------------------*/
#include "DecoderImp.h"

extern "C"
{
// SOLARIS PORTING
#ifdef WIN32
	CALLBACK INITdec (short nCode);
	CALLBACK DecSoundFrame (LPVOID pBlockIn, LPVOID pBlockOut);
#else
	int G723Dec (char * pBlockIn, char * pBlockOut);
	void Init_Dec_Cng (void);
	void Init_Decod (void);
#endif
}
#define DECODE_ERROR   SHRT_MAX
#define G723_53 0
#define G723_63 1

class G723Decoder : public DecoderImp
{
	int m_nSamples;

private:
	virtual BOOL SetFormat (
		Capabilities &formatOptions,
		DecoderParams &decoderParams
	);
	virtual int GetOptimalOutputSize () {return 480;}
	virtual BOOL Decode (
		LPBYTE pInput,
		int nInputLength,
		LPBYTE pOutput,
		int &rnOutputLength
	);
	virtual int GetDataOffset  (const LPBYTE pFrame);
	virtual DWORD GetAttributes (
		ATTRIBUTE_CODE code, 
		const LPBYTE pFrame
	);
	virtual void Run ();
};

#endif                                      // _g723dec_h sentry.
