/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(VDOnet Corp.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. VDOnet Corp. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1998.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Zvi Lifshitz at zvil@vdo.net or zvil@compuserve.com.
----------------------------------------------------------------------*/

#include <windows.h>

#ifndef DEC_STRUCTURES
#define DEC_STRUCTURES

typedef struct 
{
	int h263;
	int pels;
	int lines;
	int trd;
	int trb;
	int quant;
    int fast;
    int me8x8;
    int me4x4;
	int bquant;
	int Key;
	int Arith;
	int Advanced;
	int Edge;
	int Bframe;
	int VersionNumber;
	int AddInfo;
	int FrameNumber;
	int CompSize;
	unsigned char *Prev[3];
	unsigned char *Recon[3];
	unsigned char *PrevN[3];
	unsigned char *Compressed;
	unsigned char **Output[3];
	unsigned char *MBlocks;
	unsigned char *LineMod;
	int Reserved[10];
} StructFrameInfo;


typedef struct {
  StructFrameInfo FrameInfo;
  unsigned char * DecFrameBuffer;
  unsigned char * VDODecBuffer;
  int Swap;
} DecodeInst;

#endif DEC_STRUCTURES


extern void WINAPI
InitFrameInstDecW(int pels, int lines, DecodeInst * pDecodeInst);

extern int WINAPI
DecInstFrameW(DecodeInst * pDecodeInst, int Level, unsigned char * Compressed);

extern void WINAPI
GetFrameInstMemSizeW(int pels, int lines, int * VDODecBufferSize);

extern void WINAPI
GetCommonDecMemSizeW(int * DecFrameBufferSize);

extern void WINAPI
InitCommonDecMemW(unsigned char * DecFrameBuffer);

extern void WINAPI
RestoreCommonDecMemW(unsigned char * DecFrameBuffer);

extern int WINAPI
ExtractLevelInstW(unsigned char  * Input,char CurrLevel,unsigned char ** LevelInput, int CompSize);


extern void WINAPI
InitDecLowResW(int pels, int lines);
extern void WINAPI
InitDecHighResW(int pels, int lines);
