#ifndef _H263Prevdec_h
#define _H263Prevdec_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Decoder
FILE:       H263PrevDec.h
AUTHOR:     Karl Anders ygard (Telenor R&D)
OVERVIEW:   Definition of H263PrevDecoder
-------------------------------------------------------------------------*/

#include "DecoderImp.h"
#include "H263Karlo.h"

class H263Decoder : public DecoderImp
{
	private:
	
	virtual BOOL SetFormat (
		Capabilities &formatOptions,
		DecoderParams &decoderParams
	);
	virtual int GetOptimalOutputSize ();
	virtual BOOL Decode (
		LPBYTE pInput,
		int nInputLength,
		LPBYTE pOutput,
		int &rnOutputLength
	);
	virtual int GetDataOffset  (const LPBYTE pFrame);
	virtual DWORD GetAttributes (
		ATTRIBUTE_CODE code, 
		const LPBYTE pFrame
	);
        H263Dec m_decoder;

public:
	H263Decoder () : DecoderImp () {}
};

#endif


// Emacs uses these...
// Local Variables:
// mode: c++
// tab-width: 4
// End:
