#ifndef _jpegdec_h
#define _jpegdec_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Decoder
FILE:       JPEGDec.h
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Definition of JPEGDecoder (simulation)
-------------------------------------------------------------------------*/
/*#include "Decoder.h"
#include "Caps.h"*/
#include "DecoderImp.h"


class JPEGDecoder : public DecoderImp
{
public:

	virtual BOOL Decode (
		LPBYTE pInput,
		int nInputLength,
		LPBYTE pOutput,
		int &rnOutputLength
	);

	virtual DWORD GetAttributes (
		ATTRIBUTE_CODE code, 
		const LPBYTE pFrame
	);
	
	virtual int GetOptimalInputSize () ;
	virtual int GetOptimalOutputSize () ;


private :
	
	WORD m_width, m_height;

// SOLARIS PORTING - Does not work with the 3D player
#ifndef PLAYER3D
	virtual BOOL SetFormat (Capabilities &formatOptions,	DecoderParams &decoderParams);
#endif
public:
	JPEGDecoder () : DecoderImp () {
// SOLARIS PORTING - the 3D player requires these initializations
#ifdef PLAYER3D
		m_width = 1024;
		m_height = 1024;
#endif
	}
};

#endif // _jpegdec_h
