/*
 * JpegDecodeInMemory
 *
 * Given a compressed JPEG image in the source buffer, decode it,
 * storing the result in the given output buffer.  Also return the
 * width and height of the image.
 *
 * If the output buffer isn't large enough, return FALSE, and set
 * destLength to be the required length.
 *
 * If the image is successfully decoded, return TRUE, and set
 * destLength to the actual length of the output image.
 *
 * If an error occurs decoding the image, the width, height and
 * destLength fields will be set to 0, and TRUE will be returned.
 */

#ifdef __cplusplus
extern "C" {
#endif

int JpegDecodeInMemory (unsigned char* pSource, int sourceLength,
						unsigned char* pDest, int* destLength,
						unsigned short* width, unsigned short* height);

#ifdef __cplusplus
}
#endif
