/***********************************************************************
This software module was originally developed by Marcos Aviles
(Universidad Politecnica de Madrid, UPM) in the course of development of 
the MPEG-4 Systems (ISO/IEC 14496-1) standard. This software module is
an implementation of a part of one or more MPEG-4 Systems 
(ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems
(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems 
(ISO/IEC 14496-1) free license to this software module or modifications
thereof for use in hardware or software products claiming conformance to
the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this 
software module in hardware or software products are advised that its 
use may infringe existing patents. The original developer of this 
software module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software module
or modifications thereof in an implementation. Copyright is not 
released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
UPM retains full right to use the code for his/her own purpose, assign 
or donate the code to a third party and to inhibit third parties from 
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. This copyright notice must be included in all copies or 
derivative works. Copyright  2006
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Marcos Aviles at mar@gti.ssr.upm.es.
----------------------------------------------------------------------*/

#ifndef __JP2DEC_H__
#define __JP2DEC_H__

#include "DecoderImp.h"

class JP2Dec : public DecoderImp
{
public:
    JP2Dec();
    
    virtual BOOL Decode (LPBYTE pInput, int nInputLength, LPBYTE pOutput, int &rnOutputLength );
    virtual DWORD GetAttributes (ATTRIBUTE_CODE code, const LPBYTE pFrame);
    virtual int GetOptimalOutputSize () ;

private :
    virtual BOOL SetFormat(Capabilities &formatOptions, DecoderParams &decoderParams);

private:
    int m_nBPP, m_nWidth, m_nHeight, m_nOutsize, m_nPitch;
};

#endif // __JP2DEC_H__
