#include <stdio.h>
#include <stdlib.h>
#include "aac_adts_dsi.h"

void Usage(char *exec_name)
{
	fprintf(stderr, "Get a decoderSpecificInfo file from AAC adts bitstream --\n");
	fprintf(stderr, "Usage:\t%s [aac_adts_file] [aac_adts_dsi_file]\n", exec_name);

	exit(1);
}

void main(int argc, char* argv[])
{
	int err;
	FILE *fp1, *fp2;
	char *decoderSpecificInfo;
	unsigned int decoderSpecificInfoLen;

	if (argc != 3) 
		Usage (argv[0]);

	fp1 = fopen(argv[1], "rb");
	if (fp1==NULL) {
		fprintf (stderr,"file %s open error !\n", argv[1]);
		exit (1);
	}
	fp2 = fopen(argv[2], "wb");
	if (fp2==NULL) {
		fprintf (stderr,"file %s open error !\n", argv[2]);
		exit (1);
	}

	err = analyzeAACadtsFile ( fp1 );
	if (err) {
		fprintf (stderr,"Error in analyzeAACadtsFile () !\n");
		exit (1);
	}
	err = getDecoderSpecificInfo(&decoderSpecificInfo, &decoderSpecificInfoLen );
	if (err) {
		fprintf (stderr,"Error in getDecoderSpecificInfo () !\n");
		exit (1);
	}
	fwrite ((char *)decoderSpecificInfo, sizeof (char), decoderSpecificInfoLen, fp2);
	
	fclose (fp1);
	fclose (fp2);
}

