#if !defined(_BSAC_h)  // Sentry, use file only if it's not already included.
#define _BSAC_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Multiplexer
FILE:       BSAC.h
AUTHOR:     Dae-Sung Cho 	(dscho@sait.samsung.co.kr), Samsung AIT
OVERVIEW:   Declaration of BSAC, the class that handles BSAC streams
-------------------------------------------------------------------------*/

/*************************************************************************************
 
 This software module was originally developed by
 
	Dae-Sung Cho 	(dscho@sait.samsung.co.kr), Samsung AIT
 
 and edited by 

	Dae-Sung Cho	(dscho@sait.samsung.co.kr), Samsung AIT

 Those who intend to use this software module in hardware or software products
 are advised that its use may infringe existing patents and other intellectual
 property rights.
 
 We disclaim all warranties with regard to this software, including
 all implied warranties of merchantability and fitness.
 In no event, Samsung AIT shall be liable for any special, indirect or
 consequential damages or any damages whatsoever resulting from loss of
 data or profits arising out of or in connection with the use or performance
 of this software.
 
 Samsung AIT retains the full right to use the code for its own purpose, assign
 or donate the code to a third party and to inhibit third parties from using
 the code. This copyright notice must be included in all copies or derivative
 works.
 
 Copyright (c) 1997-2000 Samsung AIT all rights reserved

*************************************************************************************/
#ifdef _MP4FF_	// standard MP4 file format
#include "MP4Stream.h"
#else			// non-standard TRIFF file format
#include "MuxStream.h"
#endif
#include "bsac_parser.h"

class BSACStream : public Stream
{
// by D.S.CHO
	CBSACParser *m_pParser;	
	bool m_bEOF;				
	bool m_bHeader;
	unsigned char *m_pAUBuffer;	
	long m_lAULength;
	long m_lIndex;

	long m_lDTS;
	long m_lFrames;	
	int m_nNumChannel;
	long m_nSamplingFrequency;	
	int m_header;
//~by D.S.CHO

public:
	BSACStream (FILE *fStream, ESDesc *pDescriptor);	
	~BSACStream (); // by D.S.CHO
	//virtual long GetTimeStamp ();
	virtual long GetDTS ();
	virtual long GetCTS () {return m_lDTS;}
	virtual bool IsRAP ();
	virtual int GetChar ();
// by D.S.CHO SS
// by D.S.CHO NEW
//	virtual void set_i (int i) { m_lFrames=i; }
//	virtual int get_i () { return m_lFrames; }
//	virtual bool IsEnhancedStream () {return false;}
//	virtual int GetEnhancedType () {return 0;}
//~by D.S.CHO NEW	
//~by D.S.CHO SS
	unsigned char* GetAUBuffer();	// by D.S.CHO
	long GetAULength();		// by D.S.CHO
};

#endif	// _BSAC_h sentry