#if !defined(_BSAC_h)  // Sentry, use file only if it's not already included.
#define _BSAC_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  BifsEnc
FILE:       BSAC.h
AUTHOR:     Dae-Sung Cho 	(dscho@sait.samsung.co.kr), Samsung AIT
OVERVIEW:   Declaration of BSAC, the class that handles BSAC streams
-------------------------------------------------------------------------*/

/*************************************************************************************
 
 This software module was originally developed by
 
	Dae-Sung Cho 	(dscho@sait.samsung.co.kr), Samsung AIT
 
 and edited by 

	Dae-Sung Cho	(dscho@sait.samsung.co.kr), Samsung AIT

 Those who intend to use this software module in hardware or software products
 are advised that its use may infringe existing patents and other intellectual
 property rights.
 
 We disclaim all warranties with regard to this software, including
 all implied warranties of merchantability and fitness.
 In no event, Samsung AIT shall be liable for any special, indirect or
 consequential damages or any damages whatsoever resulting from loss of
 data or profits arising out of or in connection with the use or performance
 of this software.
 
 Samsung AIT retains the full right to use the code for its own purpose, assign
 or donate the code to a third party and to inhibit third parties from using
 the code. This copyright notice must be included in all copies or derivative
 works.
 
 Copyright (c) 1997-2000 Samsung AIT all rights reserved

*************************************************************************************/

#include "SaitStream.h" 
#include "bsac_parser.h"

class BSACStreamDSI : public StreamDSI
{
	bool m_bGetDecSpecificInfo;	
	unsigned char *m_pDecSpecificInfo;
	long m_lDsiLength;
	CBSACParser *m_pParser;		
public:
	BSACStreamDSI (FILE *fStream);	
	~BSACStreamDSI (); 
	virtual BYTE* GetDecSpecificInfo ();
	virtual long GetDecSpecificInfoLen ();
};

#endif	// _BSAC_h sentry