/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1998.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Zvi Lifshitz at zvil@csi.com.
----------------------------------------------------------------------*/

/*************************************************************************************
 
 This software module was originally developed by
 
	Dae-Sung Cho 	(dscho@sait.samsung.co.kr), Samsung AIT
 
 and edited by 

	Dae-Sung Cho	(dscho@sait.samsung.co.kr), Samsung AIT

 Those who intend to use this software module in hardware or software products
 are advised that its use may infringe existing patents and other intellectual
 property rights.
 
 We disclaim all warranties with regard to this software, including
 all implied warranties of merchantability and fitness.
 In no event, Samsung AIT shall be liable for any special, indirect or
 consequential damages or any damages whatsoever resulting from loss of
 data or profits arising out of or in connection with the use or performance
 of this software.
 
 Samsung AIT retains the full right to use the code for its own purpose, assign
 or donate the code to a third party and to inhibit third parties from using
 the code. This copyright notice must be included in all copies or derivative
 works.
 
 Copyright (c) 1997-2000 Samsung AIT all rights reserved

*************************************************************************************/

#if !defined(_MPEG4VIDEO_h)  // Sentry, use file only if it's not already included.
#define _MPEG4VIDEO_h

// by D.S.CHO
//#include "MuxStream.h"
#ifdef _MP4FF_	// standard MP4 file format
#include "MP4Stream.h"
#else			// non-standard TRIFF file format
#include "MuxStream.h"
#endif
#include "mp4video_parser.h"
#include "mp4video_analyzer.h"	
//~by D.S.CHO

class MP4VIDEOStream : public Stream
{
// by D.S.CHO
	long m_lFrames;	
	float m_frameRate;
	long m_lDTS;
	long m_lCTS;	
	bool m_bRAP;
	bool m_bNextRAP;	
	bool m_bEOF;				
	bool m_bIsSessionHeader;	
	bool m_bScalability;
	long m_lHierarchyType;
	unsigned char *m_pAUBuffer;	
	long m_lAULength;
	long m_lIndex;	
	CMp4VideoParser *m_pParser;	
	CMp4VideoAnalyzer *m_pAnalyzer;		
	/*
	int m_cNext [4];
	long m_lFrames;
	BOOL m_firstStartCode;
	BOOL m_returnedStartCodeLastCall;
	float m_frameRate;
	long m_lDTS;
	bool m_bRAP;
	*/
//by D.S.CHO

public:
	MP4VIDEOStream (FILE *fStream, ESDesc *pDescriptor); 	
	~MP4VIDEOStream();	// by D.S.CHO
	virtual long GetDTS (long lNow = 0);
// by D.S.CHO
//	virtual long GetCTS () {return m_lDTS;}
	virtual long GetCTS ();
//~by D.S.CHO
	virtual bool IsRAP ();
	virtual int GetChar ();
// by D.S.CHO NEW
//	virtual void set_i (int i) { m_lFrames=i; }	
//	virtual int get_i () { return m_lFrames; }	
//	virtual bool IsEnhancedStream () { return m_bScalability; }
//	virtual int GetEnhancedType () { return m_lHierarchyType; }
//~by D.S.CHO NEW	
// by D.S.CHO
	unsigned char* GetAUBuffer();
	long GetAULength();		
//~by D.S.CHO
};

#endif	// _MPEG4VIDEO_h sentry