/*************************************************************************************
 
 This software module was originally developed by
 
	Dae-Sung Cho 	(dscho@sait.samsung.co.kr), Samsung AIT
 
 and edited by 

	Dae-Sung Cho	(dscho@sait.samsung.co.kr), Samsung AIT

 Those who intend to use this software module in hardware or software products
 are advised that its use may infringe existing patents and other intellectual
 property rights.
 
 We disclaim all warranties with regard to this software, including
 all implied warranties of merchantability and fitness.
 In no event, Samsung AIT shall be liable for any special, indirect or
 consequential damages or any damages whatsoever resulting from loss of
 data or profits arising out of or in connection with the use or performance
 of this software.
 
 Samsung AIT retains the full right to use the code for its own purpose, assign
 or donate the code to a third party and to inhibit third parties from using
 the code. This copyright notice must be included in all copies or derivative
 works.
 
 Copyright (c) 1997-2000 Samsung AIT all rights reserved

*************************************************************************************/

#include "defs.h"
#include "MP4VIDEO_dsi.h"

/*-----------------------------------------------------------------
MP4VIDEOStream constructor reads first 3 character
-----------------------------------------------------------------*/
MP4VIDEOStreamDSI :: MP4VIDEOStreamDSI (FILE *fStream) :
	StreamDSI (fStream), 
	m_bGetDecSpecificInfo (false),
	m_lDsiLength (-1)
{
	m_pParser = new CMp4VideoParser(fStream);	
	if (m_pParser == NULL) {
		fprintf (stderr," No infor for CMp4VideoParser objects \n");
		exit(0);
	}
}

MP4VIDEOStreamDSI :: ~MP4VIDEOStreamDSI ()
{
	if (m_pParser != NULL) {
		delete m_pParser;
		m_pParser = NULL;
	}
}

unsigned char* MP4VIDEOStreamDSI :: GetDecSpecificInfo ()
{
	if (m_bGetDecSpecificInfo==false) 
	{
		m_bGetDecSpecificInfo=true;		
		m_pParser->initParser(); 
		if (m_pParser->parseFrameHeader() == EOF) 
		{
			fprintf(stderr,"Error: Incorrect Header Parsing!!!!\n");
			exit(1);
		}
		m_pDecSpecificInfo = m_pParser->getOutFrameBuffer ();
		m_lDsiLength = m_pParser->getOutFrameLength ();
	}
	return m_pDecSpecificInfo;
}
	
long MP4VIDEOStreamDSI :: GetDecSpecificInfoLen ()
{
	if (m_bGetDecSpecificInfo) 
	{
		return m_lDsiLength;
	} else 
	{
		return -1;
	}
}	

static StreamDsiFactory<MP4VIDEOStreamDSI> MP4VideoFactory ("MPEG4-Video");	