/*************************************************************************************

 This software module was originally developed by

        Dae-Sung Cho    (dscho@sait.samsung.co.kr), Samsung AIT

 and edited by

        Dae-Sung Cho    (dscho@sait.samsung.co.kr), Samsung AIT

 Those who intend to use this software module in hardware or software products
 are advised that its use may infringe existing patents and other intellectual
 property rights.

 We disclaim all warranties with regard to this software, including
 all implied warranties of merchantability and fitness.
 In no event, Samsung AIT shall be liable for any special, indirect or
 consequential damages or any damages whatsoever resulting from loss of
 data or profits arising out of or in connection with the use or performance
 of this software.

 Samsung AIT retains the full right to use the code for its own purpose, assign
 or donate the code to a third party and to inhibit third parties from using
 the code. This copyright notice must be included in all copies or derivative
 works.

 Copyright (c) 1997-2000 Samsung AIT all rights reserved


 Required module :

 Authors :

 Changes :
        date            programmers     comment

*************************************************************************************/

#ifndef _BITSTREAM_I_H_
#define _BITSTREAM_I_H_

#include <stdio.h>
#include <stdlib.h>

#if !defined(EOF)
#define EOF (-1)
#endif

#define BFR_SIZE			2048
#define INBFR_BYTES			8
#define INBFR_TOTAL_BITS	3*INBFR_BYTES*8
#define SE_CODE				31

class CInBitstream
{
public:
	CInBitstream ();
	CInBitstream (FILE *file);
// by D.S.CHO NEW
	CInBitstream (unsigned char *buffer, int length);
//~by D.S.CHO NEW
	~CInBitstream ();

	void bitstreamOpen (FILE *file);
// by D.S.CHO NEW
	void bitstreamOpen (unsigned char *buffer, int length);
//~by D.S.CHO NEW
	void bitstreamClose ();
	void bitstreamFillBuffer ();
	unsigned int bitstreamShowBits (int nbits);
	unsigned int bitstreamLookAheadBit (int nth_bit);
	void bitstreamFlushBits (int nbits);
	unsigned int bitstreamReadBits (int nbits);

	int getBitstreamPosition(int *offset);
	int seekBitstream(int offset);
	void clone_bitstream(CInBitstream *stream0, CInBitstream *&stream1);
	unsigned int bitstreamByteAlign ();
	unsigned int bitstreamShowBitsByteAlign (int nbits);

	int checkBitStuffing();
	unsigned int bitstreamShowBitsAfterX (int xbits, int nbits);
#if 0
	unsigned int H263BitstreamByteAlign ();
	unsigned int H263BitstreamShowBitsByteAlign (int nbits);
#endif
	FILE* getInputFile() { return m_fptr; }	// by D.S.CHO 
	bool isBitstreamEnd () { return m_bEndBits; } 	// by D.S.CHO 
	int getReadBitsNumber () { return m_bitcnt; }	// by D.S.CHO

private:
    FILE *m_fptr;						// pointer to input file 
    unsigned char m_rdbfr[BFR_SIZE+4];	// bitstream data 
    unsigned char *m_rdptr;
    unsigned char m_inbfr[3*INBFR_BYTES];
    int m_incnt;						// remained bit number in m_inbfr[] 
    int m_bitcnt;						// read bit number 
    int m_rdbfr_bitcnt;					// added by D.S.CHO NEW
    bool m_bEof;							// eof of m_fptr is eof : added by D.S.CHO 
	bool m_bEndBits;					// end of data

// by D.S.CHO NEW
	unsigned char *m_pBuffer;	// pointer to input buffer
	int	m_nLength;				// length of input buffer
	int m_nRest;				// remained byte number for ptr
	int m_nIndex;				// current pointer to input buffer
	enum {
		FILE_IN,
		BUFFER_IN,
		NOT_DEFINED
	} m_inType;
// ~by D.S.CHO
};

#endif /* _BITSTREAM_H_ */
