/*************************************************************************************
 
 This software module was originally developed by
 
	Dae-Sung Cho 	(dscho@sait.samsung.co.kr), Samsung AIT
 
 and edited by 

	Dae-Sung Cho	(dscho@sait.samsung.co.kr), Samsung AIT

 Those who intend to use this software module in hardware or software products
 are advised that its use may infringe existing patents and other intellectual
 property rights.
 
 We disclaim all warranties with regard to this software, including
 all implied warranties of merchantability and fitness.
 In no event, Samsung AIT shall be liable for any special, indirect or
 consequential damages or any damages whatsoever resulting from loss of
 data or profits arising out of or in connection with the use or performance
 of this software.
 
 Samsung AIT retains the full right to use the code for its own purpose, assign
 or donate the code to a third party and to inhibit third parties from using
 the code. This copyright notice must be included in all copies or derivative
 works.
 
 Copyright (c) 1997-2000 Samsung AIT all rights reserved

*************************************************************************************/

/*****************************************************************************
 
Copyright (c) 2000 Samsung AIT
 
Title:
 
Abstract:
        bitstream generation
 
Module Name:
        bitstream_o.h
 
Author:
        Dae-Sung Cho (Samsung AIT) : 25-May-2000
 
*******************************************************************************/
#ifndef	_BITSTREAM_O_H_
#define	_BITSTREAM_O_H_

#include <stdio.h>
#include <math.h>

#define	DEFAULT_BUFSIZE	2048
#define BFR_INC		1024

class COutBitstream
{
public:
	COutBitstream();
	~COutBitstream();

	void bitstreamOpen();
	void bitstreamClose();
	void bitstreamInit();
	int bitstreamPutBits(int iValue, int iBits);
	void bitstreamFlush();
	int getBitstreamLength();
	unsigned char *getBitstreamBuffer(); //
	void bitstreamWrite(FILE *fp);

	void bitstreamAppend(COutBitstream *appendedBits);	// NEW
	int getLastBitsNumber();	// NEW
	int getLastByteValue();		// NEW
private:
	unsigned char *m_buffer;	//
	int m_bufsize;	/* allocated buffer size */
	int m_bufcnt;	/* actual number of buffer element */	
	int m_bytebuf;	/* one byte buffer */
	int m_bitnum;	/* actutal bit number to be filled in one byte buffer(8bits) */
};

#endif /* _BITSTREAM_O_H_ */
