/**************************************************************************************

 This software module was originally developed by
 
    Dae-Sung Cho 	(dscho@sait.samsung.co.kr), Samsung AIT
 
 and edited by 

	Dae-Sung Cho	(dscho@sait.samsung.co.kr), Samsung AIT

 Those who intend to use this software module in hardware or software products
 are advised that its use may infringe existing patents and other intellectual
 property rights.
 
 We disclaim all warranties with regard to this software, including
 all implied warranties of merchantability and fitness.
 In no event, Samsung AIT shall be liable for any special, indirect or
 consequential damages or any damages whatsoever resulting from loss of
 data or profits arising out of or in connection with the use or performance
 of this software.
 
 Samsung AIT retains the full right to use the code for its own purpose, assign
 or donate the code to a third party and to inhibit third parties from using
 the code. This copyright notice must be included in all copies or derivative
 works.
 
 Copyright (c) 1997-2000 Samsung AIT all rights reserved

 Required module :
 
 Authors : 

 Changes :
    	date      	programmers     comment


**************************************************************************************/

#if !defined(_BSAC_PARSER_H_)
#define _BSAC_PARSER_H_

#include "bitstream_i.h"
#include "bitstream_o.h"

#if !defined(EOF)
#define	EOF	(-1)
#endif

#define NUMBITS_ONE_BYTE	8
#define NUMBITS_TWO_BYTES	16

/* MPEG-4 BSAC Bitstream Parser */
class CBSACParser 
{
	CInBitstream *m_pInBitstream;
	COutBitstream *m_pOutBitstream;
	int m_nNumChannel;
public:
	CBSACParser();
	//CBSACParser(char *infile);	// by D.S.CHO SS
	CBSACParser(FILE *fStream);
	~CBSACParser();
	void openParser();
	//void openParser(char *infile);	// by D.S.CHO SS
	void openParser(FILE *fStream);
	void closeParser();

	void initParser() { m_pOutBitstream->bitstreamInit (); }
	int parseFrameHeader ();
	int parseFrame ();

	void writeFrame(FILE *fp) { m_pOutBitstream->bitstreamWrite(fp); }
	int getOutFrameLength() { return m_pOutBitstream->getBitstreamLength(); }
	unsigned char* getOutFrameBuffer() { return m_pOutBitstream->getBitstreamBuffer(); }

/*
private:
	int findFirstStartCode();
	int findNextStartCode();
	int findLastStartCode();
*/
};
#endif /* !defined(_BSAC_PARSER_H_) */

