/**************************************************************************************

 This software module was originally developed by
 
    Dae-Sung Cho 	(dscho@sait.samsung.co.kr), Samsung AIT
 
 and edited by 

	Dae-Sung Cho	(dscho@sait.samsung.co.kr), Samsung AIT

 Those who intend to use this software module in hardware or software products
 are advised that its use may infringe existing patents and other intellectual
 property rights.
 
 We disclaim all warranties with regard to this software, including
 all implied warranties of merchantability and fitness.
 In no event, Samsung AIT shall be liable for any special, indirect or
 consequential damages or any damages whatsoever resulting from loss of
 data or profits arising out of or in connection with the use or performance
 of this software.
 
 Samsung AIT retains the full right to use the code for its own purpose, assign
 or donate the code to a third party and to inhibit third parties from using
 the code. This copyright notice must be included in all copies or derivative
 works.
 
 Copyright (c) 1997-2000 Samsung AIT all rights reserved

 Required module :
 
 Authors : 

 Changes :
    	date      	programmers     comment


**************************************************************************************/

#if !defined(_MP4VIDEO_CODEHEAD_H_)
#define _MP4VIDEO_CODEHEAD_H_

#if !defined(EOF)
#define	EOF	(-1)
#endif

/* definition of header bitstream */
#define MARKER_BIT						1

#define NUMBITS_START_CODE				32	/* added by D.S.CHO */

#define START_CODE_PREFIX				1
#define NUMBITS_START_CODE_PREFIX		24
#define NUMBITS_START_CODE_SUFFIX		8

/* session overhead information */
#define SESSION_START_CODE				0xB0
#define SESSION_END_CODE				0xB1
#define USER_DATA_START_CODE			0xB2

/* VO overhead information */
#define NUMBITS_VO_START_CODE			3
#define VO_START_CODE					0
#define NUMBITS_VO_ID					5

/* VOL overhead information */
#define NUMBITS_SHORT_HEADER_START_CODE 22 
#define SHORT_VIDEO_START_MARKER        32 
#define NUMBITS_VOL_START_CODE			4
#define VOL_START_CODE					2
#define NUMBITS_VOL_ID					4
#define NUMBITS_VOL_SHAPE				2
#define NUMBITS_TIME_RESOLUTION			16
#define NUMBITS_VOL_FCODE				3
#define NUMBITS_SEP_MOTION_TEXTURE		1
#define NUMBITS_QMATRIX					8

/* GOV overhead information */
#define GOV_START_CODE					0xB3
#define NUMBITS_GOV_START_CODE			8
#define NUMBITS_GOV_TIMECODE_HOUR		5
#define NUMBITS_GOV_TIMECODE_MIN		6
#define NUMBITS_GOV_TIMECODE_SEC		6
#define GOV_CLOSED						0
#define NUMBITS_GOV_CLOSED				1
#define GOV_BROKEN_LINK					0
#define NUMBITS_GOV_BROKEN_LINK			1

// sprite data
#ifdef __VERIFICATION_MODEL_
#define NUMBITS_SPRITE_USAGE			2
#else
#define NUMBITS_SPRITE_USAGE			1
#endif //__VERIFICATION_MODEL_
#define NUMBITS_SPRITE_HDIM				13
#define NUMBITS_SPRITE_VDIM				13
#define NUMBITS_SPRITE_LEFT_EDGE		13
#define NUMBITS_SPRITE_TOP_EDGE			13
#define NUMBITS_NUM_SPRITE_POINTS		6
#define NUMBITS_WARPING_ACCURACY		2
#define SPRITE_MV_ESC					2
#define NUMBITS_SPRITE_MV_ESC			13
#define NUMBITS_SPRITE_MB_OFFSET		9  //low latency stuff
#define NUMBITS_SPRITE_XMIT_MODE		2  //low latency stuff

/* VOP overhead information */
#define VOP_START_CODE					0xB6
#define NUMBITS_VOP_START_CODE			8
#define NUMBITS_VOP_TIMEINCR			10
#define NUMBITS_VOP_HORIZONTAL_SPA_REF	13
#define NUMBITS_VOP_VERTICAL_SPA_REF	13
#define NUMBITS_VOP_WIDTH				13
#define NUMBITS_VOP_HEIGHT				13
#define NUMBITS_VOP_PRED_TYPE			2
#define NUMBITS_VOP_QUANTIZER			5
#define NUMBITS_VOP_ALPHA_QUANTIZER		6
#define NUMBITS_VOP_FCODE				3

/* Mp4Video Packet	overhead, added by Toshiba*/
#define	NUMBITS_VP_RESYNC_MARKER		17
#define	RESYNC_MARKER					0x1
#define	NUMBITS_VP_QUANTIZER			NUMBITS_VOP_QUANTIZER
#define	NUMBITS_VP_HEC					1
#define	NUMBITS_VP_PRED_TYPE			NUMBITS_VOP_PRED_TYPE
#define	NUMBITS_VP_INTRA_DC_SWITCH_THR	3

/* for Data Partitioning By Toshiba(1998-1-16:DP+RVLC)*/
#define	NUMBITS_DP_MOTION_MARKER		17
#define	MOTION_MARKER				0x1F001
#define	NUMBITS_DP_DC_MARKER			19
#define	DC_MARKER				0x6B001
/* End toshiba(1998-1-16:DP+RVLC)*/

// by D.S.CHO SS
/* for NEWPRED */
#define NUMBITS_NEWPRED_ENABLE						1
#define NUMBITS_REQUESTED_BACKWARD_MESSAGE_TYPE		2
#define NUMBITS_NEWPRED_SEGMENT_TYPE				1
#define NUMBITS_VOP_ID_FOR_PREDICTION_INDICATION	1
#define NUMBITS_VOP_ID_PLUS							3
//~by D.S.CHO SS

#endif /* !defined(_MP4VIDEO_CODEHEAD_H_) */

