/////////////////////////////////////////////////////////////////////////////////////
// 
// This software module was originally developed by
// 
//    Dae-Sung Cho 	(dscho@sait.samsung.co.kr), Samsung AIT
// 
// and edited by 
//
//	  Dae-Sung Cho	(dscho@sait.samsung.co.kr), Samsung AIT
//
// Those who intend to use this software module in hardware or software products
// are advised that its use may infringe existing patents and other intellectual
// property rights.
// 
// We disclaim all warranties with regard to this software, including
// all implied warranties of merchantability and fitness.
// In no event, Samsung AIT shall be liable for any special, indirect or
// consequential damages or any damages whatsoever resulting from loss of
// data or profits arising out of or in connection with the use or performance
// of this software.
// 
// Samsung AIT retains the full right to use the code for its own purpose, assign
// or donate the code to a third party and to inhibit third parties from using
// the code. This copyright notice must be included in all copies or derivative
// works.
// 
// Copyright (c) 1997-2000 Samsung AIT all rights reserved
// 
//
// Required module :
// 
// Authors : 
//
// Changes :
//    	date      	programmers     comment
//
//
/////////////////////////////////////////////////////////////////////////////////////

#if !defined(_mp4videodec_h)	// Sentry, use file only if it's not already included.
#define _mp4videodec_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Decoder
FILE:       H263GDec.h
AUTHOR:     Dae-Sung Cho (dscho@sait.samsung.co.kr), Samsung AIT 
OVERVIEW:   Definition of Mp4videoDecoder (simulation)
-------------------------------------------------------------------------*/

#include "DecoderImp.h"
// by D.S.CHO
//#include "DecInstW.h"
//#include "declib.h"
#include "video_decoder.h"
//~by D.S.CHO

// by D.S.CHO
#define CENTERJSAMPLE		128
#define MAXJSAMPLE		255
#define SCALEBITS		16					// speediest right-shift on some machines
#define ONE_HALF		((int) 1 << 15)		// ((int) 1 << (SCALEBITS-1))
#define FIX(x)			((int) ((x) * (1L<<16) + 0.5))	// ((int) ((x) * (1L<<SCALEBITS) + 0.5))
#define RIGHT_SHIFT(x,y)	(x>>y)
#define bound(value)		(value > 255 ? 255 : (value < 0 ? 0 : value))
//~by D.S.CHO

class Mp4videoDecoder : public DecoderImp
{
private:
	virtual BOOL Setup (
		const BYTE *pSpecificInfo,
		int nSpecificInfoLength,
		int	nESNumber
	);
	virtual BOOL SetFormat (
		Capabilities &formatOptions,
		DecoderParams &decoderParams
	);
	virtual int GetOptimalOutputSize ();
	virtual BOOL Decode (
		LPBYTE pInput,
		int nInputLength,
		LPBYTE pOutput,
		int &rnOutputLength
	);
	virtual int GetDataOffset  (const LPBYTE pFrame);
	virtual DWORD GetAttributes (
		ATTRIBUTE_CODE code, 
		const LPBYTE pFrame
	);

// by D.S.CHO
	virtual void Run ();

	void Yuv2RgbInit();	
	
	int  Cr_r_tab[256];
	int  Cb_b_tab[256];
	int  Cr_g_tab[256];
	int  Cb_g_tab[256];

	int		clip[1024];
	int		*clp;
	///////////////////HYE
	ZSemaphore m_smpActive; //hye
	int m_nOffSetX; //hye
	int m_nOffSetY; //hye
//	unsigned char *pxlBYframe; //hye , alpha info
	///////////////////~HYE
	LPBYTE m_pOutput;
	int m_pOutputSize;
	
	BITMAPINFOHEADER m_bitmapheader;
	bool		m_bIsAlpha;
	bool	m_bIsFirstDecodedData; //HYE
	int			m_nFrameBitsPerPixel;
	CVideoDecoder *m_pVideoDecoder; 
	/*
	TDecodeObject m_decodeObject;
	BITMAPINFOHEADER m_biDst, m_biSrc;

	LPBYTE tempOutput;		//ML added these
	int tempOutputSize;
	*/
//~by D.S.CHO

public :

//by D.S.CHO		
	Mp4videoDecoder ();
	~Mp4videoDecoder();
	/*
	Mp4videoDecoder () : DecoderImp ()
	{	//ML added this	
		tempOutputSize = GetOptimalOutputSize();
		tempOutput = (unsigned char*)malloc(304128);
	}
	//ML added this
	~Mp4videoDecoder()
	{ free(tempOutput); }
void  Run ();	
	*/
//~by D.S.CHO		
#ifdef _SAIT_3DTG_MP4VIDEO_
	int GetYUVFrameSize(void);
#endif _SAIT_3DTG_MP4VIDEO_
};

#endif                                      // _mp4videodec_h sentry.
