/////////////////////////////////////////////////////////////////////////////////////
// 
// This software module was originally developed by
// 
//    Dae-Sung Cho 	(dscho@sait.samsung.co.kr), Samsung AIT
// 
// and edited by 
//
//	  Dae-Sung Cho	(dscho@sait.samsung.co.kr), Samsung AIT
//
// Those who intend to use this software module in hardware or software products
// are advised that its use may infringe existing patents and other intellectual
// property rights.
// 
// We disclaim all warranties with regard to this software, including
// all implied warranties of merchantability and fitness.
// In no event, Samsung AIT shall be liable for any special, indirect or
// consequential damages or any damages whatsoever resulting from loss of
// data or profits arising out of or in connection with the use or performance
// of this software.
// 
// Samsung AIT retains the full right to use the code for its own purpose, assign
// or donate the code to a third party and to inhibit third parties from using
// the code. This copyright notice must be included in all copies or derivative
// works.
// 
// Copyright (c) 1997-2000 Samsung AIT all rights reserved
//
// Required module :
// 
// Authors : 
//
// Changes :
//    	date      	programmers     comment
//
//
/////////////////////////////////////////////////////////////////////////////////////
// decoderdll.cpp : dll export for mpeg4 decoder
//
/////////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include "video_decoder.h"

#define	DllExport __declspec (dllexport)

CVideoDecoder *g_pVideoDecoder;

// DLL export declaration
DllExport	void videoDecoderDllExportOpen();

DllExport	void videoDecoderStart(char *chrBitsFile, int &iDisplayWidth, int &iDisplayHeight, char *pBitstream, long lBitstreamLength,Bool bTemporalScalability=FALSE);
DllExport	void videoDecoder(char *pBitstream, long lBitstreamLength,Bool bTemporalScalability=FALSE);
DllExport	void videoDecoderEnd(Bool bTemporalScalability=FALSE);

DllExport	int getDecConfigInfoBitstreams (char *pInBitstream, long lInBitsLength, char *&pOutBitstream, long &lOutBitsOffset, long &lOutBitsLength);
DllExport	int getVOLheaderBitstreams (char *pInBitstream, long lInBitsLength, char *&pOutBitstream, long &lOutBitsOffset, long &lOutBitsLength);
DllExport	int getOneVopBitstreams (char *pInBitstream, long lInBitsLength, char *&pOutBitstream, long &lOutBitsOffset, long &lOutBitsLength);

DllExport	unsigned char *getYframe();
DllExport	unsigned char *getUframe();
DllExport	unsigned char *getVframe();
DllExport	unsigned char *getBYframe();

DllExport	int getDecodingTime(int layer);
DllExport	int getVopType (int layer);
DllExport	int getDisplayWidth(int layer);
DllExport	int getDisplayHeight(int layer);

DllExport	bool isShapeUsed(int layer);	
DllExport	bool isVideoDecoderEnd();

DllExport	void videoDecoderDllExportClose();
DllExport	void videoBufferB1FlushTS();
DllExport	void videoBufferB2FlushTS();

// KJH
DllExport	bool getScalabilityType(void);
//~KJH

void videoBufferB1FlushTS()
{
	g_pVideoDecoder->m_pvodec[ENHN_LAYER] -> bufferB1flush ();
}
void videoBufferB2FlushTS()
{
	g_pVideoDecoder->m_pvodec[ENHN_LAYER] -> bufferB2flush ();
}

// definition of the DLL exported functions
void videoDecoderDllExportOpen()
{
	g_pVideoDecoder = new CVideoDecoder;
}

void videoDecoderStart(char *chrBitsFile, int &iDisplayWidth, int &iDisplayHeight, char *pBitstream, long lBitstreamLength,Bool bTemporalScalability)
{
	g_pVideoDecoder->videoDecoderStart(chrBitsFile,iDisplayWidth,iDisplayHeight,pBitstream, lBitstreamLength,bTemporalScalability);
}

void videoDecoder(char *pBitstream, long lBitstreamLength,Bool bTemporalScalability)
{
	g_pVideoDecoder->videoDecoder(pBitstream, lBitstreamLength,bTemporalScalability);
}

void videoDecoderEnd(Bool bTemporalScalability)
{
	g_pVideoDecoder->videoDecoderEnd(bTemporalScalability);
}

int getDecConfigInfoBitstreams (char *pInBitstream, long lInBitsLength, char *&pOutBitstream, long &lOutBitsOffset, long &lOutBitsLength)
{
	return (g_pVideoDecoder->getDecConfigInfoBitstreams (pInBitstream, lInBitsLength, pOutBitstream, lOutBitsOffset, lOutBitsLength));
}

int getVOLheaderBitstreams (char *pInBitstream, long lInBitsLength, char *&pOutBitstream, long &lOutBitsOffset, long &lOutBitsLength)
{
	return (g_pVideoDecoder->getVOLheaderBitstreams (pInBitstream, lInBitsLength, pOutBitstream, lOutBitsOffset, lOutBitsLength));
}

int getOneVopBitstreams (char *pInBitstream, long lInBitsLength, char *&pOutBitstream, long &lOutBitsOffset, long &lOutBitsLength)
{
	return (g_pVideoDecoder->getOneVopBitstreams (pInBitstream, lInBitsLength, pOutBitstream, lOutBitsOffset, lOutBitsLength));
}

unsigned char *getYframe() 
{
	return (g_pVideoDecoder->getYframe());
}

unsigned char *getUframe() 
{
	return (g_pVideoDecoder->getUframe());
}

unsigned char *getVframe() 
{
	return (g_pVideoDecoder->getVframe());
}

unsigned char *getBYframe() 
{
	return (g_pVideoDecoder->getBYframe());
}

int getDecodingTime(int layer)
{
	return (g_pVideoDecoder->getDecodingTime(layer));
}

int getVopType (int layer) 
{
	return (g_pVideoDecoder->getVopType (layer));
}

int getDisplayWidth(int layer)
{
	return (g_pVideoDecoder->getDisplayWidth (layer));
}

int getDisplayHeight(int layer)
{
	return (g_pVideoDecoder->getDisplayHeight (layer));
}

bool isShapeUsed(int layer) 
{
	return (g_pVideoDecoder->isShapeUsed(layer));
}

bool isVideoDecoderEnd()
{
		return (g_pVideoDecoder->isVideoDecoderEnd());
}

void videoDecoderDllExportClose()
{
	delete g_pVideoDecoder;
}
bool getScalabilityType(void)
{
	return (g_pVideoDecoder->getScalabilityType());
}