/////////////////////////////////////////////////////////////////////////////////////
// 
// This software module was originally developed by
// 
//    Dae-Sung Cho 	(dscho@sait.samsung.co.kr), Samsung AIT
// 
// and edited by 
//
//	  Dae-Sung Cho	(dscho@sait.samsung.co.kr), Samsung AIT
//
// Those who intend to use this software module in hardware or software products
// are advised that its use may infringe existing patents and other intellectual
// property rights.
// 
// We disclaim all warranties with regard to this software, including
// all implied warranties of merchantability and fitness.
// In no event, Samsung AIT shall be liable for any special, indirect or
// consequential damages or any damages whatsoever resulting from loss of
// data or profits arising out of or in connection with the use or performance
// of this software.
// 
// Samsung AIT retains the full right to use the code for its own purpose, assign
// or donate the code to a third party and to inhibit third parties from using
// the code. This copyright notice must be included in all copies or derivative
// works.
// 
// Copyright (c) 1997-2000 Samsung AIT all rights reserved
//
// Required module :
// 
// Authors : 
//
// Changes :
//    	date      	programmers     comment
//
//
/////////////////////////////////////////////////////////////////////////////////////
// video_decoder.h : interface of the CVideoDecoder class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(_VIDEO_DECODER_H_)
#define _VIDEO_DECODER_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// by D.S.CHO (2000/05/30)
/*
#include "typeapi.h"
//#include "mode.hpp"
//#include "vopses.hpp"
//#include "entropy/bitstrm.hpp"
//#include "tps_enhcbuf.hpp"
//#include "decoder/enhcbufdec.hpp"
//#include "decoder/vopsedec.hpp"

//#include "dataStruct.hpp"
*/
#include "typeapi.h"
#include "mode.hpp"
#include "vopses.hpp"
#include "decoder/vopsedec.hpp"
// ~by D.S.CHO (2000/05/30)

// MPEG-4 Video Decoder ////////////////////////////////////////////////////////
class CVideoDecoder
{
public:
	CVideoDecoder() {
	m_pxlYframe = NULL;
	m_pxlUframe = NULL;
	m_pxlVframe = NULL;
	m_pxlBYframe = NULL;
	};
	~CVideoDecoder() {};
/*
	int findStartCode();
	void bitstreamVOLheader();
*/
	void videoDecoderStart(char *chrBitsFile, int &iDisplayWidth, int &iDisplayHeight, char *pBitstream=NULL, long lBitstreamLength=0,Bool bTScalability=FALSE);
	bool videoDecoder(char *pBitstream=NULL, long lBitstreamLength=0,Bool bTScalability=FALSE);
	void videoDecoderEnd(Bool bTScalability=FALSE);

	int getDecConfigInfoBitstreams (char *pInBitstream, long lInBitsLength, char *&pOutBitstream, long &lOutBitsOffset, long &lOutBitsLength);
	int getVOLheaderBitstreams (char *pInBitstream, long lInBitsLength, char *&pOutBitstream, long &lOutBitsOffset, long &lOutBitsLength);
	int getOneVopBitstreams (char *pInBitstream, long lInBitsLength, char *&pOutBitstream, long &lOutBitsOffset, long &lOutBitsLength);

	void getDisplayFrame(const CVOPU8YUVBA* pvopcQuant, AlphaUsage fAUsage, CRct& rct);
	unsigned char *getYframe() { return m_pxlYframe; }
	unsigned char *getUframe() { return m_pxlUframe; }
	unsigned char *getVframe() { return m_pxlVframe; }
	unsigned char *getBYframe() { return m_pxlBYframe; }

	int getDecodingTime(int layer = 0) { return (m_pvodec[layer]->show_current_time()); }
	int getVopType (int layer = 0) { return (m_pvodec[layer]->vopmd().vopPredType); }
	int getDisplayWidth(int layer = 0) { return (m_pvodec[layer]->getvolWidth()); }
	int getDisplayHeight(int layer = 0) { return (m_pvodec[layer]->getvolHeight()); }
// by D.S.CHO NEW
	int getFrameBitsPerPixel (int layer = 0) { return (int)m_pvodec[layer]->volmd().nBits; }
	bool isAlphaPlane (int layer = 0) { return m_pvodec[layer]->volmd().bShapeOnly==TRUE; }	
//~by D.S.CHO NEW

// HYE NEW
	void GetVopPos( int *vopleft, int *voptop, int *vopwidth, int *vopheight, int layer = 0){
		m_pvodec[layer]->GetVopPos( vopleft, voptop, vopwidth, vopheight); } 
	void GetVopPos( int *vopwidth, int *vopheight, int layer = 0){
		*vopwidth = m_rctDisplay.width; *vopheight = m_rctDisplay.height(); 
	}
	bool resetBuf(); 
	//void ReSetMemory(int width, int height); 
//~ HYE
	bool isShapeUsed(int layer = 0) { return ((m_pvodec [layer]->volmd ()).fAUsage!=RECTANGLE); }	
	bool isVideoDecoderEnd() { return (m_iEof==EOF); }
	CVideoObjectDecoder* m_pvodec [2];

	//KJH - decode whether TS or SS
	Bool m_bSpatialScalable;
	Bool m_bScalable;
	Bool getScalabilityType(void);
	//~KJH

protected:
	
	Bool m_main_short_video_header;
	CRct m_rctDisplay;	
	CRct m_rctDisplay_SSenh;

	unsigned char	*m_pInStream;	
	long			m_lBitPos;		// streampos type ??? 
	long			m_lBufLength;
	
	unsigned char	*m_pxlYframe;
	unsigned char	*m_pxlUframe;
	unsigned char	*m_pxlVframe;
	unsigned char	*m_pxlBYframe;

	Int m_iEof;
	Int m_nFrames;
	Bool m_bCachedRefFrame;
	Bool m_bCachedRefFrameCoded;
	//OBSS_SAIT_991015 //_SS_BASE_BVOP_
	Int m_iBASEVOP_time;
	Int m_iBASEVOP_PredType;
	Int m_iENHNVOP_time;
	//~OBSS_SAIT_991015 //_SS_BASE_BVOP_

	Bool m_iEnhanceLayer; // system level control TRUE-base layer FALSE-enhancement layer

	long findStartCode(CInBitStream* pbitstrmIn);
	
};

#endif // !defined(_VIDEO_DECODER_H_)