/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2002.
*/

//////////////////////////////////////////////////////////////////////////////
//		File: PNGDec.h
//
//		Author: Jean Le Feuvre ENST 2002
//
//		Content: IM1 wrapper for LibPNG
//
//		check PNG updates at http://www.libpng.org/pub/png/libpng.html
//////////////////////////////////////////////////////////////////////////////


#ifndef _PNGDEC_H
#define _PNGDEC_H


#include "DecoderImp.h"


class PNGDec : public DecoderImp
{
public:
	PNGDec() : DecoderImp () {
		m_Outsize=0;
	}

	virtual BOOL Decode (LPBYTE pInput, int nInputLength,
							LPBYTE pOutput, int &rnOutputLength );

	virtual DWORD GetAttributes (ATTRIBUTE_CODE code, const LPBYTE pFrame);
	virtual int GetOptimalOutputSize () ;
	unsigned int ReadData(BYTE *ptr, unsigned int length);

private :
	virtual BOOL SetFormat (Capabilities &formatOptions,	DecoderParams &decoderParams);
	BYTE *m_pInput;
	unsigned int m_InputLength, m_CurrentPos;
	unsigned int m_BPP, m_Width, m_Height, m_Outsize;
};

#endif // _PNGDEC_H
