/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/

// SOLARIS PORTING - Include defs.h for UNIX
#if defined(__UNIX) || defined(PLAYER3D)
#include "defs.h"
#endif
#include <assert.h>
// SOLARIS PORTING
#if defined(WIN32) && !defined(PLAYER3D)
#include "windows.h"
#endif // SOLARIS PORTING
#include "StDec.h"

/*-------------------------------------------------------------
The exported function that instantiates the proper decoder
-------------------------------------------------------------*/
void *CreateInstance ()
{
	return new StDecoder;
}

BOOL StDecoder::Decode(LPBYTE pInput,int nInputLength,LPBYTE pOutput,int &rnOutputLength)
{
int	i;
	if( rnOutputLength < nInputLength ){
		rnOutputLength  = nInputLength + 1;
		return( FALSE );
	}

	for( i =0 ; i < nInputLength ; i++ )
		pOutput[i] = pInput[i];


	return TRUE;
}



int StDecoder :: GetOptimalInputSize()
		{ return (15500*3); }
int StDecoder :: GetOptimalOutputSize()
	{ return 0; }


/*-------------------------------------------------------------
In this decoder, attributes are fixed for all units
-------------------------------------------------------------*/
DWORD StDecoder :: GetAttributes (
	ATTRIBUTE_CODE code,
	const LPBYTE
)
{
	switch (code) {
	case FRAME_WIDTH:
		return m_width;
	case FRAME_HEIGHT:
		return m_height;
	case PITCH:
		return 3*m_width;
	case OFFSETX:
		return 0;
	case OFFSETY:
		return 0;
	default:
		return 0;
	}
}
/*-----------------------------------------------------------------
Find a compatible format and initialize the decoder
-----------------------------------------------------------------*/

BOOL StDecoder :: SetFormat (
	Capabilities &formatOptions,
	DecoderParams &decoderParams
)
{
	decoderParams.m_nDBSize = 10000;
	decoderParams.m_nOptimalAUSize = 0;
	decoderParams.m_nCBSize = -1;
	decoderParams.m_bRequiresFullAUs = TRUE;

	if (formatOptions.GetFormatCapabilityLength () == 0)
		return FALSE;
	decoderParams.m_nStreamNumber = 0;
	decoderParams.m_format = MediaFormat :: RGB;

	return TRUE;
}