/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2003.
*/


///////////////////////////////////////////////////////////////////////////
// File: faad_dec.cpp
//
// Authors: Jean Le Feuvre ENST 2003
//
//	you will need the FAAC library available at www.audiocoding.com to use this plugin
//
//	NB: there seems to be a pb while compiling in release mode the lib, the compilation is OK but the
//	plugin crashes. You have to disable "nline function expansions" in the libfaad project in release mode
//	to have it working properly
//
///////////////////////////////////////////////////////////////////////////

#ifndef FAAD_DEC_H
#define FAAD_DEC_H

#include "DecoderImp.h"
#include "faad.h"

class Executive;

class FAAD_Dec : public DecoderImp
{
public:
	virtual DWORD GetAttributes(ATTRIBUTE_CODE code, const LPBYTE pFrame);
		
	FAAD_Dec(  );
	virtual ~FAAD_Dec();
        
	/* overrides from class Decoder */
	virtual BOOL Setup (const BYTE *pSpecificInfo, int nSpecificInfoLength, int	nESNumber );
	virtual BOOL SetFormat (Capabilities &formatOptions,DecoderParams &decoderParams);
	virtual int GetOptimalOutputSize();
	virtual BOOL Decode( LPBYTE pInput,int nInputLength, LPBYTE pOutput,int &rnOutputLength );

private:
	faacDecHandle m_pCodec;
	faacDecFrameInfo m_Info;
	unsigned long m_SampleRate;
	unsigned char m_NumChannels;
	unsigned int m_OutSize, m_NumSamples, m_ESNum;
};


#endif	//FAAD_DEC_H
