/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2003.
*/


///////////////////////////////////////////////////////////////////////////
// File: mad_dec.h
//
// Authors: Jean Le Feuvre ENST 2003
//
//	you will need the MAD library available at mad.sourceforge.net
//
///////////////////////////////////////////////////////////////////////////


#ifndef MAD_DEC_H
#define MAD_DEC_H

#include "DecoderImp.h"
#include "mad.h"

class Executive;

class MAD_Dec : public DecoderImp
{
public:
	virtual DWORD GetAttributes(ATTRIBUTE_CODE code, const LPBYTE pFrame);
		
	MAD_Dec(  );
	virtual ~MAD_Dec();
        
	/* overrides from class Decoder */
	virtual BOOL Setup (const BYTE *pSpecificInfo, int nSpecificInfoLength, int	nESNumber );
	virtual BOOL SetFormat (Capabilities &formatOptions,DecoderParams &decoderParams);
	virtual int GetOptimalOutputSize();
	virtual BOOL Decode( LPBYTE pInput,int nInputLength, LPBYTE pOutput,int &rnOutputLength );

private:
	unsigned long m_SampleRate;
	unsigned char m_NumChannels;
	unsigned int m_OutSize, m_NumSamples, m_ESNum;

	mad_frame frame;
	mad_stream stream;
	mad_synth synth;
	
	unsigned char m_buffer[40000];
	unsigned int m_len;
	BOOL m_bFirst;
};


#endif	//MAD_DEC_H
