/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2003.
*/


///////////////////////////////////////////////////////////////////////////
// File:  xvid_dec.h
// Description:
//   demo plugin for Osmose/IM1 SDK , MPEG4 visual decoder
//
//	Note: this decoder uses the XVID codec available at www.xvid.org
//
//	you will have to patch the codec with the files contained in xvid_addons.zip
//	in order to initialise the decoder
//
//		it could be possible to use the SigmaDesign version available
//	at http://www.sigmadesigns.com/products/MPEG4_video_encoder.htm which has roughly the same interface as xvid
//
///////////////////////////////////////////////////////////////////////////

#ifndef XVID_DEC_H 
#define XVID_DEC_H 

#include "DecoderImp.h"
#include "defs.h"

#include "my_xvid.h"

class XVIDDec : public DecoderImp
{
public :
	XVIDDec();
	~XVIDDec();
	
public:
	virtual BOOL Setup (const BYTE *pSpecificInfo, int nSpecificInfoLength, int	nESNumber );
	virtual BOOL SetFormat (Capabilities &formatOptions, DecoderParams &decoderParams);
	virtual int GetOptimalOutputSize ();
	virtual BOOL Decode (LPBYTE pInput, int nInputLength, LPBYTE pOutput, int &rnOutputLength);
	virtual int GetDataOffset(const LPBYTE pFrame);
	virtual DWORD GetAttributes(ATTRIBUTE_CODE code, const LPBYTE pFrame);

protected:
	virtual BOOL CanSkipOutput() {return TRUE; }

private:
	void *m_pCodec;
	int m_EsNum;
	int m_Width, m_Height;
	int m_OutSize;
	unsigned char *m_pConv;
};

#endif  // XVID_DEC_H 
