
//	This software module was originally developed by Massimo Balestri  (TILAB)	
//	in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//	This software module is an implementation of a part of one or more MPEG-4 
//	Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
//	14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	TILAB retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2002.


// BaseCommand.cpp


#include "BaseCommand.h"
#include "IPMP_Descriptor.h"
#include <stdlib.h>

USING_MOSES_NAMESPACE

BaseCommand::BaseCommand(byte tag):
	ExpandableBaseClass(tag)
{
	
}

BaseCommand::~BaseCommand() 
{

}



unsigned int BaseCommand::sizeOfInstance() const
{
	return 0;											// nothing (0 bytes)
}


BaseCommand * BaseCommand::createMessage(const byte * message)
{
	BaseCommand * pNewMessage = NULL;

    switch (message[0])
    {
    case IPMP_ToolDescrUpdateTag:
		//	pNewMessage=new IPMP_ToolDescrUpdate;
        break;
    
    case IPMP_ToolDescrRemoveTag:
        //	pNewMessage=new IPMP_ToolDescrRemove;
        break;
    
	// Add your new messages here....

    }

	if (pNewMessage != NULL)
	{
    	pNewMessage->fromBuffer(message);
	}

	return pNewMessage;
}

