
//	This software module was originally developed by Massimo Balestri  (TILAB)	
//	in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//	This software module is an implementation of a part of one or more MPEG-4 
//	Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
//	14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	ADETTI retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2002.


// BaseDescriptor.cpp


#include "BaseDescriptor.h"
#include "IPMP_Descriptor.h"
#include "IPMP_ToolListDescriptor.h"
#include "IPMP_Tool.h"
#include "IPMP_DescriptorPointer.h"
#include "IPMP_Descriptor.h"

#include <stdlib.h>

USING_MOSES_NAMESPACE

BaseDescriptor::BaseDescriptor(byte tag):
	ExpandableBaseClass(tag)
{
	
}

BaseDescriptor::~BaseDescriptor() 
{

}



unsigned int BaseDescriptor::sizeOfInstance() const
{
	return 0;											// nothing (0 bytes)
}


BaseDescriptor * BaseDescriptor::createMessage(const byte * message)
{
	BaseDescriptor * pNewMessage = NULL;

    switch (message[0])
    {
    case IPMP_ToolListDescrTag:
			pNewMessage=new IPMP_ToolListDescriptor();
        break;
       
    case IPMP_ToolTag:
        pNewMessage=new IPMP_Tool();
        break;

	case IPMP_DescrPointerTag:
		pNewMessage = new IPMP_DescriptorPointer();
		break;
		
	case IPMP_DescrTag:
		pNewMessage = new IPMP_Descriptor();
		break;

    }

	if (pNewMessage != NULL)
	{
    	pNewMessage->fromBuffer(message);
	}

	return pNewMessage;
}

