
//	This software module was originally developed by ADETTI in the course of
//	development of the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//	This software module is an implementation of a part of one or more MPEG-4 
//	Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
//	14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	ADETTI retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2002.


// IPMP_CanProcess.cpp

#include "IPMP_CanProcess.h"
#include <stdlib.h>
#include <memory.h>
#include <assert.h>

USING_MOSES_NAMESPACE

IPMP_CanProcess::IPMP_CanProcess()
	:	IPMP_Data_BaseClass(IPMP_CanProcess_tag)
{
	canProcess=false;
}	

IPMP_CanProcess::~IPMP_CanProcess() 
{

}


unsigned int IPMP_CanProcess::sizeOfInstance() const
{
	unsigned int size = IPMP_Data_BaseClass::sizeOfInstance();

	size += 1;
	
	return size;
}

int IPMP_CanProcess::fromBuffer(const byte * buf)
{
	IPMP_Data_BaseClass::fromBuffer(buf);
	canProcess = (get(1) != 0);			// control bit
	get(7);								// reserved
	return (getReadCounter());
}

int IPMP_CanProcess::toBuffer(byte * buf)
{
	IPMP_Data_BaseClass::toBuffer(buf);
	put(canProcess, 1);					// control bit
	put(0, 7);							// reserved
	return (getWriteCounter());	
}

void IPMP_CanProcess::setCanProcess()
{
	canProcess = true;
}

void IPMP_CanProcess::clearCanProcess()
{
	canProcess = false;
}

bool IPMP_CanProcess::getCanProcess() const
{
	return canProcess;
}



