
//	This software module was originally developed by ADETTI in the course of
//	development of the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//	This software module is an implementation of a part of one or more MPEG-4 
//	Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
//	14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	ADETTI retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2002.


// IPMP_CanProcess.h

#ifndef	IPMP_CANPROCESS_H
#define	IPMP_CANPROCESS_H

#include "IPMP_Data_BaseClass.h"

#include "namespace.h"

BEGIN_MOSES_NAMESPACE

/** @class IPMP_CanProcess
 *  Sent from a Tool to the Terminal to allow or refuse content processing.
 *
 *  @author ADETTI
 *  @date 2002
 */
class IPMP_CanProcess: public IPMP_Data_BaseClass 
{
private:
	bool canProcess;

public:
	IPMP_CanProcess();								///< constructor				
	virtual ~IPMP_CanProcess();						///< destructor
	virtual int toBuffer(byte * buf);				// reimplemented
	virtual int fromBuffer(const byte * buf);		// reimplemented
	virtual unsigned int sizeOfInstance() const;	// reimplemented

	/**
	 * Set the canProcess bit to <i>true</i>.
	 */
	void setCanProcess();
	
	/**
	 * Clear (set to <i>false</i>) the canProcess bit.
	 */
	void clearCanProcess();
	
	/**
	 * Get the value of the canProcess bit.
	 * @return the value of the canProcess bit
	 */
	bool getCanProcess() const;
};

END_MOSES_NAMESPACE

#endif

