
//	This software module was originally developed by Claudio Alberti (EPFL)	
//	in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//	This software module is an implementation of a part of one or more MPEG-4 
//	Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
//	14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	EPFL retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2002.


// IPMP_ConnectTool.cpp

#include "IPMP_ConnectTool.h"
#include <memory.h>

USING_MOSES_NAMESPACE

IPMP_ConnectTool::IPMP_ConnectTool()
:IPMP_Data_BaseClass( IPMP_ConnectTool_tag )
{
}	


IPMP_ConnectTool::~IPMP_ConnectTool() 
{

}

void IPMP_ConnectTool::setIPMP_Descriptor( byte *desc )
{
	ipmpDescriptor.fromBuffer( desc ) ;
}


const IPMP_Descriptor& IPMP_ConnectTool::getIPMP_Descriptor() const
{
	return ipmpDescriptor;
}

int IPMP_ConnectTool::fromBuffer(const byte*  buf)
{
	int nbits = IPMP_Data_BaseClass::fromBuffer(buf);
	nbits += ipmpDescriptor.fromBuffer( buf + (nbits/8)  ) ;
	return nbits;
}


int IPMP_ConnectTool::toBuffer(byte * buf)
{
	int nbits = IPMP_Data_BaseClass::toBuffer(buf);

	nbits += ipmpDescriptor.toBuffer( buf + (nbits/8)  ) ;
	return nbits;
}

unsigned int IPMP_ConnectTool::sizeOfInstance() const
{
	unsigned int size = IPMP_Data_BaseClass::sizeOfInstance();

	size += ipmpDescriptor.getSize();
	
	return size;
}

void IPMP_ConnectTool::setIPMP_Descriptor( IPMP_Descriptor& desc )
{
	ipmpDescriptor = desc;
};


