//
//	This software module was originally developed by Massimo Balestri (TILAB)
//  in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//	This software module is an implementation of a part of one or more MPEG-4 
//	Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
//	14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	Telecom Italia Lab S.p.A. retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2002.


#include "IPMP_DescriptorFromBitstream.h"

USING_MOSES_NAMESPACE

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IPMP_DescriptorFromBitstream::IPMP_DescriptorFromBitstream()
:IPMP_ToolMessageBase(IPMP_DescriptorFromBitstream_tag)
{

}

IPMP_DescriptorFromBitstream::~IPMP_DescriptorFromBitstream()
{

}

unsigned int IPMP_DescriptorFromBitstream::sizeOfInstance() const
{
	int nbits = IPMP_ToolMessageBase::sizeOfInstance();	// work out size of everything
	nbits += toolDescriptor.getSize() ;

	return nbits;											//  (13 bytes)
}

int IPMP_DescriptorFromBitstream::fromBuffer(const byte * buf)
{
	int nbits = IPMP_ToolMessageBase::fromBuffer(buf) ;	// read tag and size
	nbits += toolDescriptor.fromBuffer( buf+ nbits/8 ) ;

	return nbits;
}

int IPMP_DescriptorFromBitstream::toBuffer(byte * buf)
{
	int nbits = IPMP_ToolMessageBase::toBuffer(buf);		// write tag and size
	nbits += toolDescriptor.toBuffer( buf+ nbits/8 ) ;
	return nbits;
}
