
//	This software module was originally developed by Massimo Balestri (TILAB)
//  in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//	This software module is an implementation of a part of one or more MPEG-4 
//	Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
//	14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	Telecom Italia Lab S.p.A. retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2002.


#ifndef	__IPMP_DESCRIPTORFROMBITSTREAM_H__
#define	__IPMP_DESCRIPTORFROMBITSTREAM_H__

#include "IPMP_ToolMessageBase.h"
#include "IPMP_Descriptor.h"
#include "namespace.h"

BEGIN_MOSES_NAMESPACE

/**
 * @class IPMP_DescriptorFromBitstream
 * This message is used to deliver an IPMP_Descriptor received in the bitstream 
 * to the IPMP Tool specified in the IPMP_Descriptor.
 * The descriptor is carried in a public attribute of the class, named toolDescriptor.
 * @author Massimo Balestri
 * @date 2003
 */
class IPMP_DescriptorFromBitstream : public IPMP_ToolMessageBase  
{
public:
	IPMP_Descriptor toolDescriptor;					///< the  IPMP_Descriptor received in the bitstream.

	IPMP_DescriptorFromBitstream();					///< constructor
	virtual ~IPMP_DescriptorFromBitstream();		///< destructor
	virtual int toBuffer(byte * buf);				// reimplemented (same documentation)
	virtual int fromBuffer(const byte * buf);		// reimplemented
	virtual unsigned int sizeOfInstance() const;	// reimplemented
};

END_MOSES_NAMESPACE
#endif 
