
//	This software module was originally developed by James King (CRL), 
//  Leon Sucharov (CRL) and edited by Massimo Balestri (Telecom
//	Italia Lab S.p.A.) in the course of development of the MPEG-4 Systems 
//	(ISO/IEC 14496-1) standard. This software module is an implementation 
//	of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified 
//	by the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	CRL retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2000. 
//
//
//
//	Version developed by James King (CRL), Leon Sucharov (CRL) on behalf of MOSES
//	More information on MOSES can be found at http://www.crl.co.uk/projects/moses/


// IPMP_DescriptorPointer.cpp: implementation of the IPMP_DescriptorPointer class.
//
//////////////////////////////////////////////////////////////////////

#include "IPMP_DescriptorPointer.h"

USING_MOSES_NAMESPACE

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IPMP_DescriptorPointer::IPMP_DescriptorPointer()
:BaseDescriptor( IPMP_DescrPointerTag )
{
	IPMP_DescriptorID = 0xFFFF;
	IPMP_ES_ID = 0xFFFF;
	descrType = HOOKS_TYPE;
}

IPMP_DescriptorPointer::~IPMP_DescriptorPointer()
{
}

int IPMP_DescriptorPointer::fromBuffer(const byte * buf)
{
	BaseDescriptor::fromBuffer(buf);	
	
	IPMP_DescriptorID = get(8);				// hooks version
	if (IPMP_DescriptorID == 0xFF)
	{
		descrType = IPMPX_TYPE;
		IPMP_DescriptorID = get(16);		// IPMPX version
		IPMP_ES_ID = get(16) ;
	}
	return getReadCounter();
}


int IPMP_DescriptorPointer::toBuffer(byte * buf)
{
	BaseDescriptor::toBuffer(buf);	

	put(0xFF, 8);							// when writing, always use the IPMPX version
	put( IPMP_DescriptorID, 16);
	put( IPMP_ES_ID, 16);

	return getWriteCounter() ;
}

unsigned int IPMP_DescriptorPointer::sizeOfInstance() const
{
	return ( BaseDescriptor::sizeOfInstance() + 5) ;
}


void IPMP_DescriptorPointer::setIPMP_DescriptorID(unsigned short value)
{
	IPMP_DescriptorID = value;
}


unsigned short IPMP_DescriptorPointer::getIPMP_DescriptorID() const
{
	return (unsigned short) IPMP_DescriptorID ;
}

void IPMP_DescriptorPointer::setIPMP_ES_ID(unsigned short es_id)
{
	IPMP_ES_ID = es_id;
}

unsigned short IPMP_DescriptorPointer::getIPMP_ES_ID()
{
	return (unsigned short) IPMP_ES_ID;
}
