
//	This software module was originally developed by Claudio Alberti (EPFL)	
//	in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//	This software module is an implementation of a part of one or more MPEG-4 
//	Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
//	14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	EPFL retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2002.


// IPMP_DisconnectTool.cpp

#include "IPMP_DisconnectTool.h"
#include <memory.h>

USING_MOSES_NAMESPACE


IPMP_DisconnectTool::IPMP_DisconnectTool()
	:IPMP_Data_BaseClass(IPMP_DisconnectTool_tag)
{
}	

IPMP_DisconnectTool::~IPMP_DisconnectTool() 
{

}


int IPMP_DisconnectTool::fromBuffer(const byte * buf)
{
	IPMP_Data_BaseClass::fromBuffer(buf);
	IPMP_ToolContextID = get(32);
	return getReadCounter();
}


int IPMP_DisconnectTool::toBuffer(byte * buf)
{
	IPMP_Data_BaseClass::toBuffer(buf);
	put(IPMP_ToolContextID, 32);
	return getWriteCounter();
}

unsigned int IPMP_DisconnectTool::sizeOfInstance() const
{
	return IPMP_Data_BaseClass::sizeOfInstance() + 4;
}

void IPMP_DisconnectTool::setIPMP_ToolContextID(word32 contextID)
{
	IPMP_ToolContextID = contextID;
}

word32 IPMP_DisconnectTool::getIPMP_ToolContextID() const
{
	return IPMP_ToolContextID;
}