
//	This software module was originally developed by Claudio Alberti (EPFL)	
//  and edited by Massimo Balestri (Telecom Italia Lab)
//	in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//	This software module is an implementation of a part of one or more MPEG-4 
//	Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
//	14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	EPFL retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2002.

// IPMP_DisconnectTool.h

#ifndef	IPMP_DISCONNECTTOOL_H
#define	IPMP_DISCONNECTTOOL_H

#include "IPMP_Data_BaseClass.h"
#include "namespace.h"

BEGIN_MOSES_NAMESPACE

/** 
 *  @class IPMP_DisconnectTool
 *  This message allows a tool to disconnect a tool it 
 *	has previously connected at a control point.
 *
 *  @author Claudio Alberti
 *  @date 2002
 */
class IPMP_DisconnectTool: public IPMP_Data_BaseClass 
{
private:
	word32 IPMP_ToolContextID;

public:
	IPMP_DisconnectTool();								///< constructor
	virtual ~IPMP_DisconnectTool();						///< destructor		
	virtual int toBuffer(byte * buf);					// reimplemented
	virtual int fromBuffer(const byte * buf);			// reimplemented
	virtual unsigned int sizeOfInstance() const;		// reimplemented
	
	/**
	 * Set the context ID.
	 * @param contextID the context ID of the Tool to be disconnected.
	 */
	void setIPMP_ToolContextID(word32 contextID);

	/**
	 * Get the context ID.
	 * @return the context ID of the Tool to be disconnected.
	 */
	word32 getIPMP_ToolContextID() const;

};

END_MOSES_NAMESPACE

#endif
