
//	This software module was originally developed by Claudio Alberti (EPFL)	and
//  edited by Massimo Balestri (Telecom Italia Lab)  
//	in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//	This software module is an implementation of a part of one or more MPEG-4 
//	Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
//	14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	EPFL retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2002.

// IPMP_GetToolsResponse.h

#ifndef	IPMP_GETTOOLSRESPONSE_H
#define	IPMP_GETTOOLSRESPONSE_H

#include "IPMP_Data_BaseClass.h"
#include "Container.h"
#include "IPMP_Tool.h"
#include "namespace.h"

BEGIN_MOSES_NAMESPACE

/**
 * @class IPMP_GetToolsResponse
 * This message is sent by the Terminal to a Tool in reply of an IPMP_GetTools request.
 * It returns the list of Tools, instantiated or not, that are available on the Terminal.
 *
 * @author Claudio Alberti, Massimo Balestri
 * @date 2002
 */
class IPMP_GetToolsResponse: public IPMP_Data_BaseClass 
{
public:
	Container<IPMP_Tool> tools;		///< the list of tools available to the Terminal.

	IPMP_GetToolsResponse();									///< constructor
	IPMP_GetToolsResponse(const IPMP_GetToolsResponse & obj);	///< copy constructor
	virtual ~IPMP_GetToolsResponse();							///< destructor
	virtual int toBuffer(byte * buf);				// reimplemented	
	virtual int fromBuffer(const byte * buf);		// reimplemented
	virtual unsigned int sizeOfInstance() const;	// reimplemented
};

END_MOSES_NAMESPACE

#endif
