
//	This software module was originally developed by ADETTI in the course of
//	development of the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//	This software module is an implementation of a part of one or more MPEG-4 
//	Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
//	14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	ADETTI retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2002.


// IPMP_InitAuthentication.cpp

#include "IPMP_InitAuthentication.h"

#include <assert.h>

USING_MOSES_NAMESPACE

IPMP_InitAuthentication::IPMP_InitAuthentication()
	:	IPMP_Data_BaseClass(IPMP_InitAuthentication_tag)
{
	context  = 0;
	authType = 0;
}	

IPMP_InitAuthentication::~IPMP_InitAuthentication() 
{

}

// compute size, in BYTES!
unsigned int IPMP_InitAuthentication::sizeOfInstance() const
{
	unsigned int size = IPMP_Data_BaseClass::sizeOfInstance();

	size += 4; // sizeof(context)
	size += 1; // sizeof(authType)
	
	return size;
}

int IPMP_InitAuthentication::fromBuffer(const byte * buf)
{
	IPMP_Data_BaseClass::fromBuffer(buf);
	context = get(32);
	authType = get(8);
	return getReadCounter();
}

int IPMP_InitAuthentication::toBuffer(byte * buf)
{
	IPMP_Data_BaseClass::toBuffer(buf);
	put(context, 32);
	put(authType, 8);
	return (getWriteCounter());
}

void IPMP_InitAuthentication::setContext(word32 c)
{
	context = c;
}

word32 IPMP_InitAuthentication::getContext() const
{
	return context;
}

void IPMP_InitAuthentication::setAuthType(word32 at)
{
	authType = at;
}

word32 IPMP_InitAuthentication::getAuthType() const
{
	return authType;
}

