
//	This software module was originally developed by Claudio Alberti (EPFL)	
//	in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//	This software module is an implementation of a part of one or more MPEG-4 
//	Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
//	14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	EPFL retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2002.


// IPMP_MessageFromBitstream.cpp

#include "IPMP_MessageFromBitstream.h"
#include <memory.h>
#include <string.h>
#include <assert.h>

USING_MOSES_NAMESPACE

IPMP_MessageFromBitstream::IPMP_MessageFromBitstream() 
:	IPMP_ToolMessageBase(IPMP_MessageFromBitstream_tag)
{
	
}


IPMP_MessageFromBitstream::~IPMP_MessageFromBitstream() 
{

}

int IPMP_MessageFromBitstream::fromBuffer(const byte * buf)
{
    IPMP_ToolMessageBase::fromBuffer(buf);

	long endOfMessages = 8*(getSizeOfInstance() - 9) + getReadCounter();

	while (getReadCounter() < endOfMessages)		// read all messages
	{
		IPMP_Message msg;
		getObject(msg);
		message.addObject(msg);
	}

	return (getReadCounter());
}


int IPMP_MessageFromBitstream::toBuffer(byte * buf)
{
	IPMP_ToolMessageBase::toBuffer(buf);
	
	unsigned int numMessages = message.getObjectNum();

	for(word32 i = 0; i < numMessages; i++)
		putObject(message.getObject(i));

	return (getWriteCounter());
}


unsigned int IPMP_MessageFromBitstream::sizeOfInstance() const
{
	unsigned int size = IPMP_ToolMessageBase::sizeOfInstance();
	unsigned int numMessages = message.getObjectNum();

	for(word32 i = 0; i < numMessages; i++)
		size += message.getObject(i).getSize();

	return size;									
}

