
//	This software module was originally developed by Claudio Alberti (EPFL)	
//	in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//	This software module is an implementation of a part of one or more MPEG-4 
//	Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
//	14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	EPFL retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2002.

// IPMP_MessageFromBitstream.h

#ifndef	IPMP_MESSAGEFROMBITSTREAM_H
#define	IPMP_MESSAGEFROMBITSTREAM_H

#include "IPMP_ToolMessageBase.h"
#include "IPMP_Message.h"
#include "Container.h"
#include "namespace.h"

BEGIN_MOSES_NAMESPACE

/** 
 * @class IPMP_MessageFromBitstream
 * This message is used to deliver IPMP_Message's received in the Content to the 
 * IPMP Tool context specified in the IPMP_DescriptorID of IPMP_Message. 
 * If an IPMP Access Unit delivered in the IPMP Elementary Stream contains more than 
 * one IPMP_StreamDataUpdate for a specific IPMP Tool, all IPMP_Message's for that tool 
 * will be included in a single IPMP_MessageFromBitstream.  
 * @author CRL
 * @date 2002
 */
class IPMP_MessageFromBitstream: public IPMP_ToolMessageBase 
{
public:
	Container<IPMP_Message> message;					///< the list of messages

	IPMP_MessageFromBitstream();						///< constructor
	virtual ~IPMP_MessageFromBitstream();				///< desctructor
	virtual int toBuffer(byte * buf);					// reimplemented
	virtual int fromBuffer(const byte * buf);			// reimplemented
	virtual unsigned int sizeOfInstance() const;		// reimplemented	
};

END_MOSES_NAMESPACE

#endif
