
//	This software module was originally developed by Claudio Alberti (EPFL)	
//  and modified by Massimo Balestri (TILAB)
//	in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//	This software module is an implementation of a part of one or more MPEG-4 
//	Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
//	14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	EPFL retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2002.


// IPMP_OpaqueData.cpp

#include "IPMP_OpaqueData.h"
#include <assert.h>

USING_MOSES_NAMESPACE

IPMP_OpaqueData::IPMP_OpaqueData():
	IPMP_Data_BaseClass(IPMP_OpaqueData_tag)			// set the correct tag
{
}	

IPMP_OpaqueData::~IPMP_OpaqueData() 
{
}

int IPMP_OpaqueData::getOpaqueDataSize() const
{
	return opaqueData.getDataSize();
}

const IPMP_ByteArray& IPMP_OpaqueData::getOpaqueData() const
{
	return opaqueData;
}

void IPMP_OpaqueData::setOpaqueData(const IPMP_ByteArray& od)
{ 
	opaqueData = od; 
}

int IPMP_OpaqueData::fromBuffer(const byte * buf)
{
	int nbits = IPMP_Data_BaseClass::fromBuffer(buf);
	assert((nbits % 8) == 0);
	nbits += opaqueData.fromBuffer(buf + (nbits/8));
	return nbits;
}


int IPMP_OpaqueData::toBuffer(byte * buf)
{
	int nbits = IPMP_Data_BaseClass::toBuffer(buf);
	assert((nbits % 8) == 0);
	nbits += opaqueData.toBuffer(buf + (nbits/8));
	return nbits;
}



unsigned int IPMP_OpaqueData::sizeOfInstance() const
{
	return (IPMP_Data_BaseClass::sizeOfInstance() +	opaqueData.getSize());		// size of the base class + opaqueData size.
}
