
//	This software module was originally developed by Liao Xuan (PSL)
//	in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//	This software module is an implementation of a part of one or more MPEG-4 
//	Systems (ISO/IEC 14496-1) deices as specified by the MPEG-4 Systems (ISO/IEC 
//	14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	PSL retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2003.


// IPMP_ResponseToContentRequest.h

#ifndef	IPMP_RESPONSETOCONTENTREQUEST_H
#define	IPMP_RESPONSETOCONTENTREQUEST_H

#include "IPMP_Data_BaseClass.h"

#include "namespace.h"

BEGIN_MOSES_NAMESPACE

/** @class IPMP_ResponseToContentRequest
 *  Response from the recipient device to the sender device regarding to the content request
 *
 *  @author Liao Xuan
 *  @date 2003
 */
class IPMP_ResponseToContentRequest: public IPMP_Data_BaseClass 
{
private:
	unsigned int response ;					                                     // 2 bits response

public:
	IPMP_ResponseToContentRequest();				                            ///< constructor				
	virtual ~IPMP_ResponseToContentRequest();		                            ///< destructor
	virtual int toBuffer(byte * buf);				                            // reimplemented
	virtual int fromBuffer(const byte * buf);		                            // reimplemented
	virtual unsigned int sizeOfInstance() const;	                            // reimplemented

	/**
	 * Set the response (2 bits)
	 * 00: Reserved
	 * 01: No Such content
	 * 10: Prohibit Copy/Move
	 * 11: Approved
	 */
	void setResponse( unsigned int );
	
	
	/**
	 * Get the value of the response bits.
	 * @return the value of the response bits
	 */
	unsigned int getResponse() const;
};

END_MOSES_NAMESPACE

#endif

