
//	This software module was originally developed by Massimo Balestri (TILAB)
//	in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//	This software module is an implementation of a part of one or more MPEG-4 
//	Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
//	14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	EPFL retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2002.


// IPMP_ToolListDescriptor.cpp

#include "IPMP_ToolListDescriptor.h"
#include <assert.h>
#include <stdlib.h>
#include <string.h>
#include "IPMP_Tool.h"

USING_MOSES_NAMESPACE

IPMP_ToolListDescriptor::IPMP_ToolListDescriptor()
:BaseDescriptor( IPMP_ToolListDescrTag )
{
}

IPMP_ToolListDescriptor::~IPMP_ToolListDescriptor()
{
}


int IPMP_ToolListDescriptor::fromBuffer(const byte * in)
{
	BaseDescriptor::fromBuffer( in );
	long eom = getReadCounter() + 8 * (getSizeOfInstance() - BaseDescriptor::sizeOfInstance());		// mark end of message

	while( getReadCounter() < eom )
	{	
		IPMP_Tool newtool;
		getObject(newtool);
		ipmpTool.addObject(newtool);
	}
	return getReadCounter();
}


int IPMP_ToolListDescriptor::toBuffer(byte * out)
{
	BaseDescriptor::toBuffer( out ) ;
	unsigned int num = ipmpTool.getObjectNum();

	for( unsigned int x=0; x<num; x++ )
		putObject(ipmpTool.getObject(x));
	
	return getWriteCounter(); 
}

unsigned int IPMP_ToolListDescriptor::sizeOfInstance() const
{
	int nbytes = BaseDescriptor::sizeOfInstance() ;
	unsigned int num = ipmpTool.getObjectNum();

	for( unsigned int x=0;x<num; x++ )
		nbytes += ipmpTool.getObject(x).getSize() ;

	return nbytes ;
}


