
//	This software module was originally developed by James King (CRL) and edited by
//  Massimo Balestri (Telecom Italia Lab)
//	in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//	This software module is an implementation of a part of one or more MPEG-4 
//	Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
//	14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	CRL retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2002.

// IPMP_ToolListDescriptor.h

#ifndef	IPMP_TOOLLISTDESCRIPTOR_H
#define	IPMP_TOOLLISTDESCRIPTOR_H

#include "namespace.h"
#include "BaseDescriptor.h"
#include "Container.h"

BEGIN_MOSES_NAMESPACE

class IPMP_Tool ;

/** 
 *  @class IPMP_ToolListDescriptor
 *  this message conveys the list of IPMP tools required to access the content
 *	associated with the IOD in which it is described. 
 *  
 *  @author Massimo Balestri
 *  @date 12/03/2003
 */
class IPMP_ToolListDescriptor: public BaseDescriptor 
{
private:

public:
	Container<IPMP_Tool> ipmpTool;		///< the vector of IPMP Tools descriptions


	/**
	 * constructor.
	 */
	IPMP_ToolListDescriptor();	
	
	/**
	 * destructor.
	 */
	virtual ~IPMP_ToolListDescriptor();		
	
	virtual int toBuffer(byte * buf);				// reimplemented
	virtual int fromBuffer(const byte * buf);		// reimplemented
	virtual unsigned int sizeOfInstance() const;	// reimplemented

};


END_MOSES_NAMESPACE

#endif