
//	This software module was originally developed by Claudio Alberti (EPFL)	
//	in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//	This software module is an implementation of a part of one or more MPEG-4 
//	Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
//	14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	EPFL retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2002.

// IPMP_ToolParamCapabilitiesQuery.h

#ifndef	IPMP_TOOLPARAMCAPABILITIESQUERY_H
#define	IPMP_TOOLPARAMCAPABILITIESQUERY_H

#include "IPMP_Data_BaseClass.h"
#include "IPMP_ParametricDescription.h"
#include "namespace.h"

/** @class IPMP_ToolParamCapabilitiesQuery
 *  This message allows a terminal to query a tool as for support 
 *  for a specific parametric description.  
 *  
 *  @author Claudio Alberti
 *  @date 2002
 */

BEGIN_MOSES_NAMESPACE

class IPMP_ToolParamCapabilitiesQuery: public IPMP_Data_BaseClass 
{
public:
	IPMP_ParametricDescription toolParamDesc;		///< the parametric description of the capability being queried.

public:
	/**
	 * constructor.
	 */
	IPMP_ToolParamCapabilitiesQuery();	
	/**
	 * destructor.
	 */
	virtual ~IPMP_ToolParamCapabilitiesQuery();		

	virtual int toBuffer(byte * buf);					// reimplemented
	virtual int fromBuffer(const byte * buf);			// reimplemented
	virtual unsigned int sizeOfInstance() const;		// reimplemented
};

END_MOSES_NAMESPACE

#endif
