
//	This software module was originally developed by Claudio Alberti (EPFL)	
//	in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//	This software module is an implementation of a part of one or more MPEG-4 
//	Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
//	14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	EPFL retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2002.


// IPMP_ToolParamCapabilitiesResponse.cpp

#include "IPMP_ToolParamCapabilitiesResponse.h"
#include <memory.h>

USING_MOSES_NAMESPACE

IPMP_ToolParamCapabilitiesResponse::IPMP_ToolParamCapabilitiesResponse() : 
	IPMP_Data_BaseClass( IPMP_ToolParamCapabilitiesResponse_tag ),
	capabilitiesSupported(0)
{

}	


IPMP_ToolParamCapabilitiesResponse::~IPMP_ToolParamCapabilitiesResponse() 
{

}

int IPMP_ToolParamCapabilitiesResponse::fromBuffer(const byte * buf)
{
	IPMP_Data_BaseClass::fromBuffer(buf);

	capabilitiesSupported = (get(1) == 1);			// 1 BIT
	skipReading(7);									// 7 RESERVED BITS

	return getReadCounter();
}


int IPMP_ToolParamCapabilitiesResponse::toBuffer(byte * buf)
{
	IPMP_Data_BaseClass::toBuffer(buf);

	put( capabilitiesSupported, 1);					// 1 BIT
	put( RESERVED, 7);								// 7 RESERVED BITS

	return getWriteCounter();
}

bool IPMP_ToolParamCapabilitiesResponse::areCapabilitiesSupported() const
{
	return capabilitiesSupported;
}

void IPMP_ToolParamCapabilitiesResponse::setCapabilitiesSupported(bool cs)
{
	capabilitiesSupported = cs;
}

unsigned int IPMP_ToolParamCapabilitiesResponse::sizeOfInstance() const
{
	// now compute the size of this instance.
	
	// 1 byte for flags
	int nSize = 1 + IPMP_Data_BaseClass::sizeOfInstance() ;

	return nSize;
}

