
//	This software module was originally developed by Massimo Balestri 
//	(Telecom Italia Lab S.p.A.) in the course of development 
//	of the MPEG-4 Systems (ISO/IEC 14496-1) standard. This software module 
//	is an implementation of a part of one or more MPEG-4 Systems (ISO/IEC 
//	14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
//	standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	Telecom Italia Lab S.p.A retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2000. 


#ifndef __LENGTH_H__
#define __LENGTH_H__
#include "BitField.h"
#include "namespace.h"

BEGIN_MOSES_NAMESPACE


/**
 *  @class Length
 *	@brief Reads and writes the "length" field as defined in MPEG-4 System (ISO/IES 14496-1)
 *  @author Massimo Balestri
 *  @date 2002
 */

class Length : public BitField
{
private:
	bool isCorrect;

public:
	unsigned int length;			///< the length field to be encoded/decoded
	Length();						///< constructor
	virtual ~Length();									///< desctructor
	virtual int fromBuffer(const unsigned char *buf);	///< read from buffer
	virtual int toBuffer(unsigned char *buf);			///< write into buffer
	unsigned int getSize() const;						///< get the size in bytes of the encoded "lenght"
	virtual bool checkSyntax() const;					///< check syntax correctness
};


END_MOSES_NAMESPACE

#endif
