
//	This software module was originally developed by Claudio Alberti 
//	(EPFL), in the course of development of the MPEG-4 Systems 
//	(ISO/IEC 14496-1) standard. This software module is an implementation 
//	of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified 
//	by the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	Telecom Italia Lab S.p.A retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2000. 


//common.h

#ifndef __COMMON_H__
#define __COMMON_H__


//----------- classes extending IPMP_Data_BaseClass ---------//

#include "IPMP_OpaqueData.h"
#include "IPMP_AudioWatermarkingInit.h"
#include "IPMP_VideoWatermarkingInit.h"
#include "IPMP_SelectiveDecryptionInit.h"
#include "IPMP_KeyData.h"
#include "IPMP_SendAudioWatermark.h"
#include "IPMP_SendVideoWatermark.h"
#include "IPMP_RightsData.h"
#include "IPMP_SecureContainer.h"
#include "IPMP_ToolNotificationListener.h"		// contains "add", "remove" and "notification" messages 
#include "IPMP_InitAuthentication.h"
#include "IPMP_MutualAuthentication.h"
#include "IPMP_UserQuery.h"
#include "IPMP_UserQueryResponse.h"
#include "IPMP_ToolParamCapabilitiesQuery.h"
#include "IPMP_ToolParamCapabilitiesResponse.h"
#include "IPMP_GetTools.h"
#include "IPMP_GetToolsResponse.h"
#include "IPMP_GetToolContext.h"
#include "IPMP_GetToolContextResponse.h"
#include "IPMP_ConnectTool.h"
#include "IPMP_DisconnectTool.h"
#include "IPMP_CanProcess.h"
#include "TrustSecurityMetadata.h"	
#include "IPMP_ParametricDescription.h"
#include "IPMP_ToolAPI_Config.h"

// for inter-device messages
#include "IPMP_RequestContent.h"
#include "IPMP_ResponseToContentRequest.h"
#include "IPMP_ContentTransfer.h"
#include "IPMP_RequestTool.h"
#include "IPMP_ResponseToToolRequest.h"
#include "IPMP_DeviceID_Notification.h"

//----------- classes extending BaseDescriptor ---------//

#include "IPMP_DescriptorPointer.h"
#include "IPMP_Descriptor.h"
#include "IPMP_ToolListDescriptor.h"
#include "IPMP_Tool.h"




//----------- classes extending IPMP_ToolMessageBase ----------//
#include "IPMP_MessageFromBitstream.h"
#include "IPMP_DescriptorFromBitstream.h"
#include "IPMP_MessageFromTool.h"




//----------- classes extending BaseCommand ----------------//
#include "IPMP_DescriptorUpdate.h"
// IPMP_DescriptorRemove							// NOT USED IN IPMP EXTENSION	


//----------- classes extending IPMP_DeviceMessageBase ----------//
#include "IPMP_MessageFromDevice.h"



#endif

