//  NULL user-defined extension 
//  this files is here just to allow the library to compile.
//  replace this file with your own extension of the standard IPMPX library if needed.

#include "IPMP_UserDefinedBase.h"
#include <stdlib.h>
#include <assert.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

USING_MOSES_NAMESPACE

IPMP_UserDefinedBase::IPMP_UserDefinedBase(byte tag)
:IPMP_Data_BaseClass(tag)
{
}

IPMP_UserDefinedBase::IPMP_UserDefinedBase(const IPMP_UserDefinedBase& msg)
:IPMP_Data_BaseClass(msg.getObjectId())
{
}

IPMP_UserDefinedBase::~IPMP_UserDefinedBase()
{
}

IPMP_Data_BaseClass * IPMP_UserDefinedBase::createMessage(byte tag)
{
	if (tag == 0)
		return NULL;
	
	IPMP_Data_BaseClass * pNewMessage = NULL;
	return pNewMessage;
}


IPMP_Data_BaseClass * IPMP_UserDefinedBase::createMessage(const byte * message, unsigned int & nBitRead )
{
	IPMP_Data_BaseClass * pNewMessage = createMessage(message[0]);
	
	if (pNewMessage != NULL)
	{
		nBitRead = pNewMessage->fromBuffer(message);
	}
	return pNewMessage;
}

IPMP_Data_BaseClass * IPMP_UserDefinedBase::createMessage(IPMP_Data_BaseClass &object)
{
	unsigned int size = object.getSize();
	byte * buffer = new byte[size + 1];			
	object.toBuffer(buffer);						// dump data into a buffer
	unsigned int nbitsRead;
	IPMP_Data_BaseClass * newobj = createMessage(buffer, nbitsRead);
	delete[] buffer;
	return newobj;
}

