//	This software module was originally developed by Craig A. Schultz 
//	(AccessTicket Systems Inc.)
//
//	in the course of development of the MPEG-4 Systems 
//	(ISO/IEC 14496-1) standard. This software module is an implementation 
//	of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified 
//	by the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	AccessTicket Systems Inc. retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2000. 

#ifndef _IPMP_TOOLES_STREAMDUMP_H_
#define _IPMP_TOOLES_STREAMDUMP_H_

#include <string>
//#include <stdio.h>
//#include <fcntl.h>
//#include <sys/stat.h>
//#include <io.h>

#include "IPMPXinterface.h"
#include "MediaStream.h"

class IPMPServicesFull;

class IPMP_ToolES_StreamDump
{
// Construction
public:
	IPMP_ToolES_StreamDump( ES_Descriptor		*	pESD
						  , MediaStream			*	ipmpToolStream 
						  , IPMPServicesFull	*	pParent 
						  , std::string			&	fileName );

	~IPMP_ToolES_StreamDump();
	void Start();
	void Stop();

// Private methods
private:
	bool Init() {return true;}
	void Run();
	void Terminate () {}
	int StartIPMPToolStreamDumpThread ()  {return m_IPMP_ToolES_StreamDumpThread.Begin ();}
	void IPMP_ToolES_StreamDumpThread ();
	void WaitForThread () {m_IPMP_ToolES_StreamDumpThread.Wait ();}

// Private members
private:
	std::string						toolFileName;
	BOOL							m_bActive;
	ZThread<IPMP_ToolES_StreamDump>	m_IPMP_ToolES_StreamDumpThread;
	ES_Descriptor				*	m_pESD;
	MediaStream					*	m_pIPMP_ToolES_Stream;
	IPMPServicesFull			*	m_pParent;

};

#endif	// _IPMP_TOOLES_STREAMDUMP_H_