//	This software module was originally developed by Craig A. Schultz 
//	(AccessTicket Systems Inc.)
//
//	in the course of development of the MPEG-4 Systems 
//	(ISO/IEC 14496-1) standard. This software module is an implementation 
//	of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified 
//	by the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	AccessTicket Systems Inc. retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2000. 

#include "IPMPXFull.h"
#include "IPMP_Messages.h"
#include "MessageDistributor.h"

MessageDistributor::MessageDistributor()
	: m_MessagePump(Run, this, THREAD_PRIORITY_LOWEST)
	, m_bActive	(false)
{
	if (StartMessagePump () == -1)
		throw;

	m_bActive = true;
}

MessageDistributor::~MessageDistributor()
{
	m_Wait.Set();
	m_bActive = false;
	WaitForThread ();

	ASSERT (m_MessagePump.GetThread () == NULL);
}

void
MessageDistributor::Run()
{
	//by Liao Xuan
	//ToolMessage * msg;
	IPMP_ToolMessageBase* msg;
	// by Liao Xuan

	m_Wait.Reset();
	while ( m_bActive )
	{
		m_Wait.Wait();
		if ( !m_bActive )
			return;

		m_MessageListAccess.P();

		for ( int i = m_MessageList.GetLength(); --i >= 0; )
		{	
			msg = m_MessageList[i];
			m_MessageList.DeleteFrom(i);
			//_asm{int 3};
			if ( msg->receiver != 0x00 )
			{	// Send on to tool
				for ( int j = m_pParent->ZAddressList.GetLength(); --j >= 0; )
					if ( m_pParent->ZAddressList[j].contextID == msg->receiver )
						((IPMPTool_Interface*)m_pParent->ZAddressList[j].ptrTool)->ReceiveMessage(msg);
			}	
			else
				m_pParent->ReceiveMessage( msg );

			//by Liao Xuan, cause memory release errors, to do
			if (msg!=NULL)
			{
				//delete msg;
				msg=NULL;
			}
			//by Liao Xuan
		}
		m_MessageListAccess.V();
//		m_Wait.Reset();
		if ( !m_bActive )
			return;
	}
}

// by Liao Xuan
//boolMessageDistributor::ReceiveMessage ( ToolMessage * msg )
bool MessageDistributor::ReceiveMessage ( IPMP_ToolMessageBase * msg )
// by Liao Xuan
{
	if ( msg == NULL )
		return false;

	// by Liao Xuan
	//ToolMessage * msgCopy;
	IPMP_ToolMessageBase * msgCopy;
	// by Liao Xuan

	msgCopy = msg->Copy();

	m_MessageListAccess.P();

	m_MessageList += msgCopy;

	m_MessageListAccess.V();

	m_Wait.Set();

	return true;
}
