//	This software module was originally developed by Craig A. Schultz 
//	(AccessTicket Systems Inc.)
//
//	in the course of development of the MPEG-4 Systems 
//	(ISO/IEC 14496-1) standard. This software module is an implementation 
//	of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified 
//	by the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products.     
//   
//	AccessTicket Systems Inc. retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2000. 

#include "defs.h"
#include "IPMP_Messages.h"
#include "ipmp_dummytool.h"

/*-------------------------------------------------------------
The exported function that instantiates the proper IPMPManager object
-------------------------------------------------------------*/
extern "C" void* CreateInstance ()
{
	/************** Add by Liao Xuan, to show IPMP information***********/
	OutputDebugString("Dummy Tool Loaded");
	MessageBox(NULL, "Dummy Tool Loaded", "IPMP Tool", MB_OK);
	/************** End: Add by Liao Xuan, to show IPMP information******/
	return new IPMP_DummyTool;
}

IPMP_DummyTool::IPMP_DummyTool ()
	: m_pMRInterface		(NULL)
	, myContextID			(0)
	, m_pMyIPMPDescriptor	(NULL)
{
	IPMPX_Tool::IPMPX_Tool();
}

IPMP_DummyTool::~IPMP_DummyTool()
{
}

/**********************Rewrite by Liao Xuan**************************/
/*bool IPMP_DummyTool::ReceiveMessage( ToolMessage	*	msg )
{
	for ( int i = msg->IPMP_MessageFromBitstream.GetLength(); --i >= 0; )
	{
		ProcessMessage( msg, msg->IPMP_MessageFromBitstream[i] );
	}
	for ( int j = msg->IPMP_DescriptorFromBitstream.GetLength(); --j >= 0; )
	{
		IPMP_Descriptor descriptor = *(msg->IPMP_DescriptorFromBitstream[j]);
	}
	return true;
}*/
bool IPMP_DummyTool::ReceiveMessage( IPMP_ToolMessageBase* msg )
{
	switch (msg->tag)
	{
		case(0x01): //IPMP_MessageFromBitstream
		{
			/********** Changed by Liao Xuan *******************/
			/* receive IPMP_MessageFromBitstream ***************/
			for ( int i = ((IPMP_MessageFromBitstream*)msg)->messages.GetLength(); --i >= 0; )
				ProcessBitstreamMessage( ((IPMP_MessageFromBitstream*)msg), (IPMP_Message*)((IPMP_MessageFromBitstream*)msg)->messages[i] );
			return true;
			//return false;
			/********** End: Changed by Liao Xuan **************/
		}
		case(0x02)://IPMP_DescriptorFromBitstream
		{
			for ( int i = ((IPMP_DescriptorFromBitstream*)msg)->toolDescriptor.GetLength(); --i >= 0; )
				IPMP_Descriptor descriptor = *(((IPMP_DescriptorFromBitstream*)msg)->toolDescriptor[i]);
			return true;
		}
		case(0x03)://IPMP_MessageFromTool
		{
			for ( int i = ((IPMP_MessageFromTool*)msg)->messages.GetLength(); --i >= 0; )
				ProcessMessage( ((IPMP_MessageFromTool*)msg), (IPMP_Data_BaseClass*)((IPMP_MessageFromTool*)msg)->messages[i] );
			return true;
		}
	}
	return false;
}
/*****************END: Rewrite by Liao Xuan**************************/

/***************** Add by Liao Xuan**********************************/
/* for processing IPMP_Messgaes from bitstreams						*/
bool IPMP_DummyTool::ProcessBitstreamMessage( 
						IPMP_MessageFromBitstream* base, 
						IPMP_Message* msg)
{
	int nIPMPData = ((IPMP_Message*)msg)->IPMP_ExtendedData.GetLength();// number of IPMPX data carried in this IPMP_Message
	for (int i=0; i < nIPMPData; i++)
	{
		switch (((IPMP_Message*)msg)->IPMP_ExtendedData[i]->GetTag())
		{
			case(TAG_IPMP_CanProcess):
			{
				MessageBox(NULL, "DummyTool Received CanProcess Message", "IPMP Stream Update", MB_OK);
				return true;
			}
			case(TAG_IPMP_KeyData):
			{
				IPMP_KeyData * keyData = new IPMP_KeyData;
				keyData = (IPMP_KeyData*)((IPMP_Message*)msg)->IPMP_ExtendedData[i];
				int startDTS = (int)keyData->startDTS;
				int exprDTS =  (int)keyData->expireDTS;

				//get key body from IPMP_KeyData
				int keylen = ((IPMP_KeyData*)keyData)->keyBody->array.GetLength();
				const char* keyPtr = (LPCSTR)(((IPMP_KeyData*)keyData)->keyBody->array);

				char info[200];
				sprintf(info, "DummyTool received a Key Data from IPMPS:\n Keybody: %s \n StartDTS: %d \n Exprire DTS: %d\n",keyPtr,startDTS, exprDTS );
				MessageBox(NULL, info, "IPMP Stream", MB_OK);
				return true;
			}
			default:
				return false;
		}
	}
	return false;
}
/*****************END: Add by Liao Xuan*****************************/



bool IPMP_DummyTool::ProcessData (	LPBYTE	pInput
									,int	nInputLength 
									, DWORD	dwTime )
{	
	OutputDebugString("IPMP_DummyTool:: Begin: ProcessData()\n");
	if ( m_pNextTool == NULL )
		return false;

	return m_pNextTool->ProcessData( pInput, nInputLength, dwTime );
}

/********************************* change by Liao Xuan **************/
//bool IPMP_DummyTool::ProcessMessage ( ToolMessage			*	base
							   //, IPMP_Data_BaseClass	*	msg	)
bool IPMP_DummyTool::ProcessMessage ( IPMP_MessageFromTool	*	base
									, IPMP_Data_BaseClass	*	msg)
/******************************END: change by Liao Xuan *************/
{
	OutputDebugString("IPMP_DummyTool:: Begin: ProcessMessage()");

	switch (msg->GetTag()){
	case(TAG_IPMP_Secure_Container):
			return false;
	case(TAG_IPMP_InitAuthentication):
			return false;
	case(TAG_IPMP_MutualAuthentication):
			return false;
	case(TAG_IPMP_UserQueryResponse):
			return false;
	case(TAG_IPMP_ToolParamCapabilitiesQuery):
			return false;
	case(TAG_IPMP_GetToolsResponse):
			return false;
	case(TAG_IPMP_GetToolContextResponse):
			return false;
	case(TAG_IPMP_NotifyToolEvent):
			return false;
	case(TAG_User_Initialize):
		{
			myContextID = base->receiver;
			memcpy( &m_pMRInterface
				  , LPCBYTE(((User_Initialize*)msg)->messageInterface)
				  , sizeof(void*) );

			/****** Change by Liao Xuan**************/
			//ToolMessage				newMsg;
			IPMP_MessageFromTool		newMsg;
			/****** End: Change by Liao Xuan*********/

			IPMP_CanProcess				payload;
			User_Initialized			anotherPayload;

			newMsg.receiver = 0x00;
			newMsg.sender = myContextID;

			memcpy( &m_pMyIPMPDescriptor
				  , LPCBYTE(((User_Initialize*)msg)->toolDescriptor)
				  , sizeof(void*) );

			// Read the contents of the IPMP_data field.
			for ( int ui = m_pMyIPMPDescriptor->IPMPX_Data.GetLength(); --ui >= 0; )
			{
				switch (m_pMyIPMPDescriptor->IPMPX_Data[ui]->GetTag()){
				case (TAG_IPMP_OpaqueData):
					{
						IPMP_OpaqueData * data = (IPMP_OpaqueData*)m_pMyIPMPDescriptor->IPMPX_Data[ui];
					}
				}
			}  
			payload.canProcess = true;

			/****** Change by Liao Xuan****************************/
			//newMsg.IPMP_MessageFromBitstream += &payload;
			//newMsg.IPMP_MessageFromBitstream += &anotherPayload;
			newMsg.messages += &payload;
			newMsg.messages += &anotherPayload;
			/****** End: Change by Liao Xuan***********************/

			m_pMRInterface->ReceiveMessage(&newMsg);
			return true;
		}
		case(TAG_IPMP_CanProcess):
			return false;
		default:
				return false;
	}
	return false;
}
