//	This software module was originally developed by Craig A. Schultz 
//	(AccessTicket Systems Inc.)
//
//	in the course of development of the MPEG-4 Systems 
//	(ISO/IEC 14496-1) standard. This software module is an implementation 
//	of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified 
//	by the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	AccessTicket Systems Inc. retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2000. 

#ifndef _IPMP_DUMMYTOOL_H_
#define _IPMP_DUMMYTOOL_H_

#include "IPMPX_Tool.h"

class IPMP_DummyTool : public IPMPX_Tool
{
public:
	IPMP_DummyTool();
	~IPMP_DummyTool();

	// IPMPTool_Interface interface methods.
	// by Liao Xuan
	//bool ReceiveMessage( ToolMessage* );
	bool ReceiveMessage( IPMP_ToolMessageBase*);
	// by Liao Xuan

	/********** Added by Liao Xuan **************************/
	/* to support Messages from Bitstream					*/
	bool IPMP_DummyTool::ProcessBitstreamMessage( 
						IPMP_MessageFromBitstream* base, 
						IPMP_Message* msg);
	/********** Added by Liao Xuan **************************/


	// Interface methods added by IPMPX_Tool
	bool ProcessData (
		LPBYTE,		// pInput,
		int,		// rnInputLength
		DWORD		// dwTime
		);		

private:
	// Helper method
	// by Liao Xuan
	//bool ProcessMessage ( ToolMessage			*	base
						//, IPMP_Data_BaseClass	*	msg	);
	bool ProcessMessage ( IPMP_MessageFromTool*	base
						, IPMP_Data_BaseClass*	msg	);
	// by Liao Xuan

private:
	// Member data needed during tool functioning.
	IPMPTool_Interface	*	m_pMRInterface;
	__int32					myContextID;
	IPMP_Descriptor		*	m_pMyIPMPDescriptor;

};

#endif	// _IPMPX_TOOL_H_