//	This software module was originally developed by Craig A. Schultz 
//  (AccessTicket Systems Inc.) and Filippo Chiariglione (Microsoft Research Asia) 
//
//	in the course of development of the MPEG-4 Systems 
//	(ISO/IEC 14496-1) standard. This software module is an implementation 
//	of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified 
//	by the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	AccessTicket Systems Inc. and Microsoft Research Asia retains full right to 
//  use the code for its own purpose, assign or donate the code to a third party 
//  and to inhibit third parties from using the code for non MPEG-4 Systems 
//  (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2000. 

#include "defs.h"
#include "IPMP_Messages.h"
#include "ipmp_mastertool.h"
#include "SecurityLib.h"
#include "resource.h" 
#include <windowsx.h>
#include <windows.h>
#include <winuser.h>


// Global Variables:
HINSTANCE	hinst;
char szQueryName [256];
char szDisplay [1024];
bool abortion = false;


 
// Foward declarations of functions included in this code module:
BOOL CALLBACK DialogInputNameProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK DialogDisplayActivitiesProc(HWND m_hWnd, UINT message, WPARAM wParam, LPARAM lParam);

/*-------------------------------------------------------------
The exported function that instantiates the proper IPMPManager object
-------------------------------------------------------------*/
extern "C" void* CreateInstance ()
{
	//int j=0;
	//int i= 100/j;
	/*************Add by Liao Xuan, to show IPMP information *********/
	MessageBox(NULL, "IPMP Master Tool Loaded", "IPMP Tool", MB_OK);
	/*************End: Add by Liao Xuan, to show IPMP information ****/
	return new IPMP_MasterTool;
}

IPMP_MasterTool::IPMP_MasterTool ()
	: m_pMRInterface		(NULL)
	, myContextID			(0)
	, m_pMyIPMPDescriptor	(NULL) 
	, m_nNumOfTools			(0)
	, m_nNotifications		(0)
	, m_nCanProcess			(0)
	, m_SendMessages		(Run, this, THREAD_PRIORITY_NORMAL)
	, m_pSecure				(NULL)
{
	IPMPX_Tool::IPMPX_Tool();
	if (StartMasterTool () == -1)
		throw; 
	m_WaitForLicense.Reset();
	m_hWnd = ::GetDesktopWindow();
	hinst = (HINSTANCE)GetModuleHandle("IPMP_MasterTool.dll");
}

IPMP_MasterTool::~IPMP_MasterTool()
{
	m_WaitSlaveToolsConnected.Set();
	m_WaitForLicense.Set();
	WaitForThread ();

	ASSERT (m_SendMessages.GetThread () == NULL);

	if (m_pSecure != NULL)
		delete m_pSecure;
}


void IPMP_MasterTool::Run()
{
	m_WaitForLicense.Wait();
	m_WaitSlaveToolsConnected.Reset();
	ProcessRELAuthentication();
}


/***************************Rewrite by Liao Xuan*******************/
/*bool IPMP_MasterTool::ReceiveMessage( ToolMessage	*	msg )
{
	for ( int i = msg->IPMP_MessageFromBitstream.GetLength(); --i >= 0; )
	{
		ProcessMessage( msg, msg->IPMP_MessageFromBitstream[i] );
	}

	for ( int j = msg->IPMP_DescriptorFromBitstream.GetLength(); --j >= 0; )
	{
		IPMP_Descriptor descriptor = *(msg->IPMP_DescriptorFromBitstream[j]);
	}
	return true;
}*/
bool IPMP_MasterTool::ReceiveMessage( IPMP_ToolMessageBase* msg )
{
	switch (msg->tag)
	{
		case(0x01): //IPMP_MessageFromBitstream 
			return false;
		case(0x02)://IPMP_DescriptorFromBitstream
		{
			for ( int i = ((IPMP_DescriptorFromBitstream*)msg)->toolDescriptor.GetLength(); --i >= 0; )
				IPMP_Descriptor descriptor = *(((IPMP_DescriptorFromBitstream*)msg)->toolDescriptor[i]);
			return true;
		}
		case(0x03)://IPMP_MessageFromTool
		{
			for ( int i = ((IPMP_MessageFromTool*)msg)->messages.GetLength(); --i >= 0; )
				ProcessMessage( ((IPMP_MessageFromTool*)msg), (IPMP_Data_BaseClass*)((IPMP_MessageFromTool*)msg)->messages[i] );
			return true;
		}
	}
	return false;
}
/***************************End: Rewrite by Liao Xuan*************/


bool IPMP_MasterTool::ProcessData ( LPBYTE	pInput
								, int		nInputLength 
								, DWORD		dwTime )
{	
	if ( m_pNextTool == NULL )
		return false;
	return m_pNextTool->ProcessData( pInput, nInputLength, dwTime );
}

/***************** change by Liao Xuan *************************/
//bool IPMP_MasterTool::ProcessMessage ( ToolMessage	*	base
//							   , IPMP_Data_BaseClass	*	msg	)
bool IPMP_MasterTool::ProcessMessage( IPMP_MessageFromTool*	base
									, IPMP_Data_BaseClass*	msg	)
/***************** End: change by Liao Xuan ********************/
{
	switch (msg->GetTag())
	{
		case(TAG_IPMP_OpaqueData):
		{
			IPMP_OpaqueData* data = NULL;
			data = (IPMP_OpaqueData*)msg;

			/***************** Add by Liao Xuan *****************/
			/* to manually construct data->opaqueData again     */ 
			/* otherwise it probably can not get the right value*/
			data->opaqueData = ((IPMP_OpaqueData*)msg)->opaqueData;
			/***************** ENd: Add by Liao Xuan ************/

			int dataLen = (data->opaqueData)->array.GetLength();
			const unsigned char* p_array = LPCBYTE((data->opaqueData)->array);
			memcpy( szDisplay
				  , LPCBYTE((data->opaqueData)->array)
				  , dataLen );
			DialogBox(  hinst, 
						MAKEINTRESOURCE(IDD_DIALOG_ACTIVITIES), 
						m_hWnd,
						(DLGPROC)DialogDisplayActivitiesProc);
		}
		case(TAG_IPMP_RightsData):
			return false;
		
		//no use, duplicated processing with TAG_IPMP_OpaqueData
		case(TAG_IPMP_Secure_Container):
		{
		
			if (m_pSecure != NULL)
				delete m_pSecure;
			m_pSecure = new SecurityLib((MessageDistributor*)m_pMRInterface);
			IPMP_OpaqueData* data = NULL;
				
			data = (IPMP_OpaqueData*)m_pSecure->ProcessSecureContainer((IPMP_Secure_Container*)msg, base->sender);
			/*********Add by Liao Xuan **************************/
			// to manually construct data->opaqueData again, 
			// otherwise it probably can not get the right value
			data->opaqueData = ((IPMP_Secure_Container*)msg)->encryptedData;
			/****************************************************/
			
			/*********Change By Liao Xuan ***********************/ 
			/* according to ISO/IEC 14496-1:2001/FDAM 3:2003    */
			//int dataLen = data->opaqueData.GetLength();
			//memcpy(szDisplay,LPCBYTE(data->opaqueData),dataLen );
			int dataLen = (data->opaqueData)->array.GetLength();
			memcpy(szDisplay, LPCBYTE((data->opaqueData)->array), dataLen );
		    /****************************************************/
			
			DialogBox(  hinst, 
						MAKEINTRESOURCE(IDD_DIALOG_ACTIVITIES), 
						m_hWnd,
						(DLGPROC)DialogDisplayActivitiesProc);
		}
		case(TAG_IPMP_InitAuthentication):
			return false;
		case(TAG_IPMP_MutualAuthentication):
			return false;
		case(TAG_IPMP_UserQueryResponse):
			return false;
		case(TAG_IPMP_ToolParamCapabilitiesQuery):
			return false;
		case(TAG_IPMP_GetToolsResponse):
			return false;
		case(TAG_IPMP_GetToolContextResponse):
			return false;
		case(TAG_IPMP_CanProcess):
		{ 
			/*************** Change by Liao Xuan--- Nov 2003 *********/
			//if ( ((IPMP_CanProcess*)msg)->canProcess == 0 ) //true!
			if( ((IPMP_CanProcess*)msg)->canProcess == 1 ) //true!

				m_nCanProcess++;
			else
			{
				MessageBox( NULL, "You don't have the rights to access to this content", NULL, MB_OK );
				return false;
			}	
			if ( m_nCanProcess == m_nNumOfTools )
			{	
				IPMP_CanProcess			payload;
				//payload.canProcess	= 0; //true
				payload.canProcess		= 1; //true
				//ToolMessage			newMsg;
				IPMP_MessageFromTool	newMsg;
				newMsg.receiver			= 0x00;
				newMsg.sender			= myContextID;
				//newMsg.IPMP_MessageFromBitstream += &payload;
				newMsg.messages			+= &payload;
				m_pMRInterface->ReceiveMessage(&newMsg);
			}
			return true;
			/*************** End: Change by Liao Xuan---Nov 2003 *****/
		}
		case(TAG_IPMP_NotifyToolEvent):
		{
			if ( ((IPMP_NotifyToolEvent*)msg)->eventType == CONNECTED ) 
			{
				m_nNotifications++;
			}
			if ( m_nNotifications == m_nNumOfTools )
			{	
				m_WaitSlaveToolsConnected.Set(); //messages from the slave Tools: processes can start!
			}

			/************* Add by Liao Xuan **************************/
			/* to dynamically get the ContextID of IPMP_RELTool      */
			m_RELToolContextID = ((IPMP_NotifyToolEvent*)msg)->toolContextID;
			/************* End : Add by Liao Xuan ********************/
			return true;
		}
		case(TAG_User_Initialize):
		{
			myContextID = base->receiver;
			memcpy( &m_pMRInterface
				  , LPCBYTE(((User_Initialize*)msg)->messageInterface)
				  , sizeof(void*) );

			memcpy( &m_pMyIPMPDescriptor
				  , LPCBYTE(((User_Initialize*)msg)->toolDescriptor)
				  , sizeof(void*) );

			// Parse IPMP_data.  For this tool, IPMP_data will contain
			// IPMP descriptors for the required slave tools.
			m_nNumOfTools = m_pMyIPMPDescriptor->IPMPX_Data.GetLength();
			
			/********** Change by Liao Xuan ****************************/
			for ( int i = m_nNumOfTools; --i >= 0; )
			{	
				if (m_pMyIPMPDescriptor->IPMPX_Data[i]->GetTag() == TAG_IPMP_ConnectTool)
				{
					//ask the instantiation of the Tools
					//ToolMessage				newMsg;
					IPMP_MessageFromTool		newMsg;
					newMsg.receiver = 0x00; // to IPMPXFull
					newMsg.sender = myContextID;
					//newMsg.IPMP_MessageFromBitstream += (IPMP_ConnectTool*)m_pMyIPMPDescriptor->IPMPX_Data[i];	
					newMsg.messages += (IPMP_ConnectTool*)m_pMyIPMPDescriptor->IPMPX_Data[i];

					(IPMPTool_Interface*)m_pMRInterface->ReceiveMessage(&newMsg);
					
					//Extracting the license pathname from the message; it will be sent to the IPMP_RELTool 
					//in a second time, encrypted and together with the query.
					IPMP_ConnectTool* connect = (IPMP_ConnectTool*)m_pMyIPMPDescriptor->IPMPX_Data[i]->Copy();
					if (connect->descriptor[0].IPMPX_Data[0]->GetTag() == (TAG_IPMP_RightsData))
					{
						IPMP_RightsData* rdata = (IPMP_RightsData*) connect->descriptor[0].IPMPX_Data[0]->Copy();
						GetLicenseName(rdata);
						m_WaitForLicense.Set();
					}
				}
			}
			User_Initialized	payload;
			//ToolMessage				newMsg;
			IPMP_MessageFromTool		newMsg;
			newMsg.receiver = 0x00;
			newMsg.sender = myContextID;
			//newMsg.IPMP_MessageFromBitstream += &payload;
			newMsg.messages += &payload;
			m_pMRInterface->ReceiveMessage(&newMsg);
			return true;
			/********** End: Change by Liao Xuan ***********************/

		}
		default:
				return false;
	}
}		

bool IPMP_MasterTool::GetLicenseName(IPMP_RightsData* rights)
{ 
	/********* Change by Liao Xuan **********************************/
	/* according to ISO/IEC 14496-1:2001/FDAM 3:2003                */
	//int licenseNameLen = rights->rightsInfo.GetLength();
	int licenseNameLen = ((IPMP_RightsData*)rights)->rightsInfo->array.GetLength();
	//const char* licenseLocationPtr = (LPCSTR)(rights->rightsInfo);
	const char* licenseLocationPtr = (LPCSTR)(((IPMP_RightsData*)rights)->rightsInfo->array);
	/********* End: Change by Liao Xuan *****************************/

	memset (m_sLicensePathName, 0, licenseNameLen);
	for (int i = 0; i < licenseNameLen; i++)
	{
		m_sLicensePathName[i] = (unsigned char)(*(licenseLocationPtr + i));
	}
	m_sLicensePathName[licenseNameLen] = '\0';
	return true;
}

bool IPMP_MasterTool::ProcessRELAuthentication()
{
	OutputDebugString("IPMP_MasterTool::ProcessRELAuthentication()\n");
	if (m_pSecure != NULL)
		delete m_pSecure;

	m_pSecure = new SecurityLib(SecurityLib((MessageDistributor*)m_pMRInterface));

	IPMP_RightsData licenseMsg;
	IPMP_RightsData queryMsg;
    
	/***** Add by Liao Xuan*********************************/
	/* for allocating memory for licenseMsg and queryMsg   */
	ByteArray* lincenseByteArray=new ByteArray();
	ByteArray* queryByteArray=new ByteArray();
    /******End: Addn by Liao Xuan **************************/

	bool retVal = false;

	//Building the Message containing the license
	int  count = 0, i = 0;
	long lbuf = 0;
	char* buffer = new char[10000];
    FILE *stream;
	
	stream = fopen(m_sLicensePathName, "r" );
	if (stream == NULL)
	{
		MessageBox( NULL, "The license provided is not accessible, please restart", NULL, MB_OK );
		return false;
	}
    count = fread(buffer, sizeof( char ), 10000, stream );
    fclose( stream );

	char* suitableBuffer_l = new char[count];
	memcpy (suitableBuffer_l, buffer, count);
    
	/********* Change By Liao Xuan ********************/
	licenseMsg.rightsInfo = lincenseByteArray;//alloc memory for m_pClass
	for (i = 0; i < count; i++)
	{
		((licenseMsg.rightsInfo)->array).InsertElement(suitableBuffer_l[i], i);
	}
	/**********End: Change by Liao Xuan ***************/
	
	delete[] suitableBuffer_l;


	//Building the message containing the query
	char* suitableBuffer_q = new char[count];
	memset(szQueryName, 0, 256);
	int queryLen;
	while(strlen(szQueryName) == 0)
	{	
		if (abortion == true) 
			goto outofhere;
displaybox:
		GetQuery();
	}
	//substitution of '\' with '/' for allowing the call to fopen
	queryLen = strlen(szQueryName);
	for (i = 0; i < queryLen; i++)
	{
		if (szQueryName[i] == 0x5C)
		{
			szQueryName[i] = (unsigned char) 0x2F;
		}
	}
	szQueryName[queryLen] = '\0';
	count = 0;
	stream = fopen(szQueryName, "r" ); // unsupported: exampleInputWithPrintRight.xml
    if (stream == NULL)
	{
		MessageBox( NULL, "The query provided is not available, please try again", NULL, MB_OK );
		goto displaybox;
	}
	count = fread( buffer, sizeof( char ), 10000, stream );
    if (count == 0)
	{
		MessageBox( NULL, "The query provided is an empty file, please try again", NULL, MB_OK );
		goto displaybox;
	}
    fclose( stream );
	memcpy (suitableBuffer_q, buffer, count);
	delete[] buffer;

	/********* Change By Liao Xuan ********************/
   	queryMsg.rightsInfo = queryByteArray;//alloc memory for m_pClass
	for (i = 0; i < count; i++)
	{
		//queryMsg.rightsInfo.InsertElement(suitableBuffer_q[i], i);
		((queryMsg.rightsInfo)->array).InsertElement(suitableBuffer_q[i], i);
	}
	/**********End: Change by Liao Xuan ***************/

	delete[] suitableBuffer_q;

	m_WaitSlaveToolsConnected.Wait();

	/*************** Change by Liao Xuan*******************************/
	/* send messages using IPMP_RELTool's contextID that was                 */ 
	/* dynamically got in IPMP_MasterTool: IPMP_NotifyToolEvent message		 */          
	//m_pSecure->SendSecureMessage(&licenseMsg, 0x02); //TODO: substitute 0x02 with dynamic ID
	m_pSecure->SendSecureMessage(&licenseMsg, m_RELToolContextID); 
	Sleep(1000); // for being sure that the license is sent before the query
	//m_pSecure->SendSecureMessage(&queryMsg, 0x02);
	m_pSecure->SendSecureMessage(&queryMsg, m_RELToolContextID);
    Sleep(1000);
	/*************** End: Change by Liao Xuan**************************/
	

	/*************** Add by Liao Xuan, release memory ***************/
	if (lincenseByteArray)
	{
		delete lincenseByteArray;
		lincenseByteArray = NULL;
	}
	if(queryByteArray)
	{
		delete queryByteArray;
		queryByteArray = NULL;
	}
	/*************** End: Add by Liao Xuan, release memory **********/

outofhere: 
	return retVal;
}

void IPMP_MasterTool::GetQuery() 
{
	hinst = (HINSTANCE)GetModuleHandle("IPMP_MasterTool.dll");
	DialogBox(  hinst, 
				MAKEINTRESOURCE(IDD_DIALOG_GETNAME), 
				m_hWnd,
				(DLGPROC)DialogInputNameProc);
}

BOOL CALLBACK DialogInputNameProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{ 
    switch (message) 
    { 
        case WM_INITDIALOG: 
			Edit_SetText( GetDlgItem( hwndDlg, IDC_EDIT_FILENAME), "C:/cvs/MPEG-4/Systems2/IM1/IPMP-X/TestFiles/exampleInput2.xml" );
            return TRUE; 
 
        case WM_COMMAND: 
           switch (LOWORD(wParam)) 
            { 
                case IDOK: 
					Edit_GetText( GetDlgItem( hwndDlg, IDC_EDIT_FILENAME), szQueryName, 256);
					DestroyWindow(hwndDlg); 
					return TRUE;
                case IDCANCEL: 
                    DestroyWindow(hwndDlg);
					MessageBox( NULL, "Operation Aborted", NULL, MB_OK );
					abortion = true;
                    return FALSE; 
            } 
    } 
    return FALSE;
}

BOOL CALLBACK DialogDisplayActivitiesProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message) 
    { 
        case WM_INITDIALOG: 
			Edit_SetText( GetDlgItem( hDlg, IDC_EDIT_DISPLAY), szDisplay );
            return TRUE; 
 
        case WM_COMMAND: 
           switch (LOWORD(wParam)) 
            { 
                case IDOK: 
					DestroyWindow(hDlg);
					return TRUE;
            } 
    } 
    return FALSE;
}

