//	This software module was originally developed by Craig A. Schultz
//  (AccessTicket Systems Inc.) and Filippo Chiariglione (Microsoft Research Asia)    
//
//	in the course of development of the MPEG-4 Systems 
//	(ISO/IEC 14496-1) standard. This software module is an implementation 
//	of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified 
//	by the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	AccessTicket Systems Inc. and Microsoft Research Asia retains full right to 
//  use the code for its own purpose, assign or donate the code to a third party 
//  and to inhibit third parties from using the code for non MPEG-4 Systems 
//  (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2000. 

#ifndef _IPMP_MASTERTOOL_H_
#define _IPMP_MASTERTOOL_H_


#include "IPMPX_Tool.h"
#include "CLib.h"
#include "ZTL.h"
#include "SecurityLib.h"


class IPMP_MasterTool : public IPMPX_Tool
{
public:
	IPMP_MasterTool();
	~IPMP_MasterTool();

	// IPMPTool_Interface interface methods.
	// by Liao Xuan
	//bool ReceiveMessage( ToolMessage* );
	bool ReceiveMessage( IPMP_ToolMessageBase*);
	// by Liao Xuan

	// Interface methods added by IPMPX_Tool
	bool ProcessData (
		LPBYTE,		// pInput,
		int,		// rnInputLength
		DWORD		// dwTime
		);		

private:
	// Helper method
	void	Run();
	int		StartMasterTool () {return m_SendMessages.Begin ();}
	void	WaitForThread () {m_SendMessages.Wait ();}
	// by Liao Xuan
	//bool ProcessMessage ( ToolMessage			*	base
						//, IPMP_Data_BaseClass	*	msg	);
	bool ProcessMessage ( IPMP_MessageFromTool*	base
						, IPMP_Data_BaseClass*	msg	);
	// by Liao Xuan
	void	GetQuery();
	bool	ProcessRELAuthentication();
	bool	StartProcessRELAuthentication(IPMP_RightsData* rights);
	bool	GetLicenseName(IPMP_RightsData* rights);

private:
	// Member data needed during tool functioning.
	ZThread<IPMP_MasterTool>	m_SendMessages;
	CSEvent						m_WaitSlaveToolsConnected;
	CSEvent						m_WaitForLicense;
	IPMPTool_Interface	*		m_pMRInterface;
	__int32						myContextID;
	// by Liao Xuan
	__int32						m_RELToolContextID;
	// by Liao Xuan
	IPMP_Descriptor	*			m_pMyIPMPDescriptor;
	int							m_nNumOfTools;
	int							m_nNotifications;
	int							m_nCanProcess;
	char						m_sLicensePathName[256];
	SecurityLib *				m_pSecure;
	HWND						m_hWnd;
};

#endif	// _IPMP_MASTERTOOL_H_