//	This software module was originally developed by Craig A. Schultz 
//	(AccessTicket Systems Inc.)
//
//	in the course of development of the MPEG-4 Systems 
//	(ISO/IEC 14496-1) standard. This software module is an implementation 
//	of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified 
//	by the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	AccessTicket Systems Inc. retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2000. 

#include "defs.h"
#include "IPMP_Messages.h"

OD_IMPLEMENT_DESCRIPTOR_START (ByteArray)
	OD_IMPLEMENT_FIELD (ByteArray, array)
OD_IMPLEMENT_DESCRIPTOR_END (ByteArray)

OD_IMPLEMENT_DESCRIPTOR_START (ParametricDescriptor)
	OD_IMPLEMENT_FIELD (ParametricDescriptor, Class)
	OD_IMPLEMENT_FIELD (ParametricDescriptor, subClass)
	OD_IMPLEMENT_FIELD (ParametricDescriptor, typeData)
	OD_IMPLEMENT_FIELD (ParametricDescriptor, type)
	OD_IMPLEMENT_FIELD (ParametricDescriptor, addedData)
OD_IMPLEMENT_DESCRIPTOR_END (ParametricDescriptor)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_ParamtericDescription)
	OD_IMPLEMENT_FIELD (IPMP_ParamtericDescription, Version)
	OD_IMPLEMENT_FIELD (IPMP_ParamtericDescription, dataID)
	OD_IMPLEMENT_FIELD (IPMP_ParamtericDescription, descriptionComment)
	OD_IMPLEMENT_FIELD (IPMP_ParamtericDescription, majorVersion)
	OD_IMPLEMENT_FIELD (IPMP_ParamtericDescription, minorVersion)
	OD_IMPLEMENT_FIELD (IPMP_ParamtericDescription, numOfDescriptions)
	OD_IMPLEMENT_FIELD (IPMP_ParamtericDescription, description)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_ParamtericDescription)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_ToolListDescriptor)
	OD_IMPLEMENT_FIELD (IPMP_ToolListDescriptor, ipmpTools)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_ToolListDescriptor)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_Tool)
	OD_IMPLEMENT_FIELD (IPMP_Tool, IPMP_ToolID)
	OD_IMPLEMENT_FIELD (IPMP_Tool, isAltGroup)
	OD_IMPLEMENT_FIELD (IPMP_Tool, isParametric)
	OD_IMPLEMENT_FIELD (IPMP_Tool, reserved)
	OD_IMPLEMENT_FIELD (IPMP_Tool, numAlternates)
	OD_IMPLEMENT_FIELD (IPMP_Tool, Alt_IPMP_ToolIDs)
	OD_IMPLEMENT_FIELD (IPMP_Tool, toolParamDescr)
	OD_IMPLEMENT_FIELD (IPMP_Tool, ToolURLs)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_Tool)

OD_IMPLEMENT_DESCRIPTOR_START (IPMPToolES_DecoderConfig) 
	// by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	OD_IMPLEMENT_FIELD (IPMPToolES_DecoderConfig, IPMP_ToolID)//added, Feb12 2004
	OD_IMPLEMENT_FIELD (IPMPToolES_DecoderConfig, hasFormatID)//added
	OD_IMPLEMENT_FIELD (IPMPToolES_DecoderConfig, hasPackageID)//added
	OD_IMPLEMENT_FIELD (IPMPToolES_DecoderConfig, reserved)//added
	// End: by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	OD_IMPLEMENT_FIELD (IPMPToolES_DecoderConfig, Tool_Format_ID)
	OD_IMPLEMENT_FIELD (IPMPToolES_DecoderConfig, Tool_Package_ID)
	OD_IMPLEMENT_FIELD (IPMPToolES_DecoderConfig, opaqueData)
OD_IMPLEMENT_DESCRIPTOR_END (IPMPToolES_DecoderConfig)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_OpaqueData)
	OD_IMPLEMENT_FIELD (IPMP_OpaqueData, Version)
	OD_IMPLEMENT_FIELD (IPMP_OpaqueData, dataID)
	OD_IMPLEMENT_FIELD (IPMP_OpaqueData, opaqueData)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_OpaqueData)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_AudioWatermarkingInit)
	OD_IMPLEMENT_FIELD (IPMP_AudioWatermarkingInit, Version)
	OD_IMPLEMENT_FIELD (IPMP_AudioWatermarkingInit, dataID)
	OD_IMPLEMENT_FIELD (IPMP_AudioWatermarkingInit, inputFormat)
	OD_IMPLEMENT_FIELD (IPMP_AudioWatermarkingInit, requiredOp)
	OD_IMPLEMENT_FIELD (IPMP_AudioWatermarkingInit, hasOpaqueData)
	OD_IMPLEMENT_FIELD (IPMP_AudioWatermarkingInit, reserved)
	OD_IMPLEMENT_FIELD (IPMP_AudioWatermarkingInit, nChannels)
	OD_IMPLEMENT_FIELD (IPMP_AudioWatermarkingInit, bitPerSample)
	OD_IMPLEMENT_FIELD (IPMP_AudioWatermarkingInit, frequency)
	//by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	OD_IMPLEMENT_FIELD (IPMP_AudioWatermarkingInit, wmPayloadLen)//added
	OD_IMPLEMENT_FIELD (IPMP_AudioWatermarkingInit, wmPayload)
	OD_IMPLEMENT_FIELD (IPMP_AudioWatermarkingInit, wmRecipientId)
	OD_IMPLEMENT_FIELD (IPMP_AudioWatermarkingInit, opaqueDataSize)//added
	//End: by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	OD_IMPLEMENT_FIELD (IPMP_AudioWatermarkingInit, opaqueData)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_AudioWatermarkingInit)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_VideoWatermarkingInit)
	OD_IMPLEMENT_FIELD (IPMP_VideoWatermarkingInit, Version)
	OD_IMPLEMENT_FIELD (IPMP_VideoWatermarkingInit, dataID)
	OD_IMPLEMENT_FIELD (IPMP_VideoWatermarkingInit, inputFormat)
	OD_IMPLEMENT_FIELD (IPMP_VideoWatermarkingInit, requiredOp)
	OD_IMPLEMENT_FIELD (IPMP_VideoWatermarkingInit, hasOpaqueData)
	OD_IMPLEMENT_FIELD (IPMP_VideoWatermarkingInit, reserved)
	OD_IMPLEMENT_FIELD (IPMP_VideoWatermarkingInit, frame_horizontal_size)
	OD_IMPLEMENT_FIELD (IPMP_VideoWatermarkingInit, frame_vertical_size)
	OD_IMPLEMENT_FIELD (IPMP_VideoWatermarkingInit, chroma_format)
	//by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	OD_IMPLEMENT_FIELD (IPMP_AudioWatermarkingInit, wmPayloadLen)//added
	OD_IMPLEMENT_FIELD (IPMP_VideoWatermarkingInit, wmPayload)
	OD_IMPLEMENT_FIELD (IPMP_VideoWatermarkingInit, wmRecipientId)
	OD_IMPLEMENT_FIELD (IPMP_AudioWatermarkingInit, opaqueDataSize)//added
	//End: by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	OD_IMPLEMENT_FIELD (IPMP_VideoWatermarkingInit, opaqueData)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_VideoWatermarkingInit)

OD_IMPLEMENT_DESCRIPTOR_START (BufferInfoStructure)
	OD_IMPLEMENT_FIELD (BufferInfoStructure, cipher_Id)
	OD_IMPLEMENT_FIELD (BufferInfoStructure, syncBoundary)
	OD_IMPLEMENT_FIELD (BufferInfoStructure, isBlock)
	OD_IMPLEMENT_FIELD (BufferInfoStructure, reserved)
	OD_IMPLEMENT_FIELD (BufferInfoStructure, mode)
	OD_IMPLEMENT_FIELD (BufferInfoStructure, blockSize)
	OD_IMPLEMENT_FIELD (BufferInfoStructure, keySize)
	OD_IMPLEMENT_FIELD (BufferInfoStructure, streamCipherSpecificInitInfo)
OD_IMPLEMENT_DESCRIPTOR_END (BufferInfoStructure)

OD_IMPLEMENT_DESCRIPTOR_START (FieldStructure)
	OD_IMPLEMENT_FIELD (FieldStructure, field_Id)
	OD_IMPLEMENT_FIELD (FieldStructure, field_Scope)
	OD_IMPLEMENT_FIELD (FieldStructure, reserved)
	OD_IMPLEMENT_FIELD (FieldStructure, buf)
	OD_IMPLEMENT_FIELD (FieldStructure, isMapped)
	OD_IMPLEMENT_FIELD (FieldStructure, reserved)
	OD_IMPLEMENT_FIELD (FieldStructure, sendMapTable)
	OD_IMPLEMENT_FIELD (FieldStructure, isShuffled)
	OD_IMPLEMENT_FIELD (FieldStructure, reserved)
	//by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	OD_IMPLEMENT_FIELD (FieldStructure, sizMapTable)//added
	//End: by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	OD_IMPLEMENT_FIELD (FieldStructure, mappingTable)
	OD_IMPLEMENT_FIELD (FieldStructure, shuffleSpecificInfo)
OD_IMPLEMENT_DESCRIPTOR_END (FieldStructure)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_SelectiveDecryptionInit)
	OD_IMPLEMENT_FIELD (IPMP_SelectiveDecryptionInit, Version)
	OD_IMPLEMENT_FIELD (IPMP_SelectiveDecryptionInit, dataID)
	OD_IMPLEMENT_FIELD (IPMP_SelectiveDecryptionInit, mediaTypeExtension)
	OD_IMPLEMENT_FIELD (IPMP_SelectiveDecryptionInit, mediaTypeIndication)
	OD_IMPLEMENT_FIELD (IPMP_SelectiveDecryptionInit, profileLevelIndication)
	OD_IMPLEMENT_FIELD (IPMP_SelectiveDecryptionInit, compliance)
	
	//Change by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	OD_IMPLEMENT_FIELD (IPMP_SelectiveDecryptionInit, numBufs)// added
	OD_IMPLEMENT_FIELD (IPMP_SelectiveDecryptionInit, bufferInfo)
	OD_IMPLEMENT_FIELD (IPMP_SelectiveDecryptionInit, isContentSpecific)
	OD_IMPLEMENT_FIELD (IPMP_SelectiveDecryptionInit, reserved)
	OD_IMPLEMENT_FIELD (IPMP_SelectiveDecryptionInit, numFields)//added
	OD_IMPLEMENT_FIELD (IPMP_SelectiveDecryptionInit, fields)
	//OD_IMPLEMENT_FIELD (IPMP_SelectiveDecryptionInit, decryptionMask)//delete
	OD_IMPLEMENT_FIELD (IPMP_SelectiveDecryptionInit, nSegments)//added
	OD_IMPLEMENT_FIELD (IPMP_SelectiveDecryptionInit, RLE_Data)//added
	//End: Change by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003

OD_IMPLEMENT_DESCRIPTOR_END (IPMP_SelectiveDecryptionInit)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_KeyData)
	OD_IMPLEMENT_FIELD (IPMP_KeyData, Version)
	OD_IMPLEMENT_FIELD (IPMP_KeyData, dataID)
	OD_IMPLEMENT_FIELD (IPMP_KeyData, keyBody)
	OD_IMPLEMENT_FIELD (IPMP_KeyData, startDTS) 
	OD_IMPLEMENT_FIELD (IPMP_KeyData, startPacketID)
	OD_IMPLEMENT_FIELD (IPMP_KeyData, expireDTS) 
	OD_IMPLEMENT_FIELD (IPMP_KeyData, expirePacketID)
	OD_IMPLEMENT_FIELD (IPMP_KeyData, opaqueData) 
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_KeyData)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_SendAudioWatermark)
	OD_IMPLEMENT_FIELD (IPMP_SendAudioWatermark, Version)
	OD_IMPLEMENT_FIELD (IPMP_SendAudioWatermark, dataID)
	OD_IMPLEMENT_FIELD (IPMP_SendAudioWatermark, wm_status)
	OD_IMPLEMENT_FIELD (IPMP_SendAudioWatermark, compression_status)
	OD_IMPLEMENT_FIELD (IPMP_SendAudioWatermark, hasOpaqueData)
	OD_IMPLEMENT_FIELD (IPMP_SendAudioWatermark, reserved)
	OD_IMPLEMENT_FIELD (IPMP_SendAudioWatermark, payload)
	OD_IMPLEMENT_FIELD (IPMP_SendAudioWatermark, opaqueData)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_SendAudioWatermark)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_SendVideoWatermark)
	OD_IMPLEMENT_FIELD (IPMP_SendVideoWatermark, Version)
	OD_IMPLEMENT_FIELD (IPMP_SendVideoWatermark, dataID)
	OD_IMPLEMENT_FIELD (IPMP_SendAudioWatermark, wm_status)
	OD_IMPLEMENT_FIELD (IPMP_SendAudioWatermark, compression_status)
	OD_IMPLEMENT_FIELD (IPMP_SendAudioWatermark, hasOpaqueData)
	OD_IMPLEMENT_FIELD (IPMP_SendAudioWatermark, reserved)
	OD_IMPLEMENT_FIELD (IPMP_SendAudioWatermark, payload)
	OD_IMPLEMENT_FIELD (IPMP_SendAudioWatermark, opaqueData)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_SendVideoWatermark)


OD_IMPLEMENT_DESCRIPTOR_START (IPMP_RightsData)
	OD_IMPLEMENT_FIELD (IPMP_RightsData, Version)
	OD_IMPLEMENT_FIELD (IPMP_RightsData, dataID)
	OD_IMPLEMENT_FIELD (IPMP_RightsData, rightsInfo)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_RightsData)


OD_IMPLEMENT_DESCRIPTOR_START (IPMP_Secure_Container)
	OD_IMPLEMENT_FIELD (IPMP_Secure_Container, Version)
	OD_IMPLEMENT_FIELD (IPMP_Secure_Container, dataID)
	OD_IMPLEMENT_FIELD (IPMP_Secure_Container, hasEncryption)
	OD_IMPLEMENT_FIELD (IPMP_Secure_Container, hasMAC) 
	OD_IMPLEMENT_FIELD (IPMP_Secure_Container, isMACEncrypted)
	OD_IMPLEMENT_FIELD (IPMP_Secure_Container, Reserved) 
	OD_IMPLEMENT_FIELD (IPMP_Secure_Container, encryptedData)
	OD_IMPLEMENT_FIELD (IPMP_Secure_Container, MAC) 
	//by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	OD_IMPLEMENT_FIELD (IPMP_Secure_Container, protectedMsg) //added
	//End: by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_Secure_Container)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_AddToolNotificationListener)
	OD_IMPLEMENT_FIELD (IPMP_AddToolNotificationListener, Version)
	OD_IMPLEMENT_FIELD (IPMP_AddToolNotificationListener, dataID)
	OD_IMPLEMENT_FIELD (IPMP_AddToolNotificationListener, scope)
	//by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	OD_IMPLEMENT_FIELD (IPMP_AddToolNotificationListener, reserved)//added
	OD_IMPLEMENT_FIELD (IPMP_AddToolNotificationListener, eventTypeCount)//added
	//End: by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	OD_IMPLEMENT_FIELD (IPMP_AddToolNotificationListener, eventType)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_AddToolNotificationListener)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_RemoveToolNotificationListener)
	OD_IMPLEMENT_FIELD (IPMP_RemoveToolNotificationListener, Version)
	OD_IMPLEMENT_FIELD (IPMP_RemoveToolNotificationListener, dataID)
	//by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	OD_IMPLEMENT_FIELD (IPMP_AddToolNotificationListener, eventTypeCount)//added
	//End: by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	OD_IMPLEMENT_FIELD (IPMP_RemoveToolNotificationListener, eventType)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_RemoveToolNotificationListener)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_InitAuthentication)
	OD_IMPLEMENT_FIELD (IPMP_InitAuthentication, Version)
	OD_IMPLEMENT_FIELD (IPMP_InitAuthentication, dataID)
	OD_IMPLEMENT_FIELD (IPMP_InitAuthentication, contextID)
	OD_IMPLEMENT_FIELD (IPMP_InitAuthentication, authType)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_InitAuthentication)

/****************** Rewrite by Liao Xuan *************************/
/*
OD_IMPLEMENT_DESCRIPTOR_START (AlgorithmDescriptor)
	OD_IMPLEMENT_FIELD (AlgorithmDescriptor, regAuthID)
	OD_IMPLEMENT_FIELD (AlgorithmDescriptor, specAlgoID)
	OD_IMPLEMENT_FIELD (AlgorithmDescriptor, OpaqueData)
OD_IMPLEMENT_DESCRIPTOR_END (AlgorithmDescriptor)

OD_IMPLEMENT_DESCRIPTOR_START (KeyDescriptor)
	OD_IMPLEMENT_FIELD (KeyDescriptor, keyBody)
OD_IMPLEMENT_DESCRIPTOR_END (KeyDescriptor)

OD_IMPLEMENT_DESCRIPTOR_START (Certificate)
	OD_IMPLEMENT_FIELD (Certificate, certificate)
OD_IMPLEMENT_DESCRIPTOR_END (Certificate)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_MutualAuthentication)
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, Version)
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, dataID)
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, candidateAlgorithms)
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, agreedAlgorithms)
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, AuthenticationData)
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, certType)
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, certificates)
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, publicKey)
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, opaque)
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, authCodes)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_MutualAuthentication)
*/

OD_IMPLEMENT_DESCRIPTOR_START (AlgorithmDescriptor)
	OD_IMPLEMENT_FIELD (AlgorithmDescriptor, isRegistered)//added
	OD_IMPLEMENT_FIELD (AlgorithmDescriptor, reserved)//added
	OD_IMPLEMENT_FIELD (AlgorithmDescriptor, regAuthID)
	OD_IMPLEMENT_FIELD (AlgorithmDescriptor, specAlgoID)
	OD_IMPLEMENT_FIELD (AlgorithmDescriptor, OpaqueData)
OD_IMPLEMENT_DESCRIPTOR_END (AlgorithmDescriptor)

OD_IMPLEMENT_DESCRIPTOR_START (KeyDescriptor)
	OD_IMPLEMENT_FIELD (KeyDescriptor, keyBody)
OD_IMPLEMENT_DESCRIPTOR_END (KeyDescriptor)

OD_IMPLEMENT_DESCRIPTOR_START (Certificate)
	OD_IMPLEMENT_FIELD (Certificate, certificate)
OD_IMPLEMENT_DESCRIPTOR_END (Certificate)

OD_IMPLEMENT_DESCRIPTOR_START (DateClass)
	OD_IMPLEMENT_FIELD (DateClass, Date)
OD_IMPLEMENT_DESCRIPTOR_END (DateClass)

OD_IMPLEMENT_DESCRIPTOR_START (TrustSpecification)
	OD_IMPLEMENT_FIELD (TrustSpecification,	hasCCBasedTrustMetadata)
	OD_IMPLEMENT_FIELD (TrustSpecification,	reserved)
	OD_IMPLEMENT_FIELD (TrustSpecification,	startDate)
	OD_IMPLEMENT_FIELD (TrustSpecification,	attackerProfile)
	OD_IMPLEMENT_FIELD (TrustSpecification,	reserved2)
	OD_IMPLEMENT_FIELD (TrustSpecification,	trustedDuration)
	OD_IMPLEMENT_FIELD (TrustSpecification,	CCTrustMetadata)
OD_IMPLEMENT_DESCRIPTOR_END (TrustSpecification)

OD_IMPLEMENT_DESCRIPTOR_START (TrustedTool)
	OD_IMPLEMENT_FIELD (TrustedTool, toolID)
	OD_IMPLEMENT_FIELD (TrustedTool, AuditDate)
	OD_IMPLEMENT_FIELD (TrustedTool, numTrustSpecification)
	OD_IMPLEMENT_FIELD (TrustedTool, trustSpecification)
OD_IMPLEMENT_DESCRIPTOR_END (TrustedTool)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_TrustSecurityMetadata)
	OD_IMPLEMENT_FIELD (IPMP_TrustSecurityMetadata, numTrustedTools)
	OD_IMPLEMENT_FIELD (IPMP_TrustSecurityMetadata, trustedtools)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_TrustSecurityMetadata)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_MutualAuthentication)
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, Version)
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, dataID)
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, requestNegotiation)//added	
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, successNegotiation)//added	
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, failedNegotiation)//added	
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, inclAuthenticationData)//added	
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, inclAuthCodes)//added	
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, reserved)//added	
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, nCandidateAlgorithm)//added						
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, candidateAlgorithms)
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, nAgreedAlgorithm)//added		
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, agreedAlgorithms)
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, AuthenticationData)
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, type)//added
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, nCertificate)//added
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, certType)
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, certificates)
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, publicKey)
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, opaque)
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, trustData)//added
	OD_IMPLEMENT_FIELD (IPMP_MutualAuthentication, authCodes)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_MutualAuthentication)
/****************** End: Rewrite by Liao Xuan ***********************/

OD_IMPLEMENT_DESCRIPTOR_START (DTArray)
	OD_IMPLEMENT_FIELD (DTArray, ID)
	OD_IMPLEMENT_FIELD (DTArray, displayText)
OD_IMPLEMENT_DESCRIPTOR_END (DTArray)

/************ Hide by Liao Xuan ************************************/
/* according to ISO/IEC 14496-1:2001/FDAM 3:2003, no use any more
/*
OD_IMPLEMENT_DESCRIPTOR_START (RTArray)
	OD_IMPLEMENT_FIELD (RTArray, ID)
	OD_IMPLEMENT_FIELD (RTArray, SubID)
	OD_IMPLEMENT_FIELD (RTArray, promptText)
OD_IMPLEMENT_DESCRIPTOR_END (RTArray)
*/
/************ End: Hide by Liao Xuan ********************************/


OD_IMPLEMENT_DESCRIPTOR_START (OptionArray)
	OD_IMPLEMENT_FIELD (OptionArray, ID)
	OD_IMPLEMENT_FIELD (OptionArray, SubID)
	OD_IMPLEMENT_FIELD (OptionArray, isExclusive)
	//by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	OD_IMPLEMENT_FIELD (OptionArray, reserved)//added
	//End: by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	OD_IMPLEMENT_FIELD (OptionArray, promptText)
OD_IMPLEMENT_DESCRIPTOR_END (OptionArray)

/******************** Add by Liao Xuan *****************************/
OD_IMPLEMENT_DESCRIPTOR_START (QTArray)
	OD_IMPLEMENT_FIELD (QTArray, ID)
	OD_IMPLEMENT_FIELD (QTArray, SubID)
	OD_IMPLEMENT_FIELD (QTArray, isHidden)
	OD_IMPLEMENT_FIELD (QTArray, reserved)
	OD_IMPLEMENT_FIELD (QTArray, promptText)
OD_IMPLEMENT_DESCRIPTOR_END (QTArray)
/******************** End: Add by Liao Xuan ***********************/ 


/************ Rewrite by Liao Xuan ************************************/
/* according to ISO/IEC 14496-1:2001/FDAM 3:2003, no use any more
/*
OD_IMPLEMENT_DESCRIPTOR_START (AltText)
	OD_IMPLEMENT_FIELD (AltText, languageCode)
	OD_IMPLEMENT_FIELD (AltText, charCode)
	OD_IMPLEMENT_FIELD (AltText, displayTitle)
	OD_IMPLEMENT_FIELD (AltText, displayText)
	OD_IMPLEMENT_FIELD (AltText, replyText)
	OD_IMPLEMENT_FIELD (AltText, optionSelect)
	OD_IMPLEMENT_FIELD (AltText, SMILurl)
	OD_IMPLEMENT_FIELD (AltText, SMIL)
OD_IMPLEMENT_DESCRIPTOR_END (AltText)
*/

OD_IMPLEMENT_DESCRIPTOR_START (AltText)
	OD_IMPLEMENT_FIELD (AltText, languageCode)
	OD_IMPLEMENT_FIELD (AltText, titleText)
	OD_IMPLEMENT_FIELD (AltText, nDisplayText)
	OD_IMPLEMENT_FIELD (AltText, displayText)
	OD_IMPLEMENT_FIELD (AltText, nPromptText)
	OD_IMPLEMENT_FIELD (AltText, promptText)
	OD_IMPLEMENT_FIELD (AltText, nOption)
	OD_IMPLEMENT_FIELD (AltText, option)
	OD_IMPLEMENT_FIELD (AltText, isReferenced)
	OD_IMPLEMENT_FIELD (AltText, reserved)
	OD_IMPLEMENT_FIELD (AltText, SMIL_URL)
	OD_IMPLEMENT_FIELD (AltText, SMIL)
OD_IMPLEMENT_DESCRIPTOR_END (AltText)
/************ End: Rewrite by Liao Xuan *****************************/


OD_IMPLEMENT_DESCRIPTOR_START (IPMP_UserQuery)
	OD_IMPLEMENT_FIELD (IPMP_UserQuery, Version)
	OD_IMPLEMENT_FIELD (IPMP_UserQuery, dataID)
	//by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	OD_IMPLEMENT_FIELD (IPMP_UserQuery, inclDisplayTitle)//added
	OD_IMPLEMENT_FIELD (IPMP_UserQuery, inclDisplayText)//added
	OD_IMPLEMENT_FIELD (IPMP_UserQuery, needReplyText)//added
	OD_IMPLEMENT_FIELD (IPMP_UserQuery, inclOptionSelect)//added
	OD_IMPLEMENT_FIELD (IPMP_UserQuery, inclSMIL)//added
	OD_IMPLEMENT_FIELD (IPMP_UserQuery, reserved)//added
	OD_IMPLEMENT_FIELD (IPMP_UserQuery, numOfAltText)//added
	//End: by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	OD_IMPLEMENT_FIELD (IPMP_UserQuery, query)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_UserQuery)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_UserQueryResponse)
	OD_IMPLEMENT_FIELD (IPMP_UserQueryResponse, Version)
	OD_IMPLEMENT_FIELD (IPMP_UserQueryResponse, dataID)

	//by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	OD_IMPLEMENT_FIELD (IPMP_UserQueryResponse, inclReplyText)//added
	OD_IMPLEMENT_FIELD (IPMP_UserQueryResponse, inclOptionSelect)//added
	OD_IMPLEMENT_FIELD (IPMP_UserQueryResponse, reserved)//added
	OD_IMPLEMENT_FIELD (IPMP_UserQueryResponse, languageCode)
	OD_IMPLEMENT_FIELD (IPMP_UserQueryResponse, nReplyText)//added
	//OD_IMPLEMENT_FIELD (IPMP_UserQueryResponse, charCode)//delete
	OD_IMPLEMENT_FIELD (IPMP_UserQueryResponse, replyText)
	OD_IMPLEMENT_FIELD (IPMP_UserQueryResponse, numOfOptions)
	OD_IMPLEMENT_FIELD (IPMP_UserQueryResponse, optionResults)
	OD_IMPLEMENT_FIELD (IPMP_UserQueryResponse, reserved2)//added
	//End: by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003

OD_IMPLEMENT_DESCRIPTOR_END (IPMP_UserQueryResponse)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_ToolParamCapabilitiesQuery)
	OD_IMPLEMENT_FIELD (IPMP_ToolParamCapabilitiesQuery, Version)
	OD_IMPLEMENT_FIELD (IPMP_ToolParamCapabilitiesQuery, dataID)
	OD_IMPLEMENT_FIELD (IPMP_ToolParamCapabilitiesQuery, toolParamDesc)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_ToolParamCapabilitiesQuery)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_ToolParamCapabilitiesResponse)
	OD_IMPLEMENT_FIELD (IPMP_ToolParamCapabilitiesResponse, Version)
	OD_IMPLEMENT_FIELD (IPMP_ToolParamCapabilitiesResponse, dataID)
	OD_IMPLEMENT_FIELD (IPMP_ToolParamCapabilitiesResponse, capabilitiesSupported)
	OD_IMPLEMENT_FIELD (IPMP_ToolParamCapabilitiesResponse, Reserved)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_ToolParamCapabilitiesResponse)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_GetTools)
	OD_IMPLEMENT_FIELD (IPMP_GetTools, Version)
	OD_IMPLEMENT_FIELD (IPMP_GetTools, dataID)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_GetTools)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_GetToolsResponse)
	OD_IMPLEMENT_FIELD (IPMP_GetToolsResponse, Version)
	OD_IMPLEMENT_FIELD (IPMP_GetToolsResponse, dataID)
	//by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	//OD_IMPLEMENT_FIELD (IPMP_GetToolsResponse, IPMP_ToolID)
	OD_IMPLEMENT_FIELD (IPMP_GetToolsResponse, tools)
	//End: by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_GetToolsResponse)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_GetToolContext)
	OD_IMPLEMENT_FIELD (IPMP_GetToolContext, Version)
	OD_IMPLEMENT_FIELD (IPMP_GetToolContext, dataID)
	/********* Change by Liao Xuan **************************************/
	/* according to ISO/IEC 14496-1:2001/FDAM 3:2003
	/*
	OD_IMPLEMENT_FIELD (IPMP_GetToolContext, hasDescriptor)
	OD_IMPLEMENT_FIELD (IPMP_GetToolContext, hasES_ID)
	OD_IMPLEMENT_FIELD (IPMP_GetToolContext, hasOD_ID)
	OD_IMPLEMENT_FIELD (IPMP_GetToolContext, Reserved)
	OD_IMPLEMENT_FIELD (IPMP_GetToolContext, descriptorIDEx)
	OD_IMPLEMENT_FIELD (IPMP_GetToolContext, ES_ID)
	OD_IMPLEMENT_FIELD (IPMP_GetToolContext, OD_ID)
	*/
	OD_IMPLEMENT_FIELD (IPMP_GetToolContext, scope)
	OD_IMPLEMENT_FIELD (IPMP_GetToolContext, hasIPMPDescriptorIDEx)
	OD_IMPLEMENT_FIELD (IPMP_GetToolContext, reserved)
	OD_IMPLEMENT_FIELD (IPMP_GetToolContext, IPMP_DescriptorIDEx)
	/********* End: Change by Liao Xuan **********************************/
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_GetToolContext)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_GetToolContextResponse)
	OD_IMPLEMENT_FIELD (IPMP_GetToolContextResponse, Version)
	OD_IMPLEMENT_FIELD (IPMP_GetToolContextResponse, dataID)

	//by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	OD_IMPLEMENT_FIELD (IPMP_GetToolContextResponse, hasESD_ID)//add
	OD_IMPLEMENT_FIELD (IPMP_GetToolContextResponse, reserved)//add
	OD_IMPLEMENT_FIELD (IPMP_GetToolContextResponse, OD_ID)//add
	OD_IMPLEMENT_FIELD (IPMP_GetToolContextResponse, ESD_ID)//add
	//End: by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003

	OD_IMPLEMENT_FIELD (IPMP_GetToolContextResponse, toolContextID)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_GetToolContextResponse)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_ConnectTool)
	OD_IMPLEMENT_FIELD (IPMP_ConnectTool, Version)
	OD_IMPLEMENT_FIELD (IPMP_ConnectTool, dataID)
	OD_IMPLEMENT_FIELD (IPMP_ConnectTool, descriptor)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_ConnectTool)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_DisconnectTool)
	OD_IMPLEMENT_FIELD (IPMP_DisconnectTool, Version)
	OD_IMPLEMENT_FIELD (IPMP_DisconnectTool, dataID)
	OD_IMPLEMENT_FIELD (IPMP_DisconnectTool, toolContextID)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_DisconnectTool)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_NotifyToolEvent)
	OD_IMPLEMENT_FIELD (IPMP_NotifyToolEvent, Version)
	OD_IMPLEMENT_FIELD (IPMP_NotifyToolEvent, dataID)

	//by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	OD_IMPLEMENT_FIELD (IPMP_NotifyToolEvent, hasID)//add
	OD_IMPLEMENT_FIELD (IPMP_NotifyToolEvent, reserved)//add
	OD_IMPLEMENT_FIELD (IPMP_NotifyToolEvent, OD_ID)//add
	OD_IMPLEMENT_FIELD (IPMP_NotifyToolEvent, reserved2)//add
	OD_IMPLEMENT_FIELD (IPMP_NotifyToolEvent, ESD_ID)//add
	//End: by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003

	OD_IMPLEMENT_FIELD (IPMP_NotifyToolEvent, eventType)
	OD_IMPLEMENT_FIELD (IPMP_NotifyToolEvent, toolContextID)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_NotifyToolEvent)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_CanProcess)
	OD_IMPLEMENT_FIELD (IPMP_CanProcess, Version)
	OD_IMPLEMENT_FIELD (IPMP_CanProcess, dataID)
	OD_IMPLEMENT_FIELD (IPMP_CanProcess, canProcess)
	OD_IMPLEMENT_FIELD (IPMP_CanProcess, Reserved)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_CanProcess)

OD_IMPLEMENT_DESCRIPTOR_START (User_Initialize)
	OD_IMPLEMENT_FIELD (User_Initialize, Version)
	OD_IMPLEMENT_FIELD (User_Initialize, dataID)
	OD_IMPLEMENT_FIELD (User_Initialize, messageInterface)
	OD_IMPLEMENT_FIELD (User_Initialize, toolDescriptor)
OD_IMPLEMENT_DESCRIPTOR_END (User_Initialize)

OD_IMPLEMENT_DESCRIPTOR_START (User_Initialized)
	OD_IMPLEMENT_FIELD (User_Initialized, Version)
	OD_IMPLEMENT_FIELD (User_Initialized, dataID)
OD_IMPLEMENT_DESCRIPTOR_END (User_Initialized)

OD_IMPLEMENT_DESCRIPTOR_START (IPMP_Message)
	OD_IMPLEMENT_FIELD (IPMP_Message, IPMPS_Type)
	OD_IMPLEMENT_FIELD (IPMP_Message, URLString)

	// change by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	//OD_IMPLEMENT_FIELD (IPMP_Message, IPMP_DescriptorID)
	OD_IMPLEMENT_FIELD (IPMP_Message, IPMP_DescriptorIDEx)
	// End: change by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	
	OD_IMPLEMENT_FIELD (IPMP_Message, IPMP_ExtendedData)
	OD_IMPLEMENT_FIELD (IPMP_Message, IPMP_data)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_Message)

/*********** Hide by Liao Xuan **************************/
/* use another implementation to decode IPMP_ToolES_AU	*/
/*
OD_IMPLEMENT_DESCRIPTOR_START (IPMP_ToolES_AU)
	OD_IMPLEMENT_FIELD (IPMP_ToolES_AU, isSigned)
	OD_IMPLEMENT_FIELD (IPMP_ToolES_AU, reserved)
	OD_IMPLEMENT_FIELD (IPMP_ToolES_AU, IPMP_Tool_Signature)
	
	//by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	OD_IMPLEMENT_FIELD (IPMP_ToolES_AU, numCerts)//added
	OD_IMPLEMENT_FIELD (IPMP_ToolES_AU, CertType)//added
	OD_IMPLEMENT_FIELD (IPMP_ToolES_AU, certificates)
	OD_IMPLEMENT_FIELD (IPMP_ToolES_AU, verifying_Tool_ID)
	OD_IMPLEMENT_FIELD (IPMP_ToolES_AU, sizeOfTool)//added
	//End: by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003

	OD_IMPLEMENT_FIELD (IPMP_ToolES_AU, Tool_Body)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_ToolES_AU)
*/
/*********** Hide by Liao Xuan ***************************/


/*************** Add by Liao Xuan *******************************************/
/*  according to ISO/IEC 14496-1:2001/FDAM 3:2003							*/
/*  a new messgae															*/
OD_IMPLEMENT_DESCRIPTOR_START (IPMP_ToolAPI_Config)
	OD_IMPLEMENT_FIELD (IPMP_ToolAPI_Config, Version)
	OD_IMPLEMENT_FIELD (IPMP_ToolAPI_Config, dataID)
	OD_IMPLEMENT_FIELD (IPMP_ToolAPI_Config, has_Instantiation_API_ID)
	OD_IMPLEMENT_FIELD (IPMP_ToolAPI_Config, has_Messaging_API_ID)
	OD_IMPLEMENT_FIELD (IPMP_ToolAPI_Config, reserved)
	OD_IMPLEMENT_FIELD (IPMP_ToolAPI_Config, Instantiation_API_ID)
	OD_IMPLEMENT_FIELD (IPMP_ToolAPI_Config, Messaging_API_ID)
	OD_IMPLEMENT_FIELD (IPMP_ToolAPI_Config, OpaqueData)
OD_IMPLEMENT_DESCRIPTOR_END (IPMP_ToolAPI_Config)
/*************** End: Add by Liao Xuan ***************************************/

