//	This software module was originally developed by ContentGuard, Inc
//  and later on modified by Filippo Chiariglione (Microsoft Research Asia)
//
//	in the course of development of the MPEG-4 Systems 
//	(ISO/IEC 14496-1) standard. This software module is an implementation 
//	of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified 
//	by the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	ContentGuard Inc and Microsoft Research Asia retains full right to use
//  the code for its own purpose, assign or donate the code to a third party and 
//  to inhibit third parties from using the code for non MPEG-4 Systems 
//  (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2000. 


#ifndef CGUTIL_H
#define CGUTIL_H


#include <atlbase.h>
#include <string>
#include <iostream>

#import <msxml4.dll>

using namespace std;
using namespace MSXML2;


class CGUtil
{
public:

	//-------------------------------------------------------------------------
	//--FUNCTION compare
	//-------------------------------------------------------------------------
	//--This function takes two strings containing ISO date and time, converts them
	//  to time_t representation, and returns the difference between the two time_t
	//  objects through ptrdCompareResult (wstrDateTime1 - wstrDateTime2).
	//--The input strings must be in the following format:
	//   YYYY-MM-DDTHH:MM:SS
	//--The incoming ptrdCompareResult must point to a valid double (it should be
	//  allocated by the caller).
	//--Example: 2002-10-17T12:57:23 (Oct 10th, 2002, 12:57 with 23 seconds pm)
	//-------------------------------------------------------------------------
	static HRESULT compare(
		wstring wstrDateTime1, 
		wstring wstrDateTime2, 
		double	*ptrdCompareResult);

	//-------------------------------------------------------------------------
	//--FUNCTION convertDateTime
	//-------------------------------------------------------------------------
	//--This function takes a string containing an ISO date and time and returns 
	//  the corresponding tm representation of it.
	//--The input string must be in the following format:
	//   YYYY-MM-DDTHH:MM:SS
	//--The incoming ptrtmOutTime must point to a valid tm (it should be allocated
	//  by the caller).
	//--Example: 2002-10-17T12:57:23 (Oct 10th, 2002, 12:57 with 23 seconds pm)
	//-------------------------------------------------------------------------
	static HRESULT convertDateTime(wstring wstrISODateTime, tm *ptrtmOutTime);

	//-------------------------------------------------------------------------
	//--FUNCTION ReportError
	//-------------------------------------------------------------------------
	//--This function is used for reporting parsing errors which occur during the
	//  loading of xml into a IXMLDOMDocument2Ptr object.
	//--Parameters:  
	//     wostream &wout 							-> a wide output stream to which the error report will be output to.
	//     IXMLDOMParseError *pXMLError 	-> contains the error info.
	//-------------------------------------------------------------------------
	static HRESULT ReportError(wstring* wout, MSXML2::IXMLDOMParseError *pXMLError);

};//END CLASS CGUtil


#endif