//	This software module was originally developed by Filippo Chiariglione
//	(Microsoft Research Asia), Craig A. Schultz (AccessTicket Systems Inc.) 
//  and ContentGuard Inc
//
//	in the course of development of the MPEG-4 Systems 
//	(ISO/IEC 14496-1) standard. This software module is an implementation 
//	of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified 
//	by the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
// 
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	Microsoft Research Asia, AccessTicket Systems Inc. and ContentGuard Inc
//  retains full right to use the code for its own purpose, assign or donate 
//  the code to a third party and to inhibit third parties from using the code 
//  for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2000. 


#include "RELLicenseAuthorization.h"
#include "CGUtil.h"

#include "defs.h"
#include "IPMP_Messages.h"
#include "IPMP_RELTool.h"
#include "SecurityLib.h"
#include <stdio.h>
//#include "sdl.h"

using namespace MSXML2;
using namespace std;


// XPATH expressions used throughout the program
const wstring	XPATH_QUERY_MODULUS(L"/child::*[local-name()=\"query\"]/child::*[local-name()=\"goalToCheck\"]/child::*[local-name()=\"principalToCheck\"]/@rsaModulus");
const wstring	XPATH_QUERY_EXPONENT(L"/child::*[local-name()=\"query\"]/child::*[local-name()=\"goalToCheck\"]/child::*[local-name()=\"principalToCheck\"]/@rsaExponent");
const wstring	XPATH_QUERY_RIGHT(L"/child::*[local-name()=\"query\"]/child::*[local-name()=\"goalToCheck\"]/child::*[local-name()=\"rightToCheck\"]/child::*");
const wstring	XPATH_QUERY_RESOURCE_URI(L"/child::*[local-name()=\"query\"]/child::*[local-name()=\"goalToCheck\"]/child::*[local-name()=\"resourceToCheck\"]/@uri");
const wstring	XPATH_QUERY_REFERENCE_TIME(L"/child::*[local-name()=\"query\"]/child::*[local-name()=\"simulationExerciseEnvironment\"]/child::*[local-name()=\"time\"]");
const wstring	XPATH_ISSUER_MODULUS(L"/child::*[local-name()=\"issuer\"]/child::*[local-name()=\"Signature\"][namespace-uri()=\"http://www.w3.org/2000/09/xmldsig#\"]/child::*[local-name()=\"KeyInfo\"][namespace-uri()=\"http://www.w3.org/2000/09/xmldsig#\"]/child::*[local-name()=\"KeyValue\"][namespace-uri()=\"http://www.w3.org/2000/09/xmldsig#\"]/child::*[local-name()=\"RSAKeyValue\"][namespace-uri()=\"http://www.w3.org/2000/09/xmldsig#\"]/child::*[local-name()=\"Modulus\"][namespace-uri()=\"http://www.w3.org/2000/09/xmldsig#\"]");
const wstring	XPATH_ISSUER_EXPONENT(L"/child::*[local-name()=\"issuer\"]/child::*[local-name()=\"Signature\"][namespace-uri()=\"http://www.w3.org/2000/09/xmldsig#\"]/child::*[local-name()=\"KeyInfo\"][namespace-uri()=\"http://www.w3.org/2000/09/xmldsig#\"]/child::*[local-name()=\"KeyValue\"][namespace-uri()=\"http://www.w3.org/2000/09/xmldsig#\"]/child::*[local-name()=\"RSAKeyValue\"][namespace-uri()=\"http://www.w3.org/2000/09/xmldsig#\"]/child::*[local-name()=\"Exponent\"][namespace-uri()=\"http://www.w3.org/2000/09/xmldsig#\"]");

// This flag is used to turn on and off validation.
const VARIANT_BOOL   VALIDATE_ON_PARSE(VARIANT_FALSE);


/*-------------------------------------------------------------
The exported function that instantiates the proper IPMPManager object
-------------------------------------------------------------*/
extern "C" void* CreateInstance ()
{
	//int j=0;
	//int i= 100/j;
	/*********** Add by Liao Xuan, to show IPMP information **************/
	MessageBox(NULL, "IPMP REL Tool Loaded", "IPMP Tool", MB_OK);
	/*********** End: Add by Liao Xuan, to show IPMP information *********/
	return new IPMP_RELTool;
}

IPMP_RELTool::IPMP_RELTool ()
	: m_pMRInterface		(NULL)
	, m_myContextID			(0)
	, m_pMyIPMPDescriptor	(NULL)
	, m_pSecurity			(NULL)
	, m_pData				(NULL)
	, m_bLicenseArrived (false)
{
	IPMPX_Tool::IPMPX_Tool();
}

IPMP_RELTool::~IPMP_RELTool()
{
	if (m_pSecurity != NULL)
	{
		delete m_pSecurity;
		m_pSecurity = NULL;// added by Liao Xuan
	}
	if (m_pData != NULL)
	{
		delete[] m_pData;
		m_pData = NULL;// added by Liao Xuan
	}
	::SysFreeString(m_sLicense);
}

/************************** Rewrite by Liao Xuan *******************/
/*bool IPMP_RELTool::ReceiveMessage( ToolMessage*	msg )
{	
	int i = msg->IPMP_MessageFromBitstream.GetLength() - 1;
	while (i >= 0)
	{
		if ((msg->IPMP_MessageFromBitstream[i])->GetTag() == TAG_IPMP_Secure_Container) // Could be the query
		{
			IPMP_RightsData* rights = NULL;
			rights = (IPMP_RightsData*)m_pSecurity->ProcessSecureContainer((IPMP_Secure_Container*)msg->IPMP_MessageFromBitstream[i], msg->sender);
			if (m_bLicenseArrived == false)
			{
				m_sLicense = GetRELString(rights);
				m_bLicenseArrived = true;
			}
			else
			{
				BSTR query = GetRELString(rights);
				m_bLicenseArrived = false;
				ProcessREL(query);
			}
			i--;
		}//end if
		else 
		{
			ProcessMessage( msg, msg->IPMP_MessageFromBitstream[i] );
			i--;
		}
	}		
	
	for ( int j = msg->IPMP_DescriptorFromBitstream.GetLength(); --j >= 0; )
	{
		IPMP_Descriptor descriptor = *(msg->IPMP_DescriptorFromBitstream[j]);
	}
	return true;
}*/
bool IPMP_RELTool::ReceiveMessage( IPMP_ToolMessageBase* msg )
{
	switch (msg->tag)
	{
		case(0x01): //IPMP_MessageFromBitstream 
			return false;
		case(0x02)://IPMP_DescriptorFromBitstream
		{
			for ( int i = ((IPMP_DescriptorFromBitstream*)msg)->toolDescriptor.GetLength(); --i >= 0; )
				IPMP_Descriptor descriptor = *(((IPMP_DescriptorFromBitstream*)msg)->toolDescriptor[i]);
			return true;
		}
		case(0x03): //IPMP_MessageFromTool
		{
			int i = ((IPMP_MessageFromTool*)msg)->messages.GetLength() - 1;
			while (i >= 0)
			{
				if ((((IPMP_MessageFromTool*)msg)->messages[i])->GetTag() == TAG_IPMP_Secure_Container) // Could be the query
				{
					IPMP_RightsData* rights = NULL;
					rights = (IPMP_RightsData*)m_pSecurity->ProcessSecureContainer((IPMP_Secure_Container*)((IPMP_MessageFromTool*)msg)->messages[i], msg->sender);
					if (m_bLicenseArrived == false)
					{
						m_sLicense = GetRELString(rights);
						m_bLicenseArrived = true;
					}
					else
					{
						BSTR query = GetRELString(rights);
						m_bLicenseArrived = false;
						ProcessREL(query);
					}
					i--;
				}//end if
				else 
				{
					ProcessMessage(((IPMP_MessageFromTool*)msg),(IPMP_Data_BaseClass*)((IPMP_MessageFromTool*)msg)->messages[i]);
					i--;
				}
			}
			return true;
		}
	}
	return false;
}
/**************************End: Rewrite by Liao Xuan ****************/


bool IPMP_RELTool::ProcessData ( LPBYTE	pInput
								, int		nInputLength 
								, DWORD		dwTime )
{
	if ( m_pNextTool == NULL )
		return false;

	return m_pNextTool->ProcessData( pInput, nInputLength, dwTime );
}

/******************** Change by Liao Xuan **************************/
//bool IPMP_RELTool::ProcessMessage ( ToolMessage			*	base
									//,IPMP_Data_BaseClass	*	msg	)
bool IPMP_RELTool::ProcessMessage ( IPMP_MessageFromTool	*	base
									,IPMP_Data_BaseClass	*	msg	)
/******************** End: Change by Liao Xuan *********************/
{
	switch (msg->GetTag())
	{	
		case(TAG_IPMP_RightsData):
		{
			IPMP_RightsData* data = (IPMP_RightsData*)msg;
			return false;
		}
		case(TAG_IPMP_InitAuthentication):
		{
			if (m_pSecurity == NULL)
				return false;
			return (m_pSecurity->ProcessMutAuthInit(msg));
		}
		case(TAG_IPMP_MutualAuthentication):
		{
			if (m_pSecurity == NULL)
				return false;
			return (m_pSecurity->ProcessMutAuthMsg(msg, base->sender));
		}
		case(TAG_User_Initialize):
		{
			m_myContextID = base->receiver;
			memcpy( &m_pMRInterface
				  , LPCBYTE(((User_Initialize*)msg)->messageInterface)
				  , sizeof(void*) );
			if (m_pSecurity != NULL)
				delete m_pSecurity;
			m_pSecurity = new SecurityLib((MessageDistributor*)m_pMRInterface);

			/********* Change by Liao Xuan **************************/
			//ToolMessage				newMsg;
			IPMP_MessageFromTool		newMsg;
			User_Initialized			payload;

			newMsg.receiver = 0x00;
			newMsg.sender = m_myContextID;

			memcpy( &m_pMyIPMPDescriptor
				  , LPCBYTE(((User_Initialize*)msg)->toolDescriptor)
				  , sizeof(void*) );

			// Read the contents of the IPMP_data field.
			for ( int ui = m_pMyIPMPDescriptor->IPMPX_Data.GetLength(); --ui >= 0; )
			{
				switch (m_pMyIPMPDescriptor->IPMPX_Data[ui]->GetTag()){
				case (TAG_IPMP_OpaqueData):
					{
						IPMP_OpaqueData * data = (IPMP_OpaqueData*)m_pMyIPMPDescriptor->IPMPX_Data[ui];
					}
				}
			}
			//newMsg.IPMP_MessageFromBitstream += &payload;
			newMsg.messages += &payload;
			/********* End : Change by Liao Xuan ********************/
			m_pMRInterface->ReceiveMessage(&newMsg);


			/********************** Hide by Liao Xuan ***************/
			/* need not to notify IPMP_MasterTool, becuase IPMPXFull   */
			/* will notify the succesful connection                    */
			
			/*ToolMessage					anotherNewMsg;
			IPMP_NotifyToolEvent		event;
			event.eventType =			CONNECTED;
			//by Liao Xuan
			//event.toolContextID =		m_myContextID;
			// by Liao Xuan
			anotherNewMsg.receiver = m_MasterToolContextID;
			newMsg.sender = m_myContextID;
			m_pMRInterface->ReceiveMessage(&anotherNewMsg);*/
			/**********************End: Hide by Liao Xuan ***********/
			
			return true;
		}
		case(TAG_IPMP_NotifyToolEvent):
		{
			/******** Add by Liao Xuan *****************************/
			/* to dynamically get the ContextID of IPMP_MasterTool */
			m_MasterToolContextID = ((IPMP_NotifyToolEvent*)msg)->toolContextID;
			/******** End: Add by Liao Xuan ************************/
			return true;
		}
	}
	return false;
}

/**
* This is the method used for validation request and conditions.  
*/
bool IPMP_RELTool::ProcessREL(BSTR query)
{
	OutputDebugString("IPMP_RELTool::ProcessREL(BSTR query)\n");
	CRELLicenseAuthorization authModule;
	HRESULT hr = S_OK;
	wstring						wstrLicenseGroup;					// Will hold the REL licenseGroup extracted from the license file.
	wstring						wstrUserModulus;					// Will hold the modulus (for a keyHolder) extracted from the XML query file.
	wstring						wstrUserExponent;					// Will hold the exponent (for a keyHolder) extracted from the XML query file.
	wstring						wstrResourceLocationUri;			// Will hold the resource uri extracted from the XML query file.	  	  
	wstring						wstrTimetoCheck;					// Will hold the reference time (used as the time of exercise) extracted from the XML query file.	  	  
	wstring						wstrRELKeyHolder = L"";				// Will hold the REL keyHolder that is constructed  using the modulus and exponent we pull from XML query file
	wstring						wstrRELRight;						// Will hold the REL right we pull from XML query file
	wstring						wstrErrorStr;						// Will hold info about the error occurred when loading REL in IXMLDOMDocument
	wstring						wstrResource = L"";					// Will hold the REL resource created using the resourceUri from the query file
	vector<wstring>				*pvecIssuers = NULL;				// Pointer for the issuer vector we will be returned
	wstring						*pstrIssuer = new wstring();		// For keyholder 
	vector<wstring>				*pvecConditions = NULL;				// Pointer for the condition vector we will be returned
	wstring						*pstrCondition = new wstring();		// Used in processing the conditions					
	bool						bConditionMet = false;				// Used in processing the conditions

	// Initialize COM stuff.
 	CoInitialize(NULL);

	hr = ExtractRequestItems(query, &wstrLicenseGroup,
			&wstrUserModulus, &wstrUserExponent, &wstrRELRight, &wstrResourceLocationUri,				  	  
			&wstrTimetoCheck, &wstrErrorStr);


	/*************Change by Liao Xuan ********************/
	// send one more message to IPMPXFull                
	//ToolMessage				newMsg2;
	IPMP_MessageFromTool		newMsg2;
	newMsg2.receiver = 0x00;
	newMsg2.sender = m_myContextID;

	//IPMP_OpaqueData opaque;
	IPMP_OpaqueData* opaque = new IPMP_OpaqueData;
	//create a temp ByteArray, for constructing the buggy IPMP_OpaqueData
	ByteArray* opaqueArray = new ByteArray; 
	/*************End: change by Liao Xuan****************/	
	
	if (S_OK != hr) //errors: canProcess = false and send error string
	{

		/*************change by Liao Xuan ********************/
		//ToolMessage				newMsg;
		IPMP_MessageFromTool		newMsg;
		newMsg.receiver = m_MasterToolContextID;
		newMsg.sender = m_myContextID;

		IPMP_CanProcess		payload; //It cannot process
		//payload.canProcess = 1; //false
		payload.canProcess = 0 ;//false
		/*************End: change by Liao Xuan****************/	

		
		if (m_pData != NULL)
		{
			delete[] m_pData;
		}

		//transforming the wstring in char*
		basic_string <char>::size_type len;
		len = wstrErrorStr.size();
		m_pData = new char[len * 2];
		m_pData = (char*)wstrErrorStr.c_str();

		//writes the string inside the IPMP_OpaqueData message
		/************** Change By Liao Xuan ************************/
		/* because of SDLClass<class ByteArray,1>, it is           */
		/* buggy to insert element directly                        */
		for (int i = 0; i < len; i++)
		{
			//opaque.opaqueData.InsertElement(m_pData[i*2], i);

			//first, insert element into the temp ByteArray, opaqueArray
			opaqueArray->array.InsertElement(m_pData[i*2], i);
		}
		// Then, point opaque->opaqueData to opaqueArray
		opaque->opaqueData = (ByteArray*)opaqueArray;
		/************** End: Change By Liao Xuan *******************/

		/************** Change By Liao Xuan ************************/
		//newMsg.IPMP_MessageFromBitstream += &opaque;
		//newMsg.IPMP_MessageFromBitstream += &payload;
		newMsg.messages += opaque;
		newMsg.messages += &payload;
		/************** End: Change By Liao Xuan *******************/
	
		m_pMRInterface->ReceiveMessage(&newMsg);
		
		/************** Add by Liao Xuan ***************************/
		/*  send one more CanProcess message to IPMPXFull          */
		newMsg2.messages += opaque;
		newMsg2.messages += &payload;
		m_pMRInterface->ReceiveMessage(&newMsg2);
		/************** End: Add by Liao Xuan **********************/


		return false;
	}//if (S_OK != hr)

	// Construct the principal
	wstrRELKeyHolder = L"<keyHolder xmlns=\"http://www.xrml.org/schema/2002/05/xrml2core\" xmlns:dsig=\"http://www.w3.org/2000/09/xmldsig#\"><info><dsig:KeyValue><dsig:RSAKeyValue><dsig:Modulus>" + wstrUserModulus + L"</dsig:Modulus>";
	wstrRELKeyHolder = wstrRELKeyHolder + L"<dsig:Exponent>" + wstrUserExponent + L"</dsig:Exponent>";
	wstrRELKeyHolder = wstrRELKeyHolder + L"</dsig:RSAKeyValue></dsig:KeyValue></info></keyHolder>";

	// Construct the resource
	wstrResource = L"<digitalResource xmlns=\"http://www.xrml.org/schema/2002/05/xrml2core\"><nonSecureIndirect URI=\"" + wstrResourceLocationUri + L"\"/></digitalResource>";

	wstring outstr; //string that will contain Conditions & Issuers
	outstr.assign(L"");

	// Create the CRELLicenseAuthorization module
	authModule.setValidationFlag(VALIDATE_ON_PARSE);
	hr = authModule.ValidateRequest (wstrLicenseGroup, wstrRELKeyHolder, wstrRELRight, wstrResource, &pvecConditions, &pvecIssuers, &outstr);
	// NOTE: pvecIssuers are returned by ValidateRequest to allow the application to perform trust authentication on the issuers before 
	// proceeding with authorization
	
	if (S_OK == hr)  
	{
		outstr.append(L"\r\n");
		outstr.append(L"CONDITIONS FOR ALL MATCHING GRANTS:");
		outstr.append(L"\r\n"); 
		outstr.append(L"\r\n");
		for (int n = 0; n < pvecConditions->size(); n++)
		{
			outstr.append(L"Condition #");

			char num [10];
			_itoa(n, num, 10);
			BSTR bs = _com_util::ConvertStringToBSTR(num);
			outstr.append(bs);
			
			outstr.append(L": \r\n");
			outstr.append((*pvecConditions)[n]);
			outstr.append(L"\r\n");
			outstr.append(L"\r\n");
		}

		wstring wstrIssuers;
		AddIssuers(&wstrIssuers, pvecIssuers); //store in issuers
		
		outstr.append(wstrIssuers);//append to outstr the issuers found
		
		// Matching grant found, now we need to evaluate the time condition
		outstr.append(L"\r\n");
		outstr.append(L"\r\n");
		outstr.append(L"EVALUATING CONDITIONS:");
		outstr.append(L"\r\n");

		// Preparing a wstring containing Conditions found
		int nConditionCounter;

		for (nConditionCounter = 0; nConditionCounter < pvecConditions->size(); nConditionCounter++)
		{
			if ((*pvecConditions)[nConditionCounter] == L"")
			{
				// If there was a grant with no condition, no need to evaluate further
				bConditionMet = true;
				// Exit on the first match
				break;
			}
			else
			{
				wstring wtmp;
				// We have a condition so lets evaluate it.			
				hr = authModule.ValidateCondition((*pvecConditions)[nConditionCounter], wstrTimetoCheck, &wtmp);
				if (S_OK == hr)
				{
					if(&wtmp)
					{
						outstr.append(wtmp);
						bConditionMet = true;
						// Exit on the first match
						break;
					}
					else
						return false;
				}//END IF
			}//END IF
		}//END FOR LOOP
		

		/*************change by Liao Xuan ***********/
		//ToolMessage				newMsg;
		IPMP_MessageFromTool		newMsg;
		/************* End: change by Liao Xuan *****/

		newMsg.receiver = m_MasterToolContextID;
		newMsg.sender = m_myContextID;

		IPMP_CanProcess	payload;

		if (m_pData != NULL)
		{
			delete[] m_pData;
		}
		
		// Was there a condition that was met?
		if (bConditionMet == true)
		{
			/*************change by Liao Xuan ***********/
			//payload.canProcess = 0; //true
			payload.canProcess = 1; //true
			/************ End: change by Liao Xuan ******/

			outstr.append(L"-->condition #");
			char num [10];
			_itoa(nConditionCounter, num, 10);
			BSTR bs = _com_util::ConvertStringToBSTR(num);
			outstr.append(bs);

			outstr.append(L" was met");
			outstr.append(L"\r\n");

			if (m_pSecurity == NULL) // in this case the conditions & matching grants are sent through the secure container
			{
				return false;
			}

			basic_string <char>::size_type len;
			len = outstr.size();
			m_pData = new char[len * 2];
			m_pData = (char*)outstr.c_str();

			//writes the string inside the IPMP_OpaqueData message
			/************** Change By Liao Xuan ************************/
			/* because of SDLClass<class ByteArray,1>, it is           */
			/* buggy to insert element directly                        */
			for (int i = 0; i < len; i++)
			{
				//opaque.opaqueData.InsertElement(m_pData[i*2], i);

				//first, insert element into the temp ByteArray, opaqueArray
				opaqueArray->array.InsertElement(m_pData[i*2], i);
			}
			// Then, point opaque->opaqueData to opaqueArray
			opaque->opaqueData = (ByteArray*)opaqueArray;
			/************** End: Change By Liao Xuan *******************/


			/************** Delete By Liao Xuan ***************/
			/* duplicate sending opaque message, no need      */
			//m_pSecurity->SendSecureMessage((IPMP_Data_BaseClass*)opaque, m_MasterToolContextID);// the conditions are sent through a secure channel
			/************** End: Delete By Liao Xuan **********/
		
		}//if (bConditionMet == true)

		else // Matching grant found, but the condition failed
		{
			/************** Change By Liao Xuan *******/
			//payload.canProcess = 1; //false
			payload.canProcess = false; //false
			/************** End: Change By Liao Xuan **/

			outstr.append(L"-->conditions were not met");
			outstr.append(L"\r\n");

			basic_string <char>::size_type len;
			len = outstr.size();
			m_pData = new char[len * 2];
			m_pData = (char*)outstr.c_str();

			//writes the string inside the IPMP_OpaqueData message
			/************** Change By Liao Xuan ************************/
			/* because of SDLClass<class ByteArray,1>, it is           */
			/* buggy to insert element directly                        */
			for (int i = 0; i < len; i++)
			{
				//opaque.opaqueData.InsertElement(m_pData[i*2], i);

				//first, insert element into the temp ByteArray, opaqueArray
				opaqueArray->array.InsertElement(m_pData[i*2], i);
			}
			// Then, point opaque->opaqueData to opaqueArray
			opaque->opaqueData = (ByteArray*)opaqueArray;
			/************** End: Change By Liao Xuan *******************/

		} // else ,(bConditionMet == false)

		/************** Change By Liao Xuan *********************/
		//newMsg.IPMP_MessageFromBitstream += &opaque;
		//newMsg.IPMP_MessageFromBitstream += &payload;
		newMsg.messages += opaque;
		newMsg.messages += &payload;

		m_pMRInterface->ReceiveMessage(&newMsg);

        // send one more message to IPMPXFull
		newMsg2.messages += opaque;
		newMsg2.messages += &payload;
		m_pMRInterface->ReceiveMessage(&newMsg2);
		/***************End: Change By Liao Xuan*****************/

		if(NULL != pvecConditions)
			authModule.releaseMem(pvecConditions);
		if(NULL != pvecIssuers)
			authModule.releaseMem(pvecIssuers);

		return true;
	}

	else // failure conditions
	{
		/************** Change By Liao Xuan *********************/
		//ToolMessage				newMsg;
		IPMP_MessageFromTool		newMsg;
		newMsg.receiver = m_MasterToolContextID;
		newMsg.sender =	m_myContextID;
		
		IPMP_CanProcess		payload;

		//payload.canProcess = 1; //false
		payload.canProcess = 0; //false
		/************** ENd: Change By Liao Xuan ****************/

		if (m_pData != NULL)
		{
			delete[] m_pData;
		}
		
		basic_string <char>::size_type len; // will contain the length of the wstring

		if (S_FALSE == hr) //no grants found
		{
			outstr.append(L"\r\n");
			outstr.append(L"-->NO MATCHING GRANT WAS FOUND. ");
			outstr.append(L"\r\n");

			//transforming the wstring in char*
			len = outstr.size();
			m_pData = new char[len * 2];
			m_pData = (char*)outstr.c_str();

			//writes the string inside the IPMP_OpaqueData message
			/************** Change By Liao Xuan ************************/
			/* because of SDLClass<class ByteArray,1>, it is           */
			/* buggy to insert element directly                        */
			for (int i = 0; i < len; i++)
			{
				//opaque.opaqueData.InsertElement(m_pData[i*2], i);

				//first, insert element into the temp ByteArray, opaqueArray
				opaqueArray->array.InsertElement(m_pData[i*2], i);
			}
			// Then, point opaque->opaqueData to opaqueArray
			opaque->opaqueData = (ByteArray*)opaqueArray;
			/************** End: Change By Liao Xuan *******************/
		}
		else
		{
			outstr.append(L"\r\n");
			outstr.append(L"--> unable to validate the request ");
			outstr.append(L"\r\n");

			//transforming the wstring in char*
			len = outstr.size();
			m_pData = new char[len * 2];
			m_pData = (char*)outstr.c_str();


			//writes the string inside the IPMP_OpaqueData message
			/************** Change By Liao Xuan ************************/
			/* because of SDLClass<class ByteArray,1>, it is           */
			/* buggy to insert element directly                        */
			for (int i = 0; i < len; i++)
			{
				//opaque.opaqueData.InsertElement(m_pData[i*2], i);

				//first, insert element into the temp ByteArray, opaqueArray
				opaqueArray->array.InsertElement(m_pData[i*2], i);
			}
			// Then, point opaque->opaqueData to opaqueArray
			opaque->opaqueData = (ByteArray*)opaqueArray;
			/************** End: Change By Liao Xuan *******************/

		}

		/************** Change By Liao Xuan ************************/
		//newMsg.IPMP_MessageFromBitstream += &opaque;
		//newMsg.IPMP_MessageFromBitstream += &payload;
		newMsg.messages += opaque;
		newMsg.messages += &payload;

		m_pMRInterface->ReceiveMessage(&newMsg);

		// send one more message to IPMPXFull
		newMsg2.messages += opaque;
		newMsg2.messages += &payload;
		m_pMRInterface->ReceiveMessage(&newMsg2);
		/************** End: Change By Liao Xuan ********************/
		
		if(NULL != pvecConditions)
			authModule.releaseMem(pvecConditions);
		if(NULL != pvecIssuers)
			authModule.releaseMem(pvecIssuers);
	}//else, failure conditions

	/**************** Add by Liao Xuan, release momery ***********/
	if (opaque)
	{
		delete opaque;
		opaque = NULL;
	}
	if (opaqueArray)
	{
		delete opaqueArray;
		opaqueArray = NULL;
	}
	/**************** ENd:  Add by Liao Xuan, release momery *****/
	return true;		
}


// In the case the messages are generated inside the IPMPX framework, the rightsInfo field
// will contain pointer to the license, otherwise if the messages comes from another IPMP Tool,
// the rightsInfo field will contain the whole license. 
BSTR IPMP_RELTool::GetRELString(IPMP_RightsData* msg)
{
	/************** Change By Liao Xuan ***************************/
	//int RELLen = msg->rightsInfo.GetLength();
	int RELLen = ((msg->rightsInfo)->array).GetLength();
	char* suitableBuffer = new char[RELLen];

	for (int i = 0; i < RELLen; i++)
	{
		//suitableBuffer[i] = (unsigned char)msg->rightsInfo.GetElement(i);
		suitableBuffer[i] = (unsigned char)((msg->rightsInfo)->array).GetElement(i);
	}
	/************** End: Change By Liao Xuan ********************/
	suitableBuffer[RELLen - 1]=0;

	BSTR bs = _com_util::ConvertStringToBSTR(suitableBuffer);
	
	if (suitableBuffer)
	{
		delete[] suitableBuffer;
		suitableBuffer = NULL;
	}
	return bs;
}

/*
* This method is called by the ProcessREL method for extracting from the license
* and the query their items.
*/
HRESULT IPMP_RELTool::ExtractRequestItems(
	BSTR	query,					
	wstring *pwstrLicenseGroup,				
	wstring *pwstrUserModulus,
	wstring *pwstrUserExponent,
	wstring *pwstrRELRight,				
	wstring *pwstrResourceLocationUri,				  	  
	wstring *pwstrTimetoCheck,
	wstring *pwstrErr)
{
	MSXML2::IXMLDOMDocument2Ptr pXMLLicenseDoc;		// For the license file
	MSXML2::IXMLDOMDocument2Ptr pXMLQueryDoc;		// For the input query file
	MSXML2::IXMLDOMParseError  *pXMLError = NULL;	// For XML errors
	MSXML2::IXMLDOMNodePtr		pXMLNodeTemp = NULL;	
	LONG						nErrorCode = E_FAIL;	// For error codes
	HRESULT						hr;

	if(	NULL == pwstrLicenseGroup	|| NULL == pwstrUserModulus	||
		NULL == pwstrUserExponent	|| NULL == pwstrRELRight	||
		NULL == pwstrResourceLocationUri)
	{
		return E_INVALIDARG;
	}//END IF

	// Create MSXML DOM object for the license
	hr = pXMLLicenseDoc.CreateInstance (__uuidof(MSXML2::DOMDocument40));
	if(S_OK != hr)
	{
		return E_FAIL;
	}//END IF

	// Create MSXML DOM object for the query
	hr = pXMLQueryDoc.CreateInstance (__uuidof(MSXML2::DOMDocument40));
	if(S_OK != hr)
	{
		return E_FAIL;
	}//END IF
	
	_variant_t varOut((bool)TRUE);

	// Set option to load the document synchronously
	pXMLLicenseDoc->async = VARIANT_TRUE; // default is true
	pXMLQueryDoc->async = VARIANT_TRUE; // default is true
	pXMLLicenseDoc->validateOnParse = VALIDATE_ON_PARSE;
	pXMLQueryDoc->validateOnParse = VALIDATE_ON_PARSE;

	// Load the license file into DOM
	if(pXMLLicenseDoc->loadXML(m_sLicense) != VARIANT_TRUE) // failed to load the license
    {
		(*pwstrErr).assign(L"\r\n");
		(*pwstrErr).append(L"Failed to load the License \r\n"); 
	    hr = pXMLLicenseDoc->get_parseError(&pXMLError);

		if(NULL != pXMLError)
		{
			hr = pXMLError->get_errorCode(&nErrorCode);
			if (nErrorCode != 0)
			{
				wstring wstrTmpErr;
				hr = CGUtil::ReportError(&wstrTmpErr, pXMLError);
				(*pwstrErr).append(wstrTmpErr);
			}
			pXMLError->Release();
		}
		return -1;
    }//END IF

	if (pXMLQueryDoc->loadXML(query) != VARIANT_TRUE) //failed to load the query
    {
		(*pwstrErr).assign(L"\r\n");
		(*pwstrErr).append(L"Failed to load the Query \r\n");
	    hr = pXMLQueryDoc->get_parseError(&pXMLError);
		
		if(NULL != pXMLError)
		{			
			hr = pXMLError->get_errorCode(&nErrorCode);
			if (nErrorCode != 0)
			{
				wstring wstrTmpErr;
				hr = CGUtil::ReportError(&wstrTmpErr, pXMLError);
				(*pwstrErr).append(wstrTmpErr);
			}
			pXMLError->Release();
		}
	    return -1;
    }//END IF (!success)
    
	// Pull out the query items from the XML query file.

	// Grab the modulus for the principal we want to test against
	pXMLNodeTemp = pXMLQueryDoc->selectSingleNode(XPATH_QUERY_MODULUS.c_str());
	if(NULL == pXMLNodeTemp)
	{
		(*pwstrErr).assign(L"\r\n");
		(*pwstrErr).append(L"Invalid request input. Could not find value for rsaModulus \r\n");
		return -1;	
	}
	*pwstrUserModulus = pXMLNodeTemp->text;

	// Grab the exponent for the principal we want to test against
	pXMLNodeTemp = pXMLQueryDoc->selectSingleNode(XPATH_QUERY_EXPONENT.c_str());
	if(NULL == pXMLNodeTemp)
	{
		(*pwstrErr).assign(L"\r\n");
		(*pwstrErr).append(L"Invalid request input. Could not find value for rsaExponent \r\n");
		return -1;
	}//END IF
	*pwstrUserExponent = pXMLNodeTemp->text;

	// Grab the right we want to test for
	pXMLNodeTemp = pXMLQueryDoc->selectSingleNode(XPATH_QUERY_RIGHT.c_str());
	if(NULL == pXMLNodeTemp)
	{
		(*pwstrErr).assign(L"\r\n");
		(*pwstrErr).append(L"Invalid request input. Could not find value for the right \r\n");
		return -1;
	}//END IF	
	*pwstrRELRight = pXMLNodeTemp->xml;

	// Grab the uri for the resource we want to test for	
	pXMLNodeTemp = pXMLQueryDoc->selectSingleNode(XPATH_QUERY_RESOURCE_URI.c_str());
	if(NULL == pXMLNodeTemp)
	{
		(*pwstrErr).assign(L"\r\n");
		(*pwstrErr).append(L"Invalid request input. Could not find value for the resource uri \r\n");
		return -1;
	}//END IF	
	*pwstrResourceLocationUri = pXMLNodeTemp->text;

	// Grab the time we want to use to compare against the validityInterval condition
	pXMLNodeTemp = pXMLQueryDoc->selectSingleNode(XPATH_QUERY_REFERENCE_TIME.c_str());
	if(NULL == pXMLNodeTemp)
	{
		(*pwstrErr).assign(L"\r\n");
		(*pwstrErr).append(L"Invalid request input. Could not find value for the date/time \r\n");
		return -1;
	}//END IF	
	*pwstrTimetoCheck = pXMLNodeTemp->text;

	// Pull the licenseGroup out of the REL license file
	*pwstrLicenseGroup = pXMLLicenseDoc->documentElement->xml;

	return S_OK;
}//END FUNCTION extractRequestItems


/*
* Called by the ProcessREL method, writes in pwIssuers all the Issuers found.
*/
HRESULT IPMP_RELTool::AddIssuers(wstring* pwIssuer, vector<wstring>* pvecIssuers)
{
	MSXML2::IXMLDOMParseError  *pXMLError = NULL; // For XML errors
	MSXML2::IXMLDOMDocument2Ptr pIssuer;	
	MSXML2::IXMLDOMNodePtr		pXMLNodeTemp = NULL;	
	HRESULT				hr;
	LONG				nErrorCode = E_FAIL; // For error codes
	wstring				wstrIssuerModulus; 
	wstring				wstrIssuerExponent;

	if(NULL == pvecIssuers)
	{
		return E_INVALIDARG;
	}//END IF
	
	// Writes the Issuers on the wstring
	pwIssuer->assign(L"\r\n");
	pwIssuer->append(L"ISSUERS FOR ALL MATCHING GRANTS: \r\n"); 
	for (int m = 0; m < pvecIssuers->size(); m++)
	{
		// Load each issuer into DOM tree so we can pull out the modulus and exponent for display
		hr = pIssuer.CreateInstance (__uuidof(MSXML2::DOMDocument40));

		if(S_OK != hr)
		{
			pwIssuer->append(L"Encountered a problem with MSXML4.  Please check installation. \r\n");
			return hr;
		}//END IF

		pIssuer->async = VARIANT_FALSE; // default is true
		pIssuer->validateOnParse = VALIDATE_ON_PARSE;

		if(pIssuer->loadXML ((*pvecIssuers)[m].c_str())!=VARIANT_TRUE)
		{
			pwIssuer->append(L"Failed to create issuer DOM \r\n");
			hr = pIssuer->get_parseError(&pXMLError);

			if(NULL != pXMLError)
			{
				hr = pXMLError->get_errorCode(&nErrorCode);
				if (nErrorCode != 0)
				{
					wstring wstrErrTmp;
					hr = CGUtil::ReportError(&wstrErrTmp, pXMLError);
					pwIssuer->append(wstrErrTmp);
				}//END IF
				pXMLError->Release();
			}//END IF
			return -1;
		}//END IF

		pXMLNodeTemp		= pIssuer->selectSingleNode (XPATH_ISSUER_MODULUS.c_str());
		wstrIssuerModulus	= ((NULL == pXMLNodeTemp) ? L"Missing modulus." : (wstring) pXMLNodeTemp->text);

		pXMLNodeTemp		= pIssuer->selectSingleNode (XPATH_ISSUER_EXPONENT.c_str());
		wstrIssuerExponent	= ((NULL == pXMLNodeTemp) ? L"Missing exponent." : (wstring) pXMLNodeTemp->text);

		pwIssuer->append(L"Issuer #");

		char num [10];
		_itoa(m, num, 10);
		BSTR bs = _com_util::ConvertStringToBSTR(num);
		pwIssuer->append(bs);
		
		pwIssuer->append(L": \r\n");
		pwIssuer->append(L"           Modulus=[");
		pwIssuer->append(wstrIssuerModulus);
		pwIssuer->append(L"]\r\n");
		pwIssuer->append(L"           Exponent=[");
		pwIssuer->append(wstrIssuerExponent);
		pwIssuer->append(L"]\r\n");
	}//END FOR LOOP

	return S_OK;
}//END FUNCTION printIssuers
