//	This software module was originally developed by Craig A. Schultz 
//	(AccessTicket Systems Inc.)
//
//	in the course of development of the MPEG-4 Systems 
//	(ISO/IEC 14496-1) standard. This software module is an implementation 
//	of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified 
//	by the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	AccessTicket Systems Inc. retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2000. 

#ifndef _CLIB_H_
#define _CLIB_H_

#include "defs.h"

class CSEvent
{
private:
	HANDLE m_hEvent;

public:
	CSEvent () { m_hEvent = CreateEvent ( NULL, FALSE, FALSE, NULL ); }
	~CSEvent () { CloseHandle ( m_hEvent ); }

	DWORD Wait ( UINT uTimeout = INFINITE )
		{ return WaitForSingleObject ( m_hEvent, uTimeout ); }
	bool Set () { return SetEvent ( m_hEvent ); }
	bool Reset () { return ResetEvent ( m_hEvent ); }
};
#endif	//  _CLIB_H_