//	This software module was originally developed by Craig A. Schultz 
//	(AccessTicket Systems Inc.)
//
//	in the course of development of the MPEG-4 Systems 
//	(ISO/IEC 14496-1) standard. This software module is an implementation 
//	of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified 
//	by the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	AccessTicket Systems Inc. retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2000. 

#ifndef _IPMPX_TOOL_H_
#define _IPMPX_TOOL_H_

#include "IPMPXinterface.h"

class IPMPX_Tool : public IPMPTool_Interface
{
public:
	IPMPX_Tool()
		: m_pNextTool(NULL)
	{}

	virtual ~IPMPX_Tool(){}

	// IPMPTool_Interface interface methods.
	// by Liao Xuan
	//virtual bool ReceiveMessage( ToolMessage* ) = 0;
	virtual bool ReceiveMessage( IPMP_ToolMessageBase* msg )= 0;

	// Interface methods added by IPMPX_Tool
	virtual bool ProcessData (
		LPBYTE,		// pInput,
		int,		// nInputLength,
		DWORD		// dwTime;
	) = 0;

	bool SetOutput( IPMPX_Tool * nextTool )
	{	if ( nextTool == NULL )
			return false;
		m_pNextTool = nextTool;
		return true;
	}

protected:
	IPMPX_Tool	*	m_pNextTool;
};

#endif	// _IPMPX_TOOL_H_