//	This software module was originally developed by Craig A. Schultz 
//	(AccessTicket Systems Inc.)
//
//	in the course of development of the MPEG-4 Systems 
//	(ISO/IEC 14496-1) standard. This software module is an implementation 
//	of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified 
//	by the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	AccessTicket Systems Inc. retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2000.

// IPMP_MessagesTags.h 

#ifndef _IPMP_MESSAGESTAGS_H_
#define _IPMP_MESSAGESTAGS_H_

//  IPMP data tags
//
typedef enum
{
	//by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	TAGMIN_IPMP_Data_BaseClass				= 0x01,
	//TAGMAX_IPMP_Data_BaseClass			= 0x1B,
	TAGMAX_IPMP_Data_BaseClass				= 0x1C,//changed
	//End: by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003

	TAG_ByteArray							= -1,
	TAG_IPMP_ToolES_AU						= 0x00,
	TAG_IPMP_OpaqueData,
	TAG_IPMP_AudioWatermarkingInit,
	TAG_IPMP_VideoWatermarkingInit,
	TAG_IPMP_SelectiveDecryptionInit,
	TAG_IPMP_KeyData,
	TAG_IPMP_SendAudioWatermark,
	TAG_IPMP_SendVideoWatermark,
	TAG_IPMP_RightsData,
	TAG_IPMP_Secure_Container,
	TAG_IPMP_AddToolNotificationListener,
	TAG_IPMP_RemoveToolNotificationListener,
	TAG_IPMP_InitAuthentication,
	TAG_IPMP_MutualAuthentication,
	TAG_IPMP_UserQuery,
	TAG_IPMP_UserQueryResponse,
	TAG_IPMP_ParamtericDescription,
	TAG_IPMP_ToolParamCapabilitiesQuery,
	TAG_IPMP_ToolParamCapabilitiesResponse,
	TAG_IPMP_GetTools,
	TAG_IPMP_GetToolsResponse,
	TAG_IPMP_GetToolContext,
	TAG_IPMP_GetToolContextResponse,
	TAG_IPMP_ConnectTool,
	TAG_IPMP_DisconnectTool,
	TAG_IPMP_NotifyToolEvent,
	TAG_IPMP_CanProcess,
	//by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	TAG_IPMP_TrustSecurityMetadata,//added
	TAG_IPMP_ToolAPI_Config,//added
	//End: by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	// User/implementation message tags.  For IM1
	TAG_User_Initialize,
	TAG_User_Initialized,
	TAG_IPMP_Message			= -1,
	TAG_ParametricDescriptor	= -1,
	TAG_BufferInfoStructure		= -1,
	TAG_FieldStructure			= -1,
	TAG_AlgorithmDescriptor		= 1,
	TAG_KeyDescriptor			= 2,
	TAG_Certificate				= -1,
	TAG_DTArray					= -1,
	//by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003
	//TAG_RTArray				= -1, // deleted, out of date
	TAG_OptionArray				= -1,
	TAG_AltText					= -1,
	TAG_QTArray					= -1,//added
	TAG_DateClass				= -1,//added
	TAG_TrustSpecification		= -1,//added
	TAG_TrustedTool				= -1,//added
	//End: by Liao Xuan -- according to ISO/IEC 14496-1:2001/FDAM 3:2003


} IPMP_TAGS;

#endif	//  _IPMP_MESSAGESTAGS_H_

