//	This software module was originally developed by Craig A. Schultz 
//	(AccessTicket Systems Inc.)
//
//	in the course of development of the MPEG-4 Systems 
//	(ISO/IEC 14496-1) standard. This software module is an implementation 
//	of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified 
//	by the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	AccessTicket Systems Inc. retains full right to use the code for its own purpose, 
//	assign or donate the code to a third party and to inhibit third parties from 
//	using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2000. 

#ifndef _MESSAGEDISTRIBUTOR_H_
#define _MESSAGEDISTRIBUTOR_H_

#include "CLib.h"
#include "IPMPXInterface.h"
#include "ZTL.h"

class ToolMessage;
class IPMPServicesFull;

class MessageDistributor : public IPMPTool_Interface
{
public:
	// Constructor/Desctructor
	MessageDistributor();
	~MessageDistributor();

	void SetParent( IPMPServicesFull * pParent )
		{ m_pParent = pParent; }

	// Class method from IPMPTool_Interface.
	// by Liao Xuan
	//bool ReceiveMessage ( ToolMessage * msg );
	bool ReceiveMessage ( IPMP_ToolMessageBase * msg );
	// by Liao Xuan

private:
	// Private Class methods.
	void Run();
	int StartMessagePump () {return m_MessagePump.Begin ();}
	void WaitForThread () {m_MessagePump.Wait ();}

private:
	CSEvent						m_Wait;
	ZMutex						m_MessageListAccess;
	bool						m_bActive;
	ZThread<MessageDistributor>	m_MessagePump;
	IPMPServicesFull	*		m_pParent;
	ZArray<ToolMessage*>		m_MessageList;
};
#endif	//  _MESSAGEDISTRIBUTOR_H_

