//	This software module was originally developed by Filippo Chiariglione 
//  (Microsoft Research Asia) 
//
//	in the course of development of the MPEG-4 Systems 
//	(ISO/IEC 14496-1) standard. This software module is an implementation 
//	of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified 
//	by the MPEG-4 Systems (ISO/IEC 14496-1) standard. 
//
//	ISO/IEC gives users of the  the MPEG-4 Systems (ISO/IEC 14496-1) free 
//	license to this software module or modifications thereof for use in hardware 
//	or software products claiming conformance to the MPEG-4 Systems (ISO/IEC 
//	14496-1). 
//
//	Those intending to use this software module in hardware or software 
//	products are advised that its use may infringe existing patents. 
//
//	The original developer of this software module and his/her company, the 
//	subsequent editors and their companies, and ISO/IEC have no liability for 
//	use of this software module or modifications thereof. 
//
//	Copyright is not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
//	products. 
//
//	AccessTicket Systems Inc. and Microsoft Research Asia retains full right to 
//  use the code for its own purpose, assign or donate the code to a third party 
//  and to inhibit third parties from using the code for non MPEG-4 Systems 
//  (ISO/IEC 14496-1) conforming products.
// 
//	This copyright notice must be included in all copies or derivative works. 
//
//	Copyright (c) 2000. 

#include "SecurityLib.h"
#include "IPMP_Messages.h"
//#include "..\IPMPXFull\MessageDistributor.h"
#include "MessageDistributor.h"

SecurityLib::SecurityLib ()
{
}


SecurityLib::SecurityLib(MessageDistributor* msgDistributor)
{
	this->msgDistributor = msgDistributor;
}

SecurityLib::~SecurityLib()
{
}

bool SecurityLib::ProcessMutAuthInit (IPMP_Data_BaseClass* msg)
{
	return true;
}
	
bool SecurityLib::ProcessMutAuthMsg (IPMP_Data_BaseClass* msg , SDLInt<32> contextID )
{
	return true;
}

IPMP_Data_BaseClass* SecurityLib::ProcessSecureContainer (IPMP_Secure_Container* secMsg , SDLInt<32> contextID)
{
	// by Liao Xuan
	//_asm{int 3}
	ByteArray * secArray = NULL;
	secArray = secMsg->encryptedData;
	long tmp = ((secMsg->encryptedData)->array.GetElement(3) << 24) | (secMsg->encryptedData[0].array.GetElement(2) << 16) | ((secMsg->encryptedData)->array.GetElement(1) << 8) | ((secMsg->encryptedData)->array.GetElement(0));
	secArray = secMsg->encryptedData;
	// by Liao Xuan
	return (IPMP_Data_BaseClass*)tmp;
}


bool SecurityLib::SendSecureMessage(IPMP_Data_BaseClass* msg , SDLInt<32> contextID)
{
	//_asm{int 3};
	OutputDebugString("Begin:SecurityLib::SendSecureMessage() \n");
	IPMP_RightsData* rights = NULL;
	rights = (IPMP_RightsData*)msg->Copy();
	// by Liao Xuan
	//ToolMessage			newMsg;
	IPMP_MessageFromTool	newMsg;
	// by Liao Xuan
	newMsg.receiver = contextID;
	SDLInt<32> MyContextID = 1;
	newMsg.sender = MyContextID;

	IPMP_Secure_Container* secMsg = new IPMP_Secure_Container();
	
	/******* Add By Liao Xuan  ****************/
	ByteArray* secByteArray=new ByteArray();
    secMsg->encryptedData = secByteArray; // allocate momery for m_pClass
	/*******************************************/
	
	// change rights (pointer address) from hex to decimal
	long lbuf = (long)rights;

	for (int i = 3; i >=0; i--)
	{
		int t = (byte)(lbuf >> (24 - 8*i));
        /********** Change by Liao Xuan ***************/
		//secMsg->encryptedData.InsertElement(t, i-3);
		(secMsg->encryptedData)->array.InsertElement(t, i-3);
        /**********************************************/

	}

	//_asm{int 3};

	/*********************************************
	secMsg->encryptedData = rights->rightsInfo;
	secMsg->encryptedData = tempArray;
	**********************************************/
	
	secMsg->SetLength(4);


	//newMsg.IPMP_MessageFromBitstream += secMsg;
	// by Liao Xuan
	//newMsg.IPMP_MessageFromBitstream += secMsg;
	newMsg.messages += secMsg;
	// by Liao Xuan
	msgDistributor->ReceiveMessage(&newMsg);

	//delete rights;
	//delete tempArray;
	//delete secMsg; 
	//delete[] tempArray;
	//tempArray = NULL;
	OutputDebugString("End:SecurityLib::SendSecureMessage() \n");
	return true;
}
