/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1998.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Zvi Lifshitz at zvil@csi.com.
----------------------------------------------------------------------*/

#if !defined(_Capabilities_h)	// Sentry, use file only if it's not already included.
#define _Capabilities_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Decoder / Presenter
FILE:       Capabilities.h
AUTHOR:     Zvi Lifshitz (Triton R&D Ltd.)
OVERVIEW:   Definition of Capabilities, the interface the Capabilities object
-------------------------------------------------------------------------*/

struct MediaFormat {
	enum tagMediaFormat {
		YUV,
		RGB,
		PCM,
		BGR,
		RGBA,
		YUVA,
		MPEGJ,
		//ML - added the next three lines
		FBA,
		MESH,
		ANIMSTREAM,

		//Used by PNG (VTC ?) and PixelTexture
		GRAYSCALE,
		ALPHAGRAYSCALE,
		//means "unknown at this time" in case a decoder doesn't know its format
		//until first AU is decoded (PNG is one)
		UNKNOWN,

		NONE
	} m_code; 	// ed: what else do we need?
	DWORD m_dwAdditionalInfo;
	MediaFormat (enum tagMediaFormat code = YUV, DWORD dwAdditionalInfo = 0) :
		m_code (code), m_dwAdditionalInfo (dwAdditionalInfo)
	{}
	operator int () const {return m_code;};
};

class Capabilities
{
public:
	virtual void AddFormatCapability (const MediaFormat &format, int nPriority) = 0;
	virtual const MediaFormat &GetFormatCapability (int nPriority) const = 0;
	virtual int GetFormatCapabilityLength () const = 0;
};

#endif                                      // _Capabilities_h sentry.
