/*------------------------------------------------------------------
	 2000 CSELT - Centro Studi e Laboratori Telecomunicazioni.
	All rights reserved.
------------------------------------------------------------------*/

#ifndef _daimctools_h_
#define _daimctools_h_


#include "ztl.h"


class MC_DAIChannelAddElement
{
  public:
	UINT		m_nTransmuxID;
	UINT		m_nChid;
	UINT		m_nTmpId;
	// direction for channel content. Usually from point of view of 
	// client/MPEG-4 Terminal
	DIRECTION	m_eDirection;

	RESPONSE	m_eResponse;
	QOSSTREAM	m_pQoSStream;
	// SLConfigDescriptor is provisionally exposed as a separate parameter
	BYTE*		m_pAppInfo;
	USHORT		m_nAppInfoLen;

	WORD				m_eFmxType;//FLEXMUX_TYPE is "used internally of DMIF" see FlexMuxTool.h
	LPSTREAMMAPELEM		m_pStreamMap;
	DWORD				m_nStreamMapLength;

	DWORD		m_nIPAddress;
	WORD		m_nPort;

	// user-user data.
	BYTE*		m_pData;
	USHORT		m_nDataLen;
	
  public: // methods	
	BOOL operator == (MC_DAIChannelAddElement const &el) const 
	{
		return (m_nChid == el.m_nChid);
	}
	
	MC_DAIChannelAddElement() : 
		m_nTransmuxID(0),
		m_nChid(0), 
		m_nTmpId(0), 
		m_pData(NULL), 
		m_nDataLen(0), 
		m_eDirection( DOWNSTREAM ),
		m_pQoSStream( NULL ),
		m_pAppInfo( NULL ),
		m_nAppInfoLen( 0 ),
		m_eResponse ( RESPONSE_OK ),
		m_eFmxType ( 0x00/*UNDEFINED_FLEXMUX*/ ),
		m_pStreamMap ( NULL ),
		m_nStreamMapLength ( 0 ),
		m_nIPAddress(0),
		m_nPort(0)
	{}
	
	MC_DAIChannelAddElement(const MC_DAIChannelAddElement& o)//copy constructor
	{
		m_nTransmuxID	= o.m_nTransmuxID;
		m_nChid			= o.m_nChid;
		m_nTmpId		= o.m_nTmpId;
		m_eDirection	= o.m_eDirection;
		m_eResponse		= o.m_eResponse;
		m_pQoSStream	= o.m_pQoSStream;
		m_nAppInfoLen	= o.m_nAppInfoLen;
		m_nIPAddress	= o.m_nIPAddress;
		m_nPort			= o.m_nPort;
		if ( m_nAppInfoLen > 0 )
		{
			m_pAppInfo		= new BYTE[o.m_nAppInfoLen];
			memcpy(m_pAppInfo,o.m_pAppInfo,o.m_nAppInfoLen);
		}
		else
			m_pAppInfo = NULL ;
		m_nDataLen	= o.m_nDataLen;
		if ( m_nDataLen > 0 )
		{
			m_pData		= new BYTE[o.m_nDataLen];
			memcpy(m_pData,o.m_pData,o.m_nDataLen);
		}
		else
			m_pData = NULL ;
		m_eFmxType	= o.m_eFmxType;
		m_nStreamMapLength = o.m_nStreamMapLength;
		m_pStreamMap = o.m_pStreamMap;
	}

	MC_DAIChannelAddElement& operator=(const MC_DAIChannelAddElement& r)
	{
		m_nTransmuxID	= r.m_nTransmuxID;
		m_nChid			= r.m_nChid;
		m_nTmpId		= r.m_nTmpId;
		m_eDirection	= r.m_eDirection;
		m_eResponse		= r.m_eResponse;
		m_pQoSStream	= r.m_pQoSStream;
		m_nAppInfoLen	= r.m_nAppInfoLen;
		m_nIPAddress	= r.m_nIPAddress;
		m_nPort			= r.m_nPort;
		if ( m_pAppInfo )
			delete [] m_pAppInfo ;
		if ( m_nAppInfoLen > 0 )
		{
			m_pAppInfo		= new BYTE[r.m_nAppInfoLen];
			memcpy(m_pAppInfo,r.m_pAppInfo,m_nAppInfoLen);
		}
		else
			m_pAppInfo = NULL ;
		m_nDataLen	= r.m_nDataLen;
		if ( m_pData )
			delete [] m_pData ;
		if ( m_nDataLen > 0 )
		{
			m_pData		= new BYTE[r.m_nDataLen];
			memcpy(m_pData,r.m_pData,m_nDataLen);
		}
		else
			m_pData = NULL ;
		m_eFmxType	= r.m_eFmxType;
		m_nStreamMapLength = r.m_nStreamMapLength;
		m_pStreamMap = r.m_pStreamMap;
		return ( *this ) ;
	}
	
};

typedef ZArray<MC_DAIChannelAddElement>	MC_DAIChannelAddParam;


#endif _daimctools_h_