/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1998.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Zvi Lifshitz at zvil@csi.com.
----------------------------------------------------------------------*/

#if !defined(_MediaStream_h)	// Sentry, use file only if it's not already included.
#define _MediaStream_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Buffer management
FILE:       MediaStream.h
AUTHOR:     Zvi Lifshitz (Triton R&D Ltd.)
OVERVIEW:   Definition of MediaStream, the interface for MediaStream
			objects.
-------------------------------------------------------------------------*/
class MediaStream
{
public:
	virtual ~MediaStream () {}
	virtual LPVOID Allocate (int nSize, BOOL bWait = TRUE, BOOL bShove = FALSE) = 0;
	virtual LPVOID Reallocate (int nSize) = 0;
	virtual BOOL Dispatch (int nSize, DWORD dwTime, BOOL bEOU = TRUE) = 0;
	virtual LPVOID FetchNext (
		int &rnSize,
		DWORD &rdwTime,
		BOOL &rbEOU,
		BOOL bWait = TRUE
	) = 0;
	virtual LPVOID Fetch (
		int &rnSize,
		DWORD &rdwTime,
		BOOL &rbEOU,
		int &rnStatus,
		BOOL bSkip = TRUE,
		BOOL bWait = FALSE,
		long lDelta = 0,
		BOOL bDontClose = FALSE
	) = 0;
	virtual void Release (BOOL bDiscard = TRUE) = 0;
	virtual void Close () = 0;
	virtual void Terminate () = 0;
	virtual void Open () = 0;
	virtual void Start () = 0;
	virtual void Abort () = 0;
	virtual void ResetCounters () = 0;
	virtual void GetCounters (int &, int &, int &, int &) const = 0;
	virtual int CompareTime(DWORD time1, DWORD time2) = 0;

#ifdef MPGJ
	//*** YT START (131)
	virtual void Pause (BOOL) = 0;
	virtual void HalfClose (BOOL) = 0;
	//*** YT END (131)

	/* MPEGJ - Merge - PA */
	/***** boolean flags for indicate that events occured - used in the
					MediaStreamImp class derived from this class */
	bool DECODER_OVERFLOW;
	bool DECODER_UNDERFLOW;
	/**** - end - */
	#endif
};

#define END_OF_STREAM  ((void*)-1)

#endif                                      // _MediaStream_h sentry.
