/*
-----------------------------------------------------------------------------------
File      :  global.h
Versione  :  1.1
			 Header file globale
			 Definzione dei dati globali del programma
			 Definizione dei prototipi delle funzioni 
Autore	  :  Rinaudo Alfredo
Modificato:  Vecchietti Marco, Delsanto Marco
Note	  :	 Per ogni prototipo di procedura si verifica se l'inclusione del
			 file e' avvenuta nel file in cui la procedura e' stata utilizzata
			 o se viene solamente utilizzata. Nel secondo caso viene utilizzato
			 il prefisso extern
			 Le variabili globali sono precedute dalla macro EXTERN al fine di 
			 definirle come esterne solo se non incluse nel file principale
			 In tale file deve essere definito il token M2DECODERPLUS o similare
------------------------------------------------------------------------------------ 
*/


#ifndef __GLOBAL_INCLUDED__
	#define __GLOBAL_INCLUDED__
#endif
 
// Macro per la compilazione differenziata del codice 
//      ERROR_CODE  ->  Segnalazione errori di decodifica
//
// Nota: Commentare la define per compilare il codice 
//		 negando l'opzione desiderata

 #define ERROR_CODE


 #ifdef  M2DECODERPLUS
 #define EXTERN
 #else
 #define EXTERN extern
 #endif

 
 // DICHIARAZIONE VARIABLI GLOBALI


 #ifndef __M2DECODERPLUS_INCLUDED__
	#include "M2DecoderPlus.h"
 #endif

	  														// ------------------------	
															// GESTIONE C++ C
															// ------------------------			 		

 EXTERN M2DecoderPlus	M2DecObj ;							// Puntatore all'istanza della classe M2DecoderPlus

															// ------------------------	
															// GESTIONE INTERFACCIA
															// ------------------------			 		

 EXTERN BOOL			netIsOpen ;							// Flag sorgente remota attiva
 EXTERN BOOL			fileIsOpen ;						// Flag sorgente locale attiva

 EXTERN	HRESULT			statusReport ;						// Stato della fase di inizializzazione dei componenti	
															// elementari del decoder

