// -*- c++ -*-

// This software module was originally developed 
// by Stefano Battista (STMicroelectronics) 
// in the course
// of development of the MPEG-4 Systems standard (ISO/IEC 14496-1).  This
// software module is an implementation of a part of one or more MPEG-4
// Systems tools as specified by the MPEG-4 Systems standard.  ISO/IEC
// gives users of the MPEG-4 Systems standard free license to this software
// module or modifications thereof for use in hardware or software products
// claiming conformance to the MPEG-4 Systems standard.  Those intending to
// use this software module in hardware or software products are advised
// that its use may infringe existing patents.  The original developer of
// this software module and his/her company, the subsequent editors and
// their companies, and ISO/IEC have no liability for use of this software
// module or modifications thereof in an implementation.  Copyright is not
// released for non MPEG-4 Systems conforming products.  The original
// developer retains full right to use the code for his/her own purpose,
// assign or donate the code to a third party and to inhibit third parties
// from using the code for non MPEG-4 Systems conforming products.  This
// copyright notice must be included in all copies or derivative works.
//
// Copyright 1999.

#ifndef __MESH2DCLASS_H__
#define __MESH2DCLASS_H__

#include "DecoderImp.h"

#include "mesh_decode.h"

extern "C"
{
}

class Mesh2dClass : public DecoderImp
{
private:
  MeshDecoder * mpoDecoder;


  virtual MediaFormat GetFormat();
	virtual int SetFormat(
    Capabilities * pPresentationCapabilities);

  // brutal guess: size of Acces Units
	virtual int GetOptimalInputSize() 
  { return 1024; }
	virtual int GetOptimalOutputSize()
  { return GetOptimalInputSize() * 8; }
	virtual int GetRecommendedInputBufferSize()
  { return GetOptimalInputSize() * 8; }
	virtual int GetRecommendedOutputBufferSize() 
  { return GetOptimalOutputSize() * 8; }

public:
	Mesh2dClass();
  ~Mesh2dClass();

  virtual bool Init();

  virtual void Run();

  virtual BOOL Decode(
		LPBYTE pucInput,
		int iInputLength,
		LPBYTE pucOutput,
		int & riOutputLength);

};

#endif  // __MESH2DCLASS_H__
