/*************************************************************************

This software module was originally developed by 

	Ming-Chieh Lee (Microsoft Corporation)
	Wei-ge Chen (Microsoft Corporation)
	Bruce Lin (Microsoft Corporation)
	Chuang Gu (Microsoft Corporation)

and edited by

	Peter van Beek (University of Rochester)

in the course of development of the MPEG-4 Video (ISO/IEC 14496-2). 
This software module is an implementation of a part of one or more 
MPEG-4 Video (ISO/IEC 14496-2) tools as specified by MPEG-4 Video
(ISO/IEC 14496-2). ISO/IEC gives users of the MPEG-4 Video (ISO/IEC 
14496-2) free license to this software module or modifications thereof 
for use in hardware or software products claiming conformance to the 
MPEG-4 Video (ISO/IEC 14496-2). 
Those intending to use this software module in hardware or software 
products are advised that its use may infringe existing patents. The 
original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability 
for use of this software module or modifications thereof in an 
implementation. 
Copyright is not released for non MPEG-4 Video (ISO/IEC 14496-2) 
conforming products. Microsoft Corporation retains full right to use 
the code for his/her own purpose, assign or donate the code to a third 
party and to inhibit third parties from using the code for non MPEG 
Video (ISO/IEC 14496-2) conforming products. 
This copyright notice must be included in all copies or derivative works. 

Copyright (c) 1996, 1997.

Module Name:

	basic.hpp

Abstract:
	Basic type (re)definitions

Revision History:
	Renamed basic.h, Peter van Beek

	Removed a lot of stuff, Peter Van Beek, Thu Apr  9 18:48:19 1998

*************************************************************************/

#ifndef __BASIC_HPP_ 
#define __BASIC_HPP_
#include "assert.h"
#include "string.h"

#ifdef __MAKE_DLL_
#define API __declspec (dllexport)
#define Class        class API
#else
#define API
#define Class		class
#endif // __MAKE_DLL_

#ifdef __MFC_
#include <afx.h>
#include <afxtempl.h>
#include <windowsx.h>
#endif // __MFC_

// used as "reserved word" to indicate ownership to distinguish from const
#define own 
// true and false
#define TRUE 1
#define FALSE 0
//!! Peter Van Beek, Wed Feb  5 15:00:46 1997
#ifndef NULL
#define NULL 0
#endif

#define Sizeof(x) ((unsigned long) sizeof (x))
#define sign(x) ((x) > 0 ? 1 : -1)					// see p.22/H.263

/*******************************************/
// 
//  Typedefs for basic types
// 
/*******************************************/

#if 1 // in case future compilers redefine longs and shorts
typedef unsigned long U32; 
typedef int I32; 
typedef unsigned short U16; 
typedef short I16; 
#endif // in case future compilers redefine longs and shorts 

typedef unsigned UInt; 
typedef unsigned UINT; 
typedef double Double; 
typedef float Float; 
typedef float Float32; 
typedef float F32; 
typedef unsigned char U8; 
typedef signed char I8; 
typedef long Long; 
typedef unsigned long ULong; 
typedef int Int; 
typedef void Void; 
typedef int Bool; 
typedef long CoordI; 
typedef double CoordD; 
typedef char Byte; 
typedef char Char; 

// For VLC tables
typedef struct {
	int val;							// symbol value
	char *code;							// symbol codeword
} VlcSymbol;


#endif // __BASIC_HPP_


