/**********************************************************************/
/*                                                                    */
/* This software module was originally developed by                   */
/*                                                                    */
/* Peter van Beek (University of Rochester)                           */
/*                                                                    */
/* in the course of development of MPEG-4 Visual (ISO/IEC 14496-2).   */
/* This software module is an implementation of a part of one or      */
/* more MPEG-4 Visual (ISO/IEC 14496-2) tools as specified by the     */
/* MPEG-4 Visual (ISO/IEC 14496-2). ISO/IEC gives users of MPEG-4     */
/* Visual (ISO/IEC 14496-2) free license to this software module or   */
/* modifications thereof for use in hardware or software products     */
/* claiming conformance to MPEG-4 Visual (ISO/IEC 14496-2). Those     */
/* intending to use this software module in hardware or software      */
/* products are advised that its use may infringe existing patents.   */
/* The original developer of this software module and his/her         */
/* company, the subsequent editors and their companies, and ISO/IEC   */
/* have no liability for use of this software module or modifications */ 
/* thereof in an implementation. Copyright is not released for non    */
/* MPEG-4 Visual (ISO/IEC 14496-2) conforming products.               */
/* The University of Rochester retains full right to use the code for */
/* their own purposes, assign or donate the code to a third party and */
/* to inhibit third parties from using the code for non MPEG-4 Visual */
/* (ISO/IEC 14496-2) conforming products.                             */
/* This copyright notice must be included in all copies or derivative */
/* works.                                                             */
/*                                                                    */
/* Copyright (c) 1996, 1997                                           */
/*                                                                    */
/**********************************************************************/

/*+*********************************************************************
   NAME 		delaunay.h
   AUTHOR		Peter Van Beek, Thu Apr 30 18:23:58 1998
   DESCRIPTION	Header file for delaunay triangulator interface
   SYNOPSIS		
*********************************************************************-*/

#ifndef	_MY_DELAUNAY_DEF
#define	_MY_DELAUNAY_DEF

#include "listClass.h"
#include "polyClass.h"
#include "stringClass.h"
#include "polyTessClass.h"


/********* delaunay.cpp ***********************************************/

extern Poly2dTess* triangulate (Pt2dList &mp, Poly2d &p, string fn, int flag);


#endif // _MY_DELAUNAY_DEF


/* End of file */
