/*************************************************************************

This software module was originally developed by 

	Ming-Chieh Lee (Microsoft Corporation)
	Wei-ge Chen (Microsoft Corporation)
	Bruce Lin (Microsoft Corporation)
	Chuang Gu (Microsoft Corporation)

in the course of development of the MPEG-4 Video (ISO/IEC 14496-2). 
This software module is an implementation of a part of one or more 
MPEG-4 Video (ISO/IEC 14496-2) tools as specified by MPEG-4 Video
(ISO/IEC 14496-2). ISO/IEC gives users of the MPEG-4 Video (ISO/IEC 
14496-2) free license to this software module or modifications thereof 
for use in hardware or software products claiming conformance to the 
MPEG-4 Video (ISO/IEC 14496-2). 
Those intending to use this software module in hardware or software 
products are advised that its use may infringe existing patents. The 
original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability 
for use of this software module or modifications thereof in an 
implementation. 
Copyright is not released for non MPEG-4 Video (ISO/IEC 14496-2) 
conforming products. Microsoft Corporation retains full right to use 
the code for his/her own purpose, assign or donate the code to a third 
party and to inhibit third parties from using the code for non MPEG 
Video (ISO/IEC 14496-2) conforming products. 
This copyright notice must be included in all copies or derivative works. 

Copyright (c) 1996, 1997.

Module Name:

	entropy.hpp

Abstract:

	base classes for entropy encoder/decoder

Revision History:
	Peter van Beek,
	- renamed entropy.h
	Peter Van Beek, Thu May 14 16:46:41 1998
	- added new loadTable methods

*************************************************************************/

#ifndef __ENTROPY_HPP_
#define __ENTROPY_HPP_


class istream;
class ostream;
class CInBitStream;
class COutBitStream;


Class CEntropyEncoder
{
public:
	virtual ~CEntropyEncoder () {};
    virtual Void loadTable (istream &Table) = 0;
	virtual Void loadTable (VlcSymbol vlcTable[], Int lNOfSymbols) = 0;
    virtual Void attachStream (COutBitStream &BitStream) = 0;
    virtual UInt encodeSymbol (Int lSymbol, Char* rgchSymbolName = NULL, Bool bDontSendBits = FALSE) = 0;
	virtual COutBitStream* bitstream () = 0;
};


Class CEntropyDecoder
{
public:
	virtual ~CEntropyDecoder () {};
    virtual Void loadTable (istream &Table, Bool bIncompleteTree=TRUE) = 0;
	virtual void loadTable(VlcSymbol vlcTable[], Int lNOfSymbols, Bool bIncompleteTree=TRUE) = 0;
    virtual Int decodeSymbol () = 0;
    virtual Void attachStream (CInBitStream &bitStream) = 0;
	virtual CInBitStream* bitstream () = 0;
};
#endif // __ENTROPY_HPP_

