/**********************************************************************/
/*                                                                    */
/* This software module was originally developed by                   */
/*                                                                    */
/* A. Tanju Erdem (Eastman Kodak Company)                             */
/* Candemir Toklu (University of Rochester)                           */
/*                                                                    */
/* and edited by                                                      */
/*                                                                    */
/* Peter van Beek (University of Rochester)                           */
/*                                                                    */
/* in the course of development of MPEG-4 Visual (ISO/IEC 14496-2).   */
/* This software module is an implementation of a part of one or      */
/* more MPEG-4 Visual (ISO/IEC 14496-2) tools as specified by the     */
/* MPEG-4 Visual (ISO/IEC 14496-2). ISO/IEC gives users of MPEG-4     */
/* Visual (ISO/IEC 14496-2) free license to this software module or   */
/* modifications thereof for use in hardware or software products     */
/* claiming conformance to MPEG-4 Visual (ISO/IEC 14496-2). Those     */
/* intending to use this software module in hardware or software      */
/* products are advised that its use may infringe existing patents.   */
/* The original developer of this software module and his/her         */
/* company, the subsequent editors and their companies, and ISO/IEC   */
/* have no liability for use of this software module or modifications */ 
/* thereof in an implementation. Copyright is not released for non    */
/* MPEG-4 Visual (ISO/IEC 14496-2) conforming products.               */
/* Eastman Kodak Company and the University of Rochester retain full  */
/* right to use the code for their own purposes, assign or donate the */
/* code to a third party and to inhibit third parties from using the  */
/* code for non MPEG-4 Visual (ISO/IEC 14496-2) conforming products.  */
/* This copyright notice must be included in all copies or derivative */
/* works.                                                             */
/*                                                                    */
/* Copyright (c) 1994-1997                                            */
/*                                                                    */
/**********************************************************************/

/*+*********************************************************************
   NAME         general.cpp
   AUTHOR       A. Tanju Erdem - Eastman Kodak Company and Candemir Toklu - 
                University of Rochester.
   DATE         September 1994
   UPDATE       14 August 1996 by Candemir Toklu
   DESCRIPTION  Functions which are not the members of any class are defined
                here. 

   SYNOPSIS     Include files : 
                                
                #include "general.h"
                               
*********************************************************************-*/
#include "general.h"

// Definitions of functions that are not members of any class.


//-------------------------------------------------------------------------
// A routine to sort numbers in ascending numerical order.
//-------------------------------------------------------------------------
void sortNumbers( double* arr, int* krr, int n)
{
  int i, j;
  double a; 
  int k;

  for( j = 1; j < n; j++)
  {
    a = arr[j];
    k = krr[j];
    i = j - 1;
    while( i >= 0 && arr[i] > a)
    {
      arr[i+1] = arr[i];
      krr[i+1] = krr[i];
      i--;
    }
    arr[i+1] = a;
    krr[i+1] = k;
  }
}

//-------------------------------------------------------------------------
// A routine to sort numbers in ascending numerical order.
//-------------------------------------------------------------------------
void sortNumbers( int* crr, int* krr, int n)
{
  int i, j;
  int a; 
  int k;
  int* arr = (int*) new int[n];
  for( i = 0; i < n; i++)
    arr[i] = crr[i];  // Do not alter the original array crr.

  for( j = 1; j < n; j++)
  {
    a = arr[j];
    k = krr[j];
    i = j - 1;
    while( i >= 0 && arr[i] > a)
    {
      arr[i+1] = arr[i];
      krr[i+1] = krr[i];
      i--;
    }
    arr[i+1] = a;
    krr[i+1] = k;
  }
}

//-------------------------------------------------------------------------
// A routine to sort numbers in ascending numerical order.
//-------------------------------------------------------------------------
void sortNumbers2( int* arr, int* krr, int n)
{
  int i, j;
  int a; 
  int k;
 
  for( j = 1; j < n; j++)
  {
    a = arr[j];
    k = krr[j];
    i = j - 1;
    while( i >= 0 && arr[i] > a)
    {
      arr[i+1] = arr[i];
      krr[i+1] = krr[i];
      i--;
    }
    arr[i+1] = a;
    krr[i+1] = k;
  }
}
 

//--------------------------------------------------------------------------
// Insert leading zeroes to a given number with a given minumum field length 
//--------------------------------------------------------------------------
string leadZeros( int inVal, int size)
{
  string outStr;

  int length = 1;
  int tmp = inVal;

  while( (tmp /= 10) != 0)
  {
    length++; 
  }

  if( size <= length)
  {
    outStr = inVal;
  }
  else
  {
    for( int i = 0; i < size - length; i++)
    {
      outStr += "0";
    }
    outStr = outStr + inVal;
  }
  return outStr;
}


// end of file
