/**********************************************************************/
/*                                                                    */
/* This software module was originally developed by                   */
/*                                                                    */
/* Peter van Beek (University of Rochester)                           */
/*                                                                    */
/* in the course of development of MPEG-4 Visual (ISO/IEC 14496-2).   */
/* This software module is an implementation of a part of one or      */
/* more MPEG-4 Visual (ISO/IEC 14496-2) tools as specified by the     */
/* MPEG-4 Visual (ISO/IEC 14496-2). ISO/IEC gives users of MPEG-4     */
/* Visual (ISO/IEC 14496-2) free license to this software module or   */
/* modifications thereof for use in hardware or software products     */
/* claiming conformance to MPEG-4 Visual (ISO/IEC 14496-2). Those     */
/* intending to use this software module in hardware or software      */
/* products are advised that its use may infringe existing patents.   */
/* The original developer of this software module and his/her         */
/* company, the subsequent editors and their companies, and ISO/IEC   */
/* have no liability for use of this software module or modifications */ 
/* thereof in an implementation. Copyright is not released for non    */
/* MPEG-4 Visual (ISO/IEC 14496-2) conforming products.               */
/* The University of Rochester retains full right to use the code for */
/* their own purposes, assign or donate the code to a third party and */
/* to inhibit third parties from using the code for non MPEG-4 Visual */
/* (ISO/IEC 14496-2) conforming products.                             */
/* This copyright notice must be included in all copies or derivative */
/* works.                                                             */
/*                                                                    */
/* Copyright (c) 1997                                                 */
/*                                                                    */
/**********************************************************************/

/*+*********************************************************************
   NAME 		my_portab.h
   AUTHOR		Peter van Beek, University of Rochester
   UPDATE		Peter Van Beek, Tue Oct 14 17:06:54 1997
   DESCRIPTION	Some general definitions that might be useful. 
   SYNOPSIS		
*********************************************************************-*/

#ifndef	MYPORTABDEF
#define	MYPORTABDEF

/* General C stuff */

#include	<stdio.h>
#include	<stdlib.h>

/* C stuff vs C++ stuff */
#ifdef __cplusplus

#include    <iostream.h>
#include    <fstream.h>

#ifndef	NULL
#define	NULL	0
#endif

#endif // __cplusplus


/* Definitions */

#ifndef	O_BINARY
#define	O_BINARY	0
#define	O_TEXT		0
#endif // O_BINARY

#ifndef	TRUE
#define	TRUE	1
#define	FALSE	0
#endif // TRUE

#ifndef	OK
#define	OK		1
#define	NOT_OK	0
#endif

#ifndef BYTE
#define BYTE 	unsigned char
#endif


/* Return macro's */
#define return_err(a)		{ fprintf(stderr, a); return; }
#define	return_errn(a,n)	{ fprintf(stderr, a); return(n); }


/* Debugging macros */

#if defined(DEBUGGING) || defined(_DEBUG)
/* If debugging is on during compile-time */

/* Macro's for printing debug messages */
#define DBUG(vargs) 		((void) printf vargs)

#else

/* Replace debug macro's with blank spaces */
#define DBUG(vargs)

#endif // DEBUGGING




#endif // MYPORTABDEF


/* End of file */

