/**********************************************************************/
/*                                                                    */
/* This software module was originally developed by                   */
/*                                                                    */
/* Peter van Beek (University of Rochester)                           */
/*                                                                    */
/* in the course of development of MPEG-4 Visual (ISO/IEC 14496-2).   */
/* This software module is an implementation of a part of one or      */
/* more MPEG-4 Visual (ISO/IEC 14496-2) tools as specified by the     */
/* MPEG-4 Visual (ISO/IEC 14496-2). ISO/IEC gives users of MPEG-4     */
/* Visual (ISO/IEC 14496-2) free license to this software module or   */
/* modifications thereof for use in hardware or software products     */
/* claiming conformance to MPEG-4 Visual (ISO/IEC 14496-2). Those     */
/* intending to use this software module in hardware or software      */
/* products are advised that its use may infringe existing patents.   */
/* The original developer of this software module and his/her         */
/* company, the subsequent editors and their companies, and ISO/IEC   */
/* have no liability for use of this software module or modifications */ 
/* thereof in an implementation. Copyright is not released for non    */
/* MPEG-4 Visual (ISO/IEC 14496-2) conforming products.               */
/* The University of Rochester retains full right to use the code for */
/* their own purposes, assign or donate the code to a third party and */
/* to inhibit third parties from using the code for non MPEG-4 Visual */
/* (ISO/IEC 14496-2) conforming products.                             */
/* This copyright notice must be included in all copies or derivative */
/* works.                                                             */
/*                                                                    */
/* Copyright (c) 1997, 1998                                           */
/*                                                                    */
/**********************************************************************/

/*+*********************************************************************
   NAME         vlcdef.h
   AUTHOR       Peter Van Beek, Wed May 13 16:13:08 1998
   DESCRIPTION  Definition of VLC types and VLC tables for mesh decoder.
   SYNOPSIS     #include "vlcdef.h"
   NOTE			See basic.h for definition of type VlcSymbol.
**********************************************************************-*/

#ifndef VLC_DEF_INCL
#define VLC_DEF_INCL


// VLC table for mesh node coordinate differences

static VlcSymbol coDiffTable[] = {
{ 0,  "00"},
{ 1,  "010"},
{ 2,  "011"},
{ 3,  "100"},
{ 4,  "101"},
{ 5,  "110"},
{ 6,  "1110"},
{ 7,  "11110"},
{ 8,  "111110"},
{ 9,  "1111110"},
{10,  "11111110"},
{11,  "111111110"}
};


// VLC table for mesh node motion vector differences

static VlcSymbol mvDiffTable[] = {
{ 0,  "0000000000101"},
{ 1,  "0000000000111"},
{ 2,  "000000000101"},
{ 3,  "000000000111"},
{ 4,  "000000001001"},
{ 5,  "000000001011"},
{ 6,  "000000001101"},
{ 7,  "000000001111"},
{ 8,  "00000001001"},
{ 9,  "00000001011"},
{10,  "00000001101"},
{11,  "00000001111"},
{12,  "00000010001"},
{13,  "00000010011"},
{14,  "00000010101"},
{15,  "00000010111"},
{16,  "00000011001"},
{17,  "00000011011"},
{18,  "00000011101"},
{19,  "00000011111"},
{20,  "00000100001"},
{21,  "00000100011"},
{22,  "0000010011"},
{23,  "0000010101"},
{24,  "0000010111"},
{25,  "00000111"},
{26,  "00001001"},
{27,  "00001011"},
{28,  "0000111"},
{29,  "00011"},
{30,  "0011"},
{31,  "011"},
{32,  "1"},
{33,  "010"},
{34,  "0010"},
{35,  "00010"},
{36,  "0000110"},
{37,  "00001010"},
{38,  "00001000"},
{39,  "00000110"},
{40,  "0000010110"},
{41,  "0000010100"},
{42,  "0000010010"},
{43,  "00000100010"},
{44,  "00000100000"},
{45,  "00000011110"},
{46,  "00000011100"},
{47,  "00000011010"},
{48,  "00000011000"},
{49,  "00000010110"},
{50,  "00000010100"},
{51,  "00000010010"},
{52,  "00000010000"},
{53,  "00000001110"},
{54,  "00000001100"},
{55,  "00000001010"},
{56,  "00000001000"},
{57,  "000000001110"},
{58,  "000000001100"},
{59,  "000000001010"},
{60,  "000000001000"},
{61,  "000000000110"},
{62,  "000000000100"},
{63,  "0000000000110"},
{64,  "0000000000100"}
};



#endif // VLC_DEF_INCL
