// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"

#include "mmi.h"

#include "mmidoc.h"
#include "mmiview.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_QUERYNEWPALETTE()
	ON_WM_PALETTECHANGED()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CFrameWnd::OnHelpFinder)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////

extern CMmiApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
  TRACE("[CFrame::Ctor] \n");	
}

CMainFrame::~CMainFrame()
{
  TRACE("[CFrame::Dtor] \n");	
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
  TRACE("[Frame::OnCreate] begin \n");

	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

  TRACE("[Frame::OnCreate] end \n");

  return 0;
}

void CMainFrame::OnDestroy() 
{
  TRACE("[Frame::OnDestroy] begin \n");

  CFrameWnd::OnDestroy();
	
	// TODO: Add your message handler code here
  TRACE("[Frame::OnDestroy] end \n");
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	
	
	// Add in CMmiApp class public fileName and set value in
	// InitInstance() like this : filename = cmdInfo.m_strFileName
	CString fileName = theApp.fileName;
	//In here we put string of width and height values from filename
	char x_coords[5];
	char y_coords[5];
	
	//character position in string
	int pos1;
	int pos2;
	int pos3;

	//just counter
	int i = 0;
	
	//these will be the height and width at the end
	int dx;
	int dy;

	//Do we have filename?
	if( !(fileName.IsEmpty()) )
	{
		cs.cy = 400;
		cs.cx = 400;
		//Does filename have all we need
		if( ((pos1 = fileName.Find("@")) != -1) &&
			 ((pos2 = fileName.Find("_")) != -1) &&
			  ((pos3 = fileName.Find(".")) != -1)    )
		{
			if( (pos1 < pos2)&&(pos1<pos3)&&(pos2<pos3) )
			{
				pos1++;
				while(fileName[pos1]!='_')
				{
					x_coords[i++]=fileName[pos1++];
				}
				i=0;
				pos1++;
				while(fileName[pos1]!='.')
				{
					y_coords[i++]=fileName[pos1++];
				}
				dx = abs((int)(atoi(x_coords)));
				dy = abs((int)(atoi(y_coords)));

				int win_dx = GetSystemMetrics(SM_CXSCREEN);
				int win_dy = GetSystemMetrics(SM_CYSCREEN);

				if(dx > win_dx)
					dx = win_dx;
				if(dy > win_dy)
					dy = win_dy;

				cs.cx = dx;
				cs.cy = dy;
			}
		}
	}
	else
	{
		cs.cy = 400;
		cs.cx = 400;
	}

	// remove this flag to remove " - Untitled" from the frame's caption
	cs.style &= ~ FWS_ADDTOTITLE;

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

BOOL CMainFrame::OnQueryNewPalette() 
{
	// TODO: Add your message handler code here and/or call default
	WORD		i;
	CPalette	*pOldPal;
	CMmiView	*pView = (CMmiView *)GetActiveView();
	CClientDC	dc(pView);



	pOldPal = dc.SelectPalette(&pView->m_cPalette, FALSE);
	i = dc.RealizePalette();
	dc.SelectPalette(pOldPal, FALSE);

	if(i > 0)
		InvalidateRect(NULL);
	
	return CFrameWnd::OnQueryNewPalette();
}

void CMainFrame::OnPaletteChanged(CWnd* pFocusWnd) 
{
	CFrameWnd::OnPaletteChanged(pFocusWnd);
	
	// TODO: Add your message handler code here
	if(pFocusWnd != this)
		OnQueryNewPalette();
}

