// mmi.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"

#include "mmi.h"

#include "MainFrm.h"
#include "mmiDoc.h"
#include "mmiView.h"
#include "netobj.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern DWORD dwidInst;
/////////////////////////////////////////////////////////////////////////////
// CMmiApp

BEGIN_MESSAGE_MAP(CMmiApp, CWinApp)
	//{{AFX_MSG_MAP(CMmiApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMmiApp construction

CMmiApp::CMmiApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	if(DdeInitialize(&dwidInst, LocationDdeCallBack, APPCLASS_STANDARD | APPCMD_CLIENTONLY, 0ul)){
		dwidInst = 0UL;
	}
  TRACE("[CApp::Ctor] \n");
}

CMmiApp::~CMmiApp()
{
  TRACE("[CApp::Dtor] \n");
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMmiApp object

CMmiApp theApp;

/*******************************************************************************
APP INIT
*******************************************************************************/

BOOL CMmiApp::InitInstance()
{
  TRACE("[App::InitInstance] begin \n");

  if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("MPEG-4"));

	LoadStdProfileSettings(16);  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CMmiDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CMmiView));
	AddDocTemplate(pDocTemplate);

	// Enable DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes();

    // Register icon
	TCHAR szPathName[MAX_PATH];
	::GetModuleFileName(AfxGetInstanceHandle(), szPathName, MAX_PATH);

    CString strDefaultIconCommandLine = szPathName;
	strDefaultIconCommandLine += ",1";

    RegSetValue(HKEY_CLASSES_ROOT, _T("MPEG-4.Document\\DefaultIcon"), REG_SZ , strDefaultIconCommandLine, (strDefaultIconCommandLine.GetLength() + 1) * sizeof(TCHAR));

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	fileName = cmdInfo.m_strFileName;

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

  // SB #### 99/02/23
  // moved App initialization here


	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles();

  TRACE("[App::InitInstance] end \n");

	return TRUE;
}

/*******************************************************************************
APP EXIT
*******************************************************************************/

int CMmiApp::ExitInstance() 
{
	// TODO: Add your specialized code here and/or call the base class
  TRACE("[App::ExitInstance] \n");	
	return CWinApp::ExitInstance();
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CMmiApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CMmiApp commands

/*!
  \brief Called after the user has selected a file to open.

  The MFC framework will call this function after the File Open dialog
  box has been displayed, and the user has selected a file.

  This function will call CMmiDoc::Restart() to load this file.
*/

CDocument* CMmiApp::OpenDocumentFile(LPCTSTR lpszFileName) 
{
	CWaitCursor cursor;


	CDocument* pDocument = CWinApp::OpenDocumentFile(lpszFileName);

	ASSERT(pDocument->IsKindOf(RUNTIME_CLASS(CMmiDoc)));

	TRACE("[App::OpenDocumentFile] before Doc::Restart \n");

	if (pDocument)
		((CMmiDoc*) pDocument)->Restart(lpszFileName);

	return pDocument;
}

/////////////////////////////////////////////////////////////////////////////
// Output string to status bar

void Statusbar (const char* a, ...)
{
	CWnd* pWindow = AfxGetMainWnd();
	if (pWindow) {
		va_list marker;
		char buf[1024];
	
		va_start(marker, a);
		vsprintf(buf, a, marker);

		CStatusBar* pStatus = (CStatusBar *)pWindow->GetDescendantWindow(ID_VIEW_STATUS_BAR,TRUE);
		if (pStatus)
			pStatus->SetPaneText(0, buf, TRUE);
		
		va_end(marker);
	}


}

