// mmiDoc.h : interface of the CMmiDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MMIDOC_H__43625BA7_0502_11D1_B500_0000E8D46BAC__INCLUDED_)
#define AFX_MMIDOC_H__43625BA7_0502_11D1_B500_0000E8D46BAC__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Im1defs.h"
#include "ztl.h"

// SB @@@@
//ML - removed this line
//#include "Dmif.h"

//ML - added the next include line
#include "DAItypes.h"

#include "RemoteDlg.h"

class ALManger;

class Executive3d;
class OpenGLApplication;
class OpenGLPresenter;

class CMmiDoc : public CDocument
{
protected: // create from serialization only
	CMmiDoc();
	DECLARE_DYNCREATE(CMmiDoc)

// Attributes
public:

// Operations
public:

	BOOL m_bFinished;

	OpenGLApplication * mpoApp;
	Executive3d * mpoExec;
	OpenGLPresenter * mpoPres;

	void Finish(int nReason);
	BOOL Restart(LPCTSTR lpszPathName);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMmiDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void DeleteContents();
	virtual void OnCloseDocument();
	//}}AFX_VIRTUAL

// Implementation
public:
	BOOL m_fileOpened;
	void CloseDocument();
	ZSemaphore m_smpFileOpen;
	BOOL m_bSequenceComplete;
	void OnError(NON_FATAL_ERROR error);

	// SB @@@@ ????
	// void OnFinish(SERVICE_TERMINATION reason = END_OF_SERVICE);
	//ML - changed RESPONSE_PARAMETER to RESPONSE
	void OnFinish(RESPONSE reason = RESPONSE_UNKNOWN_ERROR);

	// void OnConnect(CONNECTION_RESULT result = CONNECTION_SUCCESS);
	//ML - changed RESPONSE_PARAMETER to RESPONSE
	void OnConnect(RESPONSE result = RESPONSE_UNKNOWN_ERROR);

	BOOL m_bNavigation;
	void CreateExecutive(HWND hWnd);
	void DestroyExecutive(HWND hWnd);
	virtual ~CMmiDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMmiDoc)
	afx_msg void OnFileBIFSSimulate();
	afx_msg void OnUpdateEditUndoMovement(CCmdUI* pCmdUI);
	afx_msg void OnEditUndoMovement();
	afx_msg void OnFileClose();
	afx_msg void OnRemoteOpen();
	afx_msg void OnFileReload();
	afx_msg void OnUpdateFileReload(CCmdUI* pCmdUI);
	afx_msg void OnViewWorldInfo();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	CRemoteDlg m_RemoteDlg;
	HWND m_pViewWnd;
	int m_nReturn;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MMIDOC_H__43625BA7_0502_11D1_B500_0000E8D46BAC__INCLUDED_)
