// mmiView.h : interface of the CMmiView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MMIVIEW_H__43625BA9_0502_11D1_B500_0000E8D46BAC__INCLUDED_)
#define AFX_MMIVIEW_H__43625BA9_0502_11D1_B500_0000E8D46BAC__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Im1defs.h"

class CMmiView : public CView
{
protected: // create from serialization only
	CMmiView();
	DECLARE_DYNCREATE(CMmiView)

// Attributes
public:
	CMmiDoc*	 GetDocument();
	CPalette	*m_pOldPalette;
	CPalette	 m_cPalette;
	CClientDC	*m_pDC;
	UINT m_nTimer;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMmiView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	//}}AFX_VIRTUAL

// Implementation
public:
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	void PaintScene();
	virtual ~CMmiView();

protected:
	void ConfigureOpenGL();
	void CreateRGBPalette();
	// The following are used in timing calulations
	DWORD	ElapsedTimeinMSSinceStartup( void )
		{ return( m_ElapsedTime - m_StartTime );}
	DWORD	ElapsedTimeinMSSinceLastRender( void )
		{ return( m_ElapsedTime-m_previousElapsedTime);}
	int		FramesPerSecond( void );	

// Generated message map functions
protected:
	//{{AFX_MSG(CMmiView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnEditAbuffer();
	afx_msg void OnEditZbuffer();
	afx_msg void OnEditHWShadow();
	afx_msg void OnEDITCscreen();
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnEditSelection();
	afx_msg void OnEditSgraph();
	afx_msg void OnViewBbox();
	afx_msg void OnViewSgmem();
	afx_msg void OnViewWireframe();
	afx_msg void OnEditFasttext();
	afx_msg void OnEditNicetext();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	int m_nHeight;
	int m_nWidth;
	BOOL m_bSelection;
	BOOL m_bCscreen, m_bFastTexture, m_bNiceTexture;
	BOOL m_bSgraph, m_bBBox, m_bWFrame, m_bSGMem;
	BOOL m_bZbuffer;
	BOOL m_bAbuffer;
	BOOL m_bHWshadow;
	unsigned int modifierState;
	USER_EVENT userEvent;
		// for elapsed timing calculations
	DWORD		m_StartTime,m_ElapsedTime,m_previousElapsedTime;

};

#ifndef _DEBUG  // debug version in mmiView.cpp
inline CMmiDoc* CMmiView::GetDocument()
   { return (CMmiDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MMIVIEW_H__43625BA9_0502_11D1_B500_0000E8D46BAC__INCLUDED_)
