/***********************************************************************
This software module was originally developed by Marius Preda
(INT/ARTEMIS) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. The author retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003.
************************************************************************

For more information or to receive an up to date version of this module,
you may mail Marius Preda at marius.preda@int-evry.fr.
----------------------------------------------------------------------*/

#if !defined(_BBA_Stream_h)  // Sentry, use file only if it's not already included.
#define _BBA_Stream_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Multiplexer
FILE:       BBAStream.h
AUTHOR:     Marius Preda MP (INT)
OVERVIEW:   Declaration of the BBA Stream.
-------------------------------------------------------------------------*/
#include "MP4Stream.h"
/*

class BBAStream : public Stream
{

	  int m_cNext;
  long m_lFrames,m_lByteCount,m_lSize;
  BOOL m_bStart;
  float m_fFrameRate;
  long m_lDTS;
  bool m_bRAP;

	
	// The following variables are needed when the stream dose not have one AU
	BOOL m_constant;
	float m_nextTime;
	float m_intervalTime;


public:
	
	BBAStream (FILE *fStream, ESDesc *pDescriptor):
		Stream (fStream, pDescriptor), m_bRAP (true),
		//This variables should be used in further versions 
		m_constant(TRUE), m_nextTime(0), m_intervalTime(1) // default value
	{}

	virtual long GetDTS (long lNow = 0);
	virtual long GetCTS () {return m_lDTS;}
	virtual int GetChar ();
	virtual bool IsRAP ();
//	void SetIntervalTime(float time) { m_intervalTime = time; }
};

*/

#include "../IM1Decoders/AFX/BBA/BBADecoderLib/BBADecoderLib.h"

class BBAStream : public Stream
{
// by D.S.CHO
	long m_lFrames;	
	float m_frameRate;
	long m_lDTS;
	long m_lCTS;	
	bool m_bRAP;
	bool m_bNextRAP;	
	bool m_bEOF;				
	bool m_bIsSessionHeader;	
	unsigned char *m_pAUBuffer;	
	long m_lAULength;
	long m_lIndex;	
	BBADecoderLib m_bbaDecoderLib;
	int codingMethod;

public:
	BBAStream (FILE *fStream, ESDesc *pDescriptor); 	
	~BBAStream();	// by D.S.CHO
	virtual long GetDTS (long lNow = 0);
	virtual long GetCTS ();
	virtual bool IsRAP ();
	virtual int GetChar ();
//	unsigned char* GetAUBuffer();
//	long GetAULength();		
};

#endif	// _BBA_Stream_h sentry



////////////////////////////////////////////////////////////////////////////


