/***********************************************************************
This software module was originally developed by Khaled MAMOU
(INT/ARTEMIS) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. The author retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2007.
************************************************************************

For more information or to receive an up to date version of this module,
you may mail Khaled MAMOU at khaled.mamou@int-edu.du.
----------------------------------------------------------------------*/

#if !defined(_FAMC_Stream_h)  // Sentry, use file only if it's not already included.
#define _FAMC_Stream_h

#include "FAMCDecoder.h"

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Multiplexer
FILE:       FAMCStream.h
AUTHOR:     Khaled Mamou (INT)
OVERVIEW:   Declaration of the FAMC Stream.
-------------------------------------------------------------------------*/
#include "MP4Stream.h"

class FAMCStream : public Stream
{
	long m_lDTS;
	long m_lCTS;	
	bool m_bRAP;
	bool m_bNextRAP;	
	bool m_bEOF;				
	bool m_bIsSessionHeader;	
	unsigned char *m_pAUBuffer;	
	long m_lAULength;
	long m_lIndex;	
	FAMCDecoder m_FAMCDecoder;
	FILE * m_fStream;

public:
	FAMCStream (FILE *fStream, ESDesc *pDescriptor); 	
	~FAMCStream();	
	virtual long GetDTS (long lNow = 0);
	virtual long GetCTS ();
	virtual bool IsRAP ();
	virtual int GetChar ();
//	unsigned char* GetAUBuffer();
//	long GetAULength();		
};


#endif	// _FAMC_Stream_h sentry



////////////////////////////////////////////////////////////////////////////


