/***********************************************************************
This software module was originally developed by Marcos Aviles
(Universidad Politecnica de Madrid, UPM) in the course of development of 
the MPEG-4 Systems (ISO/IEC 14496-1) standard. This software module is
an implementation of a part of one or more MPEG-4 Systems 
(ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems
(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems 
(ISO/IEC 14496-1) free license to this software module or modifications
thereof for use in hardware or software products claiming conformance to
the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this 
software module in hardware or software products are advised that its 
use may infringe existing patents. The original developer of this 
software module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software module
or modifications thereof in an implementation. Copyright is not 
released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
UPM retains full right to use the code for his/her own purpose, assign 
or donate the code to a third party and to inhibit third parties from 
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. This copyright notice must be included in all copies or 
derivative works. Copyright  2006
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Marcos Aviles at mar@gti.ssr.upm.es.
----------------------------------------------------------------------*/

#ifndef __JP2STREAM_H__
#define __JP2STREAM_H__

#include "MP4Stream.h"

class JP2Stream : public Stream
{
    long m_lDTS;
    bool m_bRAP;
    
    BOOL m_constant;
    float m_nextTime;
    float m_intervalTime;
    
public:
    JP2Stream(FILE *fStream, ESDesc *pDescriptor);

    virtual long GetDTS(long lNow = 0);
    virtual long GetCTS() { return m_lDTS; }
    virtual int GetChar();
    virtual bool IsRAP();
};

#endif // __JP2STREAM_H__
