/***********************************************************************
This software module was originally developed by Jean Le Feuvre
(avipix, llc) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. avipix, llc retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2000.
************************************************************************/

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  MP4 File Writer
FILE:       mp4enc.h
AUTHOR:     Jean Le Feuvre (avipix, llp, jean@avipix.com), December 2000
OVERVIEW:   MP4Enc: the class that handles mp4 file writing
-------------------------------------------------------------------------*/


#ifndef __MP4ENC_H
#define __MP4ENC_H


#include "ztl.h"
//#include "esMp4.h"
#include "esMP4.h" // SOLARIS PORTING - typo
#include "ODEnc.h"

class MP4Enc  
{
public:
	MP4Enc(LPCSTR stMP4Name, BOOL bInterleaved, BOOL bMaximize);
	virtual ~MP4Enc();
	void Start (FILE *fList, int flags, FILE *trace);

private:
	BOOL NewMovie(u32 OD_ID, 
					u8 OD_PL,
					u8 scene_PL,
					u8 audio_PL,
					u8 visual_PL, 
					u8 praph_PL, 
					char *url, 
					u8 ExchangeFile);

	void MaximizeDuration();
	BOOL m_bInterleaved;
	BOOL m_bMaximize;
	char *m_stMP4Movie;
	u8 isExchangeFile;
	MP4Movie m_pMovie;

	u32 m_IODOdID;
	u32 m_IODBifsID;
};

#endif 
