#if !defined(_NHnt_h)  // Sentry, use file only if it's not already included.
#define _NHnt_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Multiplexer
FILE:       hint.h
AUTHOR:     Guido Franceschini (CSELT)
OVERVIEW:   Declaration of Hint, the class that handles input streams
which have been preparsed according to the hint format 
-------------------------------------------------------------------------*/
#include "MP4Stream.h"

struct nhntHeader {
	union {
		unsigned long	first;
		struct {
			unsigned char	version;
			unsigned char	objectTypeIndication;
			unsigned char	streamType;
			unsigned char	reserved;
		} firstByte;
	};
	unsigned long	bufferSizeDB;
	unsigned long	maxBitrate;
	unsigned long	avgBitrate;
	unsigned long	timeScale;
};

struct nhntRecord {
	unsigned long	first;
	unsigned long	offset;
	unsigned long	cts;
	unsigned long	dts;
};

class NHntStream : public Stream
{
	FILE  *m_fNHnt;
	struct nhntHeader	m_header;
	struct nhntRecord	m_nhnt;
	int   m_cNext;
	long  m_lCTS;
	int   m_nScale;
	unsigned long  m_nCount;
	unsigned long  m_nTotalCount;
	unsigned long  m_nTotalNHnt;
	unsigned long  m_nTotalNHntSize;
	unsigned long  m_nFrameSize;

public:
	NHntStream (FILE *fStream, ESDesc *pDescriptor);
	virtual int GetScale ();
	virtual long GetDTS ();
	virtual long GetCTS ();
	virtual bool IsRAP ();
	virtual int GetChar ();
};

#endif	// _NHnt_h sentry