/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1998.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Zvi Lifshitz at zvil@csi.com.
----------------------------------------------------------------------*/

#if !defined(_Stream_h)  // Sentry, use file only if it's not already included.
#define _Stream_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Multiplexer
FILE:       Stream.h
AUTHOR:     Zvi Lifshitz (Triton R&D Ltd.)
OVERVIEW:   Declaration of Stream, the base class for objects that handles
input streams.
-------------------------------------------------------------------------*/
#include "Factory.h"

class Stream
{
	FILE *m_fStream;

public:
	Stream (FILE *fStream) : m_fStream (fStream) {}
	virtual ~Stream () {}
	virtual long GetTimeStamp () = 0;
	virtual int GetChar () = 0;
	virtual int GetPaddingBits () {return 0;}

protected:
	int getc () {return fgetc (m_fStream);}
};

/*-----------------------------------------------------------------
Definiton of an execption for the case streamData is invalid
-----------------------------------------------------------------*/
struct ExceptionInvalidData
{
	LPCSTR m_szError;
	ExceptionInvalidData (LPCSTR szError) : m_szError (szError) {}
};

#endif	// _Stream_h sentry