/***********************************************************************
This software module was originally developed by Jean Le Feuvre
(avipix, llc) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. avipix, llc retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2000.
************************************************************************/

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  MP4 File Writer
FILE:       esMp4.h
AUTHOR:     Jean Le Feuvre (avipix, llp, jean@avipix.com), December 2000
OVERVIEW:   Derived special versions of ES descriptors, for the use of 
			the MP4 producer.
-------------------------------------------------------------------------*/

#ifndef __ESMP4_H
#define __ESMP4_H


#define INCLUDED_ISOMOVIE_H

#include "EncOD.h"
#include "ODCoder.h"
#include "MP4Defs.h"
#include "MP4Movies.h"

class ES_DescriptorMP4 : public ES_DescriptorEnc
{
	/*--------------------
	Methods
	--------------------*/
public:
	ES_DescriptorMP4 ();
	~ES_DescriptorMP4 ();

	//Opening of stream file
	int OpenFile (FILE *fList, int flags);
	int GetScale ();	// Guido 4/8/00
	long GetDTS (long lNow = 0);
	static void RegisterFactory (class StreamFactoryBase *pFactory);
	BOOL m_bIsInIOD;
	BOOL m_bSelfContained;

	int GetStreamType();
	MP4Err CreateTrack();
	MP4Err CreateMedia();
	MP4Err InitWrite();
	MP4Err TerminateWrite();
	char *GetFileName()	{
		return (char *) (LPCSTR) muxInfo->fileName;
	}
	void SetMovie(MP4Movie moov)
	{	m_pMovie = moov;	}

	void GetAU();
	MP4Err WriteSample(u32 *outDTS);
	//for esd URL and UI streams
	MP4Err WriteBlankSample();

private:

	BOOL BuildPacket (LPBYTE pPacket,int nMaxSize,int &rnLength, int &rnDataLength);
	u32 GetHandlerType(u32 streamType);
	u32 GetTrackType(u32 streamType);

	/*--------------------
	Members Variables
	--------------------*/
private:
	//Stream Factory 
	class Stream *m_pStream;
	FILE *m_fStream;
	static class StreamFactoryBase *m_pFactories [40];
	static int m_nFactoriesAvailable;

	//Building AUs 
	long m_lTS;
	int m_nPayloadLength;
	bool m_bStart, m_bEnd;
	BYTE m_payload [DEF_PACKET_SIZE];
	u32 m_nAULength;
	BOOL m_bEndOfAU;
	//AC:20021009 - SL extension : esMP4 : AbstractSLConfig  -- begin
	/*SLConfigDescriptor*/ AbstractSLConfig *m_pSLConfig;
	//AC:20021009 - SL extension : esMP4 : AbstractSLConfig  -- end
	u32 m_MaxDuration;
	//We still need the coder to encode the DecoderSpecificInfo
	ODCoder m_coder;

	BOOL m_bIsFirst;
	long m_iInitTS;
	//MP4 
	MP4Track m_Track;
	MP4Media m_Media;
	MP4Movie m_pMovie;
	MP4Handle m_pSampleEntry;
	MP4Handle m_sampEnt;
	MP4Handle m_pSample;
/******** Added by Liao Xuan, for DES Encryption ***/
	HINSTANCE hInstDes;
	long	indexEncryAU; // number of encrypted AU
/******** End: Added by Liao Xuan ******************/
};

#endif
