/***********************************************************************
This software module was originally developed by Jean Le Feuvre
(e-Vue, Inc) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. e-Vue, Inc retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2000.
************************************************************************/

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  MP4 File Writer
FILE:       VTC.h
AUTHOR:     Jean Le Feuvre (e-Vue Inc, llc, jlefeuvre@e-vue.com), April 2000
OVERVIEW:   Definition of VTCStream, the class that handles VTC
input streams.
-------------------------------------------------------------------------*/

#ifndef __VTC_H
#define __VTC_H


#include "MuxStream.h"

class VTCStream : public Stream
{
	BOOL m_constant;
	float m_nextTime;
	float m_intervalTime;
	FILE* m_timeFile;
	float m_prevTime[2];
	int m_prevChar[2];
	int m_nextChar;
	int m_readAhead;
	long m_lDTS;
	bool m_bRAP;

public:
	VTCStream (FILE *fStream, ESDesc *pDescriptor);
	~VTCStream ();
	virtual long GetDTS ();
	virtual long GetCTS () {return m_lDTS;}
	virtual bool IsRAP ();
	virtual int GetChar ();
};

#endif