#include <iostream.h>
#include <jni.h>
#include "Receiver.h"
 


extern "C" {
JNIEXPORT void JNICALL Java_Receiver_startFilter
  (JNIEnv *env, jclass classReceiver, jint index, jint id, jobject sfInterface, jint pid, jbyteArray pM, jbyteArray pV, jbyteArray nM, jbyteArray nV)
{

	jbyte *section = new jbyte[10];
	int i;
	jmethodID methodID;
	jvalue *args = new jvalue[2];
	
	char *sig = "(I[B)V";

	for(i = 0; i < 10; i++){
		section[i] = 'a';
	} 
	
	args[0].i = 1; //First argument (int)
	args[1].l = env->NewByteArray(10);

	env->SetByteArrayRegion((jbyteArray) args[1].l, 0, 10, section);

	if (!(methodID = env->GetMethodID(classReceiver, "newSection", sig))){
		cout << "Receiver native impl.: method newSection not found" << endl; 
		return;
	}

	if(env->ExceptionOccurred()){
		cout << "Receiver native impl.: Exception occurred during GetMethodID()" << endl; 
		env->ExceptionDescribe();
		return;
	}	

	cout << "Receiver native impl.: Calling newSection() ..." << endl;
	try{

		env->CallVoidMethodA(sfInterface, methodID, args);
	
	} catch(...){
		if(env->ExceptionOccurred()){
		cout << "Receiver native impl.: Exception occurred during calling newSection()" << endl; 
		env->ExceptionDescribe();
		}
		cout << "Receiver native impl.: Exception during call method" << endl;
		return;
	}
	cout << "Receiver native impl.: method newSection succeed" << endl;
}
}
