package sommit.sectfilt;
import  java.util.Vector;

class Notifier
    implements Runnable
{
    public static void main( String[] args )
    {
    	byte[] sec1 = new byte[10];
        Notifier not = new Notifier();
        Thread tr = new Thread( not );
		tr.start();
	    not.newSection(null, 1, sec1);
	    not.newSection(null, 0, sec1);
    }


    void newSection( SommitSfInterface l, int id, byte[] sec )
    {
        synchronized( this )
        {
            _vec.addElement( new SommitSfElement( l, id, sec ) );
            notify();
        }
    }
    
    public void run()    
    {
        // loop terminates when clockThread is set to null in stop()
        while ( true )
        {
            SommitSfElement el = getNext();
            while ( el!=null )
            {
  //              System.out.println("el.list.newSection( el.id, el.sec );");
                el.list.newSection( el.id, el.sec );
                el = getNext();
            }
            synchronized( this )
            {
                try
                {
                    if ( noDataAvailable() )
                        wait();
                }
                catch ( InterruptedException e )
                {
                }
            }
        }
    }

    boolean noDataAvailable()
    {
       	synchronized( this )
	{  return _vec.isEmpty();
        }
    }

    SommitSfElement  getNext()
    {
       	synchronized( this )
    	{
    	    if ( _vec.size() != 0 )
            {   SommitSfElement el =(SommitSfElement)_vec.firstElement();
                _vec.removeElement(el);
                return el;
            }
            else
            {   return null;
            }
    	}
    }
   
    Notifier()
    {
        _vec = new Vector();
    }

    ////////// IMPLEMENTATION //////////
    private Vector _vec;
 
}

class SommitSfElement
{
    SommitSfElement( SommitSfInterface l,int id, byte[] sec )
    {
        this.list = l;
        this.id = id;
        this.sec = sec;
    }
    
    SommitSfInterface list;
    int id;
    byte[] sec;
}
