/*******************************************************************************
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  Module              : bali (support package)
*  File name   $Logfile: /func_test_platf2/bali/si/scheduler/RetrieveListenerInterfaceAdapter.java $
*       Last save $Date: 2003/12/24 00:53:02 $
*             $Revision: 1.1.1.1 $
*          Last $Author: mikeseven $
*  Creation Date       : 16-11-98
*  First Author        : Bas van den Heuvel
*                        NatLab - Eindhoven
* 
*  Description         : ListenerInterfaceAdapter 
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: HwSfListenerInterfaceAdapter.java,v $
* Revision 1.1.1.1  2003/12/24 00:53:02  mikeseven
* Initial release of the CVS repository for MPEG-4 Systems code
* after the code was corrupted due to reorganization and human 
* errors.
*
* Revision 1.1  2003/04/03 04:29:19  mikeseven
* Initial release of Player3D and MPEG-J for all MPEG-4 reference softwares players with samples.
* For installation, follow instructions in docs/Player3D_setup.doc.
*
* Many thanks to Prashanth Gujjeti and Viswanathan Swaminathan from Sun Microsystems.
*
* -- Mikael Bourges-Sevenier (Mindego)
*
* Revision 1.1  2002/08/23 16:47:21  pg138550
* Changes for MPEG-J. NOT FINAL
*
* Revision 1.1  2000/06/06 18:43:03  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:16:41  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.1  1998-11-18 10:10:30+01  vdheuvel
* 39 march 1999, start of archive.
* Middleware packages DAVIC API implementation.
*
*
*******************************************************************************/

package bali.hw.sectfilt;
import bali.support.ListenerInterfaceAdapter;
import java.util.EventObject;
import java.util.EventListener;

/**
Adapter class for notifying RetrieveListeners.
*/

class HwSfListenerInterfaceAdapter 
	implements ListenerInterfaceAdapter 
{
	HwSfListenerInterfaceAdapter( HwSfListener l )
	{
		_l = l;
	}
	
    /*******************
    Called by ActiveEventSender to send the event.
    */
	public void notifyListeners( EventObject event )
	{
		_l.newHwSfEvent( (HwSfEvent)event );
	}
	
	///////////// PRIVATE ///////////////
	private HwSfListener _l;
}
