/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  Module              : bali.si 
*  File name   $Logfile: /func_test_platf2/bali/si/scheduler/RetrieveListener.java $
*       Last save $Date: 2003/12/24 00:53:02 $
*             $Revision: 1.1.1.1 $
*          Last $Author: mikeseven $
*  Creation Date       : 28/10/98
*  First Author        : S.A.F.A. van den Heuvel
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: SerializerSfEnhancer.java,v $
* Revision 1.1.1.1  2003/12/24 00:53:02  mikeseven
* Initial release of the CVS repository for MPEG-4 Systems code
* after the code was corrupted due to reorganization and human 
* errors.
*
* Revision 1.1  2003/04/03 04:29:21  mikeseven
* Initial release of Player3D and MPEG-J for all MPEG-4 reference softwares players with samples.
* For installation, follow instructions in docs/Player3D_setup.doc.
*
* Many thanks to Prashanth Gujjeti and Viswanathan Swaminathan from Sun Microsystems.
*
* -- Mikael Bourges-Sevenier (Mindego)
*
* Revision 1.1  2002/08/23 16:47:21  pg138550
* Changes for MPEG-J. NOT FINAL
*
* Revision 1.1  2000/06/06 18:43:04  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:16:43  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.1  1998-12-11 11:48:02+01  vdheuvel
* 39 march 1999, start of archive.
* Middleware packages DAVIC API implementation.
*
 * 
 * 1     9-11-98 13:59 Vdheuvel
 * Creation
*/

package bali.hw.sectfilt;
import  bali.support.Debug;
import  java.util.Vector;
/********************
This class allows a process to change the ansynchronous behaviour of
the section filter process into a synchronous behaviour.
*/
public class SerializerSfEnhancer
    implements HwSfListener
{
    /**************
	*/
    public SerializerSfEnhancer()
    {
        /*DBG*/Debug.msg( Debug.HWSF_LE, Debug.IMPL, "SerializerSfEnhancer ");
        _vecEvent = new Vector( 1,1 );
    }
    
    /**************
	*/
    public synchronized HwSfEvent getNextHwSfEvent()
    {
        /*DBG*/Debug.msg(Debug.HWSF_LE, "SerializerSfEnhancer.getNextHwSfEvent");
        HwSfEvent res = null;
        while ( res == null )
        {
            res = getNextEvent();
            try
            {
                /*DBG*/Debug.msg(Debug.HWSF_LE, Debug.LOW, "SerializerSfEnhancer waiting");
                if ( res == null )       
                    wait();
            }
            catch ( InterruptedException e )
            {}
        }
        /*DBG*/Debug.msg(Debug.HWSF_LE, Debug.LOW, "SerializerSfEnhancer result");
        
        return res;
    }

	/**************
	A new HwSfEvent, process the event and resend it.
	*/
    public synchronized void newHwSfEvent( HwSfEvent e)
    {
        /*DBG*/Debug.msg(Debug.HWSF_LE, "SerializerSfEnhancer newHwSfEvent");
        _vecEvent.addElement(e);
        notify();
    }

    /////////////////// IMPLEMENTATION ///////////////////
    private Vector _vecEvent;
    
    private synchronized HwSfEvent getNextEvent()
    {
        HwSfEvent res = null;
        if ( !_vecEvent.isEmpty() )
        {   res = (HwSfEvent)_vecEvent.firstElement();
            _vecEvent.removeElement( res );
        }
        /*DBG*/Debug.msg(Debug.HWSF_LE, Debug.LOW, "SerializerSfEnhancer getNextEvent"+res);
        return res;
    }
    
}