/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  File name   $Logfile: $
*       Last save $Date: 2003/12/24 00:53:02 $
*             $Revision: 1.1.1.1 $
*          Last $Author: mikeseven $
*  Creation Date       : 25/03/99
*  First Author        : S.A.F.A. van den Heuvel
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: HwTuner.java,v $
* Revision 1.1.1.1  2003/12/24 00:53:02  mikeseven
* Initial release of the CVS repository for MPEG-4 Systems code
* after the code was corrupted due to reorganization and human 
* errors.
*
* Revision 1.1  2003/04/03 04:29:22  mikeseven
* Initial release of Player3D and MPEG-J for all MPEG-4 reference softwares players with samples.
* For installation, follow instructions in docs/Player3D_setup.doc.
*
* Many thanks to Prashanth Gujjeti and Viswanathan Swaminathan from Sun Microsystems.
*
* -- Mikael Bourges-Sevenier (Mindego)
*
* Revision 1.1  2002/08/23 16:47:22  pg138550
* Changes for MPEG-J. NOT FINAL
*
* Revision 1.1  2000/06/06 18:43:05  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:16:44  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.1  1999-03-25 13:07:31+01  vdheuvel
* 39 march 1999, start of archive.
* Middleware packages DAVIC API implementation.
*
*/
package bali.hw.tuner;

/************************
This class is a high level interface to the tuner functionality.
At this point it is a placeholder for future extensions. The 
current API implementation assumes a signle TS. 
The HwTuner class is added to support sending TS changed events.
*/
public class HwTuner
{
    /*********************
    Get the instance of the Tuner.
    */
    public synchronized static HwTuner getInstance()
    {
        if ( _instance == null )
        {   
            _instance = new HwTuner();
        }
        return _instance;
    }


    /*******************
    Add a listener to tuner events.
    */
    public void addTunerListener( HwTunerListener l )
    {
    }
    
    /*******************
    Remove a listener to tuner events.
    */
    public void removeTunerListener( HwTunerListener l )
    {
    }
    
    //////////////////// PRIVATE //////////////////
    static private HwTuner _instance = null;
}