/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  Module              : bali.si 
*  File name   $Logfile: /func_test_platf2/bali/si/scheduler/TableSectionFilterData.java $
*       Last save $Date: 2003/12/24 00:53:03 $
*             $Revision: 1.1.1.1 $
*          Last $Author: mikeseven $
*  Creation Date       : 28/10/98
*  First Author        : S.A.F.A. van den Heuvel
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: SDTTableSetEnhancer.java,v $
* Revision 1.1.1.1  2003/12/24 00:53:03  mikeseven
* Initial release of the CVS repository for MPEG-4 Systems code
* after the code was corrupted due to reorganization and human 
* errors.
*
* Revision 1.1  2003/04/03 04:29:23  mikeseven
* Initial release of Player3D and MPEG-J for all MPEG-4 reference softwares players with samples.
* For installation, follow instructions in docs/Player3D_setup.doc.
*
* Many thanks to Prashanth Gujjeti and Viswanathan Swaminathan from Sun Microsystems.
*
* -- Mikael Bourges-Sevenier (Mindego)
*
* Revision 1.1  2002/08/23 16:47:23  pg138550
* Changes for MPEG-J. NOT FINAL
*
* Revision 1.1  2000/06/06 18:43:08  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:16:51  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.1  1998-12-11 11:05:50+01  vdheuvel
* 39 march 1999, start of archive.
* Middleware packages DAVIC API implementation.
*
 * 
 * 1     9-11-98 13:59 Vdheuvel
 * Creation
*/

package bali.retrieve;
import  bali.support.Debug;
import  bali.hw.sectfilt.HwSection;
import  bali.hw.sectfilt.HwSfListener;

/*******************
This class represents a TableSetSfEnhancer for retrieval of NIT's.
*/
class SDTTableSetEnhancer
    extends TableSetSfEnhancer
{
	/**************
	May only be called with FilterData on a complete section table format.
	*/
	SDTTableSetEnhancer( HwSfListener list )
	{
	    super( list );
        /*DBG*/Debug.msg( Debug.RETRIEVE, Debug.IMPL, "SDTTableSetEnhancer ");
	}
	
	
	/****************
	*/
	boolean tablesAreEqual( HwSection sec1, HwSection sec2 )
	{
        /*DBG*/Debug.msg( Debug.RETRIEVE, Debug.IMPL, "SDTTableSetEnhancer tablesAreEqual");
        return (  (sec1.table_id_extension() == sec2.table_id_extension() ) // ts_id
               && (sec1.get16bits(8)         == sec2.get16bits(8) )         // or_nw_id
               );
    }
    
}







	



