/*******************************************************************************
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  Module              : Ajg
*  File name   $Logfile: /func_test_platf2/bali/support/Assert.java $
*       Last save $Date: 2003/12/24 00:53:03 $
*             $Revision: 1.1.1.1 $
*          Last $Author: mikeseven $
*  Creation Date       : 23-4-1998
*  First Author        : Bas van den Heuvel
*                        NatLab - Eindhoven
* 
*  Description         : Java class file.
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: Assert.java,v $
* Revision 1.1.1.1  2003/12/24 00:53:03  mikeseven
* Initial release of the CVS repository for MPEG-4 Systems code
* after the code was corrupted due to reorganization and human 
* errors.
*
* Revision 1.1  2003/04/03 04:29:24  mikeseven
* Initial release of Player3D and MPEG-J for all MPEG-4 reference softwares players with samples.
* For installation, follow instructions in docs/Player3D_setup.doc.
*
* Many thanks to Prashanth Gujjeti and Viswanathan Swaminathan from Sun Microsystems.
*
* -- Mikael Bourges-Sevenier (Mindego)
*
* Revision 1.1  2002/08/23 16:47:24  pg138550
* Changes for MPEG-J. NOT FINAL
*
* Revision 1.1  2000/06/06 18:43:08  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:16:52  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.1  1999-02-12 12:35:14+01  vdheuvel
* 39 march 1999, start of archive.
* Middleware packages DAVIC API implementation.
*
 * 
 * 1     9-11-98 14:00 Vdheuvel
 * Creation
*
*******************************************************************************/

package bali.support;

/**
Java implementation of an assert.
*/
public class Assert
{

/**
Calls an assert and stops the program.
*/
private static void fail(String msg)
{
    System.err.println("assertion failed:" + msg);
        
    Throwable e = new Throwable( msg );
    e.printStackTrace();
    System.exit(1);
//    g4Assert(msg);
}

/**
Calls a G+4 assert
*/
private native static void g4Assert(String msg);

/**
Assert on a boolean.
@param b Program stops when b = false.
*/
public static void assert(boolean b)
{
	if (!b)
	{
        fail(null);
	}
}
     
/**
Assert on a object reference
@param ref Program stops if ref == null
*/
public static void assert(Object ref)
{
    if (ref == null)
        fail(null);
}

/**
Assert on a boolean.
@param b Program stops if b == false.
@param msg The message to be printed when the assert fails.
*/
public static void assert(boolean b, String msg )
{
	if (!b)
	{
        fail(msg);
	}
}
     
/**
Assert on a object reference.
@param ref Program stops if ref == null
@param msg The message to be printed when the assert fails.
*/
public static void assert(Object ref, String msg)
{
    if (ref == null)
    {
        fail(msg);
    }
}

}
