/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  Module              : bali.si 
*  File name   $Logfile: /func_test_platf2/bali/support/TimerListener.java $
*       Last save $Date: 2003/12/24 00:53:03 $
*             $Revision: 1.1.1.1 $
*          Last $Author: mikeseven $
*  Creation Date       : 28/10/98
*  First Author        : S.A.F.A. van den Heuvel
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: DavicURL.java,v $
* Revision 1.1.1.1  2003/12/24 00:53:03  mikeseven
* Initial release of the CVS repository for MPEG-4 Systems code
* after the code was corrupted due to reorganization and human 
* errors.
*
* Revision 1.1  2003/04/03 04:29:24  mikeseven
* Initial release of Player3D and MPEG-J for all MPEG-4 reference softwares players with samples.
* For installation, follow instructions in docs/Player3D_setup.doc.
*
* Many thanks to Prashanth Gujjeti and Viswanathan Swaminathan from Sun Microsystems.
*
* -- Mikael Bourges-Sevenier (Mindego)
*
* Revision 1.1  2002/08/23 16:47:24  pg138550
* Changes for MPEG-J. NOT FINAL
*
* Revision 1.1  2000/06/06 18:43:09  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:16:53  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.1  1998-12-12 16:25:50+01  vdheuvel
* 39 march 1999, start of archive.
* Middleware packages DAVIC API implementation.
*
 * 
 * 1     9-11-98 14:00 Vdheuvel
 * Creation
*/

package bali.support;
import java.net.MalformedURLException;


/*********************
*/
public class DavicURL
{
	/*************
	*/
	public DavicURL( String url )
	    throws MalformedURLException
	{
	    if ( ! url.startsWith("dvb://" ) )
	    {   throw new MalformedURLException( "dvb://" );
	    }
	    String str   = url.substring( 6 );
	    int    end   = str.indexOf(".");
	    _orNwId = Integer.parseInt(  str.substring( 0, end ) );
	    str     = str.substring( end+1 );
	    _tsId = Integer.parseInt(  str.substring( 0, str.indexOf(".") ) );
	}
	
	/*************
	*/
	public int getOriginalNetworkId()
	{
	    return _orNwId;
	}
	
	/*************
	*/
	public int getTransportStreamId()
	{
	    return _tsId;
	}
	
	/*************
	*/
	public String toString()
	{
	    return 
	        ( "dvb://"
            + Integer.toHexString( _orNwId )
       	    + "."
            + Integer.toHexString( _tsId )
            );
	}

	/////////////////// IMPLEMENTATION ////////////////////
	private int _tsId      = -1;
	private int _orNwId    = -1;
	private int _serviceId = -1;
}

