/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  File name   $Logfile: /func_test_platf2/bali/si/table/DvbString.java $
*       Last save $Date: 2003/12/24 00:53:04 $
*             $Revision: 1.1.1.1 $
*          Last $Author: mikeseven $
*  Creation Date       : 28/10/98
*  First Author        : S.A.F.A. van den Heuvel
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: DvbString.java,v $
* Revision 1.1.1.1  2003/12/24 00:53:04  mikeseven
* Initial release of the CVS repository for MPEG-4 Systems code
* after the code was corrupted due to reorganization and human 
* errors.
*
* Revision 1.1  2003/04/03 04:29:25  mikeseven
* Initial release of Player3D and MPEG-J for all MPEG-4 reference softwares players with samples.
* For installation, follow instructions in docs/Player3D_setup.doc.
*
* Many thanks to Prashanth Gujjeti and Viswanathan Swaminathan from Sun Microsystems.
*
* -- Mikael Bourges-Sevenier (Mindego)
*
* Revision 1.1  2002/08/23 16:47:24  pg138550
* Changes for MPEG-J. NOT FINAL
*
* Revision 1.1  2000/06/06 18:43:11  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:16:58  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.1  1998-11-25 11:52:14+01  vdheuvel
* 39 march 1999, start of archive.
* Middleware packages DAVIC API implementation.
*
 * 
 * 1     9-11-98 13:59 Vdheuvel
 * Creation
*/
package bali.table;

/******************************
This class represents a string in a dvb descriptor.
*/
class DvbString
{
	/******************************
	*/
	DvbString()
	{
		_long = "";
		_short = "";
	}

	/******************************
	*/
	DvbString( byte[] arB, int start, int end )
	{
		char ch;
		byte b;
		boolean emphasis = false;
			
		_long = new String();
		_short = new String();
	    
	    for ( int i=start ; i<end ; i++ )
		{	
			b  = arB[ i ];
			ch = (char)b;
			if ( b < 0x80 || b > 0x9F )
			{
				_long +=ch;
			}
			
			if ( b == 0x86 )
			{	emphasis = true; 
			}
			if ( b == 0x87 )
			{	emphasis = false;
			}

			if ( emphasis )
			{	_short += ch;
			}
		}
		if ( _short.compareTo( "" )==0 )
		{	// no emphasis marks in name
			if ( _long.length() >=4 )
			{	_short = _long.substring( 0, 3);
			}
			else
			{	_short = _long;
			}
		}
	}

	/******************************
	Get the short representation of the String
	*/
	String getShortString()
	{
		return _short;
	}
	
	/******************************
	Get the normal representation of the String
	*/
	String getString()
	{
		return _long;
	}
	
	

	/////////////////// PRIVATE /////////////////////
	String _short;
	String _long;
	
}