/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  File name   $Logfile: /func_test_platf2/bali/si/table/ES.java $
*       Last save $Date: 2003/12/24 00:53:04 $
*             $Revision: 1.1.1.1 $
*          Last $Author: mikeseven $
*  Creation Date       : 28/10/98
*  First Author        : S.A.F.A. van den Heuvel
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: ES.java,v $
* Revision 1.1.1.1  2003/12/24 00:53:04  mikeseven
* Initial release of the CVS repository for MPEG-4 Systems code
* after the code was corrupted due to reorganization and human 
* errors.
*
* Revision 1.1  2003/04/03 04:29:25  mikeseven
* Initial release of Player3D and MPEG-J for all MPEG-4 reference softwares players with samples.
* For installation, follow instructions in docs/Player3D_setup.doc.
*
* Many thanks to Prashanth Gujjeti and Viswanathan Swaminathan from Sun Microsystems.
*
* -- Mikael Bourges-Sevenier (Mindego)
*
* Revision 1.1  2002/08/23 16:47:25  pg138550
* Changes for MPEG-J. NOT FINAL
*
* Revision 1.1  2000/06/06 18:43:11  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:16:59  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.1  1998-12-08 09:50:30+01  vdheuvel
* 39 march 1999, start of archive.
* Middleware packages DAVIC API implementation.
*
 * 
 * 1     9-11-98 13:59 Vdheuvel
 * Creation
*/
package bali.table;
import bali.support.Debug;
import bali.support.TablePart;
import java.util.Vector;
import java.util.Enumeration;

/*******************
This class represents an Elementary Stream loop from a PMT.
*/
public class ES
    extends FilteredSITable
{
    /** */ private short STREAM_IDENTIFIER_DESC_TAG = 0x52;

	/***********************
	*/
	ES( TablePart tp, SITableInfo ti )
	{
	    super( ti );
		_tablePart = tp;
		
        int descLen = _tablePart.get12bits( 3 );
        _descriptorList = new DescriptorList( new TablePart( _tablePart, 5, descLen ) );
	}

	/***********************
	*/
	public int getStreamType()
	{
		return _tablePart.get8bits( 0 );
	}
	
	/***********************
	*/
	public int getPID()
	{
		return _tablePart.get13bits( 1 );
	}
	
	/***********************
	Return the component tag of this ES. When not available -2 is returned.
	*/
	public int getComponentTag()
	{
	    Descriptor desc = _descriptorList.getDescriptor( STREAM_IDENTIFIER_DESC_TAG );
	    if ( desc == null )
    	{	return -2;
    	}
    	else
    	{
    	    return (int)desc.get8bits(2);
    	}
	}
	
	/***********************
	*/
	public DescriptorList getDescriptorList()
    {
		return _descriptorList;
    }

    //////////////////////// PRIVATE ///////////////////////////////////
	private DescriptorList _descriptorList;
	private TablePart _tablePart;
}

