/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  File name   $Logfile: /func_test_platf2/bali/si/table/SITableInfo.java $
*       Last save $Date: 2003/12/24 00:53:05 $
*             $Revision: 1.1.1.1 $
*          Last $Author: mikeseven $
*  Creation Date       : 28/10/98
*  First Author        : S.A.F.A. van den Heuvel
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: SITableInfo.java,v $
* Revision 1.1.1.1  2003/12/24 00:53:05  mikeseven
* Initial release of the CVS repository for MPEG-4 Systems code
* after the code was corrupted due to reorganization and human 
* errors.
*
* Revision 1.1  2003/04/03 04:29:27  mikeseven
* Initial release of Player3D and MPEG-J for all MPEG-4 reference softwares players with samples.
* For installation, follow instructions in docs/Player3D_setup.doc.
*
* Many thanks to Prashanth Gujjeti and Viswanathan Swaminathan from Sun Microsystems.
*
* -- Mikael Bourges-Sevenier (Mindego)
*
* Revision 1.1  2002/08/23 16:47:25  pg138550
* Changes for MPEG-J. NOT FINAL
*
* Revision 1.1  2000/06/06 18:43:12  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:17:03  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.2  1999-04-15 09:53:18+02  vdheuvel
* Files changed to hook the system up to the TM demultipler and the
* TM hardware. Changes include, swapping the java.util.Date class
* for the bali.tm.Date class (to prevent using 64 bit floats). Changing
* the HW sect filt used by bali.hw.SectFilt.
*
* Revision 1.1  1998-12-01 11:17:18+01  vdheuvel
* 39 march 1999, start of archive.
* Middleware packages DAVIC API implementation.
*
 * 
 * 1     9-11-98 13:59 Vdheuvel
 * Creation
*/

package bali.table;

import org.davic.mpeg.dvb.DvbTransportStream;
/*DATE_NORMAL*/ import  java.util.Date;
//DATE_TM*/     import  bali.tm.Date;

/******************************
The basic information of a received table.
*/
public class SITableInfo
{
	/*****************
	Get the version of this table (-1 if not applicable or known).
	*/
	public int getVersion()
	{
		return _version;
	}

	/*****************
	This method returns true when the table is an Actual table or
	if this information is not applicable for this table.
	*/
	public boolean fromActual()
	{ 
		return _actual;
	}

	/*****************
	Return the transport stream this table was last filtered from.
	*/
	public DvbTransportStream getSourceTs()
	{
		return _sourceTs;
	}

	/*****************
	Return the time this table was last filtered.
	*/
	public Date getUpdateTime()
	{
		return _time;
	}

   	/*****************
	*/
    SITableInfo( SITableInfo old,  DvbTransportStream sourceTs, Date time )
    {
        _version  = old._version;
        _actual   = old._actual;
        _sourceTs = sourceTs;
        _time     = time;
    }
    

   	/*****************
	*/
    SITableInfo( int version, boolean actual, DvbTransportStream sourceTs, Date time )
    {
        _version  = version;
        _actual   = actual;
        _sourceTs = sourceTs;
        _time     = time;
    }
    
    /////////////////// PRIVATE ///////////////////////
    private int                _version;
    private boolean            _actual;
    private DvbTransportStream _sourceTs;
    private Date               _time;
}
