package bali.testframe.local_sommit;
import bali.testframe.ServerBase;
import sommit.sectfilt.SommitSectionFilter;
import bali.hw.sectfilt.HwSection;

/***************************************************************************
The Server class is the main class of the Server part of the functional test
set-up. The class provides the interface that allows a user to create a 
Server and offer sections to be send. <p>
This specific server instance has been designed to call the section filter
directly.

@version        21 October 1998
@author         Bas van den Heuvel, Philips Research
*/
public class Server
    extends ServerBase
{ 
	/*********************************************************************
	constructor using default ServerDescriptor, original network id 1, ts_d 0;
	@param	port	the	used by this Server
	@exception java.io.IOException when an error occurs
	*/	
	public Server()
	{
		System.out.println("Server: constructor");
	}

	
    /*********************************************************************
	Injects the MPEG2 section at the indicated PID.
	@param	PID		the PID this section has to be send on
	@param	section	the section to be send
	*/
	synchronized public 
 		void send( int PID, HwSection section )
	{
		//DBG System.out.println("Server : section send " + new java.util.Date() );

        SommitSectionFilter.newSection( PID, section.getData() );
	}	
	
}
 
