/*
* Copyright(c) Philips Consumer Electronics B.V. 1998
* All rights reserved. Reproduction in whole or in part is
* prohibited without the written consent of the copyright holder.
*
*  Project             : Bali
*  Module              : bali.si
*  File name   $Logfile: $
*       Last save $Date: 2003/12/24 00:53:05 $
*             $Revision: 1.1.1.1 $
*          Last $Author: mikeseven $
*  Creation Date       : early 1999
*  First Author        : Ben Golding
*                        PRL - Redhill
*
*
*  Change history      :
*  ---------------
*
* $Log: Date.java,v $
* Revision 1.1.1.1  2003/12/24 00:53:05  mikeseven
* Initial release of the CVS repository for MPEG-4 Systems code
* after the code was corrupted due to reorganization and human 
* errors.
*
* Revision 1.1  2003/04/03 04:29:28  mikeseven
* Initial release of Player3D and MPEG-J for all MPEG-4 reference softwares players with samples.
* For installation, follow instructions in docs/Player3D_setup.doc.
*
* Many thanks to Prashanth Gujjeti and Viswanathan Swaminathan from Sun Microsystems.
*
* -- Mikael Bourges-Sevenier (Mindego)
*
* Revision 1.1  2002/08/23 16:47:26  pg138550
* Changes for MPEG-J. NOT FINAL
*
* Revision 1.1  2000/07/21 21:03:33  alavilli
* adding missing files in the previous checkin for SISF
*
* Revision 1.1.2.1  1999/07/09 14:17:08  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.3  1999-04-23 19:01:20+02  vdheuvel
* Streamline of interface with java.util.Date.
*
* Revision 1.2  1999-04-23 17:11:06+02  vdheuvel
* Added simple and incomplete milles<=> value transformation to
* support EIT schedule filetering.
*
* Revision 1.1  1999-04-15 10:00:02+02  vdheuvel
* Creation, a temporarily replacement for java.util.Date to prevent
* using 64 floats.
*
*
*/

package bali.tm;

public class Date {
    private long mytime;
    private int y = 0, m = 0, d = 0, h = 0, mi = 0, s = 0;
      
    public Date(long t) {
      mytime = t;
      long deltaTime = mytime - _currentMillis;
      long dTime = deltaTime;

      int dy = (int)( deltaTime / (365*24*60*60*1000) );
      deltaTime -= dy*(365*24*60*60*1000);
      y = _currentYear+dy;

      int dm = (int)( deltaTime / (30*24*60*60*1000) );
      deltaTime -= dm*(30*24*60*60*1000);
      m = _currentMonth+dm;

      int dd = (int)( deltaTime / (24*60*60*1000) );
      deltaTime -= dd*(24*60*60*1000);
      d = _currentDay+dd;

      int dh = (int)( deltaTime / (60*60*1000) );
      deltaTime -= dh*(60*60*1000);
      h = _currentHour+dh;

      int dmi = (int)( deltaTime / (60*1000) );
      deltaTime -= dmi*(60*1000);
      mi = _currentHour+dmi;

      int ds = (int)( deltaTime / (1000) );
      deltaTime -= ds*(1000);
      s = _currentHour+ds;

//      System.out.println("Time (millis) "+dTime+","+dh+":"+dmi+" "+ds+"/"+dd+"/"+dm+"/"+dy );
//      System.out.println("Time (millis) "+String.valueOf(h)+":"+(mi<10?"0":"")+String.valueOf(mi)+" "+String.valueOf(d)+"/"+String.valueOf(m)+"/"+String.valueOf(y) );
    }
    public Date() {
      mytime =  System.currentTimeMillis() ;
    }
    public Date(int year, int month, int date, int hours, int mins, int secs) 
    {
      y = year;
      m = month;
      d = date;
      h = hours;
      mi = mins;
      s = secs;
      
      synchronized( _lock )
      {
        if ( _currentDay == -1 )
        {  
            _currentYear  = y;
            _currentMonth = m;
            _currentDay   = d;
            _currentHour  = h;
            _currentMin   = mi;
            _currentSecond= s;
//            System.out.println("Current Time "+String.valueOf(h)+":"+(mi<10?"0":"")+String.valueOf(mi)+" "+String.valueOf(d)+"/"+String.valueOf(m)+"/"+String.valueOf(y) );
         }    
      }
      {
        
        mytime = _currentMillis 
                 + (    
                     (
                       ( deltaDay()*12 + deltaHour()  // day
                       ) * 60 + deltaMinute()         // minutes
                     ) *60 + deltaSecond()            // seconds
                   ) * 1000                           // milli seconds
                 ;
      }
//      System.out.println("Time (date)"+String.valueOf(h)+":"+(mi<10?"0":"")+String.valueOf(mi)+" "+String.valueOf(d)+"/"+String.valueOf(m)+"/"+String.valueOf(y) );
    }
      
    public long getTime() {
      return mytime;
    }
    public boolean after(Date d) {
      return (mytime > d.mytime);
    }
    public boolean before(Date d) {
      return (mytime < d.mytime);
    }  
    public String toString() 
    { if(y == 0) return "Date.toString() undefined";
      return String.valueOf(h)+":"+(mi<10?"0":"")+String.valueOf(mi)+" "+String.valueOf(d)+"/"+String.valueOf(m)+"/"+String.valueOf(y);
    }
    public int getHours()
    {   return h;
    }

    public int getMinutes()
    {   return mi;
    }

    public int getDay()
    {   return d;
    }

    public int getMonth()
    {   return m;
    }

    public int getYear()
    {   return y;
    }

    //////////////// private /////////////////
    private long deltaDay()
    {   return ( (y-_currentYear)*365 + (m-_currentMonth)*30 + ( d-_currentDay) );
        // number of days not completely correct
    }
    private long deltaHour()
    {   return (h  - _currentHour);
    }
    private long deltaMinute()
    {   return (mi - _currentMin );
    }
    private long deltaSecond()
    {   return (s  - _currentSecond );
    }

    static int    _currentYear  = -1;
    static int    _currentMonth = -1;
    static int    _currentDay   = -1;
    static int    _currentHour  = -1;
    static int    _currentMin   = -1;
    static int    _currentSecond= -1;
    static long   _currentMillis = -100000;
    static Object _lock         = new Object();

}

  
