// StP -- created on Fri Oct 09 09:23:19 1998 for sommitcc@kerne from system DVBSI
/***********************************************************************************
 * project Java for Sommit :                                                       *
 * API SI-EPG                                                                      *
 * Author : Jean-Philippe Barazeur                                                 *
 * CCETT  : 14/10/98                                                               *
 ***********************************************************************************/


 /***********************************************************************************/
 /*                                                                                 */
 /*                          Alarm                                                  */
 /*                                                                                 */
 /***********************************************************************************/

 /*
 This class defines Alarm objects. This class implements SIEventListener ( see SI API
 - Davic 1.3). This interface gives Alarm Objects, an Event behaviour. When a SIEventObject
 occurs, post method is called.
 _EventId is a link between an Alarm object and an SIEvent object
 _typeOfAlarm represents an int:
  0 - Record mode / 1 - Notify mode 2 - Record & Notify mode.

*/

package sommit.APISiEpg;

//import org.davic.net.dvb.si;   API SI - Davic 1.3
import sommit.davic13.*;


public class Alarm implements SIEventListener
{
// stp class members

    SIEvent _anEvent;     // EventId of the Listenee SIEvent
    int _typeOfAlarm;

/***********************************************************************************************/
/*                                       Methods                                               */
/***********************************************************************************************/

/*---------------------------------------------------------------------------------------------*/
/* Method       :   Alarm                                                                      */
/* Description  :   Constructor - Sets attributes                                              */
/* Parameters   :   EventId(String) : the new value for _EventId                              */
/*                  typeOfAlarm :          --------  for _typeOfAlarm                          */
/* Return Value :   none                                                                       */
/*---------------------------------------------------------------------------------------------*/

public Alarm(SIEvent anEvent, int typeOfAlarm)
{
    _anEvent = anEvent;
    _typeOfAlarm = typeOfAlarm;
}


public String GetStartDate()
{
    java.util.Date tempDate =  _anEvent.getStartTime();
    return tempDate.toGMTString();
}

/*---------------------------------------------------------------------------------------------*/
/* Method       :   post ( interface method SIEventListener)                                   */
/* Description  :   is called when an SIEventObject occurs                                     */
/* Parameters   :   anEvent(SIEventObject) : see SI-API Davic 1.3                              */
/* Return Value :   none                                                                       */
/*---------------------------------------------------------------------------------------------*/

public void post(SIEventObject anEvent)
{
    if (anEvent.getType() == SIEventObjectType.RUNNING_STATUS_CHANGED)
    {
        byte NewStatus = anEvent.getRunningStatus();

        if (NewStatus == SIRunningStatus.STARTS_IN_A_FEW_SECONDS)
        {
            // alarm Recorder and User
        }
        else if (NewStatus == SIRunningStatus.RUNNING)
        {
            // begins
        }
    }
    else if (anEvent.getType() == SIEventObjectType.SOURCE_OBJECT_KILLED)
    {
          // end of event (stop recorder)
    }
}



/*---------------------------------------------------------------------------------------------*/
/* Method       :   GetEvent()                                                                 */
/* Description  :   Returns _anEvent                                                           */
/* Parameters   :   none                                                                       */
/* Return Value :   _Event (SIEvent object)                                                    */
/*---------------------------------------------------------------------------------------------*/

public SIEvent GetEvent()
{
    return _anEvent;
}


/*---------------------------------------------------------------------------------------------*/
/* Method       :   SetType()                                                                  */
/* Description  :   modifies _typeOfAlarm                                                      */
/* Parameters   :   Type(int) - new value of _typeOfAlarm                                      */
/* Return Value :   none                                                                       */
/*---------------------------------------------------------------------------------------------*/

public void SetType(int Type)
{
    _typeOfAlarm = Type;
}

/*---------------------------------------------------------------------------------------------*/
/* Method       :   GetType()                                                                  */
/* Description  :   Returns _typeOfAlarm                                                       */
/* Parameters   :   none                                                                       */
/* Return Value :   _typeOfAlarm value                                                         */
/*---------------------------------------------------------------------------------------------*/

public int GetType()
{
    return  _typeOfAlarm;
}

// stp class members end
}
// stp class definition end

