// StP -- created on Fri Oct 09 09:23:19 1998 for sommitcc@kerne from system DVBSI
/***********************************************************************************
 * project Java for Sommit :                                                       *
 * API SI-EPG                                                                      *
 * Author : Jean-Philippe Barazeur                                                 *
 * CCETT  : 14/10/98                                                               *
 ***********************************************************************************/


/***********************************************************************************/
/*                                                                                 */
/*                          DescComponent                                          */
/*                                                                                 */
/***********************************************************************************/

/*
DescComponent implements a ComponentDescriptor ( see ETS 300-468 DVB - SI Spec)
It static method, GetComponent, parses the descriptor and retrieves information
*/

// import org.davic.net.dvb.si;
package sommit.APISiEpg;

import sommit.davic13.Descriptor;
import sommit.davic13.DescriptorTag;

class DescComponent
{

/***********************************************************************************************/
/*                                       Methods                                               */
/***********************************************************************************************/

/*---------------------------------------------------------------------------------------------*/
/* Method       :   GetComponent                                                               */
/* Description  :   parses the descriptor and retrieve information into a string               */
/* Parameters   :   desc, a Descriptor object                                                  */
/* Return Value :   A String which contains information on component descriptor                */
/*---------------------------------------------------------------------------------------------*/

public static String GetComponent(Descriptor desc)
{

    String result;
    // first step : parse the DescriptorData
    if (desc.getTag() != DescriptorTag.COMPONENT)
    {
        return null;
    }

    byte Data[] = desc.getContent();
    int index = 0;
    byte streamContent = (byte)(Data[index] & 0x0F); // only the 4 LSB
    byte Component_type = Data[index+1];

    switch  (streamContent)
    {
        case 0: result = "reserved for future use";
                break;
        case 1:
                switch (Component_type)
                {
                    case 1: result = "video, 4:3 aspect ratio";
                            break;
                    case 2: result = "video, 16:9 aspect ratio, with pan vectors";
                            break;
                    case 3: result = "video, 16:9 aspect ratio, without pan vectors";
                            break;
                    case 4: result = "video,>16:9 aspect ratio";
                            break;
                    default:result = "reserved for future use";
                            break;
                }
                break;

        case 2:
                switch (Component_type)
                {
                    case 1: result = "audio, single mono channel";
                            break;
                    case 2: result = "audio, dual mono channel";
                            break;
                    case 3: result = "audio, stereo(2 channel)";
                            break;
                    case 4: result = "audio, multi-lingual, multi-channel";
                            break;
                    case 5: result = "audio, surround sound";
                            break;
                    case 0x40: result = "audio description for visually impaired";
                               break;
                    case 0x41: result = "audio for the hard of hearing";
                               break;
                    default: result = "reserved for future use";
                              break;
                }
                if ((Component_type >= 0x0B0) || (Component_type <= 0xFE))
                {
                    result = "user-defined";
                }
                break;

        case 3:
              switch (Component_type)
              {
                  case 1 : result = "EBU Teletext subtitles";
                           break;
                  case 2 : result = "associated EBU Teletext";
                           break;
                  default : result = "reserved for future use";
                           break;
              }
              break;

        default :
                result = "reserved for future use";
                break;
        }

  return result;

}





}
// stp class definition end

