// StP -- created on Fri Oct 09 09:23:20 1998 for sommitcc@kerne from system DVBSI


// stp class definition 103
/***********************************************************************************
 * project Java for Sommit :                                                       *
 * API SI-EPG                                                                      *
 * Author : Jean-Philippe Barazeur                                                 *
 * CCETT  : 14/10/98                                                               *
 ***********************************************************************************/


/***********************************************************************************/
/*                                                                                 */
/*                          DescContent                                          */
/*                                                                                 */
/***********************************************************************************/

/*
DescContent implements a ContentDescriptor ( see ETS 300-468 DVB - SI Spec)
It static method, GetContent, parses the descriptor, finds the L1 Nibbles
and retrieves information into a String
*/

// import org.davic.net.dvb.si;
package sommit.APISiEpg;

import sommit.davic13.Descriptor;
import sommit.davic13.DescriptorTag;


class DescContent
{
// stp class members
/***********************************************************************************************/
/*                                       Methods                                               */
/***********************************************************************************************/

/*---------------------------------------------------------------------------------------------*/
/* Method       :   GetContent                                                                 */
/* Description  :   parses the descriptor and retrieve information into a string               */
/* Parameters   :   desc, a Descriptor object                                                  */
/* Return Value :   A String which contains information on content descriptor                  */
/*---------------------------------------------------------------------------------------------*/

public static String GetContent(Descriptor desc)
{
   String result;

   if (desc.getTag() != DescriptorTag.CONTENT)
   {
        return null;
   }

   byte[] Data = desc.getContent();

   int index = 0;

   int L1Nibbles =(int)(Data[index] & 0x00F0);  // Nibbles L1 is the 4th MSB
   int L1L2Nibbles = (int)(Data[index] & 0x00FF);


   switch (L1Nibbles)
   {
        case 0x10:
                  switch (L1L2Nibbles)
                  {
                      case 0x10: result = "Movie (general)";
                                 break;
                      case 0x11: result = "Detective - Thriller";
                                 break;
                      case 0x12: result = "Adventure - Western - War";
                                 break;
                      case 0x13: result = "Science Fiction - Fantasy - Horror";
                                 break;
                      case 0x14: result = "Comedy";
                                 break;
                      case 0x15: result = "Soap - Melodrama - Folkloric";
                                 break;
                      case 0x16: result = "Romance";
                                 break;
                      case 0x17: result = "Serious - Classical - Religious - Historical drama";
                                 break;
                      case 0x18: result = "Adult Movie";
                                 break;
                      default  : result = "Movie";
                  }
                  break;

        case 0x20:
                  switch (L1L2Nibbles)
                  {
                      case 0x20: result = "News - Current affairs";
                                 break;
                      case 0x21: result = "News - Weather report";
                                 break;
                      case 0x22: result = "News magazine";
                                 break;
                      case 0x23: result = "Documentary";
                                 break;
                      case 0x24: result = "Discussion - Interview - Debate";
                                 break;
                      default:   result = "News - Current affairs";
                  }
                  break;

        case 0x30:
                 switch (L1L2Nibbles)
                 {
                    case 0x30: result = "Show - Game show";
                               break;
                    case 0x31: result = "Game show - Quiz - Contest";
                               break;
                    case 0x32: result = "Variety show";
                               break;
                    case 0x33: result = "Talk show";
                               break;
                    default:    result = "Show - Game show";
                 }
                 break;

        case 0x40:
                switch(L1L2Nibbles)
                {
                    case 0x40: result = "Sports";
                               break;
                    case 0x41: result = "Sports - Special Events ";
                               break;
                    case 0x42: result = "Sports magazines";
                               break;
                    case 0x43: result = "Football - Soccer";
                               break;
                    case 0x44: result = "Tennis - Squash";
                               break;
                    case 0x45: result = "Team Sports";
                               break;
                    case 0x46: result = "Athletics";
                               break;
                    case 0x47: result = "Motor Sports";
                               break;
                    case 0x48: result = "Water Sports";
                               break;
                    case 0x49: result = "Winter Sports";
                               break;
                    case 0x4A: result = "Equestrian";
                               break;
                    case 0x4B: result = "Martial Sports";
                               break;
                    default:   result = "Sports";
                               break;
                }
                break;

        case 0x50:
                  switch (L1L2Nibbles)
                  {
                      case 0x50: result = "Children's - Youth programmes";
                                 break;
                      case 0x51: result = "Pre School - Children's programmes";
                                 break;
                      case 0x52: result = "Entertainment programmes for 6 to 14";
                                 break;
                      case 0x53: result = "Entertainment programmes for 10 to 16";
                                 break;
                      case 0x54: result = "Informational - Educational - School programmes";
                                 break;
                      case 0x55: result = "Cartoons - Puppets";
                                 break;
                      default  : result = "Children's - Youth programmes";
                                 break;
                  }
                  break;

        case 0x60:
                switch (L1L2Nibbles)
                {
                      case 0x60: result = "Music - Ballet - Dance";
                                 break;
                      case 0x61: result = "Rock - Pop";
                                 break;
                      case 0x62: result = "Serious Music - Classical Music";
                                 break;
                      case 0x63: result = "Folk - Traditionnal music";
                                 break;
                      case 0x64: result = "Jazz";
                                 break;
                      case 0x65: result = "Musical - Opera";
                                 break;
                      case 0x66: result = "Ballet";
                                 break;
                      default  : result = "Music - Ballet - Dance";
                                 break;
                 }
                 break;

        case 0x70:
                  switch ( L1L2Nibbles)
                  {
                      case 0x70: result = "Arts - Culture (without music)";
                                 break;
                      case 0x71: result = "Performing arts";
                                 break;
                      case 0x72: result = "Fine arts";
                                 break;
                      case 0x73: result = "Religion";
                                 break;
                      case 0x74: result = "Popular culture - Traditionnal arts";
                                 break;
                      case 0x75: result = "Litterature";
                                 break;
                      case 0x76: result = "Arts - Film - Cinema";
                                 break;
                      case 0x77: result = "Experimental film / video";
                                 break;
                      case 0x78: result = "Broadcasting - Press (Art)";
                                 break;
                      case 0x79: result = "New media";
                                 break;
                      case 0x7A: result = "Arts - Culture magazine";
                                 break;
                      case 0x7B: result = "Fashion";
                                 break;
                      default  : result = "Arts - Culture (without music)";
                                 break;
                  }
                  break;

        case 0x80:
                  switch (L1L2Nibbles)
                  {
                      case 0x80: result = "Social - Political issues - Economics";
                                 break;
                      case 0x81: result = "Magazines - Reports - Documentary";
                                 break;
                      case 0x82: result = "Economics - Social advisory";
                                 break;
                      case 0x83: result = "Remarkable people";
                                 break;
                      default  : result = "Social - Political issues - Economics";
                                 break;
                  }
                  break;

         case 0x90:
                  switch (L1L2Nibbles)
                  {
                     case 0x90: result = "Education - Science - Factual topics";
                                break;
                     case 0x91: result = "Nature - Animals - Environment";
                                break;
                     case 0x92: result = "Technology - Natural sciences";
                                break;
                     case 0x93: result = "Medicine - Physiology - Psychology";
                                break;
                     case 0x94: result = "Foreign countries - Expeditions";
                                break;
                     case 0x95: result = "Social - Spiritual sciences";
                                break;
                     case 0x96: result = "Further education";
                                break;
                     case 0x97: result = "Languages";
                                break;
                     default  : result = "Education - Science - Factual topics";
                                break;
                  }
                  break;

        case 0xA0:
                 switch(L1L2Nibbles)
                 {
                     case 0xA0 : result = "Leisure hobbies";
                                 break;
                     case 0xA1 : result = "Tourism - Travel";
                                 break;
                     case 0xA2 : result = "Handicraft (hobbies)";
                                 break;
                     case 0xA3 : result = "Motoring (hobbies)";
                                 break;
                     case 0xA4 : result = "Fitness & Health";
                                 break;
                     case 0xA5 : result = "Cooking";
                                 break;
                     case 0xA6 : result = "Advertissement - Shopping";
                                 break;
                     default   : result = "Leisure hobbies";
                                 break;
                 }
                 break;


        default : result = "reserved for future use";
                  break;
        }

    return result;

}


/*---------------------------------------------------------------------------------------------*/
/* Method       :   GetContentInt                                                              */
/* Description  :   parses the descriptor and retrieve Content Value (L1 and L2 nibbles)       */
/* Parameters   :   desc, a Descriptor object                                                  */
/* Return Value :   Value of  content descriptor                                               */
/*---------------------------------------------------------------------------------------------*/

public static int GetContentInt(Descriptor desc)
{
    if (desc.getTag() != DescriptorTag.CONTENT)
   {
        return 0;
   }

   byte[] Data = desc.getContent();

   int index = 0;

   int L1L2Nibbles =(int)(Data[index] & 0x0FF);

   return L1L2Nibbles;
}
// stp class members end
}
// stp class definition end

