// StP -- created on Fri Oct 09 09:23:20 1998 for sommitcc@kerne from system DVBSI


/***********************************************************************************
 * project Java for Sommit :                                                       *
 * API SI-EPG                                                                      *
 * Author : Jean-Philippe Barazeur                                                 *
 * CCETT  : 14/10/98                                                               *
 ***********************************************************************************/


/***********************************************************************************/
/*                                                                                 */
/*                          DescExtendedDescription                                */
/*                                                                                 */
/***********************************************************************************/

/*
DescContent implements a ExtendedDescription Descriptor ( see ETS 300-468 DVB - SI Spec)
It static method, GetDescription, parses the descriptor,
and retrieves information into a multi-line ( \n is the separator) String
*/
// import org.davic.net.dvb.si;
package sommit.APISiEpg;

import sommit.davic13.Descriptor;
import sommit.davic13.DescriptorTag;

class DescExtendedDescription
{
    private static String result;

/***********************************************************************************************/
/*                                       Methods                                               */
/***********************************************************************************************/

/*---------------------------------------------------------------------------------------------*/
/* Method       :   GetDescription                                                             */
/* Description  :   parses the descriptor and retrieve information into a string               */
/* Parameters   :   desc, a Descriptor object                                                  */
/* Return Value :   A String which contains information on Extended description descriptor     */
/*---------------------------------------------------------------------------------------------*/

public static String GetDescription(Descriptor desc)
{

    result = new String();

    if (desc.getTag() != DescriptorTag.EXTENDED_EVENT)
    {
        return null;
    }

    byte[] Data = desc.getContent();
    int index = 0;

    // first step extraction of Items, if necessary

    index = 4;
    byte length_of_items = Data[index];
    index++;
    byte item_description_length;
    byte item_length;
    byte car;

  try
  {
    if ( length_of_items > 0)
    {

      for (int i=0; i<length_of_items;)
      {

          String ItemDesc = new String();
          String ItemContent = new String();

          item_description_length = Data[index+i];

          for (int j=0; j<item_description_length;j++)
          {
            car = Data[index+1+i+j];
            char carac =(char)((0x00FF) & car);
            ItemDesc+= (char)carac;
          }

          ItemDesc += " : ";

          ItemDesc = DescExtendedDescription.ConvertString(ItemDesc);
          result+=ItemDesc;

          item_length = Data[index+1+i+item_description_length];

          for (int k=0; k<item_length; k++)
          {
            car = Data[index+2+i+item_description_length+k];
            char carac = (char)((0x00FF) & car);
            ItemContent+=(char)carac;
          }

          i +=item_description_length + item_length+2;
          ItemContent+="\n";
          ItemContent = DescExtendedDescription.ConvertString(ItemContent);
          result+=ItemContent;
      }
      index += length_of_items;
    }

    byte text_length = Data[index];

    String TextDesc = new String();

    for (int j=0; j<text_length;j++)
    {
        car = Data[index+1+j];
        char carac = (char)((0x00FF) & car);
        TextDesc+= (char)carac;
    }
    TextDesc = DescExtendedDescription.ConvertString(TextDesc);
    result+=TextDesc;
  }
  catch (ArrayIndexOutOfBoundsException e)
  {
  }

  return result;

}


/*---------------------------------------------------------------------------------------------*/
/* Method       :   ConvertString                                                              */
/* Description  :   parses a String, removes the Table Code Identifier and converts            */
/*                  Special codes (here for table 0x05)                                        */
/* Parameters   :   Source, String to parse                                                    */
/* Return Value :   A String without Table Code ID and with correct special chars              */
/*---------------------------------------------------------------------------------------------*/

private static String ConvertString(String Source)
   {
        String result = new String();

        if ((Source == null) || (Source.length() == 0))
        {
            return Source;
        }

        char Table = Source.charAt(0);

        char[] DataBrute = Source.toCharArray();

        if (Table == 05)
        {
             for (int i=0; i<DataBrute.length;i++)
             {
                   if (DataBrute[i] == 0x0E0)
                    {
                        DataBrute[i] = '';
                    }

                    if (DataBrute[i] == 0x0E2)
                    {
                        DataBrute[i] = '';
                    }

                    if (DataBrute[i] == 0x0E7)
                    {
                        DataBrute[i] = '';
                    }

                    if (DataBrute[i] == 0x0E8)
                    {
                        DataBrute[i] = '';
                    }

                    if (DataBrute[i] == 0x0E9)
                    {
                        DataBrute[i] = '';
                    }
                }

              }
              if ((Table >=0) && (Table<=5))
              {
                  result = String.valueOf(DataBrute,1,DataBrute.length-1);
              }
              else
              {
                  result = String.valueOf(DataBrute);
              }


        return result;
   }

// stp class members end
}
// stp class definition end

