// StP -- created on Fri Oct 09 09:23:20 1998 for sommitcc@kerne from system DVBSI


// stp class definition 103
/***********************************************************************************
 * project Java for Sommit :                                                       *
 * API SI-EPG                                                                      *
 * Author : Jean-Philippe Barazeur                                                 *
 * CCETT  : 14/10/98                                                               *
 ***********************************************************************************/


/***********************************************************************************/
/*                                                                                 */
/*                          DescParental                                           */
/*                                                                                 */
/***********************************************************************************/

/*
DescParental implements a Parental Rating Descriptor ( see ETS 300-468 DVB - SI Spec)
It static method, GetRating , parses the descriptor, an returns the minimum age for
the specified language
*/

// import org.davic.net.dvb.si;
package sommit.APISiEpg;

import sommit.davic13.Descriptor;
import sommit.davic13.DescriptorTag;

class DescParental
{
// stp class members
/***********************************************************************************************/
/*                                       Methods                                               */
/***********************************************************************************************/

/*---------------------------------------------------------------------------------------------*/
/* Method       :   GetRating                                                                  */
/* Description  :   parses the descriptor and retrieves the minimum age for the event          */
/* Parameters   :   desc, a Descriptor object                                                  */
/*                  Language , a 3 character string  which contains 639_Language code          */
/* Return Value :   the minimum age (int)                                                      */
/*---------------------------------------------------------------------------------------------*/

public static int GetRating(Descriptor desc, String Language)
{
    int result = 0;
    boolean hasCorrectLanguage = false;

    if (desc.getTag() != DescriptorTag.PARENTAL_RATING)
    {
        return result;
    }

    byte[] Data = desc.getContent();

    int descriptor_length = desc.getContentLength();
    int index = 0;

    while ((index<descriptor_length) && (hasCorrectLanguage == false))
    {
        String temp = new String();
        char car;
        for (int i=0;i<3;i++)
        {
           car = (char)Data[index+i];
           temp += car;
        }
        index +=3;

        if (temp.equalsIgnoreCase(Language))
        {
            result = Data[index];
            hasCorrectLanguage = true;
        }
        index++;
    }

    if ((result >0) && (result<0x10))
    {
        result+=3;
    }
    else
    {
        result = 0;
    }

    return result;

}

// stp class members end
}
// stp class definition end

