 /***********************************************************************************
 * project Java for Sommit :                                                       *
 * API SI-EPG                                                                      *
 * Author : Jean-Philippe Barazeur                                                 *
 * CCETT  : 14/10/98                                                               *
 ***********************************************************************************/


/***********************************************************************************/
/*                                                                                 */
/*                          DescService                                            */
/*                                                                                 */
/***********************************************************************************/

/*
DescService implements a Service Descriptor ( see ETS 300-468 DVB - SI Spec)
It static method, GetType , parses the descriptor, an returns the Service Type

*/
// import org.davic.net.dvb.si;

package sommit.APISiEpg;

import sommit.davic13.Descriptor;
import sommit.davic13.DescriptorTag;

class DescService
{
// stp class members
/***********************************************************************************************/
/*                                       Methods                                               */
/***********************************************************************************************/

public static int _type;
/*---------------------------------------------------------------------------------------------*/
/* Method       :   GetType                                                                    */
/* Description  :   parses the descriptor and retrieves information on Service Type            */
/* Parameters   :   desc, a Descriptor object                                                  */
/* Return Value :   A String which contains Service Type                                       */
/*---------------------------------------------------------------------------------------------*/


public static String GetType(Descriptor desc)
{

      String result;

      if (desc.getTag() != DescriptorTag.SERVICE)
      {
          DescService._type = -1;
          return null;
      }

      byte[] Data = desc.getContent();

      byte ServiceType = Data[0];

      DescService._type =(int)ServiceType;

      switch (ServiceType)
      {
          case 1 :result = "digital television service";
                  break;
          case 2 :result = "digital radio sound service";
                  break;
          case 3 :result = "teletext service";
                  break;
          case 4 :result = "NVOD reference service";
                  break;
          case 5 :result = "NVOD time-shifted service";
                  break;
          case 6 :result = "mosaic service";
                  break;
          case 7 :result = "PAL coded signal";
                  break;
          case 8 :result = "SECAM coded signal";
                  break;
          case 9 :result = "D/D2-MAC";
                  break;
          case 0x0A: result = "FM Radio";
                  break;
          default : result = "reserved for future use";
                  break;
      }

      if ((ServiceType>=0x0B) && (ServiceType<=0x0FE))
      {
          result = "user defined";
      }

      return result;
}



}