package org.davic.mpeg.dvb;
import  org.davic.mpeg.Service;
import  bali.component.ComponentMaster;
/**
 * This class represents one elementary stream within a transport stream
 * as used in DVB.
 * 
 * @version created for DAVIC 1.3.1
 */

public class DvbElementaryStream extends org.davic.mpeg.ElementaryStream
{
	public DvbElementaryStream( Service serv, int pid, int tag, Object cm )
	{   
	    super( serv, pid );
		// security exception when called from application.
		// cm should be the component master
		if ( cm != ComponentMaster.getInstance() )
		{
		    throw new SecurityException( "DvbTransportStream created by Application." );
		}
	    _tag = tag;
	}

	/**
	  * @return the DVB component tag of this elementary stream, or null 
	  * if none is present.
	  */

	public Integer getComponentTag()
	{
	  return new Integer (_tag);
	}
	
	private int _tag;
}
