/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  Module              : bali.si 
*  File name   $Logfile: /func_test_platf2/org/davic/mpeg/dvb/DvbTransportStream.java $
*       Last save $Date: 2003/12/24 00:53:09 $
*             $Revision: 1.1.1.1 $
*          Last $Author: mikeseven $
*  Creation Date       : 09/11/98
*  First Author        : S.A.F.A. van den Heuvel
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: DvbTransportStream.java,v $
* Revision 1.1.1.1  2003/12/24 00:53:09  mikeseven
* Initial release of the CVS repository for MPEG-4 Systems code
* after the code was corrupted due to reorganization and human 
* errors.
*
* Revision 1.1  2003/04/03 04:29:31  mikeseven
* Initial release of Player3D and MPEG-J for all MPEG-4 reference softwares players with samples.
* For installation, follow instructions in docs/Player3D_setup.doc.
*
* Many thanks to Prashanth Gujjeti and Viswanathan Swaminathan from Sun Microsystems.
*
* -- Mikael Bourges-Sevenier (Mindego)
*
* Revision 1.1  2002/08/23 16:47:27  pg138550
* Changes for MPEG-J. NOT FINAL
*
* Revision 1.1  2000/06/06 18:43:17  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:17:18  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.2  1999-04-02 14:15:07+02  vdheuvel
* *** empty log message ***
*
* Revision 1.1  1999-02-16 17:22:36+01  vdheuvel
* start of archive, 29 march 1999
* DAVIC API implementation
*
* 2     9-11-98 17:20 Vdheuvel
* Added source safe headers.
*/

package org.davic.mpeg.dvb;
import  bali.component.ComponentMaster;

/**
 * This class represents an MPEG-2 Transport Stream as used
 * in DVB with its  associated Service Information (SI) as 
 * known to a decoder.
 *
 * @version created for DAVIC 1.3.1
 */

public class DvbTransportStream extends org.davic.mpeg.TransportStream {


	public DvbTransportStream( int or_nw_id, int nw_id, int ts_id, Object cm )
	{
		super( or_nw_id, ts_id );
		// security exception when called from application.
		// cm should be the component master
		if ( cm != ComponentMaster.getInstance() )
		{
		    throw new SecurityException( "DvbTransportStream created by Application." );
		}
		_or_nw_id = or_nw_id;
		_nw_id    = nw_id;
	}

	/**
	  * @return the original_network_id of this transport stream.
	  */
	public int getOriginalNetworkId()
	{
	  return _or_nw_id;
	}

	/**
	  * @return the network_id of the network from which this MPEG-2 TS is accessed.
	  */
	public int getNetworkId()
	{
	  return _nw_id;
	}

    /**
      * Compare two Transport streams
      */
    public boolean equals( Object obj )
    {
        return (  super.equals( obj )
               && ((DvbTransportStream)obj)._or_nw_id == _or_nw_id 
               && ((DvbTransportStream)obj)._nw_id == _nw_id 
               );
    }

    ///////////// PRIVATE ///////////////
    private int _or_nw_id;
    private int _nw_id;
}

