/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  File name   $Logfile: /func_test_platf2/org/davic/net/dvb/si/DescriptorTag.java $
*       Last save $Date: 2003/12/24 00:53:09 $
*             $Revision: 1.1.1.1 $
*          Last $Author: mikeseven $
*  Creation Date       : 28/10/98
*  First Author        : S.A.F.A. van den Heuvel
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: DescriptorTag.java,v $
* Revision 1.1.1.1  2003/12/24 00:53:09  mikeseven
* Initial release of the CVS repository for MPEG-4 Systems code
* after the code was corrupted due to reorganization and human 
* errors.
*
* Revision 1.1  2003/04/03 04:29:31  mikeseven
* Initial release of Player3D and MPEG-J for all MPEG-4 reference softwares players with samples.
* For installation, follow instructions in docs/Player3D_setup.doc.
*
* Many thanks to Prashanth Gujjeti and Viswanathan Swaminathan from Sun Microsystems.
*
* -- Mikael Bourges-Sevenier (Mindego)
*
* Revision 1.1  2002/08/23 16:47:27  pg138550
* Changes for MPEG-J. NOT FINAL
*
* Revision 1.1  2000/06/06 18:43:18  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:17:20  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.1  1998-11-05 10:26:30+01  vdheuvel
* start of archive, 29 march 1999
* DAVIC API implementation
*
 * 
 * 1     9-11-98 14:01 Vdheuvel
 * Creation
*/

package org.davic.net.dvb.si;

/**
 * This interface defines constants corresponding to the most common descriptor tags.
 * @see Descriptor
 *
 * @since DAVIC1.3
*/

public interface DescriptorTag
{

public final static short NETWORK_NAME                = 0x40;
public final static short SERVICE_LIST                = 0x41;
public final static short STUFFING                    = 0x42;
public final static short SATELLITE_DELIVERY_SYSTEM   = 0x43;
public final static short CABLE_DELIVERY_SYSTEM       = 0x44;
public final static short BOUQUET_NAME                = 0x47;
public final static short SERVICE                     = 0x48;
public final static short COUNTRY_AVAILABILITY        = 0x49;
public final static short LINKAGE                     = 0x4A;
public final static short NVOD_REFERENCE              = 0x4B;
public final static short TIME_SHIFTED_SERVICE        = 0x4C;
public final static short SHORT_EVENT                 = 0x4D;
public final static short EXTENDED_EVENT              = 0x4E;
public final static short TIME_SHIFTED_EVENT          = 0x4F;
public final static short COMPONENT                   = 0x50;
public final static short MOSAIC                      = 0x51;
public final static short STREAM_IDENTIFIER           = 0x52;
public final static short CA_IDENTIFIER               = 0x53;
public final static short CONTENT                     = 0x54;
public final static short PARENTAL_RATING             = 0x55;
public final static short TELETEXT                    = 0x56;
public final static short TELEPHONE                   = 0x57;
public final static short LOCAL_TIME_OFFSET           = 0x58;
public final static short SUBTITLING                  = 0x59;
public final static short TERRESTRIAL_DELIVERY_SYSTEM = 0x5A;
public final static short MULTILINGUAL_NETWORK_NAME   = 0x5B;
public final static short MULTILINGUAL_BOUQUET_NAME   = 0x5C;
public final static short MULTILINGUAL_SERVICE_NAME   = 0x5D;
public final static short MULTILINGUAL_COMPONENT      = 0x5E;
public final static short PRIVATE_DATA_SPECIFIER      = 0x5F;
public final static short SERVICE_MOVE                = 0x60;
public final static short SHORT_SMOOTHING_BUFFER      = 0x61;
public final static short FREQUENCY_LIST              = 0x62;
public final static short PARTIAL_TRANSPORT_STREAM    = 0x63;
public final static short DATA_BROADCAST              = 0x64;

}
