package test;

/*import epg.Time;*/
/*import bali.sender.*;*/
//import bali.si.*;
/*import bali.stb_sim.*;*/
import bali.support.*;
import org.davic.mpeg.TransportStream;
import org.davic.net.dvb.si.*;
import java.util.Vector;
import java.awt.*;
import prl.mpeg.*;
import prl.tuning.*;
import bali.support.Debug;

class TMTest extends Frame implements Runnable {
    private SIService _services[];
    private static boolean ready = false;
    private static boolean instantiated = false;
    private static final Color white = new Color(255, 255, 255);
    /*  private static final Color black = new Color(0, 0, 0);*/
    private static final Color black = new Color(255, 0, 255);
    /*  private static final Color transp = new Color(0, 0, 1);*/
    /*  private static final Color transp = new Color(255, 0, 255);*/
    private static final Color transp = new Color(0, 0, 0);
    private static String[] displayText;
    private static int currentServiceNumber;
    
    /*******************
    */
    public static void main (String[] args) 
    {
      System.out.println("main");
//        Debug.setPrintThread( true );
//        Debug.setDbgLvl( Debug.SI, Debug.IMPL );
//        Debug.setDbgLvl( Debug.CACHE, Debug.MEDIUM );
//        Debug.setDbgLvl( Debug.TABLE, Debug.MEDIUM );
//        Debug.setDbgLvl( Debug.COMP, Debug.LOW );
//        Debug.setDbgLvl( Debug.RETRIEVE, Debug.HIGH );
//        Debug.setDbgLvl( Debug.RETRIEVE, Debug.IMPL );
//        Debug.setDbgLvl( Debug.HWSF, Debug.IMPL );
//        Debug.setDbgLvl( Debug.HWSF_LE, Debug.IMPL );
//        Debug.setDbgLvl( Debug.SUPPORT, Debug.MEDIUM );

        if(!instantiated) {
            instantiated = true;
            new TMTest();
        }
      }

    /*******************
    */
    public TMTest() {
        // Initialise display
        // mpeg demux doesn't start till AWT is initialised !!
        System.out.println("Start TM test with initialisation of the display.");
        setBounds(14, -26, 704, 576);
        setBackground(transp);
        show();
        requestFocus(); 
        System.out.println("Display initialised, demux started, start SI gathering");
        new Thread(this).start();
//        System.out.println("Display initialised, start StressTest");
//        StressTest.main( null );
    }

  
    /*******************
    */
    public void run() {
        /* prl.tuning only works if a TDA8044 tuner is connected */
        /* 
        ChannelSettings cs = new ChannelSettings();
        ChannelSettings scanCS[] = null;
        try {scanCS = Tuner.scan(); } catch (TunerException e) {
          System.out.println("scan exception");
        }
        System.out.println("found "+scanCS.length);
        for(int i = 1; i < scanCS.length; i++) {
          System.out.println("freq "+(scanCS[i]).kHz);
        }
        */
        /*
        cs.kHz = 11798000; 
        cs.symbolsPerSec = 27500000;
        cs.puncturingRates = ChannelSettings.PUNCT_3_4;
        cs.polarisation = ChannelSettings.HORIZONTAL_LINEAR;
        try {Thread.currentThread().sleep(1000);} catch(InterruptedException e) {}
        try {Tuner.tune(cs); } catch(TunerException e) {}
        */
        
        SIIterator iter;
        SINetwork nw;
        
        System.out.println("Thread started, filter SI");   
        try {
          nw = SIDatabase.getSIDatabase()[0].retrieveActualSINetwork( null );
        } catch (SIException e) {
          throw new Error( "TMTest: 1: " + e );
        }
        
        System.out.println("Network "+nw.getNetworkName());
        SITransportStream ts;
        try {
          iter = SIDatabase.getSIDatabase()[0].retrieveActualSIServices( null );
        } catch (SIException e) {
          throw new Error("TMTest: 3: " + e );
        }
        
        _services = new SIService[ iter.numberOfRemainingObjects() + 1 ];
        
        if ( !iter.hasMoreElements() ) {
          throw new Error("TMTest: no services");
        }
        
        SIService _siService;
        
        int i = 1;  // _services[0] is unused
        
        while (iter.hasMoreElements()) {
          _services[i++] = (SIService) iter.nextElement();
        }
        
        listServices();
        displayService( 1 );
        System.out.println("TMTest: Ready");
        ready = true;
    }

  public boolean keyDown(java.awt.Event evt, int key) {
    if (!ready)
      return true;

    System.out.print("keypressed :"+key);
    switch(key) {
			// numeric input
    case '0':
      System.out.println(" ---> Display services");
      listServices();
      return true;

    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
        currentServiceNumber = key - '0';
        System.out.println(" ---> Display service"+currentServiceNumber);
        displayService(key - '0');
        return true;
    case 1002: // p+
        currentServiceNumber ++;
        System.out.println(" ---> Display service"+currentServiceNumber);
        displayService(currentServiceNumber);
        return true;
    case 1003:  // p -
        currentServiceNumber --;
        System.out.println(" ---> Display service"+currentServiceNumber);
        displayService(currentServiceNumber);
        return true;

    default:
      return true;
    }
  }

  private void listServices() {
    for (int d = 1; d < _services.length; d++) {
/*      (new Thread(new EITthread(_services[d]))).start();*/
      System.out.println(_services[d].getServiceName());
    }
  }

  private void displayService(int nr) {
    SIIterator iter;
    int i = 1;
      
    if (nr < 1 || nr >= _services.length)
      return;

    SIService _siService = _services[ nr ];
    System.out.println("TMTest: Press 0 to see list of services or 1-9 for a specific service");

    PMTElementaryStream _ess[];
    SIEvent e1, e2;
		
    try {
      e1 = _siService.retrievePresentSIEvent( null );
    } catch (SIException e) { e1 = null;System.out.println("TMTest: "+e); }

    try {
      e2 = _siService.retrieveFollowingSIEvent( null );
    } catch (SIException e) { e2 = null;System.out.println("TMTest: "+e); }

    if (e1 != null) {
      System.out.println("TMTest: Present Event (" + i + ") " + e1.getURL() + " start time = " + e1.getStartTime().toString()+ " name = " + e1.getEventName() + " description = " + e1.getShortDescription() + " theme = 0x" + Integer.toHexString( (e1.getContentNibbles()[0] >> 4) & 0x0f ) + "" + Integer.toHexString( e1.getContentNibbles()[0] & 0x0f ) );
      if(e1.getFreeCAMode()) System.out.println("scrambled");
      else System.out.println("unscrambled");
    } else {
      System.out.println("TMTest: No present event");
    }

    if (e2 != null) {
      System.out.println("TMTest: Following Event " + e2.getURL() + " start time = " + e2.getStartTime().toString() + " name = " + e2.getEventName() + " description = " + e2.getShortDescription() + " theme = 0x" + Integer.toHexString( (e2.getContentNibbles()[0] >> 4) & 0x0f ) + "" + Integer.toHexString( e2.getContentNibbles()[0] & 0x0f ) );
    } else {
      System.out.println("TMTest: No following event");
    }
    try {
      iter = _siService.retrievePMTElementaryStreams( null );
    } catch (SIException e) { iter = null;System.out.println("TMTest: "+e); }
    
    if (iter != null) {
      i = 1;
      int n;
      PMTElementaryStream pe;
      String type, peString;
      _ess = new PMTElementaryStream[ iter.numberOfRemainingObjects() + 2 ];

      while (iter.hasMoreElements()) {
	pe = (PMTElementaryStream) iter.nextElement();
	n = pe.getStreamType();
	if ( n == 2 || n==1) {
	  type = "video [streamtype "+n+"]";
	  prl.mpeg.Player.setVideoPID(pe.getElementaryPID());
	}
	else if (n == 3 || n == 4) {
	  type = "audio [streamtype "+n+"]";
	  prl.mpeg.Player.setAudioPID(pe.getElementaryPID());
	}
	else
	  type = "other [streamtype "+n+"]";

	_ess[i++] = pe;

	peString = "TMTest: PMTElementaryStream (" + i + ") " + pe.getURL() + " type = " + type  + " PID = " + pe.getElementaryPID();
	System.out.println( peString );
      }
    } else {
      System.out.println("TMTest: no PMTElementaryStreams");
    }
    System.out.println("TMTest: Service info done!");
  }

///////////////////////////////////////////////////////////////////////////////////////////

  public void paint(Graphics g) {
    blackBox(g);
    g.setFont(new Font("Arial", Font.PLAIN, 16));
  }

//////////////////////// Methods adapted from TVState class (EPG) /////////////////////////

  private void blackBox(Graphics g) {
    g.setColor(black);
    g.fillRect(16, 47, 640, 480);
  }
}

class EITthread extends Thread {
  SIService service;
  public EITthread(SIService s) {
    service = s;
  }

  public void run() {
    
    try {
      SIEvent event = service.retrievePresentSIEvent( null );
      System.out.println(service.getServiceName());
      System.out.println(event.getStartTime().toString()+": "+
			 event.getEventName()+": "+
			 event.getShortDescription());
    } catch (SIException e) { }
  }
}
