package test;
import bali.testframe.local_sommit.Server;
import bali.testframe.sender.MultiRepeater;
import bali.support.Debug;
import org.davic.net.tuning.*;
import org.davic.mpeg.*;
import org.davic.mpeg.dvb.*;
/*DATE_NORMAL*/ import  java.util.Date;
//DATE_TM*/     import  bali.tm.Date;
import test.stream6.StartStream;

/***************************
*/
public class TestComponentAPI
{
    public static void main( String args[] )
	{

        StartStream.start();
        doPrint = true;
//        Debug.setDbgLvl( Debug.MPEG, Debug.LOW );
//        Debug.setDbgLvl( Debug.SI, Debug.IMPL );
//        Debug.setDbgLvl( Debug.COMP, Debug.LOW );
//        Debug.setDbgLvl( Debug.RETRIEVE, Debug.HIGH );
//        Debug.setDbgLvl( Debug.RETRIEVE, Debug.IMPL );
//        Debug.setDbgLvl( Debug.RETRIEVE, Debug.MEDIUM );
//        Debug.setDbgLvl( Debug.MONITOR, Debug.MEDIUM );
//        Debug.setDbgLvl( Debug.TUNING, Debug.MEDIUM );
//        Debug.setDbgLvl( Debug.TABLE, Debug.HIGH );
//        Debug.setDbgLvl( Debug.MONITOR, Debug.MEDIUM );
//        Debug.setDbgLvl( Debug.CACHE, Debug.IMPL );
//        Debug.setDbgLvl( Debug.RETRIEVE, Debug.LOW );
//        Debug.setDbgLvl( Debug.HWSF, Debug.LOW );
//        Debug.setDbgLvl( Debug.SUPPORT, Debug.IMPL );
        Debug.setPrintThread( true );
		/////////////////////////
        doTest();
        doTest();
    }
    
    public static void doTest()
    {
        println("Start component API test");
        {
            NetworkInterfaceManager nim = NetworkInterfaceManager.getInstance();
            NetworkInterface[] arNi = nim.getNetworkInterfaces();
            for ( int i=0; i<arNi.length; i++)
            {
                println("========================================================");
                println("Current TS");
                printTransportStream( arNi[i].getCurrentTransportStream() );
                println("--------------------------------------------------------");
                TransportStream[] arTs = arNi[i].listAccessibleTransportStreams();
                for ( int j=0; j< arTs.length; j++ )
                {
                    printTransportStream( arTs[j] );
                }
            }
        }
    }
   
    static void printTransportStream( TransportStream ts )
    {
        if ( ts instanceof DvbTransportStream )
        {   DvbTransportStream dvbts = (DvbTransportStream)ts;
            println("   Dvb Transport Stream : or_nw_id "+dvbts.getOriginalNetworkId()+" nw_id "+dvbts.getNetworkId()+" ts_id "+dvbts.getTransportStreamId() );
        }
        else
        {
            println("   Transport Stream : ts_id "+ts.getTransportStreamId() );
        }
    
        Service[] arServ = ts.retrieveServices();
        for ( int i=0; i< arServ.length; i++ )
        {
            printService( arServ[i] );
        }
    }

    static void printService( Service service )
    {
        println( "Service : "+ service.getServiceId() );
        ElementaryStream[] arES = service.retrieveElementaryStreams();
        if ( arES != null )
        {
            for ( int i=0; i< arES.length; i++ )
            {
                printElementaryStream( arES[i] );
            }
        }
    }
   
    static void printElementaryStream( ElementaryStream es )
    {
        if ( es instanceof DvbElementaryStream )
        {   DvbElementaryStream dvbes = (DvbElementaryStream)es;
            println("   Dvb ElementaryStream : comp_tag "+dvbes.getComponentTag()+" Ass_tag: "+dvbes.getAssociationTag()+" PID :"+dvbes.getPID() );
        }
        else
        {
            println("   Dvb ElementaryStream :  Ass_tag: "+es.getAssociationTag()+" PID :"+es.getPID() );
        }
    }
   
   
   
   static boolean doPrint = false;
   static void println( String str )
   {
        if ( doPrint )
            System.out.println( str );
   }
}


