package test;
import bali.testframe.sender.MultiRepeater;
import bali.support.Debug;
import org.davic.net.dvb.si.*;
/*DATE_NORMAL*/ import  java.util.Date;
//DATE_TM*/     import  bali.tm.Date;
import test.stream1.StartStream;

/***************************
*/
public class TestSIDatabase
    implements SIEventListener
{
    public static void main( String args[] )
	{
        StartStream.start();
//        Debug.setPrintThread( true );
        doPrint = true;
//        Debug.setDbgLvl( Debug.CACHE, Debug.IMPL );
//        Debug.setDbgLvl( Debug.TABLE, Debug.IMPL );
//        Debug.setDbgLvl( Debug.SI, Debug.IMPL );
//        Debug.setDbgLvl( Debug.COMP, Debug.LOW );
//        Debug.setDbgLvl( Debug.RETRIEVE, Debug.HIGH );
//        Debug.setDbgLvl( Debug.RETRIEVE, Debug.MEDIUM );
//        Debug.setDbgLvl( Debug.RETRIEVE, Debug.LOW );
//        Debug.setDbgLvl( Debug.RETRIEVE, Debug.IMPL );
//        Debug.setDbgLvl( Debug.HWSF, Debug.LOW );
//        Debug.setDbgLvl( Debug.SUPPORT, Debug.IMPL );
		/////////////////////////
        doTest();
    }
    
    public static void doTest()
	{
        println("Start test");
        {
            testNitMonitor();
            testSdtMonitor( 2 );
            testNetwork();
            testService();
            testPresentFollowingEvent( 1 );
            testTime();
            testEITsch( 1 );
            for ( int i=0; i<20; i++ )
            {   
                testPresentFollowingEvent( i );
            }
        }
   }
   
   static void testNitMonitor()
   {
        println("Start Nit Monitor test");
    
        SIDatabase sid = SIDatabase.getSIDatabase()[0];
        try
        {
            SIIterator it;
            println("================================" );
            SINetwork nw = sid.retrieveActualSINetwork( null );
            printNetwork( nw );
            
            nw.addListener( new TestSIDatabase() );
            nw.addListener( new TestSIDatabase() );
            nw.removeListener( new TestSIDatabase() );
            nw.removeListener( new TestSIDatabase() );
            nw.addListener( new TestSIDatabase() );
        }
        catch( RetrieveFailedException e )
        {
            println("Exception " + e );
        }   
   }

   static void testSdtMonitor( int sno)
   {
        println("Start Sdt Monitor test");
    
        SIDatabase sid = SIDatabase.getSIDatabase()[0];
        try
        {
            SITransportStream ts = getCurrentTS();
            SIIterator it;
            println("================================" );
            println("Filter service "+sno);
            it = sid.retrieveSIServices( ts.getOriginalNetworkId(), ts.getTransportStreamId(), sno, null );
            SIService s = (SIService)it.nextElement();
            printService( s );
            
            s.addListener( new TestSIDatabase() );
        }
        catch( RetrieveFailedException e )
        {
            println("Exception " + e );
        }   
   }

   static void testEITsch( int sno)
   {
        println("Start EIT schedule test");
        SIDatabase sid = SIDatabase.getSIDatabase()[0];
        try
        {
            SITransportStream ts = getCurrentTS();
            SIIterator it;
            SITime time;            
            time = sid.retrieveSITimeFromTDT( );
            println("TDT filtered" );
            println(" TS time: "+time.getUTCTime() );
            Date now = time.getUTCTime();

            println("================================" );
            println("Filter service "+sno);
            it = sid.retrieveSIServices( ts.getOriginalNetworkId(), ts.getTransportStreamId(), sno, null );
            SIService s = (SIService)it.nextElement();
            
            ///////////////////////////////
            Date start = new Date( now.getTime() - 5*(60*60*1000) );
//            Date start = new Date( now.getTime() + 4*(60*60*1000) );
            Date end   = new Date( now.getTime() + 5*(60*60*1000) );
//            Date end   = new Date( now.getTime() + 5*(60*60*1000) );
//            Date end   = new Date( now.getTime() + 4*60*1000 );
            println("================================" );
            println("Filter eit schedule");
            println("  start time "+start);
            println("  end time   "+end);
            it = s.retrieveScheduledSIEvents( null, start, end );
            println("Filtered events");
            while ( it.hasMoreElements() )
            {
                printEvent( (SIEvent)it.nextElement() );
            }

            ///////////////////////////////
            start = new Date( now.getTime() - 5*(60*60*1000) );
            end   = new Date( now.getTime() + 300*(60*60*1000) );
            println("================================" );
            println("Filter eit schedule");
            println("  start time "+start);
            println("  end time   "+end);
            it = s.retrieveScheduledSIEvents( null, start, end );
            println("Filtered events");
            while ( it.hasMoreElements() )
            {
                printEvent( (SIEvent)it.nextElement() );
            }
        }
        catch( SIException e )
        {
            println("Exception " + e );
        }
        
        System.err.println("Ready "  );
           
   }
   
   static void testNetwork()
   {
        println("Start Network test");
        SIDatabase sid = SIDatabase.getSIDatabase()[0];
        try
        {
            SIIterator it;
            println("================================" );
            SINetwork nw = sid.retrieveActualSINetwork( null );
            printNetwork( nw );
            
            println("================================" );
            it = sid.retrieveSINetworks( nw.getNetworkId(), null );
            while( it.hasMoreElements() )
            {   println("----------------------------" );
                printNetwork( (SINetwork)it.nextElement() );
            }
            
            println("================================" );
            it = sid.retrieveSINetworks( -1, null );
            while( it.hasMoreElements() )
            {   println("----------------------------" );
                printNetwork( (SINetwork)it.nextElement() );
            }
     }
        catch( RetrieveFailedException e )
        {
            println("Exception " + e );
        }   
   }

   static void testPresentFollowingEvent( int sno )
   {
        println("Start Network test");
        SIDatabase sid = SIDatabase.getSIDatabase()[0];
        try
        {
            SITransportStream ts = getCurrentTS();
            SIIterator it;
            println("================================" );
            println("Filter service "+sno);
            it = sid.retrieveSIServices( ts.getOriginalNetworkId(), ts.getTransportStreamId(), sno, null );
            SIService s = (SIService)it.nextElement();
            println("================================" );
            println("Service "+sno+": present event:");
            printEvent( s.retrievePresentSIEvent( null ) );
            println("================================" );
            println("Service "+sno+": following event:");
            printEvent( s.retrieveFollowingSIEvent( null ) );
            println("================================" );
            println("Access Service "+sno+":pmt");
            it = s.retrievePMTElementaryStreams( null );
            while( it.hasMoreElements() )
            {   
                println("================================" );
                printES ( (PMTElementaryStream)it.nextElement() );
            }
            
        }
        catch( RetrieveFailedException e )
        {
            println("Exception " + e );
        }   
   }

   static void testTime()
   {
        println("Start Time test");
        SIDatabase sid = SIDatabase.getSIDatabase()[0];
        try
        {
            SIIterator it;
            println("================================" );
            SITime time;            
            time = sid.retrieveSITimeFromTDT( );
            println("TDT filtered" );
            println("  time: "+time.getUTCTime() );
            println("================================" );
            sid.retrieveSITimeFromTOT(null);
            println("TOT filtered" );
            println("  time: "+time.getUTCTime() );
        }
        catch( RetrieveFailedException e )
        {
            println("Exception " + e );
        }   
   }

   static void testService()
   {
        println("Start Network test");
        SIDatabase sid = SIDatabase.getSIDatabase()[0];
        try
        {
            SIIterator it;
            println("================================" );
            it = sid.retrieveActualSIServices( null );
            while( it.hasMoreElements() )
            {   println("----------------------------" );
                printService( (SIService)it.nextElement() );
            }

            println("================================" );
            it = sid.retrieveSIServices( -1,-1,-1,null );
            while( it.hasMoreElements() )
            {   println("----------------------------" );
                printService( (SIService)it.nextElement() );
            }

        }
        catch( RetrieveFailedException e )
        {
            println("Exception " + e );
        }   
   }
   
   static SITransportStream getCurrentTS()
   {
        SITransportStream ret=null;
        try
        {
            ret = SIDatabase.getSIDatabase()[0].retrieveActualSITransportStream( null );
        }
        catch( RetrieveFailedException e )
        {
            println("Exception " + e );
        }   
        
        return ret;
   }

   static void printService( SIService s )
   {
        println(">> Service:  "+s.getURL() );
        println(">> Name:     "+s.getServiceName() );
        println(">> Name:     "+s.getServiceProviderName() );
   }

   static void printNetwork( SINetwork nw )
   {
        println(">> Network:  "+nw.getNetworkId() );
        println(">> Name:     "+nw.getNetworkName() );
        
   }

   static void printEvent( SIEvent ev )
   {
        println(">> Event :   "+ev.getURL() );
        println(">> Name:     "+ev.getEventName() );
        println(">> Descript: "+ev.getShortDescription() );
        println(">> Start:    "+ev.getStartTime() );
        println(">> Duration: "+ev.getDuration() );
        println(">> End:      "+new Date( ev.getStartTime().getTime() +ev.getDuration() ) );
        
   }

   static void printES( PMTElementaryStream es )
   {
        println(">> ES :          "+es.getURL() );
        println(">> StreamType:   "+es.getStreamType() );
        println(">> PID:          "+es.getElementaryPID() );
   }

   static boolean doPrint = false;
   static void println( String str )
   {
        if ( doPrint )
            System.out.println( str );
   }


   public void post(SIEventObject anEvent)   
   {
        println(">>>>  new SIEventObject ");
        println(">> source      : "+anEvent.getSource() );
        println(">> type        : "+anEvent.getType() );
        println(">> running stat: "+anEvent.getRunningStatus() );
    }
}


