package test;
import bali.testframe.local_sommit.Server;
import bali.testframe.sender.MultiRepeater;
import bali.support.Debug;
import org.davic.net.dvb.si.*;
/*DATE_NORMAL*/ import  java.util.Date;
//DATE_TM*/     import  bali.tm.Date;
//import test.sommit5.StartStream;
import test.stream6.StartStream;

/***************************
*/
public class TestSIDatabaseSommit
{
    public static void main( String args[] )
	{

        StartStream.start();

        doPrint = true;
//        Debug.setDbgLvl( Debug.TABLE, Debug.LOW );
        Debug.setDbgLvl( Debug.SI, Debug.MEDIUM );
//        Debug.setDbgLvl( Debug.COMP, Debug.LOW );
        Debug.setDbgLvl( Debug.RETRIEVE, Debug.HIGH );
  //      Debug.setDbgLvl( Debug.SOMSF, Debug.LOW );
//        Debug.setDbgLvl( Debug.RETRIEVE, Debug.MEDIUM );
//        Debug.setDbgLvl( Debug.RETRIEVE, Debug.LOW );
//        Debug.setDbgLvl( Debug.HWSF, Debug.LOW );
//        Debug.setDbgLvl( Debug.HWSF, Debug.IMPL );
//        Debug.setDbgLvl( Debug.SUPPORT, Debug.IMPL );
		/////////////////////////

        println("Start test");
        SIDatabase sid = SIDatabase.getSIDatabase()[0];
        try
        {
            SIIterator it;
            println("================================" );
            SINetwork nw = sid.retrieveActualSINetwork( null );
            printNetwork( nw );

            println("================================" );
            it = sid.retrieveActualSIServices( null );
            while( it.hasMoreElements() )
            {   println("----------------------------" );
                SIService s = (SIService)it.nextElement();
                testPresentFollowingEvent( s.getOriginalNetworkId(), s.getTransportStreamId(), s.getServiceId() );
            }

            println("================================" );
            SITime time;            
            time = sid.retrieveSITimeFromTDT( );
            println("TDT filtered" );
            println("  time: "+time.getUTCTime() );
       }
        catch( RetrieveFailedException e )
        {
            println("Exception " + e );
        }   
    }

   static void testPresentFollowingEvent( int or_nw_id, int ts_id, int sno )
   {
        println("Start Network test");
        SIIterator it;
        SIService s = null;
        SIDatabase sid = SIDatabase.getSIDatabase()[0];
        try
        {
            println("================================" );
            println("Filter service "+sno);
            it = sid.retrieveSIServices( or_nw_id, ts_id, sno, null );
            s = (SIService)it.nextElement();
            println("================================" );
            println("Service "+sno+": present event:");
            printEvent( s.retrievePresentSIEvent( null ) );
            println("================================" );
            println("Service "+sno+": following event:");
            printEvent( s.retrieveFollowingSIEvent( null ) );
        }
        catch( RetrieveFailedException e )
        {
            println("Exception " + e );
        }   
        try
        {
            println("================================" );
            println("Access Service "+sno+":pmt");
            it = s.retrievePMTElementaryStreams( null );
            while( it.hasMoreElements() )
            {   
                println("================================" );
                printES ( (PMTElementaryStream)it.nextElement() );
            }
            
        }
        catch( RetrieveFailedException e )
        {
            println("Exception " + e );
        }   
   }

   static void testTime()
   {
        println("Start Time test");
        SIDatabase sid = SIDatabase.getSIDatabase()[0];
        try
        {
            SIIterator it;
            println("================================" );
            SITime time;            
            time = sid.retrieveSITimeFromTDT( );
            println("TDT filtered" );
            println("  time: "+time.getUTCTime() );
            println("================================" );
            sid.retrieveSITimeFromTOT(null);
            println("TOT filtered" );
            println("  time: "+time.getUTCTime() );
        }
        catch( RetrieveFailedException e )
        {
            println("Exception " + e );
        }   
   }

   

   static void printService( SIService s )
   {
        println(">> Service:  "+s.getURL() );
        println(">> Name:     "+s.getServiceName() );
        println(">> Name:     "+s.getServiceProviderName() );
   }

   static void printNetwork( SINetwork nw )
   {
        println(">> Network:  "+nw.getNetworkId() );
        println(">> Name:     "+nw.getNetworkName() );
        
   }

   static void printEvent( SIEvent ev )
   {
        println(">> Event :   "+ev.getURL() );
        println(">> Name:     "+ev.getEventName() );
        println(">> Descript: "+ev.getShortDescription() );
        println(">> Start:    "+ev.getStartTime() );
        println(">> Duration: "+ev.getDuration() );
        println(">> End:      "+new Date( ev.getStartTime().getTime() +ev.getDuration() ) );
        ev.getContentNibbles();
        ev.getLevel1ContentNibbles();        
   }

   static void printES( PMTElementaryStream es )
   {
        println(">> ES :          "+es.getURL() );
        println(">> StreamType:   "+es.getStreamType() );
        println(">> PID:          "+es.getElementaryPID() );
   }

    
   static boolean doPrint = false;
   static void println( String str )
   {
        if ( doPrint )
            System.out.println( str );
   }
}


