/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  File name   $Logfile: $
*       Last save $Date: 2003/12/24 00:53:13 $
*             $Revision: 1.1.1.1 $
*          Last $Author: mikeseven $
*  Creation Date       : 23-04-1999
*  First Author        : S.A.F.A. van den Heuvel
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
* $Log: DescriptorUI.java,v $
* Revision 1.1.1.1  2003/12/24 00:53:13  mikeseven
* Initial release of the CVS repository for MPEG-4 Systems code
* after the code was corrupted due to reorganization and human 
* errors.
*
* Revision 1.1  2003/04/03 04:29:39  mikeseven
* Initial release of Player3D and MPEG-J for all MPEG-4 reference softwares players with samples.
* For installation, follow instructions in docs/Player3D_setup.doc.
*
* Many thanks to Prashanth Gujjeti and Viswanathan Swaminathan from Sun Microsystems.
*
* -- Mikael Bourges-Sevenier (Mindego)
*
* Revision 1.1  2002/08/23 16:47:31  pg138550
* Changes for MPEG-J. NOT FINAL
*
* Revision 1.2  2000/07/21 20:39:02  alavilli
* adding missing files in the previous checkin for SISF
*
* Revision 1.1.2.1  1999/07/09 14:27:28  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.3  1999-04-23 16:56:37+02  vdheuvel
* Debug of errors due to FTP2 hook-up.
* Added new functionality:
*   - display of strings
*   - diplay of descriptor contents
*   - optimised filter order
*
*/

package test_awt;

import java.awt.*;
import org.davic.net.dvb.si.*;

public class DescriptorUI extends Panel {
	public List _dList;
	public Button exit;
	public Frame frame;

	public DescriptorUI( Descriptor d ) {
	    _d = d;

		setLayout(new FlowLayout());
        
        int i=0; int b; char c;
        String hexData = new String();
        String charData = new String();
        for ( i=0; i< _d.getContentLength()+2; i++ )
        {   b = ((int) _d.getByteAt(i)) & 0x00ff;
            hexData  += Integer.toHexString(b)+" ";
            c = (char)_d.getByteAt(i);
            charData += ( (Character.isUnicodeIdentifierPart(c) & !Character.isIdentifierIgnorable(c) ) 
                        ? c : '#' 
                        );
        }
		exit = new Button("Exit");
        add( exit);
		validate();

		frame = new Frame("Descriptor Tag : "+_d.getTag()+ ", Length : "+_d.getContentLength() ) ;
		frame.setLayout(new BorderLayout());
		frame.add("East",this);
		frame.add("North", new TextArea(hexData,1,40,TextArea.SCROLLBARS_HORIZONTAL_ONLY) );
		frame.add("South", new TextArea(charData,1,40,TextArea.SCROLLBARS_HORIZONTAL_ONLY) );


		frame.pack();
		frame.show();

		updateAll();
	}

	public void updateAll() {
		validate();
	}

	public boolean handleEvent(Event e) {
		if (e.target == exit) {
			if (e.id == Event.ACTION_EVENT) {
				frame.dispose();
				frame = null;
			}
		} 
		return super.handleEvent(e);
	}

	private Descriptor _d;
}
