/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  File name   $Logfile: $
*       Last save $Date: 2003/12/24 00:53:13 $
*             $Revision: 1.1.1.1 $
*          Last $Author: mikeseven $
*  Creation Date       : early 1998
*  First Author        : H. v. Woerkom
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
* $Log: SIEventUI.java,v $
* Revision 1.1.1.1  2003/12/24 00:53:13  mikeseven
* Initial release of the CVS repository for MPEG-4 Systems code
* after the code was corrupted due to reorganization and human 
* errors.
*
* Revision 1.1  2003/04/03 04:29:39  mikeseven
* Initial release of Player3D and MPEG-J for all MPEG-4 reference softwares players with samples.
* For installation, follow instructions in docs/Player3D_setup.doc.
*
* Many thanks to Prashanth Gujjeti and Viswanathan Swaminathan from Sun Microsystems.
*
* -- Mikael Bourges-Sevenier (Mindego)
*
* Revision 1.1  2002/08/23 16:47:34  pg138550
* Changes for MPEG-J. NOT FINAL
*
* Revision 1.2  2000/07/21 20:39:01  alavilli
* adding missing files in the previous checkin for SISF
*
* Revision 1.1.2.1  1999/07/09 14:27:30  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.3  1999-04-23 13:55:17+02  vdheuvel
* Debug of errors due to FTP2 hook-up.
* Added new functionality:
*   - display of strings
*   - diplay of descriptor contents
*   - optimised filter order
*
* Revision 1.2  1999-04-23 10:52:47+02  vdheuvel
* Adapted to the new ftp.
*
*
*/

package test_awt;

import java.awt.*;
import org.davic.net.dvb.si.*;

public class SIEventUI extends Panel {
	public Button exit;
	public Button refresh;
	public Button descriptors;
	public Frame frame;

	public SIEventUI( SIEvent e ) {
		_siEvent = e;

		setLayout(new FlowLayout());


		descriptors = new Button("Descriptors");
		add(descriptors);

		refresh = new Button("Refresh");
		add(refresh);

		exit = new Button("Exit");
		add(exit);

		validate();

		frame = new Frame("SIEvent " + _siEvent.getOriginalNetworkId() + ", " + _siEvent.getTransportStreamId() +
				", " + _siEvent.getServiceId() + ", " + _siEvent.getEventId() );
		frame.setLayout(new BorderLayout());
		frame.add("South",this);

	    _evName = new Label("Name : "+e.getEventName() );
        _evDescription = new Label("Description : "+e.getShortDescription() );
		frame.add( "North", _evName );
		frame.add( "West", _evDescription );

		frame.pack();
		frame.show();

		updateAll();
	}

	public void updateAll() {
		validate();
	}

	public boolean handleEvent(Event e) {
		if (e.target == exit) {
			if (e.id == Event.ACTION_EVENT) {
				frame.dispose();
				frame = null;
			}
		} else if (e.target == refresh) {
			if (e.id == Event.ACTION_EVENT) {
				updateAll();
			}
		} else if (e.target == descriptors) {
			if (e.id == Event.ACTION_EVENT) {
				try {
					new DescriptorListUI( frame.getTitle(), _siEvent.retrieveDescriptors() );
				} catch (SIException ex) {
				}
			}
		}
		return super.handleEvent(e);
	}

	private SIEvent _siEvent;
	private Label   _evName;
	private Label   _evDescription;
}
