/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  File name   $Logfile: $
*       Last save $Date: 2003/12/24 00:53:13 $
*             $Revision: 1.1.1.1 $
*          Last $Author: mikeseven $
*  Creation Date       : early 1998
*  First Author        : H. v. Woerkom
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
* $Log: SIServiceUI.java,v $
* Revision 1.1.1.1  2003/12/24 00:53:13  mikeseven
* Initial release of the CVS repository for MPEG-4 Systems code
* after the code was corrupted due to reorganization and human 
* errors.
*
* Revision 1.1  2003/04/03 04:29:40  mikeseven
* Initial release of Player3D and MPEG-J for all MPEG-4 reference softwares players with samples.
* For installation, follow instructions in docs/Player3D_setup.doc.
*
* Many thanks to Prashanth Gujjeti and Viswanathan Swaminathan from Sun Microsystems.
*
* -- Mikael Bourges-Sevenier (Mindego)
*
* Revision 1.1  2002/08/23 16:47:34  pg138550
* Changes for MPEG-J. NOT FINAL
*
* Revision 1.2  2000/07/21 20:39:01  alavilli
* adding missing files in the previous checkin for SISF
*
* Revision 1.1.2.1  1999/07/09 14:27:30  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.4  1999-04-23 19:08:33+02  vdheuvel
* *** empty log message ***
*
* Revision 1.3  1999-04-23 17:29:57+02  vdheuvel
* Debug of errors due to FTP2 hook-up.
* Added new functionality:
*   - display of strings
*   - diplay of descriptor contents
*   - optimised filter order
*
* Revision 1.2  1999-04-23 10:52:21+02  vdheuvel
* Adapted to the new ftp.
*
*
*/

package test_awt;

import java.awt.*;
import org.davic.net.dvb.si.*;
/*DATE_NORMAL*/ import  java.util.Date;
//DATE_TM*/     import  bali.tm.Date;

public class SIServiceUI extends Panel {
	public List _eventList;
	public List _esList;
	public Button exit;
	public Button refresh;
	public Button descriptors;
	public Button pmtDescriptors;
	public Frame frame;

	public SIServiceUI( SIService s ) {
		_siService = s;

		setLayout(new FlowLayout());

		add(new Label("Events"));
		_eventList = new MyList(7,false,250);
		add(_eventList);

		add(new Label("Elementary streams"));
		_esList = new MyList(7,false,250);
		add(_esList);

		pmtDescriptors = new Button("PMT Descriptors");
		add(pmtDescriptors);

		descriptors = new Button("Descriptors");
		add(descriptors);

		refresh = new Button("Refresh");
		add(refresh);

		exit = new Button("Exit");
		add(exit);

		validate();

		frame = new Frame("SIService " + _siService.getOriginalNetworkId() + ", " + _siService.getTransportStreamId() +
				", " + _siService.getServiceId() );
		frame.setLayout(new BorderLayout());
		frame.add("South",this);
		
	    _servName = new Label( "Name : "+s.getServiceName() );
	    _servProviderName  = new Label( "Provider Name : "+s.getServiceProviderName() );
    	frame.add( "West", _servName );
		frame.add( "Center", _servProviderName );

		
		frame.pack();
		frame.show();

        updatePmt();
        updatePfEventsOnly();
		updateAllEvents();
	}

	public void updateAll() {
        updatePmt();
		updateAllEvents();
		validate();
	}

	public void updatePfEventsOnly() {
		SIEvent e1, e2;
		int i = 0;
		
		try {
            /*DBG*/System.out.println("access EIT present");		
			e1 = _siService.retrievePresentSIEvent( null );
		} catch (SIException e) { e1 = null; }
		try {
            /*DBG*/System.out.println("access EIT following");		
			e2 = _siService.retrieveFollowingSIEvent( null );
		} catch (SIException e) { e2 = null; }

		_eventList.removeAll();
		_events = new SIEvent[(e1 == null ? 0 : 1) + (e2 == null ? 0 : 1) ];

		i = 0;

		if (e1 != null) {
			_events[i++] = e1;
			_eventList.addItem("Present Event " + e1.getEventId() );
		}
		if (e2 != null) {
			_events[i++] = e2;
			_eventList.addItem("Following Event " + e2.getEventId() );
		}
		validate();
	}

	public void updatePmt() {
		SIIterator iter;
		int i = 0;
		
		try {
			iter = _siService.retrievePMTElementaryStreams( null );
		} catch (SIException e) { iter = null; }

		if (iter != null) {
            /*DBG*/System.out.println("-----------------------iter != null ");		
			_ess = new PMTElementaryStream[iter.numberOfRemainingObjects()];
			while (iter.hasMoreElements()) {
                /*DBG*/System.out.println("-----------------------ES detected ");		
				PMTElementaryStream pe = (PMTElementaryStream) iter.nextElement();
				
				_ess[i++] = pe;
				_esList.addItem("Elementary stream " + pe.getURL() );
			}
		} else {
			_ess = new PMTElementaryStream[0];
		}
		validate();
	}

	public void updateAllEvents() {
		SIIterator iter3, iter;
		SIEvent e1, e2;
		int i = 0;
		
		try {
            /*DBG*/System.out.println("access EIT present");		
			e1 = _siService.retrievePresentSIEvent( null );
		} catch (SIException e) { e1 = null; System.out.println("EITpf "+e);}
		try {
            /*DBG*/System.out.println("access EIT following");		
			e2 = _siService.retrieveFollowingSIEvent( null );
		} catch (SIException e) { e2 = null; System.out.println("EITpf "+e);}
		try {
            /*DBG*/System.out.println("access EIT schedule");		
            if ( _tsTime == null )
            {
                _tsTime = _siService.getSIDatabase().retrieveSITimeFromTDT( );
            }
            Date now = _tsTime.getUTCTime();
//DATE_TM*/     Date start = new Date( now.getYear(), now.getMonth(), now.getDay(), 0, 0, 0 );
/*DATE_NORMAL*/ Date start   = new Date( now.getTime() - 5*(60*60*1000) );
            Date end   = new Date( now.getTime() + 300*(60*60*1000) );
            /*DBG*/System.out.println("  current time "+now);
            /*DBG*/System.out.println("  start   time "+start);
            /*DBG*/System.out.println("  end     time "+end);
			iter3 = _siService.retrieveScheduledSIEvents( null, start, end );
		} catch (SIException e) { iter3 = null; System.out.println("EITsch "+e);}

		_eventList.removeAll();
		_events = new SIEvent[(e1 == null ? 0 : 1) + (e2 == null ? 0 : 1) + (iter3 == null ? 0 : iter3.numberOfRemainingObjects())];

		i = 0;

		if (e1 != null) {
			_events[i++] = e1;
			_eventList.addItem("Present Event " + e1.getEventId() );
		}
		if (e2 != null) {
			_events[i++] = e2;
			_eventList.addItem("Following Event " + e2.getEventId() );
		}
        /*DBG*/System.out.println("EITsch events "+iter3);
		if (iter3 != null) {
		    /*DBG*/System.out.println("EITsch events filtered");
			while (iter3.hasMoreElements()) {
    		    /*DBG*/System.out.println("  add EITsch event");
				SIEvent ev = (SIEvent) iter3.nextElement();
				
				_events[i++] = ev;
				_eventList.addItem("Scheduled Event " + ev.getEventId() );
			}
		}
		validate();
	}


	public boolean handleEvent(Event e) {
		if (e.target == exit) {
			if (e.id == Event.ACTION_EVENT) {
				frame.dispose();
				frame = null;
			}
		} else if (e.target == _eventList) {
			if (e.id == Event.ACTION_EVENT) { // double-click
				int s = _eventList.getSelectedIndex();

				if (s != -1) {
					new SIEventUI( _events[s] );
				}
			}
		} else if (e.target == _esList) {
			if (e.id == Event.ACTION_EVENT) { // double-click
				int s = _esList.getSelectedIndex();

				if (s != -1) {
//					new PMTElementaryStreamUI( _ess[s] );
				}
			}
		} else if (e.target == refresh) {
			if (e.id == Event.ACTION_EVENT) {
				updateAll();
			}
		} else if (e.target == descriptors) {
			if (e.id == Event.ACTION_EVENT) {
				try {
					new DescriptorListUI( frame.getTitle(), _siService.retrieveDescriptors() );
				} catch (SIException ex) {
				}
			}
		} else if (e.target == pmtDescriptors) {
			if (e.id == Event.ACTION_EVENT) {
				try {
					new DescriptorListUI( "PMT " + frame.getTitle(), _siService.retrievePMTDescriptors() );
				} catch (SIException ex) {
				}
			}
		}
		return super.handleEvent(e);
	}

	private SIService           _siService;
	private SIEvent             _events[];
	private PMTElementaryStream _ess[];
	private Label               _servName;
	private Label               _servProviderName;
	static private SITime       _tsTime = null;
}
