/********************************************************************
 This software module was originally developed by  Gianluca De Petris 
(CSELT - I - SOMMIT Consortium) and edited by Luca Deri
(Finsiel - I - SOMMIT Consortium),Roberto Becchini (SIA - I - SOMMIT Consortium),
Barbara Silano (SIA - I - SOMMIT Consortium)in the course of 
development of the MPEG-4 Systems (ISO/IEC 14496-1). This software 
module is an implementation of part of one or more MPEG-4 Systems 
(ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
14496-1). ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) 
free license to this software module or modifications thereof for use 
in hardware or software products claiming conformance to the MPEG-4 
Systems (ISO/IEC 14496-1). Those intending to use this software 
module in hardware or software products are advised that its use may 
infringe existing patents. THE ORIGINAL DEVELOPER OF THIS SOFTWARE 
MODULE AND HIS/HER COMPANY, THE SUBSEQUENT EDITORS AND THEIR 
COMPANIES, AND ISO/IEC HAVE NO LIABILITY FOR USE OF THIS SOFTWARE 
MODULE OR MODIFICATIONS THEREOF. No license to this software module 
is granted for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. The SOMMIT Consortium retains full right to use the 
software module for his/her own purpose, assign or donate the 
software module to a third party and to inhibit third parties from 
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. This copyright notice must be included in all copies or 
derivative works of the software module. Copyright 1999
********************************************************************/

// SOLARIS PORTING - Added defs.h
#ifdef WIN32
#include <windows.h>		
#include <direct.h> // for the chdir
#else

#ifndef __stdcall
#define __stdcall 
#endif

#ifndef MessageBox
#define MessageBox(v1,v2,v3,v4) 
#endif

// WIN-SOL release
#include "defs.h"

#endif

#include <assert.h>
#include "JVMSupport.h"
//#include "..\SI_api_Native\SFilterBridge.h"


/* a function that redirects all VM messages. */
jint __stdcall my_vfprintf(FILE *fp, const char *format, 
                         va_list args)
{
	char tempString[1000];
	sprintf(tempString, format, args);
// SOLARIS PORTING
#ifdef WIN32
	MessageBox(NULL,tempString,"Message from JVM",MB_OK);	
#endif
	fp;
	return 0;
}

/* a VM exit hook. */
void __stdcall my_exit(jint code)
{
	char tempString[1000];
	sprintf(tempString, "JVM exited with code = %d", code);
	MessageBox(NULL,tempString,"JVM exit",MB_OK);
	//stopJVM();
};

/* a VM abort hook. */
void __stdcall my_abort()
{
	char tempString[1000];
	sprintf(tempString, "JVM abort");
	MessageBox(NULL,tempString,"Information",MB_OK);
	//stopJVM();
};

// Start the Java Virtual Machine
// Add parameter1 to the current path for Java related dll
// Add parameter2 to the current classpath for other Java classes
void JVMSupport::startJVM(const char * additionalPATH, const char * additionalCLASSPATH)
{
#ifndef DISABLE_JVM
	jint res;
	// PORTING to Java 2
//	char newPath[MAX_PATH_LENGTH]; // contains the new PATH
	char *envClassPath;
	int pathLength;
// SOLARIS PORTING - code added for debuggin with JDB
    int int_loop = 1;

	if (!startedVM)
	{
		/*
		REM Set up the path for the shared libraries
		set OLDPATH=%PATH%
		//BINDU : Add the Mpgj/Lib - to the path variable. 
		// Atually added already - see the JVMLaunch.cpp
		*/
		oldPath = getenv( "PATH" );
		if( oldPath == NULL )
		{
			MessageBox(NULL,"PATH environment variable is not set","Warning",MB_OK);
		}
		strcpy(newPath, "PATH="); pathLength = strlen("PATH=") + 1; // init 
		if (pathLength < MAX_PATH_LENGTH) {
			strncat(newPath, additionalPATH, MAX_PATH_LENGTH - pathLength); // do not exceed the size of the vector
			pathLength += strlen(additionalPATH);
		}
		if (oldPath != NULL && pathLength < MAX_PATH_LENGTH) {
			strncat(newPath, oldPath, MAX_PATH_LENGTH - pathLength); pathLength += strlen(oldPath);
		}
		if (pathLength > MAX_PATH_LENGTH)
		{
			MessageBox(NULL,"PATH environment variable is too long. Reduce the length, else you risk malfunctioning.","Warning",MB_OK);
		}
		putenv(newPath);

		/*
		REM Set up the classpath
		set OLDCLASSPATH=%CLASSPATH%
		set CLASSPATH=%MAGNETROOTPATH%\lib;%MAGNETROOTPATH%\lib\viewer.jar;%CLASSPATH%
		*/
		// PORTING to Java 2
		// Commenting the next two lines
//		vm_args.version = 0x00010001; /* New in 1.1.2: VM version */
//		JNI_GetDefaultJavaVMInitArgs(&vm_args);
		// PORTING to Java 2
//		strcpy(newClassPath, ""); // init
		strcpy(newClassPath, "-Djava.class.path="); // init
		strcat(newClassPath, additionalCLASSPATH);
		envClassPath = getenv( "CLASSPATH" );
		if( envClassPath == NULL )
		{
			MessageBox(NULL,"CLASSPATH environment variable is not set","Warning",MB_OK);
		} else
		{
// PORTING to Java 2
#ifdef WIN32
			strcat(newClassPath, ";");
#else
			strcat(newClassPath, ":");
#endif
			strcat(newClassPath,envClassPath);
		}
// PORTING to Java2
#ifdef WIN32
		strcat(newClassPath, ";");
#else
		strcat(newClassPath, ":");
#endif
// PORTING to Java 2
// Commenting this line
//		strcat(newClassPath, vm_args.classpath);
		//BINDU
#ifdef WIN32
		strcat(newClassPath, ";");
#else
		strcat(newClassPath, ":");
#endif
		//BINDU

// PORTING to Java 2
// Great many changes in the initialization args
//		vm_args.classpath = newClassPath; // Java 2 change
		//vm_args.minHeapSize = 90000000; // set the initial Java heap size
//		vm_args.maxHeapSize = 90000000; // set the maximum Java heap size // Java 2 change
		//vm_args.disableAsyncGC = 1;     // don't allow asynchronous garbage collection
		//vm_args.vfprintf = my_vfprintf;
//        vm_args.debugging = 1; // Java 2 change
//		vm_args.exit = my_exit; // Java 2 change
//		vm_args.abort = my_abort; // Java 2 change

// PORTING to Java 2
// The initialization args
		options[0].optionString = newClassPath;
#ifdef WIN32
		strcpy( newPath, "-Djava.library.path=.\\;" );
		strcat( newPath, getenv( "PATH" ) );
#else
		strcpy( newPath, "-Djava.library.path=./:" );
		strcat( newPath, getenv( "LD_LIBRARY_PATH" ) );
#endif
		options[1].optionString = newPath;

// PORTING to Java 2
// The functions exit, vfprintf, abort also
// go in as options
		options[2].optionString = "vfprintf";
		options[2].extraInfo = my_vfprintf;

		options[3].optionString = "exit";
		options[3].extraInfo = my_exit;

		options[4].optionString = "abort";
		options[4].extraInfo = my_abort;

		vm_args.version = JNI_VERSION_1_4;
		vm_args.options = options;
		vm_args.nOptions = 5;
		vm_args.ignoreUnrecognized = 1;

		// PORTING to Java 2
//		res = JNI_CreateJavaVM(&jvm, &env, &vm_args);
		res = JNI_CreateJavaVM(&jvm, (void **)&env, &vm_args);

// WIN-SOL release
#ifndef WIN32
#ifdef MPEGJ_WAIT_FOR_JAVA
        while( int_loop )
        {
            sleep(1);
        }
#endif
#endif


		if (res < 0)
		{
			MessageBox(NULL,"Can't create Java VM","Problem",MB_OK);
			assert(0);
		}
	//	MessageBox(NULL,"Created Java VM","Cool",MB_OK);
		startedVM = true;
	}
	// set debug console
	jclass c = getEnv()->FindClass("org/iso/mpeg/mpegjRefImpl/MPEGJDebugPrintStream");
	if(c == 0) return; 
	jmethodID m = getEnv()->GetStaticMethodID(c, "set", "()V");
	if(m == 0) return;
	getEnv()->CallStaticVoidMethod(c,m);

		
#endif
}

// Convert an absolute dos path into an URL
// Return 0 if OK.
// At the moment no error conditions are reported
// No optimizations are implemented
int JVMSupport::absDosPath2URL(char *dest, const char *dosPath)
{
	strcpy(dest, "file:///");
	strcat(dest, dosPath);
	// now reverse slashes
	for (unsigned int i = 0; i < strlen(dosPath); i++)
	{
		if (dest[i+8] == '\\')
			dest[i+8] = '/';
	}
	return 0;
}


void JVMSupport::runJavaApplication(const char * className, const char *arg1)
{
#ifndef DISABLE_JVM

	if (!startedVM) {
		MessageBox(NULL,"JVM not started","Problem",MB_OK);
		assert(0);
		return;
	}

	jclass cls = env->FindClass(className);
    if (cls == 0) 
	{
		MessageBox(NULL,"Can't find requested class","Problem",MB_OK);
		assert(0);
	}
	
	jmethodID mid = env->GetStaticMethodID(cls, "main", "([Ljava/lang/String;)V");
    if (mid == 0) 
	{
		MessageBox(NULL," Can't find AppletViewer.main","Problem",MB_OK);
		assert(0);

	}    

	jstr = env->NewStringUTF(arg1);
    if (jstr == 0)
	{
		MessageBox(NULL,"Out of memory in creating the string","Problem",MB_OK);
		assert(0);
	
	}

	args = env->NewObjectArray(1,env->FindClass("java/lang/String"),jstr);
    if (args == 0)
	{
		MessageBox(NULL," Out of memory","Problem",MB_OK);

	}
     
	env->CallStaticVoidMethod(cls, mid, args);
#endif
}

// Start the appletviewer on the file passed as parameter1
// Change working directory before starting the applet viewer
void JVMSupport::runAppletViewer(const char * absDosPath)
{
#ifndef DISABLE_JVM

	if (!startedVM) {
		MessageBox(NULL,"JVM not started","Problem",MB_OK);
		return;
	}

	// convert the path into an URL
	char url[1024];
	absDosPath2URL(url, absDosPath);

	jclass cls = env->FindClass("sun/applet/AppletViewer");
    if (cls == 0) 
	{
		MessageBox(NULL,"Can't find AppletViewer class","Problem",MB_OK);
	}
	
	jmethodID mid = env->GetStaticMethodID(cls, "main", "([Ljava/lang/String;)V");
    if (mid == 0) 
	{
		MessageBox(NULL," Can't find AppletViewer.main","Problem",MB_OK);

	}    

	jstr = env->NewStringUTF(url);
    if (jstr == 0)
	{
		MessageBox(NULL,"Out of memory in creating the string","Problem",MB_OK);
	
	}

	args = env->NewObjectArray(1,env->FindClass("java/lang/String"),jstr);
    if (args == 0)
	{
		MessageBox(NULL," Out of memory","Problem",MB_OK);

	}
     
	env->CallStaticVoidMethod(cls, mid, args);
#endif
}

void JVMSupport::stopJVM()
{
#ifndef DISABLE_JVM
	char newPath[MAX_PATH_LENGTH]; // contains the new PATH

	if (startedVM)
	{
		startedVM = false;
		strcpy(newPath, "PATH="); strcat(newPath, oldPath);
		putenv(newPath);

		jvm->DestroyJavaVM();
	}
	else
	{
		MessageBox(NULL,"Stopped an already stopped JVM","Problem",MB_OK);
	}
#endif
}

/*
void startJVMThread(void)
{
#ifdef _JAVA_
	if((threadHandle = CreateThread(NULL, 0, startJVM, NULL,0, &id)) == NULL)
	{
		assert(0);
	}	
#endif
}
*/
