/********************************************************************
 This software module was originally developed by  Gianluca De Petris 
(CSELT - I - SOMMIT Consortium) and edited by Luca Deri
(Finsiel - I - SOMMIT Consortium),Roberto Becchini (SIA - I - SOMMIT Consortium),
Barbara Silano (SIA - I - SOMMIT Consortium)in the course of 
development of the MPEG-4 Systems (ISO/IEC 14496-1). This software 
module is an implementation of part of one or more MPEG-4 Systems 
(ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
14496-1). ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) 
free license to this software module or modifications thereof for use 
in hardware or software products claiming conformance to the MPEG-4 
Systems (ISO/IEC 14496-1). Those intending to use this software 
module in hardware or software products are advised that its use may 
infringe existing patents. THE ORIGINAL DEVELOPER OF THIS SOFTWARE 
MODULE AND HIS/HER COMPANY, THE SUBSEQUENT EDITORS AND THEIR 
COMPANIES, AND ISO/IEC HAVE NO LIABILITY FOR USE OF THIS SOFTWARE 
MODULE OR MODIFICATIONS THEREOF. No license to this software module 
is granted for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. The SOMMIT Consortium retains full right to use the 
software module for his/her own purpose, assign or donate the 
software module to a third party and to inhibit third parties from 
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. This copyright notice must be included in all copies or 
derivative works of the software module. Copyright 1999
********************************************************************/

#ifndef _JVMSupport_H_
#define _JVMSupport_H_

#include <jni.h>

const int MAX_PATH_LENGTH = 1024;

class JVMSupport
{
public:
	JVMSupport() : startedVM(false), env(NULL), jvm(NULL), oldPath(NULL) {}
	void startJVM(const char * additionalPATH, const char * additionalCLASSPATH);
	void runAppletViewer(const char * absDosPath);
	void runJavaApplication(const char * className, const char *arg1);
	void stopJVM(void);
	inline JNIEnv *getEnv(){return env;}
	inline JavaVM *getJVM(){return jvm;}
private:
	// variable of status of the object
	bool startedVM;
	// variables related to the JVM
	JNIEnv *env;
	JavaVM *jvm;
	// PORTING to Java 2
//	JDK1_1InitArgs vm_args;
	JavaVMInitArgs vm_args;
	// PORTING to Java 2
	// Options parameter required
	JavaVMOption options[5];
	char newPath[MAX_PATH_LENGTH];
	jstring jstr;
	jobjectArray args;
	/* HANDLE threadHandle = NULL; //Handle of the thread that starts JVM
	DWORD id = 0; // identifier of the thread that starts JVM
	*/
	char *oldPath; // contains the old PATH environment variable
	char newClassPath[MAX_PATH_LENGTH]; // contains the new CLASSPATH to be passed to JVM
	// Private functions
	static int absDosPath2URL(char *dest, const char *dosPath);
};
#endif

