#if !defined(__ABSTRACT_SLMANAGER_SLEXTENSION__H__)
#define __ABSTRACT_SLMANAGER_SLEXTENSION__H__

/*-------------------------------------------------------------------------
Project Mux
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Mux
FILE:       AbstractSLManager.h
AUTHOR:     Alexandre Cotarmanac'h Echevarria
			France Telecom R&D
E-MAIL:		alexandre.cotarmanach@francetelecom.com
OVERVIEW:   Declaration of abstract sl manager.
			Classes implementing this manager set the actual slExtensionParams
			in the packet Header through SetExtensionValues
-------------------------------------------------------------------------*/

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "defs.h"
#include "ODP.h"
#include "SLExtensionPlugin.h"

class ES_DescriptorMux;

class AbstractSLManager  
{
public:
	
	AbstractSLManager(){}
	virtual ~AbstractSLManager(){}

	virtual bool Init(SDLClassArray<ObjectDescriptor, 1, 255> & ods) = 0;
	virtual bool SetExtensionValues(ES_DescriptorMux * esDescriptor, SL_PacketHeader * packetHeader) =0;
};


bool					CreateSLManager(LPCSTR slManagerName, bool bDebug=false);
AbstractSLManager *		GetSLManager();
void					CloseSLManager();

class SLManagerShell : public AbstractSLManager  
{
public:
	struct SLPlugin m_plugin;
	SLManagerShell():AbstractSLManager()
	{
	}
	virtual ~SLManagerShell()
	{
		(*m_plugin.deleteFunction)(m_plugin.handle);
	}

	bool Init(SDLClassArray<ObjectDescriptor, 1, 255> & ods)
	{
		return (*m_plugin.initFunction)(m_plugin.handle,ods);
	}
	bool SetExtensionValues(ES_DescriptorMux * esDescriptor, SL_PacketHeader * packetHeader)
	{
		return (*m_plugin.setFunction)(m_plugin.handle,esDescriptor,packetHeader);
	}
};



#endif // !defined(__ABSTRACT_SLMANAGER_SLEXTENSION__H__)
