/***********************************************************************
This software module was originally developed by Sang Oak Woo
(SAMSUNG AIT) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. SAMSUNG AIT retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2002.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Sang Oak Woo at sowoo@sait.samsung.co.kr.
----------------------------------------------------------------------*/

#if !defined(_DIBR_Stream_h)  // Sentry, use file only if it's not already included.
#define _DIBR_Stream_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Multiplexer
FILE:       DIBRStream.h
AUTHOR:     Sang Oak Woo (SAMSUNG AIT)
OVERVIEW:   Declaration of DIBR Stream.
-------------------------------------------------------------------------*/
#include "MuxStream.h"

class DIBRStream : public Stream
{
	long m_lDTS;
	bool m_bRAP;

	// The following variables are needed when the stream dose not have one AU
	BOOL m_constant;
	float m_nextTime;
	float m_intervalTime;

public:
	DIBRStream (FILE *fStream, ESDesc *pDescriptor) :
		Stream (fStream, pDescriptor), m_bRAP (true),
		//This variables should be used in further versions (when 1 InterpolatorCompresion file != 1 AU)
		m_constant(TRUE), m_nextTime(0), m_intervalTime(1)
	{}
	virtual long GetDTS (long lNow = 0);
	virtual long GetCTS () {return m_lDTS;}
	virtual int GetChar ();
	virtual bool IsRAP ();
	void SetIntervalTime(float time) { m_intervalTime = time; }
};

#endif	// _DIBR_Stream_h sentry