// -*- c++ -*-

// This software module was originally developed by Karl Anders ygard
// (Telenor R&D) in the course of development of the MPEG-4 Systems
// standard (ISO/IEC 14496-1).  This software module is an implementation
// of a part of one or more MPEG-4 Systems tools as specified by the MPEG-4
// Systems standard.  ISO/IEC gives users of the MPEG-4 Systems standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// For more information or to receive an up to date version of this module,
// mail karlo@nta.no or check <http://televr.fou.telenor.no/compositor/>.
//
// Copyright 1997.

#if !defined(_FBA_h)  // Sentry, use file only if it's not already included.
#define _FBA_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Multiplexer
FILE:       FBAStream.h
AUTHOR:     Karl Anders ygard
OVERVIEW:   Declaration of FBAStream, the class that handles FBA streams
-------------------------------------------------------------------------*/

#include "MuxStream.h"

class FBAStream : public Stream
{
	long m_lFrames;
	int m_nBitsLeft;
	float m_fFrameRate;
	unsigned char *m_pBuffer;
	int m_nBufferSize;
	int m_nCurrentBit;
	
	virtual int GetBits (int nBits);

public:
  FBAStream (
    FILE *fStream, ESDesc *pDescriptor);
	// FBAStream (FILE *fStream, LPCSTR szStreamData);
	virtual long GetDTS ();
	void GetHeader ();
	virtual int GetChar ();

  // SB 98/03/18
  virtual long GetCTS();
	virtual bool IsRAP();

};

#endif	// _FBA_h sentry
