/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1998.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Zvi Lifshitz at zvil@csi.com.
----------------------------------------------------------------------*/

#if !defined(_Factory_h)  // Sentry, use file only if it's not already included.
#define _Factory_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Multiplexer
FILE:       Factory.h
AUTHOR:     Zvi Lifshitz (Triton R&D Ltd.)
OVERVIEW:   Declaration of StreamFactory, the template class that creates
Stream objects.
-------------------------------------------------------------------------*/
class Stream;
struct ESDesc;

/*-----------------------------------------------------------------
Declare a base class for the template
-----------------------------------------------------------------*/
class StreamFactoryBase
{
	LPCSTR m_szType;

public:
	StreamFactoryBase (LPCSTR szType = NULL);
	BOOL IsTypeOf (LPCSTR szType);
	virtual Stream *Create (FILE *fStream, ESDesc *pDescriptor) = 0;
};

/*-----------------------------------------------------------------
Declare the template
-----------------------------------------------------------------*/
template <class T> class StreamFactory : public StreamFactoryBase
{
public:
	StreamFactory (LPCSTR szType) :
		StreamFactoryBase (szType)
	{}
	virtual Stream *Create (FILE *fStream, ESDesc *pDescriptor)
	{
		return new T (fStream, pDescriptor);
	}
};

#endif	// _Factory_h sentry
// SOLARIS PORTING - Added a new line
