// AACFHGheader.h: Schnittstelle fr die Klasse AACFHGheader.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_AACFHGHEADER_H__1A749176_88BC_11D1_92FE_006097B0D3A3__INCLUDED_)
#define AFX_AACFHGHEADER_H__1A749176_88BC_11D1_92FE_006097B0D3A3__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <iostream.h>
#include <stdio.h>
#include <assert.h>

#include "BitVector.h"

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Multiplexer
FILE:       AACFHGheader.h
AUTHOR:     Christian Koechling (Robert Bosch GmbH & MoMuSyS)
OVERVIEW:   class to extract the additional header information
-------------------------------------------------------------------------*/
class AACFHGheader : public BitVector  
{
public:
 	 unsigned int frame_length;
	 BYTE ID;
	 unsigned int header_length;
	 unsigned int blocks_in_frame;
	 unsigned int sampling_frequ;
	 unsigned int NumOfChan;
	 unsigned int BitsPerChan;
	
	 unsigned int pcmoutlen_byte;
	 double   pcmoutlen_ms;

	 
public:
	AACFHGheader(int numofBits);
	virtual ~AACFHGheader();

    void decodeFHGFrameInfo();


};
int readfromFile(char *FileName);
/*Dec Hex  Rate  
0   0x0	96000
1	0x1	88200
2	0x2	64000
3	0x3	48000
4	0x4	44100
5	0x5	32000 - used by SHARC-AAC encoder 
6	0x6	24000
7	0x7	22050
8	0x8	16000 - used by SHARC-AAC encoder 
9	0x9	12000
10	0xa	11025   
11	0xb	8000  - used by SHARC-AAC encoder 	 
12	0xc - 0xf 	reserviert
*/
const int SamplingRate[12] = {96000,88200,64000,48000,
							  44100,32000,24000,22050,
							  16000,12000,11025,8000};
/*-----------------------------------------------------------------*/


#endif // !defined(AFX_AACFHGHEADER_H__1A749176_88BC_11D1_92FE_006097B0D3A3__INCLUDED_)
