#if !defined(AACFHGHEADER_H)
#define AACFHGHEADER_H
/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Multiplexer
FILE:       Bitvector.h
AUTHOR:     Christian Koechling (Robert Bosch GmbH)
OVERVIEW:   to extract the additional header info embedded in the stream
            helper class
-------------------------------------------------------------------------*/

typedef unsigned char BYTE;

class BitVector
{
 public:
     BYTE *array;
 protected:
  
  int lenOfBits;
  int lenOfBytes;
  int lenOfBytesLevel;
 public:
  BitVector(int numofBits);
  ~BitVector();

  int getlen_bytes();
  int getlen_bits();
  int getlen_BytesLevel();
  // returns -1 if total level reached
  int setByte(BYTE abyte);

  void resetCounter();
  void resetAll();
  

  int getBit(int offset);
  int getBits(int offset, int len); 
  int getBits(int len);

  int getByteslh(int byteNum, int len);
  int getByteshl(int byteNum, int len);

 
 
 
};
  

                  
const int hexval[]= {0x0,0x1,0x2,0x4,0x8,0x10,0x20,0x40,0x80}; 

/* Bin tab coresponds to Hex tab below
      00000001,00000010,00000100,00001000,00010000,00100000,01000000,10000000
      00000011,00000110,00001100,00011000,00110000,01100000,11000000,
      00000111,00001110,00011100,00111000,01110000,11100000,
      00001111,00011110,00111100,01111000,11110000,
      00011111,00111110,01111100,11111000,
      00111111,01111110,11111100,
      01111111,11111110
      11111111
*/	

const int hexframes[64]={
                   0x1,0x2,0x4,0x8,0x10,0x20,0x40,0x80,
                   0x3,0x6,0xC,0x18,0x30,0x60,0xC0,0x0,
	               0x7,0xE,0x1C,0x38,0x70,0xE0,    0x0,0x0,
                   0xF,0x1E,0x3C,0x78,0xF0,        0x0,0x0,0x0,
                   0x1F,0x3E,0x7C,0xF8,            0x0,0x0,0x0,0x0,
                   0x3F,0x7E,0xFC,                 0x0,0x0,0x0,0x0,0x0,
                   0x7F,0xFE,                      0x0,0x0,0x0,0x0,0x0,0x0,
                   0xFF,                           0x0,0x0,0x0,0x0,0x0,0x0,0x0,
                  };
 

/*const int hexframes[64]={0xFE,0xFD,0xFB,0xF7,0xEF,0x6F,0xBF,0x7F,
				   0xFC,0xF9,0xF3,0xE7,0xCF,0x9F,0x3F, 0x0,
				   0xF8,0xF1,0xE3,0xC7,0x8F,0x1F,      0x0,0x0,
				   0xF0,0xE1,0xC3,0x87,0xF,            0x0,0x0,0x0,
				   0xE0,0xC1,0x83,0x7,				   0x0,0x0,0x0,0x0,
				   0xC0,0x81,                          0x0,0x0,0x0,0x0,0x0,
				   0x0,                                0x0,0x0,0x0,0x0,0x0,0x0 
                  };*/

#endif