// WaveHeader.cpp: Implementierung der Klasse WaveHeader.
//
//////////////////////////////////////////////////////////////////////

#include "defs.h"
#include "WaveHeader.h"

#define Frame_ms 30

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

WaveHeader::WaveHeader(int numofBits):BitVector(numofBits)
{
	
}

WaveHeader::~WaveHeader()
{

}

/*

 can handle only WAVE_FORMAT_PCM:

Here something about RIFF this start after 18bytes
WORD wFormatTag;              // Format category
WORD wChannels;          // Number of channels
DWORDdwSamplesPerSec;         // Sampling rate
DWORDdwAvgBytesPerSec;        // For buffer
     estimation
                         WORD wBlockAlign;        // Data block size




*/

void WaveHeader::decodeHeader(int offset)
{

  //const offset = 20;  
  const abyte = 8;
  if(lenOfBytesLevel == lenOfBytes)
  {   
	 NumOfChan = getByteslh((offset+2),2);
	 sampling_frequ = getByteslh((offset+4),4);
	 BitsPerChan = getByteslh((offset+14),2);	
     frame_length = Frame_ms*BitsPerChan/8*NumOfChan*sampling_frequ/1000;
	 pcmoutlen_ms = Frame_ms;
	 pcmoutlen_byte = frame_length;

	 cout <<"frame_length="<<frame_length << endl;
	 cout <<"sampling_frequ="<<sampling_frequ<< endl;
	 cout <<"NumOfChan="<<NumOfChan << endl;
	 cout <<"BitsPerChan="<<BitsPerChan << endl;
  }

}
void WaveHeader::decodeHeader()
{

  const offset = 20;  
  const abyte = 8;
  if(lenOfBytesLevel == lenOfBytes)
  {   
	 NumOfChan = getByteslh((offset+2),2);
	 sampling_frequ = getByteslh((offset+4),4);
	 BitsPerChan = getByteslh((offset+14),2);	
     frame_length = Frame_ms*BitsPerChan/8*NumOfChan*sampling_frequ/1000;
	 pcmoutlen_ms = Frame_ms;
	 pcmoutlen_byte = frame_length;

	 cout <<"frame_length="<<frame_length << endl;
	 cout <<"sampling_frequ="<<sampling_frequ<< endl;
	 cout <<"NumOfChan="<<NumOfChan << endl;
	 cout <<"BitsPerChan="<<BitsPerChan << endl;
  }

}
// for Testing!
/*
WaveHeader *Bitvec;
int readfromFile(char *FileName)
{
	unsigned char c;
	unsigned int count = 0;
	unsigned int frameLen = 0;

    
	FILE *fstream;
	FILE *fstream2;

	fstream = fopen(FileName,"rb");
	fstream2 = fopen("data2.dat","w+b");

	assert(fstream != NULL);
	assert(fstream2 !=NULL);
    
  
    cout<<"Begin of while"<<endl;
	while(feof(fstream) == 0)
	{
	

		getchar();
		Bitvec->resetCounter();
		do{
            c = getc(fstream);
		}while(Bitvec->setByte(c)!=-1);

        Bitvec->decodeHeader();

		cout <<"FrameLen="<<Bitvec->frame_length << endl;
        cout <<"NumOfChan="<<Bitvec->NumOfChan<< endl;
        cout <<"sampling_frequ="<<Bitvec->sampling_frequ<< endl;
        cout <<"BitsPerChan="<<Bitvec->BitsPerChan << endl;

		for(count = 0; count < Bitvec->frame_length-6; ++count)
		{
			//cout << "within for"<<endl;
			c = getc(fstream);
			//putc(c,fstream2);
			
		}

		
	}
	fclose(fstream);
	fclose(fstream2);

	return 0;
}

void main()
{



	char *St = "data.dat";
	Bitvec= new WaveHeader(50*8); 
	cout << "Let's test the BitVector class"<<endl;
    readfromFile(St);
	cout << "Tschuess :-)"<<endl;
    
   
}
*/
