
#include "defs.h"
#include "IPMPStream.h"
#include "assert.h"
#include "odMux.h"

/*-----------------------------------------------------------------
IPMPStream constructor reads first character
-----------------------------------------------------------------*/
IPMPStream :: IPMPStream (FILE *fStream, ESDesc *pDescriptor) :
	Stream (fStream, pDescriptor)
{
	m_nCount = 0;
	m_cNext = getc ();
	m_nAU = 0;

	//One IPMP AU duration
	m_dt = 30;
	//jimmy

	/********* Changed by Liao Xuan *****************************/
	/* get frame size dynamically in function IPMPStream :: GetChar ()							*/
	//m_nFrameSize = 300;
	m_nFrameSize = 0;
	/********* End: Changed by Liao Xuan ************************/

	printf("IPMPStream class set up successfully!");
	//**************************************************************
	//jimmy, for IPA,
	//**************************************************************
	char msg[200];
	sprintf(msg,"\nStart multiplexing IPMP Stream...\n");
	FILE *tt = fopen("IPMP_Mux.log","a+"); 
	fwrite(msg, strlen(msg),1,tt);
	printf(msg);
	fclose(tt);
}

/*-----------------------------------------------------------------
How about each AU contains 16 bytes now?
-----------------------------------------------------------------*/
long IPMPStream :: GetDTS ()
{
	if (m_cNext == EOF)
		return -1;
	m_lDTS = m_nAU++ * m_dt;
	m_nCount = 0;

	char tmp[100];
	sprintf(tmp,"IPMPStream: GetDTS-> %d\n",m_lDTS);
	printf(tmp);

	return m_lDTS;
}

/*-----------------------------------------------------------------
GetChar returns a character and reads one char ahead.  The number
of characters in an AU is determined by the data rate, which is
given in the pDescriptor -> streamData field.
-----------------------------------------------------------------*/
int IPMPStream :: GetChar ()
{
	/********* Added by Liao Xuan ***************************/
	/* get the fame size dynamically						*/
	if(m_nCount==0)
	m_nFrameSize = m_cNext + 1;
	/********* End: Added by Liao Xuan **********************/
	
	if (m_nCount >= m_nFrameSize)
		return -1;
	++m_nCount;
	int c = m_cNext;
	m_cNext = getc ();
	//assert (c != EOF);
	if (c==EOF)
	{
		//**************************************************************
		//jimmy, for IPA,
		//**************************************************************
		char msg[200];
		sprintf(msg,"\nIPMP Stream is multiplexed into System Stream\n");
		FILE *tt = fopen("IPMP_Mux.log","a+");
		fwrite(msg, strlen(msg),1,tt);
		printf(msg);
		fclose(tt);

		return -1;
	}
	return c;
}

/*----------------------------------------------------------------
Returns true if the AU referenced by the last call to GetDTS()
was a Random Access Point
-----------------------------------------------------------------*/
bool IPMPStream :: IsRAP ()
{
	return true;
}

static StreamFactory<IPMPStream> bifsFactory ("IPMPStream");
