/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1999.
************************************************************************/
#if !defined(_MPEGJ_h)  // Sentry, use file only if it's not already included.
#define _MPEGJ_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Multiplexer
FILE:       H263.h
AUTHOR:     Zvi Lifshitz (Triton R&D Ltd.)
OVERVIEW:   Declaration of H263, the class that handles H.263 streams
-------------------------------------------------------------------------*/
#include "MuxStream.h"

class MPEGJStream : public Stream
{
	int m_cNext;
	long m_lFrames;
	float m_fFrameRate;
	long m_lDTS;
	long m_lCurrentAUSize;

	FILE* m_infoFile;

public:
	MPEGJStream (FILE *fStream, ESDesc *pDescriptor);
	virtual long GetDTS (long lNow = 0);
	virtual long GetCTS () {return m_lDTS;}
	virtual bool IsRAP () {return true;}
	virtual int GetChar ();

private: 
	int getNextAUInfo();

};

#endif	// _MPEGJ_h sentry