/*-------------------------------------------------------------------------
Project Mux
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Mux
FILE:       AbstractSLManager.h
AUTHOR:     Alexandre Cotarmanac'h Echevarria
			France Telecom R&D
E-MAIL:		alexandre.cotarmanach@francetelecom.com
OVERVIEW:   Declaration of an SL Manager plugin.
-------------------------------------------------------------------------*/
#if !defined(__ABSTRACT_SLPLUGIN_SLEXTENSION__H__)
#define __ABSTRACT_SLPLUGIN_SLEXTENSION__H__
#include "ODP.h"

class ES_DescriptorMux;

typedef bool ( * INIT_FUNC_TYPE )    (unsigned int handle, SDLClassArray<ObjectDescriptor, 1, 255> & );
typedef bool ( * SET_FUNC_TYPE)		 (unsigned int handle,ES_DescriptorMux * esDescriptor, SL_PacketHeader * packetHeader);
typedef bool ( * DELETE_FUNC_TYPE)   (unsigned int handle);

struct SLPlugin
{
	bool				debug;
	unsigned int		handle;
	INIT_FUNC_TYPE		initFunction;
	SET_FUNC_TYPE		setFunction;
	DELETE_FUNC_TYPE	deleteFunction;
};
typedef void  (* InitialisePlugin )( SLPlugin * );

#endif // !defined(__ABSTRACT_SLPLUGIN_SLEXTENSION__H__)