/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1998.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Zvi Lifshitz at zvil@csi.com.
----------------------------------------------------------------------*/

#if !defined(_odMux_h)  // Sentry, use file only if it's not already included.
#define _odMux_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Multiplexer
FILE:       odMux.h
AUTHOR:     Zvi Lifshitz (Triton R&D Ltd.)
OVERVIEW:   Derived special versions of OD descriptors, for the use of 
			the Mux tool.
-------------------------------------------------------------------------*/
#include "EncOD.h"
#include "SLHead.h"
#include "ODCoder.h"

class ES_DescriptorMux : public ES_DescriptorEnc
{
public:
	ES_DescriptorMux ();
	~ES_DescriptorMux ();
	int OpenFile (int nFMC, FILE *fTRIF, FILE *fList, int flags, LPCSTR szRootFile);
	int GetScale ();	// Guido 4/8/00
	long GetDTS (long lNow = 0);
	long GetStartTime () {return muxInfo -> startTime;}
	void Store (BOOL bContinue);
	BOOL StoreSlot (BYTE *packet, int nSlotSize, int &rnLength);
//	BOOL isEndOfAU() { return m_bEndOfAU && m_bSlotStored;}		// GF 23/8/99
	static void RegisterFactory (class StreamFactoryBase *pFactory);
	void PrepareHeader (bool bStart, bool bEnd, bool bOCR, bool bRAP);
	BOOL BuildPacket (LPBYTE pPacket, int nMaxSize, int &rnLength, int &rnDataLength);

private:
	class Stream *m_pStream;
	FILE *m_fStream, *m_fTRIF, *m_fList;
	static class StreamFactoryBase *m_pFactories [40];
	static int m_nFactoriesAvailable;
	long m_lTS;
	int m_nScale;	// Guido 4/8/00
	int m_nPDUSequenceNumber, m_nFMC, m_nPayloadLength;
	int m_nAUSequenceNumber;
	bool m_bStart, m_bEnd;
	BYTE m_payload [255];
	int m_nAULength;
	BOOL m_bEndOfAU;
	BOOL m_bSlotStored;
	SL_Header m_slHeader;
	DWORD m_dwOCRrate, m_dwNextOCR;
	ODCoder m_coder;
/******** Added by Liao Xuan, for DES Encryption ***/
	HINSTANCE hInstDes;
	long	indexEncryAU; // number of encrypted AU
/******** End: Added by Liao Xuan ******************/
};

#endif	// _odMux_h sentry
// SOLARIS PORTING - Added a new line
