/***********************************************************************
This software module was originally developed by Ioan Alexandru Salomie
(Vrije Universiteit Brussel VUB) and James D. K. Kim (Samsung) in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard. This software
module is an implementation of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1)
tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC gives
users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. VUB and Samsung retain full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Ioan Alexandru Salomie at iasalomi@etro.vub.ac.be or
James D. K. Kim at jacobkim@sait.samsung.co.kr
----------------------------------------------------------------------*/

#if !defined(AFX_AFXMEDIAOBJECTPROXY_H__43FE0FFB_D0DA_4A7E_9B97_460290EB2FB8__INCLUDED_)
#define AFX_AFXMEDIAOBJECTPROXY_H__43FE0FFB_D0DA_4A7E_9B97_460290EB2FB8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../base/MediaObjectProxy.h"

class MediaStream;

class AFXMediaObjectProxy : public MediaObjectProxy
{
public:
	AFXMediaObjectProxy(MediaObject *pObject);
	virtual ~AFXMediaObjectProxy();

  virtual BOOL  Render(const Matrix & , const CullFlag & , OpenGLVisualRenderer *, DWORD) = 0;
  virtual BOOL  RenderFromStream(MediaStream* poStream, int id, DWORD dwTime) = 0;
  virtual BOOL  RenderFromBuffer(SFString *buffer, int id) = 0;
};

#endif // !defined(AFX_AFXMEDIAOBJECTPROXY_H__43FE0FFB_D0DA_4A7E_9B97_460290EB2FB8__INCLUDED_)
