// This software module was originally developed by Marius PREDA
// (INT/ARTEMIS) in the course of development of the MPEG-4 AFX
// standard (ISO/IEC 14496-16).  This software module is an implementation
// of a part of one or more MPEG-4 AFX tools as specified by the MPEG-4
// AFX standard.  ISO/IEC gives users of the MPEG-4 AFX standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 AFX
// conforming products.  The author retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// AFX conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// Copyright 2003


#ifndef __SBBONEPROXY_H__
#define __SBBONEPROXY_H__

#include "../AFXMediaObjectProxy.h"
#include "../../opengl/group/TransformProxy.h"
//#include "SBVector.h"
//#include "SBQuaternion.h"
//#include "SBMatrix.h"

class Transform;


class SBBoneProxy
  : public NodeProxy
{
protected:
	

public:
	
private:
	

public:

  /// Constructor

	//SBBoneProxy(SBBone* pB);
inline
SBBoneProxy::SBBoneProxy(SBBone* pB)
  : NodeProxy(pB)
{
	/*
	m_Transform.center=pB->center;
	m_Transform.rotation=pB->rotation;
	m_Transform.translation=pB->translation;
	m_Transform.scale=pB->scale;
	m_Transform.scaleOrientation=pB->scaleOrientation;
	*/
	isUpdated=true;
	
}

    //virtual ~SBBoneProxy(){		    }

  /// Render object
  virtual BOOL  RenderFromStream(MediaStream* poStream, int id, DWORD dwTime);
  virtual BOOL  RenderFromBuffer(SFString *buffer, int id);

  /// Render object description
  virtual void		RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Decode AFX bitstream

  void Enable (unsigned char *pData);

  /// Render object
  virtual BOOL Render(const Matrix&, const CullFlag&, OpenGLVisualRenderer* pRenderer, DWORD);
  //virtual BOOL Render(OpenGLVisualRenderer* pRenderer);
  //virtual BOOL Render();
  
  /// Traverse scene graph, checking for intersection

  virtual BOOL		Select(OpenGLVisualRenderer* pRenderer, DWORD dwTime, unsigned int& depth);

  // moved methods from Box to OctreeImageProxy
public:

  SBBone * GetSBBone() const{ 
	  return (SBBone *) GetMediaObject(); 
  };

void calculateState();
void computeLocalTransform();

void printState(FILE *f);

protected:
	// the rotations are always expressed in Quaternion space
	float m_accumulatedWeight;
	float m_accumulatedWeightAbsolute;

	Vec3f m_translation;
	Vec3f m_translationAbsolute;
	Vec3f m_translationBoneSpace;
	
	Rotation m_rotation;
	Rotation m_rotationAbsolute;
	Rotation m_rotationBoneSpace;

	Matrix m_transformMatrix;
	Matrix m_transformMatrixLocal;

public:
	Rotation GetRotationAbsolute();
	Rotation GetRotationBoneSpace();
	Rotation GetRotation();
	Vec3f GetTranslation();
	Vec3f GetTranslationBoneSpace();
	Vec3f GetTranslationAbsolute();
	Matrix GetTranformMatrix();

	bool isUpdated;

};


#endif // __SBBONEPROXY_H__

