// This software module was originally developed by Marius PREDA (INT)
// in the course of development of the MPEG-4 
// Systems standard (ISO/IEC 14496-1).  This software module is an 
// implementation of a part of one or more MPEG-4 Systems tools as specified by 
// the MPEG-4 Systems standard.  ISO/IEC gives users of the MPEG-4 Systems 
// standard free license to this software module or modifications thereof for 
// use in hardware or software products claiming conformance to the MPEG-4 
// Systems standard.  Those intending to use this software module in hardware or 
// software products are advised that its use may infringe existing patents.  
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use 
// of this software module or modifications thereof in an implementation.  
// Copyright is not released for non MPEG-4 Systems conforming products.  The 
// original developer retains full right to use the code for his/her own 
// purpose, assign or donate the code to a third party and to inhibit third 
// parties from using the code for non MPEG-4 Systems conforming products.  This 
// copyright notice must be included in all copies or derivative works.
//
// Copyright 2003.


#ifndef __SBSkinnedModelPROXY_H__
#define __SBSkinnedModelPROXY_H__

#include "opengl/base/NodeProxy.h"
//#include "SBVector.h"

#include <vector>

using namespace std;	


//class SBSkinnedModel;
//class OpenGLVisualRenderer;
class SBVector;


class SBSkinnedModelProxy : public NodeProxy
{
public:

	// constructor

inline
SBSkinnedModelProxy::SBSkinnedModelProxy(SBSkinnedModel* pSBSM)
  : NodeProxy(pSBSM)
{
	init = false;
}


  /// Constructor
	//SBSkinnedModelProxy(SBSkinnedModel* pSBSkinnedModel);

  /// Destructor
	//~SBSkinnedModelProxy();

public:
  virtual void RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

protected:  
  /// Render object
  virtual BOOL Render(const Matrix&, const CullFlag&, OpenGLVisualRenderer* pRenderer, DWORD);
	
/* virtual */ void Select(
		const Matrix& rTransformation, 
		const CullFlag& rCullFlag,
		OpenGLVisualRenderer* pRenderer, 
		DWORD dwTime,
		MediaObjectProxy*& intersectingObject,
		ZArray<MediaObjectProxy*>& activatedSensors, 
		unsigned int& depth,
		const ZArray<MediaObjectProxy*>& localSensors);


public:

	inline SBSkinnedModel * GetSBSkinnedModel() const {
		return (SBSkinnedModel *) GetMediaObject();
	}

	inline MF<Vec3f> &GetVerticesCoord() const{ 
		return GetSBSkinnedModel()->skinCoord->point;
	}

	inline const MF<Vec3f>& GetVerticesNormals() const{ 
		return GetSBSkinnedModel()->skinNormal->vector;
	}


	typedef struct{
		int boneId;
		float weight;
	  } Influence;
	
	typedef struct{
		/*SBVector*/ Vec3f position;
		/*SBVector*/ Vec3f normal;
		std::vector<Influence> vectorInfluence;
		int influenceCount;
	} Vertex;

	void UpdateVertices();
	void GetInitialSkin();
	void UpdateSBSegments();
	
	bool setVertex(int vertexId, const Vertex& vertex);
	void setVertex(int vertexId, float x,float y,float z);
	


// member variables
protected:
  std::vector<Vertex> m_vectorVertex;
  long m_nTimeStamp;
  bool _needUpdate;


  bool init;

};

//#include "SBSkinnedModelProxy.i"

#endif // __SBSkinnedModelPROXY_H__
