// This software module was originally developed by Sang Oak Woo (SASUNG AIT),
// James D.K. Kim (SAMSUNG, AIT), Kevin Barron (KPN Research), 
// Mike Coleman (Five Bats Research), Edward Cooke (Teltec Ireland), In-Dai Ha 
// (Hyundai Electronics Industries, Co.), Hae-Kwan Kim (Hyundai Electronics 
// Industries, Co.), Matthew Leditschke (CSELT), Zvi Lifshitz (VDOnet Corp.), 
// Karl Anders ygard (Telenor R&D), in the course of development of the MPEG-4 
// Systems standard (ISO/IEC 14496-1).  This software module is an 
// implementation of a part of one or more MPEG-4 Systems tools as specified by 
// the MPEG-4 Systems standard.  ISO/IEC gives users of the MPEG-4 Systems 
// standard free license to this software module or modifications thereof for 
// use in hardware or software products claiming conformance to the MPEG-4 
// Systems standard.  Those intending to use this software module in hardware or 
// software products are advised that its use may infringe existing patents.  
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use 
// of this software module or modifications thereof in an implementation.  
// Copyright is not released for non MPEG-4 Systems conforming products.  The 
// original developer retains full right to use the code for his/her own 
// purpose, assign or donate the code to a third party and to inhibit third 
// parties from using the code for non MPEG-4 Systems conforming products.  This 
// copyright notice must be included in all copies or derivative works.
//
// Copyright 1997.

// SOWOO 2003/06/21
#ifndef __BITWRAPPERPROXY_H__
#define __BITWRAPPERPROXY_H__

#include "opengl/base/MediaObjectProxy.h"

class BitWrapper;
class AfxStreamProxy;
class OpenGLVisualRenderer;

/// Appearance renderer class

class BitWrapperProxy
  : public MediaObjectProxy
{
public:

  /// Constructor
	BitWrapperProxy(BitWrapper* pBitWrapper);

public:
	bool GetIsDecodingNeeded() { return m_bIsDecodingNeeded; }
	void SetIsDecodingNeeded(bool bIsNeeded) { m_bIsDecodingNeeded = bIsNeeded; }
	
	BOOL Render(const Matrix& , const CullFlag& ,	OpenGLVisualRenderer*, DWORD);

public:
	inline BitWrapper * GetBitWrapper() {
		return (BitWrapper *) GetMediaObject();
	}

  void SetDecoderData(AfxStreamProxy *pProxy);

	void Start()
	{
#ifndef BIFSENC
    BitWrapper* poBitWrapper = GetBitWrapper();
    if (!poBitWrapper->IsStreamOpen())
    {
		  m_bActive = TRUE;
		  GetBitWrapper()->OpenStream();
      GetBitWrapper()->GetExecutive()->RequestChannels();
    }
#endif
	};

private:
	bool m_bIsDecodingNeeded;	// it indicates if decoding of node or buffer field is needed
};

#include "BitWrapperProxy.i"

#endif // __BITWRAPPERPROXY_H__
