// -*- c++ -*-

// This software module was originally developed by In Kyu Park
// (SAMSUNG AIT) in the course of development of the MPEG-4 AFX
// standard (ISO/IEC 14496-16).  This software module is an implementation
// of a part of one or more MPEG-4 AFX tools as specified by the MPEG-4
// AFX standard.  ISO/IEC gives users of the MPEG-4 AFX standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 AFX
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// AFX conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// Copyright 2003

#ifndef __DEPTHIMAGEPROXY_H__
#define __DEPTHIMAGEPROXY_H__

#include "../../Geometry/GeometryProxy.h"

class DepthImage;
class OpenGLVisualRenderer;

/// DepthImage renderer node

class DepthImageProxy
  : public GeometryProxy
{
public:

  /// Constructor

                        DepthImageProxy(DepthImage* pDepthImage);

  /// Render object

  virtual BOOL		Render(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Traverse scene graph, checking for intersection

  virtual BOOL		Select(OpenGLVisualRenderer* pRenderer, DWORD dwTime, unsigned int& depth);

  /// Render object description

  virtual void		RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  // Stefano Battista
  // moved methods from Box to DepthImageProxy
public:
  DepthImage * GetDepthImage() const
  { return (DepthImage *) GetMediaObject(); };
  /// Get size of box
  /// Get bounding box
};

#include "DepthImageProxy.i"

#endif // __DEPTHIMAGEPROXY_H__
