// -*- c++ -*-

// This software module was originally developed by In Kyu Park
// (SAMSUNG AIT) in the course of development of the MPEG-4 AFX
// standard (ISO/IEC 14496-16).  This software module is an implementation
// of a part of one or more MPEG-4 AFX tools as specified by the MPEG-4
// AFX standard.  ISO/IEC gives users of the MPEG-4 AFX standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 AFX
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// AFX conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// Copyright 2003

#ifdef SAIT_CONFORMANCE_2003

#ifndef __DEPTHIMAGEPROXY_H__
#define __DEPTHIMAGEPROXY_H__

#include "../../Geometry/GeometryProxy.h"

class DepthImage;
class OpenGLVisualRenderer;
class GCamera;

/// DepthImage renderer node

class DepthImageProxy
  : public MediaObjectProxy
{
public:
   	int m_nListMade;   // -1 : Null node (Cannot define), 0 : Not defined, 1 : Already defined
   	int m_nGlListID;
    double m_dRotateAngle;

public:
    BOOL m_bGLEXTInit;
	
//2003.10.7 J.Y.HAN
	int *m_pLists;	
	int m_nCurrentListIdx, m_nNumberOfFrame;
	int m_nFetchedImage;
//-

public:
  /// From Bluxxun
	int IsListMade() {return m_nListMade;}
	BOOL MakeGLList();
    void SetSplatGLParameters(float size, float minsize, float maxsize, float a, float b, float c, float thresh);
    bool InitSplatParametersExtensions();
    void CalculateSplatParametes(OpenGLVisualRenderer* , float model_size, float& size, float& minsize, float&  maxsize, float& a, float& b, float& c, float& thresh);
    void DepthImageProxy::DrawAxis(void);

  /// Constructor

                        DepthImageProxy(DepthImage* pDepthImage);

  /// Render object

  //virtual BOOL		Render(OpenGLVisualRenderer* pRenderer, DWORD dwTime);
  virtual BOOL Render(const Matrix&, const CullFlag&, OpenGLVisualRenderer* pRenderer, DWORD);

  /// Traverse scene graph, checking for intersection

  virtual BOOL		Select(OpenGLVisualRenderer* pRenderer, DWORD dwTime, unsigned int& depth);

  /// Render object description

  virtual void		RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  // Stefano Battista
  // moved methods from Box to DepthImageProxy
public:
  DepthImage * GetDepthImage() const
  { return (DepthImage *) GetMediaObject(); };
  /// Get size of box
  /// Get bounding box
};

#include "DepthImageProxy.i"

#endif // __DEPTHIMAGEPROXY_H__

#endif // SAIT_CONFORMANCE_2003