/*\   Programmed by Alexander Zhirkov azh@graphics.cs.msu.su
\*/

#ifndef __BORLANDC__
//#include "stdafx.h"
#endif


//#include "stdafx.h"
#include "IBRCommon.h"

#include <assert.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#pragma warning(disable:4244)


//-------------------------------------------------------------------------

dbl accuracy(dbl d,int n)               
{
	if(d<0) d=-d;
    if(!d) return 0;
    n-=log(d)/log(10);
    dbl q=pow(10,n);
    if(!q)
	    return -1;
    return int(pow(10,n)*d)/q;
}

int nearest(dbl d,int i1,int i2)
{
    int i;
    d+=0.5,i=d;
    if(i<i1) i=i1;
    if(i>i2) i=i2;
    return i;
}

int dbl2int(dbl z)
{
	return ((dbl)z<0.?-(-z+.5):(.5+z));
}

int int2log(dbl i,int n,int n1)
{
	if(!i) return 0;
    dbl a=(int)1<<n;
    dbl b=(int)1<<n1;
	return (dbl)b*log2(1.+fabs(i)*a);
}
int log2int(int l,int n,int n1)
{
	if(!l) return 0;
    dbl a=(int)1<<n;
    dbl b=(int)1<<n1;
	return (dbl)(pow(2,(dbl)l/b)-1.)/a;
}

//-------------------------------------------------------------------------
dbl fmx(dbl a,dbl b){
	return a>b?a:b;}
dbl fmn(dbl a,dbl b){
	return a<b?a:b;}
dbl fmx(dbl a,dbl b,dbl c){
	return fmx(a,fmx(b,c));}
dbl fmn(dbl a,dbl b,dbl c){
	return fmn(a,fmn(b,c));}

dbl sqrtsqr(dbl a,dbl b)
{
  return sqrt(a*a+b*b);
}
dbl fsqr(dbl a)
{
  return a*a;
}

int sqr(int i)
{
	return i*i;
}

dbl log2(dbl n)
{
    n=fabs(n)+1.;
    return log(n)*1.442695041;  //1/ln2
}

//-------------------------------------------------------------------------

int lg2(int i)
{
	if(!i) return -1;
    if(i<0) i=-i;
    int r=-1;
    if(i&0xFFFF0000)
      r+=16,i>>=16;
    if(i&0x0000FF00)
      r+=8,i>>=8;
    if(i&0x000000F0)
      r+=4,i>>=4;
    if(i&0x0000000C)
      r+=2,i>>=2;
    if(i&0x00000002)
      r+=1,i>>=1;
    return r+i;
}

int slg2(int i)
{
    if(!i)
		return 0;
    return 1<<lg2(i);
}

int round(dbl x)
{
    if(x>0.) return((int)(x+0.500));
	return((int) (x-0.500));
}

int quantdiv(dbl x,int q)
{
	return q?round((dbl)x/q):x;
}
int iquantdiv(int x,int q)
{
    return q?(x>0?((x<<1)+q)/(q<<1):((x<<1)-q)/(q<<1)):x;
}

int lg2roundup(int i)
{
	Assert(i>0,"<lg2roundup> bad number="+i);
    return lg2(i+1)-1;
}

int setb(int n)
{
	if(!n)
      return 0;
    return 1<<(n-1);
}

//-------------------------------------------------------------------------

int mx(int x,int y)
{
	return x>y?x:y;
}

int mn(int x,int y)
{
	return x<y?x:y;
}

//-------------------------------------------------------------------------

void swap(dbl &x,dbl &y)
{
	dbl q=x;x=y;y=q;
}

void swap(int &x,int &y)
{
	int q=x;x=y;y=q;
}

int sorti(int& x,int& y)
{
	if(x<y)
		return 0;
	int q=x;x=y;y=q;
	return 1;
}

//-------------------------------------------------------------------------

int range(int x,int x1,int x2)
{
    x=x<x1?x1:x;
    return x>x2?x2:x;
}
int rangebyte(int x)
{
    if(x<0) return 0;
    return x>255?255:x;
}

dbl frange(dbl x,dbl x1,dbl x2)
{
    x=x<x1?x1:x;
    return x>x2?x2:x;
}

int isrange(int x,int x1,int x2)
{
    int q=x;
    x=x<x1?x1:x;
    x=x>x2?x2:x;
    return x==q?1:0;
}

int ishiftl(int i,int s)
{
	if(!s) return i;
    if(s>0) return i<<s;
	s=-s;
    return i>>s;
}


//-------------------------------------------------------------------------

dbl hammingwindow(dbl x) // x=0..1
{
	x=x-.5;
	x=(0.54-0.46*cos(2.*3.1415*x));
    x=exp(-x*x);
	x=(x-1.000)*1.58+1.000;
	return x;
}

//-------------------------------------------------------------------------
void LineToPolarInt(dbl x,dbl y,dbl z,int &i,int n)
{
	dbl m,u,v;
	dbl ax=fabs(x),ay=fabs(y),az=fabs(z);
    int k,iu,iv,l=(1<<n)-1;
    if(ax>ay && ax>az) m=x,u=ay,v=az,k=0; else
    if(ay>ax && ay>az) m=y,u=az,v=ax,k=1; else
                       m=z,u=ax,v=ay,k=2;
    if(m>0) k+=3;
    m=fabs(m);
    if(m<0.0000001) {i=0; return;}

	u+=m,v+=m;
    u/=2.*m,v/=2.*m;
    u*=l,v*=l;
    u-=.5,v-=.5;
    iu=range(u,0,l);
    iv=range(v,0,l);
    i=((iu<<n)|iv)*6+k;
}
void PolarIntToLine(int i,int n,dbl &x,dbl& y,dbl &z)
{
    dbl m,u,v;
    int k,iu,iv,l=(1<<n)-1;
    k=i%6;i=i/6;
    iv=i>>n;
    iu=i-(iv<<n);
    m=k<3?-k:k;
    k%=3;
    u=-1.+2.*(dbl)((dbl)iu)/dbl(l);
    v=-1.+2.*(dbl)((dbl)iv)/dbl(l);
    switch(k){
		case 0: x=m,y=u,z=v; break;
		case 1: x=v,y=m,z=u; break;
		case 2: x=u,y=v,z=m; break;}
    dbl r=sqrt(x*x+y*y+z*z);
	x/=r,y/=r,z/=r;
}


void DecartToPolar(dbl x,dbl y,dbl& r,dbl& w) // -PI<=w<PI
{
	r=sqrt(x*x+y*y);
    if(r==0.){ w=0.; return;}
    w=((x!=0.||y!=0.)?atan2(y,x):0);
    if(w==M_PI) w=-M_PI;
}
void PolarToDecart(dbl r,dbl w,dbl& x,dbl& y)
{
	x=r*cos(w);
    y=r*sin(w);
}
void DecartToPolar(dbl x,dbl y,dbl z,dbl &r,dbl &u,dbl &v)
{
	dbl r1;
	DecartToPolar(x,y,r1,u); // |u|< PI
    DecartToPolar(r1,z,r,v); // |v|< PI/2
}
void PolarToDecart(dbl r,dbl u,dbl v,dbl &x,dbl &y,dbl &z)
{
	dbl r1;
    PolarToDecart(r,v,r1,z);
    PolarToDecart(r1,u,x,y);
}
//-------------------------------------------------------------------------
//-------------------------------------------------------------------------

chr* file_ext(chr* t)
{
    int l=strlen(t),i=l;
    for(;i>=0 && t[--i]!='.';);
    chr *ext=(char*)malloc(l+1);
    if(l) strcpy(ext,&t[i+1]);
    else  ext[0]=0;
    return ext;
}

int file_ext(chr* nam,chr* t)
{
    chr* ext=file_ext(nam);
    int i=stricmp(ext,t);
    free(ext);//delete[] ext;
    return !i;
}

chr* file_nam(chr* t)
{
    int l=strlen(t),i=l;
    chr *nam=(chr*)malloc(l+1);
    strcpy(nam,t);
    for(;i && nam[i-1]!='.';i--);
    if(i>0) nam[i-1]=0;
    return nam;
}

chr* file_delext(chr *nam)
{
    int l=strlen(nam),i=l;
    for(;i && nam[i-1]!='.';i--);
    if(i) nam[i-1]=0;
    return nam;
}

chr* file_mak(chr* nam,chr* ext,chr c)
{
    chr *mak=(chr*)malloc(strlen(nam)+strlen(ext)+2);
    int i=0;
    for(;nam[i];i++)
      mak[i]=nam[i];
    mak[i++]=c;
    for(;*ext;)
      mak[i++]=*(ext++);
    mak[i]=0;
    return mak;
}

chr* file_mak2(chr* nam,chr* ext)
{
    chr *mak=(chr*)malloc(strlen(nam)+strlen(ext)+1);
    int i=0;
    for(;nam[i];i++)
      mak[i]=nam[i];
    for(;*ext;)
      mak[i++]=*(ext++);
    mak[i]=0;
    return mak;
}

chr* file_mak100(chr* namout100,chr* nam,chr* ext)
{
    //new chr[strlen(nam)+strlen(ext)+1];
    int i=0;
    for(;nam[i] && i<80;i++)
      namout100[i]=nam[i];
    for(;*ext && i<95;)
      namout100[i++]=*(ext++);
    namout100[i]=0;
    return namout100--;
}

dbl exprandom()
{
    return sqrt(-log(linrandom()));
}

int signrandom()
{
  	return (random(2)?-1.:1.);
}

dbl linrandom()
{
  	return
        (dbl)(rand()+1.)/((dbl)2.+(RAND_MAX));
}

dbl mse2psnr(dbl mse)
{
	if(mse<=0.) return 100.; 
	return 10.*log10((dbl)10000./mse);
}
//-------------------------------------------------------------------------
//-------------------------------------------------------------------------

int __cdecl _sortint_inc(const void *v1,const void *v2)
{
	return *((int*)v1)<*((int*)v2)?-1:1;
}
int __cdecl _sortint_dec(const void *v1,const void *v2)
{
	return *((int*)v1)>*((int*)v2)?-1:1;
}
void sortint_inc(int *p,int a)
{
	qsort(p,a,4,_sortint_inc);
}
void sortint_dec(int *p,int a)
{
	qsort(p,a,4,_sortint_dec);
}

void getrangeint(int* p,int l,int &z1,int &z2)
{
	int i,z,s=0;
    for(i=0;i<l;i++)
    {
		z=p[i];
		if(s) z1=z<z1?z:z1,
        	  z2=z>z2?z:z2;
    	else  z1=z2=z,s=1;
    }
}

void sortint_value2index(int *p,int l)
{
	Assert(l>=0,"<sortint_value2index> bad length");
	int _l=(1<<30)/l,i,z,z1,z2;
    Exit(_l>=0,"<sortint_value2index> overflow index");
	getrangeint(p,l,z1,z2);
    for(i=0;i<l;i++)
    {
    	z=z2-z1?(p[i]-z1)*_l/(z2-z1):0;
	   	p[i]=(int(z)*l)+i;
    }
    sortint_dec(p,l);
    for(i=0;i<l;i++)
    	p[i]%=l;
  }

//-------------------------------------------------------------------------

void memsetdword(int* p,int s,int l)
{
	if(!l) return;
    if(l<0) p+=l,l=-l;
	__asm
    {
        mov edi,p
		mov ecx,l
		mov eax,s
		cld
		rep stosd
    }
}
void memcpydword(int* dst,int *src,int l)
{
	if(!l) return;
	Assert(l>0,"<memcpydword> len="+l);
	__asm
    {
        push esi
		push edi
		mov esi,src
		mov edi,dst
		mov ecx,l
		cld
		rep movsd
		pop edi
		pop esi
    }
}

//-------------------------------------------------------------------------

int  fsignbytes(FILE* f,int l)
{
	switch(l)
    {
	case 1: return chr(f_byte(f));
	case 2: return wrd(f_word(f));
	case 4: return int(f_dword(f));
	default:
		Exit(0,"bad number of bytes to read");
    }
    return 0;
}

 void fsignbytes(FILE* f,int l,int x)
{
	switch(l)
    {
	case 1: f_byte(f,(chr)x); break;
	case 2: f_word(f,(wrd)x); break;
	case 4: f_dword(f,(int)x); break;
	default:
		Exit(0,"bad number of bytes for write");
    }
}

void fputi(FILE* f,int l)
{
	fwrite(&l,4,1,f);
}
int fgeti(FILE* f)
{
 	int l;
	fread(&l,4,1,f);
    return l;
}
uhr f_byte(FILE *f){
    uhr c=getc(f);
	return c;}
void f_byte(FILE *f,uhr c){
    putc(c,f);}
urd f_word(FILE *f){
	urd q;
	fread(&q,2,1,f);
    return q;}
void f_word(FILE *f,urd q){
	fwrite(&q,2,1,f);}
unt f_dword(FILE *f){
	unt u;
    fread(&u,4,1,f);
    return u;}
void f_dword(FILE *f,unt u){
    fwrite(&u,4,1,f);}
flt f_float(FILE *f){
	float q;
    fread(&q,4,1,f);
    return q;}
void f_float(FILE *f,flt q){
    fwrite(&q,4,1,f);}
dbl f_dbl(FILE *f){
	dbl q;
    fread(&q,sizeof(dbl),1,f);
    return q;}
void f_dbl(FILE *f,dbl q){
    fwrite(&q,sizeof(dbl),1,f);}

void  f_str255r(FILE* f,chr* s){
	int l=f_byte(f);
	fread(s,1,l,f);
    s[l]=0;}
void  f_str255w(FILE* f,chr* s){
	int l=strlen(s);
    f_byte(f,l);
	fwrite(s,1,l,f);}

void f_line255r(FILE *f,chr *s)
{
    fgets(s,254,f);
    s[mx(strlen(s)-1,0)]=0;
}

void f_skip(FILE *f,int i){
	while(i--)
    	fgetc(f);}

int f_size(FILE *f)
{
	fseek(f,0,SEEK_END);
	int l = ftell(f);
	fseek(f,0,SEEK_SET);
    return l;
}

int f_exist(char* t)
{
	FILE *f=fopen(t,"rb");
	if(!f) return 0;
	fclose(f);
	return 1;
}

int f_isequal(chr* t1,chr* t2)
{
	int s=0,l1,l2;
	FILE *f1=fopen(t1,"rb");
	FILE *f2=fopen(t2,"rb");
	if(f1 && f2)
	{
		l1=f_size(f1);
		l2=f_size(f2);
		if(l1==l2)
		{
            s=1;
			iforinc(i,l1)
			if(f_byte(f1)!=f_byte(f2)){
				s=0;
				break;}
		}
	}
	fclose(f1);
	fclose(f2);
	return s;

}


//-------------------------------------------------------------------------
dbl goldrandom(int i)
{
    dbl z=(dbl)i*0.618033988735;
    z-=(dbl)(int)z;
    return z;
}

