// -*- Mode: c++; tab-width: 4; c-basic-offset: 4; -*-


// This software module was adapted by Christopher Lee (MERL) 
// from DIBR/PointTextureProxy.h by In Kyu Park (SAMSUNG AIT)
// and PointShop3D 2.0 by Richard Keiser, Oliver Knoll, Mark Pauly,
// and Matthias Zwicker (Computer Graphics Lab, ETH Zurich),
// in the course of development of the MPEG-4 Systems standard
// (ISO/IEC 14496-1).  This software module is an implementation
// of a part of one or more MPEG-4 Systems tools as specified by the MPEG-4
// Systems standard.  ISO/IEC gives users of the MPEG-4 Systems standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// Copyright 2004.
//
// PointShop3D is available separately, under the GNU General Public License,
//  at http://graphics.ethz.ch/pointshop3d/index.html
#ifdef SAIT_CONFORMANCE_2003

#ifndef __POINTTEXTUREPROXYV2_H__
#define __POINTTEXTUREPROXYV2_H__

#include "DIBR2-common.h"

#include "DepthImageProxyV2.h"

class PointTextureV2;
class OpenGLVisualRenderer;

/// PointTextureV2 renderer node

class PointTextureProxyV2:public MediaObjectProxy
{
  protected:

	int m_nWidth;
	int m_nHeight;
	int m_nDepthBitPerPixel;
	unsigned int m_nMaxDepth;

  public:
	/// Utilites
	int  GetWidth (void)	{ return m_nWidth;	};
	int  GetHeight (void) { return m_nHeight; };
	int  GetDepthBitPerPixel (void) { return m_nDepthBitPerPixel; };
	int  GetMaxDepth (void) { return m_nMaxDepth; };
	void SetWidth (int Width) {	m_nWidth = Width; };
	void SetHeight (int Height)	{ m_nHeight = Height; };
	void SetDepthBitPerPixel (int Depth) { m_nDepthBitPerPixel = Depth;	};
	void SetMaxDepth (int Depth) { m_nMaxDepth = Depth;	};

	// Used by parent node (DepthImageProxyV2) to get surfels to draw
	SurfelIterator* getSurfelIterator (int nearPlane, int farPlane);

	/// Constructor
	PointTextureProxyV2 (PointTextureV2 * pPointTexture);

	/// Render object description
	virtual void RenderDescription (OpenGLVisualRenderer * pRenderer,
									DWORD dwTime);

  public:
	PointTextureV2 * GetPointTexture ()const {
		return (PointTextureV2 *) GetMediaObject ();
	};
};

#include "PointTextureProxyV2.i"

#endif // __POINTTEXTUREPROXYV2_H__

#endif // SAIT_CONFORMANCE_2003
