// -*- Mode: c++; tab-width: 4; -*-

// This software module was adapted by Christopher Lee (MERL) 
// from DIBR/SimpleTextureProxy.i by Karl Anders ygard (Telenor R&D) 
// and PointShop3D 2.0 by Richard Keiser, Oliver Knoll, Mark Pauly,
// and Matthias Zwicker (Computer Graphics Lab, ETH Zurich),
// in the course of development of the MPEG-4 Systems standard
// (ISO/IEC 14496-1).  This software module is an implementation
// of a part of one or more MPEG-4 Systems tools as specified by the MPEG-4
// Systems standard.  ISO/IEC gives users of the MPEG-4 Systems standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// Copyright 2004.
//
// PointShop3D is available separately, under the GNU General Public License,
//  at http://graphics.ethz.ch/pointshop3d/index.html

// Constructor

inline
	SimpleTextureProxyV2::SimpleTextureProxyV2 (SimpleTextureV2 *
												pSimpleTexture)
:	MediaObjectProxy (pSimpleTexture)
{
	m_nBufferFetched[0] = false;
	m_nBufferFetched[1] = false;
	m_nBufferFetched[2] = false;
	m_nBufferFetched[3] = false;
	m_nBufferFetched[4] = false;
	m_nWidth = 0;
	m_nHeight = 0;
	m_nDepthBytePerPixel = 0;
	m_nMaxDepth = 0;
	m_nColorBytePerPixel = 0;
	m_nAnim = 0;
	m_pColorBuf = NULL;
	m_pDepthBuf = NULL;
	m_pNormalBuf = NULL;
	m_pSplatUBuf = NULL;
	m_pSplatVBuf = NULL;

	m_pMovieColorBuf = NULL;
	m_pMovieDepthBuf = NULL;
	m_pOTColorBuf = NULL;
	m_pOTMovieColorBuf = NULL;

//2003.10.7 J.Y.HAN
	m_nNumberOfFrame = 0;
	m_nWidth = 0;
	m_nHeight = 0;
	m_nNumberOfChannels = 0;
	m_nBytePerPixel = 0;

	// frame information
	m_nRGBFrameSize = 0;
	m_nYUVFrameSize = 0;
	m_nCurrentFrame = 0;
	m_nPreviousFrame = INT_MAX;
	m_bDump = false;

	ColorPreviousFrame = INT_MAX;
	DepthPreviousFrame = INT_MAX;

	// video buffer
	m_pVideo = NULL;
	m_nColorVideoStatus = 0;
	m_nColorVideoFetched = FALSE;
//-

	m_nDepthVideoStatus = 0;
	m_nDepthVideoFetched = FALSE;

	m_nUVScalingComputed = FALSE;
	m_descaleOffset = 0.0;
	m_descaleSlope = 0.0; 

}
