/********************************************************************************/
/* This software module was developped by										*/

/*	   Jerome Royan (MP), jerome.royan@francetelecom.com,						*/
/*                        France Telecom R&D, France							*/

/* in the course of development of the MPEG-4 standard (Part 16 AFX).			*/
/* This software module is an implementation of a part of one or				*/
/* more MPEG-4 tools as specified by the										*/
/* MPEG-4 standard. ISO/IEC gives users of the MPEG-4 standard					*/
/* free license to this software module or modifications thereof				*/
/* for use in hardware or software products claiming conformance				*/
/* to the MPEG-4 standard. Those intending to use this software					*/
/* module in hardware or software products are advised that its					*/
/* use may infringe existing patents. The original developer of					*/
/* this software module and his company, the subsequent							*/
/* editors and their companies, and ISO/IEC have no liability					*/
/* for use of this software module or modifications thereof in					*/
/* an implementation. Copyright is not released for non							*/
/* MPEG-4 standard conforming products. INT ARTEMIS								*/
/* retain full right to use the code for their own purposes,					*/
/* assign or donate the code to a third party and to inhibit					*/
/* third parties from using the code for non MPEG-4 standard					*/
/* conforming products. This copyright notice must be included					*/
/* in all copies or derivative works.    										*/
/* Copyright (c)2002 - 2005														*/
/********************************************************************************/

// FacadeProxy.h: interface for the FootPrintProxy class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FacadeProxy_H__93F1CF93_D37D_11D5_B9F1_000102A02E5B__INCLUDED_)
#define AFX_FacadeProxy_H__93F1CF93_D37D_11D5_B9F1_000102A02E5B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\AfxStreamProxy.h"
#include "..\..\..\IM1Decoders\AFX\FootPrint\FPSet.h"
#include "..\..\..\IM1Decoders\AFX\FootPrint\FPBuilding.h"
#include "Nodes.h"
#include <GL/gl.h>
#include <GL/glu.h>

#include "opengl/appearance/AppearanceProxy.h"

#ifndef CALLBACK 
#define CALLBACK __stdcall
#endif

#ifndef BYTE
typedef unsigned char BYTE;
#endif

#ifndef LPBYTE
typedef BYTE* LPBYTE;
#endif


class FacadeProxy : public AfxStreamProxy
{
public:
	/// Constructor
	FacadeProxy(Facade* facade);
	FacadeProxy(Facade* facade, FPFacade* fpFacade);
	
	~FacadeProxy(void);

//	inline FPSet* GetFPSet() {return m_pFPSet;};
	inline void SetFPFacade (FPFacade* fpFacade) { m_pFacade=fpFacade; };
	inline FPFacade* GetFPFacade() {return m_pFacade;};


	/// Render object
	virtual BOOL  Render(OpenGLVisualRenderer* pRenderer, DWORD dwTime);
	virtual BOOL  RenderFromStream(MediaStream* poStream, int id, DWORD dwTime);
	virtual BOOL  RenderFromBuffer(SFString *buffer, int id);
	virtual BOOL  Render(DWORD dwTime);
	virtual void  RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

	/// Traverse scene graph, checking for intersection
	virtual BOOL  Select(OpenGLVisualRenderer* pRenderer, DWORD dwTime, unsigned int& depth);

	inline Facade * GetFacadeNode() const { return (Facade *) GetMediaObject(); }

	inline bool Is3DReconstructed () {return m_bIs3DReconstructed;};
	inline void SetIs3DReconstructed (bool state) {m_bIs3DReconstructed=state;};

	// textures
	AppearanceProxy* LoadTexture(char* ID, OpenGLVisualRenderer* pRenderer, DWORD dwTime) const;
	void UnLoadTexture(AppearanceProxy* pAppProxy, OpenGLVisualRenderer* pRenderer, DWORD dwTime) const;
	
	// models
	MediaObject* FindModel3D(FPFacade* pElt, OpenGLVisualRenderer* pRenderer, DWORD dwTime)  const;
	void AddModel3D(FPFacade* pElt, MediaObject* pModel, OpenGLVisualRenderer* pRenderer, DWORD dwTime) const;
	
	// to construc model
	int FillElementWithModel(FPFacade* pElt, MediaObject* pModel) const;
	int ParseGroup(FPFacade* pElt, Group* pGroup, ZArray<ModelGeometry>* geoms) const;
	int ParseShape(FPFacade* pElt, Shape* pShape, ZArray<ModelGeometry>* geoms) const;
	int ParseTransform(FPFacade* pElt, Transform* pTransform, ZArray<ModelGeometry>* geoms) const;
	int ParseChildren(FPFacade* pElt, MediaObject* pObj, ZArray<ModelGeometry>* geoms) const;
	int ParseBox(Box* pBox, ZArray<ModelGeometry>* geoms) const;
	int ParseIndexedFaceSet(IndexedFaceSet* pIfs, ZArray<ModelGeometry>* geoms) const;
	bool IsGroup(MediaObject* pObj) const;
	bool IsShape(MediaObject* pObj) const;
	bool IsTransform(MediaObject* pObj) const;


protected :
	bool  m_bInit;
    DWORD m_lastTime;
	bool m_bIs3DReconstructed;
	FPFacade* m_pFacade;
//	bool m_bmutex;
//	FPSet* m_pFPSet;

};


#endif // !defined(AFX_FootPrintProxy_H__93F1CF93_D37D_11D5_B9F1_000102A02E5B__INCLUDED_)
