/********************************************************************************/
/* This software module was developped by										*/

/*	   Royan Jerome , jerome.royan@francetelecom.com							*/
/*                   France Telecom R&D, France		*/

/* in the course of development of the MPEG-4 standard (Part 16 AFX).			*/
/* This software module is an implementation of a part of one or				*/
/* more MPEG-4 tools as specified by the										*/
/* MPEG-4 standard. ISO/IEC gives users of the MPEG-4 standard					*/
/* free license to this software module or modifications thereof				*/
/* for use in hardware or software products claiming conformance				*/
/* to the MPEG-4 standard. Those intending to use this software					*/
/* module in hardware or software products are advised that its					*/
/* use may infringe existing patents. The original developer of					*/
/* this software module and his company, the subsequent							*/
/* editors and their companies, and ISO/IEC have no liability					*/
/* for use of this software module or modifications thereof in					*/
/* an implementation. Copyright is not released for non							*/
/* MPEG-4 standard conforming products. INT ARTEMIS								*/
/* retain full right to use the code for their own purposes,					*/
/* assign or donate the code to a third party and to inhibit					*/
/* third parties from using the code for non MPEG-4 standard					*/
/* conforming products. This copyright notice must be included					*/
/* in all copies or derivative works.    										*/
/* Copyright (c)2002 - 2005														*/
/********************************************************************************/

// FootPrintSetProxy.cpp: implementation of the FootPrintSetProxy class.
// dependences :
//////////////////////////////////////////////////////////////////////

#include "FootPrintProxy.h"
#include "IM1Decoders/AFX/AFX.h"
//#include "IM1Decoders/AFX/FootPrintDecoder.h"

#include "opengl/group/GroupProxy.h"
#include "opengl/group/SwitchProxy.h"
#include "opengl/group/InlineProxy.h"
#include "opengl/geometry/ShapeProxy.h"
//#include "opengl/geometry/TransformProxy.h"
#include "opengl/base/OpenGLVisualRenderer.h"
#include "opengl/base/OpenGLPresenter.h"
#include "Presenter.h"
#include "Inline.h"
/*
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif
*/


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


FootPrintProxy::FootPrintProxy(FootPrint* footprint)
  : AfxStreamProxy(footprint)
{
  m_bInit = false;
  m_lastTime = 0;
//  m_bIs3DReconstructed=false;
}

FootPrintProxy::FootPrintProxy(FootPrint* footprint, FP* fp)
  : AfxStreamProxy(footprint)
{
  fp->SetMediaObject((MediaObject*)GetFootPrintNode());
  m_pFootPrint=fp;
  m_bInit = false;
  m_lastTime = 0;
//  m_bIs3DReconstructed=false;
}

FootPrintProxy::~FootPrintProxy(void)
{

}

BOOL FootPrintProxy::Select(OpenGLVisualRenderer* pRenderer, DWORD dwTime, unsigned int& depth)
{
  GLuint selectBuffer[4];

  ::glSelectBuffer(4, selectBuffer);
  ::glRenderMode(GL_SELECT);

  Render(pRenderer, dwTime);

  if (::glRenderMode(GL_RENDER) > 0)
    if (depth >= selectBuffer[1]) {
      depth = selectBuffer[1];

      return TRUE;
    }

  return FALSE;
}

BOOL FootPrintProxy::RenderFromStream(MediaStream* poStream, int id, DWORD dwTime)
{
  // it is called by BitWrapper
  // it should retrieve from the decoder the data and initialise the fields

  // first time get the decoder specific info from the stream

  // get the stream
 
  // get the decoded data buffer
 
	//Copy the decoded mesh into the composition buffer
	//DataExchange();
	

	
	// update time

	  return TRUE;
}

BOOL FootPrintProxy::RenderFromBuffer(SFString *buffer, int id)
{
  
  return TRUE;
}

BOOL FootPrintProxy::Render(DWORD dwTime)
{

/*	glPushAttrib(GL_POLYGON_BIT);

	glEnable(GL_LIGHTING);
	glCullFace(GL_FRONT_AND_BACK);

	if (m_pFootPrint->Type()==BUILDING)
	{
		FPBuilding* b=(FPBuilding*)(m_pFootPrint);
		if (b->State3D()==COMPUTED)
		{
			Render_Facade(b, OpenGLVisualRenderer* pRenderer, dwTime);
//			Render_Roof(b);

//			Render_Facades(b); // Fo d'abord faire la reconstruction Anne Jerome
		}
	}

	glDisable(GL_LIGHTING);

	glPopAttrib();
	*/

	return TRUE;
}

BOOL FootPrintProxy::Render(OpenGLVisualRenderer* pRenderer, DWORD dwTime)
{
  // called when the node is encoded with BIFS
 // Render(dwTime);

	glPushAttrib(GL_POLYGON_BIT);

	glEnable(GL_LIGHTING);
	glCullFace(GL_FRONT_AND_BACK);

	glColor4f(1.0,0.0,0.0,1.0);
	FootPrint* pFootPrint = (FootPrint*) GetMediaObject();

	IndexedLineSet2D* ils=(IndexedLineSet2D*) pFootPrint->footprint.GetNode();

	Vec2f vertex= ils->coord->point[0];
	int index=ils->coordIndex[0];

	IndexedLineSet2DProxy* ilsProxy=(IndexedLineSet2DProxy*) ils->GetRenderingObject();

	Vec2f vertexproxy=ilsProxy->GetCoord()->point[0];
	int indexproxy=ilsProxy->GetCoordIndex()[0];

	ilsProxy->Render(pRenderer,dwTime);
	//pFootPrint->footprint.GetNode()->GetRenderingObject()->Render(pRenderer);

	Vec2f vertexproxy1=ilsProxy->GetCoord()->point[0];
	int indexproxy1=ilsProxy->GetCoordIndex()[0];

	glDisable(GL_LIGHTING);

	glPopAttrib();
  return TRUE; 
}

void FootPrintProxy::RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime)
{
  FootPrint* pFootPrint = (FootPrint*) GetMediaObject();
  GLfloat color[] = { 0.0f, 1.0f, 0.0f, 0.75f};

  glColor4fv(color);

  RenderDescriptionBox(pRenderer, "FootPrint");
}
/*
void FootPrintProxy::Render_Roof(FPBuilding* b, OpenGLVisualRenderer* pRenderer, DWORD dwTime) const
{
	unsigned int i, j;
	
	Vec2f** footprint=b->FootPrint();
	unsigned int* nbVerticesByRing=b->NbVerticesByRing();
	int nbRings=b->NbRings();

	ZArray<FPRoof*>* roofs=b->GetRoofs();

	glPushMatrix();
	for (int num_roof=0; num_roof<roofs->GetLength(); num_roof++)
	{
		FPRoof* roof=(*roofs)[num_roof];
		glColor4f(0.3,0.3,0.3,1.0);
		AppearanceProxy* pAppProxy = LoadTexture(roof->GetTexURL(), pRenderer, dwTime);
		for (int num_fp=0; num_fp<roof->GetNbFootprints(); num_fp++)
		{
			float* vertices = roof->GetVertices()[num_fp];
			glInterleavedArrays(GL_T2F_N3F_V3F, 0, vertices);
								
			for (int i=0; i<roof->GetNbSlopes()[num_fp]; i++)
			{
				unsigned int* indices = roof->GetPolygonIndices()[num_fp][i]; 
				glDrawElements(GL_POLYGON, roof->GetNbVerticesBySlope()[num_fp][i], GL_UNSIGNED_INT, roof->GetPolygonIndices()[num_fp][i]);
			}
		}
		UnLoadTexture(pAppProxy, pRenderer, dwTime);
	}
	glPopMatrix();
}

void FootPrintProxy::Render_Facade(FPBuilding* b, OpenGLVisualRenderer* pRenderer, DWORD dwTime) const
{
	Vec2f** footprint=b->FootPrint();
	unsigned int* nbVerticesByRing=b->NbVerticesByRing();
	int nbRings=b->NbRings();
	ZArray<FPFacade*>* facades=b->GetFacades();

	for (int num_facade=0; num_facade<facades->GetLength(); num_facade++)
	{
		FPFacade* facade = (*facades)[num_facade];
		Render_FacadeElement(facade, pRenderer, dwTime);
	}
}


void FootPrintProxy::Render_FacadeElement(FPFacade* pElement, OpenGLVisualRenderer* pRenderer, DWORD dwTime) const
{
	AppearanceProxy* pAppProxy = NULL;
		
	if (pElement == NULL)
		return; 

	// render child first in order to load models
	if (pElement->HasChild())
	{
		ZArray<ZArray<FPFacade*>* >* elements = pElement->GetElements();

		int nStories = pElement->GetNbStories();
		for (int j=0; j<nStories; j++)
		{
			ZArray<FPFacade*>* storeyelements = elements->ElementAt(j);
			int nElements = storeyelements->GetLength();

			for (int k=0; k<nElements; k++)
			{
				Render_FacadeElement(storeyelements->ElementAt(k), pRenderer, dwTime);
			}
		}
	}
	
	// texture ON
	if (pElement->HasTexture())
	{
		pAppProxy = LoadTexture(pElement->GetURL(), pRenderer, dwTime);
	}

	// compute if needed
	switch (pElement->GetDisplayType())
	{
	case TRIANGLES:
		if (pElement->GetState() == STATE_WAITING_CHILD_MODEL)
		{
			// include model(s)
			pElement->ComputeFacade();
			pElement->SetState(STATE_DONE);
		}
		break;
	}

	// now get vertices
	float* vertices=pElement->GetVertices();
	glInterleavedArrays(GL_T2F_N3F_V3F, 0, vertices);
	unsigned int* indices = NULL;
	int nbTris = 0;
	unsigned int** lineindices = NULL;
	int nbQuads = 0;
	int nbLines = 0;
	int i;

	switch (pElement->GetDisplayType())
	{
	case EMPTY:
#ifdef SHOW_LINES
		lineindices=pElement->GetIndicesLines();
		nbLines = pElement->GetNbLines();
		for (i=0; i<nbLines; i++)
		{
			glDrawElements(GL_LINE_STRIP, 2 ,GL_UNSIGNED_INT, lineindices[i]);

		}
#endif	
		break;

	case QUAD:
		indices=pElement->GetIndicesQuads();
		nbQuads = pElement->GetNbQuads();
		if ((indices != NULL) && (nbQuads > 0))
			glDrawElements(GL_QUADS, 4*nbQuads ,GL_UNSIGNED_INT, indices);
		break;

	case TRIANGLES:
		indices = pElement->GetIndicesTriangles();
		nbTris = pElement->GetNbTriangles();
		if ((indices != NULL) && (nbTris > 0))
			glDrawElements(GL_TRIANGLES, 3*nbTris ,GL_UNSIGNED_INT, indices);
		break;

	case MODEL3D:
		// render this element
		if (pElement->GetState() == STATE_WAITING_MODEL)  
		{
			MediaObject* pModel = FindModel3D(pElement, pRenderer, dwTime);
			if (pModel == NULL) return;

			MediaObjectProxy* pObjProxy = (MediaObjectProxy*)pModel->GetRenderingObject();
		
			int nRet = FillElementWithModel(pElement, pModel);
			if (nRet != 0)
			{
				// do not try again
				pElement->SetState(STATE_DONE);
				return;
			}
			
			pElement->ComputeElement();
			pElement->SetState(STATE_DONE);

			// now display model(s)
			AddModel3D(pElement, pModel, pRenderer, dwTime);
			return;
		}
		break;
	}

	// texture OFF
	if (pElement->HasTexture())
	{
		UnLoadTexture(pAppProxy, pRenderer, dwTime);
	}
}

AppearanceProxy* FootPrintProxy::LoadTexture(char* ID, OpenGLVisualRenderer* pRenderer, DWORD dwTime) const
{
	Root* pSceneRoot = NULL;
	OpenGLPresenter* pPresenter = NULL;
	AppearanceProxy* pAppProxy = NULL;
	Appearance* pAppearance = NULL;

	pPresenter = pRenderer->GetPresenter();
	if (pPresenter != NULL)
	{
		pSceneRoot = pPresenter->GetScene();
	}
	if (pSceneRoot != NULL)
	{
		pAppearance=(Appearance*)pSceneRoot->FindNode(ID);
	}
	if (pAppearance!=NULL)
	{
		pAppProxy=(AppearanceProxy*)pAppearance->GetRenderingObject();
	}
	if (pAppProxy != NULL)
	{
		pAppProxy->Enable(pRenderer, dwTime);
	}

	return pAppProxy;
}

void FootPrintProxy::UnLoadTexture(AppearanceProxy* pAppProxy, OpenGLVisualRenderer* pRenderer, DWORD dwTime) const
{
	if (pAppProxy != NULL)
	{
		pAppProxy->Disable(pRenderer, dwTime);
	}
}

MediaObject* FootPrintProxy::FindModel3D(FPFacade* pElt, OpenGLVisualRenderer* pRenderer, DWORD dwTime)  const
{
	Root* pSceneRoot = NULL;
	OpenGLPresenter* pPresenter = NULL;
	Switch* pSwitch = NULL;
	MediaObject* pModel = NULL;
	Group* pGroup = NULL;

	pPresenter = pRenderer->GetPresenter();
	if (pPresenter != NULL)
	{
		pSceneRoot = pPresenter->GetScene();
	}
	if (pSceneRoot != NULL)
	{
		char* ID = pElt->GetURL();
		//pSwitch = (Switch*)pSceneRoot->FindNode("s0");
		pGroup = (Group*)pSceneRoot->FindNode(ID);
	}
	if (pGroup != NULL)
	{
		pModel = pGroup;
	}
	else if (pSwitch != NULL)
	{
//		pSceneRoot->GetExecutive()->LockScene();
//		pSwitch->whichChoice=0;   // to turn on group in switch
//		pSceneRoot->GetExecutive()->UnlockScene();
	}

	return pModel; 
}

void FootPrintProxy::AddModel3D(FPFacade* pElt, MediaObject* pModel, OpenGLVisualRenderer* pRenderer, DWORD dwTime) const
{
	Root* pSceneRoot = NULL;  
	OpenGLPresenter* pPresenter = NULL;
	int nModels = 0;
	float* translations = NULL;
	
	pPresenter = pRenderer->GetPresenter();
	if (pPresenter != NULL)
	{
		pSceneRoot = pPresenter->GetScene();
	}

	nModels = pElt->GetNbModels();
	if (nModels <= 0) return;

	translations = pElt->GetModelTranslations();
	if (translations == NULL) return;

	// position model in vertical plane
	Rotation rotvertical;
	
	rotvertical.x=1;
	rotvertical.y=0;
	rotvertical.z=0;
	rotvertical.theta=M_PI/2;
	// rotate vertical plane to match facade plane 
	Rotation rotfacade;
	rotfacade.x=0;
	rotfacade.y=0;
	rotfacade.z=1;
	float xF=pElt->GetXFacade();
	float yF=pElt->GetYFacade();
	float alpha=atan2(yF, xF);
	rotfacade.theta=alpha;//-M_PI/2;
	//rotfacade.theta=M_PI/2;
	for (int i=0; i<nModels; i++)
	{
		// create transform
		Transform* pTransform = new Transform;
		pTransform->SetExecutive(pPresenter->GetExecutive());

		Transform* pTransformVertical = new Transform;
		pTransformVertical->SetExecutive(pPresenter->GetExecutive());

		// scale model
		float xs = pElt->GetScaleModelX();
		float ys = pElt->GetScaleModelY();
		float zs = pElt->GetScaleModelZ();
		pTransformVertical->scale = Vec3f(xs, ys, zs);
		pTransformVertical->rotation = rotvertical;


		// translation
		if (translations!=NULL)
		{
			float xt = translations[3*i];
			float yt = translations[3*i+1];
			float zt = translations[3*i+2];
			//pTransform->translation = Vec3f(xt, zt, -yt);
			pTransform->translation = Vec3f(xt, yt, zt);
		}
		// rotation
		pTransform->rotation = rotfacade;
	
		// add model to scene
		pTransformVertical->AddChild(pModel);
		pTransform->AddChild(pTransformVertical);
		pSceneRoot->AddChild(pTransform);
	}
}

int FootPrintProxy::FillElementWithModel(FPFacade* pElt, MediaObject* pModel) const
{
	if (pElt == NULL)
		return -1;
	
	if (pModel == NULL)
		return -1;

	// fill facade element with model index face set
	ZArray<ModelGeometry> geoms;
	ParseChildren(pElt, (Group*)pModel, &geoms);

	int ngeoms = geoms.GetLength();
	for (int i=0; i<ngeoms; i++)
	{
		ModelGeometry geom = geoms[i];
		pElt->AddModelGeometry(geom.m_nVtx, geom.m_aVtx, geom.m_nIdx, geom.m_aIdx);
	}

	return 0;
}

bool FootPrintProxy::IsGroup(MediaObject* pObj) const
{
	return true;
}

bool FootPrintProxy::IsShape(MediaObject* pObj) const
{
	char* name = pObj->GetName();
	if (name == NULL)
		return false;

	if (stricmp(name, "Shape") == 0)
		return true;

	return false;
}

bool FootPrintProxy::IsTransform(MediaObject* pObj) const
{
	char* name = pObj->GetName();
	if (name == NULL)
		return false;

	if (stricmp(name, "Transform") == 0)
		return true;

	return false;
}

int FootPrintProxy::ParseGroup(FPFacade* pElt, Group* pGroup, ZArray<ModelGeometry>* geoms) const
{
	int nRet = 0;
	int nChild = pGroup->GetChildCount();
	
	for (int i=0; i<nChild; i++)
	{
		ZArray<ModelGeometry>* childgeoms = new ZArray<ModelGeometry>;
		
		MediaObject* pChild = pGroup->GetChild(i);

		if (IsTransform(pChild))
			ParseTransform(pElt, (Transform*)pChild, childgeoms);
		else if (IsShape(pChild))
			ParseShape(pElt, (Shape*)pChild, childgeoms);
		else if (IsGroup(pChild))
			ParseGroup(pElt, (Group*)pChild, childgeoms);

		int nCount = childgeoms->GetLength();
		for (int i=0; i<nCount; i++)
			(*geoms) += (*childgeoms)[i];
		
	}
	return nRet;
}

int FootPrintProxy::ParseChildren(FPFacade* pElt, MediaObject* pObj, ZArray<ModelGeometry>* geoms) const
{
	if (pObj == NULL)
		return -1;

	int nChild=pObj->GetChildrenCount();
	for (int i=0; i<nChild; i++)
	{
		ZArray<ModelGeometry>* childgeoms = new ZArray<ModelGeometry>;
		
		MediaObject* pChild = pObj->GetChild(i);

		if (IsTransform(pChild))
			ParseTransform(pElt, (Transform*)pChild, childgeoms);
		else if (IsShape(pChild))
			ParseShape(pElt, (Shape*)pChild, childgeoms);
		else if (IsGroup(pChild))
			ParseGroup(pElt, (Group*)pChild, childgeoms);		
		int nCount = childgeoms->GetLength();
		for (int i=0; i<nCount; i++)
			(*geoms) += (*childgeoms)[i];
		
	}
	return 0;
}

int FootPrintProxy::ParseTransform(FPFacade* pElt, Transform* pTransform, ZArray<ModelGeometry>* geoms) const
{
	int nRet = -1;
	
	if (pTransform == NULL)
		return -1;

	ZArray<ModelGeometry> childgeoms;
	ParseChildren(pElt, pTransform, &childgeoms);
	
	// Translation
	Vec3f vt = pTransform->translation;
	float xt = vt.x; 
	float yt = vt.y; 
	float zt = vt.z;

	// Rotation
	Rotation rot = pTransform->rotation;
	float angle=rot.theta;
	float x_angle=rot.x;
	float y_angle=rot.y;
	float z_angle=rot.z;

	float module=(float)sqrt(x_angle*x_angle+y_angle*y_angle+z_angle*z_angle);
	float q1,q2,q3,qw;

	// check module
	if (0.0f==module)
		module=1.0f;

	// compute quaternions
	q1=x_angle*(float)sin(-angle/2.0f)/module;
	q2=y_angle*(float)sin(-angle/2.0f)/module;
	q3=z_angle*(float)sin(-angle/2.0f)/module;
	qw=(float)cos(-angle/2.0f);

	float Rot[9];
	// compute first row
	Rot[0]=qw*qw+q1*q1-q2*q2-q3*q3;
	Rot[1]=2.0f*(q1*q2+qw*q3);
	Rot[2]=2.0f*(q1*q3-qw*q2);        

	// compute second row
	Rot[3]=2.0f*(q1*q2-qw*q3);
	Rot[4]=qw*qw-q1*q1+q2*q2-q3*q3;
	Rot[5]=2.0f*(q2*q3+qw*q1);        

	// compute third row
	Rot[6]=2.0f*(q1*q3+qw*q2);        
	Rot[7]=2.0f*(q2*q3-qw*q1);        
	Rot[8]=qw*qw-q1*q1-q2*q2+q3*q3;        

	//rotation->unref();

	// scale
	Vec3f vscale = pTransform->scale;
	float xs = vscale.x;
	float ys = vscale.y;
	float zs = vscale.z;
	
	// apply transforms to 3d coordinates
	int ngeoms = childgeoms.GetLength();
	for (int i=0; i<ngeoms; i++)
	{
		ModelGeometry geom = childgeoms[i];
		int nvtx = geom.m_nVtx;
		for (int j=0; j<nvtx; j++)
		{
			// apply scale
			float x1 = geom.m_aVtx[3*j]*xs;
			float y1 = geom.m_aVtx[3*j+1]*ys;
			float z1 = geom.m_aVtx[3*j+2]*zs;

			// apply rotation
			float x2 = x1*Rot[0]+y1*Rot[1]+z1*Rot[2];
			float y2 = x1*Rot[3]+y1*Rot[4]+z1*Rot[5];
			float z2 = x1*Rot[6]+y1*Rot[7]+z1*Rot[8];

			// apply translation
			float x3 = x2 + xt;
			float y3 = y2 + yt;
			float z3 = z2 + zt;

			// set new values
			geom.m_aVtx[3*j] = x3;
			geom.m_aVtx[3*j+1] = y3;
			geom.m_aVtx[3*j+2] = z3;
		}

		(*geoms) += geom;
	}

	return 0;
}

int FootPrintProxy::ParseShape(FPFacade* pElt, Shape* pShape, ZArray<ModelGeometry>* geoms) const
{
	int nRet = -1;
	IndexedFaceSet* pIfs = NULL;
	Box* pBox = NULL;
	int i=0;
	
	if (pShape == NULL)
		return -1;

	ShapeProxy* pShapeProxy = (ShapeProxy*)pShape->GetRenderingObject();
	if (pShapeProxy == NULL)
		return -1;

	Geometry* pGeometry = (Geometry*)pShapeProxy->GetGeometry();
	if (pGeometry == NULL)
		return -1;

	pIfs = (IndexedFaceSet*)pGeometry;
	int nCode = pIfs->GetNodeCode();
	
	switch(nCode)
	{
	case CODE_Box:
		pBox = (Box*)pGeometry;
		ParseBox(pBox, geoms);
		nRet = 0;
		break;

	case CODE_IndexedFaceSet:
		ParseIndexedFaceSet(pIfs, geoms);
		nRet = 0;
		break;
	}

	return nRet;
}


int FootPrintProxy::ParseBox(Box* pBox, ZArray<ModelGeometry>* geoms) const
{
	ModelGeometry geom;
	float aIdxBox[] = { 0, 1, 2, 3, -1,
					    0, 1, 5, 4, -1,
					    1, 2, 6, 5, -1,
					    2, 3, 7, 6, -1,
					    3, 0, 4, 7, -1,
					    4, 5, 6, 7, -1 };
	float dx = pBox->size.GetValue().x;
	float dy = pBox->size.GetValue().y;
	float dz = pBox->size.GetValue().z;

	// indices
	geom.m_nIdx = 4*6 + 6;
	geom.m_aIdx = (int*)malloc(geom.m_nIdx*sizeof(int));
	for (int i=0; i<geom.m_nIdx; i++)
		geom.m_aIdx[i] = aIdxBox[i];

	// vertices
	geom.m_nVtx = 8;
	geom.m_aVtx = (float*)malloc(geom.m_nVtx*3*sizeof(float));

	// bottom
	// front left
	i=0;
	geom.m_aVtx[i*3] = -dx/2;
	geom.m_aVtx[i*3+1] = -dy/2;
	geom.m_aVtx[i*3+2] = -dz/2;

	// front right
	i=1;
	geom.m_aVtx[i*3] = dx/2;
	geom.m_aVtx[i*3+1] = -dy/2;
	geom.m_aVtx[i*3+2] = -dz/2;

	// back right
	i=2;
	geom.m_aVtx[i*3] = dx/2;
	geom.m_aVtx[i*3+1] = dy/2;
	geom.m_aVtx[i*3+2] = -dz/2;

	// back left
	i=3;
	geom.m_aVtx[i*3] = -dx/2;
	geom.m_aVtx[i*3+1] = dy/2;
	geom.m_aVtx[i*3+2] = -dz/2;

	// top
	// front left
	i=4;
	geom.m_aVtx[i*3] = -dx/2;
	geom.m_aVtx[i*3+1] = -dy/2;
	geom.m_aVtx[i*3+2] = dz/2;

	// front right
	i=5;
	geom.m_aVtx[i*3] = dx/2;
	geom.m_aVtx[i*3+1] = -dy/2;
	geom.m_aVtx[i*3+2] = dz/2;

	// back right
	i=6;
	geom.m_aVtx[i*3] = dx/2;
	geom.m_aVtx[i*3+1] = dy/2;
	geom.m_aVtx[i*3+2] = dz/2;

	// back left
	i=7;
	geom.m_aVtx[i*3] = -dx/2;
	geom.m_aVtx[i*3+1] = dy/2;
	geom.m_aVtx[i*3+2] = dz/2;	

	(*geoms) += geom;
	return 0;
}

int FootPrintProxy::ParseIndexedFaceSet(IndexedFaceSet* pIfs, ZArray<ModelGeometry>* geoms) const 
{
	ModelGeometry geom;
	
	// indices
	geom.m_nIdx = pIfs->coordIndex.GetLength();
	geom.m_aIdx = (int*)malloc(geom.m_nIdx*sizeof(int));
	for (int i=0; i<geom.m_nIdx; i++)
	{
		geom.m_aIdx[i] = pIfs->coordIndex[i];
	}
	
	// array of vertices
	SFNode<class Coordinate>* pCoordinate = (SFNode<class Coordinate>*) pIfs->GetField(5);
	MF<Vec3f>* pPoint = (MF<Vec3f>*) pCoordinate->GetNode()->GetField(0);

	// number of vertices
	geom.m_nVtx = pPoint->GetLength();
	geom.m_aVtx = (float*)malloc(geom.m_nVtx*3*sizeof(float));
	for (i=0; i<geom.m_nVtx; i++)
	{
		Vec3f pt = (*pPoint)[i];
		geom.m_aVtx[i*3] = pt.x;
		geom.m_aVtx[i*3+1] = pt.y;
		geom.m_aVtx[i*3+2] = pt.z;
	}

	(*geoms) += geom;
	return 0;
}


Tess_Poly::Init(GLvoid)
{
	// Create a new tessellation object 
	tobj = gluNewTess(); // Set callback functions
	gluTessCallback(tobj, GLU_TESS_VERTEX, (GLvoid (CALLBACK *) ( )) &vertexCallback);
	gluTessCallback(tobj, GLU_TESS_BEGIN, (GLvoid (CALLBACK *) ( )) &glBegin);
	gluTessCallback(tobj, GLU_TESS_END, (GLvoid (CALLBACK *) ( )) &glEnd);
	//gluTessCallback(tobj, GLU_TESS_COMBINE, (GLvoid (CALLBACK *) ( ))&combineCallback);
	return(1);
}


Tess_Poly::Set_Winding_Rule(GLenum winding_rule)
{
	// Set the winding rule
	gluTessProperty(tobj, GLU_TESS_WINDING_RULE, winding_rule); return(1);
}

void Tess_Poly::Render_Roof(FPBuilding* b)
{
	unsigned int i, j;
	
	unsigned int* nbVerticesByRing=b->NbVerticesByRing();
	int nbRings=b->NbRings();

}

Tess_Poly::End(GLvoid)
{
	gluDeleteTess(tobj);
	return(1);
}


void CALLBACK combineCallback(GLdouble coords[3], GLdouble *vertex_data[4], GLfloat weight[4], GLdouble **dataOut)
{

}

void CALLBACK vertexCallback(GLvoid *vertex)
{
	GLdouble *ptr;
	ptr = (GLdouble *) vertex;
	glNormal3dv((GLdouble *) ptr+3);
	glVertex3dv((GLdouble *) ptr);
	
}
*/


