/********************************************************************************/
/* This software module was developped by										*/

/*	   Jerome Royan (MP), jerome.royan@francetelecom.com,						*/
/*                        France Telecom R&D, France							*/

/* in the course of development of the MPEG-4 standard (Part 16 AFX).			*/
/* This software module is an implementation of a part of one or				*/
/* more MPEG-4 tools as specified by the										*/
/* MPEG-4 standard. ISO/IEC gives users of the MPEG-4 standard					*/
/* free license to this software module or modifications thereof				*/
/* for use in hardware or software products claiming conformance				*/
/* to the MPEG-4 standard. Those intending to use this software					*/
/* module in hardware or software products are advised that its					*/
/* use may infringe existing patents. The original developer of					*/
/* this software module and his company, the subsequent							*/
/* editors and their companies, and ISO/IEC have no liability					*/
/* for use of this software module or modifications thereof in					*/
/* an implementation. Copyright is not released for non							*/
/* MPEG-4 standard conforming products. INT ARTEMIS								*/
/* retain full right to use the code for their own purposes,					*/
/* assign or donate the code to a third party and to inhibit					*/
/* third parties from using the code for non MPEG-4 standard					*/
/* conforming products. This copyright notice must be included					*/
/* in all copies or derivative works.    										*/
/* Copyright (c)2002 - 2005														*/
/********************************************************************************/

// FootPrintProxy.h: interface for the FootPrintProxy class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FootPrintProxy_H__93F1CF93_D37D_11D5_B9F1_000102A02E5B__INCLUDED_)
#define AFX_FootPrintProxy_H__93F1CF93_D37D_11D5_B9F1_000102A02E5B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\AfxStreamProxy.h"
//#include "..\..\geometry\IndexedLineSet2DProxy.h"
#include "..\..\..\IM1Decoders\AFX\FootPrint\FPSet.h"
#include "..\..\..\IM1Decoders\AFX\FootPrint\FPBuilding.h"
#include "Nodes.h"
#include <GL/gl.h>
#include <GL/glu.h>

#include "opengl/appearance/AppearanceProxy.h"
#include "opengl/geometry/IndexedLineSet2DProxy.h"

#ifndef CALLBACK 
#define CALLBACK __stdcall
#endif

#ifndef BYTE
typedef unsigned char BYTE;
#endif

#ifndef LPBYTE
typedef BYTE* LPBYTE;
#endif


void CALLBACK combineCallback(GLdouble coords[3], GLdouble *vertex_data[4], GLfloat weight[4], GLdouble **dataOut);
void CALLBACK vertexCallback(GLvoid *vertex);

class Tess_Poly {

private:
	
	GLUtesselator *tobj; // the tessellation object

public:
	
int Init(GLvoid);
int End(GLvoid);
int Set_Winding_Rule(GLenum winding_rule);
void Render_Roof(FPBuilding* b);
};

/*
class ModelGeometry
{
public:
	ModelGeometry() : m_nVtx(0), m_aVtx(NULL), m_nIdx(0), m_aIdx(NULL) {};
	ModelGeometry(int nVtx, float* aVtx, int nIdx, int* aIdx) : m_nVtx(nVtx), m_aVtx(aVtx), m_nIdx(nIdx), m_aIdx(aIdx) {};
	~ModelGeometry() {};

public:
	int		m_nVtx;		// number of vertices
	float*	m_aVtx;		// coord of vertices
	int		m_nIdx;		// size of indexfacette
	int*	m_aIdx;		// index facette
};*/


class FootPrintProxy : public AfxStreamProxy
{
public:
	/// Constructor
	FootPrintProxy(FootPrint* footprint);
	FootPrintProxy(FootPrint* footprint, FP* fp);
	
	~FootPrintProxy(void);

//	inline FPSet* GetFPSet() {return m_pFPSet;};
	inline void SetFP (FP* footprint) { m_pFootPrint=footprint; };
	inline FP* GetFP() {return m_pFootPrint;};


	/// Render object
	virtual BOOL  Render(OpenGLVisualRenderer* pRenderer, DWORD dwTime);
	virtual BOOL  RenderFromStream(MediaStream* poStream, int id, DWORD dwTime);
	virtual BOOL  RenderFromBuffer(SFString *buffer, int id);
	virtual BOOL  Render(DWORD dwTime);
	virtual void  RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

	/// Traverse scene graph, checking for intersection
	virtual BOOL  Select(OpenGLVisualRenderer* pRenderer, DWORD dwTime, unsigned int& depth);

	inline FootPrint * GetFootPrintNode() const
	{ return (FootPrint *) GetMediaObject(); }

	inline bool Is3DReconstructed () {return m_bIs3DReconstructed;};
	inline void SetIs3DReconstructed (bool state) {m_bIs3DReconstructed=state;};

/*
	// textures
	AppearanceProxy* LoadTexture(char* ID, OpenGLVisualRenderer* pRenderer, DWORD dwTime) const;
	void UnLoadTexture(AppearanceProxy* pAppProxy, OpenGLVisualRenderer* pRenderer, DWORD dwTime) const;
	
	// models
	MediaObject* FindModel3D(FPFacade* pElt, OpenGLVisualRenderer* pRenderer, DWORD dwTime)  const;
	void AddModel3D(FPFacade* pElt, MediaObject* pModel, OpenGLVisualRenderer* pRenderer, DWORD dwTime) const;
	
	// render
	void Render_Roof(FPBuilding* b, OpenGLVisualRenderer* pRenderer, DWORD dwTime) const;
	void Render_Facade(FPBuilding* b, OpenGLVisualRenderer* pRenderer, DWORD dwTime) const;
	void Render_FacadeElement(FPFacade* facade, OpenGLVisualRenderer* pRenderer, DWORD dwTime) const;

	// to construc model
	int FillElementWithModel(FPFacade* pElt, MediaObject* pModel) const;
	int ParseGroup(FPFacade* pElt, Group* pGroup, ZArray<ModelGeometry>* geoms) const;
	int ParseShape(FPFacade* pElt, Shape* pShape, ZArray<ModelGeometry>* geoms) const;
	int ParseTransform(FPFacade* pElt, Transform* pTransform, ZArray<ModelGeometry>* geoms) const;
	int ParseChildren(FPFacade* pElt, MediaObject* pObj, ZArray<ModelGeometry>* geoms) const;
	int ParseBox(Box* pBox, ZArray<ModelGeometry>* geoms) const;
	int ParseIndexedFaceSet(IndexedFaceSet* pIfs, ZArray<ModelGeometry>* geoms) const;
	bool IsGroup(MediaObject* pObj) const;
	bool IsShape(MediaObject* pObj) const;
	bool IsTransform(MediaObject* pObj) const;
*/

protected :
	bool  m_bInit;
    DWORD m_lastTime;
	bool m_bIs3DReconstructed;
	FP* m_pFootPrint;
//	bool m_bmutex;
//	FPSet* m_pFPSet;

};


#endif // !defined(AFX_FootPrintProxy_H__93F1CF93_D37D_11D5_B9F1_000102A02E5B__INCLUDED_)
