/********************************************************************************/
/* This software module was developped by										*/

/*	   Jerome Royan (MP), jerome.royan@francetelecom.com,						*/
/*                        France Telecom R&D, France							*/

/* in the course of development of the MPEG-4 standard (Part 16 AFX).			*/
/* This software module is an implementation of a part of one or				*/
/* more MPEG-4 tools as specified by the										*/
/* MPEG-4 standard. ISO/IEC gives users of the MPEG-4 standard					*/
/* free license to this software module or modifications thereof				*/
/* for use in hardware or software products claiming conformance				*/
/* to the MPEG-4 standard. Those intending to use this software					*/
/* module in hardware or software products are advised that its					*/
/* use may infringe existing patents. The original developer of					*/
/* this software module and his company, the subsequent							*/
/* editors and their companies, and ISO/IEC have no liability					*/
/* for use of this software module or modifications thereof in					*/
/* an implementation. Copyright is not released for non							*/
/* MPEG-4 standard conforming products. INT ARTEMIS								*/
/* retain full right to use the code for their own purposes,					*/
/* assign or donate the code to a third party and to inhibit					*/
/* third parties from using the code for non MPEG-4 standard					*/
/* conforming products. This copyright notice must be included					*/
/* in all copies or derivative works.    										*/
/* Copyright (c)2002 - 2005														*/
/********************************************************************************/

// FootPrintSetProxy.h: interface for the FootPrintSetProxy class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FootPrintSetProxy_H__93F1CF93_D37D_11D5_B9F1_000102A02E5B__INCLUDED_)
#define AFX_FootPrintSetProxy_H__93F1CF93_D37D_11D5_B9F1_000102A02E5B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\AfxStreamProxy.h"
#include "..\..\..\IM1Decoders\AFX\FootPrint\FPSet.h"
#include "..\..\..\IM1Decoders\AFX\FootPrint\FPBuilding.h"
#include "Nodes.h"
#include <GL/gl.h>
#include <GL/glu.h>

#ifndef CALLBACK 
#define CALLBACK __stdcall
#endif

#ifndef BYTE
typedef unsigned char BYTE;
#endif

#ifndef LPBYTE
typedef BYTE* LPBYTE;
#endif

class BitWrapperProxy;
class FPSetDecoderSpecificInfo;


class FootPrintSetProxy : public AfxStreamProxy
{
public:
	/// Constructor
	FootPrintSetProxy(FootPrintSet* FP);

	~FootPrintSetProxy(void);

	inline FPSet* GetFPSet() { return m_pFPSet; };

	/// Decode object
	bool Decode(FootPrintSet *FPS);

	/// Render object
	virtual BOOL  Render(OpenGLVisualRenderer* pRenderer, DWORD dwTime);
	virtual BOOL  RenderFromStream(MediaStream* poStream, int id, DWORD dwTime);
	virtual BOOL  RenderFromBuffer(SFString *buffer, int id);
	virtual BOOL  Render(DWORD dwTime);
	virtual void RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

	virtual void  SetupDecoderData(BitWrapperProxy *pParent);
	void SetupDecoderData(BitWrapper *poBitWrapper, void *wsDec);

	/// Traverse scene graph, checking for intersection
	virtual BOOL  Select(OpenGLVisualRenderer* pRenderer, DWORD dwTime, unsigned int& depth);

	inline FootPrintSet * GetFootPrintSetNode() const
	{ return (FootPrintSet *) GetMediaObject(); }

	bool AddFPs(ZArray<FP*>& fpes, int parentIndex);
	bool AddFPNode(FP*);
	bool RemoveFPNode(FP*);

	FootPrint* CreateFootPrintNode(FP* footprint);
	BuildingPart* CreateBuildingPartNode(FPBuilding* building);
	Facade* CreateFacadeNode(FPFacade* facade);
	Roof* CreateRoofNode(FPRoof* roof);

protected :
	bool  m_bInit;
    DWORD m_lastTime;
	FPSet* m_pFPSet;
	FPSetDecoderSpecificInfo *m_pInfo;


};


#endif // !defined(AFX_FootPrintSetProxy_H__93F1CF93_D37D_11D5_B9F1_000102A02E5B__INCLUDED_)
