/********************************************************************************/
/* This software module was developped by										*/

/*	   Royan Jerome , jerome.royan@francetelecom.com							*/
/*                   France Telecom R&D, France		*/

/* in the course of development of the MPEG-4 standard (Part 16 AFX).			*/
/* This software module is an implementation of a part of one or				*/
/* more MPEG-4 tools as specified by the										*/
/* MPEG-4 standard. ISO/IEC gives users of the MPEG-4 standard					*/
/* free license to this software module or modifications thereof				*/
/* for use in hardware or software products claiming conformance				*/
/* to the MPEG-4 standard. Those intending to use this software					*/
/* module in hardware or software products are advised that its					*/
/* use may infringe existing patents. The original developer of					*/
/* this software module and his company, the subsequent							*/
/* editors and their companies, and ISO/IEC have no liability					*/
/* for use of this software module or modifications thereof in					*/
/* an implementation. Copyright is not released for non							*/
/* MPEG-4 standard conforming products. INT ARTEMIS								*/
/* retain full right to use the code for their own purposes,					*/
/* assign or donate the code to a third party and to inhibit					*/
/* third parties from using the code for non MPEG-4 standard					*/
/* conforming products. This copyright notice must be included					*/
/* in all copies or derivative works.    										*/
/* Copyright (c)2002 - 2005														*/
/********************************************************************************/

// FootPrintSetProxy.cpp: implementation of the FootPrintSetProxy class.
// dependences :
//////////////////////////////////////////////////////////////////////

#include "RoofProxy.h"
#include "IM1Decoders/AFX/AFX.h"
//#include "IM1Decoders/AFX/FootPrintDecoder.h"

#include "opengl/group/GroupProxy.h"
#include "opengl/group/SwitchProxy.h"
#include "opengl/group/InlineProxy.h"
#include "opengl/geometry/ShapeProxy.h"
//#include "opengl/geometry/TransformProxy.h"
#include "opengl/base/OpenGLVisualRenderer.h"
#include "opengl/base/OpenGLPresenter.h"
#include "Presenter.h"
#include "Inline.h"
/*
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif
*/


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


RoofProxy::RoofProxy(Roof* roof)
  : AfxStreamProxy(roof)
{
  m_bInit = false;
  m_lastTime = 0;
//  m_bIs3DReconstructed=false;
}

RoofProxy::RoofProxy(Roof* roof, FPRoof* fpRoof)
  : AfxStreamProxy(roof)
{
  fpRoof->SetMediaObject((MediaObject*)GetRoofNode());
  m_pRoof=fpRoof;
  m_bInit = false;
  m_lastTime = 0;
//  m_bIs3DReconstructed=false;
}

RoofProxy::~RoofProxy(void)
{

}

BOOL RoofProxy::Select(OpenGLVisualRenderer* pRenderer, DWORD dwTime, unsigned int& depth)
{
  GLuint selectBuffer[4];

  ::glSelectBuffer(4, selectBuffer);
  ::glRenderMode(GL_SELECT);

  Render(pRenderer, dwTime);

  if (::glRenderMode(GL_RENDER) > 0)
    if (depth >= selectBuffer[1]) {
      depth = selectBuffer[1];

      return TRUE;
    }

  return FALSE;
}

BOOL RoofProxy::RenderFromStream(MediaStream* poStream, int id, DWORD dwTime)
{
  // it is called by BitWrapper
  // it should retrieve from the decoder the data and initialise the fields

  // first time get the decoder specific info from the stream

  // get the stream
 
  // get the decoded data buffer
 
	//Copy the decoded mesh into the composition buffer
	//DataExchange();
	

	
	// update time

	  return TRUE;
}

BOOL RoofProxy::RenderFromBuffer(SFString *buffer, int id)
{
  
  return TRUE;
}

BOOL RoofProxy::Render(DWORD dwTime)
{

/*	glPushAttrib(GL_POLYGON_BIT);

	glEnable(GL_LIGHTING);
	glCullFace(GL_FRONT_AND_BACK);

	glColor4f(0.3,0.3,0.3,1.0);
	AppearanceProxy* pAppProxy = LoadTexture(m_pRoof->GetTexURL(), pRenderer, dwTime);
	for (int num_fp=0; num_fp<m_pRoof->GetNbFootprints(); num_fp++)
	{
		float* vertices = m_pRoof->GetVertices()[num_fp];
		glInterleavedArrays(GL_T2F_N3F_V3F, 0, vertices);
							
		for (int i=0; i<m_pRoof->GetNbSlopes()[num_fp]; i++)
		{
			unsigned int* indices = m_pRoof->GetPolygonIndices()[num_fp][i]; 
			glDrawElements(GL_POLYGON, m_pRoof->GetNbVerticesBySlope()[num_fp][i], GL_UNSIGNED_INT, m_pRoof->GetPolygonIndices()[num_fp][i]);
		}
	}
	UnLoadTexture(pAppProxy, pRenderer, dwTime);

	glDisable(GL_LIGHTING);

	glPopAttrib();
*/
  return TRUE; 
}

BOOL RoofProxy::Render(OpenGLVisualRenderer* pRenderer, DWORD dwTime)
{
  // called when the node is encoded with BIFS
 // Render(dwTime);

	glPushAttrib(GL_POLYGON_BIT);

	glEnable(GL_LIGHTING);
	glCullFace(GL_FRONT_AND_BACK);

	glColor4f(0.3,0.3,0.3,1.0);
	AppearanceProxy* pAppProxy = LoadTexture(m_pRoof->GetTexURL(), pRenderer, dwTime);
	for (int num_fp=0; num_fp<m_pRoof->GetNbFootprints(); num_fp++)
	{
		float* vertices = m_pRoof->GetVertices()[num_fp];
		glInterleavedArrays(GL_T2F_N3F_V3F, 0, vertices);
							
		for (int i=0; i<m_pRoof->GetNbSlopes()[num_fp]; i++)
		{
			unsigned int* indices = m_pRoof->GetPolygonIndices()[num_fp][i]; 
			glDrawElements(GL_POLYGON, m_pRoof->GetNbVerticesBySlope()[num_fp][i], GL_UNSIGNED_INT, m_pRoof->GetPolygonIndices()[num_fp][i]);
		}
	}
	UnLoadTexture(pAppProxy, pRenderer, dwTime);

	glDisable(GL_LIGHTING);

	glPopAttrib();
  return TRUE; 
}

void RoofProxy::RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime)
{
  Roof* pRoof = (Roof
	  *) GetMediaObject();
  GLfloat color[] = { 0.0f, 1.0f, 0.0f, 0.75f};

  glColor4fv(color);

  RenderDescriptionBox(pRenderer, "Roof");
}

AppearanceProxy* RoofProxy::LoadTexture(char* ID, OpenGLVisualRenderer* pRenderer, DWORD dwTime) const
{
	Root* pSceneRoot = NULL;
	OpenGLPresenter* pPresenter = NULL;
	AppearanceProxy* pAppProxy = NULL;
	Appearance* pAppearance = NULL;

	pPresenter = pRenderer->GetPresenter();
	if (pPresenter != NULL)
	{
		pSceneRoot = pPresenter->GetScene();
	}
	if (pSceneRoot != NULL)
	{
		pAppearance=(Appearance*)pSceneRoot->FindNode(ID);
	}
	if (pAppearance!=NULL)
	{
		pAppProxy=(AppearanceProxy*)pAppearance->GetRenderingObject();
	}
	if (pAppProxy != NULL)
	{
		pAppProxy->Enable(pRenderer, dwTime);
	}

	return pAppProxy;
}

void RoofProxy::UnLoadTexture(AppearanceProxy* pAppProxy, OpenGLVisualRenderer* pRenderer, DWORD dwTime) const
{
	if (pAppProxy != NULL)
	{
		pAppProxy->Disable(pRenderer, dwTime);
	}
}

