// This software module was originally developed by Marius PREDA (INT)
// in the course of development of the MPEG-4 
// Systems standard (ISO/IEC 14496-1).  This software module is an 
// implementation of a part of one or more MPEG-4 Systems tools as specified by 
// the MPEG-4 Systems standard.  ISO/IEC gives users of the MPEG-4 Systems 
// standard free license to this software module or modifications thereof for 
// use in hardware or software products claiming conformance to the MPEG-4 
// Systems standard.  Those intending to use this software module in hardware or 
// software products are advised that its use may infringe existing patents.  
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use 
// of this software module or modifications thereof in an implementation.  
// Copyright is not released for non MPEG-4 Systems conforming products.  The 
// original developer retains full right to use the code for his/her own 
// purpose, assign or donate the code to a third party and to inhibit third 
// parties from using the code for non MPEG-4 Systems conforming products.  This 
// copyright notice must be included in all copies or derivative works.
//
// Copyright 2003.


#ifndef __MORPHSHAPEPROXY_H__
#define __MORPHSHAPEPROXY_H__

#include "opengl/base/NodeProxy.h"
#include "Core/Nodes.h"
#define MAX_TARGETS 1024

class OpenGLVisualRenderer;


class MorphShapeProxy
  : public	NodeProxy
{
public:

  /// Constructor
	MorphShapeProxy(MorphShape* pMorphShape);

public:

	virtual void		RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Render object
protected :
	virtual BOOL Render(const Matrix&, const CullFlag&, OpenGLVisualRenderer* pRenderer, DWORD) ;
	virtual void Select(const Matrix&, const CullFlag&, OpenGLVisualRenderer* pRenderer, DWORD dwTime, MediaObjectProxy*& intersectingObject,ZArray<MediaObjectProxy*>& activatedSensors, unsigned int& depth,const ZArray<MediaObjectProxy*>& localSensors);
	BOOL MorphShapeProxy::Render(DWORD dwTime);


public:
	inline MorphShape * GetMorphShape() {
		return (MorphShape *) GetMediaObject();
	}

	inline Shape * GetMorphBaseShape() {
		MediaObject * pObject = (MediaObject*) GetMorphShape()->baseShape;
		return (Shape*) (pObject);
	}
	inline Shape * GetMorphTargetShape(int i) {
		MediaObject * pObject = (MediaObject*) GetMorphShape()->targetShapes[i];
		return (Shape*) (pObject);
	}

	BOOL RetrieveWeights();


	bool init;
	bool wellFormated;
	Vec3f *baseVertices;
	Vec3f **targetVertices;//[MAX_TARGETS];
	bool *isMorphVertex;
	int noVertices;
	int noNormals;
	int noTriangles;
	Vec3f *baseNormals;
	Vec3f **targetNormals;//[MAX_TARGETS];
	bool *isMorphNormal;
	int noTargets;
	int noWeights;
	Shape *pShapeBase;
	IndexedFaceSet *pIFSbase;
	float *m_weights;

//	MF<Vec3f> &GetBaseShapeCoord() const;
	void UpdateVerticesAndNormals();
	BOOL InitMorphing();

//	MF<Vec3f> &pointsBase;

/*
	Shape *pShp = (Shape*) poMS->baseShape;
	ShapeProxy *pShpProxy = (ShapeProxy *) (pShp->GetRenderingObject());
	MediaObject* pGeometry=pShpProxy->GetGeometry();
	IndexedFaceSet *pIFSbase=(IndexedFaceSet*) pGeometry;
	Coordinate *pCoordinate = (Coordinate *)pIFSbase->coord.GetNode();
	MF<Vec3f> &pointsBase  = pCoordinate->point;
*/

};

//#include "MorphShapeProxy.i"

#endif // __MORPHSHAPEPROXY_H__

