/***********************************************************************
This software module was originally developed by Sebastian Amengual
(Universidad Politecnica de Madrid, UPM) in the course of development of 
the MPEG-4 Systems (ISO/IEC 14496-1) standard. This software module is
an implementation of a part of one or more MPEG-4 Systems 
(ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems
(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems 
(ISO/IEC 14496-1) free license to this software module or modifications
thereof for use in hardware or software products claiming conformance to
the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this 
software module in hardware or software products are advised that its 
use may infringe existing patents. The original developer of this 
software module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software module
or modifications thereof in an implementation. Copyright is not 
released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
UPM retains full right to use the code for his/her own purpose, assign 
or donate the code to a third party and to inhibit third parties from 
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. This copyright notice must be included in all copies or 
derivative works. Copyright  2005
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Francisco Moran at fmb@gti.ssr.upm.es.
----------------------------------------------------------------------*/

/*-------------------------------------------------------------------------
Project Player3d
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  WaveSurfProxy
FILE:       WaveSurfProxy.cpp
AUTHOR:     Sebastin Amengual & Marcos Avils (UPM)
OVERVIEW:   Header file of WaveSurfProxy.cpp.
-------------------------------------------------------------------------*/

#ifndef __WaveletSubdivisionSurfaceProxy_H__
#define __WaveletSubdivisionSurfaceProxy_H__

#include "AfxStreamProxy.h"
#include "Nodes.h"

class WaveSurf;

class WaveletSubdivisionSurfaceProxy : public AfxStreamProxy
{
public:
    WaveletSubdivisionSurfaceProxy(WaveletSubdivisionSurface *pWSS);
    ~WaveletSubdivisionSurfaceProxy();

public:
    // Render object
    virtual BOOL Render(OpenGLVisualRenderer *pRenderer, DWORD dwTime);
    virtual BOOL RenderFromStream(MediaStream *poStream, int id, DWORD dwTime);
    virtual BOOL RenderFromBuffer(SFString *pBuffer, int id);

    // Traverse scene graph, checking for intersection
    virtual BOOL  Select(OpenGLVisualRenderer *pRenderer, DWORD dwTime, unsigned int &depth);

private:
    void FillIndicesAndNormalsArrays();

private:
    WaveSurf *_pWaveSurf;

    unsigned int *_indices;
    Vec3f *_normals;
};

#endif // __WaveletSubdivisionSurfaceProxy_H__
