// -*- c++ -*-



#ifndef __IMPLICITPROXY_H__
#define __IMPLICITPROXY_H__

#include "../../geometry/GeometryProxy.h"
#include "stdafx.h"
#include "VolumeTreeNode/SolidNode.h"
#include "DensityTLS.h"
#include "VolumeTreeNode/SolidTools.h"


/// Implicit renderer node

class ImplicitProxy
  : public GeometryProxy
{
public:

  /// Constructor

			ImplicitProxy(Implicit* pImplicit);

  /// Destructor

  virtual		~ImplicitProxy();





  /// Render object

  virtual BOOL		Render(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Traverse scene graph, checking for intersection

  virtual BOOL		Select(OpenGLVisualRenderer* pRenderer, DWORD dwTime, unsigned int& depth);

  /// Render object description

  virtual void		RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

private:

  // variables ici

     


  // moved methods from Implicit to ImplicitProxy
	
public:

	int Evaluate();

  inline Implicit * GetImplicit() const
  { return (Implicit *) GetMediaObject(); }


	Volume_Tree_Node *GetVolumeTreeNode();

   /// Get bounding box
  void GetBbox(Vec3f& rBboxSize, Vec3f& rBboxCenter) const;


  // GetBboxSize
  Vec3f GetbboxSize()
  {
	  return (Vec3f) GetImplicit()->bboxSize;
  }


  // GetDual
  Bool GetDual()
  {
	return (Bool) GetImplicit()->dual;
  }
// SetDual
  void SetDual(Bool dual)
  {
	GetImplicit()->dual = (SF<Bool>) dual;
  }

  // GetSolid
  inline Bool GetSolid()
  {
	return (Bool) GetImplicit()->solid;
  }

// SetSolid
  void SetSolid(Bool solid)
  {
	GetImplicit()->solid = (SF<Bool>) solid;
  }

// GetCoef
  float *GetCoef()
  {
	return (float *) (&(GetImplicit()->c[0]));
  }
  // get CoefNumber
  int GetCoefNumber()
  {
	  return (int) ((GetImplicit()->c).GetLength());
  }

// SetCoef
  void *SetCoef( MF<float>& coef)
  {
	GetImplicit()->c = coef;
  }

// GetDensities
  int *GetDensities()
  {
	return (int *) (&(GetImplicit()->densities[0]));
  }

  // GetGrid
  float GetGrid()
  {
	return grid;
  }

// SetDensities
  void *SetDensities( MF<int>& d)
  {
	GetImplicit()->densities = d;
  }


	//Fields
   DensityMatrix densMatrix; 

	// is this a solid shape ?
	Bool Solid()  { return ( GetSolid() ); }

	// is p outside the shape 

	Bool isOutside(Vec3f &p);
	Bool isSolid() { return Solid(); }

	//protected members
protected : 
	bool _needUpdate;
    //Default Grid Value
    float grid; 
	
	SFString TextureURL;

    SFString TypeOfMapping; // a rentrer manuellement
	SL_Matrix TransformMatrix;
	Bool created;
	Volume_Tree_Node *SolidTree;
		long m_nTimeStamp;
};


#endif // __IMPLICITPROXY_H__

