// -*- c++ -*-
// SolidGraphic.cpp

/***********************************************************************
This software module was originally developed by Alain Mignot( Mignot Informatique Graphique Inc. )
 in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. (Mignot Informatique Graphique Inc.)
 retains full right to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2004
*/

#include "OpenGl/OpenGl.h"
#include "SolidGraphic.h"
#include "opengl/base/OpenGLVisualRenderer.h"
#include "Polygonise.h"



// support classes



// Constructor

SolidGraphic::SolidGraphic( int type)

{

	 

}
	SolidGraphic::SolidGraphic( Shapejb *fromshape[], int nshape, ZArray<Vec3f>  **ColorTable)
	{
		for (int i = 0; i < nshape; i++) {
			shape[i] = fromshape[i];
		}
		nbshape = nshape;

	}



// Destructor

SolidGraphic::~SolidGraphic()
{
  // ici destruction

}


BOOL		SolidGraphic::Display()
{
	


#if 0  
    MF<Vec3f> color_table;
    MF<Vec3f> params(nbvertex);
#endif
		GLfloat color[] = { 100.0f, 0.0f, 0.0f, 1.0f};
  float x_side = 100;
  float y_side = 100;
  float z_side = 100;

  //::glColor4fv(color);
 // ::glMatrixMode( GL_MODELVIEW);
  //::glScalef( 100., 100.,  100. );

  //	::glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);

#if 0
  	// inclure ici le rendu
    ::glBegin(GL_QUADS);
	glClearColor(1,0,0,1);
	glClear(GL_COLOR_BUFFER_BIT);
	glColor4fv(color);
    glNormal3f(0.0f, 0.0f, -1.0f);

    glVertex3f( x_side, -y_side, -z_side);
    glVertex3f(-x_side, -y_side, -z_side);
	glVertex3f(-x_side,  y_side, -z_side);
	glVertex3f( x_side,  y_side, -z_side);


    glNormal3f(0.0f, 1.0f, 0.0f);
	glVertex3f(-x_side,  y_side,  z_side);
	glVertex3f( x_side,  y_side,  z_side);
	glVertex3f( x_side,  y_side, -z_side);
	glVertex3f(-x_side,  y_side, -z_side);

    glNormal3f(0.0f, 0.0f, 1.0f);
	glVertex3f(-x_side, -y_side,  z_side);
	glVertex3f( x_side, -y_side,  z_side);
	glVertex3f( x_side,  y_side,  z_side);
	glVertex3f(-x_side,  y_side,  z_side);

    glNormal3f(-1.0f, 0.0f, 0.0f);
	glVertex3f(-x_side, -y_side, -z_side);
	glVertex3f(-x_side, -y_side,  z_side);
	glVertex3f(-x_side,  y_side,  z_side);
	glVertex3f(-x_side,  y_side, -z_side);

    glNormal3f(0.0f, -1.0f, 0.0f);
	glVertex3f( x_side, -y_side,  z_side);
	glVertex3f(-x_side, -y_side,  z_side);
	glVertex3f(-x_side, -y_side, -z_side);
	glVertex3f( x_side, -y_side, -z_side);

    glNormal3f(1.0f, 0.0f, 0.0f);
	glVertex3f( x_side, -y_side,  z_side);
	glVertex3f( x_side, -y_side, -z_side);
	glVertex3f( x_side,  y_side, -z_side);
	glVertex3f( x_side,  y_side,  z_side);
    ::glEnd();
#endif


	//get the vertex and normals coordinates         
//	::glClearColor(1,0,0,1);
//	::glClear(GL_COLOR_BUFFER_BIT);
	::glColor4fv(color);

    for (int j = 0; j < nbshape ; j++)
    {
		Shapejb *sh = shape[j];
		VERTICES *vert = sh->Svertices();
		VERTEX      *VertexPtr        = NULL;

		int npol = sh->nbtris * 3;
//		float scale = 60.0; // a changer
		float scale = 1.0; // a changer

		int nbvertex = vert->count;


        for ( int i=0; i <  npol; i+= 3)
        { 

		    ::glBegin( GL_TRIANGLES);
		::glColor4fv(color);
			for( int k = 0 ; k < 3 ; k++) {
			int p = sh->Trivert(k + i);

            VertexPtr = &(vert->ptr[p]);

			::glNormal3d( VertexPtr->normal.x * scale,
                              VertexPtr->normal.y * scale,
                              VertexPtr->normal.z * scale);

			::glVertex3d( VertexPtr->position.x * scale,
                             VertexPtr->position.y * scale,
                             VertexPtr->position.z * scale) ;
// pour tests

			testcoord(VertexPtr->position.x,
                             VertexPtr->position.y,
                             VertexPtr->position.z,
								VertexPtr->normal.x,
                              VertexPtr->normal.y,
                              VertexPtr->normal.z);



			}
			::glEnd();

        }
        
 
    }
    
    
    return TRUE;


}

void SolidGraphic::testcoord(float x, float y, float z, float nx, float ny, float nz)
{
	int i = 0;

}

