// -*- c++ -*-



#ifndef __SOLIDREPPROXY_H__
#define __SOLIDREPPROXY_H__

#include "../../geometry/GeometryProxy.h"
#include "stdafx.h"
#include "VolumeTreeNode/VolumeTreeNode.h"

#include "VolumeTreeNode/SolidNode.h"
#include "DensityTLS.h"
#include "VolumeTreeNode/SolidTools.h"


/// SolidRep renderer node
/* fields:

        exposedField SF<Vec3f> bboxSize;
         exposedField MF<int> densityList;
         exposedField SF3DNode solidTree;
         exposedField SF<int> solidOp;

		 */
class SolidRepProxy
  : public GeometryProxy
{
public:

  /// Constructor

			SolidRepProxy(SolidRep* pSolidRep);

  /// Destructor

  virtual		~SolidRepProxy();





  /// Render object

  virtual BOOL		Render(OpenGLVisualRenderer* pRenderer, DWORD dwTime);
//  virtual BOOL Render(const Matrix&, const CullFlag&, OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Traverse scene graph, checking for intersection

  virtual BOOL		Select(OpenGLVisualRenderer* pRenderer, DWORD dwTime, unsigned int& depth);

  /// Render object description

  virtual void		RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

private:

  // variables ici

     


  // moved methods from SolidRep to SolidRepProxy
	
public:

	int Evaluate();

  inline SolidRep * GetSolidRep() const
  { return (SolidRep *) GetMediaObject(); }



   /// Get bounding box
  void GetBbox(Vec3f& rBboxSize, Vec3f& rBboxCenter) const;

 // GetBboxSize
  Vec3f GetbboxSize()
  {
	  return (Vec3f) GetSolidRep()->bboxSize;
  }


 // GetSolidTree
  SF3DNode *GetsolidTree()
  {
	return (SF3DNode *) (&(GetSolidRep()->solidTree));
  }

 // GetSolidOp
	/* 112204 [MBS] removed since solidOp not in templates v5
  int GetsolidOp()
  {
	return (int ) GetSolidRep()->solidOp;
  }*/

// GetDensities
  int *GetdensityList()
  {
	return (int *) (&(GetSolidRep()->densityList[0]));
  }
  // get CoefNumber
  int GetdensityListN()
  {
	  return (int) ((GetSolidRep()->densityList).GetLength());
  }

// SetCoef
  void *SetdensityList( MF<int>& d)
  {
	GetSolidRep()->densityList = d;
  }

  /* 112204 [MBS] removed since dual/ndual not in templates v5 anymore
  // GetDual
  Bool GetDual()
  {
	return (Bool) GetSolidRep()->dual;
  }
// SetDual
  void SetDual(Bool ndual)
  {
	GetSolidRep()->dual = (SF<Bool>) ndual;
  }*/


	//Fields
   DensityMatrix densMatrix; 

	// is this a solid shape ?
	Bool Solid()  { return ( TRUE ); }
	// is p outside the shape 

	Bool isOutside(Vec3f &p);
	Bool isSolid() { return Solid(); }

	Volume_Tree_Node *GetVolumeTreeNode(BBox *MaxBBox = 0);
    ZArray<BoundingQuadric*> *GetPrimitives();
    void SetMyTree(Volume_Tree_Node *the_other);

	//protected members
protected : 
	bool _needUpdate;
    //Default Grid Value
    float grid; 

	int densityListN;

	Volume_Tree_Node *My_Tree;
    BBox          My_TreeBBox;
    ZArray<BoundingQuadric*> ExpandedTree;



	SFString TextureURL;

    SFString TypeOfMapping; // a rentrer manuellement
	SL_Matrix TransformMatrix;
	Bool created;
	Volume_Tree_Node *SolidTree;
		long m_nTimeStamp;
};



//FUNCTIONS
//Node_Type Give_Node_Type(MediaObject *The_Node);
Volume_Tree_Node *Give_Volume_Tree_Node(MediaObject *The_Node, BBox *MaxBBox = 0, int SolidOp = 0);
void SOLID_Node_In_Solid_Rep_Must_Be_Solid(SolidNode *To_verify_Solidity);


#endif // __SOLIDREPPROXY_H__

