#ifndef _VOL_TREE_CONST_H_
#define _VOL_TREE_CONST_H_

//*******************************************************************************
//Volume_Tree_Constant : This node represent a constant density (ex. 2) that can 
//                       be used with other nodes in some operations.
//*******************************************************************************
class Volume_Tree_Constant : public Volume_Tree_Node
{
public:
    Volume_Tree_Constant(int the_value):value(the_value){}

    int     EvaluateDensity(const double& x, const double& y, const double& z)const{return value;}

    bool    EvaluateGradient(const double &x,
                             const double &y,
                             const double &z,
                             double       &Distance,
                             double       *Gradient,
                             float        *Color = 0) const {return false;}    

    double  *GetCoeff(double x, double y , double z)
    {
        double *to_return = new double[10];
        for(int i = 0; i < 10; i++)to_return[i] = 0.0;
        return to_return;
    }
    int   GetNumOfCoeff(double x, double y , double z){return 10;}

    bool  GetColor(const double &x, const double &y, const double &z, float set_color[])const
          {return false;}

    void    GetPrimitives(ZArray<BoundingQuadric*> &outPrimitives,
                          const SL_Matrix &Transform, BBox &outGlobalBox) {};

protected:
    //Protected member
    int     value;
    
    void    Manage_At_The_Top(void) {At_The_Top = true;}

    Volume_Tree_Constant(void);
    ~Volume_Tree_Constant(void){}
};

#endif //_VOL_TREE_CONST_H_