class Tri;
class Quad;
template<class Face> 
class TagMeshTp;

class TagFlatMesh;

#include<iostream.h>

// basic information
//
class SurfaceData
{
public:
    SurfaceData() : noVtx(0), pos(0), param(0), noFaces(0), face(0) { }
    long noVtx;          // number of vertices
    float *pos;   // positions
    float *param; // texture coordinate parameters
    
    long noFaces;        // number of faces
    int *face;   // faces
};

// extra information
//
struct TagSectorInfo {
  long faceIndex;
  long vertexIndex;
  long tag;
  float flatness;
  float theta;
  float *normal; // MBS 7/3/03: changed from float* to float[3]. This attrib should point to a float* in a Vec3f but IM1 doesn't represent Vec3f as float*.
  float normalTension;
};

class TagData
{
public:

    TagData() : 
      noCreaseLineIndex(0), creaseLineIndex(0),
        noDartIndex(0), dartIndex(0), noCreaseIndex(0), creaseIndex(0), noCornerIndex(0), cornerIndex(0),
        noSector(0),sectors(0) { }

    int noCreaseLineIndex;
    int* creaseLineIndex;
    //
    int noCornerIndex;
    int* cornerIndex;
    //
    int noDartIndex;
    int* dartIndex;
    //
    int noCreaseIndex;
    int* creaseIndex;
    //
    int noSector;
    TagSectorInfo *sectors;
};


// wrapper around subdivision code
//
class SubWrap {
public:
    SubWrap(int l, 
        int loopFlag,
        const SurfaceData& SurfaceData);
    SubWrap(int l, 
        int loopFlag,
        const SurfaceData& surfaceData,
        const TagData& tagData);

    ~SubWrap();

    // update control points and sector parameter
    //    WARNING: this is a terrible hack
    //    we assume only two kinds of changes:
    //    - control point positions
    //    - sector parameter (i.e. flatness, theta, etc.)
    //    this means that the connectivity and the tags stay the same!
    //    this is very restrictive!
    //    other changes might mess up the memory.  we don't test for this
    void update(int l,
        const SurfaceData& surfaceData,
        const TagData& tagData);
    
    // number of faces and vertices
    void getNumbers(int level, 
        int& noVertices, 
        int& noFaces) const;
    
    // get faces
    void getFaces(int level, 
        int* f) const;
    
    // per vertex data
    void getVertexData(int level, 
        float* pos, 
        float* normal, 
        float* param) const;

    bool isOpenMesh() const;

private:
    TagMeshTp<Quad>* _qm;
    TagMeshTp<Tri>* _tm;
    TagFlatMesh* _fm;
};

class SubInfo {
public:
    void showInfo(ostream& os);
};
