#include "subwrap.h"

#include <iostream.h>

// create a simple mesh consisting of exactly one quad
//
SurfaceData makeData()
{
    SurfaceData data;
    //
    // points
    // 0 2
    // 1 3
    data.noVtx = 4;
    data.pos = new float[4*3];
    int t = 0;
    data.pos[t++] = 0; data.pos[t++] = 0; data.pos[t++] = 0;
    data.pos[t++] = 1; data.pos[t++] = 0; data.pos[t++] = 0;
    data.pos[t++] = 0; data.pos[t++] = 1; data.pos[t++] = 0;
    data.pos[t++] = 1; data.pos[t++] = 1; data.pos[t++] = 0;
    //
    // no parameter values
    data.param = 0;
    //  
    // faces
    data.noFaces = 1;
    data.face = new int[5];
    data.face[0] = 4; // 4 vertices
    data.face[1] = 0;
    data.face[2] = 1;
    data.face[3] = 3;
    data.face[4] = 2;
    //
    // surface data
    return data;
}

void testSubWrap(int level, int loopFlag, const SubWrap& sw)
{
    int c;
    if(loopFlag)
    {
        c = 4;
    }
    else
    {
        c = 5;
    }
    
    int i;
    for(i = 0; i <= level; ++i)
    {
        int nv, nf;
        sw.getNumbers(i, nv, nf);
        cerr<<"level: "<<i<<", nv: "<<nv<<", nf: "<<nf<<endl;
        
        float *p = new float[3*nv];
        float *n = new float[3*nv];
        int   *f = new int[c*nf];
        
        sw.getFaces(i, f);
        sw.getVertexData(i, p, n, 0);        
        int t;
        for(t = 0; t < nv; ++t)
        {
            cerr<<t<<", "
                <<"pos: ("<<p[3*t+0]<<", "<<p[3*t+1]<<", "<<p[3*t+2]<<")\t"
                <<"nor: ("<<n[3*t+0]<<", "<<n[3*t+1]<<", "<<n[3*t+2]<<")"<<endl;
        }
        for(t = 0; t < nf; ++t)
        {
            int j;
            for(j = 0; j < c; ++j)
                cerr<<f[c*t+j]<<" ";
            cerr<<endl;
        }
        delete[] p;
        delete[] n;
        delete[] f;
    }
}

int main(int argc, char* argv[])
{
    SurfaceData data(makeData());
    int level = 1;
    int loopFlag = 0;
    
    SubWrap sw(level, loopFlag, data);
    testSubWrap(level, loopFlag, sw);    
    return 0;
} 