// -*- c++ -*-

/***********************************************************************
This software module was originally developed by Riitta Vaananen
(Helsinki University of Technology) in the course of development of
the MPEG-4 Systems (ISO/IEC 14496-1) standard.  This software module
is an implementation of a part of one or more MPEG-4 Systems (ISO/IEC
14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1)
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1)
free license to this software module or modifications thereof for use
in hardware or software products claiming conformance to the MPEG-4
Systems (ISO/IEC 14496-1). Those intending to use this software module
in hardware or software products are advised that its use may infringe
existing patents.  The original developer of this software module and
his/her company, the subsequent editors and their companies, and
ISO/IEC have no liability for use of this software module or
modifications thereof in an implementation.  Copyright is not released
for non MPEG-4 Systems (ISO/IEC 14496- 1) conforming products.
Helsinki University of Technology retains full right to use the code
for their own purpose, assign or donate the code to a third party and
to inhibit third parties from using the code for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. This copyright notice must be
included in all copies or derivative works. Copyright  1999.
************************************************************************/


#ifndef __ACOUSTICMATERIALPROXY_H__
#define __ACOUSTICMATERIALPROXY_H__

#include "../appearance/MaterialNodeProxy.h"
//#include "MaterialProxy.h"

class AcousticMaterial;

/// AcousticMaterial renderer class

class AcousticMaterialProxy
	: public MaterialNodeProxy
{
 public:

  /// Constructor

			AcousticMaterialProxy(AcousticMaterial* pAcousticMaterial);

  /// Enable material

   virtual BOOL		Enable(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Disable material

  virtual BOOL		Disable(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Render object description

  virtual void		RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

   inline AcousticMaterial * GetAcousticMaterial()
  { return (AcousticMaterial *) GetMediaObject(); }
};

#include "AcousticMaterialProxy.i"

#endif // __ACOUSTICMATERIALPROXY_H__
