// -*- c++ -*-
/***********************************************************************
This software module was originally developed by Riitta Vaananen
(Helsinki University of Technology) in the course of development of
the MPEG-4 Systems (ISO/IEC 14496-1) standard.  This software module
is an implementation of a part of one or more MPEG-4 Systems (ISO/IEC
14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1)
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1)
free license to this software module or modifications thereof for use
in hardware or software products claiming conformance to the MPEG-4
Systems (ISO/IEC 14496-1). Those intending to use this software module
in hardware or software products are advised that its use may infringe
existing patents.  The original developer of this software module and
his/her company, the subsequent editors and their companies, and
ISO/IEC have no liability for use of this software module or
modifications thereof in an implementation.  Copyright is not released
for non MPEG-4 Systems (ISO/IEC 14496- 1) conforming products.
Helsinki University of Technology retains full right to use the code
for their own purpose, assign or donate the code to a third party and
to inhibit third parties from using the code for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. This copyright notice must be
included in all copies or derivative works. Copyright  1999.
************************************************************************/

#include "Auralize.h"

inline //riitta 061799
float* ProcessSound::operator()(float input)
{
	float* tmp;
	if(sound_3D){
		tmp = (*sound_3D)(input);
		out[0] = tmp[0];
		out[1] = tmp[1];
	}

#ifdef ADV_AUDIO	
	else if(dirsound){
//	else if(&dirsound){
	//		tmp = (*dirsound)(input);
		tmp = (*dirsound)(&input);
	//	tmp = (dirsound)(&input);
		
		out[0] = tmp[0];
		out[1] = tmp[1];
	}

#ifdef PERCEPTUAL_AUDIO
	if(perceptualsound) // ... JB: Do the perceptual sound processing here
#endif // PERCEPTUAL_AUDIO

#endif // ADV_AUDIO


	else{
		out[0] = input;
		out[1] = input;
	}
	return (float*)out;

}

inline // 061799
float* ProcessSound3D::operator()(float input)
{
	float* tmp;
	float x = input*intensity;
	if(ellip){
		x = (*ellip)(x);			
	}

	if(pan){
		tmp = (*pan)(x);
		out[0] = tmp[0];
		out[1] = tmp[1];
	}
	else{
		out[0] = x;
		out[1] = x;
	}
	return (float*)out;
}

inline //riitta 061799
float EllipseSound::operator()(float input)
{
	float out = gain*input;
 	return out;
}

#ifdef ADV_AUDIO

inline //riitta 061799
float* ProcessDirectiveSound::operator()(float* input)
//float* ProcessDirectiveSound::operator()(float input)
{
	float* tmp;
//	float in = input*intensity*out_gain;
	float in = (*input)*intensity*out_gain;

	if(aural){
		tmp = (*aural)(in);
		out[0] = tmp[0];
		out[1] = tmp[1];
	}

	else {
		out[0] = 0.0;
		out[1] = 0.0;
	}
//	return (float*)out;
	return out;

}

inline
void ProcessDirectiveSound::process(short* input, short* output, int spat_buf_length)
{
//	float totalgain = intensity*out_gain;
	float* tmp;
	float temppi = 0;
	int i =0;
	if(aural) {
		for(i=0;i<spat_buf_length;i+=2){
			temppi = intensity /*totalgain*/ * ((float)(*input));
			tmp = (*aural)(temppi);
		//	output[i] = (*aural)((*input)*totalgain);
			output[i] = tmp[0];
			output[i+1] = tmp[1];
			input++;
//			output
		}
	}
	else {
		for(i=0;i<spat_buf_length;i++)
			output[i] = 0.0;
	//	out[0] = 0.0;
	//	out[1] = 0.0;
	}

	
	/*	float totalgain = intensity*out_gain;
	if(aural){
		aural->process(input, output, spat_buf_length, totalgain);
	}
	else {
		int i=0;
		for(i=0;i<spat_buf_length;i++){
			output[i] = 0;
		}
	}
	*/
}

/*
inline
float* ProcessSound3D::process(float input)
{
	float* tmp;
	float x = input*intensity;
	if(ellip){
		x = (*ellip)(x);			
	}

	if(pan){
		tmp = (*pan)(x);
		out[0] = tmp[0];
		out[1] = tmp[1];
	}
	else{
		out[0] = x;
		out[1] = x;
	}
	return (float*)out;
}
*/
/*JB's stuff*/
//inline added by Riitta
inline
//void ProcessSound::process(int stream_id,float* input,short *output,int spat_buf_length)
void ProcessSound::process(int stream_id,short* input,short *output,int spat_buf_length)
{

	int i;

	float* tmp;

if(sound_3D)
{	for(i=0;i<spat_buf_length;i+=2)
	{	
	/*
//		tmp = (*sound_3D)(*input);
//		*output++ = tmp[i];
//		*output++ = tmp[i+1];
		*output++ = *input;
		*output++ = *input++;
	*/
		tmp = (*sound_3D)((float)(*input));
		input++;
		output[i] = tmp[0];
		output[i+1] = tmp[1];
	}
}

#ifdef ADV_AUDIO
	
else if(dirsound)
//else if(&dirsound)
{
	
	dirsound->process(input, output, spat_buf_length);
/*
	float temppi = 0;
	for(i=0;i<spat_buf_length;i+=2)
	{			
	// tmp = (*dirsound)(*input);

	temppi = (float)(*input);
	tmp = (*dirsound)(&temppi);
//	tmp = (dirsound)(input);
		input++;
		output[i] = tmp[0];
		output[i+1] = tmp[1];
		}

  */
}
#endif

else
{	for(i=0;i<spat_buf_length;i+=2)
	{
		*output++ = *input;
		*output++ = *input;
		input++;
	}
}

}
/*jb*/
#endif // ADV_AUDIO



