// -*- c++ -*-
/***********************************************************************
This software module was originally developed by Riitta Vaananen
(Helsinki University of Technology) in the course of development of
the MPEG-4 Systems (ISO/IEC 14496-1) standard.  This software module
is an implementation of a part of one or more MPEG-4 Systems (ISO/IEC
14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1)
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1)
free license to this software module or modifications thereof for use
in hardware or software products claiming conformance to the MPEG-4
Systems (ISO/IEC 14496-1). Those intending to use this software module
in hardware or software products are advised that its use may infringe
existing patents.  The original developer of this software module and
his/her company, the subsequent editors and their companies, and
ISO/IEC have no liability for use of this software module or
modifications thereof in an implementation.  Copyright is not released
for non MPEG-4 Systems (ISO/IEC 14496- 1) conforming products.
Helsinki University of Technology retains full right to use the code
for their own purpose, assign or donate the code to a third party and
to inhibit third parties from using the code for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. This copyright notice must be
included in all copies or derivative works. Copyright  1999.
************************************************************************/
inline //riitta 061799
float* LateReverb::operator()(float input)
{
	int i=0;
	float sum_lp = 0.0; //sum of the lowpass filter outputs
	out[0] = out[1] = 0.0;

	for(i=0;i<NOF_DL;i++){
		sum_lp+=lp_out[i];
	}

	out[0] = lp_out[0] - lp_out[2];
	out[1] = lp_out[1] - lp_out[3];

	if(init_dl){
		init_dl[init_dlp] = input * init_gain;		
		init_dlp = (init_dlp + 1)%init_delay;
		float temp = init_dl[init_dlp];
		for(i=0;i<4;i++){
			dl[i][dl_p[i]] = lp_out[i] -0.5*sum_lp; // beginning of delay line
			dl[i][(dl_p[i]+(1+dl_length[i]-dl_length[0]))%dl_length[i]] = temp+
				dl[i][(dl_p[i]+(1+dl_length[i]-dl_length[0]))%dl_length[i]]; // end of delay line
			dl_p[i] = (dl_p[i]+1)%(dl_length[i]);
			lp_out[i] = Ep[i]*(dl[i][dl_p[i]]+Bp[i]*lp_del[i]);
			lp_del[i] = dl[i][dl_p[i]];
		}
	}

	else{
		float temp = input - 0.5 * sum_lp;
		for(i=0;i<4;i++){
			dlp_in[i] = (dl_p[i] + init_delay)%(dl_length[i]);
			dl[i][dlp_in[i]] = temp + lp_out[i];
			dl_p[i] = (dl_p[i]+1)%(dl_length[i]);
			lp_out[i] = Ep[i]*(dl[i][dl_p[i]]+Bp[i]*lp_del[i]);
			lp_del[i] = dl[i][dl_p[i]];
		}
	}

/*
float temp = input - 0.5 * sum_lp;
	//	float temp = input;
	for(i=0;i<4;i++){
	 dl[i][dl_p[i]] = temp + lp_out[i];
	 dl_p[i] = (dl_p[i]+1)%(dl_length[i]);
		lp_out[i] = Ep[i]*(dl[i][dl_p[i]]+Bp[i]*lp_del[i]);
		lp_del[i] = dl[i][dl_p[i]];
	}
	*/
	return (float*)out;
}