#include "OpenGl/OpenGl.h"
#ifdef ADV_AUDIO

// -*- c++ -*-

/***********************************************************************
This software module was originally developed by Riitta Vaananen
(Helsinki University of Technology) in the course of development of
the MPEG-4 Systems (ISO/IEC 14496-1) standard.  This software module
is an implementation of a part of one or more MPEG-4 Systems (ISO/IEC
14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1)
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1)
free license to this software module or modifications thereof for use
in hardware or software products claiming conformance to the MPEG-4
Systems (ISO/IEC 14496-1). Those intending to use this software module
in hardware or software products are advised that its use may infringe
existing patents.  The original developer of this software module and
his/her company, the subsequent editors and their companies, and
ISO/IEC have no liability for use of this software module or
modifications thereof in an implementation.  Copyright is not released
for non MPEG-4 Systems (ISO/IEC 14496- 1) conforming products.
Helsinki University of Technology retains full right to use the code
for their own purpose, assign or donate the code to a third party and
to inhibit third parties from using the code for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. This copyright notice must be
included in all copies or derivative works. Copyright  1997.
************************************************************************/

#include "opengl/base/Matrix.h"
#include "DirectiveSoundProxy.h"
#include "../audio/AudioObjectProxy.h"

// Render object

BOOL
DirectiveSoundProxy::Render(const Matrix& /* rTransformation */, const CullFlag& /* rCullFlag */,
		   OpenGLVisualRenderer* pRenderer, DWORD dwTime)
{

    /* const AudioObject */ MediaObject * pSound = /* ((Sound*) GetMediaObject())-> */ GetSound();

  if (pSound)
    return ((AudioObjectProxy*) pSound->GetRenderingObject())->Render(pRenderer, dwTime);
  else
    return FALSE;
}

// Render object description

/* virtual */ void
DirectiveSoundProxy::RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime)
{
 // const AudioObject* pSound = ((DirectiveSound*) GetMediaObject())->GetSound();
 /* const AudioObject */ MediaObject * pSound = /* ((Sound*) GetMediaObject())-> */ GetSound();

  RenderDescriptionBox(pRenderer, "DirectiveSound");

  if (pSound) {
    ::glPushMatrix();
    ::glTranslatef(0.0f, -1.0f, 0.0f);

    ((AudioObjectProxy*) pSound->GetRenderingObject())->RenderDescription(pRenderer, dwTime);

    ::glPopMatrix();
  }
}

// Find sound sources

/* virtual */ int 
DirectiveSoundProxy::FindSoundSources(
    ZArray<Sound*>& /*rSources3d*/, 
    ZArray<Matrix>& /*rTransformations3d*/,
		ZArray<Sound2D*>& /* rSources2d */, 
    ZArray<Matrix>& /* rTransformations2d */,
		ZArray<DirectiveSound*>& rDirsources, 
    ZArray<Matrix>& rDirtransformations,
		const Matrix& rTransform)
{
	rDirsources += (DirectiveSound*) GetMediaObject();
	rDirtransformations +=rTransform;

  return 1;
}

#endif // DirectiveSoundProxy
