// -*- c++ -*-

/***********************************************************************
This software module was originally developed by Riitta Vaananen
(Helsinki University of Technology) in the course of development of
the MPEG-4 Systems (ISO/IEC 14496-1) standard.  This software module
is an implementation of a part of one or more MPEG-4 Systems (ISO/IEC
14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1)
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1)
free license to this software module or modifications thereof for use
in hardware or software products claiming conformance to the MPEG-4
Systems (ISO/IEC 14496-1). Those intending to use this software module
in hardware or software products are advised that its use may infringe
existing patents.  The original developer of this software module and
his/her company, the subsequent editors and their companies, and
ISO/IEC have no liability for use of this software module or
modifications thereof in an implementation.  Copyright is not released
for non MPEG-4 Systems (ISO/IEC 14496- 1) conforming products.
Helsinki University of Technology retains full right to use the code
for their own purpose, assign or donate the code to a third party and
to inhibit third parties from using the code for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. This copyright notice must be
included in all copies or derivative works. Copyright  1997.
************************************************************************/


#ifndef __DIRECTIVESOUNDPROXY_H__
#define __DIRECTIVESOUNDPROXY_H__

#include "opengl/base/Node3DProxy.h"
//#include "audio/DirectiveSound.h"
//#include "base/DirectiveSound.h" // Riitta 090299
//#include "core/Nodes.h"
//#include "opengl/audio/AudioObject.h"


/** DirectiveSound renderer node.

The actual audio rendering is done in the audio processing classes (ProcessDirectiveSound, 
Auralize). */
class DirectiveSoundProxy
  : public Node3DProxy
{
public:

  /// Constructor

	                DirectiveSoundProxy(DirectiveSound* pSound);

  /// Render object

  virtual BOOL		Render(const Matrix& rTransformation, const CullFlag& rCullFlag,
			       OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Render object description

  virtual void		RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Find sound sources

  /** Looks for sound sources and their transformations.*/
  virtual int		FindSoundSources(ZArray<Sound*>& rSources3d, ZArray<Matrix>& rTransformations3d,
					 ZArray<Sound2D*>& rSources2d, ZArray<Matrix>& rTransformations2d,
					ZArray<DirectiveSound*>& rDirsources, ZArray<Matrix>& rDirtransformations,
					 const Matrix& rTransform);


  inline DirectiveSound * GetDirectiveSound()
  { return (DirectiveSound *) GetMediaObject(); }
  /// Set sound sound
//  inline void SetSound(AudioObject* pSound)
	inline void SetSound(SFAudioNode pSound)
  { GetDirectiveSound()->source /* sound */ = pSound; }
  /// Get sound sound
//  inline AudioObject * GetSound()
// { return (AudioObject*) (MediaObject*) GetDirectiveSound()->source /* sound */ ; }

	inline SFAudioNode GetSound()
	{ return GetDirectiveSound()->source /* sound */ ; }

	//riitta 042599
  /// Decide whether to Cull or Render the object
//  inline BOOL CullOrRender(
//    const Matrix& rTransformation, 
//    const CullFlag& rCullFlag,
//		OpenGLVisualRenderer* pRenderer, 
//    DWORD dwTime);
};

#include "DirectiveSoundProxy.i"

#endif // __DIRECTIVESOUNDPROXY_H__
