// This software module was originally developed by Marc Emerit and 
// Jean-Bernard Rault (France Telecom) , in the course of
// development of the MPEG-4 Systems standard (ISO/IEC 14496-1).  This
// software module is an implementation of a part of one or more MPEG-4
// Systems tools as specified by the MPEG-4 Systems standard.  ISO/IEC
// gives users of the MPEG-4 Systems standard free license to this software
// module or modifications thereof for use in hardware or software products
// claiming conformance to the MPEG-4 Systems standard.  Those intending to
// use this software module in hardware or software products are advised
// that its use may infringe existing patents.  The original developer of
// this software module and his/her company, the subsequent editors and
// their companies, and ISO/IEC have no liability for use of this software
// module or modifications thereof in an implementation.  Copyright is not
// released for non MPEG-4 Systems conforming products.  The original
// developer retains full right to use the code for his/her own purpose,
// assign or donate the code to a third party and to inhibit third parties
// from using the code for non MPEG-4 Systems conforming products.  This
// copyright notice must be included in all copies or derivative works.
//
// For more information or to receive an up to date version of this module,
// mail karlo@nta.no or check <http://televr.fou.telenor.no/compositor/>.
//
// Copyright 1998.


// Direct.h: interface for the CDirect class.
//
//////////////////////////////////////////////////////////////////////


#ifndef _Direct_H
#define _Direct_H

#include "const.h"


extern "C" void UpdateEQ(float GainLow, float GainMid, float GainHigh, float FreqLow, float FreqHigh, float coef[5]);

class CDirect
{
public:
	CDirect();
	virtual ~CDirect();
	void SetDirectEqualizer(float FreqLow,float FreqHigh,float GainLow,float GainMid,float GainHigh);
	void DoFiltering(float *inBuff, float *outBuff,int SizeBuff);

private :


	float m_b0;
	float m_b1;
	float m_b2;
	float m_a1;
	float m_a2;

	float m_mema[2];
	float m_memb[2];
	int	  m_pos;

	float m_gainEQ;

	float m_FreqLow  ;
	float m_FreqHigh ;

};

#endif
