// Source.cpp: implementation of the CSource class.
//
//////////////////////////////////////////////////////////////////////

#include "Source.h"
#include <math.h>

CSource::CSource()
{
	m_FreqLow	= (float) (1.f/32.);
	m_FreqHigh	= (float) (1.f/8.);

	m_gainEQ = 1.f;
	m_b0 = 1.f;
	m_b1 = 0.f;
	m_b2 = 0.f;
	m_a1 = 0.f;
	m_a2 = 0.f;
	m_pos = 0;
	m_memb[0] = 0.0;
	m_memb[1] = 0.0;
	m_mema[0] = 0.0;
	m_mema[1] = 0.0;

}


CSource::~CSource()
{
}

void CSource::SetSourceEqualizer(float FreqLow,float FreqHigh,float GainLow,float GainMid,float GainHigh)
{
	float coef[5];

	m_FreqLow = FreqLow;
	m_FreqHigh = FreqHigh;

	UpdateEQ(GainLow,GainMid,GainHigh,FreqLow,FreqHigh,coef);

	m_b0=coef[0];
	m_b1=coef[1];
	m_b2=coef[2];

	m_a1=coef[3];
	m_a2=coef[4];

	m_gainEQ=GainMid;

}

void CSource::DoFiltering(float *inBuff, float *outBuff,int SizeBuff)
{
	
	float S;
	
	// equalization 
	

#ifdef IMPULSE				// to calculate the impulse response
	m_gainEQ=1.0;
#endif

	for(int i=0;i<SizeBuff;i++)
	{		S=inBuff[i]*m_b0;
      	    S+=m_b1*m_memb[m_pos];
       	    S-=m_a1*m_mema[m_pos++];
            m_pos&=0x1;
      	    S+=m_b2*m_memb[m_pos];
       	    S-=m_a2*m_mema[m_pos++];
            m_pos&=0x1;

            if(fabs(S)<0.000000001f)				// to avoid underflow 
				S=0.0;

            m_pos++;
            m_pos&=0x1;

            m_memb[m_pos]=inBuff[i];
            m_mema[m_pos]=S;
            outBuff[i] =S*m_gainEQ;
   	}


}
