// -*- c++ -*-

// This software module was originally developed by Karl Anders ygard
// (Telenor R&D) in the course of development of the MPEG-4 Systems
// standard (ISO/IEC 14496-1).  This software module is an implementation
// of a part of one or more MPEG-4 Systems tools as specified by the MPEG-4
// Systems standard.  ISO/IEC gives users of the MPEG-4 Systems standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// Copyright 1997.

#ifndef __IMAGETEXTUREPROXY_H__
#define __IMAGETEXTUREPROXY_H__

#include "TextureNodeProxy.h"

class ImageTexture;

/// Image texture renderer class

class ImageTextureProxy
  : public TextureNodeProxy
{
private:
  BOOL m_bFirst;

public:

  /// Constructor

  ImageTextureProxy(ImageTexture* pImageTexture);

  /// Render object description

  virtual void		RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Enable texture

  virtual BOOL		Enable(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Disable texture

  virtual BOOL		Disable(OpenGLVisualRenderer* pRenderer, DWORD dwTime);


#ifdef SAIT_CONFORMANCE_2003
    BOOL GetFirst(void) { return m_bFirst; };
    void SetFirst(BOOL bFirst) { m_bFirst = bFirst; };
#endif

// SB
public:
  inline ImageTexture * GetImageTexture()
  { return (ImageTexture *) GetMediaObject(); }

  void Start()
  {
#ifndef BIFSENC
    m_bActive = TRUE;
    GetImageTexture()->OpenStream();
#endif
  };

  void Stop()
  {
#ifndef BIFSENC
    m_bActive = FALSE;
    GetImageTexture()->CloseStream();
    //PauseStream();
#endif
  };

};

#include "ImageTextureProxy.i"

#endif // __IMAGETEXTUREPROXY_H__
