// This software module was originally developed by Kevin Barron (KPN Research), 
// Mike Coleman (Five Bats Research), Edward Cooke (Teltec Ireland), In-Dai Ha 
// (Hyundai Electronics Industries, Co.), Hae-Kwan Kim (Hyundai Electronics 
// Industries, Co.), Matthew Leditschke (CSELT), Zvi Lifshitz (VDOnet Corp.), 
// Karl Anders ygard (Telenor R&D), in the course of development of the MPEG-4 
// Systems standard (ISO/IEC 14496-1).  This software module is an 
// implementation of a part of one or more MPEG-4 Systems tools as specified by 
// the MPEG-4 Systems standard.  ISO/IEC gives users of the MPEG-4 Systems 
// standard free license to this software module or modifications thereof for 
// use in hardware or software products claiming conformance to the MPEG-4 
// Systems standard.  Those intending to use this software module in hardware or 
// software products are advised that its use may infringe existing patents.  
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use 
// of this software module or modifications thereof in an implementation.  
// Copyright is not released for non MPEG-4 Systems conforming products.  The 
// original developer retains full right to use the code for his/her own 
// purpose, assign or donate the code to a third party and to inhibit third 
// parties from using the code for non MPEG-4 Systems conforming products.  This 
// copyright notice must be included in all copies or derivative works.
//
// Copyright 1997.


#include "OpenGl/OpenGl.h"
#include "LinePropertiesProxy.h"


// Render object description

/* virtual */ void
LinePropertiesProxy::RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD /* dwTime */)
{
  RenderDescriptionBox(pRenderer, "LineProperties");
}

// Enable lineProperties

BOOL
LinePropertiesProxy::Enable(OpenGLVisualRenderer* pRenderer, DWORD /* dwTime */)
{
  // LineProperties* pLineProperties = (LineProperties*) GetMediaObject();

  ::glPushAttrib(GL_LINE_BIT);

  if (/* pLineProperties-> */ GetWidth() != 0.0f)
    ::glLineWidth(/* pLineProperties-> */ GetWidth());

#ifdef _DEBUG
  if (pRenderer->CheckGLError("LinePropertiesProxy:")) {
    TRACE("width: %f\n", /* pLineProperties-> */ GetWidth());
    TRACE("LinePropertiesProxy::Enable() [%08x]: ", this);
  }
#endif

  return TRUE;
}
