// This software module was originally developed by Kevin Barron (KPN Research), 
// Mike Coleman (Five Bats Research), Edward Cooke (Teltec Ireland), In-Dai Ha 
// (Hyundai Electronics Industries, Co.), Hae-Kwan Kim (Hyundai Electronics 
// Industries, Co.), Matthew Leditschke (CSELT), Zvi Lifshitz (VDOnet Corp.), 
// Karl Anders ygard (Telenor R&D), in the course of development of the MPEG-4 
// Systems standard (ISO/IEC 14496-1).  This software module is an 
// implementation of a part of one or more MPEG-4 Systems tools as specified by 
// the MPEG-4 Systems standard.  ISO/IEC gives users of the MPEG-4 Systems 
// standard free license to this software module or modifications thereof for 
// use in hardware or software products claiming conformance to the MPEG-4 
// Systems standard.  Those intending to use this software module in hardware or 
// software products are advised that its use may infringe existing patents.  
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use 
// of this software module or modifications thereof in an implementation.  
// Copyright is not released for non MPEG-4 Systems conforming products.  The 
// original developer retains full right to use the code for his/her own 
// purpose, assign or donate the code to a third party and to inhibit third 
// parties from using the code for non MPEG-4 Systems conforming products.  This 
// copyright notice must be included in all copies or derivative works.
//
// Copyright 1997.


#ifndef __LINEPROPERTIESPROXY_H__
#define __LINEPROPERTIESPROXY_H__

#include "opengl/base/MediaObjectProxy.h"
//#include "defs.h"

// class LineProperties;
//#include "Nodes.h"

/// 2D lineProperties renderer class

class LinePropertiesProxy
  : public MediaObjectProxy
{
 public:

  /// Constructor

			LinePropertiesProxy(LineProperties* pLineProperties);

  /// Enable lineProperties

  BOOL			Enable(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Disable lineProperties

  BOOL			Disable(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Render object description

  virtual void		RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  // Stefano Battista
  // moved methods from LineProperties to Proxy
public:
  /// Get pointer to associated MediaObject
  inline LineProperties * GetLineProperties() const
  { return (LineProperties *) GetMediaObject(); }
  /// Set line width
  inline float GetWidth() const
  { return GetLineProperties()->width; }
  /// Get line width
  inline void SetWidth(float fWidth)
  { GetLineProperties()->width = fWidth; }
  
};

#include "LinePropertiesProxy.i"

#endif // __LINEPROPERTIESPROXY_H__
