// -*- c++ -*-

// This software module was originally developed by Karl Anders ygard
// (Telenor R&D) in the course of development of the MPEG-4 Systems
// standard (ISO/IEC 14496-1).  This software module is an implementation
// of a part of one or more MPEG-4 Systems tools as specified by the MPEG-4
// Systems standard.  ISO/IEC gives users of the MPEG-4 Systems standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// Copyright 1997.


#include "opengl/appearance/LinePropertiesProxy.h"


// constructor

inline
Material2DProxy::Material2DProxy(Material2D* pMaterial2D)
  : MaterialNodeProxy(pMaterial2D)
{
}

// disable material2D

inline BOOL
Material2DProxy::Disable(OpenGLVisualRenderer* pRenderer, DWORD dwTime)
{
  // Material2D* pMaterial = (Material2D*) GetMediaObject();

  float transparency = /* pMaterial-> */ GetTransparency();
 
  if (transparency > 0.0f)
    if (transparency < 1.0f)
      ::glDisable(GL_POLYGON_STIPPLE);
    else {
      ::glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
      ::glDepthMask(GL_TRUE);
    }	
	
  if (/* pMaterial-> */ GetLineProps())
    ((LinePropertiesProxy*) /* pMaterial-> */ GetLineProps()->GetRenderingObject())->Disable(pRenderer, dwTime);
  
  pRenderer->SetCurrentMaterial2D(NULL);

  ::glPopAttrib();

  return TRUE;
}
