// This software module was originally developed by Kevin Barron (KPN Research), 
// Mike Coleman (Five Bats Research), Edward Cooke (Teltec Ireland), In-Dai Ha 
// (Hyundai Electronics Industries, Co.), Hae-Kwan Kim (Hyundai Electronics 
// Industries, Co.), Matthew Leditschke (CSELT), Zvi Lifshitz (VDOnet Corp.), 
// Karl Anders ygard (Telenor R&D), in the course of development of the MPEG-4 
// Systems standard (ISO/IEC 14496-1).  This software module is an 
// implementation of a part of one or more MPEG-4 Systems tools as specified by 
// the MPEG-4 Systems standard.  ISO/IEC gives users of the MPEG-4 Systems 
// standard free license to this software module or modifications thereof for 
// use in hardware or software products claiming conformance to the MPEG-4 
// Systems standard.  Those intending to use this software module in hardware or 
// software products are advised that its use may infringe existing patents.  
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use 
// of this software module or modifications thereof in an implementation.  
// Copyright is not released for non MPEG-4 Systems conforming products.  The 
// original developer retains full right to use the code for his/her own 
// purpose, assign or donate the code to a third party and to inhibit third 
// parties from using the code for non MPEG-4 Systems conforming products.  This 
// copyright notice must be included in all copies or derivative works.
//
// Copyright 1997.


#ifndef __MATERIALNODEPROXY_H__
#define __MATERIALNODEPROXY_H__

#include "opengl/base/MediaObjectProxy.h"
//#include "defs.h"

class MaterialNode;

/// MaterialNode renderer class

class MaterialNodeProxy
  : public MediaObjectProxy
{
 public:

  /// Constructor

			// MaterialNodeProxy(MaterialNode* pMaterialNode);
			MaterialNodeProxy(MediaObject* pMaterialNode);

  /// Enable materialNode

  virtual BOOL		Enable(OpenGLVisualRenderer* pRenderer, DWORD dwTime) = 0;

  /// Disable materialNode

  virtual BOOL		Disable(OpenGLVisualRenderer* pRenderer, DWORD dwTime) = 0;

  /// Render object description

  virtual void		RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

protected:

  // Stipple mask for transparency

  static const unsigned char
			stippleMask[16][128];
};

#include "MaterialNodeProxy.i"

#endif // __MATERIALNODEPROXY_H__
