// -*- c++ -*-

// This software module was originally developed by Karl Anders ygard
// (Telenor R&D) in the course of development of the MPEG-4 Systems
// standard (ISO/IEC 14496-1).  This software module is an implementation
// of a part of one or more MPEG-4 Systems tools as specified by the MPEG-4
// Systems standard.  ISO/IEC gives users of the MPEG-4 Systems standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// Copyright 1997.
// This file was created by K. Mueller, FhG-HHI 2004

#ifndef __MULTITEXTUREPROXY_H__
#define __MULTITEXTUREPROXY_H__

#include "TextureNodeProxy.h"

class MultiTexture;

/// Multi texture renderer class

class MultiTextureProxy
  : public TextureNodeProxy
{

public:

  /// Constructor

  MultiTextureProxy(MultiTexture* pMultiTexture);

  /// Render object description

  virtual void		RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Enable texture

  virtual BOOL		Enable(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Disable texture

  virtual BOOL		Disable(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

// SB
public:
  UINT getNumberOfViews()
  { return m_uiNumberOfViews; }

  MF<Vec3f>& getCameraVector()
  { return m_CameraVector; }

  inline MultiTexture * GetMultiTexture() const
  { return (MultiTexture *) GetMediaObject(); }

  MediaObject* GetTexture(int n) const
  { return (MediaObject *) GetMultiTexture()->texture.GetObject(n); }

private:
  UINT m_uiNumberOfViews;
  MF<Vec3f> m_CameraVector;
};

#include "MultiTextureProxy.i"

#endif // __MULTITEXTUREPROXY_H__