// This software module was originally developed by Kevin Barron (KPN Research), 
// Mike Coleman (Five Bats Research), Edward Cooke (Teltec Ireland), In-Dai Ha 
// (Hyundai Electronics Industries, Co.), Hae-Kwan Kim (Hyundai Electronics 
// Industries, Co.), Matthew Leditschke (CSELT), Zvi Lifshitz (VDOnet Corp.), 
// Karl Anders ygard (Telenor R&D), in the course of development of the MPEG-4 
// Systems standard (ISO/IEC 14496-1).  This software module is an 
// implementation of a part of one or more MPEG-4 Systems tools as specified by 
// the MPEG-4 Systems standard.  ISO/IEC gives users of the MPEG-4 Systems 
// standard free license to this software module or modifications thereof for 
// use in hardware or software products claiming conformance to the MPEG-4 
// Systems standard.  Those intending to use this software module in hardware or 
// software products are advised that its use may infringe existing patents.  
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use 
// of this software module or modifications thereof in an implementation.  
// Copyright is not released for non MPEG-4 Systems conforming products.  The 
// original developer retains full right to use the code for his/her own 
// purpose, assign or donate the code to a third party and to inhibit third 
// parties from using the code for non MPEG-4 Systems conforming products.  This 
// copyright notice must be included in all copies or derivative works.
//
// Copyright 1997.


#ifndef __TEXTURETRANSFORMPROXY_H__
#define __TEXTURETRANSFORMPROXY_H__

#include "opengl/base/MediaObjectProxy.h"
//#include "defs.h"

// class TextureTransform;
//#include "Nodes.h"
//#include "NodeFld.h"

/// Texture transformation renderer class

class TextureTransformProxy
  : public MediaObjectProxy
{
public:

  /// Constructor

                        TextureTransformProxy(TextureTransform* pTextureTransform);

  /// Enable texture transformation

  BOOL			Enable(DWORD dwTime);

  /// Disable texture transformation

  BOOL			Disable(DWORD dwTime);

  /// Render object description

  virtual void		RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  // SB moved from TextureTransform
public:
  inline TextureTransform * GetTextureTransform()
  { return (TextureTransform *) GetMediaObject(); }
  /// Set center of scaling and rotation
  inline void SetCenter(const SF<Vec2f>& rCenter)
  { GetTextureTransform()->center = rCenter; }
  /// Get center of scaling and rotation
  inline const SF<Vec2f>& GetCenter() /* const */
  { return GetTextureTransform()->center; }
  /// Set rotation
  inline void SetRotation(float fRotation)
  { GetTextureTransform()->rotation = fRotation; }
  /// Get rotation
  inline float GetRotation() /* const */
  { return GetTextureTransform()->rotation; }
  /// Set scaling
  inline void SetScale(const SF<Vec2f>& rScale)
  { GetTextureTransform()->scale = rScale; }
  /// Get scaling
  inline const SF<Vec2f>& GetScale() /* const */
  { return GetTextureTransform()->scale; }
  /// Set translation
  inline void SetTranslation(const SF<Vec2f>& rTranslation)
  { GetTextureTransform()->translation = rTranslation; }
  /// Get translation
  inline const SF<Vec2f>& GetTranslation() /* const */
  { return GetTextureTransform()->translation; }

};

#include "TextureTransformProxy.i"

#endif // __TEXTURETRANSFORMPROXY_H__
