// -*- c++ -*-

// This software module was originally developed by Matthew Leditschke
// (CSELT) and Karl Anders ygard (Telenor R&D), in the course of
// development of the MPEG-4 Systems standard (ISO/IEC 14496-1).  This
// software module is an implementation of a part of one or more MPEG-4
// Systems tools as specified by the MPEG-4 Systems standard.  ISO/IEC
// gives users of the MPEG-4 Systems standard free license to this software
// module or modifications thereof for use in hardware or software products
// claiming conformance to the MPEG-4 Systems standard.  Those intending to
// use this software module in hardware or software products are advised
// that its use may infringe existing patents.  The original developer of
// this software module and his/her company, the subsequent editors and
// their companies, and ISO/IEC have no liability for use of this software
// module or modifications thereof in an implementation.  Copyright is not
// released for non MPEG-4 Systems conforming products.  The original
// developer retains full right to use the code for his/her own purpose,
// assign or donate the code to a third party and to inhibit third parties
// from using the code for non MPEG-4 Systems conforming products.  This
// copyright notice must be included in all copies or derivative works.
//
// Copyright 1997, 1998.

#ifndef __SOUND2DPROXY_H__
#define __SOUND2DPROXY_H__

#include "opengl/base/Node2DProxy.h"

//#include "Nodes.h"
// SB #### simply removed AudioObject
// #include "audio/AudioObject.h"

class Sound2D;

/// Sound renderer node

class Sound2DProxy
  : public Node2DProxy
{
public:

  /// Constructor

	                Sound2DProxy(Sound2D* pSound);

  /// Render object

  virtual BOOL		Render(const Matrix& rTransformation, const CullFlag& rCullFlag,
			       OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Render object description

  virtual void		RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Find sound sources

  virtual int  FindSoundSources(
    ZArray<Sound*>& rSources3d, ZArray<Matrix>& rTransformations3d,
		ZArray<Sound2D*>& rSources2d, ZArray<Matrix>& rTransformations2d,
		const Matrix& rTransform);

  // SB 98/12/04 moved from Sound2D
public:
  Sound2D * GetSound2D()
  { return (Sound2D *) GetMediaObject(); }
  /// Find Sound2D sources in hierarchy
  inline /* virtual */ int FindSound2DSources(ZArray<Sound2D*>& Sound2DSources)
  { Sound2DSources += GetSound2D() /* this */ ;
    return 1; }
  /// Get sound source
  inline SFAudioNode GetSound()
  { return GetSound2D()->source; }
  /// Set sound source
  inline void SetSound(SFAudioNode oSound)
  { GetSound2D()->source = oSound; }

};

#include "Sound2DProxy.i"

#endif // __SOUND2DPROXY_H__
