// This software module was originally developed by Kevin Barron (KPN Research), 
// Mike Coleman (Five Bats Research), Edward Cooke (Teltec Ireland), In-Dai Ha 
// (Hyundai Electronics Industries, Co.), Hae-Kwan Kim (Hyundai Electronics 
// Industries, Co.), Matthew Leditschke (CSELT), Zvi Lifshitz (VDOnet Corp.), 
// Karl Anders ygard (Telenor R&D), in the course of development of the MPEG-4 
// Systems standard (ISO/IEC 14496-1).  This software module is an 
// implementation of a part of one or more MPEG-4 Systems tools as specified by 
// the MPEG-4 Systems standard.  ISO/IEC gives users of the MPEG-4 Systems 
// standard free license to this software module or modifications thereof for 
// use in hardware or software products claiming conformance to the MPEG-4 
// Systems standard.  Those intending to use this software module in hardware or 
// software products are advised that its use may infringe existing patents.  
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use 
// of this software module or modifications thereof in an implementation.  
// Copyright is not released for non MPEG-4 Systems conforming products.  The 
// original developer retains full right to use the code for his/her own 
// purpose, assign or donate the code to a third party and to inhibit third 
// parties from using the code for non MPEG-4 Systems conforming products.  This 
// copyright notice must be included in all copies or derivative works.
//
// Copyright 1997.


#include <sys/time.h>

// Define GetTickCount() as unix doesn't implement it

static inline unsigned long
GetTickCount()
{
  struct timeval currentTime;

  ::gettimeofday(&currentTime, NULL);
  
  return currentTime.tv_sec * 1000 + currentTime.tv_usec / 1000;
} /* GetTickCount */

// Constructor

inline
AudioRendererSgi::AudioRendererSgi(Presenter* pPresenter, HWND hWnd)
  : AudioRenderer(pPresenter, hWnd),
    m_audioPort(NULL),
    m_samplesPerSec(0),
    m_bitsPerSample(0),
    m_bytesPerSample(0),
    m_numChannels(0),
    m_outputQueueSize(0),
    m_pMixBuffer(NULL),
    m_bActive(FALSE)
{
}

// Destructor

inline
AudioRendererSgi::~AudioRendererSgi()
{
  // Make sure that the renderer is first terminated

  Terminate();
}

// Get the capabilities of this audio renderer

inline /* virtual */ void
AudioRendererSgi::GetCapabilities(Capabilities* pCaps)
{
  pCaps->AddFormatCapability(FORMAT_PCM, 0);
}

