// -*- c++ -*-

// This software module was originally developed by Karl Anders ygard
// (Telenor R&D) in the course of development of the MPEG-4 Systems
// standard (ISO/IEC 14496-1).  This software module is an implementation
// of a part of one or more MPEG-4 Systems tools as specified by the MPEG-4
// Systems standard.  ISO/IEC gives users of the MPEG-4 Systems standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// Copyright 1997.

#ifndef __NODE3DPROXY_H__
#define __NODE3DPROXY_H__

#include "NodeProxy.h"
//satish added this line
#include "Nodes.h"

class MediaObject;

/// Node renderer class

class Node3DProxy
  : public NodeProxy
{
  // SB @@@@ form Node3D to Proxy >>>>
protected:
  /* Collision parents of this object.

     This list contains all Collision parents of this object.  The object
     can have multiple parents, since it may have been DEFed and USEd
     several times.

     This list is required in order to maintain consistency in bounding
     boxes of parents. */
  ZArray<Collision*>	m_CollisionParents;
  // SB @@@@ form Node3D to Proxy <<<<

public:

  /// Constructor

  // Stefano Battista 98/11/12
	// Node3DProxy(Node3D* pNode);
	Node3DProxy(MediaObject * pNode);

  /// Render object description
  virtual void RenderDescription(
    OpenGLVisualRenderer* pRenderer, 
    DWORD dwTime);

  /// Add collision parent of object  
  inline void AddCollisionParent(Collision* pParent)
  { m_CollisionParents += pParent; } 

  /// Remove collision parent of object
  inline BOOL RemoveCollisionParent(Collision* pParent)
  { return m_CollisionParents -= pParent; }
};

#include "Node3DProxy.i"

#endif // __NODE3DPROXY_H__
