// -*- C++ -*-

// This software module was originally developed by Karl Anders ygard
// (Telenor R&D), Simen Hagen (Telenor R&D) and Eddie Cooke (Teltec
// Ireland) in the course of development of the MPEG-4 Systems standard
// (ISO/IEC 14496-1).  This software module is an implementation of a part
// of one or more MPEG-4 Systems tools as specified by the MPEG-4 Systems
// standard.  ISO/IEC gives users of the MPEG-4 Systems standard free
// license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.	 The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.	 This copyright notice must be included in
// all copies or derivative works.
//
// Copyright 1997.

#ifndef __OPENGLAPPLICATION_H__
#define __OPENGLAPPLICATION_H__

//#include "App.h"
//ML - commented out the next two lines
//#include "Executive3d.h"
//#include "opengl/base/VisualRenderer.h"
//satish added the next two lines

#include "OpenGLPresenter.h"
#include "VisualRenderer.h"
#include "Application.h"

class OpenGLPresenter;
//ML - added the next line
class Executive3d;

/// OpenGL frame application

class OpenGLApplication
  : public Application
{
public:

#ifdef WIN32

  /// Constructor

			OpenGLApplication(HWND hWnd);

#else

  /// Constructor

			OpenGLApplication(int* argc, char* argv[]);

#endif

  /// Signal that a connection was made
  //ML - changed RESPONSE_PARAMETER to RESPONSE
	//satish changed this
  //virtual void OnConnect(RESPONSE result = RESPONSE_OK);
  virtual void OnConnect(CONNECTION_RESULT );

  /// Finish

  virtual void Finish();

  /// Bitstream finished
  //ML - changed RESPONSE_PARAMETER to RESPONSE
  //virtual void OnFinish(RESPONSE reason = RESPONSE_END_OF_DATA);
  virtual void OnFinish(SERVICE_TERMINATION );

  /// We got a non-fatal error

  //ML - added args parameter
  virtual void OnError(NON_FATAL_ERROR, va_list args);

  /// Print some debug stats about the application

  void Debug();

private:

  /// Are we finished?

  BOOL			m_bFinished;

  /// Return value

  int			m_nReturn;

  // Everything below is implementation specific

  // Configure OpenGL

  void			ConfigureOpenGL();

#if defined(GLUT)

  // Glut displayfunction

  static void		m_glutDisplayFunction();

  // Glut idlefunction

  static void		m_glutIdleFunction();

  // Glut menufunction

  static void		m_glutMenuFunction(int nMenuItem);

  // Glut mousefunction

  static void		m_glutMouseFunction(int nButton, int nState, int nX, int nY);

  // Glut motionfunction

  static void		m_glutMotionFunction(int nX, int nY);

  // Glut keyboardfunction

  static void		m_glutKeyboardFunction(unsigned char key, int x, int y);

  // Glut reshapefunction

  static void		m_glutReshapeFunction(int nX, int nY);

#elif defined(WIN32)

  friend LRESULT CALLBACK
                        WndProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam);

  HGLRC			m_hglrc;

#endif

  /// Mouse buttons

  int			m_nMouseButtons;

  /// Whether to render full screen

  BOOL			m_bFullscreen;

  /// Filename of bitstream

  const char*		m_pBitstreamFilename;

  /// Pointer to Executive

	//satish commented this.
  //Executive3d * m_pExecutive;

  // Running application

  static OpenGLApplication*
			m_pApplication;
};

#include "OpenGLApplication.i"

#endif // __OPENGLAPPLICATION_H__

