// -*- c++ -*-

// This software module was originally developed by Karl Anders ygard
// (Telenor R&D), in the course of development of the MPEG-4 Systems
// standard (ISO/IEC 14496-1).  This software module is an implementation
// of a part of one or more MPEG-4 Systems tools as specified by the MPEG-4
// Systems standard.  ISO/IEC gives users of the MPEG-4 Systems standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// Copyright 1997, 1998.


// Get pointer to visual renderer
  
inline /* virtual */ VisualRenderer*
OpenGLPresenter::GetVisualRenderer() const
{
  return m_pVisualRenderer;
}

// Get pointer to visual renderer
  
inline /* virtual */ OpenGLVisualRenderer*
OpenGLPresenter::GetOpenGLVisualRenderer() const
{
  return m_pVisualRenderer;
}

// Get pointer to audio renderer
  
inline /* virtual */ AudioRenderer*
OpenGLPresenter::GetAudioRenderer() const
{
  return m_pAudioRenderer;
}

/// Resize the display

inline /* virtual */ void
OpenGLPresenter::ReSize(int nWidth, int nHeight)
{
  m_pVisualRenderer->ReSize(nWidth, nHeight);
}

// SB 99/05/14: commented out: defined in Presenter (Player3d)
/// Output message
/***
inline /& virtual &/ void
OpenGLPresenter::Logf(LPCSTR szFormat, ...)
{
  va_list marker;
  char buf[1024];
  
  va_start(marker, szFormat);
  vsprintf(buf, szFormat, marker);
  
  COMPLAIN(buf);
  
  va_end(marker);
}
***/

// Return loop number
  
inline /* virtual */ DWORD
OpenGLPresenter::GetTime() const
{
  return m_dwLoop;
}

// Get clock reference
  
inline const ClockReference&
OpenGLPresenter::GetClock() const
{
  return m_clock;
}
