// This software module was originally developed by Karl Anders ygard
// (Telenor R&D) in the course of development of the MPEG-4 Systems
// standard (ISO/IEC 14496-1).  This software module is an implementation
// of a part of one or more MPEG-4 Systems tools as specified by the MPEG-4
// Systems standard.  ISO/IEC gives users of the MPEG-4 Systems standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// Copyright 1998.

#include "OpenGl/OpenGl.h"
#include "TermCapProxy.h"
#include "opengl/appearance/AppearanceProxy.h"
#include "opengl/geometry/GeometryProxy.h"
#include "opengl/base/OpenGLPresenter.h"

// Render object

/* virtual */ BOOL
TermCapProxy::Render(const Matrix& /* rTransformation */, const CullFlag& /* rCullFace */,
		     OpenGLVisualRenderer* pRenderer, DWORD /* dwTime */)
{
  TermCap* pTermCap = (TermCap*) GetMediaObject();

  if (pTermCap->capability /* GetCapability() */ == 0) {
    float fFrameRate = pRenderer->GetFrameRate();
    int capability;

    if (fFrameRate < 5.0f)
      capability = 1;
    else
      if (fFrameRate < 10.0f)
	capability = 2;
      else
	if (fFrameRate < 20.0f)
	  capability = 3;
	else
	  if (fFrameRate < 40.0f)
	    capability = 4;
	  else
	    capability = 5;
    
    if (pTermCap->value /* GetValue() */ != capability)
      pTermCap->value /* SetValue */ = (capability);
  }

  return TRUE;
}

// Render object description

/* virtual */ void
TermCapProxy::RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD /* dwTime */)
{
  GLfloat color[] = { 0.0f, 1.0f, 1.0f, 0.75f};

	//satish changed this line for compilation purposes
  //::glColor4fv(color);
  glColor4fv(color);

  RenderDescriptionBox(pRenderer, "TermCap");
}
