// This software module was originally developed by Karl Anders ygard
// (Telenor R&D) in the course of development of the MPEG-4 Systems
// standard (ISO/IEC 14496-1).  This software module is an implementation
// of a part of one or more MPEG-4 Systems tools as specified by the MPEG-4
// Systems standard.  ISO/IEC gives users of the MPEG-4 Systems standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// For more information or to receive an up to date version of this module,
// mail karlo@nta.no or check <http://televr.fou.telenor.no/compositor/>.
//
// Copyright 1997, 1998.

#include "OpenGl/OpenGl.h"
#include "VisualRenderer.h"

/***
#include "sensors/VisibilitySensor.h"
#include "sensors/ProximitySensor.h"
***/

// Paint

/* virtual */ void
VisualRenderer::Paint(RECT*)
{
  int i; 

  /* When a mediastream is not used, it must be closed.  In order to do
     this, we register objects that actually consume streams on a frame to
     frame basis, and shut off mediastreams that have become inactive since
     last frame. */
  int n = 0; // SOLARIS PORTING - moved it here from the block

  if ( n = m_oldStreamConsumers.GetLength() > 0)
  {
    TRACE("[VisualRenderer::Paint] Old Decs %4d \n", n);
    for (i = 0; i < n; i++)
    {
      TRACE("Dec %4d -- %08x \n", 
        i, (void *) m_oldStreamConsumers[i]);
    }
  }

  // SB 99/03/30 ^^^^ commented out CloseStream...
  for (i = m_oldStreamConsumers.GetLength() - 1; i >= 0; --i)
    if (m_activeStreamConsumers.Find(m_oldStreamConsumers[i]) == -1)
    {
      // SB ^^^^ m_oldStreamConsumers[i]->CloseStream(/* FALSE */);
    }

  m_oldStreamConsumers = m_activeStreamConsumers;
  m_activeStreamConsumers.Clear();

  /* Shut off sensors that have become non-visible since last frame. */

  for (i = m_oldVisibilitySensors.GetLength() - 1; i >= 0; --i)
    if (m_visibleVisibilitySensors.Find(m_oldVisibilitySensors[i]) == -1)
      ((VisibilitySensorProxy *) m_oldVisibilitySensors[i]->GetRenderingObject())->
          IsVisible(FALSE, this);

  m_oldVisibilitySensors = m_visibleVisibilitySensors;
  m_visibleVisibilitySensors.Clear();

  /* Shut off sensors that have not been activated since last frame. */

  for (i = m_oldProximitySensors.GetLength() - 1; i >= 0; --i)
    if (m_activeProximitySensors.Find(m_oldProximitySensors[i]) == -1)
      ((ProximitySensorProxy *) m_oldProximitySensors[i]->GetRenderingObject())->
          Deactivate();

  m_oldProximitySensors = m_activeProximitySensors;
  m_activeProximitySensors.Clear();
}

// Select

/* virtual */ int
VisualRenderer::Select(int /* nX */, int /* nY */)
{
  return 0;
}

// Resize the display

/* virtual */ void
VisualRenderer::ReSize(int /* nWidth */, int /* nHeight */)
{
}
