// -*- c++ -*-

// This software module was originally developed by Karl Anders ygard
// (Telenor R&D) in the course of development of the MPEG-4 Systems
// standard (ISO/IEC 14496-1).  This software module is an implementation
// of a part of one or more MPEG-4 Systems tools as specified by the MPEG-4
// Systems standard.  ISO/IEC gives users of the MPEG-4 Systems standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// For more information or to receive an up to date version of this module,
// mail karlo@nta.no or check <http://televr.fou.telenor.no/compositor/>.
//
// Copyright 1997, 1998.


// Constructor

inline
VisualRenderer::VisualRenderer(Presenter* /* pPresenter */)
{
}

// Destructor

inline /* virtual */
VisualRenderer::~VisualRenderer()
{
}

// Initialise renderer

inline /* virtual */ void
VisualRenderer::Init()
{
  m_activeStreamConsumers.Clear();
  m_oldStreamConsumers.Clear();
}

// Terminate

inline /* virtual */ void
VisualRenderer::Terminate()
{
}

// Get capabilities

inline /* virtual */ void
VisualRenderer::GetCapabilities(Capabilities* /* pCapabilities */)
{
}

// Register object that consumes a video stream

inline void VisualRenderer::RegisterStreamConsumer(StreamConsumer * pObject)
{
  if (m_activeStreamConsumers.Find(pObject) == -1) {
  // Stefano Battista 98/11/09
    // pObject->OpenStream();
    ((StreamConsumer *) pObject)->OpenStream();
    
    m_activeStreamConsumers += pObject;
  }
}

// Unregister object that consumes a video stream

inline void VisualRenderer::UnregisterStreamConsumer(StreamConsumer * pObject)
{
  if (m_activeStreamConsumers.Find(pObject) != -1)
    m_activeStreamConsumers -= pObject;

  if (m_oldStreamConsumers.Find(pObject) != -1)
    m_oldStreamConsumers -= pObject;
}

// Register VisibilitySensor that has become visible.

inline void
VisualRenderer::RegisterVisibilitySensor(VisibilitySensor* pVisibilitySensor)
{
  if (m_visibleVisibilitySensors.Find(pVisibilitySensor) == -1)
    m_visibleVisibilitySensors += pVisibilitySensor;
}

// Register ProximitySensor that has become visible.

inline void
VisualRenderer::RegisterProximitySensor(ProximitySensor* pProximitySensor)
{
  if (m_activeProximitySensors.Find(pProximitySensor) == -1)
    m_activeProximitySensors += pProximitySensor;
}
