#include "OpenGl/OpenGl.h"
//#include "Executiv.h"
//#include "opengl/base/OpenGLPresenter.h"
#include "BAPProxy.h"
#include "ConversionTable.h"

// Local Defines
#ifndef VRML_NB_JOINTS
#define VRML_NB_JOINTS 46+2
#endif

#ifndef VRML_NB_HAND_JOINTS
#define VRML_NB_HAND_JOINTS 15
#endif

#ifndef NBJ
#define NBJ (VRML_NB_JOINTS+2*VRML_NB_HAND_JOINTS)
#endif

#define FILE_OF_BAPS "input.bap"
#define FILE_OF_JOINTS_ID "Hanim2Bifs.table"

// Constructor, only calls the base constructor
BAPProxy::BAPProxy(BAP * poBap)
	: MediaObjectProxy(poBap),
	  firstUpdatePassed(FALSE)
{
	TRACE("[BAPProxy::BAPProxy]\n");
}

// Update method, use unknown for the moment
BOOL BAPProxy::Update(	VisualRenderer* /*pRenderer*/,
						DWORD /*dwTime*/)
{
	/*
	TRACE("[BAPProxy::Update]\n");

	if (!firstUpdatePassed) // If first Update opens the BAP file
	{
		Start();
		firstUpdatePassed=-1;
	}
	else // Otherwise, just read the BAPS
	{
		if (ReadBAPS()) // Did we succeed in reading a frame of BAPS ?
		{
			// Yes, updates the BAP values of the MPEG4Body
			for (int i=0 ; i<MPEG4_BODY_NUM_BAPS ; i++)
				body->bodySetBAP(i+1, GetBAPValue(i));
			body->bodyUpdate(GetPointerTable());

			this->PrettyPrintBAPs();
		}
	}
	return TRUE;*/
	
#ifndef BIFSENC

  // SB $$$$ 99/03/10 Start Stream and Register Channel
  BAP * poBAP = GetBAP();
  if (!firstUpdatePassed)
  {
    Start();
    poBAP->GetExecutive()->RequestChannels();
    firstUpdatePassed=1;
    TRACE("[BapProxy::Update] StreamConsumer started \n");
  }


#ifdef DN_CANNOT
  // Tolga 03/24/2000: The following is commented out because BAP
  // not derived from StreamConsumer anymore.
  BAP * poBAP = GetBAP();
  MediaFormat m = poBAP->GetStreamFormat();
  TRACE("[BapProxy::Update] Media Format is %d\n",m.m_code);
  MediaStream * poStream = poBAP->GetStream();

  // SB $$$$ 99/03/10 Start Stream and Register Channel
  if (!firstUpdatePassed)
  {
    Start();
    poBAP->GetExecutive()->RequestChannels();
    firstUpdatePassed=1;
    TRACE("[BapProxy::Update] StreamConsumer started \n");
  }

  // pRenderer->RegisterStreamConsumer(poFAP);

  /*
  if (poStream) {
    int nSize;
    DWORD dwTime;
    BOOL bRecurrent;

    TRACE("[BapProxy::Update]  - Stream test passed\n");
    // FOP_DATA* data = (FOP_DATA*) poStream->Fetch(nSize, dwTime, bRecurrent);

    BOOL bEOU = FALSE;
    int nStatus = 0;
    BOOL bSkip = TRUE;
    BOOL bWait = FALSE;
    BOP_DATA * data = (BOP_DATA *) poStream->Fetch(
      nSize, dwTime, bEOU, nStatus, bSkip, bWait);
    bRecurrent = FALSE;
    
    TRACE("[BAPProxy::Update] Fetch returned Size %4d at %08x \n",
      nSize, data);

    if (data && (data != END_OF_STREAM)) {
      if (!bRecurrent)
        for (int i = 0; i < NUM_BAPS; i++) {
		  body->bodySetBAPMask(i,data->bap_mask[i]);
          
          if (data->bap_mask[i])
            body->bodySetBAP(i,data->bap[i]);
        }
        
      poStream->Release(TRUE);
    }
  }

  else
	TRACE("[BapProxy::Update]  - Stream is NULL \n");
  */
  
#endif // DN_CANNOT

#endif // NOT BIFSENC
  return TRUE;

}

// RenderDescription, called by the BodyProxy
void BAPProxy::RenderDescription(	OpenGLVisualRenderer* pRenderer, 
									DWORD /*dwTime*/)
{
	TRACE("[BAPProxy::RenderDescription]\n");
	GLfloat color[] = { 0.8f, 1.0f, 0.0f, 0.75f};
	// SOLARIS PORTING - removed ::
	//::glColor4fv(color);	
	glColor4fv(color);	
	RenderDescriptionBox(pRenderer, "BAP");
}

void BAPProxy::ApplyBAPValues()
{
	for (int i = 0; i < NUM_BAPS; i++) {
#ifdef ML_CANNOT_FIX
        body->bodySetBAPMask(i,GetBAP()->BAPMask[i]);
        if (GetBAP()->BAPMask[i])
			body->bodySetBAP(i,GetBAP()->BAPValues[i]);
#endif
	}

	PrettyPrintBAPs();

	body->bodyUpdate(this->GetPointerTable());
}

// Deletes the pointerTable
void BAPProxy::InitializePointerTable()
{
	// if the pointerTable is not created
	// Normally this should not happen because this function
	// is called by the BDPProxy, which is called before Body
	// and BAP stuff
	pointerTable = new Transform*[NBJ];

	for (int i=0 ; i<NBJ ; i++)
		pointerTable[i]=NULL;
}

// Constructs the Pointer Table
void BAPProxy::ConstructPointerTable(MFNodeType<SF3DNode> & /*node*/)
{
	TRACE("[BAPProxy::ConstructPointerTable]\n");
	
	// gets the conversion table
	ConversionTable * table = new ConversionTable(FILE_OF_JOINTS_ID);

	for (int joint=0 ; joint<NBJ ; joint++) {
		// get back the joint name
		char * jointname = body->bodyGetJointName(joint);

		// creating the hanim full name
		char buffer[100];
		strcpy(buffer,"hanim_");
		strcat(buffer,jointname);

		int jointID = table->FindIdFromName(buffer);
		if (jointID!=-1) {
			MediaObject * m = this->GetBAP()->GetRoot()->FindNode(jointID);
			Transform * t = (Transform*) m;
			this->pointerTable[joint]=t;
		}
	}

	delete table;
}

// Debug Purpose
void BAPProxy::PrettyPrintBAPs()
{
	TRACE("\n");
	TRACE("[BAPProxy::PrettyPrintBAPs]------------------------------------\n");
#ifdef ML_CANNOT_FIX
	for (int i=0 ; i<NUM_BAPS ; i++) {
		TRACE("BAP%3.3d--(%c)--[%d]\n",i,(GetBAP()->BAPMask[i]?'*':' '),GetBAPValue(i));
	}
#endif
    TRACE("---------------------------------------------------------------\n\n");
}

/*

//--------------------------------------------------------
// Warning, some awfull trick here
//--------------------------------------------------------
#ifdef BAP_STREAM_IS_A_FILE

// FILE VERSION OF A STREAM
void BAPProxy::OpenStream()
{
	char  tmpStr[2000];

	bapFile = fopen(FILE_OF_BAPS,"r");
	do { 
		fgets( tmpStr, 500, bapFile); 
	} 
	while (tmpStr[0] == '#');
};

void BAPProxy::CloseStream() {
	fclose(bapFile);
}

BOOL BAPProxy::ReadBAPS() {
	char  *ptr1;
	char  s1[100];
	char  tmpStr[2000];

	// Array to store the BAPS that will be updated
	// by the frame.
	int   BAPSConcerned[MPEG4_BODY_NUM_BAPS];
	int	  positionOfLastBAPConcerned;

	// Init the array of concerned BAPS
	positionOfLastBAPConcerned = 0;

	if (!feof(bapFile)) {

		// First the mask info
		do { 
			fgets( tmpStr, 2000, bapFile); 
		} while (tmpStr[0] == '#');

		// Parse the values of the mask and stores them
		// into the Mask. Stores the positions of the concerned
		// BAPS in the local array
		ptr1 = tmpStr;
		for (int i=0; i< MPEG4_BODY_NUM_BAPS; i++) {
			sscanf( ptr1, "%s", s1);
			SetBAPMask(i,atoi(s1));
			// If this BAP has to be changed
			if (GetBAPMask(i)) {
				// then stores the position of the BAP in the array
				BAPSConcerned[positionOfLastBAPConcerned++]=i;
			}

			ptr1+=strlen(s1)+1;
		}

		// Reads the BAP values
		do { fgets( tmpStr, 2000, bapFile);
		} while (tmpStr[0] == '#');

		// skips the frame number
		ptr1 = tmpStr;
		sscanf( ptr1, "%s", s1);
		ptr1+=strlen(s1)+1;

		// Parse the array previously filled with the
		// concerned BAPS
		for (i=0 ; i<positionOfLastBAPConcerned ; i++) {
			int pos = BAPSConcerned[i];
			sscanf( ptr1, "%s", s1);
			SetBAPValue(pos,atoi(s1));
			ptr1+=strlen(s1)+1;
		}

	return TRUE;
	}
	else {
		TRACE("END OF THE BAPFILE ! Looping animation...\n");
		CloseStream();
		OpenStream();
		ReadBAPS();
	}
	
	return TRUE;
}

#else // BAP_STREAM_IS_A_FILE

	void BAPProxy::OpenStream() {
		m_bActive = TRUE;
		GetBAP()->OpenStream();

		BAP * poBAP = GetBAP();
		MediaStream * poStream = poBAP->GetStream();

		poBAP->GetExecutive()->RequestChannels();
		TRACE("[BapProxy::OpenStream] StreamConsumer started \n");
	}

	void BAPProxy::CloseStream() {
		m_bActive = FALSE;
		GetBAP()->CloseStream();
	}

	BOOL BAPProxy::ReadBAPS() {

		TRACE("readbaps");
		BAP * poBAP = GetBAP();
		MediaStream * poStream = poBAP->GetStream();

		if (!poStream) {
			TRACE("STREAM IS NOT OPEN");
			return FALSE;
		}

	    int nSize;
		DWORD dwTime;
		BOOL bRecurrent;

		BOOL bEOU = FALSE;
		int nStatus = 0;
		BOOL bSkip = TRUE;
		BOOL bWait = FALSE;
		TRACE("Fetch here");
		BOP_DATA * data = (BOP_DATA *) poStream->Fetch(nSize, dwTime, bEOU, nStatus, bSkip, bWait);
		TRACE("Fetch done");
		bRecurrent = FALSE;
    
		TRACE("[BAPProxy::Update] Fetch returned Size %4d at %08x \n",nSize, data);

		if (data && data != END_OF_STREAM) {
			if (!bRecurrent)
				for (int i = 0; i < NUM_BAPS; i++) {
					SetBAPMask(i,data->bap_mask[i] ? TRUE : FALSE);
        			if (data->bap_mask[i])
						SetBAPValue(i, data->bap[i]);
				}
			poStream->Release(TRUE);
			return TRUE;
		}
		else {
			CloseStream();
			return FALSE;
		}
		
		return TRUE;
	}

#endif // BAP_STREAM_IS_A_FILE
*/
