#include "OpenGl/OpenGl.h"
#include "BDPProxy.h"
//#include "Executiv.h"
//#include "opengl/base/OpenGLPresenter.h"

BDPProxy::BDPProxy(BDP * pBDP)
	: MediaObjectProxy(pBDP),
	  firstTime(TRUE)
{
	TRACE("[BDPProxy::BDPProxy]\n");
}

void BDPProxy::RenderDescription(OpenGLVisualRenderer * pRenderer, DWORD /*dwTime*/)
{
	// SOLARIS PORTING
	glColor4f(0.43f, 0.62f, 0.83f, 0.75f);
	//::glColor4f(0.43f, 0.62f, 0.83f, 0.75f);
	RenderDescriptionBox(pRenderer, "BDP");
}

BOOL BDPProxy::Update(Body * pBody, DWORD /*dwTime*/)
{
	TRACE("[BDPProxy::Update]\n");

	// Make sure this is done once
	if (firstTime) {

		// Gets back the BAPProxy of the current Body
		TRACE("[BDPProxy::Update] Retrieving BAPProxy\n");
		BodyProxy * pBodyProxy = (BodyProxy *) (pBody->GetRenderingObject());
		BAPProxy * pBAPProxy = (BAPProxy *) (pBodyProxy->GetBAP()->GetRenderingObject() );

		// Reinits the pointerTable
		TRACE("[BDPProxy::Update] Initializes the BAP Table\n");
		pBAPProxy->InitializePointerTable();

		// Replace the scene graph
		// A little point here. The bodySceneGraph is supposed to
		// contain a subhierarchy of Transform Nodes, aso... The proxies
		// attached to them are supposed to be built automatically by the
		// scene loader....
		TRACE("[BDPProxy::Update] Replace the current body\n");
		pBody->renderedBody=GetBDP()->bodySceneGraph;
		pBodyProxy->SetBodyIsDefinedInBDP(TRUE);

		// constructs the new conversion table
		TRACE("[BDPProxy::Update] Constructs the new transform* table\n");

		pBAPProxy->ConstructPointerTable(GetBDP()->bodySceneGraph);
		firstTime=FALSE;
	}

	return TRUE;
}
