// Stefano Battista
// 1998 November 25

#include "OpenGl/OpenGl.h"
#include "FAPProxy.h"
#include "Executiv.h"


FAPProxy::FAPProxy(FAP * poFap)
    : MediaObjectProxy(poFap)
{
  m_bbFirst = TRUE;
};

// Update object

BOOL FAPProxy::Update(

    VisualRenderer* /* pRenderer */, 
    DWORD /* dwTime */)
{

#ifndef BIFSENC

  FAP * poFAP = GetFAP();

  {
	  for (int i = 0; i < 68; i++) {
            int d=GetFAPValue(i);
			TRACE("[%d]=%d; ",i,d);
        }
	  TRACE("\n");
  }

  // SB $$$$ 99/03/10 Start Stream and Register Channel
  // SB 2000/03/24 
  if (m_bbFirst)
  {
    Start();
    poFAP->GetExecutive()->RequestChannels();
    m_bbFirst = FALSE;
    TRACE("[FapProxy::Update] StreamConsumer started \n");
  }
    
#ifdef DN_CANNOT
  MediaStream * poStream = poFAP->GetStream();

  // SB $$$$ 99/03/10 Start Stream and Register Channel
  if (m_bFirst)
  {
    Start();
    poFAP->GetExecutive()->RequestChannels();
    m_bFirst = FALSE;
    TRACE("[FapProxy::Update] StreamConsumer started \n");
  }
    
  // pRenderer->RegisterStreamConsumer(poFAP);
  
  if (poStream) {
    int nSize;
    DWORD dwTime;
    BOOL bRecurrent;
    
    // FOP_DATA* data = (FOP_DATA*) poStream->Fetch(nSize, dwTime, bRecurrent);

    BOOL bEOU = FALSE;
    int nStatus = 0;
    BOOL bSkip = TRUE;
    BOOL bWait = FALSE;
    FOP_DATA * data = (FOP_DATA *) poStream->Fetch(
      nSize, dwTime, bEOU, nStatus, bSkip, bWait);
    bRecurrent = FALSE;
    
    TRACE("[FAPProxy::Update] Fetch returned Size %4d at %08x \n",
      nSize, data);

    if (data && data != END_OF_STREAM) {
      if (!bRecurrent)
        for (int i = 0; i < 68; i++) {
          FAPMask[i] = data->fap_mask[i] ? TRUE : FALSE;
          
          if (data->fap_mask[i])
            SetFAPValue(i, data->fap[i]);
        }
        
      poStream->Release(TRUE);
    }
  }
  
#endif
#endif // NOT BIFSENC
  
  return TRUE;
}

