// Stefano Battista
// 1998 November 25

#ifndef __FAPPROXY_H__
#define __FAPPROXY_H__

//#include "Nodes.h"
// #include "fba/Viseme.h"
// #include "fba/Expression.h"

#include "fbadecoder/sim.h"
#include "Stream.h"

#include "opengl/base/MediaObjectProxy.h"

#include "opengl/base/VisualRenderer.h"

class FAPProxy
  : public MediaObjectProxy
{
public:
  FAPProxy(FAP * poFap);

  /// Update object
  BOOL Update(VisualRenderer* pRenderer, DWORD dwTime);

  // methods from FAP to Proxy
private:
  int m_bbFirst;
  /// FAP mask
  BOOL			FAPMask[68];
public:
  /// Get pointer to related FAP object
  inline FAP * GetFAP()
  { return (FAP *) GetMediaObject(); };
  /// Get viseme node
  inline Viseme * GetViseme()
  { return (Viseme*) GetFAP()->viseme; }

/*ML - removed this unused function
  /// Set viseme node
  inline void SetViseme(Viseme* pViseme)
  { if (GetViseme())
      GetViseme()->RemoveParent(GetFAP());
    GetFAP()->viseme = pViseme;
    if (pViseme)
      pViseme->SetParent(GetFAP()); }
*/
  
  /// Get expression node
  inline Expression * GetExpression()
  { return (Expression*) GetFAP()->expression; }

/*ML - removed this unused function
  /// Set expression node
  inline void SetExpression(Expression* pExpression)
  { if (GetExpression())
      GetExpression()->RemoveParent(GetFAP());
    GetFAP()->expression = pExpression;
    if (pExpression)
      pExpression->SetParent(GetFAP()); }
*/
  
  /// Get FAP values
  inline int GetFAPValue(int iField)
  {
#ifdef ML_CANNOT_FIX
    return GetFAP()->FAPValues[iField];
#else
    return iField;
#endif
  }

  /// Set FAP values
  inline void SetFAPValue(int iField, int iValue)
  { 
#ifdef ML_CANNOT_FIX
    GetFAP()->FAPValues[iField] = iValue; 
    GetFAP()->FAPMask[iField] = 1;
#else
    iField; iValue;
#endif
  }

  /// Get FAP mask
  inline BOOL GetFAPMask(int iField)
  {
#ifdef ML_CANNOT_FIX
    return GetFAP()->FAPMask[iField];
#else
    return iField;
#endif
  }

  void Start()
  {
#ifdef BIFSENCDN__CANNOT
    m_bActive = TRUE;
    GetFAP()->OpenStream();
#endif
  };

  void Stop()
  {
#ifdef BIFSENCDN__CANNOT
    m_bActive = FALSE;
    GetFAP()->CloseStream();
#endif
  };
};

#endif // ! __FAPPROXY_H__
