// Stefano Battista
// 1998 November 25

#ifndef __FITPROXY_H__
#define __FITPROXY_H__

//#include "Nodes.h"

#include "opengl/base/MediaObjectProxy.h"
#include "opengl/fba/FaceProxy.h"

class FITProxy : public MediaObjectProxy
{
#ifndef BIFSENC

// PORTING to CC 5.3
//private:
public:
  typedef struct
  {
	float coef;
	int *expos;
	BOOL delta;
  } TERM, *PTERM;

  typedef struct
  {
	int nTerms;
	PTERM terms;
  } POLY, *PPOLY;

  typedef struct
  {
	int nParents;
	int nChildren;
	PPOLY numerator;
	PPOLY denominator;
  } FUNC, *PFUNC;

  BOOL FirstTime;
  int FAPValues[75];
  BOOL FAPMasks[75];
  int m_nFAPSets;
  int m_nLinks;
  int *m_pIndex;
  BOOL *m_pbComplete;

  PFUNC LinkFuncs;

#endif // ! BIFSENC

public:
  FITProxy(FIT * pFit);
  /// Update object
  BOOL Update(Face* pFace, DWORD dwTime);
  /// Interpolate
  void Interpolate(int l);

  /// Get pointer to related MediaObject
  inline FIT * GetFIT()
  { return (FIT *) GetMediaObject(); }
};

#endif // ! __FITPROXY_H__
