#ifndef _CLASS_MYMATERIAL_
#define _CLASS_MYMATERIAL_

class MyMaterial {
	float ambientIntensity;
	float *diffuseColor;
	float *specularColor;
	float *emissiveColor;
	float shininess;
	float transparency;

// Constructor
public:
	MyMaterial::MyMaterial();
	MyMaterial::~MyMaterial();

// Accessers
public:
	inline float GetAmbient() const { return ambientIntensity; }
	inline float* GetDiffuse() const { return diffuseColor; }
	inline float* GetSpecular() const { return specularColor; }
	inline float* GetEmissive() const { return emissiveColor; }
	inline float GetShininess() const { return shininess; }
	inline float GetTransparency() const { return transparency; }

// Modifiers
public:
	inline void SetAmbient(float a) { ambientIntensity=a; }
	inline void SetDiffuse(float r, float g, float b) { diffuseColor[0]=r;
														diffuseColor[1]=g;
														diffuseColor[2]=b; }
	inline void SetSpecular(float r, float g, float b) {specularColor[0]=r;
														specularColor[1]=g;
														specularColor[2]=b; }
	inline void SetEmissive(float r, float g, float b) {emissiveColor[0]=r;
														emissiveColor[1]=g;
														emissiveColor[2]=b; }
	inline void SetShininess(float s) { shininess=s; }
	inline void SetTransparency(float t) {transparency=t; }
};

// Constructor
MyMaterial::MyMaterial()
{
	// arrays for storing red green blue components
	diffuseColor = new float[3];
	specularColor = new float[3];
	emissiveColor = new float[3];

	for (int i=0 ; i<3 ; i++) {
		diffuseColor[i]=0.f;
		specularColor[i]=0.f;
		emissiveColor[i]=0.f;
	}
	ambientIntensity=0.f;
	shininess=0.f;
	transparency=0.f;
}

// Destructor
MyMaterial::~MyMaterial()
{
	// cleans
	delete diffuseColor;
	delete specularColor;
	delete emissiveColor;
}

#endif
