/* INFO: Contains VRML Humanoid hierarchy info */

#ifndef _NODE_H
#define _NODE_H

#include "etall.h"

#define VRML_NB_JOINTS 46+2
#define VRML_NB_HAND_JOINTS 15

#define VRML_PELVIS      0
#define VRML_L_HIP       1
#define VRML_L_KNEE      2
#define VRML_L_ANKLE     3
#define VRML_L_SUBTALAR  4
#define VRML_L_MIDFOOT   5
#define VRML_L_TOE       6
#define VRML_R_HIP       7
#define VRML_R_KNEE      8
#define VRML_R_ANKLE     9
#define VRML_R_SUBTALAR  10
#define VRML_R_MIDFOOT   11
#define VRML_R_TOE       12
#define VRML_VL5         13
#define VRML_VL4         14
#define VRML_VL3         15
#define VRML_VL2         16
#define VRML_VL1         17
#define VRML_VT10        18
#define VRML_VT9         19
#define VRML_VT8         20
#define VRML_VT7         21
#define VRML_VT6         22
#define VRML_VT5         23
#define VRML_VT4         24
#define VRML_VT3         25
#define VRML_VT2         26
#define VRML_VT1         27
#define VRML_VC7         28
#define VRML_VC6         29
#define VRML_VC5         30
#define VRML_VC4         31
#define VRML_VC3         32
#define VRML_VC2         33
#define VRML_VC1         34
#define VRML_SKULLBASE   35
#define VRML_L_CLAVICULE 36
#define VRML_L_SCAPULA   37
#define VRML_L_SHOULDER  38
#define VRML_L_ELBOW     39
#define VRML_L_WRIST     40
#define VRML_R_CLAVICULE 41
#define VRML_R_SCAPULA   42
#define VRML_R_SHOULDER  43
#define VRML_R_ELBOW     44
#define VRML_R_WRIST     45

#define VRML_L_THUMB1    46
#define VRML_L_THUMB2    47
#define VRML_L_THUMB3    48
#define VRML_L_INDEX1    49
#define VRML_L_INDEX2    50
#define VRML_L_INDEX3    51
#define VRML_L_MIDDLE1   52
#define VRML_L_MIDDLE2   53
#define VRML_L_MIDDLE3   54
#define VRML_L_RING1     55
#define VRML_L_RING2     56
#define VRML_L_RING3     57
#define VRML_L_PINKY1    58
#define VRML_L_PINKY2    59
#define VRML_L_PINKY3    60
#define VRML_R_THUMB1    61
#define VRML_R_THUMB2    62
#define VRML_R_THUMB3    63
#define VRML_R_INDEX1    64
#define VRML_R_INDEX2    65
#define VRML_R_INDEX3    66
#define VRML_R_MIDDLE1   67
#define VRML_R_MIDDLE2   68
#define VRML_R_MIDDLE3   69
#define VRML_R_RING1     70
#define VRML_R_RING2     71
#define VRML_R_RING3     72
#define VRML_R_PINKY1    73
#define VRML_R_PINKY2    74
#define VRML_R_PINKY3    75

/* NEW */
#define VRML_ROOT    76

#define BODY_UNDEF 0
#define BODY_ZYX   1
#define BODY_XYZ   2
#define BODY_ZXY   3
#define BODY_ZX    4
#define BODY_ZY    5
#define BODY_Z     6
#define BODY_XY    7
#define BODY_XZ    8
#define BODY_XZY   9
#define BODY_YX   10
#define BODY_YZ   11
#define BODY_X    12

#define BODY_TR    -1

typedef struct {
  char VRML_name[20];
  char Segment_name[30];

  short order;
  int JointIndex1,JointIndex2,JointIndex3;

  short SmFig;
  char std_file_name[30];

  int n_children;
  int list_of_children[5];
} HierarchieInfo;

/*


*/
#endif
