#include <stdio.h>
#include "scn1.h"
#include "etall.h"
#include "Node.h"

#ifndef MPEG4_BODY_NUM_BAPS
#define MPEG4_BODY_NUM_BAPS 296
#endif

#define MAX_BODY 10
static SCENE *scene=NULL;
static BODY *bodyview[MAX_BODY];
/* WIN-SOL release */
#ifndef WIN32
extern HierarchieInfo Hinfo[VRML_NB_JOINTS+2*VRML_NB_HAND_JOINTS]; /* SOLARIS PORTING - added this */
#endif

static MatriX WorldRefMat = {
  { -1, 0, 0, 0},
  {  0, 1, 0, 0},
  {  0, 0,-1, 0},
  {  0, 0, 0, 1}
};

void
epflbodySetMatrices( BODY *bodyview, int Frame, MatriX bodyMatrices[]);

/* To compute size:*/
static int UpdtJointList[MPEG4_BODY_NUM_BAPS] = {
  /* 1-10 */
  BODY_JOINT_PELVIC_TILT,
  BODY_JOINT_PELVIC_TORSION,
  BODY_JOINT_PELVIC_ROLL,
  BODY_JOINT_L_HIP_FLEXION,
  BODY_JOINT_R_HIP_FLEXION,
  BODY_JOINT_L_HIP_ABDUCT,
  BODY_JOINT_R_HIP_ABDUCT,
  BODY_JOINT_L_HIP_TWISTING,
  BODY_JOINT_R_HIP_TWISTING,
  BODY_JOINT_L_KNEE_FLEXION,

  /* 11-20 */
  BODY_JOINT_R_KNEE_FLEXION,
  BODY_JOINT_L_KNEE_TWISTING,
  BODY_JOINT_R_KNEE_TWISTING,
  BODY_JOINT_L_ANKLE_FLEXION,
  BODY_JOINT_R_ANKLE_FLEXION,
  BODY_JOINT_L_KNEE_TWISTING,
  BODY_JOINT_R_KNEE_TWISTING,
  BODY_JOINT_L_ANKLE_SUBTALAR,
  BODY_JOINT_R_ANKLE_SUBTALAR,
  BODY_JOINT_L_MID_FOOT,

  /* 21-30 */
  BODY_JOINT_R_MID_FOOT,
  BODY_JOINT_L_TOE_FLEXION,
  BODY_JOINT_R_TOE_FLEXION,
  BODY_JOINT_L_CLAV_ABDUCT,
  BODY_JOINT_R_CLAV_ABDUCT,
  BODY_JOINT_L_CLAV_ROTATE,
  BODY_JOINT_R_CLAV_ROTATE,
  BODY_JOINT_L_SCAP_ABDUCT,
  BODY_JOINT_R_SCAP_ABDUCT,
  BODY_JOINT_L_SCAP_ROTATE,

  /* 31-40 */
  BODY_JOINT_R_SCAP_ROTATE,
  BODY_JOINT_L_SHOULDER_FLEXION,
  BODY_JOINT_R_SHOULDER_FLEXION,
  BODY_JOINT_L_SHOULDER_ABDUCT,
  BODY_JOINT_R_SHOULDER_ABDUCT,
  BODY_JOINT_L_SHOULDER_TWISTING,
  BODY_JOINT_R_SHOULDER_TWISTING,
  BODY_JOINT_L_ELBOW_FLEXION,
  BODY_JOINT_R_ELBOW_FLEXION,
  BODY_JOINT_L_ELBOW_TWISTING,

  /* 41-50 */
  BODY_JOINT_R_ELBOW_TWISTING,
  BODY_JOINT_L_WRIST_FLEXION,
  BODY_JOINT_R_WRIST_FLEXION,
  BODY_JOINT_L_WRIST_PIVOT,
  BODY_JOINT_R_WRIST_PIVOT,
  BODY_JOINT_L_ELBOW_TWISTING,
  BODY_JOINT_R_ELBOW_TWISTING,
  /* Added 31/08/98 :*/
  -1, /*  BODY_JOINT_SKULL_ROLL,*/
  -1, /*  BODY_JOINT_SKULL_TORSION,*/
  -1, /*  BODY_JOINT_SKULL_TILT,*/

  /* 51-60 */
  -1, /* c1 roll */
  -1, /* c1 torsion */
  -1, /* c1 tilt */
  BODY_JOINT_VC8_ROLL,
  BODY_JOINT_VC8_TORSION,
  BODY_JOINT_VC8_TILT,
  -1, /* c3 roll */
  -1, /* c3 torsion */
  -1, /* c3 tilt */
  BODY_JOINT_VC7_ROLL,

  /* 61-70 */
  BODY_JOINT_VC7_TORSION,
  BODY_JOINT_VC7_TILT,
  -1, /* c5 roll */
  -1, /* c5 torsion */
  -1, /* c5 tilt */
  -1, /* c6 roll */
  -1, /* c6 torsion */
  -1, /* c6 tilt */
  -1, /* c7 roll */
  -1, /* c7 torsion */

  /* 71-80 */
  -1, /* c7 tilt */
  BODY_JOINT_VT6_ROLL,
  BODY_JOINT_VT6_TORSION,
  BODY_JOINT_VT6_TILT,
  -1, /* t2 roll */
  -1, /* t2 torsion */
  -1, /* t2 tilt */
  -1, /* t3 roll */
  -1, /* t3 torsion */
  -1, /* t3 tilt */

  /* 81-90 */
  -1, /* t4 roll */
  -1, /* t4 torsion */
  -1, /* t4 tilt */
  -1, /* t5 roll */
  -1, /* t5 torsion */
  -1, /* t5 tilt */
  BODY_JOINT_VT5_ROLL,
  BODY_JOINT_VT5_TORSION,
  -1, /* t6 tilt */
  -1, /* t7 roll */

  /* 91-100 */
  -1, /* t7 torsion */
  -1, /* t7 tilt */
  -1, /* t8 roll */
  -1, /* t8 torsion */
  -1, /* t8 tilt */
  -1, /* t9 roll */
  -1, /* t9 torsion */
  -1, /* t9 tilt */
  BODY_JOINT_VT4_ROLL,
  BODY_JOINT_VT4_TORSION,

  /* 101-110 */
  BODY_JOINT_VT4_TILT,
  -1, /* t11 roll */
  -1, /* t11 torsion */
  -1, /* t11 tilt */
  -1, /* t12 roll */
  -1, /* t12 torsion */
  -1, /* t12 tilt */
  BODY_JOINT_VL3_ROLL,
  -1, /* l1 torsion */
  BODY_JOINT_VL3_TILT,

  /* 111-120 */
  -1, /* l2 roll */
  -1, /* l2 torsion */
  -1, /* l2 tilt */
  BODY_JOINT_VL2_ROLL,
  -1, /* l3 torsion */
  BODY_JOINT_VL2_TILT,
  -1, /* l4 roll */
  -1, /* l4 torsion */
  -1, /* l4 tilt */
  -1, /* l5 roll */

  /* 121-130 */
  -1, /* l5 torsion */
  BODY_JOINT_VL1_TILT,
  /* Added 31/08/98 :*/
  -1, /*  BODY_JOINT_L_PINKY_FL0 + 100,*/
  -1, /*  BODY_JOINT_R_PINKY_FL0 + 200,*/
  /* Hands */
  BODY_JOINT_L_PINKY_FL1 + 100,
  BODY_JOINT_R_PINKY_FL1 + 200,
  BODY_JOINT_L_PINKY_PIVOT + 100,
  BODY_JOINT_R_PINKY_PIVOT + 200,
  BODY_JOINT_L_PINKY_TWIST + 100,
  BODY_JOINT_R_PINKY_TWIST + 200,

  /* 131-140 */
  BODY_JOINT_L_PINKY_FL2 + 100,
  BODY_JOINT_R_PINKY_FL2 + 200,
  BODY_JOINT_L_PINKY_FL3 + 100,
  BODY_JOINT_R_PINKY_FL3 + 200,
  /* Added 31/08/98 :*/
  -1, /*  BODY_JOINT_L_RING_FL0 + 100,*/
  -1, /*  BODY_JOINT_R_RING_FL0 + 200,*/
  BODY_JOINT_L_RING_FL1 + 100,
  BODY_JOINT_R_RING_FL1 + 200,
  BODY_JOINT_L_RING_PIVOT + 100,
  BODY_JOINT_R_RING_PIVOT + 200,

  /* 141-150 */
  BODY_JOINT_L_RING_TWIST + 100,
  BODY_JOINT_R_RING_TWIST + 200,
  BODY_JOINT_L_RING_FL2 + 100,
  BODY_JOINT_R_RING_FL2 + 200,
  BODY_JOINT_L_RING_FL3 + 100,
  BODY_JOINT_R_RING_FL3 + 200,
  /* Added 31/08/98 :*/
  -1, /*  BODY_JOINT_L_MIDDLE_FL0 + 100,*/
  -1, /*  BODY_JOINT_R_MIDDLE_FL0 + 200,*/
  BODY_JOINT_L_MIDDLE_FL1 + 100,
  BODY_JOINT_R_MIDDLE_FL1 + 200,

  /* 151-160 */
  BODY_JOINT_L_MIDDLE_PIVOT + 100,
  BODY_JOINT_R_MIDDLE_PIVOT + 200,
  BODY_JOINT_L_MIDDLE_TWIST + 100,
  BODY_JOINT_R_MIDDLE_TWIST + 200,
  BODY_JOINT_L_MIDDLE_FL2 + 100,
  BODY_JOINT_R_MIDDLE_FL2 + 200,
  BODY_JOINT_L_MIDDLE_FL3 + 100,
  BODY_JOINT_R_MIDDLE_FL3 + 200,
  /* Added 31/08/98 :*/
  -1, /*  BODY_JOINT_L_INDEX_FL0 + 100,*/
  -1, /*  BODY_JOINT_R_INDEX_FL0 + 200,*/

  /* 161-170 */
  BODY_JOINT_L_INDEX_FL1 + 100,
  BODY_JOINT_R_INDEX_FL1 + 200,
  BODY_JOINT_L_INDEX_PIVOT + 100,
  BODY_JOINT_R_INDEX_PIVOT + 200,
  BODY_JOINT_L_INDEX_TWIST + 100,
  BODY_JOINT_R_INDEX_TWIST + 200,
  BODY_JOINT_L_INDEX_FL2 + 100,
  BODY_JOINT_R_INDEX_FL2 + 200,
  BODY_JOINT_L_INDEX_FL3 + 100,
  BODY_JOINT_R_INDEX_FL3 + 200,

  /* 171-180 */
  /* BODY_JOINT_L_THUMB_FL1 + 100,
  BODY_JOINT_R_THUMB_FL1 + 200,
  BODY_JOINT_L_THUMB_ABDUCT + 100,
  BODY_JOINT_R_THUMB_ABDUCT + 200, */
  -1,
  -1,
  -1,
  -1,
  BODY_JOINT_L_THUMB_TW + 100,
  BODY_JOINT_R_THUMB_TW + 200,
  BODY_JOINT_L_THUMB_FL2 + 100,
  BODY_JOINT_R_THUMB_FL2 + 200,
  BODY_JOINT_L_THUMB_FL3 + 100,
  BODY_JOINT_R_THUMB_FL3 + 200,

  /* 181-186 */
  /* GLOBAL POSITION */
  BODY_JOINT_TR_VERTICAL,
  BODY_JOINT_TR_LATERAL,
  BODY_JOINT_TR_FRONTAL,
  BODY_JOINT_BODY_TURN,
  BODY_JOINT_BODY_ROLL,
  BODY_JOINT_BODY_TILT

  /* 187-200 */
  -1, -1, -1, -1,
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,

  /* 201-250 */
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,

  /* 251-296 */
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
  -1, -1, -1, -1, -1, -1

};

/*
static int UpdtJointList[MPEG4_BODY_NUM_BAPS] = {
  BODY_JOINT_PELVIC_TILT,
  BODY_JOINT_PELVIC_TORSION,
  BODY_JOINT_PELVIC_ROLL,
  BODY_JOINT_L_HIP_FLEXION,
  BODY_JOINT_R_HIP_FLEXION,
  BODY_JOINT_L_HIP_ABDUCT,
  BODY_JOINT_R_HIP_ABDUCT,
  BODY_JOINT_L_HIP_TWISTING,
  BODY_JOINT_R_HIP_TWISTING,
  BODY_JOINT_L_KNEE_FLEXION,
  BODY_JOINT_R_KNEE_FLEXION,
  BODY_JOINT_L_KNEE_TWISTING,
  BODY_JOINT_R_KNEE_TWISTING,
  BODY_JOINT_L_ANKLE_FLEXION,
  BODY_JOINT_R_ANKLE_FLEXION,
  BODY_JOINT_L_KNEE_TWISTING,
  BODY_JOINT_R_KNEE_TWISTING,
  BODY_JOINT_L_ANKLE_SUBTALAR,
  BODY_JOINT_R_ANKLE_SUBTALAR,
  BODY_JOINT_L_MID_FOOT,
  BODY_JOINT_R_MID_FOOT,
  BODY_JOINT_L_TOE_FLEXION,
  BODY_JOINT_R_TOE_FLEXION,
  BODY_JOINT_L_CLAV_ABDUCT,
  BODY_JOINT_R_CLAV_ABDUCT,
  BODY_JOINT_L_CLAV_ROTATE,
  BODY_JOINT_R_CLAV_ROTATE,
  BODY_JOINT_L_SCAP_ABDUCT,
  BODY_JOINT_R_SCAP_ABDUCT,
  BODY_JOINT_L_SCAP_ROTATE,
  BODY_JOINT_R_SCAP_ROTATE,

  BODY_JOINT_L_SHOULDER_FLEXION,
  BODY_JOINT_R_SHOULDER_FLEXION,
  BODY_JOINT_L_SHOULDER_ABDUCT,
  BODY_JOINT_R_SHOULDER_ABDUCT,
  BODY_JOINT_L_SHOULDER_TWISTING,
  BODY_JOINT_R_SHOULDER_TWISTING,
  BODY_JOINT_L_ELBOW_FLEXION,
  BODY_JOINT_R_ELBOW_FLEXION,
  BODY_JOINT_L_ELBOW_TWISTING,
  BODY_JOINT_R_ELBOW_TWISTING,
  BODY_JOINT_L_WRIST_FLEXION,
  BODY_JOINT_R_WRIST_FLEXION,
  BODY_JOINT_L_WRIST_PIVOT,
  BODY_JOINT_R_WRIST_PIVOT,
  BODY_JOINT_L_ELBOW_TWISTING,
  BODY_JOINT_R_ELBOW_TWISTING,

  -1,
  -1,
  -1,

  -1,
  -1,
  -1,
  
  BODY_JOINT_VC8_ROLL,
  BODY_JOINT_VC8_TORSION,
  BODY_JOINT_VC8_TILT,
  
  -1,
  -1,
  -1,
  
  BODY_JOINT_VC7_ROLL,
  BODY_JOINT_VC7_TORSION,
  BODY_JOINT_VC7_TILT,
  
  -1,
  -1,
  -1,
  -1,
  -1,
  -1,
  -1,
  -1,
  -1,
  
  BODY_JOINT_VT6_ROLL,
  BODY_JOINT_VT6_TORSION,
  BODY_JOINT_VT6_TILT,
  
  -1,
  -1,
  -1,
  -1,
  -1,
  -1,
  -1,
  -1,
  -1,
  -1,
  -1,
  -1,
  
  BODY_JOINT_VT5_ROLL,
  BODY_JOINT_VT5_TORSION,
  -1,

  -1,
  -1,
  -1,
  -1,
  -1,
  -1,
  -1,
  -1,
  -1,
  
  BODY_JOINT_VT4_ROLL,
  BODY_JOINT_VT4_TORSION,
  BODY_JOINT_VT4_TILT,
  
  -1,
  -1,
  -1,
  -1,
  -1,
  -1,
  
  BODY_JOINT_VL3_ROLL,
  -1,
  BODY_JOINT_VL3_TILT,
  
  -1,
  -1,
  -1,
  
  BODY_JOINT_VL2_ROLL,
  -1,
  BODY_JOINT_VL2_TILT,
  
  -1,
  -1,
  -1,
  
  -1,
  -1,
  BODY_JOINT_VL1_TILT,

  -1,
  -1,

  BODY_JOINT_L_PINKY_FL1 + 100,
  BODY_JOINT_R_PINKY_FL1 + 200,
  BODY_JOINT_L_PINKY_PIVOT + 100,
  BODY_JOINT_R_PINKY_PIVOT + 200,
  BODY_JOINT_L_PINKY_TWIST + 100,
  BODY_JOINT_R_PINKY_TWIST + 200,
  BODY_JOINT_L_PINKY_FL2 + 100,
  BODY_JOINT_R_PINKY_FL2 + 200,
  BODY_JOINT_L_PINKY_FL3 + 100,
  BODY_JOINT_R_PINKY_FL3 + 200,

  -1,
  -1,

  BODY_JOINT_L_RING_FL1 + 100,
  BODY_JOINT_R_RING_FL1 + 200,
  BODY_JOINT_L_RING_PIVOT + 100,
  BODY_JOINT_R_RING_PIVOT + 200,
  BODY_JOINT_L_RING_TWIST + 100,
  BODY_JOINT_R_RING_TWIST + 200,
  BODY_JOINT_L_RING_FL2 + 100,
  BODY_JOINT_R_RING_FL2 + 200,
  BODY_JOINT_L_RING_FL3 + 100,
  BODY_JOINT_R_RING_FL3 + 200,
  
  -1,
  -1,

  BODY_JOINT_L_MIDDLE_FL1 + 100,
  BODY_JOINT_R_MIDDLE_FL1 + 200,
  BODY_JOINT_L_MIDDLE_PIVOT + 100,
  BODY_JOINT_R_MIDDLE_PIVOT + 200,
  BODY_JOINT_L_MIDDLE_TWIST + 100,
  BODY_JOINT_R_MIDDLE_TWIST + 200,
  BODY_JOINT_L_MIDDLE_FL2 + 100,
  BODY_JOINT_R_MIDDLE_FL2 + 200,
  BODY_JOINT_L_MIDDLE_FL3 + 100,
  BODY_JOINT_R_MIDDLE_FL3 + 200,

  -1,
  -1,

  BODY_JOINT_L_INDEX_FL1 + 100,
  BODY_JOINT_R_INDEX_FL1 + 200,
  BODY_JOINT_L_INDEX_PIVOT + 100,
  BODY_JOINT_R_INDEX_PIVOT + 200,
  BODY_JOINT_L_INDEX_TWIST + 100,
  BODY_JOINT_R_INDEX_TWIST + 200,
  BODY_JOINT_L_INDEX_FL2 + 100,
  BODY_JOINT_R_INDEX_FL2 + 200,
  BODY_JOINT_L_INDEX_FL3 + 100,
  BODY_JOINT_R_INDEX_FL3 + 200,
  
  BODY_JOINT_L_THUMB_FL1 + 100,
  BODY_JOINT_R_THUMB_FL1 + 200,
  BODY_JOINT_L_THUMB_ABDUCT + 100,
  BODY_JOINT_R_THUMB_ABDUCT + 200,
  BODY_JOINT_L_THUMB_TW + 100,
  BODY_JOINT_R_THUMB_TW + 200,
  BODY_JOINT_L_THUMB_FL2 + 100,
  BODY_JOINT_R_THUMB_FL2 + 200,
  BODY_JOINT_L_THUMB_FL3 + 100,
  BODY_JOINT_R_THUMB_FL3 + 200,

  BODY_JOINT_TR_VERTICAL,
  BODY_JOINT_TR_LATERAL,
  BODY_JOINT_TR_FRONTAL,
  BODY_JOINT_BODY_TURN,
  BODY_JOINT_BODY_ROLL,
  BODY_JOINT_BODY_TILT

};
*/

/* WIN-SOL release */
#ifdef WIN32
HierarchieInfo Hinfo[VRML_NB_JOINTS+2*VRML_NB_HAND_JOINTS] = {
  /* --------- Lower Part Top Hierarchy */

  /* pelvis = sacroiliac */
  {"sacroiliac","pelvis",
   BODY_XYZ,BODY_N3D_PELVIC_TILT,BODY_N3D_PELVIC_TORSION,BODY_N3D_PELVIC_ROLL,
   1,"_hip",
   2,{VRML_L_HIP,VRML_R_HIP,-1,-1,-1}},
 
  {"l_hip","l_thigh",
   BODY_XYZ,BODY_N3D_L_HIP_FLEXION,BODY_N3D_L_HIP_ABDUCT,BODY_N3D_L_HIP_TWISTING,
   1,"_left_thigh",
   1,{VRML_L_KNEE,-1,-1,-1,-1}},
  {"l_knee","l_calf",
   BODY_XY,BODY_N3D_L_KNEE_FLEXION,BODY_N3D_L_KNEE_TWISTING,0,
   1,"_left_leg",
   1,{VRML_L_ANKLE,-1,-1,-1,-1}},
  {"l_ankle","l_hindfoot",
   BODY_X,BODY_N3D_L_ANKLE_FLEXION,0,0,
   1,"_left_foot",
   1,{VRML_L_SUBTALAR,-1,-1,-1,-1}},
  {"l_subtalar","l_midproximal",
   BODY_UNDEF,BODY_N3D_L_ANKLE_SUBTALAR,0,0,
   0,"",
   1,{VRML_L_MIDFOOT,-1,-1,-1,-1}},
  /* midfoot = midtarsal */
  {"l_midtarsal","l_middistral",
   BODY_Z,BODY_N3D_L_MID_FOOT,0,0,
   0,"",
   1,{VRML_L_TOE,-1,-1,-1,-1}},
  /* toe = metatarsal */
  {"l_metatarsal","l_forefoot",
   BODY_Z,BODY_N3D_L_TOE_FLEXION,0,0,
   0,"",
   0,{-1,-1,-1,-1,-1}},

  {"r_hip","r_thigh",
   BODY_XYZ,BODY_N3D_R_HIP_FLEXION,BODY_N3D_R_HIP_ABDUCT,BODY_N3D_R_HIP_TWISTING,
   1,"_right_thigh",
   1,{VRML_R_KNEE,-1,-1,-1,-1}},
  {"r_knee","r_calf",
   BODY_XY,BODY_N3D_R_KNEE_FLEXION,BODY_N3D_R_KNEE_TWISTING,0,
   1,"_right_leg",
   1,{VRML_R_ANKLE,-1,-1,-1,-1}},
  {"r_ankle","r_hindfoot",
   BODY_X,BODY_N3D_R_ANKLE_FLEXION,0,0,
   1,"_right_foot",
   1,{VRML_R_SUBTALAR,-1,-1,-1,-1}},
  {"r_subtalar","r_midproximal",
   BODY_UNDEF,BODY_N3D_R_ANKLE_SUBTALAR,0,0,
   0,"",
   1,{VRML_R_MIDFOOT,-1,-1,-1,-1}},
  /* midfoot = midtarsal */
  {"r_midtarsal","r_middistral",
   BODY_Z,BODY_N3D_R_MID_FOOT,0,0,
   0,"",
   1,{VRML_R_TOE,-1,-1,-1,-1}},
  /* toe = metatarsal */
  {"r_metatarsal","r_forefoot",
   BODY_Z,BODY_N3D_R_TOE_FLEXION,0,0,
   0,"",
   0,{-1,-1,-1,-1,-1}},
  
  {"vl5","l5",
   BODY_X,BODY_N3D_VL1_TILT,0,0,
   0,"",
   1,{VRML_VL4,-1,-1,-1,-1}},
  {"vl4","l4",
   BODY_UNDEF,BODY_N3D_VL1_TILT,0,0, /* BODY_N3D_VL1_TILT because it is a Jack N3D */
   0,"",
   1,{VRML_VL3,-1,-1,-1,-1}},
  {"vl3","l3",
   BODY_XY,BODY_N3D_VL2_ROLL,BODY_N3D_VL2_TILT,0,
   1,"_lower_torso",
   1,{VRML_VL2,-1,-1,-1,-1}},
  {"vl2","l2",
   BODY_UNDEF,BODY_N3D_VL2_ROLL,0,0, /* BODY_N3D_VL2_ROLL because it is a Jack N3D */
   0,"",
   1,{VRML_VL1,-1,-1,-1,-1}},
  {"vl1","l1",
   BODY_XY,BODY_N3D_VL3_ROLL,BODY_N3D_VL3_TILT,0,
   0,"",
   1,{VRML_VT10,-1,-1,-1,-1}},
  {"vt10","t10",
   BODY_XYZ,BODY_N3D_VT4_ROLL,BODY_N3D_VT4_TORSION,BODY_N3D_VT4_TILT,
   1,"_upper_torso",
   1,{VRML_VT9,-1,-1,-1,-1}},
  {"vt9","t9",
   BODY_UNDEF,BODY_N3D_VT4_ROLL,0,0, /* BODY_N3D_VT4_ROLL because it is a Jack N3D */
   0,"",
   1,{VRML_VT8,-1,-1,-1,-1}},
  {"vt8","t8",
   BODY_UNDEF,BODY_N3D_VT4_ROLL,0,0, /* BODY_N3D_VT4_ROLL because it is a Jack N3D */
   0,"",
   1,{VRML_VT7,-1,-1,-1,-1}},
  {"vt7","t7",
   BODY_UNDEF,BODY_N3D_VT4_ROLL,0,0, /* BODY_N3D_VT4_ROLL because it is a Jack N3D */
   0,"",
   1,{VRML_VT6,-1,-1,-1,-1}},
  {"vt6","t6",
   BODY_YZ,BODY_N3D_VT5_ROLL,BODY_N3D_VT5_TORSION,0,
   0,"",
   1,{VRML_VT5,-1,-1,-1,-1}},
  {"vt5","t5",
   BODY_UNDEF,BODY_N3D_VT5_ROLL,0,0, /* BODY_N3D_VT5_ROLL because it is a Jack N3D */
   0,"",
   1,{VRML_VT4,-1,-1,-1,-1}},
  {"vt4","t4",
   BODY_UNDEF,BODY_N3D_VT5_ROLL,0,0, /* BODY_N3D_VT5_ROLL because it is a Jack N3D */
   0,"",
   1,{VRML_VT3,-1,-1,-1,-1}},
  {"vt3","t3",
   BODY_UNDEF,BODY_N3D_VT5_ROLL,0,0, /* BODY_N3D_VT5_ROLL because it is a Jack N3D */
   0,"",
   1,{VRML_VT2,-1,-1,-1,-1}},
  {"vt2","t2",
   BODY_UNDEF,BODY_N3D_VT5_ROLL,0,0, /* BODY_N3D_VT5_ROLL because it is a Jack N3D */
   0,"",
   1,{VRML_VT1,-1,-1,-1,-1}},
  {"vt1","t1",
   BODY_XYZ,BODY_N3D_VT6_ROLL,BODY_N3D_VT6_TORSION,BODY_N3D_VT6_TILT,
   0,"",
   3,{VRML_VC7,VRML_L_CLAVICULE,VRML_R_CLAVICULE,-1,-1}},
  {"vc7","c7",
   BODY_UNDEF,BODY_N3D_VT6_ROLL,0,0, /* BODY_N3D_VT6_ROLL because it is a Jack N3D */
   0,"",
   1,{VRML_VC6,-1,-1,-1,-1}},
  {"vc6","c6",
   BODY_UNDEF,BODY_N3D_VT6_ROLL,0,0, /* BODY_N3D_VT6_ROLL because it is a Jack N3D */
   0,"",
   1,{VRML_VC5,-1,-1,-1,-1}},
  {"vc5","c5",
   BODY_UNDEF,BODY_N3D_VT6_ROLL,0,0, /* BODY_N3D_VT6_ROLL because it is a Jack N3D */
   0,"",
   1,{VRML_VC4,-1,-1,-1,-1}},
  {"vc4","c4",
   BODY_XYZ,BODY_N3D_VC7_ROLL,BODY_N3D_VC7_TORSION,BODY_N3D_VC7_TILT,
   1,"_neck",
   1,{VRML_VC3,-1,-1,-1,-1}},
  {"vc3","c3",
   BODY_UNDEF,BODY_N3D_VC7_ROLL,0,0, /* BODY_N3D_VC7_ROLL because it is a Jack N3D */
   0,"",
   1,{VRML_VC2,-1,-1,-1,-1}},
  {"vc2","c2",
   BODY_XYZ,BODY_N3D_VC8_ROLL,BODY_N3D_VC8_TORSION,BODY_N3D_VC8_TILT,
   1,"_head",
   1,{VRML_VC1,-1,-1,-1,-1}},
  {"vc1","c1",
   BODY_UNDEF,BODY_N3D_VC8_ROLL,0,0, /* BODY_N3D_VC8_ROLL because it is a Jack N3D */
   0,"",
   1,{VRML_SKULLBASE,-1,-1,-1,-1}},
  {"skullbase","skull",
   BODY_UNDEF,0,0,0,
   0,"",
   0,{-1,-1,-1,-1,-1}},

  /* calvicule = sternoclavicular */
  {"l_sternoclavicular","l_clavicule",
   BODY_XY,BODY_N3D_L_CLAV_ABDUCT,BODY_N3D_L_CLAV_ROTATE,0,
   0,"",
   1,{VRML_L_SCAPULA,-1,-1,-1,-1}},
  /* scapula = acromioclavicular */
  {"l_acromioclavicular","l_scapula",
   BODY_XY,BODY_N3D_L_SCAP_ABDUCT,BODY_N3D_L_SCAP_ROTATE,0,
   0,"",
   1,{VRML_L_SHOULDER,-1,-1,-1,-1}},
  {"l_shoulder","l_upperarm",
   BODY_XYZ,BODY_N3D_L_SHOULDER_FLEXION,BODY_N3D_L_SHOULDER_ABDUCT,BODY_N3D_L_SHOULDER_TWISTING,
   1,"_left_upper_arm",
   1,{VRML_L_ELBOW,-1,-1,-1,-1}},
  {"l_elbow","l_forearm",
   BODY_XY,BODY_N3D_L_ELBOW_FLEXION,BODY_N3D_L_ELBOW_TWISTING,0,
   1,"_left_lower_arm",
   1,{VRML_L_WRIST,-1,-1,-1,-1}},
  {"l_wrist","l_hand",
   BODY_XY,BODY_N3D_L_WRIST_FLEXION,BODY_N3D_L_WRIST_PIVOT,0,
   1,"_l_palm",
   5,{VRML_L_THUMB1,VRML_L_INDEX1,VRML_L_MIDDLE1,VRML_L_RING1,VRML_L_PINKY1}},

  /* calvicule = sternoclavicular */
  {"r_sternoclavicular","r_clavicule",
   BODY_XY,BODY_N3D_R_CLAV_ABDUCT,BODY_N3D_R_CLAV_ROTATE,0,
   0,"",
   1,{VRML_R_SCAPULA,-1,-1,-1,-1}},
  /* scapula = acromioclavicular */
  {"r_acromioclavicular","r_scapula",
   BODY_XY,BODY_N3D_R_SCAP_ABDUCT,BODY_N3D_R_SCAP_ROTATE,0,
   0,"",
   1,{VRML_R_SHOULDER,-1,-1,-1,-1}},
  {"r_shoulder","r_upperarm",
   BODY_XYZ,BODY_N3D_R_SHOULDER_FLEXION,BODY_N3D_R_SHOULDER_ABDUCT,BODY_N3D_R_SHOULDER_TWISTING,
   1,"_right_upper_arm",
   1,{VRML_R_ELBOW,-1,-1,-1,-1}},
  {"r_elbow","r_forearm",
   BODY_XY,BODY_N3D_R_ELBOW_FLEXION,BODY_N3D_R_ELBOW_TWISTING,0,
   1,"_right_lower_arm",
   1,{VRML_R_WRIST,-1,-1,-1,-1}},
  {"r_wrist","r_hand",
   BODY_XY,BODY_N3D_R_WRIST_FLEXION,BODY_N3D_R_WRIST_PIVOT,0,
   1,"_r_palm",
   5,{VRML_R_THUMB1,VRML_R_INDEX1,VRML_R_MIDDLE1,VRML_R_RING1,VRML_R_PINKY1}},


/* Additional HumanoidRoot (missing) node */
  {"HumanoidRoot","VRML_Root",
   BODY_TR,BODY_N3D_TR_VERTICAL,BODY_N3D_TR_LATERAL,BODY_N3D_TR_FRONTAL/*BODY_N3D_PELVIC_ROLL*/,
   1,"",
   1,{VRML_PELVIS,-1,-1,-1,-1}},
  {"HumanoidRoot","VRML_Root",
   BODY_ZYX,BODY_N3D_BODY_TURN,BODY_N3D_BODY_ROLL,BODY_N3D_BODY_TILT,
   1,"",
   5,{VRML_PELVIS,-1,-1,-1,-1}},





  /* Left Fingers */
  {"l_thumb1","l_thumb_metacarpal",
   BODY_XY,BODY_N3D_L_THUMB_FL1,BODY_N3D_L_THUMB_ABDUCT,BODY_N3D_L_THUMB_TW,
   1,"_l_thumb_base",
   1,{VRML_L_THUMB2,-1,-1,-1,-1}},
  {"l_thumb2","l_thumb_proximal",
   BODY_XY,BODY_N3D_L_THUMB_FL2,0,0,
   1,"_l_thumb_mid",
   1,{VRML_L_THUMB3,-1,-1,-1,-1}},
  {"l_thumb3","l_thumb_distal",
   BODY_XY,BODY_N3D_L_THUMB_FL3,0,0,
   1,"_l_thumb_ext",
   0,{-1,-1,-1,-1,-1}},
  {"l_index1","l_index_proximal",
   BODY_XY,BODY_N3D_L_INDEX_FL1,BODY_N3D_L_INDEX_PIVOT,BODY_N3D_L_INDEX_TWIST,
   1,"_l_index_base",
   1,{VRML_L_INDEX2,-1,-1,-1,-1}},
  {"l_index2","l_index_middle",
   BODY_XY,BODY_N3D_L_INDEX_FL2,0,0,
   1,"_l_index_mid",
   1,{VRML_L_INDEX3,-1,-1,-1,-1}},
  {"l_index3","l_index_distal",
   BODY_XY,BODY_N3D_L_INDEX_FL3,0,0,
   1,"_l_index_ext",
   0,{-1,-1,-1,-1,-1}},
  {"l_middle1","l_middle_proximal",
   BODY_XY,BODY_N3D_L_MIDDLE_FL1,BODY_N3D_L_MIDDLE_PIVOT,BODY_N3D_L_MIDDLE_TWIST,
   1,"_l_middle_base",
   1,{VRML_L_MIDDLE2,-1,-1,-1,-1}},
  {"l_middle2","l_middle_middle",
   BODY_XY,BODY_N3D_L_MIDDLE_FL2,0,0,
   1,"_l_middle_mid",
   1,{VRML_L_MIDDLE3,-1,-1,-1,-1}},
  {"l_middle3","l_middle_distal",
   BODY_XY,BODY_N3D_L_MIDDLE_FL3,0,0,
   1,"_l_middle_ext",
   0,{-1,-1,-1,-1,-1}},
  {"l_ring1","l_ring_proximal",
   BODY_XY,BODY_N3D_L_RING_FL1,BODY_N3D_L_RING_PIVOT,BODY_N3D_L_RING_TWIST,
   1,"_l_ring_base",
   1,{VRML_L_RING2,-1,-1,-1,-1}},
  {"l_ring2","l_ring_middle",
   BODY_XY,BODY_N3D_L_RING_FL2,0,0,
   1,"_l_ring_mid",
   1,{VRML_L_RING3,-1,-1,-1,-1}},
  {"l_ring3","l_ring_distal",
   BODY_XY,BODY_N3D_L_RING_FL3,0,0,
   1,"_l_ring_ext",
   0,{-1,-1,-1,-1,-1}},
  {"l_pinky1","l_pinky_proximal",
   BODY_XY,BODY_N3D_L_PINKY_FL1,BODY_N3D_L_PINKY_PIVOT,BODY_N3D_L_PINKY_TWIST,
   1,"_l_pinky_base",
   1,{VRML_L_PINKY2,-1,-1,-1,-1}},
  {"l_pinky2","l_pinky_middle",
   BODY_XY,BODY_N3D_L_PINKY_FL2,0,0,
   1,"_l_pinky_mid",
   1,{VRML_L_PINKY3,-1,-1,-1,-1}},
  {"l_pinky3","l_pinky_distal",
   BODY_XY,BODY_N3D_L_PINKY_FL3,0,0,
   1,"_l_pinky_ext",
   0,{-1,-1,-1,-1,-1}},

  /* Right Fingers */
  {"r_thumb1","r_thumb_metacarpal",
   BODY_XY,BODY_N3D_R_THUMB_FL1,BODY_N3D_R_THUMB_ABDUCT,BODY_N3D_R_THUMB_TW,
   1,"_r_thumb_base",
   1,{VRML_R_THUMB2,-1,-1,-1,-1}},
  {"r_thumb2","r_thumb_proximal",
   BODY_XY,BODY_N3D_R_THUMB_FL2,0,0,
   1,"_r_thumb_mid",
   1,{VRML_R_THUMB3,-1,-1,-1,-1}},
  {"r_thumb3","r_thumb_distal",
   BODY_XY,BODY_N3D_R_THUMB_FL3,0,0,
   1,"_r_thumb_ext",
   0,{-1,-1,-1,-1,-1}},
  {"r_index1","r_index_proximal",
   BODY_XY,BODY_N3D_R_INDEX_FL1,BODY_N3D_R_INDEX_PIVOT,BODY_N3D_R_INDEX_TWIST,
   1,"_r_index_base",
   1,{VRML_R_INDEX2,-1,-1,-1,-1}},
  {"r_index2","r_index_middle",
   BODY_XY,BODY_N3D_R_INDEX_FL2,0,0,
   1,"_r_index_mid",
   1,{VRML_R_INDEX3,-1,-1,-1,-1}},
  {"r_index3","r_index_distal",
   BODY_XY,BODY_N3D_R_INDEX_FL3,0,0,
   1,"_r_index_ext",
   0,{-1,-1,-1,-1,-1}},
  {"r_middle1","r_middle_proximal",
   BODY_XY,BODY_N3D_R_MIDDLE_FL1,BODY_N3D_R_MIDDLE_PIVOT,BODY_N3D_R_MIDDLE_TWIST,
   1,"_r_middle_base",
   1,{VRML_R_MIDDLE2,-1,-1,-1,-1}},
  {"r_middle2","r_middle_middle",
   BODY_XY,BODY_N3D_R_MIDDLE_FL2,0,0,
   1,"_r_middle_mid",
   1,{VRML_R_MIDDLE3,-1,-1,-1,-1}},
  {"r_middle3","r_middle_distal",
   BODY_XY,BODY_N3D_R_MIDDLE_FL3,0,0,
   1,"_r_middle_ext",
   0,{-1,-1,-1,-1,-1}},
  {"r_ring1","r_ring_proximal",
   BODY_XY,BODY_N3D_R_RING_FL1,BODY_N3D_R_RING_PIVOT,BODY_N3D_R_RING_TWIST,
   1,"_r_ring_base",
   1,{VRML_R_RING2,-1,-1,-1,-1}},
  {"r_ring2","r_ring_middle",
   BODY_XY,BODY_N3D_R_RING_FL2,0,0,
   1,"_r_ring_mid",
   1,{VRML_R_RING3,-1,-1,-1,-1}},
  {"r_ring3","r_ring_distal",
   BODY_XY,BODY_N3D_R_RING_FL3,0,0,
   1,"_r_ring_ext",
   0,{-1,-1,-1,-1,-1}},
  {"r_pinky1","r_pinky_proximal",
   BODY_XY,BODY_N3D_R_PINKY_FL1,BODY_N3D_R_PINKY_PIVOT,BODY_N3D_R_PINKY_TWIST,
   1,"_r_pinky_base",
   1,{VRML_R_PINKY2,-1,-1,-1,-1}},
  {"r_pinky2","r_pinky_middle",
   BODY_XY,BODY_N3D_R_PINKY_FL2,0,0,
   1,"_r_pinky_mid",
   1,{VRML_R_PINKY3,-1,-1,-1,-1}},
  {"r_pinky3","r_pinky_distal",
   BODY_XY,BODY_N3D_R_PINKY_FL3,0,0,
   1,"_r_pinky_ext",
   0,{-1,-1,-1,-1,-1}}
};
#endif


/*
#define MAX_BODY 50
typedef struct {
  BODY *bodyPtr;
} HUMANOID;
HUMANOID bodies[MAX_BODY];
*/


epflbody_scene_init()
{
  scene = scene_new("skeletonview");

}

void epflbody_init( int bodyId)
{
  MatriX bodyMatrices[2+VRML_NB_JOINTS+2*VRML_NB_HAND_JOINTS];

  if (!scene)
    epflbody_scene_init();

  /*bodies[bodyId].bodyPtr = */

  bodyview[bodyId] = body_insTance_creation(scene);
  body_set_orientation(bodyview[bodyId], BODY_Y_UP);

  if(!body_set_right_hand(bodyview[bodyId], TRUE)) exit(1);
  if(!body_set_left_hand(bodyview[bodyId], TRUE)) exit(1);

  epflbodySetMatrices( bodyview[bodyId], -1, bodyMatrices);
}


void
GetWorldNodeMat( N3D_t *self1 , N3D_t *self2, MatriX TT1, MatriX TT2 )
{
  MatriX P1_ref_inv;
  MatriX WrldInv;
  N3D_t  *tmpNode;

  /* Get 1st Parent's ref_inv */
  n3d_get_ref_inv( n3d_get_parent( self1 ), P1_ref_inv );

  tmpNode = n3d_get_parent( self1 );

  matrix_copy( P1_ref_inv, TT1);
  n3d_get_ref_dir( self2, TT2 );

}

/*-------------------------------------------------------------------*/
void    matrix_transpose(MatriX a,
                         MatriX at)
{
  MatriX  m;
  int     i,j;

  for(i=0 ; i<4 ; i++)
     for(j=0 ; j<4 ; j++)
	m[i][j] = a[j][i];

  for(i=0 ; i<4 ; i++)
     for(j=0 ; j<4 ; j++)
	at[i][j] = m[i][j];
}

epflComputeJointWorldTransf( N3D_t *self1, N3D_t *self2,
			     MatriX TT1, MatriX TT2, MatriX TT3 )
{
  MatriX P1_ref_dir, ref_inv2, X1, X2;

  /* Get 1st DOF Parent ref_dir */
  n3d_get_ref_dir( n3d_get_parent( self1 ), P1_ref_dir );

  /* Get last DOF's ref_inv */
  n3d_get_ref_inv( self2, ref_inv2 );

  matrix_mult( WorldRefMat, TT1, X1 );
  matrix_mult( X1, P1_ref_dir, X2 );
  matrix_mult( X2, ref_inv2, X1 );
  matrix_mult( X1, TT2, X2 );
  matrix_mult( X2, WorldRefMat, X1);
  matrix_transpose( X1, TT3 );
}

void
epflbodySetMatrices( BODY *bodyview, int Frame, MatriX bodyMatrices[])
{
  int i;
  MatriX mat1, mat2, res, temp;
  N3D *node1, *node2;
  static MatriX initial_matrices1[VRML_NB_JOINTS+2*VRML_NB_HAND_JOINTS];
  static MatriX initial_matrices2[VRML_NB_JOINTS+2*VRML_NB_HAND_JOINTS];
  int node2_id;

  for (i=0; i<VRML_NB_JOINTS+2*VRML_NB_HAND_JOINTS; i++) {

    if (Hinfo[i].order == BODY_UNDEF) {
      matrix_idt_( bodyMatrices[i]);
      continue;
    }

    if (i<VRML_NB_JOINTS)
      node1 = bodyGetN3D( bodyview, Hinfo[i].JointIndex1 ); /*bodyview->tn3d[Hinfo[i].JointIndex1];*/
    else if (i<VRML_NB_JOINTS+VRML_NB_HAND_JOINTS)
      node1 = bodyGetLHandN3D(bodyview, Hinfo[i].JointIndex1 ); /*bodyview->tlhand[Hinfo[i].JointIndex1];*/
    else
      node1 = bodyGetRHandN3D(bodyview, Hinfo[i].JointIndex1 );/*bodyview->trhand[Hinfo[i].JointIndex1];*/

    if (Hinfo[i].JointIndex3)
      node2_id = Hinfo[i].JointIndex3;
    else if (Hinfo[i].JointIndex2)
      node2_id = Hinfo[i].JointIndex2;
    else
      node2_id = Hinfo[i].JointIndex1;  

    if (i<VRML_NB_JOINTS)
      node2 = bodyGetN3D( bodyview, node2_id ); /* bodyview->tn3d[node2_id]; */
    else if (i<VRML_NB_JOINTS+VRML_NB_HAND_JOINTS)
      node2 =  bodyGetLHandN3D( bodyview, node2_id );/* bodyview->tlhand[node2_id]; */
    else
      node2 =  bodyGetRHandN3D( bodyview, node2_id );/* bodyview->trhand[node2_id]; */

    if (Frame == -1) {
      GetWorldNodeMat( node1, node2, initial_matrices1[i], initial_matrices2[i] );

    }
    else {
      epflComputeJointWorldTransf( 
		 node1, node2, initial_matrices1[i], initial_matrices2[i], res );
		 matrix_copy( res, bodyMatrices[i]);
    }

  }

}

int epflbody_set_val( int bodyId, int id, float newVal)
{
  if (id == -1) return;

  /* EPFLBODY ids start from 0 */
  id--;

  if (UpdtJointList[id] >= 100 && UpdtJointList[id] <= 200)
    bodyChangeLHandJointVal( bodyview[bodyId], UpdtJointList[id]-100, newVal);
  else if (UpdtJointList[id] >= 200)
    bodyChangeRHandJointVal(bodyview[bodyId], UpdtJointList[id]-200, newVal);
  else
    bodyChangeJointVal( bodyview[bodyId],UpdtJointList[id], newVal );
}

int epflbody_body_update( int bodyId, MatriX bodyMatrices[])
{
  static int first_time = 1;
  h3d_update_ref_config(bodyGetN3D( bodyview[bodyId], BODY_N3D_GLOBAL_MOTION));
  if (first_time) {
    first_time = 0;
    /* epflbodySetMatrices( bodyview[bodyId], -1, bodyMatrices); */
  }
  
  epflbodySetMatrices( bodyview[bodyId], 0, bodyMatrices);
 
}


#ifndef EPSILON
#define EPSILON 1e-4
#endif

void epflbody_mr3dI_to_axis_angle(VT3D axis, MR3D mr, float *theta)
{
  float angle, norm, ww, xx, yy, four_w, two_x;
  double scalar ;
  VHOM  quat ;
  
  ww = 0.25 * ( 1.0 + mr[0][0] + mr[1][1] + mr[2][2]);
  
  if (ww > EPSILON)
  {
    quat[3] = sqrt(ww);
    four_w  = 4.0 * quat[3];
    quat[0] = (mr[1][2] - mr[2][1]) / four_w;
    quat[1] = (mr[2][0] - mr[0][2]) / four_w;
    quat[2] = (mr[0][1] - mr[1][0]) / four_w;
          
  }
  else
  {
    quat[3] = 0.0;
    xx = -0.5 * (mr[1][1] + mr[2][2]);

    if (xx > EPSILON)
    {
      quat[0] = sqrt(xx);
      two_x = quat[0] * 2.0;
      quat[1] = mr[0][1] / two_x;
      quat[2] = mr[0][2] / two_x;
    }
    else
    {
      quat[0] = 0.0;
      yy = 0.5 * (1.0 - mr[2][2]);

      if (yy > EPSILON)
      {
	quat[1] = sqrt(yy);
	quat[2] = mr[1][2] / (2.0 * quat[1]);
      }
      else
      {
	quat[1] = 0.0;
	quat[2] = 1.0;
      }
    }
  }


  /* normalize the quaternion */
  norm = sqrt(
    quat[0] * quat[0] +
    quat[1] * quat[1] +
    quat[2] * quat[2] +
    quat[3] * quat[3]);

  if (norm > EPSILON)
  {
    quat[0] /= norm;
    quat[1] /= norm;
    quat[2] /= norm;
    quat[3] /= norm;
  }
  else
  {
    quat[0] = 0.0;
    quat[1] = 0.0;
    quat[2] = 0.0;
    quat[3] = 1.0;
  }

  /* calculate angle */
  angle = 2.0 * acos(quat[3]);

  axis[0] = quat[0];
  axis[1] = quat[1];
  axis[2] = quat[2];

  norm = sqrt((double)(axis[0]*axis[0] + axis[1]*axis[1] + axis[2]*axis[2])) ;
  if (norm > EPSILON)
  {
    *theta = (float) angle;
    axis[0] /= norm;
    axis[1] /= norm;
    axis[2] /= norm;
  }
  else
  {
    *theta = angle;
    axis[0] = 1 ;
    axis[1] = 0. ;
    axis[2] = 0. ;
     
  }
}

char *epflbody_get_hinfo_name( int ind) 
{
  return Hinfo[ind].VRML_name;
}
