#ifndef _HIERARCHY_H_
#define _HIERARCHY_H_

#include "Node.h"

HierarchieInfo Hinfo[VRML_NB_JOINTS+2*VRML_NB_HAND_JOINTS] = {
  /* --------- Lower Part Top Hierarchy */

  /*  pelvis = sacroiliac */
  {"sacroiliac","pelvis",
   BODY_XYZ,BODY_N3D_PELVIC_TILT,BODY_N3D_PELVIC_TORSION,BODY_N3D_PELVIC_ROLL,
   1,"_hip",
   2,{VRML_L_HIP,VRML_R_HIP,-1,-1,-1}},
 
  {"l_hip","l_thigh",
   BODY_XYZ,BODY_N3D_L_HIP_FLEXION,BODY_N3D_L_HIP_ABDUCT,BODY_N3D_L_HIP_TWISTING,
   1,"_left_thigh",
   1,{VRML_L_KNEE,-1,-1,-1,-1}},
  {"l_knee","l_calf",
   BODY_XY,BODY_N3D_L_KNEE_FLEXION,BODY_N3D_L_KNEE_TWISTING,0,
   1,"_left_leg",
   1,{VRML_L_ANKLE,-1,-1,-1,-1}},
  {"l_ankle","l_hindfoot",
   BODY_X,BODY_N3D_L_ANKLE_FLEXION,0,0,
   1,"_left_foot",
   1,{VRML_L_SUBTALAR,-1,-1,-1,-1}},
  {"l_subtalar","l_midproximal",
   BODY_UNDEF,BODY_N3D_L_ANKLE_SUBTALAR,0,0,
   0,"",
   1,{VRML_L_MIDFOOT,-1,-1,-1,-1}},
  /*  midfoot = midtarsal  */
  {"l_midtarsal","l_middistral",
   BODY_Z,BODY_N3D_L_MID_FOOT,0,0,
   0,"",
   1,{VRML_L_TOE,-1,-1,-1,-1}},
  /*  toe = metatarsal  */
  {"l_metatarsal","l_forefoot",
   BODY_Z,BODY_N3D_L_TOE_FLEXION,0,0,
   0,"",
   0,{-1,-1,-1,-1,-1}},

  {"r_hip","r_thigh",
   BODY_XYZ,BODY_N3D_R_HIP_FLEXION,BODY_N3D_R_HIP_ABDUCT,BODY_N3D_R_HIP_TWISTING,
   1,"_right_thigh",
   1,{VRML_R_KNEE,-1,-1,-1,-1}},
  {"r_knee","r_calf",
   BODY_XY,BODY_N3D_R_KNEE_FLEXION,BODY_N3D_R_KNEE_TWISTING,0,
   1,"_right_leg",
   1,{VRML_R_ANKLE,-1,-1,-1,-1}},
  {"r_ankle","r_hindfoot",
   BODY_X,BODY_N3D_R_ANKLE_FLEXION,0,0,
   1,"_right_foot",
   1,{VRML_R_SUBTALAR,-1,-1,-1,-1}},
  {"r_subtalar","r_midproximal",
   BODY_UNDEF,BODY_N3D_R_ANKLE_SUBTALAR,0,0,
   0,"",
   1,{VRML_R_MIDFOOT,-1,-1,-1,-1}},
  /*  midfoot = midtarsal  */
  {"r_midtarsal","r_middistral",
   BODY_Z,BODY_N3D_R_MID_FOOT,0,0,
   0,"",
   1,{VRML_R_TOE,-1,-1,-1,-1}},
  /*  toe = metatarsal  */
  {"r_metatarsal","r_forefoot",
   BODY_Z,BODY_N3D_R_TOE_FLEXION,0,0,
   0,"",
   0,{-1,-1,-1,-1,-1}},
  
  {"vl5","l5",
   BODY_X,BODY_N3D_VL1_TILT,0,0,
   0,"",
   1,{VRML_VL4,-1,-1,-1,-1}},
  {"vl4","l4",
   BODY_UNDEF,BODY_N3D_VL1_TILT,0,0, /*  BODY_N3D_VL1_TILT because it is a Jack N3D  */
   0,"",
   1,{VRML_VL3,-1,-1,-1,-1}},
  {"vl3","l3",
   BODY_XY,BODY_N3D_VL2_ROLL,BODY_N3D_VL2_TILT,0,
   1,"_lower_torso",
   1,{VRML_VL2,-1,-1,-1,-1}},
  {"vl2","l2",
   BODY_UNDEF,BODY_N3D_VL2_ROLL,0,0, /*  BODY_N3D_VL2_ROLL because it is a Jack N3D  */
   0,"",
   1,{VRML_VL1,-1,-1,-1,-1}},
  {"vl1","l1",
   BODY_XY,BODY_N3D_VL3_ROLL,BODY_N3D_VL3_TILT,0,
   0,"",
   1,{VRML_VT10,-1,-1,-1,-1}},
  {"vt10","t10",
   BODY_XYZ,BODY_N3D_VT4_ROLL,BODY_N3D_VT4_TORSION,BODY_N3D_VT4_TILT,
   1,"_upper_torso",
   1,{VRML_VT9,-1,-1,-1,-1}},
  {"vt9","t9",
   BODY_UNDEF,BODY_N3D_VT4_ROLL,0,0, /*  BODY_N3D_VT4_ROLL because it is a Jack N3D  */
   0,"",
   1,{VRML_VT8,-1,-1,-1,-1}},
  {"vt8","t8",
   BODY_UNDEF,BODY_N3D_VT4_ROLL,0,0, /*  BODY_N3D_VT4_ROLL because it is a Jack N3D  */
   0,"",
   1,{VRML_VT7,-1,-1,-1,-1}},
  {"vt7","t7",
   BODY_UNDEF,BODY_N3D_VT4_ROLL,0,0, /*  BODY_N3D_VT4_ROLL because it is a Jack N3D  */
   0,"",
   1,{VRML_VT6,-1,-1,-1,-1}},
  {"vt6","t6",
   BODY_YZ,BODY_N3D_VT5_ROLL,BODY_N3D_VT5_TORSION,0,
   0,"",
   1,{VRML_VT5,-1,-1,-1,-1}},
  {"vt5","t5",
   BODY_UNDEF,BODY_N3D_VT5_ROLL,0,0, /* BODY_N3D_VT5_ROLL because it is a Jack N3D  */
   0,"",
   1,{VRML_VT4,-1,-1,-1,-1}},
  {"vt4","t4",
   BODY_UNDEF,BODY_N3D_VT5_ROLL,0,0, /*  BODY_N3D_VT5_ROLL because it is a Jack N3D  */
   0,"",
   1,{VRML_VT3,-1,-1,-1,-1}},
  {"vt3","t3",
   BODY_UNDEF,BODY_N3D_VT5_ROLL,0,0, /*  BODY_N3D_VT5_ROLL because it is a Jack N3D  */
   0,"",
   1,{VRML_VT2,-1,-1,-1,-1}},
  {"vt2","t2",
   BODY_UNDEF,BODY_N3D_VT5_ROLL,0,0, /*  BODY_N3D_VT5_ROLL because it is a Jack N3D  */
   0,"",
   1,{VRML_VT1,-1,-1,-1,-1}},
  {"vt1","t1",
   BODY_XYZ,BODY_N3D_VT6_ROLL,BODY_N3D_VT6_TORSION,BODY_N3D_VT6_TILT,
   0,"",
   3,{VRML_VC7,VRML_L_CLAVICULE,VRML_R_CLAVICULE,-1,-1}},
  {"vc7","c7",
   BODY_UNDEF,BODY_N3D_VT6_ROLL,0,0, /*  BODY_N3D_VT6_ROLL because it is a Jack N3D  */
   0,"",
   1,{VRML_VC6,-1,-1,-1,-1}},
  {"vc6","c6",
   BODY_UNDEF,BODY_N3D_VT6_ROLL,0,0, /*  BODY_N3D_VT6_ROLL because it is a Jack N3D  */
   0,"",
   1,{VRML_VC5,-1,-1,-1,-1}},
  {"vc5","c5",
   BODY_UNDEF,BODY_N3D_VT6_ROLL,0,0, /*  BODY_N3D_VT6_ROLL because it is a Jack N3D  */
   0,"",
   1,{VRML_VC4,-1,-1,-1,-1}},
  {"vc4","c4",
   BODY_XYZ,BODY_N3D_VC7_ROLL,BODY_N3D_VC7_TORSION,BODY_N3D_VC7_TILT,
   1,"_neck",
   1,{VRML_VC3,-1,-1,-1,-1}},
  {"vc3","c3",
   BODY_UNDEF,BODY_N3D_VC7_ROLL,0,0, /*  BODY_N3D_VC7_ROLL because it is a Jack N3D  */
   0,"",
   1,{VRML_VC2,-1,-1,-1,-1}},
  {"vc2","c2",
   BODY_XYZ,BODY_N3D_VC8_ROLL,BODY_N3D_VC8_TORSION,BODY_N3D_VC8_TILT,
   1,"_head",
   1,{VRML_VC1,-1,-1,-1,-1}},
  {"vc1","c1",
   BODY_UNDEF,BODY_N3D_VC8_ROLL,0,0, /*  BODY_N3D_VC8_ROLL because it is a Jack N3D  */
   0,"",
   1,{VRML_SKULLBASE,-1,-1,-1,-1}},
  {"skullbase","skull",
   BODY_UNDEF,0,0,0,
   0,"",
   0,{-1,-1,-1,-1,-1}},

  /*  calvicule = sternoclavicular  */
  {"l_sternoclavicular","l_clavicule",
   BODY_XY,BODY_N3D_L_CLAV_ABDUCT,BODY_N3D_L_CLAV_ROTATE,0,
   0,"",
   1,{VRML_L_SCAPULA,-1,-1,-1,-1}},
  /*  scapula = acromioclavicular  */
  {"l_acromioclavicular","l_scapula",
   BODY_XY,BODY_N3D_L_SCAP_ABDUCT,BODY_N3D_L_SCAP_ROTATE,0,
   0,"",
   1,{VRML_L_SHOULDER,-1,-1,-1,-1}},
  {"l_shoulder","l_upperarm",
   BODY_XYZ,BODY_N3D_L_SHOULDER_FLEXION,BODY_N3D_L_SHOULDER_ABDUCT,BODY_N3D_L_SHOULDER_TWISTING,
   1,"_left_upper_arm",
   1,{VRML_L_ELBOW,-1,-1,-1,-1}},
  {"l_elbow","l_forearm",
   BODY_XY,BODY_N3D_L_ELBOW_FLEXION,BODY_N3D_L_ELBOW_TWISTING,0,
   1,"_left_lower_arm",
   1,{VRML_L_WRIST,-1,-1,-1,-1}},
  {"l_wrist","l_hand",
   BODY_XY,BODY_N3D_L_WRIST_FLEXION,BODY_N3D_L_WRIST_PIVOT,0,
   1,"_l_palm",
   5,{VRML_L_THUMB1,VRML_L_INDEX1,VRML_L_MIDDLE1,VRML_L_RING1,VRML_L_PINKY1}},

  /*  calvicule = sternoclavicular  */
  {"r_sternoclavicular","r_clavicule",
   BODY_XY,BODY_N3D_R_CLAV_ABDUCT,BODY_N3D_R_CLAV_ROTATE,0,
   0,"",
   1,{VRML_R_SCAPULA,-1,-1,-1,-1}},
  /*  scapula = acromioclavicular  */
  {"r_acromioclavicular","r_scapula",
   BODY_XY,BODY_N3D_R_SCAP_ABDUCT,BODY_N3D_R_SCAP_ROTATE,0,
   0,"",
   1,{VRML_R_SHOULDER,-1,-1,-1,-1}},
  {"r_shoulder","r_upperarm",
   BODY_XYZ,BODY_N3D_R_SHOULDER_FLEXION,BODY_N3D_R_SHOULDER_ABDUCT,BODY_N3D_R_SHOULDER_TWISTING,
   1,"_right_upper_arm",
   1,{VRML_R_ELBOW,-1,-1,-1,-1}},
  {"r_elbow","r_forearm",
   BODY_XY,BODY_N3D_R_ELBOW_FLEXION,BODY_N3D_R_ELBOW_TWISTING,0,
   1,"_right_lower_arm",
   1,{VRML_R_WRIST,-1,-1,-1,-1}},
  {"r_wrist","r_hand",
   BODY_XY,BODY_N3D_R_WRIST_FLEXION,BODY_N3D_R_WRIST_PIVOT,0,
   1,"_r_palm",
   5,{VRML_R_THUMB1,VRML_R_INDEX1,VRML_R_MIDDLE1,VRML_R_RING1,VRML_R_PINKY1}},


/*  Additional HumanoidRoot (missing) node  */
  {"HumanoidRoot","VRML_Root",
   BODY_TR,BODY_N3D_TR_VERTICAL,BODY_N3D_TR_LATERAL,BODY_N3D_TR_FRONTAL/* BODY_N3D_PELVIC_ROLL */,
   1,"",
   1,{VRML_ROOT,-1,-1,-1,-1}},
  {"HumanoidRoot","VRML_Root",
   BODY_ZYX,BODY_N3D_BODY_TURN,BODY_N3D_BODY_ROLL,BODY_N3D_BODY_TILT,
   1,"",
   5,{VRML_ROOT,-1,-1,-1,-1}},





  /*  Left Fingers  */
  {"l_thumb1","l_thumb_metacarpal",
   BODY_XY,BODY_N3D_L_THUMB_FL1,BODY_N3D_L_THUMB_ABDUCT,BODY_N3D_L_THUMB_TW,
   1,"_l_thumb_base",
   1,{VRML_L_THUMB2,-1,-1,-1,-1}},
  {"l_thumb2","l_thumb_proximal",
   BODY_XY,BODY_N3D_L_THUMB_FL2,0,0,
   1,"_l_thumb_mid",
   1,{VRML_L_THUMB3,-1,-1,-1,-1}},
  {"l_thumb3","l_thumb_distal",
   BODY_XY,BODY_N3D_L_THUMB_FL3,0,0,
   1,"_l_thumb_ext",
   0,{-1,-1,-1,-1,-1}},
  {"l_index1","l_index_proximal",
   BODY_XY,BODY_N3D_L_INDEX_FL1,BODY_N3D_L_INDEX_PIVOT,BODY_N3D_L_INDEX_TWIST,
   1,"_l_index_base",
   1,{VRML_L_INDEX2,-1,-1,-1,-1}},
  {"l_index2","l_index_middle",
   BODY_XY,BODY_N3D_L_INDEX_FL2,0,0,
   1,"_l_index_mid",
   1,{VRML_L_INDEX3,-1,-1,-1,-1}},
  {"l_index3","l_index_distal",
   BODY_XY,BODY_N3D_L_INDEX_FL3,0,0,
   1,"_l_index_ext",
   0,{-1,-1,-1,-1,-1}},
  {"l_middle1","l_middle_proximal",
   BODY_XY,BODY_N3D_L_MIDDLE_FL1,BODY_N3D_L_MIDDLE_PIVOT,BODY_N3D_L_MIDDLE_TWIST,
   1,"_l_middle_base",
   1,{VRML_L_MIDDLE2,-1,-1,-1,-1}},
  {"l_middle2","l_middle_middle",
   BODY_XY,BODY_N3D_L_MIDDLE_FL2,0,0,
   1,"_l_middle_mid",
   1,{VRML_L_MIDDLE3,-1,-1,-1,-1}},
  {"l_middle3","l_middle_distal",
   BODY_XY,BODY_N3D_L_MIDDLE_FL3,0,0,
   1,"_l_middle_ext",
   0,{-1,-1,-1,-1,-1}},
  {"l_ring1","l_ring_proximal",
   BODY_XY,BODY_N3D_L_RING_FL1,BODY_N3D_L_RING_PIVOT,BODY_N3D_L_RING_TWIST,
   1,"_l_ring_base",
   1,{VRML_L_RING2,-1,-1,-1,-1}},
  {"l_ring2","l_ring_middle",
   BODY_XY,BODY_N3D_L_RING_FL2,0,0,
   1,"_l_ring_mid",
   1,{VRML_L_RING3,-1,-1,-1,-1}},
  {"l_ring3","l_ring_distal",
   BODY_XY,BODY_N3D_L_RING_FL3,0,0,
   1,"_l_ring_ext",
   0,{-1,-1,-1,-1,-1}},
  {"l_pinky1","l_pinky_proximal",
   BODY_XY,BODY_N3D_L_PINKY_FL1,BODY_N3D_L_PINKY_PIVOT,BODY_N3D_L_PINKY_TWIST,
   1,"_l_pinky_base",
   1,{VRML_L_PINKY2,-1,-1,-1,-1}},
  {"l_pinky2","l_pinky_middle",
   BODY_XY,BODY_N3D_L_PINKY_FL2,0,0,
   1,"_l_pinky_mid",
   1,{VRML_L_PINKY3,-1,-1,-1,-1}},
  {"l_pinky3","l_pinky_distal",
   BODY_XY,BODY_N3D_L_PINKY_FL3,0,0,
   1,"_l_pinky_ext",
   0,{-1,-1,-1,-1,-1}},

  /*  Right Fingers  */
  {"r_thumb1","r_thumb_metacarpal",
   BODY_XY,BODY_N3D_R_THUMB_FL1,BODY_N3D_R_THUMB_ABDUCT,BODY_N3D_R_THUMB_TW,
   1,"_r_thumb_base",
   1,{VRML_R_THUMB2,-1,-1,-1,-1}},
  {"r_thumb2","r_thumb_proximal",
   BODY_XY,BODY_N3D_R_THUMB_FL2,0,0,
   1,"_r_thumb_mid",
   1,{VRML_R_THUMB3,-1,-1,-1,-1}},
  {"r_thumb3","r_thumb_distal",
   BODY_XY,BODY_N3D_R_THUMB_FL3,0,0,
   1,"_r_thumb_ext",
   0,{-1,-1,-1,-1,-1}},
  {"r_index1","r_index_proximal",
   BODY_XY,BODY_N3D_R_INDEX_FL1,BODY_N3D_R_INDEX_PIVOT,BODY_N3D_R_INDEX_TWIST,
   1,"_r_index_base",
   1,{VRML_R_INDEX2,-1,-1,-1,-1}},
  {"r_index2","r_index_middle",
   BODY_XY,BODY_N3D_R_INDEX_FL2,0,0,
   1,"_r_index_mid",
   1,{VRML_R_INDEX3,-1,-1,-1,-1}},
  {"r_index3","r_index_distal",
   BODY_XY,BODY_N3D_R_INDEX_FL3,0,0,
   1,"_r_index_ext",
   0,{-1,-1,-1,-1,-1}},
  {"r_middle1","r_middle_proximal",
   BODY_XY,BODY_N3D_R_MIDDLE_FL1,BODY_N3D_R_MIDDLE_PIVOT,BODY_N3D_R_MIDDLE_TWIST,
   1,"_r_middle_base",
   1,{VRML_R_MIDDLE2,-1,-1,-1,-1}},
  {"r_middle2","r_middle_middle",
   BODY_XY,BODY_N3D_R_MIDDLE_FL2,0,0,
   1,"_r_middle_mid",
   1,{VRML_R_MIDDLE3,-1,-1,-1,-1}},
  {"r_middle3","r_middle_distal",
   BODY_XY,BODY_N3D_R_MIDDLE_FL3,0,0,
   1,"_r_middle_ext",
   0,{-1,-1,-1,-1,-1}},
  {"r_ring1","r_ring_proximal",
   BODY_XY,BODY_N3D_R_RING_FL1,BODY_N3D_R_RING_PIVOT,BODY_N3D_R_RING_TWIST,
   1,"_r_ring_base",
   1,{VRML_R_RING2,-1,-1,-1,-1}},
  {"r_ring2","r_ring_middle",
   BODY_XY,BODY_N3D_R_RING_FL2,0,0,
   1,"_r_ring_mid",
   1,{VRML_R_RING3,-1,-1,-1,-1}},
  {"r_ring3","r_ring_distal",
   BODY_XY,BODY_N3D_R_RING_FL3,0,0,
   1,"_r_ring_ext",
   0,{-1,-1,-1,-1,-1}},
  {"r_pinky1","r_pinky_proximal",
   BODY_XY,BODY_N3D_R_PINKY_FL1,BODY_N3D_R_PINKY_PIVOT,BODY_N3D_R_PINKY_TWIST,
   1,"_r_pinky_base",
   1,{VRML_R_PINKY2,-1,-1,-1,-1}},
  {"r_pinky2","r_pinky_middle",
   BODY_XY,BODY_N3D_R_PINKY_FL2,0,0,
   1,"_r_pinky_mid",
   1,{VRML_R_PINKY3,-1,-1,-1,-1}},
  {"r_pinky3","r_pinky_distal",
   BODY_XY,BODY_N3D_R_PINKY_FL3,0,0,
   1,"_r_pinky_ext",
   0,{-1,-1,-1,-1,-1}}
};

#endif
