#ifndef HEADER_OF_CLASS_MPEG4BODY
#define HEADER_OF_CLASS_MPEG4BODY

#include <stdio.h>
#include <stdlib.h>
#include "mpeg4bdef.h"

#include "defs.h"
#include "opengl/base/OpenGLPresenter.h"
#include "opengl/group/TransformProxy.h"
#include "Nodes.h"

// Parameters: BAP IDs range from 1 to 186. BAP ID 0 is unused.
#define MPEG4_BODY_FRAME_RATE          (0)
#define MPEG4_BODY_NUM_BAPS            (296)

// Object functionality
#define MPEG4_BODY_MAIN_BODY           (0)
#define MPEG4_BODY_L_HAND              (1)
#define MPEG4_BODY_R_HAND              (2)
#define MPEG4_BODY_HEAD                (3)

/* Hanim files contain a large number of chars. Keep it */
#define MPEG4_BODY_STRLEN              (500)    

/* Maximum number of BAP files that can be loaded at the same time */
#define MPEG4_MAX_BAPFILE 64
#define MPEG4_MAX_NUM_FRAMES 2048
#define MPEG4_MAX_BODIES  64

class Mpeg4Body {
 private:

  // Body data
  int           bapValues[MPEG4_BODY_NUM_BAPS+1];
  int           bapMasks[MPEG4_BODY_NUM_BAPS+1];
  int           bodyId;

  // Bap related
  int           numFramesStored;
  //float **        frames;

 public:

  Mpeg4Body();
  ~Mpeg4Body();

  int bodySetBAP( int bapId, int value);
  int bodyGetBAP( int bapId);
  int bodyGetBAPMask(int bapId);
  int bodySetBAPMask(int bapId, int value);
  int bodySetBAPs( int values[]);
  int bodyGetBAPs( int values[]);
  int bodyUpdate(Transform ** pointerTable);
  char * bodyGetJointName(int pos);

  //void dumpAnimationToFile(char * filename);
};


#endif //HEADER_OF_CLASS_MPEG4BODY
