/* Basic Human Data Structure - the "golem" is the unit entry point */

struct body
{
  char	    *idt;   /* name					    */

  SCENE_t   *scene; 
  UNIT_t    *golem; 
/*        SKELETON_t *skeleton;*/


  BODY_t    *template; 

  int         nb_instance; 
  Booleen_t   orientation_mode; 
	


  MM_t	      total_height;  
  MM_t        ratio_height;  
  MM_t	      frontal_scaling;  
  MM_t	      high_lateral_scaling; 
  MM_t	      low_lateral_scaling;  
  MM_t	      spine_origin_ratio; 

/* ADDITION: */
MM_t        spine_origin;

  int	      nb_n3d;	   
  N3D_t	   ** tn3d;	   
  Booleen_t   joint;	   
  int	      nb_joint;	   
  JOINT_t  ** tjoint;	   

  Booleen_t   rhand;	   
  int	      nb_rhand;	   
  
  N3D_t	   ** trhand;	   
  
  int	      nb_joint_rhand;
  
  JOINT_t  ** tjoint_rhand;
  

  Booleen_t   lhand;	   
  int	      nb_lhand;	   
  
  N3D_t	   ** tlhand;	   
  
  int	      nb_joint_lhand;
  
  JOINT_t  ** tjoint_lhand;
  

  Booleen_t   rfoot;	   


  Booleen_t   lfoot;	   

};

struct Hand_
{
  VT3D_t tr_metac_pinky_fl_origin ;   /* wrist to pinky metac. origin */
  VT3D_t rt_metac_pinky_fl_orient ;   /* metac_pinky_fl orientation	*/
  VT3D_t tr_pinky_fl1_origin ; /* metac_pinky_fl to pinky_fl1 origin */
  VT3D_t rt_pinky_fl1_orient ; /* pinky_fl1 orientation	*/
  float	 tr_pinky_fl2_origin;  /* pinky_fl1 to pinky_fl2 origin */
  float	 tr_pinky_fl3_origin;  /* pinky_fl2 to pinky_fl3 origin */
  float	 tr_pinky_ext_origin;  /* pinky_fl3 to extrema origin */

  VT3D_t rt_metac_ring_fl_orient ;    /* metac_ring_fl orientation	*/
  VT3D_t tr_ring_fl1_origin ;  /* metac_ring_fl to ring_fl1 origin	*/
  VT3D_t rt_ring_fl1_orient ;  /* ring_fl1 orientation	*/
  float	 tr_ring_fl2_origin;   /* ring_fl1 to ring_fl2 origin	*/
  float	 tr_ring_fl3_origin;   /* ring_fl2 to ring_fl3 origin	*/
  float	 tr_ring_ext_origin;   /* ring_fl3 to extrema origin	*/

  VT3D_t tr_middle_fl1_origin; /* mmiddle to middle_fl1 origin */
  VT3D_t rt_middle_fl1_orient; /* middle_fl1 orientation	*/
  float	 tr_middle_fl2_origin; /* middle_fl1 to middle_fl2 origin */
  float	 tr_middle_fl3_origin; /*rightmiddle_fl2 to middle_fl3 origin */
  float	 tr_middle_ext_origin; /* middle_fl3 to extrema origin */

  VT3D_t tr_metac_index_fl_origin ;   /* wrist to index metac. origin */
  VT3D_t tr_index_fl1_origin ; /* metac_index_fl to index_fl1 origin  */
  VT3D_t rt_index_fl1_orient ; /* index_fl1 orientation	   */
  float	 tr_index_fl2_origin;  /* index_fl1 to index_fl2 origin  */
  float	 tr_index_fl3_origin;  /* index_fl2 to index_fl3 origin  */
  float	 tr_index_ext_origin;  /* index_fl3 to extrema origin   */

  VT3D_t tr_thumb_piv_origin ;   /* wrist to thumb origin	*/
  VT3D_t rt_thumb_piv_orient ;   /* thumb_piv orientation	*/
  VT3D_t rt_thumb_fl1_orient ;  /* thumb_fl1 orientation	*/
  float	 tr_thumb_fl2_origin;  /* thumb_fl1 to thumb_fl2 origin  */
  float	 tr_thumb_fl3_origin;  /* thumb_fl2 to thumb_fl3 origin */
  float	 tr_thumb_ext_origin;  /* thumb_fl3 to extrema origin  */
};

struct skeleton_
{
  float	  spine_origin ; 	   
  VT3D_t  rt_spine_orient;   
  
};

