// -*- c++ -*-

// This software module was originally developed by Karl Anders ygard
// (Telenor R&D), in the course of development of the MPEG-4 Systems
// standard (ISO/IEC 14496-1).  This software module is an implementation
// of a part of one or more MPEG-4 Systems tools as specified by the MPEG-4
// Systems standard.  ISO/IEC gives users of the MPEG-4 Systems standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// Copyright 1997.

#ifndef __CIRCLEPROXY_H__
#define __CIRCLEPROXY_H__

#include "GeometryProxy.h"

// class Circle;
//#include "Nodes.h"

/// Circle renderer node

class CircleProxy
  : public GeometryProxy
{
public:

  /// Constructor
  CircleProxy(Circle* pCircle);

  /// Render object
  virtual BOOL  Render(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Traverse scene graph, checking for intersection
  virtual BOOL  Select(OpenGLVisualRenderer* pRenderer, DWORD dwTime, unsigned int& depth);

  // Stefano Battista
  // moved methods from Circle to CircleProxy
  Circle * GetCircle() const
  { return (Circle *) GetMediaObject(); }
  /// Set radius of circle
  inline void SetRadius(float fRadius)
  { GetCircle()->radius = fRadius; }
  /// Get radius of circle
  inline float GetRadius() const
  { return GetCircle()->radius; }
  /// Get bounding box
  inline /* virtual */ void GetBbox(Vec3f& rBboxSize, Vec3f& rBboxCenter) const
  { rBboxSize = Vec3f(GetRadius() * 2, GetRadius() * 2, 0.0f);
  rBboxCenter = Vec3f(0, 0, 0); }

};
  
#include "CircleProxy.i"

#endif // __CIRCLEPROXY_H__
