// -*- c++ -*-

// This software module was originally developed by Karl Anders ygard
// (Telenor R&D), in the course of development of the MPEG-4 Systems
// standard (ISO/IEC 14496-1).  This software module is an implementation
// of a part of one or more MPEG-4 Systems tools as specified by the MPEG-4
// Systems standard.  ISO/IEC gives users of the MPEG-4 Systems standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// Copyright 1997.


// constructor

inline
IndexedLineSet2DProxy::IndexedLineSet2DProxy(IndexedLineSet2D* pIndexedLineSet2D)
  : GeometryProxy(pIndexedLineSet2D)
{
}

// render object

/* This is the actual method that does the work.  It is inlined, thus
   removing most of the if statements. */

inline void
IndexedLineSet2DProxy::inlinedRenderLoop(BOOL bUseCI, BOOL bColorPerVertex, const Color* pColor)
{
  // IndexedLineSet2D* pIndexedLineSet2D = (IndexedLineSet2D*) GetMediaObject();

  const MF<int>& coordIndex = /* pIndexedLineSet2D-> */ GetCoordIndex();
  const Coordinate2D* coord = /* pIndexedLineSet2D-> */ GetCoord();
  const MF<int>& colorIndex = /* pIndexedLineSet2D-> */ GetColorIndex();

  const MF<Vec2f>& coordarray = coord->point /* GetPoint() */;
  const MF<Color3f>& colorarray = pColor->color /* GetColor() */;


  int currentColor = 0;
  BOOL begin = FALSE;
  int coords = coordIndex.GetLength();

  for (int i = 0; i < coords; ++i) {
    if (coordIndex[i] == -1) {
      if (begin) {
	::glEnd();
	begin = FALSE;
      }
    } else {
      const Vec2f& vertex = coordarray[coordIndex[i]];

      if (bColorPerVertex && pColor)
	if (bUseCI) {
	  const Color3f& col = colorarray[colorIndex[i]];
	  
              // SOLARIS PORTING - removed "::"
	      //::glColor3f(col.r, col.g, col.b);
	      glColor3f(col.r, col.g, col.b);
	} else {
	  const Color3f& col = colorarray[coordIndex[i]];
	    
              // SOLARIS PORTING - removed "::"
	      //::glColor3f(col.r, col.g, col.b);
	      glColor3f(col.r, col.g, col.b);
	}

      if (!begin) {
	::glBegin(GL_LINE_STRIP);

	if (!bColorPerVertex && pColor)
	  if (bUseCI) {
	    const Color3f& col = colorarray[colorIndex[currentColor++]];
	  
              // SOLARIS PORTING - removed "::"
	      //::glColor3f(col.r, col.g, col.b);
	      glColor3f(col.r, col.g, col.b);
	  } else {
	    const Color3f& col = colorarray[currentColor++];
	    
              // SOLARIS PORTING - removed "::"
	      //::glColor3f(col.r, col.g, col.b);
	      glColor3f(col.r, col.g, col.b);
	  }

	begin = TRUE;
      }
	    
        // SOLARIS PORTING - removed "::"
	//::glVertex2f(vertex.x, vertex.y);
	glVertex2f(vertex.x, vertex.y);
    }
  }
  	
  if (begin)
    ::glEnd();

}
