// This software module was originally developed by Kevin Barron (KPN Research), 
// Mike Coleman (Five Bats Research), Edward Cooke (Teltec Ireland), In-Dai Ha 
// (Hyundai Electronics Industries, Co.), Hae-Kwan Kim (Hyundai Electronics 
// Industries, Co.), Matthew Leditschke (CSELT), Zvi Lifshitz (VDOnet Corp.), 
// Karl Anders ygard (Telenor R&D), in the course of development of the MPEG-4 
// Systems standard (ISO/IEC 14496-1).  This software module is an 
// implementation of a part of one or more MPEG-4 Systems tools as specified by 
// the MPEG-4 Systems standard.  ISO/IEC gives users of the MPEG-4 Systems 
// standard free license to this software module or modifications thereof for 
// use in hardware or software products claiming conformance to the MPEG-4 
// Systems standard.  Those intending to use this software module in hardware or 
// software products are advised that its use may infringe existing patents.  
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use 
// of this software module or modifications thereof in an implementation.  
// Copyright is not released for non MPEG-4 Systems conforming products.  The 
// original developer retains full right to use the code for his/her own 
// purpose, assign or donate the code to a third party and to inhibit third 
// parties from using the code for non MPEG-4 Systems conforming products.  This 
// copyright notice must be included in all copies or derivative works.
//
// Copyright 1997.


#include "OpenGl/OpenGl.h"
#include "PointSet2DProxy.h"

// render object

/* virtual */ BOOL
PointSet2DProxy::Render(OpenGLVisualRenderer*, DWORD)
{
  // PointSet2D* pPointSet2D = (PointSet2D*) GetMediaObject();

  const Color* color = /* pPointSet2D-> */ GetColor();

  ::glPushAttrib(GL_ENABLE_BIT);

  ::glDisable(GL_LIGHTING);
  ::glDisable(GL_TEXTURE_2D);

  if (color)
    inlinedRenderLoop(color);
  else
    inlinedRenderLoop(NULL);
  
  ::glPopAttrib();

  return TRUE;
}

// traverse scene graph, checking for intersection

/* virtual */ BOOL
PointSet2DProxy::Select(
    OpenGLVisualRenderer*, 
    DWORD, 
    unsigned int& depth)
{
  GLuint selectBuffer[4];

  ::glSelectBuffer(4, selectBuffer);
  ::glRenderMode(GL_SELECT);

  inlinedRenderLoop(NULL);

  if (::glRenderMode(GL_RENDER) > 0)
    if (depth >= selectBuffer[1]) {
      depth = selectBuffer[1];

      return TRUE;
    }

  return FALSE;
}
