// -*- c++ -*-

// This software module was originally developed by Karl Anders ygard
// (Telenor R&D), in the course of development of the MPEG-4 Systems
// standard (ISO/IEC 14496-1).  This software module is an implementation
// of a part of one or more MPEG-4 Systems tools as specified by the MPEG-4
// Systems standard.  ISO/IEC gives users of the MPEG-4 Systems standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// Copyright 1997.

#ifndef __POINTSET2DPROXY_H__
#define __POINTSET2DPROXY_H__

#include "GeometryProxy.h"

class PointSet2D;
class Color;

/// Indexed pointset2D renderer node

class PointSet2DProxy
  : public GeometryProxy
{
public:

  /// Constructor

			PointSet2DProxy(PointSet2D* pPointSet2D);

  /// Render object

  virtual BOOL		Render(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Traverse scene graph, checking for intersection
  
  virtual BOOL		Select(
      OpenGLVisualRenderer* pRenderer, 
      DWORD dwTime, 
      unsigned int& depth);
  
private:
  
  // Render object
  
  void                  inlinedRenderLoop(const Color* pColor);
  
  // SB 98/12/04 moved from PointSet2D
public:
  inline PointSet2D * GetPointSet2d()
  { return (PointSet2D *) GetMediaObject(); }

//ML - removed this function
//  // Set coordinates
//  inline /* virtual */ void SetCoord(Coordinate2D* pCoord)
//  { GetPointSet2d()->coord = pCoord; }

  // Get coordinates
  inline Coordinate2D * GetCoord()
  { return GetPointSet2d()->coord; }

//ML - removed this function
//  // Set colors
//  inline /* virtual */ void SetColor(Color* pColor)
//  { GetPointSet2d()->color = pColor; }

  // Get colors
  // SOLARIS PORTING - To core version 5.9rc9 - Appropriate Typecast
  inline Color * GetColor()
  { return (Color*)(MediaObject*)( GetPointSet2d()->color); }

};

#include "PointSet2DProxy.i"

#endif // __POINTSET2DPROXY_H__
