// -*- c++ -*-

// This software module was originally developed by Karl Anders ygard
// (Telenor R&D) in the course of development of the MPEG-4 Systems
// standard (ISO/IEC 14496-1).  This software module is an implementation
// of a part of one or more MPEG-4 Systems tools as specified by the MPEG-4
// Systems standard.  ISO/IEC gives users of the MPEG-4 Systems standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// Copyright 1997.

#ifndef __POINTSETPROXY_H__
#define __POINTSETPROXY_H__

#include "GeometryProxy.h"

class PointSet;
class Color;

/// Indexed pointset renderer node

class PointSetProxy
  : public GeometryProxy
{
public:

  /// Constructor

			PointSetProxy(PointSet* pPointSet);

  /// Render object

  virtual BOOL		Render(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Traverse scene graph, checking for intersection

  virtual BOOL		Select(
      OpenGLVisualRenderer* pRenderer, 
      DWORD dwTime, 
      unsigned int& depth);

private:

  // render object

  void                  inlinedRenderLoop(const Color* pColor);

  // SB 98/12/04 moved from PointSet
public:
  PointSet * GetPointSet()
  { return (PointSet *) GetMediaObject(); }

//ML - removed this function
//  /// Set coordinates
//  inline /* virtual */ void SetCoord(Coordinate* pCoord)
//  { GetPointSet()->coord = pCoord; }

  /// Get coordinates
  inline Coordinate * GetCoord()
  { return GetPointSet()->coord; }

//ML - removed this function
//  /// Set colors
//  inline /* virtual */ void SetColor(Color* pColor)
//  { GetPointSet()->color = pColor; }

  /// Get colors
  // SOLARIS PORTING - To core version 5.9rc9 - Appropriate Typecast
  inline Color * GetColor()
  { return (Color*)(MediaObject*)(GetPointSet()->color); }
  
};

#include "PointSetProxy.i"

#endif // __POINTSETPROXY_H__
