// -*- c++ -*-

// This software module was originally developed by Karl Anders ygard
// (Telenor R&D) in the course of development of the MPEG-4 Systems
// standard (ISO/IEC 14496-1).  This software module is an implementation
// of a part of one or more MPEG-4 Systems tools as specified by the MPEG-4
// Systems standard.  ISO/IEC gives users of the MPEG-4 Systems standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// Copyright 1997.


// Constructor

inline
PointSetProxy::PointSetProxy(PointSet* pPointSet)
  : GeometryProxy(pPointSet)
{
}

// render object

/* This is the actual method that does the work.  It is inlined, thus
   removing most of the if statements. */

inline void
PointSetProxy::inlinedRenderLoop(const Color* pColor)
{
  // PointSet* pPointSet = (PointSet*) GetMediaObject();

  const Coordinate* coord = /* pPointSet-> */ GetCoord();

  const MF<Vec3f>& coordarray = coord->point /* GetPoint() */;
  const MF<Color3f>& colorarray = pColor->color /* GetColor() */;

  ::glBegin(GL_POINTS);

  for (int coords = coordarray.GetLength(); coords >= 0; --coords) {
    const Vec3f& vertex = coordarray[coords];

    if (pColor) {
      const Color3f& col = colorarray[coords];
      
      // SOLARIS PORTING - removed "::"
      //::glColor3f(col.r, col.g, col.b);
      glColor3f(col.r, col.g, col.b);
    }

    // SOLARIS PORTING - removed "::"
    //::glVertex3f(vertex.x, vertex.y, vertex.z);
    glVertex3f(vertex.x, vertex.y, vertex.z);
  }

  ::glEnd();
}
