// -*- c++ -*-

// This software module was originally developed by Karl Anders ygard
// (Telenor R&D) in the course of development of the MPEG-4 Systems
// standard (ISO/IEC 14496-1).  This software module is an implementation
// of a part of one or more MPEG-4 Systems tools as specified by the MPEG-4
// Systems standard.  ISO/IEC gives users of the MPEG-4 Systems standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// Copyright 1997.

#include "opengl/base/OpenGLVisualRenderer.h"


// Constructor

inline
SphereProxy::SphereProxy(Sphere* pSphere)
  : GeometryProxy(pSphere)
{
  m_pGluQuadric = ::gluNewQuadric();
}

// Destructor

inline
SphereProxy::~SphereProxy()
{
  ::gluDeleteQuadric(m_pGluQuadric);
}

// Render object

inline /* virtual */ BOOL
SphereProxy::Render(OpenGLVisualRenderer* pRenderer, DWORD)
{
  // Sphere* pSphere = (Sphere*) GetMediaObject();

  ::glPushAttrib(GL_POLYGON_BIT);

  ::glEnable(GL_CULL_FACE);

  if (pRenderer->GetCurrentTexture() != NULL)
    ::gluQuadricTexture(m_pGluQuadric, GL_TRUE);
  else
    ::gluQuadricTexture(m_pGluQuadric, GL_FALSE);

  ::gluSphere(m_pGluQuadric, /* pSphere-> */ GetRadius(), 16, 10);
  
  ::glPopAttrib();
  
  return TRUE;
}
