// -*- c++ -*-

// This software module was originally developed by Karl Anders ygard
// (Telenor R&D) in the course of development of the MPEG-4 Systems
// standard (ISO/IEC 14496-1).  This software module is an implementation
// of a part of one or more MPEG-4 Systems tools as specified by the MPEG-4
// Systems standard.  ISO/IEC gives users of the MPEG-4 Systems standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// Copyright 1998.

#ifndef __ANCHORPROXY_H__
#define __ANCHORPROXY_H__

#include "GroupProxy.h"

// SOLARIS PORTING - Commented the following header file
// WIN-SOL release
#ifdef WIN32
#include "mmi/NetObj.h"
#endif


class Anchor;

/// Anchor renderering node

class AnchorProxy
  : public GroupProxy
{
  // SB @@@@ moved from Anchor to Proxy >>>>
private:
  bool activated;
#if defined(WIN32) && !defined(BIFSENC)
  BOOL                  m_nMode;
  CNetObj             * m_pNetObj;
#endif
  // SB @@@@ moved from Anchor to Proxy <<<<

public:

  /// Constructor

  AnchorProxy(Anchor* pAnchor);

  /// Render object description

  virtual void		RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Activate sensor

  virtual bool Activate(
      OpenGLVisualRenderer* pRenderer,
			float fObjectX, 
      float fObjectY, 
      float fObjectZ,
			int nX, 
      int nY, 
      bool bMouseActivated);

  /// Deactivate sensor

  void			Deactivate(OpenGLVisualRenderer* pRenderer, BOOL bMouseActive);

  /// Trig sensor

  void			Trigger(OpenGLVisualRenderer* pRenderer);

  /// Return whether object is a pointing device sensor

  virtual BOOL          IsPointingDeviceSensor() const;

  // SB moved from Anchor to Proxy
public:
  Anchor * GetAnchor()
  { return (Anchor *) GetMediaObject(); }
  /// Activate object
  bool ActivateNode(bool bMouseActivated);
  /// Deactivate object
  void DeactivateNode(bool bMouseOver);
};

#include "AnchorProxy.i"

#endif // __ANCHORPROXY_H__
