// -*- c++ -*-

// This software module was originally developed by Edward Cooke (Teltec
// Ireland) in the course of development of the MPEG-4 Systems standard
// (ISO/IEC 14496-1).  This software module is an implementation of a part
// of one or more MPEG-4 Systems tools as specified by the MPEG-4 Systems
// standard.  ISO/IEC gives users of the MPEG-4 Systems standard free
// license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// Copyright 1998.

#ifndef __FORMPROXY_H__
#define __FORMPROXY_H__

// SB #### Carefull from Group2D to Group
// #include "Group2DProxy.h"
#include "GroupProxy.h"

// class Form;
//#include "Nodes.h"

/** Form renderering node.

    NOTE: this class has not yet been implemented. */

class FormProxy
  : public GroupProxy
{
public:
// static members
	static int AL;
  

  /// Constructor

			FormProxy(Form* pForm);

  /// Render object and its children

  virtual BOOL		Render(const Matrix& rTransformation, const CullFlag& rCullFlag,
			       OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Render object description

  virtual void		RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  // Stefano Battista
  // from Form to FormProxy
private:
  BOOL  rendered;
public:
  /// Get the pointer to the related Form object
  inline Form * GetForm() const
  { return (Form *) GetForm(); }
  /// Set size of form
  inline void SetSize(const SF<Vec2f>& rSize)
  { GetForm()->size = rSize; }
  /// Get size of form
  inline const SF<Vec2f>& GetSize() const
  { return GetForm()->size; }
  /// Get "childern" field from Form
  inline const MFNodeType<SF2DNode>& GetChildren() const
  { return GetForm()->children; }
  inline const MF<class ZString>& GetConstraintList() const
  { return GetForm()->constraints; }
  inline const MF<int>& GetGroupsList() const
  { return GetForm()->groups; }

#ifndef BIFSENC
  void  SetChildrenFormation();
#endif
  float MaxChildbbox( UINT x );
  float MinChildbbox( UINT x );
  /// Compute the information in the constraint list
  int ComputeConstraints(int constraintindex, float bboxvalue, int nSpace, UINT x, UINT positionmax);
  float ChildBBox(int childindex, UINT x, UINT positionmax);
  int AlignCenters(int constraintindex, UINT x, float cvalue);
  void PositionBBox(float bBoxOffset, int nSpace,
				     UINT nIndex, UINT x, UINT positionmax);

};

#include "FormProxy.i"

#endif // __FORMPROXY_H__
