// Stefano Battista 99/05/12

#ifndef __COLORINTERPOLATORPROXY_H__
#define __COLORINTERPOLATORPROXY_H__

#include "InterpolatorNodeProxy.h"

class ColorInterpolatorProxy :
public InterpolatorNodeProxy
{
public:
  ColorInterpolatorProxy(MediaObject * poNode);
public:
  BOOL SetValue(ColorInterpolator * poCI, int iIndex);
  BOOL InterpolateValue(int nMinIndex, int nMaxIndex, float fFraction);
  BOOL Evaluate();

private:
  static void RGBToHSV(
      float fR, float fG, float fB,
      float& rH, float& rS, float& rV);
  static void HSVToRGB(
      float fH, float fS, float fV,
      float& rR, float& rG, float& rB);
};

#endif // __COLORINTERPOLATORPROXY_H__
