/***********************************************************************
This software module was originally developed by James D. K. Kim
(Samsung) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Samsung retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact James D. K. Kim at jacobkim@sait.samsung.co.kr.
----------------------------------------------------------------------*/

#ifndef __COORDINATEINTERPOLATORPROXY_H__
#define __COORDINATEINTERPOLATORPROXY_H__

#include "..\AFX\CompressedInterpolatorProxy.h"

class CoordinateInterpolatorProxy :
public CompressedInterpolatorProxy
{
public:
  CoordinateInterpolatorProxy(MediaObject * poNode);
public:
  BOOL SetValue(CoordinateInterpolator * poCI, int iIndex);
  BOOL InterpolateValue(int nMinIndex, int nMaxIndex, float fFraction);
  BOOL Evaluate();

// SOWOO 20030714 begin
#if defined SAIT_CONFORMANCE_2003
  virtual BOOL RenderFromStream(MediaStream* poStream, int id, DWORD dwTime);
  virtual void RenderFromBuffer(SFString *buffer, int id);
	void Enable (unsigned char *pData);
#endif SAIT_CONFORMANCE_2003
// SOWOO 20030714 end
};

#endif // __COORDINATEINTERPOLATORPROXY_H__
