uniform sampler2D diff_scenemap;
uniform sampler2D basetexture;
uniform sampler2D spec_scenemap;
uniform sampler2D ambientlight;
uniform sampler2D depthmap_camera;
varying vec3 fog;
varying vec3 glFogCoord;
varying float ecPos;
varying vec4 color;

void main()
{
	// Nebelberechnung siehe: Orange Book p.226ff
	
	ecPos  = texture2D(depthmap_camera, vec2(gl_TexCoord[0]));
	gl_FogFragCoord = length(ecPos);
	
	/* Linearer Nebel */
	//fog = (gl_Fog.end - gl_FogFragCoord) * gl_Fog.scale;
	
	/* EXP Nebel */
	const float LOG2E = 1.442695;
	fog = exp2(-gl_Fog.end * gl_FogFragCoord * LOG2E);
	
	/* EXP hoch 2Nebel */
	//const float LOG2E = 1.442695;
	//fog = exp2(-gl_Fog.density * gl_Fog.density * gl_FogFragCoord * gl_FogFragCoord * LOG2E);
	
	fog = clamp(fog, 0.0, 1.0);
	
	// Texture Compositing siehe: Orange Book p.388ff
	
	color = ((texture2D(diff_scenemap, vec2(gl_TexCoord[0])) + texture2D(ambientlight, vec2(gl_TexCoord[0])))
			* texture2D(basetexture, vec2(gl_TexCoord[0])))+ texture2D(spec_scenemap, vec2(gl_TexCoord[0])) ;

	gl_FragColor = mix(vec4(gl_Fog.color), color, fog);
//	gl_FragColor = color;
}

