varying vec4 diffuse,ambient;
varying vec3 normal,lightDir;
uniform vec4 Material_diffuse;

void main()
{
	uniform vec4 Material_diffuse = (0.8,0.8,0.8,1.0);
	
	/* first transform the normal into eye space and
	normalize the result */

	normal = normalize(gl_NormalMatrix * gl_Normal);

	/* now normalize the light's direction. Note that
	according to the OpenGL specification, the light
	is stored in eye space. Also since we're talking about
	a directional light, the position field is actually direction */

	lightDir = normalize(vec3(gl_LightSource[0].position));

	/* Compute the diffuse, ambient and globalAmbient terms */

	diffuse = Material_diffuse * gl_LightSource[0].diffuse;
//	ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient;
//	ambient += gl_LightModel.ambient * gl_FrontMaterial.ambient;

	gl_Position = ftransform();
}