varying vec4 diffuse;
varying vec4 ambient;
varying vec3 normal;
varying vec3 lightDir;
varying float dist;

void main()
{	
	vec4 ecPos;
	vec3 aux;
	
	vec4 Material_diffuse = (1.0, 1.0, 1.0, 1.0);
	
	/* first transform the normal into eye space and normalize the result */
	normal = normalize(gl_NormalMatrix * gl_Normal);
	
	/* now normalize the light's direction. Note that according to the
	OpenGL specification, the light is stored in eye space. Also since 
	we're talking about a directional light, the position field is actually 
	direction */
	ecPos = gl_ModelViewMatrix * gl_Vertex;
	aux = vec3(vec3(gl_LightSource[0].position)-ecPos);
	lightDir = normalize(aux);
	
	/* compute the distance to the light source to a varying variable*/
	dist = length(aux);
	
	/* Compute the diffuse, ambient and globalAmbient terms */
	//ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient;
	ambient = (0.0, 0.0, 0.0, 0.01);
	diffuse = Material_diffuse * gl_LightSource[0].diffuse;
	
	gl_Position = ftransform();
} 
