varying vec4 diffuse;
varying vec4 ambient;
varying vec3 normal;
varying vec3 lightDir;
varying float dist;
uniform float radius;

void main()
{
	vec3 n;
	vec4 color = ambient;;
	float NdotL;
	float att;
	float spotEffect;

	/* a fragment shader can't write a varying variable, hence we need
	a new variable to store the normalized interpolated normal */
	
	n = normalize(normal);
	
	/* compute the dot product between normal and ldir */


	NdotL = max(dot(n,normalize(lightDir)),0.0);
	/*if (dist > radius){ NdotL = -1.0;}*/

	if (NdotL > 0.0) {
		spotEffect = dot(normalize(gl_LightSource[0].spotDirection),normalize(-lightDir));
		
		if (spotEffect > gl_LightSource[0].spotCosCutoff) {
			spotEffect = pow(spotEffect, gl_LightSource[0].spotExponent);
			att = spotEffect / (gl_LightSource[0].constantAttenuation +
					gl_LightSource[0].linearAttenuation * dist +
					gl_LightSource[0].quadraticAttenuation * dist * dist);
			
			color = att * (diffuse * NdotL + ambient);
		}
	}

	gl_FragColor = color;
}
