varying vec4 ambient;
varying vec3 normal;
varying vec3 lightDir;
varying vec3 halfVector;
varying float dist;
uniform float radius;


void main()
{
	//vec4 color = (0,0,0,0);
	vec4 color = ambient;
	vec3 n;
	vec3 halfV;
	float NdotL;
	float NdotHV;
	float att;
	float spotEffect;

	/* a fragment shader can't write a varying variable, hence we need
	a new variable to store the normalized interpolated normal */
	
	n = normalize(normal);
	
	/* compute the dot product between normal and ldir */

	NdotL = max(dot(n,normalize(lightDir)),0.0);
	if (dist > radius){ NdotL = -1.0;}

	if (NdotL > 0.0) {
		spotEffect = dot(normalize(gl_LightSource[0].spotDirection),normalize(-lightDir));
		
		if (spotEffect > gl_LightSource[0].spotCosCutoff) {
			spotEffect = pow(spotEffect, gl_LightSource[0].spotExponent);
			att = spotEffect / (gl_LightSource[0].constantAttenuation +
					gl_LightSource[0].linearAttenuation * dist +
					gl_LightSource[0].quadraticAttenuation * dist * dist);
	
			halfV = normalize(halfVector);
			NdotHV = max(dot(n,halfV),0.0);
		
			color = ambient + (att * gl_FrontMaterial.specular * 
				    gl_LightSource[0].specular * 
				    pow(NdotHV,gl_FrontMaterial.shininess));
		}
	}

	gl_FragColor = color;
}
