/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2002.
*/

///////////////////////////////////////////////////////////////////////////
// File:  AudioClipProxy.h
//
// Author: Jean Le Feuvre - ENST 2002
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef AUDIOCLIP_PROXY_H
#define AUDIOCLIP_PROXY_H

#include "Audible.h"
#include "TimedNode.h"

class AudioClipProxy : public AudibleNode, TimedNode
{
public:

	AudioClipProxy(MediaObject* pMO);
	~AudioClipProxy();


	// Functions inherited from the base class
	void Render(Effects *effects);
	virtual float GetIntensity();

	void UpdateTimeInfo();
	void OnUpdate();

	virtual BOOL IsMuted();
	virtual float GetSpeed();

private:
	void Activate();
	void Deactivate();
	BOOL IsLooping();

	double m_startTime, m_Speed, m_cycle;
	unsigned int m_RestartStatus, m_iNumLoop;
	BOOL m_bSetSpeed;
	BOOL m_bRegWithMC;
};

#endif // AUDIOCLIP_PROXY_H
