/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2002.
*/

///////////////////////////////////////////////////////////////////////////
// File:  Background2DProxy.h
//
// Author: Jean Le Feuvre ENST 2002
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef BACKGROUND2D_PROXY_H
#define BACKGROUND2D_PROXY_H

#include "DrawableImage.h"

class BindableStack; 


class BackgroundStatus
{
public:
	//static drawable context
	DrawableContext m_Context;
	//previous color (has to be stored per context since it invalidates the context)
	Color3f m_previousBackColor;
	BindableStack *m_pStack;
};

class Background2DProxy : public DrawableImage
{
public:
	Background2DProxy(MediaObject* pMO);
	~Background2DProxy();
    void DeleteObject(); 

	// Return a pointer to the Background2D node that this node is the proxy for
	Background2D* GetBackground2D() const { return (Background2D*)GetObject(); }

	// Functions inherited from the base classes
	void Render(Effects *effects);
	void Draw(DrawableContext *pDrawableContext);

	//return the context of this background in the desired stack
	DrawableContext *GetContext(BindableStack *stack);

	ZArray<BackgroundStatus *> m_Surfaces;

protected:
	virtual BOOL ShouldBuildBrush() {return TRUE; }
	
	// Private implementation details
private:
	//get context associated with the surface, register it if not found
	BackgroundStatus *GetStatus(Effects & effects);

	BOOL m_firstTime;

};


#endif // BACKGROUND2D_PROXY_H
