/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2002.
*/

///////////////////////////////////////////////////////////////////////////
// File:  Bindable.cpp
//
// Author: Jean Le Feuvre ENST 2002
//
// Description: Bindable stack object
//   
//
// Created: August, 2002.
//
///////////////////////////////////////////////////////////////////////////


#include "defs.h"
#include "Bindable.h"
	
BOOL BindableStack::AddBindable(BindableObject Bindable)
{
	int ret = m_List.Find(Bindable);
	if (ret>=0) return NULL;

	m_List += Bindable;
	return TRUE;
}

BOOL BindableStack::RemoveBindable(BindableObject Bindable)
{
	int ret = m_List.Find(Bindable);
	if (ret<0) return FALSE;
	m_List.DeleteFrom(ret);
	return TRUE;
}

BOOL BindableStack::MoveToTop(BindableObject Bindable)
{
	int ret = m_List.Find(Bindable);
	if (ret<0) return FALSE;
	if (ret==0) return TRUE;

	m_List.DeleteFrom(ret);
	m_List.InsertAt(0, Bindable);
	return TRUE;
}

BOOL BindableStack::RemoveFromTop(BindableObject Bindable)
{
	if (!m_List.GetLength() || (m_List[0] != Bindable)) return FALSE;
	if (m_List.GetLength() == 1) return TRUE;

	m_List.DeleteFrom(0);
	m_List += Bindable;
	return TRUE;
}
