//////////////////////////////////////////////////////////////////////////////
//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////
//
// File:  Bindable.h
//
// Author: Gianluca Di Cagno 
//
// Modified 
//			Jean Le Feuvre ENST 2002
// 
//
// Description:
//   
//
// Created: February, 2000.
//
//
///////////////////////////////////////////////////////////////////////////
#ifndef BINDABLE_H
#define BINDABLE_H

#include "defs.h"
#include "ztl.h"

typedef void * BindableObject ;

class BindableStack
{
public :
	BindableStack() {}

	ZArray<BindableObject> m_List;


	//to call when creating / deleting an object only
	BOOL AddBindable(BindableObject Bindable);
	BOOL RemoveBindable(BindableObject Bindable);

	BOOL MoveToTop(BindableObject Bindable);	
	BOOL RemoveFromTop(BindableObject Bindable);	
	
	BindableObject GetTop() {
		if (!m_List.GetLength()) return NULL;
		return m_List[0];
	}
	
	BOOL IsOnTop(BindableObject Bindable) {
		if (!Bindable ) return FALSE;
		return (Bindable == GetTop());
	}
	BOOL IsEmpty() {
		return !m_List.GetLength();
	}

};

#endif