/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2002.
*/

///////////////////////////////////////////////////////////////////////////
// File:  Curve2DProxy.h
//
// Author: Jean Le Feuvre
//
// Description:
//   Rendering of the Curve2D and XCurve2D nodes
//
// Created: august 2002.
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef CURVE2D_PROXY_H
#define CURVE2D_PROXY_H


#include "GeometryNode.h"


class Curve2DProxy : public GeometryNode
{
public:
	Curve2DProxy(MediaObject* pMO);
	~Curve2DProxy();

	// Return a pointer to the Coordinate2D object belonging to the
	// Curve2D node that this node is the proxy for.
	Coordinate2D* GetCoordinate2D() const;

	// Return a type belonging to the Curve2D node that this node is the proxy for.
	int GetType(int i) const;
	int GetNumTypes() const;
	float GetFineness() const;

	// Functions inherited from the base class
	virtual void Render(Effects *effects);
	virtual void Draw(DrawableContext * pContext);

	virtual void GetOriginalBounds(BRect &bounds);

	virtual void AddToClipper(VisualClipper *, DrawableContext *, BOOL bInside, BOOL bUseXOR = FALSE);

private:
	void BuildGraph(BOOL bFilled = TRUE);
};


#endif // CURVE2D_PROXY_H
