/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2002.
*/

///////////////////////////////////////////////////////////////////////////
// File:  EllipseProxy.h
//
// Author: Jean Le Feuvre ENST 2002
//
///////////////////////////////////////////////////////////////////////////


#ifndef ELLIPSEPROXY_H
#define ELLIPSEPROXY_H


#include "GeometryNode.h"


class EllipseProxy : public GeometryNode
{
public:
	EllipseProxy(MediaObject* pMO) : GeometryNode(pMO) {}

	// Return a pointer to the Circle node that this node is the proxy for
	// MSB 031223: changed EllipseNode to Ellipse
	class Ellipse *GetEllipse() const { return (class Ellipse *)GetObject(); }

	// Functions inherited from the base class
	void Render(Effects *effects);
	void Draw(DrawableContext *pDrawableContext);

	virtual void GetOriginalBounds(BRect &bounds);

	virtual void AddToClipper(VisualClipper *pClipper, DrawableContext *pContext, BOOL bInside, BOOL bUseXOR = FALSE);

private:
	void BuildGraph();
};


#endif // ELLIPSEPROXY_H
