/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2002.
*/

///////////////////////////////////////////////////////////////////////////
// File:  EmptyProxies.cpp
//
// Authors: Jean Le Feuvre ENST 2002
//			
// Modified:
//
// Description:
//   All "empty" proxies are defined here (nodes whose proxies do nothing..)
//
// Created: September, 2002.
//
//
///////////////////////////////////////////////////////////////////////////

#include "defs.h"
#include "Nodes-INIT.h"
#include "EmptyProxies.h"
#include "Presenter.h"

AppearanceProxy * Presenter::InitAppearance(Appearance* pObj)
{
	return (new AppearanceProxy(pObj));
}


ColorInterpolatorProxy* Presenter::InitColorInterpolator(ColorInterpolator* pObj)
{
	return (new ColorInterpolatorProxy(pObj));
}

Coordinate2DProxy* Presenter::InitCoordinate2D(Coordinate2D* pObj)
{
	return (new Coordinate2DProxy(pObj));
}

ConditionalProxy*Presenter::InitConditional(Conditional * pObj)
{
	return (new ConditionalProxy(pObj));
}

ColorProxy* Presenter::InitColor(Color* pObj)
{
	 return (new ColorProxy(pObj));
}

CoordinateInterpolator2DProxy* Presenter::InitCoordinateInterpolator2D(CoordinateInterpolator2D* pObj)
{
	return (new CoordinateInterpolator2DProxy(pObj));
}

FontStyleProxy* Presenter::InitFontStyle(FontStyle* pObj)
{
	return (new FontStyleProxy(pObj));
}

LinePropertiesProxy* Presenter::InitLineProperties(LineProperties* pObj)
{
	return new LinePropertiesProxy(pObj); 
}

Material2DProxy* Presenter::InitMaterial2D(Material2D* pObj)
{
	return new Material2DProxy(pObj);  
}

MaterialKeyProxy* Presenter::InitMaterialKey(MaterialKey* pObj)
{
	return new MaterialKeyProxy(pObj);  
}

PositionInterpolator2DProxy* Presenter::InitPositionInterpolator2D(PositionInterpolator2D* pObj)
{
	return new PositionInterpolator2DProxy(pObj);  
}

ScalarInterpolatorProxy* Presenter::InitScalarInterpolator(ScalarInterpolator* pObj)
{
	return new  ScalarInterpolatorProxy(pObj);
}

ScriptProxy* Presenter::InitScript(ScriptImp* pObj)
{
	return new ScriptProxy(pObj); 
}


TextureTransformProxy *Presenter::InitTextureTransform(TextureTransform *pObj)
{
	return (new TextureTransformProxy(pObj));
}

AdvancedFontStyleProxy* Presenter::InitAdvancedFontStyle(XFontStyle* pObj)
{
	return (new AdvancedFontStyleProxy(pObj));
}

XLinePropertiesProxy* Presenter::InitXLineProperties(XLineProperties* pObj)
{
	return new XLinePropertiesProxy(pObj); 
}
