/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2002.
*/

///////////////////////////////////////////////////////////////////////////
// File:  InlineProxy.cpp
//
// Author: Jean Le Feuvre ENST 2002
//
///////////////////////////////////////////////////////////////////////////

#include "defs.h"
#include "Nodes-INIT.h"
#include "InlineProxy.h"
#include "GroupProxy.h"
#include "Presenter.h"

InlineProxy* Presenter::InitInline(InlineImp* pObj)
{
	return new InlineProxy(pObj); 
}

void InlineProxy ::Render(Effects *effects )
{
	InlineImp *pInline = (InlineImp*) GetObject ();
	Root* pGroupNode = pInline->GetScene();
	if (!pGroupNode) return;
	MediaControlImp *pCtrl = pInline->GetObjectMediaControl();
	
	//if no mediaControl don't inspect the inline timeline, otherwise check for end of stream
	if (pCtrl && pInline->IsFinished()) {
		if ((Bool) pCtrl->loop) {
			pInline->GetExecutive()->AddInlineToRestart(pInline);
		} else {
			//if not looping stop the inline. If the content is "bad" some streams in the inline
			//may indeed be still running after the BIFS is signaled done
			//NB: we could skip this part but let's keep it if there is a mediaControl. Otherwise keep 
			//the inline running 
			if (m_bNeedsClose) {
				effects->m_isSwitchedOff = TRUE;
				((Traversable*)pGroupNode ->GetRenderingObject())->Render (effects);
				effects->m_isSwitchedOff = FALSE;
				m_bNeedsClose = FALSE;
			}
		}
		return;
	}
	m_bNeedsClose = TRUE;
	((Traversable*)pGroupNode ->GetRenderingObject())->Render (effects);
} 
