// MainFrm.cpp : implementation of the CMainFrame class
//

#include "defs.h"
#include "Osmose.h"

#include "MainFrm.h"
#include "ViewWorldInfo.h"
#include "EnterNetworkAddress.h"

#include "VisualRender-GDIP.h"
#include "bindable.h"
#include "ViewportProxy.h"

#include "DirectDraw.h"

#ifdef USE_DX_3
#pragma message("Using DirectDraw 3 - screen export disabled")
#endif


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

#define COM_VIEWPORT_BEGIN	(WM_USER + 100)
static int numViewports = 0;
#define MAX_VIEWPORTS	20

#define COM_YUV_BEGIN	(WM_USER + 200)


IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	ON_WM_CREATE()
	ON_COMMAND(ID_VIEW_STATUS_BAR, OnViewStatusBar)
	ON_WM_INITMENUPOPUP()
	ON_WM_SIZE()
	ON_WM_MOVE()

	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_SYSKEYDOWN()
	ON_WM_SYSKEYUP()
	ON_WM_CHAR()
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()

	ON_MESSAGE(WM_OPENFILE, OnOpen)
	ON_MESSAGE(WM_CONSOLEMSG, OnConsoleMessage)

	ON_CBN_SELENDOK(AFX_IDW_TOOLBAR + 1,OnNewAddress)
	ON_COMMAND(IDOK, OnNewAddressEnter)
	ON_MESSAGE(WM_DROPFILES, OnFileDroped)
	ON_MESSAGE(WM_SETSIZE,OnSetSize)
	ON_MESSAGE(WM_NAVIGATE,OnNavigate)
	ON_COMMAND(ID_FILE_CLOSE, OnFileClose)
	ON_UPDATE_COMMAND_UI(ID_FILE_CLOSE, OnUpdateFileClose)
	ON_COMMAND(ID_FILE_OPEN_NETWORK, OnFileOpenNetwork)
	ON_COMMAND(ID_OPTIONS_30FPS, OnOptions30fps)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_30FPS, OnUpdateOptions30fps)
	ON_COMMAND(ID_OPTIONS_25FPS, OnOptions25fps)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_25FPS, OnUpdateOptions25fps)
	ON_COMMAND(ID_OPTIONS_15FPS, OnOptions15fps)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_15FPS, OnUpdateOptions15fps)
	ON_COMMAND(ID_OPTIONS_10FPS, OnOptions10fps)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_10FPS, OnUpdateOptions10fps)
	ON_COMMAND(ID_OPTIONS_5FPS, OnOptions5fps)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_5FPS, OnUpdateOptions5fps)
	ON_COMMAND(ID_VIEW_WORLD_INFO, OnViewWorldInfo)
	ON_COMMAND(ID_VIEW_ORIGINAL, OnViewOriginal)
	ON_COMMAND(ID_VIEW_TIMING, OnViewTiming)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TIMING, OnUpdateViewTiming)
	ON_COMMAND(ID_VIEW_WIREFRAME, OnViewWireframe)
	ON_UPDATE_COMMAND_UI(ID_VIEW_WIREFRAME, OnUpdateViewWireframe)
	ON_COMMAND(ID_RENDER_DIRECT, OnRenderDirect)
	ON_UPDATE_COMMAND_UI(ID_RENDER_DIRECT, OnUpdateRenderDirect)
	ON_COMMAND(ID_RENDER_INDIRECT, OnRenderIndirect)
	ON_UPDATE_COMMAND_UI(ID_RENDER_INDIRECT, OnUpdateRenderIndirect)
	ON_COMMAND(ID_RENDER_BOTH, OnRenderBoth)
	ON_UPDATE_COMMAND_UI(ID_RENDER_BOTH, OnUpdateRenderBoth)	

	ON_COMMAND(ID_RENDER_SPLITREDRAW, OnSplitTracking)
	ON_UPDATE_COMMAND_UI(ID_RENDER_SPLITREDRAW, OnUpdateSplitTracking)	

	ON_COMMAND(ID_VIEW_FULLSCREEN, OnViewFullScreen)
	ON_UPDATE_COMMAND_UI(ID_VIEW_FULLSCREEN, OnUpdateViewFullScreen)

	ON_COMMAND(ID_FILE_RESTART, OnFileRestart)
	ON_UPDATE_COMMAND_UI(ID_FILE_RESTART, OnUpdateFileRestart)
	ON_COMMAND(ID_FILE_PAUSE, OnFilePause)
	ON_UPDATE_COMMAND_UI(ID_FILE_PAUSE, OnUpdateFilePause)
	ON_COMMAND(ID_FILE_STEP, OnFileStep)
	ON_UPDATE_COMMAND_UI(ID_FILE_STEP, OnUpdateFileStep)


	ON_COMMAND(ID_OPTIONS_CLEAR_ON_END, OnOptionsClearOnEnd)
	ON_COMMAND(ID_OPTIONS_USECURSORS, OnOptionsCustomCursors)
	ON_COMMAND(ID_OPTIONS_RENDER_FAST, OnOptionsRenderFast)
	ON_COMMAND(ID_OPTIONS_RENDER_ZOOM, OnOptionsRenderZoom)
	ON_COMMAND(ID_OPTIONS_RENDER_RATIO, OnOptionsRenderRatio)
	ON_COMMAND(ID_OPTIONS_RENDER_ANTIALIAS, OnOptionsRenderAntialias)
	ON_COMMAND(ID_OPTIONS_RENDER_TEXTANTIALIAS, OnOptionsRenderTextAntialias)

	ON_COMMAND(ID_FILE_SHOT, OnFileScreenshot)
	ON_UPDATE_COMMAND_UI(ID_FILE_SHOT, OnUpdateFileScreenshot)
	ON_COMMAND(ID_FILE_CAPTURE, OnFileCapture)
	ON_UPDATE_COMMAND_UI(ID_FILE_CAPTURE, OnUpdateFileCapture)

	ON_COMMAND(ID_OPTIONS_YUV, OnOptionsYUV)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_YUV, OnUpdateOptionsYUV)

	ON_UPDATE_COMMAND_UI(ID_OPTIONS_CLEAR_ON_END, OnUpdateOptionsClearOnEnd)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_USECURSORS, OnUpdateOptionsCustomCursors)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_RENDER_FAST, OnUpdateOptionsRenderFast)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_RENDER_ZOOM, OnUpdateOptionsRenderZoom)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_RENDER_RATIO, OnUpdateOptionsRenderRatio)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_RENDER_ANTIALIAS, OnUpdateOptionsRenderAntialias)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_RENDER_TEXTANTIALIAS, OnUpdateOptionsRenderTextAntialias)
	ON_COMMAND(ID_FILE_OPENFILE, OnFileOpenfile)

	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_TIMERVIEW,
	ID_FPSVIEW,
	ID_SEPARATOR,           // status line indicator
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	m_bOpened = FALSE;	
	m_bIsCapturing = FALSE;
	m_bFullScreen = FALSE;
	numFormats = 0;
	m_ConsoleTimerID = 0;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// create a view to occupy the client area of the frame
	if (!m_wndView.CreateEx(0, NULL, NULL, WS_POPUP | WS_VISIBLE, 0, 0, 300, 200, m_hWnd, NULL, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndStatusBar.SetPaneInfo(0, ID_TIMERVIEW, SBPS_NORMAL, 45);
	m_wndStatusBar.SetPaneInfo(1, ID_FPSVIEW, SBPS_NORMAL, 45);
	m_wndStatusBar.SetPaneInfo(2, ID_SEPARATOR, SBPS_STRETCH, 0);

	SetIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME), TRUE);
	SetIcon(AfxGetApp()->LoadIcon(IDI_MAINICO), FALSE);

	SetWindowPos(NULL, 100, 100, 0, 0, SWP_NOSIZE);

	m_hError = AfxGetApp()->LoadIcon(IDI_ICO_ERROR);
	m_hMessage = AfxGetApp()->LoadIcon(IDI_ICO_MESSAGE);
	

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// let the view have first crack at the command
	if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}



void CMainFrame::SetSize(UINT width, UINT height)
{
	// Determine how large to make the window to fit in the required
	// client area
	RECT winRect;
	winRect.left = 0;
	winRect.right = width;
	winRect.top = 0;
	winRect.bottom = height;
	AdjustWindowRectEx(&winRect, GetStyle(), TRUE, GetExStyle());
	winRect.bottom -= winRect.top;
	winRect.right -= winRect.left;

	RECT barRect;
	CControlBar* pBar = GetControlBar(ID_VIEW_STATUS_BAR);
	if (pBar != NULL) {
		pBar->GetClientRect(&barRect);
		winRect.bottom += barRect.bottom;
	}
	SetWindowPos(NULL, 0, 0, winRect.right, winRect.bottom, SWP_NOMOVE | SWP_NOZORDER | SWP_SHOWWINDOW);
}


// These functions keep the client area the same size when the toolbar
// and status bar are toggled on and off.
void CMainFrame::AdjustWindowSize(UINT nID)
{
	CFrameWnd::OnBarCheck(nID);

	// Get the height of the toolbar
	CControlBar* pBar = GetControlBar(nID);
	if (pBar != NULL)
	{
		// Get the dimensions of the toolbar
		RECT toolbarRect;
		pBar->GetClientRect(&toolbarRect);

		// Get the dimensions of the window
		RECT winRect;
		GetWindowRect(&winRect);
		winRect.right -= winRect.left;
		winRect.bottom -= winRect.top;

		// Change the size of the window to keep the active area the same
		if (pBar->GetStyle() & WS_VISIBLE)
			winRect.bottom += toolbarRect.bottom;
		else
			winRect.bottom -= toolbarRect.bottom;

		SetWindowPos(NULL, NULL, NULL, winRect.right, winRect.bottom,
					 SWP_NOMOVE | SWP_NOZORDER | SWP_SHOWWINDOW);
	}
}

void CMainFrame::OnViewStatusBar() 
{
	AdjustWindowSize(ID_VIEW_STATUS_BAR);
}

/////////////////////////////////////////////////////

void CMainFrame::OnSize(UINT nType, int cx, int cy) 
{

	CFrameWnd::OnSize(nType, cx, cy);
	
	CControlBar* pBar = GetControlBar(ID_VIEW_STATUS_BAR);
	if (pBar) {
		RECT rc;
		pBar->GetClientRect(&rc);
		cy -= rc.bottom - rc.top;
	}
	m_wndView.SetWindowPos(this, 0, 0, cx, cy, SWP_NOMOVE);
	
	//resize direct draw surface
	Executive *pExecutive = GetApp()->GetExecutive();
	if (pExecutive!=NULL) {
		(((Presenter*)pExecutive->GetPresenter()))->AskScreenAccess();
		((Presenter*)pExecutive->GetPresenter())->GetVisualRenderer()->UpdateScreenSizeInfo();
		((Presenter*)pExecutive->GetPresenter())->ReleaseScreenAccess();
	}

	SetActiveWindow();
	SetFocus();

}

void CMainFrame::OnMove(int x, int y)
{
	RECT rc;
	m_wndView.GetClientRect(&rc);
	m_wndView.SetWindowPos(this, x, y, 0, 0, SWP_NOSIZE);

	CControlBar* pBar = GetControlBar(ID_VIEW_STATUS_BAR);
	pBar->SetWindowPos(this, x, y+rc.bottom, 0, 0, SWP_NOSIZE);
}

void CMainFrame::ForwardMessage()
{
	const MSG *msg = GetCurrentMessage();
	m_wndView.SendMessage(msg->message, msg->wParam, msg->lParam);
}

void CMainFrame::OnSysKeyUp(UINT , UINT , UINT )
{
	ForwardMessage();
}
void CMainFrame::OnSysKeyDown(UINT , UINT , UINT )
{
	ForwardMessage();
}
void CMainFrame::OnChar(UINT , UINT , UINT )
{
	ForwardMessage();
}
void CMainFrame::OnKeyDown(UINT , UINT , UINT )
{
	ForwardMessage();
}
void CMainFrame::OnKeyUp(UINT , UINT , UINT )
{
	ForwardMessage();
}
void CMainFrame::OnLButtonDown(UINT , CPoint ) 
{
	ForwardMessage();
}
void CMainFrame::OnLButtonDblClk(UINT , CPoint ) 
{
	ForwardMessage();
}
void CMainFrame::OnLButtonUp(UINT , CPoint ) 
{
	ForwardMessage();
}



void CMainFrame::OnNewAddressEnter()
{
	// gets called when an item is entered manually into the edit box portion
	// of the Address combo box.
	// navigate to the newly selected location and also add this address to the
	// list of addresses in the combo box.
}

void CMainFrame::OnNewAddress()
{
	// gets called when an item in the Address combo box is selected
	// just navigate to the newly selected location.
}
void CMainFrame::OnSetSize(WPARAM /*wParam*/, LPARAM lParam)
{
	SetSize(LOWORD (lParam),HIWORD( lParam));
}

void CMainFrame::OnNavigate(WPARAM /*wParam*/, LPARAM lParam)
{
	//quick analyse of URL
	if (strstr((LPCSTR) lParam, ".mp4")) {
		char _str[MAX_PATH];
		LPCSTR st = (LPCSTR) lParam;
		//no absolute URL
		if (!strstr(st, "://") && !strstr(st, "/") && !strstr(st, "\\") ) {
			CString _last = GetPath();
			int res = _last.ReverseFind('\\');
			_last.SetAt(res+1, 0);
			strcpy(_str, (LPCSTR) _last);
			strcat(_str, st);
		} else {
			strcpy(_str, (LPCSTR) lParam);
		}
		ClosePresentation();
		OpenPresentation(_str);
		SetWindowText(_str);
	} else {
		sprintf(GetApp()->m_szConsole, "%s", (LPCSTR) lParam);
		GetApp()->m_MessageType = 1;
		PostMessage(WM_CONSOLEMSG);
		ShellExecute(NULL, "open", (LPCSTR) lParam, NULL, NULL, SW_SHOWNORMAL);
	}
}


void CMainFrame::OnFileDroped(WPARAM wParam, LPARAM /*lParam*/)
{
	char fileName[MAX_PATH];
	CString name;
	HDROP hDropInfo = (HDROP)wParam;

	GetMainFrame()->ClosePresentation();
	::DragQueryFile (hDropInfo, 0, fileName, MAX_PATH);
	name = fileName;
	Sleep(200);
	OpenPresentation(name);
}

void CMainFrame::OpenPresentation(CString name)
{
	// Close the current file - if one is open
	if (m_bOpened) ClosePresentation();
	if (name.GetLength()) m_CurrentPath = name;
	if (!m_CurrentPath) return;

	char *fileName = strrchr((LPCSTR) name, '\\');
	if (!fileName) fileName = strrchr((LPCSTR) name, '/');
	if (fileName) 
		m_CurrentName = fileName+1;
	else
		m_CurrentName = name;

	GetApp()->GetExecutive()->Start(m_CurrentPath);
}


void CMainFrame::ClosePresentation() 
{
	// Only proceed if  a file is actually open
	if (m_bOpened) {
		// Stop the executive running this session
		GetApp()->GetExecutive()->Stop();
		m_bOpened = FALSE;

		// Wait for the application to be notified that the file has been closed
		GetApp()->m_smpFileOpen.P();
		GetApp()->m_smpFileOpen.V();
	}
	SetWindowText("Osmo4");
	m_bIsPaused = FALSE;
}

void CMainFrame::OnFileRestart() 
{
	// Only proceed if there is a previous file to restart
	if (!m_CurrentPath.IsEmpty()) {
		ClosePresentation();
		Sleep(200);
		OpenPresentation(m_CurrentPath);
	}
}

void CMainFrame::OnUpdateFileRestart(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bOpened);
}



void CMainFrame::OnFilePause() 
{
	// Only proceed if there is a previous file to restart
	if (m_CurrentPath.IsEmpty()) return;

	if (m_bIsPaused) {
		GetPresenter()->Resume();
		m_bIsPaused = FALSE;
	} else {
		GetPresenter()->Pause();
		m_bIsPaused = TRUE;
	}
}

void CMainFrame::OnUpdateFilePause(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bOpened);
	if (m_bIsPaused) {
		pCmdUI->SetText("Resume\tCtrl+P");
	} else {
		pCmdUI->SetText("Pause\tCtrl+P");
	}
}

void CMainFrame::OnFileStep() 
{
	// Only proceed if there is a previous file to restart
	if (m_CurrentPath.IsEmpty()) return;

	GetPresenter()->Step();
	m_bIsPaused = TRUE;
}

void CMainFrame::OnUpdateFileStep(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bOpened);
}

void CMainFrame::OnFileClose() 
{
	ClosePresentation();
}

void CMainFrame::OnUpdateFileClose(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bOpened);
}

void CMainFrame::OnFileOpenNetwork() 
{
	ClosePresentation();

	CEnterNetworkAddress dialog;
	int result = dialog.DoModal();
	
	if (result == IDOK) {
		char *pAddress = (char *) dialog.GetNetworkAddress();
		OpenPresentation(pAddress);
	}
}



void CMainFrame::OnOptions30fps() 
{
	GetPresenter()->SetTargetFrameRate(30);
}

void CMainFrame::OnUpdateOptions30fps(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((int)GetPresenter()->GetTargetFrameRate() == 30);
}
void CMainFrame::OnOptions25fps() 
{
	GetPresenter()->SetTargetFrameRate(25);
}

void CMainFrame::OnUpdateOptions25fps(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((int) GetPresenter()->GetTargetFrameRate() == 25);
}

void CMainFrame::OnOptions15fps() 
{
	GetPresenter()->SetTargetFrameRate(15);
}

void CMainFrame::OnUpdateOptions15fps(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((int)GetPresenter()->GetTargetFrameRate() == 15);
}

void CMainFrame::OnOptions10fps() 
{
	GetPresenter()->SetTargetFrameRate(10);
}

void CMainFrame::OnUpdateOptions10fps(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((int)GetPresenter()->GetTargetFrameRate() == 10);
}

void CMainFrame::OnOptions5fps() 
{
	GetPresenter()->SetTargetFrameRate(5);
}

void CMainFrame::OnUpdateOptions5fps(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((int)GetPresenter()->GetTargetFrameRate() == 5);
}



void CMainFrame::OnRenderDirect() 
{
	GetApp()->m_VideoMode = 0;
	AfxGetApp()->WriteProfileInt("Options", "VideoMode", GetApp()->m_VideoMode);
	GetPresenter()->SetVideoRenderMode(GetApp()->m_VideoMode);
}
void CMainFrame::OnUpdateRenderDirect(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetApp()->m_VideoMode == 0);
}

void CMainFrame::OnRenderIndirect() 
{
	GetApp()->m_VideoMode = 1;
	AfxGetApp()->WriteProfileInt("Options", "VideoMode", GetApp()->m_VideoMode);
	GetPresenter()->SetVideoRenderMode(GetApp()->m_VideoMode);
}
void CMainFrame::OnUpdateRenderIndirect(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetApp()->m_VideoMode == 1);
}

void CMainFrame::OnRenderBoth() 
{
	GetApp()->m_VideoMode = 2;
	AfxGetApp()->WriteProfileInt("Options", "VideoMode", GetApp()->m_VideoMode);
	GetPresenter()->SetVideoRenderMode(GetApp()->m_VideoMode);
}
void CMainFrame::OnUpdateRenderBoth(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetApp()->m_VideoMode == 2);
}

void CMainFrame::OnOptionsClearOnEnd() 
{
	GetApp()->m_clearOnEnd = ! GetApp()->m_clearOnEnd;

	// Update this change in the .INI file
	AfxGetApp()->WriteProfileInt("Options", "ClearOnEnd", GetApp()->m_clearOnEnd);
   	GetPresenter()->GetVisualRenderer()->SetRenderingOption(VIDEO_FLAG_CLEARONEND, GetApp()->m_clearOnEnd);
}

void CMainFrame::OnUpdateOptionsClearOnEnd(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetApp()->m_clearOnEnd);
}

void CMainFrame::OnOptionsCustomCursors() 
{
	GetApp()->m_bUseCursors =! GetApp()->m_bUseCursors;
	AfxGetApp()->WriteProfileInt("Options", "CustomCursors", GetApp()->m_bUseCursors);
}

void CMainFrame::OnUpdateOptionsCustomCursors(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetApp()->m_bUseCursors);
}

void CMainFrame::OnOptionsRenderFast() 
{
	GetApp()->m_bFastSpeed = ! GetApp()->m_bFastSpeed;
	AfxGetApp()->WriteProfileInt("Options", "FastSpeed", GetApp()->m_bFastSpeed);
	GetPresenter()->GetVisualRenderer()->SetRenderingOption(VIDEO_FLAG_HIGHSPEED, GetApp()->m_bFastSpeed);
}

void CMainFrame::OnUpdateOptionsRenderFast(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetApp()->m_bFastSpeed);
}

void CMainFrame::OnOptionsRenderAntialias() 
{
	GetApp()->m_bAntiAlias = ! GetApp()->m_bAntiAlias;
	AfxGetApp()->WriteProfileInt("Options", "AntiAlias", GetApp()->m_bAntiAlias);

	GetPresenter()->GetVisualRenderer()->SetRenderingOption(VIDEO_FLAG_ANTIALIAS, GetApp()->m_bAntiAlias);
}
void CMainFrame::OnUpdateOptionsRenderAntialias(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetApp()->m_bAntiAlias);
}

void CMainFrame::OnOptionsRenderTextAntialias() 
{
	GetApp()->m_bTextAntiAlias = ! GetApp()->m_bTextAntiAlias;
	AfxGetApp()->WriteProfileInt("Options", "TextAntiAlias", GetApp()->m_bTextAntiAlias);

	GetPresenter()->GetVisualRenderer()->SetRenderingOption(VIDEO_FLAG_TEXTANTIALIAS, GetApp()->m_bTextAntiAlias);
}
void CMainFrame::OnUpdateOptionsRenderTextAntialias(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetApp()->m_bTextAntiAlias);
}


void CMainFrame::OnOptionsRenderZoom() 
{
	GetApp()->m_bZoom = ! GetApp()->m_bZoom;
	AfxGetApp()->WriteProfileInt("Options", "Zoom", GetApp()->m_bZoom);

	GetPresenter()->GetVisualRenderer()->SetRenderingOption(VIDEO_FLAG_SCALABLEZOOM, GetApp()->m_bZoom);
}
void CMainFrame::OnUpdateOptionsRenderZoom(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetApp()->m_bZoom);
}

void CMainFrame::OnOptionsRenderRatio() 
{
	GetApp()->m_bRatio = ! GetApp()->m_bRatio;
	AfxGetApp()->WriteProfileInt("Options", "KeepRatio", GetApp()->m_bRatio);

	GetPresenter()->GetVisualRenderer()->SetRenderingOption(VIDEO_FLAG_KEEPRATIO, GetApp()->m_bRatio);
}

void CMainFrame::OnUpdateOptionsRenderRatio(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetApp()->m_bRatio);
}


void CMainFrame::OnSplitTracking()
{
	GetApp()->m_bSplitTracking = ! GetApp()->m_bSplitTracking;
	AfxGetApp()->WriteProfileInt("Options", "SplitTracking", GetApp()->m_bSplitTracking);
	GetPresenter()->SetBoundsTrackingMode(GetApp()->m_bSplitTracking);
}

void CMainFrame::OnUpdateSplitTracking(CCmdUI* pCmdUI)
{
	if (!GetApp()->m_VideoMode) {
		pCmdUI->SetCheck(FALSE);
		pCmdUI->Enable(FALSE);
	} else {
		pCmdUI->Enable(TRUE);
		pCmdUI->SetCheck(GetApp()->m_bSplitTracking);
	}
}

void CMainFrame::OnViewWorldInfo() 
{
	CViewWorldInfo dialog;
	dialog.DoModal();
} 

void CMainFrame::OnViewOriginal() 
{
	m_wndView.curZoom = 1.0;
	GetPresenter()->ResetTranslation();
	GetPresenter()->SetZoom(1.0);
	GetPresenter()->GetVisualRenderer()->SetRenderingOption(VIDEO_FLAG_RESTOREASPECT, 0);
}

void CMainFrame::OnViewTiming()
{
	GetApp()->m_bShowTiming = !GetApp()->m_bShowTiming;
	AfxGetApp()->WriteProfileInt("Options", "Timing", GetApp()->m_bShowTiming);
}
void CMainFrame::OnUpdateViewTiming(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(GetApp()->m_bShowTiming);
}

void CMainFrame::OnViewWireframe() 
{
	GetApp()->m_bWireframe = ! GetApp()->m_bWireframe;
	AfxGetApp()->WriteProfileInt("Options", "Wireframe", GetApp()->m_bWireframe);

	GetPresenter()->GetVisualRenderer()->SetRenderingOption(VIDEO_FLAG_NOFILL, GetApp()->m_bWireframe);
}

void CMainFrame::OnUpdateViewWireframe(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetApp()->m_bWireframe);
}

void CMainFrame::OnFileScreenshot()
{
	char BASED_CODE szFilter[] = "All Image files (*.png;*.jpg;*.bmp)|*.png;*.jpg;*.bmp||";
	CFileDialog fd(FALSE,NULL,NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,szFilter);

	if (fd.DoModal()!=IDOK) return;

	GetPresenter()->GetVisualRenderer()->Screenshot((const char *)fd.GetPathName(), VIDEO_CAPTURE_SHOT);
}

void CMainFrame::OnUpdateFileScreenshot(CCmdUI* pCmdUI)
{
#ifdef USE_DX_3
	pCmdUI->Enable(FALSE);
#else
	pCmdUI->Enable(m_bOpened);
#endif
}


void CMainFrame::OnFileCapture()
{
	if (!m_bIsCapturing) {
		char BASED_CODE szFilter[] = "All Image files (*.png;*.jpg;*.bmp)|*.png;*.jpg;*.bmp||";
		CFileDialog fd(FALSE,NULL,NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,szFilter);
		if (fd.DoModal()!=IDOK) return;
		GetPresenter()->GetVisualRenderer()->Screenshot((const char *)fd.GetPathName(), VIDEO_CAPTURE_START);
	} else {
		GetPresenter()->GetVisualRenderer()->Screenshot(NULL, VIDEO_CAPTURE_STOP);
	}
	m_bIsCapturing = !m_bIsCapturing;
}

void CMainFrame::OnUpdateFileCapture(CCmdUI* pCmdUI)
{
#ifdef USE_DX_3
	pCmdUI->Enable(FALSE);
#else
	pCmdUI->Enable(TRUE);
	pCmdUI->SetText(m_bIsCapturing ? "Stop Capture" : "Start Capture");
#endif
}


void CMainFrame::OnFileOpenfile() 
{
	// TODO: Add your command handler code here
	char BASED_CODE szFilter[] = "Mpeg4 file formats (*.mp4;*.trif)|*.mp4;*.trif|All files (*.*)|*.*||";
	CFileDialog fd(TRUE,NULL,NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,szFilter);

	if (fd.DoModal()==IDOK)
		OpenPresentation(fd.GetPathName()); 
}

void CMainFrame::BuildViewportList()
{
	Presenter *pPres = GetPresenter();
	BindableStack *pStack = pPres->GetVisualRenderer()->GetViewportStack();
	if (!pStack || pStack->IsEmpty()) return;

	//THIS IS HARCODED FROM THE MENU LAYOUT - DON'T CHANGE
	CMenu *pMenu = GetMenu()->GetSubMenu(1)->GetSubMenu(0);
	
	//reset
	while (pMenu->GetMenuItemCount())
		pMenu->DeleteMenu(0, MF_BYPOSITION);

	int id = COM_VIEWPORT_BEGIN;
	ViewportProxy *pVP;
	numViewports = pStack->m_List.GetLength();
	for (int i=0; i<numViewports; i++) {
		pVP = (ViewportProxy *) pStack->m_List[i];
		pMenu->AppendMenu(MF_ENABLED, id+i, pVP->GetViewport()->description);
	}
}

void CMainFrame::BuildYUVList()
{
	VisualRendererGDI *pVR = (VisualRendererGDI *)GetPresenter()->GetVisualRenderer();

	//THIS IS HARCODED FROM THE MENU LAYOUT - DON'T CHANGE
	CMenu *pMenu = GetMenu()->GetSubMenu(2)->GetSubMenu(9);
	
	//reset
	while (pMenu->GetMenuItemCount())
		pMenu->DeleteMenu(0, MF_BYPOSITION);

	pMenu->AppendMenu(MF_ENABLED, ID_OPTIONS_YUV, "Enable Acceleration");
	pMenu->AppendMenu(MF_SEPARATOR, 0, "");

	int format;

	for (int i=0; i<pVR->m_pDirectDraw->m_numFormats; i++) {
		format = pVR->m_pDirectDraw->m_Formats[i];
		format_names[i][0] = format & 0xFF;
		format_names[i][1] = (format>>8) & 0xFF;
		format_names[i][2] = (format>>16) & 0xFF;
		format_names[i][3] = (format>>24) & 0xFF;
		format_names[i][4] = 0;
		pMenu->AppendMenu(MF_ENABLED, COM_YUV_BEGIN+i, (const char *) format_names[i]);
	}
	numFormats = pVR->m_pDirectDraw->m_numFormats;
}

void CMainFrame::OnInitMenuPopup(CMenu* pPopupMenu, UINT ID, BOOL bSys)
{
	/*viewport list*/
	CMenu *pMenu = GetMenu()->GetSubMenu(1)->GetSubMenu(0);
	if (pMenu->m_hMenu == pPopupMenu->m_hMenu) {
		Presenter *pPres = GetPresenter();
		BindableStack *pStack = pPres->GetVisualRenderer()->GetViewportStack();
		if (!pStack || pStack->IsEmpty()) 
			return;

		ViewportProxy *pVP;
		numViewports = pStack->m_List.GetLength();
		for (int i=0; i<numViewports; i++) {
			pVP = (ViewportProxy *) pStack->m_List[i];
			if (!i) {
				if ( (BOOL) (Bool) pVP->GetViewport()->isBound) {
					if (numViewports==1) 
						pMenu->EnableMenuItem(i, MF_BYPOSITION);
					pMenu->CheckMenuItem(i, MF_BYPOSITION | MF_CHECKED);
				} else {
					pMenu->EnableMenuItem(i, MF_BYPOSITION);
				}
			} else {
				pMenu->EnableMenuItem(i, MF_BYPOSITION);		
			}
		}
		return;
	} 
	/*YUV list*/
	pMenu = GetMenu()->GetSubMenu(2)->GetSubMenu(9);
	if (pMenu->m_hMenu == pPopupMenu->m_hMenu) {
		VisualRendererGDI *pVR = (VisualRendererGDI *)GetPresenter()->GetVisualRenderer();
		BOOL useYUV = GetApp()->m_bUseYUVHW;

		int format;
		pVR->GetRenderingOption(VIDEO_FLAG_YUV, format);

		if (useYUV) {
			if (!format) {
				pMenu->ModifyMenu(0, MF_BYPOSITION, ID_OPTIONS_YUV, "Enabled (not active)");
			} else {
				pMenu->ModifyMenu(0, MF_BYPOSITION, ID_OPTIONS_YUV, "Enabled");
			}
			pMenu->CheckMenuItem(0, MF_BYPOSITION | MF_CHECKED);
		} else if (pVR->m_pDirectDraw->m_numFormats) {
			pMenu->ModifyMenu(0, MF_BYPOSITION, ID_OPTIONS_YUV, "Enable Acceleration");
			pMenu->CheckMenuItem(0, MF_BYPOSITION);
		} else {
			pMenu->ModifyMenu(0, MF_BYPOSITION, ID_OPTIONS_YUV, "No YUV hardware available");
			pMenu->EnableMenuItem(0, MF_BYPOSITION | MF_DISABLED | MF_UNCHECKED);
		}
		
		pVR->GetRenderingOption(VIDEO_FLAG_YUV_FORMAT, format);

		for (int i=0; i<pVR->m_pDirectDraw->m_numFormats; i++) {
			if (useYUV) {
				pMenu->EnableMenuItem(i+2, MF_BYPOSITION);
				if ((DWORD) format== pVR->m_pDirectDraw->m_Formats[i]) {
					pMenu->CheckMenuItem(i+2, MF_BYPOSITION | MF_CHECKED);
				} else {
					pMenu->CheckMenuItem(i+2, MF_BYPOSITION | MF_UNCHECKED);
				}
			} else {
				pMenu->EnableMenuItem(i+2, MF_BYPOSITION | MF_GRAYED | MF_UNCHECKED);
			}
		}
		return;
	}
	/*default*/
	CFrameWnd::OnInitMenuPopup(pPopupMenu, ID, bSys);
}

BOOL CMainFrame::OnCommand(WPARAM wParam, LPARAM lParam)
{
	int ID = LOWORD(wParam);

	if ( (ID>=COM_VIEWPORT_BEGIN) && (ID<COM_VIEWPORT_BEGIN+numViewports)) {
		Presenter *pPres = GetPresenter();
		BindableStack *pStack = pPres->GetVisualRenderer()->GetViewportStack();

		ID -= COM_VIEWPORT_BEGIN;
		ViewportProxy *pVP = (ViewportProxy *) pStack->m_List[ID];
		if (!ID) {
			pVP->GetViewport()->set_bind = ! (Bool) pVP->GetViewport()->isBound;
		} else {
			//otherwise set current to top
			pVP->GetViewport()->set_bind = TRUE;
		}
		//and fire event
		pVP->GetViewport()->Onset_bind();


		BuildViewportList();
		return TRUE;
	}
	if (ID==ID_OPTIONS_YUV) {
		OnOptionsYUV();
		return TRUE;
	}
	if ( (ID>=COM_YUV_BEGIN) && (ID<COM_YUV_BEGIN + (int) numFormats)) {
		VisualRendererGDI *pVR = (VisualRendererGDI *)GetPresenter()->GetVisualRenderer();
		DWORD fmt = pVR->m_pDirectDraw->m_Formats[ID - COM_YUV_BEGIN];
		pVR->SetRenderingOption(VIDEO_FLAG_YUV_FORMAT, fmt);
		return TRUE;
	}
	return CFrameWnd::OnCommand(wParam, lParam);
}


void CMainFrame::OnViewFullScreen()
{
	SetFullScreen();
}

void CMainFrame::OnUpdateViewFullScreen(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(TRUE);
}


void CMainFrame::OnOptionsYUV()
{
	GetApp()->m_bUseYUVHW = !GetApp()->m_bUseYUVHW;
	if (!GetPresenter()->GetVisualRenderer()->SetRenderingOption(VIDEO_FLAG_YUV, GetApp()->m_bUseYUVHW)) {
		GetApp()->m_bUseYUVHW = FALSE;
	}
}
void CMainFrame::OnUpdateOptionsYUV(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(GetApp()->m_bUseYUVHW);
}


void CMainFrame::SetFullScreen()
{
	VisualRenderer *pRend = GetPresenter()->GetVisualRenderer();


	if (!m_bIsPaused) GetPresenter()->Pause();
	if (!m_bFullScreen) {
		m_wndView.GetClientRect(&m_Pos);
		if (pRend->SetRenderingOption(VIDEO_FLAG_FULLSCREEN, !m_bFullScreen)) {
			m_bFullScreen = !m_bFullScreen;
		} else {
			pRend->SetRenderingOption(VIDEO_FLAG_RESTOREASPECT, 0);
		}
		pRend->UpdateScreenSizeInfo();

	} else {
		if (pRend->SetRenderingOption(VIDEO_FLAG_FULLSCREEN, !m_bFullScreen)) {
			m_bFullScreen = !m_bFullScreen;
		}
		SetWindowPos(NULL, 100, 100, 100, 100, 0L);
		SetSize(m_Pos.right - m_Pos.left, m_Pos.bottom - m_Pos.top);
	}
	if (!m_bIsPaused) GetPresenter()->Resume();
}

LONG CMainFrame::OnOpen(WPARAM , LPARAM )
{
	OpenPresentation(m_CurrentPath);
	return 0;
}

void CALLBACK EXPORT ConsoleTimer(HWND /*hWnd*/, UINT /*nMsg*/,
							   UINT /*nIDEvent*/, DWORD /*dwTime*/)
{
	OsmoseApp *app = GetApp();

	GetMainFrame()->GetStatusBar()->GetStatusBarCtrl().SetIcon(2, NULL);
	app->m_lastMessageTime = 0;
	app->m_MessageType = -1;
	GetMainFrame()->KillTimer(GetMainFrame()->m_ConsoleTimerID);
	GetMainFrame()->m_ConsoleTimerID = 0;
	GetMainFrame()->GetStatusBar()->SetPaneText(2, "Ready");
}

#define CONSOLE_DISPLAY_TIME	3000

LONG CMainFrame::OnConsoleMessage(WPARAM wParam, LPARAM lParam)
{
	if (m_ConsoleTimerID) KillTimer(m_ConsoleTimerID);
	if (GetApp()->m_MessageType) {
		m_wndStatusBar.GetStatusBarCtrl().SetIcon(2, m_hMessage);
	} else {
		m_wndStatusBar.GetStatusBarCtrl().SetIcon(2, m_hError);
	}
	m_wndStatusBar.SetPaneText(2, GetApp()->m_szConsole);
	
	m_ConsoleTimerID = SetTimer(2, CONSOLE_DISPLAY_TIME, ConsoleTimer);
	
	return 0;
}

void CMainFrame::ConnectOK()
{
	m_bOpened = TRUE;
	CString str = "Osmo4 - ";
	str += GetName();
	SetWindowText(str);
	m_wndView.curZoom = 1.0;
	m_bIsPaused = FALSE;
}

