// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__46E27E04_7BB8_4E5F_9911_4A736FDD2BDC__INCLUDED_)
#define AFX_MAINFRM_H__46E27E04_7BB8_4E5F_9911_4A736FDD2BDC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ChildView.h"
#include "Presenter.h"

class CMainFrame : public CFrameWnd
{
	
public:
	CMainFrame();
protected: 
	DECLARE_DYNAMIC(CMainFrame)

// Attributes
public:

	BOOL m_bOpened;

// Operations
public:
	CStatusBar* GetStatusBar() { return &m_wndStatusBar; }
	CChildView* GetView() { return &m_wndView; }

	// Set the size of the client area to the given size.
	void SetSize(UINT width, UINT height);
	CString GetPath() {return m_CurrentPath;}
	CString GetName() {return m_CurrentName;}

	void ClosePresentation();
	void OpenPresentation(CString name);

	void BuildViewportList();

	void SetFullScreen();
	BOOL IsFullScreen() { return m_bFullScreen; }

	void ConnectOK();

	CString m_CurrentPath;
	void BuildYUVList();

	UINT m_ConsoleTimerID;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	HICON m_hError, m_hMessage;
	CString m_CurrentName;

	CChildView    m_wndView;
	RECT m_Pos;
	BOOL m_bIsPaused;
	BOOL m_bIsCapturing;
	BOOL m_bFullScreen;

	void AdjustWindowSize(UINT nID);

	Presenter *GetPresenter() { return (Presenter *) GetApp()->GetExecutive()->GetPresenter(); }


	void ForwardMessage();

	unsigned char format_names[50][5];
	unsigned int numFormats;
// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnViewStatusBar();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMove(int x, int y);

	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnChar( UINT nChar, UINT nRepCnt, UINT nFlags );
	afx_msg void OnSysKeyDown( UINT nChar, UINT nRepCnt, UINT nFlags );
	afx_msg void OnSysKeyUp( UINT nChar, UINT nRepCnt, UINT nFlags );
	afx_msg void OnKeyDown( UINT nChar, UINT nRepCnt, UINT nFlags );
	afx_msg void OnKeyUp( UINT nChar, UINT nRepCnt, UINT nFlags );
	
	afx_msg void OnNewAddress();
	afx_msg void OnNewAddressEnter();

	afx_msg void OnSetSize(WPARAM wParam, LPARAM lParam);
	afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
	afx_msg BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	afx_msg void OnNavigate(WPARAM wParam, LPARAM lParam);
	afx_msg void OnFileDroped(WPARAM wParam, LPARAM lParam);
	
	afx_msg void OnFileRestart();
	afx_msg void OnUpdateFileRestart(CCmdUI* pCmdUI);
	afx_msg void OnFilePause();
	afx_msg void OnUpdateFilePause(CCmdUI* pCmdUI);
	afx_msg void OnFileStep();
	afx_msg void OnUpdateFileStep(CCmdUI* pCmdUI);


	afx_msg void OnFileClose();
	afx_msg void OnUpdateFileClose(CCmdUI* pCmdUI);
	afx_msg void OnFileOpenNetwork();
	afx_msg void OnFileScreenshot();
	afx_msg void OnUpdateFileScreenshot(CCmdUI* pCmdUI);
	afx_msg void OnFileCapture();
	afx_msg void OnUpdateFileCapture(CCmdUI* pCmdUI);
	
	afx_msg void OnOptions30fps();
	afx_msg void OnUpdateOptions30fps(CCmdUI* pCmdUI);
	afx_msg void OnOptions25fps();
	afx_msg void OnUpdateOptions25fps(CCmdUI* pCmdUI);
	afx_msg void OnOptions15fps();
	afx_msg void OnUpdateOptions15fps(CCmdUI* pCmdUI);
	afx_msg void OnOptions10fps();
	afx_msg void OnUpdateOptions10fps(CCmdUI* pCmdUI);
	afx_msg void OnOptions5fps();
	afx_msg void OnUpdateOptions5fps(CCmdUI* pCmdUI);

	afx_msg void OnRenderDirect();
	afx_msg void OnUpdateRenderDirect(CCmdUI* pCmdUI);
	afx_msg void OnRenderIndirect();
	afx_msg void OnUpdateRenderIndirect(CCmdUI* pCmdUI);
	afx_msg void OnRenderBoth();
	afx_msg void OnUpdateRenderBoth(CCmdUI* pCmdUI);
	afx_msg void OnSplitTracking();
	afx_msg void OnUpdateSplitTracking(CCmdUI* pCmdUI);

	afx_msg void OnViewFullScreen();
	afx_msg void OnUpdateViewFullScreen(CCmdUI* pCmdUI);

	afx_msg void OnViewWorldInfo();
	afx_msg void OnViewOriginal();
	afx_msg void OnViewTiming();
	afx_msg void OnUpdateViewTiming(CCmdUI* pCmdUI);
	afx_msg void OnViewWireframe();
	afx_msg void OnUpdateViewWireframe(CCmdUI* pCmdUI);
	afx_msg void OnOptionsClearOnEnd();
	afx_msg void OnOptionsCustomCursors();
	afx_msg void OnOptionsRenderFast();
	afx_msg void OnOptionsRenderZoom();
	afx_msg void OnOptionsRenderRatio();
	afx_msg void OnOptionsRenderAntialias();
	afx_msg void OnOptionsRenderTextAntialias();
	afx_msg void OnUpdateOptionsClearOnEnd(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsCustomCursors(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsRenderFast(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsRenderAntialias(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsRenderTextAntialias(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsRenderZoom(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsRenderRatio(CCmdUI* pCmdUI);
	afx_msg void OnFileOpenfile();

	afx_msg void OnOptionsYUV();
	afx_msg void OnUpdateOptionsYUV(CCmdUI* pCmdUI);

	afx_msg LONG OnOpen(WPARAM wParam, LPARAM lParam);
	afx_msg LONG OnConsoleMessage(WPARAM wParam, LPARAM lParam);
	
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__46E27E04_7BB8_4E5F_9911_4A736FDD2BDC__INCLUDED_)
