/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2002.
*/

///////////////////////////////////////////////////////////////////////////
// File:  MediaSensorProxy.cpp
//
// Author: Jean Le Feuvre ENST 2002
//
///////////////////////////////////////////////////////////////////////////

#include "defs.h"
#include "Nodes-INIT.h"
#include "MediaSensorProxy.h"
#include "Presenter.h"

MediaSensorProxy* Presenter::InitMediaSensor(MediaSensorImp* pObj)
{
	return new MediaSensorProxy(pObj); 
}

MediaSensorProxy::MediaSensorProxy(MediaObject* pMO) : Traversable(pMO) 
{
	GetPresenter()->MediaSensorAdded();
}

MediaSensorProxy::~MediaSensorProxy()
{
	GetPresenter()->MediaSensorRemoved();
}


void MediaSensorProxy::Render(Effects *effects )
{
	MediaSensor *pMS = GetSensor();
	//we don't use flextime so create a time context with the current time in the scene
	PresenterContext ft_ctx;
	ft_ctx.SetTime(GetFlexTime());
	pMS->Render(& ft_ctx);
} 
