/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2002.
*/

///////////////////////////////////////////////////////////////////////////
// File:  Nodes-INIT.cpp
//
// Author: Jean Le Feuvre ENST 2002
//
// Description:
//   all proxy construction from node construction for all nodes integrated in OSMOSE
//
///////////////////////////////////////////////////////////////////////////


#include "defs.h"
#include "Nodes-INIT.h"
#include "Executiv.h"
#include "Presenter.h"

RenderingObject *AnchorINIT::CreateRenderingObject (MediaObject *)
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitAnchor(this);
}

RenderingObject *AppearanceINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitAppearance(this);
}


RenderingObject *AudioBufferINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitAudioBuffer(this);
}

RenderingObject *AudioClipINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitAudioClip(this);
}

RenderingObject *AudioSourceINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitAudioSource(this);
}


RenderingObject *Background2DINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitBackground2D(this);
}

RenderingObject *BitmapINIT::CreateRenderingObject (MediaObject *)
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitBitmap(this);
}

RenderingObject *CircleINIT::CreateRenderingObject (MediaObject *)
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitCircle(this);
}

RenderingObject *ColorINIT::CreateRenderingObject (MediaObject *)
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitColor(this);
}

RenderingObject *ColorInterpolatorINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitColorInterpolator(this);
}

RenderingObject *Coordinate2DINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitCoordinate2D(this);
}

RenderingObject *CoordinateInterpolator2DINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitCoordinateInterpolator2D(this);
}

RenderingObject *Curve2DINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitCurve2D(this);
}

RenderingObject *DiscSensorINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitDiscSensor(this);
}

RenderingObject *EllipseINIT::CreateRenderingObject (MediaObject *)
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitEllipse(this);
}

RenderingObject *FontStyleINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitFontStyle(this);
}

RenderingObject *FormINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitForm(this);
}

RenderingObject *GroupINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitGroup(this);
}

RenderingObject *InlineINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitInline(this);
}

RenderingObject *AnimationStreamINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitAnimationStream(this);
}

RenderingObject *IndexedLineSet2DINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitIndexedLineSet2D(this);
}

RenderingObject *IndexedFaceSet2DINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitIndexedFaceSet2D(this);
}

RenderingObject *LayoutINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitLayout(this);
}

RenderingObject *Layer2DINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitLayer2D(this);
}

RenderingObject *LinePropertiesINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitLineProperties(this);
}

RenderingObject *Material2DINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitMaterial2D(this);
}


RenderingObject *MaterialKeyINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitMaterialKey(this);
}

RenderingObject *MediaControlINIT::CreateRenderingObject (MediaObject *)
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitMediaControl(this);
}

RenderingObject *MediaSensorINIT::CreateRenderingObject (MediaObject *)
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitMediaSensor(this);
}

RenderingObject *MovieTextureINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitMovieTexture(this);
}



RenderingObject *SynthesizedTextureINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitSynthesizedTexture(this);
}




RenderingObject *MatteTextureINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitMatteTexture(this);
}

RenderingObject *OrderedGroupINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitOrderedGroup(this);
}

RenderingObject *PixelTextureINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitPixelTexture(this);
}

RenderingObject *ValuatorINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitValuator(this);
}

RenderingObject *PlaneSensor2DINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitPlaneSensor2D(this);
}

RenderingObject *PointSet2DINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitPointSet2D(this);
}

RenderingObject *PositionInterpolator2DINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitPositionInterpolator2D(this);
}

RenderingObject *ProximitySensor2DINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitProximitySensor2D(this);
}

RenderingObject *RectangleINIT::CreateRenderingObject (MediaObject *)
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitRectangle(this);
}

RenderingObject *ScalarInterpolatorINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitScalarInterpolator(this);
}

RenderingObject *ShapeINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitShape(this);
}

RenderingObject *Sound2DINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitSound2D(this);
}

RenderingObject *ScriptINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitScript(this);
}

RenderingObject *SwitchINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitSwitch(this);
}

RenderingObject *TextINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitText(this);
}

RenderingObject *ImageTextureINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitImageTexture(this);
}

RenderingObject *TermCapINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitTermCap(this);
}

RenderingObject *TimeSensorINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitTimeSensor(this);
}

RenderingObject *TouchSensorINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitTouchSensor(this);
}


RenderingObject *Transform2DINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitTransform2D(this);
}

RenderingObject *ConditionalINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitConditional(this);
}

RenderingObject *WorldInfoINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitWorldInfo(this);
}

RenderingObject *TemporalTransformINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitTemporalTransform(this);
}

RenderingObject *TemporalGroupINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitTemporalGroup(this);
}

RenderingObject *CompositeTexture2DINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitCompositeTexture2D(this);
}

RenderingObject *TextureTransformINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitTextureTransform(this);
}

RenderingObject *GradientRadialINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitGradientRadial(this);
}
RenderingObject *GradientLinearINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitGradientLinear(this);
}

RenderingObject *AdvancedFontStyleINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitAdvancedFontStyle(this);
}

RenderingObject *TransformMatrix2DINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitTransformMatrix2D(this);
}

RenderingObject *XLinePropertiesINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitXLineProperties(this);
}

RenderingObject *ViewportINIT::CreateRenderingObject (MediaObject *) 
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitViewport(this);
}

RenderingObject *Clipper2DINIT::CreateRenderingObject(MediaObject *)
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitClipper2D(this);
}

RenderingObject *XCurve2DINIT::CreateRenderingObject(MediaObject *)
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitXCurve2D(this);
}

RenderingObject *ColorTransformINIT::CreateRenderingObject(MediaObject *)
{
	return (RenderingObject *) ((Presenter*)GetExecutive()->GetPresenter())->InitColorTransform(this);
}

