// Osmose.cpp : Defines the class behaviors for the application.
//

#include "defs.h"
#include <assert.h>
#include "Clock.h"
#include "Osmose.h"
#include "VisualRender-GDIP.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

FILE *_trace = NULL;

/////////////////////////////////////////////////////////////////////////////
// OsmoseApp

BEGIN_MESSAGE_MAP(OsmoseApp, CWinApp)
	//{{AFX_MSG_MAP(OsmoseApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)

		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// OsmoseApp construction

OsmoseApp::OsmoseApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only OsmoseApp object

OsmoseApp theApp;

/////////////////////////////////////////////////////////////////////////////
// OsmoseApp initialization


BOOL OsmoseApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif
	
	
	SetRegistryKey(_T("Osmo4 Player"));


	// To create the main window, this code creates a new frame window
	// object and then sets it as the application's main window object.

	CMainFrame* pFrame = new CMainFrame;
	m_pMainWnd = pFrame;

	// create and load the frame with its resources

	pFrame->LoadFrame(IDR_MAINFRAME,
		WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE, NULL,
		NULL);


	// Read the flags which are stored in the application's .INI file
	m_clearOnEnd = AfxGetApp()->GetProfileInt("Options", "ClearOnEnd", TRUE);
	m_bUseCursors = AfxGetApp()->GetProfileInt("Options", "CustomCursors", TRUE);
	m_bAntiAlias = AfxGetApp()->GetProfileInt("Options", "AntiAlias", FALSE);
	m_bTextAntiAlias = AfxGetApp()->GetProfileInt("Options", "TextAntiAlias", TRUE);
	m_bFastSpeed = AfxGetApp()->GetProfileInt("Options", "FastSpeed", TRUE);
	m_bZoom = AfxGetApp()->GetProfileInt("Options", "Zoom", FALSE);
	m_bRatio = AfxGetApp()->GetProfileInt("Options", "KeepRatio", TRUE);
	m_VideoMode = AfxGetApp()->GetProfileInt("Options", "VideoMode", 2);
	m_bWireframe = AfxGetApp()->GetProfileInt("Options", "Wireframe", FALSE);
	m_bShowTiming = AfxGetApp()->GetProfileInt("Options", "Timing", FALSE);
	m_bSplitTracking = AfxGetApp()->GetProfileInt("Options", "SplitTracking", TRUE);

	m_hCursorNormal = ::LoadCursor(NULL, IDC_ARROW);
	m_hCursorPlane = ::LoadCursor(NULL, IDC_SIZEALL);
	m_hCursorProxy = ::LoadCursor(NULL, IDC_UPARROW);
	m_hCursorHand = LoadCursor(MAKEINTRESOURCE(IDC_HANDCURSOR));
	m_hCursorDisc = LoadCursor(MAKEINTRESOURCE(IDC_DISCSENSOR));
	m_hCursorZoomIn = LoadCursor(MAKEINTRESOURCE(IDC_ZOOMIN));
	m_hCursorZoomOut = LoadCursor(MAKEINTRESOURCE(IDC_ZOOMOUT));
	m_hCursorMove = LoadCursor(MAKEINTRESOURCE(IDC_HANDMOVE));
	m_hCursorMoveClose = LoadCursor(MAKEINTRESOURCE(IDC_HANDMOVECLOSE));

	m_CursorType = SENSOR_NONE;

	m_MessageType = -1;

	//init GDIplus
	Gdiplus::GdiplusStartupInput startupInput;
	Gdiplus::GdiplusStartup(&m_gdiToken, &startupInput, NULL);

	GetMainFrame()->SetSize(300, 200);

	CreateExecutive(GetMainFrame()->GetView()->m_hWnd);
	if (!GetExecutive()) {
		m_pMainWnd->PostMessage(WM_QUIT);
	}

	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles();

	// Load the list of network addresses from the INI file
	GetProfileNetworkAddresses();

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
	
	// The one and only window has been initialized, so show and update it.
	pFrame->ShowWindow(SW_SHOW);
	pFrame->UpdateWindow();

	Sleep(500);
	GetMainFrame()->BuildYUVList();

	if (! cmdInfo.m_strFileName.IsEmpty()) {
		GetMainFrame()->m_CurrentPath = (LPCSTR) cmdInfo.m_strFileName;
		GetMainFrame()->PostMessage(WM_OPENFILE);
	}

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// OsmoseApp message handlers


int OsmoseApp::ExitInstance() 
{
	// Write the current frame rate to the .INI file
	if (GetExecutive() != NULL)
		GetApp()->WriteProfileFloat("Options", "FrameRate",
			((Presenter*)GetExecutive()->GetPresenter())->GetTargetFrameRate());

	// and also write the list of network addresses
	WriteProfileNetworkAddresses();

	m_deviceFilter.DevicePlugin_Detach_Req(m_keyboardInstance.m_nDeviceId);
	m_deviceFilter.DevicePlugin_Detach_Req(m_mouseInstance.m_nDeviceId);
	m_deviceFilter.DevicePlugin_Detach_Req(m_Web3DKeySensorInstance.m_nDeviceId);

	if (m_pExecutive) {
		m_pExecutive->Stop();
		Sleep(500);
		delete m_pExecutive;
	}

	//shutdown GDIplus
	Gdiplus::GdiplusShutdown(m_gdiToken);

	// Empty the list of entered network addresses
	for (int i = 0; i < m_networkAddresses.GetLength(); i++)
		free(m_networkAddresses[i]);

	_CrtCheckMemory();
	return CWinApp::ExitInstance();
}



/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnWww();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_WWW, OnWww)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void OsmoseApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

void CAboutDlg::OnWww() 
{
	ShellExecute(NULL, "open", "http://www.comelec.enst.fr/osmo4", NULL, NULL, SW_SHOWNORMAL);
}

/////////////////////////////////////////////////////////////////////////////
// OsmoseApp message handlers




void OsmoseApp::CreateExecutive(HWND hWnd)
{
	// Create the executive object
	m_pExecutive = new Executive(this, hWnd, _trace, TRACE_PARSE, &m_deviceFilter);
	
	// Set the initial frame rate
	Presenter* pPres = (Presenter *) GetExecutive()->GetPresenter();

	if(pPres==NULL) {
		delete m_pExecutive;
		m_pExecutive=NULL;

		MessageBox(NULL, "Renderer Loading Failed", "Check Registry Settings", MB_OK);
		return;
	}

	float frameRate = GetApp()->GetProfileFloat("Options", "FrameRate", 25.0);
	pPres->SetTargetFrameRate(frameRate);	
	pPres->SetVideoRenderMode(m_VideoMode);
	pPres->SetBoundsTrackingMode(m_bSplitTracking);

	pPres->GetVisualRenderer()->SetRenderingOption(VIDEO_FLAG_CLEARONEND, m_clearOnEnd);
	pPres->GetVisualRenderer()->SetRenderingOption(VIDEO_FLAG_HIGHSPEED, m_bFastSpeed);
	pPres->GetVisualRenderer()->SetRenderingOption(VIDEO_FLAG_ANTIALIAS, m_bAntiAlias);
	pPres->GetVisualRenderer()->SetRenderingOption(VIDEO_FLAG_TEXTANTIALIAS, m_bTextAntiAlias);
	pPres->GetVisualRenderer()->SetRenderingOption(VIDEO_FLAG_SCALABLEZOOM, m_bZoom);
	pPres->GetVisualRenderer()->SetRenderingOption(VIDEO_FLAG_KEEPRATIO, m_bRatio);
	pPres->GetVisualRenderer()->SetRenderingOption(VIDEO_FLAG_NOFILL, m_bWireframe);

	/*get YUV support flag*/
	VisualRendererGDI *pVR = (VisualRendererGDI *) pPres->GetVisualRenderer();
	m_bUseYUVHW = pVR->m_pDirectDraw->m_numFormats ? TRUE : FALSE;

	m_deviceFilter.SetVisualRenderer(pPres->GetVisualRenderer());
	m_keyboardInstance.SetDeviceFilter(&m_deviceFilter);
	m_Web3DKeySensorInstance.SetDeviceFilter(&m_deviceFilter);
	m_mouseInstance.SetDeviceFilter(&m_deviceFilter);
	m_deviceFilter.DevicePlugin_Attach_Req(&m_keyboardInstance);
	m_deviceFilter.DevicePlugin_Attach_Req(&m_mouseInstance);
	m_deviceFilter.DevicePlugin_Attach_Req(&m_Web3DKeySensorInstance);
}

void CALLBACK EXPORT TimerProc(HWND /*hWnd*/, UINT /*nMsg*/,
							   UINT /*nIDEvent*/, DWORD /*dwTime*/)
{
	char text[100];
	Presenter* pPres = (Presenter *) GetApp()->GetExecutive()->GetPresenter();

	
	if (! GetApp()->m_bShowTiming || !pPres->IsActive()) return;

	int ms = pPres->GetTime();
	float fps = pPres->GetActualFrameRate();

	sprintf(text, "FPS %.1f", fps);
	GetMainFrame()->GetStatusBar()->SetPaneText(1, text);

	// Format the time as MM.SS.HH
	sprintf(text, "%02d:%02d.%02d", ((int)(ms / 1000)) / 60, ((int)(ms / 1000)) % 60, (ms % 1000) / 10);

	// Update the pane in the status bar
	GetMainFrame()->GetStatusBar()->SetPaneText(0, text);
}


void OsmoseApp::OnConnect(RESPONSE result)
{
	if (result == RESPONSE_OK) {
		// Start a timer to update the running time display
		m_timerID = GetMainFrame()->SetTimer(1, 250, TimerProc);

		GetMainFrame()->ConnectOK();
		m_smpFileOpen.P();
	} else {
		MessageBox(NULL, "Couldn't open the requested service", "Error!", MB_OK);
	}
}

void OsmoseApp::OnFinish(RESPONSE /*reason*/)
{
	// Stop the timer which is updating the display of the running time.
	if(GetMainFrame()!=NULL)
		GetMainFrame()->KillTimer(m_timerID);
	m_CursorType = SENSOR_NONE;
	m_smpFileOpen.V();
}

void OsmoseApp::OnError(NON_FATAL_ERROR nERROR, va_list args)
{
	GetMainFrame()->GetView()->NonFatalError((int) nERROR, args);
}

void OsmoseApp::OnFatalError(FATAL_ERROR nERROR, LPCSTR msg)
{
	GetMainFrame()->GetView()->FatalError((int) nERROR, (char *) msg);
}

void OsmoseApp::OverSensor(unsigned int sensorType)
{
	
	if (!m_bUseCursors) {
		SetCursor(m_hCursorNormal);
		return;
	}

	unsigned int type;
	if (sensorType>=SENSOR_ZOOMIN) {
		if (sensorType==SENSOR_RESETPRIVATE) {
			m_bCursorIsPrivate = FALSE;
		} else {
			m_bCursorIsPrivate = TRUE;
			m_privateType = sensorType;
		}
	} else {
		m_CursorType = sensorType;
	}
	
	type = m_bCursorIsPrivate ? m_privateType : m_CursorType;

	switch (type) {
	case SENSOR_TOUCH:
	case SENSOR_ANCHOR:
		SetCursor(m_hCursorHand);
		break;
	case SENSOR_DISC:
		SetCursor(m_hCursorDisc);
		break;
	case SENSOR_PLANE:
		SetCursor(m_hCursorPlane);
		break;
	case SENSOR_PROXIMITY:
		SetCursor(m_hCursorProxy);
		break;
	//these are our internal types
	case SENSOR_ZOOMIN:
		SetCursor(m_hCursorZoomIn);
		break;
	case SENSOR_ZOOMOUT:
		SetCursor(m_hCursorZoomOut);
		break;
	case SENSOR_MOVEOPEN:
		SetCursor(m_hCursorMove);
		break;
	case SENSOR_MOVECLOSE:
		SetCursor(m_hCursorMoveClose);
		break;
	default:
		SetCursor(m_hCursorNormal);
		m_CursorType = SENSOR_NONE;
		break;
	}
}

int OsmoseApp::Navigate(LPCSTR szAddress)
{	
	GetMainFrame()->PostMessage(WM_NAVIGATE, NULL,(LPARAM) szAddress);
	return 1;
}

void OsmoseApp::SetSize(unsigned int width, unsigned int height)
{	
	LPARAM lparam =MAKELPARAM(width,height);
	GetMainFrame()->PostMessage(WM_SETSIZE,NULL,lparam);
}

//we don't use the stack info, only allow for top-level stack modifs
void OsmoseApp::ViewportStackChanged(class BindableStack *)
{
	//rebuild the list
	GetMainFrame()->BuildViewportList();
}



/////////////////////////////////////////////////////////////////////////////

float OsmoseApp::GetProfileFloat(LPCTSTR lpszSection,
									   LPCTSTR lpszEntry,
									   float fDefault)
{
	CString str = GetProfileString(lpszSection, lpszEntry);
	if (str.IsEmpty())
		return fDefault;
	else
		return atof(str);
}


BOOL OsmoseApp::WriteProfileFloat(LPCTSTR lpszSection,
										LPCTSTR lpszEntry,
										float value)
{
	char str[20];
	sprintf(str, "%.4f", value);
	return WriteProfileString(lpszSection, lpszEntry, str);
}


void OsmoseApp::GetProfileNetworkAddresses()
{
	CString str = GetProfileString("State", "NetworkAddresses");
	if (!str.IsEmpty())
	{
		char* localStr = strdup((LPCTSTR)str);
		char* pStr = localStr;

		// Break the string into separate string, using the commas
		// as separators
		while (pStr != NULL)
		{
			// NULL terminate the substring (if required)
			char* pEnd = strchr(pStr, ',');
			if (pEnd != NULL)
				*pEnd = 0;

			// Make a copy of the substring
			m_networkAddresses += strdup(pStr);

			// Move onto the next string
			if (pEnd != NULL)
				pStr = pEnd + 1;
			else
				pStr = pEnd;
		}
       
		free(localStr);
	}
}

void OsmoseApp::WriteProfileNetworkAddresses()
{
	// If there are no network addresses, write an empty string
	if (m_networkAddresses.GetLength() == 0)
		WriteProfileString("State", "NetworkAddresses", "");

	// Otherwise, combine all of the network addresses into a single,
	// comma separated list in order to store it in the application's
	// profile.
	else
	{
		int requiredLength = 0;
		for (int i = 0; i < m_networkAddresses.GetLength(); i++)
			requiredLength += strlen(m_networkAddresses[i]) + 1;

		char* combinedString = new char[requiredLength];
		strcpy(combinedString, m_networkAddresses[0]);
		for (i = 1; i < m_networkAddresses.GetLength(); i++)
		{
			strcat(combinedString, ",");
			strcat(combinedString, m_networkAddresses[i]);
		}

		WriteProfileString("State", "NetworkAddresses", combinedString);
		delete combinedString;
	}
}


const char *OsmoseApp::GetApplicationName()
{
	return "Osmo4 Player";
}
const char *OsmoseApp::GetApplicationVersion()
{
	return "Version 1.2.1";
}
const char *OsmoseApp::GetWorldURL()
{
	return (const char *) GetMainFrame()->m_CurrentPath;
}
