// OsmoseDoc.h : interface of the COsmoseDoc class
//
/////////////////////////////////////////////////////////////////////////////
enum BROWSER{HTML,MPEG,UNKNOWN};

class COsmoseDoc : public CDocument
{


protected: // create from serialization only
	COsmoseDoc();
	DECLARE_DYNCREATE(COsmoseDoc)

// Attributes
public:
	// The name of the file being read from
	CString m_fileName;

	// TRUE if a file has been opened, FALSE once it is closed
	BOOL m_fileOpened;
	BOOL m_webFileOpened;

// Operations
public:
	void CloseDocument();
	BOOL OpenDocument();
	BOOL DocumentNeedsOpening();
	BOOL IsFileOpen() const { return m_fileOpened; }


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COsmoseDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual void OnCloseDocument();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~COsmoseDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(COsmoseDoc)
	afx_msg void OnFileRestart();
	afx_msg void OnUpdateFileRestart(CCmdUI* pCmdUI);
	afx_msg void OnFileClose();
	afx_msg void OnUpdateFileClose(CCmdUI* pCmdUI);
	afx_msg void OnFileOpenNetwork();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
