/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2002.
*/

///////////////////////////////////////////////////////////////////////////
// File:  PlaneSensor2DProxy.h
//
// Author: Jean Le Feuvre - ENST 2002
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef PLANE_SENSOR2D_PROXY_H
#define PLANE_SENSOR2D_PROXY_H


#include "UserEventHandlerProxy.h"


class PlaneSensor2DProxy : public UserEventHandlerProxy
{
public:
	PlaneSensor2DProxy(MediaObject* pMO) : UserEventHandlerProxy(pMO)
	{
		m_mouseDown = FALSE;
		m_LastWasNotOver = 0;
	}

	// Return a pointer to the PlaneSensor2D node that this node is the proxy for
	PlaneSensor2D* GetPlaneSensor2D() const
	{ return (PlaneSensor2D*)GetObject(); }

	// Functions inherited from the base classes
	BOOL OnUserEvent(EventInfo const* pEvent, Matrix2D *pSensorMatrix);
	virtual BOOL IsSensor() { return TRUE; }

	virtual BOOL IsEnabled() {return (BOOL) (Bool) GetPlaneSensor2D()->enabled; }

	//valuator doesn't modify the scene, it only generate events
	virtual BOOL ChangesInvalidateScene() { return FALSE; }

private:
	BOOL m_mouseDown;	// Remember the previous state of the mouse button
	Vec2f m_pointStartDrag;
	BOOL m_LastWasNotOver;

	Vec2f GetTranslation(float X, float Y, Matrix2D matrix);
	Matrix2D m_InitialMatrix;
};


#endif // PLANE_SENSOR2D_PROXY_H
