/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2002.
*/

///////////////////////////////////////////////////////////////////////////
// File:  Proximity2DSensor.h
//
// Author: Jean Le Feuvre ENST 2002
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef PROXIMITY_SENSOR_2D_PROXY_H
#define PROXIMITY_SENSOR_2D_PROXY_H


#include "UserEventHandlerProxy.h"
#include "VisualPath.h"


class ProximitySensor2DProxy : public UserEventHandlerProxy
{
public:
	ProximitySensor2DProxy(MediaObject* pMO) : UserEventHandlerProxy(pMO),
		m_JustEntered(FALSE),m_LastUpdateTime(0),m_InRegion(FALSE){}
		 
	
	// Return a pointer to the ProximitySensor2D node that this node is the proxy for
	ProximitySensor2D* GetProximitySensor2D() const
	{ return (ProximitySensor2D*)GetObject(); }

	// Functions inherited from the base classes
	BOOL OnUserEvent(EventInfo const* pEvent, Matrix2D *pSensorMatrix);
	virtual BOOL IsSensor() { return TRUE; }

	virtual BOOL IsEnabled() {return (BOOL) (Bool) GetProximitySensor2D()->enabled; }
	
	//valuator doesn't modify the scene, it only generate events
	virtual BOOL ChangesInvalidateScene() { return FALSE; }

private:
	BOOL IsInSensor(float X, float Y);
	BOOL m_JustEntered, m_InRegion, m_HasLeft;
	DWORD m_LastUpdateTime;

	//used to store the exitTime (note that this means we don't accurately support multiple instances
	//(DEF/USE) with flexTime since we generate the exitTime based on this value)
	double m_lastTime;
};


#endif // PROXIMITY_SENSOR_2D_PROXY_H
