/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2002.
*/

///////////////////////////////////////////////////////////////////////////
// File:  RectCollect.h
//
// Author: Jean Le Feuvre ENST 2002
//
///////////////////////////////////////////////////////////////////////////

#ifndef RECTCOLLECT_H
#define RECTCOLLECT_H

#include "BRect.h"
#include "ztl.h"

class RectCollect
{
public:
	//adds a rectangle to the collection
	void Union(BRect rc);
	//perform final regroupment and make sure all rectangles don't
	//overlap
	void UpdateCollection();
	void Merge(RectCollect &other);
	void Intersection(RectCollect &other);
	void MakeEmpty();

	//merge all items into a single rect
	void MakeRect();

	//returns TRUE if empty. Shall be called after UpdateCollection
	BOOL IsEmpty();

	ZArray<BRect> m_List;

	void SetRectEmulation(BOOL on);

private:
	//if set, acts as BRect object
	BOOL m_bEmulateRect;
};

#endif	//RECTCOLLECT_H