/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2002.
*/

///////////////////////////////////////////////////////////////////////////
// File:  ShapeProxy.cpp
//
// Authors: Jean Le Feuvre ENST 2002
//
// Description:
//   proxy object for Shape node.
//
// Created: August 2002.
//
///////////////////////////////////////////////////////////////////////////


#include "defs.h"
#include "Nodes-INIT.h"
#include "ShapeProxy.h"
#include "GeometryNode.h"
#include "Presenter.h"

ShapeProxy* Presenter::InitShape(Shape* pObj)
{
		return new  ShapeProxy(pObj);
}

void ShapeProxy::Render(Effects *effects)
{
	MediaObject* pMediaObject=GetGeometry();
	if (! pMediaObject) return;


	effects->m_pAppearanceProxy = NULL;
	if (GetShape()->appearance) 
		effects->m_pAppearanceProxy = (AppearanceProxy *) GetShape()->appearance->GetRenderingObject();

	effects->m_pGeometryProxy = (GeometryNode *) GetShape()->geometry->GetRenderingObject();

	if (effects->m_pGeometryProxy) effects->m_pGeometryProxy->Render(effects);

	effects->m_pAppearanceProxy = NULL;
	effects->m_pGeometryProxy = NULL;
}


