/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/


#ifndef SynthesizedTexture_PROXY_H
#define SynthesizedTexture_PROXY_H


#include "DrawableImage.h"
#include "TimedNode.h"

#include "bindable.h"

#include	"St.h"


//we cannot use double heritance on objects deriving from Traversable, thus we duplicate GroupNodeProxy
//functionality in CompositeTexture
class SynthesizedTextureProxy : public DrawableImage, TimedNode
{
public:
	SynthesizedTextureProxy(MediaObject* pMO);
	~SynthesizedTextureProxy();

	// Return a pointer to the ImageTexture node that this node is the proxy for
	SynthesizedTexture* GetSynthesizedTexture() const { return (SynthesizedTexture *) GetObject(); }

	// Functions inherited from the base classes
	virtual void Update(DrawableContext *pContext);

	void UpdateTimeInfo();



protected:
	virtual BOOL ShouldBuildBrush() {return TRUE; }


	int LoadStream();

	void	UpdateTranslation();
	void	UpdateRotation();





private:
	//contains all sensors of this group (avoids double browsing of all children)
	ZArray<Traversable *> m_sensors;

	DWORD m_LastDrawTime;

	DWORD m_LastUpdateTime;

	CSt	*m_st;

//	void *m_hvim;

	void *m_im;
	void *m_im1;

private:
//	BOOL m_firstTime;
	MediaStreamImp *m_pStream;

	BOOL m_bFirstTime, m_bFirstFrameFetched;
	double m_startTime;
};


#endif // SynthesizedTexture_PROXY_H
