/***********************************************************************
    This software module  was  originally  developed by Patrice Bazerque
	(IBM Research)
    in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
    standard.  This software module is an implementation of a part of
    one or more MPEG-4 Systems (ISO/IEC 14496-1) tools  as  specified
    by  the  MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC gives
    users of the MPEG-4 Systems (ISO/IEC 14496-1)  free  license  to
    this software module or modifications thereof for use in hardware
    or software products claiming conformance to the  MPEG-4  Systems
    (ISO/IEC 14496-1). Those intending to use this software module in
    hardware or software  products  are  advised  that  its  use  may
    infringe   existing  patents.  The  original  developer  of  this
    software module and his/her company, the subsequent  editors  and
    their  companies,  and  ISO/IEC have no liability for use of this
    software module or modifications thereof  in  an  implementation.
    Copyright  is not released for non MPEG-4 Systems (ISO/IEC 14496-
    1) conforming  products.  IBM
    retain  full  right to use the code for their own purpose, assign
    or donate the code to a third party and to inhibit third  parties
    from  using  the  code  for  non MPEG-4 Systems (ISO/IEC 14496-1)
    conforming products. This copyright notice must  be  included  in
    all copies or derivative works. Copyright  1999.
************************************************************************/

/**************************************************************************
 * Project Im1Player
 * INTERNATIONAL STANDARD ORGANIZATION
 * ISO/IEC JTC1/SC29/WG11
 * 
 * SUBSYSTEM: BIFS Encoder/Decoder
 * FILE:      TemporalGroupProxy.cpp
 * AUTHOR:    Patrice Bazerque (IBM Research)
 * OVERVIEW:  The implementation of the proxy object used by the presenter
 *   to handle the TemporalGroup node.
 * 
 * Comment:   Contact: mykim@us.ibm.com
 *
 *
 *		Modified: 
 *				Jean Le Feuvre, ENST, October 2002 
 *
 **************************************************************************/

#include "defs.h"
#include "Nodes-INIT.h"
#include "TemporalGroupProxy.h"
#include "Presenter.h"


TemporalGroupProxy* Presenter::InitTemporalGroup(TemporalGroup* pObj)
{
	return new  TemporalGroupProxy(pObj); 
}


void TemporalGroupProxy::Render(Effects *effects)
{
	//pass it through
	RenderChildren(effects);
}
