/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2002.
*/

///////////////////////////////////////////////////////////////////////////
// File:  TimeSensorProxy.h
//
// Author: Jean Le Feuvre ENST 2002
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef TIME_SENSOR_PROXY_H
#define TIME_SENSOR_PROXY_H


#include "Traversable.h"
#include "TimedNode.h"


class TimeSensorProxy : public Traversable, TimedNode
{
public:
	TimeSensorProxy(MediaObject* pMO);
	~TimeSensorProxy();

	// Return a pointer to the TimeSensor node that this node is the proxy for
	TimeSensor* GetTimeSensor() const
	{ return (TimeSensor*)GetObject(); }

	void UpdateTimeInfo();

	// Functions inherited from the base classes
	virtual void Render(Effects *);
	//this is not a proper sensor, just an event generator 
	virtual BOOL IsSensor() { return FALSE; }

	//valuator doesn't modify the scene, it only generate events
	virtual BOOL ChangesInvalidateScene() { return FALSE; }

	void OnUpdate();

	// Private implementation details
private:
	void Deactivate();
	BOOL m_bNeedsUnregister;	
	double m_StartTime;
	double m_CycleInterval;
	unsigned int m_NumCycles;
};


#endif // TIME_SENSOR_PROXY_H
