/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2002.
*/

///////////////////////////////////////////////////////////////////////////
// File:  TransformMatrix2DProxy.cpp
//
// Author: Jean Le Feuvre
//
// Modified: 
//
// Description:
//   proxy object for TransformMatrix2D node.
//
// Created: September, 2002
//
//
///////////////////////////////////////////////////////////////////////////


#include "defs.h"
#include "Nodes-INIT.h"
#include "TransformMatrix2DProxy.h"
#include "Presenter.h"

TransformMatrix2DProxy* Presenter::InitTransformMatrix2D(TransformMatrix2D* pObj)
{
	return new  TransformMatrix2DProxy(pObj);
}

void TransformMatrix2DProxy::GetMatrix(Matrix2D *mat)
{
	mat->SetIdentity();

	TransformMatrix2D *pMatrix = GetTransformMatrix2D();
	mat->Set(pMatrix->mxx, pMatrix->mxy, pMatrix->tx, pMatrix->myx, pMatrix->myy, pMatrix->ty);
}

void TransformMatrix2DProxy::Render(Effects *effects)
{
	Effects *newEffects = new Effects(effects);

	//get local matrix
	GetMatrix(&newEffects->transform);

	//and move to parent system
	newEffects->transform.AddTransform(&effects->transform);
	
	// Apply these new effects to the children nodes
	RenderChildren(newEffects);

	delete newEffects;
}