/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2002.
*/

///////////////////////////////////////////////////////////////////////////
// File:  TransformMatrix2DProxy.h
//
// Author: Jean Le Feuvre ENST 2002
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef TRANSFORMMATRIX2D_PROXY_H
#define TRANSFORMMATRIX2D_PROXY_H


#include "GroupNodeProxy.h"


class TransformMatrix2DProxy : public GroupNodeProxy
{
public:
	TransformMatrix2DProxy(MediaObject* pMO) : GroupNodeProxy(pMO) {}

	// Return a pointer to the Transform2D node that this node is the proxy for
	TransformMatrix2D* GetTransformMatrix2D() const { return (TransformMatrix2D*)GetObject(); }

	// Functions inherited from the base class
	virtual void Render(Effects *effects);
	void GetMatrix(Matrix2D *);

private:
};


#endif // TRANSFORMMATRIX2D_PROXY_H
