// WorldInfo.cpp : implementation file
//

#include "defs.h"
#include "Osmose.h"


#include "ViewWorldInfo.h"
#include "Root.h"
#include "Nodes.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CViewWorldInfo dialog


CViewWorldInfo::CViewWorldInfo(CWnd* pParent /*=NULL*/)
	: CDialog(CViewWorldInfo::IDD, pParent)
{
	//{{AFX_DATA_INIT(CViewWorldInfo)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CViewWorldInfo::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CViewWorldInfo)
	DDX_Control(pDX, IDC_INFO, m_info);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CViewWorldInfo, CDialog)
	//{{AFX_MSG_MAP(CViewWorldInfo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////

BOOL CViewWorldInfo::OnInitDialog() 
{
	CDialog::OnInitDialog();

	Root* pRoot = GetApp()->GetExecutive()->GetScene();

	// If there is no scene currently loaded, say so
	if (pRoot == NULL) {
		m_info.SetWindowText("No scene is currently loaded.");
		return TRUE;
	}
	// Get a pointer to the WorldInfo node in the current scene.
	WorldInfo* pWorldInfo = pRoot->GetWorldInfo();

	// If there is not one, say so
	if (pWorldInfo == NULL)
	{
		m_info.SetWindowText("This scene does not contain a WorldInfo node.");
		return TRUE;
	}

	CString text;
	text += (LPCTSTR) pWorldInfo->title;
	SetWindowText(text);

	text="";
	for (int i=0; i<pWorldInfo->info.GetLength(); i++) {
		text += (LPCTSTR) pWorldInfo->info[i];
		text += "\r\n";
	}
	m_info.SetWindowText(text);
	m_info.SetSel(0, 0);
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
