/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2002.
*/

///////////////////////////////////////////////////////////////////////////
// File: ViewportProxy.h
//
// Author: Jean Le Feuvre
//
// Modified: 
//
// Description:
//   The definition of the proxy object used by the presenter
//   to handle the Viewport node.
//
// Created: September 2002.
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef VIEWPORT_PROXY_H
#define VIEWPORT_PROXY_H


#include "Traversable.h"
#include "Nodes.h"

class BindableStack; 

class ViewportProxy : public Traversable
{
public:
	ViewportProxy(MediaObject* pMO): Traversable(pMO) 
	{
		m_bFirstTime = TRUE;
	}
	virtual void DeleteObject();


	// Return a pointer to the TimeSensor node that this node is the proxy for
	Viewport *GetViewport() const { return (Viewport *)GetObject(); }

	// Functions inherited from the base classes
	void Render(Effects *);

	void SetupEffects(Effects *effects, float parent_width, float parent_height, BRect &FinalClipper);

	ZArray<BindableStack *> m_Stacks;
	
private:
	BindableStack *GetStack(Effects *effects);

	BOOL m_bFirstTime;
};


#endif // VIEWPORT_PROXY_H
