/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2002.
*/

///////////////////////////////////////////////////////////////////////////
// File: VisualClipper.h
//
// Authors: Jean Le Feuvre ENST 2002
//
// Note: the clipper works in absolute BIFS coordinates
//
///////////////////////////////////////////////////////////////////////////


#ifndef VISUALCLIPPER_H
#define VISUALCLIPPER_H


#include "ztypes.h"
#include "VisualPath.h"

#include "OsmoseGdiplus.h"


class VisualClipper
{
	// Public functions
public:
	VisualClipper();
	virtual ~VisualClipper();

	//clone clipper
	VisualClipper *Clone();
	//reset clipper
	void Reset();
	
	//transform the clipper
	BOOL Transform(Matrix2D *mat);
		
	//adds a path to the clipper with an optional transform matrix. 
	//if bIsCliping is false, the clipper will be used as a "hole"
	BOOL AddPath(VisualPath *path, Matrix2D *mat = NULL, BOOL bIsClipping = TRUE, BOOL bUseXOR = FALSE);


	//region needs access by VisualSurface
	Gdiplus::Region *m_pRegion;

	BOOL m_bIsClipping;

private:
	//init the clipper to a given path and apply a transform matrix if desired - the matrix
	//shall give the absolute world transform of the path in BIFS coords
	//if bIsCliping is false, the clipper will be used as a "hole"
	BOOL Set(VisualPath *path, Matrix2D *mat = NULL, BOOL bIsCliping = TRUE);
};


#endif // VISUALCLIPPER_H

