/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2002.
*/

///////////////////////////////////////////////////////////////////////////
// File:  BitmapProxy.h
//
// Author: Jean Le Feuvre - ENST 2002
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef BITMAP_PROXY_H
#define BITMAP_PROXY_H


#include "GeometryNode.h"


class BitmapProxy : public GeometryNode
{
public:
	BitmapProxy(MediaObject* pMO);

	// Return a pointer to the Bitmap node that this node is the proxy for
	Bitmap* GetBitmap() const { return (Bitmap*)GetObject(); }

	// Functions inherited from the base classes
	void Render(Effects *effects);
	void OnEndOfStream();
    virtual void Draw(DrawableContext *pDrawableContext);     

	//this is called to check if the point is over the shape when in its BRect
	//default is TRUE for bitmap since it fills its BRect (we don't support alpha images
	//testing, that would be way too slow).
	virtual BOOL IsPointOver(DrawableContext * /*pContext*/, float /*x*/, float /*y*/) { return TRUE; }
	
	//gradient texture not used with bitmap
	virtual void GetOriginalBounds(BRect &bounds) {
		bounds.MakeEmpty();
	}
	//bitmap not used as a clipping node
	virtual void AddToClipper(VisualClipper*, DrawableContext *, BOOL, BOOL ) {}

private :
	void BuildGraph(DrawableContext *pContext);
};


#endif // BITMAP_PROXY_H
