/*
	This software module was originally developed by ENST in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.
	This software module is an implementation of a part of one or more MPEG-4
Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 14496-1) 
standard. ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license 
to this software module or modifications thereof for use in hardware or software 
products claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
Those intending to use this software module in hardware or software products are 
advised that its use may infringe existing patents.
	The original developer of this software module and his/her company, the 
subsequent editors and their companies, and ISO/IEC have no liability for use of 
this software module or modifications thereof in an implementation. Copyright is 
not released for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
	ENST retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using the code 
for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright    
notice must be included in all copies or derivative works.              
						Copyright  2002.
*/

///////////////////////////////////////////////////////////////////////////
// File:  Layer2DProxy.h
//
// Author: Jean Le Feuvre ENST 2002
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef Layer2D_PROXY_H
#define Layer2D_PROXY_H


#include "GroupNodeProxy.h"
#include "drawable.h"


class Layer2DProxy : public GroupNodeProxy
{
public:
	Layer2DProxy(MediaObject* pMO);
	~Layer2DProxy();

	// Return a pointer to the Layout node that this node is the proxy for
	Layer2D* GetLayer2D() const { return (Layer2D*)GroupNodeProxy::GetObject(); }

	// Functions inherited from the base classes
	void Render(Effects *effects);

	//used by layer2D for tracing stacks
	virtual BindableStack *GetBackgroundStack() { return m_pBackgroundStack; }
	virtual BindableStack *GetViewportStack() { return m_pViewportStack; }

private:

	//background list. 
	BindableStack * m_pBackgroundStack;
	//viewport list
	BindableStack * m_pViewportStack;

	BOOL m_bFirst;

	DrawableContext m_drawableContext;

};

#endif // Layer2D_PROXY_H
