#include "OpenGl/OpenGl.h"
#include "Executive3d.h"
#include "opengl/base/OpenGLPresenter.h"

Executive3d::Executive3d(
  CMmiDoc * poDoc, 
  Application * poApp,
  HWND hWnd, 
  FILE * poFileTrace,
  int iFlags) :
Executive(
  poApp,
  hWnd,
  poFileTrace,
  iFlags)
{
  //TRACE("[Exec3d::Ctor] \n");
  mpoDoc = poDoc;
}

Executive3d::~Executive3d()
{
  //TRACE("[Exec3d::Dtor] \n");
}

/*-----------------------------------------------------------------
Finish is called from ALManager at end of session or error.
If the main service finished, wait till all streams are played to end,
and notify the application.
-----------------------------------------------------------------*/
//ML - changed RESPONSE_PARAMETER to RESPONSE
void Executive3d::OnFinish(
  ALManager* /*poAlManager*/, 
  RESPONSE /*eReason*/)
{
  //TRACE("[Exec3d::OnFinish] begin \n");
#ifdef ML_CANNOT_FIX
  if (poAlManager == m_pAL)
	{	m_smpOpenStreams.P ();
		m_smpOpenStreams.V ();
		CMmiDoc * poDoc = mpoDoc;
		m_smpActive.V ();

		//TRACE("[Exec3d::OnFinish] calling Doc::OnFinish \n");
		poDoc -> OnFinish (eReason);
	}
#endif
}

void Executive3d::SetPresenter(OpenGLPresenter * poPresenter)
{
  m_pPresenter = poPresenter;
}
  
void Executive3d::ReSize(int iWidth, int iHeight)
{
  if (m_bActive)
    ((OpenGLPresenter *) m_pPresenter) -> ReSize (iWidth, iHeight);
}
