//$Log: AArithDec.cpp,v $
//Revision 1.1.1.1  2003/12/24 00:55:03  mikeseven
//Initial release of the CVS repository for MPEG-4 Systems code
//after the code was corrupted due to reorganization and human 
//errors.
//
//Revision 1.1.1.2  2003/01/30 16:28:28  payan
//no message
//
//Revision 1.1.1.1  2002/07/18 01:08:23  mikeseven
//Initial check in of July 17, 2002 version
//
//Revision 1.1.1.1  2001/10/08 17:20:43  lanouiller
//Cration de la base du projet BifsAnim
//
//Revision 1.1.2.1  2000/03/10 15:59:32  Alex Cotarmanac'h
//deuxime envoi
//
//Revision 1.1  2000/03/03 18:41:21  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
// Je modifie ce fichier pour pouvoir lire directement sur le BifsDecoder.
// AC <alexandre.cotarmanac-h@polytechnique.org>
/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

  SUBSYSTEM:  Decoder
  FILE:       AnimationStreamDec.cpp
  AUTHOR:     Mikael Bourges-Sevenier (France Telecom CNET/DIH/ATI)
  OVERVIEW:   Implementation of AArithmeticDecoder
-------------------------------------------------------------------------*/

/************************************************************************
 *
 *  sac.c, part of tmndecode (H.263 decoder)
 *  Copyright (C) 1996  Telenor R&D, Norway
 *        Karl Olav Lillevold <Karl.Lillevold@nta.no>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Karl Olav Lillevold               <Karl.Lillevold@nta.no>
 *  Telenor Research and Development
 *  P.O.Box 83                        tel.:   +47 63 84 84 00
 *  N-2007 Kjeller, Norway            fax.:   +47 63 81 00 76
 *
 *  Robert Danielsen                  e-mail: Robert.Danielsen@nta.no
 *  Telenor Research and Development  www:    http://www.nta.no/brukere/DVC/
 *  P.O.Box 83                        tel.:   +47 63 84 84 00
 *  N-2007 Kjeller, Norway            fax.:   +47 63 81 00 76
 *  
 ************************************************************************/

/*********************************************************************
 *        SAC Decoder Module
 *        Algorithm as Specified in H26P Annex -E
 *              (c) 1995 BT Labs
 *
 *	Author:	Wayne Ellis <ellis_w_wayne@bt-web.bt.co.uk>
 *
 *********************************************************************/

#include "defs.h"

#ifdef PREDICTIVE	//AC 20000227

#include "AArithDec.h"
#include "BifsDec.h"
#include "Except.h"
/*********************************************************************
 *        SAC Decoder Algorithm as Specified in H26P Annex -E
 *
 *        Name:        decode_a_symbol
 *
 *	Description:	Decodes an Aritmetically Encoded Symbol
 *
 *	Input:        none. Uses built-in array of cumulative frequencies.
 *
 *	Returns:	Index to relevant symbol model
 *
 *	Side Effects:	Modifies low, high, length, cum and code_value
 *
 *	Author:        Wayne Ellis <ellis_w_wayne@bt-web.bt.co.uk>
 *
 *********************************************************************/
 
AArithmeticDecoder::AArithmeticDecoder(BIFSDecoder *pAS) :
  nb_of_symbols(256),freq(NULL),cumul_freq(NULL),pin(pAS),
  bitcount(0),opposite_bits(0),zerocount(0),buffer(0),m_isToFlush(false)
{
	  bits_used=0;
}

AArithmeticDecoder::~AArithmeticDecoder() {
  if(cumul_freq) delete[] cumul_freq;
  if(freq) delete[] freq;
}

/*-----------------------------------------------------------------
Gets a bit out of PSC layer
-----------------------------------------------------------------*/
BOOL AArithmeticDecoder::bit_out_psc_layer()
{
	int pinBit;
	try {
		 pinBit=pin->ParseInt(1,"bit_out_psc_layer");
	}
	catch ( BifsException ) // Nota we do not check really what's going on...
	{
//		printf("[AArithmeticDecoder] End of File : filling with zeros\n");
		pinBit=(zerocount==ZEROMAX)?1:0; // avoid Marker Bit Error
	}
	inBits+=pinBit;
	buffer <<= 1;
	buffer |= (pinBit?1:0);
#if 1
	ASSERT(ZEROMAX==22);
	if(zerocount == ZEROMAX) {
		bitcount++;
		fprintf(stderr,"ZEROMAX\n");
		if(!pinBit) 
		{
			fprintf(stderr, "MARKER BIT error in arithmetic decoding\n");
#ifdef TRACE_ENCODING
			for (int i=0;i<10;i++)
				pin->TraceNewLine();
/*
			pin->Error(SCENE_PARSING_ERROR);
			exit(1);
*/
#endif
			return FALSE;
		}
		pinBit=pin->ParseInt(1,"bit_out_psc_layer");
		inBits+=pinBit;
		buffer <<= 1;
		buffer |= pinBit;
		zerocount = 0;
	}
#endif
  
	Bit = pinBit;
	//fprintf(stderr,"[AArithmeticDecoder::bit_out_psc_layer,Bit] %d \n",Bit);
	bitcount++;
	m_isToFlush=true;
	if(!Bit) zerocount++;
	else zerocount = 0;
	//printf(" %d",(Bit?1:0));
	return TRUE;
}
/*-----------------------------------------------------------------
Send back buffer : so that ParseInt can come back to the correct values
-----------------------------------------------------------------*/
void AArithmeticDecoder :: flush()
{
	if (m_isToFlush) 
	{
//		printf("bits_used = %d\n",bits_used);
		int value=0;
		for (int j=(bits_used+1); j<inBits.GetLength();j++)
		{
			value = (value<<1) + inBits[j];
		}
		pin->setIntBuffer(value,14);
//		fprintf(stderr,"[AArithmeticDecoder::flush]InBits.len %d \n",inBits.GetLength());
//		fprintf(stderr,"[AArithmeticDecoder::flush] %d (contre %d)en (code_value %d)\n",buffer&0xFFFF,value,code_value);
//		fprintf(stderr,"[AArithmeticDecoder::flush]opposite_bits %d\n",opposite_bits);
		
		m_isToFlush=false;
		bits_used=0;
		bitcount=0;
		code_value = 0;
		low = 0;
		high = TOP;
		zerocount = 0;
		bitcount=0;
		opposite_bits=0;
	}
}
void AArithmeticDecoder :: flushChoice()
{
		bits_used=0;
		bitcount=0;
		if(!bit_out_psc_layer())
			return;
		code_value = 2 * code_value + (Bit ? 1 : 0);
		 if(!bit_out_psc_layer())
			return;
		code_value = 2 * code_value + (Bit ? 1 : 0);
		code_value = code_value & TOP;
		low = 0;
		high = TOP;
		zerocount = 0;
		bitcount=0;
		opposite_bits=0;
		printf("[flushChoice], %d\n",code_value);

}
void AArithmeticDecoder :: clearBuffer()
{
			inBits.Clear();
}
void AArithmeticDecoder :: clearBufferChoice()
{
	inBits.Clear();
	if (m_isToFlush) 
	{
		pin->setIntBuffer(code_value,16);
		m_isToFlush=false;
	}
}
int AArithmeticDecoder ::ParseInt(int nbbits,const char * txt)
{
	assert(nbbits!=0);
	int k=0;
	int res=0;
	while (k<nbbits)
	{
		res= (res<<1) + (code_value>>15);
		bit_out_psc_layer();
		code_value = (2 * code_value + (Bit ? 1 : 0)) & TOP;
		k++;
		fprintf(stdout,"%sRes= %d Code_value=%d\n",txt,res,code_value);
	}
	return res;
}
/*-----------------------------------------------------------------
Fills Decoder FIFO after a fixed word length string has been detected.
-----------------------------------------------------------------*/
BOOL AArithmeticDecoder :: reset()
{
  int i;
  
  code_value = 0;
  low = 0;
  high = TOP;
  zerocount = 0;
  bitcount=0;
  opposite_bits=0; // OO : opposite_bits gets reset here, because it is not in flush()
  
  for (i = 1;   i <= CODEVALNBBITS;   i++) {
    if(!bit_out_psc_layer())
      return FALSE;
    code_value = 2 * code_value + (Bit ? 1 : 0);
  }
  
  return TRUE;
}

/*-----------------------------------------------------------------
Decodes a symbol from stream and updates statistics
-----------------------------------------------------------------*/
int AArithmeticDecoder :: decodeAndUpdate(ArithModel &model, int &nbused, int&bcount)
{
	nbused=bits_used;
	bcount=bitcount;
	
  int val=decode(model);
//  printf("val=%d\n",val);
  update(val,model);
  nbused= bits_used -nbused;
  bcount= bitcount -bcount;
  return val;
}

/*-----------------------------------------------------------------
Decodes a symbol from stream 
-----------------------------------------------------------------*/
int AArithmeticDecoder :: decode(ArithModel &model)
{
  length = high - low + 1;
  cum = (-1 + (code_value - low + 1) *  model.getCumulFreq(0)) / length;
  
  for (sacindex = 1; model.getCumulFreq(sacindex) > (int) cum; sacindex++);
  
  high  = low - 1 + (length * model.getCumulFreq(sacindex-1)) / model.getCumulFreq(0);
  low  +=           (length * model.getCumulFreq(sacindex  )) / model.getCumulFreq(0);
  
  bitcount=0;
  
  for ( ; ; ) {
    if (high < Q2) 
      opposite_bits=0;
    else if (low >= Q2) {
      code_value -= Q2;
      low -= Q2;
      high -= Q2;
      opposite_bits=0;
    }
    
    else if (low >= Q1 && high < Q3) {
      code_value -= Q1;
      low -= Q1;
      high -= Q1;
      opposite_bits++;
    }
    
    else {
      break;
    }
    
    low *= 2;
    high = 2*high + 1;
    if(!bit_out_psc_layer())
      return DEC_ERROR;
    code_value = 2*code_value + (Bit ? 1 : 0);
	bits_used++;
  }
//  fprintf(stderr,"[Message] Reste encore : %d (ai lu %d)\n", code_value, sacindex-1);
  return (sacindex-1);
}

void AArithmeticDecoder :: adjustBits()
{
  opposite_bits++;
  fprintf(stderr,"NE SAIS PAS FAIRE ENCORE !!!!!!!");
  //pin->adjustBits();
}

#endif	//AC end
