//$Log: AArithDec.h,v $
//Revision 1.1.1.1  2003/12/24 00:55:03  mikeseven
//Initial release of the CVS repository for MPEG-4 Systems code
//after the code was corrupted due to reorganization and human 
//errors.
//
//Revision 1.1.1.2  2003/01/30 16:28:28  payan
//no message
//
//Revision 1.1.1.1  2002/07/18 01:08:23  mikeseven
//Initial check in of July 17, 2002 version
//
//Revision 1.1  2000/03/03 18:41:21  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
// AC <alexandre.cotarmanac-h@polytechnique.org>
// -*- c++ -*-



#ifndef __AARITHDEC_H_
#define __AARITHDEC_H_

#define CPLUSPLUS

#include "ArithModel.h"
#include "ztl.h"
class BIFSDecoder;


class AArithmeticDecoder {
private:
  // Adapative Arithmetic Coding
  unsigned int low, high, code_value, length, sacindex, cum;
  unsigned int bitcount;
  int nb_of_symbols, zerocount;
  unsigned int *freq,*cumul_freq;
  int buffer; // buffer for BifsDecoder
  BOOL Bit;
  int  opposite_bits;

  BIFSDecoder *pin;

public:
  AArithmeticDecoder(BIFSDecoder *pAS=NULL);
  ~AArithmeticDecoder();
  void setStream( BIFSDecoder *pAS) { pin=pAS; }

  void update(int symbol,ArithModel &model) { model.update(symbol); }
  void init(ArithModel &model) { model.init(); }

  int getBitCount() { return bitcount; }
  BOOL reset();
  int decode(ArithModel &model);
  int decodeAndUpdate(ArithModel &model, int &nbused, int&bitcount);
  void adjustBits();
  void flush();
  void flushChoice();
  int ParseInt(int nbbits,const char * txt);
  void clearBuffer();
  void clearBufferChoice();
private:
	bool m_isToFlush;
  BOOL bit_out_psc_layer();
  ZArray<int> inBits;
  int bits_used;
  
};

#endif // __AARITHDEC_H_
