//$Log: Predictive.cpp,v $
//Revision 1.1.1.1  2003/12/24 00:55:04  mikeseven
//Initial release of the CVS repository for MPEG-4 Systems code
//after the code was corrupted due to reorganization and human 
//errors.
//
//Revision 1.1.1.2  2003/01/30 16:28:29  payan
//no message
//
//Revision 1.1.1.1  2002/07/18 01:08:24  mikeseven
//Initial check in of July 17, 2002 version
//
//Revision 1.1.2.1  2000/03/10 15:59:32  Alex Cotarmanac'h
//deuxime envoi
//
//Revision 1.1  2000/03/03 18:41:21  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
#include "defs.h"

#ifdef PREDICTIVE	//AC 20000227

#include "Nodes.h"
#include "NodeFld.h"
#include "MediaObj.h"
#include "BifsDec.h"
#include "Route.h"
#include "Root.h"
#include "Quantize.h"
#include "NodeCode.h"
#include "Proto.h"
#include "ArithModel.h"
#include "AArithDec.h"
#include "Predictive.h"

// **************************************************************************
//			PredictiveMField :: PredictiveMField
PredictiveMField :: PredictiveMField(BIFSDecoder * pCoder, 
									MediaObject * pNode, 
									Quantizer * pQuant,
									MField * pMField) :

	m_pCoder ( pCoder ),
	m_pNode  ( pNode ),
	m_pQuant ( pQuant ),
	m_pMField( pMField ),
	m_numberOfFields( 0 ),
	m_IPPolicy ( -1 ),
	m_intraInterval ( -1 ),
	m_NbBounds ( -1 ),
	m_CompNbBits ( -1 ),
	m_NbFieldsNbBits( 0 )
{
	// Create a QP for this if necessary.
	MediaObject * a_QP;
	if ((a_QP=pCoder->GetCurrentQP()) == NULL)
	{
		fprintf(stdout,"[Message] a_QP is NULL\n");
		a_QP= SFGenericNode().CreateNode(CODE_QuantizationParameter);
	}
	m_pQuant->SetQPNode( a_QP );
	//
	m_quantNbBits=m_pQuant->GetQuantizationNbBits();
	if (m_quantNbBits == 0 ) fprintf(stderr,"[ERROR] Quantization in 0 bits !!\n");
	m_NbComp= getNbComp();
	m_Model[0]=NULL;
	m_Model[1]=NULL;
	m_Model[3]=NULL;
	m_BitModel = NULL;
	//m_Decoder = new AnimationStreamDecoder();
	//m_Decoder-> SetStream (NULL, pNode->GetExecutive (), pNode->GetRoot()  );
	//m_aad = new ArithmeticDecoder((AnimationStreamDecoder*)m_Decoder);
	m_aad = new AArithmeticDecoder(pCoder);
	
}

PredictiveMField :: ~PredictiveMField()
{
	clearModels();
	delete m_aad;
	//delete m_Decoder;
}
// **************************************************************************
//			PredictiveMField :: Parse

BOOL PredictiveMField :: Parse ()
{
	// Parse the PredictiveMFField
	//TRACEF("Predictive MField",3);
	//*********************************************************
	//							ParseArrayHeader	
	m_NbFieldsNbBits = m_pCoder->ParseInt(5,"m_NbFieldsNbBits");
	m_numberOfFields = m_pCoder->ParseInt(m_NbFieldsNbBits,"numberOfFields");
	//AC QP 14
	m_pCoder->setLengthCoord(m_numberOfFields);
	//AC end
	m_IPPolicy = m_pCoder->ParseInt(2,"IPPolicy");
	m_intraInterval=0;

	// Quantization stuff
	MediaObject *qpOld = m_pCoder->GetCurrentQP();
	if (qpOld == NULL) printf("Comprends pas ce beans\n");
	// get the quantizationType.
	m_quantType = m_pQuant->GetQuantizationType();
//	printf("Quantization type is : %d\n",m_quantType);
	
	switch (m_IPPolicy) 
	{
	case 1 : // An Intra every given number of predictive values
		m_intraInterval = m_pCoder->ParseInt(m_NbFieldsNbBits,"intraInterval");
	case 0 :
	case 2 :
		// Get CompNbbits : compensation bits ?
		m_CompNbBits = m_pCoder->ParseInt(5,"CompNbBits");
		m_NbBounds = getNbBounds(m_quantType); 
		PredictiveMField :: ParseCompMin( m_NbBounds);
		break;
	default:
		printf("Erreur!! cas non stipul\n");
		return FALSE;
	}
	resetDecodingModels();
	//*********************************************************
	//							ParseArrayOfValues
	return PredictiveMField :: ParseArrayOfValues ();
}



// **************************************************************************
//			PredictiveMField :: ParseArrayOfValues
BOOL PredictiveMField :: ParseArrayOfValues ()
{
#ifdef TRACE_ENCODING
	BIFSDecoder *pCoder = m_pCoder;
#endif
	// First Intra Value 0 : ArrayIValue
	if (!ParseIValue()) return FALSE;	
	m_aad->reset();
	// Other Fields
	for (int i=1; i<m_numberOfFields ; i++)
	{
		switch (m_IPPolicy) {
		case 0: 
			if (!PredictiveMField :: ParsePValue ()) return FALSE;// Predictive Value
			break;
		case 1: // an Intra every given number of fields
			if ( i%m_intraInterval == 0 ) 
			{
				m_aad->flush();
				m_aad->clearBuffer();
				ParseArrayQP();//				ARRAY QP
				if (! PredictiveMField :: ParseIValue ()) return FALSE;// Intra Value
				if (i<m_numberOfFields-1) m_aad->reset();
				//if (!m_pMField->AppendElement (m_pCoder, m_pNode, m_pQuant))
				//	return FALSE;	
			}
			else 
			{
				if (! PredictiveMField :: ParsePValue ()) return FALSE;// Predictive Value

			}
			break;
		case 2: // bit specified mode
			if ( m_aad->ParseInt(1,"isIntra") ) 
			{
				m_aad->clearBufferChoice();
				ParseArrayQP();//				ARRAY QP
				if (!  PredictiveMField :: ParseIValue ()) return FALSE;// Intra Value
				if (i<m_numberOfFields-1) m_aad->reset();
				//if (!m_pMField->AppendElement (m_pCoder, m_pNode, m_pQuant))
				//	return FALSE;
			}
			else
			{
				TRACEF("BIFS: bit (1) isIntra = 0 (0x0)", 0);
				// Setup the Arithmetic Adaptative Decoder.
				if (! PredictiveMField :: ParsePValue ()) return FALSE;// Predictive Value
				m_aad->flushChoice();
			}
			break;
		default :
			printf("Erreur : cas non stipul\n");
			return FALSE;

		}
	}
	if (m_IPPolicy==2)
		m_aad->clearBufferChoice();
		else m_aad->flush();
	TRACEINDENT (-1);
	TRACEF ("]", 0);
	return TRUE;
}
// **************************************************************************
BOOL PredictiveMField :: ParseIValue ()
{
	switch ( m_quantType ) 
	{
	case 9: // Normal
//		TRACEF("[Message] C'est une normale");
		m_curDirection=(m_pCoder->ParseInt(1,"direction") == 0)?1:-1;
	case 10:
		m_orientation=m_pCoder->ParseInt(2,"orientation");
		break;
	default:
		break;
	}
	
	for (int j=0; j< m_NbComp; j++) {
		m_curQuant[j]=m_pCoder->ParseInt(m_quantNbBits,"readingIntraCompo");
//		printf("curQuant[%d] = %d\n",j, m_curQuant[j]);
	}
	unQuantize();
	return TRUE;
}

// **************************************************************************
BOOL PredictiveMField :: ParsePValue ()
{
	m_predDirection=0;
	int used,read;
	used=0;
	switch ( m_quantType ) 
	{
	case 9: // Normal
		m_predDirection=m_curDirection;		
		m_curDirection=m_aad->decodeAndUpdate( *m_BitModel,used,read);
		//==0)?1:-1 in adddelta
		//fprintf(stderr,"[Message] P-Normal : %d\n",m_curDirection);
		break;
	default:
		break;
	}
	int kModelCount=0;
	for (int j=0; j< m_NbComp; j++) {
		m_predQuant[j]= m_curQuant[j]; // save old cut quant.
		
		int pmin=m_CompMin[kModelCount] - (1<<m_quantNbBits);
		m_curQuant[j]=  m_aad->decodeAndUpdate(*(m_Model[kModelCount]), used, read) 
						+ pmin;// get new one from aad
		//fprintf(stdout,"\nUsed=%d, Read=%d curQuant[%d]=%d\n",used,read,j,m_curQuant[j]);
		kModelCount+=(m_NbBounds==1)?0:1; // do we need to change the model
	}
	Compensate();	// Compensate
	unQuantize();	// UnQuantize
	
	
	return TRUE;
}


// **************************************************************************
//			PredictiveMField :: ParseCompMin
void PredictiveMField :: ParseCompMin( int NbBounds)
{
		for (int i=0; i< NbBounds ; i++)
			m_CompMin[i] = m_pCoder->ParseInt(m_quantNbBits+1,"CompMin"); 
}


// **************************************************************************
//			PredictiveMField :: ParseArrayQP
void PredictiveMField :: ParseArrayQP()
{
	bool needToReset=true;// We will whatever reset decoding models (not specified in spec)
	if (m_pCoder->ParseInt(1,"hasQP")) // read Array QP
	{
		if (m_IPPolicy==1) 
			m_intraInterval = m_pCoder->ParseInt(m_NbFieldsNbBits,"intraInterval");
		if ( m_pCoder->ParseInt(1,"hasCompNbBits") ){
			needToReset=true;
			m_CompNbBits = m_pCoder->ParseInt(5,"CompNbBits"); // reRead CompNbBits
		}
		if ( m_pCoder->ParseInt(1,"hasCompMin") ){
			needToReset=true;
			ParseCompMin(  m_NbBounds); // reRead CompMin
		}
	}
	if (needToReset) resetDecodingModels();
}
// **************************************************************************
//			PredictiveMField :: getNbComp
int PredictiveMField :: getNbComp ()
{
	switch (m_pMField->GetType())
	{

		case MFCOLOR :
		case MFVEC3F : 
			if (m_pQuant->GetQuantizationType()==9) return 2;//normals
		case MFROTATION : 
			return 3;
		case MFVEC2F :  
			return 2;
		case MFFLOAT : 
		case MFINT32 : 
			return 1;
		default:
			::fprintf(stderr,"[ERROR] Unsupported Field Type\n");
			return 0;
	}
}

// **************************************************************************
//			PredictiveMField :: getNbBounds

int PredictiveMField :: getNbBounds( int quantType)
{
	switch (quantType) // animType
	{
	case 1 :
		return 3;
	case 2 :
		return 2;
	default :
		return 1;
	}
}

// **************************************************************************
//			PredictiveMField :: resetDecodingModels
void PredictiveMField :: resetDecodingModels()
{
	if (m_Model[0]== NULL) {
		createModels();
	}
	resetModels();
}
// **************************************************************************
//			PredictiveMField :: createModels
void PredictiveMField :: createModels()
{
	for(int k=0;k<m_NbBounds;k++)
		m_Model[k]=new ArithModel();
	m_BitModel=new ArithModel();
}

// **************************************************************************
//			PredictiveMField :: resetModels
void PredictiveMField :: resetModels()
{
	  for (int k=0;k<m_NbBounds;k++)
		  m_Model[k]->init(1<< m_CompNbBits);
	  m_BitModel->init(2);
//	::fprintf(stderr,"[MESSAGE] ArithModels reset\n");

}
// **************************************************************************
//			PredictiveMField :: resetModels
void PredictiveMField :: clearModels()
{
	  for (int k=0;k<m_NbBounds;k++)
		  delete m_Model[k];
	  delete m_BitModel;
//	::fprintf(stderr,"[MESSAGE] ArithModels deleted\n");

}

// **************************************************************************
//			PredictiveMField :: Compensate
void PredictiveMField :: Compensate()
{
	switch ( m_quantType )
	{
	case 9: // Normal
	case 10: // Rotation
		addDelta();
		break;
	default:
		for (int i=0; i< m_NbComp ; i++)
			m_curQuant[i] = m_predQuant [i] + m_curQuant[i];
	}
}
// **************************************************************************
//			PredictiveMField :: addDelta
void PredictiveMField :: addDelta ()
{
	// need to shift data.
	for (int i=0;i<3;i++)
	{
		m_predQuant[i] = m_predQuant[i] - (1 << (m_quantNbBits -1));
		m_curQuant[i]  = m_curQuant[i]  - (1 << (m_quantNbBits -1));
	}
	// ...
	int scale= (1 << (m_quantNbBits -1)) - 1;
	int deltaInverse = (m_curDirection==0)? 1 : -1;
	int diffDirection = m_predDirection * deltaInverse;
	int newQuant[3];
	int inv=1;
	int diffOrientation=0;
	for (int j=0; j< m_NbComp; j++) {
		newQuant[j]=m_predQuant[j] + m_curQuant[j];
		if ( ::abs(newQuant[j]) > scale ) {
			diffOrientation = j+1;
			inv = ( newQuant[j] > 0) ? 1 : -1;
			break;
		}
	}
	if (diffOrientation != 0) {
		int k=0;
		for (int j=0; j< m_NbComp - diffOrientation; j++) {
			k = (j+diffOrientation) % m_NbComp;
			newQuant[j] = inv * ( m_predQuant[k] +  m_curQuant[k]);
		}
		k=diffOrientation - 1;
		newQuant[m_NbComp - diffOrientation] = inv * 2 * scale - (m_predQuant[k]+m_curQuant[k]) ; 
		for (j= m_NbComp - diffOrientation+1; j< m_NbComp ; j++) {
			k = (j+diffOrientation-1) % m_NbComp;
			newQuant[j] = inv * ( m_predQuant[k] +  m_curQuant[k]);
		}
	}
	// restore current curQuant Data
	m_orientation= (m_orientation + diffOrientation)% (m_NbComp + 1);
	m_curDirection= diffDirection*inv;
	
	for (j=0; j< m_NbComp; j++) 
		m_curQuant[j]= newQuant[j] + (1 << (m_quantNbBits -1)); //Unshift
	
}
// **************************************************************************
//			PredictiveMField :: unQuantize
void PredictiveMField :: unQuantize ()
{
	BIFSDecoder *pCoder = m_pCoder;
	switch (m_quantType)
	{
	case 9:
		{
			Vec3f res = 
				m_pQuant->unQuantizeNormal(m_curQuant,m_curDirection, m_orientation);
			//printf(" % 6.4f % 6.4f % 6.4f ,\n",res.x, res.y, res.z);
			TRACEF3("% 6.4f % 6.4f % 6.4f ,",res.x, res.y, res.z);
			TRACENEWLINE;
			m_pMField->addElement(res);
		}
		break;
	case 10:
		{
			// we set curDirection to 1
			Rotation res=m_pQuant->unQuantizeRotation(m_curQuant,1, m_orientation);
			//printf(" % 6.4f % 6.4f % 6.4f % 6.4f,\n",res.x, res.y, res.z, res.theta);
			//TRACEF(" %4d %4d %4d %4d,\t",m_orientation, m_curQuant[0], m_curQuant[1], m_curQuant[2]);
			TRACEF4("% 6.4f % 6.4f % 6.4f % 6.4f,",res.x, res.y, res.z, res.theta);
			TRACENEWLINE;
			m_pMField->addElement(res);
		}
		break;
	default:
		switch (m_pMField->GetType())
		{
		case MFFLOAT :
			{
			float natV=0;
			natV = m_pQuant->unQuantizeFloat(m_curQuant[0]);
			TRACEF("%f",natV);
			TRACENEWLINE;
			m_pMField->addElement(natV);
			}
			break;
		case MFVEC3F :
			{
				Vec3f res=m_pQuant->unQuantizeVec3f(m_curQuant);
				//printf(" % 6.4f % 6.4f % 6.4f ,\n",res.x, res.y, res.z);
				TRACEF3("% 6.4f % 6.4f % 6.4f ,",res.x, res.y, res.z);
				TRACENEWLINE;
				m_pMField->addElement(res);
			}
			break;
		case MFVEC2F :
			{
				Vec2f res = m_pQuant->unQuantizeVec2f(m_curQuant);
				//printf(" % 6.4f % 6.4f ,\n",res.x, res.y);
				TRACEF2(" % 6.4f % 6.4f ,",res.x, res.y);
				TRACENEWLINE;
				m_pMField->addElement(res);
			}
			break;
		case MFCOLOR :
			{
			Color3f res=m_pQuant->unQuantizeColor3f(m_curQuant);
			TRACEF3("% 6.4f % 6.4f % 6.4f ,",res.r, res.g, res.b);
			TRACENEWLINE;			
			m_pMField->addElement(res);
			}
			break;
		case MFINT32 :
		{
			int natV=m_pQuant->unQuantizeInt(m_curQuant[0]);
			TRACEF(" %d ",natV);
			if (natV==-1) TRACENEWLINE;
			m_pMField->addElement(natV);
		}
			break;

		}

		break;
	}


	//::fprintf(stderr,"[ERROR] Not Implemented\n");
}

#endif	//AC end
