//$Log: Predictive.h,v $
//Revision 1.1.1.1  2003/12/24 00:55:04  mikeseven
//Initial release of the CVS repository for MPEG-4 Systems code
//after the code was corrupted due to reorganization and human 
//errors.
//
//Revision 1.2  2003/04/03 04:29:43  mikeseven
//Initial release of Player3D and MPEG-J for all MPEG-4 reference softwares players with samples.
//For installation, follow instructions in docs/Player3D_setup.doc.
//
//Many thanks to Prashanth Gujjeti and Viswanathan Swaminathan from Sun Microsystems.
//
//-- Mikael Bourges-Sevenier (Mindego)
//
//Revision 1.1.1.2  2003/01/30 16:28:29  payan
//no message
//
//Revision 1.1.1.1  2002/07/18 01:08:24  mikeseven
//Initial check in of July 17, 2002 version
//
//Revision 1.1  2000/03/03 18:41:21  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
//
#include "ztl.h"
#include "ztypes.h"
#include "MediaObj.h"
#include "FldTypes.h"
#include "ArithModel.h"
#include "AArithDec.h"
#include "NodeFld.h"


class PredictiveMField {
public :
	// constructeur.
	PredictiveMField(BIFSDecoder *, MediaObject *, 
					Quantizer *, MField * );
	PredictiveMField :: ~PredictiveMField();
	// parse
	BOOL Parse ();
private :
	BOOL ParseArrayOfValues ();
	BOOL ParseIValue ();
	BOOL ParsePValue ();
	void ParseCompMin(int );
	void ParseArrayQP();
	int getNbComp ();
	int getNbBounds( int );
	void resetDecodingModels();
	void createModels();
	void resetModels();
	void clearModels();
	void Compensate();
	void addDelta ();
	void unQuantize ();
	 // 
	BIFSDecoder * m_pCoder;
	MediaObject * m_pNode;
	Quantizer * m_pQuant;
	MField * m_pMField;
	Decoder * m_Decoder ;
	AArithmeticDecoder * m_aad;

	// read Values
	int m_NbFieldsNbBits;
	int m_numberOfFields;
	int m_IPPolicy;
	int m_intraInterval;
	int m_NbBounds;
	int m_CompNbBits;
	int m_NbComp;
	int m_CompMin[3] ; // there's maxi 3 CompMin.
	int m_quantType;   // quantification type.
	int m_quantNbBits;
	int m_curDirection;
	int m_predDirection;
	int m_orientation;
	int m_curQuant [3] ; // quantified value
	int m_predQuant [3]; // previous
	int m_vdelta [3];
	
	ArithModel * m_Model[3];
	ArithModel * m_BitModel;

};
// SOLARIS PORTING - Added a new line
