//$Log: ArithEncoder.cpp,v $
//Revision 1.1.1.1  2003/12/24 00:55:04  mikeseven
//Initial release of the CVS repository for MPEG-4 Systems code
//after the code was corrupted due to reorganization and human 
//errors.
//
//Revision 1.1.1.2  2003/01/30 16:28:29  payan
//no message
//
//Revision 1.1.1.1  2002/07/18 01:08:24  mikeseven
//Initial check in of July 17, 2002 version
//
//Revision 1.1.1.1  2001/10/08 17:20:43  lanouiller
//Cration de la base du projet BifsAnim
//
//Revision 1.1  2000/03/03 18:41:21  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
//Revision 1.2  1999/12/07 08:23:52  A C
//*** empty log message ***
//
//Revision 1.1  1999/12/06 01:08:22  A C
//*** empty log message ***
//
#include "defs.h"
#include "ArithEncoder.h"

bool ArithEncoder::reset()
{
	low=0;
	high=TOP;
	zerocount=0;
	m_bitcount=0;
	m_opposite_bits=0;
	return true;
}

void ArithEncoder::encodeAndUpdate(int val, ArithModel &model, char * str,int &bits)
{
	int a_obits=m_opposite_bits;
	encode(val,model,str);
	bits= m_bitcount + m_opposite_bits - a_obits;
	update(val,model);
}

void ArithEncoder::encodeAndUpdate(int val, ArithModel &model)
{
	encode(val,model);
	update(val,model);
}
	
void ArithEncoder::encode(int index, ArithModel &model,char * text)
{
	encode(index,model);
	text;
//	fprintf(stderr,"[Message] %s\n",text);
}

void ArithEncoder::encode(int index, ArithModel &model)
{
	length=high-low+1;
	high = low - 1 + ( length * model.getCumulFreq(index)) / model.getCumulFreq(0);
	low  += (length * model.getCumulFreq(index+1)) / model.getCumulFreq(0);
	m_bitcount=0;
	for (;;)
	{
		if (high<Q2) bit_opp_bits(false,"Encoding");
		else if (low>=Q2) 
			{
				bit_opp_bits(true,"Encoding");
				low -= Q2;
				high -= Q2;
			}
			else 
				if ( low>= Q1 && high < Q3 )
				{
					m_opposite_bits++;
					low -= Q1;
					high -= Q1;
				}
				else break;
			
		low *= 2;
		high = 2 * high +1;
	}
}

int ArithEncoder::flush()
{
	m_bitcount=0;
	m_opposite_bits++;
	int retValue=1+m_opposite_bits;
//	printf("ArithEncoder::flush(%d)\n",m_opposite_bits);
	if (low<Q1) bit_opp_bits(false,"AAE flush");
	else bit_opp_bits(true,"AAE flush");
	reset();
	return retValue;
}

void ArithEncoder::bit_opp_bits(bool bit,char *  str)
{
	bit_in_psc_layer(bit,str);
	while (m_opposite_bits> 0) 
	{
		bit_in_psc_layer(!bit,str);
		m_opposite_bits--;
	}
}

void ArithEncoder::bit_in_psc_layer(bool bit,char* str)
{
#if 1
	ASSERT(ZEROMAX==22);
	if (zerocount == ZEROMAX )
	{
		out+=true;
		m_bitcount ++;
		zerocount=0;
		fprintf(stderr,"[Message]ArithEncoder : marker bit!%s\n",str);
	}
#else
	zerocount=0;
	str;
#endif
	out+=bit;
//	fprintf(stderr,"[Mesage] ArithEncoder %d(%s)\n",bit,str);
	m_bitcount++;
	zerocount=bit?0:zerocount+1;
}