//$Log: NatInt.cpp,v $
//Revision 1.1.1.1  2003/12/24 00:55:04  mikeseven
//Initial release of the CVS repository for MPEG-4 Systems code
//after the code was corrupted due to reorganization and human 
//errors.
//
//Revision 1.1.1.2  2003/01/30 16:28:29  payan
//no message
//
//Revision 1.1.1.1  2002/07/18 01:08:25  mikeseven
//Initial check in of July 17, 2002 version
//
//Revision 1.1  2000/03/03 18:41:22  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
//<alexandre.cotarmanac-h@polytechnique.org>
#include "defs.h"
#include <assert.h>
#include "NatInt.h"
#include "QuantInt.h"
#include "Quantize.h"
#include "Token.h"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
bool NatInt::m_predictiveNatScheme=true;

NatInt::NatInt():m_value(-1),m_isPureNat(true),m_maxi(-1),m_mini(-1),m_nbbits(-1)
{
}

NatInt::NatInt(Quantizer * pQuant,int v,bool isPureNat): 
	m_value(v),m_isPureNat(isPureNat),m_maxi(-1),m_mini(-1),m_nbbits(-1)
{
		assert(pQuant!=NULL);
		pQuant->GetIntData(m_nbbits,m_mini,m_maxi);
}
NatInt::NatInt(int nbbits, float mini,float maxi, int v,bool isPureNat):
	m_value(v),m_isPureNat(isPureNat),m_maxi(maxi),m_mini(mini),m_nbbits(nbbits)
{
}

NatInt::~NatInt()
{

}

NatInt NatInt::parseValue(Quantizer * pQuant)
{
	int v=nextToken.GetInt();
	if (nextToken == TID_COMMA ) nextToken.Scan();
	return NatInt(pQuant,v,true);
}

QuantInt NatInt::Quantize()
{
	if (m_isPureNat)
		return QuantInt(m_nbbits,m_mini,m_maxi,
		Quantizer::Quantize(m_mini,m_maxi,m_nbbits,m_value));
	else {
		int sgn = (m_value>=0)?1:-1;
		int qval = sgn * Quantizer::Quantize(m_mini,m_maxi,m_nbbits,sgn * m_value);
		return QuantInt(m_nbbits,m_mini,m_maxi,qval);
	}
}

NatInt & NatInt::operator -=(NatInt a)
{
	m_value-= a.m_value;
	m_isPureNat = false; 
	return *this;
}


NatInt & NatInt::operator +=(NatInt aQI)
{
	//assert (aQI.m_pQuant == m_pQuant);
	m_value+=aQI.m_value;
	return *this;
}

NatInt operator+ (NatInt a, NatInt b)
{
	NatInt r = a;
	return (r+=b);
}

NatInt operator- (NatInt a, NatInt b)
{
	NatInt r = a;
	return (r-=b);
}

#ifdef DEBUGPREDICTIVE
void NatInt::Print(FILE * out)
{
	fprintf(out,"%4d",m_value);
	if (!m_isPureNat) fprintf(out,"D");
	fprintf(out," ");
}
#endif


