//$Log: NatNormal.h,v $
//Revision 1.1.1.1  2003/12/24 00:55:04  mikeseven
//Initial release of the CVS repository for MPEG-4 Systems code
//after the code was corrupted due to reorganization and human 
//errors.
//
//Revision 1.2  2003/04/03 04:29:43  mikeseven
//Initial release of Player3D and MPEG-J for all MPEG-4 reference softwares players with samples.
//For installation, follow instructions in docs/Player3D_setup.doc.
//
//Many thanks to Prashanth Gujjeti and Viswanathan Swaminathan from Sun Microsystems.
//
//-- Mikael Bourges-Sevenier (Mindego)
//
//Revision 1.1.1.2  2003/01/30 16:28:29  payan
//no message
//
//Revision 1.1.1.1  2002/07/18 01:08:25  mikeseven
//Initial check in of July 17, 2002 version
//
//Revision 1.1  2000/03/03 18:41:22  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
//<alexandre.cotarmanac-h@polytechnique.org>
#ifndef NATNORMALH
#define NATNORMALH
#include "Quantize.h"

class QuantNormal;


class NatNormal
{
public:
	enum { m_nbComp = 3 };
	NatNormal& operator+= (NatNormal);
	NatNormal& operator-= (NatNormal);
	NatNormal& operator = (const NatNormal &);
	NatNormal();
	NatNormal(Quantizer * pQuant,float x=0.0, float y=0.0, float z=0.0, bool isPureNat=true);
	NatNormal(int nbbits, float x, float y, float z, bool isPureNat=true);
	NatNormal(int nbbits, float quat[], bool isPureNat=true);
	virtual ~NatNormal();
	static NatNormal parseValue(Quantizer * pQuant);
	QuantNormal Quantize();
public:
	static bool m_predictiveNatScheme;
private:
	int m_nbbits;
	bool m_isPureNat; // is PureNat i.e. NatNormal difference ?
	float m_x;
	float m_y;
	float m_z;
	float m_quat[4]; // quaternion form.
private:
	void computeQuaternions();
#ifdef DEBUGPREDICTIVE
public:
	void Print(FILE *);
#endif
};
NatNormal operator+ (NatNormal a, NatNormal b);
NatNormal operator- (NatNormal a, NatNormal b);
#endif
// SOLARIS PORTING - Added a new line
