//$Log: NatVec2f.cpp,v $
//Revision 1.1.1.1  2003/12/24 00:55:04  mikeseven
//Initial release of the CVS repository for MPEG-4 Systems code
//after the code was corrupted due to reorganization and human 
//errors.
//
//Revision 1.1.1.2  2003/01/30 16:28:29  payan
//no message
//
//Revision 1.1.1.1  2002/07/18 01:08:25  mikeseven
//Initial check in of July 17, 2002 version
//
//Revision 1.1.2.1  2000/03/11 12:48:17  Alex Cotarmanac'h
//Vec2f
//
//<alexandre.cotarmanac-h@polytechnique.org>
#include "defs.h"
#include <assert.h>
#include "NatVec2f.h"
#include "QuantVec2f.h"
#include "Quantize.h"
#include "Token.h"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
bool NatVec2f::m_predictiveNatScheme=true;
NatVec2f::NatVec2f()
{
}
NatVec2f::NatVec2f(Quantizer * pQuant, float x, float y,bool isPureNat): 
	m_isPureNat(isPureNat),m_nbbits(-1),m_x(x),m_y(y)
{
		assert(pQuant!=NULL);
		pQuant->GetVec2fData(m_nbbits,m_mini,m_maxi);
}
NatVec2f::NatVec2f(int nbbits, float mini[],float maxi[], float x, float y,bool isPureNat):
	m_isPureNat(isPureNat),m_x(x),m_y(y),m_nbbits(nbbits)
{
		for (int i=0; i< m_nbComp; i++)
		{
			m_mini[i]=mini[i];
			m_maxi[i]=maxi[i];
		}
}

NatVec2f::~NatVec2f()
{

}

NatVec2f NatVec2f::parseValue(Quantizer * pQuant)
{
	float c[m_nbComp];
	for (int i=0; i< m_nbComp; i++)
		c[i]= nextToken.GetReal();
	if (nextToken == TID_COMMA ) nextToken.Scan();
	return NatVec2f(pQuant,c[0],c[1],true);
}

QuantVec2f NatVec2f::Quantize()
{
	int qv[2];
	float v[2];
	float sgv[2];
	v[0]=m_x;
	v[1]=m_y;

	for (int i=0; i<2; i++)
	{
		sgv[i]=(m_isPureNat || (v[i]>=0) )?1:-1;
		v[i]=(m_isPureNat)?v[i]: sgv[i]*v[i]+m_mini[i];
		qv[i]=sgv[i]*Quantizer::Quantize(m_mini[i],m_maxi[i],m_nbbits,v[i]);
	}
	return QuantVec2f(m_nbbits,m_mini,m_maxi,qv[0],qv[1]);
}

NatVec2f & NatVec2f::operator -=(NatVec2f a)
{
	m_x-= a.m_x;
	m_y-= a.m_y;

	m_isPureNat = false; 
	return *this;
}


NatVec2f & NatVec2f::operator +=(NatVec2f aQI)
{
	m_x+=aQI.m_x;
	m_y+=aQI.m_y;

	return *this;
}

NatVec2f operator+ (NatVec2f a, NatVec2f b)
{
	NatVec2f r = a;
	return (r+=b);
}

NatVec2f operator- (NatVec2f a, NatVec2f b)
{
	NatVec2f r = a;
	return (r-=b);
}

#ifdef DEBUGPREDICTIVE
void NatVec2f::Print(FILE * out)
{
//	fprintf(stdout,"(%f , %f , %f)",m_x,m_y,m_z);
	fprintf(out,"(% 5.2f , % 5.2f )",m_x,m_y);
	if (!m_isPureNat) fprintf(out,"D");
	fprintf(out," \n");
}
#endif


