//$Log: NatVec2f.h,v $
//Revision 1.1.1.1  2003/12/24 00:55:04  mikeseven
//Initial release of the CVS repository for MPEG-4 Systems code
//after the code was corrupted due to reorganization and human 
//errors.
//
//Revision 1.2  2003/04/03 04:29:44  mikeseven
//Initial release of Player3D and MPEG-J for all MPEG-4 reference softwares players with samples.
//For installation, follow instructions in docs/Player3D_setup.doc.
//
//Many thanks to Prashanth Gujjeti and Viswanathan Swaminathan from Sun Microsystems.
//
//-- Mikael Bourges-Sevenier (Mindego)
//
//Revision 1.1.1.2  2003/01/30 16:28:29  payan
//no message
//
//Revision 1.1.1.1  2002/07/18 01:08:25  mikeseven
//Initial check in of July 17, 2002 version
//
//Revision 1.1.2.1  2000/03/11 12:48:17  Alex Cotarmanac'h
//Vec2f
//
//<alexandre.cotarmanac-h@polytechnique.org>
#ifndef NATVEC2FH
#define NATVEC2FH
#include "Quantize.h"

class QuantVec2f;


class NatVec2f
{
public:
	enum { m_nbComp = 2 };
	NatVec2f& operator+= (NatVec2f);
	NatVec2f& operator-= (NatVec2f);
	NatVec2f();
	NatVec2f(Quantizer * pQuant,float x=0.0, float y=0.0,bool isPureNat=true);
	NatVec2f(int nbbits, float mini[],float maxi[], float x, float y,bool isPureNat=true);
	virtual ~NatVec2f();
	static NatVec2f parseValue(Quantizer * pQuant);
	QuantVec2f Quantize();
public:
	static bool m_predictiveNatScheme;
private:
	int m_nbbits;
	float m_maxi[2];
	float m_mini[2];
	bool m_isPureNat; // is PureNat i.e. NatVec2f belongs to [Min;Max]
					  // otherwise NatVec2f belongs to [Min-Max;Max-Min]
	float m_x;
	float m_y;

#ifdef DEBUGPREDICTIVE
public:
	void Print(FILE *);
#endif
};
NatVec2f operator+ (NatVec2f a, NatVec2f b);
NatVec2f operator- (NatVec2f a, NatVec2f b);
#endif
// SOLARIS PORTING - Added a new line
