//$Log: NatVec3f.h,v $
//Revision 1.1.1.1  2003/12/24 00:55:04  mikeseven
//Initial release of the CVS repository for MPEG-4 Systems code
//after the code was corrupted due to reorganization and human 
//errors.
//
//Revision 1.2  2003/04/03 04:29:44  mikeseven
//Initial release of Player3D and MPEG-J for all MPEG-4 reference softwares players with samples.
//For installation, follow instructions in docs/Player3D_setup.doc.
//
//Many thanks to Prashanth Gujjeti and Viswanathan Swaminathan from Sun Microsystems.
//
//-- Mikael Bourges-Sevenier (Mindego)
//
//Revision 1.1.1.2  2003/01/30 16:28:30  payan
//no message
//
//Revision 1.1.1.1  2002/07/18 01:08:25  mikeseven
//Initial check in of July 17, 2002 version
//
//Revision 1.1  2000/03/03 18:41:22  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
//<alexandre.cotarmanac-h@polytechnique.org>
#ifndef NATVEC3FH
#define NATVEC3FH
#include "Quantize.h"

class QuantVec3f;


class NatVec3f
{
public:
	enum { m_nbComp = 3 };
	NatVec3f& operator+= (NatVec3f);
	NatVec3f& operator-= (NatVec3f);
	NatVec3f();
	NatVec3f(Quantizer * pQuant,float x=0.0, float y=0.0, float z=0.0,bool isPureNat=true);
	NatVec3f(int nbbits, float mini[],float maxi[], float x, float y, float z,bool isPureNat=true);
	virtual ~NatVec3f();
	static NatVec3f parseValue(Quantizer * pQuant);
	QuantVec3f Quantize();
public:
	static bool m_predictiveNatScheme;
private:
	int m_nbbits;
	float m_maxi[3];
	float m_mini[3];
	bool m_isPureNat; // is PureNat i.e. NatVec3f belongs to [Min;Max]
					  // otherwise NatVec3f belongs to [Min-Max;Max-Min]
	float m_x;
	float m_y;
	float m_z;

#ifdef DEBUGPREDICTIVE
public:
	void Print(FILE *);
#endif
};
NatVec3f operator+ (NatVec3f a, NatVec3f b);
NatVec3f operator- (NatVec3f a, NatVec3f b);
#endif
// SOLARIS PORTING - Added a new line
