// PredictiveEncoder.h: interface for the PredictiveEncoder class.
//
//////////////////////////////////////////////////////////////////////
//$Log: PredictiveEncoder.h,v $
//Revision 1.1.1.1  2003/12/24 00:55:04  mikeseven
//Initial release of the CVS repository for MPEG-4 Systems code
//after the code was corrupted due to reorganization and human 
//errors.
//
//Revision 1.1.1.2  2003/01/30 16:28:30  payan
//no message
//
//Revision 1.1.1.1  2002/07/18 01:08:25  mikeseven
//Initial check in of July 17, 2002 version
//
//Revision 1.1  2000/03/03 18:41:22  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
//<alexandre.cotarmanac-h@polytechnique.org>
#if !defined(AFX_PREDICTIVEENCODER_H__D11C75A2_D821_11D3_8169_525405F4A0F5__INCLUDED_)
#define AFX_PREDICTIVEENCODER_H__D11C75A2_D821_11D3_8169_525405F4A0F5__INCLUDED_


#include "PredictiveParameters.h"	// Added by ClassView
#include "BifsEnc.h"
#include "Quantize.h"
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class PredictiveEncoderError  
{
public:
	PredictiveEncoderError();
	PredictiveEncoderError(const char * msg)
	{
		printf("PredictiveEncoderError::%s\n",msg);
	}
	virtual ~PredictiveEncoderError();

};

class PredictiveEncoder  
{
public:
	PredictiveEncoder(BIFSEncoder * pBifs, Quantizer * pQuantizer);
	virtual ~PredictiveEncoder();
	virtual void calcPredictiveVector()=0;
	int getNbFields();
	void setParameters(PredictiveParameters p);
	static void Encode(BIFSEncoder * pBifs, Quantizer * pQuant, MField * pMField, char * basename);
private:
	virtual void EncodeData()=0;

protected:
	
	
	PredictiveParameters m_params;
	virtual void parseNativeArray()=0;
	int m_nbFields;
	Quantizer * m_pQuant;
	BIFSEncoder * m_pBifs;
//#ifndef DEBUGPREDICTIVE
	ZArray<bool> m_outArray;
//#endif
	ZArray<int> m_outIndexes;
#ifdef DEBUGPREDICTIVE
public:
//	ZArray<bool> m_outArray;
	virtual void PrintInput()=0;
	virtual void PrintQ()=0;
	virtual void PrintDelta()=0;
	virtual void PrintPminNbBits()=0;
	virtual void PrintOutArray()=0;
	virtual void DecodeAndPrintOutArray()=0;
protected:
	FILE * m_out;
#endif
};




#endif // !defined(AFX_PREDICTIVEENCODER_H__D11C75A2_D821_11D3_8169_525405F4A0F5__INCLUDED_)
