// PredictiveParameters.h: interface for the PredictiveParameters class.
//
//////////////////////////////////////////////////////////////////////
//$Log: PredictiveParameters.h,v $
//Revision 1.1.1.1  2003/12/24 00:55:04  mikeseven
//Initial release of the CVS repository for MPEG-4 Systems code
//after the code was corrupted due to reorganization and human 
//errors.
//
//Revision 1.1.1.2  2003/01/30 16:28:30  payan
//no message
//
//Revision 1.1.1.1  2002/07/18 01:08:26  mikeseven
//Initial check in of July 17, 2002 version
//
//Revision 1.1.2.1  2000/03/10 15:59:33  Alex Cotarmanac'h
//deuxime envoi
//
//Revision 1.1  2000/03/03 18:41:22  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
//<alexandre.cotarmanac-h@polytechnique.org>
#if !defined(AFX_PREDICTIVEPARAMETERS_H__D11C75A5_D821_11D3_8169_525405F4A0F5__INCLUDED_)
#define AFX_PREDICTIVEPARAMETERS_H__D11C75A5_D821_11D3_8169_525405F4A0F5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "ztl.h"

enum IP_POLICY
{
	ALLPREDICTIVE = 0,//AC
	INTERVAL = 1 ,
	CHOICE = 2,
	UNKNOWN = -1
};

class PredictiveParameters  
{
public:
	IP_POLICY getPolicy();
	void Reset();
	PredictiveParameters(const PredictiveParameters &); // because of ZArrays.
	void finish(int nb_fields);
	void setIntraInterval(int i);
	int intraInterval(int i);
	int nextIntra(int i);
	void setIntra(int i);
	void setIPPolicy(IP_POLICY ip);
	PredictiveParameters();
	virtual ~PredictiveParameters();
	PredictiveParameters & operator =(const PredictiveParameters &pp);
private:	
	bool m_finished;
	ZArray<int> m_intraArray;
	ZArray<int> m_intraIntervalArray;
	int m_currentIndex;
	IP_POLICY m_IPPolicy;

};

#endif // !defined(AFX_PREDICTIVEPARAMETERS_H__D11C75A5_D821_11D3_8169_525405F4A0F5__INCLUDED_)
