//$Log: PredictiveParser.h,v $
//Revision 1.1.1.1  2003/12/24 00:55:04  mikeseven
//Initial release of the CVS repository for MPEG-4 Systems code
//after the code was corrupted due to reorganization and human 
//errors.
//
//Revision 1.2  2003/04/03 04:29:44  mikeseven
//Initial release of Player3D and MPEG-J for all MPEG-4 reference softwares players with samples.
//For installation, follow instructions in docs/Player3D_setup.doc.
//
//Many thanks to Prashanth Gujjeti and Viswanathan Swaminathan from Sun Microsystems.
//
//-- Mikael Bourges-Sevenier (Mindego)
//
//Revision 1.1.1.2  2003/01/30 16:28:30  payan
//no message
//
//Revision 1.1.1.1  2002/07/18 01:08:27  mikeseven
//Initial check in of July 17, 2002 version
//
//Revision 1.1  2000/03/03 18:41:22  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
//<alexandre.cotarmanac-h@polytechnique.org>
#include <fstream.h>
#include <iostream.h>
#include <string.h>
#include "PredictiveParameters.h"

enum TOKENS{
	PREDICTIVEPARAMS,
	IPPOLICY,
	ARRAYQP,
	INTRAINTERVAL,
	OBRACKET,
	CBRACKET,
	COMMA,
	VALUE,
	INTRA,
	EOFILE,
	ERREUR,
	NONE,
} ;

class PredictiveParserError {
public:
	PredictiveParserError(){}
	PredictiveParserError(const char * msg)
	{
		printf("PredictiveParserError::%s\n",msg);
	}
};

class PredictiveParser {
private:
	FILE * ifs;
	int value;
	PredictiveParameters & m_rParams;
	char * fName;
public:
	PredictiveParser(const char * basename, PredictiveParameters & rParams) : 
		m_rParams(rParams),
		m_line(0),
		m_arrayNdx(0)
	{
		fName = new char[(strlen(basename)+5)] ;
		strcpy(fName,basename);
		strcat(fName,".prd");
//		fprintf(stdout,"%s\n",fName);
		ifs=fopen(fName,"r");
		if (ifs == NULL) {
				fprintf(stderr,"[ERROR] Unable to open %s\n",basename);
				delete [] fName;
				throw PredictiveParserError("OpenFile");
		}

	}
	static void Parse(const char * basename,int nb_fields,PredictiveParameters &);
	~PredictiveParser(){
		fclose(ifs);
		delete [] fName;
	}
	void operator =(const PredictiveParser&);//comprends pas !!
private:
	TOKENS getToken();
	void ParseBody();
	void ParseQP(bool isInitial);
	void ParseExtra();
	void ErrorMessage(char *s);
	int m_ippolicy;
	int m_intraInterval;
	int m_line;
	int m_arrayNdx;
};
// SOLARIS PORTING - Added a new line
