//$Log: QuantInt.cpp,v $
//Revision 1.1.1.1  2003/12/24 00:55:04  mikeseven
//Initial release of the CVS repository for MPEG-4 Systems code
//after the code was corrupted due to reorganization and human 
//errors.
//
//Revision 1.1.1.2  2003/01/30 16:28:31  payan
//no message
//
//Revision 1.1.1.1  2002/07/18 01:08:27  mikeseven
//Initial check in of July 17, 2002 version
//
//Revision 1.1  2000/03/03 18:41:23  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
//<alexandre.cotarmanac-h@polytechnique.org>
#include <assert.h>
#include "defs.h"
#include "NatInt.h"
#include "QuantInt.h"
#include "ztl.h"
#include "ArithModel.h"
#include "BifsEnc.h"
#ifdef DEBUGPREDICTIVE
#include "AArithDecoder.h"
#endif
//********************************************************************************
extern int getNbBits(int k);

//********************************************************************************
extern void writeInt(ZArray<bool> &o, int n, int nBits);

//********************************************************************************
QuantInt::QuantInt(): m_value(-1), m_mini(-1), m_maxi(-1), m_nbbits(-1)
{
}
QuantInt::~QuantInt()
{

}
//********************************************************************************
QuantInt::QuantInt( Quantizer *pQuant,int x) : 
	m_value(x), m_mini(-1), m_maxi(-1), m_nbbits(-1)
{
		assert(pQuant !=NULL);
		pQuant->GetIntData(m_nbbits,m_mini,m_maxi);
		assert (m_nbbits>=0);
}
//********************************************************************************
QuantInt::QuantInt(int nbbits, float mini, float maxi, int x):
	m_value(x), m_mini(mini), m_maxi(maxi),m_nbbits(nbbits)
{
}
//********************************************************************************
void QuantInt::setNbAACModels(Quantizer * pQuant)
{
	pQuant;
	return;
}
//********************************************************************************
QuantInt QuantInt::CompMin(ZArray<QuantInt> & qFArray, int begin, int end, int &nbits)
{
	QuantInt Min=qFArray[begin];
	QuantInt Max=qFArray[begin];
	for (int i=begin+1; i<end;i++)
	{
#ifdef DEBUGPREDICTIVE
#ifdef DEBUGCOMPMIN
		printf("[ min= ");
		Min.Print();
		printf(" ; max= ");
		Max.Print();
		printf(" ]\n");
#endif
#endif
		if (qFArray[i].m_value<Min.m_value) 
			Min=qFArray[i];
		if (qFArray[i].m_value>Max.m_value) 
			Max=qFArray[i];
	}
	nbits=getNbBits(Max.m_value - Min.m_value);
	return Min;
}
//********************************************************************************
void QuantInt::Shift(ZArray<QuantInt> &d, ZArray<QuantInt> &q, 
					   QuantInt PMin, int begin, int end)
{
	for (int i=begin; i<end;i++)
		d.SetAt(i,q[i]-PMin);
}
//********************************************************************************
QuantInt QuantInt::unShift(QuantInt a, QuantInt Pmin)
{
	return (a+Pmin);
}
//********************************************************************************
void QuantInt::AAEncode(ZArray<bool> & oA, ZArray<int> &oIndx, ZArray<QuantInt> & iA, 
						  int nbbits, int begin, int end, bool isChoice)
{
	ArithModel model[m_nbComp]; 
	for (int h=0; h<m_nbComp; h++) { 
		model[h]=ArithModel(); 
		model[h].init(1<<nbbits); //compnbbits
	}
	
	ArithEncoder aae= ArithEncoder(oA);
	aae.reset();
	for (int i=begin; i<end;i++)
	{
		
#ifdef DEBUGPREDICTIVE
//#ifdef DEBUGAAENCODE
//		int k=iA[i].m_value;
//		printf("{encoding %d : (%d) < %d}\n",i,k,1<< nbbits);
//		model[0].PrintFreq();
//		model[0].PrintCumFreq();
//#endif
#endif
		int bits=iA[i].EncodeAA(aae,model);
		if (isChoice && (i!=end-1)) 
		{
			int obits=bits;
			bits+=aae.flush();
			printf("[AAEC]oA.GetLength %d ?  bitsT=%d obits=%d nbits=%d\n",oA.GetLength(),bits+oIndx[i-1],obits,bits);
		}
		//printf("[AAEC]%d in %d bits\n",i,bits);
		if (i!=end-1) oIndx.SetAt(i,bits+oIndx[i-1]/*oA.GetLength()*/);
		//oIndx.SetAt(i,bits+oIndx[i-1]
	}
#ifdef DEBUGPREDICTIVE
//#ifdef DEBUGAAENCODE
//	model[0].PrintFreq();
//#ifdef DEBUGAAENCODE
#endif
	aae.flush();
	oIndx.SetAt(end-1,oA.GetLength());
	printf("{End if this round} begin=%d; end=%d; oIndx[end-1]=%d; outArray.lg()=%d\n",begin,end,oIndx[end-1], oA.GetLength());
	
}
//********************************************************************************
int QuantInt::EncodeAA(ArithEncoder & aae, ArithModel model[] )
{
	int bits=0;
	for (int h=0; h<m_nbComp; h++) 
		aae.encodeAndUpdate(m_value,model[h],"AAC",bits);
	return bits;
}
//********************************************************************************
void QuantInt::WriteIntra(ZArray<bool> &o)
{
	int nbBits = m_nbbits;
	writeInt(o, m_value, nbBits);
}
//********************************************************************************
QuantInt & QuantInt::operator +=(QuantInt aQI)
{
	//assert (aQI.m_pQuant == m_pQuant);
	m_value+=aQI.m_value;
	return *this;
}
//********************************************************************************
QuantInt & QuantInt::operator -=(QuantInt aQI)
{
	//assert (aQI.m_pQuant == m_pQuant);
	m_value-=aQI.m_value;
	return *this;
}
//********************************************************************************
NatInt QuantInt::unQuantize()
{
	return NatInt(m_nbbits,m_mini,m_maxi,
		Quantizer::unQuantize(m_value,m_mini,m_maxi,m_nbbits,false));
}
//********************************************************************************
QuantInt operator+ (QuantInt a, QuantInt b)
{
	QuantInt r = a;
	return (r+=b);
}
//********************************************************************************
QuantInt operator- (QuantInt a, QuantInt b)
{
	QuantInt r = a;
	return (r-=b);
}
//********************************************************************************
bool operator != (QuantInt a, QuantInt b)
{
	return (a.m_value!=b.m_value);
}
//********************************************************************************
void QuantInt::Encode(BIFSEncoder *pBifs)
{
		pBifs->EncodeInt(m_value,m_nbbits,"Intra");
}
//********************************************************************************
void QuantInt::EncodePMin(BIFSEncoder *pBifs)
{

	pBifs->EncodeInt(m_value+(1<<m_nbbits),m_nbbits+1,"CompMin");
}
//********************************************************************************
//********************************************************************************

#ifdef DEBUGPREDICTIVE
//********************************************************************************
int QuantInt::Decode(ZArray<QuantInt> & decArray, ZArray<bool> & m_outArray,int index,
		int nb, int aadnbBits,Quantizer * m_pQuant, FILE * out, bool isChoice)
{
	fprintf(out,"[QuantInt::Decode] index=%d\n",index);
	int ibits=m_pQuant->GetQuantizationNbBits();
	int v=0;
	for (int i=0; i<ibits; i++) v= (v<<1) + (m_outArray[i+index]?1:0);
	printf("QuantV = %d (index=%d)",v,index);
	QuantInt IntraV= QuantInt(m_pQuant,v);
	decArray+=IntraV;

	ArithModel model[m_nbComp]; 
	for (int h=0; h<m_nbComp; h++) { 
		model[h]=ArithModel(); 
		model[h].init(1<<aadnbBits); //compnbbits
	}
	ArithDecoder aad= ArithDecoder(m_outArray,index+ibits);
	aad.reset();
	int bitsRead=0;
	int bitsReadFrame=0;
	for (i=0; i< nb-1 ; i++)
	{
		QuantInt Value=QuantInt(m_pQuant,aad.decodeAndUpdate(model[0],bitsReadFrame));
		if (isChoice && (i+1 < nb-1)) 
		{
			aad.flush(bitsReadFrame);
		}
		fprintf(out,"[QuantInt::Decode](%d) value=",i);
		Value.Print(out);
		fprintf(out,"  (%d bits) [total =%d]\n",bitsReadFrame,bitsRead);
		decArray+=Value;
		bitsRead+=bitsReadFrame;
	}
	aad.flush(bitsRead);
	fprintf(out,"Finally read : %d\n",bitsRead);
	return bitsRead+ibits;
}
//********************************************************************************
void QuantInt::Print(FILE * out)
{
	fprintf(out,"%d ",m_value);
}
#endif



