//$Log: QuantNormal.h,v $
//Revision 1.1.1.1  2003/12/24 00:55:04  mikeseven
//Initial release of the CVS repository for MPEG-4 Systems code
//after the code was corrupted due to reorganization and human 
//errors.
//
//Revision 1.1.1.2  2003/01/30 16:28:31  payan
//no message
//
//Revision 1.1.1.1  2002/07/18 01:08:28  mikeseven
//Initial check in of July 17, 2002 version
//
//Revision 1.1  2000/03/03 18:41:23  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
//<alexandre.cotarmanac-h@polytechnique.org>
#ifndef QUANTNORMALH
#define QUANTNORMALH
#include "ztl.h"
#include "NatNormal.h"	// Added by ClassView
#include "Quantize.h"
#include "../Animation/ArithModel.h"
#include "ArithEncoder.h"


class QuantNormal 
{
	friend bool operator != (QuantNormal a, QuantNormal b);
public:
	enum { m_nbComp = 2 };
	QuantNormal();
	QuantNormal(Quantizer * pQuant,  int x=0, int y=0, int direction=0, int orient=0);
	QuantNormal(int nbbits,  int x=0, int y=0, int direction=0, int orient=0);
	QuantNormal& operator+= (QuantNormal);
	QuantNormal& operator-= (QuantNormal);
	virtual ~QuantNormal();
	NatNormal unQuantize();

//   ****			Predictive Encoder Functions
	static void setNbAACModels(Quantizer * pQuant);//sets static vars
	static QuantNormal CompMin(ZArray<QuantNormal> & qFArray,int begin,int end, int &nbits);
	static void Shift(ZArray<QuantNormal> & d, ZArray<QuantNormal> & q, QuantNormal PMin, int begin, int end);
	static QuantNormal unShift(QuantNormal a, QuantNormal Pmin);
	static void AAEncode(ZArray<bool> & o, ZArray<int> &oIndx, ZArray<QuantNormal> & i,int nbbits, int begin, int end, bool isChoice);
	void Encode(BIFSEncoder * pBifs);
	void EncodePMin(BIFSEncoder * pBifs);
	int getDirection() { return m_qv[0]; }
	int getQValue(int i) { assert(i>0); return m_qv[i]; }
		void WriteIntra(ZArray<bool> & o);
private:
	bool m_shifted;
	void unshift();
	void shift();
	int m_qv[4];
	int m_nbbits;
	static int m_nbAACModels;
	virtual int EncodeAA(ArithEncoder & aae, ArithModel model[] );
#ifdef DEBUGPREDICTIVE
public:
	static int Decode(ZArray<QuantNormal> & decArray, ZArray<bool> & m_outArray,int index,
		int nb,int aadnbBits,Quantizer * m_pQuant, FILE * out, bool isChoice);
	void Print(FILE *);
#endif
};

QuantNormal operator+ (QuantNormal a, QuantNormal b);
QuantNormal operator- (QuantNormal a, QuantNormal b);
#endif