//$Log: QuantRot.h,v $
//Revision 1.1.1.1  2003/12/24 00:55:04  mikeseven
//Initial release of the CVS repository for MPEG-4 Systems code
//after the code was corrupted due to reorganization and human 
//errors.
//
//Revision 1.1.1.2  2003/01/30 16:28:31  payan
//no message
//
//Revision 1.1.1.1  2002/07/18 01:08:28  mikeseven
//Initial check in of July 17, 2002 version
//
//Revision 1.1  2000/03/03 18:41:23  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
//<alexandre.cotarmanac-h@polytechnique.org>
#ifndef QUANTROTH
#define QUANTROTH
#include "ztl.h"
#include "NatRot.h"	// Added by ClassView
#include "Quantize.h"
#include "../Animation/ArithModel.h"
#include "ArithEncoder.h"


class QuantRot 
{
	friend bool operator != (QuantRot a, QuantRot b);
public:
	enum { m_nbComp = 3 };
	QuantRot();
	QuantRot(Quantizer * pQuant, int orient=0, int b=0, int c=0, int d=0);
	QuantRot(int nbbits,  int orient=0, int b=0, int c=0, int d=0);
	QuantRot& operator+= (QuantRot);
	QuantRot& operator-= (QuantRot);
	virtual ~QuantRot();
	NatRot unQuantize();

//   ****			Predictive Encoder Functions
	static void setNbAACModels(Quantizer * pQuant);//sets static vars
	static QuantRot CompMin(ZArray<QuantRot> & qFArray,int begin,int end, int &nbits);
	static void Shift(ZArray<QuantRot> & d, ZArray<QuantRot> & q, QuantRot PMin, int begin, int end);
	static QuantRot unShift(QuantRot a, QuantRot Pmin);
	static void AAEncode(ZArray<bool> & o, ZArray<int> &oIndx, ZArray<QuantRot> & i,int nbbits, int begin, int end, bool isChoice);
	void Encode(BIFSEncoder * pBifs);
	void EncodePMin(BIFSEncoder * pBifs);
		void WriteIntra(ZArray<bool> & o);
	int getDirection() { return m_qv[0]; }
	int getQValue(int i) { assert(i>0); return m_qv[i]; }
private:
	bool m_shifted;
	void unshift();
	void shift();
	int m_qv[4];
	int m_nbbits;
	static int m_nbAACModels;
	virtual int EncodeAA(ArithEncoder & aae, ArithModel model[] );
#ifdef DEBUGPREDICTIVE
public:
	static int Decode(ZArray<QuantRot> & decArray, ZArray<bool> & m_outArray,int index,
		int nb,int aadnbBits,Quantizer * m_pQuant, FILE * out, bool isChoice);
	void Print(FILE *);
#endif
};

QuantRot operator+ (QuantRot a, QuantRot b);
QuantRot operator- (QuantRot a, QuantRot b);
#endif