//$Log: QuantTypes.cpp,v $
//Revision 1.1.1.1  2003/12/24 00:55:05  mikeseven
//Initial release of the CVS repository for MPEG-4 Systems code
//after the code was corrupted due to reorganization and human 
//errors.
//
//Revision 1.1.1.2  2003/01/30 16:28:31  payan
//no message
//
//Revision 1.1.1.1  2002/07/18 01:08:29  mikeseven
//Initial check in of July 17, 2002 version
//
//Revision 1.2  2000/03/09 20:46:09  Alex Cotarmanac'h
//Fixed parameter bug
//
//Revision 1.1  2000/03/03 18:41:23  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
//<alexandre.cotarmanac-h@polytechnique.org>
#include <assert.h>
#include "defs.h"
#include "NatTypes.h"
#include "QuantTypes.h"
#include "ztl.h"
#include "ArithModel.h"
#include "BifsEnc.h"
#ifdef DEBUGPREDICTIVE
#include "AArithDecoder.h"
#endif
//********************************************************************************
int getNbBits(int k)
{
	int j=1;
	while (k >= (1<<j) ) 
	{
//		fprintf(stdout,"[Message] %d %d\n",j,1<<j);
		j++;
	}
	return j;
}
//********************************************************************************
void writeInt(ZArray<bool> &o, int n, int nBits)
{
	int nValue=n;
	nValue <<= sizeof (int) * 8 - nBits;
	while (--nBits >= 0)
	{	
		o+= (nValue < 0);
		nValue <<= 1;
	}
}
//********************************************************************************
QuantFloat::~QuantFloat()
{

}
//********************************************************************************
QuantFloat::QuantFloat( Quantizer *pQuant,int x) : 
	m_value(x), m_mini(-1), m_maxi(-1), m_nbbits(-1)
{
		assert(pQuant !=NULL);
		pQuant->GetFloatData(m_nbbits,m_mini,m_maxi);
		assert (m_nbbits>=0);
}
//********************************************************************************
QuantFloat::QuantFloat(int nbbits, float mini, float maxi, int x):
	m_value(x), m_mini(mini), m_maxi(maxi),m_nbbits(nbbits)
{
}
//********************************************************************************
void QuantFloat::setNbAACModels(Quantizer * pQuant)
{
	pQuant;
	return;
}
//********************************************************************************
QuantFloat QuantFloat::CompMin(ZArray<QuantFloat> & qFArray, int begin, int end, int &nbits)
{
	QuantFloat Min=qFArray[begin];
	QuantFloat Max=qFArray[begin];
	for (int i=begin+1; i<end;i++)
	{
#ifdef DEBUGPREDICTIVE
#ifdef DEBUGCOMPMIN
		printf("[ min= ");
		Min.Print();
		printf(" ; max= ");
		Max.Print();
		printf(" ]\n");
#endif
#endif
		if (qFArray[i].m_value<Min.m_value) 
			Min=qFArray[i];
		if (qFArray[i].m_value>Max.m_value) 
			Max=qFArray[i];
	}
	nbits=getNbBits(Max.m_value - Min.m_value);
	return Min;
}
//********************************************************************************
void QuantFloat::Shift(ZArray<QuantFloat> &d, ZArray<QuantFloat> &q, 
					   QuantFloat PMin, int begin, int end)
{
	for (int i=begin; i<end;i++)
		d.SetAt(i,q[i]-PMin);
}
//********************************************************************************
QuantFloat QuantFloat::unShift(QuantFloat a, QuantFloat Pmin)
{
	return (a+Pmin);
}
//********************************************************************************
void QuantFloat::AAEncode(ZArray<bool> & oA, ZArray<int> &oIndx, ZArray<QuantFloat> & iA, 
						  int nbbits, int begin, int end, bool isChoice)
{
	ArithModel model[m_nbComp]; 
	for (int h=0; h<m_nbComp; h++) { 
		model[h]=ArithModel(); 
		model[h].init(1<<nbbits); //compnbbits
	}
	
	ArithEncoder aae= ArithEncoder(oA);
	aae.reset();
	for (int i=begin; i<end;i++)
	{
		
#ifdef DEBUGPREDICTIVE
//#ifdef DEBUGAAENCODE
		int k=iA[i].m_value;
		printf("{encoding %d : (%d) < %d}\n",i,k,1<< nbbits);
//		model[0].PrintFreq();
//		model[0].PrintCumFreq();
//#endif
#endif
		int bits=iA[i].EncodeAA(aae,model);
		if (isChoice && (i!=end-1)) 
		{
			int obits=bits;
			bits+=aae.flush();
			printf("[AAEC]oA.GetLength %d ?  bitsT=%d obits=%d nbits=%d\n",oA.GetLength(),bits+oIndx[i-1],obits,bits);
		}
		//printf("[AAEC]%d in %d bits\n",i,bits);
		if (i!=end-1) oIndx.SetAt(i,bits+oIndx[i-1]/*oA.GetLength()*/);
		//oIndx.SetAt(i,bits+oIndx[i-1]
	}
#ifdef DEBUGPREDICTIVE
//#ifdef DEBUGAAENCODE
//	model[0].PrintFreq();
//#ifdef DEBUGAAENCODE
#endif
	aae.flush();
	oIndx.SetAt(end-1,oA.GetLength());
	printf("{End if this round} begin=%d; end=%d; oIndx[end-1]=%d; outArray.lg()=%d\n",begin,end,oIndx[end-1], oA.GetLength());
	
}
//********************************************************************************
int QuantFloat::EncodeAA(ArithEncoder & aae, ArithModel model[] )
{
	int bits=0;
	for (int h=0; h<m_nbComp; h++) 
		aae.encodeAndUpdate(m_value,model[h],"AAC",bits);
	return bits;
}
//********************************************************************************
void QuantFloat::WriteIntra(ZArray<bool> &o)
{
	int nbBits = m_nbbits;
	writeInt(o, m_value, nbBits);
}
//********************************************************************************
QuantFloat & QuantFloat::operator +=(QuantFloat aQI)
{
	//assert (aQI.m_pQuant == m_pQuant);
	m_value+=aQI.m_value;
	return *this;
}
//********************************************************************************
QuantFloat & QuantFloat::operator -=(QuantFloat aQI)
{
	//assert (aQI.m_pQuant == m_pQuant);
	m_value-=aQI.m_value;
	return *this;
}
//********************************************************************************
NatFloat QuantFloat::unQuantize()
{
	return NatFloat(m_nbbits,m_mini,m_maxi,
		Quantizer::unQuantize(m_value,m_mini,m_maxi,m_nbbits,false));
}
//********************************************************************************
QuantFloat operator+ (QuantFloat a, QuantFloat b)
{
	QuantFloat r = a;
	return (r+=b);
}
//********************************************************************************
QuantFloat operator- (QuantFloat a, QuantFloat b)
{
	QuantFloat r = a;
	return (r-=b);
}
//********************************************************************************
bool operator != (QuantFloat a, QuantFloat b)
{
	return (a.m_value!=b.m_value);
}
//********************************************************************************
void QuantFloat::Encode(BIFSEncoder *pBifs)
{
		pBifs->EncodeInt(m_value,m_nbbits,"Intra");
}
//********************************************************************************
void QuantFloat::EncodePMin(BIFSEncoder *pBifs)
{

	pBifs->EncodeInt(m_value+(1<<m_nbbits),m_nbbits+1,"CompMin");
}
//********************************************************************************
//********************************************************************************

#ifdef DEBUGPREDICTIVE
//********************************************************************************
int QuantFloat::Decode(ZArray<QuantFloat> & decArray, ZArray<bool> & m_outArray,int index,
		int nb, int aadnbBits,Quantizer * m_pQuant, FILE * out, bool isChoice)
{
	fprintf(out,"[QuantFloat::Decode] index=%d\n",index);
	int ibits=m_pQuant->GetQuantizationNbBits();
	int v=0;
	for (int i=0; i<ibits; i++) v= (v<<1) + (m_outArray[i+index]?1:0);
	printf("QuantV = %d (index=%d)",v,index);
	QuantFloat IntraV= QuantFloat(m_pQuant,v);
	decArray+=IntraV;

	ArithModel model[m_nbComp]; 
	for (int h=0; h<m_nbComp; h++) { 
		model[h]=ArithModel(); 
		model[h].init(1<<aadnbBits); //compnbbits
	}
	ArithDecoder aad= ArithDecoder(m_outArray,index+ibits);
	aad.reset();
	int bitsRead=0;
	int bitsReadFrame=0;
	for (i=0; i< nb-1 ; i++)
	{
		QuantFloat Value=QuantFloat(m_pQuant,aad.decodeAndUpdate(model[0],bitsReadFrame));
		if (isChoice && (i+1 < nb-1)) 
		{
			aad.flush(bitsReadFrame);
		}
		fprintf(out,"[QuantFloat::Decode](%d) value=",i);
		Value.Print(out);
		fprintf(out,"  (%d bits) [total =%d]\n",bitsReadFrame,bitsRead);
		decArray+=Value;
		bitsRead+=bitsReadFrame;
	}
	aad.flush(bitsRead);
	fprintf(out,"Finally read : %d\n",bitsRead);
	return bitsRead+ibits;
}
//********************************************************************************
void QuantFloat::Print(FILE * out)
{
	fprintf(out,"%d ",m_value);
}
#endif

/*
QuantInt::QuantInt(): m_value(0), m_pQuant(NULL) {}
QuantInt::QuantInt(int x, Quantizer * pQuant): m_value(x), m_pQuant(pQuant) {}
NatInt QuantInt::unQuantize()
{
	return NatInt(m_pQuant->unQuantizeInt(m_value));
}
QuantInt & QuantInt::operator +=(QuantInt aQI)
{
	//assert (aQI.m_pQuant == m_pQuant);
	m_value+=aQI.m_value;
	return *this;
}

QuantInt QuantInt::operator -(QuantInt aQI)
{
	return QuantInt(-aQI.m_value,aQI.m_pQuant);
}
*/







