//$Log: QuantTypes.h,v $
//Revision 1.1.1.1  2003/12/24 00:55:05  mikeseven
//Initial release of the CVS repository for MPEG-4 Systems code
//after the code was corrupted due to reorganization and human 
//errors.
//
//Revision 1.1.1.2  2003/01/30 16:28:31  payan
//no message
//
//Revision 1.1.1.1  2002/07/18 01:08:29  mikeseven
//Initial check in of July 17, 2002 version
//
//Revision 1.2  2000/03/09 20:46:09  Alex Cotarmanac'h
//Fixed parameter bug
//
//Revision 1.1  2000/03/03 18:41:23  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
//<alexandre.cotarmanac-h@polytechnique.org>

#include "Quantize.h"
#include "ztl.h"
#include "NatTypes.h"	// Added by ClassView
#include "../Animation/ArithModel.h"
#include "ArithEncoder.h"

class QuantFloat 
{
	friend bool operator != (QuantFloat a, QuantFloat b);
public:
	enum { m_nbComp = 1 };
	QuantFloat(Quantizer * pQuant, int x=0);
	QuantFloat(int nbbits=-1, float mini=-1, float maxi=-1, int x=0);
	QuantFloat& operator+= (QuantFloat);
	QuantFloat& operator-= (QuantFloat);
	virtual ~QuantFloat();
	NatFloat unQuantize();

//   ****			Predictive Encoder Functions
	static void setNbAACModels(Quantizer * pQuant);
	static QuantFloat CompMin(ZArray<QuantFloat> & qFArray,int begin,int end, int &nbits);
	static void Shift(ZArray<QuantFloat> & d, ZArray<QuantFloat> & q, QuantFloat PMin, int begin, int end);
	static QuantFloat unShift(QuantFloat a, QuantFloat Pmin);
	static void AAEncode(ZArray<bool> & o, ZArray<int> &oIndx, ZArray<QuantFloat> & i,int nbbits, int begin, int end, bool isChoice);
	void Encode(BIFSEncoder * pBifs);
	void EncodePMin(BIFSEncoder * pBifs);
		void WriteIntra(ZArray<bool> & o);
private:
	int m_value;
	int m_nbbits;
	float m_maxi;
	float m_mini;
	virtual int EncodeAA(ArithEncoder & aae, ArithModel model[] );
#ifdef DEBUGPREDICTIVE
public:
	static int Decode(ZArray<QuantFloat> & decArray, ZArray<bool> & m_outArray,int index,
		int nb,int aadnbBits,Quantizer * m_pQuant, FILE * out, bool isChoice);
	void Print(FILE *);
#endif
};

QuantFloat operator+ (QuantFloat a, QuantFloat b);
QuantFloat operator- (QuantFloat a, QuantFloat b);

/*class NatInt;

class QuantInt
{
public:
	QuantInt();
	QuantInt(int x, Quantizer * pQuant);
	NatInt unQuantize();
	QuantInt& operator+= (QuantInt);
	QuantInt operator- (QuantInt);
private:
	int m_value;
	Quantizer * m_pQuant;

};

QuantInt operator+ (QuantInt a, QuantInt b)
{
	QuantInt r = a;
	return (r+=b);
}
*/
/*
class NatFloat;

class QuantFloat
{
public:
	QuantFloat();
	NatFloat unQuantize();
	QuantFloat& operator+= (QuantFloat);
	QuantFloat operator- (QuantFloat);
private:
	int m_value;
	Quantizer * m_pQuant;

}
QuantFloat operator+ (QuantFloat a, QuantFloat b)
{
	QuantFloat r = a;
	return (r+=b);
}
class NatVec3f;

class QuantVec3f
{
public:
	QuantVec3f();
	NatVec3f unQuantize();
	QuantVec3f& operator+ (QuantVec3f, QuantVec3f);
	QuantVec3f operator- (QuantVec3f);
private:
	int m_value[3];
	Quantizer * m_pQuant;

}
QuantVec3f operator+ (QuantVec3f a, QuantVec3f b)
{
	QuantVec3f r = a;
	return (r+=b);
}
*/
