//$Log: QuantVec2f.h,v $
//Revision 1.1.1.1  2003/12/24 00:55:05  mikeseven
//Initial release of the CVS repository for MPEG-4 Systems code
//after the code was corrupted due to reorganization and human 
//errors.
//
//Revision 1.1.1.2  2003/01/30 16:28:32  payan
//no message
//
//Revision 1.1.1.1  2002/07/18 01:08:29  mikeseven
//Initial check in of July 17, 2002 version
//
//Revision 1.1.2.1  2000/03/11 12:48:17  Alex Cotarmanac'h
//Vec2f
//
//<alexandre.cotarmanac-h@polytechnique.org>
#ifndef QUANTVEC2FH
#define QUANTVEC2FH
#include "Quantize.h"
#include "ztl.h"
#include "NatVec2f.h"	// Added by ClassView
#include "../Animation/ArithModel.h"
#include "ArithEncoder.h"


class QuantVec2f 
{
	friend bool operator != (QuantVec2f a, QuantVec2f b);
public:
	enum { m_nbComp = 2 };
	QuantVec2f();
	QuantVec2f(Quantizer * pQuant, int x=0, int y=0);
	QuantVec2f(int nbbits, float mini[], float maxi[], int x=0, int y=0);
	QuantVec2f& operator+= (QuantVec2f);
	QuantVec2f& operator-= (QuantVec2f);
	virtual ~QuantVec2f();
	NatVec2f unQuantize();

//   ****			Predictive Encoder Functions
	static void setNbAACModels(Quantizer * pQuant);//sets static vars
	static QuantVec2f CompMin(ZArray<QuantVec2f> & qFArray,int begin,int end, int &nbits);
	static void Shift(ZArray<QuantVec2f> & d, ZArray<QuantVec2f> & q, QuantVec2f PMin, int begin, int end);
	static QuantVec2f unShift(QuantVec2f a, QuantVec2f Pmin);
	static void AAEncode(ZArray<bool> & o, ZArray<int> &oIndx, ZArray<QuantVec2f> & i,int nbbits, int begin, int end, bool isChoice);
	void Encode(BIFSEncoder * pBifs);
	void EncodePMin(BIFSEncoder * pBifs);
	void WriteIntra(ZArray<bool> & o);
private:
	int m_x;
	int m_y;
	int m_nbbits;
	float m_maxi[2];
	float m_mini[2];
	static int m_nbAACModels;
	virtual int EncodeAA(ArithEncoder & aae, ArithModel model[] );
#ifdef DEBUGPREDICTIVE
public:
	static int Decode(ZArray<QuantVec2f> & decArray, ZArray<bool> & m_outArray,int index,
		int nb,int aadnbBits,Quantizer * m_pQuant, FILE * out, bool isChoice);
	void Print(FILE *);
#endif
};

QuantVec2f operator+ (QuantVec2f a, QuantVec2f b);
QuantVec2f operator- (QuantVec2f a, QuantVec2f b);
#endif