//$Log: QuantVec3f.h,v $
//Revision 1.1.1.1  2003/12/24 00:55:05  mikeseven
//Initial release of the CVS repository for MPEG-4 Systems code
//after the code was corrupted due to reorganization and human 
//errors.
//
//Revision 1.1.1.2  2003/01/30 16:28:32  payan
//no message
//
//Revision 1.1.1.1  2002/07/18 01:08:29  mikeseven
//Initial check in of July 17, 2002 version
//
//Revision 1.1  2000/03/03 18:41:23  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
//<alexandre.cotarmanac-h@polytechnique.org>
#ifndef QUANTVEC3FH
#define QUANTVEC3FH
#include "Quantize.h"
#include "ztl.h"
#include "NatVec3f.h"	// Added by ClassView
#include "../Animation/ArithModel.h"
#include "ArithEncoder.h"


class QuantVec3f 
{
	friend bool operator != (QuantVec3f a, QuantVec3f b);
public:
	enum { m_nbComp = 3 };
	QuantVec3f();
	QuantVec3f(Quantizer * pQuant, int x=0, int y=0, int z=0);
	QuantVec3f(int nbbits, float mini[], float maxi[], int x=0, int y=0, int z=0);
	QuantVec3f& operator+= (QuantVec3f);
	QuantVec3f& operator-= (QuantVec3f);
	virtual ~QuantVec3f();
	NatVec3f unQuantize();

//   ****			Predictive Encoder Functions
	static void setNbAACModels(Quantizer * pQuant);//sets static vars
	static QuantVec3f CompMin(ZArray<QuantVec3f> & qFArray,int begin,int end, int &nbits);
	static void Shift(ZArray<QuantVec3f> & d, ZArray<QuantVec3f> & q, QuantVec3f PMin, int begin, int end);
	static QuantVec3f unShift(QuantVec3f a, QuantVec3f Pmin);
	static void AAEncode(ZArray<bool> & o, ZArray<int> &oIndx, ZArray<QuantVec3f> & i,int nbbits, int begin, int end, bool isChoice);
	void Encode(BIFSEncoder * pBifs);
	void EncodePMin(BIFSEncoder * pBifs);
	void WriteIntra(ZArray<bool> & o);
private:
	int m_x;
	int m_y;
	int m_z;
	int m_nbbits;
	float m_maxi[3];
	float m_mini[3];
	static int m_nbAACModels;
	virtual int EncodeAA(ArithEncoder & aae, ArithModel model[] );
#ifdef DEBUGPREDICTIVE
public:
	static int Decode(ZArray<QuantVec3f> & decArray, ZArray<bool> & m_outArray,int index,
		int nb,int aadnbBits,Quantizer * m_pQuant, FILE * out, bool isChoice);
	void Print(FILE *);
#endif
};

QuantVec3f operator+ (QuantVec3f a, QuantVec3f b);
QuantVec3f operator- (QuantVec3f a, QuantVec3f b);
#endif