/********************************************************************
  This software module was originally developed by Helge Drumm and Marco 
  Albrecht in the context of the IAVAS Project. For the object based
  functionality the IM1 Implementation of MPEG-4 Systems implementation
  is used.
*********************************************************************/

/*--------------------------------------------------------------------
Project I3D: IAVAS 3D Player

FILE	: NRCone.h
AUTHOR	: Helge Drumm, Marco Albrecht
OVERVIEW: Declaration of the Implementation class for NRCone
CVS     : $Id: NRCone.h,v 1.3 2007/05/08 06:23:03 drumm Exp $
----------------------------------------------------------------------*/


#ifndef __NRCONE_H__
#define __NRCONE_H__

#include "../Core/Nodes.h"
#include "../Core/NodeFld.h"
#include "RBaseList.h"

class NRCone : public RBaseList 
{
public:
	NRCone(MediaObject *refnode);
	virtual ~NRCone();

	void UpdateValue(float Upd_bottomRadius,float Upd_height,bool Upd_side,bool Upd_bottom);

	Cone *refnode;

	float bottomRadius;
    float height;
    bool side;
    bool bottom;

    //MF<Vec3f> test;

};

#endif // __NRCONE_H__
