/********************************************************************
  This software module was originally developed by Helge Drumm and Marco 
  Albrecht in the context of the IAVAS Project. For the object based
  functionality the IM1 Implementation of MPEG-4 Systems implementation
  is used.
*********************************************************************/

/*--------------------------------------------------------------------
Project I3D: IAVAS 3D Player

FILE	: NRCylinder.h
AUTHOR	: Helge Drumm, Marco Albrecht
OVERVIEW: Declaration of the Implementation class for NRCylinder
CVS     : $Id: NRCylinder.h,v 1.3 2007/05/08 06:23:03 drumm Exp $
----------------------------------------------------------------------*/


#ifndef __NRCYLINDER_H__
#define __NRCYLINDER_H__

#include "../Core/Nodes.h"
#include "../Core/NodeFld.h"
#include "RBaseList.h"

class NRCylinder : public RBaseList 
{
public:
	NRCylinder(MediaObject *refnode);
	virtual ~NRCylinder();

	void UpdateValue(bool Upd_bottom,float Upd_height,float Upd_radius,bool Upd_side,bool Upd_top);

	Cylinder *refnode;

	 bool  bottom;
     float height;
     float radius;
     bool  side;
     bool  top;

};

#endif // __NRCYLINDER_H__
