/********************************************************************
  This software module was originally developed by Helge Drumm and Marco 
  Albrecht in the context of the IAVAS Project. For the object based
  functionality the IM1 Implementation of MPEG-4 Systems implementation
  is used.
*********************************************************************/

/*--------------------------------------------------------------------
Project I3D: IAVAS 3D Player

FILE	: NRDirectionalLight.cpp
AUTHOR	: Helge Drumm, Marco Albrecht
OVERVIEW: Implementation of class NRDirectionalLight 
CVS     : $Id: NRDirectionalLight.cpp,v 1.2 2007/04/18 17:37:31 drumm Exp $
----------------------------------------------------------------------*/



#include "NRDirectionalLight.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

NRDirectionalLight::NRDirectionalLight(MediaObject *refnode)
{
  
  this->ambientIntensity = 0;
  this->color = Color3f(1, 1, 1); 
  this->direction = Vec3f(0,0,-1);
  this->intensity = 1;
  this->on = true;
}

NRDirectionalLight::~NRDirectionalLight()
{

}

void NRDirectionalLight::UpdateValue(float Upd_ambientIntensity,Color3f Upd_color,Vec3f Upd_direction,float Upd_intensity,bool Upd_on)
{
  this->ambientIntensity = Upd_ambientIntensity;
  this->color.r          = Upd_color.r;
  this->color.g          = Upd_color.g;
  this->color.b          = Upd_color.b;
  this->direction.x      = Upd_direction.x;
  this->direction.y      = Upd_direction.y;
  this->direction.z      = Upd_direction.z;
  this->intensity        = Upd_intensity;
  this->on               = Upd_on; 


}