/********************************************************************
  This software module was originally developed by Helge Drumm and Marco 
  Albrecht in the context of the IAVAS Project. For the object based
  functionality the IM1 Implementation of MPEG-4 Systems implementation
  is used.
*********************************************************************/

/*--------------------------------------------------------------------
Project I3D: IAVAS 3D Player

FILE	: NRDirectionalLight.h
AUTHOR	: Helge Drumm, Marco Albrecht
OVERVIEW: Declaration of the Implementation class for NRDirectionalLight
CVS     : $Id: NRDirectionalLight.h,v 1.3 2007/05/08 06:23:03 drumm Exp $
----------------------------------------------------------------------*/

#ifndef __NRDIRECTIONALLIGHT_H__
#define __NRDIRECTIONALLIGHT_H__

#include "../Core/Nodes.h"
#include "../Core/NodeFld.h"
#include "RBaseList.h"

class NRDirectionalLight : public RBaseList
{
public:
	NRDirectionalLight(MediaObject *refnode);
	virtual ~NRDirectionalLight();
     
    void UpdateValue(float Upd_ambientIntensity,Color3f Upd_color,Vec3f Upd_direction,float Upd_intensity,bool Upd_on);

	DirectionalLight *refnode;

	float ambientIntensity;
    Color3f color;
    Vec3f direction;
    float intensity;
    bool  on;
	float penumbra;

	int gl_light;


};

#endif // __NRDIRECTIONALLIGHT_H__