/********************************************************************
  This software module was originally developed by Helge Drumm and Marco 
  Albrecht in the context of the IAVAS Project. For the object based
  functionality the IM1 Implementation of MPEG-4 Systems implementation
  is used.
*********************************************************************/

/*--------------------------------------------------------------------
Project I3D: IAVAS 3D Player

FILE	: NRElevationGrid.h
AUTHOR	: Helge Drumm, Marco Albrecht
OVERVIEW: Declaration of the Implementation class for NRElevationGrid
CVS     : $Id: NRElevationGrid.h,v 1.3 2007/05/08 06:23:03 drumm Exp $
----------------------------------------------------------------------*/

#ifndef __NRELEVATIONGRID_H__
#define __NRELEVATIONGRID_H__

#include "../Core/Nodes.h"
#include "../Core/NodeFld.h"
#include "RBaseList.h"

class NRElevationGrid : public RBaseList  
{
public:
	NRElevationGrid(MediaObject *refnode);
	virtual ~NRElevationGrid();

	ElevationGrid *refnode;

	MF<float> height;
    bool ccw;
    bool colorPerVertex;
    float creaseAngle;
    bool normalPerVertex;
    bool solid;
    int xDimension;
    float xSpacing;
    int zDimension;
    float zSpacing;


};

#endif // __NRELEVATIONGRID_H__