/********************************************************************
  This software module was originally developed by Helge Drumm and Marco 
  Albrecht in the context of the IAVAS Project. For the object based
  functionality the IM1 Implementation of MPEG-4 Systems implementation
  is used.
*********************************************************************/

/*--------------------------------------------------------------------
Project I3D: IAVAS 3D Player

FILE	: NRFog.h
AUTHOR	: Helge Drumm, Marco Albrecht
OVERVIEW: Declaration of the Implementation class for NRFog
CVS     : $Id: NRFog.h,v 1.3 2007/05/08 06:23:04 drumm Exp $
----------------------------------------------------------------------*/

#ifndef __NRFOG_H__
#define __NRFOG_H__

#include "../Core/Nodes.h"
#include "../Core/NodeFld.h"
#include "RBaseList.h"

class NRFog : public RBaseList  
{
public:
	NRFog(MediaObject *refnode);
	virtual ~NRFog();

	Color3f color;
    bool  type; // 0 == Linear ; 1 = Exp
	float visRange;

	void UpdateValue(Color3f c,bool t,float vR);
	
	Fog *refnode;
  
  
};

#endif // __NRFOG_H__
