/********************************************************************
  This software module was originally developed by Helge Drumm and Marco 
  Albrecht in the context of the IAVAS Project. For the object based
  functionality the IM1 Implementation of MPEG-4 Systems implementation
  is used.
*********************************************************************/

/*--------------------------------------------------------------------
Project I3D: IAVAS 3D Player

FILE	: NRIndexedFaceSet.h
AUTHOR	: Helge Drumm, Marco Albrecht
OVERVIEW: Declaration of the Implementation class for NRIndexedFaceSet
CVS     : $Id: NRIndexedFaceSet.h,v 1.3 2007/05/08 06:23:04 drumm Exp $
----------------------------------------------------------------------*/

#ifndef __NRINDEXEDFACESET_H__
#define __NRINDEXEDFACESET_H__

#include "../Core/Nodes.h"
#include "../Core/NodeFld.h"
#include "RBaseList.h"

class NRIndexedFaceSet : public RBaseList  
{
public:
	NRIndexedFaceSet(MediaObject *refnode);
	virtual ~NRIndexedFaceSet();

	IndexedFaceSet *refnode;

	bool ccw;
   // MF<int> colorIndex;
    bool colorPerVertex;
    bool convex;
   // MF<int> coordIndex;
    float creaseAngle;
   // MF<int> normalIndex;
    bool normalPerVertex;
    bool solid;
   // MF<int> texCoordIndex; 

};

#endif // __NRINDEXEDFACESET_H__
