/********************************************************************
  This software module was originally developed by Helge Drumm and Marco 
  Albrecht in the context of the IAVAS Project. For the object based
  functionality the IM1 Implementation of MPEG-4 Systems implementation
  is used.
*********************************************************************/

/*--------------------------------------------------------------------
Project I3D: IAVAS 3D Player

FILE	: NRPointLight.cpp
AUTHOR	: Helge Drumm, Marco Albrecht
OVERVIEW: Implementation of class NRPointLight 
CVS     : $Id: NRPointLight.cpp,v 1.2 2007/04/18 17:36:50 drumm Exp $
----------------------------------------------------------------------*/



#include "NRPointLight.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

NRPointLight::NRPointLight(MediaObject *refnode)
{
  this->ambientIntensity = 0; 
  this->attenuation = Vec3f(1,0,0);
  this->color = Color3f(1,1,1); 
  this->intensity = 1;
  this->location  = Vec3f(0,0,0);
  this->on = true;
  this->radius = 100;
}

NRPointLight::~NRPointLight()
{

}

void NRPointLight::UpdateValue(float Upd_ambientIntensity,Vec3f Upd_attenuation,Color3f Upd_color,float Upd_intensity,Vec3f Upd_location,bool Upd_on,float Upd_radius)
{
  this->ambientIntensity = Upd_ambientIntensity;
  this->attenuation.x    = Upd_attenuation.x;
  this->attenuation.y    = Upd_attenuation.y;
  this->attenuation.z    = Upd_attenuation.z;
  this->color.r          = Upd_color.r;
  this->color.g          = Upd_color.g;
  this->color.b          = Upd_color.b;
  this->intensity        = Upd_intensity;
  this->location.x       = Upd_location.x;
  this->location.y       = Upd_location.y;
  this->location.z       = Upd_location.z;
  this->on               = Upd_on;
  this->radius           = Upd_radius;

}