/********************************************************************
  This software module was originally developed by Helge Drumm and Marco 
  Albrecht in the context of the IAVAS Project. For the object based
  functionality the IM1 Implementation of MPEG-4 Systems implementation
  is used.
*********************************************************************/

/*--------------------------------------------------------------------
Project I3D: IAVAS 3D Player

FILE	: NRPointLight.h
AUTHOR	: Helge Drumm, Marco Albrecht
OVERVIEW: Declaration of the Implementation class for NRPointLight
CVS     : $Id: NRPointLight.h,v 1.3 2007/05/08 06:23:05 drumm Exp $
----------------------------------------------------------------------*/

#ifndef __NRPOINTLIGHT_H__
#define __NRPOINTLIGHT_H__

#include "../Core/Nodes.h"
#include "../Core/NodeFld.h"
#include "RBaseList.h"

class NRPointLight : public RBaseList  
{
public:
	NRPointLight(MediaObject *refnode);
	virtual ~NRPointLight();
    void UpdateValue(float Upd_ambientIntensity,Vec3f Upd_attenuation,Color3f Upd_color,float Upd_intensity,Vec3f Upd_location,bool Upd_on,float Upd_radius); 

	PointLight *refnode;

    float ambientIntensity; 
    Vec3f attenuation;
    Color3f color;
    float intensity;
    Vec3f location;
    bool  on;
    float radius;

	float penumbra;
    
	int gl_light;

};

#endif // __NRPOINTLIGHT_H__
