/********************************************************************
  This software module was originally developed by Helge Drumm and Marco 
  Albrecht in the context of the IAVAS Project. For the object based
  functionality the IM1 Implementation of MPEG-4 Systems implementation
  is used.
*********************************************************************/

/*--------------------------------------------------------------------
Project I3D: IAVAS 3D Player

FILE	: NRShape.cpp
AUTHOR	: Helge Drumm, Marco Albrecht
OVERVIEW: Implementation of class NRShape 
CVS     : $Id: NRShape.cpp,v 1.2 2007/04/18 17:36:52 drumm Exp $
----------------------------------------------------------------------*/



#include "NRShape.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

NRShape::NRShape(MediaObject *refnode)
{
  this->isRenderable=true;
  this->spl_count=0;
}

NRShape::~NRShape()
{

}

ShadowP NRShape::GetShadowProp(RBaseList* LightSource)
{
  ShadowP shadow_prop; 
  bool hasfound;
  hasfound = false;
  for(int i=0; i<spl_count;i++)
  {
    if(this->ShadowPropList[i].refnode==LightSource)
	{
      shadow_prop = this->ShadowPropList[i];
	  this->shadow.cast = this->ShadowPropList[i].cast;
	  this->shadow.receive = this->ShadowPropList[i].receive;
//	  this->shadow.self = this->ShadowPropList[i].self;
	  hasfound = true;
	} else
    {
	  if(hasfound == false)
	  {
	  shadow_prop.cast=0;
	  shadow_prop.receive=0;
//	  shadow_prop.self=0;
	  shadow_prop.refnode=LightSource;
	  this->shadow.cast=0;
	  this->shadow.receive=0;
//	  this->shadow.self=0;
	  }
	}
  
  }

return shadow_prop;

}
