/********************************************************************
  This software module was originally developed by Helge Drumm and Marco 
  Albrecht in the context of the IAVAS Project. For the object based
  functionality the IM1 Implementation of MPEG-4 Systems implementation
  is used.
*********************************************************************/

/*--------------------------------------------------------------------
Project I3D: IAVAS 3D Player

FILE	: NRShape.h
AUTHOR	: Helge Drumm, Marco Albrecht
OVERVIEW: Declaration of the Implementation class for NRShape
CVS     : $Id: NRShape.h,v 1.3 2007/05/08 06:23:05 drumm Exp $
----------------------------------------------------------------------*/

#ifndef __NRSHAPE_H__
#define __NRSHAPE_H__

#include "../Core/Nodes.h"
#include "../Core/NodeFld.h"
#include "RBaseList.h"

typedef	struct 
{
	   RBaseList *refnode;
       bool cast;
	   bool receive;
	   bool self;	
}ShadowP;

class NRShape : public RBaseList
{
public:
	NRShape(MediaObject *refnode);
	virtual ~NRShape();

	
	
    int ShapeNR;

	int spl_count;
	ShadowP ShadowPropList[16];



	Shape *refnode;

	ShadowP GetShadowProp(RBaseList* LightSource);

};

#endif // __NRSHAPE_H__
