/********************************************************************
  This software module was originally developed by Helge Drumm and Marco 
  Albrecht in the context of the IAVAS Project. For the object based
  functionality the IM1 Implementation of MPEG-4 Systems implementation
  is used.
*********************************************************************/

/*--------------------------------------------------------------------
Project I3D: IAVAS 3D Player

FILE	: NRSpotLight.h
AUTHOR	: Helge Drumm, Marco Albrecht
OVERVIEW: Declaration of the Implementation class for NRSpotLight
CVS     : $Id: NRSpotLight.h,v 1.3 2007/05/08 06:23:05 drumm Exp $
----------------------------------------------------------------------*/

#ifndef __NRSPOTLIGHT_H__
#define __NRSPOTLIGHT_H__

#include "../Core/Nodes.h"
#include "../Core/NodeFld.h"
#include "RBaseList.h"

class NRSpotLight : public RBaseList
{
public:
	NRSpotLight(MediaObject *refnode);
	virtual ~NRSpotLight();
    void UpdateValue(float Upd_ambientIntensity,Vec3f Upd_attenuation,float Upd_beamWidth,Color3f Upd_color,float Upd_cutOffAngle,Vec3f Upd_direction,float Upd_intensity,Vec3f Upd_location,bool Upd_on,float Upd_radius);


	SpotLight *refnode;

	float ambientIntensity;
    Vec3f attenuation;
    float beamWidth;
    Color3f color;
    float cutOffAngle;
    Vec3f direction;
    float intensity;
    Vec3f location;
    bool  on;
    float radius;

	float penumbra;

	int gl_light;


};

#endif // __NRSPOTLIGHT_H__
