/********************************************************************
  This software module was originally developed by Helge Drumm and Marco 
  Albrecht in the context of the IAVAS Project. For the object based
  functionality the IM1 Implementation of MPEG-4 Systems implementation
  is used.
*********************************************************************/

/*--------------------------------------------------------------------
Project I3D: IAVAS 3D Player

FILE	: NRTransform.h
AUTHOR	: Helge Drumm, Marco Albrecht
OVERVIEW: Declaration of the Implementation class for NRTransform
CVS     : $Id: NRTransform.h,v 1.3 2007/05/08 06:23:06 drumm Exp $
----------------------------------------------------------------------*/

#ifndef __NRTRANSFORM_H__
#define __NRTRANSFORM_H__

#include "../Core/Nodes.h"
#include "../Core/NodeFld.h"
#include "RBaseList.h"

class NRTransform : public RBaseList
{
public:
	NRTransform(Transform *refnode);
	virtual ~NRTransform();

	Transform *refnode;

	

    void UpdateValue(Vec3f Upd_center,Rotation Upd_rotation,Vec3f Upd_scale,Rotation Upd_scaleOrientation,Vec3f translation);
    void SetMatrix(void);

	Vec3f      center;
	Rotation   rotation;
	Vec3f      scale;
	Rotation   scaleOrientation;
	Vec3f      translation;

	
};

#endif // __NRTRANSFORM_H__
