// RBaseList.cpp: Implementierung der Klasse RBaseList.
//
//////////////////////////////////////////////////////////////////////

#include <string.h>
#include <assert.h>
#include "RBaseList.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////



void RBaseList::DeleteAll(void) {
	RBaseList *next = head;
	while(next) {
		if(next->count>0)
		{
          next->DeleteAll();
		}
		RBaseList *del = next;
		next = del->next;
		
		delete del;
		
		}
	head = tail = 0;
	count = 0;
	}


int RBaseList::Find(char *name) {
	RBaseList *ptr = head;
	int index = 0;
	while(ptr) {
		if(strcmp(name, ptr->name) == 0)
			return index;
		index++; 
		ptr = ptr->next;
		}
	return -1;
	}

int RBaseList::FindID(int ID) {
	RBaseList *ptr = head;
	int index = 0;
	while(ptr) {
		if(ptr->RefNodeID == ID)
			return index;
		index++; 
		ptr = ptr->next;
		}
	return -1;
	}

int RBaseList::Add(RBaseList* objptr) {
//	if(Find(name) >= 0)
//		return -1;
//	RBaseObject *n = new RBaseObject(name);
	if(tail)
	tail->next = objptr;
	tail = objptr;
	if(!head)
		head = objptr;
	count++;
	return count-1;
	}

void RBaseList::Delete(int index) {
	assert(index < count);
	RBaseList *ptr = head;
	RBaseList *prev = 0;
	while(index) {
		if(!ptr) {
			assert(0);
			return;
			}
		prev = ptr;
		ptr = ptr->next;
		index--;
		}
	if(prev)
		prev->next = ptr->next;
	else
		head = ptr->next;
	count--;
	if(tail == ptr)
		tail = prev;
	delete ptr;
	}

RBaseList *RBaseList::GetNamedPtr(int index) {
	assert(index < count);
	RBaseList *ptr = head;
	while(index) {
		if(!ptr) {
			assert(0);
			return NULL;
			}
		ptr = ptr->next;
		index--;
		}
	return ptr;
	}
