// Class:          RBaseList
// Description:    Handle NRObject in a concatenated several times list
// Author:         Marco Albrecht (2004)                
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RBASELIST_H__83B2C169_26B5_41C7_B397_77C468AC33CD__INCLUDED_)
#define AFX_RBASELIST_H__83B2C169_26B5_41C7_B397_77C468AC33CD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "RBaseObject.h"

class RBaseList : public RBaseObject  
{
public:
	RBaseList() { head = tail = 0; count = 0; next = 0;} // Constructor
	virtual ~RBaseList() { }                             // Deconstructor
	RBaseList *parent;        // Pointer to parent object 
	RBaseList *next;          // Pointer to next object 
	
	RBaseList *head;          // Pointer to first object 
	RBaseList *tail;          // Pointer to last  object 

	int count;                // Number of objects in list
		
	void DeleteAll(void);     // Delete all objects 
	
	int Find(char *name);     // Find a object by name
	int FindID(int ID);       // Find a object by ID (RefnodeID)
	
	int Add(RBaseList *objptr);  //Add a object to list
	
	void Delete(int index);      //Delete a object from list, specified by index
	
	int Count() { return count; } // Count of all objects in list
	
	RBaseList *GetNamedPtr(int index);  //Get name of object, specified by index 


};

#endif // !defined(AFX_RBASELIST_H__83B2C169_26B5_41C7_B397_77C468AC33CD__INCLUDED_)
