//////////////////////////////////////////////////////////////////////
//Class:        RNodeProperties
//Description:  Handle all additional Nodes Properties
//Author:       Marco Albrecht (2004)
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RNODEPROPERTIES_H__BE63AAD7_0523_4297_A1FC_AA1F1D178ABD__INCLUDED_)
#define AFX_RNODEPROPERTIES_H__BE63AAD7_0523_4297_A1FC_AA1F1D178ABD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "NRMatrix.h"

class RNodeProperties  
{
public:
	RNodeProperties();
	virtual ~RNodeProperties();

    int NodeID;     // ID from MediaObject 
	int NodeCode;   // NodeCode from MediaObject

	bool isGroupingNode; // Flag -> set true if MediaObject a GroupingNode   
	bool isShadowMember; // Flag -> set true if MediaObject inside a ShadowNode
	bool isLightMember;
	bool isRenderable;   // Flag -> set true if MediaObject outside a ShadowNode 
                         // or no GeometryNode defined
	struct ShadowProp{   // ShadowProperty for each NodeRefernce Object
		bool cast;
		bool receive;
		//bool self;
	}shadow;
	
    float penumbra;

	NRMatrix *Matrix4x4; // Transformations Matrix

};

#endif // !defined(AFX_RNODEPROPERTIES_H__BE63AAD7_0523_4297_A1FC_AA1F1D178ABD__INCLUDED_)
