// SGManager.cpp: Implementierung der Klasse SGManager.
// Author:        Marco Albrecht (2004)
//
// TransformAudio3D, WideSound, SurroundingSound
// added by Matthias Frank 25-10-2005
//////////////////////////////////////////////////////////////////////


#include "SGManager.h"

#include <tchar.h>
#include "RendObj.h"





//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

SGManager::SGManager()
{
 
	
	SceneGraph  = new RBaseList;        // init first node in scenegraph
	SceneGraph->isGroupingNode=true;    // first node is always a grouping node
	SceneGraph->parent = NULL;          // first node has no parent
	this->sg_info.num_nrshape_nodes=0;  // number_nodereference shapes nodes = 0 
	this->sg_info.num_nrshape_noshadow_nodes=0; //number_nodereference no shadow nodes = 0 
	this->sg_info.num_nrshape_shadow_nodes=0; // number_nodereference shadow nodes = 0
	this->sg_info.hasShadowToRender=false;  // stats hasShadowToRender init with FALSE
	this->sg_info.num_direclights=0;        // number directional lights = 0 
	this->sg_info.num_pointlights=0;        // number point lights = 0 
	this->sg_info.num_spotlights=0;         // number spot lights = 0
	this->sg_info.hasFogToRender=false;     // stats hasFogToRende init with FALSE
    
	this->env_fog = NULL;                   // Pointer to NRFog
	
	this->Light0.Light = NULL;              // Pointer to all lightsources
	
	this->Light1.Light = NULL;
	this->Light2.Light = NULL;
	this->Light3.Light = NULL;
	this->Light4.Light = NULL;
	this->Light5.Light = NULL;
	this->Light6.Light = NULL;
	this->Light7.Light = NULL;

    this->Light0.LightNR = 0;
    this->Light0.NodeCode = 0;
    this->Light0.cast_objects = 0;
    this->Light0.receive_objects=0;
    this->Light0.noshadow_objects=0;

	this->Light1.LightNR = 0;
    this->Light1.NodeCode = 0;
    this->Light1.cast_objects = 0;
    this->Light1.receive_objects=0;
    this->Light1.noshadow_objects=0;

	this->Light2.LightNR = 0;
    this->Light2.NodeCode = 0;
    this->Light2.cast_objects = 0;
    this->Light2.receive_objects=0;
    this->Light2.noshadow_objects=0;

	this->Light3.LightNR = 0;
    this->Light3.NodeCode = 0;
    this->Light3.cast_objects = 0;
    this->Light3.receive_objects=0;
    this->Light3.noshadow_objects=0;

	this->Light4.LightNR = 0;
    this->Light4.NodeCode = 0;
    this->Light4.cast_objects = 0;
    this->Light4.receive_objects=0;
    this->Light4.noshadow_objects=0;

	this->Light5.LightNR = 0;
    this->Light5.NodeCode = 0;
    this->Light5.cast_objects = 0;
    this->Light5.receive_objects=0;
    this->Light5.noshadow_objects=0;

	this->Light6.LightNR = 0;
    this->Light6.NodeCode = 0;
    this->Light6.cast_objects = 0;
    this->Light6.receive_objects=0;
    this->Light6.noshadow_objects=0;

	this->Light7.LightNR = 0;
    this->Light7.NodeCode = 0;
    this->Light7.cast_objects = 0;
    this->Light7.receive_objects=0;
    this->Light7.noshadow_objects=0;
  

  

	this->shapecount=0;                     // Shapecount, count of all shapes in scene 
	this->renderPass=1;                     // stats active renderpass

	this->activeLight = &Light0;            // set Light0 as default active light
	globalID=-1;

   // ((NRPointLight *)(this->Light0.Light))->color.
}

SGManager::~SGManager()
{
  
  
  free(SceneGraph);
  //fclose(SG_FileHandle);
}

 

RBaseList* SGManager::CreateReference(char *name,MediaObject *NRefnode,RBaseList *lastNode,int NCode)
{
    


 
	
	this->globalID++;
	//fprintf(this->SG_FileHandle,"%i\n",this->globalID);
	
	/*if(globalID>0)
	{
	fprintf(this->SG_FileHandle,"   Parent:  %s\n",lastNode->name);
	fprintf(this->SG_FileHandle,"   Parent:  %i\n",lastNode->RefNodeID);
	fprintf(this->SG_FileHandle,"   Counter  %i\n",lastNode->count);
	}*/
	
	switch(NCode){

	case  CODE_AcousticMaterial: { NRAcousticMaterial *RefObject = new NRAcousticMaterial(NRefnode);
	                              RefObject->name=name;
							      RefObject->refnode=(AcousticMaterial *)NRefnode;
							      RefObject->RefNodeID=this->globalID;
	                              RefObject->parent=lastNode;
							      lastNode->Add(RefObject);
								  return (RBaseList *) RefObject; break;}
	
	case CODE_AcousticScene:     { NRAcousticScene *RefObject = new NRAcousticScene(NRefnode); 
							      RefObject->name=name;
							      RefObject->refnode=(AcousticScene *)NRefnode;
							      RefObject->RefNodeID=this->globalID;
	                              RefObject->parent=lastNode;
							      lastNode->Add(RefObject);
	                              return RefObject; break;}
    
	case CODE_Anchor:            { NRAnchor *RefObject = new  NRAnchor(NRefnode); 
	                              RefObject->name=name;
							      RefObject->refnode=(Anchor *)NRefnode;
							      RefObject->RefNodeID=this->globalID;
	                              RefObject->parent=lastNode;
							      if(lastNode->isShadowMember==true || lastNode->NodeCode==CODE_Shadow)
								  {
							       RefObject->isShadowMember=true;
								  }
							      if(lastNode->NodeCode!=CODE_Shadow)
								  {
                                   RefObject->shadow.cast=lastNode->shadow.cast;
								   RefObject->shadow.receive=lastNode->shadow.receive;
								   //RefObject->shadow.self=lastNode->shadow.self;
								  }
							      lastNode->Add(RefObject);
	                              return RefObject; break;}

	case CODE_AnimationStream:  { NRAnimationStream *RefObject = new NRAnimationStream(NRefnode); 
	                             RefObject->name=name;
							     RefObject->refnode=(AnimationStream *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
	                             return RefObject; break;}

	case CODE_Appearance:       { NRAppearance *RefObject = new NRAppearance(NRefnode);
	                             RefObject->name=name;
							     RefObject->refnode=(Appearance *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
								 return RefObject; break;}
    
    case CODE_ApplicationWindow:{ NRApplicationWindow *RefObject = new NRApplicationWindow(NRefnode); 
	                             RefObject->name=name;
							     RefObject->refnode=(ApplicationWindow*)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
	                             return RefObject; break;}
    
	case CODE_AudioBuffer:      { NRAudioBuffer *RefObject = new NRAudioBuffer(NRefnode); 
							     RefObject->name=name;
							     RefObject->refnode=(AudioBuffer *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
	                             return RefObject; break;}

	case CODE_AudioClip:        { NRAudioClip *RefObject = new NRAudioClip(NRefnode); 
	 						     RefObject->name=name;
							     RefObject->refnode=(AudioClip *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
	                             return RefObject; break;}

	case CODE_AudioFX:          { NRAudioFX *RefObject = new NRAudioFX(NRefnode); 
							     RefObject->name=name;
							     RefObject->refnode=(AudioFX *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
	                             return RefObject; break;}

	case CODE_AudioMix:         { NRAudioMix *RefObject = new NRAudioMix(NRefnode); 
							     RefObject->name=name;
							     RefObject->refnode=(AudioMix *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
	                             return RefObject; break;}

	case CODE_AudioSource:      { NRAudioSource *RefObject = new NRAudioSource(NRefnode); 
							     RefObject->name=name;
							     RefObject->refnode=(AudioSource *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
	                             return RefObject; break;} 
	
	case CODE_AudioSwitch:      { NRAudioSwitch *RefObject = new NRAudioSwitch(NRefnode); 
							     RefObject->name=name;
							     RefObject->refnode=(AudioSwitch *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
	                             return RefObject; break;}
	
	case CODE_Background:       { NRBackground *RefObject = new NRBackground(NRefnode); 
							     RefObject->name=name;
							     RefObject->refnode=(Background *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
								 return RefObject; break;} 

	case CODE_Background2D:     { NRBackground2D *RefObject = new NRBackground2D(NRefnode); 
							     RefObject->name=name;
							     RefObject->refnode=(Background2D *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
	                             return RefObject; break;}
	 
	case CODE_BAP:              { NRBAP *RefObject = new NRBAP(NRefnode); 
							     RefObject->name=name;
							     RefObject->refnode=(BAP *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
	                             return RefObject; break;} 

	case CODE_BDP:              { NRBDP *RefObject = new NRBDP(NRefnode); 
							     RefObject->name=name;
							     RefObject->refnode=(BDP *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
	                             return RefObject; break;}
	 
	case CODE_Billboard:        { NRBillboard *RefObject = new NRBillboard(NRefnode); 
							     RefObject->name=name;
							     RefObject->refnode=(Billboard *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     if(lastNode->isShadowMember==true || lastNode->NodeCode==CODE_Shadow)
								 {
							      RefObject->isShadowMember=true;
								 }
							     if(lastNode->NodeCode!=CODE_Shadow)
								 {
                                  RefObject->shadow.cast=lastNode->shadow.cast;
								  RefObject->shadow.receive=lastNode->shadow.receive;
								  //RefObject->shadow.self=lastNode->shadow.self;
								 }
							     lastNode->Add(RefObject);
	                             return RefObject; break;}

	case CODE_Bitmap:           { NRBitmap *RefObject = new NRBitmap(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(Bitmap *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
	                             return RefObject; break;}

	case CODE_BitWrapper:       { NRBitWrapper *RefObject = new NRBitWrapper(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(BitWrapper *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
							     RefObject->parent=lastNode;
	                             lastNode->Add(RefObject);
	                             return RefObject; break;}

	case CODE_Body:             { NRBody *RefObject = new NRBody(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(Body *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
	                             return RefObject; break;}

	case CODE_BodyDefTable:     { NRBodyDefTable *RefObject = new NRBodyDefTable(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(BodyDefTable *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
							     RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
	                             return RefObject;}

	case CODE_BodySegmentConnectionHint:{NRBodySegmentConnectionHint *RefObject = new NRBodySegmentConnectionHint(NRefnode);
							             RefObject->name=name;
							             RefObject->refnode=(BodySegmentConnectionHint *)NRefnode;
							             RefObject->RefNodeID=this->globalID;
							             RefObject->parent=lastNode;
							             lastNode->Add(RefObject);
	                                     return RefObject; break;}

	case CODE_Box:              { NRBox *RefObject = new NRBox(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(Box *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
						         RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
	                             return RefObject; break;}

	case CODE_Circle:           { NRCircle *RefObject = new NRCircle(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(Circle *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
							     RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
								 return RefObject; break;}

	case CODE_Clipper2D:        { NRClipper2D *RefObject = new NRClipper2D(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(Clipper2D *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
	                             return RefObject; break;}

	case CODE_Collision:        { NRCollision *RefObject = new NRCollision(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(Collision *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
							     RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
							     if(lastNode->isShadowMember==true || lastNode->NodeCode==CODE_Shadow)
								 {
							      RefObject->isShadowMember=true;
								 }
							     if(lastNode->NodeCode!=CODE_Shadow)
								 {
                                  RefObject->shadow.cast=lastNode->shadow.cast;
								  RefObject->shadow.receive=lastNode->shadow.receive;
								  //RefObject->shadow.self=lastNode->shadow.self;
								 }
	                             return RefObject; break;}

	case CODE_Color:            { NRColor *RefObject = new NRColor(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(Color *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
								 return RefObject; break;} 

	case CODE_ColorInterpolator:{ NRColorInterpolator *RefObject = new NRColorInterpolator(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(ColorInterpolator *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
							     RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
	                             return RefObject; break;}

	case CODE_ColorTransform:   { NRColorTransform *RefObject = new NRColorTransform(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(ColorTransform *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
							     RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
	                             return RefObject; break;}

	case CODE_CompositeTexture2D:{ NRCompositeTexture2D *RefObject = new NRCompositeTexture2D(NRefnode);
							      RefObject->name=name;
							      RefObject->refnode=(CompositeTexture2D *)NRefnode;
							      RefObject->RefNodeID=this->globalID;
	                              RefObject->parent=lastNode;
							      lastNode->Add(RefObject);
	                              return RefObject; break;}

	case CODE_CompositeTexture3D:{ NRCompositeTexture3D *RefObject = new NRCompositeTexture3D(NRefnode);
							      RefObject->name=name;
							      RefObject->refnode=(CompositeTexture3D *)NRefnode;
							      RefObject->RefNodeID=this->globalID;
	                              RefObject->parent=lastNode;
							      lastNode->Add(RefObject);
							      return RefObject; break;}

	case CODE_Conditional:       { NRConditional *RefObject = new NRConditional(NRefnode);
							      RefObject->name=name;
							      RefObject->refnode=(Conditional *)NRefnode;
							      RefObject->RefNodeID=this->globalID;
	                              RefObject->parent=lastNode;
							      lastNode->Add(RefObject);
							      return RefObject; break;}

	case CODE_Cone:              { NRCone *RefObject = new NRCone(NRefnode);
							      RefObject->name=name;
							      RefObject->refnode=(Cone *)NRefnode;
							      RefObject->RefNodeID=this->globalID;
	                              RefObject->parent=lastNode;
							      lastNode->Add(RefObject);
							      return RefObject; break;}

	case CODE_Coordinate:        { NRCoordinate *RefObject = new NRCoordinate(NRefnode);
							      RefObject->name=name;
							      RefObject->refnode=(Coordinate *)NRefnode;
							      RefObject->RefNodeID=this->globalID;
	                              RefObject->parent=lastNode;
							      lastNode->Add(RefObject);
							      return RefObject; break;}

	case CODE_Coordinate2D:      { NRCoordinate2D *RefObject = new NRCoordinate2D(NRefnode);
							      RefObject->name=name;
							      RefObject->refnode=(Coordinate2D *)NRefnode;
							      RefObject->RefNodeID=this->globalID;
 	                              RefObject->parent=lastNode;
							      lastNode->Add(RefObject);
							      return RefObject; break;}

	case CODE_CoordinateInterpolator:
		{ NRCoordinateInterpolator *RefObject = new NRCoordinateInterpolator(NRefnode);
							          RefObject->name=name;
							          RefObject->refnode=(CoordinateInterpolator *)NRefnode;
							          RefObject->RefNodeID=this->globalID;
	                                  RefObject->parent=lastNode;
							          lastNode->Add(RefObject);
							          return RefObject; break;}

	case CODE_CoordinateInterpolator2D: 
		{ NRCoordinateInterpolator2D *RefObject = new NRCoordinateInterpolator2D(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(CoordinateInterpolator2D *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_CoordinateInterpolator4D:
	  { NRCoordinateInterpolator4D *RefObject = new NRCoordinateInterpolator4D(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(CoordinateInterpolator4D *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_Curve2D:        { NRCurve2D *RefObject = new NRCurve2D(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(Curve2D *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_Cylinder:       { NRCylinder *RefObject = new NRCylinder(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(Cylinder *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_CylinderSensor: { NRCylinderSensor *RefObject = new NRCylinderSensor(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(CylinderSensor *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_DepthImage:     { NRDepthImage *RefObject = new NRDepthImage(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(DepthImage *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_DepthImageV2:  { NRDepthImageV2 *RefObject = new NRDepthImageV2(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(DepthImageV2 *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_DirectionalLight:{ NRDirectionalLight *RefObject = new NRDirectionalLight(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(DirectionalLight *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
							    //LightGroupMMap.insert(std::pair<RBaseList*,RBaseList*>(lastNode,RefObject));
							    RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
								this->sg_info.num_direclights++;
							    return RefObject; break;}

	case CODE_DirectiveSound:{ NRDirectiveSound *RefObject = new NRDirectiveSound(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(DirectiveSound *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_DiscSensor:    { NRDiscSensor *RefObject = new NRDiscSensor(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(DiscSensor *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_ElevationGrid: { NRElevationGrid *RefObject = new NRElevationGrid(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(ElevationGrid *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

/*	case CODE_Ellipse:
	  { NREllipse *RefObject = new NREllipse(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(XEllipse *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}*/

	case CODE_Expression:    { NRExpression *RefObject = new NRExpression(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(Expression *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_Extrusion:     { NRExtrusion *RefObject = new NRExtrusion(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(Extrusion *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_Face:          { NRFace *RefObject = new NRFace(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(Face *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_FaceDefMesh:   { NRFaceDefMesh *RefObject = new NRFaceDefMesh(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(FaceDefMesh *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_FaceDefTables: { NRFaceDefTables *RefObject = new NRFaceDefTables(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(FaceDefTables *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_FaceDefTransform:{ NRFaceDefTransform *RefObject = new NRFaceDefTransform(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(FaceDefTransform *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_FAP:           { NRFAP *RefObject = new NRFAP(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(FAP *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_FDP:           { NRFDP *RefObject = new NRFDP(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(FDP *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_FFD:           { NRFFD *RefObject = new NRFFD(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(FFD *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_FIT:           { NRFIT *RefObject = new NRFIT(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(FIT *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_Fog:           { NRFog *RefObject = new NRFog(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(Fog *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   this->sg_info.hasFogToRender=true;
							   return RefObject; break;}

    case CODE_FontStyle:     { NRFontStyle *RefObject = new NRFontStyle(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(FontStyle *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_Form:          { NRForm *RefObject = new NRForm(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(Form *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_Group:         { NRGroup *RefObject = new NRGroup(NRefnode);
							   RefObject->name=name;							  
							   RefObject->refnode=(Group *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   if(lastNode->isShadowMember==true || lastNode->NodeCode==CODE_Shadow)
							   {
							     RefObject->isShadowMember=true;
							   }
							   if(lastNode->NodeCode!=CODE_Shadow)
							   {
                                 RefObject->shadow.cast=lastNode->shadow.cast;
								 RefObject->shadow.receive=lastNode->shadow.receive;
								 //RefObject->shadow.self=lastNode->shadow.self;
							   }
							   return (RBaseList *) RefObject;}

	case CODE_Hierarchical3DMesh:
		{ NRHierarchical3DMesh *RefObject = new NRHierarchical3DMesh(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(Hierarchical3DMesh *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_ImageTexture:  { NRImageTexture *RefObject = new NRImageTexture(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(ImageTexture *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_IndexedFaceSet:{ NRIndexedFaceSet *RefObject = new NRIndexedFaceSet(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(IndexedFaceSet *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}
	
	case CODE_IndexedFaceSet2D:
		{ NRIndexedFaceSet2D *RefObject = new NRIndexedFaceSet2D(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(IndexedFaceSet2D *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
		      				   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_IndexedLineSet:{ NRIndexedLineSet *RefObject = new NRIndexedLineSet(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(IndexedLineSet *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_IndexedLineSet2D:{ NRIndexedLineSet2D *RefObject = new NRIndexedLineSet2D(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(IndexedLineSet2D *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_Inline:         { NRInline *RefObject = new NRInline(NRefnode);
							    RefObject->name=name;							  
							    RefObject->refnode=(Inline *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    if(lastNode->isShadowMember==true || lastNode->NodeCode==CODE_Shadow)
								{
							     RefObject->isShadowMember=true;
								}
							    if(lastNode->NodeCode!=CODE_Shadow)
								{
                                 RefObject->shadow.cast=lastNode->shadow.cast;
								 RefObject->shadow.receive=lastNode->shadow.receive;
								 //RefObject->shadow.self=lastNode->shadow.self;
								}
							    return RefObject; break;}

	case CODE_InputSensor:    { NRInputSensor *RefObject = new NRInputSensor(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(InputSensor *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

    case CODE_Layer2D:        { NRLayer2D *RefObject = new NRLayer2D(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(Layer2D *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_Layer3D:        { NRLayer3D *RefObject = new NRLayer3D(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(Layer3D *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_Layout:         { NRLayout *RefObject = new NRLayout(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(Layout *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_LinearGradient: { NRLinearGradient *RefObject = new NRLinearGradient(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(LinearGradient *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_LineProperties: { NRLineProperties *RefObject = new NRLineProperties(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(LineProperties *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_ListeningPoint: { NRListeningPoint *RefObject = new NRListeningPoint(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(ListeningPoint *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_LOD:            { NRLOD *RefObject = new NRLOD(NRefnode);
							    RefObject->name=name;							   
							    RefObject->refnode=(LOD *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    if(lastNode->isShadowMember==true || lastNode->NodeCode==CODE_Shadow)
								{
							     RefObject->isShadowMember=true;
								}
							    if(lastNode->NodeCode!=CODE_Shadow)
								{
                                 RefObject->shadow.cast=lastNode->shadow.cast;
								 RefObject->shadow.receive=lastNode->shadow.receive;
								 //RefObject->shadow.self=lastNode->shadow.self;
								}
							    return RefObject; break;}

	case CODE_Material:       { NRMaterial *RefObject = new NRMaterial(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(Material *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_Material2D:     { NRMaterial2D *RefObject = new NRMaterial2D(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(Material2D *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_MaterialKey:    { NRMaterialKey *RefObject = new NRMaterialKey(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(MaterialKey *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_MatteTexture:   { NRMatteTexture *RefObject = new NRMatteTexture(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(MatteTexture *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_MediaBuffer:    { NRMediaBuffer *RefObject = new NRMediaBuffer(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(MediaBuffer *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_MediaControl:   { NRMediaControl *RefObject = new NRMediaControl(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(MediaControl *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_MediaSensor:    { NRMediaSensor *RefObject = new NRMediaSensor(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(MediaSensor *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_MeshGrid:       { NRMeshGrid *RefObject = new NRMeshGrid(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(MeshGrid *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_MovieTexture:   { NRMovieTexture *RefObject = new NRMovieTexture(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(MovieTexture *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_NavigationInfo: { NRNavigationInfo *RefObject = new NRNavigationInfo(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(NavigationInfo *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}
	
	case CODE_NonLinearDeformer:{ NRNonLinearDeformer *RefObject = new NRNonLinearDeformer(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(NonLinearDeformer *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
							     return RefObject; break;}

	case CODE_Normal:           { NRNormal *RefObject = new NRNormal(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(Normal *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
							     return RefObject; break;}

	case CODE_NormalInterpolator:{ NRNormalInterpolator *RefObject = new NRNormalInterpolator(NRefnode);
							      RefObject->name=name;
							      RefObject->refnode=(NormalInterpolator *)NRefnode;
							      RefObject->RefNodeID=this->globalID;
	                              RefObject->parent=lastNode;
							      lastNode->Add(RefObject);
							      return RefObject; break;}

	case CODE_NurbsCurve:       { NRNurbsCurve *RefObject = new NRNurbsCurve(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(NurbsCurve *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
							     return RefObject; break;}

	case CODE_NurbsCurve2D:     { NRNurbsCurve2D *RefObject = new NRNurbsCurve2D(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(NurbsCurve2D *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
							     return RefObject; break;}

	case CODE_NurbsSurface:     { NRNurbsSurface *RefObject = new NRNurbsSurface(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(NurbsSurface *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
							     return RefObject; break;}

	case CODE_OctreeImage:      { NROctreeImage *RefObject = new NROctreeImage(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(OctreeImage *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
							     return RefObject; break;}

	case CODE_OrderedGroup:     { NROrderedGroup *RefObject = new NROrderedGroup(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(OrderedGroup *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
							     return RefObject; break;}

	case CODE_OrientationInterpolator:
		{ NROrientationInterpolator *RefObject = new NROrientationInterpolator(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(OrientationInterpolator *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
		     				   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_PathLayout:	  { NRPathLayout *RefObject = new NRPathLayout(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(PathLayout *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_PerceptualParameters:
	  { NRPerceptualParameters *RefObject = new NRPerceptualParameters(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(PerceptualParameters *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_PixelTexture:	  { NRPixelTexture *RefObject = new NRPixelTexture(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(PixelTexture *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_PlaneSensor:	  { NRPlaneSensor *RefObject = new NRPlaneSensor(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(PlaneSensor *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_PlaneSensor2D:	  { NRPlaneSensor2D *RefObject = new NRPlaneSensor2D(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(PlaneSensor2D *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_PointLight:	  { NRPointLight *RefObject = new NRPointLight(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(PointLight *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           //LightGroupMMap.insert(std::pair<RBaseList*,RBaseList*>(lastNode,RefObject));
							   RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
								this->sg_info.num_pointlights++;
							   return RefObject; break;}

	case CODE_PointSet:	  { NRPointSet *RefObject = new NRPointSet(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(PointSet *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_PointSet2D:	  { NRPointSet2D *RefObject = new NRPointSet2D(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(PointSet2D *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_PointTexture:	  { NRPointTexture *RefObject = new NRPointTexture(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(PointTexture *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_PointTextureV2: { NRPointTextureV2 *RefObject = new NRPointTextureV2(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(PointTextureV2 *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}
	
	case CODE_PositionAnimator:{ NRPositionAnimator *RefObject = new NRPositionAnimator(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(PositionAnimator *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_PositionAnimator2D:
	  { NRPositionAnimator2D *RefObject = new NRPositionAnimator2D(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(PositionAnimator2D *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_PositionInterpolator:
	  { NRPositionInterpolator *RefObject = new NRPositionInterpolator(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(PositionInterpolator *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_PositionInterpolator2D:
	  { NRPositionInterpolator2D *RefObject = new NRPositionInterpolator2D(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(PositionInterpolator2D *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_PositionInterpolator4D:
	  { NRPositionInterpolator4D *RefObject = new NRPositionInterpolator4D(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(PositionInterpolator4D *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_ProceduralTexture:
	  { NRProceduralTexture *RefObject = new NRProceduralTexture(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(ProceduralTexture *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_ProximitySensor:{ NRProximitySensor *RefObject = new NRProximitySensor(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(ProximitySensor *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_ProximitySensor2D:
	  { NRProximitySensor2D *RefObject = new NRProximitySensor2D(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(ProximitySensor2D *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_QuantizationParameter:
	  { NRQuantizationParameter *RefObject = new NRQuantizationParameter(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(QuantizationParameter *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_RadialGradient: { NRRadialGradient *RefObject = new NRRadialGradient(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(RadialGradient *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_Rectangle:     { NRRectangle *RefObject = new NRRectangle(NRefnode);
							   RefObject->name=name;						
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_SBBone:   	  { NRSBBone *RefObject = new NRSBBone(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(SBBone *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_SBMuscle: 	  { NRSBMuscle *RefObject = new NRSBMuscle(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(SBMuscle *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_SBSegment:	  { NRSBSegment *RefObject = new NRSBSegment(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(SBSegment *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_SBSite:   	  { NRSBSite *RefObject = new NRSBSite(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(SBSite *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_SBSkinnedModel:{ NRSBSkinnedModel *RefObject = new NRSBSkinnedModel(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(SBSkinnedModel *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_SBVCAnimation:  { NRSBVCAnimation *RefObject = new NRSBVCAnimation(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(SBVCAnimation *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_ScalarAnimator: { NRScalarAnimator *RefObject = new NRScalarAnimator(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(ScalarAnimator *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_ScalarInterpolator:
	  { NRScalarInterpolator *RefObject = new NRScalarInterpolator(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(ScalarInterpolator *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_Script:   	  { NRScript *RefObject = new NRScript(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(Script *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_ServerCommand:  { NRServerCommand *RefObject = new NRServerCommand(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(ServerCommand *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_Shadow:   	  { NRShadow *RefObject = new NRShadow(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(Shadow *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   RefObject->isShadowMember=true;
							   //RefObject->isRenderable=true;
							   if(lastNode->isShadowMember==true || lastNode->NodeCode==CODE_Shadow)
							   { return lastNode; break;}   ///!!!!!!! Achtung dieses nochmal berprfen
							   else {
								   return RefObject; break;}}

	case CODE_Shape:          { NRShape *RefObject = new NRShape(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(Shape *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    RefObject->isRenderable=true;
								this->sg_info.num_nrshape_nodes++;
							    if(lastNode->isShadowMember==true || lastNode->NodeCode==CODE_Shadow)
								{
							     RefObject->isShadowMember=true;
								 this->sg_info.num_nrshape_shadow_nodes++;
							 	 
								}else
								{
                                 this->sg_info.num_nrshape_noshadow_nodes++; 
								 RefObject->ShapeNR=this->sg_info.num_nrshape_noshadow_nodes; 
								}
							    if(lastNode->NodeCode!=CODE_Shadow)
								{
                                 RefObject->shadow.cast=lastNode->shadow.cast;
								 RefObject->shadow.receive=lastNode->shadow.receive;
								 //RefObject->shadow.self=lastNode->shadow.self;
								}
							    ShapeMMap.insert(std::pair<MediaObject*,NRShape*>(NRefnode,RefObject));
							    return RefObject; break;}

	case CODE_SimpleTexture:   { NRSimpleTexture *RefObject = new NRSimpleTexture(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(SimpleTexture *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_SimpleTextureV2: { NRSimpleTextureV2 *RefObject = new NRSimpleTextureV2(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(SimpleTextureV2 *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_Sound:           { NRSound *RefObject = new NRSound(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(Sound *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_Sound2D:         { NRSound2D *RefObject = new NRSound2D(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(Sound2D *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_Sphere:          { NRSphere *RefObject = new NRSphere(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(Sphere *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_SphereSensor:    { NRSphereSensor *RefObject = new NRSphereSensor(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(SphereSensor *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_SpotLight:       { NRSpotLight *RefObject = new NRSpotLight(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(SpotLight *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            //LightGroupMMap.insert(std::pair<RBaseList*,RBaseList*>(lastNode,RefObject));
							    RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
								this->sg_info.num_spotlights++;
							    return RefObject; break;}

	case CODE_SubdivisionSurface:
		{ NRSubdivisionSurface *RefObject = new NRSubdivisionSurface(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(SubdivisionSurface *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_SubdivSurfaceSector:
		{ NRSubdivSurfaceSector *RefObject = new NRSubdivSurfaceSector(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(SubdivSurfaceSector *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}


	case CODE_Switch:          { NRSwitch *RefObject = new NRSwitch(NRefnode);
							    RefObject->name=name;							   
							    RefObject->refnode=(Switch *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    if(lastNode->isShadowMember==true || lastNode->NodeCode==CODE_Shadow)
								{
							     RefObject->isShadowMember=true;
								}
							    if(lastNode->NodeCode!=CODE_Shadow)
								{
                                 RefObject->shadow.cast=lastNode->shadow.cast;
								 RefObject->shadow.receive=lastNode->shadow.receive;
								 //RefObject->shadow.self=lastNode->shadow.self;
								}
							    return RefObject; break;}

	case CODE_SynthesizedTexture:
	  { NRSynthesizedTexture *RefObject = new NRSynthesizedTexture(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(SynthesizedTexture *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_TemporalGroup:    { NRTemporalGroup *RefObject = new NRTemporalGroup(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(TemporalGroup *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
							     return RefObject; break;}

	case CODE_TemporalTransform:{ NRTemporalTransform *RefObject = new NRTemporalTransform(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(TemporalTransform *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
							     return RefObject; break;}

	case CODE_TermCap:          { NRTermCap *RefObject = new NRTermCap(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(TermCap *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_Text:             { NRText *RefObject = new NRText(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(Text *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
							     return RefObject; break;}

	case CODE_TextureCoordinate:{ NRTextureCoordinate *RefObject = new NRTextureCoordinate(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(TextureCoordinate *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
							     return RefObject; break;}

	case CODE_TextureTransform: { NRTextureTransform *RefObject = new NRTextureTransform(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(TextureTransform *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
							     return RefObject; break;}

	case CODE_TimeSensor:       { NRTimeSensor *RefObject = new NRTimeSensor(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(TimeSensor *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
							     return RefObject; break;}

	case CODE_TouchSensor:      { NRTouchSensor *RefObject = new NRTouchSensor(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(TouchSensor *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
							     return RefObject; break;}

	case CODE_Transform:        { NRTransform *RefObject = new NRTransform((Transform*) NRefnode);
							     RefObject->name=name;
							     //RefObject->refnode=(Transform *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
                                 lastNode->Add(RefObject);
							     if(lastNode->isShadowMember==true || lastNode->NodeCode==CODE_Shadow)
								 {
							      RefObject->isShadowMember=true;
								 }
							     if(lastNode->NodeCode!=CODE_Shadow)
								 {
                                 RefObject->shadow.cast=lastNode->shadow.cast;
								 RefObject->shadow.receive=lastNode->shadow.receive;
								 //RefObject->shadow.self=lastNode->shadow.self;
								 }
							     return RefObject; break;}

	case CODE_Transform2D:      { NRTransform2D *RefObject = new NRTransform2D(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(Transform2D *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
							     return RefObject; break;}


	case CODE_TransformMatrix2D:{ NRTransformMatrix2D *RefObject = new NRTransformMatrix2D(NRefnode);
							     RefObject->name=name;
							     RefObject->refnode=(TransformMatrix2D *)NRefnode;
							     RefObject->RefNodeID=this->globalID;
	                             RefObject->parent=lastNode;
							     lastNode->Add(RefObject);
							     return RefObject; break;}

	case CODE_Valuator:        { NRValuator *RefObject = new NRValuator(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(Valuator *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;} 

	case CODE_Viewpoint:       { NRViewpoint *RefObject = new NRViewpoint(NRefnode);
	                            RefObject->name=name;
							    RefObject->refnode=(Viewpoint *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							     return RefObject; break;}

	case CODE_Viewport:  	  { NRViewport *RefObject = new NRViewport(NRefnode);
						       RefObject->name=name;
							   RefObject->refnode=(Viewport *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return (RBaseList *)RefObject;}

	case CODE_Viseme:    	  { NRViseme *RefObject = new NRViseme(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(Viseme *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
						       return RefObject; break;}

	case CODE_VisibilitySensor:{ NRVisibilitySensor *RefObject = new NRVisibilitySensor(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(VisibilitySensor *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_WaveletSubdivisionSurface:
	  { NRWaveletSubdivisionSurface *RefObject = new NRWaveletSubdivisionSurface(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(WaveletSubdivisionSurface *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}


	case CODE_WorldInfo:      { NRWorldInfo *RefObject = new NRWorldInfo(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(WorldInfo *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_XCurve2D: 	  { NRXCurve2D *RefObject = new NRXCurve2D(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(XCurve2D *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_XEllipse: 	  { NRXEllipse *RefObject = new NRXEllipse(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(XEllipse *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
						       lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_XFontStyle:     { NRXFontStyle *RefObject = new NRXFontStyle(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(XFontStyle *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_XLineProperties:{ NRXLineProperties *RefObject = new NRXLineProperties(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(XLineProperties *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_Implicit:     { NRImplicit *RefObject = new NRImplicit(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(Implicit *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_XXLFM_Appearance:{ NRXXLFM_Appearance *RefObject = new NRXXLFM_Appearance(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(XXLFM_Appearance *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_XXLFM_BlendList:{ NRXXLFM_BlendList *RefObject = new NRXXLFM_BlendList(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(XXLFM_BlendList *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_XXLFM_FrameList:{ NRXXLFM_FrameList *RefObject = new NRXXLFM_FrameList(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(XXLFM_FrameList *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_XXLFM_LightMap:{ NRXXLFM_LightMap *RefObject = new NRXXLFM_LightMap(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(XXLFM_LightMap *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_XXLFM_SurfaceMapList:
		{ NRXXLFM_SurfaceMapList *RefObject = new NRXXLFM_SurfaceMapList(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(XXLFM_SurfaceMapList *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_XXLFM_ViewMapList:
	  { NRXXLFM_ViewMapList *RefObject = new NRXXLFM_ViewMapList(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(XXLFM_ViewMapList *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

    case CODE_XXParticleInitBox:
	  { NRXXParticleInitBox *RefObject = new NRXXParticleInitBox(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(XXParticleInitBox *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_XXParticles:   { NRXXParticles *RefObject = new NRXXParticles(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(XXParticles *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_XXPlanarObstacle:
	  { NRXXPlanarObstacle *RefObject = new NRXXPlanarObstacle(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(XXPlanarObstacle *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_XXPointAttractor:
	  { NRXXPointAttractor *RefObject = new NRXXPointAttractor(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(XXPointAttractor *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_Quadric:
	  { NRQuadric *RefObject = new NRQuadric(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(Quadric *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_SolidRep:
	  { NRSolidRep *RefObject = new NRSolidRep(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(SolidRep *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}
	 

	case CODE_MorphShape:
	  { NRMorphShape *RefObject = new NRMorphShape();
							   RefObject->name=name;
							   RefObject->refnode=(MorphShape *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}
/*
	case CODE_IndexedFaceSetV2:
	  { NRIndexedFaceSetV2 *RefObject = new NRIndexedFaceSetV2();
							   RefObject->name=name;
							   RefObject->refnode=(IndexedFaceSetV2 *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}

	case CODE_MultiTextureCoordinate:
	  { NRMultiTextureCoordinate *RefObject = new NRMultiTextureCoordinate(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(MultiTextureCoordinate *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}
*/
	case CODE_MultiTexture:
	  { NRMultiTexture *RefObject = new NRMultiTexture(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(MultiTexture *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							   return RefObject; break;}
	
	case CODE_SurroundingSound: 
	  { NRSurroundingSound *RefObject = new NRSurroundingSound(NRefnode);
							    RefObject->name=name;
							    RefObject->refnode=(SurroundingSound *)NRefnode;
							    RefObject->RefNodeID=this->globalID;
	                            RefObject->parent=lastNode;
							    lastNode->Add(RefObject);
							    return RefObject; break;}

	case CODE_Transform3DAudio:
	  { NRTransform3DAudio *RefObject = new NRTransform3DAudio(NRefnode);
							    RefObject->name=name;
								RefObject->refnode=(Transform3DAudio *)NRefnode;
								RefObject->RefNodeID=this->globalID;
								RefObject->parent=lastNode;
								lastNode->Add(RefObject);
								return RefObject; break;}

	case CODE_WideSound:
	  { NRWideSound *RefObject = new NRWideSound(NRefnode);
							   RefObject->name=name;
							   RefObject->refnode=(WideSound *)NRefnode;
							   RefObject->RefNodeID=this->globalID;
	                           RefObject->parent=lastNode;
							   lastNode->Add(RefObject);
							   return RefObject; break;}  
	}

	
}

void SGManager::ShowLightMultiMap(void)
{

    FILE *logMM;
	//logMM=fopen("LightMM.log","w+");
	logMM=this->SG_FileHandle;
	
	
	       fprintf(logMM,"***********************************************************\n");
		   fprintf(logMM,"*                    Scene Info                           *\n");
		   fprintf(logMM,"*                                                         *\n");
		   fprintf(logMM,"*                                                         *\n");
		   fprintf(logMM,"***********************************************************\n");
	
	fprintf(logMM,"Number of all NRShape Nodes                  : %i \n",this->sg_info.num_nrshape_nodes);
	fprintf(logMM,"Number of all no shadow member NRShape Nodes : %i \n",this->sg_info.num_nrshape_noshadow_nodes);
	fprintf(logMM,"Number of all shadow member NRShape Nodes    : %i \n",this->sg_info.num_nrshape_shadow_nodes); 
	fprintf(logMM,"Number of PointLights                        : %i \n",this->sg_info.num_pointlights);
	fprintf(logMM,"Number of SpotLights                         : %i \n",this->sg_info.num_spotlights);
	fprintf(logMM,"Number of DirectionalLights                  : %i \n",this->sg_info.num_direclights); 
	
	
	
	//fprintf(logMM,"SHOW MULTIMAP \n");
	       fprintf(logMM,"***********************************************************\n");
		   fprintf(logMM,"*         NRGroupNode - NRLightNode Relation              *\n");
		   fprintf(logMM,"*                                                         *\n");
		   fprintf(logMM,"* Data: Group,Position in SceneGraph,Light, Pos. in SG    *\n");
		   fprintf(logMM,"***********************************************************\n");

	for (std::multimap<RBaseList*, RBaseList*>::iterator it = LightGroupMMap.begin();
       it != LightGroupMMap.end();
       ++it)
	   {
		   

		   fprintf(logMM,"%s %i %s %i\n",(*it).first->name,(*it).first->RefNodeID,(*it).second->name,(*it).second->RefNodeID);
	   
	   
	   }
           fprintf(logMM,"***********************************************************\n");
		   fprintf(logMM,"*         NRShapeNode - NRLightNode Relation              *\n");
		   fprintf(logMM,"*         Result Based on the Group/Light Relation        *\n");
		   fprintf(logMM,"* Data: Shape,Position in SceneGraph,Light, Pos. in SG    *\n");
		   fprintf(logMM,"* Data: Shadow: cast receive self                         *\n");
     	   fprintf(logMM,"***********************************************************\n");

	for (std::multimap<RBaseList*, RBaseList*>::iterator it2 = LightShapeMMap.begin();
       it2 != LightShapeMMap.end();
       ++it2)
	   {
		  fprintf(logMM,"Shape RefNodeID: %i NodeID: %i LightType: %s  RefNodeID: %i\n",(*it2).first->RefNodeID,(*it2).first->NodeID,(*it2).second->name,(*it2).second->RefNodeID);
		  fprintf(logMM,"Shadow Properties: cast: %i receive: %i  \n\n",(*it2).first->shadow.cast,(*it2).first->shadow.receive);
	      
	   
	   }

	   fprintf(logMM,"***********************************************************\n");
	   fprintf(logMM,"*       Pointer MediaObj - NRShapeNode                    *\n");
	   fprintf(logMM,"* Data: Pointer MO , NRShape                              *\n");
       fprintf(logMM,"***********************************************************\n");

	for (std::multimap<MediaObject*, NRShape*>::iterator it7 = ShapeMMap.begin();
       it7 != ShapeMMap.end();
       ++it7)
	   {
		   		      
         //fprintf(logMM,"%i %s %i\n",(DWORD)((*it7).second->refnode),(*it7).second->name,(*it7).second->RefNodeID);
         fprintf(logMM,"Created NRShapeObject \n");
		 fprintf(logMM,"MediaObject Pointer: %i NodeID: %i RefNodeID: %i\n\n",(DWORD)((*it7).second->refnode),(*it7).first->GetID(),(*it7).second->RefNodeID);
		 //fprintf(logMM,"NodeID             : %i\n",(*it7).second->NodeID);
		 //fprintf(logMM,"RefNodeID          : %i\n",(*it7).second->RefNodeID);
		 //fprintf(logMM,"FLAG isRenderable  : %i\n",(*it7).second->isRenderable);
		 //fprintf(logMM,"FLAG isShadowMember: %i\n\n",(*it7).second->isShadowMember);
		   
	   
	   }
	   fprintf(logMM,"***********************************************************\n");
	   fprintf(logMM,"*         RenderSLMap NRLight - NRShape                     *\n");
	   fprintf(logMM,"*                                                         *\n");
	   fprintf(logMM,"* Data: NRLight,Position in SceneGraph,NRShape, Pos.in SG *\n");
	   fprintf(logMM,"* Data: Shadow: cast receive self                         *\n");
       fprintf(logMM,"***********************************************************\n");


	for (std::multimap<RBaseList*, NRShape*>::iterator it4 = RenderSLMap.begin();
       it4 != RenderSLMap.end();
       ++it4)
	   {
		   		      
         fprintf(logMM,"%s RefNodeID: %i NodeID: %i %s RefNodeID: %i NodeID: %i  ShapeNR: %i\n",(*it4).first->name,(*it4).first->RefNodeID,(*it4).first->NodeID,(*it4).second->name,(*it4).second->RefNodeID,(*it4).second->NodeID,(*it4).second->ShapeNR);
		 (*it4).second->GetShadowProp((*it4).first);
		 fprintf(logMM,"Shadow Properties: cast %i receive %i\n\n",(*it4).second->shadow.cast,(*it4).second->shadow.receive);

		   
	   
	   }
	


	   fprintf(logMM,"***********************************************************\n");
	   fprintf(logMM,"*         RenderNSLMap NRLight - NRShape                     *\n");
	   fprintf(logMM,"*                                                         *\n");
	   fprintf(logMM,"* Data: NRLight,Position in SceneGraph,NRShape, Pos.in SG *\n");
	   fprintf(logMM,"* Data: Shadow: cast receive self                         *\n");
       fprintf(logMM,"***********************************************************\n");


	for (std::multimap<RBaseList*, NRShape*>::iterator it5 = RenderNSLMap.begin();
       it5 != RenderNSLMap.end();
       ++it5)
	   {
		   		      
         fprintf(logMM,"%s RefNodeID: %i NodeID: %i %s RefNodeID: %i NodeID: %i ShapeNR: %i\n",(*it5).first->name,(*it5).first->RefNodeID,(*it5).first->NodeID,(*it5).second->name,(*it5).second->RefNodeID,(*it5).second->NodeID,(*it5).second->ShapeNR);
		 //(*it4).second->GetShadowProp((*it4).first);
		 //fprintf(logMM,"Shadow Properties: cast %i receive %i self %i\n\n",(*it4).second->shadow.cast,(*it4).second->shadow.receive,(*it4).second->shadow.self);

		   
	   
	   }

       if(activeLight->Light!=NULL)
	   {
	   fprintf(logMM,"***********************************************************\n");
	   fprintf(logMM,"*         RenderMultiMaps NRLight / NRShape               *\n");
	   fprintf(logMM,"*                                                         *\n");
       fprintf(logMM,"***********************************************************\n");
       int maxlight;
	   maxlight= sg_info.num_direclights+sg_info.num_pointlights+sg_info.num_spotlights;
       for(int i=1; i<=maxlight; i++)
	   {
	     this->SetActiveLight(i);
		 fprintf(logMM,"LightProperties: %s  RefNodeID: %i  LightNummer: %i \n",activeLight->Light->name,activeLight->Light->RefNodeID,activeLight->LightNR);    
         fprintf(logMM,"Cast Shapes      Nummer: %i \n",activeLight->cast_objects);
         
		 for (std::multimap<int, NRShape*>::iterator it6 = activeLight->cast_pass.begin();
              it6 != activeLight->cast_pass.end();
              ++it6)
			{
		   		      
         fprintf(logMM,"%i %s RefNodeID: %i NodeID: %i ShapeNR: %i\n",(*it6).first,(*it6).second->name,(*it6).second->RefNodeID,(*it6).second->NodeID,(*it6).second->ShapeNR);
		 	   }  
	   
	     fprintf(logMM,"Receive Shapes      Nummer: %i \n",activeLight->receive_objects);
         
		 for (it6 = activeLight->receive_pass.begin();
              it6 != activeLight->receive_pass.end();
              ++it6)
			{
		   		      
         fprintf(logMM,"%i %s RefNodeID: %i NodeID: %i ShapeNR: %i\n",(*it6).first,(*it6).second->name,(*it6).second->RefNodeID,(*it6).second->NodeID,(*it6).second->ShapeNR);
		 	   }   

		 fprintf(logMM,"NoShadow Shapes      Nummer: %i \n",activeLight->noshadow_objects);
         
		 for (it6 = activeLight->noshadow_pass.begin();
              it6 != activeLight->noshadow_pass.end();
              ++it6)
			{
		   		      
         fprintf(logMM,"%i %s RefNodeID: %i NodeID: %i ShapeNR: %i\n",(*it6).first,(*it6).second->name,(*it6).second->RefNodeID,(*it6).second->NodeID,(*it6).second->ShapeNR);
		 	   }  
	   }
       }
   //fprintf(logMM,"SHOW MULTIMAP END \n");
   //fclose(logMM);

}


void SGManager::GenerateLightShapeMultiMap(std::multimap<RBaseList*, RBaseList*> LMultiMap)
{
	
	std::multimap<RBaseList*, RBaseList*> temp;
	bool check1 = true;
	

	std::multimap<RBaseList*,RBaseList*>::iterator it = LMultiMap.begin();
	int mm_count = 0;
	while(it != LMultiMap.end())
	{
          RBaseList *ptr = (*it).first->head;
		  for(int i = 0;i < (*it).first->count; i++)
		  {
		    if(ptr->isGroupingNode==true)
			{
			  if((((*it).second->parent==ptr->parent) && ptr->NodeCode==CODE_Shadow)|| (((*it).second->parent!=ptr->parent) && ptr->NodeCode!=CODE_Shadow))           
			  { 
				  
				  temp.insert(std::pair<RBaseList*,RBaseList*>(ptr,(*it).second));
			      mm_count++; 

			  }
			 
			  
			  //temp.insert(std::pair<RBaseList*,RBaseList*>(ptr,(*it).second));
			  //mm_count++; 
			  
			}

			if(ptr->isRenderable==true)
			{
				for(std::multimap<MediaObject*,NRShape*>::iterator it2 = ShapeMMap.begin();
				it2 != ShapeMMap.end();++it2)
                {
                  if(((*it2).second->isShadowMember == true) && ((*it2).second->refnode ==((NRShape*)ptr)->refnode))
				  {   
					  for(std::multimap<RBaseList*, RBaseList*>::iterator it3 = LightShapeMMap.begin(); 
                          it3!=LightShapeMMap.end();++it3)
						    
						  { 
							    
                            if( (((NRShape*)((*it3).first))->refnode == ((NRShape*)ptr)->refnode) &&( (((NRSpotLight*)((*it3).second))->refnode == ((NRSpotLight*)((*it).second))->refnode)||
								(((NRPointLight*)((*it3).second))->refnode == ((NRPointLight*)((*it).second))->refnode)||
								(((NRDirectionalLight*)((*it3).second))->refnode == ((NRDirectionalLight*)((*it).second))->refnode)))
							{
								check1=false;
                                
								((NRShape*)((*it3).first))->shadow.cast = ((NRShape*)ptr)->shadow.cast || ((NRShape*)((*it3).first))->shadow.cast;
								((NRShape*)((*it3).first))->shadow.receive = ((NRShape*)ptr)->shadow.receive || ((NRShape*)((*it3).first))->shadow.receive;
								//((NRShape*)((*it3).first))->shadow.self = ((NRShape*)ptr)->shadow.self || ((NRShape*)((*it3).first))->shadow.self;
								
								
							}
							

						  }
				  }
				 // nderungen fr ShadowRendering Status2 
                 //if(((*it2).second->isShadowMember == false) && ((*it2).second->refnode ==((NRShape*)ptr)->refnode))
				 // {   
					  //check1=false;
                 //     RenderNSLMap.insert(std::pair<RBaseList*,NRShape*>((*it).second,(*it2).second)); 
				 // } 
                   


				 // 
				}
				if(check1==true)
				{ LightShapeMMap.insert(std::pair<RBaseList*,RBaseList*>(ptr,(*it).second));}
				//fprintf(SG_FileHandle,"\n %s %i %s %i\n\n",ptr->name,ptr->RefNodeID,(*it).second->name,(*it).second->RefNodeID);}
			}
			check1=true;
			ptr = ptr->next; 
		  }
		  
		  
		  ++it;
		}
	 it == LMultiMap.begin();
	 while(it !=LMultiMap.end())
	 {
        temp.insert(std::pair<RBaseList*,RBaseList*>((*it).first,(*it).second));
		++it;
	 }
	
	
	if(mm_count!=0) { GenerateLightShapeMultiMap(temp);}
}



void SGManager::DirectNSLMap(std::multimap<RBaseList*, RBaseList*> GLMap)
{

  std::multimap<RBaseList*, RBaseList*> temp;
  bool check1 = true;
	

	std::multimap<RBaseList*,RBaseList*>::iterator it = GLMap.begin();
	int mm_count = 0;
	while(it != GLMap.end())
	{
          RBaseList *ptr = (*it).first->head;
		  for(int i = 0;i < (*it).first->count; i++)
		  {
		    if(ptr->isGroupingNode==true)
			{
			  if(ptr->NodeCode!=CODE_Shadow)           
			  { 
				  
				  temp.insert(std::pair<RBaseList*,RBaseList*>(ptr,(*it).second));
			      mm_count++; 

			  }
			 			  			  
			}

			if(ptr->isRenderable==true && ptr->isShadowMember==false)
			{
	
               RenderNSLMap.insert(std::pair<RBaseList*,NRShape*>((*it).second,(NRShape*)ptr));
                  
				
			}
			
			ptr = ptr->next; 
		  }
		  
		  
		  ++it;
		}
	
	
	if(mm_count!=0) { DirectNSLMap(temp);}


}



void SGManager::GenerateRenderNSLMap(std::multimap<RBaseList*, RBaseList*> LMultiMap)
{

    std::multimap<RBaseList*, RBaseList*> temp;
    std::multimap<RBaseList*,RBaseList*>::iterator it = LMultiMap.begin();
	int mm_count = 0;
	
	if(this->sg_info.num_spotlights!=0 || this->sg_info.num_pointlights!=0 || this->sg_info.num_direclights!=0)
    {
	 while(it != LMultiMap.end())
	 {
         for(std::multimap<MediaObject*,NRShape*>::iterator it2 = ShapeMMap.begin();
			it2 != ShapeMMap.end();++it2)
             {
				if((*it2).second->isShadowMember == false && (*it).second->NodeCode!=CODE_DirectionalLight)
				{
				 
					RenderNSLMap.insert(std::pair<RBaseList*,NRShape*>((*it).second,(*it2).second));
				
				}
			
			
			}
		 if((*it).second->NodeCode==CODE_DirectionalLight)
		 {
		   temp.insert(std::pair<RBaseList*,RBaseList*>((*it).first,(*it).second));
		 
		 }
		  
		  ++it;
	 }
    } 
	
	if(this->sg_info.num_direclights!=0)
	{
	  
		  
	   DirectNSLMap(temp);
	
	}

	 
}







void SGManager::GenerateRenderSLMap(void)
{
	RBaseList *debugP;
	int c,r,s;

	std::multimap<MediaObject*, NRShape*> temp;
    for(std::multimap<MediaObject*, NRShape*>::iterator it1 = ShapeMMap.begin(); 
        it1!=ShapeMMap.end();++it1)
		{
			if((*it1).second->isRenderable==true && (*it1).second->isShadowMember==false)
			{
			 temp.insert(std::pair<MediaObject*,NRShape*>((*it1).first,(*it1).second));
			 //fprintf(this->SG_FileHandle,"%i %s %i\n",(DWORD)((*it1).second->refnode),(*it1).second->name,(*it1).second->RefNodeID); 
			}
		}
      
     for(std::multimap<MediaObject*,NRShape*>::iterator it3 =temp.begin();
	     		it3!=temp.end();++it3)	
		{
		for(std::multimap<RBaseList*, RBaseList*>::iterator it2 = LightShapeMMap.begin(); 
        it2!=LightShapeMMap.end();++it2)	
			{
              if( ((NRShape*)((*it2).first))->refnode == (*it3).second->refnode)
			  { 
				(*it3).second->ShadowPropList[(*it3).second->spl_count].refnode = (*it2).second;
                (*it3).second->ShadowPropList[(*it3).second->spl_count].cast=((NRShape*)((*it2).first))->shadow.cast;
				(*it3).second->ShadowPropList[(*it3).second->spl_count].receive=((NRShape*)((*it2).first))->shadow.receive;
				//(*it3).second->ShadowPropList[(*it3).second->spl_count].self=((NRShape*)((*it2).first))->shadow.self;
				debugP=(*it3).second->ShadowPropList[(*it3).second->spl_count].refnode;
				c=(*it3).second->ShadowPropList[(*it3).second->spl_count].cast;
				r=(*it3).second->ShadowPropList[(*it3).second->spl_count].receive;
				//s=(*it3).second->ShadowPropList[(*it3).second->spl_count].self;
				
				    RenderSLMap.insert(std::pair<RBaseList*,NRShape*>((*it2).second,(*it3).second));
					(*it3).second->spl_count++;
				   sg_info.hasShadowToRender=true; 
			  }
			}

		}


    

}


void SGManager::ResetLights(void)
{
  Light0.Light=NULL;
  Light0.LightNR = 0;
  Light0.NodeCode = 0;
  Light0.cast_objects = 0;
  Light0.cast_pass.clear();
  Light0.receive_objects=0;
  Light0.receive_pass.clear();
  Light0.noshadow_objects=0;
  Light0.noshadow_pass.clear();

  Light1.Light=NULL;
  Light1.LightNR = 0;
  Light1.NodeCode = 0;
  Light1.cast_objects = 0;
  Light1.cast_pass.clear();
  Light1.receive_objects=0;
  Light1.receive_pass.clear();
  Light1.noshadow_objects=0;
  Light1.noshadow_pass.clear();

  Light2.Light=NULL;
  Light2.LightNR = 0;
  Light2.NodeCode = 0;
  Light2.cast_objects = 0;
  Light2.cast_pass.clear();
  Light2.receive_objects=0;
  Light2.receive_pass.clear();
  Light2.noshadow_objects=0;
  Light2.noshadow_pass.clear();

  Light3.Light=NULL;
  Light3.LightNR = 0;
  Light3.NodeCode = 0;
  Light3.cast_objects = 0;
  Light3.cast_pass.clear();
  Light3.receive_objects=0;
  Light3.receive_pass.clear();
  Light3.noshadow_objects=0;
  Light3.noshadow_pass.clear();

  Light4.Light=NULL;
  Light4.LightNR = 0;
  Light4.NodeCode = 0;
  Light4.cast_objects = 0;
  Light4.cast_pass.clear();
  Light4.receive_objects=0;
  Light4.receive_pass.clear();
  Light4.noshadow_objects=0;
  Light4.noshadow_pass.clear();

  Light5.Light=NULL;
  Light5.LightNR = 0;
  Light5.NodeCode = 0;
  Light5.cast_objects = 0;
  Light5.cast_pass.clear();
  Light5.receive_objects=0;
  Light5.receive_pass.clear();
  Light5.noshadow_objects=0;
  Light5.noshadow_pass.clear();

  Light6.Light=NULL;
  Light6.LightNR = 0;
  Light6.NodeCode = 0;
  Light6.cast_objects = 0;
  Light6.cast_pass.clear();
  Light6.receive_objects=0;
  Light6.receive_pass.clear();
  Light6.noshadow_objects=0;
  Light6.noshadow_pass.clear();

  Light7.Light=NULL;
  Light7.LightNR = 0;
  Light7.NodeCode = 0;
  Light7.cast_objects = 0;
  Light7.cast_pass.clear();
  Light7.receive_objects=0;
  Light7.receive_pass.clear();
  Light7.noshadow_objects=0;
  Light7.noshadow_pass.clear();

  
}

void SGManager::SetActiveLight(int l)
{
 switch(l){
  case 1 :   { this->activeLight=&Light0; break;}
  case 2 :   { this->activeLight=&Light1; break;}
  case 3 :   { this->activeLight=&Light2; break;}
  case 4 :   { this->activeLight=&Light3; break;}
  case 5 :   { this->activeLight=&Light4; break;}
  case 6 :   { this->activeLight=&Light5; break;}
  case 7 :   { this->activeLight=&Light6; break;}
  case 8 :   { this->activeLight=&Light7; break;}
  default:  { this->activeLight=&Light0; break;}
}


}


bool SGManager::checkShadowRender(void)
{
  if(((Light0.cast_objects==0) & (Light1.cast_objects==0) &
      (Light2.cast_objects==0) & (Light3.cast_objects==0) &
	    (Light4.cast_objects==0) & (Light5.cast_objects==0) &
	    (Light6.cast_objects==0) & (Light7.cast_objects==0)) |
		  ((Light0.receive_objects==0) & (Light1.receive_objects==0) &
	     (Light2.receive_objects==0) & (Light3.receive_objects==0) &
	     (Light4.receive_objects==0) & (Light5.receive_objects==0) &
	     (Light6.receive_objects==0) & (Light7.receive_objects==0)))
		{ this->sg_info.hasShadowToRender=false;
      return false; 
		} 
	else
		{
			this->sg_info.hasShadowToRender=true;
			return true;
	  }
}



void SGManager::AddShapeToActiveLight(NRShape *Shape)
{
  
  bool nos_obj_exist = false;
  bool rev_obj_exist = false;
  bool cas_obj_exist = false;

  Shape->GetShadowProp(activeLight->Light);
  
  for(std::multimap<int, NRShape*>::iterator it1 = activeLight->noshadow_pass.begin(); 
        it1!=activeLight->noshadow_pass.end();++it1)
		{
		  if((*it1).first==Shape->ShapeNR && (*it1).second==Shape)
		  {
            nos_obj_exist = true;
		  }
		
		}
  
  for(std::multimap<int, NRShape*>::iterator it2 = activeLight->cast_pass.begin(); 
        it2!=activeLight->cast_pass.end();++it2)
		{
		  if((*it2).first==Shape->ShapeNR && (*it2).second==Shape)
		  {
            cas_obj_exist = true;
		  }
		
		}
  
  for(std::multimap<int, NRShape*>::iterator it3 = activeLight->receive_pass.begin(); 
        it3!=activeLight->receive_pass.end();++it3)
		{
		  if((*it3).first==Shape->ShapeNR && (*it3).second==Shape)
		  {
            rev_obj_exist = true;
		  }
		
		}
  
		
  if(activeLight->NodeCode==CODE_PointLight && nos_obj_exist==false)
  {
  
    activeLight->noshadow_objects++;
	activeLight->noshadow_pass.insert(std::pair<int,NRShape*>(Shape->ShapeNR,Shape));
    
  }
  
  if(activeLight->NodeCode==CODE_DirectionalLight && nos_obj_exist==false)
  {
    activeLight->noshadow_objects++;
	activeLight->noshadow_pass.insert(std::pair<int,NRShape*>(Shape->ShapeNR,Shape));
  }

  if(activeLight->NodeCode==CODE_SpotLight)
  {
    if(Shape->shadow.cast==1 && cas_obj_exist==false)
	{
      activeLight->cast_objects++;
	  activeLight->cast_pass.insert(std::pair<int,NRShape*>(Shape->ShapeNR,Shape));
	}
    if(Shape->shadow.receive==1 && rev_obj_exist==false)
	{
      activeLight->receive_objects++;
	  activeLight->receive_pass.insert(std::pair<int,NRShape*>(Shape->ShapeNR,Shape));
	}
	if((Shape->shadow.cast==1 && Shape->shadow.receive==0 && nos_obj_exist==false) || 
		(Shape->shadow.cast==0 && Shape->shadow.receive==0 && nos_obj_exist==false))
	{
		activeLight->noshadow_objects++;
	    activeLight->noshadow_pass.insert(std::pair<int,NRShape*>(Shape->ShapeNR,Shape));
	}

  }



}


void SGManager::InitLights(void)
{
   int lightnum;
   lightnum = 1;
   this->SetActiveLight(lightnum);

   for (std::multimap<RBaseList *,RBaseList*>::iterator it = LightGroupMMap.begin();
         it != LightGroupMMap.end();
		 ++it){
		 
          activeLight->Light=(*it).second;     		 
		  activeLight->LightNR=lightnum;
		  activeLight->NodeCode=(*it).second->NodeCode;
		  if(lightnum<9)
		  {
		  lightnum++;
		  SetActiveLight(lightnum);
		  }		  
		 }
}


void SGManager::GenerateMultipassMaps(void)
{
  int num_scene_lights;
  int lightnum;
  
  num_scene_lights=sg_info.num_pointlights+sg_info.num_direclights+sg_info.num_spotlights;
  lightnum = 1;
  this->SetActiveLight(lightnum);
	
  InitLights();

  for (std::multimap<RBaseList *,NRShape*>::iterator it = RenderSLMap.begin();
         it != RenderSLMap.end();
		 ++it){
                for(int i=1; i<=num_scene_lights; i++)
				{
                  this->SetActiveLight(i);
				  if((*it).first==activeLight->Light)
				  {
				    this->AddShapeToActiveLight((*it).second);
				  }
				  
				}
  

		 }

  for (std::multimap<RBaseList *,NRShape*>::iterator it2 = RenderNSLMap.begin();
         it2 != RenderNSLMap.end();
		 ++it2){
                for(int i=1; i<=num_scene_lights; i++)
				{
                  this->SetActiveLight(i);
				  if((*it2).first==activeLight->Light)
				  {
				    this->AddShapeToActiveLight((*it2).second);
				  }
				  
				}
  

		 }




}


bool SGManager::checkShapeToRender(int i,MediaObject *Shape)
{
  bool check;
  check = false;
	
  switch(this->renderPass)
  {
  case 1:   { for(std::multimap<int, NRShape*>::iterator it1 = activeLight->cast_pass.begin(); 
              it1!=activeLight->cast_pass.end();++it1)
			  {
		       if((*it1).first==i )//&& (*it1).second->refnode==Shape)
			   {
                check = true;
			   }
		
			  }
   			
			 break;}
  
  case 2:   { for(std::multimap<int, NRShape*>::iterator it2 = activeLight->receive_pass.begin(); 
              it2!=activeLight->receive_pass.end();++it2)
			  {
		       if((*it2).first==i)// && (*it2).second->refnode==Shape)
			   {
                check = true;
			   }
		
			  }
   			
			 break;}
  case 3:   
			{ for(std::multimap<int, NRShape*>::iterator it3 = activeLight->noshadow_pass.begin(); 
              it3!=activeLight->noshadow_pass.end();++it3)
			  {
		       if((*it3).first==i)// && (*it3).second->refnode==Shape)
			   {
                check = true;
			   }
		
			  }
   			
			 break;}
  
  
  case 5:    { for(std::multimap<int, NRShape*>::iterator it3 = activeLight->noshadow_pass.begin(); 
              it3!=activeLight->noshadow_pass.end();++it3)
			  {
		       if((*it3).first==i)// && (*it3).second->refnode==Shape)
			   {
                check = true;
			   }
		
			  }
              for(std::multimap<int, NRShape*>::iterator it2 = activeLight->receive_pass.begin(); 
              it2!=activeLight->receive_pass.end();++it2)
			  {
		       if((*it2).first==i)// && (*it2).second->refnode==Shape)
			   {
                check = true;
			   }
		
			  }

   			
			 break;}
  
  default:  { check = false; break;}
  
  }

  return check;
}


void SGManager::SetOGl_LightProp(MediaObject *mo, int lightID)
{
  for (std::multimap<RBaseList*, RBaseList*>::iterator it = LightGroupMMap.begin();
       it != LightGroupMMap.end();
       ++it) {
	   if((*it).second->name == ID_DirectionalLight)
	   {
         if( ((NRDirectionalLight*)((*it).second))->refnode == mo)
		 {
			 ((NRDirectionalLight*)((*it).second))->gl_light=lightID;
		 }
	   }
	   if((*it).second->name == ID_PointLight)
	   {
          if( ((NRPointLight*)((*it).second))->refnode == mo)
		 {
			 ((NRPointLight*)((*it).second))->gl_light=lightID;
		 }
	   }
	   if((*it).second->name == ID_SpotLight)
	   {
          if( ((NRSpotLight*)((*it).second))->refnode == mo)
		 {
			 ((NRSpotLight*)((*it).second))->gl_light=lightID;
		 }
	   }
	   
	   
	   }

}