/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*****************************
 ***	AgpDepthDefault.c   ***
 *****************************/

#include	"AgpTool/AgpTool.h"

#include	"AgpLayer/AgpLayer.h"


#include	"AgpDepth.h"


void
agp_depth_default( gp_array *agp, float depth )
{
layer_type	*layer;
vec3d	N,	P;
int	i;
/*
int	i,	j;
gp_type	*gp;
jnt_type	*jnt;
*/

	if( (agp->type & AGP_DEPTH) && agp->ad != NULL ){
		free( agp->ad->vw );
		free( agp->ad );
		agp->ad = NULL;
	}



	for( i = 0 ; i < agp->layer_no ; i++ ){
		free( agp->layer[i] );
		agp->layer[i] = NULL;
	}
	agp->layer_no = 0;



	agp->ad = ADEPTH_ALLOC();
	agp->ad->Mbr = (1L << 0 );

	agp->ad->br_no = 0;

	agp->ad->vw = VIEW_ALLOC();



	view_create_noraml( agp->ad->vw, 1.0/512.0, agp->row, agp->column );



	agp->layer_no = 0;
	layer = agp->layer[agp->layer_no++] = LAYER_ALLOC();
	layer->Mbr = (1L<<0);
	layer->i0 = 1;
	layer->j0 = 1;
	layer->i1 = agp->Ni-1;
	layer->j1 = agp->Nj-1;
	layer->Fdepth_delta = 0;


	agp_layer_init( agp );



	agp->type = AGP_DEPTH;



	if( depth <= 1 )	depth = 100.0;
	N = agp->ad->vw->N;
	P.x = agp->ad->vw->cp.x + depth * N.x;
	P.y = agp->ad->vw->cp.y + depth * N.y;
	P.z = agp->ad->vw->cp.z + depth * N.z;

	adepth_set_plane( agp->ad, 0, &N, &P );


/*
	agp->ad->N = agp->ad->vw->N;
	agp->ad->P = agp->ad->vw->rp;



	agp_layer_depth( agp, 0 );
*/
	agp_depth_base( agp );



/*
	for( i = 0 ; i < agp->Ni ; i++ )
		for( j = 0 ; j < agp->Nj ; j++ ){
			gp = &agp->gp[i][j];
			for( jnt = gp->jnt ; jnt != NULL ; jnt = jnt->nj )
				jnt_set_depth( jnt );
		}
*/
}
