/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*****************************
 ***    AgpDepthRange.c    ***
 *****************************/

#include	"GpType/GpType.h"

#include	"AgpDepth.h"



void
agp_depth_range( gp_array *agp, float *d0, float *d1 )
{
gp_type	*gp;
bgp_type	*bgp;
link_type	*link;
int	i,	j;

	*d0 = 1000;
	*d1 = 0;
	for( i = 0 ; i < agp->Ni ; i++ )
	    for( j = 0 ; j < agp->Nj ; j++ ){
		gp = &agp->gp[i][j];

		for( bgp = gp->bgp ; bgp != NULL ; bgp = bgp->p ){
			if( bgp->depth < *d0 )	*d0 = bgp->depth;

			if( bgp->depth > *d1 )	*d1 = bgp->depth;
		}


		for( link = gp->link ; link != NULL ; link = link->nl ){
			if( link->pr[0].p->depth < *d0 )
					*d0 = link->pr[0].p->depth;

			if( link->pr[0].p->depth > *d1 )
					*d1 = link->pr[0].p->depth;
		}
	    }


	if( *d0 == 1000 )	*d0 = *d1;
}
