/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/

/****************************
 ***	AgpLinkInverse.c   ***
 ****************************/
#include        <stdio.h>   
#include	<math.h>

#include        "AgpEditTool.h"




void
agp_link_inverse( gp_array *agp, link_type *link )
{
link_type	*l,	*nl;
jnt_type	*jnt;
int	bno;
vec2d	ctr;


	for( l = link ; LINK_PREV(l) != NULL ; l = LINK_PREV(l) );

	jnt = l->p[0].p.jnt;
	bno = l->p[0].bno;
	ctr.x = jnt->gctr.x + jnt->brn[bno]->ctr.x;
	ctr.y = jnt->gctr.y + jnt->brn[bno]->ctr.y;

	agp_lnf_clear_link( &ctr, l, agp );



	for(  ; l != NULL ; l = LINK_PREV(l) ){
		link_1_inverse( l );
		nl = l;
	}


	jnt = nl->p[0].p.jnt;
	bno = nl->p[0].bno;

	ctr.x = jnt->gctr.x + jnt->brn[bno]->ctr.x;
	ctr.y = jnt->gctr.y + jnt->brn[bno]->ctr.y;
	agp_lnf_link( &ctr, nl, agp );
}
