/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef		_AGP_SELECT_H_
#define		_AGP_SELECT_H_

#include        <stdio.h>
#include        "GpType/GpType.h"


float	agp_select_hunch( gp_array *agp, vec2d *v,
					vec2d *s_ctr, hunch_type **s_hunch );

float	agp_select_link( gp_array *agp, vec2d *v, int Fridge,
				vec2d *s_ctr, link_type **s_link );


float	agp_select_linkN( gp_array *agp, vec2d *v, int Mnf, link_type *ignore_link, 
				vec2d *s_ctr, link_type **s_link );


float	agp_select_plink( gp_array *agp, vec2d *v,
			int Fridge, link_type *link0,
			vec2d *s_ctr, link_type **s_link, int *s_direct );


float	agp_select_point( gp_array *agp, vec2d *v,
					int Fridge, link_type *elink, jnt_type *ejnt,
					vec2d *s_ctr, link_type **s_link, jnt_type **s_jnt );



int	agp_select_find_link( gp_array *agp, vec2d *ctr0, link_type *link,
					vec2d *s_ctr );

float   agp_select_jnt( gp_array *agp, vec2d *v, int Fridge,
					jnt_type **s_jnt, int *s_bno );

float	agp_select_jntN( gp_array *agp, vec2d *v, int EMjnt, jnt_type *ignore_jnt,
					jnt_type **s_jnt, int *s_bno );


float agp_select_bgp(gp_array *agp, vec2d *v,vec2d *s_ctr, bgp_type **s_bgp);
#endif
