/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef		_AGP_LAYER_H_
#define		_AGP_LAYER_H_

#include	"Uigp/igp.h"

#include	"GpType/GpType.h"


	/* AgpLayer.c */

void	agp_layer_changh_no( gp_array *agp, int br, int nbr );

void 	agp_layer_add_const( gp_array *agp, int cosnt );

int		agp_layer_no( gp_array *agp, int *layer0, int *layer1 );

int		agp_layer_id( gp_array *agp, int iLayer );

int		agp_layer_index( gp_array *agp, int layerId );




	/* AgpLayerCopy.c */
gp_array *	agp_layer_copy( gp_array *agp, int mbr, int Fbox );

int	agp_layer_copy_test( gp_array *agp, int br, vec2d *p );

gp_array *	agp_layer_copy_contour( gp_array *agp, int br, int Fbox );

	/* AgpCopyContour.c */
gp_array *agp_layer_copy_contour( gp_array *agp, int branch, int Fbox );


	/* AgpLayerCut.c */
int	agp_layer_cut( gp_array *agp, int br );



	/* AgpLayerInit.c */
void	agp_layer_init( gp_array *agp );

	/* AgpLayerClear.c */
void	agp_layer_clear( gp_array *agp, int layer );

	/* AgpLayerDepth.c */
void	agp_layer_depth( gp_array *agp, int br );


	/* AgpLayerDepth.c */
void	agp_layer_depth_base( gp_array *agp, int mbr );



	/* AgpLayerBox.c */
void	agp_layer_box( gp_array *agp, int mbr, box2d *box );
void	agp_layer_alink_box( link_type *link[], int no, box2d *box );



	/* AgpLayerF.c */
void	agp_layer_F( gp_array *agp, int branch, vec2d *p, int flag );

	/* AgpLayerFC.c  */
void	agp_layer_FC( gp_array *baseAgp, int branch, vec2d *p, int step_no );

	/* AgpLayerFillN3.c */
void	agp_layer_F_n3_prime_load( gp_array *agp );


	/* AgpLayerHole.c */
int	agp_layer_hole( gp_array *agp, int br, vec2d *p );


	/* AgpLayerSelect.c */
int	agp_layer_select( gp_array *agp, mbr_type Lmbr, vec2d *p, float d,
					vec2d *s_ctr, float *s_depth );



	/* AgpLayerSphere.c */
void	agp_layer_sphere( gp_array *agp, int mbr,
					float depthMax,float depthMin );


	/* AgpLayerMiddle.c */
float	agp_layer_middle_distance( gp_array *agp, int mbr );


	/* AgpLayerColor.c */
void agp_layer_color( gp_array *agp ,int color ,int mbr);


	/* AgpLayerCountor.c	*/
int	agp_layer_contour( gp_array *agp, vec2d *ctr, link_type *link,
			int layer, float depth, vec2d *mp, int step );

gp_array *	agp_layer_contour_copy( gp_array *agp, vec2d *ctr, link_type *link, 
			     int layer, float depth, vec2d *mp );


gp_array *	agp_layer_contour_copyT( gp_array *agp, vec2d *ctr, link_type *link, 
						int layer, float depth, vec2d *mp );

	/* AgpLayerContourPolylink.c */
int	agp_layer_contour_polylink( gp_array *agp, int br, vec2d *ctr, link_type **link );

#endif
