/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef		_AGP_TOOL_
#define		_AGP_TOOL_

#include        "Uigp/igp.h"
#include        "ImageType/ImageType.h"

#include        "GpType/GpType.h"


#include        "LinkTool/TlType.h"


/* AgpCopy.c */
void	agp_copy( gp_array *agp, gp_array *nagp, int row, int column, int bgp);

gp_array *	agp_make_copy( gp_array *agp );


	/* AgpExtend.c */
gp_array *	agp_extend( gp_array *agp, int row, int column, int bgp );


	/* AgpZoom.c */
gp_array *	agp_zoom( gp_array *agp, float Zf, int bgp );
int		agp_zoom_move_layer( gp_array *nagp, gp_array *agp,
                                float Zf, link_type *links[], vec2d gctr[] );

	/* AgpZoomP.c */
gp_array *	agp_zoomP( gp_array *agp, float zf, int bgp );
gp_array *	agp_zoomP_layer(gp_array *agp,
				int mbr, float zf, int bgp, int step );


	/* AgpUnion.c */
void	agp_union( gp_array *agp, vec2d *gctr, gp_array *uagp );


	/* AgpMakeUnion.c */
gp_array *	agp_make_union( gp_array *Agp[], int no );

gp_array *	agp_make_union2( gp_array *agp0, gp_array *agp1 );


	/* AgpConst.c */
gp_array *	agp_const( int row, int column, int bgp,
                        int red, int green, int blue );

void	agp_const1( gp_array *agp,
			int red, int green, int blue );

	/* AgpFlipV.c */
gp_array * agp_flipV( gp_array *agp );

	/* AgpFlipH.c */
gp_array * agp_flipH( gp_array *agp );


	/* AgpMold.c */
gp_array *	agp_make_mold( gp_array *agp );

	/* AgpCleare.c */
gp_array *	agp_make_cleare( gp_array *agp, int moldColorInLayers );






	/* AgpProfile.c */
void	agp_profile_get_prm( GP_prm **prm, int *prm_no, void (**check)() );

void	agp_profile_init( char *file );

void	agp_profile( gp_array *agp );


	/* AgpProfileWidth.c */
void	agp_profile_width(gp_array *agp,float width,int mbr );



	/* AgpBgValue.c */
void	agp_bg_value( gp_array *agp, vec2d *p, float val[SP_NO] );

int		agp_bg_valueL( gp_array *agp, int layer, vec2d *p, float val[SP_NO] );


	/* AgpBgpFill.c */
void	agp_bgp_fill( gp_array *agp, int layer_no );

void	agp_bgp_fill_layer( gp_array *agp, int layer_no );


	/* AgpBgpFillSmooth.c */
void	agp_bgp_fill_smooth( gp_array *agp, box2d *box );





	/* AgpLinkLen.c */
int	agp_link_len( gp_array *agp, int max_len );

	/* AgpLinkNo.c */
int	agp_link_no( gp_array *agp, int max_no );



	/* AgpConnectJnt.c */
void	agp_connect_jnt( gp_array *agp );


	/* AgpDelete.c */
void	agp_delete( gp_array *agp, int Mnf, box2d *box );




	/* AgpAddConstLayer.c */
void	agp_add_const_layer( gp_array *agp,
			int br, float depth, float r, float b, float g );


	/* AgpBrList.c */
void	agp_br_mask( gp_array *agp, int *Mnf, int *Mbg, int *Fbr );

void	agp_br_list( gp_array *agp );


	/* AgpNf.c */
int	agp_nf( gp_array *agp, box2d *box, int nf[NF_TYPES] );
void	agp_data_size( gp_array *agp, int *data_size, int *alloc_no );



	/* AgpJntBrn4.c */
void	agp_jnt_brn4( gp_array *agp );



	/* AgpImage.c */
image_type *	agp_to_image( gp_array *agp, int color, image_type *im );

image_type *	agp_to_imageS( gp_array *agp, int i0, int j0,
					int row, int col, image_type *im );

	/* AgpCloseHole.o */
int	agp_close_hole( gp_array *agp, float max_u );


	/* AgpAppend.c */
void	agp_append( gp_array *agp, vec2d *gctr, gp_array *uagp );



	/* AgpNormalView.c */
void	agp_normal_view( gp_array *agp );


	/* AgpBorder.c */
void	agp_border_add( gp_array *agp );

void	agp_border_clear( gp_array *agp );


	/* AgpDumpWrite.c */
void	agp_dump_write( gp_array *agp, char *path, char *name, char dump_type_binary );

	/* AgpDumpRead.c */
gp_array *agp_dump_read( char *path, char *name );


	/* AgpScriptWrite.c */
void	agp_script_write( gp_array *agp, char *path, char *name, char dump_type_binary );

	/* AgpScriptRead.c */
gp_array *agp_script_read( char *path, char *name, int bgp );

	/* AgpCheckLinkFbr.c */
int agp_check_link_fbr( gp_array *agp);


	/* AgpDither.c */
image_type *	agp_dither( gp_array *agp, float zf, float bf, float len, float dis );


	/* AgpCountorLink.c */
int	agp_countor_link( gp_array *agp, int mbr, tl_type tlink[] );



	/* AgpMoveLayer.c */
gp_array *	agp_reposition_layer( gp_array *sagp, int iLayer, vec2d *dp );


	/* AgpBgpTest.c */
int	agp_bgp_test( gp_array *agp, int iLayer );
				 
#endif
