/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	AgpInsert.c	***
 **************************/
#include	<stdio.h>

#include        "Uigp/igp.h"


#include        "GpType/GpType.h"



static jnt_type *	agp_exist_jnt( gp_type *gp, jnt_type *jnt );

/*
static jnt_type *	agp_exist_jnt_rn3( gp_type *gp, jnt_type *jnt );
*/


void
agp_insert_hunch( gp_array *agp, hunch_type *hunch )
{
int	i,	j;
gp_type	*gp;

	hunch->ctr.x += (agp->Ni0-1) * agp->bgp;
	hunch->ctr.y += (agp->Nj0-1) * agp->bgp;

	i = (hunch->ctr.x+agp->bgp) * agp->inv_bgp;
        j = (hunch->ctr.y+agp->bgp) * agp->inv_bgp;


	gp = &agp->gp[i][j];


	hunch->ctr.x -= gp->ctr.x;
	hunch->ctr.y -= gp->ctr.y;
	hunch->nh = gp->hunch;
	gp->hunch = hunch;
}




jnt_type *
agp_insert_jnt( gp_array *agp, jnt_type *jnt )
{
gp_type	*gp;
jnt_type	*ojnt;
int	i,	j;

	jnt->gctr.x += (agp->Ni0-1) * agp->bgp;
	jnt->gctr.y += (agp->Nj0-1) * agp->bgp;

	i = (jnt->gctr.x+agp->bgp) * agp->inv_bgp;
        j = (jnt->gctr.y+agp->bgp) * agp->inv_bgp;


	gp = &agp->gp[i][j];

	jnt->ctr.x = jnt->gctr.x - gp->ctr.x;
	jnt->ctr.y = jnt->gctr.y -gp->ctr.y;




	if( jnt->Fborder != JNT_IN ){
		ojnt = agp_exist_jnt( gp, jnt );
		if( ojnt != NULL ){
			ojnt->jnt_no = jnt->jnt_no;
			jnt_free( jnt );
			return( ojnt );
		}
	}


	jnt->nj = gp->jnt;
	gp->jnt = jnt;

	return( jnt );
}



static jnt_type *
agp_exist_jnt( gp_type *gp, jnt_type *jnt )
{
jnt_type	*j;
float	x,	y;

	for( j = gp->jnt ; j != NULL ; j = j->nj ){

		if( j->type != jnt->type )	continue;
		if( j->Fborder != jnt->Fborder )	continue;

		if( (x = j->ctr.x - jnt->ctr.x) < 0 )	x = -x;
		if( (y = j->ctr.y - jnt->ctr.y) < 0 )	y = -y;
		if( x < 0.001 && y < 0.001 ){

/*
		if( j->type == jnt->type && j->ctr.x == jnt->ctr.x &&
				j->ctr.y == jnt->ctr.y &&
				j->Fborder == jnt->Fborder ){
*/

			if( j->type == JNT_RIDGE && j->brn_no > 1 )
				return( NULL );

			if( j->type != JNT_N3 )	return( j );

			return( NULL );
		}
	}

	return( NULL );
}


/*
static jnt_type *
agp_exist_jnt_rn3( gp_type *gp, jnt_type *jnt )
{
jnt_type	*j;

	for( j = gp->jnt ; j != NULL ; j = j->nj ){

		if( j->type != JNT_N3 )		continue;

		if( j->ctr.x == jnt->ctr.x &&
				j->ctr.y == jnt->ctr.y &&
				j->Fborder & JNT_STATIC ){

			return( j );
		}
	}

	return( NULL );
}
*/
