/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************************************************************
*									*
*                            AgpLnf.c					*
*									*
************************************************************************/
#include        <stdio.h>   
#include	<math.h>

#include        "GpType/GpType.h"




/*
void
agp_lnf_box( gp_array *agp )
{
int	i,	j,	bno;
gp_type	*gp;
jnt_type	*jnt;
brn_type	*b;
vec2d	ctr;
int	Fout,	Fouti,	Fborder;

	for( i = agp->Ni0-1 ; i < agp->Ni1+1 ; i++ ){

	    if( i ==  agp->Ni0-1 || i == agp->Ni1 )	Fouti = 1;
	    else	Fouti =0;


	    for( j = agp->Nj0-1 ; j < agp->Nj1+1 ; j++ ){
		Fout = Fouti;
	    	if( j ==  agp->Nj0-1 || j == agp->Nj1 )	Fout = 1;

		Fborder = agp_Fborder_ij( agp, i, j );


		gp = &agp->gp[i][j];

		for( jnt = gp->jnt ; jnt != NULL ; jnt = jnt->nj ){
			if( Fout && jnt->Fborder == JNT_IN )	continue;

			for( bno = 0 ; bno < jnt->brn_no ; bno++ ){
				b = jnt->brn[bno];

				if( b->type != BRN_EDGE && b->type != BRN_N3 &&
							b->type != BRN_RIDGE )
					continue;

				if( jnt->Fborder != JNT_IN &&
					b->Fborder != Fborder )	continue;

				if( b->direction != F_BEGIN )
					continue;

				ctr.x = jnt->gctr.x + b->ctr.x;
				ctr.y = jnt->gctr.y + b->ctr.y;

				agp_lnf_link( &ctr, b->link, agp );
			}
		}
	    }
	}
}
*/


#pragma optimize( "", off )
void
agp_lnf_link( vec2d *ctr, link_type *link, gp_array *agp )
{
gp_type	*gp;
link_type	*l,	*pl;
vec2d	v;
int     i,      j;

	for( l = link, v = *ctr ; l != NULL ; l = LINK_NEXT( l ) ){

		i = ( v.x + agp->bgp ) * agp->inv_bgp;
		j = ( v.y + agp->bgp ) * agp->inv_bgp;

		gp = &agp->gp[i][j];


		l->ctr.x = v.x - gp->ctr.x;
		l->ctr.y = v.y - gp->ctr.y;

		v.x += l->v.x;
		v.y += l->v.y;

		if( gp->link == NULL ){
			l->nl = NULL;
			gp->link = l;
			continue;
		}


		if( l->ctr.x < gp->link->ctr.x || 
		l->ctr.x == gp->link->ctr.x &&
		( l->ctr.y < gp->link->ctr.y ||
		l->ctr.y == gp->link->ctr.y && l->len < gp->link->len )){
			l->nl = gp->link;
			gp->link = l;
			continue;
		}

		for( pl = gp->link ; pl->nl != NULL ; pl = pl->nl )
			if( l->ctr.x < pl->nl->ctr.x || 
				l->ctr.x == pl->nl->ctr.x &&
				( l->ctr.y < pl->nl->ctr.y ||
				l->ctr.y == pl->nl->ctr.y &&
				l->len < pl->nl->len ))
				break;
		l->nl = pl->nl;
		pl->nl = l;

	}
}
#pragma optimize( "", on )

/*
void 
agp_lnf_add( int type, vec2d *ctr, link_type *link, gp_array *agp )
{ 
gp_type	*gp; 
int	i,	j;  
 
	i = ( ctr->x + agp->bgp ) * agp->inv_bgp; 
	j = ( ctr->y + agp->bgp ) * agp->inv_bgp; 
 
	gp = &agp->gp[i][j]; 

	link->nl = gp->link;
	gp->link = link;
 
	link->type = type; 
	link->ctr.x = ctr->x - gp->ctr.x; 
	link->ctr.y = ctr->y - gp->ctr.y; 
}
*/


void 
agp_lnf_add_link_1( vec2d *ctr, link_type *l, gp_array *agp )
{ 
gp_type	*gp; 
link_type       *pl;
int	i,	j;  
 
	i = ctr->x * agp->inv_bgp +1;
	j = ctr->y * agp->inv_bgp +1;
 
	gp = &agp->gp[i][j]; 

	l->ctr.x = ctr->x - gp->ctr.x; 
	l->ctr.y = ctr->y - gp->ctr.y; 

	if( gp->link == NULL ){
		l->nl = NULL;
		gp->link = l;
		return;
	}
 
 
	if( l->ctr.x < gp->link->ctr.x ||
                l->ctr.x == gp->link->ctr.x && ( l->ctr.y < gp->link->ctr.y ||
                l->ctr.y == gp->link->ctr.y && l->len < gp->link->len )){
		l->nl = gp->link;
		gp->link = l;
		return;
	}
 
	for( pl = gp->link ; pl->nl != NULL ; pl = pl->nl )
		if( l->ctr.x < pl->nl->ctr.x ||
			l->ctr.x == pl->nl->ctr.x &&
			( l->ctr.y < pl->nl->ctr.y ||
			l->ctr.y == pl->nl->ctr.y &&
			l->len < pl->nl->len ))
			break;

	l->nl = pl->nl;
	pl->nl = l;

}




/*
void
agp_lnf_clear_box( gp_array *agp )
{
int	i,	j,	bno;
gp_type	*gp;
jnt_type	*jnt;
brn_type	*b;
vec2d	ctr;
int	Fout,	Fouti,	Fborder;

	for( i = agp->Ni0-1 ; i < agp->Ni1+1 ; i++ ){

	    if( i ==  agp->Ni0-1 || i == agp->Ni1 )	Fouti = 1;
	    else	Fouti =0;


	    for( j = agp->Nj0-1 ; j < agp->Nj1+1 ; j++ ){
		Fout = Fouti;
	    	if( j ==  agp->Nj0-1 || j == agp->Nj1 )	Fout = 1;

		Fborder = agp_Fborder_ij( agp, i, j );


		gp = &agp->gp[i][j];

		for( jnt = gp->jnt ; jnt != NULL ; jnt = jnt->nj ){
			if( Fout && jnt->Fborder == JNT_IN )	continue;

			for( bno = 0 ; bno < jnt->brn_no ; bno++ ){
				b = jnt->brn[bno];

				if( b->type != BRN_EDGE && b->type != BRN_N3 &&
							b->type != BRN_RIDGE )
					continue;

				if( jnt->Fborder != JNT_IN &&
					b->Fborder != Fborder )	continue;

				if( b->direction != F_BEGIN )
					continue;

				ctr.x = jnt->gctr.x + b->ctr.x;
				ctr.y = jnt->gctr.y + b->ctr.y;

				agp_lnf_clear_link( &ctr, b->link, agp );
			}
		}
	    }
	}
}
*/


#pragma optimize( "", off )
void
agp_lnf_clear_link( vec2d *ctr, link_type *link, gp_array *agp )
{
gp_type	*gp;
link_type	*l,	*nl;
vec2d	v;
int     i,      j;

	for( l = link, v = *ctr ; l != NULL ; l = LINK_NEXT( l ) ){

		i = ( v.x + agp->bgp ) * agp->inv_bgp;
		j = ( v.y + agp->bgp ) * agp->inv_bgp;

		v.x += l->v.x;
		v.y += l->v.y;

		gp = &agp->gp[i][j];

		if( gp->link == l ){
			gp->link = l->nl;
			continue;
		}

		for( nl = gp->link ; nl->nl != NULL ; nl = nl->nl ){
			if( nl->nl != l )	continue;

			nl->nl = l->nl;
			break;
		}

	}
}
#pragma optimize( "", on )


void
agp_lnf_clear_link_1( vec2d *ctr, link_type *link, gp_array *agp )
{
gp_type	*gp;
link_type	*nl;
int     i,      j;


	i = ctr->x * agp->inv_bgp +1;
	j = ctr->y * agp->inv_bgp +1;

	gp = &agp->gp[i][j];

	if( gp->link == link ){
		gp->link = link->nl;
		return;
	}

	for( nl = gp->link ; nl->nl != NULL ; nl = nl->nl ){
		if( nl->nl != link )	continue;

		nl->nl = link->nl;
		return;
	}
}
