/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	EdgeTool.c	***
 **************************/
#include	<stdio.h>
#include        "Uigp/igp.h"


#include        "GpType/EdgeType.h"


void
edge_afine( edge_type *e0, edge_type *e1, float t, edge_type *e )
{
	e->width = t* e0->width + (1-t)*e1->width;
 
	e->side[0].val[SP_Y] = t* e0->side[0].val[SP_Y] + (1-t)*e1->side[0].val[SP_Y];
	e->side[1].val[SP_Y] = t* e0->side[1].val[SP_Y] + (1-t)*e1->side[1].val[SP_Y];
 
	e->side[0].val[SP_Q] = t* e0->side[0].val[SP_Q] + (1-t)*e1->side[0].val[SP_Q];
	e->side[1].val[SP_Q] = t* e0->side[1].val[SP_Q] + (1-t)*e1->side[1].val[SP_Q];
 
	e->side[0].val[SP_A] = t* e0->side[0].val[SP_A] + (1-t)*e1->side[0].val[SP_A];
	e->side[1].val[SP_A] = t* e0->side[1].val[SP_A] + (1-t)*e1->side[1].val[SP_A];



	e->side[0].bval[SP_Y] = t* e0->side[0].bval[SP_Y] + (1-t)*e1->side[0].bval[SP_Y];
	e->side[1].bval[SP_Y] = t* e0->side[1].bval[SP_Y] + (1-t)*e1->side[1].bval[SP_Y];
 
	e->side[0].bval[SP_Q] = t* e0->side[0].bval[SP_Q] + (1-t)*e1->side[0].bval[SP_Q];
	e->side[1].bval[SP_Q] = t* e0->side[1].bval[SP_Q] + (1-t)*e1->side[1].bval[SP_Q];
 
	e->side[0].bval[SP_A] = t* e0->side[0].bval[SP_A] + (1-t)*e1->side[0].bval[SP_A];
	e->side[1].bval[SP_A] = t* e0->side[1].bval[SP_A] + (1-t)*e1->side[1].bval[SP_A];
}


void
edge_copy_inverse( edge_type *se, edge_type *e )
{
	e->depth = se->depth;

	e->width = se->width;
	e->side[F_RIGHT].val[SP_Y] = se->side[F_LEFT].val[SP_Y];
	e->side[F_LEFT].val[SP_Y] = se->side[F_RIGHT].val[SP_Y];

	e->side[F_RIGHT].val[SP_Q] = se->side[F_LEFT].val[SP_Q];
	e->side[F_LEFT].val[SP_Q] = se->side[F_RIGHT].val[SP_Q];

	e->side[F_RIGHT].val[SP_A] = se->side[F_LEFT].val[SP_A];
	e->side[F_LEFT].val[SP_A] = se->side[F_RIGHT].val[SP_A];



	e->side[F_RIGHT].bval[SP_Y] = se->side[F_LEFT].bval[SP_Y];
	e->side[F_LEFT].bval[SP_Y] = se->side[F_RIGHT].bval[SP_Y];

	e->side[F_RIGHT].bval[SP_Q] = se->side[F_LEFT].bval[SP_Q];
	e->side[F_LEFT].bval[SP_Q] = se->side[F_RIGHT].bval[SP_Q];

	e->side[F_RIGHT].bval[SP_A] = se->side[F_LEFT].bval[SP_A];
	e->side[F_LEFT].bval[SP_A] = se->side[F_RIGHT].bval[SP_A];
}


void
edge_inverse( edge_type *e )
{
float	tmp;

	tmp = e->side[F_RIGHT].val[SP_Y];
	e->side[F_RIGHT].val[SP_Y] = e->side[F_LEFT].val[SP_Y];
	e->side[F_LEFT].val[SP_Y] = tmp;

	tmp = e->side[F_RIGHT].val[SP_Q];
	e->side[F_RIGHT].val[SP_Q] = e->side[F_LEFT].val[SP_Q];
	e->side[F_LEFT].val[SP_Q] = tmp;

	tmp = e->side[F_RIGHT].val[SP_A];
	e->side[F_RIGHT].val[SP_A] = e->side[F_LEFT].val[SP_A];
	e->side[F_LEFT].val[SP_A] = tmp;



	tmp = e->side[F_RIGHT].bval[SP_Y];
	e->side[F_RIGHT].bval[SP_Y] = e->side[F_LEFT].bval[SP_Y];
	e->side[F_LEFT].bval[SP_Y] = tmp;

	tmp = e->side[F_RIGHT].bval[SP_Q];
	e->side[F_RIGHT].bval[SP_Q] = e->side[F_LEFT].bval[SP_Q];
	e->side[F_LEFT].bval[SP_Q] = tmp;

	tmp = e->side[F_RIGHT].bval[SP_A];
	e->side[F_RIGHT].bval[SP_A] = e->side[F_LEFT].bval[SP_A];
	e->side[F_LEFT].bval[SP_A] = tmp;
}
