/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	HunchTool.c	***
 **************************/

#include	<stdio.h>
#ifndef __SYMBIAN32__
	#include	<malloc.h>
#endif // 	__SYMBIAN32__
#include	<math.h>

#include        "Uigp/igp.h"


#include        "GpType/HunchType.h"



hunch_type	*
hunch_alloc()
{
hunch_type	*h;

	h = (hunch_type *)malloc( sizeof( hunch_type ) );

	h->depth = 1.0;
        h->rval[0] = h->rval[1] = h->rval[2] = 0.0;
        h->gval[0] = h->gval[1] = h->gval[2] = 0.0;
        h->lm1[0] = h->lm1[1] = h->lm1[2] = 0.0;

	return( h );
}



hunch_type *
hunch_make_copy( hunch_type *hunch )
{
hunch_type	*h;

	h = (hunch_type *)malloc( sizeof( hunch_type ) );

	*h = *hunch;

	return( h );
}




void
hunch_set_aux( hunch_type  *h )
{
int     i;

        h->g.u.x = cos( (double)(h->g.theta) );
        h->g.u.y = sin( (double)(h->g.theta) );
        for( i = 0 ; i < SP_NO ; i++ ){ 

		if( ABS(h->rval[i]) < 0.01 )	h->rval[i] = 0.01;

		h->lm1[i] = -h->rval[i]/(h->g.width*h->g.width);
		h->lm2[i] = -h->rval[i]/(h->g.len*h->g.len);
        }
}


void
rhunch_set_aux( hunch_type  *rh )
{
int     i;

        rh->g.u.x = cos( (double)(rh->g.theta) );
        rh->g.u.y = sin( (double)(rh->g.theta) );
        for( i = 0 ; i < SP_NO ; i++ ){
             	rh->lm1[i] =
                    -rh->rval[i]/(rh->g.width*rh->g.width);
        }

	rh->lm2[0] = 0.0;
        rh->lm2[1] = 0.0;
        rh->lm2[2] = 0.0;
}
