/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/***********************
 ***    JntEdge.c    ***
 ***********************/

#include	<stdio.h>
#include	<math.h>

#include	"Uigp/igp.h"
#include	"GpType/JntType.h"


static void	jnt_edge_reorder( jnt_type *jnt );


void
jnt_edge_set_aux( jnt_type *jnt )
{
	if( jnt->brn_no > 2 )
		jnt_edge_reorder( jnt );
}






static void
jnt_edge_reorder( jnt_type *jnt )
{
brn_type	*b;
int	i,	j,	flag,	tflag;
vec2d	V[10],	v,	*v0,	*v1,	*v2;
int	I;
float	tmp;

	for( i = 0 ; i < jnt->brn_no ; i++ ){
		b = jnt->brn[i];

		tmp = b->link->c_prb * b->link->len;

		if( b->direction == F_BEGIN ){
			V[i].x = -(-b->link->u.y - tmp * b->link->u.x);
			V[i].y = -(b->link->u.x - tmp * b->link->u.y);
			continue;
		}

		V[i].x = -b->link->u.y + tmp * b->link->u.x;
		V[i].y = b->link->u.x + tmp * b->link->u.y;
	}


	for( i = 1 ; i < jnt->brn_no-1 ; i++ ){
		v0 = &V[i-1];
		v1 = &V[i];

		flag = -( v1->x * v0->y + v1->y * -v0->x ) > 0;

		I = i;

		for( j = i+1 ; j < jnt->brn_no ; j++ ){
			v2 = &V[j];
			tflag = -( v2->x * v0->y + v2->y * -v0->x ) > 0;
			if( -( v2->x * v1->y + v2->y * -v1->x ) > 0 )
				tflag |= 0x02;

			if( (flag == 1 && tflag == 0x01 ) ||
				(flag == 0 && tflag != 0x02 ) ){
				
				I = j;
				v1 = v2;
				flag = -( v1->x * v0->y + v1->y * -v0->x ) > 0;
			}
		}

		if( i == I )	continue;

		b = jnt->brn[i];
		jnt->brn[i] = jnt->brn[I];
		jnt->brn[I] = b;

		v = V[i];
		V[i] = V[I];
		V[I] = v;

		b = jnt->brn[i];
		b->link->p[b->direction].bno = i;

		b = jnt->brn[I];
		b->link->p[b->direction].bno = I;
	}
}
