/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/***********************
 ***    JntN3In.c    ***
 ***********************/

#include	<stdio.h>
#include	<math.h>

#include	"Uigp/igp.h"

#include	"GpType/JntType.h"
#include	"GpType/GpType.h"




int
jnt_n3_in_delete_segment( jnt_type *jnt, int bno )
{
jnt_type	*njnt;
int	nbno;

	if( jnt_n3_in_get_next( jnt, bno, &njnt, &nbno ) == 0 )
		return( 0 );
 
	jnt_n3_in_delete( jnt, bno );
	jnt_n3_to_jnt_rn3( jnt );

	jnt_n3_in_delete( njnt, nbno );
	jnt_n3_to_jnt_rn3( jnt );

	return( 1 );
}




int
jnt_n3_in_get_next( jnt_type *jnt, int bno, jnt_type **njnt, int *nbno )
{
link_type	*l,	*nl;
in_type	*in;
int	side,	direct;
 
	if( jnt->brn[0]->direction == F_BEGIN )
		side = ( bno == 1 ) ? F_LEFT : F_RIGHT;
	else    side = ( bno == 1 ) ? F_RIGHT : F_LEFT;
 
	l = jnt->brn[0]->link;
	while( 1 ){
		if( l->in[side] != NULL )	break;
 
		nl = ( jnt->brn[0]->direction == F_BEGIN )?
					LINK_NEXT(l) : LINK_PREV(l);
		if( nl == NULL )	break;
 
		l = nl;
	}
 
	if( l->in[side] == NULL ){
		direct = INV_FLAG( jnt->brn[0]->direction );
		*njnt = l->p[direct].p.jnt;
		*nbno = 3 - bno;

		if( (*njnt)->brn[*nbno]->type != BRN_IN )	return( 0 );
		return( 1 );
	}
 
 
	in = l->in[side];
	if( jnt->brn[0]->direction == F_END )
		for( ; in->p != NULL ; in = in->p );
 
	*njnt = in->jnt;
	*nbno = in->bno;

	return( 1 );
}
