/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/******************
 ***	NfAux.c	***
 ******************/

#include	<stdio.h>
#include	<math.h>
#include        "Uigp/igp.h"

#include        "GpType/JntType.h"
#include        "GpType/LinkType.h"



void
link_set_geo_aux( link_type *link )
{
link_type	*l;
jnt_type	*jnt;
width_type	*width;


	if( link->type != NF_N3 )	return;

	link_width_bes( link );

	l = link;
	jnt = l->p[F_BEGIN].p.jnt;
	width = link->width[F_BEGIN];

	if( jnt->type == JNT_N3 ){
		width->bes.x = -( -jnt->u.y);
		width->bes.y = -( jnt->u.x);
	}
	else	jnt_rn3_set_aux( jnt );

	if( l->p[F_BEGIN].bno == 0 ){
		width->w[F_LEFT] = -jnt->rwidth;
		width->w[F_RIGHT] = jnt->lwidth;
	}
	else	{
		width->w[F_LEFT] = -jnt->lwidth;
		width->w[F_RIGHT] = jnt->rwidth;
	}
	l->pr[0].n3->width[F_RIGHT] = width->w[F_RIGHT];
	l->pr[0].n3->width[F_LEFT] = -width->w[F_LEFT];




	for( ; LINK_NEXT(l) != NULL ; l = LINK_NEXT(l) );
	jnt = l->p[F_END].p.jnt;	

	width = l->width[F_END];
	if( jnt->type == JNT_N3 ){
		width->bes.x = ( -jnt->u.y);
		width->bes.y = ( jnt->u.x);
	}
	else	jnt_rn3_set_aux( jnt );

	if( l->p[F_END].bno == 0 ){
		width->w[F_LEFT] = -jnt->lwidth;
		width->w[F_RIGHT] = jnt->rwidth;
	}
	else	{
		width->w[F_LEFT] = -jnt->rwidth;
		width->w[F_RIGHT] = jnt->lwidth;
	}
	l->pr[1].n3->width[F_RIGHT] = width->w[F_RIGHT];
	l->pr[1].n3->width[F_LEFT] = -width->w[F_LEFT];
}



void
link_1_set_geo_aux( link_type *link )
{
jnt_type	*jnt;
link_type	*l;
width_type	*width;
vec2d	tmp;
float	t;

	if( link->type != NF_N3 )	return;

	if( (l = LINK_PREV(link)) != NULL ){
		tmp.x = -( link->u.y + l->u.y );
		tmp.y =  ( link->u.x + l->u.x );
		t = 1.0/ hypot( tmp.x, tmp.y );
		link->width[F_BEGIN]->bes.x = t * tmp.x;
		link->width[F_BEGIN]->bes.y = t * tmp.y;
	}

	if( (l = LINK_NEXT(link)) != NULL ){
		tmp.x = -( link->u.y + l->u.y );
		tmp.y =  ( link->u.x + l->u.x );
		t = 1.0/ hypot( tmp.x, tmp.y );
		link->width[F_END]->bes.x = t * tmp.x;
		link->width[F_END]->bes.y = t * tmp.y;
	}

		

	if( LINK_PREV(link) == NULL ){
		jnt = link->p[F_BEGIN].p.jnt;
		width = link->width[F_BEGIN];

		if( jnt->type == JNT_N3 ){
			width->bes.x = -( -jnt->u.y);
			width->bes.y = -( jnt->u.x);
		}
		else	{
			width->bes.x = -link->u.y;
			width->bes.y = link->u.x;

			jnt_rn3_set_aux( jnt );
		}


		if( link->p[F_BEGIN].bno == 0 ){
			width->w[F_LEFT] = -jnt->rwidth;
			width->w[F_RIGHT] = jnt->lwidth;
		}
		else	{
			width->w[F_LEFT] = -jnt->lwidth;
			width->w[F_RIGHT] = jnt->rwidth;
		}

		link->pr[0].n3->width[F_RIGHT] = width->w[F_RIGHT];
		link->pr[0].n3->width[F_LEFT] = -width->w[F_LEFT];
	}



	if( LINK_NEXT(link) == NULL ){
		jnt = link->p[F_END].p.jnt;	

		width = link->width[F_END];
		if( jnt->type == JNT_N3 ){
			width->bes.x = ( -jnt->u.y );
			width->bes.y = ( jnt->u.x );
		}
		else	{
			width->bes.x = -link->u.y;
			width->bes.y = link->u.x;

			jnt_rn3_set_aux( jnt );
		}


		if( link->p[F_END].bno == 0 ){
			width->w[F_LEFT] = -jnt->lwidth;
			width->w[F_RIGHT] = jnt->rwidth;
		}
		else	{
			width->w[F_LEFT] = -jnt->rwidth;
			width->w[F_RIGHT] = jnt->lwidth;
		}

		link->pr[1].n3->width[F_RIGHT] = width->w[F_RIGHT];
		link->pr[1].n3->width[F_LEFT] = -width->w[F_LEFT];
	}
}
