/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	WidthTool.c	***
 **************************/
#include	<stdio.h>
#ifndef __SYMBIAN32__
	#include	<malloc.h>
	#include	<memory.h>	
#endif // 	__SYMBIAN32__
#include	"Uigp/igp.h"


#include	"GpType/WidthType.h"


width_type	*
width_alloc()
{
width_type	*w;

	w =  WDITH_TYPE_ALLOC();

	return( w );
}



width_type	*
width_make_copy( width_type *w )
{
width_type	*nw;

	nw = WDITH_TYPE_ALLOC();

	*nw = *w;

	return( nw );
}



void
width_afine( width_type *w0, width_type *w1, float t, width_type *w )
{
	w->w[F_RIGHT] = t*w0->w[F_RIGHT] + (1-t)*w1->w[F_RIGHT];
	w->w[F_LEFT] = t*w0->w[F_LEFT] + (1-t)*w1->w[F_LEFT];
}



void
width_inverse( width_type *w )
{
float	tmp;

	tmp = w->w[F_RIGHT];
	w->w[F_RIGHT] = -w->w[F_LEFT];
	w->w[F_LEFT] = -tmp;

	w->bes.x = - w->bes.x;
	w->bes.y = - w->bes.y;


	tmp = w->depth[F_RIGHT];
	w->depth[F_RIGHT] = w->depth[F_LEFT];
	w->depth[F_LEFT] = tmp;
}
