/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*************************
 ***	AdepthType.h   ***
 *************************/
#ifndef         _ADEPTH_TYPE_
#define         _ADEPTH_TYPE_

#include	"Uigp/igp.h"

#include	"Uview/ViewType.h"

#include	"MbrType.h"


#define		MAX_BR	30


typedef struct abr_type {
	int	no;

	int	Fplane;
	vec3d	N,	P;
	vec3d	D;

}	abr_type;


typedef struct adepth_type {

	view_type	*vw;

	vec3d	N,	P;


	int	br_no;
	abr_type	abr[MAX_BR];

	mbr_type	Mbr;

}	adepth_type;




#define		ADEPTH_ALLOC()	\
		( (adepth_type *) malloc( sizeof(adepth_type) ))


adepth_type * 	adepth_copy( adepth_type *ad );

adepth_type *	adepth_default( float depth, int row, int column );

void	adepth_set_plane( adepth_type *ad, int layer, vec3d *N, vec3d *P );

void	adepth_set_planeD( adepth_type *ad, int layer, vec3d *N, float depth );

void	adepth_set_planeND( adepth_type *ad, int layer, float depth );

int	adepth_get_plane( adepth_type *ad, int layer, vec3d *N, float *d );

abr_type * adepth_get_layer_depth( adepth_type *ad, int layer );

void	adepth_rescale( adepth_type *ad, float fk );

#endif
