/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**********************
 ***	BgpType.h   ***
 **********************/

#ifndef         _BGP_TYPE_
#define         _BGP_TYPE_

#include	"Uigp/igp.h"


#include	"Uvec/Vec2d.h"




typedef struct bgp_type {
	vec2d	ctr;

	float	depth;
	char	br;
	char	Sbr;

	qcolor_type	val[SP_NO];

	struct bgp_type	*p;



	/* Rendering AUX */
	vec2d	rctr;
	float	rdepth;

	struct bgp_type *rp;

	
	struct pl_type       *pl;

}	bgp_type;

#define         BGP_ALLOC()	( (bgp_type *)malloc( sizeof( bgp_type ) ) )


#endif
