/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/***********************
 ***	EdgeType.h   ***
 ***********************/

#ifndef         EDGE_TYPE
#define         EDGE_TYPE

#ifndef __SYMBIAN32__
	#include	<malloc.h>
#endif // __SYMBIAN32__

#include	"ColorType.h"



typedef  struct  edge_ltype {
        qcolor_type   val[SP_NO];

        qcolor_type   bval[SP_NO];
} edge_ltype;



typedef  struct  edge_type {

	float depth;
	float repth;
 
	float	width;

        edge_ltype      side[2];

}  edge_type   ;  


#define		EDGE_ALLOC()	( (edge_type *)malloc( sizeof(edge_type) ) )
#define		EDGE_CALLOC()	( (edge_type *)calloc( 1, sizeof(edge_type) ))

void	edge_afine( edge_type *e0, edge_type *e1, float t, edge_type *e );

void	edge_copy_inverse( edge_type *se, edge_type *e );

void	edge_inverse( edge_type *e );

#endif
