/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	HunchType.h	***
 **************************/

#ifndef		_HUNCH_TYPE_
#define		_HUNCH_TYPE_

#include        "Uigp/igp.h"

#include	"ColorType.h"
     

#include	"Uvec/Vec2d.h"


typedef  struct  hunch_gtype {
	float      theta;

	/*** aux ***/
	vec2d      u;
	float	width,	len;

} hunch_gtype;


typedef  struct  hunch_type {
	int	type;		/* NF_HUNCH or NF_RH */
	vec2d	ctr;


	float	depth;
	u_char	br;


	hunch_gtype	g;

	qcolor_type	gval[SP_NO] ;
	qcolor_type	rval[SP_NO];

	qcolor_type	lm1[SP_NO];
	qcolor_type	lm2[SP_NO];



	struct  hunch_type	*nh;


	/* Rendering AUX */
	vec2d	rctr;
	float	rdepth;
	struct  hunch_type	*rnh;

	struct pl_type	*pl;

}  hunch_type;



#define		HUNCH_ALLOC( no )  \
			( (hunch_type *)malloc( no*sizeof( hunch_type )) )
#define		HUNCH_COPY( h, nh, no )  \
				memcpy( nh, h, no*sizeof( hunch_type ) )


#define		HUNCH_FREE( h )		free( h )

	
hunch_type      *hunch_alloc();

hunch_type *	hunch_make_copy( hunch_type *hunch );

void		hunch_copy( hunch_type *h, hunch_type *nh );

void		hunch_inverse_copy( hunch_type *h, hunch_type *nh, int dno );



void		rhunch_set_aux( hunch_type  *rh );

void		hunch_set_aux( hunch_type  *h );

#endif
