/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*********************
 ***	N3Type.h   ***
 *********************/

#ifndef         N3_TYPE
#define         N3_TYPE

#ifndef __SYMBIAN32__
	#include	<malloc.h>
#endif // __SYMBIAN32__


#include	"ColorType.h"


typedef  struct  n3_ltype {
	qcolor_type   val[SP_NO];
	qcolor_type   bval[SP_NO];

}	n3_ltype;




typedef  struct  n3_type {
	float	depth;
	float	rdepth;

	float	width[2];
        qcolor_type	mval[SP_NO]; 
        n3_ltype	side[2];

}	n3_type;  



#define		N3_ALLOC()	( (n3_type *)malloc( sizeof(n3_type) ) )
#define		N3_CALLOC()	( (n3_type *)calloc( 1, sizeof(n3_type) ) )

void	n3_afine( n3_type *n0, n3_type *n1, float t, n3_type *n );

void	n3_copy_inverse( n3_type *se, n3_type *e );

void	n3_inverse( n3_type *e );

#endif
