/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	ProfileType.h   ***
 **************************/

#ifndef         PROFILE_TYPE
#define         PROFILE_TYPE

#include	"Uigp/igp.h"


#include	"Uvec/Vec2d.h"


#include	"RidgeType.h"
#include	"EdgeType.h"
#include	"N3Type.h"





typedef struct pskl_type {
	float	depth;
	float	rdepth;

}	profileT_type;



typedef union {
                ridge_type      *ridge;
                edge_type       *edge;
                n3_type       *n3;

                profileT_type    *p;

}       profile_type;






profile_type    profile_alloc( int type );
profile_type    profile_make_copy( profile_type ppr, int type );

void	profile_afine( int type, profile_type pr0, profile_type pr1,
						float t, profile_type pr );
	
void	profile_copy_inverse( int type, profile_type spr, profile_type tpr );
void	profile_copy( int type, profile_type spr, profile_type tpr );

#endif
