/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************
 ***	WidthType.h   ***
 ************************/

#ifndef         WIDTH_TYPE
#define         WIDTH_TYPE

#include	"Uvec/Vec2d.h"




typedef struct width_type {
	float	w[2];

	/* AUX	*/
	vec2d	bes;


	/* for Depth */
	float	depth[2];

}	width_type;
	


#define		WDITH_TYPE_ALLOC()      \
                        ( (width_type *)malloc( sizeof( width_type ) ) );


width_type      * width_alloc();

width_type      * width_make_copy( width_type *w );

void	width_afine( width_type *w0, width_type *w1, float t, width_type *w );

void	width_inverse( width_type *w );
#endif
