/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*********************
 ***	TlType.h   ***
 *********************/
#ifndef         _LINK_TOOL_
#define         _LINK_TOOL_

#include	"Uigp/igp.h"
#include	"Uprm/prm.h"
#include	"Ubox/Box2d.h"

#include	"GpType/LinkType.h"
#include	"UGeoApp/GeoApp.h"
//struct box2d;



	/* LinkFromGapp.c */
link_type *		link_from_gapp( gapp_type *gapp, int type, link_type **last );
	

	/* LinkFromLine.c */
link_type *		links_from_line( vec2d *point1, vec2d *point2 ,
								float max_dist, int type, link_type **last_link );

link_type *	link_from_points( vec2d p[], int no, int Fclose );

float	polylink_length(link_type *link, link_type *endLink);

int	polylink_link_no(link_type *link, link_type *endLink);

link_type * polylink_max_len( link_type *link, float max_len );

link_type *		link_reapproximate( vec2d *ctr,link_type *link, float max_len, link_type **last );


	/* LinkReaproximate.c */
link_type *		polylink_reapproximate( vec2d *ctr,link_type *link, link_type *elink, link_type **last );

gapp_type *	polylink_to_gapp( vec2d *ctr, link_type *link, link_type *elink );


	/* LinkSetProfile.c */
void	link_profile_alloc( link_type *link, int type );

void link_edge_set_profile( link_type *link, int br, int Fbr, float depth,
														float width, int color );


	/* Beizer2Link.c */

void		beizer_to_link_get_prm(GP_prm **prm, int *prm_no, void (**check)() );

void		beizer_to_link_init( char *file );

link_type *		beizer_curve_to_links( vec2d *p, int no );

link_type *		beizer_to_Links( vec2d *p0,vec2d *p1,vec2d *p2,vec2d *p3 );

link_type *		link_from_qubic_bezier(vec2d *p0,vec2d *p1,vec2d *p2,vec2d *p3, link_type **last );

link_type *		link_from_conic_bezier(vec2d *p0,vec2d *p1,vec2d *p2, link_type **last );


	/* LinkFilter.c */  //Grisha 05.07.01

link_type *link_filter( vec2d *ctr, link_type *link, float min_width );


	/* LinkDistance.c */
float	link_distance( vec2d *ctr, link_type *l, vec2d *v, float *u, float *t );

float	link_distance2( vec2d *ctr, link_type *l, vec2d *v, float *u, float *t );

float		polylink_distance( vec2d *ctr, link_type  *link, link_type *elink, vec2d  *v,
										link_type **sl, float *u, float *t, float *gt );


void	polylink_filter_short_link( vec2d *ctr, link_type *link, float d );




//LinkClip.c
link_type* link_clip(vec2d *gCtr, link_type *link, box2d *box);

link_type* link_frame_box(int type1, box2d *box);


	/* LinkSimplify.c */
void	polylink_simplify( vec2d *ctr, link_type **link );

void	polylink_append( vec2d *ctr, link_type *link, vec2d *v2, link_type *l2 );

int	polylink_append_point( vec2d *ctr, link_type **link, vec2d *p, float Tlen, int Fsimplify );

void	polylink_close( vec2d *ctr, link_type *link, float Tlen );

void	polylink_split( vec2d *ctr, link_type *link, link_type *sl, float t,
											vec2d *ctr1, link_type **l1 );



	/* LinkSplit.c */
link_type *	link_split( vec2d *ctr, link_type *link, vec2d *p );

link_type *	link_split_t( link_type *link, float t0 );

link_type *	link_ssplit( link_type *link, float t, float dt );



	/* LinkTool2.c */

void	link_connect( link_type *l0, link_type *l1 );

void	link_set_gCtr(link_type *l, vec2d *gCtr);

void	polylink_set_ctr( vec2d *ctr, link_type *l );

void	polylink_tanget_end( link_type *link, vec2d *tanget );

void	link_end_point(link_type *l, vec2d *v);

void	link_set_prev_next( link_type *first, link_type *second );

void	link_set_type( link_type *link, int l_type );

link_type *polylink_get_last_link( link_type *link );

link_type *polylink_get_first_link( link_type *link );

link_type *	polylink_copy( link_type *plink, link_type *elink );


	/* LinkSet.c */
void	link_set_begin( vec2d *ctr, link_type *link, vec2d *p );

void	link_set_end( vec2d *ctr, link_type *link, vec2d *p );

void	link_set_a_point( vec2d *ctr, link_type *l, vec2d *p );

void	link_set_a( vec2d *ctr, link_type *l, float a );


	/* LinkBox.c */
void	polylink_box( vec2d *ctr, link_type *link, link_type *last, box2d *box );

void	polylinkA_box( link_type *alink[], int no, box2d *box );

	/* LinkInsidePoint.c */
void	polylink_inside_point( vec2d *ctr, link_type *link, vec2d *p );


	/* LinkIo.o */
int	ploylink_write_to_file( vec2d *ctr, link_type *link, char *file );

int	ploylink_write_to_buffer( vec2d *ctr, link_type *link, char **data, int *bytes );

int	polylink_write( vec2d *ctr, link_type *link, FILE *fp );

int	ploylink_read_from_file( char *file, vec2d *ctr, link_type **link );

int	ploylink_read_from_buffer( char *data, int bytes, vec2d *ctr, link_type **link );

int	ploylink_read( FILE *fp, vec2d *ctr, link_type **link );


#endif
