/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	TlSelect.c	***
 **************************/

#include	<stdio.h>
#include	<math.h>

#include	"Uigp/igp.h"

#include	"TlType.h"



int
tl_array_select( tl_type  tlink[], int no, vec2d  *v, int mbr,
				tl_type **sl, float *u, float *t )
{
tl_type	*tl;
link_type	*l;
int         i,	ret;
vec2d       cv;
float	cu,	ct,	dt;
float	dis,	tmp;


	*sl = NULL;
	*u = 1000;
	*t = 100;
	ret = -1;

	dis = 100000;


	for( i = 0 ; i < no ; i++ ){
		tl = &tlink[i];

		if( mbr != 0 && !(tl->mbr & mbr) )	continue;

		cv.x = v->x - tl->ctr.x;
		cv.y = v->y - tl->ctr.y;

		l = tl->l;

		cu = l->u.x * cv.x + l->u.y * cv.y;

		ct = -l->u.y * cv.x + l->u.x * cv.y;



		if( ct < 0 ){
			tmp = cu*cu + 1.44*ct*ct;

			if( cu > 0 ) cu -= ct;
			else	cu += ct;

			ct = 0;
		}
		else	if( (dt = ct - l->len) > 0 ){
				tmp = cu*cu + 1.44*dt*dt;

				if( cu > 0 ) cu += dt;
				else	cu -= dt;

				ct = l->len;
			}
			else	{
				tmp = cu*cu;
				cu -= l->c_prb*ct *(ct - l->len );
			}


		if( tmp > dis )	continue;
		dis = tmp;

		*u = cu;
		*t = ct;
		*sl = tl;
		ret = i;
	}

	return( ret );
}




int
tl_array_set( vec2d *ctr, link_type *link, link_type *elink, tl_type  atl[], int *no )
{
tl_type *tl;
link_type	*l;
vec2d	v;
int	i;

	for( l = link, v = *ctr, i = 0 ; l != elink ; l = LINK_NEXT(l) ){
		tl = &atl[i];

		tl->ctr = v;
		tl->l = l;

		tl->mbr = 1 << l->br;
	}

	*no = i;

	return( i );
}
