/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*************************
 ***    N3PrimeIn.h    ***
 *************************/

#ifndef		_N3_PRIME_IN_
#define		_N3_PRIME_IN_

#include	"GpType/GpType.h"

	/* N3PrimeLink.c */
void	n3_prime_link_seg( vec2d *ctr, link_type *link, int side, in_type *in0,
				link_type *link1, in_type *in1,
				jnt_type *jnt0, jnt_type *jnt1 );

link_type *	n3_prime_link_in( vec2d *ctr, link_type *l, int side,
				vec2d *ctr0, in_type *in0,
				vec2d *ctr1, in_type *in1 );

void	n3_prime_link_connect_jnt( jnt_type *jnt, link_type *link, int direct );


	/* N3PrimeProfile.c */
edge_type *	n3_prime_profile( link_type *link, int side, int direct );

edge_type *	n3_prime_profile_in( link_type *link, int side, float t0 );

edge_type *	n3_prime_profile1( jnt_type *jnt, int bno, int side, int flag );

edge_type *	n3_prime_profile11( jnt_type *jnt, int bno, int direct );



	/* N3PrimeInNull.c */
void	n3_prime_in_null( gp_array *agp );

void	n3_prime_in_null_init( gp_array *agp );

#endif
