/**********************
 ***   RelValue.c   ***
 **********************/

#include        <stdio.h>   
#include	<math.h>
#include	"Uigp/igp.h"

#include        "GpType/GpType.h"
#include        "RelValue.h"

#include        "RelValueIn.h"


#include        "EpType/EpType.h"
#include        "Ep/Ep.h"
#include        "EpValue/EpValue.h"


static void	rel_value_hunch( epValue_type *epValue, ep_type *ep, vec2d *ctr, hunch_type *h );

static void	rel_value_ridge( epValue_type *epValue, ep_type *ep, vec2d *ctr, ridge_type *r );



void
rel_value_agp( gp_array *agp, ep_array *aep, int Fwidth )
{
gp_type		*gp;
hunch_type		*h;
jnt_type	*jnt;
brn_type	*b;
link_type	*link;
vec2d	v;
ep_type	*ep;
ridge_type	*r;
  
int     i1,	j1;
int     i,      j,	bno;

        for( i = JSIZE, i1 = aep->Ni0-1 ; i < aep->Ni-JSIZE ; i++, i1++ ){

            for( j = JSIZE, j1 = aep->Nj0-1 ; j < aep->Nj-JSIZE ; j++, j1++ ){
			gp = &agp->gp[i1][j1];

			ep = &aep->ep[i][j];



			for( h = gp->hunch ; h != NULL ; h = h->nh ){

				rel_value_hunch( &aep->epValue, ep, &h->ctr, h );

				switch( h->type ){
				case    NF_HUNCH:
					if( Fwidth )	set_width_len_hunch( h);
					hunch_set_aux( h );
				    break;
				case    NF_RH:
					if( Fwidth )	set_width_hr( h );
					rhunch_set_aux( h );
				    break;
				}
			}



			for( link = gp->link ; link != NULL ; link = link->nl){

                                if( link->type != NF_RIDGE &&
					link->type != NF_N3R )    continue; 

				r = link->pr[F_BEGIN].ridge;
				rel_value_ridge( &aep->epValue, ep, &link->ctr, r );

				set_width_ridge_profile( r );
			}


			for( jnt = gp->jnt ; jnt != NULL ; jnt = jnt->nj ){

                                if( jnt->type != JNT_RIDGE &&
					jnt->type != JNT_RN3 &&
					jnt->type != JNT_N3 )    continue; 
	
				for( bno = 0 ; bno < jnt->brn_no ; bno++ ){
					b = jnt->brn[bno];
					if( b->direction != F_END )
						continue;

					if( b->link == NULL )	continue;
                                	if( b->link->type != NF_RIDGE &&
						b->link->type != NF_N3R )
						continue; 

					v.x = jnt->ctr.x + b->ctr.x;
					v.y = jnt->ctr.y + b->ctr.y;

					r = b->link->pr[F_END].ridge;

					rel_value_ridge( &aep->epValue, ep, &v, r );

					set_width_ridge_profile( r );
				}
			}
	     }
	}

  
}






static void
rel_value_hunch( epValue_type *epValue, ep_type *ep, vec2d *ctr, hunch_type *h )
{
float	val[SP_NO];

	ep_value3( epValue, ep, ctr, val );

	h->rval[SP_Y] =  h->gval[SP_Y] - F2QCOLOR( val[SP_Y] );
	h->rval[SP_Q] =  h->gval[SP_Q] - F2QCOLOR( val[SP_Q] );
	h->rval[SP_A] =  h->gval[SP_A] - F2QCOLOR( val[SP_A] );
}


void
rel_value_ridge( epValue_type *epValue, ep_type *ep, vec2d *ctr, ridge_type *r )
{
float	val[SP_NO];

	ep_value3( epValue, ep, ctr, val );

	r->rval[SP_Y] =  r->mval[SP_Y] - F2QCOLOR( val[SP_Y] );
	r->rval[SP_Q] =  r->mval[SP_Q] - F2QCOLOR( val[SP_Q] );
	r->rval[SP_A] =  r->mval[SP_A] - F2QCOLOR( val[SP_A] );
}
