#ifndef		_CODING_H_
#define		_CODING_H_

#include	"Uprm/prm.h"

#include	"CodingAdepth.h"

#include	"CodingHunch.h"
#include	"CodingLink.h"
#include	"CodingJoint.h"
#include	"CodingN3.h"
#include	"CodingBg.h"
#include	"CodingRidge.h"
#include	"CodingProfile.h"
#include	"CodingCenter.h"
#include	"CodingDepth.h"


typedef struct coding_type {

	int	head;
	int	N;

	codingAdepth_type	*ad;

	codingJoint_type	*jc;
	codingLink_type		*lc;
	codingN3_type		*nc;
	codingHunch_type	*hc;
	codingBg_type		*bc;
	codingProfile_type	*pc;
	codingRidge_type	*rc;
	codingCenter_type	*cc;

	codingDepth_type	*depth;

}	coding_type;





	/* for agp header */
#define	CODING_RH		0x01
#define	CODING_HUNCH		0x02
#define	CODING_RIDGE		0x04
#define	CODING_DEPTH		0x08
#define	CODING_DEPTH_DELTA	0x10
#define	CODING_LAYER_NAME	0x20





void	coding_get_group( GP_prm_group **prm_group, int *prm_group_no );

void	coding_set_config_dir( char *config_dir );

coding_type *	coding_init( int Lcoding, int bgp );

coding_type *	coding_set_local_prm( char *file, int bgp );

coding_type *	coding_set( int Lcoding, int bgp );


void		coding_free( coding_type * cprm );



 
#endif

