/**************************
 ***	CodingHunch.c	***
 *************************/
#include        "Uigp/igp.h"
#include        "Ucode/code.h"

#include	"GpType/Configuration.h"

#include	"GpType/ColorType.h"

#include	"CodingHunch.h"




 

#ifndef PLAYER

static code_in  Hval_in[SP_NO] = {      { 0.0, 127.0, 1.0, 0.0, 0.0 },
                                        { 0.0, 127.0, 1.0, 0.0, 0.0 },
                                        { 0.0, 127.0, 1.0, 0.0, 0.0 } };


static code_in  Hlen_in = { 0.5, 10.0, 0.5, 0.0, 0.0 };
static code_in  Hwidth_in = { 0.75, 2.0, 0.5, 0.0, 0.0 };


static code_in  Htheta_in = { 0.0 ,180.0, 22.5, 0.0, 0.0 };


float	Hround_min;

float	DeltaR;

float	Hval_t;



static GP_prm  Param[]    =    {
        {"H-val-Y-d", (char*)&Hval_in[0].d, PRM_FLOAT, "%.2f", "1.0"},
        {"H-val-Q-d", (char*)&Hval_in[1].d, PRM_FLOAT, "%.2f", "1.0"},
        {"H-val-A-d", (char*)&Hval_in[2].d, PRM_FLOAT, "%.2f", "1.0"},
 
        {"H-len-min", (char*)&Hlen_in.min, PRM_FLOAT, "%.2f", "0.5"},
 
        {"H-len-d", (char*)&Hlen_in.d, PRM_FLOAT, "%.2f", "1.0."},


        {"H-width-min", (char*)&Hwidth_in.min, PRM_FLOAT, "%.2f", "0.75"},
        {"H-width-d", (char*)&Hwidth_in.d, PRM_FLOAT, "%.2f", "0.5"},

        {"H-theta-d", (char*)&Htheta_in.d, PRM_FLOAT, "%.2f", "45.0"},

		{"H-Round", (char*)&DeltaR, PRM_FLOAT, "%.2f", "0.2"},

        {"H-round-min", (char*)&Hround_min, PRM_FLOAT, "%.2f", "0.5"},

        {"H-val-t", (char*)&Hval_t, PRM_FLOAT, "%.2f", "3"},
};



void
coding_hunch_get_prm( GP_prm  **prm, int *prm_no, void (**check)())
{
        *prm    = Param;
        *prm_no  = PRM_NUMBER(Param);
        *check = NULL;
}







codingHunch_type *
coding_hunch_set_lprm( char *file )
{
codingHunch_type	*hc;

	gp_prm_init( file, coding_hunch_get_prm );

	hc = ( (codingHunch_type *)malloc( sizeof( codingHunch_type ) ) ) ;


	code_set( &hc->Htheta, 0, 180, Htheta_in.d, 0, M_PI/180.0 );

	code_set( &hc->Hwidth, Hwidth_in.min, 2.0, Hwidth_in.d, 0, 1.0 );
	coding_set_lprm( &Hwidth_in, &hc->Hwidth, 1.0 );


	code_set( &hc->Hlen, Hlen_in.min, 10.0, Hlen_in.d, 0, 1.0 );

	hc->DeltaR = DeltaR;
	hc->Hround_min = Hround_min;


	code_set( &hc->Hval[SP_Y], 0, 127.0, Hval_in[SP_Y].d, 0, QCOLOR_UNIT );
	code_set( &hc->Hval[SP_Q], 0, 127.0, Hval_in[SP_Q].d, 0, QCOLOR_UNIT );
	code_set( &hc->Hval[SP_A], 0, 127.0, Hval_in[SP_A].d, 0, QCOLOR_UNIT );


	hc->Hval_t = F2QCOLOR(Hval_t);

	return( hc );
}

#endif



extern	float   H_val_Y_d[];
extern	float   H_val_Q_d[];
extern	float   H_val_A_d[];
 
extern	float   H_len_min[];
extern	float   H_len_d[];
 
extern	float   H_theta_d[];
extern	float   H_Round[];
extern	float   H_round_min[];
 
extern	float   H_width_min[];
extern	float   H_width_d[];
 
extern	float   H_val_t[];


codingHunch_type *
coding_hunch_set( int iCoding )
{
codingHunch_type	*hc;

	hc = ( (codingHunch_type *)malloc( sizeof( codingHunch_type ) ) ) ;


	code_set( &hc->Htheta, 0, 180, H_theta_d[iCoding], 0, M_PI/180.0 );


	code_set( &hc->Hwidth, H_width_min[iCoding], 2.0, H_width_d[iCoding], 0, 1.0 );


	code_set( &hc->Hlen, H_len_min[iCoding], 10.0, H_len_d[iCoding], 0, 1.0 );

	hc->DeltaR = H_Round[iCoding];
	hc->Hround_min = H_round_min[iCoding];


	code_set( &hc->Hval[SP_Y], 0, 127.0, H_val_Y_d[iCoding], 0, QCOLOR_UNIT );
	code_set( &hc->Hval[SP_Q], 0, 127.0, H_val_Q_d[iCoding], 0, QCOLOR_UNIT );
	code_set( &hc->Hval[SP_A], 0, 127.0, H_val_A_d[iCoding], 0, QCOLOR_UNIT );


	hc->Hval_t = F2QCOLOR(H_val_t[iCoding]);

	return( hc );
}
