#include	<stdio.h>
#include	<math.h>
 
#include	"Ucode/code.h"

#include	"GpType/Configuration.h"

#include	"CodingLink.h"







#ifndef	PLAYER

static code_in		La_in =      { -0.5,   0.5, 0.125 };
static code_in		Llen_in =    {  0.0,   2.0, 0.5   };
static code_in		Lwidth_in =  {  0.0,   2.0, 0.25  };


static GP_prm  Parames[]    =    {
	{"L-a-d",(char *)&La_in.d, PRM_FLOAT, "%.3f", "0.125"},

	{"L-len-d", (char*)&Llen_in.d, PRM_FLOAT, "%.3f", "0.5"},

	{"L-width-d", (char*)&Lwidth_in.d, PRM_FLOAT, "%.3f", "0.25"},
};



void 
coding_link_get_prm( GP_prm  **prm, int *prm_no, void (**check)())
{
        *prm    = Parames;
        *prm_no  = PRM_NUMBER(Parames);
        *check = NULL;
}



codingLink_type	*
coding_link_set_lprm( char *file )
{
codingLink_type * lc;

	gp_prm_init( file, coding_link_get_prm );

	lc =  ( (codingLink_type *)malloc( sizeof( codingLink_type ) ) ) ;

	code_set( &lc->La, -0.5, 0.5, La_in.d, 0, 1.0 );

	code_set( &lc->Llen, 0, 2.0, Llen_in.d, 0, 1.0 );

	code_set( &lc->Lwidth, 0, 2.0, Lwidth_in.d, 0, 1.0 );

	lc->Base_u.x = 1.0;
	lc->Base_u.y = 0.0;

	return( lc );
}

#endif




extern	float   L_a_d6[];
extern	float   L_len_d6[];
extern	float   L_width_d6[];
 
extern	float   L_a_d[];
extern	float   L_len_d[];
extern	float   L_width_d[];



codingLink_type	*
coding_link_set( int iCoding, int bgp )
{
codingLink_type * lc;
float	d;

	lc =  ( (codingLink_type *)malloc( sizeof( codingLink_type ) ) ) ;

	d = ( bgp == 6 )? L_a_d6[iCoding] : L_a_d[iCoding];
	code_set( &lc->La, -0.5, 0.5, d, 0, 1.0 );

	d = ( bgp == 6 )? L_len_d6[iCoding] : L_len_d[iCoding];
	code_set( &lc->Llen, 0, 2.0, d, 0, 1.0 );

	d = ( bgp == 6 )? L_width_d[iCoding] : L_width_d[iCoding];
	code_set( &lc->Lwidth, 0, 2.0, d, 0, 1.0 );


	lc->Base_u.x = 1.0;
	lc->Base_u.y = 0.0;

	return( lc );
}
