/**************************
 ***	CodingRidge.c   ***
 **************************/
#include        "Uigp/igp.h"
#include        "Uprm/prm.h"

#include 	"Ucode/code.h"

#include	"GpType/Configuration.h"

#include 	"GpType/ColorType.h"

#include	"CodingRidge.h"

     

	

#ifndef PLAYER

static code_in Rval_in[SP_NO] =   {	{ -255.0, 255.0, 1.0 },
					{ -255.0, 255.0, 1.0 },
					{ -255.0, 255.0, 1.0 } };


static code_in Rlm_in =      { 5.0, 255.0, 4.0 };



static float   Rval_t;


static GP_prm  Params[]    =    {
	{"R-lm-d", (char*)&Rlm_in.d, PRM_FLOAT, "%.2f", "1.0"},

        {"R-val-Y-d", (char*)&Rval_in[SP_Y].d, PRM_FLOAT, "%.2f", "1.0"},
	{"R-val-Q-d", (char*)&Rval_in[SP_Q].d, PRM_FLOAT, "%.2f", "1.0"},
	{"R-val-A-d", (char*)&Rval_in[SP_A].d, PRM_FLOAT, "%.2f", "1.0"},

	{"R-val-t", (char*)&Rval_t, PRM_FLOAT, "%.2f", "3"},
};



void
coding_ridge_get_prm( GP_prm  **prm, int *prm_no, void (**check)())
{
        *prm    = Params;
        *prm_no  = PRM_NUMBER(Params);
        *check = NULL;
}






 

codingRidge_type *
coding_ridge_set_lprm( char *file )
{
codingRidge_type * rc = ((codingRidge_type *)malloc(sizeof(codingRidge_type))) ;

	gp_prm_init( file, coding_ridge_get_prm );

	code_set( &rc->Rlm, 5.0, 255.0, Rlm_in.d, 0, QCOLOR_UNIT );

	code_set( &rc->Rval[SP_Y], -255, 255.0, Rval_in[SP_Y].d, 0, QCOLOR_UNIT );
	code_set( &rc->Rval[SP_Q], -255, 255.0, Rval_in[SP_Q].d, 0, QCOLOR_UNIT );
	code_set( &rc->Rval[SP_A], -255, 255.0, Rval_in[SP_A].d, 0, QCOLOR_UNIT );


	rc->Rval_t = F2QCOLOR( Rval_t );

	return rc;
}

#endif




extern float	R_lm_d[];
extern float	R_val_Y_d[];
extern float	R_val_Q_d[];
extern float	R_val_A_d[];
extern float	R_val_t[];



codingRidge_type *
coding_ridge_set( int iCoding )
{
codingRidge_type * rc = ((codingRidge_type *)malloc(sizeof(codingRidge_type))) ;

	code_set( &rc->Rlm, 5.0, 255.0, R_lm_d[iCoding], 0, QCOLOR_UNIT );

	code_set( &rc->Rval[SP_Y], -255, 255.0, R_val_Y_d[iCoding], 0, QCOLOR_UNIT );
	code_set( &rc->Rval[SP_Q], -255, 255.0, R_val_Q_d[iCoding], 0, QCOLOR_UNIT );
	code_set( &rc->Rval[SP_A], -255, 255.0, R_val_A_d[iCoding], 0, QCOLOR_UNIT );


	rc->Rval_t = F2QCOLOR( R_val_t[iCoding] );

	return rc;
}