/*************************
 ***   QuasiLength.c   ***
 *************************/
#include        "Uigp/igp.h"
#include		"QuasiLength.h"


#define		F2QUASILEN( x )		(( x < 0 )? -x*2 + 0.5 : x*2 + 0.5 ) 


static int	quasi_length( int a, int b );


int
polylink_quasi_length( link_type *link, int qlen[] )
{
link_type	*l;
int	len;
int	i;


	for( l = link, i = 0, len = 0 ; l != NULL ; l = LINK_NEXT(l), i++ ){

		qlen[i] = link_quasi_length( l );

		len += qlen[i];
	}

	return( len );
}



int
link_quasi_length( link_type *link )
{
int	a,	b;
	a = F2QUASILEN( l->v.x );
	b = F2QUASILEN( l->v.y );

	if ( a > 3*b )
		return a;

	if ( b > 3*a )
		return b;

	return ( (a+b)*3/4 );
}


int
vec2d_quasi_length( vec2d *v )
{
int	a,	b;
	a = F2QUASILEN( v->x );
	b = F2QUASILEN( v->y );

	if ( a > 3*b )
		return a;

	if ( b > 3*a )
		return b;

	return ( (a+b)*3/4 );
}




int
quasi_length( int a, int b )
{
	if( a < 0 )	a = -a;
	if( b < 0 )	b = -b;

	if ( a > 3*b )
		return a;
	else if ( b > 3*a )
		return b;
	else
		return ( (a+b)*3/4 );
}