/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef		_CODING_BG_IN_
#define		_CODING_BG_IN_


#include	"Ubst/BstType.h"
#include	"Ucst/CstType.h"

#include	"Coding/Coding.h"




#include	"Ep2/Ep2Type.h"




	/* DecBg.c */
void	decoding_ep( ep2_array *aep2,codingBg_type *bc, bst_type *bst );
 
void	decoding_ep_close( codingBg_type *bc );
 
void	decoding_ep_huffman( codingBg_type *bc, bst_type *bst );





	/* DecLayerBg.h */
void	decoding_layer_bg( ep2_array *aep2, codingDepth_type *dc, bst_type *bst );
 

	/* DecAbsValue.c */
void	decoding_abs_value_agp( gp_array *agp, ep_array *aep );
 
void	decoding_abs_value_agp_br( gp_array *agp, ep_array *aep, int mbr ); 




	/* EncEp.c */
void	encoding_ep_open( codingBg_type *bc );

void	encoding_ep( ep2_array *aep2, codingBg_type *bc, bst_type *bst );

void	encoding_ep_close( codingBg_type *bc );

void	encoding_ep_huffman( codingBg_type *bc,FILE *cfd );

void	encoding_ep_end_line(FILE * fp);

int		encoding_ep_print_inf(FILE * fp);


	/* EncLayerBg.c */
void	encoding_layer_bg( ep2_array *aep2,codingDepth_type *dc, bst_type *bst );


#endif
