/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/

#include	"Ucode/code.h"
#include	"Ubst/BstType.h"

#include 	"Uigp/igp.h"

#include	"EpType/EpType.h"
#include	"Ep2/Ep2Type.h"
#include	"Ep2/Ep2.h"



#include		"Decoding/DecIn.h"
#include        "CodingBgIn.h"

#include	"Coding/CodingDepth.h"




static void	decoding_layer_bg_trans0( ep2_array *aep2,
				codingDepth_type *dc, bst_type *bst );

static void	decoding_layer_bg_trans1( ep2_array *aep2,
				codingDepth_type *dc, bst_type *bst );


static void	decoding_layer_bg_put_br( ep2_type *ep2 );

void
decoding_layer_bg( ep2_array *aep2, codingDepth_type *dc, bst_type *bst )
{
ep2_type	*ep2;
bound2_type	*b2;
int     i,      j,	k;
int	no;


	aep2_br( aep2 );



	no = 0;
	for( i = 0 ; i < aep2->Ni ; i++ )
		for( j = 0 ; j < aep2->Nj ; j++ ){
			ep2 = &aep2->ep[i][j];

			for( k = 0 ; k < ep2->b_no ; k++ ){
				b2 = ep2->bound[k];
				if( b2->Sbr == 1 )      continue;

				no++;
			}
		}

	if( no == 0 ){
		for( i = 0 ; i < aep2->Ni ; i++ )
			for( j = 0 ; j < aep2->Nj ; j++ ){
				ep2 = &aep2->ep[i][j];
				decoding_layer_bg_put_br( ep2 );
			}
		return;
	}

	if( bst_get( bst ) == 0 )
		decoding_layer_bg_trans0( aep2, dc, bst );
	else	decoding_layer_bg_trans1( aep2, dc, bst );
}


static void
decoding_layer_bg_trans0( ep2_array *aep2,
			codingDepth_type *dc, bst_type *bst )
{
ep2_type	*ep2;
bound2_type	*b2;
int	i,	j,	k,	br;

	if( bst_get( bst ) == 0 ){

		br = CST_GET_SCHAR( dc->Br_f.cst );
		for( i = 0 ; i < aep2->Ni ; i++ )
			for( j = 0 ; j < aep2->Nj ; j++ ){
				ep2 = &aep2->ep[i][j];

				for( k = 0 ; k < ep2->b_no ; k++ ){
					b2 = ep2->bound[k];
					if( b2->Sbr == 1 )	continue;

					b2->br = br;
				}

				decoding_layer_bg_put_br( ep2 );
			}

		return;
	}


	for( i = 0 ; i < aep2->Ni ; i++ )
		for( j = 0 ; j < aep2->Nj ; j++ ){
			ep2 = &aep2->ep[i][j];

			for( k = 0 ; k < ep2->b_no ; k++ ){
				b2 = ep2->bound[k];
				if( b2->Sbr == 1 )	continue;

				br = CST_GET_SCHAR( dc->Br_f.cst );
				b2->br = br;

			}

			decoding_layer_bg_put_br( ep2 );
		}
}



static void
decoding_layer_bg_trans1( ep2_array *aep2,
			codingDepth_type *dc, bst_type *bst )
{
ep2_type	*ep2;
bound2_type	*b2;
int	i,	j,	k,	no,	br;

	if( bst_get( bst ) == 0 ){
		for( i = 0 ; i < aep2->Ni ; i++ )
			for( j = 0 ; j < aep2->Nj ; j++ ){
				ep2 = &aep2->ep[i][j];
				decoding_layer_bg_put_br( ep2 );
			}

		return;
	}


	if( bst_get( bst ) == 0 ){
		no = 1;
		br = CST_GET_SCHAR( dc->Br_f.cst );
	}
	else	no = 2;

	for( i = 0 ; i < aep2->Ni ; i++ )
		for( j = 0 ; j < aep2->Nj ; j++ ){
			ep2 = &aep2->ep[i][j];

			for( k = 0 ; k < ep2->b_no ; k++ ){
				b2 = ep2->bound[k];
				if( b2->Sbr == 1 )	continue;

				if( bst_get( bst ) == 0 ){
/*
					b2->br = -1;
*/
					continue;
				}


				if( no == 1 ){
					b2->br = br;
					continue;
				}

				br = CST_GET_SCHAR( dc->Br_f.cst );
				b2->br = br;
			}

			decoding_layer_bg_put_br( ep2 );
		}

}



static void
decoding_layer_bg_put_br( ep2_type *ep2 )
{
ep_type	*ep;
bound_type	*b;
int	i,	bno;

	for( i = 0 ; i < 4 ; i++ ){
		ep = ep2->ep[i];
		if( ep == NULL )	continue;

		for( bno = 0 ; bno < ep->b_no ; bno++ ){
			b = ep->bound[bno];

			if( b->Mbgp == NULL )	continue;

			if( ep2->bound[b->b2_no]->br < 0 ){
				b->Mbgp->val[SP_Y] = b->Mbgp->val[SP_Q] =
						b->Mbgp->val[SP_A] = 0;
				continue;
			}

			if( b->br.no == 255 )
				b->br.no = ep2->bound[b->b2_no]->br;
		}
	}
}
