/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include        <stdio.h>

#include        "Uigp/igp.h"
#include        "Ucode/code.h"

#include        "DecIn.h"
#include        "Coding/CodingJoint.h"





static void	decoding_joint_get_link_no( gp_type *gp,
			int type, link_type *link, int *no, link_type *ln[] );



void
decoding_branch_in( gp_array *agp, jnt_type *jnt, int bno,
				codingJoint_type *jc, bst_type *bst )
{
brn_type	*b;
vec2d	ctr;
int	i0,	j0,	i,	j;
int	di,	dj,	dij;
int	lno,	no;
link_type	*ln[MAX_LINK];

	b = jnt->brn[bno];
	ctr.x = jnt->gctr.x + b->ctr.x;
	ctr.y = jnt->gctr.y + b->ctr.y;

        i0 = (ctr.x +agp->bgp) * agp->inv_bgp;
        j0 = (ctr.y +agp->bgp) * agp->inv_bgp;

	dij = CST_GET_SCHAR( jc->Jend_f.cst );

        di = dij/11 -5;
        dj = dij%11 -5;
        i = i0 + di;
        j = j0 + dj;


	decoding_joint_get_link_no( &agp->gp[i][j],
				(1L<<NF_N3) | (1L<<NF_N3R),
				b->link, &lno, ln );
	if( lno > 1 )
                no = bst_get_int( bst, coding_ilog2( lno-1 ) );
	else	no = 0;

	b->link = ln[no];

	b->direction = bst_get( bst );
}






static void
decoding_joint_get_link_no( gp_type *gp, int mtype, link_type *link,
				int *no, link_type *ln[] )
{
int	i;
link_type	*l;

	if( gp->link->nl == NULL ){
		*no = 1;
		ln[0] = gp->link;
		return;
	}

	*no = 0;
	for( l = gp->link, i = 0 ; l != NULL ; l = l->nl, i++ ){
		if( !((1L<<l->type) & mtype) )	continue;

		ln[ (*no)++ ] = l;
	}
}
