/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/***********************
 ***	DecIn.c    ***
 **********************/
#include	<stdio.h>

#include        "Uigp/igp.h"

#include        "LossLessCoding/LossLessCoding.h"

#include	"DecIn.h"




static void	decoding_agp_bst_get_header( bst_type * bst,
					int *cotype, int *size );


void
decoding_agp_bst_read_header( bst_type *bst,
			int *type, int *row, int *column,
			int *bgp, int *Lcoding )
{
	*type = bst_get_align_num( bst, 2 );
	*row = bst_get_align_num( bst, 2 );
	*column = bst_get_align_num( bst, 2 );
	*bgp = bst_get_align_num( bst, 2 );
	*Lcoding = bst_get_align_num( bst, 2 );
}
 



bst_type *
decoding_agp_file_cut_bst( bst_type* bst_file )
{
int	cotype,	byte;
bst_type	*bst;
 
	decoding_agp_bst_get_header( bst_file, &cotype, &byte );

//	bst = bst_alloc( byte );
//	bst_copy( bst_file, bst, byte );

	bst = bst_get_align_bst( bst_file, byte );

	return( bst );
}


cst_type *
decoding_agp_file_cut_huffman_cst( bst_type* bst_file )
{
int	cotype,	byte;
cst_type	*cst;
 

	decoding_agp_bst_get_header( bst_file, &cotype, &byte );

	cst = lossless_decoding_cst( bst_file, byte, cotype );

	cst_rewind( cst );

	return( cst );
}





static void
decoding_agp_bst_get_header( bst_type * bst_file, int *cotype, int *size )
{

	u_char value;
	value = bst_get_align_num(bst_file,1);
	*cotype = value & 0xf;

	if( *cotype == 0xf )	*cotype = -1;

	switch( value & 0xf0 ){
	case 0x10:
		*size = 0;
	    break;

	case 0x20:
		*size = bst_get_align_num(bst_file,1);
	    break;

	case 0x30:
		*size = bst_get_align_num(bst_file,2);
	    break;

	case 0x40:
		*size = bst_get_align_num(bst_file,3);
	    break;
	}
}
