/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef		_DEC_IN_
#define		_DEC_IN_


#include	"Ubst/BstType.h"
#include	"Ucst/CstType.h"

#include	"Coding/Coding.h"

#include	"Ep2/Ep2Type.h"


	/* DecAdepth.c */
void	decoding_adepth( coding_type *cprm, bst_type * bst, gp_array *agp ); 

int	decoding_adepth_layer_no( coding_type *cprm, int row, int column, view_type **vw, bst_type *bst_file );


	/* DecCenter.c */
void	decoding_center( gp_array *agp,codingCenter_type *cc );
 
void	decoding_center_close( codingCenter_type *cc );
 
void	decoding_center_huffman( codingCenter_type *cc, bst_type *bst );



	/* DecJoint.c */
void	decoding_joint( gp_array *agp, coding_type *cprm, bst_type *bst);
 
void	decoding_joint_close( codingJoint_type *jc );
 
void	decoding_joint_huffman( codingJoint_type *jc, bst_type *bst );
 
 

	/* DecBranchIn.c */
void	decoding_branch_in( gp_array *agp, jnt_type *jnt, int bno,
			codingJoint_type *jc, bst_type *bst );



	/* DecLink.c */
link_type *	decoding_link(codingLink_type *lc,
			vec2d *ctr, int type, vec2d *base_u, int flag  );
 
void 	decoding_link_huffman( codingLink_type *lc, bst_type * bst );
 
void	decoding_link_close( codingLink_type *lc ); 



	/*DecProfile.h */
void	decoding_profile( gp_array *agp,codingProfile_type *pc, bst_type *bst );
 
void	decoding_profile_close( codingProfile_type *pc );
 
void	decoding_profile_huffman( codingProfile_type *pc, bst_type *bst ); 




	/* DecN3.c */
void	decoding_n3_width( link_type *link ,codingN3_type *nc );
 
void	decoding_n3_close(codingN3_type *nc );
 
void	decoding_n3_huffman( codingN3_type *nc,bst_type *bst ); 



	/* DecRidge.c */
void	decoding_ridge( link_type *link[], int ridge_no,
				codingRidge_type *rc, bst_type *bst );
 
void	decoding_ridge_close( codingRidge_type *rc );
 
void	decoding_ridge_huffman( codingRidge_type *rc,bst_type *bst ); 



	/* DecHunch.c */
void	decoding_hunch( hunch_type *ah[], int hunch_no,
				codingHunch_type *hc, bst_type *bst );
 
void	decoding_hunch_close( codingHunch_type *hc );
 
void	decoding_hunch_huffman( codingHunch_type *hc, bst_type *bst );




	/* DecLayer.h */
void	decoding_layer( gp_array *agp, codingDepth_type *dc, bst_type *bst );

void	decoding_layer_close( codingDepth_type *dc );
 
void	decoding_layer_huffman( codingDepth_type *dc, bst_type *bst );


	/* decDepth.c */
void    decoding_depth( gp_array *agp, codingDepth_type *dc, bst_type *bst );
 
 
void    decoding_depth_close( codingDepth_type *dc );
 
void    decoding_depth_huffman( codingDepth_type *dc, bst_type *bst );




	/* DecFile.c */
int	decoding_agp_file_info( char *file,
				int *type, int *row, int *column,
				int *bgp, int *Lcoding );


void	decoding_agp_bst_read_header( bst_type *bst,
			int *type, int *row, int *column,
			int *bgp, int *Lcoding );


bst_type *	decoding_agp_file_cut_bst( bst_type *bst );
cst_type *	decoding_agp_file_cut_huffman_cst( bst_type *bst );


#endif
