/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/********************
 ***	DecN3.c   ***
 ********************/
#include 	"Uigp/igp.h"




#include	"DecIn.h"
#include	"Coding/CodingN3.h"




void
decoding_n3_huffman( codingN3_type *nc,bst_type *bst_file )
{
	nc->Nwidth.cst = decoding_agp_file_cut_huffman_cst( bst_file );
}


void
decoding_n3_width( link_type *link ,codingN3_type *nc)
{
link_type	*l;
width_type	*width;
int	cno;
float	tmp;


	for( l = LINK_NEXT(link) ; l != NULL ; l = LINK_NEXT(l) ){

		width = l->width[F_BEGIN];

		cno =  CST_GET_SCHAR( nc->Nwidth.cst );
		tmp = UNZCODE( cno, nc->Nwidth );
		width->w[F_RIGHT] = tmp + nc->Nwidth.a;

		cno =  CST_GET_SCHAR( nc->Nwidth.cst );
		tmp = UNZCODE( cno, nc->Nwidth );
		width->w[F_LEFT] = -(tmp + nc->Nwidth.a);


        	l->pr[0].n3->width[F_RIGHT] = width->w[F_RIGHT];
        	l->pr[0].n3->width[F_LEFT] = -width->w[F_LEFT];
	}
}




void
decoding_n3_close(codingN3_type *nc)
{
	cst_free( nc->Nwidth.cst );
}
