/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/

/**************************
 ***   Ep2BoundValue.c  	***
 **************************/

#include	"Uigp/igp.h"


#include        "EpType/EpType.h"
#include        "Ep2/Ep2Type.h"

#include        "EpBgp/EpBgp.h"

#include        "Ep2In.h"


static void	ep2_bound_value_one( ep2_type *ep2, bound2_type *b2 );


void
ep2_bound_value( ep2_array *aep2, epValue_type *epValue )
{
ep2_type	*ep2;
int     i,      j,	k;

	for( i = 0 ; i < aep2->Ni ; i++ )
		for( j = 0 ; j < aep2->Nj ; j++ ){
			ep2 = &aep2->ep[i][j];

			ep_bgp_mctr_value( ep2->ep[0], epValue );
			if( ep2->ep[1] != NULL )
				ep_bgp_mctr_value( ep2->ep[1], epValue );
			if( ep2->ep[2] != NULL )
				ep_bgp_mctr_value( ep2->ep[2], epValue );
			if( ep2->ep[3] != NULL )
				ep_bgp_mctr_value( ep2->ep[3], epValue );

			for( k = 0 ; k < ep2->b_no ; k++ )
				ep2_bound_value_one( ep2, ep2->bound[k] );
		}
}




static void
ep2_bound_value_one( ep2_type *ep2, bound2_type *b2 )
{
bound_type	*b;
ebgp_type	*bp;
int	i,	bno;
float	w,	tmp;

	b2->val[SP_Y] = b2->val[SP_Q] = b2->val[SP_A] = 0;
	w = 0;


	for( i = 0 ; i < 4 ; i++ ){
		if( ep2->ep[i] == NULL )	continue;
		for( bno = 0 ; bno < ep2->ep[i]->b_no ; bno++ ){

			if( !( b2->Fbound[i] & (1L<< bno) ) ) continue;

			b = ep2->ep[i]->bound[ bno ];
			

			if( b->Mbgp == NULL )	continue;

			/*
			for( bp = b->bgp ; bp != NULL ; bp = bp->p ){
				b2->val[SP_Y] += bp->val[SP_Y];
				b2->val[SP_Q] += bp->val[SP_Q];
				b2->val[SP_A] += bp->val[SP_A];
				w++;
			}
			*/
			bp = b->Mbgp;
			b2->val[SP_Y] += bp->val[SP_Y];
			b2->val[SP_Q] += bp->val[SP_Q];
			b2->val[SP_A] += bp->val[SP_A];
			w++;
		}
	}

	tmp = 1.0/w;

	b2->val[SP_Y] *= tmp;
	b2->val[SP_Q] *= tmp;
	b2->val[SP_A] *= tmp;
}
