/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/

/**************************
 ***   Ep2Br.c  	***
 **************************/

#include	"Uigp/igp.h"


#include        "Ep2In.h"


static void	ep2_br( ep2_array *aep2, int i0, int j0 );



void
aep2_br_set( ep2_array *aep2 )
{
ep2_type *ep2;
int	i,	j,	k;

        for( i = 0 ; i < aep2->Ni ; i++ )
                for( j = 0 ; j < aep2->Nj ; j++ ){
			ep2 = &aep2->ep[i][j];

			for( k = 0 ; k < ep2->b_no ; k++ )
				ep2->bound[k]->br = 1;
		}
}





void
aep2_br( ep2_array *aep2 )
{
int	i,	j;

        for( i = 0 ; i < aep2->Ni ; i++ )
                for( j = 0 ; j < aep2->Nj ; j++ )
			ep2_br( aep2, i, j );
}




static const int	NG[9][2] = {	-1, -1,
				-1,  0,
				-1,  1,
				 0, -1,
				 0,  0,
				 0,  1,
				 1, -1,
				 1,  0,
				 1,  1 };

static void
ep2_br( ep2_array *aep2, int i0, int j0 )
{
ep2_type *ep2,	*nep2;
bound2_type	*b2;
int	i,	j,	k,	n,	nbno;

	ep2 = &aep2->ep[i0][j0];

	for( k = 0 ; k < ep2->b_no ; k++ ){
		b2 = ep2->bound[k];

		if( b2->Sbr == 1 )	continue;

		for( n = 0 ; n < 9 ; n++ ){
			if( n == 4 )	continue;
			if( b2->Fcont[n] == 0 )	continue;

			i = i0 + NG[n][0];
			j = j0 + NG[n][1];
			nep2 = &aep2->ep[i][j];

			for( nbno = 0 ; nbno < nep2->b_no ; nbno++){
                        	if( (b2->Fcont[n] & (1L << nbno)) == 0 )
                                	continue;
				if( nep2->bound[nbno]->Sbr == 0)	continue;

				b2->Sbr = 1;
				b2->br = nep2->bound[nbno]->br;
			}
		}
	}
}
