/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/***************************
 ***	Ep2PrevValue.c   ***
 ***************************/
#include	<stdio.h>

#include	"Uigp/igp.h"

#include	"Ep2/Ep2In.h"


#define	WPF		0.10f


int
ep2_prev_value3( ep2_array *aep2, int i0, int j0, int bno, float val[3] )
{
int	i,	j;
ep2_type *ep2,	*nep2;
bound2_type *b,	*nb;
float	w;
int	fcont;


	ep2 =  &aep2->ep[i0][j0];
	b = ep2->bound[bno];

	val[0] = val[1] = val[2] = 0;
	w = 0;

	nep2 =  ep2 - aep2->NJ-1;

	for( i = 0 ; i < 4 ; i++, nep2++ ){

		if( (fcont = b->Fcont[i]) == 0)	continue;

		if( i == 3 )   nep2 = ep2 - 1;


		for( j = 0 ; fcont != 0 ; fcont >>= 1, j++ ){

			if( !(fcont & 0x01) )	continue;

			nb = nep2->bound[j];


			if( nb->type != B2_OPENED ){
				val[0] += nb->val[0];
				val[1] += nb->val[1];
				val[2] += nb->val[2];
				w += 1;
			}
			else	{
				val[0] += WPF *  nb->val[0];
				val[1] += WPF *  nb->val[1];
				val[2] += WPF *  nb->val[2];
				w += WPF ;
			}
		}
	}

	if( w == 0 )	return( 0 );
	
	w =  1.0f / w;
	val[0] *= w;
	val[1] *= w;
	val[2] *= w;

	return( 1 );
}



#ifndef PLAYER
float
ep2_prev_value( ep2_array *aep2, int i0, int j0, int bno, int sp )
{
int	i,	j;
ep2_type *ep2,	*nep2;
bound2_type *b,	*nb;
float	sumV,	sumW;
int	fcont;


	ep2 =  &aep2->ep[i0][j0];
	b = ep2->bound[bno];

	sumW = sumV = 0;

	nep2 =  ep2 - aep2->NJ-1;

	for( i = 0 ; i < 4 ; i++, nep2++ ){

		if( (fcont = b->Fcont[i]) == 0)	continue;

		if( i == 3 )   nep2 = ep2 - 1;


		for( j = 0 ; fcont != 0 ; fcont >>= 1, j++ ){

			if( !(fcont & 0x01) )	continue;

			nb = nep2->bound[j];


			if( nb->type != B2_OPENED ){
				sumV += nb->val[sp];
				sumW += 1;
			}
			else	{
				sumV += WPF *  nb->val[sp];
				sumW += WPF ;
			}
		}
	}
	
	if( sumW != 0 )
		return( sumV / sumW );

	return( 0 );
}
#endif
