/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**********************
 ***	Ep2Type.h   ***
 **********************/

#ifndef         _EP2_TYPE_
#define         _EP2_TYPE_


#include	"Uigp/igp.h"



#include	"EpType/EpType.h"


#define		MAX_BOUND2	16

/* Macros for bound2_type.type field */

typedef enum { B2_OPENED, B2_CLOSED } B2_TYPE_FLAG;

#define	B2_INDEPENDENT(bound)	((bound).Fcont[0] == 0 && \
				 (bound).Fcont[1] == 0 && \
				 (bound).Fcont[2] == 0 && \
				 (bound).Fcont[3] == 0 ) 



typedef struct ep2Value_type {
	float	h;
	float	h_inv;	// 1.0 /h 

	float	oh;
	float	oh_inv;	// 1.0 /h 

}	ep2Value_type;




typedef struct bound2_type {
	float	val[SP_NO];
	int	no;
	vec2d   Mctr;

	short	br;
	short	Sbr;

	short	Fbound[4];
        u_long  Fcont[9];
	B2_TYPE_FLAG	type;
} bound2_type;




typedef struct ep2_type {
	vec2d		ctr;
	ep_type		*ep[4];


	int		b_no;
	bound2_type	*bound[MAX_BOUND2];
} ep2_type;



typedef struct ep2_array {
	int		bgp;
	float		bgp_inv;

	int		NI,	NJ;
	int		Ni,	Nj;

	ep2Value_type ep2Value;

	char	*data,	*p;

	ep2_type	**ep;
} ep2_array;



#define		AEP2_ALLOC_DATA( aep2, target, type )	\
			{ \
			target = ( type * )aep2->p; \
			aep2->p += sizeof( type ); \
			}


	/* Eptool.c */
ep2_array *	aep2_alloc();

void	aep2_destroy( ep2_array *aep );

void	ep2_array_init(ep2_array * aep2, ep_array *aep );

#endif
