/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef		_HUFFMAN_L_H
#define		_HUFFMAN_L_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include	"Uigp/igp.h"
#include	"Ufbst/FbstType.h"
#include	"Huffman.h"


typedef struct tree_node {
    unsigned int count;			
    unsigned int saved_count;	
    int child_0;				
    int child_1;				
} NODE;

typedef struct code1 {
    unsigned int code;	
    int code_bits;		
} CODE;


#define END_OF_STREAM 256



	/* Huffman.c*/
int huff_build_tree( NODE *nodes );


	/* HuffmanAux.c*/
void	huff_print_model( NODE *nodes, CODE *codes );


	/* HuffmanEncode.c*/
void	huff_convert_tree_to_code( NODE *nodes,
                           CODE *codes,
                           unsigned int code_so_far,
                           int bits,
                           int node );
void	huff_output_counts( fbst_type *obst, NODE *nodes );
void	huff_scale_counts( unsigned long *long_counts, NODE *nodes );
void	huff_output_counts_cst( bst_type *obst, NODE *nodes );


	/* HuffmanDecode.c*/
void	huff_input_counts( bst_type *ibst, NODE *nodes );


#endif
