/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>



#include	"Uigp/igp.h"
#include	"Ucst/CstType.h"



#include	"LossLessCoding.h"

#include	"Huffman.h"
#include	"Rlength.h"
#include	"Bits.h"




cst_type *
lossless_decoding_cst( bst_type * bst, int byte_no, int cotype )
{
cst_type	*cst,	*cst1;

	cst = NULL;

	switch (cotype){
	case 0:
		cst = huffman_decoding_cst( bst, byte_no );
	    break;

	case 1:
		cst1 = huffman_decoding_cst( bst, byte_no );

		cst = rlength_decoding_cst( cst1, cotype );

		cst_free( cst1 );
	    break;

	case 2:
	    break;

	case 3:	/* arithmetic coding */
/*
		cst = AexpandFile_cst( cfd, byte_no );
*/
	    break;

	case 4:
		cst = bitstream_decoding_cst( bst, byte_no );
	    break;

	case 5:
		cst = huffman_decoding_extended_cst( bst, byte_no );
	    break;

	case 0x0e:
		cst = cst_alloc( 1 );
	    break;
	}

	return( cst );
}
