/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include	<stdio.h>

#include	"Uigp/igp.h"

#include	"Ucst/CstType.h"

#include	"Rlength.h"

void 
rlength_decoding( FILE *input, FILE *output, int a )
{
int     c,	i,	no;

	while( (c = getc(input) ) != EOF){
		putc( c, output );

		if( (c > 0 ? c : -c) >= a )	continue;

		no = (u_char)getc(input);
		for( i = 0; i < no; i++)
			putc( c, output );
	}
}


cst_type *
rlength_decoding_cst( cst_type *in_cst, int a )
{
int     c,	i,	j,	no,	msg_no;
cst_type	*cst;

	cst_rewind( in_cst );
	msg_no = 0;
	for( i = 0 ; i < in_cst->byte_no ; i++ ){
		c = CST_GET_UCHAR( in_cst );
		msg_no ++;

		if( (c > 0 ? c : -c) >= a )	continue;

		no = CST_GET_UCHAR( in_cst );
		i++;
		msg_no += no;
	}

	cst = cst_alloc( msg_no );

	cst_rewind( in_cst );
	for( i = 0 ; i < in_cst->byte_no; i++ ){
		c = CST_GET_UCHAR( in_cst );
		CST_PUT_CHAR( cst, c );

		if( (c > 0 ? c : -c) >= a )	continue;

		no = CST_GET_UCHAR( in_cst );
		i++;

		for( j = 0; j < no; j++)
			CST_PUT_CHAR( cst, c );
	}

	return( cst );
}
