/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/******************
 ***   Ep.c  	***
 ******************/

#include <stdio.h>
#include <math.h>

#include	"Uigp/igp.h"
#include        "Uprm/prm.h"


#include        "EpType/EpType.h"

#include        "Ep.h"
#include        "EpIn.h"








void
ep_create( gp_array *agp, int I0, int J0, int Ni, int Nj,
					int mbr, ep_array *aep )
{
ep_type	*ep;
int	i,	j;


	ep_agp_al( agp, I0, J0, Ni, Nj, mbr, aep );


        for( i = JSIZE ; i < aep->Ni-JSIZE ; i++ )
                for( j = JSIZE ; j < aep->Nj-JSIZE ; j++ ){

			ep = &aep->ep[i][j];


			ep_range( ep, aep );


			ep_bound( ep, aep );


			ep_bound_set_fcorner( ep, aep->hbgp );

			ep_cont_init( ep );
		}


        for( i = JSIZE ; i < aep->Ni-JSIZE ; i++ )
                for( j = JSIZE ; j < aep->Nj-JSIZE ; j++ ){
			ep = &aep->ep[i][j];

			ep_cont( ep );
		}
}
