/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*****************
 ***	Ep.h   ***
 *****************/

#ifndef         _EP_H_
#define         _EP_H_

#include	"Uigp/igp.h"
#include        "Uprm/prm.h"


#include	"GpType/GpType.h"

#include	"EpType/EpType.h"


	/* Ep.c */
void	ep_create( gp_array *agp, int I0, int J0, int Ni, int Nj,
						int mbr, ep_array *aep );


	/* EpTool.o */
ep_array *	aep_alloc();
void 		aep_destroy( ep_array *aep );

void	ep_array_init( ep_array *aep, int bgp, int ni, int nj );
void	ep_array_clear( ep_array *aep, int bgp, int Ni, int Nj );
void	ep_array_free( ep_array *aep );



	/* BountPoint.o */
int	ep_bound_point( ep_type *ep, vec2d *v, float *dis );
int	ep_bound_point_br( ep_type *ep, int br, vec2d *v, float *dis );


	/* RangePoint.o */
int	ep_range_is_point_in( ep_type *ep, int rno, vec2d *v );


#endif
