/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/******************
 ***	EpIn.h	***
 ******************/

#ifndef         _EP_IN_
#define         _EP_IN_

#include	"Uigp/igp.h"


#include	"GpType/GpType.h"

#include	"EpType/EpType.h"


	/* ElBes.c */
void	aep_set_el_bes( ep_array *aep );


	/* EpAgp.c */
void	ep_agp_al( gp_array *agp, int I0, int J0, int Ni, int Nj,
                                        int mbr, ep_array *aep );


	/* EpAl.c */
void	aep_al( ep_array *aep );
void     ep_al( vec2d *ctr, el_type *l, ep_array *aep ); 
void	ep_al_1( vec2d *ctr, el_type *l, ep_array *aep );



	/* AlBes.c */
void	al_set_bes( ep_type *ep );



	/* Range.c */
void	ep_range( ep_type *ep, ep_array *aep );

void	ep_range_cross_link( al_type *al, int side,
				ep_type *ep, ep_array *aep );

range_type *range_alloc( ep_type *ep, int rl_no, ep_array *aep );

void	range_free( range_type *r );


	/* RangeRp.c */
void    ep_range_set_rp( ep_type *ep, range_type *r, vec2d *rp, float hbgp );



	/* Bound.c */
void	ep_bound( ep_type *ep, ep_array *aep );

void	ep_bound_set_fcorner( ep_type *ep, float hbgp );

void	ep_bound_set_pixel_no( ep_type *ep, int bgp );




	/* BoundCont.c */
void	ep_cont_init( ep_type *ep );

void	ep_cont( ep_type *ep );



	/* RangePoint.c */
void	ep_range_Frange( ep_type *ep, range_type *r,
				int rno, int Frange[], int Fal[], float hbgp );
int	ep_range_is_point_in( ep_type *ep, int rno, vec2d *v );


#endif
