/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/********************
 ***	EpBgp.h   ***
 ********************/

#ifndef         _EP_BGP_
#define         _EP_BGP_

#include	"Uigp/igp.h"


#include	"GpType/GpType.h"

#include	"EpType/EpType.h"



	/* EpBgpGet.c */
void	ep_bgp_get( gp_array *agp, ep_array *aep );


	/* EpBgpGetAverage.c */
void	ep_bgp_get_average( gp_array *agp, ep_array *aep );
void	ep_bgp_get_average_decoding( gp_array *agp, ep_array *aep );


	/* EpBgpGetBr.c */
void	ep_bgp_get_br( gp_array *agp, int mbr, ep_array *aep );


	/* EpBgpPut.c */
void	ep_bgp_put( gp_array *agp, ep_array *aep, int Fmiddle );



	/* EpBgpPut1.c */
void	ep_bgp_put_1( gp_array *agp, ep_array *aep, int Fprofile );


	/* EpBgpMiddle.c */
int	ep_middle_bgp( ep_type *ep, int bgp_in[4], float hbgp );


	/* EpBgpBoundary.c */
void	ep_bgp_boundray( gp_array *agp, ep_array *aep );


	/* EpBgpMctr.c */
void	ep_bgp_mctr( ep_type *ep, ep_array *aep );

void	ep_bgp_mctr_value( ep_type *ep, epValue_type *epValue );


	/* EpBoundBr.c */
void	aep_br_set( ep_array *aep );
void	aep_br_fill( ep_array *aep );


	/* EpBgpFill.c */
void	aep_bgp_fill( gp_array *agp, ep_array *aep );

	/* EpBgpFillBr.c */
void	aep_bgp_fill_br( gp_array *agp, ep_array *aep, int mbr );

#endif
