/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/

/**************************
 ***   EpBgpBoundary.c 	***
 **************************/

#include <stdio.h>
#include <math.h>

#include	"Uigp/igp.h"
#include        "Uprm/prm.h"


#include        "GpType/GpType.h"

#include        "Ep/Ep.h"
#include        "EpBgp.h"


void
ep_bgp_boundray( gp_array *agp, ep_array *aep )
{
ep_type		*ep;
bound_type	*b;
ebgp_type	*bp;

int	i,	j,	bno;

	if( aep->Ni0 == 1 )
		for( j = JSIZE ; j < aep->Nj-JSIZE ; j++ ){
			ep = &aep->ep[JSIZE][j];

			for( bno = 0 ; bno < ep->b_no ; bno++ ){
				b = ep->bound[bno];
				while( (bp = b->bgp) != NULL ){
					b->bgp = b->bgp->p;
				}
			}
		}


	if( aep->Nj0 == 1 )
		for( i = JSIZE ; i < aep->Ni-JSIZE ; i++ ){
			ep = &aep->ep[i][JSIZE];

			for( bno = 0 ; bno < ep->b_no ; bno++ ){
				b = ep->bound[bno];
				while( (bp = b->bgp) != NULL ){
					b->bgp = b->bgp->p;
				}
			}
		}



	if( aep->Ni0 + aep->Ni-2*LSIZE == agp->Ni-1 )
		for( j = JSIZE ; j < aep->Nj-JSIZE ; j++ ){
			ep = &aep->ep[aep->Ni-1-JSIZE][j];

			for( bno = 0 ; bno < ep->b_no ; bno++ ){
				b = ep->bound[bno];
				while( (bp = b->bgp) != NULL ){
					b->bgp = b->bgp->p;
				}
			}
		}


	if( aep->Nj0 + aep->Nj-2*LSIZE == agp->Nj-1 )
		for( i = JSIZE ; i < aep->Ni-JSIZE ; i++ ){
			ep = &aep->ep[i][aep->Nj-1-JSIZE];

			for( bno = 0 ; bno < ep->b_no ; bno++ ){
				b = ep->bound[bno];
				while( (bp = b->bgp) != NULL ){
					b->bgp = b->bgp->p;
				}
			}
		}
}
