/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/

/**************************
 ***   EpBgpGet.c      	***
 **************************/

#include <stdio.h>
#include <math.h>

#include	"Uigp/igp.h"

#include        "GpType/GpType.h"
#include        "EpType/EpType.h"

#include        "DepthEpIn.h"


static void	depth_ep_bgp_average_one( ep_type *ep );


void
depth_ep_bgp_average( ep_array *aep )
{
int	i,	j;


	for( i = JSIZE ; i < aep->Ni-JSIZE ; i++ )
		for( j = JSIZE ; j < aep->Nj-JSIZE ; j++ ){

			depth_ep_bgp_average_one( &aep->ep[i][j] );

		}
}


static void
depth_ep_bgp_average_one( ep_type *ep )
{
bound_type	*b;

ebgp_type	*bp;

int	n,	bno;

	for( bno = 0 ; bno < ep->b_no ; bno++ ){
		b = ep->bound[bno];
		if( b->bgp == NULL || b->bgp->p == NULL )	continue;


		for( bp = b->bgp->p, n = 1 ; bp != NULL ; bp = bp->p , n++ ){
			b->bgp->ctr.x += bp->ctr.x;
			b->bgp->ctr.y += bp->ctr.y;

			b->bgp->val[SP_Y] += bp->val[SP_Y];
			b->bgp->val[SP_Q] += bp->val[SP_Q];
			b->bgp->val[SP_A] += bp->val[SP_A];
		}

		b->bgp->ctr.x /= n;
		b->bgp->ctr.y /= n;

		b->bgp->val[SP_Y] /= n;
		b->bgp->val[SP_Q] /= n;
		b->bgp->val[SP_A] /= n;

		b->bgp->p = NULL;
	}
}
