/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
	DepthBgpMiddle.c
**************************/


#include	"Uigp/igp.h"

#include	"EpType/EpType.h"
#include	"Ep/Ep.h"
#include	"DepthEpIn.h"




int
depth_ep_middle_bgp( ep_type *ep, int br, int bgp_in[4], float hbgp )
{
bound_type	*b;
vec2d	p;
float	hb;
int	bno,	Bin[4];
float	dis;

	p.x = p.y = 0;
	bno = ep_bound_point_br( ep, br, &p, &dis );
	
	if( bno == -1 ){
		bgp_in[0] = bgp_in[1] = bgp_in[2] = bgp_in[3] = 0;
		return( -1 );
	}

	b = ep->bound[bno];

	p.y = 0;
	p.x = -hbgp;
	Bin[0] = bno == ep_bound_point_br( ep, br, &p, &dis );

	p.y = 0;
	p.x = hbgp;
	Bin[2] = bno == ep_bound_point_br( ep, br, &p, &dis );


	p.x = 0;
	p.y = -hbgp;
	Bin[3] = bno == ep_bound_point_br( ep, br, &p, &dis );

	p.x = 0;
	p.y = hbgp;
	Bin[1] = bno == ep_bound_point_br( ep, br, &p, &dis );

	hb = 0.5 * hbgp;

	if( b->Fcorner & 0x01 && Bin[0] && Bin[3] ){
		p.x = -hb;
		p.y = -hb;
		bgp_in[0] = bno == ep_bound_point_br( ep, br, &p, &dis );
	}
	else	bgp_in[0] = 0;

	if( b->Fcorner & 0x02 && Bin[0] && Bin[1] ){
		p.x = -hb;
		p.y = hb;
		bgp_in[1] = bno == ep_bound_point_br( ep, br, &p, &dis );
	}
	else	bgp_in[1] = 0;



	if( b->Fcorner & 0x04 && Bin[2] && Bin[3] ){
		p.x = hb;
		p.y = -hb;
		bgp_in[2] = bno == ep_bound_point_br( ep, br, &p, &dis );
	}
	else	bgp_in[2] = 0;




	if( b->Fcorner & 0x08 && Bin[1] && Bin[2] ){
		p.x = hb;
		p.y = hb;
		bgp_in[3] = bno == ep_bound_point_br( ep, br, &p, &dis );
	}
	else	bgp_in[3] = 0;


	return( bno );
}
