/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef		_DEPTH_BG_IN_
#define		_DEPTH_BG_IN_

#include	"Uigp/igp.h"

#include	"GpType/GpType.h"

#include	"EpType/EpType.h"


	/* DepthEp.c */

void	depth_ep_create( gp_array *agp,
		int I0, int J0, int Ni, int Nj, ep_array *aep, int Fcomplete );



	/* DepthRange.c */
void	depth_ep_range_branch( ep_type *ep );


	/* DepthBound.c */
void	depth_ep_bound( ep_type *ep, ep_array *aep );

void	depth_ep_bound_set_fcorner( ep_type *ep, float hbgp );


	/* DepthBoundCont.c */
void	depth_ep_cont_init( ep_type *ep );
void	depth_ep_cont( ep_type *ep );

void	depth_ep_cont_bound_corenr( ep_type *ep, ep_type *nep, int cno );


	/* DepthBgpGet.c */
void	depth_ep_bgp_get( gp_array *agp, ep_array *aep );

	/* DepthBgpAverage.c */
void	depth_ep_bgp_average( ep_array *aep );


	/* DepthBgpMiddle.c */
int	depth_ep_middle_bgp( ep_type *ep, int br, int bgp_in[4], float hbgp );



	/* DepthEpComplete.c */
void	depth_ep_complete_intrnal( ep_array *aep, int step );

	/* DepthCompleteNull.o */
void	depth_ep_complete_null( ep_array *aep );
#endif
