/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/

/**************************
 ***   RangeTool.c  	***
 **************************/

#include <stdio.h>
#include <math.h>

#include	"Uigp/igp.h"


#include        "GpType/GpType.h"

#include        "EpType/EpType.h"
#include        "Ep/EpIn.h"

#include        "DepthEpIn.h"

static void	depth_ep_range_branch_one( range_type *r );


void
depth_ep_range_branch( ep_type *ep )
{
range_type	*r;

	for( r = ep->range ; r != NULL ; r = r->nr )
		depth_ep_range_branch_one( r );
}



static void
depth_ep_range_branch_one( range_type *r )
{
link_type	*link;
rlink_type	*rl;

	
	rl = &r->rl[0];
	link = rl->al->link;


	if(link->Fbr == 0x04 )
		r->br.no = ( rl->side == F_RIGHT)? link->br : link->br1;
	else	r->br.no = link->br;

	r->br.depth = link->pr[0].p->depth;

	r->br.flag = ( link->Fbr&(1<<rl->side) )? 1 : 0;
}
