/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/***********************
 ***   BoundType.h   ***
 ***********************/

#ifndef         BOUND_TYPE
#define         BOUND_TYPE

#include	"Uigp/igp.h"


#include	"Uvec/Vec2d.h"

#include	"GpType/BgpType.h"
#include	"GpType/DepthType.h"
#include	"EpType/RangeType.h"

#include	"EpType/EBgpType.h"






/* for bound_type.type */
#define		BOUND_CROSS		0x01
#define		BOUND_ALL		0x08
#define		BOUND_UNSET		0x80


#define		IS_BOUND_UNSET( type )	( type & BOUND_UNSET )

#define		BOUND_SET( type )	( type &= ~BOUND_UNSET )




typedef struct bound_type {
	u_char	type;

	u_char	Fcorner;

	s_char    b2_no;		/* Only for Bg2 */

	ebgp_type	*bgp;
	ebgp_type	*Mbgp;


	range_type	*range;
	short	Frange;

	short	Fcont[9];

	depth_type	br;

} bound_type;

#define         BOUND_ALLOC() \
                        ( (bound_type *)malloc( sizeof( bound_type ) ) )



#endif
