/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*********************
 ***	EpType.h   ***
 *********************/

#ifndef         _EP_TYPE_
#define         _EP_TYPE_

#include	"Uigp/igp.h"


#include	"GpType/GpType.h"

#include	"EpType/ElType.h"


#include	"EpType/AlType.h"


#include	"EpType/RangeType.h"

#include	"EpType/BoundType.h"

#include	"EpType/EpValueType.h"

#define		EP_N		8


/*
#define         LSIZE           5
#define         JSIZE           4
*/
#define         LSIZE           2
#define         JSIZE           1


#define		MAX_BOUND	24
#define		MAX_RANGE	32


typedef struct ep_type {

	vec2d	ctr;

	struct ep_type *ng[9];	/* pointer to neigbure */


//	link_type	*el1;



	al_type		*al;



	int     r_no;
	range_type      *range;


	int	br_no;

	char	corner[4];
	int	b_no;
	bound_type	*bound[MAX_BOUND];
} ep_type;




typedef struct ep_array {
	int	bgp;
	float	bgp_inv;
	float	hbgp;

	int	NI,	NJ;
	int	Ni,	Nj;
	int	BNi,	BNj;

	int	Ni0,	Nj0;
	vec2d	V0;

	epValue_type	epValue;	// value needed for ep_value

	char	*data,	*p;

	ep_type	**ep;
} ep_array;




#define		ALLOC_AEP_DATA( target, type, aep ) \
			{\
			target = ( type * )aep->p; \
			aep->p += sizeof( type );\
			}


#define		ALLOC_AEP_DATA_N( target, type, n, aep ) \
			{ \
			target = ( type * )aep->p; \
			aep->p += sizeof( type ) * n; \
			}


#endif
