/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef		_EP_BG_EXP_H_
#define		_EP_BG_EXP_H_

#include 	"Uprm/prm.h"

#include 	"GpType/GpType.h"

#include 	"EpType/EpType.h"

#define         MAX_BGP_AUX       64


typedef	struct	bgp_aux {
	vec2d	ctr;
	float	val[SP_NO];
}	bgp_aux;



typedef	struct	bgp_aux_box {
	int	no;
	bgp_aux		bgp[MAX_BGP_AUX];
}	bgp_aux_box;



typedef	struct	bound_aux {
	float	v0[SP_NO];
	float	v1[SP_NO];
	float	v2[SP_NO];
	float	v3[SP_NO];
}	bound_aux;



typedef	struct	bound0_aux {
	float	v0[SP_NO];
	float	dy[SP_NO];
	float	dx[SP_NO];
	float	dyx[SP_NO];
}	bound0_aux;



	/* EpValue.c */
void	ep_value_init( int bgp );

float	aep_value( ep_array *aep, vec2d *v, int sp );

float	ep_value( ep_type *ep, vec2d *v, int sp );

float	ep_bound_value( ep_type *ep, int bno, vec2d *v, int sp );



	/* EpValue3.c */

//void	ep_value3_init( int bgp );

int	aep_value3( ep_array *aep, vec2d *v, float val[SP_NO] );

int	ep_value3( epValue_type *epValue, ep_type *ep, vec2d *v, float val[SP_NO] );

int	ep_bound_value3( epValue_type *epValue, ep_type *ep, int bno, vec2d *v, float val[SP_NO] );



	/* EpValueAux.c */
void	ep_bg_expand_set_bgp_aux( ep_type *ep, int bno, bgp_aux_box *baux );

void	ep_bg_expand_set_bgp_aux( ep_type *ep, int bno, bgp_aux_box *baux );


void	ep_bg_expand_set_bound_aux( ep_type *ep, int bno,
					int bgp, bound_aux *baux );
void	ep_bound_aux_value( bound_aux *b, float x, float y, float val[SP_NO] );


void	ep_bg_expand_set_bound0_aux( ep_type *ep,
				int bno, int bgp, bound0_aux *baux );
#endif 
