/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	DepthExp.h	***
 **************************/
  
#ifndef		_DEPTH_EXP_
#define		_DEPTH_EXP_

#include	"Uigp/igp.h"
#include	"ImageType/ImageType.h"


#include	"GpType/GpType.h"


#include	"Xp/XpType.h"
#include	"Zp/ZpType.h"

#include	"SbrType.h"
#include	"Expand/ExpType.h"
#include	"Expand/CpType.h"


//	DepthExp.c


typedef struct expAux_type {
	zp_array        azp;

	exp_array       aexp[MAX_LAYER];

	exp_array       *BAexp[MAX_LAYER_BIT];

	cp_array	acp;
 
	xp_array	*axp;

	sbr_array	*asbr;

	exp_type	Se;

}	expAux_type;



void	depth_expand_init();



expAux_type *	expAux_alloc();

void	expAux_destroy( expAux_type *expA );


void	depth_expand_agp( gp_array  *agp, expAux_type *expA,
			mbr_type Sbr, int color,
			image_type *im );


int	depth_expand_xp( gp_array *agp, xp_array *axp, expAux_type *expA,
				image_type *im, int R0, int C0,
				mbr_type Sbr, mbr_type *sbr, int Fclear );


/*	DepthExpIm.c */

void	depth_expand_agp_image( gp_array *agp, expAux_type *expA,
			mbr_type Sbr, int color, 
			image_type *im, image_type *im_bgrd );

int	depth_expand_xp_image( gp_array *agp, xp_array *axp,
				expAux_type *expA,
				image_type *im, image_type *im_bgrd, int R0, int C0,
				mbr_type Sbr, mbr_type *sbr, int Fclear );

/*	DepthExpTr.c */

void	depth_expand_agp_transparent( gp_array  *agp, expAux_type *expA,
			mbr_type Sbr, int color,
			image_type *im );


int	depth_expand_xp_transparent( gp_array *agp, xp_array *axp, expAux_type *expA,
				image_type *im, int R0, int C0,
				mbr_type Sbr, mbr_type *sbr, int Fclear );

#endif
