/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	DepthExpIn.h	***
 **************************/
  
#ifndef		_DEPTH_EXP_IN_
#define		_DEPTH_EXP_IN_

#include	"Uigp/igp.h"
#include	"Uprm/prm.h"

#include	"GpType/GpType.h"

#include	"Xp/XpType.h"




#include	"Expand/ExpType.h"
#include	"Expand/CpType.h"
#include	"Zp/ZpType.h"



	/* ExpEdgeBr.c */
void	expand_edge_br_init();

void	depth_aexp_edge( xp_array *axp, exp_array *aexp[], mbr_type Mbr );


	/* ExpEdgeB4.c */
void	expand_edge_br0x4_init();

void	expand_edge_br0x4( vec2d *ctr, link_type *l,
					int Fbr, exp_array *aexp );


	/* DepthAexpRidge.c */
void    depth_aexp_ridge( xp_array *axp, exp_array *aexp[], mbr_type Mbr );

	/* DepthAexpHunch.c */
void	depth_aexp_hunch( xp_array *axp, exp_array *aexp[], mbr_type Mbr );




	/* DepthAexpFinal.c */
void	depth_aexp_final_init();

void	depth_aexp_final(exp_array *aexp, zp_array *azp, int br );


	/* DepthAexpBgp.c */
void	depth_aexp_bgp( gp_array *agp, zp_array *azp, int bg,
					exp_array *aexp, cp_array *acp );

	/* DepthAexpBgpEnd.c */
void	depth_aexp_bgp_end( exp_array *aexp, cp_array *acp );

void	depth_aexp_bgp_end_update_dp( zp_array *azp, cp_array *acp, int br );




#endif
