/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	ExpEdgeBr.h	***
 **************************/

#ifndef         _EXP_EDGE_BR_
#define         _EXP_EDGE_BR_

#include        "Uigp/igp.h"
#include        "Uprm/prm.h"

#include        "GpType/GpType.h"


#include        "Expand/FPointType.h"



typedef struct edge_br_aux {
	int	h[SP_NO];

	int	dh[SP_NO];


	int	w,	dw;
	float	len;

	int	Fbr;
}	edge_br_aux;



void	expand_edge_br_init();

void	expand_edge_br_aux( link_type *l, edge_br_aux *ar );

void	expand_edges_br( vec2d *ctr, link_type *l, exp_array *aexp );

void	expand_profile_edge_br( edge_br_aux *ar,
			float t, float  u,
			float val[SP_NO], float *ubg, u_char *Fpr );

#endif
