/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***    SbrInit.c       ***
 **************** *********/

#include        <stdio.h>   

#include        "SbrType.h"


sbr_array *
asbr_alloc()
{
sbr_array	*asbr;

	asbr = (sbr_array *)malloc( sizeof( sbr_array ) );

	asbr->row = asbr->column = 0;
	asbr->Ni = asbr->Nj = 0;
	asbr->no = 0;

	asbr->sbr = NULL;

	return( asbr );
}
	

void
asbr_reset( sbr_array *asbr, int row, int col, int bsize )
{
	if( asbr->row == row && asbr->column == col && asbr->bsize == bsize )
		return;

	asbr->row = row;
	asbr->column = col;

	asbr->bsize = bsize;
	asbr->Ni = (asbr->row + asbr->bsize-1)/asbr->bsize;
	asbr->Nj = (asbr->column + asbr->bsize-1)/asbr->bsize;

	asbr->no = asbr->Ni*asbr->Nj;

	if( asbr->sbr != NULL )	free( asbr->sbr );

	asbr->sbr = ( mbr_type *)calloc( asbr->no, sizeof(mbr_type) );

	asbr->Fclear = 1;
}


void
asbr_clear( sbr_array *asbr, int row, int col, int bsize )
{

	if( asbr->row == row && asbr->column == col && asbr->bsize == bsize ){

		asbr->Fclear = 1;

		return;
	}

	asbr->row = row;
	asbr->column = col;

	asbr->bsize = bsize;
	asbr->Ni = (asbr->row + asbr->bsize-1)/asbr->bsize;
	asbr->Nj = (asbr->column + asbr->bsize-1)/asbr->bsize;

	asbr->no = asbr->Ni*asbr->Nj;

	if( asbr->sbr != NULL )	free( asbr->sbr );

	asbr->sbr = ( mbr_type *)calloc( asbr->no, sizeof(mbr_type) );

	asbr->Fclear = 1;
}


void
asbr_free( sbr_array *asbr )
{
	if( asbr->sbr != NULL ) free( asbr->sbr );

	asbr->row = asbr->column = 0;
	asbr->Ni = asbr->Nj = 0;
	asbr->no = 0;

	asbr->sbr = NULL;
}
