/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	AcpInit.c	***
 *************************/

#include        <stdio.h>   
#include	<math.h>

#include        "CpType.h"


static void	cp_array_alloc( cp_array *acp, int ni, int nj );



void
acp_init( cp_array *acp, int ni, int nj )
{
int     i,      j;
cp_type	*e;

	ni += 3;
	nj += 3;

	if( ni > acp->NI || nj > acp->NJ ){
		acp_free( acp );
		cp_array_alloc( acp, ni, nj );
	}

	acp->Ni = ni;
	acp->Nj = nj;


	for( i = 0 ; i < acp->Ni ; i++ )
	    for( j = 0, e = acp->cp[i] ; j < acp->Nj ; j++, e++ ){
		e->w = 0;
                e->bg_val[SP_Y] = e->bg_val[SP_Q] = e->bg_val[SP_A] = 0;
	    }
}



static void
cp_array_alloc( cp_array *acp, int ni, int nj )
{
int	i; 

	acp->Ni  = acp->NI = ni;
	acp->Nj  = acp->NJ = nj;

	acp->cp = (cp_type **)malloc( acp->Ni * sizeof( cp_type * ) );
 
	acp->cp[0] = (cp_type *)malloc( acp->Ni*acp->Nj *sizeof(cp_type));

	for( i = 0 ; i < acp->Ni-1 ; i++ )
		acp->cp[i+1] = acp->cp[i] + acp->Nj;
}



void
acp_free( cp_array *acp )
{
	if( acp->cp != NULL ){
		if( acp->cp[0] != NULL )
			free( acp->cp[0] );

		free( acp->cp );
	}

	acp->cp = NULL;
 
	acp->NI = acp->NJ = 0;
	acp->Ni = acp->Nj = 0;
}
