/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	AexpBgp.c	***
 *************************/

#include        <stdio.h>   
#include	<math.h>

#include        "ExpIn.h"

#include        "ExpType.h"
#include        "BpType.h"

#include        "CpType.h"


static void	exp_bgp_put_one1( int i0, int j0,
			bgp_type *gp_bgp, int bgp, cp_array *acp );




void
aexp_bgp( gp_array *agp, bp_array *abp, exp_array *aexp, cp_array *acp )
{
gp_type         *gp;
bgp_type	*bgp;
bp_type	*bp;

int     i,      j,      i0,	j0;


	acp_init( acp, abp->Ni-2, abp->Nj-2 );


        for( i = 1, i0 = 0; i < abp->Ni-1 ; i++, i0 += agp->bgp ){
		bp = &abp->bp[i][1];
		gp = &agp->gp[i+abp->Ni0-1][abp->Nj0];

                for( j = 1, j0 = 0; j < abp->Nj-1 ;
				j++, j0 += agp->bgp, gp++, bp++ ){

			if( bp->Fbr == 0 ){
				exp_bgp_put_one1( i, j, gp->bgp, agp->bgp,acp);
				continue;
			}

                        for( bgp = gp->bgp ; bgp != NULL ; bgp = bgp->p )
				exp_bgp_put_one( i0, j0, bgp, aexp, i, j, acp );
                }
	}





	i = 0;
	i0 = 0;
	bp = abp->bp[i];
	gp = &agp->gp[i+abp->Ni0-1][abp->Nj0-1];

	for( j = 0 ; j < abp->Nj ; j++, gp++, bp++ ){

		if( bp->Fbr == 0 ){
			exp_bgp_put_one1( i, j, gp->bgp, agp->bgp,acp);
			continue;
		}
	}


	i = abp->Ni-1;
	bp = abp->bp[i];
	gp = &agp->gp[i+abp->Ni0-1][abp->Nj0-1];

	for( j = 0 ; j < abp->Nj ; j++, gp++, bp++ ){

		if( bp->Fbr == 0 ){
			exp_bgp_put_one1( i, j, gp->bgp, agp->bgp, acp);
			continue;
		}
	}



	j = 0;
        for( i = 1; i < abp->Ni-1 ; i++ ){
		bp = abp->bp[i];
		gp = &agp->gp[i+abp->Ni0-1][abp->Nj0-1];

		if( bp->Fbr == 0 ){
			exp_bgp_put_one1( i, j, gp->bgp, agp->bgp, acp);
			continue;
		}
	}


	j =  abp->Nj-1;
        for( i = 1 ; i < abp->Ni-1 ; i++ ){
		bp = &abp->bp[i][j];
		gp = &agp->gp[i+abp->Ni0-1][j+abp->Nj0-1];

		if( bp->Fbr == 0 ){
			exp_bgp_put_one1( i, j, gp->bgp, agp->bgp, acp);
			continue;
		}
	}
}




void
exp_bgp_put_one( int i0, int j0, bgp_type *bp, exp_array *aexp, int ic, int jc, cp_array *acp )
{
int	i1,	j1;
int	i,	j,	wi,	wj,	wi1,	wj1,	w,	flag;
exp_type	*e;
int   val[SP_NO];
int	bgp;
cp_type	*cp0,	*cp1,	*cp2,	*cp3;

float	hbgp;

	bgp = aexp->bgp;
	hbgp = bgp>>1;

	wi = (int)(bp->ctr.x+hbgp);
	wj = (int)(bp->ctr.y+hbgp);
	i1 = i0 + wi;
	j1 = j0 + wj;

	e = &aexp->exp[i1][j1];

	if( e->Fbg != 0 )	return;
/*
	e->bg_val[SP_Y] = val[SP_Y];
	e->bg_val[SP_Q] = val[SP_Q];
	e->bg_val[SP_A] = val[SP_A];
	e->Fbg = 1;
*/

	cp0 = &acp->cp[ic][jc];
        cp1 = cp0+1;
        cp2 = cp0 + acp->NJ;
        cp3 = cp2+1;


#ifdef  QFLOAT
        val[SP_Y] = QCOLOR2F( bp->val[SP_Y] ) * V_FPF;
        val[SP_Q] = QCOLOR2F( bp->val[SP_Q] ) * V_FPF;
        val[SP_A] = QCOLOR2F( bp->val[SP_A] ) * V_FPF;
#endif
 
#ifdef  QSHORT 
        val[SP_Y] = ((int)bp->val[SP_Y]) << ( V_SFP - COLOR_SFP);
        val[SP_Q] = ((int)bp->val[SP_Q]) << ( V_SFP - COLOR_SFP);
        val[SP_A] = ((int)bp->val[SP_A]) << ( V_SFP - COLOR_SFP);
#endif





	wi1 = bgp-wi;
	wj1 = bgp-wj;



	

	flag = 0;
	if( aexp->exp[i0][j0].Fbg == 1 )	flag |= 0x01;
	if( aexp->exp[i0][j0+bgp].Fbg == 1 )	flag |= 0x02;
	if( aexp->exp[i0+bgp][j0].Fbg == 1 )	flag |= 0x04;
	if( aexp->exp[i0+bgp][j0+bgp].Fbg == 1 )	flag |= 0x08;

	if( flag == 0x0f )	return;

	for( i = i1-1 ; i > i0 ; i-- )
		if( aexp->exp[i][j1].Fbg != 0 ) break;


	if( i == i0 && aexp->exp[i0][j1].Fbg == 0 ){

		
		if( !( flag & 0x01 ) ){
			for( j = j1 ; j > j0 ; j-- )
				if( aexp->exp[i0][j].Fbg != 0 ) break;

			if( j == j0 ){
				w = MAX( wi1, wj1 );
				cp0->bg_val[SP_Y] += w * val[SP_Y];
				cp0->bg_val[SP_Q] += w * val[SP_Q];
				cp0->bg_val[SP_A] += w * val[SP_A];
				cp0->w += w;
				flag |= 0x01;
			}
		}


		if( !( flag & 0x02 ) ){
			for( j = j1 ; j < j0+bgp ; j++ )
				if( aexp->exp[i0][j].Fbg != 0 ) break;

			if( j == j0+bgp ){
				w = MAX( wi1, wj );
				cp1->bg_val[SP_Y] += w * val[SP_Y];
				cp1->bg_val[SP_Q] += w * val[SP_Q];
				cp1->bg_val[SP_A] += w * val[SP_A];
				cp1->w += w;
				flag |= 0x02;
			}
		}
	}

	if( flag == 0x0f )	return;


	for( i = i1+1 ; i < i0+bgp ; i++ )
		if( aexp->exp[i][j1].Fbg != 0 ) break;


	if( i == i0+bgp && aexp->exp[i0+bgp][j1].Fbg == 0 ){

		
		if( !( flag & 0x04 ) ){
			for( j = j1 ; j > j0 ; j-- )
				if( aexp->exp[i0+bgp][j].Fbg != 0 ) break;

			if( j == j0 ){
				w = MAX( wi, wj1 );
				cp2->bg_val[SP_Y] += w * val[SP_Y];
				cp2->bg_val[SP_Q] += w * val[SP_Q];
				cp2->bg_val[SP_A] += w * val[SP_A];
				cp2->w += w;
				flag |= 0x04;
			}
		}


		if( !( flag & 0x08 ) ){
			for( j = j1 ; j < j0+bgp ; j++ )
				if( aexp->exp[i0+bgp][j].Fbg != 0 ) break;

			if( j == j0+bgp ){
				w = MAX( wi, wj );
				cp3->bg_val[SP_Y] += w * val[SP_Y];
				cp3->bg_val[SP_Q] += w * val[SP_Q];
				cp3->bg_val[SP_A] += w * val[SP_A];
				cp3->w += w;
				flag |= 0x08;
			}
		}
	}

	if( flag == 0x0f )	return;




	if( !( flag & 0x01 ) && !( flag & 0x04 ) ){
		for( j = j1-1 ; j > j0 ; j-- )
			if( aexp->exp[i1][j].Fbg != 0 ) break;


		if( j == j0 && aexp->exp[i1][j0].Fbg == 0 ){

		
			if( !( flag & 0x01 ) ){
				for( i = i1 ; i > i0 ; i-- )
					if( aexp->exp[i][j0].Fbg != 0 ) break;

				if( i == i0 ){
					w = MAX( wi1, wj1 );
					cp0->bg_val[SP_Y] += w * val[SP_Y];
					cp0->bg_val[SP_Q] += w * val[SP_Q];
					cp0->bg_val[SP_A] += w * val[SP_A];
					cp0->w += w;
					flag |= 0x01;
				}
			}


			if( !( flag & 0x04 ) ){
				for( i = i1 ; i < i0+bgp ; i++ )
					if( aexp->exp[i][j0].Fbg != 0 ) break;
	
				if( i == i0+bgp ){
					w = MAX( wi, wj1 );
					cp2->bg_val[SP_Y] += w * val[SP_Y];
					cp2->bg_val[SP_Q] += w * val[SP_Q];
					cp2->bg_val[SP_A] += w * val[SP_A];
					cp2->w += w;
					flag |= 0x04;
				}
			}
		}
	}

	if( flag == 0x0f )	return;


	if( !( flag & 0x02 ) && !( flag & 0x08 ) ){
		for( j = j1+1 ; j < j0+bgp ; j++ )
			if( aexp->exp[i1][j].Fbg != 0 ) break;


		if( j == j0 && aexp->exp[i1][j0+bgp].Fbg == 0 ){

		
			if( !( flag & 0x02 ) ){
				for( i = i1 ; i > i0 ; i-- )
					if( aexp->exp[i][j0+bgp].Fbg != 0 )
						break;

				if( i == i0 ){
					w = MAX( wi1, wj );
					cp1->bg_val[SP_Y] += w * val[SP_Y];
					cp1->bg_val[SP_Q] += w * val[SP_Q];
					cp1->bg_val[SP_A] += w * val[SP_A];
					cp1->w += w;
					flag |= 0x02;
				}
			}

	
			if( !( flag & 0x08 ) ){
				for( i = i1  ; i < i0+bgp ; i++ )
					if( aexp->exp[i][j0+bgp].Fbg != 0 )
						break;
	
				if( i == i0+bgp ){
					w = MAX( wi, wj );
					cp3->bg_val[SP_Y] += w * val[SP_Y];
					cp3->bg_val[SP_Q] += w * val[SP_Q];
					cp3->bg_val[SP_A] += w * val[SP_A];
					cp3->w += w;
					flag |= 0x08;
				}
			}
		}
	}
}





static void
exp_bgp_put_one1( int i0, int j0, bgp_type *gp_bgp, int bgp, cp_array *acp )
{
int	wi,	wj;
int	w0,	w1,	w2,	w3;
bgp_type	*b;
int   val[SP_NO];
cp_type	*be[4];
float	hbgp = bgp>>1;


	be[0] = &acp->cp[i0][j0];
        be[1] = be[0]+1;
        be[2] = be[0] + acp->NJ;
        be[3] = be[2]+1;


	for( b = gp_bgp ; b != NULL ; b = b->p ){

#ifdef  QFLOAT
                val[SP_Y] = QCOLOR2F( b->val[SP_Y]) * V_FPF;
                val[SP_Q] = QCOLOR2F( b->val[SP_Q]) * V_FPF;
                val[SP_A] = QCOLOR2F( b->val[SP_A]) * V_FPF;
#endif 

#ifdef  QSHORT
		val[SP_Y] = ((int)b->val[SP_Y]) << ( V_SFP - COLOR_SFP);
		val[SP_Q] = ((int)b->val[SP_Q]) << ( V_SFP - COLOR_SFP);
		val[SP_A] = ((int)b->val[SP_A]) << ( V_SFP - COLOR_SFP);
#endif 

		wi = (int)(b->ctr.x+hbgp);
		wj = (int)(b->ctr.y+hbgp);



		if( wi < wj ){
			w0 = bgp-wi;
			w3 = wj;
		}
		else	{
			w0 = bgp-wj;
			w3 = wi;
		}

		if( (w1 = bgp - wi) < wj ){
			w1 = wj;
			w2 = wi;
		}
		else	w2 = bgp - wj;


		be[0]->bg_val[SP_Y] += w0 * val[SP_Y];
		be[0]->bg_val[SP_Q] += w0 * val[SP_Q];
		be[0]->bg_val[SP_A] += w0 * val[SP_A];
		be[0]->w += w0;


		be[1]->bg_val[SP_Y] += w1 * val[SP_Y];
		be[1]->bg_val[SP_Q] += w1 * val[SP_Q];
		be[1]->bg_val[SP_A] += w1 * val[SP_A];
		be[1]->w += w1;


		be[2]->bg_val[SP_Y] += w2 * val[SP_Y];
		be[2]->bg_val[SP_Q] += w2 * val[SP_Q];
		be[2]->bg_val[SP_A] += w2 * val[SP_A];
		be[2]->w += w2;

		be[3]->bg_val[SP_Y] += w3 * val[SP_Y];
		be[3]->bg_val[SP_Q] += w3 * val[SP_Q];
		be[3]->bg_val[SP_A] += w3 * val[SP_A];
		be[3]->w += w3;
	}
}
