/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***    AexpBgp.c       ***
 *************************/

#include	<stdio.h>
#include	<math.h>

#include	"ExpIn.h"

#include	"ExpType.h"
#include	"BpType.h"

#include	"CpType.h"




void
aexp_bgp_end( exp_array *aexp, cp_array	*acp )
{
exp_type	*e0,	*e1,	*eend,	*e;
cp_type	*cp,	*cp1,	*cp0;
int	i,	j,	w,	bgp,	i0;
int	algin,	algin_bgp;
float	t;

	bgp = aexp->bgp;

	algin = aexp->NJ;
	algin_bgp = bgp*algin;


	cp0 = &acp->cp[1][1];
	eend =  &aexp->exp[0][aexp->Nj-1];
	for( i = 0 ; i < aexp->Ni ; i += bgp, eend += algin_bgp ){

		cp = cp0;
		cp0 += acp->NJ;

		for( e0 = aexp->exp[i] ; e0 != eend ; e0 += bgp, cp++ ){

			e1 = e0 + bgp;

			for( e = e0 + 1, w = bgp-1 ;
					e->Fbg != 1 && e != e1 ; e++, w-- );
			if( e == e1 )	continue;

			if( e0->Fbg == 0 ){
				cp->bg_val[SP_Y] +=
						w * EXP_IMAGE_RED(e->bg_val);
				cp->bg_val[SP_Q] +=
						w * EXP_IMAGE_GREEN(e->bg_val);
				cp->bg_val[SP_A] +=
						w * EXP_IMAGE_BLUE(e->bg_val);
				cp->w += w;
			}

			if( e1->Fbg == 1 )	continue;
			for( e = e1 - 1, w = bgp-1 ; e->Fbg != 1 ; e--, w-- );

			cp1 = cp+1;
			cp1->bg_val[SP_Y] += w * EXP_IMAGE_RED( e->bg_val );
			cp1->bg_val[SP_Q] += w * EXP_IMAGE_GREEN(e->bg_val );
			cp1->bg_val[SP_A] += w * EXP_IMAGE_BLUE(e->bg_val );
			cp1->w += w;
		}
	}


	eend =  &aexp->exp[aexp->Ni-1][0];
	cp0 = &acp->cp[1][1];
	for( j = 0 ; j < aexp->Nj ; j += bgp, eend += bgp ){

		cp = cp0;
		cp0++;
		for( e0 = &aexp->exp[0][j] ; e0 != eend ;
					e0 += algin_bgp, cp += acp->NI ){

			e1 = e0 + algin_bgp;

			for( e = e0 + algin, w = bgp-1 ;
				e->Fbg != 1 && e != e1 ; e += algin, w-- );
			if( e == e1 )	continue;

			if( e0->Fbg == 0 ){
				cp->bg_val[SP_Y] +=
						w * EXP_IMAGE_RED( e->bg_val );
				cp->bg_val[SP_Q] +=
						w * EXP_IMAGE_GREEN( e->bg_val);
				cp->bg_val[SP_A] +=
						w * EXP_IMAGE_BLUE( e->bg_val );
				cp->w += w;
			}

			if( e1->Fbg == 1 )	continue;

			for( e = e1 - algin, w = bgp-1 ;
					e->Fbg != 1 ; e -= algin, w-- );

			cp1 = cp + acp->NI;
			cp1->bg_val[SP_Y] += w * EXP_IMAGE_RED( e->bg_val );
			cp1->bg_val[SP_Q] += w * EXP_IMAGE_GREEN(e->bg_val );
			cp1->bg_val[SP_A] += w * EXP_IMAGE_BLUE(e->bg_val );
			cp1->w += w;
		}
	}




	for( i = 0, i0 = 1 ; i < aexp->Ni ; i += bgp, i0++ ){
		e = &aexp->exp[i][0];
		cp = &acp->cp[i0][1];
		for( j = 0 ; j < aexp->Nj ; j += bgp, e += bgp, cp++ ){
			if( e->Fbg == 1 )	continue;
/*
			if( cp->w == 0 )	continue;
*/
			if( cp->w == 0 ){
				e->bg_val = 0x008080;
					/* 32896 = 128.5 * 256 */
				e->Fbg = 1;
				continue;
			}


			t = 1.0 / cp->w;
			cp->bg_val[SP_Y] *= t;
			cp->bg_val[SP_Q] *= t;
			cp->bg_val[SP_A] *= t;

			e->bg_val = EXP_IMAGE4_RGB( cp->bg_val[SP_Y],
                                                cp->bg_val[SP_Q],
                                                cp->bg_val[SP_A] );
			e->Fbg = 1;
		}
	}
}



/*
static void
aexp_final1(exp_array *aexp, int i0, int j0, int bgp )
{
int	i,	j,	w;
exp_type	*e,	*ne;
float	t;

	e = &aexp->exp[i0][j0];
	if( e->Fbg != 0 )	return;


	for( i = i0, w = 0 ; i > i0 -bgp ; i--, w++ )
		if( aexp->exp[i][j0].Fbg != 0 ) break;

	if( i != i0 -bgp ){
		ne = &aexp->exp[i][j0];

		e->bg_val[SP_Y] += w * ne->bg_val[SP_Y];
		e->bg_val[SP_Q] += w * ne->bg_val[SP_Q];
		e->bg_val[SP_A] += w * ne->bg_val[SP_A];
		e->w += w;
	}


	for( i = i0, w = 0 ; i < i0 +bgp ; i++, w++ )
		if( aexp->exp[i][j0].Fbg != 0 ) break;

	if( i != i0 +bgp ){
		ne = &aexp->exp[i][j0];

		e->bg_val[SP_Y] += w * ne->bg_val[SP_Y];
		e->bg_val[SP_Q] += w * ne->bg_val[SP_Q];
		e->bg_val[SP_A] += w * ne->bg_val[SP_A];
		e->w += w;
	}


	for( j = j0, w = 0 ; j > j0 -bgp ; j--, w++ )
		if( aexp->exp[i0][j].Fbg != 0 ) break;

	if( j != j0 -bgp ){
		ne = &aexp->exp[i0][j];

		e->bg_val[SP_Y] += w * ne->bg_val[SP_Y];
		e->bg_val[SP_Q] += w * ne->bg_val[SP_Q];
		e->bg_val[SP_A] += w * ne->bg_val[SP_A];
		e->w += w;
	}


	for( j = j0, w = 0 ; j < j0 +bgp ; j++, w++ )
		if( aexp->exp[i0][j].Fbg != 0 ) break;

	if( j != j0 +bgp ){
		ne = &aexp->exp[i0][j];

		e->bg_val[SP_Y] += w * ne->bg_val[SP_Y];
		e->bg_val[SP_Q] += w * ne->bg_val[SP_Q];
		e->bg_val[SP_A] += w * ne->bg_val[SP_A];
		e->w += w;
	}

	t = Winv[e->w];
	e->bg_val[SP_Y] *= t;
	e->bg_val[SP_Q] *= t;
	e->bg_val[SP_A] *= t;
	e->Fbg = 1;
}
*/
