/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	AexpEdge.c	***
 *************************/


#include	"Uigp/igp.h"

#include	"ExpType.h"

#include	"ExpEdge.h"

#include	"ExpIn.h"



void
aexp_edge( xp_array *axp, exp_array *aexp )
{
xp_type		*xp;
link_type	*link;
vec2d	ctr;
int	i,	 j;


	for( i = 0 ; i < axp->Ni ; i++ ){
	    xp = &axp->xp[i][0];
	    for( j = 0 ; j < axp->Nj ; j++, xp++ ){

		for( link = xp->link ; link != NULL ; link = link->cln ){

			ctr.x = link->ctr.x + xp->ctr.x;
			ctr.y = link->ctr.y + xp->ctr.y;

			expand_edges( &ctr, link, aexp );
		}
	    }
	}
}
