/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	AexpHunch.c	***
 **************************/


#include	"Uigp/igp.h"


#include	"ExpIn.h"


void
aexp_hunch( xp_array *axp, exp_array *aexp )
{
xp_type *xp;
hunch_type *h;
vec2d   ctr;
int     i,	j,	i0,	j0,	i1,	j1;

        i0 = JXP;
        i1 = axp->Ni-JXP;

        j0 = JXP;
        j1 = axp->Nj-JXP;

        for( i = i0 ; i < i1 ; i++ ){
            xp = &axp->xp[i][j0];
            for( j = j0 ; j < j1 ; j++, xp++ ){

		for( h = xp->hunch ; h != NULL ; h = h->nh ){

                        ctr.x = h->ctr.x + xp->ctr.x;
                        ctr.y = h->ctr.y + xp->ctr.y;


			if( h->type == NF_HUNCH )
				expand_hunchs( &ctr, h, aexp );
			else    expand_rhs( &ctr, h, aexp );
		}
	    }
	}
}
