/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	AbpEdge.c	***
 **************** *********/
#include        <stdio.h>   

#include        "ExpIn.h"
#include        "BpType.h"


static void	abp_edge_one( vec2d *ctr, link_type *l, bp_array *abp );

void
abp_edge( xp_array *axp, bp_array *abp )
{
xp_type	*xp;
link_type	*link;
vec2d	ctr;
int	i,	j;

	abp_init( abp, axp->BNi, axp->BNj );

	abp->bgp = axp->bgp;
	abp->bgp_inv = axp->bgp_inv;

	abp->Ni0 = axp->Ni0;
	abp->Nj0 = axp->Nj0;



	for( i = 0 ; i < axp->Ni ; i++ ){
	    xp = &axp->xp[i][0];
	    for( j = 0 ; j < axp->Nj ; j++, xp++ ){


		for( link = xp->link ; link != NULL ; link = link->cln ){

			ctr.x = link->ctr.x + xp->ctr.x;
			ctr.y = link->ctr.y + xp->ctr.y;

			abp_edge_one( &ctr, link, abp );
		}
	    }
	}
}



static void
abp_edge_one( vec2d *ctr, link_type *l, bp_array *abp )
{
float	t,	h;
vec2d	v,	p;
int	i0,	j0;

	v.x = ctr->x + abp->bgp;
	v.y = ctr->y + abp->bgp;


	i0 = v.x * abp->bgp_inv;
	j0 = v.y * abp->bgp_inv;

	if( i0 >= 0 && i0 < abp->Ni && j0 >= 0 && j0 < abp->Nj )
		abp->bp[i0][j0].Fbr = 1;


	p.x = v.x + l->v.x;
	p.y = v.y + l->v.y;
	i0 = p.x * abp->bgp_inv;
	j0 = p.y * abp->bgp_inv;

	if( i0 >= 0 && i0 < abp->Ni && j0 >= 0 && j0 < abp->Nj )
		abp->bp[i0][j0].Fbr = 1;


	for( t = 4 ; t < l->len ; t+= 4.0 ){

		h = l->c_prb * t * (t - l->len);
		p.x = v.x  +  t * -l->u.y  +  h * l->u.x;
		p.y = v.y  +  t *  l->u.x  +  h * l->u.y;

		i0 = p.x * abp->bgp_inv;
		j0 = p.y * abp->bgp_inv;

		if( i0 < 0 || i0 >= abp->Ni )	continue;
		if( j0 < 0 || j0 >= abp->Nj )	continue;

		abp->bp[i0][j0].Fbr = 1;
	}
}
