/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***    AbpInit.c       ***
 **************** *********/

#include        <stdio.h>   
#include        "BpType.h"


static void	bp_array_alloc( bp_array *abp, int ni, int nj );



void
abp_init( bp_array *abp, int ni, int nj )
{
int     i,      j;
bp_type	*e;

	ni += 2;
	nj += 2;

	if( ni > abp->NI || nj > abp->NJ ){
		abp_free( abp );
		bp_array_alloc( abp, ni, nj );
	}

	abp->Ni = ni;
	abp->Nj = nj;


	for( i = 0 ; i < abp->Ni ; i++ )
	    for( j = 0, e = abp->bp[i] ; j < abp->Nj ; j++, e++ ){

		e->Fbr = 0;
	    }
}



static void
bp_array_alloc( bp_array *abp, int ni, int nj )
{
int	i; 

	abp->Ni  = abp->NI = ni;
	abp->Nj  = abp->NJ = nj;

        abp->bp = (bp_type **)malloc( abp->Ni * sizeof( bp_type * ) );
 
        abp->bp[0] = (bp_type *)malloc( abp->Ni*abp->Nj *sizeof(bp_type));
 
        for( i = 0 ; i < abp->Ni-1 ; i++ )
                abp->bp[i+1] = abp->bp[i] + abp->Nj;
}



void
abp_free( bp_array *abp )
{

        if( abp->bp != NULL ){
                if( abp->bp[0] != NULL )
                        free( abp->bp[0] );
 
                free( abp->bp );
		abp->bp = NULL;
        } 

 
	abp->NI = abp->NJ = 0;
	abp->Ni = abp->Nj = 0;
}
