/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***       ExpEpBg.c	***
 **************************/

#include        <stdio.h>   
#include	<math.h>

#include        "Expand.h"

#include        "ExpIn.h"


#include	"ExpType.h"




static void	aexp_bg_to_pixel( exp_array *aexp,
				image_type *im, int R0, int C0 );




extern exp_array	Aexp;
extern bp_array		Abp;
extern cp_array		Acp;

void
expand_xp_bg( gp_array *agp, xp_array *axp, image_type *im, int R0, int C0 )
{

	aexp_init( &Aexp, axp->Pi, axp->Pj, axp->bgp, NULL );


	aexp_edge( axp, &Aexp );


	abp_edge( axp, &Abp );


	aexp_bgp( agp, &Abp, &Aexp, &Acp );

	aexp_final( &Aexp, &Acp );


	aexp_bg_to_pixel( &Aexp, im, R0, C0 );
}




static void
aexp_bg_to_pixel( exp_array *aexp, image_type *im, int R0, int C0 )
{
int	i,	j;
int	algin,	algin_e,	ni,	nj;
register u_int *y_ptr;
 
exp_type	*e;
 
 
	nj = aexp->Nj-1;
	ni = aexp->Ni-1;
 
	if( C0 + nj > IMAGE_COLUMN(im) )	nj = IMAGE_COLUMN(im) - C0;
	if( R0 + ni > IMAGE_ROW(im) )		ni = IMAGE_ROW(im)-R0;
 
	y_ptr = ((u_int *)im->data) + R0 * im->column + C0;
	algin = im->column - nj;
 
	algin_e = aexp->NJ - nj;



	e = aexp->exp[0];
	for( i = 0 ; i < ni ; i++, y_ptr += algin, e += algin_e ){

		for( j = 0 ; j < nj ; j++, e++ ){


			*y_ptr++ = e->bg_val;
		}
	}
}
