/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	ExpEdge.h	***
 **************************/

#ifndef         _EXP_EDGE_
#define         _EXP_EDGE_

#include        "Uigp/igp.h"

#include        "GpType/GpType.h"

#include        "ExpType.h"



typedef struct edge_aux {
	int	h0[SP_NO];
	int	h1[SP_NO];

	int	ah0[SP_NO];
	int	ah1[SP_NO];


	int	w,	dw;
	float	len;
	float	len_inv;

}	edge_aux;



typedef struct  eval_type {
        int     val[SP_NO];
        int     dval[SP_NO];

        int     flag;

} eval_type;



void	expand_edge_init();

void	expand_edge_aux( link_type *l, edge_aux *ar );

void	expand_edges( vec2d *ctr, link_type *l, exp_array *aexp );

void	expand_profile_edge( edge_aux *ar,
			int t, int  u, int val[SP_NO], int *ubg );

#endif
