/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/******************
 ***	ExpIn.h	***
 ******************/
  
#ifndef		_EXP_IN_
#define		_EXP_IN_

#include	"Uigp/igp.h"
#include	"Uprm/prm.h"

#include	"GpType/GpType.h"

#include	"Xp/XpType.h"



#include	"ExpType.h"
#include	"BpType.h"

#include	"CpType.h"



	/* AexpEdge.c */
void	aexp_edge( xp_array *axp, exp_array *aexp );


	/* AexpRidge.c */
void    aexp_ridge( xp_array *axp, exp_array *aexp );



	/* AexpHunch.c */
void	aexp_hunch( xp_array *axp, exp_array *aexp );



	/* ExpHunch.c */
void	expand_hunch_get_prm(GP_prm **prm, int *prm_no, void (**check)());

void	expand_hunch_set_lprm();

void	expand_hunchs( vec2d *ctr, hunch_type *h, exp_array *aexp );

void	expand_hunch( vec2d *ctr, hunch_type *h, vec2d *p,
					float val[], float *ubg );



	/* ExpRHunch.c */

void	expand_rh_get_prm(GP_prm **prm, int *prm_no, void (**check)());

void	expand_rh_set_lprm();

void	expand_rh( vec2d *ctr, hunch_type  *h, vec2d *p,
					float val[], float *ubg );

void	expand_rhs( vec2d *ctr, hunch_type *h, exp_array *aexp );




	/* ExpNf.c */

int	expand_nf_edge( vec2d *ctr, link_type *link, vec2d *v,
			float val[], float *ubg );

int	expand_nf_n3( vec2d *ctr, link_type *link, vec2d *v,
			float val[], float *ubg );

int	expand_nf_ridge( vec2d *ctr, link_type *link, vec2d *v,
			float val[], float *ubg );

int	expand_nf_hunch( vec2d *ctr, hunch_type *hunch, vec2d *v,
			float val[], float *ubg );

int	expand_nf_rh( vec2d *ctr, hunch_type *hunch, vec2d *v,
			float val[], float *ubg );



	/* AexpFinal.c */
void	aexp_final_init();

void	aexp_final( exp_array *aexp, cp_array *acp );


	/* AexpBgp.c */
void	aexp_bgp( gp_array *agp, bp_array *bp, exp_array *aexp, cp_array *acp );
void	exp_bgp_put_one( int i0, int j0, bgp_type *bp,
			exp_array *aexp, int ic, int jc, cp_array *acp );


	/* AexpBgp.c */
void	aexp_bgp_end( exp_array *aexp, cp_array	*acp );

	/* BpEdge.c */
void	abp_edge( xp_array *axp, bp_array *abp );


	/* LinkBes.c */
int	link_bes( link_type *link );

#endif
