/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	ExpType.h	***
 **************************/
  
#ifndef		_EXP_TYPE_
#define		_EXP_TYPE_

#include	"Uigp/igp.h"
#include	"Ubox/Box2d.h"

#include	"GpType/GpType.h"


#include	"FPointType.h"


#define		EXP_M		5

typedef struct  exp_type {

	int	u;


	u_char	Fbg,	Fpr;
	short	ubg;

	int	bg_val;
	int	val;



}	exp_type;



typedef struct exp_array {
    int     bgp;
    float   bgp_inv;
    int     Ni,     Nj;
    int     NI,     NJ;

	int	Ni0,	Nj0;	/* index in agp */

	int	pixel;		/* Ni*Nj */

	int	i0,	i1,	j0,	j1;

	mbr_type	mbr;
	

	exp_type **exp;
} exp_array;




#ifdef WIN32
#define         EXP_IMAGE4_RGB( r, g, b ) \
				((((r)&0xff00)<<8) | ((g)&0xff00) | ((b)>>8) )

#define		EXP_IMAGE_RED(pixel)	((pixel>>8)&0x00ff00)
#define		EXP_IMAGE_GREEN(pixel)	((pixel)&0x00ff00)
#define		EXP_IMAGE_BLUE(pixel)	((pixel<<8) &0x00ff00)
#endif




#ifdef __linux 
#define         EXP_IMAGE4_RGB( r, g, b ) \
				((((r)&0xff00)<<8) | ((g)&0xff00) | ((b)>>8) )

#define		EXP_IMAGE_RED(pixel)	((pixel>>8)&0x00ff00)
#define		EXP_IMAGE_GREEN(pixel)	((pixel)&0x00ff00)
#define		EXP_IMAGE_BLUE(pixel)	((pixel<<8) &0x00ff00)

#endif



#ifdef PALMOS
#define         EXP_IMAGE4_RGB( r, g, b ) \
			(((int)((b)&0xff00)<<8) | ((g)&0xff00) | ((r)>>8) )                             
#define		EXP_IMAGE_BLUE(pixel)	(((int)(pixel)>>8)&0x00ff00)

#define		EXP_IMAGE_GREEN(pixel)	(((int)(pixel))&0x00ff00)

#define		EXP_IMAGE_RED(pixel)	(((int)(pixel<<8)) &0x00ff00)

#endif



#ifndef	EXP_IMAGE4_RGB
#define         EXP_IMAGE4_RGB( r, g, b ) \
			(((int)((b)&0xff00)<<8) | ((g)&0xff00) | ((r)>>8) )                             

#define		EXP_IMAGE_BLUE(pixel)	((pixel>>8)&0x00ff00)

#define		EXP_IMAGE_GREEN(pixel)	((pixel)&0x00ff00)

#define		EXP_IMAGE_RED(pixel)	((pixel<<8) &0x00ff00)
#endif






void	aexp_init( exp_array *aexp, int ni, int nj, int bgp, box2i *box );

void	aexp_free( exp_array *aexp );


#endif
