/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	FPointType.h	***
 *************************/

#ifndef FPOINT_TYPE
#define FPOINT_TYPE


/*============= constants for fixed point =============*/


#define EXP_SFP		8	/* shift for fixed point        */

#define EXP_0p5FP	128	/* 0.5 for fixed point */
#define EXP_FP		256	/* 1<<EXP_SFP : 1 for fixed point */

#define EXP_FPF		256.0F	/* 1 for fixed point FLOAT */



#define G_SFP		8	/* shift for fixed point        */

#define G_0p5FP		128	/* 0.5 for fixed point */
#define G_FP		256	/* 1<<G_SFP : 1 for fixed point */

#define G_FPF		256.0F	/* 1 for fixed point FLOAT */
#define G_IFPF		0.00390625F	/* 1 / G_FPF for fixed point FLOAT */





#define V_SFP		8

#define V_0p5FP		128	/* 0.5 for fixed point */
#define V_FP		256	/* 1<<V_SFP : 1 for fixed point */

#define V_FPF		256.0F	/* 1 for fixed point FLOAT */


#endif
