/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**********************
 ***    XpType.h    ***
 **********************/

#ifndef         _XP_TYPE_
#define         _XP_TYPE_

#include	"Uigp/igp.h"


#include	"GpType/GpType.h"




#define         LXP           5
#define         JXP           4


typedef struct xp_type {

	vec2d	ctr;


	link_type	*link;
	link_type	*rlink;

	bgp_type	*bgp;

	hunch_type	*hunch;
} xp_type;




typedef struct xp_array {
	int	bgp;
	float	bgp_inv;
	int	NI,	NJ;
	int	Ni,	Nj;

	int	BNi,	BNj;
	int	Pi,	Pj;	/* BNi *bgp */


	int	Ni0,	Nj0;
	vec2d	V0;

	xp_type	**xp;
} xp_array;



	/* XpAgp.c */
void	xp_agp( gp_array *agp, int I0, int J0, int Ni, int Nj, xp_array *axp );


	/* XpTool.c */
xp_array *	axp_alloc();

void		axp_destroy( xp_array *axp );

void	xp_array_init( xp_array *axp, int bgp, int ni, int nj );

void	xp_array_clear( xp_array *axp, int bgp, int Ni, int Nj );

void	xp_array_Fclear( xp_array *axp, int bgp, int Ni, int Nj );

void	xp_array_realloc( xp_array *axp, int ni, int nj );

void	xp_array_free( xp_array *axp );


#endif
