/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/***************************
	ZpBox.c
***************************/
#include        <stdio.h>   
#include	<math.h>

#include        "ZpType.h"



void
azp_box( zp_array *azp, int Abr[], int br_no, box2i abox[] )
{
zp_type	*dp;

int	i,	j,	k;
box2i	*box;
mbr_type	Rmbr[32],	Cmbr[32],	*cmbr,	*rmbr;
mbr_type	mask;


	for( i = 0 ; i < azp->Nj ; i++ )	Cmbr[i] = 0;

	rmbr = Rmbr;
	for( i = 1 ; i < azp->Ni-1 ; i++, rmbr++ ){
		dp = &azp->dp[i][1];
		*rmbr = 0;
		cmbr = Cmbr;
		for( j = 1 ; j < azp->Nj-1 ; j++, dp++, cmbr++ ){


			*rmbr |= dp->Mbr;
			*cmbr |= dp->Mbr;
		}
	}


	for( k = 0 ; k < br_no ; k++ ){

		box = &abox[k];
//		mask = 1L << Abr[k];
		mask = MBR_BIT( Abr[k] );


		for( i = 0 ; i < azp->Ni-2 ; i++ )
			if( Rmbr[i] & mask )	break;
		box->x0 = i * azp->bgp;

		for( i = azp->Ni-3 ; i >= 0 ; i-- )
			if( Rmbr[i] & mask )	break;
		box->x1 = (i+1) * azp->bgp;


		for( j = 0 ; j < azp->Nj-2 ; j++ )
			if( Cmbr[j] & mask )	break;
		box->y0 = j * azp->bgp;

		for( j = azp->Nj-3 ; j >= 0 ; j-- )
			if( Cmbr[j] & mask )	break;
		box->y1 = (j+1) * azp->bgp;
	}
}
