/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ****	ZpCreate.c	***
 *************************/

#include	<stdio.h>   
#include	<math.h>

#include	"ZpType.h"


static void	azp_order(  zp_array *azp );
static void	azp_bgp( xp_array *axp, zp_array *azp );


int
azp_create( xp_array *axp, zp_array *azp, int Abr[] )
{
int	br,	no;
mbr_type	mbr;

/*
	if( (mbr = azp_test( axp )) >= 0 ){
		azp->Mbr = mbr;

		azp->Ffilter = 0;
	
		return( mbr != 0 );
	}
*/

	azp_init( azp, axp->BNi, axp->BNj );

	azp->bgp = axp->bgp;
	azp->bgp_inv = axp->bgp_inv;

	azp->Ni0 = axp->Ni0;
	azp->Nj0 = axp->Nj0;



	azp_edge( axp, azp );

	azp_bgp( axp, azp );


	for( mbr = azp->Mbr, br = 0, no = 0 ; mbr != 0 ; mbr >>=1, br++ ){
		if( !(mbr & 0x01) )	continue;
		Abr[no++] = br;
	}

	if( no == 1 ){
		azp_complete( azp );
		return( 1 );
	}



	azp_order( azp );

	azp_complete( azp );

	azp_filter( azp );



	for( mbr = azp->Mbr, br = 0, no = 0 ; mbr != 0 ; mbr >>=1, br++ ){
		if( !(mbr & 0x01) )	continue;
		Abr[no++] = br;
	}



	return( no );
}



static void
azp_order(  zp_array *azp )
{
zp_type	*dp;
int	i,	j;
int	k,	n,	kk;
int	br;
float	depth;

	for( i = 0 ; i < azp->Ni ; i++ ){
		dp = azp->dp[i];
		for( j = 0 ; j < azp->Nj ; j++, dp++ ){

			if( dp->br_no <= 1 )	continue;

			for( k = 0 ; k <  dp->br_no-1 ; k++ ){
				kk = k;
				for( n = k+1 ; n < dp->br_no ; n++ )
					if( dp->depth[n] < dp->depth[kk] )
						kk = n;
			
				if( kk == k )	continue;

				br = dp->br[kk];
				dp->br[kk] = dp->br[k];
				dp->br[k] = br;

				depth = dp->depth[kk];
				dp->depth[kk] = dp->depth[k];
				dp->depth[k] = depth;
			}

		}
	}
}




static void
azp_bgp( xp_array *axp, zp_array *azp )
{
xp_type	 *xp;
bgp_type	*bgp;
zp_type	*dp;
int     i,      j;
mbr_type	mbr;


	for( i = 0  ; i < azp->Ni ; i++ ){
		dp = azp->dp[i];
		xp = &axp->xp[JXP + i][JXP];

		for( j = 0; j < azp->Nj ; j++, xp++, dp++ ){

			dp->Mbr_e |= dp->Mbr_ee;
			dp->Mbr = dp->Mbr_e;

			for( bgp = xp->bgp ; bgp != NULL ; bgp = bgp->p ){
//				mbr = 1L << bgp->br;
				mbr = MBR_BIT(bgp->br);
	
				if( dp->Mbr & mbr )	continue;

				dp->Mbr |= mbr;

				dp->br[dp->br_no] = bgp->br;
				dp->depth[dp->br_no] = bgp->depth;
				dp->br_no++;

				azp->Mbr |= mbr;
			}

		}
	}
}
