/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************
 ***	ZpFiletr.c    ***
 ************************/
#include        <stdio.h>   
#include	<math.h>

#include        "ZpType.h"




void
azp_filter( zp_array *azp )
{
zp_type	*dp;
int	i,	j,	k;
mbr_type	Mbr,	mbr;

	for( i = 0 ; i < azp->Ni ; i++ ){
		dp = azp->dp[i];
		for( j = 0 ; j < azp->Nj ; j++, dp++ ){

			dp->Mbr = 0;

			for( k = 0 ; k < dp->br_no ; k++ ){
//				mbr = 1L<< dp->br[k];
				mbr = MBR_BIT(dp->br[k] );
				dp->Mbr |= mbr;
				if( mbr & dp->Mbr_ee )	continue;

				dp->br_no = k+1;

				break;
			}

			dp->Mbr_e &= dp->Mbr;
			dp->Mbr_ee &= dp->Mbr;
		}
	}


	Mbr = 0;
	mbr = 0;
	for( i = 1 ; i < azp->Ni-1 ; i++ ){
		dp = &azp->dp[i][1];
		for( j = 1 ; j < azp->Nj-1 ; j++, dp++ ){

			Mbr |= dp->Mbr;
			mbr |= dp->Mbr_ee;
		}
	}


	if( Mbr == azp->Mbr && mbr == 0 )	return;


	azp->Mbr = Mbr;
}
