/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	ZpTest.c	***
 **************************/
#include        "Xp/XpType.h"
#include        "ZpType.h"




int
azp_test( xp_array *axp )
{
xp_type *xp;
link_type *link;
bgp_type	*bgp;
int     i,      j;
int	Fbr,	br;
mbr_type	Mbr;

	Fbr = Mbr = 0;
	br = -1;
	for( i = 0 ; i < axp->Ni ; i++ ){
		xp = axp->xp[i];
		for( j = 0 ; j < axp->Nj ; j++, xp++ ){


			for( link = xp->link ; link != NULL ; link = link->cln){

				Fbr |= link->Fbr;
				br = link->br;
//				Mbr = ( 1L<< br);
				MBR_SET( Mbr, 1);
			}
		}


		if( Fbr != 0 )	return( -1 );

//		if( br > 0 && Mbr != ( 1L<<br) )	return( -1 );
		if( br > 0 && Mbr != MBR_BIT(br) )	return( -1 );
	}




	for( i = JXP ; i < axp->Ni-JXP ; i++ ){
		xp = &axp->xp[i][JXP];
		for( j = JXP ; j < axp->Nj-JXP ; j++, xp++ ){

			for( bgp = xp->bgp ; bgp != NULL ; bgp = bgp->p ){

				br = bgp->br;
//				Mbr = ( 1L<< br);
				MBR_SET( Mbr, 1);
			}
		}

//		if( br > 0 && Mbr != ( 1L<<br) )   return( -1 );
		if( br > 0 && Mbr != MBR_BIT(br) )	return( -1 );
	}

	return( Mbr );
}
