/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	 ZpType.h	***
 **************************/
  
#ifndef		_ZP_TYPE_
#define		_ZP_TYPE_

#include	"Uigp/igp.h"

#include	"GpType/GpType.h"
#include	"Xp/XpType.h"


#define		MAXBR		16


typedef struct  zp_type {

	mbr_type	Mbr;
	mbr_type	Mbr_e;	/* only for edge */

	mbr_type	Mbr_ee;
	int	step;

	int	br_no;
	int	br[MAXBR];
	float	depth[MAXBR];

}	zp_type;




typedef struct zp_array {
    int     bgp;
    float   bgp_inv;
    int     Ni,     Nj;
    int     NI,     NJ;

	int	Ni0,	Nj0;	/* index in agp */

	mbr_type	Mbr;

	int	Ftransparent;


	zp_type **dp;
} zp_array;




	/* ZpCreate.c */
int	azp_create( xp_array *axp, zp_array *azp, int Abr[] );

	/* ZpInit.c */
void	azp_init( zp_array *azp, int ni, int nj );

void	zp_array_free( zp_array *azp );

void	azp_print( zp_array *azp, int i0, int j0, int ni, int nj );


	/* ZpEdge.c */
void	azp_edge( xp_array *axp, zp_array *azp );


	/* ZpComplete.c */
void	azp_complete( zp_array *azp );


	/* ZpFilter.c */
void	azp_filter( zp_array *azp );


	/* ZpBox.c */
void	azp_box( zp_array *azp, int Abr[], int br_no, box2i abox[] );


	/* ZpTest.c */
int	azp_test( xp_array *axp );

#endif
