/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef	_COLOR_PALETTE_
#define	_COLOR_PALETTE_

#include	"Uigp/igp.h"


#define PL_NBITS 5



#define	PALETTE_RGB				0
#define PALETTE_BW				1
#define PALETTE_WB				2
#define PALETTE_GRAY			3
#define PALETTE_ADAPTIVE		4
#define PALETTE_WINDOW_SYSTEM	5
#define PALETTE_HALFTONE		6
#define PALETTE_222				7
#define PALETTE_UNKNOWN			8

#define PALETTE_ADAPTIVE4		10


#define PALETTE_SMART			PALETTE_ADAPTIVE


#define	PALETTE_IS_VALID( colorSpace )	( colorSpace >= 0 && colorSpace <= 7 )

typedef struct color_type
{
	u_char	Red;
	u_char	Green;
	u_char	Blue;

} color_type;




typedef struct palette_type
{
	int type;

	int	bitPerPixel;
	int		ALLOCATED;
	int		colorsNumber;
	color_type *data;

	char	*table;

} palette_type;



palette_type *	palette_alloc( int no );

palette_type *  palette_copy( palette_type* palette);


void	palette_destroy( palette_type *p );


palette_type *	palette_create( int type );
palette_type *	palette_create_WINDOW_SYSTEM();
palette_type *  palette_create_222( );
palette_type *  palette_create_gray( int bit );
palette_type *  palette_create_HALFTONE();

void	palette_write( palette_type *p, int no, FILE *fp );

int palette_write_to_file( palette_type *p, char *file );

 
int	palette_index( palette_type *palette, int red, int green, int blue );

int palette_color_space(char * colorStr);
#endif

