// VimageR2.h: interface for the CVimageR2 class.
//
//////////////////////////////////////////////////////////////////////

#ifndef __ST_H__
#define __ST_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#if defined _DEBUG || defined DEBUG
#pragma comment( lib, "libStD.lib" )
#else
#pragma comment( lib, "libSt.lib" )
#endif

#include	"FrameControl.h"

extern "C" {
#include "ImageType/ImageType.h"
#include	"Uvec/Vec3d.h"
}



class CSt : public CFrameControl
{
public:
	CSt();
	virtual ~CSt();

	int	Decode( char *file );
	
	int	Decode( char *data, int dataSize );

	int GetFrameWidth();

	int GetFrameHeight();


	image_type *	Render( int frame, image_type *im );


	void	SetTranslation( vec3d av[], int len );
	void	SetRotation( vec3d av[], int len );


	void	SetGlobalConfiguration( vec3d av[], int len );

public:
	void *m_hvim;
};

#endif