/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef		_GEO_APP_
#define		_GEO_APP_


#include	"Uvec/Vec2d.h"


//#define		MAX_POINT_NUMBER    4096
#define		MAX_POINT_NUMBER    8192


#define		GEOM_DIVISION		1


typedef struct {
	int	type;
	int	no;		/* Segments number in polyline */
	int	ino;

	int	N;

	vec2d	*v;

	vec2d	*tang;
	
	int   *flag;

	float   *a;

}	gapp_type;



typedef struct {
	float	dwight;		/* wight of dev 1 */

	float	err;		/* max  L2  distance */

	float	Max_dev;	/* max distance */
	float	Min_dev;	/* distance */

	int	Min_pnumber;
	float	min_len;
	float	max_len;
}	gapp_prm;



	/* GappTool.h */

gapp_type *	gapp_alloc( int no );

void	gapp_destroy( gapp_type *gapp );


	/* GeoApp.c */

int	geo_approximate( gapp_type *gapp, gapp_prm *gprm );

void	geo_approximate_modify( gapp_type *gapp, int dlen, float Dang,
					gapp_prm *gprm );

int	gapp_next( gapp_type *gapp, int from, int div_type );



	/* GeoApp1.c */

/*
void	geo_approximate_1( gapp_type *gapp, int i0, int i1,
                        	vec2d *p0, vec2d *p2, gapp_prm *gprm );
*/


float	geo_approximate_l2( vec2d *p0, vec2d *p1,
			vec2d *v, vec2d *tang, int no,
			gapp_prm *gprm,
			float *a, float *len,
			vec2d *p2, int *i2, float *a2 );


#endif
