/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************************************************************/
/*									*/
/*           Box2d.h   :						*/
/*									*/
/************************************************************************/

#ifndef         BOX2D_TYPE
#define         BOX2D_TYPE

#include	"Uvec/Vec2d.h"

typedef struct box2d {
	float	x0,	x1;
	float	y0,	y1;
} box2d ;


typedef struct box2i {
	int	x0,	x1;
	int	y0,	y1;
} box2i ;




#define		BOX2D_SET( b, xmin, xmax, ymin, ymax ) \
			{ \
				(b).x0 = xmin;	\
			    	(b).x1 = xmax;	\
			    	(b).y0 = ymin;	\
			    	(b).y1 = ymax;	\
			}

#define         BOX2D_INIT( b, x, y ) \
			{ \
				(b).x0 = (b).x1 = x;	\
			   	(b).y0 = (b).y1 = y;	\
			}

#define         BOX2D_UPDATE( b, x, y ) \
			{ \
				if( x < (b).x0 )	(b).x0 = x; \
				else	if( x > (b).x1 )        (b).x1 = x; \
				if( y < (b).y0 )	(b).y0 = y; \
				else	if( y > (b).y1 )        (b).y1 = y; \
			}


#define         BOX2D_IS_IN( b, vx, vy ) \
			(	vx >= (b).x0 && vx <= (b).x1  &&  \
				vy >= (b).y0 && vy <= (b).y1 )

#define         BOX2D_IS_IN_O( b, vx, vy ) \
			(	vx > (b).x0 && vx < (b).x1  &&  \
				vy > (b).y0 && vy < (b).y1 )



box2d *box2d_alloc();

	/* Box2Tool.c */
int	box2_segment( box2d *b, vec2d *p, vec2d *p1, int Fp1,
						vec2d *v0, vec2d *v1 );


void	box_shift( box2d *b, float a, float y );

void	box_update( box2d *b, box2d *b1 );

void	box2d_union( box2d ab[], int no, box2d *b );

void	box2d_round( box2d *b );


	/* Box2iTool.c */
int	box2i_select( box2i *b, int select_t, int x, int y );



#endif
