/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	BstIn.c		***
 **************************/
#include	<stdio.h>

#include	"BstType.h"


#define		INCREMENT_BYTE( bst ) \
			bst->byte_i++; \
			bst->byte_ptr++;



int
bst_InputBit( bst_type *bst )
{
int	value;
 

	value = (*bst->byte_ptr) & bst->mask;
	bst->mask >>= 1;

	if ( bst->mask == 0 ){
		bst->mask = 0x80;
		bst->byte_i++;
		bst->byte_ptr++;
	}

	return( value ? 1 : 0 );
}



int
bst_InputBits( bst_type *bst, int bit_no )
{
unsigned int	mask;
unsigned int	return_value;
 
	 mask = 1L << ( bit_no - 1 );
	 return_value = 0;

	 while( mask != 0 ){

		if( (*bst->byte_ptr) & bst->mask )
			return_value |= mask;
		mask >>= 1;
		bst->mask >>= 1;

		if( bst->mask == 0 ){
			bst->mask = 0x80;
			bst->byte_i++;
			bst->byte_ptr++;
		}
	}

	 return( (int)return_value );
}
