/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	BstType.h	***
 **************************/

#ifndef		_BST_TYPE_
#define		_BST_TYPE_

#include	<stdio.h>
#include 	"Uigp/igp.h"

#include 	"Ucode/code.h"


typedef struct bst_type {
	int	MaskIndex;
	int	mask;

	int	byte_i;
	u_char	*byte_ptr;

	u_char	*data;
	int	BYTE_NO;
	int	byte_no;
	
} bst_type;


#define		BST_BITS( bst )		( bst->byte_i*8 + bst->MaskIndex )

#define		BST_BYTES( bst )	(( bst->MaskIndex == 0 )? \
						bst->byte_i : bst->byte_i +1 )



	/* BstTool.c */
bst_type *	bst_alloc( int byte_no );

void		bst_realloc( bst_type *bst, int byte_no );

void		bst_extend(bst_type *bst, int byte_extention);

void		bst_rewind( bst_type *bst );

bst_type *	bst_read( FILE *fp, int byte_no );

void		bst_write( FILE *fp, bst_type *bst );

void    	bst_copy( bst_type *bst_in, bst_type * bst_out, int byte_no); 

void		bst_clear( bst_type *bst );

void		bst_destroy( bst_type *bst );
#define		bst_free	bst_destroy


bst_type *	bst_read_from_file( char *file );

int		bst_write_to_file( bst_type *bst, char *file );

bst_type *	bst_create( char data[], int byte_no, int FCopydata );

bst_type *	bst_make_copy( bst_type *bst_in );



	/* BstGet.c */
int	bst_get( bst_type *bst );

int	bst_get_inv( bst_type *bst );//arie

int	bst_get_int( bst_type *bst, int bit_no );

void	bst_get_align( bst_type *bst );

int	bst_get_align_char( bst_type *bst );

void	bst_get_string( bst_type *bst, char *s, int len );

char *	bst_get_Astring(  bst_type *bst, int len );

void	bst_get_buff( bst_type *bst, char *s, int len );

int     bst_get_align_num( bst_type *bst, int byte_no );

float	bst_get_float_code( bst_type *bst, code *cd, int bit );

float	bst_get_float( bst_type *bst, float d, int bit );

bst_type *	bst_get_align_bst( bst_type *bst_in, int byte_no );



	/* BstPut.c */
void	bst_put( bst_type *bst, int bit );

void	bst_put_inv( bst_type *bst, int bit );//arie

void	bst_put_int( bst_type *bst, int code, int bit_no );

void	bst_put_align( bst_type *bst );

void	bst_put_align_char( bst_type *bst, int a );

void	bst_put_string( bst_type *bst, char *s, int len );

void	bst_put_align_num( bst_type *bst, int value, int byte_no );

void	bst_put_buff( bst_type *bst, char *s, int len );

void	bst_reput_align_num( bst_type *bst, int i, int value, int byte_no );

void	bst_put_float_code( bst_type *bst, float a, code *cd, int bit );

void	bst_put_float( bst_type *bst, float a, float d,  int bit );



	/* BstIn.c - like BstGet but in defrennt diretion */
int	bst_InputBit( bst_type *bst );

int	bst_InputBits( bst_type *bst, int bit_no );

#endif 
