/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/******************
 ***	code.c	***
 ******************/
#include	<string.h>
#include	"code.h"


void
code_set( code *c, float min, float max, float d, float avarege, float nf )
{
	c->min = min * nf;
	c->max = max * nf;
	c->d = d * nf;

	c->a = avarege;



	c->inv_d = 1.0/c->d;

	c->imax = (c->max - c->min) * c->inv_d;

	if( c->imax*c->d == c->max - c->min )
		c->imax -= 1;

	c->rbit = coding_ilog2( c->imax );

	c->hr = (c->imax+1)/2;



	c->bits = 0;
}


void
coding_set_lprm( code_in *c_in, code *c, float	nf )
{
	c->min = c_in->min * nf;
	c->max = c_in->max * nf;
	c->d = c_in->d * nf;

	c->inv_d = 1.0/c->d;

	c->imax = (c->max - c->min) * c->inv_d;

	if( c->imax*c->d == c->max - c->min )
		c->imax -= 1;

	c->rbit = coding_ilog2( c->imax );

	c->hr = (c->imax+1)/2;


	c->a = c_in->a;



	c->bits = 0;

}

/*
void
coding_set_data_lprm( code_in *c_in, code *c, float nf, char *file_name )
{
	c->min = c_in->min * nf;
	c->max = c_in->max * nf;
	c->d = c_in->d * nf;

	c->inv_d = 1.0/c->d;

	c->imax = (c->max - c->min) * c->inv_d;

	if( c->imax*c->d == c->max - c->min )
		c->imax -= 1;

	c->rbit = coding_ilog2( c->imax );

	c->hr = (c->imax+1)/2;

	c->a = c_in->a;
	c->f = c_in->f;

	strcpy( c->fname, file_name );

	c->bits = 0;
}
*/

void
code_file_set( cfile_type *c, char *file_name )
{
	strcpy( c->fname, file_name );

	c->fd = -1;
	c->fp = NULL;

	c->bits = 0;
}



int
coding_ilog2( int a )
{
int     i;
        if( a < 0 )     a = -a;
 
        if( a < 1 )     return( 0 ); 
 
        for( i = 1 ; ; i++ )
                if( a < (1L<<i) )  return( i );
}
