/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/******************
 ***	code.h	***
 ******************/

#ifndef		_UCODE_
#define		_UCODE_

#include        <stdio.h>   

#include       "Ucst/CstType.h"
/*
extern struct cst_type;
*/



typedef	struct code_in {
	float	min,	max,	d;
	float	a, f;
} code_in;



typedef	struct code {
	float	min,	max,	d,	inv_d;
	float	a;

	int	imax,	hr,	rbit;

	char	fname[64];

	FILE	*fp;
	int	bits;
	int	msgs;

	struct cst_type	*cst;
} code;

typedef	code code_type;


typedef	struct cfile_type {
	char	fname[64];
	int	fd;
	FILE	*fp;
	int	bits;
	int	msgs;
	struct cst_type	*cst;
} cfile_type;






#define	CODE( x, c )	 	( (x - (c).min) *(c).inv_d )
#define	UNCODE( cno, c )	(( (cno) + 0.5) *(c).d + (c).min )
#define QCODE( x, c )		( ( (x) < 0 )?  \
				(( ((int)((x)*(c).inv_d)) - 0.5) *(c).d ) : \
				(( ((int)((x)*(c).inv_d)) + 0.5) *(c).d ) )


#define	ZCODE( x, c )	 	( ( (x) < 0 )? \
				  ( ( (x) - 0.5*(c).d )*(c).inv_d ) : \
				  ( ( (x) + 0.5*(c).d )*(c).inv_d ) )
#define	UNZCODE( cno, c )	( (cno) *(c).d )

#define	QZCODE( x, c )		( ((int)ZCODE( x, c )) *(c).d )



void	code_set( code *c, float min, float max, float d, float avarege, float nf );


void	coding_set_lprm( code_in *c_in, code *c, float	nf );

/*
void	coding_set_data_lprm( code_in *c_in, code *c, float nf,
                                                        char *file_name );
*/
void	code_file_set( cfile_type *c, char *file_name );

int	coding_ilog2( int a );


#endif  /* of _UCODE_ */
