/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************************************************************
*									*
*			Config3d.h					*
*									*
************************************************************************/

#ifndef		_CONFIG_3D_
#define		_CONFIG_3D_

#include	<stdio.h>

#include	"Uigp/igp.h"



typedef struct config3d {
	float	x,	y;
	float	u1;


	float	z;
	float	u2;


	float	u3;

}	config3d;



#define		ALLOC_CONFIG3D()  ( (config3d *)malloc( sizeof(config3d) ))

#define		CONFIG3D_IS_INIT( c )  \
	( (c).x == 0 && (c).y == 0 && (c).z == 0 && \
		(c).u1 == 0 && (c).u2 == 0 && (c).u3 == 0 )

#define		CONFIG3D_IS_EQUAL( c, c1 )  \
	( (c).x == (c1).x && (c).y == (c1).y && (c).z == (c1).z && \
		(c).u1 == (c1).u1 && (c).u2 == (c1).u2 && (c).u3 == (c1).u3 )


	/* Config3D.h */
void	config3d_init( config3d *cp );


	/* ConfigIo.h */
void	config3d_read( FILE *fp, config3d *cp );
void	config3d_write( FILE *fp, config3d *cp );

int	config3d_load( char *file, config3d cp[], int *cp_no );

int	config3d_dump( char *file, config3d cp[], int cp_no );


int	config3d_create_trajectory( config3d cm[], int cm_no,
					int no, config3d tm[] );

#endif
