/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	CstType.h	***
 **************************/

#ifndef		_CST_TYPE_
#define		_CST_TYPE_

#include	<stdio.h>
#include 	"Uigp/igp.h"

struct bst_type;


typedef struct cst_type {
	int	byte_i;
	u_char	*byte_ptr;

	u_char	*data;
	int	BYTE_NO;
	int	byte_no;
	
} cst_type;


#define		CST_GET_SCHAR( cst )	( (char)*( (cst)->byte_ptr++) )
#define		CST_GET_UCHAR( cst )	( (u_char)*( (cst)->byte_ptr++) )

#define		CST_GETC( cst )			( (char)*( (cst)->byte_ptr++) )
#define		CST_GETUC( cst )		( (u_char)*( (cst)->byte_ptr++) )


#define		CST_PUTC( cst, a )		(*( (cst)->byte_ptr++) = (u_char)a)


#define		CST_PUT_CHAR( cst, a )	\
		{ \
			*( (cst)->byte_ptr++) = (u_char)a; \
			(cst)->byte_no++; \
		}


#define		CST_BYTES( cst )	( (cst)->byte_ptr - (cst)->data )

#define		CST_BYTE_INDEX( cst )	( (cst)->byte_ptr - (cst)->data )

#define     CST_BYTE_AVAILABLE( cst ) ((cst) ->BYTE_NO - CST_BYTES(cst))

#define		CST_END( cst )  ( cst->byte_ptr >= cst->data + cst->byte_no )

	/* CstTool.c */

cst_type *	cst_alloc( int byte_no );

cst_type *	cst_create( char data[], int byte_no, int FCopydata );


void	cst_clear( cst_type *cst );

void	cst_free( cst_type *cst );

void	cst_destroy( cst_type *cst, int FDeletedata  );



void	cst_realloc( cst_type *cst, int byte_no );

void	cst_extend(cst_type *cst, int byte_extention);

void	cst_read( FILE *fp, cst_type *cst, int byte_no );

void	cst_write( FILE *fp, cst_type *cst );



int			cst_put_string( cst_type *cst, char *buf );
void		cst_put_stringA( cst_type *cst, int align, char *name );



int	cst_put_buffer( cst_type *cst, char buf[], int byte_no );



cst_type * cst_load_from_file( char *file );

int		cst_write_to_file(cst_type *cst, char *file);

void	cst_rewind( cst_type *cst );

int	cst_get_buffer( cst_type *cst, u_char buf[], int byte_no );


int	cst_put_buffer_int( cst_type *cst, u_char buf[], int byte_no );

struct bst_type *	cst2bst(cst_type* cst, int byte_no);



void	cst_put_xml_tag_int( cst_type *cst, char *name, int value );

void	cst_put_xml_tag_string( cst_type *cst, char *name, char *value);
void	cst_put_xml_tag_stringS( cst_type *cst, char *name, char *value, int size );


void	cst_put_xml_tag_intA( cst_type *cst, int align, char *name, int value );

void	cst_put_xml_tag_floatA( cst_type *cst, int align, char *name, float value );

void	cst_put_xml_tag_stringA( cst_type *cst, int align, char *name, char *value );

void	cst_put_xml_tag_openA( cst_type *cst, int align, char *name );

void	cst_put_xml_tag_closeA( cst_type *cst, int align, char *name );


void	cst_put_xml_tag_intB( cst_type *cst, char *name, int value );

void	cst_put_xml_tag_floatB( cst_type *cst, char *name, float value );

void	cst_put_xml_tag_stringB( cst_type *cst, char *name, char *value );

void	cst_put_xml_tag_openB( cst_type *cst, char *name );

void	cst_put_xml_tag_closeB( cst_type *cst, char *name );

void	cst_put_xml_att_string( cst_type *cst, char *name, char *value );

void	cst_put_xml_att_int( cst_type *cst, char *name, int value, char *ext );

#endif 
