/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	FbstType.h	***
 **************************/

#ifndef		_FBST_TYPE_
#define		_FBST_TYPE_

#include	<stdio.h>
#include 	"Uigp/igp.h"


typedef struct fbst_type {
	int	MaskIndex;
	int	mask;

	u_char	byte;
	int	byte_i;

	FILE	*fp;
	
} fbst_type;


#define		FBST_BITS( bst )	( bst->byte_i*8 + bst->MaskIndex )


	/* BstTool.c */
fbst_type *	fbst_alloc();

void	fbst_free( fbst_type *bst );

fbst_type *	fbst_open_to_write( char *file_name );

fbst_type *	fbst_open_to_read( char *file_name );
fbst_type *	fbst_set_to_read( FILE *fp );

void	fbst_close( fbst_type *bst, int Fwrite );




	/* BstfGet.c */
int	fbst_get( fbst_type *bst );

int	fbst_get_int( fbst_type *bst, int bit_no );

void	fbst_get_int1( fbst_type *bst, int *cno, int bit_no );

void	fbst_get_algin( fbst_type *bst );

int	fbst_get_algin_char( fbst_type *bst );


	/* BstfPut.c */
void	fbst_put( fbst_type *bst, int bit );

void	fbst_put_int( fbst_type *bst, int code, int bit_no );

void	fbst_put_algin( fbst_type *bst );

void	fbst_put_algin_char( fbst_type *bst, int a );



#endif 
