/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include	<stdio.h>

#ifdef CE
#include <windows.h>
#else
#include	<sys/types.h>
#include	<sys/stat.h>
#ifdef  WIN32
#include	<direct.h>
#else
#include	<dirent.h>
#endif
#endif

#include	<string.h>





#include	"igp.h"



int
gp_is_file_exist( char *file )
{
#ifdef CE
	return gp_is_dir_exist(file);
#else
struct stat     statbuf;

        if( stat( file, &statbuf ) == 0 )       return( 1 );
        return( 0 );
#endif
}


int
gp_file_size( char *file )
{
#ifdef CE
	HANDLE h;
	DWORD r;
	int ir;
	TCHAR * buf = (TCHAR *)malloc((strlen(file) + 1) * sizeof(TCHAR));
	wsprintf(buf, _T("%S"), file);
	h = CreateFile(buf, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	free(buf);
	if (h == INVALID_HANDLE_VALUE)
		return -1;
	r = GetFileSize(h, NULL);
	ir = (r == 0xFFFFFFFF)? -1: (int)r;
	CloseHandle(h);
	return ir;
#else
struct stat     statbuf;

        if( stat( file, &statbuf ) != 0 )       return( -1 );

	return( (int)statbuf.st_size );
#endif
}


int
gp_is_dir_exist( char *dir )
{
#ifdef CE
	HANDLE h;
	TCHAR * buf = (TCHAR*)malloc((strlen(dir) + 1) * sizeof(TCHAR));
	wsprintf(buf, _T("%S"), dir);
	h = CreateFile(buf, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	free(buf);
	if (h == INVALID_HANDLE_VALUE)
		return 0;
	else
		CloseHandle(h);
	return 1;
#else
struct stat     statbuf;

	if( stat( dir, &statbuf ) != 0 )       return( 0 );

	if(( statbuf.st_mode & S_IFMT ) != S_IFDIR ) return( 0 );

        return( 1 );
#endif
}

int
gp_getcwd( char *dir, int size )
{
#ifndef CE
#ifdef	WIN32
	_getcwd( dir, size );
#else
	getcwd( dir, size );
#endif//WIN32
#endif//CE
	return( 1 );
}


int gp_setcwd(char *dir)
{
#ifndef CE
#ifdef WIN32
	_chdir(dir);
#else
	chdir(dir);
#endif// WIN32
#endif// CE
	return 1;
}


int
gp_mkdir( char *dir )
{
#ifndef CE
#ifdef	WIN32
	if( mkdir( dir ) == -1 ) return( 0 );
#else
	if( mkdir( dir, 0755 ) == -1 ) return( 0 );
#endif
#endif
	return( 1 );
}



int
gp_rmdir( char *dir )
{

#ifndef CE
#ifdef	WIN32
	if( _rmdir( dir ) == -1 )	return( -1 );
	return( 1 );
#else
struct dirent	*dp;
DIR	*dfd;
char	name[256];

        if ( (dfd = opendir(dir)) == NULL)
                return( -1 );

        while ( (dp = readdir(dfd)) != NULL ) {

		if( strcmp( dp->d_name, "." ) == 0 )	continue;
		if( strcmp( dp->d_name, ".." ) == 0 )	continue;

		strcpy( name, dir );
		strcat( name, "/" );
		strcat( name, dp->d_name );
		unlink( name );
	}

	closedir( dfd );


        if ( (dfd = opendir(dir)) == NULL)
                return( -1 );
	closedir( dfd );



	if( rmdir( dir ) == -1 )
		perror( "rmdir" );

	return( 1 );
#endif
#else
	return 1;
#endif
}


void
gp_sort_strings( char *str[], int no  )
{
int	i,	j;
char	*s;
	for( i = 1 ; i < no-1 ; i++ )
		for( j = 0 ; j < no-i ; j++ )
			if( strcmp( str[j], str[j+1] ) > 0 ){
				s = str[j];
				str[j] = str[j+1];
				str[j+1] = s;
			}
}





