/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/******************
 ***	igp.h	***
 ******************/

#ifndef         _GP_UTIL_
#define         _GP_UTIL_

#include  <stdio.h>

#ifndef __SYMBIAN32__
	#include	<malloc.h>
	#include	<memory.h>
#endif // 	__SYMBIAN32__


#ifndef CE 
#ifdef WIN32
#include  <io.h>
#else
#include  <unistd.h>
#endif
#endif

#ifdef WIN32
#pragma warning(disable:4244)
#pragma warning(disable:4305)
#endif




#ifdef __SYMBIAN32__
	#define hypot(x,y) sqrt((x)*(x) + (y)*(y))
#endif // __SYMBIAN32__

#define		TRUE	1
#define		FALSE	0



#define         F_BEGIN		0
#define         F_END		1

#define         F_NEXT		0
#define         F_PREV		1


#define         F_RIGHT		0
#define         F_LEFT		1

#define         INV_FLAG(flag)		( flag ^ 1 )



#define         SP_NO           3

#define         SP_Y            0
#define         SP_Q            1
#define         SP_A            2

#define         SP_R            0
#define         SP_G            1
#define         SP_B            2


	// byte order
#define		LITTLE_ENDIAN		0
#define		BIG_ENDIAN			1


#ifndef M_PI
#define M_PI    3.14159265358979323846
#endif

#ifndef ABS
#define		ABS( a )        (( (a) < 0 )? -(a) : (a) )
#endif

#ifndef MAX
#define		MAX( a, b )        (( (a) < (b) )? (b) : (a) )
#endif

#ifndef MIN
#define		MIN( a, b )        (( (a) < (b) )? (a) : (b) )
#endif

#define		NINT( a )	( ( (a) > 0 )? ((int)((a)+0.5)) : ((int)((a)-0.5)) )

#define		IN_RANGE( x, a, b )        ( (a) <= (x) && (x) < (b) )

#ifndef ROUND
#define		ROUND( a )        ( ( (a) < 0 )? ((int)((a)-1)) : ((int)((a))) )
#endif

#define         PUSH_TO_RANGE( x, a, b )   \
	      		( ( (x) <= (a) )? (a) : (( (x) > (b) )? (b) : (x) ) )




#ifdef  WIN32
typedef	char	s_char;

typedef	unsigned char   u_char;
typedef unsigned short  u_short;
typedef unsigned int    u_int;
typedef unsigned long   u_long;

#else
	#ifndef PALMOS
		typedef	signed char	s_char;
		#include	<sys/types.h>
	#endif
#endif


#ifdef CE
#define hypot(x,y) sqrt((x)*(x) + (y)*(y))
#endif 


#ifdef WIN32
#define		RGB_COLOR( r, g, b ) 	(((r)<<16) | ((g)<<8) | (b) )
#elif __linux
#define		RGB_COLOR( r, g, b ) 	(((r)<<16) | ((g)<<8) | (b) )
#endif

	
#define RGB_REVERSE( color ) ((((color) & 0xff)<<16) | ((((color) >> 8) & 0xff)<<8) | (((color) >> 16) & 0xff) )

#ifdef WIN32
#define STOCHAR(x) (LPTSTR)LPCSTR(x) 
#define S2CHAR(x) (LPTSTR)LPCSTR(x) 
#endif

	/* GpMsg.c */
void	error(char *from, char *s );
 
void	warning(char *from, char *s );

void	wno( char * name, int no );

void	wnof( char * name, float	no );


	/* GpIo.c */
void    gp_fwrite_num( FILE *fp, int a, int nByte );
 
int     gp_fread_num( FILE *fp, int nByte ); 


/*  put intger no in the given file in a MSB first order */
void	gp_fwrite_int( FILE *fp, int a );
int	gp_fread_int( FILE *fp );

void	gp_fwrite_int3( FILE *fp, int a );
int	gp_fread_int3( FILE *fp );

void	gp_fwrite_float( FILE *fp, float a );
float	gp_fread_float( FILE *fp );

int	gp_fread_short( FILE *fp );
void	gp_fwrite_short( FILE *fp, int a );

int	gp_read_int( int fd );
int	gp_read_short( int fd );

void	gp_write_int( int fd, int a );
void	gp_write_short( int fd, int a );





int	gp_read_int_lsbf( int fd );
int	gp_read_short_lsbf( int fd );

void	gp_write_int_lsbf( int fd, int a );
void	gp_write_short_lsbf( int fd, int a );







	/* GpFile.c */
int	gp_directory_childs( char *dir, char *precede,
				char *extension, char *name[], int max  );
int	gp_filename_extand( char *file1, char *file2 );
int	gp_string_cut_extension( char *s1, char *extansion, char *s2 );

void	gp_filename( char *dir, char *fname, char *extension, char *file );

void	gp_filename_split( char *fname, char *dir, char *name, char *extension);

void	gp_filename_extract_name( char *fname, char *name, int len );

void	gp_filename_extract_extension( char *fname, char *extension, int len );

void	gp_filename_extract_dir(char *fname, char *dir, int len);

void	gp_filename_force_extension( char *file, char *extension );

void	gp_filename_slash( char *fname );


int 	gp_is_file_exist( char *file );

int		gp_file_size( char *file );

int 	gp_is_dir_exist( char *dir );

int		gp_getcwd( char *dir, int size );
int		gp_mkdir( char *dir );
int		gp_rmdir( char *dir );

void	gp_sort_strings( char *str[], int no  );



	/* GpFile1.c */
int	gp_file_create( char *data, int bytes, char *file );

int	gp_file_copy( char *ifile, char *ofile );

int	gp_file_append( char *file, int i0, FILE *fp );


int	gp_file_compare( char *file1, char *file2 );

void	gp_write_buffer_to_file(char *szFile, void *buffer, int dwSize);

int		gp_read_buffer_from_file(char *szFile, u_char **buffer);

int		gp_write_INTtable_to_file(char *file, char *name, int table[], int no );

void	gp_fwrite_bits( FILE *fp, int code, int no );



	/* GpDir.c */
int	gp_directory_file( char *dir, char *precede, char *extension,
                                        char *name[], int max  );

int	gp_directory_dir( char *dir, char *name[], int max  );

int gpDir_get_files_list(const char *dir, const char *prefix, const char *ext,
						 char *files[], int max_num_of_files, int bFullPath );


	/* GpRelinquish.c */
void	gp_relinquish_cpu();


	/* GpByteOrder.c */
int		gp_byte_order();

void	gp_byte_order_swap_short( short *loc, int no );

void	gp_byte_order_swap_int( int *loc, int no );



	/* GpFunction.c  */
int		gp_ilog2( int a );
int		gp_bound2( int a );

char	* gp_strlwr(char *szString);

int		gp_strnicmp(const char *szString1, const char *szString2, int count);

int		gp_stricmp(const char *s1, const char *s2);

char	*gp_strcasestr(const char *haystack, const char *needle);


int		gp_unique_id();

void	gp_filename_get_temporary( char *prefix, int unique, char *extension, char *filename );

void	gp_filename_get_temporaryD( char *prefix, int unique,
								   char *dir, char *name );

#endif
