/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef	_MAT2F_TYPE_
#define		_MAT2F_TYPE_

typedef struct mat2f_type {

	int	ni,	nj;

	float 	*f ;	

} mat2f_type ;




#define		MAT2F_ELM( mat, i, j )	\
			( (mat)->f + (i)*(mat)->nj + j  )



mat2f_type *	mat2f_alloc( int ni, int nj );

void		mat2f_free( mat2f_type *mat );


float		mat2f_inner( mat2f_type *m1, mat2f_type *m2 );


mat2f_type *	mat2f_add( mat2f_type *m1, mat2f_type *m2 );

void		ma2f_accumulate( mat2f_type *m, mat2f_type *m1, float t );


void		mat2f_const( mat2f_type *m, float a );

void		mat2f_add_const( mat2f_type *m, float a );

void		mat2f_mult_const( mat2f_type *m, float a );


	/* Mat2fBase.c */
void	mat2f_base_ortonormalize( mat2f_type *m[], int no );

void	mat2f_base_apply( mat2f_type *base[] ,int no, mat2f_type *mat, float f[] );

void	mat2f_base_apply_inv( mat2f_type *base[] ,int no, float f[], mat2f_type *mat );
 
void	mat2f_base_free( mat2f_type *base[] ,int no );


	/* Mat2fBaseDct.c */
void	mat2f_base_dct( mat2f_type *base[], int N, int M );
#endif
