/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************
 ***	MediaType.h   ***
 ************************/
#ifndef         _MEDIA_DATA_TYPE_
#define         _MEDIA_DATA_TYPE_ 

#include		"Uigp/igp.h"

	/* mediaData.type */
#define		MA_WAV		1
#define		MA_MIDI		2
#define		MA_WMA		3
#define		MA_MP3		4
#define		MA_AMR		5



typedef struct mediaData_type {

	char	type;

	char	mime[64];

	int		bytes;
	char	*data;


	// Aux
	float	sec;

} mediaData_type;




mediaData_type *	mediaData_alloc( int bytes );

void				mediaData_destroy( mediaData_type *md );


mediaData_type *	mediaData_create( int mediaType, char *data, int bytes );

mediaData_type *	mediaData_make_copy( mediaData_type *smd );


mediaData_type *	mediaData_read_file( char *file );

void	mediaData_write_to_file( mediaData_type *md, char *file );


	/* MediaFormat.c */
int		mediaData_mime2format( char *mime );

char *	mediaData_format2mime( int format, char *mime );

char *	mediaData_mime( mediaData_type *md, char *mime );

char *	mediaData_format2extension( int format, char *extension );



#endif
