/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************************************************************/
/*									*/
/*           vec2d.h   :						*/
/*									*/
/************************************************************************/

#ifndef         VEC2D_TYPE
#define         VEC2D_TYPE


typedef struct vec2d {
	float 	x ;	
	float 	y ;	
} vec2d ;


typedef struct plane2d {
        vec2d   n;
        float   d;
} plane2d ;

#define		VEC2D_EQUAL(u,v)	( ((v).x == (u).x ) && ((v).y == (u).y) )

#define		VEC2D_SET( v, xval, yval )     { (v).x = xval; (v).y = yval; }

#define		VEC2D_DOT(u,v)		( (u).x * (v).x  +  (u).y * (v).y )

//#define		VEC2D_INNER(u,v)	( (u).x * (v).x  +  (u).y * (v).y )

#define		VEC2D_NORM2( v )	VEC2D_DOT( (v) , (v) )


#define         VEC2D_UPDATE_BOUND( v, beg, end ) \
                        { \
                        if( (v).x < (beg).x )   (beg).x = (v).x;            \
                        else    if( (v).x > (end).x )      (end).x = (v).x; \
                        if( (v).y < (beg).y )   (beg).y = (v).y;            \
                        else    if( (v).y > (end).y )      (end).y = (v).y; \
                        }
   

	/* V2c2dTool.c */
void	vec2d_reorder( vec2d V[], int no );

int	vec2d_select( vec2d V[], int no, vec2d *p );

float	vec2d_distance( vec2d *v0 ,vec2d *v1 );

float	vec2d_distance2( vec2d *v0 ,vec2d *v1 );

#endif
