/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************************************************************/
/*									*/
/*           Vec3d.h   :						*/
/*									*/
/************************************************************************/

#ifndef         VEC3D_TYPE
#define         VEC3D_TYPE


typedef struct vec3d {
	float 	x ;	
	float 	y ;	
	float 	z ;	
} vec3d ;



typedef struct plane3d {
	vec3d	n;
	float	d;
} plane3d ;




#define		VEC3D_SET( v, vx, vy, vz ) \
			    { (v).x = vx; (v).y = vy; (v).z = vz; }

#define		VEC3D_INNER( u, v ) \
		( (u).x * (v).x  +  (u).y * (v).y + (u).z * (v).z )

#define		VEC3D_NORM2( v )	VEC3D_INNER( (v) , (v) )

#define		VEC3D_NORM( v )	  sqrt( VEC3D_INNER( (v) , (v) ) )



#define		VEC3D_NORMAL( v )	\
	{ \
	double   t = 1.0 / VEC3D_NORM( v ); \
        	(v).x *= t; \
        	(v).y *= t; \
        	(v).z *= t; \
	}



#define		VEC3D_PRODUCT( a, b, c ) \
	{ \
		(c).x =  (a).y * (b).z  -  (a).z * (b).y ; \
		(c).y = -(a).x * (b).z  +  (a).z * (b).x ; \
		(c).z =  (a).x * (b).y  -  (a).y * (b).x ; \
	}

   

#endif
