/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**********************************
 ***	ViewCreateNormal.c	***
 **********************************/

#include	<math.h>

#include	"Uigp/igp.h"
#include	"Uview/ViewType.h"



void
view_create_noraml( view_type *vw, float rf, int row, int column )
{
	vw->type = VIEW_PERSPECTIVE;
	vw->Upixel = column;
	vw->Vpixel = row;

        vw->cp.x = 0;
        vw->cp.y = 0;
        vw->cp.z = 1.0;
 
        vw->rp.x = 0;
        vw->rp.y = 0;
        vw->rp.z = 0;

	vw->dis = 1.0;
 
 
        VEC3D_SET( vw->N, 0, 0, -1 );
        VEC3D_SET( vw->V, 0, 1, 0 );
        VEC3D_SET( vw->U, 1, 0, 0 );



	vw->uv.y0 = -0.5 * rf * vw->Vpixel;
	vw->uv.y1 =  0.5 * rf * vw->Vpixel;

	vw->uv.x0 = -0.5 * rf * vw->Upixel;
	vw->uv.x1 =  0.5 * rf * vw->Upixel;

	view_per_set( vw, &vw->cp, 1, &vw->N, 1, &vw->V, 1 );
	view_set_pixel( vw, row, column );
}
