/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************
 ***	ViewPlane.c   ***
 ************************/
#include	<stdio.h>
#include	<math.h>


#include	"ViewType.h"



void
view_plane_g2v( view_type *vw,
		vec3d *N, vec3d *P, plane3d *plane )
{
vec3d	p1,	p2;
 
	plane->n.x = VEC3D_INNER( vw->U, *N );
	plane->n.y = VEC3D_INNER( vw->V, *N );
	plane->n.z = -VEC3D_INNER( vw->N, *N );
 
	p1.x = P->x - vw->cp.x;
	p1.y = P->y - vw->cp.y;
	p1.z = P->z - vw->cp.z;
 
	p2.x = VEC3D_INNER( vw->U, p1 );
	p2.y = VEC3D_INNER( vw->V, p1 );
	p2.z = -VEC3D_INNER( vw->N, p1 );
 
	plane->d =  -VEC3D_INNER( p2, plane->n );
} 
