/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	OcpLFrame.c	***
 **************************/
#include	<math.h>

#include	"Uigp/igp.h"


#include	"VimageType/OcpType.h"




ocp_type *
ocp_affine( ocp_type *cp0, ocp_type *cp1, float t, ocp_type *cp )
{
config3d	gc;


	if( cp == NULL ){
		cp = ocp_make_copy( cp0 );
		cp->Fgc = 0;
	}






	gc.x = t *cp1->dgc.x;
	gc.y = t *cp1->dgc.y;
	gc.z = t *cp1->dgc.z;
	gc.u1 = 0;
	gc.u2 = 0;
	gc.u3 = 0;


	cp->gc.x = cp0->gc.x + gc.x;
	cp->gc.y = cp0->gc.y + gc.y;
	cp->gc.z = cp0->gc.z + gc.z;
	cp->gc.u1 = cp->gc.u2 = cp->gc.u3 = 0;




	cp->c.x = (1 - t ) *cp0->c.x + t *cp1->c.x;
	cp->c.y = (1 - t ) *cp0->c.y + t *cp1->c.y;

        cp->dp.x = (1 - t ) *cp0->dp.x + t *cp1->dp.x;
        cp->dp.y = (1 - t ) *cp0->dp.y + t *cp1->dp.y; 



	skl_affine( cp0->skl, cp1->skl, t, cp->skl );


	return( cp );
}
