/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***    OcpLShot.c     ***
 **************************/
#include        <math.h>
 
#include	"Uigp/igp.h"
 
 
#include	"VimageType/OcpType.h" 






/***** ocpL_anim_init *****
Description:The method sets the first cp at 0,0 and moves all the rest by the same Delta.
Params:ocp - the list
		fInit3D - flag - erase the 3d information? (1 - yes, 0 - no)
Returns:
*****************************/
void ocpL_shot_init( ocp_list *ocp )
{

ocp_type	*cp,	*lcp;
config3d c;
int	fno;

	c = ocp->cp->c;

	for( cp = ocp->cp, fno = 0 ; cp != NULL ; cp = cp->next ){
		cp->fno = fno;
		fno += cp->dfno;

		cp->Fshot = SHOT_MID;
	
		cp->Fgc = 0;
		cp->c.x -= c.x;
		cp->c.y -= c.y;

		lcp = cp;
	}


	ocp->cp->Fgc = 1;
	

	lcp->Fshot = SHOT_END;
	lcp->Fgc = 1;
	config3d_init( &ocp->cp->gc );
	config3d_init( &lcp->gc );
	
}

