/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	OcpLTool1.c	***
 **************************/
#include	<math.h>

#include	"Uigp/igp.h"


#include	"VimageType/OcpType.h"






ocp_list *
ocpL_copy_segmentN( ocp_list *socp, int *f0, int *f1 )
{
ocp_list	*ocp;
ocp_type	*cp,	*pcp, *cp0;


	
	cp0 = ocpLF_get_kf( socp, *f0 );

	if( cp0 == NULL ){
		if( socp->cp == NULL || socp->cp->fno >= *f1 )	return( NULL );
		cp0 = socp->cp;
		*f0 = cp0->fno;
	}

	if( cp0->fno < *f0 && cp0->Fshot == SHOT_END ){
		if( cp0->next == NULL )	return( NULL );
		*f0 = cp0->next->fno;
		cp0 = cp0->next;
	}

	if( *f0 > *f1 )	return( NULL );
	
	pcp = ocpLF_copy( socp, *f0 );
	if( pcp == NULL )	return( NULL );

	pcp->fno = 0;


	ocp = ocpL_alloc();

	ocp->cp = pcp;
	ocp->no = 1;

	while( cp0->fno+cp0->dfno <= *f1 ){
		cp0 = cp0->next;
		cp = ocp_make_copy( cp0 );
		cp->fno -= *f0;

		pcp->next = cp;
		pcp->dfno = cp->fno - pcp->fno;

		ocp->no++;

		pcp = cp;

		if( cp0->next == NULL ){
			*f1 = cp0->fno;
			break;
		}
	}


	if( cp0->fno < *f1 && (cp = ocpLF_copy( socp, *f1 )) != NULL ){

		cp->fno -= *f0;

		pcp->next = cp;
		pcp->dfno = cp->fno - pcp->fno;

		ocp->no++;

		pcp = cp;
	}

	*f1 = *f0 + pcp->fno;

	pcp->Fshot = SHOT_END;
	pcp->Fgc = 1;
	pcp->dfno = 1;
	pcp->next = NULL;



	return( ocp );
}









ocp_type *
ocpL_add_segmentN( ocp_list *ocp, int frame, ocp_list *ocp_n )
{
ocp_type	*cp;
ocp_type	*pcp0,	*pcp1,	*cp0;
ocp_type	*ncp1;
int	fno;



	fno = ocpL_anim_init( ocp_n, 1 );

	for( ncp1 = ocp_n->cp ; ncp1->next != NULL ; ncp1 = ncp1->next );


	cp0 = ocpLF_force_kf( ocp, frame );
	pcp0 = ocpLF_get_kf( ocp, frame-1 );

	if( cp0 != NULL ){
		for( cp = ocp_n->cp ; cp->next != NULL ; cp = cp->next ){
			cp->c.x += cp0->c.x;
			cp->c.y += cp0->c.y;
		}

		if( cp0->Fgc == 1 ){
			ocp_n->cp->Fgc = 1;
			ocp_n->cp->gc = cp0->gc;
		}
		else	ocp_n->cp->Fgc = 0;
	}


	pcp1 = ocpLF_get_kf( ocp, frame + fno - 1 );



	if( pcp1->next != NULL ){
		ncp1->next = pcp1->next;
		ncp1->Fshot = pcp1->Fshot;

		pcp1->next = NULL;
	}
	else	{
		ncp1->Fgc = 1;
		ncp1->Fshot = SHOT_END;
	}



	if( pcp0 != NULL ){
		cp0 = pcp0->next;
		pcp0->next = ocp_n->cp;
	}
	else	{
		cp0 = ocp->cp;
		ocp->cp = ocp_n->cp;

		ocp->cp->Fgc = 1;
	}






	while( ( cp = cp0 ) != NULL ){
		cp0 = cp0->next;
		ocp_free( cp );
	}


	for( cp = ocp->cp, ocp->no = 0 ; cp != NULL ; cp = cp->next, ocp->no++ );
	
	ocp_n->cp = NULL;
	ocp_n->no = 0;

	return( cp );
}
