/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/***********************
 ***    TcpTool.c    ***
 ***********************/
#include	"Uigp/igp.h"



#include	"VimageType/TcpType.h"





int
tcp_configuration( tcp_list *tcp, int fno, config3d *cp0, config3d *ocp )
{
tcp_type	*cp,	*cp1;
config3d	c;
float	t;


	cp = tcp->a_cp;
	while( cp->fno + cp->dfno <= fno )	cp = cp->next;
	tcp->a_cp = cp;


	if( cp->fno == fno ){
		c.x = cp->c.x + cp0->x;
		c.y = cp->c.y + cp0->y;
		c.z = cp->c.z + cp0->z;

		c.u1 = cp->c.u1 + cp0->u1;
		c.u2 = cp->c.u2 + cp0->u2;
		c.u3 = cp->c.u3 + cp0->u3;

		if( CONFIG3D_IS_EQUAL( c, *ocp ) )	return( 1 );
		*ocp = c;
		return( 0 );
	}

	t = ( fno - cp->fno ) / (float)cp->dfno;

	cp1 = cp->next;
	c.x = t*( cp1->c.x - cp->c.x ) + cp->c.x + cp0->x;
	c.y = t*( cp1->c.y - cp->c.y ) + cp->c.y + cp0->y;
	c.z = t*( cp1->c.z - cp->c.z ) + cp->c.z + cp0->z;

	c.u1 = t*( cp1->c.u1 - cp->c.u1 ) + cp->c.u1 + cp0->u1;
	c.u2 = t*( cp1->c.u2 - cp->c.u2 ) + cp->c.u2 + cp0->u2;
	c.u3 = t*( cp1->c.u3 - cp->c.u3 ) + cp->c.u3 + cp0->u3;

	if( CONFIG3D_IS_EQUAL( c, *ocp ) )	return( 1 );
	*ocp = c;
	return( 0 );
}
