/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include	<stdio.h>
#include	<math.h>


#include	"AnimCodingIn.h"


#include	"Ucode/code.h"
#include	"Ubst/BstType.h"
/*
#include	"Uprm/prm.h"
static code_in	Ax_in =   { -8.0, 8.0, 0.0078125, 0.0, 0.0 };
static code_in	Aangle_in = { -3.0, 3.0, 0.0078125, 0.0, 0.0 };
static code_in	ACcp_in = { -3.0, 3.0, 0.0078125, 0.0, 0.0 };
static code_in	Alen_in = { -3.0, 3.0, 0.125, 0.0, 0.0 };
static code_in	Aa_in = { -3.0, 3.0, 0.125, 0.0, 0.0 };
static code_in	Aang_in = { -3.0, 3.0, 1.0, 0.0, 0.0 };




#ifndef PLAYER
static GP_prm  Parames[]    =    {
        {"A-x-d",(char *)&Ax_in.d, PRM_FLOAT, "%.3f", "0.0078125"},
        {"A-angle-d",(char *)&Aangle_in.d, PRM_FLOAT, "%.3f", "0.0078125"},
        {"A-cp-d",(char *)&ACcp_in.d, PRM_FLOAT, "%.3f", "0.0078125"},
        {"A-len-d",(char *)&Alen_in.d, PRM_FLOAT, "%.3f", "0.125"},
        {"A-a-d",(char *)&Aa_in.d, PRM_FLOAT, "%.3f", "0.125"},
        {"A-ang-d",(char *)&Aang_in.d, PRM_FLOAT, "%.3f", "1.0"},
};
#endif
*/



codingA_type *
anim_coding_prm_get()
{
codingA_type	*cd;

	cd = (codingA_type *)malloc( sizeof(codingA_type) );

//	coding_set_lprm( &Ax_in, &cd->Ax, 1.0 );
	code_set( &cd->Ax, -8.0, 8.0, 0.0078125, 0.0, 1.0 );
	
//	coding_set_lprm( &Aangle_in, &cd->Aangle, 1.0 );
	code_set( &cd->Aangle, -3.0, 3.0, 0.0078125, 0.0, 1.0 );

//	coding_set_lprm( &ACcp_in, &cd->ACcp, 1.0 );
	code_set( &cd->ACcp, -3.0, 3.0, 0.0078125, 0.0, 1.0 );

//	coding_set_lprm( &Alen_in, &cd->Alen, 1.0 );
	code_set( &cd->Alen, -3.0, 3.0, 0.125, 0.0, 1.0 );

//	coding_set_lprm( &Aa_in, &cd->Aa, 1.0 );
	code_set( &cd->Aa, -3.0, 3.0, 0.125, 0.0, 1.0 );

//	coding_set_lprm( &Aang_in, &cd->Aang, 1.0 );
	code_set( &cd->Aang, -3.0, 3.0, 1.0, 0.0, 1.0 );

	return( cd );
}


void
anim_coding_prm_destroy( codingA_type * codingA )
{
	free( codingA );
}
