/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef		_ANIM_CODING_IN_
#define		_ANIM_CODING_IN_


#include	"Uprm/prm.h"
#include	"Ucode/code.h"

#include        "Ubst/BstType.h"



#include        "VimageType/OcpType.h"
#include        "VimageType/TcpType.h"



typedef struct codingA_type {
	code    Ax;
	code	Aangle;

	code    ACcp;
	code	Alen;
	code	Aa;
	code	Aang;


	/* AUX variable */
	int	Gtwo,	Gstatic;
	int	Gxbit,	Gybit,	Gzbit;
	int	Gu1_bit,	Gu2_bit,	Gu3_bit; 

	int	xbit,	ybit,	df_bit;	/* for c.x, c.y, dfno */
 	int	Sxy_bit,	Slen_bit,	Sa_bit,	Sang_bit;

}	codingA_type;



	/* AnimCoding.c */
codingA_type *	anim_coding_prm_get();
void		anim_coding_prm_destroy( codingA_type * codingA );





        /* AnimQuantize.c */
void	anim_quantize_ocp( ocp_list *ocp, codingA_type *cd );

void    anim_quantize_cp( ocp_type *cp, codingA_type *cd );
 
void    anim_quantize_tcp( tcp_type *acp, int cp_no, codingA_type *cd );


		/* OcpQuantize.c */
void	ocp_quantize( skl_type *skl, ocp_list *ocp, codingA_type *cd );



#endif
