/***************************
 ***	OcpDecoding.c    ***
 **************************/
#include	<stdio.h>
#include	<math.h>

#include        "Ubst/BstType.h"


#include	"VimageType/OcpType.h"

#include	"AnimCodingIn.h"




static ocp_type *	anim_decoding_cp( ocp_type *rcp, int cp_no,
				codingA_type *cd, bst_type *bst );

static void	anim_decoding_skl( skl_type *rskl, skl_type *skl,
				 codingA_type *cd, bst_type *bst );
static void	anim_decoding_lnk( lnk_type *rlink,
				vec2d *ctr, lnk_type *link,
				 codingA_type *cd, bst_type *bst );
static void	anim_decoding_lnk_1( lnk_type *rlink,
				vec2d *ctr, lnk_type *link,
				 codingA_type *cd, bst_type *bst );


static void	anim_decoding_ocp_gc( ocp_type *cp,
					 codingA_type *cd, bst_type *bst );




ocp_list *
ocp_decoding( skl_type *skl, bst_type *bst )
{
ocp_list	*ocp;
codingA_type *cd;
ocp_type	*cp,	*rcp,	**lcp;
ocp_type	*bcp;
int	nKf,	head;
int	i,	fno; 

	cd = anim_coding_prm_get(); 

 
	bcp = ocp_alloc( skl );
	bcp->Fshot = SHOT_MID;
 
 
	ocp = ocpL_alloc();



	head = bst_get_int( bst, 8 );
 


	cd->xbit = bst_get_int( bst, 5 );
	cd->ybit = bst_get_int( bst, 5 );
	cd->df_bit = bst_get_int( bst, 4 );


	cd->Sxy_bit = bst_get_int( bst, 5 );
	cd->Slen_bit = bst_get_int( bst, 5 );
	cd->Sa_bit = bst_get_int( bst, 5 );



	cd->Gtwo = bst_get( bst );
	cd->Gstatic = bst_get( bst );

	if( cd->Gstatic == 0 ){
		cd->Gxbit = bst_get_int( bst, 5 );
		cd->Gybit = bst_get_int( bst, 5 );
		cd->Gzbit = bst_get_int( bst, 5 );
		cd->Gu1_bit = bst_get_int( bst, 5 );
		cd->Gu2_bit = bst_get_int( bst, 5 );
		cd->Gu3_bit = bst_get_int( bst, 5 );
	}


	ocp->no = 0;
	ocp->cp = NULL;
	lcp = &ocp->cp;


	nKf = bst_get_int( bst, 16 );


	fno = bst_get_int( bst, cd->df_bit );


	rcp = bcp;
	for( i = 0 ; i < nKf ; i++ ){
		cp = anim_decoding_cp( rcp, rcp == bcp, cd, bst );

		cp->fno = fno;
		fno += cp->dfno;


		*lcp = cp;
		lcp = &(*lcp)->next;
		*lcp = NULL;
		ocp->no++;

		rcp = ( cp->Fshot != SHOT_END )? cp : bcp;
	}

/*
	while ( bst_get( bst ) != 0 ){

		rcp = bcp;
		do {
			cp = anim_decoding_cp( rcp, rcp == bcp, cd, bst );

			cp->fno = fno;
			fno += cp->dfno;


			*lcp = cp;
			lcp = &(*lcp)->next;
			*lcp = NULL;
			ocp->no++;

			rcp = ( cp->Fshot != SHOT_END )? cp : bcp;

		} while( cp->Fshot != SHOT_END );
	}
*/



	ocp_free( bcp );

 

	anim_coding_prm_destroy( cd );
 
	return( ocp );
}





static ocp_type *
anim_decoding_cp( ocp_type *rcp, int Fbegin,
		codingA_type *cd, bst_type *bst )
{
ocp_type	*cp;

	cp = ocp_make_copy( rcp );

	cp->c.x = rcp->c.x;
	cp->c.y = rcp->c.y;
	cp->Fshot = SHOT_MID;
	cp->dfno = 1;



	if( bst_get( bst ) == 1 )
		cp->Fshot = SHOT_END;



	cp->dfno = bst_get_int( bst, cd->df_bit ) + 1;


	if( bst_get( bst ) == 1 ){

		if( cd->xbit != 0 )
			cp->c.x = bst_get_float_code( bst, &cd->ACcp, cd->xbit);
		else	cp->c.x = 0;

		if( cd->ybit != 0 )
			cp->c.y = bst_get_float_code( bst, &cd->ACcp, cd->ybit);
		else	cp->c.y = 0;
	}




	anim_decoding_skl( rcp->skl, cp->skl, cd, bst );



	/* gc */
	if( cp->Fshot == SHOT_MID && Fbegin == 0 )
			cp->Fgc = ( cd->Gtwo == 0 )? bst_get( bst ) : 0;
	else	cp->Fgc = 1;


	if( cd->Gstatic == 0 && cp->Fgc == 1 )
		anim_decoding_ocp_gc( cp, cd, bst );
	else	config3d_init( &cp->gc );


	return( cp );
}




static void
anim_decoding_skl( skl_type *rskl, skl_type *skl,
				codingA_type *cd, bst_type *bst )
{
jskl_type	*rj,	*jnt;
vec2d	dv;
int	i,	k;

	cd->Sang_bit = bst_get_int( bst, 4 );

	skl_topology( skl );

	for( jnt = skl->jnt ; jnt != NULL ; jnt = jnt->nj )     jnt->no = -1;
	
	for( rj = rskl->jnt, i = 0, jnt = skl->jnt ; rj != NULL ;
					rj = rj->nj, jnt = jnt->nj, i++ ){

		if( jnt->Ftopology == 1 && cd->Sxy_bit != 0 ){
			if( bst_get( bst ) == 1 ){
				dv.x = bst_get_float_code( bst, &cd->Aa, cd->Sxy_bit);
				dv.y = bst_get_float_code( bst, &cd->Aa, cd->Sxy_bit);
				jnt->ctr.x = rj->ctr.x + dv.x;
				jnt->ctr.y = rj->ctr.y + dv.y;

			}
			else	jnt->ctr = rj->ctr;

			jnt->no = i;
		}
		else	if( jnt->pl != NULL )   jnt->ctr = rj->ctr;


		for( k = 0 ; k < jnt->bno ; k++ ){
			if( jnt->b[k].direct != F_BEGIN )	continue;

			if( jnt->b[k].link->width == 0 )
				anim_decoding_lnk_1( rj->b[k].link,
					&jnt->ctr, jnt->b[k].link, cd, bst );
			else	anim_decoding_lnk( rj->b[k].link,
					&jnt->ctr, jnt->b[k].link, cd, bst );
		}
	}


	skl_update_attach( skl );
}


static void
anim_decoding_lnk( lnk_type *rlink, vec2d *ctr, lnk_type *link,
				codingA_type *cd, bst_type *bst )
{
jskl_type       *jnt;
lnk_type        *rl,    *l,     *pl;
float	t,	u,	angle1;
float   len,      a;
float   angle,  cosa,   sina;
vec2d   pu,	pru,	v;
int     flag;

        pu.x = pru.x = 1.0;
        pu.y = pru.y = 0.0;

        for( l = link, rl = rlink, v = *ctr ; l != NULL ;
                        l = LNK_NEXT(l), rl = LNK_NEXT(rl) ){


		l->ctr = v;


		if( LNK_NEXT(l) == NULL && (jnt = l->p[F_END].p.jnt) != NULL ){
			if( jnt->Ftopology != 0 ){
				if( bst_get( bst ) == 1 ){
					a = bst_get_float_code( bst, &cd->Aa,cd->Sa_bit);
					l->a = rl->a + a;
				}
				else	l->a = rl->a;

				l->v.x = jnt->ctr.x - l->ctr.x;
				l->v.y = jnt->ctr.y - l->ctr.y;
				lnk_set_aux( l );

				return;
			}

			jnt->Ftopology = -1;
		}


		flag = bst_get_int( bst, 2 );

                switch( flag ){
                case 0: 
                        angle = 0;
                        len = 0.0;
                        a = 0;
                    break;

                case 1:  
			angle = bst_get_float_code( bst, &cd->Aang, cd->Sang_bit);
                        len = 0.0;
                        a = 0;
                    break;

                case 2:  
			angle = bst_get_float_code( bst, &cd->Aang, cd->Sang_bit);
			a = bst_get_float_code( bst, &cd->Aa, cd->Sa_bit );
                        len = 0.0;
                    break;
 
                case 3:
			angle = bst_get_float_code( bst, &cd->Aang, cd->Sang_bit);
			len = bst_get_float_code( bst, &cd->Alen, cd->Slen_bit);
			a = bst_get_float_code( bst, &cd->Aa, cd->Sa_bit);
                    break;
                }


                t = rl->u.x * pru.x + rl->u.y * pru.y;
                u = rl->u.x * pru.y - rl->u.y * pru.x;

                angle1 = atan2( u, t ) *180/M_PI;

                angle += angle1;


                angle *= M_PI/180;
                cosa = cos( angle );
                sina = sin( angle );

                l->u.x = cosa * pu.x + sina * pu.y;
                l->u.y = cosa * pu.y - sina * pu.x;




/*
                angle *= M_PI/180;
                cosa = cos( angle );
                sina = sin( angle );
 
                l->u.x = cosa * rl->u.x + sina * rl->u.y;
                l->u.y = cosa * rl->u.y - sina * rl->u.x;
*/
 
                l->len = rl->len  + len;
                l->a = rl->a + a;
                l->c_prb = -4.0 *l->a/( l->len*l->len);
 
 
                l->v.x = - l->len * l->u.y;
                l->v.y = l->len * l->u.x;
 
 
 
                v.x += l->v.x;
                v.y += l->v.y;
 
                pl = l;
        }


        if( (jnt = pl->p[F_END].p.jnt) == NULL )        return;
 
        if( jnt->no < 0 ){
                jnt->ctr.x = pl->ctr.x + pl->v.x;
                jnt->ctr.y = pl->ctr.y + pl->v.y;
                jnt->no = 100;
                return;
        }
 
        pl->v.x = jnt->ctr.x - pl->ctr.x;
        pl->v.y = jnt->ctr.y - pl->ctr.y;
        lnk_set_aux( pl );
}





static void
anim_decoding_lnk_1( lnk_type *rlink, vec2d *ctr, lnk_type *link,
					codingA_type *cd, bst_type *bst )
{
jskl_type       *jnt;
lnk_type        *rl,    *l,     *pl;
float   angle,	len,      a;
float   cosa,   sina,   angle1;
vec2d   v,      pu,     pru;
float   t1,     u1;
int     flag;
 
    pu.x = pru.x = 1.0;
    pu.y = pru.y = 0.0;

    for( l = link, rl = rlink, v = *ctr ; l != NULL ;
                    l = LNK_NEXT(l), rl = LNK_NEXT(rl) ){

		l->ctr = v;

		flag = bst_get_int( bst, 2 );


		switch( flag ){
		case 0:
				angle = 0;
				len = 0;
				a = 0;
			break;

		case 1:
				angle = bst_get_float_code( bst, &cd->Aang, cd->Sang_bit);
				len = 0;
				a = 0;
			break;

		case 2:
				angle = bst_get_float_code( bst, &cd->Aang, cd->Sang_bit);
				a = bst_get_float_code( bst, &cd->Aa, cd->Sa_bit);
				len = 0;
			break;

		case 3:
				angle = bst_get_float_code( bst, &cd->Aang, cd->Sang_bit);
				len = bst_get_float_code( bst, &cd->Alen, cd->Slen_bit);
				a = bst_get_float_code( bst, &cd->Aa, cd->Sa_bit);
			break;
		}


		t1 = rl->u.x * pru.x + rl->u.y * pru.y;
		u1 = rl->u.x * pru.y - rl->u.y * pru.x;

		angle1 = atan2( u1, t1 ) *180/M_PI;

		angle += angle1;


		angle *= M_PI/180;
		cosa = cos( angle );
		sina = sin( angle );

		l->u.x = cosa * pu.x + sina * pu.y;
		l->u.y = cosa * pu.y - sina * pu.x;



		l->len = rl->len + len;
		l->a = rl->a + a;
		l->c_prb = -4.0 *l->a/( l->len*l->len);


		l->v.x = - l->len * l->u.y;
		l->v.y = l->len * l->u.x;



		pu = l->u;
		pru = rl->u;

		v.x += l->v.x;
		v.y += l->v.y;

		pl = l;
    }


        if( (jnt = pl->p[F_END].p.jnt) == NULL )        return;
 
        if( jnt->no < 0 ){
                jnt->ctr.x = pl->ctr.x + pl->v.x;
                jnt->ctr.y = pl->ctr.y + pl->v.y;
                jnt->no = 100;
                return;
        }

        pl->v.x = jnt->ctr.x - pl->ctr.x;
        pl->v.y = jnt->ctr.y - pl->ctr.y;
        lnk_set_aux( pl );
}



static void
anim_decoding_ocp_gc( ocp_type *cp, codingA_type *cd, bst_type *bst )
{
        cp->gc.x = bst_get_float_code( bst, &cd->Ax, cd->Gxbit );

        cp->gc.y = bst_get_float_code( bst, &cd->Ax, cd->Gybit );

        cp->gc.z = bst_get_float_code( bst, &cd->Ax, cd->Gzbit );

        cp->gc.u1 = bst_get_float_code( bst, &cd->Aangle, cd->Gu1_bit );

        cp->gc.u2 = bst_get_float_code( bst, &cd->Aangle, cd->Gu2_bit );

        cp->gc.u3 = bst_get_float_code( bst, &cd->Aangle, cd->Gu3_bit );
}
