/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	TcpDecoding.c   ***
 **************************/
#include	<stdio.h>
#include	<math.h>
#include	<string.h>

#include	"VimageType/TcpType.h"

#include	"AnimCodingIn.h"
#include	"Ubst/BstType.h"


tcp_list *
tcp_decoding( int frame_no, bst_type *bst )
{
codingA_type *cd;
tcp_list	*tcp;
tcp_type        *cp;
int	xbit,	ybit,	zbit,	u1_bit,	u2_bit,	u3_bit,	fno_bit;
int	no;


	tcp = tcpL_alloc();

	if( bst_get( bst ) == 0 ){
		tcpL_clear( tcp, 2, frame_no );
		return( tcp );
	}


	cd = anim_coding_prm_get();


	no = bst_get_int( bst, 8 );
	tcpL_clear( tcp, no, frame_no );


        xbit = bst_get_int( bst, 5 );
        ybit = bst_get_int( bst, 5 );
        zbit = bst_get_int( bst, 5 );
        u1_bit = bst_get_int( bst, 5 );
        u2_bit = bst_get_int( bst, 5 );
        u3_bit = bst_get_int( bst, 5 );
	

	fno_bit = coding_ilog2( frame_no );

	for( cp = tcp->cp ; cp != NULL ; cp = cp->next ){
        	cp->fno = bst_get_int( bst, fno_bit );

		if( xbit != 0 )
			cp->c.x = bst_get_float_code( bst, &cd->Ax, xbit );


		if( ybit != 0 )
			cp->c.y = bst_get_float_code( bst, &cd->Ax, ybit );

		if( zbit != 0 )
			cp->c.z = bst_get_float_code( bst, &cd->Ax, zbit );


		if( u1_bit != 0 )
			cp->c.u1 = bst_get_float_code( bst,
						&cd->Aangle, u1_bit );

		if( u2_bit != 0 )
			cp->c.u2 = bst_get_float_code( bst,
						&cd->Aangle, u2_bit );

		if( u3_bit != 0 )
			cp->c.u3 = bst_get_float_code( bst,
						&cd->Aangle, u3_bit );
	}


//	tcpL_rescale( tcp, frame_no, frame_no );
	tcpL_rescale_frame( tcp, frame_no, frame_no );


	anim_coding_prm_destroy( cd );


	return( tcp );
}
