/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	TcpEncodingp.c	***
 *************************/
#include	<math.h>

#include	"Ubst/BstType.h"


#include	"BframeType.h"


bframeL_type *
bframeL_decoding( bst_type *bst )
{
bframeL_type *bfL;
bframe_type		*bf,	*pbf;
int	no,	i;
int	head,	bitFno;
int	bitFlashing,	bitLedFlashing,	bitVibration,	bitDelay;


	bfL = bframeL_alloc();


	head = bst_get_int( bst, 8 );

	bitFno = bst_get_int( bst, 4 );


	if( head & BFRAME_DELAY )
		bitDelay = bst_get_int( bst, 4 );

	if( head & BFRAME_FALSHING )
		bitFlashing = bst_get_int( bst, 4 );

	if( head & BFRAME_LED_FALSHING )
		bitLedFlashing = bst_get_int( bst, 4 );

	if( head & BFRAME_VIBRATION )
		bitVibration = bst_get_int( bst, 4 );



	no = bst_get_int( bst, bitFno );


	for( i = 0 ; i < no ; i++ ){
		bf = bframe_alloc();
        bf->fno = bst_get_int( bst, bitFno );

		bf->priority = -1;
		if( head & BFRAME_PRIORITY ){
			bf->priority = bst_get_int( bst, 2 );

			if( head & BFRAME_DELAY )
				bf->delay = bst_get_int( bst, bitDelay );
		}



		if( head & BFRAME_FALSHING )
			bf->flashing = bst_get_int( bst, bitFlashing );

		if( head & BFRAME_LED_FALSHING )
			bf->ledFlashing = bst_get_int( bst, bitLedFlashing );

		if( head & BFRAME_VIBRATION )
			bf->vibration = bst_get_int( bst, bitVibration );


		if( bfL->bf == NULL )
			bfL->bf = bf;
		else	pbf->next = bf;

		pbf = bf;
	}

	return( bfL );
}



