/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef         _BFRAME_TYPE_
#define         _BFRAME_TYPE_

#include	"Ubst/BstType.h"


// bfarme.priority
#define		BFRAME_PRIORITY_NONE	0
#define		BFRAME_PRIORITY_LOW		1
#define		BFRAME_PRIORITY_MEDIUM	2
#define		BFRAME_PRIORITY_HIGH	3




// for coding
#define		BFRAME_PRIORITY		0x01
#define		BFRAME_DELAY		0x02
#define		BFRAME_FALSHING		0x04
#define		BFRAME_LED_FALSHING	0x08
#define		BFRAME_VIBRATION	0x10



typedef struct bframe_type {
	int     fno;

	int		priority;

	int		delay;

	int		flashing;
	int		ledFlashing;
	int		vibration;

	struct bframe_type *next;

}	bframe_type;



typedef struct bframeL_type {

	bframe_type	*bf;

}	bframeL_type;




bframe_type *	bframe_alloc();
void	bframe_destroy( bframe_type *bf );


bframeL_type *	bframeL_alloc();
void	bframeL_destroy( bframeL_type *bfL );

int		bframeL_set( bframeL_type *bfL, int frame, int priority, int delay,
				int flashing, int ledFlashing, int vibration );

int		bframeL_set_bframe( bframeL_type *bfL, int frame, bframe_type *bf );


bframe_type *	bframeL_get( bframeL_type *bfL, int frame );


void	bframeL_clip( bframeL_type *bfL, int maxFrame );

void	bframeL_delete( bframeL_type *bfL, int frame );

bframe_type *	bframeL_get_previous( bframeL_type *bfL, int frame );

bframeL_type *	bframeL_copy_segment( bframeL_type *bfL, int minFrame, int maxFrame, int Frame0
									 );

void	bframeL_fno_add( bframeL_type *bfL, int frame0 );


void	bframeL_rescale_frame( bframeL_type *bfL, int cframe_no, int frame_no );


	/* BframeDecoding.c */
bframeL_type *	bframeL_decoding( bst_type *bst );

bframeL_type *	bframeL_decoding0005( int frame_no, bst_type *bst );

bframeL_type *	bframeL_decoding0002( int frame_no, bst_type *bst );


	/* BframeDecoding.c */
void	bframeL_encoding( bframeL_type *bfL, bst_type *bst );

	/* BframeDecoding.c */
int	bframeL_append( bframeL_type *bfL, bframeL_type *abfL, int startFrame );

#endif
