/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**********************************
 ***	InteractionDecoding.c	***
 **********************************/
#include	<math.h>

#include	"Ubst/BstType.h"
#include	"AnimCoding/AnimCoding.h"

#include	"InteractionType.h"


interactionL_type *
interactionL_decoding( skl_type *skl, bst_type *bst )
{
interactionL_type	*inL;
interaction_type		*in,	*pin;
int	fno_bit,	head;


	inL = interactionL_alloc();


	head = bst_get_int( bst, 8 );



	fno_bit = bst_get_int( bst, 4 );

	pin = NULL;
	while( bst_get( bst ) == 1 ){
		in  = interaction_alloc();


		in->trigger = bst_get_int( bst, 4 );

		if( in->trigger == TRIGGER_FRAME )
			in->fno = bst_get_int( bst, fno_bit );


		in->type = bst_get_int( bst, 4 );


		switch( in->type ){
		case INTERACTION_SOUND:
		case INTERACTION_LINK:
		case INTERACTION_REPLACE:
		case INTERACTION_MERGE:
			bst_get_string( bst, in->url, URL_LEN );
			break;

		case INTERACTION_ANIMATATION:
			in->ocpL = ocp_decoding( skl, bst );
			break;
		}



		in->next = NULL;

		if( pin == NULL )
				inL->in = in;
		else	pin->next = in;

		pin = in;
	}

	return( inL );
}
