/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef		_RENDER_H_
#define		_RENDER_H_

#include	"Uigp/igp.h"
#include	"Uview/ViewType.h"

#include	"GpType/GpType.h"

#include        "SklType/LnkType.h"


	/* RenderAgp.c */
void	render_agp( view_type *base, gp_array *agp, float depth0, float depth1,
			view_type *vw, gp_array *nagp );


void	render_point( view_type *base, vec2d *p, float depth,
				view_type *vw, vec2d *np, float *ndepth );

void	render_point_inv( view_type *vw, vec2d *np, float depth,
                                                view_type *base, vec2d *p );



	/* RenderAgpPl.c */
void	render_agp_pl( view_type *base, gp_array *agp,
				float depth0, float depth1,
                                view_type *vw, gp_array *nagp );



	/* RenderAgpPlW.c */
void	render_agp_plw( view_type *base, gp_array *agp,
				float depth0, float depth1,
                                view_type *vw, gp_array *nagp );



	/* hyputA.c */
float	hypotA( float x, float y );



	/* RenderAgpClear.c */
void	render_agp_clear( gp_array *agp, int bgp, int row, int column, mbr_type Sbr);



	/* RenderAux.c */
void	render_agp_aux( gp_array *agp );

void	render_agp_aux_free( gp_array *agp );


	/* RenderAuxPl.c */
void	agp_pl( gp_array *agp, lnk_type *link[], int no );
 
void	agp_pl_free( gp_array *agp );
 
void	agp_pl_init( gp_array *agp );

#endif
