/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/******************************
 ***    RenderAgpClear.c    ***
 ******************************/
#include        <stdio.h>   
#include	<math.h>

#include        "Uview/ViewType.h"

#include        "Render.h"



void
render_agp_clear( gp_array *agp, int bgp, int row, int column, mbr_type Sbr )
{
gp_type	*gp;
jnt_type	**jnt;
link_type	**link;
bgp_type	**bp;
hunch_type	**h;
int     i,      j,	br;

	if( agp->bgp != bgp || agp->row != row || agp->column != column ){
		gp_array_free( agp );
		agp_init( agp, bgp, row, column, 8*bgp, 8*bgp );

		agp->Fn3_prime = 1;
		agp->type = AGP_RENDER;
		agp->color_type = AGP_RGB;
		return;
	}

 
	if( Sbr == 0 ){
        for( i = 0 ; i < agp->Ni; i++ )
                for( j = 0 ; j < agp->Nj; j++ ){
			gp = &agp->gp[i][j];

		        gp->hunch = NULL;

			gp->jnt = NULL;

			gp->link = NULL;

			gp->bgp = NULL;
		}

		return;
	}



	for( i = 0 ; i < agp->Ni; i++ )
		for( j = 0 ; j < agp->Nj; j++ ){
			gp = &agp->gp[i][j];

			for( h = &gp->hunch ; *h != NULL ; ){
//				if( Sbr & (1L<< (*h)->br) )
				if( MBR_IS_SET(Sbr, (*h)->br) )
					h = &(*h)->nh;
				else	*h = (*h)->nh;
			}

			for( bp = &gp->bgp ; *bp != NULL ; ){
//				if( Sbr & (1L<< (*bp)->br) )
				if( MBR_IS_SET(Sbr, (*bp)->br) )
					bp = &(*bp)->p;
				else	*bp = (*bp)->p;
			}

			for( jnt = &gp->jnt ; *jnt != NULL ; ){
				br = (*jnt)->brn[0]->link->br;

//				if( Sbr & (1L<< br) )
				if( MBR_IS_SET(Sbr, br) )
					jnt = &(*jnt)->nj;
				else	*jnt = (*jnt)->nj;
			}

			for( link = &gp->link ; *link != NULL ; ){
//				if( Sbr & (1L<< (*link)->br) )
				if( MBR_IS_SET(Sbr, (*link)->br) )
					link = &(*link)->nl;
				else	*link = (*link)->nl;
			}
		}
 
 
}
