/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*************************
 ***	RenderAux.c    ***
 *************************/
#include	<stdio.h>   
#include	<math.h>

#include	"Render.h"





void
render_agp_aux( gp_array *agp )
{
gp_type		*gp;
bgp_type	*bgp;
hunch_type	*h;
link_type	*link;
//jnt_type	*jnt;
int	i,	j;
  


	/* copy nf and jnt  */
	for( i = 0 ; i < agp->Ni ; i++ )
		for( j = 0 ; j < agp->Nj ; j++ ){
			gp = &agp->gp[i][j];

			for( h = gp->hunch ; h != NULL ; h = h->nh ){
				h->rctr.x = gp->ctr.x + h->ctr.x;
				h->rctr.y = gp->ctr.y + h->ctr.y;
				h->rdepth = h->depth;

				h->rnh = h->nh;
			}

			for( bgp = gp->bgp ; bgp != NULL ; bgp = bgp->p ){
				bgp->rctr.x = gp->ctr.x + bgp->ctr.x;
				bgp->rctr.y = gp->ctr.y + bgp->ctr.y;
				bgp->rdepth = bgp->depth;

				bgp->rp = bgp->p;
			}


			for( link = gp->link ; link != NULL ; link = link->nl ){
				link->rctr.x = gp->ctr.x + link->ctr.x;
				link->rctr.y = gp->ctr.y + link->ctr.y;
				link->rv = link->v;
				link->ra = link->a / link->len;

				link->pr[0].p->rdepth = link->pr[0].p->depth;
				link->pr[1].p->rdepth = link->pr[1].p->depth;

				link->rnl = link->nl;
			}


/*
			for( jnt = gp->jnt ; jnt != NULL ; jnt = jnt->nj ){
				jnt->rctr = jnt->gctr;
				jnt->rdepth = jnt->depth;
				jnt->rnj = jnt->nj;
			}
*/
		}
}








void
render_agp_aux_free( gp_array *agp )
{
gp_type		*gp;
bgp_type	*bgp;
hunch_type	*h;
jnt_type	*jnt;
link_type	*link;
int	i,	j,	k;
brn_type	*b;
 
 
 
	for( i = 0 ; i < agp->Ni ; i++ )
		for( j = 0 ; j < agp->Nj ; j++ ){
			gp = &agp->gp[i][j];
 
			for( h = gp->hunch ; h != NULL ; h = h->rnh ){

				h->ctr.x = h->rctr.x - gp->ctr.x;
				h->ctr.y = h->rctr.y - gp->ctr.y;
				h->depth = h->rdepth;

				h->nh = h->rnh;

			} 
 
			for( bgp = gp->bgp ; bgp != NULL ; bgp = bgp->rp ){

				bgp->ctr.x = bgp->rctr.x - gp->ctr.x;
				bgp->ctr.y = bgp->rctr.y - gp->ctr.y;
				bgp->depth = bgp->rdepth;

				bgp->p = bgp->rp;
			}


			for( link = gp->link ; link != NULL ; link = link->nl ){
				link->ctr.x = link->rctr.x - gp->ctr.x;
				link->ctr.y = link->rctr.y - gp->ctr.y;
				link->v = link->rv;

				link_set_aux( link );
				link->a = link->ra * link->len;
				link_set_aux( link );


				link->pr[0].p->depth = link->pr[0].p->rdepth;
				link->pr[1].p->depth = link->pr[1].p->rdepth;

				link->nl = link->rnl;
			}

 
 
/*
			for( jnt = gp->jnt ; jnt != NULL ; jnt = jnt->nj ){
				jnt->gctr = jnt->rctr;
				jnt->ctr.x = jnt->gctr.x - gp->ctr.x;
				jnt->ctr.y = jnt->gctr.y - gp->ctr.y;
				jnt->depth = jnt->rdepth;
				jnt->nj = jnt->rnj;
			}
*/
		}



	for( i = 0 ; i < agp->Ni ; i++ )
	    for( j = 0 ; j < agp->Nj ; j++ ){
		gp = &agp->gp[i][j];

		for( jnt = gp->jnt ; jnt != NULL ; jnt = jnt->nj ){
			if( jnt->type == JNT_N3 ){
				b = jnt->brn[0];
				if( b->type == NF_N3 && b->direction == F_BEGIN)
					link_set_geo_aux( b->link );
				continue;
			}

			if( jnt->type != JNT_RN3 )	continue;
			for( k = 0 ; k < jnt->brn_no ; k++ ){
				b = jnt->brn[k];
				if( b->type == NF_N3 && b->direction == F_BEGIN)
					link_set_geo_aux( b->link );
			}
		}
	    }
}
