/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/

/******************
 ***	AgpPl.c	***
 ******************/

#include	<stdio.h>   
#include	<math.h>

#include	"GpType/GpType.h"


#include	"SklType/LnkType.h"

#include	"SklType/PlType.h"


#include	"LinkTool/TlType.h"

static void    agp_link0x04( gp_array *agp,
				tl_type tlink[], int *no, int *mbr );

static void	agp_pl_bgp( bgp_type *bgp, lnk_type *link[], int no );

static void	agp_pl_hunch( hunch_type *h, lnk_type *link[], int no );

static void	agp_pl_link( link_type *l, lnk_type *link[], int no );

/*
static void	agp_pl_jnt( jnt_type *jnt, lnk_type *link[], int no );
*/

void	agp_pl_point1( lnk_type *link[], int no,
				vec2d *v, int br, pl_type **pl );


#define		TL_DIS	16
//static tl_type	Tlink[100];
//static int	Tno,	Tmbr;


void
agp_pl( gp_array *agp, lnk_type *link[], int no )
{
gp_type	*gp;
link_type	*l;
hunch_type	*hunch;
bgp_type	*bgp;
/*
jnt_type	*jnt;
*/
 
int	i,	j;
tl_type	Tlink[100];
int	Tno,	Tmbr;

	agp_link0x04( agp, Tlink, &Tno, &Tmbr );
 
	for( i = 0 ; i < agp->Ni ; i++ )
	    for( j = 0 ; j < agp->Nj ; j++ ){
		gp = &agp->gp[i][j];
 

		for( bgp = gp->bgp ; bgp != NULL ; bgp = bgp->rp )
			agp_pl_bgp( bgp, link, no );


		for( hunch = gp->hunch ; hunch != NULL ; hunch = hunch->rnh )
			agp_pl_hunch( hunch, link, no );


		for( l = gp->link ; l != NULL ; l = l->rnl )
			agp_pl_link( l, link, no );


/*
		for( jnt = gp->jnt ; jnt != NULL ; jnt = jnt->rnj )
			agp_pl_jnt( jnt, link, no );
*/
	    }
}



static void
agp_link0x04( gp_array *agp, tl_type tlink[], int *no, int *mbr )
{
gp_type *gp;
tl_type *tl;
link_type	*l;
int     i,      j;
 
 
	*no = 0;
	*mbr = 0;
	for( i = 0 ; i < agp->Ni ; i++ )
		for( j = 0 ; j < agp->Nj ; j++ ){
			gp = &agp->gp[i][j];
 
			for( l = gp->link ; l != NULL ; l = l->nl ){
				if( l->Fbr != 0x04 )    continue;
 
				tl = &tlink[(*no)];
				(*no)++;
 
				tl->ctr.x = gp->ctr.x + l->ctr.x;
				tl->ctr.y = gp->ctr.y + l->ctr.y;
				tl->l = l;
 
				tl->mbr = ( 1L<<l->br) | ( 1L<<l->br1);
 
				*mbr |= tl->mbr;
			}
		}
}                                                                              




static void
agp_pl_bgp( bgp_type *bgp, lnk_type *link[], int no )
{
/*
vec2d	v;
	v.x = gp->ctr.x + bbgp->ctr.x;
	v.y = gp->ctr.y + bbgp->ctr.y;
*/

	agp_pl_point1( link, no, &bgp->rctr, bgp->br, &bgp->pl );
	
}


static void
agp_pl_hunch( hunch_type *hunch, lnk_type *link[], int no )
{
/*
vec2d	v;
	v.x = gp->ctr.x + bhunch->ctr.x;
	v.y = gp->ctr.y + bhunch->ctr.y;
*/

	agp_pl_point1( link, no, &hunch->rctr, hunch->br, &hunch->pl );
	
}


/*
static void
agp_pl_jnt( jnt_type *jnt, lnk_type *link[], int no )
{
vec2d	v;
int	br;

	br = jnt->brn[0]->link->br;



	v = jnt->rctr;

	agp_pl_point1( link, no, &v, br, &jnt->pl );

	
}
*/


static void
agp_pl_link( link_type *l, lnk_type *link[], int no )
{
vec2d	v;
link_type	*l0;
int	br;

	br = l->br;


/*
	v.x = gp->ctr.x + l->ctr.x;
	v.y = gp->ctr.y + l->ctr.y;
*/
	v = l->rctr;

	agp_pl_point1( link, no, &v, br, &l->pl[0] );


	if( (l0 = LINK_PREV(l)) != NULL )
		l0->pl[1] = l->pl[0];

	if( LINK_NEXT(l) != NULL )	return;

	v.x += l->rv.x;
	v.y += l->rv.y;

	agp_pl_point1( link, no, &v, br, &l->pl[1] );
}






void
agp_pl_point1( lnk_type *link[], int no, vec2d *v, int br, pl_type **pl0 )
{
pl_type	*pl;
lnk_type	*l;
//tl_type	*tl;
vec2d	dv;
float	t,	u,	len,	t0,	w;
mbr_type	mbr;

//	mbr = 1L<<br;
	mbr = MBR_BIT( br );

#ifdef AAA
	if( Tno > 0 && (mbr & Tmbr) ){
		tl_array_select( Tlink, Tno, v, mbr, &tl, &u, &t );
		if( tl != NULL && ABS(u) < TL_DIS )
			mbr = tl->mbr;
	}
#endif

	lnk_array_select( link, no, v, mbr, &l, &u, &t );
	if( l == NULL )	return;



	if( l->width > 0 )
		w = 1.0 - ABS(u) / l->width;
	else	w = 1.0;


	dv.x = v->x - l->ctr.x;
	dv.y = v->y - l->ctr.y;


	t0 = -l->u.y * dv.x + l->u.x * dv.y;
	if( t0 < 0 || t0 > l->len ){
		u = l->u.x * dv.x + l->u.y * dv.y; 
	}


	t0 = t0 - l->t0 * u;
	len = l->len  - l->t0 * u + l->t1 * u;



	if( *pl0 == NULL || (*pl0)->p == NULL ){
		pl = PL_ALLOC();
		pl->p = *pl0;
		*pl0 = pl;

	}
	else	{
		if( (*pl0)->w < (*pl0)->p->w )
			pl = (*pl0);
		else	pl = (*pl0)->p;

		if( w < pl->w )	return;
	}


	pl->l = l;
	pl->u = u;
	pl->t  = t0 / len;
	pl->w = w;
}





void
agp_pl_free( gp_array *agp )
{
gp_type	*gp;
link_type	*l;
hunch_type	*hunch;
bgp_type	*bgp;

 
int	i,	j;

 
	for( i = 0 ; i < agp->Ni ; i++ )
	    for( j = 0 ; j < agp->Nj ; j++ ){
		gp = &agp->gp[i][j];
 

		for( bgp = gp->bgp ; bgp != NULL ; bgp = bgp->rp ){
			if( bgp->pl == NULL )	continue;
			if( bgp->pl->p != NULL )	free( bgp->pl->p );
			free( bgp->pl );
			bgp->pl = NULL;
		}


		for( hunch = gp->hunch ; hunch != NULL ; hunch = hunch->rnh ){
			if( hunch->pl == NULL )	continue;
			if( hunch->pl->p != NULL )	free( hunch->pl->p );
			free( hunch->pl );
			hunch->pl = NULL;
		}


		for( l = gp->link ; l != NULL ; l = l->rnl ){
			if( l->pl[0] != NULL ){
				if( l->pl[0]->p != NULL )
					free( l->pl[0]->p );
				free( l->pl[0] );
				l->pl[0] = NULL;
			}

			if( LINK_NEXT( l ) != NULL ){
				l->pl[1] = NULL;
				continue;
			}

			if( l->pl[1] != NULL ){
				if( l->pl[1]->p != NULL )
					free( l->pl[1]->p );
				free( l->pl[1] );
				l->pl[1] = NULL;
			}
		}

	}
}




void
agp_pl_init( gp_array *agp )
{
gp_type	*gp;
link_type	*l;
hunch_type	*hunch;
bgp_type	*bgp;

 
int	i,	j;

 
	for( i = 0 ; i < agp->Ni ; i++ )
	    for( j = 0 ; j < agp->Nj ; j++ ){
		gp = &agp->gp[i][j];
 

		for( bgp = gp->bgp ; bgp != NULL ; bgp = bgp->rp ){
			bgp->pl = NULL;
		}


		for( hunch = gp->hunch ; hunch != NULL ; hunch = hunch->rnh ){
			hunch->pl = NULL;
		}


		for( l = gp->link ; l != NULL ; l = l->rnl ){
			l->pl[0] = NULL;

			l->pl[1] = NULL;
		}


	    }
}
