/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*********************
 ***	hyputA.c   ***
 *********************/
#include	<math.h>

#include	"Uigp/igp.h"
#include	"GpType/Configuration.h"

#ifdef _DEBUG
//static float hypotA_error = 0;
#endif

#define VIM_CONST_EXAPND_TABLE

#ifdef VIM_CONST_EXAPND_TABLE

#include	"HypotA.tab"

#else
static int HypotA[257];


void
hypotA_table()
{

float	t;
int	i,	tmp;


	for( i =0, t = 0 ; i < 257 ; i++, t += 1.0/256 ){
		tmp = (sqrt( 1+t)-1) *256 + 0.5;
		HypotA[i] = tmp;
	}

//	gp_write_INTtable_to_file( "D:/Player/hypotA.tab", "HypotA", HypotA, 256 );
}
#endif

float
hypotA( float x, float y )
{
float	t,	t0;
int	i;


#ifndef VIM_CONST_EXAPND_TABLE
static int Ftab =0;
	if( Ftab == 0 ){

		hypotA_table();

		Ftab = 1;
	}
#endif


	if( x < 0 )	x = -x;
	if( y < 0 ) y = -y;

	if( x < y ){
		t =  x / y;
		t0 = y;
	}
	else	{
		t0 = x;
		t = y /x;
	}

	i = t*t*256 + 0.5;

	t  = 1.0 + HypotA[i] * (1.0/256);
	t *= t0;


#ifdef _DEBUG
//	t0 = hypot( x, y );
//	if( (t0 = t0 - t) < 0 ) t0 = -t0;
//	if( t0 > hypotA_error ) hypotA_error = t0;
#endif


	return( t );
}
