/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**
**	SklAppend.c
*/

#include	"SklType/SklType.h"



void skl_append ( skl_type *bskl, vec2d *vec, skl_type *skl )
{
	skl_type *copy = NULL;
	jskl_type *jnt = NULL;
	
	copy = skl_make_copy(bskl);
	skl_shift( copy, vec->x, vec->y );
	jnt = skl->jnt;

	if(jnt == NULL)
	{
		skl->jnt = copy->jnt;		
		copy->jnt = NULL;
		skl_free(copy);
		return;
	}

	while(jnt->nj!= NULL)
		jnt = jnt->nj;
	
	jnt->nj = copy->jnt;
	copy->jnt = NULL;
	skl_free(copy);
	
}

