/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	SklBes.c	***
 *************************/
#include	<stdio.h>
#include	<math.h>

#include	"Uigp/igp.h"


#include	"SklType/SklType.h"


static void	jbrn_set_bes( bskl_type *b, bskl_type *nb );


void
skl_set_bes( skl_type *skl )
{
jskl_type	*jnt;
bskl_type	*b,	*nb;
int	i,	j;

	for( jnt = skl->jnt ; jnt != NULL ; jnt = jnt->nj ){


		for( i = 0 ; i < jnt->bno ; i++ ){
			if( jnt->b[i].direct != F_BEGIN )	continue;

			lnk_set_bes( jnt->b[i].link );
		}
	}

	for( jnt = skl->jnt ; jnt != NULL ; jnt = jnt->nj )

		for( i = 0 ; i < jnt->bno-1 ; i++ ){
			b = &jnt->b[i];
			if( b->link->width > 0 )	continue;

			for( j = i+1 ; j < jnt->bno ; j++ ){
				nb = &jnt->b[j];
				if( nb->link->width > 0 )	continue;
				if( b->link->br == nb->link->br )
					jbrn_set_bes( b, nb );
			}
		}
}

static void
jbrn_set_bes( bskl_type *b, bskl_type *nb )
{
lnk_type	*l,	*nl;
vec2d	tmp;
float	t;

	l = b->link;
	nl = nb->link;

	if( b->direct == F_END ){
		if( nb->direct == F_BEGIN ){

			tmp.y = ( l->u.y + nl->u.y );
			tmp.x =  ( l->u.x + nl->u.x );


			t = 1.0 / (tmp.x*nl->u.x + tmp.y*nl->u.y);

			nl->t0 = t*( tmp.x * -nl->u.y + tmp.y * nl->u.x );
			l->t1 = -nl->t0;

			return;
		}


		tmp.y = ( l->u.y - nl->u.y );
		tmp.x =  ( l->u.x - nl->u.x );


		t = 1.0 / (tmp.x*-nl->u.x + tmp.y*-nl->u.y);

		nl->t1 = t*( tmp.x * nl->u.y + tmp.y * -nl->u.x );
		l->t1 = -nl->t1;

		return;
	}


	if( nb->direct == F_BEGIN ){

		tmp.y = ( -l->u.y + nl->u.y );
		tmp.x =  ( -l->u.x + nl->u.x );


		t = 1.0 / (tmp.x*nl->u.x + tmp.y*nl->u.y);

		nl->t0 = t*( tmp.x * -nl->u.y + tmp.y * nl->u.x );
		l->t0 = -nl->t0;

		return;
	}


	tmp.y = ( -l->u.y - nl->u.y );
	tmp.x =  ( -l->u.x - nl->u.x );


	t = 1.0 / (tmp.x*-nl->u.x + tmp.y*-nl->u.y);

	nl->t1 = t*( tmp.x * nl->u.y + tmp.y * -nl->u.x );
	l->t0 = -nl->t1;

	return;
}


		
