/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include	<stdio.h>
#include	<math.h>

#include	"Uigp/igp.h"


#include	"GpType/GpType.h"


#include	"SklType/SklType.h"




int
skl_br( skl_type *skl )
{
jskl_type	*jnt;
int	i;
int	br;

	br = -1;

	for( jnt = skl->jnt ; jnt != NULL ; jnt = jnt->nj ){

		if( jnt->br > br )	br = jnt->br;


		for( i = 0 ; i < jnt->bno ; i++ ){
			if( jnt->b[i].direct != F_BEGIN )	continue;

			if( jnt->b[i].link->br > br )
				br = jnt->b[i].link->br;
		}
	}

	return( br );
}



void
skl_br_add( skl_type *skl, int br )
{
jskl_type	*jnt;
lnk_type	*l;
int	i;

	for( jnt = skl->jnt ; jnt != NULL ; jnt = jnt->nj ){

		jnt->br += br;


		for( i = 0 ; i < jnt->bno ; i++ ){
			if( jnt->b[i].direct != F_BEGIN )	continue;

			for( l = jnt->b[i].link ; l != NULL ; l = LNK_NEXT(l) )
				l->br += br;
		}
	}
}


void
skl_br_set( skl_type *skl, int br )
{
jskl_type	*jnt;
lnk_type	*l;
int	i;

	for( jnt = skl->jnt ; jnt != NULL ; jnt = jnt->nj ){

		jnt->br = br;


		for( i = 0 ; i < jnt->bno ; i++ ){
			if( jnt->b[i].direct != F_BEGIN )	continue;

			for( l = jnt->b[i].link ; l != NULL ; l = LNK_NEXT(l) )
				l->br = br;
		}
	}
}


void
skl_br_change( skl_type *skl, int br, int nbr )
{
jskl_type	*jnt;
lnk_type	*l;
int	i;

	for( jnt = skl->jnt ; jnt != NULL ; jnt = jnt->nj ){

		if( jnt->br == br )
			jnt->br = nbr;


		for( i = 0 ; i < jnt->bno ; i++ ){
			if( jnt->b[i].direct != F_BEGIN )	continue;

			for( l = jnt->b[i].link ; l != NULL ; l = LNK_NEXT(l) )
				if( l->br == br )
					l->br = nbr;
		}
	}
}
