/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**********************
 ***	SklCoding.c	***
 **********************/
#include        <stdio.h>
#include        "Uigp/igp.h"
#include        "Uprm/prm.h"
#include        "Ucode/code.h"
#include        "Ubst/BstType.h"

#include	"SklType/SklType.h"

#include	"SklCoding.h"


/*
static code_in         Sa_in =   { -8.0, 8.0, 0.25, 0.0, 0.0 };
static code_in         Sctr_in = { -3.0, 3.0, 0.25, 0.0, 0.0 };

#ifndef PLAYER
static GP_prm  Parames[]    =    {
        {"S-a-d",(char *)&Sa_in.d, PRM_FLOAT, "%.3f", "0.25"},
        {"S-ctr-d",(char *)&Sctr_in.d, PRM_FLOAT, "%.3f", "0.25"},
};
#endif
*/

 
codingSkl_type *
skl_coding_prm_get( int row, int column )
{
codingSkl_type	*cd;

	cd = (codingSkl_type *)malloc( sizeof(codingSkl_type) );


//	Sctr_in.min = -20;
//	Sctr_in.max  = column + 20;
//	coding_set_lprm( &Sctr_in, &cd->Sctr_y, 1.0 );
	code_set( &cd->Sctr_y, -20, column+20, 0.25, 0, 1.0 );


//	Sctr_in.min = -20;
//	Sctr_in.max  = row + 20;
//	coding_set_lprm( &Sctr_in, &cd->Sctr_x, 1.0 );
	code_set( &cd->Sctr_x, -20, row+20, 0.25, 0, 1.0 );


//	coding_set_lprm( &Sa_in, &cd->Sa, 1.0 );
	code_set( &cd->Sa, -8, 8, 0.25, 0, 1.0 );
	

	return( cd );
}


void
skl_coding_prm_destroy( codingSkl_type * cd )
{
	free( cd );
}
