/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***    SklCompare.c    ***
 *************************/
#include	<stdio.h>
#include	<math.h>

#include	"SklType/SklType.h"




static int	lnk_compare( lnk_type *link0, vec2d *ctr, lnk_type *link );



int
skl_compare( skl_type *skl0, skl_type *skl )
{
jskl_type	*jnt,	*j0;
bskl_type	*b,	*b0;
int	i,	ret;

	for( jnt = skl->jnt, j0 = skl0->jnt ; jnt != NULL ;
						jnt= jnt->nj, j0 = j0->nj ){

		jnt->ctr = j0->ctr;


		for( i = 0 ; i < jnt->bno ; i++ ){

			b = &jnt->b[i];
			if( b->direct == F_END )	continue;

			b0 = &j0->b[i];

			ret = lnk_compare( b0->link, &jnt->ctr, b->link );
			if( ret == 0 )	return( 0 );
		}
	}

	return( 1 );
}



static int
lnk_compare( lnk_type *link0, vec2d *ctr, lnk_type *link )
{
lnk_type	*l,	*l0;
vec2d	v;

	for( l = link, l0 = link0, v = *ctr ; l != NULL ; 
                                l = LNK_NEXT(l), l0 = LNK_NEXT(l0) ){

		if( l->ctr.x == v.x && l->ctr.y == v.y &&
				l->v.x == l0->v.x && l->v.y == l0->v.y &&
				l->a == l0->a ){
			v.x += l->v.x;
			v.y += l->v.y;
			continue;
		}

		return( 0 );


	}

	return( 1 );
}
