/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	SklComponnet.c	***
 *************************/
#include	<stdio.h>

#include	"Uigp/igp.h"

#include	"SklType/SklType.h"


int
skl_componnet( skl_type *skl )
{
jskl_type	*ajnt[100],	*jnt,	*nj;
bskl_type	*b;
lnk_type	*l;
int	no;
int	i,	j,	k,	direct;
int	componnet;

	componnet = 0;

	no = 0;


	for( jnt = skl->jnt ; jnt != NULL ; jnt = jnt->nj ){

		if( jnt->pl != NULL )	continue;

		for( i = 0 ; i < no ; i++ )
			if( ajnt[i] == jnt )	break;

		if( i < no )	continue;

		componnet++;

		ajnt[no++] = jnt;


		for( i = no-1 ; i < no ; i++ ){
		    jnt = ajnt[i];

		    for( k = 0 ; k < jnt->bno ; k++ ){
			b = &jnt->b[k];

			if( b->direct == F_BEGIN ){
				for( l = b->link ; l != NULL ; l = LNK_NEXT(l))
					if( LNK_NEXT(l) == NULL )	break;
			}
			else
				for( l = b->link ; l != NULL ; l = LNK_PREV(l))
					if( LNK_PREV(l) == NULL )	break;

			direct = INV_FLAG( b->direct );
			if( (nj = l->p[direct].p.jnt) == NULL )
				continue;

			for( j = 0 ; j < no ; j++ )
				if( ajnt[j] == nj )	break;

			if( j < no )	continue;

			ajnt[no] = nj;
			no++;
		    }
		}
	}

	return( componnet );
}
