/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include	<stdio.h>
#include	<math.h>
#include	<string.h>

#include	"Uigp/igp.h"


#include	"GpType/GpType.h"


#include	"SklType/SklType.h"




void
skl_copy( skl_type *skl, skl_type *tskl )
{
jskl_type	*j,	*tj;
lnk_type	*l,	*tl;
int	i;

	tskl->type = skl->type;
	tskl->topology = skl->topology;
	tskl->orientation = skl->orientation;
	

	for( j = skl->jnt, tj = tskl->jnt ; j != NULL ; j = j->nj, tj = tj->nj){

		tj->ctr = j->ctr;
		tj->Ftopology = j->Ftopology;

		for( i = 0 ; i < j->bno ; i++ ){
			if( j->b[i].direct != F_BEGIN )	continue;

			for( l = j->b[i].link, tl = tj->b[i].link ; l != NULL ;
					l = LNK_NEXT(l), tl = LNK_NEXT(tl) ){
				tl->ctr = l->ctr;
				tl->v = l->v;
				tl->a = l->a;

				tl->u = l->u;
				tl->c_prb = l->c_prb;
				tl->len = l->len;
			}
		}
	}
}



skl_type *
skl_make_copy( skl_type *skl )
{
skl_type	*tskl;
jskl_type	*j,	*tj,	**pj;
bskl_type	*b;
lnk_type	*l;
int	i;

	tskl = skl_alloc();
	tskl->type = skl->type;
	tskl->topology = skl->topology;
	tskl->orientation = skl->orientation;

	tskl->row = skl->row;
	tskl->column = skl->column;

	strncpy( tskl->name,  skl->name, 16 ); 

	pj = &tskl->jnt;
	for( j = skl->jnt ; j != NULL ; j = j->nj ){
		tj = jskl_alloc();

		j->cj = tj;

		*tj = *j;
		*pj = tj;
		pj = &tj->nj;
	}


	for( j = tskl->jnt ; j != NULL ; j = j->nj ){

		for( i = 0 ; i < j->bno ; i++ ){
			if( j->b[i].direct != F_BEGIN )	continue;


			j->b[i].link = lnk_make_copy( j->b[i].link );
			j->b[i].link->p[F_BEGIN].p.jnt = j;

			for( l = j->b[i].link ; LINK_NEXT(l) != NULL ;
							l = LNK_NEXT(l));

			if( l->p[F_END].p.jnt == NULL )	continue;

			tj = l->p[F_END].p.jnt->cj;
			b = &tj->b[ l->p[F_END].bno ];
			b->link = l;
			l->p[F_END].p.jnt = tj;
		}
	}


	skl_set_bes( tskl );


	for( j = tskl->jnt ; j != NULL ; j = j->nj ){
		if( j->pl == NULL )	continue;
		for( l = j->pl->l ; LINK_PREV(l) != NULL ; l = LINK_PREV(l) );
		l = l->p[F_BEGIN].p.jnt->cj->b[ l->p[F_BEGIN].bno ].link;

		j->pl = pl_point_set( &l->ctr, l, &j->ctr );
	}
		


	return( tskl );
}
