/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	SklFlip.c	***
 *************************/
#include	<stdio.h>
#include	<math.h>

#include	"Uigp/igp.h"

#include	"SklType/SklType.h"


static void	lnk_filter_short_link( vec2d *ctr, lnk_type *link, float d );

void
skl_filter( skl_type *skl )
{
//jskl_type	*jnt,	*pj,	*cjnt;
jskl_type	*jnt,	*cjnt;

int	i;

	for( jnt = skl->jnt ; jnt != NULL ; jnt = jnt->nj ){

		for( i = 0 ; i < jnt->bno ; i++ ){
			if( jnt->b[i].direct != F_BEGIN ){
				i++;
				continue;
			}

			lnk_filter_short_link( &jnt->ctr, jnt->b[i].link, 1.0 );

			if( lnk_length( jnt->b[i].link, NULL ) < 1.5 ){
				skl_delete_polylink( skl, jnt->b[i].link );
				i = 0;
			}
			else	i++;
		}
	}


	for( jnt = skl->jnt ; jnt != NULL ; ){
		cjnt = jnt;
		jnt = jnt->nj;
		skl_delete_jnt( skl, cjnt );
	}

/*
	pj = NULL;
	for( jnt = skl->jnt ; jnt != NULL ; ){
		if( jnt->bno > 0 ){
			pj = jnt;
			jnt = jnt->nj;
			continue;
		}

		if( pj == NULL )
			skl->jnt = jnt->nj;
		else	pj->nj = jnt->nj;

		cjnt = jnt;
		jnt = jnt->nj;
		jskl_free( cjnt );
	}
*/
}







static void
lnk_filter_short_link( vec2d *ctr, lnk_type *link, float d )
{
lnk_type *l,	*l1,	*l2;
jskl_type	*jnt;
vec2d	p,	p1,	p2,	pm;


	for( l = link, p = *ctr ; LNK_NEXT(l) != NULL ; l = LNK_NEXT(l) ){

		l1 = LNK_NEXT(l);
		
		if( l1->len > d ){
			p.x += l->v.x;
			p.y += l->v.y;
			continue;
		}

		p1.x = p.x + l->v.x;
		p1.y = p.y + l->v.y;

		l2 = LNK_NEXT(l1);

		if( l2 == NULL ){
			break;
		}

		p2.x = p1.x + l1->v.x;
		p2.y = p1.y + l1->v.y;

		pm.x = 0.5*( p1.x + p2.x);
		pm.y = 0.5*( p1.y + p2.y);



		l2->v.x = p2.x + l2->v.x - pm.x;
		l2->v.y = p2.y + l2->v.y - pm.y;

		l2->ctr = pm;

		lnk_set_aux( l2 );



		l->v.x = pm.x - p.x;
		l->v.y = pm.y - p.y;

		lnk_set_aux( l );

		l->p[1].p.l = l2;
		l2->p[0].p.l = l;

		free( l1 );

		p.x += l->v.x;
		p.y += l->v.y;
	}


	l1 = LNK_NEXT(l);
	if( l1 != NULL && l1->len < d ){
		l->v.x += l1->v.x;
		l->v.y += l1->v.y;
		lnk_set_aux( l );
		l->p[1] = l1->p[1];

		jnt = l->p[1].p.jnt;
		if( jnt != NULL )
			jnt->b[l->p[1].bno].link = l;

		free( l1 );
	}

	if( link->len < d ){
		l1 = LNK_NEXT( l );
		if( l1 != NULL ){
			link->v.x += l1->v.x;
			link->v.y += l1->v.y;
			lnk_set_aux( link );
			link->p[1] = l1->p[1];

			l2 = LNK_NEXT(l1 );
			if( l2 != NULL )
				l2->p[0].p.l = link;

			free( l1 );
		}
	}

}