/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	SklRotate.c	***
 *************************/
#include	<stdio.h>
#include	<math.h>

#include	"Uigp/igp.h"

#include	"SklType/SklType.h"



void
skl_rotate( skl_type *skl, vec2d *ctr, float cosa, float sina )
{
jskl_type	*jnt;
lnk_type	*l;
vec2d	v,	u;
int	i;

	for( jnt = skl->jnt ; jnt != NULL ; jnt = jnt->nj ){
		v.x = jnt->ctr.x - ctr->x;
		v.y = jnt->ctr.y - ctr->y;

		jnt->ctr.x = ctr->x + cosa*v.x + sina*v.y;
		jnt->ctr.y = ctr->y - sina*v.x + cosa*v.y;


		for( i = 0 ; i < jnt->bno ; i++ ){
			if( jnt->b[i].direct != F_BEGIN )	continue;

			v = jnt->ctr;
			for( l = jnt->b[i].link ; l != NULL ; l = LNK_NEXT(l)){

				l->ctr = v;

				u.x =  cosa * l->u.x + sina * l->u.y;
				u.y = -sina * l->u.x + cosa * l->u.y;

				l->u = u;

				l->v.x = - l->len * l->u.y;
				l->v.y =   l->len * l->u.x;

				v.x += l->v.x;
				v.y += l->v.y;
			}
		}
	}
}
