/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef         _JSKL_TYPE_
#define         _JSKL_TYPE_


#include        "LnkType.h"

#include        "SklType/PlType.h"

#define JSKL_BRN_MAX	8

typedef struct bskl_type {

	int	direct;			// F_BEGIN or F_END - is it starting or ending at the joint
	lnk_type	*link;	// first link in the polylink
}	bskl_type;
	



typedef struct jskl_type {
	vec2d	ctr;				// center of the joint
	int	bno;					// number of branches - starting AND ending at that joint
    bskl_type	b[JSKL_BRN_MAX];			// wrppers for polylinks 
	int	br;						// layer number
	pl_type	*pl;				// connect to other elements in the skl
	struct jskl_type	*nj;	// next joint in the list
	struct jskl_type	*cj;	/* use in   skl_make_copy */
	int	no;						// order number 
	int	Ftopology;				// 1 - independent in topology. 0 - dependent
}       jskl_type;



	/* JsklTool.c */
jskl_type *	jskl_alloc();

void	jskl_free( jskl_type *j );

void	jskl_untied_brn( jskl_type *jnt, int bno );

int		jskl_connet_link( jskl_type *jnt, int bno, lnk_type *link, int direct );

void	jskl_update_ctr( jskl_type *jnt, vec2d *ctr );


#endif
