/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*********************
 ***	PlType.h   ***
 *********************/

#ifndef         _PL_TYPE_
#define         _PL_TYPE_

#include	"Uigp/igp.h"


typedef struct pl_type {
	float	t,	u;		// the distance to the link
	float	w;			// width of influence

	struct lnk_type	*l;	// the link to be attached to.

	struct pl_type	*p;	//no use
}	pl_type;


#define         PL_ALLOC()	( (pl_type *)malloc( sizeof( pl_type ) ) );


pl_type *	pl_point_set( vec2d *ctr, lnk_type *link, vec2d *v );
	

void		pl_point( pl_type *pl, vec2d *p );


/*
void		plw_point( pl_type *pl, vec2d *p );
*/

#endif

