/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************
 ***	SoundType.h   ***
 ************************/
#ifndef         _SOUND_TYPE_
#define         _SOUND_TYPE_ 

#include	"Uigp/igp.h"
#include	"Ubst/BstType.h"

#include	"GpType/configuration.h"

#include	"Umedia/MediaDataType.h"



#define		SOUND_NAME_LEN	64


#define		SOUND_WAV	1
#define		SOUND_MIDI	2
#define		SOUND_WMA	3
#define		SOUND_MP3	4



#define		MSOUND_F0			0x01
#define		MSOUND_F1			0x02
#define		MSOUND_BIG_SIZE		0x04
#define		MSOUND_NAME			0x08
#define		MSOUND_CHARCTER		0x10








typedef struct sound_type {
	char	name[SOUND_NAME_LEN];

	int	Fcharcter;	

	mediaData_type	*md;

	mediaData_type	*mdPlay;

	int	fno0,	fno1;



}	sound_type;


/*
typedef struct soundRef_type {
	int		id;					// the sound id, refer to index in sound Array;
	sound_type	*sound; 

	int		fno,	fno1;

	struct soundRef_type	*next;

}	soundRef_type;
*/



sound_type *	sound_alloc();

sound_type *	sound_create( char *name, int Faux, mediaData_type *md );

void		sound_destroy( sound_type * sound );


sound_type *	sound_make_copy( sound_type * sound_src );



void		sound_write( bst_type *bst, sound_type *sound );

sound_type *	sound_read( bst_type * bst );
sound_type *	sound_read0x002( bst_type * bst);
void			sound_skip0x002( bst_type * bst );



	/* SoundAux.c */
void	sound_aux( sound_type *sound, int Fplay );


sound_type *	sound_read_file( char *file, int Faux );


void	sound_write_to_file( sound_type *sound, int uniqueId, char *dir );





#endif
