/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*************************
 ***	VimCoding.h   ***
 *************************/
#ifndef	 _VIM_CODING_H_
#define	 _VIM_CODING_H_

#ifdef __cplusplus
extern "C" {
#endif

#include	"VimageType/VimageType.h"
#include	"VimageType/VimHeader.h"
#include	"VimIo.h"

	/* VimEncoding.c */
void	vim_encoding( vimage_type *vim, int Ftexture, int Fanim, vimIo_type *vio );

	/* VimEncodingTo.c */
int	vim_encoding_to_buffer( vimage_type *vim[], int vim_no, vimHeader_type *vh,
			int Ftexture, int Fanim,
			char **data, int *bytes );

int	vim_encoding_to_file( vimage_type *vim[], int vim_no, vimHeader_type *vh,
							int Ftexture, int Fanim,
							char *file );

int	vim_encoding_cast_to_file( cast_type *cast, char *file );


	/* VimEncodingAnim.c */
int	vim_encoding_anim_to_file( vimage_type *vim, char *dir, char *name );

int	vim_encoding_cast_anim( cast_type *cast, ocp_list *ocp, char *dir, char *name );

int	vim_encoding_cast_anim_segement( vimage_type *svim,
				int iCast, int frame0, int frame1,
				char *dir, char *name );



	/* VimEncodingPreparation.c */
void	vim_encoding_preparation( vimage_type *vim );






	/* VimDecodingFile.c */
int		vim_decoding_version_from_file( char *file, int *version );

int		vim_decoding_from_file( vimage_type *avim[], int vim_no, vimHeader_type **vh,
				int Ftexture, int Faux, char *file );

int		vim_decoding_from_buffer( vimage_type *avim[], int vim_no, vimHeader_type **vh,
				int Ftexture, int Faux, char *data, int bytes );

int		vim_decoding( vimage_type *avim[], int vim_no, vimHeader_type **vh,
				int Ftexture, int Faux, vimIo_type *vio );

void	vim_decoding_final( vimage_type *vim, int Ftexture, vimIo_type *vio );

//Ftexture == 0x01 playing
//Ftexture == 0x03 editing
//Ftexture == 0x02 composing


	/* VimDecoding.c */
int		vim_decoding_block( vimage_type *vim, int Ftexture,
					int head, bst_type *bst,
					vimIo_type *vio );


void	vim_retrieve_texture( vimage_type *vim, int Ftexture, vimIo_type *vio );

int		cast_retrieve_texture( cast_type *cast, int Ftexture, vimIo_type *vio );


	/* VimDecoding005.c */
int		vim_decoding005( vimage_type *avim[], int vim_no, vimHeader_type **vh,
				int Fagp, int Faux, vimIo_type *vio );

int		vim_decoding_block0005( vimage_type *vim, int Fagp,
				int head, bst_type *bst,
				vimIo_type *vio );




	/* VimReadAnim.c */
int	vim_read_anim_from_file( vimage_type *vim, int Fwin, char *file );

ocp_list *	vim_read_cast_anim( cast_type *scast, char *file );

#ifdef __cplusplus
}
#endif
#endif
