/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*************************
 ***	VimCoding.h   ***
 *************************/
#ifndef	 _VIM_CODING_IN_H_
#define	 _VIM_CODING_IN_H_

#include	"Ubst/BstType.h"
#include	"VimageType/VimageType.h"
#include	"VimageType/VimHeader.h"
#include	"VimIo.h"


/* for writing header block in vim file */
 
#define		MH_SCENE_NO		0x01
#define		MH_TITLE        0x02
#define		MH_ARTIST       0x04
#define		MH_DESCRIPTION  0x08
#define		MH_COPYRIGHT    0x10
#define		MH_DATE         0x20
#define		MH_PROTECTED    0x40




/* for writing scene block in vim file */
#define		MS_NAME					0x01
#define		MS_FRAME_SIZE			0x02
#define		MS_BACKGROUND_COLOR		0x04
#define		MS_CAMERA_SCENARIO		0x08
#define		MS_PREVIEW_FRAME		0x10
#define		MS_FRAMERATE			0x20
#define		MS_INTERACTION			0x40

#define		MS_PALETTE				0x01





/* for writing cast block in vim file */
#define		MC_NAME					0x01
#define		MC_TYPE					0x02
#define		MC_SCALE_HEIGHT			0x04
#define		MC_SKELETON				0x08
#define		MC_ANIMATION			0x10
#define		MC_FLIP					0x20		// the object flip 180 dgree
#define		MC_TEXT_PROPERTY		0x40		// text property present




#define		MC_MOVEABLE				0x01		// Does the object can move by the player
#define		MC_FLIPABLE				0x02		// Does the object can rotate by more than 180 dgree
#define		MC_INTERACTION			0x04		// IS interaction information present?




	/* VimEncoding.c */
void vim_encoding_flags( bst_type *bst, u_char head[], int len );

	/* VimEncodingScence.c */
int	vim_encoding_scene_block( vimage_type *vim, int Fanim, vimIo_type *vio );

	/* VimEncodingCast.c */
int	vim_encoding_cast_block( cast_type *cast, int Fanim, vimIo_type *vio );

	/* VimEncodingTexture.c */
int	vim_encoding_texture_block_background( vimage_type *vim, vimIo_type *vio );
int	vim_encoding_texture_block_cast( cast_type *cast, vimIo_type *vio );

	/* VimEncodingHeader.c */
void	vim_write_header_block( vimHeader_type *vh, int scene_no, vimIo_type *vio );




	/* VimDecoding.c */
void vim_decoding_flags( bst_type *bst, u_char head[], int len );

	/* VimDecdoingHeader.c */
vimHeader_type *	vim_decoding_header( bst_type *bst );


	/* VimDecodingScene.c */
int	vim_decoding_scene_block( vimage_type *vim, bst_type *bst, vimIo_type *vio );


	/* VimDecodingCast.c */
cast_type *	vim_decoding_cast_block( bst_type *bst, vimIo_type *vio );

	/* VimDecoderTexture.c */
int	vim_decoding_texture_block( vimage_type *vim, int Ftexture,
							   bst_type *bst, vimIo_type *vio );

int	vim_decoding_texture_block0( vimage_type *vim, int Ftexture,
							   bst_type *bst, vimIo_type *vio );
#ifdef IMAGE_BACKGROUND
image_type *	vim_read_image( bst_type *bst, vimIo_type *vio );
#endif





#endif
