/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/******************************
 ***	VimDecodingCast.c   ***
 ******************************/
#include	<string.h>

#include	"Uigp/igp.h"
#include	"Ubst/BstType.h"


#include	"GpType/Configuration.h"

#include	"VimageType/VimageType.h"
#include	"VimCodingIn.h"

#include	"AnimCoding/AnimCoding.h"

#include	"VimIo.h"






static text_type *	vim_decoding_cast_textProperty( bst_type *bst );



cast_type *
vim_decoding_cast_block( bst_type *bst, vimIo_type *vio )
{
cast_type *cast;
u_char     head[10];

	cast = cast_alloc();

	cast->type = CAST_REGULAR;
 
	
	vim_decoding_flags( bst, head, 2 );

 
 
	if( head[0] & MC_NAME )
		bst_get_string( bst, cast->name, 63 );

	if( head[0] & MC_TYPE )
		cast->type = bst_get_int( bst, 4 );
 
 
	if( head[0] & MC_SCALE_HEIGHT )
		cast->scale = bst_get_int( bst, 10 );
 

	
	if( head[0] & MC_SKELETON )
			cast->skl = skl_decoding( bst );
	else	cast->skl = skl_alloc();


	cast->oim = oimage_alloc();
	cast->oim->skl = skl_make_copy( cast->skl );
 
 
	if( head[0] & MC_ANIMATION )
		cast->ocp = ocp_decoding( cast->skl, bst );


	if( head[0] & MC_TEXT_PROPERTY )
		cast->text = vim_decoding_cast_textProperty( bst );



	if( head[1] & MC_MOVEABLE )
		cast->Moveable = 1;

	if( head[1] & MC_FLIPABLE )
		cast->Flipable = 1;



	if( head[1] & MC_INTERACTION )
		cast->inL = interactionL_decoding( cast->skl, bst );
 

	if( cast->Moveable == 1 )
		cast->Flock = TRUE;


	return( cast );
}




static text_type *
vim_decoding_cast_textProperty( bst_type *bst )
{
text_type	*textProperty;
int	r,	g,	b;
int	i;

	textProperty = TEXT_ALLOC();

	textProperty->text[0] = 0;

	bst_get_string( bst, textProperty->font, MAX_FONT_NAME );

	textProperty->size = bst_get_int( bst, 8 );

	textProperty->style = bst_get_int( bst, 4 );

	textProperty->skl = bst_get_int( bst, 4 );


	r = bst_get_int( bst, 8 );
	g = bst_get_int( bst, 8 );
	b = bst_get_int( bst, 8 );
	textProperty->color = IMAGE4_RGB( r,g,b);


	for( i = 0 ; i < MAX_TEXT_SIZE ; i++ ){
		textProperty->text[i] = bst_get_align_num( bst, 2 );
		if( textProperty->text[i] == 0 )	break;
	}

	return( textProperty );
}



