/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/******************************
 ***	VimDecodingHeader.c	***
 ******************************/
#include	<stdio.h>
#include	<math.h>
#include	<string.h>


#include	"Uigp/igp.h"
#include	"Ubst/BstType.h"

#include	"VimageType/VimageType.h"
#include	"VimageType/VimHeader.h"

#include	"VimIo.h"


#include 	"VimCodingIn.h"




vimHeader_type *
vim_decoding_header( bst_type *bst )
{
vimHeader_type *vh;
u_char	head[2];
 
 
 
	vh = vimHeader_alloc();


//	vh->bytes = bst_get_align_num( bst, 4 );

	if( bst->byte_no == 5 ){
		bst_free( bst );
		return( vh );
	}
	
	vim_decoding_flags( bst, head, 2 );


	vh->scenes = 1;
	if( head[0] & MH_SCENE_NO )
		vh->scenes = bst_get_align_num( bst, 1 );


	if( head[0] & MH_DATE )
		vh->date = bst_get_align_num( bst, 4 );


	if( head[0] & MH_TITLE )
		vh->title = bst_get_Astring( bst, 64 );


	if( head[0] & MH_COPYRIGHT )
		vh->copyright = bst_get_Astring( bst, 64 );


	if( head[0] & MH_ARTIST )
		vh->artist = bst_get_Astring( bst, 64 );


	if( head[0] & MH_DESCRIPTION )
		vh->description = bst_get_Astring( bst, 256 );


	bst_free( bst );   

	return( vh );
}
