/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*******************************
 ***	VimDEcodingScene.c   ***
 *******************************/
#include	"Uigp/igp.h"
#include	"Ubst/BstType.h"

#include	"GpType/Configuration.h"



#include	"VimageType/VimageType.h"
#include	"VimCodingIn.h"

#include	"AnimCoding/AnimCoding.h"

#include	"VimIo.h"




int
vim_decoding_scene_block( vimage_type *vim, bst_type *bst, vimIo_type *vio )
{
u_char	head[10];
int	r,	g,	b;
 

	vim_decoding_flags( bst, head, 2 );


	vio->cast_no = bst_get_align_num( bst, 1);


	if( head[0] & MS_BACKGROUND_COLOR ){
		r = bst_get_align_num( bst, 1 );
		g = bst_get_align_num( bst, 1 );
		b = bst_get_align_num( bst, 1 );
		vim->color = IMAGE4_RGB( r,g,b);
	}
 

	if( head[0] & MS_NAME )
		bst_get_string( bst, vim->name, 63 );
 

	vim->frame = bst_get_int( bst, 16 );
	vim->row = bst_get_int( bst, 12 );
	vim->column = bst_get_int( bst, 12 );



	vim->Srow = vim->row;
	vim->Scolumn = vim->column;

	if( head[0] & MS_FRAME_SIZE ){
		vim->Srow = bst_get_int( bst, 12 );
		vim->Scolumn = bst_get_int( bst, 12 );
	}
 

	 if( head[0] & MS_FRAMERATE )
		vim->frameRate = bst_get_int( bst, 8 );

 	if( head[0] & MS_PREVIEW_FRAME )
		vim->previewFrame = bst_get_int( bst, 16 );



	if( head[0] & MS_CAMERA_SCENARIO )
		vim->tcp = tcp_decoding( vim->frame, bst );  




	if( head[0] & MS_INTERACTION )
		vim->inL = interactionL_decoding( NULL, bst );
 

	return( 1 );
}




