/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*********************************
 ***	VimDecodingTexture.c   ***
 *********************************/
#include	<string.h>
#include	"Uigp/igp.h"

#include	"GpType/Configuration.h"

#include	"Uigp/igp.h"
#include	"Ubst/BstType.h"

#include	"AgpTool/AgpTool.h"
#include	"Decoding/Decoding.h"

#include	"VimageType/VimageType.h"
#include	"VimIo.h"

#include	"VimCodingIn.h"




int
vim_decoding_texture_block( vimage_type *vim, int Ftexture,
						bst_type *bst, vimIo_type *vio )
{
gp_array	*agp;
cast_type	*cast;


	if( vio->stat == 0 ){
		vim_decoding_texture_block0(  vim, Ftexture, bst, vio );
		return( 1 );
	}


	if( Ftexture == 0 )	return( 1 );


	if( Ftexture & 0x01 ){
		agp = decoding_agp_from_bst( bst );
	}
	else	agp = NULL;




	if( vim->no == 0 ){
		if( agp != NULL )
			vim->bim = bimage_create( agp,
					agp->row, agp->column, vim->color );
		else vim->bim = bimage_create( NULL,
					vim->row, vim->column, vim->color );

		vimIo_add( vio, vim->name, 0, vio->byte0, 'A', bst );

		if( Ftexture & 0x02 )
			vim->bim->agp_bst = bst_make_copy( bst );

		return( 1 );
	}



	cast = vim->cast[vim->no-1];

	cast_set_agp( cast, agp );
	vimIo_add( vio, cast->name, cast->type, vio->byte0, 'A', bst );

	if( Ftexture & 0x02 )
		cast->oim->agp_bst = bst_make_copy( bst );

	return( 1 );
}




int
vim_decoding_texture_block0( vimage_type *vim, int Ftexture,
						bst_type *bst, vimIo_type *vio )
{
gp_array	*agp;
cast_type	*cast;

	agp = decoding_agp_from_bst( bst );
	if( agp == NULL )	return( -1 );


	if( agp->type != AGP_TRANSPARENT && agp->type != AGP_TRANSPARENT_U){
 
		vim->bim = bimage_create( agp,
				agp->row, agp->column, vim->color );

		vim->row = vim->Srow = agp->row;
		vim->column = vim->Scolumn = agp->column;


		vimIo_add( vio, vim->name, 0, vio->byte0, 'A', bst );

		if( Ftexture & 0x02 )
			vim->bim->agp_bst = bst_make_copy( bst );
 
		return( 1 );
	}



	vim->cast[ vim->no++] = cast_create( agp, vio->file );



	if( Ftexture == 1 && vim->row < vim->cast[0]->scale ){
		vim->row = vim->Srow = vim->cast[0]->scale;
		vim->bim = bimage_create( NULL, vim->row, vim->column, vim->color );
	}



	cast = vim->cast[ vim->no-1];
	vimIo_add( vio, cast->name, cast->type, vio->byte0, 'A', bst );

	if( Ftexture & 0x02 )
		cast->oim->agp_bst = bst_make_copy( bst );


	return( 1 );
}








#ifdef IMAGE_BACKGROUND
#include        "ImageReadJpeg.h"
 
image_type *
vim_read_image( bst_type *bst, vimIo_type *vio )
{
image_type *im;
 

	im = image_read_jpg_buffer( bst->data,  bst->byte_no, 0 );

	return( im );
}
#endif
