/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/******************
 ***	VimIo.c	***
 ******************/
#include	<stdio.h>
#include	<math.h>
#include	<string.h>


#include	"Uigp/igp.h"
#include	"Ubst/BstType.h"

#include	"VimageType/VimageType.h"
#include	"VimageType/VimHeader.h"

#include	"VimIo.h"




vimHeader_type	*
vimHeader_alloc( )
{
vimHeader_type	*vh;

	vh = (vimHeader_type *)malloc( sizeof(vimHeader_type));


	vh->scenes = 0;
	vh->bytes = 0;


	vh->title =  NULL;

	vh->copyright =  NULL;

	vh->artist =  NULL;

	vh->description =  NULL;

	vh->date = 0;

	vh->frame_rate1 = 0;

	
	return( vh );
}

void
vimHeader_free( vimHeader_type *vh )
{
	if( vh == NULL )	return;

	if( vh->title != NULL )
		free( vh->title );


	if( vh->copyright != NULL )
		free( vh->copyright );

	if( vh->artist != NULL )
		free( vh->artist );

	if( vh->description != NULL )
		free( vh->description );

	free( vh );
}
