/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/***********************
 ***	VimIo.h   ***
 ***********************/
#ifndef	 _VIM_IO_
#define	 _VIM_IO_

#include	"Ubst/BstType.h"



typedef struct vimE_type {
	char *name;
 
	int	type;
	int	byte0;
	char    head;
	bst_type	*bst;
 
	struct vimE_type *next;
 
} vimE_type;



typedef struct vimIo_type {

	char	file[256];
	int	Ffile;

//	char	config_dir[256];

	int	version;

	int	stat;

	int	cast_no;


	FILE	*fp;

	char	*data;
	int		data_N;
	int		available_data;
	int		data_i;

	int	Fdata;

	int	byte0;	// position of the current block
 
	vimE_type *ve;
 
} vimIo_type;



vimIo_type	*	vimIo_alloc();


vimIo_type *	vimIo_openR_file( char *file );

vimIo_type *	vimIo_openR_buffer( char *data, int len, int Fdata );

vimIo_type *	vimIo_openW_file( char *file );


void	vimIo_free( vimIo_type *vio );

void	vimIo_attach_filename( vimIo_type *vio, char *file );

int	vimIo_is_in( vimIo_type *vio, char head, char *name, int type );

vimE_type * vimIo_get( vimIo_type *vio, char head, char *name );

void	vimIo_add( vimIo_type *vio, char *name, int type,
					int byte0, char head, bst_type *bst );

void	vimIo_append_data( vimIo_type *vio, char *buffer, int len );

void	vimIo_set_data( vimIo_type *vio, char *buffer, int len, int Fdata );

bst_type *	vimIo_cut_data( vimIo_type *vio, int *head );

int	vimIo_get_version( vimIo_type *vio, int *version );

void	vimIo_destroy( vimIo_type *vio );



	/* for Write vim file */
int		vimIo_write_version( vimIo_type *vio );

int	vimIo_write_block( vimIo_type *vio, int head, bst_type *bst );

int	vimIo_write_blockD( vimIo_type *vio, int head, char *data, int bytes );



#endif
