/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*********************************
 ***	VimRetrieveTexture.c   ***
 *********************************/

#include	<string.h>


#include	"Uigp/igp.h"

#include	"VimageType/VimageType.h"

#include	"AgpTool/AgpTool.h"
#include	"Decoding/Decoding.h"

#ifndef _ST
	#include	"VimText/VimText.h"
#endif // _ST

#include	"VimCoding.h"



#include	"VimIo.h"


cast_type *	cast_retrieve_texture_text_ascii( cast_type *bcast );



void
vim_retrieve_texture( vimage_type *vim, int Ftexture, vimIo_type *vio )
{
cast_type	*cast;
int	i;

	for( i = 0 ; i < vim->no ; i++ ){
		cast = vim->cast[i];
		if( cast->oim->agp != NULL )	continue;

		cast_retrieve_texture( cast, Ftexture, vio );

/*
		if ( cast->oim->agp == NULL && cast->type == CAST_TEXT ){
			cast = cast_retrieve_texture_text_ascii( cast );
			vim->cast[i] = cast;
		}
*/
	}
}



int
cast_retrieve_texture( cast_type *cast, int Ftexture, vimIo_type *vio )
{
vimE_type	*ve;
gp_array	*agp;

	ve = vimIo_get( vio, 'A', cast->name );
	if( ve == NULL )	return( -1 );

	if( Ftexture & 0x01 ){
		agp = decoding_agp_from_bst( ve->bst );
		cast_set_agp( cast, agp );
	}

	if( Ftexture & 0x01 )
		cast->oim->agp_bst = bst_make_copy( ve->bst );

	return( 1 );
}


#ifndef _ST
#if defined (__SYMBIAN32__) && !defined(__DEBUG)
	const char	Font_dir[256] = "";
#else
	char	Font_dir[256] = "";
#endif // __SYMBIAN32__

void
vim_read_set_font( char *font_dir )
{
	strcpy( Font_dir, font_dir );
}






cast_type *
cast_retrieve_texture_text_ascii( cast_type *bcast )
{
cast_type	*cast;
text_type	*text;
char	font_file[256];
int	style,	size,	color;


	if( (text = bcast->text) != NULL ){
		style = text->style;
		color = text->color;
		size = text->size;
	}
	else	{
		style = 0;
		color = 0x0000ff;
		size = 30;
	}


	switch( style ){
	case 0:
		sprintf( font_file, "%s\\Arial.vim", Font_dir );
	    break;
	case 1:
		sprintf( font_file, "%s\\Arial_b.vim", Font_dir );
	    break;
	case 2:
		sprintf( font_file, "%s\\Arial_i.vim", Font_dir );
	    break;
	case 3:
		sprintf( font_file, "%s\\Arial_bi.vim", Font_dir );
	    break;
	}

	cast = vim_text_cast( font_file, bcast->name,
					size, color, 0 );

	if( cast != NULL ){
		
		if( cast->ocp != NULL )
			ocpL_destroy( cast->ocp );

		cast->ocp = ocpL_Copy_Change (cast->skl,
						bcast->skl, bcast->ocp );
	}

	cast_destroy( bcast );

	return( cast );
}
#endif