/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include	<stdio.h>
#include	<math.h>


#include	"Uigp/igp.h"
#include	"ImageType/ImageType.h"
#include	"AgpLayer/AgpLayer.h"
#include	"Decoding/Decoding.h"

#include	"VimageType/BimageType.h"

#include	"Rendering/Render.h"


bimage_type *
bimage_alloc()
{
bimage_type *bim;

	bim = ( (bimage_type *)malloc( sizeof(bimage_type) ));
	bim->agp = NULL;

	bim->im = NULL;

	bim->Faux = 0;

	bim->row = 480;
	bim->column = 700;
	bim->color = IMAGE4_RGB( 196, 246, 234 ); 

	bim->depth0 = bim->depth1 = 100;

	bim->Mbr = 0;

	bim->agp_bst = NULL;


	return( bim );
}



void
bimage_free( bimage_type *bim )
{
	if( bim->agp != NULL ){
		if( bim->Faux == 1 )
			render_agp_aux_free( bim->agp );
 
		agp_destroy( bim->agp );
		bim->agp = NULL;
	}


	if( bim->im != NULL )
		image_destroy( bim->im, 1 );


	if( bim->agp_bst != NULL )
		bst_destroy( bim->agp_bst );



	free( bim );
}




bimage_type *
bimage_create( gp_array *agp, int row, int column, int color )
{
bimage_type	*bim;

	bim = ( (bimage_type *)malloc( sizeof(bimage_type) ));
	bim->agp = agp;

	bim->im = NULL;
 
	bim->row = row;
	bim->column = column;

	bim->color = color;
 
	bim->Faux = 0;

	bim->depth0 = bim->depth1 = 100;
	bim->Mbr = 0;

	bim->agp_bst = NULL;
 
	return( bim );                                                        
}

int  
bimage_layer_no( bimage_type *bim )
{
int	type,	row,	column,	bgp, Lcoding, layer_no;

	if( bim->agp != NULL )
		return( agp_layer_no( bim->agp, NULL, NULL ) );


	if( bim->agp_bst != NULL ){
		decoding_agp_bst_info( bim->agp_bst, &type, &row, &column, &bgp, &Lcoding, &layer_no );
		return( layer_no );
	}

	return( 0 );
}