/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************
 ***	CastTool1.c   ***
 ************************/
#include	<string.h>
#include	"AgpLayer/AgpLayer.h"

#include	"VimageType/VimageType.h"


void
cast_simplifay_skl( cast_type *cast )
{
ocp_list	*ocp;
skl_type	*skl;

	skl = skl_make_copy( cast->skl );


	skl_simplifay( skl, 30 );

	ocp = ocpL_Implication ( skl, cast->skl, cast->ocp );

	cast_replace_skl( cast, skl );


	ocpL_free( cast->ocp );

	cast->ocp = ocp;
}




void
cast_simplifay_skl_key( cast_type *cast )
{
ocp_list	*ocp;
skl_type	*skl;

	skl = skl_make_copy( cast->skl );

	skl_simplifay_key( skl );

	ocp = ocpL_Implication ( skl, cast->skl, cast->ocp );

	cast_replace_skl( cast, skl );


	ocpL_free( cast->ocp );

	cast->ocp = ocp;
}




void
cast_replace_skl( cast_type *cast, skl_type *skl )
{

	if( cast->oim->Faux == 1 )
		oimage_skl_aux_clear( cast->oim );


	skl_free( cast->skl );
	cast->skl = skl;

	skl_free( cast->oim->skl );
	cast->oim->skl = skl_make_copy( cast->skl );




	if( cast->oim->Faux == 1 ){
		skl_br_add( cast->oim->skl, cast->oim->br0 );

		skl_free( cast->oim->icp->skl );
		cast->oim->icp->skl = skl_make_copy( cast->oim->skl );

		oimage_skl_aux( cast->oim );
	}
}



cast_type * 
cast_copy_template( cast_type *scast, int Fanim )
{
cast_type *cast;
text_type	*text;

	cast = cast_alloc();
 
	cast->type = scast->type;
 
	cast->scale = scast->scale;
 
 
//	cast->Mproperty = scast->Mproperty;
 
 
 
	strncpy( cast->name, scast->name, 63 );
 
 
	cast->scale = scast->scale;
 
 
	cast->oim = oimage_alloc();
 
//	cast->oim->cp0.x = scast->oim->cp0.x;
//	cast->oim->cp0.y = scast->oim->cp0.y;
//	cast->oim->cp0.z = scast->oim->cp0.z;
 
 
 
	cast->skl = skl_make_copy( scast->skl );
	skl_topology(cast->skl);

 
	cast->oim->skl = skl_make_copy( cast->skl );
 
 
	if( Fanim )
		cast->ocp = ocpL_copy( scast->ocp );
 
 
	if( scast->text != NULL ){
		text = cast->text = TEXT_ALLOC();

		strncpy( text->font, scast->text->font, MAX_FONT_NAME );
 
		text->size = scast->text->size;
 
		text->style = scast->text->style;
 
		text->skl = scast->text->skl;
 
		text->color = scast->text->color;
	}

 
 /*
#ifdef CE 
	if( scast->url != NULL )
		cast->url = _strdup( scast->url );
#else
	if( scast->url != NULL )
		cast->url = strdup( scast->url );
#endif // CE

	if( scast->rcp != NULL )
		cast->rcp = ocpL_copy( scast->rcp );
 */
 
	cast->Flock = scast->Flock;

	return( cast );
}

