/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************
 ***	CastTool1.c   ***
 ************************/
#include	<string.h>
#include	"AgpLayer/AgpLayer.h"
#include	"Decoding/Decoding.h"

#include	"VimageType/VimageType.h"

void
cast_set_moveable( cast_type *cast, int value )
{
	cast->Moveable = value;
}

void
cast_set_flipable( cast_type *cast, int value )
{
	cast->Flipable = value;
}

int
cast_is_moveable( cast_type *cast )
{
	return( cast->Moveable );
}

int
cast_is_flipable( cast_type *cast )
{
	return( cast->Flipable );
}


interaction_type *
cast_interaction_get( cast_type *cast, int trigger, int frame, int type )
{
interaction_type *in;

	if( cast->inL == NULL ) return( NULL );

	in = interactionL_get( cast->inL, trigger, frame, 0 );
	return( in );
}

void 
cast_interaction_add_URL( cast_type *cast, int trigger, int type, char *url )
{
	if( cast->inL == NULL )
		cast->inL = interactionL_alloc();

	interactionL_add_URL( cast->inL, trigger, type, url );
}

int  
cast_layer_no( cast_type *cast )
{
int	type,	row,	column,	bgp, Lcoding, layer_no;

	if( cast->oim->agp != NULL )
		return( agp_layer_no( cast->oim->agp, NULL, NULL ) );


	if( cast->oim->agp_bst != NULL ){
		decoding_agp_bst_info( cast->oim->agp_bst, &type, &row, &column, &bgp, &Lcoding, &layer_no );
		cast->oim->row = row;
		cast->oim->column = column;
		return( layer_no );
	}

	return( 0 );
}


view_type *  
cast_view( cast_type *cast )
{
int	type,	row,	column,	bgp, Lcoding, layer_no;


	if( cast->oim->vw == NULL && cast->oim->agp_bst != NULL ){
		decoding_agp_bst_info_vw( cast->oim->agp_bst,
				&type, &row, &column, &bgp, &Lcoding, &layer_no, &cast->oim->vw );

		cast->oim->row = row;
		cast->oim->column = column;

	}

	return( cast->oim->vw );
}