/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include	<stdio.h>
#include	<math.h>


#include	"VimageType/VimageType.h"

#include	"Rendering/Render.h"

#include	"LinkTool/TlType.h"


static void	agp_skl_aux( gp_array *agp, skl_type *skl );




void
oimage_skl_aux( oimage_type *oim )
{
	skl_mass_point( oim->skl );

	agp_skl_aux( oim->agp, oim->icp->skl );


	if( oim->agpF != NULL )
		agp_skl_aux( oim->agpF, oim->icpF->skl );

}


static void
agp_skl_aux( gp_array *agp, skl_type *skl )
{
jskl_type	*jnt;

#ifdef PDA
	lnk_type	*link[200],	*l;
#else
	lnk_type	*link[10000],	*l;
#endif // PDA



int	no,	i;


	skl_set_bes( skl );

	no = 0;

	for( jnt = skl->jnt ; jnt != NULL ; jnt = jnt->nj ){

		for( i = 0 ; i < jnt->bno ; i++ ){
			if( jnt->b[i].direct != F_BEGIN ) continue;

			if( jnt->b[i].link->width > 0 )	continue;

			for( l = jnt->b[i].link ; l != NULL ; l = LNK_NEXT(l)){
//				l->mbr = (1L<<l->br);
				l->mbr = MBR_BIT(l->br );
				link[no++] = l;
			}

		}
	}

	if( no > 0 )
		agp_pl( agp, link, no );



	for( jnt = skl->jnt ; jnt != NULL ; jnt = jnt->nj ){

		for( i = 0 ; i < jnt->bno ; i++ ){
			if( jnt->b[i].direct != F_BEGIN ) continue;

			if( jnt->b[i].link->width <= 0 )	continue;

			no = 0;
			for( l = jnt->b[i].link ; l != NULL ; l = LNK_NEXT(l)){
//				l->mbr = (1L<<l->br);
				l->mbr = MBR_BIT(l->br );
				link[no++] = l;
			}

			agp_pl( agp, link, no );

		}
	}

}
				
				


void
oimage_skl_aux_clear( oimage_type *oim )
{
	agp_pl_free( oim->agp );

	if( oim->agpF != NULL )
		agp_pl_free( oim->agpF );
}
