/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	VimageAnimAux.c	***
 **************************/
#include	<stdio.h>
#include	<math.h>


#include	"VimageType/VimageType.h"



static ocp_type *	ocp_anim_aux_shot( ocp_type *cp0, int *F0 );


static ocp_type *	oimage_anim_aux_c0_shot( oimage_type *oim,
					ocp_type *cp0, config3d *c0 );


void
vimage_anim_rewind( vimage_type *vim )
{
cast_type	*cast;
int	i;

	vim->tcp->a_cp = vim->tcp->cp;


	for( i = 0 ; i < vim->no ; i++ ){
		cast = vim->cast[i];
		cast->ocp->acp = cast->ocp->cp;
	}


	vim->frame_i = -1;
}





void
vimage_anim_set_aux( vimage_type *vim )
{
cast_type	*cast;
tcp_type	*tcp;
int	i,	frame,	max_frame;

	vim->tcp->a_cp = vim->tcp->cp;


	max_frame = 0;
	for( i = 0 ; i < vim->no ; i++ ){
		cast = vim->cast[i];

		frame = cast_anim_aux( cast, cast->ocp );

		if( frame > max_frame )	max_frame = frame;

		if( cast->oim->Faux == 1 )
			skl_topology( cast->oim->icp->skl );
	}


//	if( vim->no > 0 && max_frame != vim->frame ){
	if( vim->no > 0 && max_frame > vim->frame ){


		for( tcp = vim->tcp->cp ; tcp->next != NULL ;
						tcp = tcp->next );
		if( tcp->fno < max_frame ){
			tcp->fno = max_frame-1;
			vim->frame = max_frame; 
		}

		tcpL_rescale_frame( vim->tcp, vim->frame, max_frame);

		vim->frame = max_frame;
	}


	vim->frame_i = -1;



/*
	if( vim->Avw != NULL ){
		view_crop_pixel( vim->Avw, vim->row, vim->column );
		view_set_pixel( vim->Avw, vim->Rrow, vim->Rcolumn );
	}
*/
}


int
cast_anim_aux( cast_type *cast, ocp_list *ocp )
{
int	frame;

	ocp->acp = ocp->cp;


	frame = -1;



	frame = ocp_anim_aux( ocp );


	if( cast->oim->Faux == 1 )
		oimage_anim_aux_c0( cast->oim, ocp, &cast->oim->Gcp );

/*
	if( cast->rcp != NULL && (cast->Mproperty & MC_ROLE_OVER))
		ocp_anim_aux( cast->rcp );
*/



	return( frame+1 );
}


int
ocp_anim_aux( ocp_list *ocp )
{
ocp_type	*cp;
int     frame;
 
 
	frame = -1;
 
 
	for( cp = ocp->cp ; cp != NULL ; )
		cp = ocp_anim_aux_shot( cp,  &frame );


	return( frame );
}



static ocp_type *
ocp_anim_aux_shot( ocp_type *Fcp, int *F0 )
{
ocp_type	*Lcp;
ocp_type	*cp0,	*cp1,	*cp,	*pcp;
int	fno;
float	t;


	fno = ( *F0 < Fcp->fno )? Fcp->fno : *F0 +1;

	for( cp = Fcp ; cp != NULL ; cp = cp->next ){

		cp->fno = fno;

		if( cp->dfno < 1 )	cp->dfno = 1;

		if( cp->Fshot == SHOT_END )	break;

		fno += cp->dfno;
	}


	Lcp = cp;
	Lcp->dfno = ( Lcp->next != NULL )? Lcp->next->fno - Lcp->fno : 1;
	if( Lcp->dfno < 1 )	Lcp->dfno = 1;

	*F0 = fno;



	/* set intermidate gc */
	cp0 = Fcp;
	cp0->dgc = cp0->gc;
	while( cp0 != Lcp && cp0->next != NULL ){
		for( cp = cp0->next ;
			cp->Fgc == 0 && cp->next != NULL ; cp = cp->next );

		cp1 = cp;


		for( cp = cp0->next, pcp = cp0 ; cp != cp1 ; cp = cp->next ){

			t = ( cp->fno - cp0->fno ) /
					(float)( cp1->fno - cp0->fno );

			cp->gc.x = (1 - t ) *cp0->gc.x + t *cp1->gc.x;
			cp->gc.y = (1 - t ) *cp0->gc.y + t *cp1->gc.y;
			cp->gc.z = (1 - t ) *cp0->gc.z + t *cp1->gc.z;

			cp->gc.u1 = cp->gc.u2 = cp->gc.u3 = 0;


			cp->dgc.x = cp->gc.x - pcp->gc.x;
			cp->dgc.y = cp->gc.y - pcp->gc.y;
			cp->dgc.z = cp->gc.z - pcp->gc.z;
			cp->dgc.u1 = cp->dgc.u2 = cp->dgc.u3 = 0;

			pcp = cp;
		}


		cp1->dgc.x = cp1->gc.x - pcp->gc.x;
		cp1->dgc.y = cp1->gc.y - pcp->gc.y;
		cp1->dgc.z = cp1->gc.z - pcp->gc.z;
/*
		cp1->dgc.u1 =  cp1->gc.u1 - cp0->gc.u1;
		cp1->dgc.u2 =  cp1->gc.u2 - cp0->gc.u2;
		cp1->dgc.u3 =  cp1->gc.u3 - cp0->gc.u3;
*/
		cp1->dgc.u1 =  cp1->gc.u1;
		cp1->dgc.u2 =  cp1->gc.u2;
		cp1->dgc.u3 =  cp1->gc.u3;
		cp0 = cp1;
	}

	return( Lcp->next );
}






void
oimage_anim_aux_c0( oimage_type *oim, ocp_list *ocp, config3d *gc0 )
{
ocp_type	*cp;

	for( cp = ocp->cp ; cp != NULL ; )
		cp = oimage_anim_aux_c0_shot( oim, cp, gc0 );
}



static ocp_type *
oimage_anim_aux_c0_shot( oimage_type *oim, ocp_type *cp0, config3d *c0 )
{
ocp_type	*cp;
vec2d	v;

	v.x = v.y = 0;

	for( cp = cp0 ; cp != NULL ; cp = cp->next ){

		cp->u = cp->c.x - v.x;
		cp->v = cp->c.y - v.y;
		v.x = cp->c.x;
		v.y = cp->c.y;

		oimage_view_cp( oim, c0, &cp->dgc, cp->u, cp->v, &cp->c0 );

		c0 = &cp->c0;

		if( cp->Fshot == SHOT_END )	return( cp->next );
	}

	return( NULL );
}
