/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include	<stdio.h>
#include	<math.h>


#include	"VimageType/VimageType.h"



void
vimage_anim_init( vimage_type *vim, int frame )
{
cast_type     *cast;
int     i;

	vim->frame = frame;
	vim->row = vim->bim->row;
	vim->column = vim->bim->column;


	if( vim->tcp == NULL )
		vim->tcp = tcpL_alloc();
	tcpL_clear( vim->tcp, 2, vim->frame );




	config3d_init( &vim->Gcp );


 
	for( i = 0 ; i < vim->no ; i++ ){
		cast = vim->cast[ i ];

		cast_anim_clear( cast, vim->frame );

	}
 

	vimage_anim_set_aux( vim );
}



void
vimage_anim_init_global( vimage_type *vim )
{
cast_type     *cast;
int     i;



	config3d_init( &vim->Gcp );


 
	for( i = 0 ; i < vim->no ; i++ ){
		cast = vim->cast[ i ];
		config3d_init( &cast->oim->Gcp );
	}
}



int
vimage_anim_is_clear( vimage_type *vim )
{
cast_type	*cast;
int	i;


	if( vim->sound != NULL )	return( 0 );

	if( !tcpL_is_clear( vim->tcp ) )	return( 0 );

	for( i = 0 ; i < vim->no ; i++ ){
		cast = vim->cast[i];

		if( ocpL_is_clear( cast->ocp, cast->skl, vim->frame ) != 1 )
			return( 0 );

	}

	return( 1 );
}

