/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/****************************
 ***	VimageRender.c    ***
 ****************************/
#include	<stdio.h>
#include	<math.h>


#include	"VimageType/VimageType.h"

#include	"Rendering/Render.h"




void
vimage_render( vimage_type *vim, gp_array *agp )
{
view_type	vw;
oimage_type	*oim;
bimage_type	*bim;
int	i;
mbr_type	Csbr;

	view_camera_shift( vim->Avw, 1.0, 1.0, &vim->Ccp, &vw );


	if( vw.Vpixel != agp->row || vw.Upixel != agp->column )
		vim->Sbr = 0;


	bim = vim->bim;

	Csbr = 0;
	if( (vim->Sbr & bim->Mbr ) == bim->Mbr )
		Csbr = bim->Mbr;

	for( i = 0 ; i < vim->no ; i++ ){
		oim = vim->cast[i]->oim;
		if( oim->Falive == 0 )	continue;
		if( (vim->Sbr & oim->Mbr ) == oim->Mbr )
			Csbr |= oim->Mbr;
	}



	render_agp_clear( agp, vim->rbgp, vw.Vpixel, vw.Upixel, Csbr );


 
	if( bim->agp != NULL && ( vim->Sbr & bim->Mbr ) != bim->Mbr )
		render_agp( bim->agp->ad->vw, bim->agp,
				bim->depth0, bim->depth1, &vw, agp );

 
 
	for( i = 0 ; i < vim->no ; i++ ){
		oim = vim->cast[i]->oim;
		if( oim->Falive == 0 )	continue;
		if( (vim->Sbr & oim->Mbr ) == oim->Mbr )	continue;
		oimage_render( oim, &vw, agp );
	}

 
 
/*
	render_agp_geomtric_aux( agp );
*/
}






void
oimage_render( oimage_type *oim, view_type *vw, gp_array *agp )
{
config3d	cp;
view_type	ovw;
gp_array	*sagp;
vec3d	dp,	N;


	cp = oim->Bcp;
	
	sagp = oim->agp;


#ifndef PDA
	oimage_view_N( oim, &cp, &N );


	dp.x = oim->P.x + cp.x - vw->cp.x;
	dp.y = oim->P.y + cp.y - vw->cp.y;
	dp.z = oim->P.z + cp.z - vw->cp.z;



	if(  oim->agpF != NULL && VEC3D_INNER( N, dp ) < 0 ){

		if( cp.u2 < 0 )	cp.u2 += 180;
		else	cp.u2 -= 180;

		sagp = oim->agpF;

		skl_copy_flipV( oim->icp->skl, oim->agp->columnR, oim->icpF->skl);

		skl_set_bes( oim->icpF->skl );
	}


	oimage_view( oim, &cp, &ovw );

	switch( oim->skl->type ){
	case SKL_NULL:
		render_agp( &ovw, sagp, oim->depth0, oim->depth1, vw, agp);
	    break;

	case SKL_GLOBAL:
		render_agp_pl( &ovw, sagp, oim->depth0, oim->depth1, vw, agp);
	    break;

	case SKL_WIDTH:
		render_agp_plw( &ovw, sagp, oim->depth0, oim->depth1, vw, agp);
	    break;
	}

#else
	oimage_view( oim, &cp, &ovw );
	render_agp_pl( &ovw, sagp, oim->depth0, oim->depth1, vw, agp);
#endif
}
