/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************
 *** VimageSelect.c   ***
 ************************/
#include	"VimageType/VimageType.h"

#include	"AgpLayer/AgpLayer.h"



int
vimage_select_object( vimage_type *vim, gp_array *agp, int Flock, vec2d *p, float *depth ) 
{
cast_type	*cast;
oimage_type	*oim;
int	layer,	i;
mbr_type	lock_mbr;
vec2d	ctr;


	lock_mbr = 0;
	for( i = 0 ; i < vim->no ; i++ ){
		cast = vim->cast[i];
		if( Flock && cast->Flock )	lock_mbr |= cast->oim->Mbr;
	}


	layer = agp_layer_select( agp, lock_mbr, p, 5.0, &ctr, depth );

	if( layer == -1 )
		layer = agp_layer_select( agp, lock_mbr, p, 10.0, &ctr, depth );


	if( layer == -1 )
		return( -1 );


//	if( vim->bim->Mbr & ( 1L<< layer ) )
	if( MBR_IS_SET( vim->bim->Mbr, layer ) )
		return( -1 );



	for( i = 0 ; i < vim->no ; i++ ){
		oim = vim->cast[i]->oim;
//		if( oim->agp->ad->Mbr & ( 1L<< layer ) )
		if( MBR_IS_SET( oim->Mbr, layer ) )
			return( i );
	}

	return( -1 );
}
