/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*****************************
 ***	VImageAuxView.c    ***
 *****************************/
#include	<math.h>

#include	"Uigp/igp.h"

#include	"Decoding/Decoding.h"

#include	"VimageType/VimageType.h"



void
vimage_view_init( vimage_type *vim )
{
    if( vim->Avw == NULL )  vim->Avw = VIEW_ALLOC();

    if( vim->bim->agp != NULL && vim->bim->agp->ad != NULL )
            *vim->Avw = *vim->bim->agp->ad->vw;
    else     view_create_noraml( vim->Avw, 1.0/512.0,
                                    vim->bim->row, vim->bim->column );


	view_crop_pixel( vim->Avw, vim->row, vim->column );

	view_set_pixel( vim->Avw, vim->Srow, vim->Scolumn );
}



void
vimage_view_init2( vimage_type *vim )
{
int	type,	row,	column,	bgp, Lcoding, layer_no;
view_type	*vw;

    if( vim->Avw == NULL )  vim->Avw = VIEW_ALLOC();



	view_create_noraml( vim->Avw, 1.0/512.0,
                                    vim->bim->row, vim->bim->column );
	if( vim->bim->agp != NULL && vim->bim->agp->type != AGP_NORMAL ){
		if( vim->bim->agp->ad != NULL )
            *vim->Avw = *vim->bim->agp->ad->vw;

		else	
			if( vim->bim->agp_bst != NULL ){
				decoding_agp_bst_info_vw( vim->bim->agp_bst,
						&type, &row, &column, &bgp, &Lcoding, &layer_no, &vw );
				*vim->Avw = *vw;
				free( vw );
			}
	}				


    else     view_create_noraml( vim->Avw, 1.0/512.0,
                                    vim->bim->row, vim->bim->column );


	view_crop_pixel( vim->Avw, vim->row, vim->column );

	view_set_pixel( vim->Avw, vim->Srow, vim->Scolumn );
}

void
vimage_view_crop( vimage_type *vim, int row, int column )
{
	vim->row = row;
	vim->column = column;

	vim->Srow = vim->row;
        vim->Scolumn = vim->column;

	vimage_view_init( vim );
}



void
vimage_view_rescale( vimage_type *vim, int row, int column )
{
	vim->Srow = row;
	vim->Scolumn = column;

	view_set_pixel( vim->Avw, vim->Srow, vim->Scolumn );
}
