/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*************************
 ***	BimageType.h   ***
 *************************/
#ifndef		_BIMAGE_TYPE_
#define		_BIMAGE_TYPE_

#include	"Ubst/BstType.h"

#include	"ImageType/ImageType.h"


#include	"GpType/GpType.h"





typedef struct bimage_type { 

	char	name[64];

    gp_array        *agp;		// the agp - logical data

	image_type	*im;			// real data of image

	int	color;
	int	row,	column;			// size of image

	// 
	mbr_type	Mbr;					// mask for layers

	int	Faux;					// TURE if vimage render aux set 

	/* AUX */
	float	depth0,	depth1;	



	/* for save agp */
	bst_type	*agp_bst;


}	bimage_type;







	/* BimageTool.c */
bimage_type *	bimage_alloc();

void		bimage_free( bimage_type *bim );


bimage_type *	bimage_create( gp_array *agp, int row, int column, int color);


int		bimage_layer_no( bimage_type *bim );


	/* BimageR2Tool.c */
void    bimage_R2_init( bimage_type *bim );

void    bimage_R2_clear( bimage_type *bim );

void    bimage_R2_render( bimage_type *bim, image_type *imageVim, image_type *depthVim );

#endif
