/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef         _OIMAGE_TYPE_
#define         _OIMAGE_TYPE_

#include	"Ucst/CstType.h"


#include	"GpType/GpType.h"



#include	"OcpType.h"


#include	"SklType/SklType.h"


#include        "Uconfig3d/Config3d.h"


#include	"ImageType/ImageType.h"
 
#ifndef _ST
	#include	"VimageR2/OimageR2Type.h"
#endif // _ST

#ifndef _ST
typedef struct oimage_type {

	char	name[16];	/* may be differ from fname */


	gp_array	*agp;
	gp_array	*agpF;



	int		br0;
//	config3d	cp0;
	int	scale;

  


	mbr_type	Mbr;
	int	Faux;	/* TURE if oimage render aux set */


	/* Skl Animation */
	skl_type	*skl;




	config3d	Gcp;	/* Global Object Camera */


	/* Current Configurtion */
	int	Falive;
	ocp_type	*icp;
	ocp_type	*icpF;

	config3d        Bcp;     /* Current position */




	/* AUX */
	float	depth0,	depth1;
	vec3d	P,	N;
	vec3d	U,	V,	Vp;

	view_type	*vw;



	int	row,	column;


	/* for save agp */
	bst_type	*agp_bst;


	/* ****************** OimageR2 **********************/
	oimageR2_type *oimR2;

}	oimage_type;
#else
typedef struct oimage_type {

	char	name[16];	/* may be differ from fname */


	gp_array	*agp;
	gp_array	*agpF;



	int		br0;
//	config3d	cp0;
	int	scale;

  


	mbr_type	Mbr;
	int	Faux;	/* TURE if oimage render aux set */


	/* Skl Animation */
	skl_type	*skl;




	config3d	Gcp;	/* Global Object Camera */


	/* Current Configurtion */
	int	Falive;
	ocp_type	*icp;
	ocp_type	*icpF;

	config3d        Bcp;     /* Current position */




	/* AUX */
	float	depth0,	depth1;
	vec3d	P,	N;
	vec3d	U,	V,	Vp;

	view_type	*vw;



	int	row,	column;


	/* for save agp */
	bst_type	*agp_bst;


	/* ****************** OimageR2 **********************/
//	oimageR2_type *oimR2;

}	oimage_type;
#endif // _ST




oimage_type *	oimage_alloc();

void		oimage_free( oimage_type *oim );

void		oimage_flipV( oimage_type *oim );

oimage_type *	oimage_make_copy( oimage_type *oim );



	/* OimageTool1.c */
void	oimage_set_scale( oimage_type *oim, int size );



        /* OimageSklAux.c */
void    oimage_skl_aux( oimage_type *oim );
 
void    oimage_skl_aux_clear( oimage_type *oim );



	/* OimageCp.c */
void	oimage_kf_shift( oimage_type *oim, ocp_type *acp,
                        view_type *vw, vec2d *p0, vec2d *p1, int Fshot );

void	oimage_kf_shift_selection( oimage_type *oim, ocp_type *acp,
			view_type *vw, vec2d *p0, vec2d *p1, int endSelection );


void	oimage_kf_normal_shift_ocpL( oimage_type *oim, ocp_list *ocp );

void	oimage_kf_normal_shift( oimage_type *oim, ocp_type *acp );



void	oimage_cp_set_dp_all( oimage_type *oim, ocp_list *ocp );

void	oimage_cp_set_dp( oimage_type *oim, ocp_type *cp );

void	oimage_cp_set_c( oimage_type *oim, vec2d *dp, config3d *c );

void	oimage_kf_shiftD( oimage_type *oim, vec2d *p0, vec2d *p1, vec2d *dp );


#ifndef _ST
	/* ****************** OimageR2 **********************/
	/* OimageR2Tool.c */
void oimage_R2_clear( oimage_type *oim );

void oimage_R2_destroy( oimage_type *oim );

void oimage_R2_border( oimageR2_type *oimR2 );


	/* OimageR2Texture.c */
oimageR2_type *	oimageR2_from_agp( gp_array * agp );

layerR2_type *oimage_R2_makeLayersTexture( gp_array *agp );

void oimage_R2_mapColor24to8( layerR2_type *arrLayersR2, int nLayersR2,
				  u_char color_table, palette_type *palette );


	/* OimageR2Skl.c */
void	oimagR2_skl_aux( oimage_type *oim );

	/* OimageR2Render.c */
void oimage_R2_render( oimage_type *oim, view_type *vw );

void oimage_R2_render_layerR2( layerR2_type *layerR2, int indexDepth,
						image_type *imageVim, image_type *depthVim );

void	oimageR2_aux( oimage_type *oim, int scale, int iCast, int *layer0 );
#endif // _ST

#endif
