/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef         _TCPE_TYPE_
#define         _TCPE_TYPE_

#include	<stdio.h>

#include	"Uconfig3d/Config3d.h"



/*eyal*/
//#define TCP_SHOT_START	1
//#define TCP_SHOT_MID	2
//#define TCP_KEYFRAME	4




// grid macros!!!
#define		FRAME_BLANK			0
#define		FRAME_MIDDLE		3
#define		FRAME_K_STANDALONE	4
#define		FRAME_K_END			5
#define		FRAME_K_BEGIN		6
#define		FRAME_K_MIDDLE		7

#define		FRAME_K				0x04



typedef struct tcp_type {

	config3d        c;

	int	Fshot;

	int     fno,    dfno;

	struct tcp_type *next;

}       tcp_type;



typedef struct tcp_list {
	int	no,	i;
	tcp_type	*cp,	*a_cp;

}       tcp_list;




tcp_type *	tcp_alloc();

void	tcp_free( tcp_type *cp );

int		tcpL_add(tcp_list *tcpL, int fInserted) ;

int		tcpL_insert(tcp_list *tcpL, int fno, int fInserted);


tcp_type *	tcp_make_copy( tcp_type *scp);
tcp_type *	tcp_affine( tcp_type *cp0, tcp_type *cp1, float t, tcp_type *cp );

int	tcp_equals(tcp_type *cp0, tcp_type *cp1);

tcp_list *	tcpL_alloc();

void		tcpL_clear( tcp_list *tcp, int no, int frame );

void		tcpL_destroy( tcp_list *tcp );



int		tcpL_is_clear( tcp_list *tcp );



	/* TcpConfiguration.c */
int	tcp_configuration( tcp_list *tcp, int fno,
				config3d *cp0, config3d *ocp );

	/* TcpLFrame.c */
tcp_type *	tcpL_kf_add( tcp_list *tcp,
				tcp_type *pcp, config3d *c, int fno );

tcp_type *	tcpL_kf_delete( tcp_list *tcp, tcp_type *acp );



void		tcpL_kf_set_fno( tcp_list *ocp, tcp_type *acp, int fno );

tcp_type *	tcpLF_copy( tcp_list *tcp, int frame );
int		tcpLF_paste( tcp_list *tcp, int frame,
					tcp_type *cp, int Fadd );

int	tcpLF_is_kfG( tcp_list *tcp, int frame );


int	tcpLF_is_kf( tcp_list *tcp, int frame );


int		tcpLF_status(tcp_list *ocp, int frame );



int	tcpL_extend_frame( tcp_list *tcp, int frame );

tcp_type *	tcpLF_force_kf( tcp_list *tcp, int frame );


	/* TcpLCopy.c */
tcp_list *	tcpL_copy( tcp_list *stcp );

tcp_list *tcpL_copy_segment( tcp_list *stcp, int f0, int f1 );


int	tcpL_clean(tcp_list *tcp, int frame0, int frame1);

int	tcpL_clip( tcp_list *tcp, int frame );

void	tcpL_rescale_frame( tcp_list *tcp, int cframe_no, int frame_no );

int tcpL_cut(tcp_list *tcp, int frame0, int frame1);

int tcpL_paste_list(tcp_list *tcpl, tcp_list *tcpl1, int frame);


int tcpL_shrink(tcp_list *tcp, int f0, int f1);


	/* TcpLRescale.c */
tcp_list *	tcpL_rescale(  tcp_list *tcp, float Zf );

void	tcpL_remove_unnecessary_KF(tcp_list *tcp);

	/* TcpLAppend.c */
int	tcpL_append( tcp_list *tcp, tcp_list *atcp, int startFrame );


	

#endif
