/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************
 ***	TextType.h   ***
 ************************/
#ifndef         _TEXT_TYPE_
#define         _TEXT_TYPE_ 

#include	"Uigp/igp.h"
#include	"Ubst/BstType.h"

#define		MAX_TEXT_SIZE	64
#define		MAX_FONT_NAME	24

#define		TEXT_BOLD		1
#define		TEXT_ITALIC		2




typedef struct text_type {
	short	text[MAX_TEXT_SIZE];

	char	font[MAX_FONT_NAME];

	char	size;
	char	style;
	char	skl;
	int		color;
} text_type;


#define		TEXT_ALLOC()	\
			( (text_type *)malloc( sizeof( text_type ) ) )


text_type *	textPro_alloc();


void	textPro_set_ascii_text( text_type *tp, char *str );


int	textPro_get_ascii_text( text_type *tp, char *data, int len );

#endif
