/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:	Compositor (simulation)
FILE:       InputDeviceImp.cpp
AUTHORS:    Cyril Concolato ( ENST/COMELEC cyril.concolato@enst.fr )
OVERVIEW:   
-------------------------------------------------------------------------*/
#include "defs.h"
#include "InputSensorImp.h"
#include "Executiv.h"
#include "BifsDec.h"
#include "ODDec.h"
#include "StrParser.h"
#include "ODImp.h"

InputSensorImp::InputSensorImp() : InputSensor()
{
	m_pDecoder = NULL;
}

void InputSensorImp::OnUpdate() 
{
	if (m_pDecoder) {
		if (! (Bool) enabled) {
			if (m_prevEnabled == TRUE) m_isActive = FALSE;
			m_prevEnabled = FALSE;
		} else {
			if (m_prevEnabled == FALSE) m_isActive = TRUE;
			m_prevEnabled = TRUE;
		}
		UpdateBuffer();
	}
}

void InputSensorImp::DeleteObject() 
{
	if (m_pDecoder) m_pDecoder->Terminate();
	StreamConsumer::DeleteObject();
}

Decoder *InputSensorImp::CreateDecoder (DecoderConfigDescriptor *pDecoderConfig, QoS_Descriptor *, Decoder *){

	m_pDecoder = new UIStreamDecoder( GetExecutive(),
								  GetInline(),
								  GetExecutive() -> GetTraceFile(),
								  "UIStream",
								  GetExecutive() -> GetTraceFlags(),
								  pDecoderConfig -> objectTypeIndication == 0xff ? 0 : pDecoderConfig -> objectTypeIndication);

	m_pDecoder->SetNode(this);
	
	UpdateBuffer();

	DecoderImp *pParser = new StreamParser (GetExecutive (), m_pDecoder, GetInline());

	return pParser;

}

void InputSensorImp::UpdateBuffer() {
	m_pDecoder ->UpdateBuffer((const BYTE *) (LPCSTR) buffer,buffer.GetLength());	
}

BOOL InputSensorImp::IsEnabled() {
	return (BOOL)(Bool)enabled;
}
