
import javax.xml.transform.*;
import javax.xml.transform.stream.*;

import java.io.FileOutputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

public class XMTRef
{
	public static void main(String[] args)
		throws TransformerConfigurationException, TransformerException, FileNotFoundException,
		IOException
	
  {  

		XMTRef.xmt2bifs(args[0]);	//code to convert xmt instance to scene instance
		XMTRef.xmt2mux(args[0]);	//code to convert xmt instance to mux instance

  }

        public static void xmt2bifs(String fileName)
		throws TransformerConfigurationException, TransformerException, FileNotFoundException,
		IOException
  {

	TransformerFactory tFactory = TransformerFactory.newInstance();

	Transformer transformer = tFactory.newTransformer(new StreamSource("xmt2bifs.xsl"));

	transformer.transform(new StreamSource(fileName+".xmt"), new StreamResult(new FileOutputStream(fileName+".scene")));
	
	System.out.println("************* "+fileName+".xmt has been successfully converted to "+fileName+".scene  *************");
 
  }

	public static void xmt2mux(String fileName)
		throws TransformerConfigurationException, TransformerException, FileNotFoundException,
		IOException
  {

	TransformerFactory tFactory = TransformerFactory.newInstance();

	Transformer transformer = tFactory.newTransformer(new StreamSource("xmt2mux.xsl"));

	transformer.transform(new StreamSource(fileName+".xmt"), new StreamResult(new FileOutputStream(fileName+".mux")));

	System.out.println("*************  "+fileName+".xmt has been successfully converted to "+fileName+".mux   *************");
 
  }
	

}
