/***********************************************************************
    This software module  was  originally  developed by Zvi  Lifshitz
    (Triton R&D Ltd.) and  Mikael Bourges-Sevenier (France Telecom CNET)
    in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
    standard.  This software module is an implementation of a part of
    one or more MPEG-4 Systems (ISO/IEC 14496-1) tools  as  specified
    by  the  MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC gives
    users of the MPEG-4 Systems (ISO/IEC 14496-1)  free  license  to
    this software module or modifications thereof for use in hardware
    or software products claiming conformance to the  MPEG-4  Systems
    (ISO/IEC 14496-1). Those intending to use this software module in
    hardware or software  products  are  advised  that  its  use  may
    infringe   existing  patents.  The  original  developer  of  this
    software module and his/her company, the subsequent  editors  and
    their  companies,  and  ISO/IEC have no liability for use of this
    software module or modifications thereof  in  an  implementation.
    Copyright  is not released for non MPEG-4 Systems (ISO/IEC 14496-
    1) conforming  products.  Triton R&D Ltd. and France  Telecom  CNET
    retain  full  right to use the code for their own purpose, assign
    or donate the code to a third party and to inhibit third  parties
    from  using  the  code  for  non MPEG-4 Systems (ISO/IEC 14496-1)
    conforming products. This copyright notice must  be  included  in
    all copies or derivative works. Copyright  1997.
************************************************************************/

/**************************************************************************
 * Project Im1Player
 * INTERNATIONAL STANDARD ORGANIZATION
 * ISO/IEC JTC1/SC29/WG11
 *
 * SUBSYSTEM: BIFS Encoder/Decoder
 * FILE:      NodeStub.cpp
 * AUTHOR:    Mikael Bourges-Sevenier (Mindego Inc.)
 * OVERVIEW:  Void implementation of eventIn handlers.
 *
 * Comment:   Automatically generated on Wed Jul 09 10:40:43 PDT 2003
 *            by parsing the MPEG-4 node templates files.
 *            Contact: mikael@mindego.com
 *
 **************************************************************************/
#include "defs.h"
#include "nodes.h"

/* Currently, we have 177 nodes defined. */

void Anchor :: OnaddChildren() {}
void Anchor :: OnremoveChildren() {}
void Anchor :: Onactivate() {}
void AudioDelay :: OnaddChildren() {}
void AudioDelay :: OnremoveChildren() {}
void AudioFX :: OnaddChildren() {}
void AudioFX :: OnremoveChildren() {}
void AudioMix :: OnaddChildren() {}
void AudioMix :: OnremoveChildren() {}
void AudioSource :: OnaddChildren() {}
void AudioSource :: OnremoveChildren() {}
void AudioSwitch :: OnaddChildren() {}
void AudioSwitch :: OnremoveChildren() {}
void Background :: Onset_bind() {}
void Background2D :: Onset_bind() {}
void Billboard :: OnaddChildren() {}
void Billboard :: OnremoveChildren() {}
void Collision :: OnaddChildren() {}
void Collision :: OnremoveChildren() {}
void ColorInterpolator :: Onset_fraction() {}
void CompositeTexture2D :: OnaddChildren() {}
void CompositeTexture2D :: OnremoveChildren() {}
void CompositeTexture3D :: OnaddChildren() {}
void CompositeTexture3D :: OnremoveChildren() {}
//void Conditional :: Onactivate() {}
//void Conditional :: OnreverseActivate() {}
void CoordinateInterpolator :: Onset_fraction() {}
void CoordinateInterpolator2D :: Onset_fraction() {}
void ElevationGrid :: Onset_height() {}
void Extrusion :: Onset_crossSection() {}
void Extrusion :: Onset_orientation() {}
void Extrusion :: Onset_scale() {}
void Extrusion :: Onset_spine() {}
void Fog :: Onset_bind() {}
void Form :: OnaddChildren() {}
void Form :: OnremoveChildren() {}
void Group :: OnaddChildren() {}
void Group :: OnremoveChildren() {}
void IndexedFaceSet :: Onset_colorIndex() {}
void IndexedFaceSet :: Onset_coordIndex() {}
void IndexedFaceSet :: Onset_normalIndex() {}
void IndexedFaceSet :: Onset_texCoordIndex() {}
void IndexedFaceSet2D :: Onset_colorIndex() {}
void IndexedFaceSet2D :: Onset_coordIndex() {}
void IndexedFaceSet2D :: Onset_texCoordIndex() {}
void IndexedLineSet :: Onset_colorIndex() {}
void IndexedLineSet :: Onset_coordIndex() {}
void IndexedLineSet2D :: Onset_colorIndex() {}
void IndexedLineSet2D :: Onset_coordIndex() {}
void Layer2D :: OnaddChildren() {}
void Layer2D :: OnremoveChildren() {}
void Layer3D :: OnaddChildren() {}
void Layer3D :: OnremoveChildren() {}
void Layout :: OnaddChildren() {}
void Layout :: OnremoveChildren() {}
void ListeningPoint :: Onset_bind() {}
void NavigationInfo :: Onset_bind() {}
void NormalInterpolator :: Onset_fraction() {}
void OrderedGroup :: OnaddChildren() {}
void OrderedGroup :: OnremoveChildren() {}
void OrientationInterpolator :: Onset_fraction() {}
void PositionInterpolator :: Onset_fraction() {}
void PositionInterpolator2D :: Onset_fraction() {}
void ScalarInterpolator :: Onset_fraction() {}
void TermCap :: Onevaluate() {}
void Transform :: OnaddChildren() {}
void Transform :: OnremoveChildren() {}
void Transform2D :: OnaddChildren() {}
void Transform2D :: OnremoveChildren() {}
void Valuator :: OninSFBool() {}
void Valuator :: OninSFColor() {}
void Valuator :: OninMFColor() {}
void Valuator :: OninSFFloat() {}
void Valuator :: OninMFFloat() {}
void Valuator :: OninSFInt32() {}
void Valuator :: OninMFInt32() {}
void Valuator :: OninSFRotation() {}
void Valuator :: OninMFRotation() {}
void Valuator :: OninSFString() {}
void Valuator :: OninMFString() {}
void Valuator :: OninSFTime() {}
void Valuator :: OninSFVec2f() {}
void Valuator :: OninMFVec2f() {}
void Valuator :: OninSFVec3f() {}
void Valuator :: OninMFVec3f() {}
void Viewpoint :: Onset_bind() {}
void Hierarchical3DMesh :: OntriangleBudget() {}
void TemporalTransform :: OnaddChildren() {}
void TemporalTransform :: OnremoveChildren() {}
void TemporalGroup :: OnaddChildren() {}
void TemporalGroup :: OnremoveChildren() {}
//void ServerCommand :: Ontrigger() {}
void CoordinateInterpolator4D :: Onset_fraction() {}
void FFD :: OnaddChildren() {}
void FFD :: OnremoveChildren() {}
void MeshGrid :: Onset_colorIndex() {}
void MeshGrid :: Onset_coordIndex() {}
void MeshGrid :: Onset_normalIndex() {}
void MeshGrid :: Onset_texCoordIndex() {}
void NurbsCurve :: Onset_colorIndex() {}
void NurbsCurve2D :: Onset_colorIndex() {}
void NurbsSurface :: Onset_colorIndex() {}
void NurbsSurface :: Onset_texColorIndex() {}
void PositionAnimator :: Onset_fraction() {}
void PositionAnimator2D :: Onset_fraction() {}
void PositionInterpolator4D :: Onset_fraction() {}
void SBBone :: OnaddChildren() {}
void SBBone :: OnremoveChildren() {}
void SBSegment :: OnaddChildren() {}
void SBSegment :: OnremoveChildren() {}
void SBSite :: OnaddChildren() {}
void SBSite :: OnremoveChildren() {}
void ScalarAnimator :: Onset_fraction() {}
void SubdivisionSurface :: Onset_colorIndex() {}
void SubdivisionSurface :: Onset_coordIndex() {}
void SubdivisionSurface :: Onset_cornerVertexIndex() {}
void SubdivisionSurface :: Onset_creaseEdgeIndex() {}
void SubdivisionSurface :: Onset_creaseVertexIndex() {}
void SubdivisionSurface :: Onset_dartVertexIndex() {}
void SubdivisionSurface :: Onset_texCoordIndex() {}
void ColorTransform :: OnaddChildren() {}
void ColorTransform :: OnremoveChildren() {}
// void SynthesizedTexture :: OnaddChildren() {}
// void SynthesizedTexture :: OnremoveChildren() {}
void TransformMatrix2D :: OnaddChildren() {}
void TransformMatrix2D :: OnremoveChildren() {}
void Viewport :: Onset_bind() {}
void Clipper2D :: OnaddChildren() {}
void Clipper2D :: OnremoveChildren() {}
void PathLayout :: OnaddChildren() {}
void PathLayout :: OnremoveChildren() {}
void AdvancedAudioBuffer :: OnaddChildren() {}
void AdvancedAudioBuffer :: OnremoveChildren() {}
void AudioChannelConfig :: OnaddChildren() {}
void AudioChannelConfig :: OnremoveChildren() {}
void Transform3DAudio :: OnaddChildren() {}
void Transform3DAudio :: OnremoveChildren() {}
void FootPrintSet :: OnaddChildren() {}
void FootPrintSet :: OnremoveChildren() {}
void Shadow :: OnaddChildren() {}
void Shadow :: OnremoveChildren() {}
/* End of automatically generated file */
