/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1998.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Zvi Lifshitz at zvil@csi.com.
----------------------------------------------------------------------*/

#if !defined(_presenter_h)	// Sentry, use file only if it's not already included.
#define _presenter_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Presenter
FILE:       Presenter.h
AUTHOR:     Zvi Lifshitz (Triton R&D Ltd.)
OVERVIEW:   Definition of Presenter
-------------------------------------------------------------------------*/
#include "PresBase.h"

class Presenter : public PresenterBase
{
	DWORD m_dwIterations, m_dwOffset;
	FILE *m_fLogFile;
	BOOL m_bClockActive;
	DWORD m_dwStartTime;

public:
	DWORD GetClockTime ();
	long GetClockOffset () {return (long) m_dwOffset;}
	void SetClock (BOOL bOn);
	BOOL ClockActive () {return m_bClockActive;}
	Presenter (Executive *pExecutive, HWND hWnd);
	~Presenter ();
	virtual void GetCapabilities (Capabilities *pPresentationCapabilities);
	virtual void Start ();
	virtual void OnUserEvent (USER_EVENT event, int x, int y, UINT uControlKeysStatus);
	virtual DWORD GetTime ();
	virtual int GetIterationInterval () {return 30;}
	virtual void Render ();
	void LogStream (DWORD dwSceneTime, LPCSTR szDesc, int nodeID, int nID, int nUnitSize, DWORD dwTime);
	void Logf (DWORD dwSceneTime, LPCSTR szFormat, ...);
};

/*-------------------------------------------------------------
Context structure for the Render function
-------------------------------------------------------------*/
class ZPresenterContext : public PresenterContext
{	
public:
	ZPresenterContext (DWORD dwIteration) : m_dwIteration (dwIteration), m_nTabs (0) {}
public:
	int m_nTabs;
	DWORD m_dwIteration;
	DWORD m_dwCTS;
};

#endif                                      // _presenter_h sentry.
