/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Optibase Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Optibase Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1997.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Zvi Lifshitz at zvil@csi.com.
----------------------------------------------------------------------*/

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Presenter (simulation)
FILE:       ZFlxTime.cpp
AUTHOR:     Zvi Lifshitz (Optibase Ltd.)
OVERVIEW:   Implementation of my overloading nodes for FlexTime
-------------------------------------------------------------------------*/

#include "defs.h"
#include "ZFlxTime.h"
#include "Presenter.h"

/*-------------------------------------------------------------
The Render method of TemporalTransform applies temporal transformation on its child
nodes and on the URL (or segment) it controls.
Temporal transformation is enabled through the use of a context variable, which passes between
Render function during scene traversal
-------------------------------------------------------------*/
BOOL ZTemporalTransform :: Render (PresenterContext *pContext)
{
	/*-------------------------------------------------------------
	Cooy the context class and call Transform to apply temporal transformation on it
	-------------------------------------------------------------*/
	ZPresenterContext context = *(ZPresenterContext *) pContext;
	Transform (&context);

	/*-------------------------------------------------------------
	Render the children under new temporal values
	-------------------------------------------------------------*/
	++context.m_nTabs;
	for (int i = 0; i < children.GetLength (); i++)
	{	MediaObject *pObject = children [i];
		if (pObject)
			pObject -> Render (&context);
	}

//	if (GetUpdateTime () == GetPresenter () -> GetTime ())
//		GetPresenter () -> Logf (
//			"%*c%d:TemporalTransform - isActive: %s\n",
//			((PresenterContext *) pContext) -> m_nTabs*3,
//			' ',
//			GetID (),
//			(Bool) isActive ? "TRUE" : "FALSE"
//		);


	return TRUE;
}
