/*
This software module was originally developed by Apple Computer, Inc.
in the course of development of MPEG-4. 
This software module is an implementation of a part of one or 
more MPEG-4 tools as specified by MPEG-4. 
ISO/IEC gives users of MPEG-4 free license to this
software module or modifications thereof for use in hardware 
or software products claiming conformance to MPEG-4.
Those intending to use this software module in hardware or software
products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company,
the subsequent editors and their companies, and ISO/IEC have no
liability for use of this software module or modifications thereof
in an implementation.
Copyright is not released for non MPEG-4 conforming
products. Apple Computer, Inc. retains full right to use the code for its own
purpose, assign or donate the code to a third party and to
inhibit third parties from using the code for non 
MPEG-4 conforming products.
This copyright notice must be included in all copies or
derivative works. Copyright (c) 1999.
*/
/*
	$Id: MP4LinkedList.h,v 1.1.1.1 2003/12/24 00:52:31 mikeseven Exp $
*/
#ifndef INCLUDED_MP4_LINKED_LIST_H
#define INCLUDED_MP4_LINKED_LIST_H

#include "MP4Movies.h"


typedef struct MP4ListItem
{
	struct MP4ListItem* link;
	void *data;
} MP4ListItem, *MP4ListItemPtr;

typedef struct MP4List
{
	struct MP4ListItem *head;
	struct MP4ListItem *tail;
	u32                 entryCount;
	int                 foundEntryNumber;
	struct MP4ListItem *foundEntry;
} MP4List, *MP4LinkedList;

MP4Err MP4MakeLinkedList( MP4LinkedList *outList );
MP4Err MP4PrependListEntry( MP4LinkedList list, void *item );
MP4Err MP4AddListEntry( void* item, MP4LinkedList list );
MP4Err MP4DeleteLinkedList( MP4LinkedList list );
MP4Err MP4GetListEntryCount( MP4LinkedList list, u32 *outCount );
MP4Err MP4GetListEntry( MP4LinkedList list, u32 itemNumber, char* *outItem );

#endif
