/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1998.
************************************************************************/

// AUTHOR : Bindu
// DESCRIPTION: This is to populate the jump-table with the DMIF related functions, 
// accessed in the DMIFMnitorImp.cpp file. 
// Created : 07/16/99


// SOLARIS PORTING
#ifdef WIN32
//#include <windows.h>
#endif

#include "DMIFMonitor.h"
#include "Executiv.h"
#include "AL.h" 
#include "MPEGJTerminalInterface.h"
#include <jni.h>
#include <assert.h>

Executive* DMIFMonitor::m_pExec = 0;


MPJErr DMIFMonitor::MyNumChannels()
{
	ALManager* m_almn;
	
	#ifdef MPGJ
	if ( m_pExec != NULL )
		m_almn = m_pExec->GetALManager();
	else {
		return -1;
	}	

	if( m_almn != NULL)
	{		 
		if(m_almn -> m_channels != NULL)  {
			int len = (m_almn-> m_channels).GetLength();
			return len;		
		}
		else{
			assert(0);
			return -1;
		}
	}
	else{
		assert(0);
		return -1;
	}
	#endif
	return -1;
	
}

DMIFMonitor::DMIFMonitor(Executive* e) {
	m_pExec = e; 	
}

bool DMIFMonitor::initialize(MPJTerminalDispatchTablePtr d)
{
	bool success = false;
	

// SOLARIS PORTING
#ifdef WIN32
	HINSTANCE theDLLInstance = LoadLibrary("mpjterminal");
#else
	void * theDLLInstance = dlopen("libmpjterminal.so", RTLD_LAZY);
#endif
	if ( theDLLInstance )
	{
		typedef void (*setTableFunc)(MPJTerminalDispatchTablePtr);

// SOLARIS PORTING
#ifdef WIN32
		setTableFunc setTable = (setTableFunc) GetProcAddress( 
theDLLInstance, "MPJSetTerminalDispatchTable");
#else
		setTableFunc setTable = (setTableFunc) dlsym( 
theDLLInstance, "MPJSetTerminalDispatchTable");
#endif
		if ( setTable )
		{
			if( m_pExec != NULL)
				d -> numChannels = MyNumChannels;
			else
				assert(0);
			setTable(d);
			success = true;

		}
	}
	return success;
}
