/********************************************************************
 This software module was originally developed by Roberto Becchini
 (SIA - I - SOMMIT Consortium), Barbara Silano (SIA - I - SOMMIT 
Consortium) and edited by Luca Deri (Finsiel - I - SOMMIT Consortium),
 Gianluca De Petris (CSELT - I - SOMMIT Consortium) in the course of 
development of the MPEG-4 Systems (ISO/IEC 14496-1). This software 
module is an implementation of part of one or more MPEG-4 Systems 
(ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
14496-1). ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) 
free license to this software module or modifications thereof for use 
in hardware or software products claiming conformance to the MPEG-4 
Systems (ISO/IEC 14496-1). Those intending to use this software 
module in hardware or software products are advised that its use may 
infringe existing patents. THE ORIGINAL DEVELOPER OF THIS SOFTWARE 
MODULE AND HIS/HER COMPANY, THE SUBSEQUENT EDITORS AND THEIR 
COMPANIES, AND ISO/IEC HAVE NO LIABILITY FOR USE OF THIS SOFTWARE 
MODULE OR MODIFICATIONS THEREOF. No license to this software module 
is granted for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. The SOMMIT Consortium retains full right to use the 
software module for his/her own purpose, assign or donate the 
software module to a third party and to inhibit third parties from 
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. This copyright notice must be included in all copies or 
derivative works of the software module. Copyright 1999
********************************************************************/
/*-------------------------------------------------------------------------
MPEGJ 
AUTHORS:    Viswanathan Swaminathan - vishy@eng.sun.com 
			Robert Schmidt(RLS)
			Praveen Alavilli(PA) 
			YUNTAI KYONG(YT) - yuntaikyong@ieee.org
-------------------------------------------------------------------------*/

#include <AL.h>
#include <Channel.h>
#include "../mpegj/stubs/org_iso_mpeg_mpegjRefImpl_net_DMIFMonitorImp.h"

#include "../Mpgj/sources/DMIFbridge.h" //per la definizione di getinfo()
#include "MPEGJTerminalInterface.h" // BINDU - to access the table!!!

// SOLARIS PORTING
#ifdef WIN32
//#include <windows.h>
#endif

#include <assert.h>
// MPEGJ - PA
#include "Inline.h"
#include "Executiv.h"
#include "ODImp.h"




JNIEXPORT jint JNICALL Java_org_iso_mpeg_mpegjRefImpl_net_DMIFMonitorImp_getChannelIDNat
  (JNIEnv *, jobject, jint pos)

{
	int ind = 0;
	ind = pos;
	ALManager *al = getinfo();	
	#ifdef MPGJ
	return(al->m_channels[ind]->GetESid());
	#endif

	return -1;


}

JNIEXPORT jlong JNICALL Java_org_iso_mpeg_mpegjRefImpl_net_DMIFMonitorImp_getSessionIDNat
  (JNIEnv *, jobject)
{	
	ALManager *al = getinfo();	
	return al->GetServiceID();
}

// Function changed by BINDU to test the new framework....

JNIEXPORT jint JNICALL Java_org_iso_mpeg_mpegjRefImpl_net_DMIFMonitorImp_getnumOfChannelsNat
  (JNIEnv *, jobject)
{
	int len = 0;
	
	// old code
	//ALManager *al = getinfo();	
	//len = (al->m_channels).GetLength();
	// return len;
	
	/* what follows is similar to code in the MPJTerminal.cpp - note that this is 
	 * the native side on the MPEGJ side which is interacting with java APIs 
	 * requiring dynamic information from the player. - BINDU  */
	
	
	MPJTerminalDispatchTablePtr d = MPJGetTerminalDispatchTable();
	if ( d && (d->numChannels) )
		len = (int) d->numChannels();
	else 
		assert(0);


	
	return len;

}

JNIEXPORT jstring JNICALL Java_org_iso_mpeg_mpegjRefImpl_net_DMIFMonitorImp_getURLNat
  (JNIEnv *env, jobject obj)
{
	jstring str_test;
	ALManager *al;
	al = getinfo();
	str_test = (env)->NewStringUTF(al->GetURL());
	return str_test;

}

JNIEXPORT jint JNICALL Java_org_iso_mpeg_mpegjRefImpl_net_DMIFMonitorImp_getStatusNat
  (JNIEnv *, jobject, jlong channelID)
{
	int		i	= 0;
	int		len = 0;
	long	id	= 0;
	int		status=0;
	ALManager *al = getinfo();	

	#ifdef MPGJ
	len = al->m_channels.GetLength();
	for(i = 0; i < len; i++)
	{	
		if( (id = al->m_channels[i]->GetESid()) == channelID)
			return(al->m_channels[i]->m_state);
	}
	#endif

	return(1);//DA STABILIRE ERRORE

}

JNIEXPORT jint JNICALL Java_org_iso_mpeg_mpegjRefImpl_net_DMIFMonitorImp_getErrNat
  (JNIEnv *, jobject, jlong channelID)
{
	int		i	= 0;
	int		len = 0;
	long	id	= 0;
	ALManager *al = getinfo();	
	#ifdef MPGJ
	len = al->m_channels.GetLength();
	for(i = 0; i < len; i++)
	{
		if( (id = al->m_channels[i]->GetESid()) == channelID)
			return(al->m_channels[i]->error);
	}
	#endif

	return(1);//DA STABILIRE ERRORE
}


JNIEXPORT jint JNICALL Java_org_iso_mpeg_mpegjRefImpl_net_DMIFMonitorImp_getAUrateNat
  (JNIEnv *, jobject, jlong channelID)
{

	int		i	= 0;
	int		len = 0;
	long	id	= 0;
	
	ALManager *al = getinfo();	
	
	#ifdef MPGJ
	len = al->m_channels.GetLength();
	for(i = 0; i < len; i++)
	{
		if( (id = al->m_channels[i]->GetESid()) == channelID)
			return(al->m_channels[i]-> retrievedCredit);
	}
	#endif

	return(1);//DA STABILIRE ERRORE

}

JNIEXPORT jlong JNICALL Java_org_iso_mpeg_mpegjRefImpl_net_DMIFMonitorImp_getODIDNat
  (JNIEnv *, jobject, jlong channelID)
{

	int		i	= 0;
	int		len = 0;
	long	id	= 0;	
	
	ALManager *al = getinfo();	
	InlineImp* pInline;
	#ifdef MPGJ
	pInline = al->GetExecutive()->GetInline();

	len = pInline->m_streamAssociation.GetLength();
	for ( i=0; i< len; i++ ) {
		ObjectDescriptorImp* odImp = pInline->m_streamAssociation[i].m_pOD;
		for ( int j = 0; j < odImp->esDescr.GetLength(); j++ ) {
				ES_DescriptorImp* esImp = (ES_DescriptorImp*)odImp->esDescr[j];
				if ( esImp->ES_ID == channelID ) {
					return odImp->ObjectDescriptorID; 
					
				}
			}
	}	
	#endif
	return -1;
}








