 /****************************************************************
 This software module is an implementation of part of one or more 
 MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 
 Systems (ISO/IEC 14496-1). ISO/IEC gives users of the MPEG-4 
 Systems (ISO/IEC 14496-1) free license to this software module or
 modifications thereof for use in hardware or software products 
 claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
 Those intending to use this software module in hardware or software 
 products are advised that its use may infringe existing patents. 
 THE ORIGINAL DEVELOPER OF THIS SOFTWARE MODULE AND HIS/HER COMPANY,
 THE SUBSEQUENT EDITORS AND THEIR COMPANIES, AND ISO/IEC HAVE NO 
 LIABILITY FOR USE OF THIS SOFTWARE MODULE OR MODIFICATIONS THEREOF. 
*******************************************************************/
/*-------------------------------------------------------------------------
MPEGJ 
AUTHORS:    Viswanathan Swaminathan - vishy@eng.sun.com 
			Robert Schmidt(RLS)
			Praveen Alavilli(PA) 
			YUNTAI KYONG(YT) - yuntaikyong@ieee.org
-------------------------------------------------------------------------*/

#ifndef INCLUDED_MPDECODER_IM1_IMP_H
#define INCLUDED_MPDECODER_IM1_IMP_H

#include <jni.h>
#include "Executiv.h"
//class Executive;
#include "../mpegj/stubs/org_iso_mpeg_mpegjRefImpl_decoder_MPDecoderImp.h" 
//*** YT START (137)
class ES_DescriptorImp;
class DecoderImp;
//*** YT END (137)

//*** YT START (138)
// definition of decoderAssociation
// remember the refrence to the detached decoder
// associate it with ODID and ESID
struct decoderAssociation
{
	int m_odID;
	int m_esID;
	DecoderImp *m_decoder;
	operator int () const {return m_esID;}
	decoderAssociation(int esID=-1,int odID=-1) : m_odID(odID), m_esID(esID), m_decoder(NULL) {}
	~decoderAssociation() {}
};
//*** YT END (138)

class MPDecoder
{
	//*** YT START (139)
	static ZArray<decoderAssociation>* s_decoderAssociation;
	static ZSemaphore zLock;
public:	
	static Executive* myExecutive;
	static bool initialize (Executive *e);
	static int StartDecoding (long);
	static int StopDecoderOnNode(long);
	static int DetachDecoder( int, int);
	static int AttachDecoder( int, int);
	static int PauseDecoding();
	static int ResumeDecoding();
	static int IsPauseable();
	static int GetDecoderInstance();
	static int GetDecoderType(int);
	static int GetDecoderTypeNat(long, long);
	static char* GetDecoderVendor();
private:
	//*** YT START (140)
	static StreamConsumer* GetStreamConsumer(int odID);
	static ES_DescriptorImp* GetESDescriptor(int odID,int esID);
	static ObjectDescriptorImp* GetObjectDescriptor(int odID);
	//*** YT END (140)
};

#endif
