 /****************************************************************
 This software module is an implementation of part of one or more 
 MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 
 Systems (ISO/IEC 14496-1). ISO/IEC gives users of the MPEG-4 
 Systems (ISO/IEC 14496-1) free license to this software module or
 modifications thereof for use in hardware or software products 
 claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
 Those intending to use this software module in hardware or software 
 products are advised that its use may infringe existing patents. 
 THE ORIGINAL DEVELOPER OF THIS SOFTWARE MODULE AND HIS/HER COMPANY,
 THE SUBSEQUENT EDITORS AND THEIR COMPANIES, AND ISO/IEC HAVE NO 
 LIABILITY FOR USE OF THIS SOFTWARE MODULE OR MODIFICATIONS THEREOF. 
*******************************************************************/
/*-------------------------------------------------------------------------
MPEGJ 
AUTHORS:    Viswanathan Swaminathan - vishy@eng.sun.com 
			Robert Schmidt(RLS)
			Praveen Alavilli(PA) 
			YUNTAI KYONG(YT) - yuntaikyong@ieee.org
-------------------------------------------------------------------------*/


// SOLARIS PORTING - Added defs.h
#ifdef WIN32
//#include <windows.h>
#endif

#include "defs.h"

#include "MPEGJTerminal.h"
//#include "Executiv.h" // Bindu - not needed here any more
#include "MPEGJTerminalInterface.h"
#include <jni.h>
#include "DMIFMonitor.h" // bindu
#include <assert.h>
#include "ResourceManagerIM1Imp.h" //PA- for resource manager
#include "MPDecoderIM1Imp.h" //PA- for mpdecoder

JavaVM *MPEGJTerminal::s_jvm = 0;
// PORTING to Java 2
//JNIEnv *MPEGJTerminal::s_env = 0;
void *MPEGJTerminal::s_env = 0;

// SOLARIS PORTING
#ifdef WIN32
extern __declspec( dllexport ) bool __cdecl InitializeMPEGJ( Executive *e )
#else
bool InitializeMPEGJ( Executive *e )
#endif
{
	return MPEGJTerminal::initialize( e );
}

MPJErr MyExamplePlayerCall()
{
	return 0;
}

bool MPEGJTerminal::initialize( Executive *e )
{
	bool success = false;

// SOLARIS PORTING
#ifdef WIN32
	HINSTANCE theDLLInstance = LoadLibrary("mpjterminal");
#else
	void * theDLLInstance = dlopen("libmpjterminal.so", RTLD_LAZY);
#endif
	if ( theDLLInstance )
	{
		typedef void (*setTableFunc)(MPJTerminalDispatchTablePtr);

// SOLARIS PORTING
#ifdef WIN32
		setTableFunc setTable = (setTableFunc) GetProcAddress( 
theDLLInstance, "MPJSetTerminalDispatchTable");
#else
		setTableFunc setTable = (setTableFunc) dlsym( 
theDLLInstance, "MPJSetTerminalDispatchTable");
#endif
		if ( setTable )
		{
			MPJTerminalDispatchTablePtr dispatch = new MPJTerminalDispatchTable;
			dispatch->examplePlayerCall = MyExamplePlayerCall;	

			dispatch->dEQ = NULL;				
			dispatch->rEQ = NULL;

			if( e!= NULL){
				// initialize all managers
				DMIFMonitor *dmifMon = new DMIFMonitor(e);
				dmifMon -> initialize(dispatch);
				// This should actually be in a different table structure
				// like MPJNetDispatchTable ( should be moved from here )
				// and that Network Managers's initialize
				// should be called from MPEGJTerminal::initialize().
				// similar to the following code for initializing  Resource manager 
				// and MPDecoder function tables'.
				ResourceManager * resManager = new ResourceManager();
				resManager->initialize(e );
				MPDecoder *myDecoder = new MPDecoder();
				myDecoder->initialize(e); 
				// similarly sceneInterface function table should be initiaized here				
			}
			else
				assert(0);
			setTable( dispatch );
			success = true;
		}
	}
	return success;
}


bool MPEGJTerminal::startJavaVM( const char *garbage )
{
	JDK1_1InitArgs vm_args;
	vm_args.version = 0x00010001; /* New in 1.1.2: VM version */
	JNI_GetDefaultJavaVMInitArgs( &vm_args );	
	return JNI_CreateJavaVM( &s_jvm, &s_env, &vm_args );
}
