/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1998.
************************************************************************

/*-------------------------------------------------------------------------
MPEGJ 
AUTHORS:    Viswanathan Swaminathan - vishy@eng.sun.com 
			Robert Schmidt(RLS)
			Praveen Alavilli(PA) 
			YUNTAI KYONG(YT) - yuntaikyong@ieee.org
-------------------------------------------------------------------------*/

#ifndef INCLUDED_MPEGJTERMINAL_INTERFACE_H
#define INCLUDED_MPEGJTERMINAL_INTERFACE_H

// SOLARIS PORTING
#ifdef WIN32
#ifdef MPEGJDLLAPI
#define MPJ_EXTERN(v) extern __declspec( dllexport ) v __cdecl
#else
#define MPJ_EXTERN(v) extern __declspec( dllimport ) v __cdecl
#endif

#else

#define MPJ_EXTERN(var) extern "C" var
#include "../Include/defs.h"

#endif


#ifdef __cplusplus
extern "C" {
#endif



#include <stdio.h>
#include <jni.h>
typedef int MPJErr;

struct decoderEventQueue{
		int condition;
		long ODID;
		
		//*** YT START (141)
		// decoder event is now associated with ESID also
		long ESID;
		//*** YT END (141)
		decoderEventQueue* next;
		//*** YT START (142)
		// esid is added
		decoderEventQueue( int cond, long odid, long esid ) : condition(cond), ODID(odid), ESID(esid), next(NULL) { }
		//*** YT END (142)
		~decoderEventQueue();

};

struct rendererEventQueue{
		int condition;
		rendererEventQueue* next;
		rendererEventQueue( int cond ) : condition(cond), next(NULL) { }
		~rendererEventQueue();
};

typedef decoderEventQueue* decoderQueue;
typedef rendererEventQueue* rendererQueue;

struct MPJTerminalDispatchTable
{
	MPJErr (*examplePlayerCall)();
	// This is filled when the initialize of DMIFMonitor is defined in DMIFMonitorImp.cpp 
	// is called from the MPEGJTerminal::initialize() is called. 
	MPJErr (*numChannels)();
	// added by PA for Event generation  
	int (*throwEvent)(MPJTerminalDispatchTable* fnPtr , JNIEnv *this_env);
	int isJVMStarted;
	int isFirstTime;
	int isStartedDispatching;
	void *hThrow; // thread handle  
	decoderQueue dEQ; 
	rendererQueue rEQ;
};

typedef MPJTerminalDispatchTable* MPJTerminalDispatchTablePtr;

MPJ_EXTERN( void )
MPJSetTerminalDispatchTable( MPJTerminalDispatchTablePtr table );

MPJ_EXTERN( MPJTerminalDispatchTablePtr )
MPJGetTerminalDispatchTable();

#ifdef __cplusplus
}
#endif

#endif
