#include <windows.h>
#include "MPJDecodersIM1Imp.h"
#include <jni.h>


MPJErr MPJDecodersCall()
{
	return 0;
}

bool MPJDecoders::initialize( Executive *e )
{
	bool success = false;

	HINSTANCE theDLLInstance = LoadLibrary("MPJDecoders" );
	if ( theDLLInstance )
	{
		typedef void (*setTableFunc)(MPJDecodersDispatchTablePtr);

		setTableFunc setTable = (setTableFunc) GetProcAddress( theDLLInstance, 
													"MPJSetMPJDecodersDispatchTable");
		if ( setTable )
		{
			MPJDecodersDispatchTablePtr dispatch = new MPJDecodersDispatchTable;
			// native implementation for the functions in the 
			// function table has to be done yet.
			// replace the function names ( right of '= ' )
			//with the new appropriate names
			//dispatch->getDecoderInstance = MPJDecoderCall; 
			//dispatch->getDecoderType = MPJDecoderCall;
			//dispatch->getDecoderVendor = MPDecoderCall; 
			//dispatch->startDecoding = MPDecoderCall; 
			//dispatch->stopDecoderOnNode = MPJDecoderCall; 
			//dispatch->pauseDecoding = MPDecoderCall;
			//dispatch->resumeDecoding = MPDecoderCall;
			//dispatch->getEnhancementLevel = Java_org_iso_mpeg_mpegj_decoder_SclDecoderImp_getEnhancementLevel(JNIEnv*, jobject);
			//dispatch->getEnhancementMode = Java_org_iso_mpeg_mpegj_decoder_SclDecoderImp_getEnhancementMode(JNIEnv*, jobject);
			//dispatch->setSpatialEnhancement =Java_org_iso_mpeg_mpegj_decoder_SclDecoderImp_setSpatialEnhancement(JNIEnv*, jobject);
			//dispatch->setTemporalEnhancement =Java_org_iso_mpeg_mpegj_decoder_SclDecoderImp_setTemporalEnhancement(JNIEnv*, jobject);
			//dispatch->setSnrEnhancement =Java_org_iso_mpeg_mpegj_decoder_SclDecoderImp_setSnrEnhancement(JNIEnv*, jobject);

			setTable( dispatch );
			success = true;
		}
	}
	return success;
}

/*
 * SclDecoder Native Implementation
 * Class:     org_iso_mpeg_mpegj_decoder_SclDecoderImp
 * Method:    getEnhancementLevel
 * Signature: ()I
 */
JNIEXPORT jint JNICALL 
Java_org_iso_mpeg_mpegj_decoder_SclDecoderImp_getEnhancementLevel (JNIEnv* env, jobject thisObj)
{
	jclass j_scldec_class = env->GetObjectClass(thisObj);
	jfieldID j_level = env->GetFieldID(j_scldec_class, "level", "I");

	jint ret_val = env->GetIntField(thisObj, j_level);
	return ret_val;
}

/*
 * SclDecoder Native Implementation
 * Class:     org_iso_mpeg_mpegj_decoder_SclDecoderImp
 * Method:    getEnhancementMode
 * Signature: ()I
 */
JNIEXPORT jint JNICALL 
Java_org_iso_mpeg_mpegj_decoder_SclDecoderImp_getEnhancementMode 
	(JNIEnv* env, jobject thisObj)
{
	jclass j_scldec_class = env->GetObjectClass(thisObj);
	jfieldID j_mode = env->GetFieldID(j_scldec_class, "mode", "I");

	jint ret_val = env->GetIntField(thisObj, j_mode);
	return ret_val;
}

/*
 * SclDecoder Native Implementation
 * Class:     org_iso_mpeg_mpegj_decoder_SclDecoderImp
 * Method:    setSpatialEnhancement
 * Signature: ()Z
 * This function must retrieve the node ID from the java class, 
 * check the enhancement stata of the IM1 decoder, and set it to 
 * Spatial Enhancement if possible. It will return TRUE if sucessful'
 * FALSE if not.
 */
JNIEXPORT jboolean JNICALL 
Java_org_iso_mpeg_mpegj_decoder_SclDecoderImp_setSpatialEnhancement
	(JNIEnv* env, jobject thisObj)
{
	jclass j_scldec_class = env->GetObjectClass(thisObj);
	jfieldID j_nodeID = env->GetFieldID(j_scldec_class, "nodeID", "I");

	// The implementation for this will have to wait until we have
	// a scalable decoder in IM1; for now We just return a failure.

	jboolean ret_val = false;
	return ret_val;
}

/*
 * SclDecoder Native Implementation
 * Class:     org_iso_mpeg_mpegj_decoder_SclDecoderImp
 * Method:    setTemporalEnhancement
 * Signature: ()Z
 * This function must retrieve the node ID from the java class, 
 * check the enhancement stata of the IM1 decoder, and set it to 
 * Temporal Enhancement if possible. It will return TRUE if sucessful'
 * FALSE if not.
 */
JNIEXPORT jboolean JNICALL 
Java_org_iso_mpeg_mpegj_decoder_SclDecoderImp_setTemporalEnhancement 
	(JNIEnv* env, jobject thisObj)
{
	jclass j_scldec_class = env->GetObjectClass(thisObj);
	jfieldID j_nodeID = env->GetFieldID(j_scldec_class, "nodeID", "I");

	// The implementation for this will have to wait until we have
	// a scalable decoder in IM1; for now We just return a failure.

	jboolean ret_val = false;
	return ret_val;
}

/*
 * SclDecoder Native Implementation
 * Class:     org_iso_mpeg_mpegj_decoder_SclDecoderImp
 * Method:    setSnrEnhancement
 * Signature: ()Z
 * This function must retrieve the node ID from the java class, 
 * check the enhancement stata of the IM1 decoder, and set it to 
 * Temporal Enhancement if possible. It will return TRUE if sucessful'
 * FALSE if not.
 */
JNIEXPORT jboolean JNICALL 
Java_org_iso_mpeg_mpegj_decoder_SclDecoderImp_setSnrEnhancement 
	(JNIEnv* env, jobject thisObj)
{
	jclass j_scldec_class = env->GetObjectClass(thisObj);
	jfieldID j_nodeID = env->GetFieldID(j_scldec_class, "nodeID", "I");

	// The implementation for this will have to wait until we have
	// a scalable decoder in IM1; for now We just return a failure.

	jboolean ret_val = false;
	return ret_val;
}

