 /****************************************************************
 This software module is an implementation of part of one or more 
 MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 
 Systems (ISO/IEC 14496-1). ISO/IEC gives users of the MPEG-4 
 Systems (ISO/IEC 14496-1) free license to this software module or
 modifications thereof for use in hardware or software products 
 claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
 Those intending to use this software module in hardware or software 
 products are advised that its use may infringe existing patents. 
 THE ORIGINAL DEVELOPER OF THIS SOFTWARE MODULE AND HIS/HER COMPANY,
 THE SUBSEQUENT EDITORS AND THEIR COMPANIES, AND ISO/IEC HAVE NO 
 LIABILITY FOR USE OF THIS SOFTWARE MODULE OR MODIFICATIONS THEREOF. 
*******************************************************************/

#ifndef INCLUDED_MPDECODER_INTERFACE_H
#define INCLUDED_MPDECODER_INTERFACE_H

// SOLARIS PORTING
#ifdef WIN32
#ifdef MPEGJDLLAPI
#define MPJ_EXTERN(v) extern __declspec( dllexport ) v __cdecl
#else
#define MPJ_EXTERN(v) extern __declspec( dllimport ) v __cdecl
#endif

#else

#define MPJ_EXTERN(var) extern "C" var
#include "../Include/defs.h"

#endif // WIN32

#ifdef __cplusplus
extern "C" {
#endif

typedef int MPJErr;
class Decoder;

struct MPJMPDecoderDispatchTable
{
	MPJErr (*attachDecoder)(int, int);
	MPJErr (*detachDecoder)(int, int);
	int (*getDecoderInstance)();
	int (*getDecoderType)(int);
	char * (*getDecoderVendor)();
	MPJErr (*startDecoding)(long);
	MPJErr (*stopDecoderOnNode)(long);
	MPJErr (*pauseDecoding)();
	MPJErr (*resumeDecoding)();
	int (*isPauseable)();
	Decoder* dec[5];
	int (*getDecoderTypeNat)(long, long);
};

typedef MPJMPDecoderDispatchTable* MPJMPDecoderDispatchTablePtr;

MPJ_EXTERN( void )
MPJSetMPDecoderDispatchTable( MPJMPDecoderDispatchTablePtr table );

MPJ_EXTERN( MPJMPDecoderDispatchTablePtr )
MPJGetMPDecoderDispatchTable();

#ifdef __cplusplus
}
#endif
#endif
