/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1998.
************************************************************************
/*
	Author: Yuntai Kyong, Columbia University
	Created: July 26 00
	Contact: yuntaikyong@ieee.org
*/

// SOLARIS PORTING
#ifdef WIN32
#include <windows.h>
#endif

#include "MPEGJDebugConsole.h"

// SOLARIS PORTING
#ifdef WIN32
/*
 * Class:     MPEGJDebugConsole
 * Method:    init
 * Signature: ()V
 */
static bool bInit = false;
static HANDLE hConsole = NULL;

bool init()
{
	if(!bInit) {
		if(!AllocConsole())	// Allocate Console
		{
			printf("failed to allocate console!: %d\n",GetLastError());
			return bInit;
		}
		if((hConsole = GetStdHandle(STD_OUTPUT_HANDLE)) == INVALID_HANDLE_VALUE)
			// Get standard output handle
		{
			printf("failed to get standard handle!: %d",GetLastError());
			return bInit;
		}
		bInit = true;
	}
	return bInit;
}
#endif // WIN32

/*
 * Class:     MPEGJDebugConsole
 * Method:    writeMsg
 * Signature: (Ljava/lang/String;)V
 */
JNIEXPORT void JNICALL Java_org_iso_mpeg_mpegjRefImpl_MPEGJDebugConsole_nativeWriteMsg
  (JNIEnv *env, jclass jc, jstring js)
{
// SOLARIS PORTING
#ifdef WIN32
	if(!bInit)
		if(!init())
			return;
	jsize size = env->GetStringLength(js);
	jboolean jb;
	const char* buf = env->GetStringUTFChars(js,&jb); 
	if(jb == JNI_TRUE) {
		DWORD dw;
		WriteConsole(hConsole,buf,size,&dw,NULL);
		env->ReleaseStringUTFChars(js,buf);
	}
#else
	jsize size = env->GetStringLength(js);
	jboolean jb;
	const char* buf = env->GetStringUTFChars(js,&jb); 
    printf("[MPEGJ-DebugConsole]%s", buf);
	env->ReleaseStringUTFChars(js,buf);
#endif // WIN32
}
