 /****************************************************************
 This software module is an implementation of part of one or more 
 MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 
 Systems (ISO/IEC 14496-1). ISO/IEC gives users of the MPEG-4 
 Systems (ISO/IEC 14496-1) free license to this software module or
 modifications thereof for use in hardware or software products 
 claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
 Those intending to use this software module in hardware or software 
 products are advised that its use may infringe existing patents. 
 THE ORIGINAL DEVELOPER OF THIS SOFTWARE MODULE AND HIS/HER COMPANY,
 THE SUBSEQUENT EDITORS AND THEIR COMPANIES, AND ISO/IEC HAVE NO 
 LIABILITY FOR USE OF THIS SOFTWARE MODULE OR MODIFICATIONS THEREOF. 
*******************************************************************/

#ifndef INCLUDED_MPEGJ_TERMINAL_H
#define INCLUDED_MPEGJ_TERMINAL_H
#include <jni.h>

class Executive;
class ALManager;

// SOLARIS PORTING
#ifdef WIN32
extern __declspec( dllexport ) bool __cdecl InitializeMPEGJ( Executive *e );
#else
bool InitializeMPEGJ( Executive *e );
#endif // WIN32

class MPEGJTerminal
{
	public:
		static bool initialize( Executive *e );

	private:
		static bool startJavaVM( const char *garbage );

		static JavaVM *s_jvm;
		static JNIEnv *s_env;
	
		MPEGJTerminal();
		MPEGJTerminal( const MPEGJTerminal& );
};

#endif
