#ifndef INCLUDED_MPJDECODERS_INTERFACE_H
#define INCLUDED_MPJDECODERS_INTERFACE_H

#ifdef MPEGJDLLAPI
#define MPJ_EXTERN(v) extern __declspec( dllexport ) v __cdecl
#else
#define MPJ_EXTERN(v) extern __declspec( dllimport ) v __cdecl
#endif

#ifdef __cplusplus
extern "C" {
#endif

typedef int MPJErr;

struct MPJDecodersDispatchTable
{
	int (*getDecoderInstance)();
	int (*getDecoderType)();
	char * (*getDecoderVendor)();
	void (*startDecoding)();
	void (*stopDecoderOnNode)();
	void (*pauseDecoding)();
	void (*resumeDecoding)();
	long (*getEnhancementLevel)(JNIEnv*, jobject);
	long (*getEnhancementMode)(JNIEnv*, jobject);
	boolean (*setSpatialEnhancement)(JNIEnv*, jobject);
	boolean (*setTemporalEnhancement)(JNIEnv*, jobject);
	boolean (*setSnrEnhancement)(JNIEnv*, jobject);
};

typedef MPJDecodersDispatchTable* MPJDecodersDispatchTablePtr;

MPJ_EXTERN( void )
MPJSetDecodersDispatchTable( MPJDecodersDispatchTablePtr table );

MPJ_EXTERN( MPJDecodersDispatchTablePtr )
MPJGetDecodersDispatchTable();

#ifdef __cplusplus
}
#endif
#endif
