 /****************************************************************
 This software module is an implementation of part of one or more 
 MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 
 Systems (ISO/IEC 14496-1). ISO/IEC gives users of the MPEG-4 
 Systems (ISO/IEC 14496-1) free license to this software module or
 modifications thereof for use in hardware or software products 
 claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
 Those intending to use this software module in hardware or software 
 products are advised that its use may infringe existing patents. 
 THE ORIGINAL DEVELOPER OF THIS SOFTWARE MODULE AND HIS/HER COMPANY,
 THE SUBSEQUENT EDITORS AND THEIR COMPANIES, AND ISO/IEC HAVE NO 
 LIABILITY FOR USE OF THIS SOFTWARE MODULE OR MODIFICATIONS THEREOF. 
*******************************************************************/

// SOLARIS PORTING
#include "../stubs/org_iso_mpeg_mpegjRefImpl_decoder_MPDecoderImp.h"
#include "../../mpegj-player/MPDecoderInterface.h"


static long instanceCount = 0L;
static MPJMPDecoderDispatchTablePtr dispatch = 0;

MPJ_EXTERN( long ) CreateInstance()
{
	return ++instanceCount;
}

MPJ_EXTERN( MPJMPDecoderDispatchTablePtr )
MPJGetMPDecoderDispatchTable()
{
	return dispatch;
}

MPJ_EXTERN( void )
MPJSetMPDecoderDispatchTable( MPJMPDecoderDispatchTablePtr table )
{
	dispatch = table;

	// if you have any functions to be called from the
	// player, add the address of these to this table
	// before returning. (none used here -- yet) all the callbacks that player side would call
}

/* getDecoderInstance */
JNIEXPORT jint JNICALL Java_org_iso_mpeg_mpegjRefImpl_decoder_MPDecoderImp_getDecoderInstance
  (JNIEnv *, jobject)
{
	int decInst;

	MPJMPDecoderDispatchTablePtr d = MPJGetMPDecoderDispatchTable();
	if (d && (d->getDecoderInstance) )
		decInst = d->getDecoderInstance();

	return decInst;
}

/*
 * Class:     org_iso_mpeg_mpegjRefImpl_decoder_MPDecoderImp
 * Method:    getDecoderType
 */
JNIEXPORT jint JNICALL Java_org_iso_mpeg_mpegjRefImpl_decoder_MPDecoderImp_getDecoderType
  (JNIEnv *, jobject, jint odid)
{
	int decType;
	MPJMPDecoderDispatchTablePtr d = MPJGetMPDecoderDispatchTable();
	if (d && (d->getDecoderType) ) {
		decType = d->getDecoderType(odid);
		return decType;
	}
	else return -1;
}

/*
 * Class:     org_iso_mpeg_mpegjRefImpl_decoder_MPDecoderImp
 * Method:    getDecoderVendor
 */
JNIEXPORT jstring JNICALL Java_org_iso_mpeg_mpegjRefImpl_decoder_MPDecoderImp_getDecoderVendor
  (JNIEnv *, jobject)
{	
	char * decVendor;
	MPJMPDecoderDispatchTablePtr d = MPJGetMPDecoderDispatchTable();
	if (d && (d->getDecoderVendor) )
		decVendor = d->getDecoderVendor();

	return (jstring) decVendor;
}

/*
 * Class:     org_iso_mpeg_mpegjRefImpl_decoder_MPDecoderImp
 * Method:    startDecoding
 */
JNIEXPORT void JNICALL Java_org_iso_mpeg_mpegjRefImpl_decoder_MPDecoderImp_startDecoding
  (JNIEnv *, jobject, jlong odID)
{
	MPJMPDecoderDispatchTablePtr d = MPJGetMPDecoderDispatchTable();
	d->startDecoding((long)odID);
}

/*
 * Class:     org_iso_mpeg_mpegjRefImpl_decoder_MPDecoderImp
 * Method:    stopDecoderOnNode
 */
JNIEXPORT void JNICALL Java_org_iso_mpeg_mpegjRefImpl_decoder_MPDecoderImp_stopDecoderOnNode
  (JNIEnv *, jobject, jlong odID) 
{
	MPJMPDecoderDispatchTablePtr d = MPJGetMPDecoderDispatchTable();
	d->stopDecoderOnNode((long)odID); 
}

/*
 * Class:     org_iso_mpeg_mpegjRefImpl_decoder_MPDecoderImp
 * Method:    pauseDecoding
 */
JNIEXPORT void JNICALL Java_org_iso_mpeg_mpegjRefImpl_decoder_MPDecoderImp_pauseDecoding
	(JNIEnv *, jobject)
{
	MPJMPDecoderDispatchTablePtr d = MPJGetMPDecoderDispatchTable();
	d->pauseDecoding();
}

/*
 * Class:     org_iso_mpeg_mpegjRefImpl_decoder_MPDecoderImp
 * Method:    resumeDecoding
 */
JNIEXPORT void JNICALL Java_org_iso_mpeg_mpegjRefImpl_decoder_MPDecoderImp_resumeDecoding
  (JNIEnv *, jobject)
{
	MPJMPDecoderDispatchTablePtr d = MPJGetMPDecoderDispatchTable();
	d->resumeDecoding();

}

/*
 * Class:     org_iso_mpeg_mpegjRefImpl_decoder_MPDecoderImp
 * Method:    getDecoderTypeNat
 */
JNIEXPORT jint JNICALL Java_org_iso_mpeg_mpegjRefImpl_decoder_MPDecoderImp_getDecoderTypeNat
	(JNIEnv *, jobject, jlong odid, jlong esid) {
	MPJMPDecoderDispatchTablePtr d = MPJGetMPDecoderDispatchTable();
	
	return d->getDecoderTypeNat((long)odid , (long)esid);
}

/*
 * Class:     org_iso_mpeg_mpegjRefImpl_decoder_MPDecoderImp
 * Method:    attachDecoder
 */
JNIEXPORT jint JNICALL Java_org_iso_mpeg_mpegjRefImpl_decoder_MPDecoderImp_attachDecoder
  (JNIEnv *, jobject, jint odid, jint esid) {
	MPJMPDecoderDispatchTablePtr d = MPJGetMPDecoderDispatchTable();
	return d->attachDecoder(odid, esid);
}

/*
 * Class:     org_iso_mpeg_mpegjRefImpl_decoder_MPDecoderImp
 * Method:    detachDecoder
 */
JNIEXPORT jint JNICALL Java_org_iso_mpeg_mpegjRefImpl_decoder_MPDecoderImp_detachDecoder
	(JNIEnv *, jobject, jint odid, jint esid) {
	MPJMPDecoderDispatchTablePtr d = MPJGetMPDecoderDispatchTable();
	return d->detachDecoder(odid, esid);
}
