/*
 * File: ES_Descriptor.java
 *
 */

/**********************************************************************
 * Copyright  2001 ISO/IEC All Rights Reserved
 *
 * This software module was developed by
 *
 * Sun Microsystems, Inc.
 *
 * in the course of development of the MPEG-4 standard. This software
 * module is an implementation of a part of one or more MPEG-4 Systems
 * (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems standard.
 *
 * The copyright of this software belongs to ISO/IEC. ISO/IEC gives
 * users of the MPEG-4 Systems (ISO/IEC 14496-1) standard free license
 * to this software module or modifications thereof for hardware
 * or software products claiming conformance to the MPEG-4 Systems.
 *
 * Those intending to use this software module in hardware or software
 * products are advised that use may infringe existing  patents. The
 * original developers of this software module and their companies, the
 * subsequent editors and their companies, and ISO/IEC have no liability
 * and ISO/IEC have no liability for use of this software module or
 * modification thereof in an implementation.
 **********************************************************************/

package org.iso.mpeg.mpegj;


/**
  * interface for ES_Descriptor
  *
  */

public interface ES_Descriptor
{
    /**
      * Returns the ID associated with this ES_descriptor
      * @return ES_ID
      */
    long getES_ID();

    /**
      * Returns whether this elementary stream depends another elementary stream
      * @return true or false
      */
    boolean isStreamDependent();

    /**
      * Returns the ES_ID of another elementary stream on which this
      *         elementary stream depends.
      * @return ES_ID or -1 if the stream is not dependent on another
      */
    int getdependsOn_ES_ID();

    /**
      * Returns the relative measure for the priority of this stream.
      * An elementary stream with higher stream priority is more important than one
      * with a lower stream priority.
      * @return priority
      */
    int getStreamPriority();

    /**
      * Returns the decoder config Descriptor 
      * @return DecoderConfigDescriptor
      */
    DecoderConfigDescriptor getDecoderConfigDescriptor();

}