/**********************************************************************
 * Copyright (c) 2000 ISO/IEC All Rights Reserved
 *
 * This software module was developed by
 *
 * Sun Microsystems, Inc.
 *
 * in the course of development of the MPEG-4 standard. This software
 * module is an implementation of a part of one or more MPEG-4 Systems
 * (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems standard.
 *
 * The copyright of this software belongs to ISO/IEC. ISO/IEC gives
 * users of the MPEG-4 Systems (ISO/IEC 14496-1) standard free license
 * to this software module or modifications thereof for hardware
 * or software products claiming conformance to the MPEG-4 Systems.
 *
 * Those intending to use this software module in hardware or software
 * products are advised that use may infringe existing  patents. The
 * original developers of this software module and their companies, the
 * subsequent editors and their companies, and ISO/IEC have no liability
 * and ISO/IEC have no liability for use of this software module or
 * modification thereof in an implementation.
 **********************************************************************/
/*
 * File: ObjectDescriptor.java
 *
 */

 
package org.iso.mpeg.mpegj;
import java.util.*;

/**
  * interface for ObjectDescriptor
  *
  */


public interface ObjectDescriptor
{
   /**
     * Returns the ID associated with this Object Descriptor
     * @return ObjectDescriptorID
     */
   long getObjectDescriptorID();

   /**
     * Returns the ES_Descriptors associated with this ObjectDescriptor
     * @return vector of ES_Descriptors
     */
   Vector getES_Descriptors();

   /**
     * Returns the ES_Descriptor associated with the given ESID
     * @param ES_Descriptor ID
     * @return ES_Descriptor object
     */
   ES_Descriptor getES_Descriptor( int ESID );

   /**
     * Returns the URL String 
     * @return String
     */
   String getURL();



}
