/**********************************************************************
 * Copyright  1998 ISO/IEC All Rights Reserved                        
 *                                                                       
 * This software module was developed by 
 *                                                                       
 * Sun Microsystems, Inc.
 *                                                                       
 * in the course of development of the MPEG-4 standard. This software
 * module is an implementation of a part of one or more MPEG-4 Systems
 * (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems standard.
 *                                                                       
 * The copyright of this software belongs to ISO/IEC. ISO/IEC gives
 * users of the MPEG-4 Systems (ISO/IEC 14496-1) standard free license
 * to this software module or modifications thereof for hardware
 * or software products claiming conformance to the MPEG-4 Systems.
 *                                                                       
 * Those intending to use this software module in hardware or software   
 * products are advised that use may infringe existing  patents. The     
 * original developers of this software module and their companies, the  
 * subsequent editors and their companies, and ISO/IEC have no liability 
 * and ISO/IEC have no liability for use of this software module or      
 * modification thereof in an implementation.                            
 **********************************************************************/
/*
 * File: DecoderType.java
 *
 * Author: Yihan Fang (yihan.fang@sun.com or fang@ee.columbia.edu)
 *
 * Description:
 *
 * Created: August, 1998
 *
 * Modified: March, 1999  Vishy Swaminathan (vishy@eng.sun.com)
 * Fixed the Package Name
 *
 */
package org.iso.mpeg.mpegj.decoder;

/**
 * Interface for decoder types.
 */
public interface DecoderType
{
  /**
   * MPEG1 video.
   */
  public int MPEG1V = 0;

  /**
   * MPEG1 audio.
   */
  public int MPEG1A = 1;

  /**
   * MPEG2 transport stream.
   */
  public int MPEG2TS = 2;

  /**
   * MPEG2 video.
   */
  public int MPEG2V = 3;

  /**
   * MPEG2 audio.
   */
  public int MPEG2A = 4;

  /**
   * MPEG4 systems.
   */
  public int MPEG4S = 5;

  /**
   * MPEG4 video.
   */
  public int MPEG4V = 6;

  /**
   * MPEG4 scalable video.
   */
  public int MPEG4VS = 7;

  /**
   * MPEG4 image texture.
   */
  public int MPEG4T = 8;

  /**
   * MPEG4 scalable texture.
   */
  public int MPEG4TS = 9;

  /**
   * MPEG4 mesh decoder.
   */
  public int MPEG4M = 10;

  /**
   * MPEG4 face decoder.
   */
  public int MPEG4F = 11;

  /**
   * MPEG4 scalable face decoder.
   */
  public int MPEG4FS = 12;

  /**
   * MPEG4 audio.
   */
  public int MPEG4A = 13;

  /**
   * MPEG4 scalable audio
   */
  public int MPEG4AS = 14;

  /**
   * MPEG4 TTS audio
   */
  public int MPEG4TT = 15;

  /**
   * MPEG4 structured audio.
   */
  public int MPEG4SA = 16;

  /**
   * Get decoder type.
   */
  public int getDecoderType();
}






