/**********************************************************************
 * Copyright  1999 ISO/IEC All Rights Reserved                        
 *                                                                       
 * This software module was developed by 
 *                                                                       
 * AT&T, Inc.
 *                                                                       
 * in the course of development of the MPEG-4 standard. This software
 * module is an implementation of a part of one or more MPEG-4 Systems
 * (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems standard.
 *                                                                       
 * The copyright of this software belongs to ISO/IEC. ISO/IEC gives
 * users of the MPEG-4 Systems (ISO/IEC 14496-1) standard free license
 * to this software module or modifications thereof for hardware
 * or software products claiming conformance to the MPEG-4 Systems.
 *                                                                       
 * Those intending to use this software module in hardware or software   
 * products are advised that use may infringe existing  patents. The     
 * original developers of this software module and their companies, the  
 * subsequent editors and their companies, and ISO/IEC have no liability 
 * and ISO/IEC have no liability for use of this software module or      
 * modification thereof in an implementation.                            
 **********************************************************************/
/*
 * File: SclDecoder.java
 *
 * Author: Bob Schmidt (rls@research.att.com)
 *
 * Description:
 *
 * Created: October, 1999
 *
 */

package org.iso.mpeg.mpegj.decoder;

import org.iso.mpeg.mpegj.resource.*;

/** 
 * This is the base interface for scalable media decoders.
 * It is built on the MPDecoder Interface which is used for 
 * single layer decoders.
 */
public interface SclDecoder 	extends MPDecoder
{
  /**  
   *  Get the Spacial Enhancement Layer Number.
   */
  public int getLevel();
	
  /** 
   * Get the spatial Enhancement Mode Number.
   */
  public int getMode();

  /** 
   *  Set the decoder Spatial Enhancement Level.
   */
  public boolean spatialEnhancement(int level, int mode)
  						throws 	InvalidDecoderLevelException,
  								InvalidDecoderModeException;

  /** 
   *  Set the decoder Temporal Enhancement Level.
   */
  public boolean temporalEnhancement(int level, int mode)
  						throws 	InvalidDecoderLevelException,
  								InvalidDecoderModeException;

  /**
   * Set the decoder SNR Enhancement Level. 
   */
  public boolean snrEnhancement(int level, int mode) 
  						throws 	InvalidDecoderLevelException,
  								InvalidDecoderModeException;

}
