package org.iso.mpeg.mpegj.net;

/*
*******************************************************************
 This software module was originally developed by Roberto Becchini
 (SIA - I - SOMMIT Consortium), Barbara Silano (SIA - I - SOMMIT 
Consortium) and edited by Luca Deri (Finsiel - I - SOMMIT Consortium),
 Gianluca De Petris (CSELT - I - SOMMIT Consortium) in the course of 
development of the MPEG-4 Systems (ISO/IEC 14496-1). This software 
module is an implementation of part of one or more MPEG-4 Systems 
(ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
14496-1). ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) 
free license to this software module or modifications thereof for use 
in hardware or software products claiming conformance to the MPEG-4 
Systems (ISO/IEC 14496-1). Those intending to use this software 
module in hardware or software products are advised that its use may 
infringe existing patents. THE ORIGINAL DEVELOPER OF THIS SOFTWARE 
MODULE AND HIS/HER COMPANY, THE SUBSEQUENT EDITORS AND THEIR 
COMPANIES, AND ISO/IEC HAVE NO LIABILITY FOR USE OF THIS SOFTWARE 
MODULE OR MODIFICATIONS THEREOF. No license to this software module 
is granted for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. The SOMMIT Consortium retains full right to use the 
software module for his/her own purpose, assign or donate the 
software module to a third party and to inhibit third parties from 
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. This copyright notice must be included in all copies or 
derivative works of the software module. Copyright 1999
********************************************************************/
/**
*
*	This interface allows to retriev all the information about a channel in a specified service session.
*
**/
public interface ChannelDescriptor {

/**
*	
*	This method retrieves the service session identifier associated to the specific channel
*
**/
	public long		getServiceSessionID();

/**
*	
*	This method retrieves the channel identifier of the channel associated to the descriptor. Using this value it is possible to obtain both the Object Descriptor Identifier and the Elementary stream identifier associated to the channel:
*	OD ID: (channelID >> 6)
*
*	ES ID: (channelId & 0x0000003F)
*
**/
	public long		getChannelID();

/**
*
*	This method retrieves the actual Access Unit rate of the channel. This value may change over the time.
*
**/
	public int		getAURate();

/**
*
*	This method retrieves information about error conditions associated to the channel (see DMIF specification). This value may change over the time.
*
**/
	public int		getError(); 

/**
*
*	This method retrieves information about the status of the channel (see DMIF specification). This value may change over the time.
*
**/
	public int		getStatus();

/**
*
*	This method retrieves information about the Quality of service associated to the channel (see QualifierTag). 
*
**/
	public QoSDescriptor		getQoS();
  }
