/********************************************************************
 This software module was originally developed by Luca Deri (Finsiel
- I - SOMMIT Consortium) and edited by Roberto Becchini (SIA - I -
SOMMIT Consortium), Barbara Silano (SIA - I - SOMMIT Consortium),
Gianluca De Petris (CSELT - I - SOMMIT Consortium) in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1). This software
module is an implementation of part of one or more MPEG-4 Systems
(ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC
14496-1). ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1)
free license to this software module or modifications thereof for use
in hardware or software products claiming conformance to the MPEG-4
Systems (ISO/IEC 14496-1). Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents. THE ORIGINAL DEVELOPER OF THIS SOFTWARE
MODULE AND HIS/HER COMPANY, THE SUBSEQUENT EDITORS AND THEIR
COMPANIES, AND ISO/IEC HAVE NO LIABILITY FOR USE OF THIS SOFTWARE
MODULE OR MODIFICATIONS THEREOF. No license to this software module
is granted for non MPEG-4 Systems (ISO/IEC 14496-1) conforming
products. The SOMMIT Consortium retains full right to use the
software module for his/her own purpose, assign or donate the
software module to a third party and to inhibit third parties from
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming
products. This copyright notice must be included in all copies or
derivative works of the software module. Copyright 1999
********************************************************************/


package org.iso.mpeg.mpegj.resource;


 /**
 *
 *
 * The CPUmonitor class is used to monitor selected terminal activities including
 * CPU load, and free/available system memory utilisation. Because the Java JDK does
 * not provide hooks for retrieving this information directly from Java, the use of
 * native code is needed. The current implementation makes use of the CPUmonitor DLL.
 *
 *
 * @author  Luca Deri (l.deri@tecsiel.it)
 * @version 1.0, 11/1998
 */

public class CPUmonitor {

  public static native short getCPUload();
  public static native long  getFreeSystemMemory();
  public static native long  getAvailSystemMemory();

  static {
    System.loadLibrary("CPUMonitor");
  }
}

