
package org.iso.mpeg.mpegj.resource;

/********************************************************************
 This software module was originally developed by Luca Deri (Finsiel
- I - SOMMIT Consortium) and edited by Roberto Becchini (SIA - I -
SOMMIT Consortium), Barbara Silano (SIA - I - SOMMIT Consortium),
Gianluca De Petris (CSELT - I - SOMMIT Consortium) in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1). This software
module is an implementation of part of one or more MPEG-4 Systems
(ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC
14496-1). ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1)
free license to this software module or modifications thereof for use
in hardware or software products claiming conformance to the MPEG-4
Systems (ISO/IEC 14496-1). Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents. THE ORIGINAL DEVELOPER OF THIS SOFTWARE
MODULE AND HIS/HER COMPANY, THE SUBSEQUENT EDITORS AND THEIR
COMPANIES, AND ISO/IEC HAVE NO LIABILITY FOR USE OF THIS SOFTWARE
MODULE OR MODIFICATIONS THEREOF. No license to this software module
is granted for non MPEG-4 Systems (ISO/IEC 14496-1) conforming
products. The SOMMIT Consortium retains full right to use the
software module for his/her own purpose, assign or donate the
software module to a third party and to inhibit third parties from
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming
products. This copyright notice must be included in all copies or
derivative works of the software module. Copyright 1999
********************************************************************/

import java.lang.*;
import java.util.*;


/**
 *
 *
 * This class is used to store information related to dynamic observers.
 *
 * @author  Luca Deri (l.deri@tecsiel.it)
 * @version 1.0, 11/1998
 */

public class CapabilityInfo {
  private long valueThreshold;
  private boolean aboveThreshold;
  private Observer observable;

  public CapabilityInfo(Observer _observable, long _valueThreshold,
			boolean _aboveThreshold) {
    valueThreshold = _valueThreshold;
    aboveThreshold = _aboveThreshold;
    observable = _observable;
  }

    /**
    *
    * Verify Capability Value
    *
    * @param  value  the capability value that has to be verified
    * @return  true is the passed value exceeds the threshold, false otherwise.
    *
    */
  public boolean verifyCapabilityValue(long value) {
    /*
      System.out.println("verifyCapabilityValue: "+value+"/"+
      valueThreshold+"/"+aboveThreshold);
      */

    if(aboveThreshold) {
      if(value > valueThreshold)
	return true;
    } else {
      if(value < valueThreshold)
	return true;
    }

    return false;
  }

}
