/**********************************************************************
 * Copyright  1998 ISO/IEC All Rights Reserved                        
 *                                                                       
 * This software module was developed by 
 *                                                                       
 * Sun Microsystems, Inc.
 *                                                                       
 * in the course of development of the MPEG-4 standard. This software
 * module is an implementation of a part of one or more MPEG-4 Systems
 * (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems standard.
 *                                                                       
 * The copyright of this software belongs to ISO/IEC. ISO/IEC gives
 * users of the MPEG-4 Systems (ISO/IEC 14496-1) standard free license
 * to this software module or modifications thereof for hardware
 * or software products claiming conformance to the MPEG-4 Systems.
 *                                                                       
 * Those intending to use this software module in hardware or software   
 * products are advised that use may infringe existing  patents. The     
 * original developers of this software module and their companies, the  
 * subsequent editors and their companies, and ISO/IEC have no liability 
 * and ISO/IEC have no liability for use of this software module or      
 * modification thereof in an implementation.                            
 **********************************************************************/
/*
 * File: MPDecoderEventGenerator.java
 *
 * Author: Yihan Fang (yihan.fang@sun.com or fang@ee.columbia.edu)
 *
 * Description:
 *
 * Created: August, 1998
 *
 * Modified: March, 1999
 * Vishy Swaminathan (vishy@eng.sun.com)
 * Fixed Package Name
 *
 */

package org.iso.mpeg.mpegj.resource;

/**
 * An interface for adding and removing Decoder event listeners.
 */
public interface MPDecoderEventGenerator
{
    /**
   * Add a Render event listener. The listener is called by an
   * MPdecoder when registered.
   * @param l the listener to add.
   */
  public void addMPDecoderMediaListener(MPDecoderMediaListener l);
  /**
   * Remove a Decoder event listener.
   *
   * @param l the listener to remove.
   */
  public void removeMPDecoderMediaListener(MPDecoderMediaListener l);
}
