
package org.iso.mpeg.mpegj.resource;

/********************************************************************
 This software module was originally developed by Luca Deri (Finsiel
- I - SOMMIT Consortium) and edited by Roberto Becchini (SIA - I -
SOMMIT Consortium), Barbara Silano (SIA - I - SOMMIT Consortium),
Gianluca De Petris (CSELT - I - SOMMIT Consortium) in the course of
development of the MPEG-4 Systems (ISO/IEC 14496-1). This software
module is an implementation of part of one or more MPEG-4 Systems
(ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC
14496-1). ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1)
free license to this software module or modifications thereof for use
in hardware or software products claiming conformance to the MPEG-4
Systems (ISO/IEC 14496-1). Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents. THE ORIGINAL DEVELOPER OF THIS SOFTWARE
MODULE AND HIS/HER COMPANY, THE SUBSEQUENT EDITORS AND THEIR
COMPANIES, AND ISO/IEC HAVE NO LIABILITY FOR USE OF THIS SOFTWARE
MODULE OR MODIFICATIONS THEREOF. No license to this software module
is granted for non MPEG-4 Systems (ISO/IEC 14496-1) conforming
products. The SOMMIT Consortium retains full right to use the
software module for his/her own purpose, assign or donate the
software module to a third party and to inhibit third parties from
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming
products. This copyright notice must be included in all copies or
derivative works of the software module. Copyright 1999
********************************************************************/



 import java.lang.*;

 /**
 *
 *
 * <p>This interface allows applications to query the terminal profiles. Profiles are
 * specified in the document ISO/IEC FCD 14496-1:1998.
 *
 * @author  Luca Deri (l.deri@tecsiel.it)
 * @version 1.0, 11/1998
 */
 public interface TerminalProfileManager  {
    /* old constants - to get the demo running - praveen*/
   static final short Profile_Simple   = 0;
   static final short Profile_2D       = 1;
   static final short Profile_VRML     = 2;
   static final short Profile_Audio    = 3;
   static final short Profile_Complete = 4;
   
//   public static final short Profile_Audio      = 0;
   public static final short Profile_Simple2D   = 1;  
   public static final short Profile_Complete2D = 2;
 //  public static final short Profile_Complete   = 3;

   public static final short VisualProfile_Simple               = 0;
   public static final short VisualProfile_SimpleScalable       = 3;
   public static final short VisualProfile_Core                 = 1;
   public static final short VisualProfile_Main                 = 2;
   public static final short VisualProfile_Nbit                 = 4;
   public static final short VisualProfile_Hybrid               = 5;
   public static final short VisualProfile_BasicAnimatedTexture = 6;
   public static final short VisualProfile_ScaleableTexture     = 7;
   public static final short VisualProfile_SimpleFA             = 8;


   public static final short AudioProfile_Speech    = 0;
   public static final short AudioProfile_Synthesis = 1;
   public static final short AudioProfile_Scalable  = 2;
   public static final short AudioProfile_Main      = 3;

    /**
    *
    * This method returns the supported visual profile
    *
    * @return the supported visual profile.
    *
    */
    public short getVisualProfile();

    /**
    *
    * This method returns the supported audio profile
    *
    * @return the audio description profile.
    *
    */
    public short getAudioProfile();


    /**
    *
    * This method returns the supported scene description profile
    *
    * @return the supported sceen description profile.
    *
    */
   public short getSceneDescriptionProfile();

 }
