package org.iso.mpeg.mpegj.scene;

/**
 * An interface with inner classes defining the constants for the field
 * IDs of each node.
 */
public interface EventIn
{
  /**
   * An interface defining constant for the field IDs of the Anchor node.
   */
  public interface Anchor
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the description field = 3.
     */
    static final int description = 3;
    /**
     * The ID for the parameter field = 4.
     */
    static final int parameter = 4;
    /**
     * The ID for the url field = 5.
     */
    static final int url = 5;
    /**
     * The ID for the activate field = 6.
     */
    static final int activate = 6;
  }
  /**
   * An interface defining constant for the field IDs of the AnimationStream node.
   */
  public interface AnimationStream
  {
    /**
     * The ID for the loop field = 0.
     */
    static final int loop = 0;
    /**
     * The ID for the speed field = 1.
     */
    static final int speed = 1;
    /**
     * The ID for the startTime field = 2.
     */
    static final int startTime = 2;
    /**
     * The ID for the stopTime field = 3.
     */
    static final int stopTime = 3;
    /**
     * The ID for the url field = 4.
     */
    static final int url = 4;
  }
  /**
   * An interface defining constant for the field IDs of the Appearance node.
   */
  public interface Appearance
  {
    /**
     * The ID for the material field = 0.
     */
    static final int material = 0;
    /**
     * The ID for the texture field = 1.
     */
    static final int texture = 1;
    /**
     * The ID for the textureTransform field = 2.
     */
    static final int textureTransform = 2;
  }
  /**
   * An interface defining constant for the field IDs of the AudioBuffer node.
   */
  public interface AudioBuffer
  {
    /**
     * The ID for the loop field = 0.
     */
    static final int loop = 0;
    /**
     * The ID for the pitch field = 1.
     */
    static final int pitch = 1;
    /**
     * The ID for the startTime field = 2.
     */
    static final int startTime = 2;
    /**
     * The ID for the stopTime field = 3.
     */
    static final int stopTime = 3;
    /**
     * The ID for the children field = 4.
     */
    static final int children = 4;
    /**
     * The ID for the numChan field = 5.
     */
    static final int numChan = 5;
    /**
     * The ID for the phaseGroup field = 6.
     */
    static final int phaseGroup = 6;
    /**
     * The ID for the length field = 7.
     */
    static final int length = 7;
  }
  /**
   * An interface defining constant for the field IDs of the AudioClip node.
   */
  public interface AudioClip
  {
    /**
     * The ID for the description field = 0.
     */
    static final int description = 0;
    /**
     * The ID for the loop field = 1.
     */
    static final int loop = 1;
    /**
     * The ID for the pitch field = 2.
     */
    static final int pitch = 2;
    /**
     * The ID for the startTime field = 3.
     */
    static final int startTime = 3;
    /**
     * The ID for the stopTime field = 4.
     */
    static final int stopTime = 4;
    /**
     * The ID for the url field = 5.
     */
    static final int url = 5;
  }
  /**
   * An interface defining constant for the field IDs of the AudioDelay node.
   */
  public interface AudioDelay
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the delay field = 3.
     */
    static final int delay = 3;
  }
  /**
   * An interface defining constant for the field IDs of the AudioFX node.
   */
  public interface AudioFX
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the orch field = 3.
     */
    static final int orch = 3;
    /**
     * The ID for the score field = 4.
     */
    static final int score = 4;
    /**
     * The ID for the params field = 5.
     */
    static final int params = 5;
  }
  /**
   * An interface defining constant for the field IDs of the AudioMix node.
   */
  public interface AudioMix
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the numInputs field = 3.
     */
    static final int numInputs = 3;
    /**
     * The ID for the matrix field = 4.
     */
    static final int matrix = 4;
  }
  /**
   * An interface defining constant for the field IDs of the AudioSource node.
   */
  public interface AudioSource
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the url field = 3.
     */
    static final int url = 3;
    /**
     * The ID for the pitch field = 4.
     */
    static final int pitch = 4;
    /**
     * The ID for the speed field = 5.
     */
    static final int speed = 5;
    /**
     * The ID for the startTime field = 6.
     */
    static final int startTime = 6;
    /**
     * The ID for the stopTime field = 7.
     */
    static final int stopTime = 7;
  }
  /**
   * An interface defining constant for the field IDs of the AudioSwitch node.
   */
  public interface AudioSwitch
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the whichChoice field = 3.
     */
    static final int whichChoice = 3;
  }
  /**
   * An interface defining constant for the field IDs of the Background node.
   */
  public interface Background
  {
    /**
     * The ID for the set_bind field = 0.
     */
    static final int set_bind = 0;
    /**
     * The ID for the groundAngle field = 1.
     */
    static final int groundAngle = 1;
    /**
     * The ID for the groundColor field = 2.
     */
    static final int groundColor = 2;
    /**
     * The ID for the backUrl field = 3.
     */
    static final int backUrl = 3;
    /**
     * The ID for the bottomUrl field = 4.
     */
    static final int bottomUrl = 4;
    /**
     * The ID for the frontUrl field = 5.
     */
    static final int frontUrl = 5;
    /**
     * The ID for the leftUrl field = 6.
     */
    static final int leftUrl = 6;
    /**
     * The ID for the rightUrl field = 7.
     */
    static final int rightUrl = 7;
    /**
     * The ID for the topUrl field = 8.
     */
    static final int topUrl = 8;
    /**
     * The ID for the skyAngle field = 9.
     */
    static final int skyAngle = 9;
    /**
     * The ID for the skyColor field = 10.
     */
    static final int skyColor = 10;
  }
  /**
   * An interface defining constant for the field IDs of the Background2D node.
   */
  public interface Background2D
  {
    /**
     * The ID for the set_bind field = 0.
     */
    static final int set_bind = 0;
    /**
     * The ID for the backColor field = 1.
     */
    static final int backColor = 1;
    /**
     * The ID for the url field = 2.
     */
    static final int url = 2;
  }
  /**
   * An interface defining constant for the field IDs of the Billboard node.
   */
  public interface Billboard
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the axisOfRotation field = 3.
     */
    static final int axisOfRotation = 3;
  }
  /**
   * An interface defining constant for the field IDs of the Bitmap node.
   */
  public interface Bitmap
  {
    /**
     * The ID for the scale field = 0.
     */
    static final int scale = 0;
  }
  /**
   * An interface defining constant for the field IDs of the Box node.
   */
  public interface Box
  {
  }
  /**
   * An interface defining constant for the field IDs of the Circle node.
   */
  public interface Circle
  {
    /**
     * The ID for the radius field = 0.
     */
    static final int radius = 0;
  }
  /**
   * An interface defining constant for the field IDs of the Collision node.
   */
  public interface Collision
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the collide field = 3.
     */
    static final int collide = 3;
  }
  /**
   * An interface defining constant for the field IDs of the Color node.
   */
  public interface Color
  {
    /**
     * The ID for the color field = 0.
     */
    static final int color = 0;
  }
  /**
   * An interface defining constant for the field IDs of the ColorInterpolator node.
   */
  public interface ColorInterpolator
  {
    /**
     * The ID for the set_fraction field = 0.
     */
    static final int set_fraction = 0;
    /**
     * The ID for the key field = 1.
     */
    static final int key = 1;
    /**
     * The ID for the keyValue field = 2.
     */
    static final int keyValue = 2;
  }
  /**
   * An interface defining constant for the field IDs of the CompositeTexture2D node.
   */
  public interface CompositeTexture2D
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the pixelWidth field = 3.
     */
    static final int pixelWidth = 3;
    /**
     * The ID for the pixelHeight field = 4.
     */
    static final int pixelHeight = 4;
    /**
     * The ID for the background field = 5.
     */
    static final int background = 5;
    /**
     * The ID for the viewport field = 6.
     */
    static final int viewport = 6;
  }
  /**
   * An interface defining constant for the field IDs of the CompositeTexture3D node.
   */
  public interface CompositeTexture3D
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the pixelWidth field = 3.
     */
    static final int pixelWidth = 3;
    /**
     * The ID for the pixelHeight field = 4.
     */
    static final int pixelHeight = 4;
    /**
     * The ID for the background field = 5.
     */
    static final int background = 5;
    /**
     * The ID for the fog field = 6.
     */
    static final int fog = 6;
    /**
     * The ID for the navigationInfo field = 7.
     */
    static final int navigationInfo = 7;
    /**
     * The ID for the viewpoint field = 8.
     */
    static final int viewpoint = 8;
  }
  /**
   * An interface defining constant for the field IDs of the Conditional node.
   */
  public interface Conditional
  {
    /**
     * The ID for the activate field = 0.
     */
    static final int activate = 0;
    /**
     * The ID for the reverseActivate field = 1.
     */
    static final int reverseActivate = 1;
    /**
     * The ID for the buffer field = 2.
     */
    static final int buffer = 2;
  }
  /**
   * An interface defining constant for the field IDs of the Cone node.
   */
  public interface Cone
  {
  }
  /**
   * An interface defining constant for the field IDs of the Coordinate node.
   */
  public interface Coordinate
  {
    /**
     * The ID for the point field = 0.
     */
    static final int point = 0;
  }
  /**
   * An interface defining constant for the field IDs of the Coordinate2D node.
   */
  public interface Coordinate2D
  {
    /**
     * The ID for the point field = 0.
     */
    static final int point = 0;
  }
  /**
   * An interface defining constant for the field IDs of the CoordinateInterpolator node.
   */
  public interface CoordinateInterpolator
  {
    /**
     * The ID for the set_fraction field = 0.
     */
    static final int set_fraction = 0;
    /**
     * The ID for the key field = 1.
     */
    static final int key = 1;
    /**
     * The ID for the keyValue field = 2.
     */
    static final int keyValue = 2;
  }
  /**
   * An interface defining constant for the field IDs of the CoordinateInterpolator2D node.
   */
  public interface CoordinateInterpolator2D
  {
    /**
     * The ID for the set_fraction field = 0.
     */
    static final int set_fraction = 0;
    /**
     * The ID for the key field = 1.
     */
    static final int key = 1;
    /**
     * The ID for the keyValue field = 2.
     */
    static final int keyValue = 2;
  }
  /**
   * An interface defining constant for the field IDs of the Curve2D node.
   */
  public interface Curve2D
  {
    /**
     * The ID for the point field = 0.
     */
    static final int point = 0;
    /**
     * The ID for the fineness field = 1.
     */
    static final int fineness = 1;
    /**
     * The ID for the type field = 2.
     */
    static final int type = 2;
  }
  /**
   * An interface defining constant for the field IDs of the Cylinder node.
   */
  public interface Cylinder
  {
  }
  /**
   * An interface defining constant for the field IDs of the CylinderSensor node.
   */
  public interface CylinderSensor
  {
    /**
     * The ID for the autoOffset field = 0.
     */
    static final int autoOffset = 0;
    /**
     * The ID for the diskAngle field = 1.
     */
    static final int diskAngle = 1;
    /**
     * The ID for the enabled field = 2.
     */
    static final int enabled = 2;
    /**
     * The ID for the maxAngle field = 3.
     */
    static final int maxAngle = 3;
    /**
     * The ID for the minAngle field = 4.
     */
    static final int minAngle = 4;
    /**
     * The ID for the offset field = 5.
     */
    static final int offset = 5;
  }
  /**
   * An interface defining constant for the field IDs of the DirectionalLight node.
   */
  public interface DirectionalLight
  {
    /**
     * The ID for the ambientIntensity field = 0.
     */
    static final int ambientIntensity = 0;
    /**
     * The ID for the color field = 1.
     */
    static final int color = 1;
    /**
     * The ID for the direction field = 2.
     */
    static final int direction = 2;
    /**
     * The ID for the intensity field = 3.
     */
    static final int intensity = 3;
    /**
     * The ID for the on field = 4.
     */
    static final int on = 4;
  }
  /**
   * An interface defining constant for the field IDs of the DiscSensor node.
   */
  public interface DiscSensor
  {
    /**
     * The ID for the autoOffset field = 0.
     */
    static final int autoOffset = 0;
    /**
     * The ID for the enabled field = 1.
     */
    static final int enabled = 1;
    /**
     * The ID for the maxAngle field = 2.
     */
    static final int maxAngle = 2;
    /**
     * The ID for the minAngle field = 3.
     */
    static final int minAngle = 3;
    /**
     * The ID for the offset field = 4.
     */
    static final int offset = 4;
  }
  /**
   * An interface defining constant for the field IDs of the ElevationGrid node.
   */
  public interface ElevationGrid
  {
    /**
     * The ID for the set_height field = 0.
     */
    static final int set_height = 0;
    /**
     * The ID for the color field = 1.
     */
    static final int color = 1;
    /**
     * The ID for the normal field = 2.
     */
    static final int normal = 2;
    /**
     * The ID for the texCoord field = 3.
     */
    static final int texCoord = 3;
  }
  /**
   * An interface defining constant for the field IDs of the Expression node.
   */
  public interface Expression
  {
    /**
     * The ID for the expression_select1 field = 0.
     */
    static final int expression_select1 = 0;
    /**
     * The ID for the expression_intensity1 field = 1.
     */
    static final int expression_intensity1 = 1;
    /**
     * The ID for the expression_select2 field = 2.
     */
    static final int expression_select2 = 2;
    /**
     * The ID for the expression_intensity2 field = 3.
     */
    static final int expression_intensity2 = 3;
    /**
     * The ID for the init_face field = 4.
     */
    static final int init_face = 4;
    /**
     * The ID for the expression_def field = 5.
     */
    static final int expression_def = 5;
  }
  /**
   * An interface defining constant for the field IDs of the Extrusion node.
   */
  public interface Extrusion
  {
    /**
     * The ID for the set_crossSection field = 0.
     */
    static final int set_crossSection = 0;
    /**
     * The ID for the set_orientation field = 1.
     */
    static final int set_orientation = 1;
    /**
     * The ID for the set_scale field = 2.
     */
    static final int set_scale = 2;
    /**
     * The ID for the set_spine field = 3.
     */
    static final int set_spine = 3;
  }
  /**
   * An interface defining constant for the field IDs of the Face node.
   */
  public interface Face
  {
    /**
     * The ID for the fap field = 0.
     */
    static final int fap = 0;
    /**
     * The ID for the fdp field = 1.
     */
    static final int fdp = 1;
    /**
     * The ID for the fit field = 2.
     */
    static final int fit = 2;
    /**
     * The ID for the ttsSource field = 3.
     */
    static final int ttsSource = 3;
    /**
     * The ID for the renderedFace field = 4.
     */
    static final int renderedFace = 4;
  }
  /**
   * An interface defining constant for the field IDs of the FaceDefMesh node.
   */
  public interface FaceDefMesh
  {
  }
  /**
   * An interface defining constant for the field IDs of the FaceDefTables node.
   */
  public interface FaceDefTables
  {
    /**
     * The ID for the faceDefMesh field = 2.
     */
    static final int faceDefMesh = 2;
    /**
     * The ID for the faceDefTransform field = 3.
     */
    static final int faceDefTransform = 3;
  }
  /**
   * An interface defining constant for the field IDs of the FaceDefTransform node.
   */
  public interface FaceDefTransform
  {
  }
  /**
   * An interface defining constant for the field IDs of the FAP node.
   */
  public interface FAP
  {
    /**
     * The ID for the viseme field = 0.
     */
    static final int viseme = 0;
    /**
     * The ID for the expression field = 1.
     */
    static final int expression = 1;
    /**
     * The ID for the open_jaw field = 2.
     */
    static final int open_jaw = 2;
    /**
     * The ID for the lower_t_midlip field = 3.
     */
    static final int lower_t_midlip = 3;
    /**
     * The ID for the raise_b_midlip field = 4.
     */
    static final int raise_b_midlip = 4;
    /**
     * The ID for the stretch_l_corner field = 5.
     */
    static final int stretch_l_corner = 5;
    /**
     * The ID for the stretch_r_corner field = 6.
     */
    static final int stretch_r_corner = 6;
    /**
     * The ID for the lower_t_lip_lm field = 7.
     */
    static final int lower_t_lip_lm = 7;
    /**
     * The ID for the lower_t_lip_rm field = 8.
     */
    static final int lower_t_lip_rm = 8;
    /**
     * The ID for the lower_b_lip_lm field = 9.
     */
    static final int lower_b_lip_lm = 9;
    /**
     * The ID for the lower_b_lip_rm field = 10.
     */
    static final int lower_b_lip_rm = 10;
    /**
     * The ID for the raise_l_cornerlip field = 11.
     */
    static final int raise_l_cornerlip = 11;
    /**
     * The ID for the raise_r_cornerlip field = 12.
     */
    static final int raise_r_cornerlip = 12;
    /**
     * The ID for the thrust_jaw field = 13.
     */
    static final int thrust_jaw = 13;
    /**
     * The ID for the shift_jaw field = 14.
     */
    static final int shift_jaw = 14;
    /**
     * The ID for the push_b_lip field = 15.
     */
    static final int push_b_lip = 15;
    /**
     * The ID for the push_t_lip field = 16.
     */
    static final int push_t_lip = 16;
    /**
     * The ID for the depress_chin field = 17.
     */
    static final int depress_chin = 17;
    /**
     * The ID for the close_t_l_eyelid field = 18.
     */
    static final int close_t_l_eyelid = 18;
    /**
     * The ID for the close_t_r_eyelid field = 19.
     */
    static final int close_t_r_eyelid = 19;
    /**
     * The ID for the close_b_l_eyelid field = 20.
     */
    static final int close_b_l_eyelid = 20;
    /**
     * The ID for the close_b_r_eyelid field = 21.
     */
    static final int close_b_r_eyelid = 21;
    /**
     * The ID for the yaw_l_eyeball field = 22.
     */
    static final int yaw_l_eyeball = 22;
    /**
     * The ID for the yaw_r_eyeball field = 23.
     */
    static final int yaw_r_eyeball = 23;
    /**
     * The ID for the pitch_l_eyeball field = 24.
     */
    static final int pitch_l_eyeball = 24;
    /**
     * The ID for the pitch_r_eyeball field = 25.
     */
    static final int pitch_r_eyeball = 25;
    /**
     * The ID for the thrust_l_eyeball field = 26.
     */
    static final int thrust_l_eyeball = 26;
    /**
     * The ID for the thrust_r_eyeball field = 27.
     */
    static final int thrust_r_eyeball = 27;
    /**
     * The ID for the dilate_l_pupil field = 28.
     */
    static final int dilate_l_pupil = 28;
    /**
     * The ID for the dilate_r_pupil field = 29.
     */
    static final int dilate_r_pupil = 29;
    /**
     * The ID for the raise_l_i_eyebrow field = 30.
     */
    static final int raise_l_i_eyebrow = 30;
    /**
     * The ID for the raise_r_i_eyebrow field = 31.
     */
    static final int raise_r_i_eyebrow = 31;
    /**
     * The ID for the raise_l_m_eyebrow field = 32.
     */
    static final int raise_l_m_eyebrow = 32;
    /**
     * The ID for the raise_r_m_eyebrow field = 33.
     */
    static final int raise_r_m_eyebrow = 33;
    /**
     * The ID for the raise_l_o_eyebrow field = 34.
     */
    static final int raise_l_o_eyebrow = 34;
    /**
     * The ID for the raise_r_o_eyebrow field = 35.
     */
    static final int raise_r_o_eyebrow = 35;
    /**
     * The ID for the squeeze_l_eyebrow field = 36.
     */
    static final int squeeze_l_eyebrow = 36;
    /**
     * The ID for the squeeze_r_eyebrow field = 37.
     */
    static final int squeeze_r_eyebrow = 37;
    /**
     * The ID for the puff_l_cheek field = 38.
     */
    static final int puff_l_cheek = 38;
    /**
     * The ID for the puff_r_cheek field = 39.
     */
    static final int puff_r_cheek = 39;
    /**
     * The ID for the lift_l_cheek field = 40.
     */
    static final int lift_l_cheek = 40;
    /**
     * The ID for the lift_r_cheek field = 41.
     */
    static final int lift_r_cheek = 41;
    /**
     * The ID for the shift_tongue_tip field = 42.
     */
    static final int shift_tongue_tip = 42;
    /**
     * The ID for the raise_tongue_tip field = 43.
     */
    static final int raise_tongue_tip = 43;
    /**
     * The ID for the thrust_tongue_tip field = 44.
     */
    static final int thrust_tongue_tip = 44;
    /**
     * The ID for the raise_tongue field = 45.
     */
    static final int raise_tongue = 45;
    /**
     * The ID for the tongue_roll field = 46.
     */
    static final int tongue_roll = 46;
    /**
     * The ID for the head_pitch field = 47.
     */
    static final int head_pitch = 47;
    /**
     * The ID for the head_yaw field = 48.
     */
    static final int head_yaw = 48;
    /**
     * The ID for the head_roll field = 49.
     */
    static final int head_roll = 49;
    /**
     * The ID for the lower_t_midlip_o field = 50.
     */
    static final int lower_t_midlip_o = 50;
    /**
     * The ID for the raise_b_midlip_o field = 51.
     */
    static final int raise_b_midlip_o = 51;
    /**
     * The ID for the stretch_l_cornerlip field = 52.
     */
    static final int stretch_l_cornerlip = 52;
    /**
     * The ID for the stretch_r_cornerlip field = 53.
     */
    static final int stretch_r_cornerlip = 53;
    /**
     * The ID for the lower_t_lip_lm_o field = 54.
     */
    static final int lower_t_lip_lm_o = 54;
    /**
     * The ID for the lower_t_lip_rm_o field = 55.
     */
    static final int lower_t_lip_rm_o = 55;
    /**
     * The ID for the raise_b_lip_lm_o field = 56.
     */
    static final int raise_b_lip_lm_o = 56;
    /**
     * The ID for the raise_b_lip_rm_o field = 57.
     */
    static final int raise_b_lip_rm_o = 57;
    /**
     * The ID for the raise_l_cornerlip_o field = 58.
     */
    static final int raise_l_cornerlip_o = 58;
    /**
     * The ID for the raise_r_cornerlip_o field = 59.
     */
    static final int raise_r_cornerlip_o = 59;
    /**
     * The ID for the stretch_l_nose field = 60.
     */
    static final int stretch_l_nose = 60;
    /**
     * The ID for the stretch_r_nose field = 61.
     */
    static final int stretch_r_nose = 61;
    /**
     * The ID for the raise_nose field = 62.
     */
    static final int raise_nose = 62;
    /**
     * The ID for the bend_nose field = 63.
     */
    static final int bend_nose = 63;
    /**
     * The ID for the raise_l_ear field = 64.
     */
    static final int raise_l_ear = 64;
    /**
     * The ID for the raise_r_ear field = 65.
     */
    static final int raise_r_ear = 65;
    /**
     * The ID for the pull_l_ear field = 66.
     */
    static final int pull_l_ear = 66;
    /**
     * The ID for the pull_r_ear field = 67.
     */
    static final int pull_r_ear = 67;
  }
  /**
   * An interface defining constant for the field IDs of the FDP node.
   */
  public interface FDP
  {
    /**
     * The ID for the featurePointsCoord field = 0.
     */
    static final int featurePointsCoord = 0;
    /**
     * The ID for the textureCoord field = 1.
     */
    static final int textureCoord = 1;
    /**
     * The ID for the faceDefTables field = 2.
     */
    static final int faceDefTables = 2;
    /**
     * The ID for the faceSceneGraph field = 3.
     */
    static final int faceSceneGraph = 3;
  }
  /**
   * An interface defining constant for the field IDs of the FIT node.
   */
  public interface FIT
  {
    /**
     * The ID for the FAPs field = 0.
     */
    static final int FAPs = 0;
    /**
     * The ID for the Graph field = 1.
     */
    static final int Graph = 1;
    /**
     * The ID for the numeratorExp field = 2.
     */
    static final int numeratorExp = 2;
    /**
     * The ID for the denominatorExp field = 3.
     */
    static final int denominatorExp = 3;
    /**
     * The ID for the numeratorImpulse field = 4.
     */
    static final int numeratorImpulse = 4;
    /**
     * The ID for the numeratorTerms field = 5.
     */
    static final int numeratorTerms = 5;
    /**
     * The ID for the denominatorTerms field = 6.
     */
    static final int denominatorTerms = 6;
    /**
     * The ID for the numeratorCoefs field = 7.
     */
    static final int numeratorCoefs = 7;
    /**
     * The ID for the denominatorCoefs field = 8.
     */
    static final int denominatorCoefs = 8;
  }
  /**
   * An interface defining constant for the field IDs of the Fog node.
   */
  public interface Fog
  {
    /**
     * The ID for the color field = 0.
     */
    static final int color = 0;
    /**
     * The ID for the fogType field = 1.
     */
    static final int fogType = 1;
    /**
     * The ID for the visibilityRange field = 2.
     */
    static final int visibilityRange = 2;
    /**
     * The ID for the set_bind field = 3.
     */
    static final int set_bind = 3;
  }
  /**
   * An interface defining constant for the field IDs of the FontStyle node.
   */
  public interface FontStyle
  {
    /**
     * The ID for the family field = 0.
     */
    static final int family = 0;
    /**
     * The ID for the horizontal field = 1.
     */
    static final int horizontal = 1;
    /**
     * The ID for the justify field = 2.
     */
    static final int justify = 2;
    /**
     * The ID for the language field = 3.
     */
    static final int language = 3;
    /**
     * The ID for the leftToRight field = 4.
     */
    static final int leftToRight = 4;
    /**
     * The ID for the size field = 5.
     */
    static final int size = 5;
    /**
     * The ID for the spacing field = 6.
     */
    static final int spacing = 6;
    /**
     * The ID for the style field = 7.
     */
    static final int style = 7;
    /**
     * The ID for the topToBottom field = 8.
     */
    static final int topToBottom = 8;
  }
  /**
   * An interface defining constant for the field IDs of the Form node.
   */
  public interface Form
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the size field = 3.
     */
    static final int size = 3;
    /**
     * The ID for the groups field = 4.
     */
    static final int groups = 4;
    /**
     * The ID for the constraints field = 5.
     */
    static final int constraints = 5;
    /**
     * The ID for the groupsIndex field = 6.
     */
    static final int groupsIndex = 6;
  }
  /**
   * An interface defining constant for the field IDs of the Group node.
   */
  public interface Group
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
  }
  /**
   * An interface defining constant for the field IDs of the ImageTexture node.
   */
  public interface ImageTexture
  {
    /**
     * The ID for the url field = 0.
     */
    static final int url = 0;
  }
  /**
   * An interface defining constant for the field IDs of the IndexedFaceSet node.
   */
  public interface IndexedFaceSet
  {
    /**
     * The ID for the set_colorIndex field = 0.
     */
    static final int set_colorIndex = 0;
    /**
     * The ID for the set_coordIndex field = 1.
     */
    static final int set_coordIndex = 1;
    /**
     * The ID for the set_normalIndex field = 2.
     */
    static final int set_normalIndex = 2;
    /**
     * The ID for the set_texCoordIndex field = 3.
     */
    static final int set_texCoordIndex = 3;
    /**
     * The ID for the color field = 4.
     */
    static final int color = 4;
    /**
     * The ID for the coord field = 5.
     */
    static final int coord = 5;
    /**
     * The ID for the normal field = 6.
     */
    static final int normal = 6;
    /**
     * The ID for the texCoord field = 7.
     */
    static final int texCoord = 7;
  }
  /**
   * An interface defining constant for the field IDs of the IndexedFaceSet2D node.
   */
  public interface IndexedFaceSet2D
  {
    /**
     * The ID for the set_colorIndex field = 0.
     */
    static final int set_colorIndex = 0;
    /**
     * The ID for the set_coordIndex field = 1.
     */
    static final int set_coordIndex = 1;
    /**
     * The ID for the set_texCoordIndex field = 2.
     */
    static final int set_texCoordIndex = 2;
    /**
     * The ID for the color field = 3.
     */
    static final int color = 3;
    /**
     * The ID for the coord field = 4.
     */
    static final int coord = 4;
    /**
     * The ID for the texCoord field = 5.
     */
    static final int texCoord = 5;
  }
  /**
   * An interface defining constant for the field IDs of the IndexedLineSet node.
   */
  public interface IndexedLineSet
  {
    /**
     * The ID for the set_colorIndex field = 0.
     */
    static final int set_colorIndex = 0;
    /**
     * The ID for the set_coordIndex field = 1.
     */
    static final int set_coordIndex = 1;
    /**
     * The ID for the color field = 2.
     */
    static final int color = 2;
    /**
     * The ID for the coord field = 3.
     */
    static final int coord = 3;
  }
  /**
   * An interface defining constant for the field IDs of the IndexedLineSet2D node.
   */
  public interface IndexedLineSet2D
  {
    /**
     * The ID for the set_colorIndex field = 0.
     */
    static final int set_colorIndex = 0;
    /**
     * The ID for the set_coordIndex field = 1.
     */
    static final int set_coordIndex = 1;
    /**
     * The ID for the color field = 2.
     */
    static final int color = 2;
    /**
     * The ID for the coord field = 3.
     */
    static final int coord = 3;
  }
  /**
   * An interface defining constant for the field IDs of the Inline node.
   */
  public interface Inline
  {
    /**
     * The ID for the url field = 0.
     */
    static final int url = 0;
  }
  /**
   * An interface defining constant for the field IDs of the LOD node.
   */
  public interface LOD
  {
    /**
     * The ID for the level field = 0.
     */
    static final int level = 0;
  }
  /**
   * An interface defining constant for the field IDs of the Layer2D node.
   */
  public interface Layer2D
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the size field = 3.
     */
    static final int size = 3;
    /**
     * The ID for the background field = 4.
     */
    static final int background = 4;
    /**
     * The ID for the viewport field = 5.
     */
    static final int viewport = 5;
  }
  /**
   * An interface defining constant for the field IDs of the Layer3D node.
   */
  public interface Layer3D
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the size field = 3.
     */
    static final int size = 3;
    /**
     * The ID for the background field = 4.
     */
    static final int background = 4;
    /**
     * The ID for the fog field = 5.
     */
    static final int fog = 5;
    /**
     * The ID for the navigationInfo field = 6.
     */
    static final int navigationInfo = 6;
    /**
     * The ID for the viewpoint field = 7.
     */
    static final int viewpoint = 7;
  }
  /**
   * An interface defining constant for the field IDs of the Layout node.
   */
  public interface Layout
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the wrap field = 3.
     */
    static final int wrap = 3;
    /**
     * The ID for the size field = 4.
     */
    static final int size = 4;
    /**
     * The ID for the horizontal field = 5.
     */
    static final int horizontal = 5;
    /**
     * The ID for the justify field = 6.
     */
    static final int justify = 6;
    /**
     * The ID for the leftToRight field = 7.
     */
    static final int leftToRight = 7;
    /**
     * The ID for the topToBottom field = 8.
     */
    static final int topToBottom = 8;
    /**
     * The ID for the spacing field = 9.
     */
    static final int spacing = 9;
    /**
     * The ID for the smoothScroll field = 10.
     */
    static final int smoothScroll = 10;
    /**
     * The ID for the loop field = 11.
     */
    static final int loop = 11;
    /**
     * The ID for the scrollVertical field = 12.
     */
    static final int scrollVertical = 12;
    /**
     * The ID for the scrollRate field = 13.
     */
    static final int scrollRate = 13;
    /**
     * The ID for the scrollMode field = 14.
     */
    static final int scrollMode = 14;
  }
  /**
   * An interface defining constant for the field IDs of the LineProperties node.
   */
  public interface LineProperties
  {
    /**
     * The ID for the lineColor field = 0.
     */
    static final int lineColor = 0;
    /**
     * The ID for the lineStyle field = 1.
     */
    static final int lineStyle = 1;
    /**
     * The ID for the width field = 2.
     */
    static final int width = 2;
  }
  /**
   * An interface defining constant for the field IDs of the ListeningPoint node.
   */
  public interface ListeningPoint
  {
    /**
     * The ID for the set_bind field = 0.
     */
    static final int set_bind = 0;
    /**
     * The ID for the jump field = 1.
     */
    static final int jump = 1;
    /**
     * The ID for the orientation field = 2.
     */
    static final int orientation = 2;
    /**
     * The ID for the position field = 3.
     */
    static final int position = 3;
  }
  /**
   * An interface defining constant for the field IDs of the Material node.
   */
  public interface Material
  {
    /**
     * The ID for the ambientIntensity field = 0.
     */
    static final int ambientIntensity = 0;
    /**
     * The ID for the diffuseColor field = 1.
     */
    static final int diffuseColor = 1;
    /**
     * The ID for the emissiveColor field = 2.
     */
    static final int emissiveColor = 2;
    /**
     * The ID for the shininess field = 3.
     */
    static final int shininess = 3;
    /**
     * The ID for the specularColor field = 4.
     */
    static final int specularColor = 4;
    /**
     * The ID for the transparency field = 5.
     */
    static final int transparency = 5;
  }
  /**
   * An interface defining constant for the field IDs of the Material2D node.
   */
  public interface Material2D
  {
    /**
     * The ID for the emissiveColor field = 0.
     */
    static final int emissiveColor = 0;
    /**
     * The ID for the filled field = 1.
     */
    static final int filled = 1;
    /**
     * The ID for the lineProps field = 2.
     */
    static final int lineProps = 2;
    /**
     * The ID for the transparency field = 3.
     */
    static final int transparency = 3;
  }
  /**
   * An interface defining constant for the field IDs of the MovieTexture node.
   */
  public interface MovieTexture
  {
    /**
     * The ID for the loop field = 0.
     */
    static final int loop = 0;
    /**
     * The ID for the speed field = 1.
     */
    static final int speed = 1;
    /**
     * The ID for the startTime field = 2.
     */
    static final int startTime = 2;
    /**
     * The ID for the stopTime field = 3.
     */
    static final int stopTime = 3;
    /**
     * The ID for the url field = 4.
     */
    static final int url = 4;
  }
  /**
   * An interface defining constant for the field IDs of the NavigationInfo node.
   */
  public interface NavigationInfo
  {
    /**
     * The ID for the set_bind field = 0.
     */
    static final int set_bind = 0;
    /**
     * The ID for the avatarSize field = 1.
     */
    static final int avatarSize = 1;
    /**
     * The ID for the headlight field = 2.
     */
    static final int headlight = 2;
    /**
     * The ID for the speed field = 3.
     */
    static final int speed = 3;
    /**
     * The ID for the type field = 4.
     */
    static final int type = 4;
    /**
     * The ID for the visibilityLimit field = 5.
     */
    static final int visibilityLimit = 5;
  }
  /**
   * An interface defining constant for the field IDs of the Normal node.
   */
  public interface Normal
  {
    /**
     * The ID for the vector field = 0.
     */
    static final int vector = 0;
  }
  /**
   * An interface defining constant for the field IDs of the NormalInterpolator node.
   */
  public interface NormalInterpolator
  {
    /**
     * The ID for the set_fraction field = 0.
     */
    static final int set_fraction = 0;
    /**
     * The ID for the key field = 1.
     */
    static final int key = 1;
    /**
     * The ID for the keyValue field = 2.
     */
    static final int keyValue = 2;
  }
  /**
   * An interface defining constant for the field IDs of the OrderedGroup node.
   */
  public interface OrderedGroup
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the order field = 3.
     */
    static final int order = 3;
  }
  /**
   * An interface defining constant for the field IDs of the OrientationInterpolator node.
   */
  public interface OrientationInterpolator
  {
    /**
     * The ID for the set_fraction field = 0.
     */
    static final int set_fraction = 0;
    /**
     * The ID for the key field = 1.
     */
    static final int key = 1;
    /**
     * The ID for the keyValue field = 2.
     */
    static final int keyValue = 2;
  }
  /**
   * An interface defining constant for the field IDs of the PixelTexture node.
   */
  public interface PixelTexture
  {
    /**
     * The ID for the image field = 0.
     */
    static final int image = 0;
  }
  /**
   * An interface defining constant for the field IDs of the PlaneSensor node.
   */
  public interface PlaneSensor
  {
    /**
     * The ID for the autoOffset field = 0.
     */
    static final int autoOffset = 0;
    /**
     * The ID for the enabled field = 1.
     */
    static final int enabled = 1;
    /**
     * The ID for the maxPosition field = 2.
     */
    static final int maxPosition = 2;
    /**
     * The ID for the minPosition field = 3.
     */
    static final int minPosition = 3;
    /**
     * The ID for the offset field = 4.
     */
    static final int offset = 4;
  }
  /**
   * An interface defining constant for the field IDs of the PlaneSensor2D node.
   */
  public interface PlaneSensor2D
  {
    /**
     * The ID for the autoOffset field = 0.
     */
    static final int autoOffset = 0;
    /**
     * The ID for the enabled field = 1.
     */
    static final int enabled = 1;
    /**
     * The ID for the maxPosition field = 2.
     */
    static final int maxPosition = 2;
    /**
     * The ID for the minPosition field = 3.
     */
    static final int minPosition = 3;
    /**
     * The ID for the offset field = 4.
     */
    static final int offset = 4;
  }
  /**
   * An interface defining constant for the field IDs of the PointLight node.
   */
  public interface PointLight
  {
    /**
     * The ID for the ambientIntensity field = 0.
     */
    static final int ambientIntensity = 0;
    /**
     * The ID for the attenuation field = 1.
     */
    static final int attenuation = 1;
    /**
     * The ID for the color field = 2.
     */
    static final int color = 2;
    /**
     * The ID for the intensity field = 3.
     */
    static final int intensity = 3;
    /**
     * The ID for the location field = 4.
     */
    static final int location = 4;
    /**
     * The ID for the on field = 5.
     */
    static final int on = 5;
    /**
     * The ID for the radius field = 6.
     */
    static final int radius = 6;
  }
  /**
   * An interface defining constant for the field IDs of the PointSet node.
   */
  public interface PointSet
  {
    /**
     * The ID for the color field = 0.
     */
    static final int color = 0;
    /**
     * The ID for the coord field = 1.
     */
    static final int coord = 1;
  }
  /**
   * An interface defining constant for the field IDs of the PointSet2D node.
   */
  public interface PointSet2D
  {
    /**
     * The ID for the color field = 0.
     */
    static final int color = 0;
    /**
     * The ID for the coord field = 1.
     */
    static final int coord = 1;
  }
  /**
   * An interface defining constant for the field IDs of the PositionInterpolator node.
   */
  public interface PositionInterpolator
  {
    /**
     * The ID for the set_fraction field = 0.
     */
    static final int set_fraction = 0;
    /**
     * The ID for the key field = 1.
     */
    static final int key = 1;
    /**
     * The ID for the keyValue field = 2.
     */
    static final int keyValue = 2;
  }
  /**
   * An interface defining constant for the field IDs of the PositionInterpolator2D node.
   */
  public interface PositionInterpolator2D
  {
    /**
     * The ID for the set_fraction field = 0.
     */
    static final int set_fraction = 0;
    /**
     * The ID for the key field = 1.
     */
    static final int key = 1;
    /**
     * The ID for the keyValue field = 2.
     */
    static final int keyValue = 2;
  }
  /**
   * An interface defining constant for the field IDs of the ProximitySensor2D node.
   */
  public interface ProximitySensor2D
  {
    /**
     * The ID for the center field = 0.
     */
    static final int center = 0;
    /**
     * The ID for the size field = 1.
     */
    static final int size = 1;
    /**
     * The ID for the enabled field = 2.
     */
    static final int enabled = 2;
  }
  /**
   * An interface defining constant for the field IDs of the ProximitySensor node.
   */
  public interface ProximitySensor
  {
    /**
     * The ID for the center field = 0.
     */
    static final int center = 0;
    /**
     * The ID for the size field = 1.
     */
    static final int size = 1;
    /**
     * The ID for the enabled field = 2.
     */
    static final int enabled = 2;
  }
  /**
   * An interface defining constant for the field IDs of the QuantizationParameter node.
   */
  public interface QuantizationParameter
  {
  }
  /**
   * An interface defining constant for the field IDs of the Rectangle node.
   */
  public interface Rectangle
  {
    /**
     * The ID for the size field = 0.
     */
    static final int size = 0;
  }
  /**
   * An interface defining constant for the field IDs of the ScalarInterpolator node.
   */
  public interface ScalarInterpolator
  {
    /**
     * The ID for the set_fraction field = 0.
     */
    static final int set_fraction = 0;
    /**
     * The ID for the key field = 1.
     */
    static final int key = 1;
    /**
     * The ID for the keyValue field = 2.
     */
    static final int keyValue = 2;
  }
  /**
   * An interface defining constant for the field IDs of the Script node.
   */
  public interface Script
  {
    /**
     * The ID for the url field = 0.
     */
    static final int url = 0;
  }
  /**
   * An interface defining constant for the field IDs of the Shape node.
   */
  public interface Shape
  {
    /**
     * The ID for the appearance field = 0.
     */
    static final int appearance = 0;
    /**
     * The ID for the geometry field = 1.
     */
    static final int geometry = 1;
  }
  /**
   * An interface defining constant for the field IDs of the Sound node.
   */
  public interface Sound
  {
    /**
     * The ID for the direction field = 0.
     */
    static final int direction = 0;
    /**
     * The ID for the intensity field = 1.
     */
    static final int intensity = 1;
    /**
     * The ID for the location field = 2.
     */
    static final int location = 2;
    /**
     * The ID for the maxBack field = 3.
     */
    static final int maxBack = 3;
    /**
     * The ID for the maxFront field = 4.
     */
    static final int maxFront = 4;
    /**
     * The ID for the minBack field = 5.
     */
    static final int minBack = 5;
    /**
     * The ID for the minFront field = 6.
     */
    static final int minFront = 6;
    /**
     * The ID for the priority field = 7.
     */
    static final int priority = 7;
    /**
     * The ID for the source field = 8.
     */
    static final int source = 8;
  }
  /**
   * An interface defining constant for the field IDs of the Sound2D node.
   */
  public interface Sound2D
  {
    /**
     * The ID for the intensity field = 0.
     */
    static final int intensity = 0;
    /**
     * The ID for the location field = 1.
     */
    static final int location = 1;
    /**
     * The ID for the source field = 2.
     */
    static final int source = 2;
  }
  /**
   * An interface defining constant for the field IDs of the Sphere node.
   */
  public interface Sphere
  {
  }
  /**
   * An interface defining constant for the field IDs of the SphereSensor node.
   */
  public interface SphereSensor
  {
    /**
     * The ID for the autoOffset field = 0.
     */
    static final int autoOffset = 0;
    /**
     * The ID for the enabled field = 1.
     */
    static final int enabled = 1;
    /**
     * The ID for the offset field = 2.
     */
    static final int offset = 2;
  }
  /**
   * An interface defining constant for the field IDs of the SpotLight node.
   */
  public interface SpotLight
  {
    /**
     * The ID for the ambientIntensity field = 0.
     */
    static final int ambientIntensity = 0;
    /**
     * The ID for the attenuation field = 1.
     */
    static final int attenuation = 1;
    /**
     * The ID for the beamWidth field = 2.
     */
    static final int beamWidth = 2;
    /**
     * The ID for the color field = 3.
     */
    static final int color = 3;
    /**
     * The ID for the cutOffAngle field = 4.
     */
    static final int cutOffAngle = 4;
    /**
     * The ID for the direction field = 5.
     */
    static final int direction = 5;
    /**
     * The ID for the intensity field = 6.
     */
    static final int intensity = 6;
    /**
     * The ID for the location field = 7.
     */
    static final int location = 7;
    /**
     * The ID for the on field = 8.
     */
    static final int on = 8;
    /**
     * The ID for the radius field = 9.
     */
    static final int radius = 9;
  }
  /**
   * An interface defining constant for the field IDs of the Switch node.
   */
  public interface Switch
  {
    /**
     * The ID for the choice field = 0.
     */
    static final int choice = 0;
    /**
     * The ID for the whichChoice field = 1.
     */
    static final int whichChoice = 1;
  }
  /**
   * An interface defining constant for the field IDs of the TermCap node.
   */
  public interface TermCap
  {
    /**
     * The ID for the evaluate field = 0.
     */
    static final int evaluate = 0;
    /**
     * The ID for the capability field = 1.
     */
    static final int capability = 1;
  }
  /**
   * An interface defining constant for the field IDs of the Text node.
   */
  public interface Text
  {
    /**
     * The ID for the string field = 0.
     */
    static final int string = 0;
    /**
     * The ID for the length field = 1.
     */
    static final int length = 1;
    /**
     * The ID for the fontStyle field = 2.
     */
    static final int fontStyle = 2;
    /**
     * The ID for the maxExtent field = 3.
     */
    static final int maxExtent = 3;
  }
  /**
   * An interface defining constant for the field IDs of the TextureCoordinate node.
   */
  public interface TextureCoordinate
  {
    /**
     * The ID for the point field = 0.
     */
    static final int point = 0;
  }
  /**
   * An interface defining constant for the field IDs of the TextureTransform node.
   */
  public interface TextureTransform
  {
    /**
     * The ID for the center field = 0.
     */
    static final int center = 0;
    /**
     * The ID for the rotation field = 1.
     */
    static final int rotation = 1;
    /**
     * The ID for the scale field = 2.
     */
    static final int scale = 2;
    /**
     * The ID for the translation field = 3.
     */
    static final int translation = 3;
  }
  /**
   * An interface defining constant for the field IDs of the TimeSensor node.
   */
  public interface TimeSensor
  {
    /**
     * The ID for the cycleInterval field = 0.
     */
    static final int cycleInterval = 0;
    /**
     * The ID for the enabled field = 1.
     */
    static final int enabled = 1;
    /**
     * The ID for the loop field = 2.
     */
    static final int loop = 2;
    /**
     * The ID for the startTime field = 3.
     */
    static final int startTime = 3;
    /**
     * The ID for the stopTime field = 4.
     */
    static final int stopTime = 4;
  }
  /**
   * An interface defining constant for the field IDs of the TouchSensor node.
   */
  public interface TouchSensor
  {
    /**
     * The ID for the enabled field = 0.
     */
    static final int enabled = 0;
  }
  /**
   * An interface defining constant for the field IDs of the Transform node.
   */
  public interface Transform
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the center field = 2.
     */
    static final int center = 2;
    /**
     * The ID for the children field = 3.
     */
    static final int children = 3;
    /**
     * The ID for the rotation field = 4.
     */
    static final int rotation = 4;
    /**
     * The ID for the scale field = 5.
     */
    static final int scale = 5;
    /**
     * The ID for the scaleOrientation field = 6.
     */
    static final int scaleOrientation = 6;
    /**
     * The ID for the translation field = 7.
     */
    static final int translation = 7;
  }
  /**
   * An interface defining constant for the field IDs of the Transform2D node.
   */
  public interface Transform2D
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the center field = 3.
     */
    static final int center = 3;
    /**
     * The ID for the rotationAngle field = 4.
     */
    static final int rotationAngle = 4;
    /**
     * The ID for the scale field = 5.
     */
    static final int scale = 5;
    /**
     * The ID for the scaleOrientation field = 6.
     */
    static final int scaleOrientation = 6;
    /**
     * The ID for the translation field = 7.
     */
    static final int translation = 7;
  }
  /**
   * An interface defining constant for the field IDs of the Valuator node.
   */
  public interface Valuator
  {
    /**
     * The ID for the inSFBool field = 0.
     */
    static final int inSFBool = 0;
    /**
     * The ID for the inSFColor field = 1.
     */
    static final int inSFColor = 1;
    /**
     * The ID for the inMFColor field = 2.
     */
    static final int inMFColor = 2;
    /**
     * The ID for the inSFFloat field = 3.
     */
    static final int inSFFloat = 3;
    /**
     * The ID for the inMFFloat field = 4.
     */
    static final int inMFFloat = 4;
    /**
     * The ID for the inSFInt32 field = 5.
     */
    static final int inSFInt32 = 5;
    /**
     * The ID for the inMFInt32 field = 6.
     */
    static final int inMFInt32 = 6;
    /**
     * The ID for the inSFRotation field = 7.
     */
    static final int inSFRotation = 7;
    /**
     * The ID for the inMFRotation field = 8.
     */
    static final int inMFRotation = 8;
    /**
     * The ID for the inSFString field = 9.
     */
    static final int inSFString = 9;
    /**
     * The ID for the inMFString field = 10.
     */
    static final int inMFString = 10;
    /**
     * The ID for the inSFTime field = 11.
     */
    static final int inSFTime = 11;
    /**
     * The ID for the inSFVec2f field = 12.
     */
    static final int inSFVec2f = 12;
    /**
     * The ID for the inMFVec2f field = 13.
     */
    static final int inMFVec2f = 13;
    /**
     * The ID for the inSFVec3f field = 14.
     */
    static final int inSFVec3f = 14;
    /**
     * The ID for the inMFVec3f field = 15.
     */
    static final int inMFVec3f = 15;
    /**
     * The ID for the Factor1 field = 32.
     */
    static final int Factor1 = 32;
    /**
     * The ID for the Factor2 field = 33.
     */
    static final int Factor2 = 33;
    /**
     * The ID for the Factor3 field = 34.
     */
    static final int Factor3 = 34;
    /**
     * The ID for the Factor4 field = 35.
     */
    static final int Factor4 = 35;
    /**
     * The ID for the Offset1 field = 36.
     */
    static final int Offset1 = 36;
    /**
     * The ID for the Offset2 field = 37.
     */
    static final int Offset2 = 37;
    /**
     * The ID for the Offset3 field = 38.
     */
    static final int Offset3 = 38;
    /**
     * The ID for the Offset4 field = 39.
     */
    static final int Offset4 = 39;
    /**
     * The ID for the Sum field = 40.
     */
    static final int Sum = 40;
  }
  /**
   * An interface defining constant for the field IDs of the Viewpoint node.
   */
  public interface Viewpoint
  {
    /**
     * The ID for the set_bind field = 0.
     */
    static final int set_bind = 0;
    /**
     * The ID for the fieldOfView field = 1.
     */
    static final int fieldOfView = 1;
    /**
     * The ID for the jump field = 2.
     */
    static final int jump = 2;
    /**
     * The ID for the orientation field = 3.
     */
    static final int orientation = 3;
    /**
     * The ID for the position field = 4.
     */
    static final int position = 4;
  }
  /**
   * An interface defining constant for the field IDs of the VisibilitySensor node.
   */
  public interface VisibilitySensor
  {
    /**
     * The ID for the center field = 0.
     */
    static final int center = 0;
    /**
     * The ID for the enabled field = 1.
     */
    static final int enabled = 1;
    /**
     * The ID for the size field = 2.
     */
    static final int size = 2;
  }
  /**
   * An interface defining constant for the field IDs of the Viseme node.
   */
  public interface Viseme
  {
    /**
     * The ID for the viseme_select1 field = 0.
     */
    static final int viseme_select1 = 0;
    /**
     * The ID for the viseme_select2 field = 1.
     */
    static final int viseme_select2 = 1;
    /**
     * The ID for the viseme_blend field = 2.
     */
    static final int viseme_blend = 2;
    /**
     * The ID for the viseme_def field = 3.
     */
    static final int viseme_def = 3;
  }
  /**
   * An interface defining constant for the field IDs of the WorldInfo node.
   */
  public interface WorldInfo
  {
  }
  /**
   * An interface defining constant for the field IDs of the AcousticMaterial node.
   */
  public interface AcousticMaterial
  {
    /**
     * The ID for the ambientIntensity field = 0.
     */
    static final int ambientIntensity = 0;
    /**
     * The ID for the diffuseColor field = 1.
     */
    static final int diffuseColor = 1;
    /**
     * The ID for the emissiveColor field = 2.
     */
    static final int emissiveColor = 2;
    /**
     * The ID for the shininess field = 3.
     */
    static final int shininess = 3;
    /**
     * The ID for the specularColor field = 4.
     */
    static final int specularColor = 4;
    /**
     * The ID for the transparency field = 5.
     */
    static final int transparency = 5;
  }
  /**
   * An interface defining constant for the field IDs of the AcousticScene node.
   */
  public interface AcousticScene
  {
    /**
     * The ID for the reverbLevel field = 4.
     */
    static final int reverbLevel = 4;
    /**
     * The ID for the reverbDelay field = 5.
     */
    static final int reverbDelay = 5;
  }
  /**
   * An interface defining constant for the field IDs of the ApplicationWindow node.
   */
  public interface ApplicationWindow
  {
    /**
     * The ID for the isActive field = 0.
     */
    static final int isActive = 0;
    /**
     * The ID for the startTime field = 1.
     */
    static final int startTime = 1;
    /**
     * The ID for the stopTime field = 2.
     */
    static final int stopTime = 2;
    /**
     * The ID for the description field = 3.
     */
    static final int description = 3;
    /**
     * The ID for the parameter field = 4.
     */
    static final int parameter = 4;
    /**
     * The ID for the url field = 5.
     */
    static final int url = 5;
    /**
     * The ID for the size field = 6.
     */
    static final int size = 6;
  }
  /**
   * An interface defining constant for the field IDs of the BAP node.
   */
  public interface BAP
  {
    /**
     * The ID for the sacroiliac_tilt field = 0.
     */
    static final int sacroiliac_tilt = 0;
    /**
     * The ID for the sacroiliac_torsion field = 1.
     */
    static final int sacroiliac_torsion = 1;
    /**
     * The ID for the sacroiliac_roll field = 2.
     */
    static final int sacroiliac_roll = 2;
    /**
     * The ID for the l_hip_flexion field = 3.
     */
    static final int l_hip_flexion = 3;
    /**
     * The ID for the r_hip_flexion field = 4.
     */
    static final int r_hip_flexion = 4;
    /**
     * The ID for the l_hip_abduct field = 5.
     */
    static final int l_hip_abduct = 5;
    /**
     * The ID for the r_hip_abduct field = 6.
     */
    static final int r_hip_abduct = 6;
    /**
     * The ID for the l_hip_twisting field = 7.
     */
    static final int l_hip_twisting = 7;
    /**
     * The ID for the r_hip_twisting field = 8.
     */
    static final int r_hip_twisting = 8;
    /**
     * The ID for the l_knee_flexion field = 9.
     */
    static final int l_knee_flexion = 9;
    /**
     * The ID for the r_knee_flexion field = 10.
     */
    static final int r_knee_flexion = 10;
    /**
     * The ID for the l_knee_twisting field = 11.
     */
    static final int l_knee_twisting = 11;
    /**
     * The ID for the r_knee_twisting field = 12.
     */
    static final int r_knee_twisting = 12;
    /**
     * The ID for the l_ankle_flexion field = 13.
     */
    static final int l_ankle_flexion = 13;
    /**
     * The ID for the r_ankle_flexion field = 14.
     */
    static final int r_ankle_flexion = 14;
    /**
     * The ID for the l_ankle_twisting field = 15.
     */
    static final int l_ankle_twisting = 15;
    /**
     * The ID for the r_ankle_twisting field = 16.
     */
    static final int r_ankle_twisting = 16;
    /**
     * The ID for the l_subtalar_flexion field = 17.
     */
    static final int l_subtalar_flexion = 17;
    /**
     * The ID for the r_subtalar_flexion field = 18.
     */
    static final int r_subtalar_flexion = 18;
    /**
     * The ID for the l_midtarsal_flexion field = 19.
     */
    static final int l_midtarsal_flexion = 19;
    /**
     * The ID for the r_midtarsal_flexion field = 20.
     */
    static final int r_midtarsal_flexion = 20;
    /**
     * The ID for the l_metatarsal_flexion field = 21.
     */
    static final int l_metatarsal_flexion = 21;
    /**
     * The ID for the r_metatarsal_flexion field = 22.
     */
    static final int r_metatarsal_flexion = 22;
    /**
     * The ID for the l_sternoclavicular_abduct field = 23.
     */
    static final int l_sternoclavicular_abduct = 23;
    /**
     * The ID for the r_sternoclavicular_abduct field = 24.
     */
    static final int r_sternoclavicular_abduct = 24;
    /**
     * The ID for the l_sternoclavicular_rotate field = 25.
     */
    static final int l_sternoclavicular_rotate = 25;
    /**
     * The ID for the r_sternoclavicular_rotate field = 26.
     */
    static final int r_sternoclavicular_rotate = 26;
    /**
     * The ID for the l_acromioclavicular_abduct field = 27.
     */
    static final int l_acromioclavicular_abduct = 27;
    /**
     * The ID for the r_acromioclavicular_abduct field = 28.
     */
    static final int r_acromioclavicular_abduct = 28;
    /**
     * The ID for the l_acromioclavicular_rotate field = 29.
     */
    static final int l_acromioclavicular_rotate = 29;
    /**
     * The ID for the r_acromioclavicular_rotate field = 30.
     */
    static final int r_acromioclavicular_rotate = 30;
    /**
     * The ID for the l_shoulder_flexion field = 31.
     */
    static final int l_shoulder_flexion = 31;
    /**
     * The ID for the r_shoulder_flexion field = 32.
     */
    static final int r_shoulder_flexion = 32;
    /**
     * The ID for the l_shoulder_abduct field = 33.
     */
    static final int l_shoulder_abduct = 33;
    /**
     * The ID for the r_shoulder_abduct field = 34.
     */
    static final int r_shoulder_abduct = 34;
    /**
     * The ID for the l_shoulder_twisting field = 35.
     */
    static final int l_shoulder_twisting = 35;
    /**
     * The ID for the r_shoulder_twisting field = 36.
     */
    static final int r_shoulder_twisting = 36;
    /**
     * The ID for the l_elbow_flexion field = 37.
     */
    static final int l_elbow_flexion = 37;
    /**
     * The ID for the r_elbow_flexion field = 38.
     */
    static final int r_elbow_flexion = 38;
    /**
     * The ID for the l_elbow_twisting field = 39.
     */
    static final int l_elbow_twisting = 39;
    /**
     * The ID for the r_elbow_twisting field = 40.
     */
    static final int r_elbow_twisting = 40;
    /**
     * The ID for the l_wrist_flexion field = 41.
     */
    static final int l_wrist_flexion = 41;
    /**
     * The ID for the r_wrist_flexion field = 42.
     */
    static final int r_wrist_flexion = 42;
    /**
     * The ID for the l_wrist_pivot field = 43.
     */
    static final int l_wrist_pivot = 43;
    /**
     * The ID for the r_wrist_pivot field = 44.
     */
    static final int r_wrist_pivot = 44;
    /**
     * The ID for the l_wrist_twisting field = 45.
     */
    static final int l_wrist_twisting = 45;
    /**
     * The ID for the r_wrist_twisting field = 46.
     */
    static final int r_wrist_twisting = 46;
    /**
     * The ID for the skullbase_roll field = 47.
     */
    static final int skullbase_roll = 47;
    /**
     * The ID for the skullbase_torsion field = 48.
     */
    static final int skullbase_torsion = 48;
    /**
     * The ID for the skullbase_tilt field = 49.
     */
    static final int skullbase_tilt = 49;
    /**
     * The ID for the vc1roll field = 50.
     */
    static final int vc1roll = 50;
    /**
     * The ID for the vc1torsion field = 51.
     */
    static final int vc1torsion = 51;
    /**
     * The ID for the vc1tilt field = 52.
     */
    static final int vc1tilt = 52;
    /**
     * The ID for the vc2roll field = 53.
     */
    static final int vc2roll = 53;
    /**
     * The ID for the vc2torsion field = 54.
     */
    static final int vc2torsion = 54;
    /**
     * The ID for the vc2tilt field = 55.
     */
    static final int vc2tilt = 55;
    /**
     * The ID for the vc3roll field = 56.
     */
    static final int vc3roll = 56;
    /**
     * The ID for the vc3torsion field = 57.
     */
    static final int vc3torsion = 57;
    /**
     * The ID for the vc3tilt field = 58.
     */
    static final int vc3tilt = 58;
    /**
     * The ID for the vc4roll field = 59.
     */
    static final int vc4roll = 59;
    /**
     * The ID for the vc4torsion field = 60.
     */
    static final int vc4torsion = 60;
    /**
     * The ID for the vc4tilt field = 61.
     */
    static final int vc4tilt = 61;
    /**
     * The ID for the vc5roll field = 62.
     */
    static final int vc5roll = 62;
    /**
     * The ID for the vc5torsion field = 63.
     */
    static final int vc5torsion = 63;
    /**
     * The ID for the vc5tilt field = 64.
     */
    static final int vc5tilt = 64;
    /**
     * The ID for the vc6roll field = 65.
     */
    static final int vc6roll = 65;
    /**
     * The ID for the vc6torsion field = 66.
     */
    static final int vc6torsion = 66;
    /**
     * The ID for the vc6tilt field = 67.
     */
    static final int vc6tilt = 67;
    /**
     * The ID for the vc7roll field = 68.
     */
    static final int vc7roll = 68;
    /**
     * The ID for the vc7torsion field = 69.
     */
    static final int vc7torsion = 69;
    /**
     * The ID for the vc7tilt field = 70.
     */
    static final int vc7tilt = 70;
    /**
     * The ID for the vt1roll field = 71.
     */
    static final int vt1roll = 71;
    /**
     * The ID for the vt1torsion field = 72.
     */
    static final int vt1torsion = 72;
    /**
     * The ID for the vt1tilt field = 73.
     */
    static final int vt1tilt = 73;
    /**
     * The ID for the vt2roll field = 74.
     */
    static final int vt2roll = 74;
    /**
     * The ID for the vt2torsion field = 75.
     */
    static final int vt2torsion = 75;
    /**
     * The ID for the vt2tilt field = 76.
     */
    static final int vt2tilt = 76;
    /**
     * The ID for the vt3roll field = 77.
     */
    static final int vt3roll = 77;
    /**
     * The ID for the vt3torsion field = 78.
     */
    static final int vt3torsion = 78;
    /**
     * The ID for the vt3tilt field = 79.
     */
    static final int vt3tilt = 79;
    /**
     * The ID for the vt4roll field = 80.
     */
    static final int vt4roll = 80;
    /**
     * The ID for the vt4torsion field = 81.
     */
    static final int vt4torsion = 81;
    /**
     * The ID for the vt4tilt field = 82.
     */
    static final int vt4tilt = 82;
    /**
     * The ID for the vt5roll field = 83.
     */
    static final int vt5roll = 83;
    /**
     * The ID for the vt5torsion field = 84.
     */
    static final int vt5torsion = 84;
    /**
     * The ID for the vt5tilt field = 85.
     */
    static final int vt5tilt = 85;
    /**
     * The ID for the vt6roll field = 86.
     */
    static final int vt6roll = 86;
    /**
     * The ID for the vt6torsion field = 87.
     */
    static final int vt6torsion = 87;
    /**
     * The ID for the vt6tilt field = 88.
     */
    static final int vt6tilt = 88;
    /**
     * The ID for the vt7roll field = 89.
     */
    static final int vt7roll = 89;
    /**
     * The ID for the vt7torsion field = 90.
     */
    static final int vt7torsion = 90;
    /**
     * The ID for the vt7tilt field = 91.
     */
    static final int vt7tilt = 91;
    /**
     * The ID for the vt8roll field = 92.
     */
    static final int vt8roll = 92;
    /**
     * The ID for the vt8torsion field = 93.
     */
    static final int vt8torsion = 93;
    /**
     * The ID for the vt8tilt field = 94.
     */
    static final int vt8tilt = 94;
    /**
     * The ID for the vt9roll field = 95.
     */
    static final int vt9roll = 95;
    /**
     * The ID for the vt9torsion field = 96.
     */
    static final int vt9torsion = 96;
    /**
     * The ID for the vt9tilt field = 97.
     */
    static final int vt9tilt = 97;
    /**
     * The ID for the vt10roll field = 98.
     */
    static final int vt10roll = 98;
    /**
     * The ID for the vt10torsion field = 99.
     */
    static final int vt10torsion = 99;
    /**
     * The ID for the vt10tilt field = 100.
     */
    static final int vt10tilt = 100;
    /**
     * The ID for the vt11roll field = 101.
     */
    static final int vt11roll = 101;
    /**
     * The ID for the vt11torsion field = 102.
     */
    static final int vt11torsion = 102;
    /**
     * The ID for the vt11tilt field = 103.
     */
    static final int vt11tilt = 103;
    /**
     * The ID for the vt12roll field = 104.
     */
    static final int vt12roll = 104;
    /**
     * The ID for the vt12torsion field = 105.
     */
    static final int vt12torsion = 105;
    /**
     * The ID for the vt12tilt field = 106.
     */
    static final int vt12tilt = 106;
    /**
     * The ID for the vl1roll field = 107.
     */
    static final int vl1roll = 107;
    /**
     * The ID for the vl1torsion field = 108.
     */
    static final int vl1torsion = 108;
    /**
     * The ID for the vl1tilt field = 109.
     */
    static final int vl1tilt = 109;
    /**
     * The ID for the vl2roll field = 110.
     */
    static final int vl2roll = 110;
    /**
     * The ID for the vl2torsion field = 111.
     */
    static final int vl2torsion = 111;
    /**
     * The ID for the vl2tilt field = 112.
     */
    static final int vl2tilt = 112;
    /**
     * The ID for the vl3roll field = 113.
     */
    static final int vl3roll = 113;
    /**
     * The ID for the vl3torsion field = 114.
     */
    static final int vl3torsion = 114;
    /**
     * The ID for the vl3tilt field = 115.
     */
    static final int vl3tilt = 115;
    /**
     * The ID for the vl4roll field = 116.
     */
    static final int vl4roll = 116;
    /**
     * The ID for the vl4torsion field = 117.
     */
    static final int vl4torsion = 117;
    /**
     * The ID for the vl4tilt field = 118.
     */
    static final int vl4tilt = 118;
    /**
     * The ID for the vl5roll field = 119.
     */
    static final int vl5roll = 119;
    /**
     * The ID for the vl5torsion field = 120.
     */
    static final int vl5torsion = 120;
    /**
     * The ID for the vl5tilt field = 121.
     */
    static final int vl5tilt = 121;
    /**
     * The ID for the l_pinky0_flexion field = 122.
     */
    static final int l_pinky0_flexion = 122;
    /**
     * The ID for the r_pinky0_flexion field = 123.
     */
    static final int r_pinky0_flexion = 123;
    /**
     * The ID for the l_pinky1_flexion field = 124.
     */
    static final int l_pinky1_flexion = 124;
    /**
     * The ID for the r_pinky1_flexion field = 125.
     */
    static final int r_pinky1_flexion = 125;
    /**
     * The ID for the l_pinky1_pivot field = 126.
     */
    static final int l_pinky1_pivot = 126;
    /**
     * The ID for the r_pinky1_pivot field = 127.
     */
    static final int r_pinky1_pivot = 127;
    /**
     * The ID for the l_pinky1_twisting field = 128.
     */
    static final int l_pinky1_twisting = 128;
    /**
     * The ID for the r_pinky1_twisting field = 129.
     */
    static final int r_pinky1_twisting = 129;
    /**
     * The ID for the l_pinky2_flexion field = 130.
     */
    static final int l_pinky2_flexion = 130;
    /**
     * The ID for the r_pinky2_flexion field = 131.
     */
    static final int r_pinky2_flexion = 131;
    /**
     * The ID for the l_pinky3_flexion field = 132.
     */
    static final int l_pinky3_flexion = 132;
    /**
     * The ID for the r_pinky3_flexion field = 133.
     */
    static final int r_pinky3_flexion = 133;
    /**
     * The ID for the l_ring0_flexion field = 134.
     */
    static final int l_ring0_flexion = 134;
    /**
     * The ID for the r_ring0_flexion field = 135.
     */
    static final int r_ring0_flexion = 135;
    /**
     * The ID for the l_ring1_flexion field = 136.
     */
    static final int l_ring1_flexion = 136;
    /**
     * The ID for the r_ring1_flexion field = 137.
     */
    static final int r_ring1_flexion = 137;
    /**
     * The ID for the l_ring1_pivot field = 138.
     */
    static final int l_ring1_pivot = 138;
    /**
     * The ID for the r_ring1_pivot field = 139.
     */
    static final int r_ring1_pivot = 139;
    /**
     * The ID for the l_ring1_twisting field = 140.
     */
    static final int l_ring1_twisting = 140;
    /**
     * The ID for the r_ring1_twisting field = 141.
     */
    static final int r_ring1_twisting = 141;
    /**
     * The ID for the l_ring2_flexion field = 142.
     */
    static final int l_ring2_flexion = 142;
    /**
     * The ID for the r_ring2_flexion field = 143.
     */
    static final int r_ring2_flexion = 143;
    /**
     * The ID for the l_ring3_flexion field = 144.
     */
    static final int l_ring3_flexion = 144;
    /**
     * The ID for the r_ring3_flexion field = 145.
     */
    static final int r_ring3_flexion = 145;
    /**
     * The ID for the l_middle0_flexion field = 146.
     */
    static final int l_middle0_flexion = 146;
    /**
     * The ID for the r_middle0_flexion field = 147.
     */
    static final int r_middle0_flexion = 147;
    /**
     * The ID for the l_middle1_flexion field = 148.
     */
    static final int l_middle1_flexion = 148;
    /**
     * The ID for the r_middle1_flexion field = 149.
     */
    static final int r_middle1_flexion = 149;
    /**
     * The ID for the l_middle1_pivot field = 150.
     */
    static final int l_middle1_pivot = 150;
    /**
     * The ID for the r_middle1_pivot field = 151.
     */
    static final int r_middle1_pivot = 151;
    /**
     * The ID for the l_middle1_twisting field = 152.
     */
    static final int l_middle1_twisting = 152;
    /**
     * The ID for the r_middle1_twisting field = 153.
     */
    static final int r_middle1_twisting = 153;
    /**
     * The ID for the l_middle2_flexion field = 154.
     */
    static final int l_middle2_flexion = 154;
    /**
     * The ID for the r_middle2_flexion field = 155.
     */
    static final int r_middle2_flexion = 155;
    /**
     * The ID for the l_middle3_flexion field = 156.
     */
    static final int l_middle3_flexion = 156;
    /**
     * The ID for the r_middle3_flexion field = 157.
     */
    static final int r_middle3_flexion = 157;
    /**
     * The ID for the l_index0_flexion field = 158.
     */
    static final int l_index0_flexion = 158;
    /**
     * The ID for the r_index0_flexion field = 159.
     */
    static final int r_index0_flexion = 159;
    /**
     * The ID for the l_index1_flexion field = 160.
     */
    static final int l_index1_flexion = 160;
    /**
     * The ID for the r_index1_flexion field = 161.
     */
    static final int r_index1_flexion = 161;
    /**
     * The ID for the l_index1_pivot field = 162.
     */
    static final int l_index1_pivot = 162;
    /**
     * The ID for the r_index1_pivot field = 163.
     */
    static final int r_index1_pivot = 163;
    /**
     * The ID for the l_index1_twisting field = 164.
     */
    static final int l_index1_twisting = 164;
    /**
     * The ID for the r_index1_twisting field = 165.
     */
    static final int r_index1_twisting = 165;
    /**
     * The ID for the l_index2_flexion field = 166.
     */
    static final int l_index2_flexion = 166;
    /**
     * The ID for the r_index2_flexion field = 167.
     */
    static final int r_index2_flexion = 167;
    /**
     * The ID for the l_index3_flexion field = 168.
     */
    static final int l_index3_flexion = 168;
    /**
     * The ID for the r_index3_flexion field = 169.
     */
    static final int r_index3_flexion = 169;
    /**
     * The ID for the l_thumb1_flexion field = 170.
     */
    static final int l_thumb1_flexion = 170;
    /**
     * The ID for the r_thumb1_flexion field = 171.
     */
    static final int r_thumb1_flexion = 171;
    /**
     * The ID for the l_thumb1_pivot field = 172.
     */
    static final int l_thumb1_pivot = 172;
    /**
     * The ID for the r_thumb1_pivot field = 173.
     */
    static final int r_thumb1_pivot = 173;
    /**
     * The ID for the l_thumb1_twisting field = 174.
     */
    static final int l_thumb1_twisting = 174;
    /**
     * The ID for the r_thumb1_twisting field = 175.
     */
    static final int r_thumb1_twisting = 175;
    /**
     * The ID for the l_thumb2_flexion field = 176.
     */
    static final int l_thumb2_flexion = 176;
    /**
     * The ID for the r_thumb2_flexion field = 177.
     */
    static final int r_thumb2_flexion = 177;
    /**
     * The ID for the l_thumb3_flexion field = 178.
     */
    static final int l_thumb3_flexion = 178;
    /**
     * The ID for the r_thumb3_flexion field = 179.
     */
    static final int r_thumb3_flexion = 179;
    /**
     * The ID for the HumanoidRoot_tr_vertical field = 180.
     */
    static final int HumanoidRoot_tr_vertical = 180;
    /**
     * The ID for the HumanoidRoot_tr_lateral field = 181.
     */
    static final int HumanoidRoot_tr_lateral = 181;
    /**
     * The ID for the HumanoidRoot_tr_frontal field = 182.
     */
    static final int HumanoidRoot_tr_frontal = 182;
    /**
     * The ID for the HumanoidRoot_rt_body_turn field = 183.
     */
    static final int HumanoidRoot_rt_body_turn = 183;
    /**
     * The ID for the HumanoidRoot_rt_body_roll field = 184.
     */
    static final int HumanoidRoot_rt_body_roll = 184;
    /**
     * The ID for the HumanoidRoot_rt_body_tilt field = 185.
     */
    static final int HumanoidRoot_rt_body_tilt = 185;
    /**
     * The ID for the extensionBap187 field = 186.
     */
    static final int extensionBap187 = 186;
    /**
     * The ID for the extensionBap188 field = 187.
     */
    static final int extensionBap188 = 187;
    /**
     * The ID for the extensionBap189 field = 188.
     */
    static final int extensionBap189 = 188;
    /**
     * The ID for the extensionBap190 field = 189.
     */
    static final int extensionBap190 = 189;
    /**
     * The ID for the extensionBap191 field = 190.
     */
    static final int extensionBap191 = 190;
    /**
     * The ID for the extensionBap192 field = 191.
     */
    static final int extensionBap192 = 191;
    /**
     * The ID for the extensionBap193 field = 192.
     */
    static final int extensionBap193 = 192;
    /**
     * The ID for the extensionBap194 field = 193.
     */
    static final int extensionBap194 = 193;
    /**
     * The ID for the extensionBap195 field = 194.
     */
    static final int extensionBap195 = 194;
    /**
     * The ID for the extensionBap196 field = 195.
     */
    static final int extensionBap196 = 195;
    /**
     * The ID for the extensionBap197 field = 196.
     */
    static final int extensionBap197 = 196;
    /**
     * The ID for the extensionBap198 field = 197.
     */
    static final int extensionBap198 = 197;
    /**
     * The ID for the extensionBap199 field = 198.
     */
    static final int extensionBap199 = 198;
    /**
     * The ID for the extensionBap200 field = 199.
     */
    static final int extensionBap200 = 199;
    /**
     * The ID for the extensionBap201 field = 200.
     */
    static final int extensionBap201 = 200;
    /**
     * The ID for the extensionBap202 field = 201.
     */
    static final int extensionBap202 = 201;
    /**
     * The ID for the extensionBap203 field = 202.
     */
    static final int extensionBap203 = 202;
    /**
     * The ID for the extensionBap204 field = 203.
     */
    static final int extensionBap204 = 203;
    /**
     * The ID for the extensionBap205 field = 204.
     */
    static final int extensionBap205 = 204;
    /**
     * The ID for the extensionBap206 field = 205.
     */
    static final int extensionBap206 = 205;
    /**
     * The ID for the extensionBap207 field = 206.
     */
    static final int extensionBap207 = 206;
    /**
     * The ID for the extensionBap208 field = 207.
     */
    static final int extensionBap208 = 207;
    /**
     * The ID for the extensionBap209 field = 208.
     */
    static final int extensionBap209 = 208;
    /**
     * The ID for the extensionBap210 field = 209.
     */
    static final int extensionBap210 = 209;
    /**
     * The ID for the extensionBap211 field = 210.
     */
    static final int extensionBap211 = 210;
    /**
     * The ID for the extensionBap212 field = 211.
     */
    static final int extensionBap212 = 211;
    /**
     * The ID for the extensionBap213 field = 212.
     */
    static final int extensionBap213 = 212;
    /**
     * The ID for the extensionBap214 field = 213.
     */
    static final int extensionBap214 = 213;
    /**
     * The ID for the extensionBap215 field = 214.
     */
    static final int extensionBap215 = 214;
    /**
     * The ID for the extensionBap216 field = 215.
     */
    static final int extensionBap216 = 215;
    /**
     * The ID for the extensionBap217 field = 216.
     */
    static final int extensionBap217 = 216;
    /**
     * The ID for the extensionBap218 field = 217.
     */
    static final int extensionBap218 = 217;
    /**
     * The ID for the extensionBap219 field = 218.
     */
    static final int extensionBap219 = 218;
    /**
     * The ID for the extensionBap220 field = 219.
     */
    static final int extensionBap220 = 219;
    /**
     * The ID for the extensionBap221 field = 220.
     */
    static final int extensionBap221 = 220;
    /**
     * The ID for the extensionBap222 field = 221.
     */
    static final int extensionBap222 = 221;
    /**
     * The ID for the extensionBap223 field = 222.
     */
    static final int extensionBap223 = 222;
    /**
     * The ID for the extensionBap224 field = 223.
     */
    static final int extensionBap224 = 223;
    /**
     * The ID for the extensionBap225 field = 224.
     */
    static final int extensionBap225 = 224;
    /**
     * The ID for the extensionBap226 field = 225.
     */
    static final int extensionBap226 = 225;
    /**
     * The ID for the extensionBap227 field = 226.
     */
    static final int extensionBap227 = 226;
    /**
     * The ID for the extensionBap228 field = 227.
     */
    static final int extensionBap228 = 227;
    /**
     * The ID for the extensionBap229 field = 228.
     */
    static final int extensionBap229 = 228;
    /**
     * The ID for the extensionBap230 field = 229.
     */
    static final int extensionBap230 = 229;
    /**
     * The ID for the extensionBap231 field = 230.
     */
    static final int extensionBap231 = 230;
    /**
     * The ID for the extensionBap232 field = 231.
     */
    static final int extensionBap232 = 231;
    /**
     * The ID for the extensionBap233 field = 232.
     */
    static final int extensionBap233 = 232;
    /**
     * The ID for the extensionBap234 field = 233.
     */
    static final int extensionBap234 = 233;
    /**
     * The ID for the extensionBap235 field = 234.
     */
    static final int extensionBap235 = 234;
    /**
     * The ID for the extensionBap236 field = 235.
     */
    static final int extensionBap236 = 235;
    /**
     * The ID for the extensionBap237 field = 236.
     */
    static final int extensionBap237 = 236;
    /**
     * The ID for the extensionBap238 field = 237.
     */
    static final int extensionBap238 = 237;
    /**
     * The ID for the extensionBap239 field = 238.
     */
    static final int extensionBap239 = 238;
    /**
     * The ID for the extensionBap240 field = 239.
     */
    static final int extensionBap240 = 239;
    /**
     * The ID for the extensionBap241 field = 240.
     */
    static final int extensionBap241 = 240;
    /**
     * The ID for the extensionBap242 field = 241.
     */
    static final int extensionBap242 = 241;
    /**
     * The ID for the extensionBap243 field = 242.
     */
    static final int extensionBap243 = 242;
    /**
     * The ID for the extensionBap244 field = 243.
     */
    static final int extensionBap244 = 243;
    /**
     * The ID for the extensionBap245 field = 244.
     */
    static final int extensionBap245 = 244;
    /**
     * The ID for the extensionBap246 field = 245.
     */
    static final int extensionBap246 = 245;
    /**
     * The ID for the extensionBap247 field = 246.
     */
    static final int extensionBap247 = 246;
    /**
     * The ID for the extensionBap248 field = 247.
     */
    static final int extensionBap248 = 247;
    /**
     * The ID for the extensionBap249 field = 248.
     */
    static final int extensionBap249 = 248;
    /**
     * The ID for the extensionBap250 field = 249.
     */
    static final int extensionBap250 = 249;
    /**
     * The ID for the extensionBap251 field = 250.
     */
    static final int extensionBap251 = 250;
    /**
     * The ID for the extensionBap252 field = 251.
     */
    static final int extensionBap252 = 251;
    /**
     * The ID for the extensionBap253 field = 252.
     */
    static final int extensionBap253 = 252;
    /**
     * The ID for the extensionBap254 field = 253.
     */
    static final int extensionBap254 = 253;
    /**
     * The ID for the extensionBap255 field = 254.
     */
    static final int extensionBap255 = 254;
    /**
     * The ID for the extensionBap256 field = 255.
     */
    static final int extensionBap256 = 255;
    /**
     * The ID for the extensionBap257 field = 256.
     */
    static final int extensionBap257 = 256;
    /**
     * The ID for the extensionBap258 field = 257.
     */
    static final int extensionBap258 = 257;
    /**
     * The ID for the extensionBap259 field = 258.
     */
    static final int extensionBap259 = 258;
    /**
     * The ID for the extensionBap260 field = 259.
     */
    static final int extensionBap260 = 259;
    /**
     * The ID for the extensionBap261 field = 260.
     */
    static final int extensionBap261 = 260;
    /**
     * The ID for the extensionBap262 field = 261.
     */
    static final int extensionBap262 = 261;
    /**
     * The ID for the extensionBap263 field = 262.
     */
    static final int extensionBap263 = 262;
    /**
     * The ID for the extensionBap264 field = 263.
     */
    static final int extensionBap264 = 263;
    /**
     * The ID for the extensionBap265 field = 264.
     */
    static final int extensionBap265 = 264;
    /**
     * The ID for the extensionBap266 field = 265.
     */
    static final int extensionBap266 = 265;
    /**
     * The ID for the extensionBap267 field = 266.
     */
    static final int extensionBap267 = 266;
    /**
     * The ID for the extensionBap268 field = 267.
     */
    static final int extensionBap268 = 267;
    /**
     * The ID for the extensionBap269 field = 268.
     */
    static final int extensionBap269 = 268;
    /**
     * The ID for the extensionBap270 field = 269.
     */
    static final int extensionBap270 = 269;
    /**
     * The ID for the extensionBap271 field = 270.
     */
    static final int extensionBap271 = 270;
    /**
     * The ID for the extensionBap272 field = 271.
     */
    static final int extensionBap272 = 271;
    /**
     * The ID for the extensionBap273 field = 272.
     */
    static final int extensionBap273 = 272;
    /**
     * The ID for the extensionBap274 field = 273.
     */
    static final int extensionBap274 = 273;
    /**
     * The ID for the extensionBap275 field = 274.
     */
    static final int extensionBap275 = 274;
    /**
     * The ID for the extensionBap276 field = 275.
     */
    static final int extensionBap276 = 275;
    /**
     * The ID for the extensionBap277 field = 276.
     */
    static final int extensionBap277 = 276;
    /**
     * The ID for the extensionBap278 field = 277.
     */
    static final int extensionBap278 = 277;
    /**
     * The ID for the extensionBap279 field = 278.
     */
    static final int extensionBap279 = 278;
    /**
     * The ID for the extensionBap280 field = 279.
     */
    static final int extensionBap280 = 279;
    /**
     * The ID for the extensionBap281 field = 280.
     */
    static final int extensionBap281 = 280;
    /**
     * The ID for the extensionBap282 field = 281.
     */
    static final int extensionBap282 = 281;
    /**
     * The ID for the extensionBap283 field = 282.
     */
    static final int extensionBap283 = 282;
    /**
     * The ID for the extensionBap284 field = 283.
     */
    static final int extensionBap284 = 283;
    /**
     * The ID for the extensionBap285 field = 284.
     */
    static final int extensionBap285 = 284;
    /**
     * The ID for the extensionBap286 field = 285.
     */
    static final int extensionBap286 = 285;
    /**
     * The ID for the extensionBap287 field = 286.
     */
    static final int extensionBap287 = 286;
    /**
     * The ID for the extensionBap288 field = 287.
     */
    static final int extensionBap288 = 287;
    /**
     * The ID for the extensionBap289 field = 288.
     */
    static final int extensionBap289 = 288;
    /**
     * The ID for the extensionBap290 field = 289.
     */
    static final int extensionBap290 = 289;
    /**
     * The ID for the extensionBap291 field = 290.
     */
    static final int extensionBap291 = 290;
    /**
     * The ID for the extensionBap292 field = 291.
     */
    static final int extensionBap292 = 291;
    /**
     * The ID for the extensionBap293 field = 292.
     */
    static final int extensionBap293 = 292;
    /**
     * The ID for the extensionBap294 field = 293.
     */
    static final int extensionBap294 = 293;
    /**
     * The ID for the extensionBap295 field = 294.
     */
    static final int extensionBap295 = 294;
    /**
     * The ID for the extensionBap296 field = 295.
     */
    static final int extensionBap296 = 295;
  }
  /**
   * An interface defining constant for the field IDs of the BDP node.
   */
  public interface BDP
  {
    /**
     * The ID for the bodyDefTables field = 0.
     */
    static final int bodyDefTables = 0;
    /**
     * The ID for the bodySceneGraph field = 1.
     */
    static final int bodySceneGraph = 1;
  }
  /**
   * An interface defining constant for the field IDs of the Body node.
   */
  public interface Body
  {
    /**
     * The ID for the bdp field = 0.
     */
    static final int bdp = 0;
    /**
     * The ID for the bap field = 1.
     */
    static final int bap = 1;
    /**
     * The ID for the renderedBody field = 2.
     */
    static final int renderedBody = 2;
  }
  /**
   * An interface defining constant for the field IDs of the BodyDefTable node.
   */
  public interface BodyDefTable
  {
    /**
     * The ID for the bodySceneGraphNodeName field = 0.
     */
    static final int bodySceneGraphNodeName = 0;
    /**
     * The ID for the bapIDs field = 1.
     */
    static final int bapIDs = 1;
    /**
     * The ID for the vertexIds field = 2.
     */
    static final int vertexIds = 2;
    /**
     * The ID for the bapCombinations field = 3.
     */
    static final int bapCombinations = 3;
    /**
     * The ID for the displacements field = 4.
     */
    static final int displacements = 4;
    /**
     * The ID for the numInterpolateKeys field = 5.
     */
    static final int numInterpolateKeys = 5;
  }
  /**
   * An interface defining constant for the field IDs of the BodySegmentConnectionHint node.
   */
  public interface BodySegmentConnectionHint
  {
    /**
     * The ID for the firstSegmentNodeName field = 0.
     */
    static final int firstSegmentNodeName = 0;
    /**
     * The ID for the secondSegmentNodeName field = 1.
     */
    static final int secondSegmentNodeName = 1;
    /**
     * The ID for the firstVertexIdList field = 2.
     */
    static final int firstVertexIdList = 2;
    /**
     * The ID for the secondVertexIdList field = 3.
     */
    static final int secondVertexIdList = 3;
  }
  /**
   * An interface defining constant for the field IDs of the DirectiveSound node.
   */
  public interface DirectiveSound
  {
    /**
     * The ID for the direction field = 0.
     */
    static final int direction = 0;
    /**
     * The ID for the intensity field = 1.
     */
    static final int intensity = 1;
    /**
     * The ID for the location field = 2.
     */
    static final int location = 2;
    /**
     * The ID for the source field = 3.
     */
    static final int source = 3;
    /**
     * The ID for the perceptualParameters field = 4.
     */
    static final int perceptualParameters = 4;
    /**
     * The ID for the roomEffect field = 5.
     */
    static final int roomEffect = 5;
    /**
     * The ID for the spatialize field = 6.
     */
    static final int spatialize = 6;
  }
  /**
   * An interface defining constant for the field IDs of the Hierarchical3DMesh node.
   */
  public interface Hierarchical3DMesh
  {
    /**
     * The ID for the triangleBudget field = 0.
     */
    static final int triangleBudget = 0;
    /**
     * The ID for the level field = 1.
     */
    static final int level = 1;
  }
  /**
   * An interface defining constant for the field IDs of the MaterialKey node.
   */
  public interface MaterialKey
  {
    /**
     * The ID for the isKeyed field = 0.
     */
    static final int isKeyed = 0;
    /**
     * The ID for the isRGB field = 1.
     */
    static final int isRGB = 1;
    /**
     * The ID for the keyColor field = 2.
     */
    static final int keyColor = 2;
    /**
     * The ID for the lowThreshold field = 3.
     */
    static final int lowThreshold = 3;
    /**
     * The ID for the highThreshold field = 4.
     */
    static final int highThreshold = 4;
    /**
     * The ID for the transparency field = 5.
     */
    static final int transparency = 5;
  }
  /**
   * An interface defining constant for the field IDs of the PerceptualParameters node.
   */
  public interface PerceptualParameters
  {
    /**
     * The ID for the sourcePresence field = 0.
     */
    static final int sourcePresence = 0;
    /**
     * The ID for the sourceWarmth field = 1.
     */
    static final int sourceWarmth = 1;
    /**
     * The ID for the sourceBrilliance field = 2.
     */
    static final int sourceBrilliance = 2;
    /**
     * The ID for the roomPresence field = 3.
     */
    static final int roomPresence = 3;
    /**
     * The ID for the runningReverberance field = 4.
     */
    static final int runningReverberance = 4;
    /**
     * The ID for the envelopment field = 5.
     */
    static final int envelopment = 5;
    /**
     * The ID for the lateReverberance field = 6.
     */
    static final int lateReverberance = 6;
    /**
     * The ID for the heavyness field = 7.
     */
    static final int heavyness = 7;
    /**
     * The ID for the liveness field = 8.
     */
    static final int liveness = 8;
    /**
     * The ID for the omniDirectivity field = 9.
     */
    static final int omniDirectivity = 9;
    /**
     * The ID for the directFilterGains field = 10.
     */
    static final int directFilterGains = 10;
    /**
     * The ID for the inputFilterGains field = 11.
     */
    static final int inputFilterGains = 11;
    /**
     * The ID for the refDistance field = 12.
     */
    static final int refDistance = 12;
    /**
     * The ID for the freqLow field = 13.
     */
    static final int freqLow = 13;
    /**
     * The ID for the freqHigh field = 14.
     */
    static final int freqHigh = 14;
    /**
     * The ID for the timeLimit1 field = 15.
     */
    static final int timeLimit1 = 15;
    /**
     * The ID for the timeLimit2 field = 16.
     */
    static final int timeLimit2 = 16;
    /**
     * The ID for the timeLimit3 field = 17.
     */
    static final int timeLimit3 = 17;
    /**
     * The ID for the modalDensity field = 18.
     */
    static final int modalDensity = 18;
  }
  /**
   * An interface defining constant for the field IDs of the TemporalTransform node.
   */
  public interface TemporalTransform
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the url field = 3.
     */
    static final int url = 3;
    /**
     * The ID for the startTime field = 4.
     */
    static final int startTime = 4;
    /**
     * The ID for the optimalDuration field = 5.
     */
    static final int optimalDuration = 5;
    /**
     * The ID for the active field = 6.
     */
    static final int active = 6;
    /**
     * The ID for the speed field = 7.
     */
    static final int speed = 7;
    /**
     * The ID for the scalability field = 8.
     */
    static final int scalability = 8;
    /**
     * The ID for the stretchMode field = 9.
     */
    static final int stretchMode = 9;
    /**
     * The ID for the shrinkMode field = 10.
     */
    static final int shrinkMode = 10;
    /**
     * The ID for the maxDelay field = 11.
     */
    static final int maxDelay = 11;
  }
  /**
   * An interface defining constant for the field IDs of the TemporalGroup node.
   */
  public interface TemporalGroup
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the priority field = 6.
     */
    static final int priority = 6;
  }
  /**
   * An interface defining constant for the field IDs of the ServerCommand node.
   */
  public interface ServerCommand
  {
    /**
     * The ID for the trigger field = 0.
     */
    static final int trigger = 0;
    /**
     * The ID for the enable field = 1.
     */
    static final int enable = 1;
    /**
     * The ID for the url field = 2.
     */
    static final int url = 2;
    /**
     * The ID for the command field = 3.
     */
    static final int command = 3;
  }
  /**
   * An interface defining constant for the field IDs of the InputSensor node.
   */
  public interface InputSensor
  {
    /**
     * The ID for the enabled field = 0.
     */
    static final int enabled = 0;
    /**
     * The ID for the buffer field = 1.
     */
    static final int buffer = 1;
    /**
     * The ID for the url field = 2.
     */
    static final int url = 2;
  }
  /**
   * An interface defining constant for the field IDs of the MatteTexture node.
   */
  public interface MatteTexture
  {
    /**
     * The ID for the operation field = 3.
     */
    static final int operation = 3;
    /**
     * The ID for the fraction field = 5.
     */
    static final int fraction = 5;
    /**
     * The ID for the parameter field = 6.
     */
    static final int parameter = 6;
  }
  /**
   * An interface defining constant for the field IDs of the MediaBuffer node.
   */
  public interface MediaBuffer
  {
    /**
     * The ID for the bufferSize field = 0.
     */
    static final int bufferSize = 0;
    /**
     * The ID for the url field = 1.
     */
    static final int url = 1;
    /**
     * The ID for the mediaStartTime field = 2.
     */
    static final int mediaStartTime = 2;
    /**
     * The ID for the mediaStopTime field = 3.
     */
    static final int mediaStopTime = 3;
    /**
     * The ID for the enabled field = 5.
     */
    static final int enabled = 5;
  }
  /**
   * An interface defining constant for the field IDs of the MediaControl node.
   */
  public interface MediaControl
  {
    /**
     * The ID for the url field = 0.
     */
    static final int url = 0;
    /**
     * The ID for the mediaStartTime field = 1.
     */
    static final int mediaStartTime = 1;
    /**
     * The ID for the mediaStopTime field = 2.
     */
    static final int mediaStopTime = 2;
    /**
     * The ID for the mediaSpeed field = 3.
     */
    static final int mediaSpeed = 3;
    /**
     * The ID for the loop field = 4.
     */
    static final int loop = 4;
    /**
     * The ID for the preRoll field = 5.
     */
    static final int preRoll = 5;
    /**
     * The ID for the mute field = 6.
     */
    static final int mute = 6;
    /**
     * The ID for the enabled field = 7.
     */
    static final int enabled = 7;
  }
  /**
   * An interface defining constant for the field IDs of the MediaSensor node.
   */
  public interface MediaSensor
  {
    /**
     * The ID for the url field = 0.
     */
    static final int url = 0;
  }
  /**
   * An interface defining constant for the field IDs of the BitWrapper node.
   */
  public interface BitWrapper
  {
  }
  /**
   * An interface defining constant for the field IDs of the CoordinateInterpolator4D node.
   */
  public interface CoordinateInterpolator4D
  {
    /**
     * The ID for the set_fraction field = 0.
     */
    static final int set_fraction = 0;
    /**
     * The ID for the key field = 1.
     */
    static final int key = 1;
    /**
     * The ID for the keyValue field = 2.
     */
    static final int keyValue = 2;
  }
  /**
   * An interface defining constant for the field IDs of the DepthImage node.
   */
  public interface DepthImage
  {
  }
  /**
   * An interface defining constant for the field IDs of the FFD node.
   */
  public interface FFD
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the controlPoint field = 3.
     */
    static final int controlPoint = 3;
  }
  /**
   * An interface defining constant for the field IDs of the Implicit node.
   */
  public interface Implicit
  {
    /**
     * The ID for the bboxSize field = 0.
     */
    static final int bboxSize = 0;
    /**
     * The ID for the c field = 1.
     */
    static final int c = 1;
    /**
     * The ID for the densities field = 2.
     */
    static final int densities = 2;
    /**
     * The ID for the dual field = 3.
     */
    static final int dual = 3;
    /**
     * The ID for the solid field = 4.
     */
    static final int solid = 4;
  }
  /**
   * An interface defining constant for the field IDs of the MeshGrid node.
   */
  public interface MeshGrid
  {
    /**
     * The ID for the set_colorIndex field = 0.
     */
    static final int set_colorIndex = 0;
    /**
     * The ID for the set_coordIndex field = 1.
     */
    static final int set_coordIndex = 1;
    /**
     * The ID for the set_normalIndex field = 2.
     */
    static final int set_normalIndex = 2;
    /**
     * The ID for the set_texCoordIndex field = 3.
     */
    static final int set_texCoordIndex = 3;
    /**
     * The ID for the color field = 4.
     */
    static final int color = 4;
    /**
     * The ID for the coord field = 5.
     */
    static final int coord = 5;
    /**
     * The ID for the displayLevel field = 6.
     */
    static final int displayLevel = 6;
    /**
     * The ID for the filterType field = 7.
     */
    static final int filterType = 7;
    /**
     * The ID for the gridCoord field = 8.
     */
    static final int gridCoord = 8;
    /**
     * The ID for the hierarchicalLevel field = 9.
     */
    static final int hierarchicalLevel = 9;
    /**
     * The ID for the nLevels field = 10.
     */
    static final int nLevels = 10;
    /**
     * The ID for the normal field = 11.
     */
    static final int normal = 11;
    /**
     * The ID for the nSlices field = 12.
     */
    static final int nSlices = 12;
    /**
     * The ID for the texCoord field = 13.
     */
    static final int texCoord = 13;
    /**
     * The ID for the vertexOffset field = 14.
     */
    static final int vertexOffset = 14;
    /**
     * The ID for the vertexLink field = 15.
     */
    static final int vertexLink = 15;
  }
  /**
   * An interface defining constant for the field IDs of the NonLinearDeformer node.
   */
  public interface NonLinearDeformer
  {
    /**
     * The ID for the axis field = 0.
     */
    static final int axis = 0;
    /**
     * The ID for the extend field = 1.
     */
    static final int extend = 1;
    /**
     * The ID for the geometry field = 2.
     */
    static final int geometry = 2;
    /**
     * The ID for the param field = 3.
     */
    static final int param = 3;
    /**
     * The ID for the type field = 4.
     */
    static final int type = 4;
  }
  /**
   * An interface defining constant for the field IDs of the NurbsCurve node.
   */
  public interface NurbsCurve
  {
    /**
     * The ID for the set_colorIndex field = 0.
     */
    static final int set_colorIndex = 0;
    /**
     * The ID for the color field = 1.
     */
    static final int color = 1;
    /**
     * The ID for the controlPoint field = 2.
     */
    static final int controlPoint = 2;
    /**
     * The ID for the tessellation field = 3.
     */
    static final int tessellation = 3;
  }
  /**
   * An interface defining constant for the field IDs of the NurbsCurve2D node.
   */
  public interface NurbsCurve2D
  {
    /**
     * The ID for the set_colorIndex field = 0.
     */
    static final int set_colorIndex = 0;
    /**
     * The ID for the color field = 1.
     */
    static final int color = 1;
    /**
     * The ID for the controlPoint field = 2.
     */
    static final int controlPoint = 2;
    /**
     * The ID for the tessellation field = 3.
     */
    static final int tessellation = 3;
  }
  /**
   * An interface defining constant for the field IDs of the NurbsSurface node.
   */
  public interface NurbsSurface
  {
    /**
     * The ID for the set_colorIndex field = 0.
     */
    static final int set_colorIndex = 0;
    /**
     * The ID for the set_texColorIndex field = 1.
     */
    static final int set_texColorIndex = 1;
    /**
     * The ID for the color field = 2.
     */
    static final int color = 2;
    /**
     * The ID for the controlPoint field = 3.
     */
    static final int controlPoint = 3;
    /**
     * The ID for the texCoord field = 4.
     */
    static final int texCoord = 4;
    /**
     * The ID for the uTessellation field = 5.
     */
    static final int uTessellation = 5;
    /**
     * The ID for the vTessellation field = 6.
     */
    static final int vTessellation = 6;
  }
  /**
   * An interface defining constant for the field IDs of the OctreeImage node.
   */
  public interface OctreeImage
  {
  }
  /**
   * An interface defining constant for the field IDs of the PointTexture node.
   */
  public interface PointTexture
  {
  }
  /**
   * An interface defining constant for the field IDs of the PositionAnimator node.
   */
  public interface PositionAnimator
  {
    /**
     * The ID for the set_fraction field = 0.
     */
    static final int set_fraction = 0;
    /**
     * The ID for the fromTo field = 1.
     */
    static final int fromTo = 1;
    /**
     * The ID for the key field = 2.
     */
    static final int key = 2;
    /**
     * The ID for the keyOrientation field = 3.
     */
    static final int keyOrientation = 3;
    /**
     * The ID for the keyType field = 4.
     */
    static final int keyType = 4;
    /**
     * The ID for the keySpline field = 5.
     */
    static final int keySpline = 5;
    /**
     * The ID for the keyValue field = 6.
     */
    static final int keyValue = 6;
    /**
     * The ID for the keyValueType field = 7.
     */
    static final int keyValueType = 7;
    /**
     * The ID for the offset field = 8.
     */
    static final int offset = 8;
    /**
     * The ID for the weight field = 9.
     */
    static final int weight = 9;
  }
  /**
   * An interface defining constant for the field IDs of the PositionAnimator2D node.
   */
  public interface PositionAnimator2D
  {
    /**
     * The ID for the set_fraction field = 0.
     */
    static final int set_fraction = 0;
    /**
     * The ID for the fromTo field = 1.
     */
    static final int fromTo = 1;
    /**
     * The ID for the key field = 2.
     */
    static final int key = 2;
    /**
     * The ID for the keyOrientation field = 3.
     */
    static final int keyOrientation = 3;
    /**
     * The ID for the keyType field = 4.
     */
    static final int keyType = 4;
    /**
     * The ID for the keySpline field = 5.
     */
    static final int keySpline = 5;
    /**
     * The ID for the keyValue field = 6.
     */
    static final int keyValue = 6;
    /**
     * The ID for the keyValueType field = 7.
     */
    static final int keyValueType = 7;
    /**
     * The ID for the offset field = 8.
     */
    static final int offset = 8;
    /**
     * The ID for the weight field = 9.
     */
    static final int weight = 9;
  }
  /**
   * An interface defining constant for the field IDs of the PositionInterpolator4D node.
   */
  public interface PositionInterpolator4D
  {
    /**
     * The ID for the set_fraction field = 0.
     */
    static final int set_fraction = 0;
    /**
     * The ID for the key field = 1.
     */
    static final int key = 1;
    /**
     * The ID for the keyValue field = 2.
     */
    static final int keyValue = 2;
  }
  /**
   * An interface defining constant for the field IDs of the ProceduralTexture node.
   */
  public interface ProceduralTexture
  {
    /**
     * The ID for the aSmooth field = 0.
     */
    static final int aSmooth = 0;
    /**
     * The ID for the aWarpmap field = 1.
     */
    static final int aWarpmap = 1;
    /**
     * The ID for the aWeights field = 2.
     */
    static final int aWeights = 2;
    /**
     * The ID for the bSmooth field = 3.
     */
    static final int bSmooth = 3;
    /**
     * The ID for the bWarpmap field = 4.
     */
    static final int bWarpmap = 4;
    /**
     * The ID for the bWeights field = 5.
     */
    static final int bWeights = 5;
    /**
     * The ID for the cellWidth field = 6.
     */
    static final int cellWidth = 6;
    /**
     * The ID for the cellHeight field = 7.
     */
    static final int cellHeight = 7;
    /**
     * The ID for the color field = 8.
     */
    static final int color = 8;
    /**
     * The ID for the distortion field = 9.
     */
    static final int distortion = 9;
    /**
     * The ID for the height field = 10.
     */
    static final int height = 10;
    /**
     * The ID for the roughness field = 11.
     */
    static final int roughness = 11;
    /**
     * The ID for the seed field = 12.
     */
    static final int seed = 12;
    /**
     * The ID for the type field = 13.
     */
    static final int type = 13;
    /**
     * The ID for the xSmooth field = 14.
     */
    static final int xSmooth = 14;
    /**
     * The ID for the xWarpmap field = 15.
     */
    static final int xWarpmap = 15;
    /**
     * The ID for the ySmooth field = 16.
     */
    static final int ySmooth = 16;
    /**
     * The ID for the yWarpmap field = 17.
     */
    static final int yWarpmap = 17;
    /**
     * The ID for the width field = 18.
     */
    static final int width = 18;
  }
  /**
   * An interface defining constant for the field IDs of the Quadric node.
   */
  public interface Quadric
  {
    /**
     * The ID for the bboxSize field = 0.
     */
    static final int bboxSize = 0;
    /**
     * The ID for the densities field = 1.
     */
    static final int densities = 1;
    /**
     * The ID for the dual field = 2.
     */
    static final int dual = 2;
    /**
     * The ID for the P0 field = 3.
     */
    static final int P0 = 3;
    /**
     * The ID for the P1 field = 4.
     */
    static final int P1 = 4;
    /**
     * The ID for the P2 field = 5.
     */
    static final int P2 = 5;
    /**
     * The ID for the P3 field = 6.
     */
    static final int P3 = 6;
    /**
     * The ID for the P4 field = 7.
     */
    static final int P4 = 7;
    /**
     * The ID for the P5 field = 8.
     */
    static final int P5 = 8;
    /**
     * The ID for the solid field = 9.
     */
    static final int solid = 9;
  }
  /**
   * An interface defining constant for the field IDs of the SBBone node.
   */
  public interface SBBone
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the boneID field = 2.
     */
    static final int boneID = 2;
    /**
     * The ID for the center field = 3.
     */
    static final int center = 3;
    /**
     * The ID for the children field = 4.
     */
    static final int children = 4;
    /**
     * The ID for the endpoint field = 5.
     */
    static final int endpoint = 5;
    /**
     * The ID for the falloff field = 6.
     */
    static final int falloff = 6;
    /**
     * The ID for the ikChainPosition field = 7.
     */
    static final int ikChainPosition = 7;
    /**
     * The ID for the ikPitchLimit field = 8.
     */
    static final int ikPitchLimit = 8;
    /**
     * The ID for the ikRollLimit field = 9.
     */
    static final int ikRollLimit = 9;
    /**
     * The ID for the ikTxLimit field = 10.
     */
    static final int ikTxLimit = 10;
    /**
     * The ID for the ikTyLimit field = 11.
     */
    static final int ikTyLimit = 11;
    /**
     * The ID for the ikTzLimit field = 12.
     */
    static final int ikTzLimit = 12;
    /**
     * The ID for the ikYawLimit field = 13.
     */
    static final int ikYawLimit = 13;
    /**
     * The ID for the rotation field = 14.
     */
    static final int rotation = 14;
    /**
     * The ID for the rotationOrder field = 15.
     */
    static final int rotationOrder = 15;
    /**
     * The ID for the scale field = 16.
     */
    static final int scale = 16;
    /**
     * The ID for the scaleOrientation field = 17.
     */
    static final int scaleOrientation = 17;
    /**
     * The ID for the sectionInner field = 18.
     */
    static final int sectionInner = 18;
    /**
     * The ID for the sectionOuter field = 19.
     */
    static final int sectionOuter = 19;
    /**
     * The ID for the sectionPosition field = 20.
     */
    static final int sectionPosition = 20;
    /**
     * The ID for the skinCoordIndex field = 21.
     */
    static final int skinCoordIndex = 21;
    /**
     * The ID for the skinCoordWeight field = 22.
     */
    static final int skinCoordWeight = 22;
    /**
     * The ID for the translation field = 23.
     */
    static final int translation = 23;
  }
  /**
   * An interface defining constant for the field IDs of the SBMuscle node.
   */
  public interface SBMuscle
  {
    /**
     * The ID for the falloff field = 0.
     */
    static final int falloff = 0;
    /**
     * The ID for the muscleCurve field = 1.
     */
    static final int muscleCurve = 1;
    /**
     * The ID for the muscleID field = 2.
     */
    static final int muscleID = 2;
    /**
     * The ID for the radius field = 3.
     */
    static final int radius = 3;
    /**
     * The ID for the skinCoordIndex field = 4.
     */
    static final int skinCoordIndex = 4;
    /**
     * The ID for the skinCoordWeight field = 5.
     */
    static final int skinCoordWeight = 5;
  }
  /**
   * An interface defining constant for the field IDs of the SBSegment node.
   */
  public interface SBSegment
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the centerOfMass field = 2.
     */
    static final int centerOfMass = 2;
    /**
     * The ID for the children field = 3.
     */
    static final int children = 3;
    /**
     * The ID for the mass field = 4.
     */
    static final int mass = 4;
    /**
     * The ID for the momentsOfInertia field = 5.
     */
    static final int momentsOfInertia = 5;
    /**
     * The ID for the name field = 6.
     */
    static final int name = 6;
  }
  /**
   * An interface defining constant for the field IDs of the SBSite node.
   */
  public interface SBSite
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the center field = 2.
     */
    static final int center = 2;
    /**
     * The ID for the children field = 3.
     */
    static final int children = 3;
    /**
     * The ID for the name field = 4.
     */
    static final int name = 4;
    /**
     * The ID for the rotation field = 5.
     */
    static final int rotation = 5;
    /**
     * The ID for the scale field = 6.
     */
    static final int scale = 6;
    /**
     * The ID for the scaleOrientation field = 7.
     */
    static final int scaleOrientation = 7;
    /**
     * The ID for the translation field = 8.
     */
    static final int translation = 8;
  }
  /**
   * An interface defining constant for the field IDs of the SBSkinnedModel node.
   */
  public interface SBSkinnedModel
  {
    /**
     * The ID for the bones field = 0.
     */
    static final int bones = 0;
    /**
     * The ID for the center field = 1.
     */
    static final int center = 1;
    /**
     * The ID for the muscles field = 2.
     */
    static final int muscles = 2;
    /**
     * The ID for the name field = 3.
     */
    static final int name = 3;
    /**
     * The ID for the rotation field = 4.
     */
    static final int rotation = 4;
    /**
     * The ID for the segments field = 5.
     */
    static final int segments = 5;
    /**
     * The ID for the scale field = 6.
     */
    static final int scale = 6;
    /**
     * The ID for the scaleOrientation field = 7.
     */
    static final int scaleOrientation = 7;
    /**
     * The ID for the sites field = 8.
     */
    static final int sites = 8;
    /**
     * The ID for the skeleton field = 9.
     */
    static final int skeleton = 9;
    /**
     * The ID for the skin field = 10.
     */
    static final int skin = 10;
    /**
     * The ID for the skinCoord field = 11.
     */
    static final int skinCoord = 11;
    /**
     * The ID for the skinNormal field = 12.
     */
    static final int skinNormal = 12;
    /**
     * The ID for the translation field = 13.
     */
    static final int translation = 13;
    /**
     * The ID for the weighsComputationSkinCoord field = 14.
     */
    static final int weighsComputationSkinCoord = 14;
  }
  /**
   * An interface defining constant for the field IDs of the SBVCAnimation node.
   */
  public interface SBVCAnimation
  {
    /**
     * The ID for the url field = 0.
     */
    static final int url = 0;
    /**
     * The ID for the virtualCharacters field = 1.
     */
    static final int virtualCharacters = 1;
  }
  /**
   * An interface defining constant for the field IDs of the ScalarAnimator node.
   */
  public interface ScalarAnimator
  {
    /**
     * The ID for the set_fraction field = 0.
     */
    static final int set_fraction = 0;
    /**
     * The ID for the fromTo field = 1.
     */
    static final int fromTo = 1;
    /**
     * The ID for the key field = 2.
     */
    static final int key = 2;
    /**
     * The ID for the keyType field = 3.
     */
    static final int keyType = 3;
    /**
     * The ID for the keySpline field = 4.
     */
    static final int keySpline = 4;
    /**
     * The ID for the keyValue field = 5.
     */
    static final int keyValue = 5;
    /**
     * The ID for the keyValueType field = 6.
     */
    static final int keyValueType = 6;
    /**
     * The ID for the offset field = 7.
     */
    static final int offset = 7;
    /**
     * The ID for the weight field = 8.
     */
    static final int weight = 8;
  }
  /**
   * An interface defining constant for the field IDs of the SimpleTexture node.
   */
  public interface SimpleTexture
  {
  }
  /**
   * An interface defining constant for the field IDs of the SolidRep node.
   */
  public interface SolidRep
  {
    /**
     * The ID for the bboxSize field = 0.
     */
    static final int bboxSize = 0;
    /**
     * The ID for the densityList field = 1.
     */
    static final int densityList = 1;
    /**
     * The ID for the solidTree field = 2.
     */
    static final int solidTree = 2;
  }
  /**
   * An interface defining constant for the field IDs of the SubdivisionSurface node.
   */
  public interface SubdivisionSurface
  {
    /**
     * The ID for the set_colorIndex field = 0.
     */
    static final int set_colorIndex = 0;
    /**
     * The ID for the set_coordIndex field = 1.
     */
    static final int set_coordIndex = 1;
    /**
     * The ID for the set_cornerVertexIndex field = 2.
     */
    static final int set_cornerVertexIndex = 2;
    /**
     * The ID for the set_creaseEdgeIndex field = 3.
     */
    static final int set_creaseEdgeIndex = 3;
    /**
     * The ID for the set_creaseVertexIndex field = 4.
     */
    static final int set_creaseVertexIndex = 4;
    /**
     * The ID for the set_dartVertexIndex field = 5.
     */
    static final int set_dartVertexIndex = 5;
    /**
     * The ID for the set_texCoordIndex field = 6.
     */
    static final int set_texCoordIndex = 6;
    /**
     * The ID for the color field = 7.
     */
    static final int color = 7;
    /**
     * The ID for the coord field = 8.
     */
    static final int coord = 8;
    /**
     * The ID for the texCoord field = 9.
     */
    static final int texCoord = 9;
    /**
     * The ID for the sectors field = 10.
     */
    static final int sectors = 10;
    /**
     * The ID for the subdivisionLevel field = 11.
     */
    static final int subdivisionLevel = 11;
    /**
     * The ID for the subdivisionType field = 12.
     */
    static final int subdivisionType = 12;
    /**
     * The ID for the subdivisionSubType field = 13.
     */
    static final int subdivisionSubType = 13;
  }
  /**
   * An interface defining constant for the field IDs of the SubdivSurfaceSector node.
   */
  public interface SubdivSurfaceSector
  {
    /**
     * The ID for the flatness field = 0.
     */
    static final int flatness = 0;
    /**
     * The ID for the normal field = 1.
     */
    static final int normal = 1;
    /**
     * The ID for the normalTension field = 2.
     */
    static final int normalTension = 2;
    /**
     * The ID for the tag field = 3.
     */
    static final int tag = 3;
    /**
     * The ID for the theta field = 4.
     */
    static final int theta = 4;
  }
  /**
   * An interface defining constant for the field IDs of the WaveletSubdivisionSurface node.
   */
  public interface WaveletSubdivisionSurface
  {
    /**
     * The ID for the baseMesh field = 0.
     */
    static final int baseMesh = 0;
    /**
     * The ID for the fieldOfView field = 1.
     */
    static final int fieldOfView = 1;
    /**
     * The ID for the frequency field = 2.
     */
    static final int frequency = 2;
    /**
     * The ID for the quality field = 3.
     */
    static final int quality = 3;
  }
  /**
   * An interface defining constant for the field IDs of the Clipper2D node.
   */
  public interface Clipper2D
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the geometry field = 3.
     */
    static final int geometry = 3;
    /**
     * The ID for the inside field = 4.
     */
    static final int inside = 4;
    /**
     * The ID for the transform field = 5.
     */
    static final int transform = 5;
    /**
     * The ID for the XOR field = 6.
     */
    static final int XOR = 6;
  }
  /**
   * An interface defining constant for the field IDs of the ColorTransform node.
   */
  public interface ColorTransform
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the mrr field = 3.
     */
    static final int mrr = 3;
    /**
     * The ID for the mrg field = 4.
     */
    static final int mrg = 4;
    /**
     * The ID for the mrb field = 5.
     */
    static final int mrb = 5;
    /**
     * The ID for the mra field = 6.
     */
    static final int mra = 6;
    /**
     * The ID for the tr field = 7.
     */
    static final int tr = 7;
    /**
     * The ID for the mgr field = 8.
     */
    static final int mgr = 8;
    /**
     * The ID for the mgg field = 9.
     */
    static final int mgg = 9;
    /**
     * The ID for the mgb field = 10.
     */
    static final int mgb = 10;
    /**
     * The ID for the mga field = 11.
     */
    static final int mga = 11;
    /**
     * The ID for the tg field = 12.
     */
    static final int tg = 12;
    /**
     * The ID for the mbr field = 13.
     */
    static final int mbr = 13;
    /**
     * The ID for the mbg field = 14.
     */
    static final int mbg = 14;
    /**
     * The ID for the mbb field = 15.
     */
    static final int mbb = 15;
    /**
     * The ID for the mba field = 16.
     */
    static final int mba = 16;
    /**
     * The ID for the tb field = 17.
     */
    static final int tb = 17;
    /**
     * The ID for the mar field = 18.
     */
    static final int mar = 18;
    /**
     * The ID for the mag field = 19.
     */
    static final int mag = 19;
    /**
     * The ID for the mab field = 20.
     */
    static final int mab = 20;
    /**
     * The ID for the maa field = 21.
     */
    static final int maa = 21;
    /**
     * The ID for the ta field = 22.
     */
    static final int ta = 22;
  }
  /**
   * An interface defining constant for the field IDs of the Ellipse node.
   */
  public interface Ellipse
  {
    /**
     * The ID for the radius field = 0.
     */
    static final int radius = 0;
  }
  /**
   * An interface defining constant for the field IDs of the LinearGradient node.
   */
  public interface LinearGradient
  {
    /**
     * The ID for the endPoint field = 0.
     */
    static final int endPoint = 0;
    /**
     * The ID for the key field = 1.
     */
    static final int key = 1;
    /**
     * The ID for the keyValue field = 2.
     */
    static final int keyValue = 2;
    /**
     * The ID for the opacity field = 3.
     */
    static final int opacity = 3;
    /**
     * The ID for the spreadMethod field = 4.
     */
    static final int spreadMethod = 4;
    /**
     * The ID for the startPoint field = 5.
     */
    static final int startPoint = 5;
    /**
     * The ID for the transform field = 6.
     */
    static final int transform = 6;
  }
  /**
   * An interface defining constant for the field IDs of the PathLayout node.
   */
  public interface PathLayout
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the geometry field = 3.
     */
    static final int geometry = 3;
    /**
     * The ID for the alignment field = 4.
     */
    static final int alignment = 4;
    /**
     * The ID for the pathOffset field = 5.
     */
    static final int pathOffset = 5;
    /**
     * The ID for the spacing field = 6.
     */
    static final int spacing = 6;
    /**
     * The ID for the reverseLayout field = 7.
     */
    static final int reverseLayout = 7;
    /**
     * The ID for the wrapMode field = 8.
     */
    static final int wrapMode = 8;
    /**
     * The ID for the splitText field = 9.
     */
    static final int splitText = 9;
  }
  /**
   * An interface defining constant for the field IDs of the RadialGradient node.
   */
  public interface RadialGradient
  {
    /**
     * The ID for the center field = 0.
     */
    static final int center = 0;
    /**
     * The ID for the focalPoint field = 1.
     */
    static final int focalPoint = 1;
    /**
     * The ID for the key field = 2.
     */
    static final int key = 2;
    /**
     * The ID for the keyValue field = 3.
     */
    static final int keyValue = 3;
    /**
     * The ID for the opacity field = 4.
     */
    static final int opacity = 4;
    /**
     * The ID for the radius field = 5.
     */
    static final int radius = 5;
    /**
     * The ID for the spreadMethod field = 6.
     */
    static final int spreadMethod = 6;
    /**
     * The ID for the transform field = 7.
     */
    static final int transform = 7;
  }
  /**
   * An interface defining constant for the field IDs of the SynthesizedTexture node.
   */
  public interface SynthesizedTexture
  {
    /**
     * The ID for the translation field = 0.
     */
    static final int translation = 0;
    /**
     * The ID for the rotation field = 1.
     */
    static final int rotation = 1;
    /**
     * The ID for the pixelWidth field = 2.
     */
    static final int pixelWidth = 2;
    /**
     * The ID for the pixelHeight field = 3.
     */
    static final int pixelHeight = 3;
    /**
     * The ID for the loop field = 4.
     */
    static final int loop = 4;
    /**
     * The ID for the speed field = 5.
     */
    static final int speed = 5;
    /**
     * The ID for the startTime field = 6.
     */
    static final int startTime = 6;
    /**
     * The ID for the stopTime field = 7.
     */
    static final int stopTime = 7;
    /**
     * The ID for the url field = 8.
     */
    static final int url = 8;
  }
  /**
   * An interface defining constant for the field IDs of the TransformMatrix2D node.
   */
  public interface TransformMatrix2D
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the mxx field = 3.
     */
    static final int mxx = 3;
    /**
     * The ID for the mxy field = 4.
     */
    static final int mxy = 4;
    /**
     * The ID for the tx field = 5.
     */
    static final int tx = 5;
    /**
     * The ID for the myx field = 6.
     */
    static final int myx = 6;
    /**
     * The ID for the myy field = 7.
     */
    static final int myy = 7;
    /**
     * The ID for the ty field = 8.
     */
    static final int ty = 8;
  }
  /**
   * An interface defining constant for the field IDs of the Viewport node.
   */
  public interface Viewport
  {
    /**
     * The ID for the set_bind field = 0.
     */
    static final int set_bind = 0;
    /**
     * The ID for the position field = 1.
     */
    static final int position = 1;
    /**
     * The ID for the size field = 2.
     */
    static final int size = 2;
    /**
     * The ID for the orientation field = 3.
     */
    static final int orientation = 3;
    /**
     * The ID for the alignment field = 4.
     */
    static final int alignment = 4;
    /**
     * The ID for the fit field = 5.
     */
    static final int fit = 5;
  }
  /**
   * An interface defining constant for the field IDs of the XCurve2D node.
   */
  public interface XCurve2D
  {
    /**
     * The ID for the point field = 0.
     */
    static final int point = 0;
    /**
     * The ID for the fineness field = 1.
     */
    static final int fineness = 1;
    /**
     * The ID for the type field = 2.
     */
    static final int type = 2;
  }
  /**
   * An interface defining constant for the field IDs of the XFontStyle node.
   */
  public interface XFontStyle
  {
    /**
     * The ID for the fontName field = 0.
     */
    static final int fontName = 0;
    /**
     * The ID for the horizontal field = 1.
     */
    static final int horizontal = 1;
    /**
     * The ID for the justify field = 2.
     */
    static final int justify = 2;
    /**
     * The ID for the language field = 3.
     */
    static final int language = 3;
    /**
     * The ID for the leftToRight field = 4.
     */
    static final int leftToRight = 4;
    /**
     * The ID for the size field = 5.
     */
    static final int size = 5;
    /**
     * The ID for the stretch field = 6.
     */
    static final int stretch = 6;
    /**
     * The ID for the letterSpacing field = 7.
     */
    static final int letterSpacing = 7;
    /**
     * The ID for the wordSpacing field = 8.
     */
    static final int wordSpacing = 8;
    /**
     * The ID for the weight field = 9.
     */
    static final int weight = 9;
    /**
     * The ID for the fontKerning field = 10.
     */
    static final int fontKerning = 10;
    /**
     * The ID for the style field = 11.
     */
    static final int style = 11;
    /**
     * The ID for the topToBottom field = 12.
     */
    static final int topToBottom = 12;
    /**
     * The ID for the featureName field = 13.
     */
    static final int featureName = 13;
    /**
     * The ID for the featureStartOffset field = 14.
     */
    static final int featureStartOffset = 14;
    /**
     * The ID for the featureLength field = 15.
     */
    static final int featureLength = 15;
    /**
     * The ID for the featureValue field = 16.
     */
    static final int featureValue = 16;
  }
  /**
   * An interface defining constant for the field IDs of the XLineProperties node.
   */
  public interface XLineProperties
  {
    /**
     * The ID for the lineColor field = 0.
     */
    static final int lineColor = 0;
    /**
     * The ID for the lineStyle field = 1.
     */
    static final int lineStyle = 1;
    /**
     * The ID for the isCenterAligned field = 2.
     */
    static final int isCenterAligned = 2;
    /**
     * The ID for the isScalable field = 3.
     */
    static final int isScalable = 3;
    /**
     * The ID for the lineCap field = 4.
     */
    static final int lineCap = 4;
    /**
     * The ID for the lineJoin field = 5.
     */
    static final int lineJoin = 5;
    /**
     * The ID for the miterLimit field = 6.
     */
    static final int miterLimit = 6;
    /**
     * The ID for the transparency field = 7.
     */
    static final int transparency = 7;
    /**
     * The ID for the width field = 8.
     */
    static final int width = 8;
    /**
     * The ID for the dashOffset field = 9.
     */
    static final int dashOffset = 9;
    /**
     * The ID for the dashes field = 10.
     */
    static final int dashes = 10;
    /**
     * The ID for the texture field = 11.
     */
    static final int texture = 11;
    /**
     * The ID for the textureTransform field = 12.
     */
    static final int textureTransform = 12;
  }
  /**
   * An interface defining constant for the field IDs of the AdvancedAudioBuffer node.
   */
  public interface AdvancedAudioBuffer
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the loop field = 3.
     */
    static final int loop = 3;
    /**
     * The ID for the pitch field = 4.
     */
    static final int pitch = 4;
    /**
     * The ID for the startTime field = 5.
     */
    static final int startTime = 5;
    /**
     * The ID for the stopTime field = 6.
     */
    static final int stopTime = 6;
    /**
     * The ID for the startLoadTime field = 7.
     */
    static final int startLoadTime = 7;
    /**
     * The ID for the stopLoadTime field = 8.
     */
    static final int stopLoadTime = 8;
    /**
     * The ID for the loadMode field = 9.
     */
    static final int loadMode = 9;
    /**
     * The ID for the numAccumulatedBlocks field = 10.
     */
    static final int numAccumulatedBlocks = 10;
    /**
     * The ID for the deleteBlock field = 11.
     */
    static final int deleteBlock = 11;
    /**
     * The ID for the playBlock field = 12.
     */
    static final int playBlock = 12;
    /**
     * The ID for the length field = 13.
     */
    static final int length = 13;
  }
  /**
   * An interface defining constant for the field IDs of the AudioChannelConfig node.
   */
  public interface AudioChannelConfig
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the generalChannelFormat field = 3.
     */
    static final int generalChannelFormat = 3;
    /**
     * The ID for the fixedPreset field = 4.
     */
    static final int fixedPreset = 4;
    /**
     * The ID for the fixedPresetSubset field = 5.
     */
    static final int fixedPresetSubset = 5;
    /**
     * The ID for the fixedPresetAddInf field = 6.
     */
    static final int fixedPresetAddInf = 6;
    /**
     * The ID for the channelCoordinateSystems field = 7.
     */
    static final int channelCoordinateSystems = 7;
    /**
     * The ID for the channelSoundLocation field = 8.
     */
    static final int channelSoundLocation = 8;
    /**
     * The ID for the channelDirectionalPattern field = 9.
     */
    static final int channelDirectionalPattern = 9;
    /**
     * The ID for the channelDirection field = 10.
     */
    static final int channelDirection = 10;
    /**
     * The ID for the ambResolution2D field = 11.
     */
    static final int ambResolution2D = 11;
    /**
     * The ID for the ambResolution3D field = 12.
     */
    static final int ambResolution3D = 12;
    /**
     * The ID for the ambEncodingConvention field = 13.
     */
    static final int ambEncodingConvention = 13;
    /**
     * The ID for the ambNfcReferenceDistance field = 14.
     */
    static final int ambNfcReferenceDistance = 14;
    /**
     * The ID for the ambSoundSpeed field = 15.
     */
    static final int ambSoundSpeed = 15;
    /**
     * The ID for the ambArrangementRule field = 16.
     */
    static final int ambArrangementRule = 16;
    /**
     * The ID for the ambRecombinationPreset field = 17.
     */
    static final int ambRecombinationPreset = 17;
    /**
     * The ID for the ambComponentIndex field = 18.
     */
    static final int ambComponentIndex = 18;
    /**
     * The ID for the ambBackwardMatrix field = 19.
     */
    static final int ambBackwardMatrix = 19;
    /**
     * The ID for the ambSoundfieldResolution field = 20.
     */
    static final int ambSoundfieldResolution = 20;
  }
  /**
   * An interface defining constant for the field IDs of the DepthImageV2 node.
   */
  public interface DepthImageV2
  {
  }
  /**
   * An interface defining constant for the field IDs of the MorphShape node.
   */
  public interface MorphShape
  {
    /**
     * The ID for the baseShape field = 0.
     */
    static final int baseShape = 0;
    /**
     * The ID for the morphID field = 1.
     */
    static final int morphID = 1;
    /**
     * The ID for the targetShapes field = 2.
     */
    static final int targetShapes = 2;
    /**
     * The ID for the weights field = 3.
     */
    static final int weights = 3;
  }
  /**
   * An interface defining constant for the field IDs of the MultiTexture node.
   */
  public interface MultiTexture
  {
    /**
     * The ID for the alpha field = 0.
     */
    static final int alpha = 0;
    /**
     * The ID for the color field = 1.
     */
    static final int color = 1;
    /**
     * The ID for the function field = 2.
     */
    static final int function = 2;
    /**
     * The ID for the mode field = 3.
     */
    static final int mode = 3;
    /**
     * The ID for the source field = 4.
     */
    static final int source = 4;
    /**
     * The ID for the texture field = 5.
     */
    static final int texture = 5;
    /**
     * The ID for the cameraVector field = 6.
     */
    static final int cameraVector = 6;
    /**
     * The ID for the transparent field = 7.
     */
    static final int transparent = 7;
  }
  /**
   * An interface defining constant for the field IDs of the MultiTextureCoordinate node.
   */
  public interface MultiTextureCoordinate
  {
    /**
     * The ID for the texCoord field = 0.
     */
    static final int texCoord = 0;
  }
  /**
   * An interface defining constant for the field IDs of the PointTextureV2 node.
   */
  public interface PointTextureV2
  {
  }
  /**
   * An interface defining constant for the field IDs of the SBVCAnimationV2 node.
   */
  public interface SBVCAnimationV2
  {
    /**
     * The ID for the activeUrlIndex field = 0.
     */
    static final int activeUrlIndex = 0;
    /**
     * The ID for the loop field = 1.
     */
    static final int loop = 1;
    /**
     * The ID for the speed field = 2.
     */
    static final int speed = 2;
    /**
     * The ID for the startTime field = 3.
     */
    static final int startTime = 3;
    /**
     * The ID for the stopTime field = 4.
     */
    static final int stopTime = 4;
    /**
     * The ID for the transitionTime field = 5.
     */
    static final int transitionTime = 5;
    /**
     * The ID for the url field = 6.
     */
    static final int url = 6;
    /**
     * The ID for the virtualCharacters field = 7.
     */
    static final int virtualCharacters = 7;
  }
  /**
   * An interface defining constant for the field IDs of the SimpleTextureV2 node.
   */
  public interface SimpleTextureV2
  {
  }
  /**
   * An interface defining constant for the field IDs of the SurroundingSound node.
   */
  public interface SurroundingSound
  {
    /**
     * The ID for the source field = 0.
     */
    static final int source = 0;
    /**
     * The ID for the intensity field = 1.
     */
    static final int intensity = 1;
    /**
     * The ID for the distance field = 2.
     */
    static final int distance = 2;
    /**
     * The ID for the location field = 3.
     */
    static final int location = 3;
    /**
     * The ID for the distortionFactor field = 4.
     */
    static final int distortionFactor = 4;
    /**
     * The ID for the orientation field = 5.
     */
    static final int orientation = 5;
    /**
     * The ID for the isTransformable field = 6.
     */
    static final int isTransformable = 6;
  }
  /**
   * An interface defining constant for the field IDs of the Transform3DAudio node.
   */
  public interface Transform3DAudio
  {
    /**
     * The ID for the addChildren field = 0.
     */
    static final int addChildren = 0;
    /**
     * The ID for the removeChildren field = 1.
     */
    static final int removeChildren = 1;
    /**
     * The ID for the children field = 2.
     */
    static final int children = 2;
    /**
     * The ID for the thirdCenterCoordinate field = 3.
     */
    static final int thirdCenterCoordinate = 3;
    /**
     * The ID for the rotationVector field = 4.
     */
    static final int rotationVector = 4;
    /**
     * The ID for the thirdScaleCoordinate field = 5.
     */
    static final int thirdScaleCoordinate = 5;
    /**
     * The ID for the scaleOrientationVector field = 6.
     */
    static final int scaleOrientationVector = 6;
    /**
     * The ID for the thirdTranslationCoordinate field = 7.
     */
    static final int thirdTranslationCoordinate = 7;
    /**
     * The ID for the coordinateTransform field = 8.
     */
    static final int coordinateTransform = 8;
  }
  /**
   * An interface defining constant for the field IDs of the WideSound node.
   */
  public interface WideSound
  {
    /**
     * The ID for the source field = 0.
     */
    static final int source = 0;
    /**
     * The ID for the intensity field = 1.
     */
    static final int intensity = 1;
    /**
     * The ID for the location field = 2.
     */
    static final int location = 2;
    /**
     * The ID for the spatialize field = 3.
     */
    static final int spatialize = 3;
    /**
     * The ID for the perceptualParameters field = 4.
     */
    static final int perceptualParameters = 4;
    /**
     * The ID for the roomEffect field = 5.
     */
    static final int roomEffect = 5;
    /**
     * The ID for the shape field = 6.
     */
    static final int shape = 6;
    /**
     * The ID for the size field = 7.
     */
    static final int size = 7;
    /**
     * The ID for the direction field = 8.
     */
    static final int direction = 8;
    /**
     * The ID for the density field = 9.
     */
    static final int density = 9;
    /**
     * The ID for the diffuseSelect field = 10.
     */
    static final int diffuseSelect = 10;
    /**
     * The ID for the decorrStrength field = 11.
     */
    static final int decorrStrength = 11;
  }
} // end
