package org.iso.mpeg.mpegj.scene;

/**
 * An interface defining constants for node types.
 */
public interface NodeType
{
  /**
   * Anchor node = 1.
   */
  public static final int Anchor = 1;

  /**
   * AnimationStream node = 2.
   */
  public static final int AnimationStream = 2;

  /**
   * Appearance node = 3.
   */
  public static final int Appearance = 3;

  /**
   * AudioBuffer node = 4.
   */
  public static final int AudioBuffer = 4;

  /**
   * AudioClip node = 5.
   */
  public static final int AudioClip = 5;

  /**
   * AudioDelay node = 6.
   */
  public static final int AudioDelay = 6;

  /**
   * AudioFX node = 7.
   */
  public static final int AudioFX = 7;

  /**
   * AudioMix node = 8.
   */
  public static final int AudioMix = 8;

  /**
   * AudioSource node = 9.
   */
  public static final int AudioSource = 9;

  /**
   * AudioSwitch node = 10.
   */
  public static final int AudioSwitch = 10;

  /**
   * Background node = 11.
   */
  public static final int Background = 11;

  /**
   * Background2D node = 12.
   */
  public static final int Background2D = 12;

  /**
   * Billboard node = 13.
   */
  public static final int Billboard = 13;

  /**
   * Bitmap node = 14.
   */
  public static final int Bitmap = 14;

  /**
   * Box node = 15.
   */
  public static final int Box = 15;

  /**
   * Circle node = 16.
   */
  public static final int Circle = 16;

  /**
   * Collision node = 17.
   */
  public static final int Collision = 17;

  /**
   * Color node = 18.
   */
  public static final int Color = 18;

  /**
   * ColorInterpolator node = 19.
   */
  public static final int ColorInterpolator = 19;

  /**
   * CompositeTexture2D node = 20.
   */
  public static final int CompositeTexture2D = 20;

  /**
   * CompositeTexture3D node = 21.
   */
  public static final int CompositeTexture3D = 21;

  /**
   * Conditional node = 22.
   */
  public static final int Conditional = 22;

  /**
   * Cone node = 23.
   */
  public static final int Cone = 23;

  /**
   * Coordinate node = 24.
   */
  public static final int Coordinate = 24;

  /**
   * Coordinate2D node = 25.
   */
  public static final int Coordinate2D = 25;

  /**
   * CoordinateInterpolator node = 26.
   */
  public static final int CoordinateInterpolator = 26;

  /**
   * CoordinateInterpolator2D node = 27.
   */
  public static final int CoordinateInterpolator2D = 27;

  /**
   * Curve2D node = 28.
   */
  public static final int Curve2D = 28;

  /**
   * Cylinder node = 29.
   */
  public static final int Cylinder = 29;

  /**
   * CylinderSensor node = 30.
   */
  public static final int CylinderSensor = 30;

  /**
   * DirectionalLight node = 31.
   */
  public static final int DirectionalLight = 31;

  /**
   * DiscSensor node = 32.
   */
  public static final int DiscSensor = 32;

  /**
   * ElevationGrid node = 33.
   */
  public static final int ElevationGrid = 33;

  /**
   * Expression node = 34.
   */
  public static final int Expression = 34;

  /**
   * Extrusion node = 35.
   */
  public static final int Extrusion = 35;

  /**
   * Face node = 36.
   */
  public static final int Face = 36;

  /**
   * FaceDefMesh node = 37.
   */
  public static final int FaceDefMesh = 37;

  /**
   * FaceDefTables node = 38.
   */
  public static final int FaceDefTables = 38;

  /**
   * FaceDefTransform node = 39.
   */
  public static final int FaceDefTransform = 39;

  /**
   * FAP node = 40.
   */
  public static final int FAP = 40;

  /**
   * FDP node = 41.
   */
  public static final int FDP = 41;

  /**
   * FIT node = 42.
   */
  public static final int FIT = 42;

  /**
   * Fog node = 43.
   */
  public static final int Fog = 43;

  /**
   * FontStyle node = 44.
   */
  public static final int FontStyle = 44;

  /**
   * Form node = 45.
   */
  public static final int Form = 45;

  /**
   * Group node = 46.
   */
  public static final int Group = 46;

  /**
   * ImageTexture node = 47.
   */
  public static final int ImageTexture = 47;

  /**
   * IndexedFaceSet node = 48.
   */
  public static final int IndexedFaceSet = 48;

  /**
   * IndexedFaceSet2D node = 49.
   */
  public static final int IndexedFaceSet2D = 49;

  /**
   * IndexedLineSet node = 50.
   */
  public static final int IndexedLineSet = 50;

  /**
   * IndexedLineSet2D node = 51.
   */
  public static final int IndexedLineSet2D = 51;

  /**
   * Inline node = 52.
   */
  public static final int Inline = 52;

  /**
   * LOD node = 53.
   */
  public static final int LOD = 53;

  /**
   * Layer2D node = 54.
   */
  public static final int Layer2D = 54;

  /**
   * Layer3D node = 55.
   */
  public static final int Layer3D = 55;

  /**
   * Layout node = 56.
   */
  public static final int Layout = 56;

  /**
   * LineProperties node = 57.
   */
  public static final int LineProperties = 57;

  /**
   * ListeningPoint node = 58.
   */
  public static final int ListeningPoint = 58;

  /**
   * Material node = 59.
   */
  public static final int Material = 59;

  /**
   * Material2D node = 60.
   */
  public static final int Material2D = 60;

  /**
   * MovieTexture node = 61.
   */
  public static final int MovieTexture = 61;

  /**
   * NavigationInfo node = 62.
   */
  public static final int NavigationInfo = 62;

  /**
   * Normal node = 63.
   */
  public static final int Normal = 63;

  /**
   * NormalInterpolator node = 64.
   */
  public static final int NormalInterpolator = 64;

  /**
   * OrderedGroup node = 65.
   */
  public static final int OrderedGroup = 65;

  /**
   * OrientationInterpolator node = 66.
   */
  public static final int OrientationInterpolator = 66;

  /**
   * PixelTexture node = 67.
   */
  public static final int PixelTexture = 67;

  /**
   * PlaneSensor node = 68.
   */
  public static final int PlaneSensor = 68;

  /**
   * PlaneSensor2D node = 69.
   */
  public static final int PlaneSensor2D = 69;

  /**
   * PointLight node = 70.
   */
  public static final int PointLight = 70;

  /**
   * PointSet node = 71.
   */
  public static final int PointSet = 71;

  /**
   * PointSet2D node = 72.
   */
  public static final int PointSet2D = 72;

  /**
   * PositionInterpolator node = 73.
   */
  public static final int PositionInterpolator = 73;

  /**
   * PositionInterpolator2D node = 74.
   */
  public static final int PositionInterpolator2D = 74;

  /**
   * ProximitySensor2D node = 75.
   */
  public static final int ProximitySensor2D = 75;

  /**
   * ProximitySensor node = 76.
   */
  public static final int ProximitySensor = 76;

  /**
   * QuantizationParameter node = 77.
   */
  public static final int QuantizationParameter = 77;

  /**
   * Rectangle node = 78.
   */
  public static final int Rectangle = 78;

  /**
   * ScalarInterpolator node = 79.
   */
  public static final int ScalarInterpolator = 79;

  /**
   * Script node = 80.
   */
  public static final int Script = 80;

  /**
   * Shape node = 81.
   */
  public static final int Shape = 81;

  /**
   * Sound node = 82.
   */
  public static final int Sound = 82;

  /**
   * Sound2D node = 83.
   */
  public static final int Sound2D = 83;

  /**
   * Sphere node = 84.
   */
  public static final int Sphere = 84;

  /**
   * SphereSensor node = 85.
   */
  public static final int SphereSensor = 85;

  /**
   * SpotLight node = 86.
   */
  public static final int SpotLight = 86;

  /**
   * Switch node = 87.
   */
  public static final int Switch = 87;

  /**
   * TermCap node = 88.
   */
  public static final int TermCap = 88;

  /**
   * Text node = 89.
   */
  public static final int Text = 89;

  /**
   * TextureCoordinate node = 90.
   */
  public static final int TextureCoordinate = 90;

  /**
   * TextureTransform node = 91.
   */
  public static final int TextureTransform = 91;

  /**
   * TimeSensor node = 92.
   */
  public static final int TimeSensor = 92;

  /**
   * TouchSensor node = 93.
   */
  public static final int TouchSensor = 93;

  /**
   * Transform node = 94.
   */
  public static final int Transform = 94;

  /**
   * Transform2D node = 95.
   */
  public static final int Transform2D = 95;

  /**
   * Valuator node = 96.
   */
  public static final int Valuator = 96;

  /**
   * Viewpoint node = 97.
   */
  public static final int Viewpoint = 97;

  /**
   * VisibilitySensor node = 98.
   */
  public static final int VisibilitySensor = 98;

  /**
   * Viseme node = 99.
   */
  public static final int Viseme = 99;

  /**
   * WorldInfo node = 100.
   */
  public static final int WorldInfo = 100;

  /**
   * AcousticMaterial node = 101.
   */
  public static final int AcousticMaterial = 101;

  /**
   * AcousticScene node = 102.
   */
  public static final int AcousticScene = 102;

  /**
   * ApplicationWindow node = 103.
   */
  public static final int ApplicationWindow = 103;

  /**
   * BAP node = 104.
   */
  public static final int BAP = 104;

  /**
   * BDP node = 105.
   */
  public static final int BDP = 105;

  /**
   * Body node = 106.
   */
  public static final int Body = 106;

  /**
   * BodyDefTable node = 107.
   */
  public static final int BodyDefTable = 107;

  /**
   * BodySegmentConnectionHint node = 108.
   */
  public static final int BodySegmentConnectionHint = 108;

  /**
   * DirectiveSound node = 109.
   */
  public static final int DirectiveSound = 109;

  /**
   * Hierarchical3DMesh node = 110.
   */
  public static final int Hierarchical3DMesh = 110;

  /**
   * MaterialKey node = 111.
   */
  public static final int MaterialKey = 111;

  /**
   * PerceptualParameters node = 112.
   */
  public static final int PerceptualParameters = 112;

  /**
   * TemporalTransform node = 113.
   */
  public static final int TemporalTransform = 113;

  /**
   * TemporalGroup node = 114.
   */
  public static final int TemporalGroup = 114;

  /**
   * ServerCommand node = 115.
   */
  public static final int ServerCommand = 115;

  /**
   * InputSensor node = 116.
   */
  public static final int InputSensor = 116;

  /**
   * MatteTexture node = 117.
   */
  public static final int MatteTexture = 117;

  /**
   * MediaBuffer node = 118.
   */
  public static final int MediaBuffer = 118;

  /**
   * MediaControl node = 119.
   */
  public static final int MediaControl = 119;

  /**
   * MediaSensor node = 120.
   */
  public static final int MediaSensor = 120;

  /**
   * BitWrapper node = 121.
   */
  public static final int BitWrapper = 121;

  /**
   * CoordinateInterpolator4D node = 122.
   */
  public static final int CoordinateInterpolator4D = 122;

  /**
   * DepthImage node = 123.
   */
  public static final int DepthImage = 123;

  /**
   * FFD node = 124.
   */
  public static final int FFD = 124;

  /**
   * Implicit node = 125.
   */
  public static final int Implicit = 125;

  /**
   * MeshGrid node = 126.
   */
  public static final int MeshGrid = 126;

  /**
   * NonLinearDeformer node = 127.
   */
  public static final int NonLinearDeformer = 127;

  /**
   * NurbsCurve node = 128.
   */
  public static final int NurbsCurve = 128;

  /**
   * NurbsCurve2D node = 129.
   */
  public static final int NurbsCurve2D = 129;

  /**
   * NurbsSurface node = 130.
   */
  public static final int NurbsSurface = 130;

  /**
   * OctreeImage node = 131.
   */
  public static final int OctreeImage = 131;

  /**
   * PointTexture node = 132.
   */
  public static final int PointTexture = 132;

  /**
   * PositionAnimator node = 133.
   */
  public static final int PositionAnimator = 133;

  /**
   * PositionAnimator2D node = 134.
   */
  public static final int PositionAnimator2D = 134;

  /**
   * PositionInterpolator4D node = 135.
   */
  public static final int PositionInterpolator4D = 135;

  /**
   * ProceduralTexture node = 136.
   */
  public static final int ProceduralTexture = 136;

  /**
   * Quadric node = 137.
   */
  public static final int Quadric = 137;

  /**
   * SBBone node = 138.
   */
  public static final int SBBone = 138;

  /**
   * SBMuscle node = 139.
   */
  public static final int SBMuscle = 139;

  /**
   * SBSegment node = 140.
   */
  public static final int SBSegment = 140;

  /**
   * SBSite node = 141.
   */
  public static final int SBSite = 141;

  /**
   * SBSkinnedModel node = 142.
   */
  public static final int SBSkinnedModel = 142;

  /**
   * SBVCAnimation node = 143.
   */
  public static final int SBVCAnimation = 143;

  /**
   * ScalarAnimator node = 144.
   */
  public static final int ScalarAnimator = 144;

  /**
   * SimpleTexture node = 145.
   */
  public static final int SimpleTexture = 145;

  /**
   * SolidRep node = 146.
   */
  public static final int SolidRep = 146;

  /**
   * SubdivisionSurface node = 147.
   */
  public static final int SubdivisionSurface = 147;

  /**
   * SubdivSurfaceSector node = 148.
   */
  public static final int SubdivSurfaceSector = 148;

  /**
   * WaveletSubdivisionSurface node = 149.
   */
  public static final int WaveletSubdivisionSurface = 149;

  /**
   * Clipper2D node = 150.
   */
  public static final int Clipper2D = 150;

  /**
   * ColorTransform node = 151.
   */
  public static final int ColorTransform = 151;

  /**
   * Ellipse node = 152.
   */
  public static final int Ellipse = 152;

  /**
   * LinearGradient node = 153.
   */
  public static final int LinearGradient = 153;

  /**
   * PathLayout node = 154.
   */
  public static final int PathLayout = 154;

  /**
   * RadialGradient node = 155.
   */
  public static final int RadialGradient = 155;

  /**
   * SynthesizedTexture node = 156.
   */
  public static final int SynthesizedTexture = 156;

  /**
   * TransformMatrix2D node = 157.
   */
  public static final int TransformMatrix2D = 157;

  /**
   * Viewport node = 158.
   */
  public static final int Viewport = 158;

  /**
   * XCurve2D node = 159.
   */
  public static final int XCurve2D = 159;

  /**
   * XFontStyle node = 160.
   */
  public static final int XFontStyle = 160;

  /**
   * XLineProperties node = 161.
   */
  public static final int XLineProperties = 161;

  /**
   * AdvancedAudioBuffer node = 162.
   */
  public static final int AdvancedAudioBuffer = 162;

  /**
   * AudioChannelConfig node = 163.
   */
  public static final int AudioChannelConfig = 163;

  /**
   * DepthImageV2 node = 164.
   */
  public static final int DepthImageV2 = 164;

  /**
   * MorphShape node = 165.
   */
  public static final int MorphShape = 165;

  /**
   * MultiTexture node = 166.
   */
  public static final int MultiTexture = 166;

  /**
   * MultiTextureCoordinate node = 167.
   */
  public static final int MultiTextureCoordinate = 167;

  /**
   * PointTextureV2 node = 168.
   */
  public static final int PointTextureV2 = 168;

  /**
   * SBVCAnimationV2 node = 169.
   */
  public static final int SBVCAnimationV2 = 169;

  /**
   * SimpleTextureV2 node = 170.
   */
  public static final int SimpleTextureV2 = 170;

  /**
   * SurroundingSound node = 171.
   */
  public static final int SurroundingSound = 171;

  /**
   * Transform3DAudio node = 172.
   */
  public static final int Transform3DAudio = 172;

  /**
   * WideSound node = 173.
   */
  public static final int WideSound = 173;

} // end
