/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1999.
************************************************************************/
package org.iso.mpeg.mpegj.scene;

/**
 * An interface used for obtaining SFNode values.
 */
public interface SFNodeFieldValue extends FieldValue {
    /**
     * Obtain the SFNode value. If this object was obtained
     * by the getEventOut method of the Node interface, then the return
     * value shall contain a proxy for a node in the BIFS scene. If
     * this object has been passed to the sendEventIn method of the
     * Node interface, then the return value shall contain either a proxy
     * or an object implementing the NewNode interface to specify how to
     * create a new node.
     *
     * @return a NodeValue object either acting as a proxy for a node in the BIFS scene or specifying how to create a new node.
     */
    public NodeValue getSFNodeValue();
}