
/**********************************************************************
 * Copyright (c) 2000 ISO/IEC All Rights Reserved
 *
 * This software module was developed by
 *
 * Sun Microsystems, Inc.
 *
 * in the course of development of the MPEG-4 standard. This software
 * module is an implementation of a part of one or more MPEG-4 Systems
 * (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems standard.
 *
 * The copyright of this software belongs to ISO/IEC. ISO/IEC gives
 * users of the MPEG-4 Systems (ISO/IEC 14496-1) standard free license
 * to this software module or modifications thereof for hardware
 * or software products claiming conformance to the MPEG-4 Systems.
 *
 * Those intending to use this software module in hardware or software
 * products are advised that use may infringe existing  patents. The
 * original developers of this software module and their companies, the
 * subsequent editors and their companies, and ISO/IEC have no liability
 * and ISO/IEC have no liability for use of this software module or
 * modification thereof in an implementation.
 **********************************************************************/
/*
 * File: DecoderConfigDescriptor.java
 */
/**********************************************************************
 * Copyright  2001 ISO/IEC All Rights Reserved
 *
 * This software module was developed by
 *
 * Sun Microsystems, Inc.
 *
 * in the course of development of the MPEG-4 standard. This software
 * module is an implementation of a part of one or more MPEG-4 Systems
 * (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems standard.
 *
 * The copyright of this software belongs to ISO/IEC. ISO/IEC gives
 * users of the MPEG-4 Systems (ISO/IEC 14496-1) standard free license
 * to this software module or modifications thereof for hardware
 * or software products claiming conformance to the MPEG-4 Systems.
 *
 * Those intending to use this software module in hardware or software
 * products are advised that use may infringe existing  patents. The
 * original developers of this software module and their companies, the
 * subsequent editors and their companies, and ISO/IEC have no liability
 * and ISO/IEC have no liability for use of this software module or
 * modification thereof in an implementation.
 **********************************************************************/
package org.iso.mpeg.mpegjRefImpl;
import org.iso.mpeg.mpegj.DecoderConfigDescriptor;

public class DecoderConfigDescriptorImp implements DecoderConfigDescriptor
{
    private int st;
	private int br;
	private int bs;
	private int mbr;
	private int oti;
	
	DecoderConfigDescriptorImp(int _st,int _br, int _bs, int _mbr, int _oti) 
	{
		st = _st;
		br = _br;
		bs = _bs;
		mbr = _mbr;
		oti = _oti;
	}
	/**
      * Returns the type of this elementary stream 
      * @return stream type value
      */
    public int getStreamType() 
	{
    	return st;
	}

    /**
      * Returns average bitrate in bits per second of this elementary stream
      * @return average bit rate
      */
    public int getavgBitRate()
	{
		return br;    
	}

    /**
      * Returns the size of the decoding buffer for this elementary stream in byte
      * @return size of the buffer
      */
    public int getBuffersizeDB()
	{
    	return bs;    
	}

    /**
      * Returns the maximum bitrate in bits/second of this elementary stream
      * @return maximum bitrate
      */
    public int getmaxBitrate()
	{
    	return mbr;    
	}

    /**
      * Returns the indication of the object or scene description type
      * @return value representing the object or scene description type that needs to be supported
	  * by the decoder for this elementary stream
      */
    public int getObjectTypeIndication()
	{
    	return oti;    
	}

}
