/********************************************************************
 This software module was originally developed by Roberto Becchini
 (SIA - I - SOMMIT Consortium), Barbara Silano (SIA - I - SOMMIT 
Consortium) and edited by Luca Deri (Finsiel - I - SOMMIT Consortium),
 Gianluca De Petris (CSELT - I - SOMMIT Consortium) in the course of 
development of the MPEG-4 Systems (ISO/IEC 14496-1). This software 
module is an implementation of part of one or more MPEG-4 Systems 
(ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
14496-1). ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) 
free license to this software module or modifications thereof for use 
in hardware or software products claiming conformance to the MPEG-4 
Systems (ISO/IEC 14496-1). Those intending to use this software 
module in hardware or software products are advised that its use may 
infringe existing patents. THE ORIGINAL DEVELOPER OF THIS SOFTWARE 
MODULE AND HIS/HER COMPANY, THE SUBSEQUENT EDITORS AND THEIR 
COMPANIES, AND ISO/IEC HAVE NO LIABILITY FOR USE OF THIS SOFTWARE 
MODULE OR MODIFICATIONS THEREOF. No license to this software module 
is granted for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. The SOMMIT Consortium retains full right to use the 
software module for his/her own purpose, assign or donate the 
software module to a third party and to inhibit third parties from 
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. This copyright notice must be included in all copies or 
derivative works of the software module. Copyright 1999
********************************************************************/
/*
 * File: MPRendererEventGeneratorImp.java
 * Author: Yihan Fang (fang@ee.columbia.edu)
 * Description:
 * Created: August, 1999
 */

package org.iso.mpeg.mpegjRefImpl.resource;

import java.util.*;
import org.iso.mpeg.mpegj.resource.*;

/**
 * Implementation of MPRendererEventGenerator interface
 */

public class MPRendererEventGeneratorImp implements MPRendererEventGenerator
{
	private Vector eventListeners;

	public MPRendererEventGeneratorImp () {
		eventListeners = new Vector();
	}

	public void addMPRendererMediaListener(MPRendererMediaListener l) {
		eventListeners.addElement (l);
	}

	public void removeMPRendererMediaListener(MPRendererMediaListener l) {
		eventListeners.removeElement (l);
	}

	public void dispatch (MPRendererMediaEvents e) {
		for (int i=0; i<eventListeners.size(); i++)
			((MPRendererMediaListener)eventListeners.elementAt(i)).mPCompositeMediaHandler (e);
	}
}

