/**********************************************************************
 * Copyright  1998 ISO/IEC All Rights Reserved                        
 *                                                                       
 * This software module was developed by 
 *                                                                       
 * Sun Microsystems, Inc.
 *                                                                       
 * in the course of development of the MPEG-4 standard. This software
 * module is an implementation of a part of one or more MPEG-4 Systems
 * (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems standard.
 *                                                                       
 * The copyright of this software belongs to ISO/IEC. ISO/IEC gives
 * users of the MPEG-4 Systems (ISO/IEC 14496-1) standard free license
 * to this software module or modifications thereof for hardware
 * or software products claiming conformance to the MPEG-4 Systems.
 *                                                                       
 * Those intending to use this software module in hardware or software   
 * products are advised that use may infringe existing  patents. The     
 * original developers of this software module and their companies, the  
 * subsequent editors and their companies, and ISO/IEC have no liability 
 * and ISO/IEC have no liability for use of this software module or      
 * modification thereof in an implementation.                            
 **********************************************************************/
/*
 * File: RendererImp.java
 *
 * Author: Praveen Alavilli (alavilli@cc.usu.edu)
 *
 * Description: Implementation for Renderer Interface 
 *
 * Created: March, 2000
 *
 */
package org.iso.mpeg.mpegjRefImpl.resource;
import org.iso.mpeg.mpegj.resource.*;
import java.util.*;
import java.io.*;
import org.iso.mpeg.mpegjRefImpl.MPEGJEventMulticaster;

public class RendererImp implements Renderer {
	public MPRendererMediaListener localMPRendererMediaListener = null;
	public MPRendererFrameListener localMPRendererFrameListener = null;
	public int localMPRendererFrameCount = 0;
	public int localMPRendererFrameFrequency = 0;

	public RendererImp() { 	
	} 	  

	public void addMPRendererMediaListener(MPRendererMediaListener l) {
		MPEGJEventMulticaster.add(this);    
		localMPRendererMediaListener= l ;
	}

	public void removeMPRendererMediaListener(MPRendererMediaListener l) {
		if( localMPRendererMediaListener == l ) {
			MPEGJEventMulticaster.remove(this);
			localMPRendererMediaListener = null; 
		}
	}

	public void addMPRendererFrameListener(MPRendererFrameListener l, int frames) {
		MPEGJEventMulticaster.add(this);    
		localMPRendererFrameListener= l ;
		localMPRendererFrameFrequency = frames;
		localMPRendererFrameCount = 0;
	}

	public void removeMPRendererFrameListener(MPRendererFrameListener l) {
		if( localMPRendererFrameListener == l ) {
			MPEGJEventMulticaster.remove(this);
			localMPRendererFrameListener = null; 
		}
	}
}


