/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1999.
************************************************************************/
/*
  $Id: NativeNode.java,v 1.1.1.1 2003/12/24 00:52:57 mikeseven Exp $
*/

package org.iso.mpeg.mpegjRefImpl.scene;
import org.iso.mpeg.mpegj.scene.*;
import java.util.*;

public class NativeNode extends PrivateNode implements Node, NodeValue
{
	static
	{
		//System.loadLibrary( "mpjscene" );
	}
	
	Hashtable m_listenerList = new Hashtable();  // ArrayList[eventOutID]
	
    NativeNode( int nodeID, int handle )
    {
        super( nodeID, handle );
    }
    
	NativeNode( int nodeID, NativeScene scene ) throws BadParameterException
	{
		super( nodeID, getNode( scene.getHandle(), nodeID ) );
	}
	
	int getID()
	{
		return m_id;
	}
	
	public void sendEventIn( int inID, FieldValue event )
	{
		doSendEventIn( m_handle, inID, event );
	}
	
	public FieldValue getEventOut( int outID )
	{
		return doGetEventOut( m_handle, outID );
	}
	
	public void addEventOutListener( int outID, EventOutListener listener )
	{
		doAddEventOutListener( m_handle, outID, listener );
		Vector l = (Vector) m_listenerList.get(new Integer(outID) );
		if ( l == null )
		{
		    l = new Vector();
		    m_listenerList.put( new Integer(outID), l );
		}
		l.addElement( listener );
	}

	public void removeEventOutListener( int outID, EventOutListener listener )
	{
	    Integer key = new Integer( outID );
		Vector l = (Vector) m_listenerList.get( key );
		if ( l != null )
		{
		    l.removeElement( listener );
		    if ( l.size() == 0 )
		    {
		        m_listenerList.remove( key );
		    }
		}
	}
	
    public int getNodeType()
    {
    	return doGetNodeType( m_handle );
    }
    
	public int getHandle()
	{
	    return m_handle;
	}
	
	int eventOutNotification( int eventOutID, FieldValue changedFieldValue )
	{
	    Vector listeners = (Vector) m_listenerList.get( new Integer(eventOutID) );
	    if ( listeners != null )
	    {
	        for( Enumeration i = listeners.elements(); i.hasMoreElements(); )
	        {
	            EventOutListener l = (EventOutListener) i.nextElement();
	            l.notify( eventOutID, changedFieldValue );
	        }
	    }
	    return 0;
	}
	
	native static int getNode( int sceneHandle, int nodeID );
    	
	native void doSendEventIn( int nodeHandle, int inID, FieldValue event );
	native FieldValue doGetEventOut( int nodeHandle, int outID );
	native void doAddEventOutListener( int nodeHandle, int outID, EventOutListener listener );
    native int doGetNodeType( int nodeHandle );    
}