/*******************************************************************************
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  File name   $Logfile: $
*       Last save $Date: 2003/12/24 00:52:57 $
*             $Revision: 1.1.1.1 $
*          Last $Author: mikeseven $
*  Creation Date       : 15-11-1998
*  First Author        : Bas van den Heuvel
*                        NatLab - Eindhoven
* 
*  Change history      :
*  ---------------
*
* $Log: SommitSectionFilter.java,v $
* Revision 1.1.1.1  2003/12/24 00:52:57  mikeseven
* Initial release of the CVS repository for MPEG-4 Systems code
* after the code was corrupted due to reorganization and human 
* errors.
*
* Revision 1.1  2003/04/03 04:30:08  mikeseven
* Initial release of Player3D and MPEG-J for all MPEG-4 reference softwares players with samples.
* For installation, follow instructions in docs/Player3D_setup.doc.
*
* Many thanks to Prashanth Gujjeti and Viswanathan Swaminathan from Sun Microsystems.
*
* -- Mikael Bourges-Sevenier (Mindego)
*
* Revision 1.1  2002/08/23 16:47:49  pg138550
* Changes for MPEG-J. NOT FINAL
*
* Revision 1.1  2001/01/22 05:21:58  kyong
* *** empty log message ***
*
* Revision 1.2  2000/07/21 20:35:54  alavilli
* adding missing files in the previous checkin for SISF
*
* Revision 1.1.2.1  1999/07/09 14:16:33  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.2  1999/01/26 10:29:34  depetris
* Modified Java files in order that the Bas' stuff compiles.
* Not yet tested the running of this code.
*
*
*******************************************************************************/
package sommit.sectfilt;
import  bali.support.Debug;
import  bali.support.Assert;

/****************
The class represents the section filter interface connecting
a Java application with the CSELT SOMMIT demonstrator.
Date: 19-11-1998
CSELT  : Massimo Balestri    mailto:Massimo.Balestri@cselt.it
Philips: Bas van den Heuvel  mailto:vdheuvel@natlab.research.philips.com
*/
public class SommitSectionFilter implements Runnable
{
    static 
	{
//		System.loadLibrary("c:\\mbalestri\\testjni\\debug\\testjni");//TEST
		System.loadLibrary("SectionFilterImp");//TEST
//		init();
        
        sommit.InitJavaSystem.init();
    	//DBG*/ Debug.msg(Debug.HWSF, Debug.IMPL, "SommitSF init" );
	}
	
	/********** SIA */ 
	private static Thread sectionFilterThread = null;

   private
    static int indexP;
    static int idP;
    static SommitSfInterface lP;
    static int PIDP;
    static byte[] posMaskP;
    static byte[] posValueP;
    static byte[] negMaskP;
    static byte[] negValueP;
	/**************
    The sections filtering will be performed by a separate thread in order to do not 
    block the whole filtering process if the native filtering blocks
    */
	public void run() {
        
        startFilterNat(indexP, 
					   idP,
					   lP,
					   PIDP,
					   posMaskP,
					   posValueP,
                       negMaskP,
                       negValueP);
    }
    /********** End SIA */
    
	/**************
    Return the number of section filters available to Java.
    */
    public final static int getNumberOfFilters()
    {
    	System.out.println("BB: In SommitSectionFilter");
    	System.out.println("BB: err output werkt wel");
    	return 1;
    }
    
    private native final static void startFilterNat
		( int index
        , int id
        , SommitSfInterface l
        , int PID
        , byte[] posMask
        , byte[] posValue
        , byte[] negMask
        , byte[] negValue
        );

    /**************
    Start a filter action on the indicated filter.
    A section filter is set using a mask and value for negative and positive
    filtering. The following algorithm is to be used:
    A section fits the filter parameters when:
      sec : array of unsigned bytes representing this section. sec[0] is the table_id
            field
      mask and value arrays: array of unsigned bytes with a length 12.
      LL = MIN( 12, sec.length )
      (Ai : 0<=i<LL: (  posMask[i]&posValue[i] == posMask[i]&sec[i]
                     && negMask[i]&negValue[i] != negMask[i]&sec[i]
                     ))
    @param index  The index of the section filter to be started. When the section
                  filter is already active it will stop and restart using this
                  section filter parameters.
    @param id     An identifier provided by the application that identifies this
                  filter action (session id).
    @param l      The class that will receive the sections filtered on this filter
                  session.
    @param PID    The PID to filter upon.
    @param posMask  The mask used for positive filtering.
    @param posValue The value used for positive filtering.
    @param negMask  The mask used for negative filtering, unless null.
    @param negValue The value used for negative filtering, unless null.
    */
    public final static void startFilter
        ( int index
        , int id
        , SommitSfInterface l
        , int PID
        , byte[] posMask
        , byte[] posValue
        , byte[] negMask
        , byte[] negValue
        )
    { 
    	System.out.println("BB: In the correct startFilter method");   
	//DBG*/ Debug.msg(Debug.HWSF, Debug.IMPL, "SommitSF.startSectionFilter pos&neg" );
		startFilterNat(index, 
					   id,
					   l,
					   PID,
					   posMask,
					   posValue,
					   negMask,
					   negValue);		
    }


    /**************
    Start a filter action on the indicated filter.
    A section filter is set using a mask and value for positive
    filtering. The following algorithm is to be used:
    A section fits the filter parameters when:
      sec : array of unsigned bytes representing this section. sec[0] is the table_id
            field
      mask and value arrays: array of unsigned bytes with a length 12.
      LL = MIN( 12, sec.length )
      (Ai : 0<=i<LL: (  posMask[i]&posValue[i] == posMask[i]&sec[i]
                     ))
    @param index  The index of the section filter to be started. When the section
                  filter is already active it will stop and restart using this
                  section filter parameters.
    @param id     An identifier provided by the application that identifies this
                  filter action (session id).
    @param l      The class that will receive the sections filtered on this filter
                  session.
    @param PID    The PID to filter upon.
    @param posMask  The mask used for positive filtering.
    @param posValue The value used for positive filtering.
    */
    public final static void startFilter
        ( int index
        , int id
        , SommitSfInterface l
        , int PID
        , byte[] posMask
        , byte[] posValue
        )
    {    
        
    byte[] byte1 = new byte[1]; //dummy values
    byte[] byte2 = new byte[1];
    System.out.println("BB: Wrong startFilter method");
	//DBG*/ Debug.msg(Debug.HWSF, Debug.IMPL, "SommitSF.startSectionFilter pos only" );
	//DBG*/ Debug.msg(Debug.HWSF, Debug.IMPL, "SommitSF.startSectionFilter Index: " + Integer.toString(index));
	//DBG*/ Debug.msg(Debug.HWSF, Debug.IMPL, "SommitSF.startSectionFilter id: " + Integer.toString(id));
	//DBG*/ Debug.msg(Debug.HWSF, Debug.IMPL, "SommitSF.startSectionFilter PID: " + Integer.toString(PID));
		
	if(l!= null)
	//DBG*/ Debug.msg(Debug.HWSF, Debug.IMPL, "SommitSF.startSectionFilter SOMMIT interface ok");
/*	
	ThreadSectionFilter SfThread = new ThreadSectionFilter(
	                   this,
	                   index, 
					   id,
					   l,
					   PID,
					   posMask,
					   posValue,
					   byte1,
					   byte2);
    SfThread.start();
*/	
    indexP = index;
    idP = id;
    lP = l;
    PIDP = PID;
    posMaskP = posMask;
    posValueP = posValue;
    negMaskP = null;
    negValueP = null;
    sectionFilterThread = new Thread(new SommitSectionFilter(), "SommitSectionFilter");
    sectionFilterThread.start();
    			   
/* 	startFilterNat(index, 
					   id,
					   l,
					   PID,
					   posMask,
					   posValue,
					   byte1,
					   byte2);
*/
	//DBG*/ Debug.msg(Debug.HWSF, Debug.IMPL, "SommitSF.startSectionFilter PASSED");
    }



	private native final static void stopFilterNat(int index);
    /**************
    Stop the section filter indicated with index.
    */
    public final static void stopFilter( int index )
    {
    	System.out.println("BB: stopFilter entered");
		stopFilterNat(index);
    }
   
    private native final static void newSectionNat(int PID, byte[] sec);

   /**
    A new section is present in the TS, check if it fits any of the filters
   */
    static public void newSection( int PID, byte[] sec )
    {
    	System.out.println("BB: newSection entered");
		newSectionNat(PID, sec);
    }
    
}