/*
This software module was originally developed by Five Bats Research
in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Five Bats Research retains full right
to use the code for its purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1999.
*/
#ifndef INCLUDED_FIELDVALUEMAKER_H
#define INCLUDED_FIELDVALUEMAKER_H

#include "../../mpegj-player/MPJSceneInterface.h"
#include "jni.h"


// To prevent multiple inclusion.. Need to clear this up
#ifndef MPJException_DEFINED
#define MPJException_DEFINED
class MPJException
{
public:
	MPJException( int error ) : m_err(error){}
	int getErrorCode() const { return m_err; }
private:
	int m_err;
};
#endif

class FieldValueMaker
{
	public:
		static int setFieldValue( JNIEnv *env, jobject val, FieldValuePtr f );
		static jobject asJavaFieldValue( JNIEnv *env, FieldValuePtr val );
		static void freeFieldValueContent( FieldValuePtr val );
	private:
		static void setTableFor( JNIEnv *env, int idx, const char *fieldType );
		void setFields( JNIEnv *env );
		int doSetFieldValue( JNIEnv *env, jobject val, FieldValuePtr f );
		FieldValueMaker( JNIEnv *env );
		int getFieldValueType( JNIEnv *env, jobject val );

		static jclass s_classTypes[ MPJ_FIELDVALUE_TYPE_COUNT ];
		static jclass s_SFFields[ MPJ_FIELDVALUE_TYPE_COUNT ];
		static jclass s_MFFields[ MPJ_FIELDVALUE_TYPE_COUNT ];
		static char* s_MFFieldValueClassNames[ MPJ_FIELDVALUE_TYPE_COUNT ];
		static FieldValueMaker* s_self;
};

#endif
