 /****************************************************************
 This software module is an implementation of part of one or more 
 MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 
 Systems (ISO/IEC 14496-1). ISO/IEC gives users of the MPEG-4 
 Systems (ISO/IEC 14496-1) free license to this software module or
 modifications thereof for use in hardware or software products 
 claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
 Those intending to use this software module in hardware or software 
 products are advised that its use may infringe existing patents. 
 THE ORIGINAL DEVELOPER OF THIS SOFTWARE MODULE AND HIS/HER COMPANY,
 THE SUBSEQUENT EDITORS AND THEIR COMPANIES, AND ISO/IEC HAVE NO 
 LIABILITY FOR USE OF THIS SOFTWARE MODULE OR MODIFICATIONS THEREOF. 
*******************************************************************/

#include "org_iso_mpeg_mpegj_MpegjTerminal.h"
#include "../../mpegj-player/MPEGJTerminalInterface.h"



static long instanceCount = 0L;
static MPJTerminalDispatchTablePtr dispatch = 0;

MPJ_EXTERN( long ) CreateInstance()
{
	return ++instanceCount;
}

MPJ_EXTERN( MPJTerminalDispatchTablePtr )
MPJGetTerminalDispatchTable()
{
	return dispatch;
}

MPJ_EXTERN( void )
MPJSetTerminalDispatchTable( MPJTerminalDispatchTablePtr table )
{
	dispatch = table;
	// if you have any functions to be called from the
	// player, add the address of these to this table
	// before returning. (none used here -- yet) all the callbacks that player side would call
}

JNIEXPORT jint JNICALL Java_org_iso_mpeg_terminal_MPJTerminalImp_callExampleFunction
  (JNIEnv *, jobject)
{
	int ret = -1;
	MPJTerminalDispatchTablePtr d = MPJGetTerminalDispatchTable();
	if ( d && (d->examplePlayerCall) )
		ret = (int) d->examplePlayerCall();
	return ret;
}
