 /****************************************************************
 This software module is an implementation of part of one or more 
 MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 
 Systems (ISO/IEC 14496-1). ISO/IEC gives users of the MPEG-4 
 Systems (ISO/IEC 14496-1) free license to this software module or
 modifications thereof for use in hardware or software products 
 claiming conformance to the MPEG-4 Systems (ISO/IEC 14496-1). 
 Those intending to use this software module in hardware or software 
 products are advised that its use may infringe existing patents. 
 THE ORIGINAL DEVELOPER OF THIS SOFTWARE MODULE AND HIS/HER COMPANY,
 THE SUBSEQUENT EDITORS AND THEIR COMPANIES, AND ISO/IEC HAVE NO 
 LIABILITY FOR USE OF THIS SOFTWARE MODULE OR MODIFICATIONS THEREOF. 
*******************************************************************/
/*-------------------------------------------------------------------------
MPEGJ 
AUTHORS:    Viswanathan Swaminathan - vishy@eng.sun.com 
			Robert Schmidt(RLS)
			Praveen Alavilli(PA) 
			YUNTAI KYONG(YT) - yuntaikyong@ieee.org
-------------------------------------------------------------------------*/

#include "org_iso_mpeg_mpegj_resource_ResourceManager.h"
#include "../../mpegj-player/ResourceManagerInterface.h"
static long instanceCount = 0L;
static MPJResourceManagerDispatchTablePtr dispatch = 0;

MPJ_EXTERN( long ) CreateInstance()
{
	return ++instanceCount;
}

MPJ_EXTERN( MPJResourceManagerDispatchTablePtr )
MPJGetResourceManagerDispatchTable()
{
	return dispatch;
}

MPJ_EXTERN( void )
MPJSetResourceManagerDispatchTable( MPJResourceManagerDispatchTablePtr table )
{
	dispatch = table;
	// if you have any functions to be called from the
	// player, add the address of these to this table
	// before returning. (none used here -- yet) all the callbacks that player side would call
}

/*
 * Class:     org_iso_mpeg_mpegj_resourceManager_ResourceManager
 * Method:    getESIDOnNode
 */
JNIEXPORT jint JNICALL Java_org_iso_mpeg_mpegj_resource_ResourceManager_getESIDOnNode
  (JNIEnv *, jobject, jint nodeID)
{
	int ESID;
	MPJResourceManagerDispatchTablePtr d = MPJGetResourceManagerDispatchTable();
	if (d && (d->getESID) )
		ESID = d->getESID(nodeID);

	return ESID;
}
//*** YT START (149)
/*
 * Class:     org_iso_mpeg_mpegj_resource_ResourceManager
 * Method:    changeDecoder
 * Signature: (JJJ)I
 */
JNIEXPORT jint JNICALL Java_org_iso_mpeg_mpegj_resource_ResourceManager_changeDecoder
  (JNIEnv *, jobject, jlong odid, jlong esid, jlong oldesid)
{
	MPJResourceManagerDispatchTablePtr d = MPJGetResourceManagerDispatchTable();
	if(d && d->changeDecoder)
		return d->changeDecoder((long)odid,(long)esid,(long)oldesid);
	return 0;
}

/*
 * Class:     org_iso_mpeg_mpegj_resource_ResourceManager
 * Method:    checkODID
 * Signature: (J)I
 */
JNIEXPORT jint JNICALL Java_org_iso_mpeg_mpegj_resource_ResourceManager_checkODID
  (JNIEnv *, jobject, jlong odid)
{
	MPJResourceManagerDispatchTablePtr d = MPJGetResourceManagerDispatchTable();
	if(d && d->checkODID)
		return d->checkODID((long)odid);
	return 0;
}


/*
 * Class:     org_iso_mpeg_mpegj_resource_ResourceManager
 * Method:    checkESID
 * Signature: (J)I
 */
JNIEXPORT jint JNICALL Java_org_iso_mpeg_mpegj_resource_ResourceManager_checkESID
  (JNIEnv *, jobject, jlong esid)
{
	MPJResourceManagerDispatchTablePtr d = MPJGetResourceManagerDispatchTable();
	if(d && d->checkESID)
		return d->checkESID((long)esid);
	return 0;
}

//*** YT END (149)
