// ScriptInterface.cpp //AC
//<alexandre.cotarmanac-h@polytechnique.org>
//$Log: ScriptInterface.cpp,v $
//Revision 1.1.1.1  2003/12/24 00:56:30  mikeseven
//Initial release of the CVS repository for MPEG-4 Systems code
//after the code was corrupted due to reorganization and human 
//errors.
//
//Revision 1.1.1.2  2003/01/30 16:28:33  payan
//no message
//
//Revision 1.1.1.1  2002/07/18 01:08:34  mikeseven
//Initial check in of July 17, 2002 version
//
/*class ScriptInterface : Proto
{
public:
	ScriptInterface(): Proto() {};
	const BifsFieldTable *GetFieldTable () const {return m_fieldTable;}
private:
	ZString m_scriptName;
	ZArray<BifsFieldTable> m_fieldTable;
}
*/
#include "defs.h"
#include "NodeFld.h"
#include "VSNodeField.h"
#include "ScriptInterface.h"


bool ScriptInterface::StoreScriptDefinition(ZArray<VSNodeField *> & eventArray)
{
	VSNodeField * event=NULL;
	for (int i=0; i<eventArray.GetLength(); i++)
	{
		event=eventArray[i];
		CreateInterface(event->getEventType(),
			event->getType(),
			event->GetName());

	}
	//AC :store the "always-defined" fields"
	//just in case there's a Route to url I suppose.
	//Nota: eUNKNOWN_TYPE stands for exposedfield here
	CreateInterface(eFIELD,SFBOOL,"directOutput");
	CreateInterface(eFIELD,SFBOOL,"mustEvaluate");
	CreateInterface(eUNKNOWN_TYPE,MFSTRING,"url");//MFSCRIPT
	m_bifsBounds.CalculateBounds();
	return true;
}

NodeField *ScriptInterface::CreateInterface(
	int eventType,
	int fieldType,
	LPCSTR szName
)
{
	/*-------------------------------------------------------------
	Add an entry to the BifsFieldTable
	-------------------------------------------------------------*/
	int nOffset = m_fieldTable.GetLength ();
	BifsFieldTable &rEntry = ++m_fieldTable;
	rEntry.m_AnimationType = -1;
	rEntry.m_bChildren = false;
	rEntry.m_dynID = -1;
	rEntry.m_defID = rEntry.m_inID = rEntry.m_outID = -1;
	rEntry.m_fMax [0] = FLT_MAX;
	rEntry.m_fMin [0] = -FLT_MAX;
	rEntry.m_function = NULL;
	rEntry.m_nDimension = 0;
	rEntry.m_nQuantizationType = -1;
	rEntry.m_offset = -nOffset;
	rEntry.m_quantParams = -1;
	if (szName != NULL)
		rEntry.m_szName = m_fieldNames += szName;

	/*-------------------------------------------------------------
	Increment counter in the BifsBounds structure
	-------------------------------------------------------------*/
	m_bifsBounds.m_nTotalAll++;
	switch (eventType) {
	case eFIELD:
		rEntry.m_defID = m_bifsBounds.m_nTotalDefs++; 
//		TRACEF ("field\t\t\t", 0);
		break;
	case eUNKNOWN_TYPE: //exposed field 
		rEntry.m_defID = m_bifsBounds.m_nTotalDefs++; 
		rEntry.m_inID = m_bifsBounds.m_nTotalIns++;
		rEntry.m_outID = m_bifsBounds.m_nTotalOuts++;
//		TRACEF ("exposedField\t", 0);
		break;
	case eEVENTIN: 
		rEntry.m_inID = m_bifsBounds.m_nTotalIns++;
//		TRACEF ("eventIn\t\t\t", 0);
		break;
	case eEVENTOUT:
		rEntry.m_outID = m_bifsBounds.m_nTotalOuts++;
//		TRACEF ("eventOut\t\t", 0);
		break;
	}

	/*-------------------------------------------------------------
	Instantiate the proper field object and add it to the list
	-------------------------------------------------------------*/
	NodeField *pField = NULL;


	switch (fieldType) {
	case SFBOOL: 
		pField = new SFBool;
//			TRACEF ("SFBool\t", 0);
		break;
	case SFFLOAT: 
		pField = new SF<float>;
//			TRACEF ("SFFloat\t", 0);
		break;
	case SFTIME:
		pField = new SF<Time>;
//			TRACEF ("SFTime\t", 0);
		break;
	case SFINT32: 
		pField = new SF<int>;
//			TRACEF ("SFInt32\t", 0);
		break;
	case SFSTRING: 
		pField = new SFString;
//			TRACEF ("SFString", 0);
		break;
	case SFVEC3F:
		pField = new SF<Vec3f>;
//			TRACEF ("SFVec3f\t", 0);
		break;
	case SFVEC2F:
		pField = new SF<Vec2f>;
//			TRACEF ("SFVec2f\t", 0);
		break;
	case SFCOLOR: 
		pField = new SF<Color3f>;
//			TRACEF ("SFColor\t", 0);
		break;
	case SFROTATION:
		pField = new SF<Rotation>;
//			TRACEF ("SFRotation", 0);
		break;
	case SFIMAGE:
		pField = new SF<Image>;
//			TRACEF ("SFImage\t", 0);
		break;
	case SFNODE:
		pField = new SFWorldNode;
//			TRACEF ("SFNode\t", 0);
		break;

	case MFBOOL: 
		pField = new MF<Bool>;
//			TRACEF ("MFBool\t", 0);
		break;
	case MFFLOAT: 
		pField = new MF<float>;
//			TRACEF ("MFFloat\t", 0);
		break;
	case MFTIME:
		pField = new MF<Time>;
//			TRACEF ("MFTime\t", 0);
		break;
	case MFINT32: 
		pField = new MF<int>;
//			TRACEF ("MFInt32\t", 0);
		break;
	case MFSTRING: 
		pField = new MF<ZString>;
//			TRACEF ("MFString", 0);
		break;
	case MFVEC3F:
		pField = new MF<Vec3f>;
//			TRACEF ("MFVec3f\t", 0);
		break;
	case MFVEC2F:
		pField = new MF<Vec2f>;
//			TRACEF ("MFVec2f\t", 0);
		break;
	case MFCOLOR: 
		pField = new MF<Color3f>;
		break;
	case MFROTATION:
		pField = new MF<Rotation>;
//			TRACEF ("MFRotation", 0);
		break;
	case MFIMAGE:
		pField = new MF<Image>;
//			TRACEF ("MFImage\t", 0);
		break;
	case MFNODE:
		pField = new MFWorldNode;
//			TRACE ("MFNode\t", 0);
		break;
	default:
		return NULL;
	}

	m_fields += pField;
	return pField;
}
