// This software module was originally developed by Wei Wu(Rockwell Science
// Center) and Wenlong Dong(Rockwell Science Center) in the course of 
// development of the MPEG-4 Systems standard
// (ISO/IEC 14496-1).  This software module is an implementation of a part
// of one or more MPEG-4 Systems tools as specified by the MPEG-4 Systems
// standard.  ISO/IEC gives users of the MPEG-4 Systems standard free
// license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// For more information or to receive an up to date version of this module,
// you may call Wei Wu at weiwu@jupiter.risc.rockwell.com or Wenlong Dong 
// at wdong@usc.edu.
//
// Copyright 1998.

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:	Script Node
FILE: 	   StrBuffer.h
AUTHOR:    Wei Wu       (Rockwell Science Center)
		   Wenlong Dong (Rockwell Science Center)
		   Yuval Fisher (Rockwell Science Center)
OVERVIEW:  Interface of CStrBuffer class
----------------------------------------------------------------------*/
#ifndef _StrBuffer_h_
#define _StrBuffer_h_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "defs.h"

#define DEF_BUF_SIZE	100
#define BUF_SIZE_INC	10

class CStrBuffer
{
public:
	CStrBuffer();
	~CStrBuffer();
	char * operator[] (int);
	void insert(LPCSTR str);
	LPCSTR getStr();
	void reset() {m_curPos=0, m_headPos=0;}
	int getPos() {return m_curPos;}
	void print();
	int hasStr(LPCSTR str);
private:

	char **m_buf;
	int m_size;
	int m_curPos, m_headPos;
};

int calNbits(int val);

#endif // _StrBuffer_h_
