/***********************************************************************
    This software module  was  originally  developed by Zvi  Lifshitz
    (Triton R&D Ltd.) and  Mikael Bourges-Sevenier (France Telecom CNET)
    in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
    standard.  This software module is an implementation of a part of
    one or more MPEG-4 Systems (ISO/IEC 14496-1) tools  as  specified
    by  the  MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC gives
    users of the MPEG-4 Systems (ISO/IEC 14496-1)  free  license  to
    this software module or modifications thereof for use in hardware
    or software products claiming conformance to the  MPEG-4  Systems
    (ISO/IEC 14496-1). Those intending to use this software module in
    hardware or software  products  are  advised  that  its  use  may
    infringe   existing  patents.  The  original  developer  of  this
    software module and his/her company, the subsequent  editors  and
    their  companies,  and  ISO/IEC have no liability for use of this
    software module or modifications thereof  in  an  implementation.
    Copyright  is not released for non MPEG-4 Systems (ISO/IEC 14496-
    1) conforming  products.  Triton R&D Ltd. and France  Telecom  CNET
    retain  full  right to use the code for their own purpose, assign
    or donate the code to a third party and to inhibit third  parties
    from  using  the  code  for  non MPEG-4 Systems (ISO/IEC 14496-1)
    conforming products. This copyright notice must  be  included  in
    all copies or derivative works. Copyright  1997.
************************************************************************/

/**************************************************************************
 * Project Im1Player
 * INTERNATIONAL STANDARD ORGANIZATION
 * ISO/IEC JTC1/SC29/WG11
 * 
 * SUBSYSTEM: BIFS Encoder/Decoder
 * FILE:      Nodes.cpp
 * AUTHOR:    Mikael Bourges-Sevenier (Mindego Inc.)
 * OVERVIEW:  BIFS macros for node objects.
 * 
 * Comment:   Automatically generated on Fri Apr 07 09:16:02 PDT 2006
 *            by parsing the MPEG-4 node templates files.
 *            Contact: mikael@mindego.com
 *
 **************************************************************************/
#include "defs.h"
#include "Im1defs.h"
#include "NodeCode.h"
#include "Nodes.h"
#include "CrNodes.h"

//	SOLARIS PORTING - Added the following
// ML - added the next include line
#ifdef BIFSDEC
#ifdef PLAYER3D
#include "Presenter.h"
#endif
#endif

/* Currently, we have 183 nodes defined. */

BIFS_IMPLEMENT_NODE_START(Anchor)
    BIFS_EVENT(Anchor, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(Anchor, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(Anchor, children, 0, 2, 0, -1)
    BIFS_FIELD(Anchor, description, 1, 3, 1, -1, 0, 0)
    BIFS_FIELD(Anchor, parameter, 2, 4, 2, -1, 0, 0)
    BIFS_FIELD(Anchor, url, 3, 5, 3, -1, 0, 0)
    BIFS_EVENT(Anchor, activate, 6, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Anchor)

BIFS_IMPLEMENT_NODE_START(AnimationStream)
    BIFS_FIELD(AnimationStream, loop, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD1(AnimationStream, speed, 1, 1, 1, 0, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(AnimationStream, startTime, 2, 2, 2, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(AnimationStream, stopTime, 3, 3, 3, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(AnimationStream, url, 4, 4, 4, -1, 0, 0)
    BIFS_FIELD(AnimationStream, duration_changed, -1, -1, 5, -1, 0, 0)
    BIFS_FIELD(AnimationStream, isActive, -1, -1, 6, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(AnimationStream)

BIFS_IMPLEMENT_NODE_START(Appearance)
    BIFS_FIELD(Appearance, material, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(Appearance, texture, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD(Appearance, textureTransform, 2, 2, 2, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Appearance)

BIFS_IMPLEMENT_NODE_START(AudioBuffer)
    BIFS_FIELD(AudioBuffer, loop, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD1(AudioBuffer, pitch, 1, 1, 1, 0, 0, 7, 0, FLT_MAX)
    BIFS_FIELD1(AudioBuffer, startTime, 2, 2, 2, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD1(AudioBuffer, stopTime, 3, 3, 3, -1, 0, 0, 0, FLT_MAX)
    BIFS_CHILDREN(AudioBuffer, children, 4, 4, 4, -1)
    BIFS_FIELD1_SQ(AudioBuffer, numChan, 5, 5, 5, -1, 13, 8, 0, 0, 255)
    BIFS_FIELD(AudioBuffer, phaseGroup, 6, 6, 6, -1, 0, 0)
    BIFS_FIELD1(AudioBuffer, length, 7, 7, 7, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD(AudioBuffer, duration_changed, -1, -1, 8, -1, 0, 0)
    BIFS_FIELD(AudioBuffer, isActive, -1, -1, 9, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(AudioBuffer)

BIFS_IMPLEMENT_NODE_START(AudioClip)
    BIFS_FIELD(AudioClip, description, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(AudioClip, loop, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD1(AudioClip, pitch, 2, 2, 2, 0, 0, 7, 0, FLT_MAX)
    BIFS_FIELD1(AudioClip, startTime, 3, 3, 3, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(AudioClip, stopTime, 4, 4, 4, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(AudioClip, url, 5, 5, 5, -1, 0, 0)
    BIFS_FIELD(AudioClip, duration_changed, -1, -1, 6, -1, 0, 0)
    BIFS_FIELD(AudioClip, isActive, -1, -1, 7, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(AudioClip)

BIFS_IMPLEMENT_NODE_START(AudioDelay)
    BIFS_EVENT(AudioDelay, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(AudioDelay, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(AudioDelay, children, 0, 2, 0, -1)
    BIFS_FIELD1(AudioDelay, delay, 1, 3, 1, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD1_SQ(AudioDelay, numChan, 2, -1, -1, -1, 13, 8, 0, 0, 255)
    BIFS_FIELD1_SQ(AudioDelay, phaseGroup, 3, -1, -1, -1, 13, 8, 0, 0, 255)
BIFS_IMPLEMENT_NODE_END(AudioDelay)

BIFS_IMPLEMENT_NODE_START(AudioFX)
    BIFS_EVENT(AudioFX, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(AudioFX, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(AudioFX, children, 0, 2, 0, -1)
    BIFS_FIELD(AudioFX, orch, 1, 3, 1, -1, 0, 0)
    BIFS_FIELD(AudioFX, score, 2, 4, 2, -1, 0, 0)
    BIFS_FIELD1(AudioFX, params, 3, 5, 3, 0, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1_SQ(AudioFX, numChan, 4, -1, -1, -1, 13, 8, 0, 0, 255)
    BIFS_FIELD1_SQ(AudioFX, phaseGroup, 5, -1, -1, -1, 13, 8, 0, 0, 255)
BIFS_IMPLEMENT_NODE_END(AudioFX)

BIFS_IMPLEMENT_NODE_START(AudioMix)
    BIFS_EVENT(AudioMix, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(AudioMix, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(AudioMix, children, 0, 2, 0, -1)
    BIFS_FIELD1_SQ(AudioMix, numInputs, 1, 3, 1, -1, 13, 8, 0, 1, 255)
    BIFS_FIELD1(AudioMix, matrix, 2, 4, 2, 0, 0, 7, 0, 1)
    BIFS_FIELD1_SQ(AudioMix, numChan, 3, -1, -1, -1, 13, 8, 0, 0, 255)
    BIFS_FIELD1_SQ(AudioMix, phaseGroup, 4, -1, -1, -1, 13, 8, 0, 0, 255)
BIFS_IMPLEMENT_NODE_END(AudioMix)

BIFS_IMPLEMENT_NODE_START(AudioSource)
    BIFS_EVENT(AudioSource, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(AudioSource, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(AudioSource, children, 0, 2, 0, -1)
    BIFS_FIELD(AudioSource, url, 1, 3, 1, -1, 0, 0)
    BIFS_FIELD1(AudioSource, pitch, 2, 4, 2, 0, 0, 7, 0, FLT_MAX)
    BIFS_FIELD1(AudioSource, speed, 3, 5, 3, 1, 0, 7, 0, FLT_MAX)
    BIFS_FIELD(AudioSource, startTime, 4, 6, 4, -1, 0, 0)
    BIFS_FIELD(AudioSource, stopTime, 5, 7, 5, -1, 0, 0)
    BIFS_FIELD1_SQ(AudioSource, numChan, 6, -1, -1, -1, 13, 8, 0, 0, 255)
    BIFS_FIELD1_SQ(AudioSource, phaseGroup, 7, -1, -1, -1, 13, 8, 0, 0, 255)
BIFS_IMPLEMENT_NODE_END(AudioSource)

BIFS_IMPLEMENT_NODE_START(AudioSwitch)
    BIFS_EVENT(AudioSwitch, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(AudioSwitch, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(AudioSwitch, children, 0, 2, 0, -1)
    BIFS_FIELD1_SQ(AudioSwitch, whichChoice, 1, 3, 1, -1, 13, 1, 0, 0, 1)
    BIFS_FIELD1_SQ(AudioSwitch, numChan, 2, -1, -1, -1, 13, 8, 0, 0, 255)
    BIFS_FIELD1_SQ(AudioSwitch, phaseGroup, 3, -1, -1, -1, 13, 8, 0, 0, 255)
BIFS_IMPLEMENT_NODE_END(AudioSwitch)

BIFS_IMPLEMENT_NODE_START(Background)
    BIFS_EVENT(Background, set_bind, 0, -1, 0, 0)
    BIFS_FIELD1(Background, groundAngle, 0, 1, 0, 0, 6, 8, 0, 1.5707963)
    BIFS_FIELD1(Background, groundColor, 1, 2, 1, 1, 4, 4, 0, 1)
    BIFS_FIELD(Background, backUrl, 2, 3, 2, -1, 0, 0)
    BIFS_FIELD(Background, bottomUrl, 3, 4, 3, -1, 0, 0)
    BIFS_FIELD(Background, frontUrl, 4, 5, 4, -1, 0, 0)
    BIFS_FIELD(Background, leftUrl, 5, 6, 5, -1, 0, 0)
    BIFS_FIELD(Background, rightUrl, 6, 7, 6, -1, 0, 0)
    BIFS_FIELD(Background, topUrl, 7, 8, 7, -1, 0, 0)
    BIFS_FIELD1(Background, skyAngle, 8, 9, 8, 2, 6, 8, 0, 3.14159265)
    BIFS_FIELD1(Background, skyColor, 9, 10, 9, 3, 4, 4, 0, 1)
    BIFS_FIELD(Background, isBound, -1, -1, 10, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Background)

BIFS_IMPLEMENT_NODE_START(Background2D)
    BIFS_EVENT(Background2D, set_bind, 0, -1, 0, 0)
    BIFS_FIELD1(Background2D, backColor, 0, 1, 0, 0, 4, 4, 0, 1)
    BIFS_FIELD(Background2D, url, 1, 2, 1, -1, 0, 0)
    BIFS_FIELD(Background2D, isBound, -1, -1, 2, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Background2D)

BIFS_IMPLEMENT_NODE_START(Billboard)
    BIFS_EVENT(Billboard, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(Billboard, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(Billboard, children, 0, 2, 0, -1)
    BIFS_FIELD(Billboard, axisOfRotation, 1, 3, 1, 0, 9, 9)
BIFS_IMPLEMENT_NODE_END(Billboard)

BIFS_IMPLEMENT_NODE_START(Bitmap)
    BIFS_FIELD1(Bitmap, scale, 0, 0, 0, 0, 12, 12, -1, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(Bitmap)

BIFS_IMPLEMENT_NODE_START(Box)
    BIFS_FIELD1(Box, size, 0, -1, -1, -1, 11, 0, 0, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(Box)

BIFS_IMPLEMENT_NODE_START(Circle)
    BIFS_FIELD1(Circle, radius, 0, 0, 0, 0, 12, 7, 0, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(Circle)

BIFS_IMPLEMENT_NODE_START(Collision)
    BIFS_EVENT(Collision, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(Collision, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(Collision, children, 0, 2, 0, -1)
    BIFS_FIELD(Collision, collide, 1, 3, 1, -1, 0, 0)
    BIFS_FIELD(Collision, proxy, 2, -1, -1, -1, 0, 0)
    BIFS_FIELD(Collision, collideTime, -1, -1, 2, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Collision)

BIFS_IMPLEMENT_NODE_START(Color)
    BIFS_FIELD1(Color, color, 0, 0, 0, 0, 4, 4, 0, 1)
BIFS_IMPLEMENT_NODE_END(Color)

BIFS_IMPLEMENT_NODE_START(ColorInterpolator)
    BIFS_EVENT(ColorInterpolator, set_fraction, 0, -1, 0, 0)
    BIFS_FIELD1(ColorInterpolator, key, 0, 1, 0, -1, 8, 0, 0, 1)
    BIFS_FIELD1(ColorInterpolator, keyValue, 1, 2, 1, -1, 4, 0, 0, 1)
    BIFS_FIELD(ColorInterpolator, value_changed, -1, -1, 2, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(ColorInterpolator)

BIFS_IMPLEMENT_NODE_START(CompositeTexture2D)
    BIFS_EVENT(CompositeTexture2D, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(CompositeTexture2D, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(CompositeTexture2D, children, 0, 2, 0, -1)
    BIFS_FIELD1_SQ(CompositeTexture2D, pixelWidth, 1, 3, 1, -1, 13, 16, 0, 0, 65535)
    BIFS_FIELD1_SQ(CompositeTexture2D, pixelHeight, 2, 4, 2, -1, 13, 16, 0, 0, 65535)
    BIFS_FIELD(CompositeTexture2D, background, 3, 5, 3, -1, 0, 0)
    BIFS_FIELD(CompositeTexture2D, viewport, 4, 6, 4, -1, 0, 0)
    BIFS_FIELD1_SQ(CompositeTexture2D, repeatSandT, 5, -1, -1, -1, 13, 2, 0, 0, 3)
BIFS_IMPLEMENT_NODE_END(CompositeTexture2D)

BIFS_IMPLEMENT_NODE_START(CompositeTexture3D)
    BIFS_EVENT(CompositeTexture3D, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(CompositeTexture3D, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(CompositeTexture3D, children, 0, 2, 0, -1)
    BIFS_FIELD1_SQ(CompositeTexture3D, pixelWidth, 1, 3, 1, -1, 13, 16, 0, 0, 65535)
    BIFS_FIELD1_SQ(CompositeTexture3D, pixelHeight, 2, 4, 2, -1, 13, 16, 0, 0, 65535)
    BIFS_FIELD(CompositeTexture3D, background, 3, 5, 3, -1, 0, 0)
    BIFS_FIELD(CompositeTexture3D, fog, 4, 6, 4, -1, 0, 0)
    BIFS_FIELD(CompositeTexture3D, navigationInfo, 5, 7, 5, -1, 0, 0)
    BIFS_FIELD(CompositeTexture3D, viewpoint, 6, 8, 6, -1, 0, 0)
    BIFS_FIELD(CompositeTexture3D, repeatS, 7, -1, -1, -1, 0, 0)
    BIFS_FIELD(CompositeTexture3D, repeatT, 8, -1, -1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(CompositeTexture3D)

BIFS_IMPLEMENT_NODE_START(Conditional)
    BIFS_EVENT(Conditional, activate, 0, -1, 0, 0)
    BIFS_EVENT(Conditional, reverseActivate, 1, -1, 0, 0)
    BIFS_FIELD(Conditional, buffer, 0, 2, 0, -1, 0, 0)
    BIFS_FIELD(Conditional, isActive, -1, -1, 1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Conditional)

BIFS_IMPLEMENT_NODE_START(Cone)
    BIFS_FIELD1(Cone, bottomRadius, 0, -1, -1, -1, 11, 0, 0, FLT_MAX)
    BIFS_FIELD1(Cone, height, 1, -1, -1, -1, 11, 0, 0, FLT_MAX)
    BIFS_FIELD(Cone, side, 2, -1, -1, -1, 0, 0)
    BIFS_FIELD(Cone, bottom, 3, -1, -1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Cone)

BIFS_IMPLEMENT_NODE_START(Coordinate)
    BIFS_FIELD1(Coordinate, point, 0, 0, 0, 0, 1, 1, -FLT_MAX, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(Coordinate)

BIFS_IMPLEMENT_NODE_START(Coordinate2D)
    BIFS_FIELD1(Coordinate2D, point, 0, 0, 0, 0, 2, 2, -FLT_MAX, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(Coordinate2D)

BIFS_IMPLEMENT_NODE_START(CoordinateInterpolator)
    BIFS_EVENT(CoordinateInterpolator, set_fraction, 0, -1, 0, 0)
    BIFS_FIELD1(CoordinateInterpolator, key, 0, 1, 0, -1, 8, 0, 0, 1)
    BIFS_FIELD1(CoordinateInterpolator, keyValue, 1, 2, 1, -1, 1, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(CoordinateInterpolator, value_changed, -1, -1, 2, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(CoordinateInterpolator)

BIFS_IMPLEMENT_NODE_START(CoordinateInterpolator2D)
    BIFS_EVENT(CoordinateInterpolator2D, set_fraction, 0, -1, 0, 0)
    BIFS_FIELD1(CoordinateInterpolator2D, key, 0, 1, 0, -1, 8, 0, 0, 1)
    BIFS_FIELD1(CoordinateInterpolator2D, keyValue, 1, 2, 1, -1, 2, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(CoordinateInterpolator2D, value_changed, -1, -1, 2, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(CoordinateInterpolator2D)

BIFS_IMPLEMENT_NODE_START(Curve2D)
    BIFS_FIELD(Curve2D, point, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD1(Curve2D, fineness, 1, 1, 1, 0, 0, 7, 0, 1)
    BIFS_FIELD1_SQ(Curve2D, type, 2, 2, 2, -1, 13, 2, 0, 0, 3)
BIFS_IMPLEMENT_NODE_END(Curve2D)

BIFS_IMPLEMENT_NODE_START(Cylinder)
    BIFS_FIELD(Cylinder, bottom, 0, -1, -1, -1, 0, 0)
    BIFS_FIELD1(Cylinder, height, 1, -1, -1, -1, 11, 0, 0, FLT_MAX)
    BIFS_FIELD1(Cylinder, radius, 2, -1, -1, -1, 11, 0, 0, FLT_MAX)
    BIFS_FIELD(Cylinder, side, 3, -1, -1, -1, 0, 0)
    BIFS_FIELD(Cylinder, top, 4, -1, -1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Cylinder)

BIFS_IMPLEMENT_NODE_START(CylinderSensor)
    BIFS_FIELD(CylinderSensor, autoOffset, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD1(CylinderSensor, diskAngle, 1, 1, 1, -1, 6, 0, 0, 1.5707963)
    BIFS_FIELD(CylinderSensor, enabled, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD1(CylinderSensor, maxAngle, 3, 3, 3, -1, 6, 0, -6.2831853, 6.2831853)
    BIFS_FIELD1(CylinderSensor, minAngle, 4, 4, 4, -1, 6, 0, -6.2831853, 6.2831853)
    BIFS_FIELD1(CylinderSensor, offset, 5, 5, 5, -1, 6, 0, 0, 6.2831853)
    BIFS_FIELD(CylinderSensor, isActive, -1, -1, 6, -1, 0, 0)
    BIFS_FIELD(CylinderSensor, rotation_changed, -1, -1, 7, -1, 0, 0)
    BIFS_FIELD(CylinderSensor, trackPoint_changed, -1, -1, 8, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(CylinderSensor)

BIFS_IMPLEMENT_NODE_START(DirectionalLight)
    BIFS_FIELD1(DirectionalLight, ambientIntensity, 0, 0, 0, 0, 4, 8, 0, 1)
    BIFS_FIELD1(DirectionalLight, color, 1, 1, 1, 1, 4, 4, 0, 1)
    BIFS_FIELD(DirectionalLight, direction, 2, 2, 2, 2, 9, 9)
    BIFS_FIELD1(DirectionalLight, intensity, 3, 3, 3, 3, 4, 8, 0, 1)
    BIFS_FIELD(DirectionalLight, on, 4, 4, 4, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(DirectionalLight)

BIFS_IMPLEMENT_NODE_START(DiscSensor)
    BIFS_FIELD(DiscSensor, autoOffset, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(DiscSensor, enabled, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD1(DiscSensor, maxAngle, 2, 2, 2, -1, 6, 0, -6.2831853, 6.2831853)
    BIFS_FIELD1(DiscSensor, minAngle, 3, 3, 3, -1, 6, 0, -6.2831853, 6.2831853)
    BIFS_FIELD1(DiscSensor, offset, 4, 4, 4, -1, 6, 0, 0, 6.2831853)
    BIFS_FIELD(DiscSensor, isActive, -1, -1, 5, -1, 0, 0)
    BIFS_FIELD(DiscSensor, rotation_changed, -1, -1, 6, -1, 0, 0)
    BIFS_FIELD(DiscSensor, trackPoint_changed, -1, -1, 7, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(DiscSensor)

BIFS_IMPLEMENT_NODE_START(ElevationGrid)
    BIFS_EVENT(ElevationGrid, set_height, 0, -1, 0, 0)
    BIFS_FIELD(ElevationGrid, color, 0, 1, 0, -1, 0, 0)
    BIFS_FIELD(ElevationGrid, normal, 1, 2, 1, -1, 0, 0)
    BIFS_FIELD(ElevationGrid, texCoord, 2, 3, 2, -1, 0, 0)
    BIFS_FIELD1(ElevationGrid, height, 3, -1, -1, 0, 11, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(ElevationGrid, ccw, 4, -1, -1, -1, 0, 0)
    BIFS_FIELD(ElevationGrid, colorPerVertex, 5, -1, -1, -1, 0, 0)
    BIFS_FIELD1(ElevationGrid, creaseAngle, 6, -1, -1, -1, 6, 0, 0, 6.2831853)
    BIFS_FIELD(ElevationGrid, normalPerVertex, 7, -1, -1, -1, 0, 0)
    BIFS_FIELD(ElevationGrid, solid, 8, -1, -1, -1, 0, 0)
    BIFS_FIELD1(ElevationGrid, xDimension, 9, -1, -1, -1, 11, 0, 0, INT_MAX)
    BIFS_FIELD1(ElevationGrid, xSpacing, 10, -1, -1, -1, 11, 0, 0, FLT_MAX)
    BIFS_FIELD1(ElevationGrid, zDimension, 11, -1, -1, -1, 11, 0, 0, INT_MAX)
    BIFS_FIELD1(ElevationGrid, zSpacing, 12, -1, -1, -1, 11, 0, 0, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(ElevationGrid)

BIFS_IMPLEMENT_NODE_START(Expression)
    BIFS_FIELD1_SQ(Expression, expression_select1, 0, 0, 0, -1, 13, 5, 0, 0, 31)
    BIFS_FIELD1_SQ(Expression, expression_intensity1, 1, 1, 1, -1, 13, 6, 0, 0, 63)
    BIFS_FIELD1_SQ(Expression, expression_select2, 2, 2, 2, -1, 13, 5, 0, 0, 31)
    BIFS_FIELD1_SQ(Expression, expression_intensity2, 3, 3, 3, -1, 13, 6, 0, 0, 63)
    BIFS_FIELD(Expression, init_face, 4, 4, 4, -1, 0, 0)
    BIFS_FIELD(Expression, expression_def, 5, 5, 5, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Expression)

BIFS_IMPLEMENT_NODE_START(Extrusion)
    BIFS_EVENT(Extrusion, set_crossSection, 0, -1, 0, 0)
    BIFS_EVENT(Extrusion, set_orientation, 1, -1, 0, 0)
    BIFS_EVENT(Extrusion, set_scale, 2, -1, 0, 0)
    BIFS_EVENT(Extrusion, set_spine, 3, -1, 0, 0)
    BIFS_FIELD(Extrusion, beginCap, 0, -1, -1, -1, 0, 0)
    BIFS_FIELD(Extrusion, ccw, 1, -1, -1, -1, 0, 0)
    BIFS_FIELD(Extrusion, convex, 2, -1, -1, -1, 0, 0)
    BIFS_FIELD1(Extrusion, creaseAngle, 3, -1, -1, -1, 6, 0, 0, 6.2831853)
    BIFS_FIELD1(Extrusion, crossSection, 4, -1, -1, -1, 2, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(Extrusion, endCap, 5, -1, -1, -1, 0, 0)
    BIFS_FIELD1(Extrusion, orientation, 6, -1, -1, -1, 10, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(Extrusion, scale, 7, -1, -1, -1, 7, 0, 0, FLT_MAX)
    BIFS_FIELD(Extrusion, solid, 8, -1, -1, -1, 0, 0)
    BIFS_FIELD1(Extrusion, spine, 9, -1, -1, -1, 1, 0, -FLT_MAX, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(Extrusion)

BIFS_IMPLEMENT_NODE_START(Face)
    BIFS_FIELD(Face, fap, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(Face, fdp, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD(Face, fit, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD(Face, ttsSource, 3, 3, 3, -1, 0, 0)
    BIFS_FIELD(Face, renderedFace, 4, 4, 4, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Face)

BIFS_IMPLEMENT_NODE_START(FaceDefMesh)
    BIFS_FIELD(FaceDefMesh, faceSceneGraphNode, 0, -1, -1, -1, 0, 0)
    BIFS_FIELD(FaceDefMesh, intervalBorders, 1, -1, -1, -1, 0, 0)
    BIFS_FIELD(FaceDefMesh, coordIndex, 2, -1, -1, -1, 0, 0)
    BIFS_FIELD(FaceDefMesh, displacements, 3, -1, -1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(FaceDefMesh)

BIFS_IMPLEMENT_NODE_START(FaceDefTables)
    BIFS_FIELD1_SQ(FaceDefTables, fapID, 0, -1, -1, -1, 13, 7, 0, 1, 68)
    BIFS_FIELD1_SQ(FaceDefTables, highLevelSelect, 1, -1, -1, -1, 13, 6, 0, 1, 64)
    BIFS_FIELD(FaceDefTables, faceDefMesh, 2, 0, 0, -1, 0, 0)
    BIFS_FIELD(FaceDefTables, faceDefTransform, 3, 1, 1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(FaceDefTables)

BIFS_IMPLEMENT_NODE_START(FaceDefTransform)
    BIFS_FIELD(FaceDefTransform, faceSceneGraphNode, 0, -1, -1, -1, 0, 0)
    BIFS_FIELD(FaceDefTransform, fieldId, 1, -1, -1, -1, 0, 0)
    BIFS_FIELD1(FaceDefTransform, rotationDef, 2, -1, -1, -1, 10, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(FaceDefTransform, scaleDef, 3, -1, -1, -1, 7, 0)
    BIFS_FIELD(FaceDefTransform, translationDef, 4, -1, -1, -1, 1, 0)
BIFS_IMPLEMENT_NODE_END(FaceDefTransform)

BIFS_IMPLEMENT_NODE_START(FAP)
    BIFS_FIELD(FAP, viseme, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(FAP, expression, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD1(FAP, open_jaw, 2, 2, 2, -1, 0, 0, 0, INT_MAX)
    BIFS_FIELD1(FAP, lower_t_midlip, 3, 3, 3, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, raise_b_midlip, 4, 4, 4, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, stretch_l_corner, 5, 5, 5, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, stretch_r_corner, 6, 6, 6, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, lower_t_lip_lm, 7, 7, 7, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, lower_t_lip_rm, 8, 8, 8, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, lower_b_lip_lm, 9, 9, 9, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, lower_b_lip_rm, 10, 10, 10, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, raise_l_cornerlip, 11, 11, 11, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, raise_r_cornerlip, 12, 12, 12, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, thrust_jaw, 13, 13, 13, -1, 0, 0, 0, INT_MAX)
    BIFS_FIELD1(FAP, shift_jaw, 14, 14, 14, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, push_b_lip, 15, 15, 15, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, push_t_lip, 16, 16, 16, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, depress_chin, 17, 17, 17, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, close_t_l_eyelid, 18, 18, 18, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, close_t_r_eyelid, 19, 19, 19, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, close_b_l_eyelid, 20, 20, 20, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, close_b_r_eyelid, 21, 21, 21, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, yaw_l_eyeball, 22, 22, 22, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, yaw_r_eyeball, 23, 23, 23, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, pitch_l_eyeball, 24, 24, 24, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, pitch_r_eyeball, 25, 25, 25, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, thrust_l_eyeball, 26, 26, 26, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, thrust_r_eyeball, 27, 27, 27, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, dilate_l_pupil, 28, 28, 28, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, dilate_r_pupil, 29, 29, 29, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, raise_l_i_eyebrow, 30, 30, 30, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, raise_r_i_eyebrow, 31, 31, 31, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, raise_l_m_eyebrow, 32, 32, 32, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, raise_r_m_eyebrow, 33, 33, 33, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, raise_l_o_eyebrow, 34, 34, 34, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, raise_r_o_eyebrow, 35, 35, 35, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, squeeze_l_eyebrow, 36, 36, 36, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, squeeze_r_eyebrow, 37, 37, 37, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, puff_l_cheek, 38, 38, 38, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, puff_r_cheek, 39, 39, 39, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, lift_l_cheek, 40, 40, 40, -1, 0, 0, 0, INT_MAX)
    BIFS_FIELD1(FAP, lift_r_cheek, 41, 41, 41, -1, 0, 0, 0, INT_MAX)
    BIFS_FIELD1(FAP, shift_tongue_tip, 42, 42, 42, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, raise_tongue_tip, 43, 43, 43, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, thrust_tongue_tip, 44, 44, 44, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, raise_tongue, 45, 45, 45, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, tongue_roll, 46, 46, 46, -1, 0, 0, 0, INT_MAX)
    BIFS_FIELD1(FAP, head_pitch, 47, 47, 47, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, head_yaw, 48, 48, 48, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, head_roll, 49, 49, 49, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, lower_t_midlip_o, 50, 50, 50, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, raise_b_midlip_o, 51, 51, 51, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, stretch_l_cornerlip, 52, 52, 52, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, stretch_r_cornerlip, 53, 53, 53, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, lower_t_lip_lm_o, 54, 54, 54, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, lower_t_lip_rm_o, 55, 55, 55, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, raise_b_lip_lm_o, 56, 56, 56, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, raise_b_lip_rm_o, 57, 57, 57, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, raise_l_cornerlip_o, 58, 58, 58, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, raise_r_cornerlip_o, 59, 59, 59, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, stretch_l_nose, 60, 60, 60, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, stretch_r_nose, 61, 61, 61, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, raise_nose, 62, 62, 62, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, bend_nose, 63, 63, 63, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, raise_l_ear, 64, 64, 64, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, raise_r_ear, 65, 65, 65, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, pull_l_ear, 66, 66, 66, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(FAP, pull_r_ear, 67, 67, 67, -1, 0, 0, INT_MIN, INT_MAX)
BIFS_IMPLEMENT_NODE_END(FAP)

BIFS_IMPLEMENT_NODE_START(FDP)
    BIFS_FIELD(FDP, featurePointsCoord, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(FDP, textureCoord, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD(FDP, faceDefTables, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD(FDP, faceSceneGraph, 3, 3, 3, -1, 0, 0)
    BIFS_FIELD(FDP, useOrthoTexture, 4, -1, -1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(FDP)

BIFS_IMPLEMENT_NODE_START(FIT)
    BIFS_FIELD1_SQ(FIT, FAPs, 0, 0, 0, -1, 13, 7, 0, -1, 68)
    BIFS_FIELD1_SQ(FIT, Graph, 1, 1, 1, -1, 13, 7, 0, 0, 68)
    BIFS_FIELD1_SQ(FIT, numeratorExp, 2, 2, 2, -1, 13, 4, 0, 0, 15)
    BIFS_FIELD1_SQ(FIT, denominatorExp, 3, 3, 3, -1, 13, 4, 0, 0, 15)
    BIFS_FIELD1_SQ(FIT, numeratorImpulse, 4, 4, 4, -1, 13, 10, 0, 0, 1023)
    BIFS_FIELD1_SQ(FIT, numeratorTerms, 5, 5, 5, -1, 13, 4, 0, 0, 10)
    BIFS_FIELD1_SQ(FIT, denominatorTerms, 6, 6, 6, -1, 13, 4, 0, 0, 10)
    BIFS_FIELD1(FIT, numeratorCoefs, 7, 7, 7, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(FIT, denominatorCoefs, 8, 8, 8, -1, 0, 0, -FLT_MAX, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(FIT)

BIFS_IMPLEMENT_NODE_START(Fog)
    BIFS_FIELD1(Fog, color, 0, 0, 0, 0, 4, 4, 0, 1)
    BIFS_FIELD(Fog, fogType, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD1(Fog, visibilityRange, 2, 2, 2, -1, 11, 0, 0, FLT_MAX)
    BIFS_EVENT(Fog, set_bind, 3, -1, 0, 0)
    BIFS_FIELD(Fog, isBound, -1, -1, 3, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Fog)

BIFS_IMPLEMENT_NODE_START(FontStyle)
    BIFS_FIELD(FontStyle, family, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(FontStyle, horizontal, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD(FontStyle, justify, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD(FontStyle, language, 3, 3, 3, -1, 0, 0)
    BIFS_FIELD(FontStyle, leftToRight, 4, 4, 4, -1, 0, 0)
    BIFS_FIELD1(FontStyle, size, 5, 5, 5, -1, 11, 0, 0, FLT_MAX)
    BIFS_FIELD1(FontStyle, spacing, 6, 6, 6, -1, 11, 0, 0, FLT_MAX)
    BIFS_FIELD(FontStyle, style, 7, 7, 7, -1, 0, 0)
    BIFS_FIELD(FontStyle, topToBottom, 8, 8, 8, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(FontStyle)

BIFS_IMPLEMENT_NODE_START(Form)
    BIFS_EVENT(Form, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(Form, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(Form, children, 0, 2, 0, -1)
    BIFS_FIELD1(Form, size, 1, 3, 1, 0, 12, 12, 0, FLT_MAX)
    BIFS_FIELD1_SQ(Form, groups, 2, 4, 2, -1, 13, 10, 0, -1, 1022)
    BIFS_FIELD(Form, constraints, 3, 5, 3, -1, 0, 0)
    BIFS_FIELD1_SQ(Form, groupsIndex, 4, 6, 4, -1, 13, 10, 0, -1, 1022)
BIFS_IMPLEMENT_NODE_END(Form)

BIFS_IMPLEMENT_NODE_START(Group)
    BIFS_EVENT(Group, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(Group, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(Group, children, 0, 2, 0, -1)
BIFS_IMPLEMENT_NODE_END(Group)

BIFS_IMPLEMENT_NODE_START(ImageTexture)
    BIFS_FIELD(ImageTexture, url, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(ImageTexture, repeatS, 1, -1, -1, -1, 0, 0)
    BIFS_FIELD(ImageTexture, repeatT, 2, -1, -1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(ImageTexture)

BIFS_IMPLEMENT_NODE_START(IndexedFaceSet)
    BIFS_EVENT(IndexedFaceSet, set_colorIndex, 0, -1, 0, 0)
    BIFS_EVENT(IndexedFaceSet, set_coordIndex, 1, -1, 0, 0)
    BIFS_EVENT(IndexedFaceSet, set_normalIndex, 2, -1, 0, 0)
    BIFS_EVENT(IndexedFaceSet, set_texCoordIndex, 3, -1, 0, 0)
    BIFS_FIELD(IndexedFaceSet, color, 0, 4, 0, -1, 0, 0)
    BIFS_FIELD(IndexedFaceSet, coord, 1, 5, 1, -1, 0, 0)
    BIFS_FIELD(IndexedFaceSet, normal, 2, 6, 2, -1, 0, 0)
    BIFS_FIELD(IndexedFaceSet, texCoord, 3, 7, 3, -1, 0, 0)
    BIFS_FIELD(IndexedFaceSet, ccw, 4, -1, -1, -1, 0, 0)
    BIFS_FIELD1(IndexedFaceSet, colorIndex, 5, -1, -1, -1, 14, 0, -1, FLT_MAX)
    BIFS_FIELD(IndexedFaceSet, colorPerVertex, 6, -1, -1, -1, 0, 0)
    BIFS_FIELD(IndexedFaceSet, convex, 7, -1, -1, -1, 0, 0)
    BIFS_FIELD1(IndexedFaceSet, coordIndex, 8, -1, -1, -1, 14, 0, -1, FLT_MAX)
    BIFS_FIELD1(IndexedFaceSet, creaseAngle, 9, -1, -1, -1, 6, 0, 0, 6.2831853)
    BIFS_FIELD1(IndexedFaceSet, normalIndex, 10, -1, -1, -1, 14, 0, -1, FLT_MAX)
    BIFS_FIELD(IndexedFaceSet, normalPerVertex, 11, -1, -1, -1, 0, 0)
    BIFS_FIELD(IndexedFaceSet, solid, 12, -1, -1, -1, 0, 0)
    BIFS_FIELD1(IndexedFaceSet, texCoordIndex, 13, -1, -1, -1, 14, 0, -1, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(IndexedFaceSet)

BIFS_IMPLEMENT_NODE_START(IndexedFaceSet2D)
    BIFS_EVENT(IndexedFaceSet2D, set_colorIndex, 0, -1, 0, 0)
    BIFS_EVENT(IndexedFaceSet2D, set_coordIndex, 1, -1, 0, 0)
    BIFS_EVENT(IndexedFaceSet2D, set_texCoordIndex, 2, -1, 0, 0)
    BIFS_FIELD(IndexedFaceSet2D, color, 0, 3, 0, -1, 0, 0)
    BIFS_FIELD(IndexedFaceSet2D, coord, 1, 4, 1, -1, 0, 0)
    BIFS_FIELD(IndexedFaceSet2D, texCoord, 2, 5, 2, -1, 0, 0)
    BIFS_FIELD1(IndexedFaceSet2D, colorIndex, 3, -1, -1, -1, 14, 0, -1, FLT_MAX)
    BIFS_FIELD(IndexedFaceSet2D, colorPerVertex, 4, -1, -1, -1, 0, 0)
    BIFS_FIELD(IndexedFaceSet2D, convex, 5, -1, -1, -1, 0, 0)
    BIFS_FIELD1(IndexedFaceSet2D, coordIndex, 6, -1, -1, -1, 14, 0, -1, FLT_MAX)
    BIFS_FIELD1(IndexedFaceSet2D, texCoordIndex, 7, -1, -1, -1, 14, 0, -1, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(IndexedFaceSet2D)

BIFS_IMPLEMENT_NODE_START(IndexedLineSet)
    BIFS_EVENT(IndexedLineSet, set_colorIndex, 0, -1, 0, 0)
    BIFS_EVENT(IndexedLineSet, set_coordIndex, 1, -1, 0, 0)
    BIFS_FIELD(IndexedLineSet, color, 0, 2, 0, -1, 0, 0)
    BIFS_FIELD(IndexedLineSet, coord, 1, 3, 1, -1, 0, 0)
    BIFS_FIELD1(IndexedLineSet, colorIndex, 2, -1, -1, -1, 14, 0, -1, FLT_MAX)
    BIFS_FIELD(IndexedLineSet, colorPerVertex, 3, -1, -1, -1, 0, 0)
    BIFS_FIELD1(IndexedLineSet, coordIndex, 4, -1, -1, -1, 14, 0, -1, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(IndexedLineSet)

BIFS_IMPLEMENT_NODE_START(IndexedLineSet2D)
    BIFS_EVENT(IndexedLineSet2D, set_colorIndex, 0, -1, 0, 0)
    BIFS_EVENT(IndexedLineSet2D, set_coordIndex, 1, -1, 0, 0)
    BIFS_FIELD(IndexedLineSet2D, color, 0, 2, 0, -1, 0, 0)
    BIFS_FIELD(IndexedLineSet2D, coord, 1, 3, 1, -1, 0, 0)
    BIFS_FIELD1(IndexedLineSet2D, colorIndex, 2, -1, -1, -1, 14, 0, -1, FLT_MAX)
    BIFS_FIELD(IndexedLineSet2D, colorPerVertex, 3, -1, -1, -1, 0, 0)
    BIFS_FIELD1(IndexedLineSet2D, coordIndex, 4, -1, -1, -1, 14, 0, -1, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(IndexedLineSet2D)

BIFS_IMPLEMENT_NODE_START(Inline)
    BIFS_FIELD(Inline, url, 0, 0, 0, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Inline)

BIFS_IMPLEMENT_NODE_START(LOD)
    BIFS_FIELD(LOD, level, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD1(LOD, center, 1, -1, -1, -1, 1, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(LOD, range, 2, -1, -1, -1, 11, 0, 0, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(LOD)

BIFS_IMPLEMENT_NODE_START(Layer2D)
    BIFS_EVENT(Layer2D, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(Layer2D, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(Layer2D, children, 0, 2, 0, -1)
    BIFS_FIELD1(Layer2D, size, 1, 3, 1, 0, 12, 12, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(Layer2D, background, 2, 4, 2, -1, 0, 0)
    BIFS_FIELD(Layer2D, viewport, 3, 5, 3, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Layer2D)

BIFS_IMPLEMENT_NODE_START(Layer3D)
    BIFS_EVENT(Layer3D, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(Layer3D, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(Layer3D, children, 0, 2, 0, -1)
    BIFS_FIELD1(Layer3D, size, 1, 3, 1, 0, 12, 12, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(Layer3D, background, 2, 4, 2, -1, 0, 0)
    BIFS_FIELD(Layer3D, fog, 3, 5, 3, -1, 0, 0)
    BIFS_FIELD(Layer3D, navigationInfo, 4, 6, 4, -1, 0, 0)
    BIFS_FIELD(Layer3D, viewpoint, 5, 7, 5, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Layer3D)

BIFS_IMPLEMENT_NODE_START(Layout)
    BIFS_EVENT(Layout, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(Layout, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(Layout, children, 0, 2, 0, -1)
    BIFS_FIELD(Layout, wrap, 1, 3, 1, -1, 0, 0)
    BIFS_FIELD1(Layout, size, 2, 4, 2, 0, 12, 12, 0, FLT_MAX)
    BIFS_FIELD(Layout, horizontal, 3, 5, 3, -1, 0, 0)
    BIFS_FIELD(Layout, justify, 4, 6, 4, -1, 0, 0)
    BIFS_FIELD(Layout, leftToRight, 5, 7, 5, -1, 0, 0)
    BIFS_FIELD(Layout, topToBottom, 6, 8, 6, -1, 0, 0)
    BIFS_FIELD1(Layout, spacing, 7, 9, 7, 1, 0, 7, 0, FLT_MAX)
    BIFS_FIELD(Layout, smoothScroll, 8, 10, 8, -1, 0, 0)
    BIFS_FIELD(Layout, loop, 9, 11, 9, -1, 0, 0)
    BIFS_FIELD(Layout, scrollVertical, 10, 12, 10, -1, 0, 0)
    BIFS_FIELD1(Layout, scrollRate, 11, 13, 11, 2, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1_SQ(Layout, scrollMode, 12, 14, 12, -1, 13, 2, 0, -1, 1)
BIFS_IMPLEMENT_NODE_END(Layout)

BIFS_IMPLEMENT_NODE_START(LineProperties)
    BIFS_FIELD1(LineProperties, lineColor, 0, 0, 0, 0, 4, 4, 0, 1)
    BIFS_FIELD1_SQ(LineProperties, lineStyle, 1, 1, 1, -1, 13, 3, 0, 0, 5)
    BIFS_FIELD1(LineProperties, width, 2, 2, 2, 1, 12, 7, 0, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(LineProperties)

BIFS_IMPLEMENT_NODE_START(ListeningPoint)
    BIFS_EVENT(ListeningPoint, set_bind, 0, -1, 0, 0)
    BIFS_FIELD(ListeningPoint, jump, 0, 1, 0, -1, 0, 0)
    BIFS_FIELD(ListeningPoint, orientation, 1, 2, 1, 0, 10, 10)
    BIFS_FIELD1(ListeningPoint, position, 2, 3, 2, 1, 1, 1, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(ListeningPoint, description, 3, -1, -1, -1, 0, 0)
    BIFS_FIELD(ListeningPoint, bindTime, -1, -1, 3, -1, 0, 0)
    BIFS_FIELD(ListeningPoint, isBound, -1, -1, 4, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(ListeningPoint)

BIFS_IMPLEMENT_NODE_START(Material)
    BIFS_FIELD1(Material, ambientIntensity, 0, 0, 0, 0, 4, 8, 0, 1)
    BIFS_FIELD1(Material, diffuseColor, 1, 1, 1, 1, 4, 4, 0, 1)
    BIFS_FIELD1(Material, emissiveColor, 2, 2, 2, 2, 4, 4, 0, 1)
    BIFS_FIELD1(Material, shininess, 3, 3, 3, 3, 4, 8, 0, 1)
    BIFS_FIELD1(Material, specularColor, 4, 4, 4, 4, 4, 4, 0, 1)
    BIFS_FIELD1(Material, transparency, 5, 5, 5, 5, 4, 8, 0, 1)
BIFS_IMPLEMENT_NODE_END(Material)

BIFS_IMPLEMENT_NODE_START(Material2D)
    BIFS_FIELD1(Material2D, emissiveColor, 0, 0, 0, 0, 4, 4, 0, 1)
    BIFS_FIELD(Material2D, filled, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD(Material2D, lineProps, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD1(Material2D, transparency, 3, 3, 3, 1, 4, 8, 0, 1)
BIFS_IMPLEMENT_NODE_END(Material2D)

BIFS_IMPLEMENT_NODE_START(MovieTexture)
    BIFS_FIELD(MovieTexture, loop, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD1(MovieTexture, speed, 1, 1, 1, 0, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(MovieTexture, startTime, 2, 2, 2, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(MovieTexture, stopTime, 3, 3, 3, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(MovieTexture, url, 4, 4, 4, -1, 0, 0)
    BIFS_FIELD(MovieTexture, repeatS, 5, -1, -1, -1, 0, 0)
    BIFS_FIELD(MovieTexture, repeatT, 6, -1, -1, -1, 0, 0)
    BIFS_FIELD(MovieTexture, duration_changed, -1, -1, 5, -1, 0, 0)
    BIFS_FIELD(MovieTexture, isActive, -1, -1, 6, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(MovieTexture)

BIFS_IMPLEMENT_NODE_START(NavigationInfo)
    BIFS_EVENT(NavigationInfo, set_bind, 0, -1, 0, 0)
    BIFS_FIELD1(NavigationInfo, avatarSize, 0, 1, 0, -1, 11, 0, 0, FLT_MAX)
    BIFS_FIELD(NavigationInfo, headlight, 1, 2, 1, -1, 0, 0)
    BIFS_FIELD1(NavigationInfo, speed, 2, 3, 2, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD(NavigationInfo, type, 3, 4, 3, -1, 0, 0)
    BIFS_FIELD1(NavigationInfo, visibilityLimit, 4, 5, 4, 0, 11, 7, 0, FLT_MAX)
    BIFS_FIELD(NavigationInfo, isBound, -1, -1, 5, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(NavigationInfo)

BIFS_IMPLEMENT_NODE_START(Normal)
    BIFS_FIELD(Normal, vector, 0, 0, 0, 0, 9, 9)
BIFS_IMPLEMENT_NODE_END(Normal)

BIFS_IMPLEMENT_NODE_START(NormalInterpolator)
    BIFS_EVENT(NormalInterpolator, set_fraction, 0, -1, 0, 0)
    BIFS_FIELD1(NormalInterpolator, key, 0, 1, 0, -1, 8, 0, 0, 1)
    BIFS_FIELD1(NormalInterpolator, keyValue, 1, 2, 1, -1, 9, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(NormalInterpolator, value_changed, -1, -1, 2, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(NormalInterpolator)

BIFS_IMPLEMENT_NODE_START(OrderedGroup)
    BIFS_EVENT(OrderedGroup, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(OrderedGroup, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(OrderedGroup, children, 0, 2, 0, -1)
    BIFS_FIELD1(OrderedGroup, order, 1, 3, 1, -1, 3, 0, 0, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(OrderedGroup)

BIFS_IMPLEMENT_NODE_START(OrientationInterpolator)
    BIFS_EVENT(OrientationInterpolator, set_fraction, 0, -1, 0, 0)
    BIFS_FIELD1(OrientationInterpolator, key, 0, 1, 0, -1, 8, 0, 0, 1)
    BIFS_FIELD1(OrientationInterpolator, keyValue, 1, 2, 1, -1, 10, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(OrientationInterpolator, value_changed, -1, -1, 2, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(OrientationInterpolator)

BIFS_IMPLEMENT_NODE_START(PixelTexture)
    BIFS_FIELD(PixelTexture, image, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(PixelTexture, repeatS, 1, -1, -1, -1, 0, 0)
    BIFS_FIELD(PixelTexture, repeatT, 2, -1, -1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(PixelTexture)

BIFS_IMPLEMENT_NODE_START(PlaneSensor)
    BIFS_FIELD(PlaneSensor, autoOffset, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(PlaneSensor, enabled, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD1(PlaneSensor, maxPosition, 2, 2, 2, -1, 2, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PlaneSensor, minPosition, 3, 3, 3, -1, 2, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PlaneSensor, offset, 4, 4, 4, -1, 1, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(PlaneSensor, isActive, -1, -1, 5, -1, 0, 0)
    BIFS_FIELD(PlaneSensor, trackPoint_changed, -1, -1, 6, -1, 0, 0)
    BIFS_FIELD(PlaneSensor, translation_changed, -1, -1, 7, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(PlaneSensor)

BIFS_IMPLEMENT_NODE_START(PlaneSensor2D)
    BIFS_FIELD(PlaneSensor2D, autoOffset, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(PlaneSensor2D, enabled, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD1(PlaneSensor2D, maxPosition, 2, 2, 2, -1, 2, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PlaneSensor2D, minPosition, 3, 3, 3, -1, 2, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PlaneSensor2D, offset, 4, 4, 4, -1, 12, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(PlaneSensor2D, isActive, -1, -1, 5, -1, 0, 0)
    BIFS_FIELD(PlaneSensor2D, trackPoint_changed, -1, -1, 6, -1, 0, 0)
    BIFS_FIELD(PlaneSensor2D, translation_changed, -1, -1, 7, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(PlaneSensor2D)

BIFS_IMPLEMENT_NODE_START(PointLight)
    BIFS_FIELD1(PointLight, ambientIntensity, 0, 0, 0, 0, 4, 8, 0, 1)
    BIFS_FIELD1(PointLight, attenuation, 1, 1, 1, 1, 11, 1, 0, FLT_MAX)
    BIFS_FIELD1(PointLight, color, 2, 2, 2, 2, 4, 4, 0, 1)
    BIFS_FIELD1(PointLight, intensity, 3, 3, 3, 3, 4, 8, 0, 1)
    BIFS_FIELD1(PointLight, location, 4, 4, 4, 4, 1, 1, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(PointLight, on, 5, 5, 5, -1, 0, 0)
    BIFS_FIELD1(PointLight, radius, 6, 6, 6, 5, 11, 7, 0, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(PointLight)

BIFS_IMPLEMENT_NODE_START(PointSet)
    BIFS_FIELD(PointSet, color, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(PointSet, coord, 1, 1, 1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(PointSet)

BIFS_IMPLEMENT_NODE_START(PointSet2D)
    BIFS_FIELD(PointSet2D, color, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(PointSet2D, coord, 1, 1, 1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(PointSet2D)

BIFS_IMPLEMENT_NODE_START(PositionInterpolator)
    BIFS_EVENT(PositionInterpolator, set_fraction, 0, -1, 0, 0)
    BIFS_FIELD1(PositionInterpolator, key, 0, 1, 0, -1, 8, 0, 0, 1)
    BIFS_FIELD1(PositionInterpolator, keyValue, 1, 2, 1, -1, 1, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(PositionInterpolator, value_changed, -1, -1, 2, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(PositionInterpolator)

BIFS_IMPLEMENT_NODE_START(PositionInterpolator2D)
    BIFS_EVENT(PositionInterpolator2D, set_fraction, 0, -1, 0, 0)
    BIFS_FIELD1(PositionInterpolator2D, key, 0, 1, 0, -1, 8, 0, 0, 1)
    BIFS_FIELD1(PositionInterpolator2D, keyValue, 1, 2, 1, -1, 2, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(PositionInterpolator2D, value_changed, -1, -1, 2, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(PositionInterpolator2D)

BIFS_IMPLEMENT_NODE_START(ProximitySensor2D)
    BIFS_FIELD1(ProximitySensor2D, center, 0, 0, 0, -1, 2, 0, -1, FLT_MAX)
    BIFS_FIELD1(ProximitySensor2D, size, 1, 1, 1, -1, 12, 0, 0, FLT_MAX)
    BIFS_FIELD(ProximitySensor2D, enabled, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD(ProximitySensor2D, isActive, -1, -1, 3, -1, 0, 0)
    BIFS_FIELD(ProximitySensor2D, position_changed, -1, -1, 4, -1, 0, 0)
    BIFS_FIELD(ProximitySensor2D, orientation_changed, -1, -1, 5, -1, 0, 0)
    BIFS_FIELD(ProximitySensor2D, enterTime, -1, -1, 6, -1, 0, 0)
    BIFS_FIELD(ProximitySensor2D, exitTime, -1, -1, 7, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(ProximitySensor2D)

BIFS_IMPLEMENT_NODE_START(ProximitySensor)
    BIFS_FIELD1(ProximitySensor, center, 0, 0, 0, -1, 1, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(ProximitySensor, size, 1, 1, 1, -1, 11, 0, 0, FLT_MAX)
    BIFS_FIELD(ProximitySensor, enabled, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD(ProximitySensor, isActive, -1, -1, 3, -1, 0, 0)
    BIFS_FIELD(ProximitySensor, position_changed, -1, -1, 4, -1, 0, 0)
    BIFS_FIELD(ProximitySensor, orientation_changed, -1, -1, 5, -1, 0, 0)
    BIFS_FIELD(ProximitySensor, enterTime, -1, -1, 6, -1, 0, 0)
    BIFS_FIELD(ProximitySensor, exitTime, -1, -1, 7, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(ProximitySensor)

BIFS_IMPLEMENT_NODE_START(QuantizationParameter)
    BIFS_FIELD(QuantizationParameter, isLocal, 0, -1, -1, -1, 0, 0)
    BIFS_FIELD(QuantizationParameter, position3DQuant, 1, -1, -1, -1, 0, 0)
    BIFS_FIELD1(QuantizationParameter, position3DMin, 2, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(QuantizationParameter, position3DMax, 3, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1_SQ(QuantizationParameter, position3DNbBits, 4, -1, -1, -1, 13, 5, 0, 0, 31)
    BIFS_FIELD(QuantizationParameter, position2DQuant, 5, -1, -1, -1, 0, 0)
    BIFS_FIELD1(QuantizationParameter, position2DMin, 6, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(QuantizationParameter, position2DMax, 7, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1_SQ(QuantizationParameter, position2DNbBits, 8, -1, -1, -1, 13, 5, 0, 0, 31)
    BIFS_FIELD(QuantizationParameter, drawOrderQuant, 9, -1, -1, -1, 0, 0)
    BIFS_FIELD1(QuantizationParameter, drawOrderMin, 10, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(QuantizationParameter, drawOrderMax, 11, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1_SQ(QuantizationParameter, drawOrderNbBits, 12, -1, -1, -1, 13, 5, 0, 0, 31)
    BIFS_FIELD(QuantizationParameter, colorQuant, 13, -1, -1, -1, 0, 0)
    BIFS_FIELD1(QuantizationParameter, colorMin, 14, -1, -1, -1, 0, 0, 0, 1)
    BIFS_FIELD1(QuantizationParameter, colorMax, 15, -1, -1, -1, 0, 0, 0, 1)
    BIFS_FIELD1_SQ(QuantizationParameter, colorNbBits, 16, -1, -1, -1, 13, 5, 0, 0, 31)
    BIFS_FIELD(QuantizationParameter, textureCoordinateQuant, 17, -1, -1, -1, 0, 0)
    BIFS_FIELD1(QuantizationParameter, textureCoordinateMin, 18, -1, -1, -1, 0, 0, 0, 1)
    BIFS_FIELD1(QuantizationParameter, textureCoordinateMax, 19, -1, -1, -1, 0, 0, 0, 1)
    BIFS_FIELD1_SQ(QuantizationParameter, textureCoordinateNbBits, 20, -1, -1, -1, 13, 5, 0, 0, 31)
    BIFS_FIELD(QuantizationParameter, angleQuant, 21, -1, -1, -1, 0, 0)
    BIFS_FIELD1(QuantizationParameter, angleMin, 22, -1, -1, -1, 0, 0, 0, 6.2831853)
    BIFS_FIELD1(QuantizationParameter, angleMax, 23, -1, -1, -1, 0, 0, 0, 6.2831853)
    BIFS_FIELD1_SQ(QuantizationParameter, angleNbBits, 24, -1, -1, -1, 13, 5, 0, 0, 31)
    BIFS_FIELD(QuantizationParameter, scaleQuant, 25, -1, -1, -1, 0, 0)
    BIFS_FIELD1(QuantizationParameter, scaleMin, 26, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(QuantizationParameter, scaleMax, 27, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1_SQ(QuantizationParameter, scaleNbBits, 28, -1, -1, -1, 13, 5, 0, 0, 31)
    BIFS_FIELD(QuantizationParameter, keyQuant, 29, -1, -1, -1, 0, 0)
    BIFS_FIELD1(QuantizationParameter, keyMin, 30, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(QuantizationParameter, keyMax, 31, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1_SQ(QuantizationParameter, keyNbBits, 32, -1, -1, -1, 13, 5, 0, 0, 31)
    BIFS_FIELD(QuantizationParameter, normalQuant, 33, -1, -1, -1, 0, 0)
    BIFS_FIELD1_SQ(QuantizationParameter, normalNbBits, 34, -1, -1, -1, 13, 5, 0, 0, 31)
    BIFS_FIELD(QuantizationParameter, sizeQuant, 35, -1, -1, -1, 0, 0)
    BIFS_FIELD1(QuantizationParameter, sizeMin, 36, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(QuantizationParameter, sizeMax, 37, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1_SQ(QuantizationParameter, sizeNbBits, 38, -1, -1, -1, 13, 5, 0, 0, 31)
    BIFS_FIELD(QuantizationParameter, useEfficientCoding, 39, -1, -1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(QuantizationParameter)

BIFS_IMPLEMENT_NODE_START(Rectangle)
    BIFS_FIELD1(Rectangle, size, 0, 0, 0, 0, 12, 2, 0, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(Rectangle)

BIFS_IMPLEMENT_NODE_START(ScalarInterpolator)
    BIFS_EVENT(ScalarInterpolator, set_fraction, 0, -1, 0, 0)
    BIFS_FIELD1(ScalarInterpolator, key, 0, 1, 0, -1, 8, 0, 0, 1)
    BIFS_FIELD1(ScalarInterpolator, keyValue, 1, 2, 1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(ScalarInterpolator, value_changed, -1, -1, 2, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(ScalarInterpolator)

BIFS_IMPLEMENT_NODE_START(Script)
    BIFS_FIELD(Script, url, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(Script, directOutput, 1, -1, -1, -1, 0, 0)
    BIFS_FIELD(Script, mustEvaluate, 2, -1, -1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Script)

BIFS_IMPLEMENT_NODE_START(Shape)
    BIFS_FIELD(Shape, appearance, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(Shape, geometry, 1, 1, 1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Shape)

BIFS_IMPLEMENT_NODE_START(Sound)
    BIFS_FIELD1(Sound, direction, 0, 0, 0, -1, 9, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(Sound, intensity, 1, 1, 1, 0, 4, 7, 0, 1)
    BIFS_FIELD1(Sound, location, 2, 2, 2, 1, 1, 1, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(Sound, maxBack, 3, 3, 3, 2, 11, 7, 0, FLT_MAX)
    BIFS_FIELD1(Sound, maxFront, 4, 4, 4, 3, 11, 7, 0, FLT_MAX)
    BIFS_FIELD1(Sound, minBack, 5, 5, 5, 4, 11, 7, 0, FLT_MAX)
    BIFS_FIELD1(Sound, minFront, 6, 6, 6, 5, 11, 7, 0, FLT_MAX)
    BIFS_FIELD1(Sound, priority, 7, 7, 7, -1, 4, 0, 0, 1)
    BIFS_FIELD(Sound, source, 8, 8, 8, -1, 0, 0)
    BIFS_FIELD(Sound, spatialize, 9, -1, -1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Sound)

BIFS_IMPLEMENT_NODE_START(Sound2D)
    BIFS_FIELD1(Sound2D, intensity, 0, 0, 0, 0, 4, 7, 0, 1)
    BIFS_FIELD1(Sound2D, location, 1, 1, 1, 1, 2, 2, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(Sound2D, source, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD(Sound2D, spatialize, 3, -1, -1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Sound2D)

BIFS_IMPLEMENT_NODE_START(Sphere)
    BIFS_FIELD1(Sphere, radius, 0, -1, -1, -1, 11, 0, 0, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(Sphere)

BIFS_IMPLEMENT_NODE_START(SphereSensor)
    BIFS_FIELD(SphereSensor, autoOffset, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(SphereSensor, enabled, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD1(SphereSensor, offset, 2, 2, 2, -1, 10, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(SphereSensor, isActive, -1, -1, 3, -1, 0, 0)
    BIFS_FIELD(SphereSensor, rotation_changed, -1, -1, 4, -1, 0, 0)
    BIFS_FIELD(SphereSensor, trackPoint_changed, -1, -1, 5, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(SphereSensor)

BIFS_IMPLEMENT_NODE_START(SpotLight)
    BIFS_FIELD1(SpotLight, ambientIntensity, 0, 0, 0, 0, 4, 8, 0, 1)
    BIFS_FIELD1(SpotLight, attenuation, 1, 1, 1, 1, 11, 1, 0, FLT_MAX)
    BIFS_FIELD1(SpotLight, beamWidth, 2, 2, 2, 2, 6, 8, 0, 1.5707963)
    BIFS_FIELD1(SpotLight, color, 3, 3, 3, 3, 4, 4, 0, 1)
    BIFS_FIELD1(SpotLight, cutOffAngle, 4, 4, 4, 4, 6, 8, 0, 1.5707963)
    BIFS_FIELD1(SpotLight, direction, 5, 5, 5, 5, 9, 9, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(SpotLight, intensity, 6, 6, 6, 6, 4, 8, 0, 1)
    BIFS_FIELD1(SpotLight, location, 7, 7, 7, 7, 1, 1, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(SpotLight, on, 8, 8, 8, -1, 0, 0)
    BIFS_FIELD1(SpotLight, radius, 9, 9, 9, 8, 11, 7, 0, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(SpotLight)

BIFS_IMPLEMENT_NODE_START(Switch)
    BIFS_FIELD(Switch, choice, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD1_SQ(Switch, whichChoice, 1, 1, 1, -1, 13, 10, 0, -1, 1022)
BIFS_IMPLEMENT_NODE_END(Switch)

BIFS_IMPLEMENT_NODE_START(TermCap)
    BIFS_EVENT(TermCap, evaluate, 0, -1, 0, 0)
    BIFS_FIELD1_SQ(TermCap, capability, 0, 1, 0, -1, 13, 7, 0, 0, 127)
    BIFS_FIELD1_SQ(TermCap, value, -1, -1, 1, -1, 13, 3, 0, 0, 7)
BIFS_IMPLEMENT_NODE_END(TermCap)

BIFS_IMPLEMENT_NODE_START(Text)
    BIFS_FIELD(Text, string, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD1(Text, length, 1, 1, 1, 0, 11, 7, 0, FLT_MAX)
    BIFS_FIELD(Text, fontStyle, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD1(Text, maxExtent, 3, 3, 3, 1, 11, 7, 0, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(Text)

BIFS_IMPLEMENT_NODE_START(TextureCoordinate)
    BIFS_FIELD1(TextureCoordinate, point, 0, 0, 0, 0, 5, 2, -FLT_MAX, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(TextureCoordinate)

BIFS_IMPLEMENT_NODE_START(TextureTransform)
    BIFS_FIELD1(TextureTransform, center, 0, 0, 0, 0, 2, 2, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(TextureTransform, rotation, 1, 1, 1, 1, 6, 6, 0, 6.2831853)
    BIFS_FIELD1(TextureTransform, scale, 2, 2, 2, 2, 7, 12, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(TextureTransform, translation, 3, 3, 3, 3, 2, 2, -FLT_MAX, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(TextureTransform)

BIFS_IMPLEMENT_NODE_START(TimeSensor)
    BIFS_FIELD1(TimeSensor, cycleInterval, 0, 0, 0, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD(TimeSensor, enabled, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD(TimeSensor, loop, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD1(TimeSensor, startTime, 3, 3, 3, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(TimeSensor, stopTime, 4, 4, 4, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(TimeSensor, cycleTime, -1, -1, 5, -1, 0, 0)
    BIFS_FIELD(TimeSensor, fraction_changed, -1, -1, 6, -1, 0, 0)
    BIFS_FIELD(TimeSensor, isActive, -1, -1, 7, -1, 0, 0)
    BIFS_FIELD(TimeSensor, time, -1, -1, 8, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(TimeSensor)

BIFS_IMPLEMENT_NODE_START(TouchSensor)
    BIFS_FIELD(TouchSensor, enabled, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(TouchSensor, hitNormal_changed, -1, -1, 1, -1, 0, 0)
    BIFS_FIELD(TouchSensor, hitPoint_changed, -1, -1, 2, -1, 0, 0)
    BIFS_FIELD(TouchSensor, hitTexCoord_changed, -1, -1, 3, -1, 0, 0)
    BIFS_FIELD(TouchSensor, isActive, -1, -1, 4, -1, 0, 0)
    BIFS_FIELD(TouchSensor, isOver, -1, -1, 5, -1, 0, 0)
    BIFS_FIELD(TouchSensor, touchTime, -1, -1, 6, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(TouchSensor)

BIFS_IMPLEMENT_NODE_START(Transform)
    BIFS_EVENT(Transform, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(Transform, removeChildren, 1, -1, 0, 0)
    BIFS_FIELD1(Transform, center, 0, 2, 0, 0, 1, 1, -FLT_MAX, FLT_MAX)
    BIFS_CHILDREN(Transform, children, 1, 3, 1, -1)
    BIFS_FIELD(Transform, rotation, 2, 4, 2, 1, 10, 10)
    BIFS_FIELD1(Transform, scale, 3, 5, 3, 2, 7, 11, 0, FLT_MAX)
    BIFS_FIELD(Transform, scaleOrientation, 4, 6, 4, 3, 10, 10)
    BIFS_FIELD1(Transform, translation, 5, 7, 5, 4, 1, 1, -FLT_MAX, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(Transform)

BIFS_IMPLEMENT_NODE_START(Transform2D)
    BIFS_EVENT(Transform2D, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(Transform2D, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(Transform2D, children, 0, 2, 0, -1)
    BIFS_FIELD1(Transform2D, center, 1, 3, 1, 0, 2, 2, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(Transform2D, rotationAngle, 2, 4, 2, 1, 6, 6, 0, 6.2831853)
    BIFS_FIELD1(Transform2D, scale, 3, 5, 3, 2, 7, 12, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(Transform2D, scaleOrientation, 4, 6, 4, 3, 6, 6, 0, 6.2831853)
    BIFS_FIELD1(Transform2D, translation, 5, 7, 5, 4, 2, 2, -FLT_MAX, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(Transform2D)

BIFS_IMPLEMENT_NODE_START(Valuator)
    BIFS_EVENT(Valuator, inSFBool, 0, -1, 0, 0)
    BIFS_EVENT(Valuator, inSFColor, 1, -1, 0, 0)
    BIFS_EVENT(Valuator, inMFColor, 2, -1, 0, 0)
    BIFS_EVENT(Valuator, inSFFloat, 3, -1, 0, 0)
    BIFS_EVENT(Valuator, inMFFloat, 4, -1, 0, 0)
    BIFS_EVENT(Valuator, inSFInt32, 5, -1, 0, 0)
    BIFS_EVENT(Valuator, inMFInt32, 6, -1, 0, 0)
    BIFS_EVENT(Valuator, inSFRotation, 7, -1, 0, 0)
    BIFS_EVENT(Valuator, inMFRotation, 8, -1, 0, 0)
    BIFS_EVENT(Valuator, inSFString, 9, -1, 0, 0)
    BIFS_EVENT(Valuator, inMFString, 10, -1, 0, 0)
    BIFS_EVENT(Valuator, inSFTime, 11, -1, 0, 0)
    BIFS_EVENT(Valuator, inSFVec2f, 12, -1, 0, 0)
    BIFS_EVENT(Valuator, inMFVec2f, 13, -1, 0, 0)
    BIFS_EVENT(Valuator, inSFVec3f, 14, -1, 0, 0)
    BIFS_EVENT(Valuator, inMFVec3f, 15, -1, 0, 0)
    BIFS_FIELD(Valuator, outSFBool, -1, -1, 0, -1, 0, 0)
    BIFS_FIELD(Valuator, outSFColor, -1, -1, 1, -1, 0, 0)
    BIFS_FIELD(Valuator, outMFColor, -1, -1, 2, -1, 0, 0)
    BIFS_FIELD(Valuator, outSFFloat, -1, -1, 3, -1, 0, 0)
    BIFS_FIELD(Valuator, outMFFloat, -1, -1, 4, -1, 0, 0)
    BIFS_FIELD(Valuator, outSFInt32, -1, -1, 5, -1, 0, 0)
    BIFS_FIELD(Valuator, outMFInt32, -1, -1, 6, -1, 0, 0)
    BIFS_FIELD(Valuator, outSFRotation, -1, -1, 7, -1, 0, 0)
    BIFS_FIELD(Valuator, outMFRotation, -1, -1, 8, -1, 0, 0)
    BIFS_FIELD(Valuator, outSFString, -1, -1, 9, -1, 0, 0)
    BIFS_FIELD(Valuator, outMFString, -1, -1, 10, -1, 0, 0)
    BIFS_FIELD(Valuator, outSFTime, -1, -1, 11, -1, 0, 0)
    BIFS_FIELD(Valuator, outSFVec2f, -1, -1, 12, -1, 0, 0)
    BIFS_FIELD(Valuator, outMFVec2f, -1, -1, 13, -1, 0, 0)
    BIFS_FIELD(Valuator, outSFVec3f, -1, -1, 14, -1, 0, 0)
    BIFS_FIELD(Valuator, outMFVec3f, -1, -1, 15, -1, 0, 0)
    BIFS_FIELD1(Valuator, Factor1, 0, 16, 16, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(Valuator, Factor2, 1, 17, 17, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(Valuator, Factor3, 2, 18, 18, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(Valuator, Factor4, 3, 19, 19, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(Valuator, Offset1, 4, 20, 20, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(Valuator, Offset2, 5, 21, 21, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(Valuator, Offset3, 6, 22, 22, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(Valuator, Offset4, 7, 23, 23, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(Valuator, Sum, 8, 24, 24, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Valuator)

BIFS_IMPLEMENT_NODE_START(Viewpoint)
    BIFS_EVENT(Viewpoint, set_bind, 0, -1, 0, 0)
    BIFS_FIELD1(Viewpoint, fieldOfView, 0, 1, 0, 0, 6, 8, 0, 3.1415927)
    BIFS_FIELD(Viewpoint, jump, 1, 2, 1, -1, 0, 0)
    BIFS_FIELD(Viewpoint, orientation, 2, 3, 2, 1, 10, 10)
    BIFS_FIELD1(Viewpoint, position, 3, 4, 3, 2, 1, 1, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(Viewpoint, description, 4, -1, -1, -1, 0, 0)
    BIFS_FIELD(Viewpoint, bindTime, -1, -1, 4, -1, 0, 0)
    BIFS_FIELD(Viewpoint, isBound, -1, -1, 5, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Viewpoint)

BIFS_IMPLEMENT_NODE_START(VisibilitySensor)
    BIFS_FIELD1(VisibilitySensor, center, 0, 0, 0, 0, 1, 1, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(VisibilitySensor, enabled, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD1(VisibilitySensor, size, 2, 2, 2, 1, 11, 11, 0, FLT_MAX)
    BIFS_FIELD(VisibilitySensor, enterTime, -1, -1, 3, -1, 0, 0)
    BIFS_FIELD(VisibilitySensor, exitTime, -1, -1, 4, -1, 0, 0)
    BIFS_FIELD(VisibilitySensor, isActive, -1, -1, 5, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(VisibilitySensor)

BIFS_IMPLEMENT_NODE_START(Viseme)
    BIFS_FIELD1_SQ(Viseme, viseme_select1, 0, 0, 0, -1, 13, 5, 0, 0, 31)
    BIFS_FIELD1_SQ(Viseme, viseme_select2, 1, 1, 1, -1, 13, 5, 0, 0, 31)
    BIFS_FIELD1_SQ(Viseme, viseme_blend, 2, 2, 2, -1, 13, 6, 0, 0, 63)
    BIFS_FIELD(Viseme, viseme_def, 3, 3, 3, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Viseme)

BIFS_IMPLEMENT_NODE_START(WorldInfo)
    BIFS_FIELD(WorldInfo, info, 0, -1, -1, -1, 0, 0)
    BIFS_FIELD(WorldInfo, title, 1, -1, -1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(WorldInfo)

BIFS_IMPLEMENT_NODE_START(AcousticMaterial)
    BIFS_FIELD1(AcousticMaterial, ambientIntensity, 0, 0, 0, 0, 4, 8, 0, 1)
    BIFS_FIELD1(AcousticMaterial, diffuseColor, 1, 1, 1, 1, 4, 8, 0, 1)
    BIFS_FIELD1(AcousticMaterial, emissiveColor, 2, 2, 2, 2, 4, 8, 0, 1)
    BIFS_FIELD1(AcousticMaterial, shininess, 3, 3, 3, 3, 4, 8, 0, 1)
    BIFS_FIELD1(AcousticMaterial, specularColor, 4, 4, 4, 4, 4, 8, 0, 1)
    BIFS_FIELD1(AcousticMaterial, transparency, 5, 5, 5, 5, 4, 8, 0, 1)
    BIFS_FIELD1(AcousticMaterial, reffunc, 6, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(AcousticMaterial, transfunc, 7, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(AcousticMaterial, refFrequency, 8, -1, -1, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD1(AcousticMaterial, transFrequency, 9, -1, -1, -1, 0, 0, 0, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(AcousticMaterial)

BIFS_IMPLEMENT_NODE_START(AcousticScene)
    BIFS_FIELD1(AcousticScene, center, 0, -1, -1, -1, 1, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(AcousticScene, Size, 1, -1, -1, -1, 11, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(AcousticScene, reverbTime, 2, -1, -1, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD1(AcousticScene, reverbFreq, 3, -1, -1, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD1(AcousticScene, reverbLevel, 4, 0, 0, 0, 0, 7, 0, FLT_MAX)
    BIFS_FIELD1(AcousticScene, reverbDelay, 5, 1, 1, -1, 0, 0, 0, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(AcousticScene)

BIFS_IMPLEMENT_NODE_START(ApplicationWindow)
    BIFS_FIELD(ApplicationWindow, isActive, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD1(ApplicationWindow, startTime, 1, 1, 1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(ApplicationWindow, stopTime, 2, 2, 2, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(ApplicationWindow, description, 3, 3, 3, -1, 0, 0)
    BIFS_FIELD(ApplicationWindow, parameter, 4, 4, 4, -1, 0, 0)
    BIFS_FIELD(ApplicationWindow, url, 5, 5, 5, -1, 0, 0)
    BIFS_FIELD1(ApplicationWindow, size, 6, 6, 6, 0, 12, 12, -FLT_MAX, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(ApplicationWindow)

BIFS_IMPLEMENT_NODE_START(BAP)
    BIFS_FIELD1(BAP, sacroiliac_tilt, 0, 0, 0, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, sacroiliac_torsion, 1, 1, 1, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, sacroiliac_roll, 2, 2, 2, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_hip_flexion, 3, 3, 3, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_hip_flexion, 4, 4, 4, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_hip_abduct, 5, 5, 5, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_hip_abduct, 6, 6, 6, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_hip_twisting, 7, 7, 7, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_hip_twisting, 8, 8, 8, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_knee_flexion, 9, 9, 9, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_knee_flexion, 10, 10, 10, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_knee_twisting, 11, 11, 11, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_knee_twisting, 12, 12, 12, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_ankle_flexion, 13, 13, 13, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_ankle_flexion, 14, 14, 14, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_ankle_twisting, 15, 15, 15, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_ankle_twisting, 16, 16, 16, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_subtalar_flexion, 17, 17, 17, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_subtalar_flexion, 18, 18, 18, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_midtarsal_flexion, 19, 19, 19, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_midtarsal_flexion, 20, 20, 20, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_metatarsal_flexion, 21, 21, 21, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_metatarsal_flexion, 22, 22, 22, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_sternoclavicular_abduct, 23, 23, 23, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_sternoclavicular_abduct, 24, 24, 24, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_sternoclavicular_rotate, 25, 25, 25, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_sternoclavicular_rotate, 26, 26, 26, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_acromioclavicular_abduct, 27, 27, 27, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_acromioclavicular_abduct, 28, 28, 28, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_acromioclavicular_rotate, 29, 29, 29, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_acromioclavicular_rotate, 30, 30, 30, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_shoulder_flexion, 31, 31, 31, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_shoulder_flexion, 32, 32, 32, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_shoulder_abduct, 33, 33, 33, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_shoulder_abduct, 34, 34, 34, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_shoulder_twisting, 35, 35, 35, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_shoulder_twisting, 36, 36, 36, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_elbow_flexion, 37, 37, 37, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_elbow_flexion, 38, 38, 38, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_elbow_twisting, 39, 39, 39, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_elbow_twisting, 40, 40, 40, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_wrist_flexion, 41, 41, 41, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_wrist_flexion, 42, 42, 42, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_wrist_pivot, 43, 43, 43, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_wrist_pivot, 44, 44, 44, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_wrist_twisting, 45, 45, 45, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_wrist_twisting, 46, 46, 46, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, skullbase_roll, 47, 47, 47, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, skullbase_torsion, 48, 48, 48, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, skullbase_tilt, 49, 49, 49, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc1roll, 50, 50, 50, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc1torsion, 51, 51, 51, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc1tilt, 52, 52, 52, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc2roll, 53, 53, 53, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc2torsion, 54, 54, 54, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc2tilt, 55, 55, 55, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc3roll, 56, 56, 56, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc3torsion, 57, 57, 57, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc3tilt, 58, 58, 58, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc4roll, 59, 59, 59, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc4torsion, 60, 60, 60, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc4tilt, 61, 61, 61, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc5roll, 62, 62, 62, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc5torsion, 63, 63, 63, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc5tilt, 64, 64, 64, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc6roll, 65, 65, 65, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc6torsion, 66, 66, 66, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc6tilt, 67, 67, 67, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc7roll, 68, 68, 68, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc7torsion, 69, 69, 69, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc7tilt, 70, 70, 70, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt1roll, 71, 71, 71, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt1torsion, 72, 72, 72, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt1tilt, 73, 73, 73, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt2roll, 74, 74, 74, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt2torsion, 75, 75, 75, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt2tilt, 76, 76, 76, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt3roll, 77, 77, 77, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt3torsion, 78, 78, 78, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt3tilt, 79, 79, 79, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt4roll, 80, 80, 80, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt4torsion, 81, 81, 81, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt4tilt, 82, 82, 82, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt5roll, 83, 83, 83, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt5torsion, 84, 84, 84, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt5tilt, 85, 85, 85, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt6roll, 86, 86, 86, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt6torsion, 87, 87, 87, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt6tilt, 88, 88, 88, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt7roll, 89, 89, 89, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt7torsion, 90, 90, 90, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt7tilt, 91, 91, 91, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt8roll, 92, 92, 92, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt8torsion, 93, 93, 93, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt8tilt, 94, 94, 94, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt9roll, 95, 95, 95, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt9torsion, 96, 96, 96, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt9tilt, 97, 97, 97, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt10roll, 98, 98, 98, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt10torsion, 99, 99, 99, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt10tilt, 100, 100, 100, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt11roll, 101, 101, 101, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt11torsion, 102, 102, 102, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt11tilt, 103, 103, 103, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt12roll, 104, 104, 104, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt12torsion, 105, 105, 105, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt12tilt, 106, 106, 106, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl1roll, 107, 107, 107, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl1torsion, 108, 108, 108, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl1tilt, 109, 109, 109, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl2roll, 110, 110, 110, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl2torsion, 111, 111, 111, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl2tilt, 112, 112, 112, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl3roll, 113, 113, 113, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl3torsion, 114, 114, 114, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl3tilt, 115, 115, 115, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl4roll, 116, 116, 116, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl4torsion, 117, 117, 117, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl4tilt, 118, 118, 118, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl5roll, 119, 119, 119, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl5torsion, 120, 120, 120, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl5tilt, 121, 121, 121, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_pinky0_flexion, 122, 122, 122, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_pinky0_flexion, 123, 123, 123, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_pinky1_flexion, 124, 124, 124, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_pinky1_flexion, 125, 125, 125, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_pinky1_pivot, 126, 126, 126, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_pinky1_pivot, 127, 127, 127, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_pinky1_twisting, 128, 128, 128, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_pinky1_twisting, 129, 129, 129, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_pinky2_flexion, 130, 130, 130, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_pinky2_flexion, 131, 131, 131, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_pinky3_flexion, 132, 132, 132, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_pinky3_flexion, 133, 133, 133, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_ring0_flexion, 134, 134, 134, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_ring0_flexion, 135, 135, 135, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_ring1_flexion, 136, 136, 136, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_ring1_flexion, 137, 137, 137, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_ring1_pivot, 138, 138, 138, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_ring1_pivot, 139, 139, 139, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_ring1_twisting, 140, 140, 140, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_ring1_twisting, 141, 141, 141, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_ring2_flexion, 142, 142, 142, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_ring2_flexion, 143, 143, 143, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_ring3_flexion, 144, 144, 144, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_ring3_flexion, 145, 145, 145, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_middle0_flexion, 146, 146, 146, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_middle0_flexion, 147, 147, 147, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_middle1_flexion, 148, 148, 148, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_middle1_flexion, 149, 149, 149, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_middle1_pivot, 150, 150, 150, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_middle1_pivot, 151, 151, 151, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_middle1_twisting, 152, 152, 152, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_middle1_twisting, 153, 153, 153, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_middle2_flexion, 154, 154, 154, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_middle2_flexion, 155, 155, 155, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_middle3_flexion, 156, 156, 156, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_middle3_flexion, 157, 157, 157, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_index0_flexion, 158, 158, 158, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_index0_flexion, 159, 159, 159, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_index1_flexion, 160, 160, 160, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_index1_flexion, 161, 161, 161, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_index1_pivot, 162, 162, 162, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_index1_pivot, 163, 163, 163, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_index1_twisting, 164, 164, 164, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_index1_twisting, 165, 165, 165, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_index2_flexion, 166, 166, 166, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_index2_flexion, 167, 167, 167, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_index3_flexion, 168, 168, 168, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_index3_flexion, 169, 169, 169, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_thumb1_flexion, 170, 170, 170, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_thumb1_flexion, 171, 171, 171, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_thumb1_pivot, 172, 172, 172, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_thumb1_pivot, 173, 173, 173, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_thumb1_twisting, 174, 174, 174, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_thumb1_twisting, 175, 175, 175, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_thumb2_flexion, 176, 176, 176, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_thumb2_flexion, 177, 177, 177, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_thumb3_flexion, 178, 178, 178, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_thumb3_flexion, 179, 179, 179, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, HumanoidRoot_tr_vertical, 180, 180, 180, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, HumanoidRoot_tr_lateral, 181, 181, 181, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, HumanoidRoot_tr_frontal, 182, 182, 182, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, HumanoidRoot_rt_body_turn, 183, 183, 183, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, HumanoidRoot_rt_body_roll, 184, 184, 184, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, HumanoidRoot_rt_body_tilt, 185, 185, 185, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap187, 186, 186, 186, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap188, 187, 187, 187, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap189, 188, 188, 188, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap190, 189, 189, 189, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap191, 190, 190, 190, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap192, 191, 191, 191, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap193, 192, 192, 192, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap194, 193, 193, 193, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap195, 194, 194, 194, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap196, 195, 195, 195, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap197, 196, 196, 196, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap198, 197, 197, 197, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap199, 198, 198, 198, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap200, 199, 199, 199, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap201, 200, 200, 200, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap202, 201, 201, 201, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap203, 202, 202, 202, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap204, 203, 203, 203, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap205, 204, 204, 204, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap206, 205, 205, 205, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap207, 206, 206, 206, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap208, 207, 207, 207, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap209, 208, 208, 208, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap210, 209, 209, 209, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap211, 210, 210, 210, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap212, 211, 211, 211, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap213, 212, 212, 212, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap214, 213, 213, 213, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap215, 214, 214, 214, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap216, 215, 215, 215, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap217, 216, 216, 216, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap218, 217, 217, 217, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap219, 218, 218, 218, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap220, 219, 219, 219, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap221, 220, 220, 220, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap222, 221, 221, 221, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap223, 222, 222, 222, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap224, 223, 223, 223, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap225, 224, 224, 224, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap226, 225, 225, 225, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap227, 226, 226, 226, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap228, 227, 227, 227, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap229, 228, 228, 228, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap230, 229, 229, 229, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap231, 230, 230, 230, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap232, 231, 231, 231, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap233, 232, 232, 232, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap234, 233, 233, 233, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap235, 234, 234, 234, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap236, 235, 235, 235, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap237, 236, 236, 236, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap238, 237, 237, 237, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap239, 238, 238, 238, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap240, 239, 239, 239, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap241, 240, 240, 240, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap242, 241, 241, 241, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap243, 242, 242, 242, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap244, 243, 243, 243, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap245, 244, 244, 244, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap246, 245, 245, 245, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap247, 246, 246, 246, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap248, 247, 247, 247, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap249, 248, 248, 248, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap250, 249, 249, 249, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap251, 250, 250, 250, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap252, 251, 251, 251, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap253, 252, 252, 252, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap254, 253, 253, 253, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap255, 254, 254, 254, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap256, 255, 255, 255, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap257, 256, 256, 256, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap258, 257, 257, 257, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap259, 258, 258, 258, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap260, 259, 259, 259, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap261, 260, 260, 260, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap262, 261, 261, 261, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap263, 262, 262, 262, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap264, 263, 263, 263, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap265, 264, 264, 264, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap266, 265, 265, 265, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap267, 266, 266, 266, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap268, 267, 267, 267, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap269, 268, 268, 268, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap270, 269, 269, 269, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap271, 270, 270, 270, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap272, 271, 271, 271, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap273, 272, 272, 272, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap274, 273, 273, 273, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap275, 274, 274, 274, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap276, 275, 275, 275, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap277, 276, 276, 276, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap278, 277, 277, 277, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap279, 278, 278, 278, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap280, 279, 279, 279, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap281, 280, 280, 280, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap282, 281, 281, 281, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap283, 282, 282, 282, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap284, 283, 283, 283, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap285, 284, 284, 284, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap286, 285, 285, 285, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap287, 286, 286, 286, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap288, 287, 287, 287, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap289, 288, 288, 288, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap290, 289, 289, 289, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap291, 290, 290, 290, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap292, 291, 291, 291, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap293, 292, 292, 292, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap294, 293, 293, 293, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap295, 294, 294, 294, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap296, 295, 295, 295, -1, 0, 0, INT_MIN, INT_MAX)
BIFS_IMPLEMENT_NODE_END(BAP)

BIFS_IMPLEMENT_NODE_START(BDP)
    BIFS_FIELD(BDP, bodyDefTables, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(BDP, bodySceneGraph, 1, 1, 1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(BDP)

BIFS_IMPLEMENT_NODE_START(Body)
    BIFS_FIELD(Body, bdp, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(Body, bap, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD(Body, renderedBody, 2, 2, 2, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Body)

BIFS_IMPLEMENT_NODE_START(BodyDefTable)
    BIFS_FIELD(BodyDefTable, bodySceneGraphNodeName, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD1_SQ(BodyDefTable, bapIDs, 1, 1, 1, -1, 13, 9, 0, 1, 296)
    BIFS_FIELD1(BodyDefTable, vertexIds, 2, 2, 2, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD1(BodyDefTable, bapCombinations, 3, 3, 3, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(BodyDefTable, displacements, 4, 4, 4, -1, 0, 0)
    BIFS_FIELD1(BodyDefTable, numInterpolateKeys, 5, 5, 5, -1, 0, 0, 2, INT_MAX)
BIFS_IMPLEMENT_NODE_END(BodyDefTable)

BIFS_IMPLEMENT_NODE_START(BodySegmentConnectionHint)
    BIFS_FIELD(BodySegmentConnectionHint, firstSegmentNodeName, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(BodySegmentConnectionHint, secondSegmentNodeName, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD1(BodySegmentConnectionHint, firstVertexIdList, 2, 2, 2, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD1(BodySegmentConnectionHint, secondVertexIdList, 3, 3, 3, -1, 0, 0, 0, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(BodySegmentConnectionHint)

BIFS_IMPLEMENT_NODE_START(DirectiveSound)
    BIFS_FIELD1(DirectiveSound, direction, 0, 0, 0, 0, 9, 9, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(DirectiveSound, intensity, 1, 1, 1, 1, 0, 7, 0, FLT_MAX)
    BIFS_FIELD1(DirectiveSound, location, 2, 2, 2, 2, 1, 1, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(DirectiveSound, source, 3, 3, 3, -1, 0, 0)
    BIFS_FIELD(DirectiveSound, perceptualParameters, 4, 4, 4, -1, 0, 0)
    BIFS_FIELD(DirectiveSound, roomEffect, 5, 5, 5, -1, 0, 0)
    BIFS_FIELD(DirectiveSound, spatialize, 6, 6, 6, -1, 0, 0)
    BIFS_FIELD1(DirectiveSound, directivity, 7, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(DirectiveSound, angles, 8, -1, -1, -1, 6, 0, 0, 3.14159265)
    BIFS_FIELD1(DirectiveSound, frequency, 9, -1, -1, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD1(DirectiveSound, speedOfSound, 10, -1, -1, -1, 1, 0, 0, FLT_MAX)
    BIFS_FIELD1(DirectiveSound, distance, 11, -1, -1, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD(DirectiveSound, useAirabs, 12, -1, -1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(DirectiveSound)

BIFS_IMPLEMENT_NODE_START(Hierarchical3DMesh)
    BIFS_EVENT(Hierarchical3DMesh, triangleBudget, 0, -1, 0, 0)
    BIFS_FIELD1(Hierarchical3DMesh, level, 0, 1, 0, -1, 0, 0, -1, FLT_MAX)
    BIFS_FIELD(Hierarchical3DMesh, url, 1, -1, -1, -1, 0, 0)
    BIFS_FIELD(Hierarchical3DMesh, doneLoading, -1, -1, 1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Hierarchical3DMesh)

BIFS_IMPLEMENT_NODE_START(MaterialKey)
    BIFS_FIELD(MaterialKey, isKeyed, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(MaterialKey, isRGB, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD1(MaterialKey, keyColor, 2, 2, 2, 0, 4, 4, 0, 1)
    BIFS_FIELD1(MaterialKey, lowThreshold, 3, 3, 3, 1, 4, 8, 0, 1)
    BIFS_FIELD1(MaterialKey, highThreshold, 4, 4, 4, 2, 4, 8, 0, 1)
    BIFS_FIELD1(MaterialKey, transparency, 5, 5, 5, 3, 4, 8, 0, 1)
BIFS_IMPLEMENT_NODE_END(MaterialKey)

BIFS_IMPLEMENT_NODE_START(PerceptualParameters)
    BIFS_FIELD1(PerceptualParameters, sourcePresence, 0, 0, 0, 0, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, sourceWarmth, 1, 1, 1, 1, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, sourceBrilliance, 2, 2, 2, 2, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, roomPresence, 3, 3, 3, 3, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, runningReverberance, 4, 4, 4, 4, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, envelopment, 5, 5, 5, 5, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, lateReverberance, 6, 6, 6, 6, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, heavyness, 7, 7, 7, 7, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, liveness, 8, 8, 8, 8, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, omniDirectivity, 9, 9, 9, 9, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, directFilterGains, 10, 10, 10, 10, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, inputFilterGains, 11, 11, 11, 11, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, refDistance, 12, 12, 12, 12, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, freqLow, 13, 13, 13, 13, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, freqHigh, 14, 14, 14, 14, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, timeLimit1, 15, 15, 15, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, timeLimit2, 16, 16, 16, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, timeLimit3, 17, 17, 17, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, modalDensity, 18, 18, 18, -1, 0, 0, -FLT_MAX, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(PerceptualParameters)

BIFS_IMPLEMENT_NODE_START(TemporalTransform)
    BIFS_EVENT(TemporalTransform, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(TemporalTransform, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(TemporalTransform, children, 0, 2, 0, -1)
    BIFS_FIELD(TemporalTransform, url, 1, 3, 1, -1, 0, 0)
    BIFS_FIELD(TemporalTransform, startTime, 2, 4, 2, -1, 0, 0)
    BIFS_FIELD(TemporalTransform, optimalDuration, 3, 5, 3, -1, 0, 0)
    BIFS_FIELD(TemporalTransform, active, 4, 6, 4, -1, 0, 0)
    BIFS_FIELD1(TemporalTransform, speed, 5, 7, 5, 0, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(TemporalTransform, scalability, 6, 8, 6, 1, 12, 12, -1, FLT_MAX)
    BIFS_FIELD1_SQ(TemporalTransform, stretchMode, 7, 9, 7, -1, 13, 2, 0, 0, 2)
    BIFS_FIELD1_SQ(TemporalTransform, shrinkMode, 8, 10, 8, -1, 13, 1, 0, 0, 1)
    BIFS_FIELD(TemporalTransform, maxDelay, 9, 11, 9, -1, 0, 0)
    BIFS_FIELD(TemporalTransform, actualDuration, -1, -1, 10, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(TemporalTransform)

BIFS_IMPLEMENT_NODE_START(TemporalGroup)
    BIFS_EVENT(TemporalGroup, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(TemporalGroup, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(TemporalGroup, children, 0, 2, 0, -1)
    BIFS_FIELD(TemporalGroup, costart, 1, -1, -1, -1, 0, 0)
    BIFS_FIELD(TemporalGroup, coend, 2, -1, -1, -1, 0, 0)
    BIFS_FIELD(TemporalGroup, meet, 3, -1, -1, -1, 0, 0)
    BIFS_FIELD1(TemporalGroup, priority, 4, 3, 1, -1, 3, 0, 0, FLT_MAX)
    BIFS_FIELD(TemporalGroup, isActive, -1, -1, 2, -1, 0, 0)
    BIFS_FIELD(TemporalGroup, activeChild, -1, -1, 3, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(TemporalGroup)

BIFS_IMPLEMENT_NODE_START(ServerCommand)
    BIFS_EVENT(ServerCommand, trigger, 0, -1, 0, 0)
    BIFS_FIELD(ServerCommand, enable, 0, 1, 0, -1, 0, 0)
    BIFS_FIELD(ServerCommand, url, 1, 2, 1, -1, 0, 0)
    BIFS_FIELD(ServerCommand, command, 2, 3, 2, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(ServerCommand)

BIFS_IMPLEMENT_NODE_START(InputSensor)
    BIFS_FIELD(InputSensor, enabled, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(InputSensor, buffer, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD(InputSensor, url, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD(InputSensor, eventTime, -1, -1, 3, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(InputSensor)

BIFS_IMPLEMENT_NODE_START(MatteTexture)
    BIFS_FIELD(MatteTexture, surfaceA, 0, -1, -1, -1, 0, 0)
    BIFS_FIELD(MatteTexture, surfaceB, 1, -1, -1, -1, 0, 0)
    BIFS_FIELD(MatteTexture, alphaSurface, 2, -1, -1, -1, 0, 0)
    BIFS_FIELD(MatteTexture, operation, 3, 0, 0, -1, 0, 0)
    BIFS_FIELD(MatteTexture, overwrite, 4, -1, -1, -1, 0, 0)
    BIFS_FIELD(MatteTexture, fraction, 5, 1, 1, -1, 0, 0)
    BIFS_FIELD(MatteTexture, parameter, 6, 2, 2, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(MatteTexture)

BIFS_IMPLEMENT_NODE_START(MediaBuffer)
    BIFS_FIELD1(MediaBuffer, bufferSize, 0, 0, 0, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD(MediaBuffer, url, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD1(MediaBuffer, mediaStartTime, 2, 2, 2, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(MediaBuffer, mediaStopTime, 3, 3, 3, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(MediaBuffer, isBuffered, -1, -1, 4, -1, 0, 0)
    BIFS_FIELD(MediaBuffer, enabled, 4, 4, 5, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(MediaBuffer)

BIFS_IMPLEMENT_NODE_START(MediaControl)
    BIFS_FIELD(MediaControl, url, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD1(MediaControl, mediaStartTime, 1, 1, 1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(MediaControl, mediaStopTime, 2, 2, 2, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(MediaControl, mediaSpeed, 3, 3, 3, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(MediaControl, loop, 4, 4, 4, -1, 0, 0)
    BIFS_FIELD(MediaControl, preRoll, 5, 5, 5, -1, 0, 0)
    BIFS_FIELD(MediaControl, mute, 6, 6, 6, -1, 0, 0)
    BIFS_FIELD(MediaControl, enabled, 7, 7, 7, -1, 0, 0)
    BIFS_FIELD(MediaControl, isPreRolled, -1, -1, 8, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(MediaControl)

BIFS_IMPLEMENT_NODE_START(MediaSensor)
    BIFS_FIELD(MediaSensor, url, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(MediaSensor, mediaCurrentTime, -1, -1, 1, -1, 0, 0)
    BIFS_FIELD(MediaSensor, streamObjectStartTime, -1, -1, 2, -1, 0, 0)
    BIFS_FIELD(MediaSensor, mediaDuration, -1, -1, 3, -1, 0, 0)
    BIFS_FIELD(MediaSensor, isActive, -1, -1, 4, -1, 0, 0)
    BIFS_FIELD(MediaSensor, info, -1, -1, 5, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(MediaSensor)

BIFS_IMPLEMENT_NODE_START(BitWrapper)
    BIFS_FIELD(BitWrapper, node, 0, -1, -1, -1, 0, 0)
    BIFS_FIELD(BitWrapper, type, 1, -1, -1, -1, 0, 0)
    BIFS_FIELD(BitWrapper, url, 2, -1, -1, -1, 0, 0)
    BIFS_FIELD(BitWrapper, buffer, 3, -1, -1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(BitWrapper)

BIFS_IMPLEMENT_NODE_START(CoordinateInterpolator4D)
    BIFS_EVENT(CoordinateInterpolator4D, set_fraction, 0, -1, 0, 0)
    BIFS_FIELD1(CoordinateInterpolator4D, key, 0, 1, 0, -1, 8, 0, 0, 1)
    BIFS_FIELD1(CoordinateInterpolator4D, keyValue, 1, 2, 1, -1, 15, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(CoordinateInterpolator4D, value_changed, -1, -1, 2, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(CoordinateInterpolator4D)

BIFS_IMPLEMENT_NODE_START(DepthImage)
    BIFS_FIELD(DepthImage, diTexture, 0, -1, -1, -1, 0, 0)
    BIFS_FIELD1(DepthImage, farPlane, 1, -1, -1, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD1(DepthImage, fieldOfView, 2, -1, -1, -1, 0, 0, 0, 3.1415927)
    BIFS_FIELD1(DepthImage, nearPlane, 3, -1, -1, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD(DepthImage, orientation, 4, -1, -1, -1, 0, 0)
    BIFS_FIELD(DepthImage, orthographic, 5, -1, -1, -1, 0, 0)
    BIFS_FIELD1(DepthImage, position, 6, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(DepthImage)

BIFS_IMPLEMENT_NODE_START(FFD)
    BIFS_EVENT(FFD, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(FFD, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(FFD, children, 0, 2, 0, -1)
    BIFS_FIELD1(FFD, controlPoint, 1, 3, 1, 0, 15, 15, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1_SQ(FFD, uDimension, 2, -1, -1, -1, 13, 8, 0, 2, 257)
    BIFS_FIELD1(FFD, uKnot, 3, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1_SQ(FFD, uOrder, 4, -1, -1, -1, 13, 5, 0, 2, 33)
    BIFS_FIELD1_SQ(FFD, vDimension, 5, -1, -1, -1, 13, 8, 0, 2, 257)
    BIFS_FIELD1(FFD, vKnot, 6, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1_SQ(FFD, vOrder, 7, -1, -1, -1, 13, 5, 0, 2, 33)
    BIFS_FIELD1_SQ(FFD, wDimension, 8, -1, -1, -1, 13, 8, 0, 2, 257)
    BIFS_FIELD1(FFD, wKnot, 9, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1_SQ(FFD, wOrder, 10, -1, -1, -1, 13, 5, 0, 2, 33)
BIFS_IMPLEMENT_NODE_END(FFD)

BIFS_IMPLEMENT_NODE_START(Implicit)
    BIFS_FIELD1(Implicit, bboxSize, 0, 0, 0, 0, 11, 11, 0, FLT_MAX)
    BIFS_FIELD1(Implicit, c, 1, 1, 1, 1, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(Implicit, densities, 2, 2, 2, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD(Implicit, dual, 3, 3, 3, -1, 0, 0)
    BIFS_FIELD(Implicit, solid, 4, 4, 4, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Implicit)

BIFS_IMPLEMENT_NODE_START(XXLFM_Appearance)
    BIFS_FIELD(XXLFM_Appearance, blendList, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(XXLFM_Appearance, lightMapList, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD(XXLFM_Appearance, tileList, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD(XXLFM_Appearance, vertexFrameList, 3, 3, 3, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(XXLFM_Appearance)

BIFS_IMPLEMENT_NODE_START(XXLFM_BlendList)
    BIFS_FIELD1_SQ(XXLFM_BlendList, blendMode, 0, 0, 0, -1, 13, 1, 0, 0, 1)
    BIFS_FIELD(XXLFM_BlendList, lightMapIndex, 1, 1, 1, -1, 14, 0)
BIFS_IMPLEMENT_NODE_END(XXLFM_BlendList)

BIFS_IMPLEMENT_NODE_START(XXLFM_FrameList)
    BIFS_FIELD(XXLFM_FrameList, index, 0, 0, 0, -1, 14, 0)
    BIFS_FIELD1(XXLFM_FrameList, frame, 1, 1, 1, -1, 1, 0, -1, 1)
BIFS_IMPLEMENT_NODE_END(XXLFM_FrameList)

BIFS_IMPLEMENT_NODE_START(XXLFM_LightMap)
    BIFS_FIELD1(XXLFM_LightMap, biasRGB, 0, 0, 0, -1, 7, 0, -1, 1)
    BIFS_FIELD1_SQ(XXLFM_LightMap, priorityLevel, 1, 1, 1, -1, 13, 8, 0, 0, 255)
    BIFS_FIELD1(XXLFM_LightMap, scaleRGB, 2, 2, 2, -1, 7, 0, -1, 1)
    BIFS_FIELD(XXLFM_LightMap, surfaceMapList, 3, 3, 3, -1, 0, 0)
    BIFS_FIELD(XXLFM_LightMap, viewMapList, 4, 4, 4, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(XXLFM_LightMap)

BIFS_IMPLEMENT_NODE_START(XXLFM_SurfaceMapList)
    BIFS_FIELD(XXLFM_SurfaceMapList, tileIndex, 0, 0, 0, -1, 14, 0)
    BIFS_FIELD(XXLFM_SurfaceMapList, triangleCoordinate, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD(XXLFM_SurfaceMapList, triangleIndex, 2, 2, 2, -1, 14, 0)
    BIFS_FIELD(XXLFM_SurfaceMapList, viewMapIndex, 3, 3, 3, -1, 14, 0)
BIFS_IMPLEMENT_NODE_END(XXLFM_SurfaceMapList)

BIFS_IMPLEMENT_NODE_START(XXLFM_ViewMapList)
    BIFS_FIELD(XXLFM_ViewMapList, textureOrigin, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(XXLFM_ViewMapList, textureSize, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD(XXLFM_ViewMapList, tileIndex, 2, 2, 2, -1, 14, 0)
    BIFS_FIELD(XXLFM_ViewMapList, vertexIndex, 3, 3, 3, -1, 14, 0)
BIFS_IMPLEMENT_NODE_END(XXLFM_ViewMapList)

BIFS_IMPLEMENT_NODE_START(MeshGrid)
    BIFS_EVENT(MeshGrid, set_colorIndex, 0, -1, 0, 0)
    BIFS_EVENT(MeshGrid, set_coordIndex, 1, -1, 0, 0)
    BIFS_EVENT(MeshGrid, set_normalIndex, 2, -1, 0, 0)
    BIFS_EVENT(MeshGrid, set_texCoordIndex, 3, -1, 0, 0)
    BIFS_FIELD(MeshGrid, color, 0, 4, 0, -1, 0, 0)
    BIFS_FIELD(MeshGrid, coord, 1, 5, 1, -1, 0, 0)
    BIFS_FIELD1_SQ(MeshGrid, displayLevel, 2, 6, 2, 0, 13, 32, 13, 0, INT_MAX)
    BIFS_FIELD1_SQ(MeshGrid, filterType, 3, 7, 3, 1, 13, 2, 13, 0, 1)
    BIFS_FIELD(MeshGrid, gridCoord, 4, 8, 4, -1, 0, 0)
    BIFS_FIELD1_SQ(MeshGrid, hierarchicalLevel, 5, 9, 5, 2, 13, 32, 13, -1, INT_MAX)
    BIFS_FIELD(MeshGrid, nLevels, 6, 10, 6, 3, 7, 7)
    BIFS_FIELD(MeshGrid, normal, 7, 11, 7, -1, 0, 0)
    BIFS_FIELD(MeshGrid, nSlices, 8, 12, 8, 4, 7, 7)
    BIFS_FIELD(MeshGrid, texCoord, 9, 13, 9, -1, 0, 0)
    BIFS_FIELD1(MeshGrid, vertexOffset, 10, 14, 10, 5, 7, 7, 0, 2)
    BIFS_FIELD1_SQ(MeshGrid, vertexLink, 11, 15, 11, -1, 13, 2, 0, 0, 3)
    BIFS_FIELD1(MeshGrid, colorIndex, 12, -1, -1, -1, 14, 0, -1, FLT_MAX)
    BIFS_FIELD1(MeshGrid, coordIndex, 13, -1, -1, -1, 14, 0, -1, FLT_MAX)
    BIFS_FIELD1(MeshGrid, normalIndex, 14, -1, -1, -1, 14, 0, -1, FLT_MAX)
    BIFS_FIELD(MeshGrid, solid, 15, -1, -1, -1, 0, 0)
    BIFS_FIELD1(MeshGrid, texCoordIndex, 16, -1, -1, -1, 14, 0, -1, FLT_MAX)
    BIFS_FIELD(MeshGrid, isLoading, -1, -1, 12, -1, 0, 0)
    BIFS_FIELD(MeshGrid, nVertices, -1, -1, 13, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(MeshGrid)

BIFS_IMPLEMENT_NODE_START(NonLinearDeformer)
    BIFS_FIELD1(NonLinearDeformer, axis, 0, 0, 0, -1, 0, 0, 0, 1)
    BIFS_FIELD(NonLinearDeformer, extend, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD(NonLinearDeformer, geometry, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD(NonLinearDeformer, param, 3, 3, 3, -1, 0, 0)
    BIFS_FIELD1(NonLinearDeformer, type, 4, 4, 4, -1, 0, 0, 0, 2)
BIFS_IMPLEMENT_NODE_END(NonLinearDeformer)

BIFS_IMPLEMENT_NODE_START(NurbsCurve)
    BIFS_EVENT(NurbsCurve, set_colorIndex, 0, -1, 0, 0)
    BIFS_FIELD(NurbsCurve, color, 0, 1, 0, -1, 0, 0)
    BIFS_FIELD1(NurbsCurve, controlPoint, 1, 2, 1, 0, 15, 15, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(NurbsCurve, tessellation, 2, 3, 2, -1, 0, 0, 0, INT_MAX)
    BIFS_FIELD(NurbsCurve, colorIndex, 3, -1, -1, -1, 14, 0)
    BIFS_FIELD(NurbsCurve, colorPerVertex, 4, -1, -1, -1, 0, 0)
    BIFS_FIELD1(NurbsCurve, knot, 5, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1_SQ(NurbsCurve, order, 6, -1, -1, -1, 13, 5, 0, 3, 34)
BIFS_IMPLEMENT_NODE_END(NurbsCurve)

BIFS_IMPLEMENT_NODE_START(NurbsCurve2D)
    BIFS_EVENT(NurbsCurve2D, set_colorIndex, 0, -1, 0, 0)
    BIFS_FIELD(NurbsCurve2D, color, 0, 1, 0, -1, 0, 0)
    BIFS_FIELD1(NurbsCurve2D, controlPoint, 1, 2, 1, 0, 2, 2, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(NurbsCurve2D, tessellation, 2, 3, 2, -1, 0, 0, 0, INT_MAX)
    BIFS_FIELD(NurbsCurve2D, colorIndex, 3, -1, -1, -1, 14, 0)
    BIFS_FIELD(NurbsCurve2D, colorPerVertex, 4, -1, -1, -1, 0, 0)
    BIFS_FIELD1(NurbsCurve2D, knot, 5, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1_SQ(NurbsCurve2D, order, 6, -1, -1, -1, 13, 5, 0, 3, 34)
BIFS_IMPLEMENT_NODE_END(NurbsCurve2D)

BIFS_IMPLEMENT_NODE_START(NurbsSurface)
    BIFS_EVENT(NurbsSurface, set_colorIndex, 0, -1, 0, 0)
    BIFS_EVENT(NurbsSurface, set_texColorIndex, 1, -1, 0, 0)
    BIFS_FIELD(NurbsSurface, color, 0, 2, 0, -1, 0, 0)
    BIFS_FIELD1(NurbsSurface, controlPoint, 1, 3, 1, 0, 15, 15, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(NurbsSurface, texCoord, 2, 4, 2, -1, 0, 0)
    BIFS_FIELD1(NurbsSurface, uTessellation, 3, 5, 3, -1, 0, 0, 0, INT_MAX)
    BIFS_FIELD1(NurbsSurface, vTessellation, 4, 6, 4, -1, 0, 0, 0, INT_MAX)
    BIFS_FIELD(NurbsSurface, ccw, 5, -1, -1, -1, 0, 0)
    BIFS_FIELD(NurbsSurface, colorIndex, 6, -1, -1, -1, 14, 0)
    BIFS_FIELD(NurbsSurface, colorPerVertex, 7, -1, -1, -1, 0, 0)
    BIFS_FIELD(NurbsSurface, solid, 8, -1, -1, -1, 0, 0)
    BIFS_FIELD(NurbsSurface, texColorIndex, 9, -1, -1, -1, 14, 0)
    BIFS_FIELD1_SQ(NurbsSurface, uDimension, 10, -1, -1, -1, 13, 8, 0, 3, 258)
    BIFS_FIELD1(NurbsSurface, uKnot, 11, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1_SQ(NurbsSurface, uOrder, 12, -1, -1, -1, 13, 5, 0, 3, 34)
    BIFS_FIELD1_SQ(NurbsSurface, vDimension, 13, -1, -1, -1, 13, 8, 0, 3, 258)
    BIFS_FIELD1(NurbsSurface, vKnot, 14, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1_SQ(NurbsSurface, vOrder, 15, -1, -1, -1, 13, 5, 0, 3, 34)
BIFS_IMPLEMENT_NODE_END(NurbsSurface)

BIFS_IMPLEMENT_NODE_START(OctreeImage)
    BIFS_FIELD(OctreeImage, images, 0, -1, -1, -1, 0, 0)
    BIFS_FIELD1_SQ(OctreeImage, octree, 1, -1, -1, -1, 13, 8, 0, 0, 255)
    BIFS_FIELD1(OctreeImage, octreeResolution, 2, -1, -1, -1, 0, 0, 1, INT_MAX)
    BIFS_FIELD1_SQ(OctreeImage, voxelImageIndex, 3, -1, -1, -1, 13, 8, 0, 0, 255)
BIFS_IMPLEMENT_NODE_END(OctreeImage)

BIFS_IMPLEMENT_NODE_START(XXParticles)
    BIFS_FIELD(XXParticles, creationRate, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(XXParticles, creationRateVariation, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD(XXParticles, emitAlpha, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD(XXParticles, emitColor, 3, 3, 3, -1, 0, 0)
    BIFS_FIELD(XXParticles, emitColorVariation, 4, 4, 4, -1, 0, 0)
    BIFS_FIELD(XXParticles, emitterPosition, 5, 5, 5, -1, 0, 0)
    BIFS_FIELD(XXParticles, emitVelocity, 6, 6, 6, -1, 0, 0)
    BIFS_FIELD(XXParticles, emitVelocityVariation, 7, 7, 7, -1, 0, 0)
    BIFS_FIELD(XXParticles, enabled, 8, 8, 8, -1, 0, 0)
    BIFS_FIELD(XXParticles, fadeAlpha, 9, 9, 9, -1, 0, 0)
    BIFS_FIELD(XXParticles, fadeColor, 10, 10, 10, -1, 0, 0)
    BIFS_FIELD(XXParticles, fadeRate, 11, 11, 11, -1, 0, 0)
    BIFS_FIELD(XXParticles, force, 12, 12, 12, -1, 0, 0)
    BIFS_FIELD(XXParticles, influences, 13, 13, 13, -1, 0, 0)
    BIFS_FIELD(XXParticles, init, 14, 14, 14, -1, 0, 0)
    BIFS_FIELD(XXParticles, maxLifeTime, 15, 15, 15, -1, 0, 0)
    BIFS_FIELD(XXParticles, maxLifeTimeVariation, 16, 16, 16, -1, 0, 0)
    BIFS_FIELD(XXParticles, maxParticles, 17, 17, 17, -1, 0, 0)
    BIFS_FIELD(XXParticles, minRange, 18, 18, 18, -1, 0, 0)
    BIFS_FIELD(XXParticles, maxRange, 19, 19, 19, -1, 0, 0)
    BIFS_FIELD(XXParticles, primitive, 20, 20, 20, -1, 0, 0)
    BIFS_FIELD(XXParticles, primitiveType, 21, 21, 21, -1, 0, 0)
    BIFS_FIELD(XXParticles, particleRadius, 22, 22, 22, -1, 0, 0)
    BIFS_FIELD(XXParticles, particleRadiusRate, 23, 23, 23, -1, 0, 0)
    BIFS_FIELD(XXParticles, particleRadiusVariation, 24, 24, 24, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(XXParticles)

BIFS_IMPLEMENT_NODE_START(XXParticleInitBox)
    BIFS_FIELD(XXParticleInitBox, falloff, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(XXParticleInitBox, size, 1, 1, 1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(XXParticleInitBox)

BIFS_IMPLEMENT_NODE_START(XXPlanarObstacle)
    BIFS_FIELD(XXPlanarObstacle, distance, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(XXPlanarObstacle, normal, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD(XXPlanarObstacle, reflection, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD(XXPlanarObstacle, absorption, 3, 3, 3, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(XXPlanarObstacle)

BIFS_IMPLEMENT_NODE_START(XXPointAttractor)
    BIFS_FIELD(XXPointAttractor, innerRadius, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(XXPointAttractor, outerRadius, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD(XXPointAttractor, position, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD(XXPointAttractor, rate, 3, 3, 3, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(XXPointAttractor)

BIFS_IMPLEMENT_NODE_START(PointTexture)
    BIFS_FIELD(PointTexture, color, 0, -1, -1, -1, 0, 0)
    BIFS_FIELD1(PointTexture, depth, 1, -1, -1, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD1_SQ(PointTexture, depthNbBits, 2, -1, -1, -1, 13, 5, 0, 0, 31)
    BIFS_FIELD1(PointTexture, height, 3, -1, -1, -1, 0, 0, 1, INT_MAX)
    BIFS_FIELD1(PointTexture, width, 4, -1, -1, -1, 0, 0, 1, INT_MAX)
BIFS_IMPLEMENT_NODE_END(PointTexture)

BIFS_IMPLEMENT_NODE_START(PositionAnimator)
    BIFS_EVENT(PositionAnimator, set_fraction, 0, -1, 0, 0)
    BIFS_FIELD(PositionAnimator, fromTo, 0, 1, 0, -1, 8, 0)
    BIFS_FIELD(PositionAnimator, key, 1, 2, 1, -1, 8, 0)
    BIFS_FIELD(PositionAnimator, keyOrientation, 2, 3, 2, -1, 0, 0)
    BIFS_FIELD(PositionAnimator, keyType, 3, 4, 3, -1, 0, 0)
    BIFS_FIELD(PositionAnimator, keySpline, 4, 5, 4, -1, 8, 0)
    BIFS_FIELD(PositionAnimator, keyValue, 5, 6, 5, -1, 4, 0)
    BIFS_FIELD(PositionAnimator, keyValueType, 6, 7, 6, -1, 0, 0)
    BIFS_FIELD1(PositionAnimator, offset, 7, 8, 7, -1, 1, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PositionAnimator, weight, 8, 9, 8, -1, 0, 0, -1, 1)
    BIFS_FIELD(PositionAnimator, endValue, -1, -1, 9, -1, 0, 0)
    BIFS_FIELD(PositionAnimator, rotation_changed, -1, -1, 10, -1, 0, 0)
    BIFS_FIELD(PositionAnimator, value_changed, -1, -1, 11, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(PositionAnimator)

BIFS_IMPLEMENT_NODE_START(PositionAnimator2D)
    BIFS_EVENT(PositionAnimator2D, set_fraction, 0, -1, 0, 0)
    BIFS_FIELD(PositionAnimator2D, fromTo, 0, 1, 0, -1, 8, 0)
    BIFS_FIELD(PositionAnimator2D, key, 1, 2, 1, -1, 8, 0)
    BIFS_FIELD(PositionAnimator2D, keyOrientation, 2, 3, 2, -1, 0, 0)
    BIFS_FIELD(PositionAnimator2D, keyType, 3, 4, 3, -1, 0, 0)
    BIFS_FIELD(PositionAnimator2D, keySpline, 4, 5, 4, -1, 8, 0)
    BIFS_FIELD(PositionAnimator2D, keyValue, 5, 6, 5, -1, 4, 0)
    BIFS_FIELD(PositionAnimator2D, keyValueType, 6, 7, 6, -1, 0, 0)
    BIFS_FIELD1(PositionAnimator2D, offset, 7, 8, 7, -1, 2, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PositionAnimator2D, weight, 8, 9, 8, -1, 0, 0, -1, 1)
    BIFS_FIELD(PositionAnimator2D, endValue, -1, -1, 9, -1, 0, 0)
    BIFS_FIELD(PositionAnimator2D, rotation_changed, -1, -1, 10, -1, 0, 0)
    BIFS_FIELD(PositionAnimator2D, value_changed, -1, -1, 11, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(PositionAnimator2D)

BIFS_IMPLEMENT_NODE_START(PositionInterpolator4D)
    BIFS_EVENT(PositionInterpolator4D, set_fraction, 0, -1, 0, 0)
    BIFS_FIELD1(PositionInterpolator4D, key, 0, 1, 0, -1, 8, 0, 0, 1)
    BIFS_FIELD1(PositionInterpolator4D, keyValue, 1, 2, 1, -1, 15, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(PositionInterpolator4D, value_changed, -1, -1, 2, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(PositionInterpolator4D)

BIFS_IMPLEMENT_NODE_START(ProceduralTexture)
    BIFS_FIELD(ProceduralTexture, aSmooth, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD1(ProceduralTexture, aWarpmap, 1, 1, 1, -1, 2, 0, 0, 1)
    BIFS_FIELD1(ProceduralTexture, aWeights, 2, 2, 2, -1, 0, 0, -1, 1)
    BIFS_FIELD(ProceduralTexture, bSmooth, 3, 3, 3, -1, 0, 0)
    BIFS_FIELD1(ProceduralTexture, bWarpmap, 4, 4, 4, -1, 2, 0, 0, 1)
    BIFS_FIELD1(ProceduralTexture, bWeights, 5, 5, 5, -1, 0, 0, -1, 1)
    BIFS_FIELD1_SQ(ProceduralTexture, cellWidth, 6, 6, 6, -1, 13, 4, 0, 0, 15)
    BIFS_FIELD1_SQ(ProceduralTexture, cellHeight, 7, 7, 7, -1, 13, 4, 0, 0, 15)
    BIFS_FIELD(ProceduralTexture, color, 8, 8, 8, -1, 4, 0)
    BIFS_FIELD1_SQ(ProceduralTexture, distortion, 9, 9, 9, -1, 13, 16, 0, 0, 1)
    BIFS_FIELD1_SQ(ProceduralTexture, height, 10, 10, 10, -1, 13, 4, 0, 1, 15)
    BIFS_FIELD1_SQ(ProceduralTexture, roughness, 11, 11, 11, -1, 13, 4, 0, 0, 15)
    BIFS_FIELD1(ProceduralTexture, seed, 12, 12, 12, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1_SQ(ProceduralTexture, type, 13, 13, 13, -1, 13, 3, 0, 0, 4)
    BIFS_FIELD(ProceduralTexture, xSmooth, 14, 14, 14, -1, 0, 0)
    BIFS_FIELD1(ProceduralTexture, xWarpmap, 15, 15, 15, -1, 2, 0, 0, 1)
    BIFS_FIELD(ProceduralTexture, ySmooth, 16, 16, 16, -1, 0, 0)
    BIFS_FIELD1(ProceduralTexture, yWarpmap, 17, 17, 17, -1, 2, 0, 0, 1)
    BIFS_FIELD1_SQ(ProceduralTexture, width, 18, 18, 18, -1, 13, 4, 0, 1, 15)
    BIFS_FIELD(ProceduralTexture, image_changed, -1, -1, 19, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(ProceduralTexture)

BIFS_IMPLEMENT_NODE_START(Quadric)
    BIFS_FIELD1(Quadric, bboxSize, 0, 0, 0, 0, 11, 11, 0, FLT_MAX)
    BIFS_FIELD1(Quadric, densities, 1, 1, 1, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD(Quadric, dual, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD1(Quadric, P0, 3, 3, 3, 1, 15, 15, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(Quadric, P1, 4, 4, 4, 2, 15, 15, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(Quadric, P2, 5, 5, 5, 3, 15, 15, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(Quadric, P3, 6, 6, 6, 4, 15, 15, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(Quadric, P4, 7, 7, 7, 5, 15, 15, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(Quadric, P5, 8, 8, 8, 6, 15, 15, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(Quadric, solid, 9, 9, 9, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Quadric)

BIFS_IMPLEMENT_NODE_START(SBBone)
    BIFS_EVENT(SBBone, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(SBBone, removeChildren, 1, -1, 0, 0)
    BIFS_FIELD1_SQ(SBBone, boneID, 0, 2, 0, -1, 13, 10, 0, 0, 1023)
    BIFS_FIELD(SBBone, center, 1, 3, 1, 0, 1, 1)
    BIFS_CHILDREN(SBBone, children, 2, 4, 2, -1)
    BIFS_FIELD(SBBone, endpoint, 3, 5, 3, 1, 1, 1)
    BIFS_FIELD1_SQ(SBBone, falloff, 4, 6, 4, -1, 13, 3, 0, -1, 4)
    BIFS_FIELD1_SQ(SBBone, ikChainPosition, 5, 7, 5, -1, 13, 2, 0, 0, 3)
    BIFS_FIELD(SBBone, ikPitchLimit, 6, 8, 6, -1, 0, 0)
    BIFS_FIELD(SBBone, ikRollLimit, 7, 9, 7, -1, 0, 0)
    BIFS_FIELD(SBBone, ikTxLimit, 8, 10, 8, -1, 0, 0)
    BIFS_FIELD(SBBone, ikTyLimit, 9, 11, 9, -1, 0, 0)
    BIFS_FIELD(SBBone, ikTzLimit, 10, 12, 10, -1, 0, 0)
    BIFS_FIELD(SBBone, ikYawLimit, 11, 13, 11, -1, 0, 0)
    BIFS_FIELD(SBBone, rotation, 12, 14, 12, 2, 10, 10)
    BIFS_FIELD1_SQ(SBBone, rotationOrder, 13, 15, 13, -1, 13, 5, 0, 0, 23)
    BIFS_FIELD(SBBone, scale, 14, 16, 14, 3, 7, 11)
    BIFS_FIELD(SBBone, scaleOrientation, 15, 17, 15, 4, 10, 10)
    BIFS_FIELD(SBBone, sectionInner, 16, 18, 16, -1, 0, 0)
    BIFS_FIELD(SBBone, sectionOuter, 17, 19, 17, -1, 0, 0)
    BIFS_FIELD(SBBone, sectionPosition, 18, 20, 18, -1, 0, 0)
    BIFS_FIELD(SBBone, skinCoordIndex, 19, 21, 19, -1, 14, 0)
    BIFS_FIELD1(SBBone, skinCoordWeight, 20, 22, 20, -1, 0, 0, -1, 1)
    BIFS_FIELD(SBBone, translation, 21, 23, 21, 5, 1, 1)
BIFS_IMPLEMENT_NODE_END(SBBone)

BIFS_IMPLEMENT_NODE_START(SBMuscle)
    BIFS_FIELD1_SQ(SBMuscle, falloff, 0, 0, 0, -1, 13, 3, 0, -1, 4)
    BIFS_FIELD(SBMuscle, muscleCurve, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD1_SQ(SBMuscle, muscleID, 2, 2, 2, -1, 13, 10, 0, 0, 1023)
    BIFS_FIELD(SBMuscle, radius, 3, 3, 3, 0, 7, 11)
    BIFS_FIELD1(SBMuscle, skinCoordIndex, 4, 4, 4, -1, 14, 0, 0, FLT_MAX)
    BIFS_FIELD1(SBMuscle, skinCoordWeight, 5, 5, 5, -1, 0, 0, -1, 1)
BIFS_IMPLEMENT_NODE_END(SBMuscle)

BIFS_IMPLEMENT_NODE_START(SBSegment)
    BIFS_EVENT(SBSegment, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(SBSegment, removeChildren, 1, -1, 0, 0)
    BIFS_FIELD(SBSegment, centerOfMass, 0, 2, 0, 0, 1, 1)
    BIFS_CHILDREN(SBSegment, children, 1, 3, 1, -1)
    BIFS_FIELD(SBSegment, mass, 2, 4, 2, -1, 0, 0)
    BIFS_FIELD(SBSegment, momentsOfInertia, 3, 5, 3, -1, 0, 0)
    BIFS_FIELD(SBSegment, name, 4, 6, 4, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(SBSegment)

BIFS_IMPLEMENT_NODE_START(SBSite)
    BIFS_EVENT(SBSite, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(SBSite, removeChildren, 1, -1, 0, 0)
    BIFS_FIELD(SBSite, center, 0, 2, 0, 0, 1, 1)
    BIFS_CHILDREN(SBSite, children, 1, 3, 1, -1)
    BIFS_FIELD(SBSite, name, 2, 4, 2, -1, 0, 0)
    BIFS_FIELD(SBSite, rotation, 3, 5, 3, 1, 10, 10)
    BIFS_FIELD(SBSite, scale, 4, 6, 4, 2, 7, 11)
    BIFS_FIELD(SBSite, scaleOrientation, 5, 7, 5, 3, 10, 10)
    BIFS_FIELD(SBSite, translation, 6, 8, 6, 4, 1, 1)
BIFS_IMPLEMENT_NODE_END(SBSite)

BIFS_IMPLEMENT_NODE_START(SBSkinnedModel)
    BIFS_FIELD(SBSkinnedModel, bones, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(SBSkinnedModel, center, 1, 1, 1, 0, 1, 1)
    BIFS_FIELD(SBSkinnedModel, muscles, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD(SBSkinnedModel, name, 3, 3, 3, -1, 0, 0)
    BIFS_FIELD(SBSkinnedModel, rotation, 4, 4, 4, 1, 10, 10)
    BIFS_FIELD(SBSkinnedModel, segments, 5, 5, 5, -1, 0, 0)
    BIFS_FIELD(SBSkinnedModel, scale, 6, 6, 6, 2, 7, 11)
    BIFS_FIELD(SBSkinnedModel, scaleOrientation, 7, 7, 7, 3, 10, 10)
    BIFS_FIELD(SBSkinnedModel, sites, 8, 8, 8, -1, 0, 0)
    BIFS_FIELD(SBSkinnedModel, skeleton, 9, 9, 9, -1, 0, 0)
    BIFS_FIELD(SBSkinnedModel, skin, 10, 10, 10, -1, 0, 0)
    BIFS_FIELD(SBSkinnedModel, skinCoord, 11, 11, 11, -1, 0, 0)
    BIFS_FIELD(SBSkinnedModel, skinNormal, 12, 12, 12, -1, 0, 0)
    BIFS_FIELD(SBSkinnedModel, translation, 13, 13, 13, 4, 1, 1)
    BIFS_FIELD(SBSkinnedModel, weighsComputationSkinCoord, 14, 14, 14, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(SBSkinnedModel)

BIFS_IMPLEMENT_NODE_START(SBVCAnimation)
    BIFS_FIELD(SBVCAnimation, url, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(SBVCAnimation, virtualCharacters, 1, 1, 1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(SBVCAnimation)

BIFS_IMPLEMENT_NODE_START(ScalarAnimator)
    BIFS_EVENT(ScalarAnimator, set_fraction, 0, -1, 0, 0)
    BIFS_FIELD(ScalarAnimator, fromTo, 0, 1, 0, -1, 8, 0)
    BIFS_FIELD(ScalarAnimator, key, 1, 2, 1, -1, 8, 0)
    BIFS_FIELD(ScalarAnimator, keyType, 2, 3, 2, -1, 0, 0)
    BIFS_FIELD(ScalarAnimator, keySpline, 3, 4, 3, -1, 8, 0)
    BIFS_FIELD(ScalarAnimator, keyValue, 4, 5, 4, -1, 0, 0)
    BIFS_FIELD(ScalarAnimator, keyValueType, 5, 6, 5, -1, 0, 0)
    BIFS_FIELD(ScalarAnimator, offset, 6, 7, 6, -1, 0, 0)
    BIFS_FIELD1(ScalarAnimator, weight, 7, 8, 7, -1, 0, 0, -1, 1)
    BIFS_FIELD(ScalarAnimator, endValue, -1, -1, 8, -1, 0, 0)
    BIFS_FIELD(ScalarAnimator, value_changed, -1, -1, 9, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(ScalarAnimator)

BIFS_IMPLEMENT_NODE_START(SimpleTexture)
    BIFS_FIELD(SimpleTexture, depth, 0, -1, -1, -1, 0, 0)
    BIFS_FIELD(SimpleTexture, texture, 1, -1, -1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(SimpleTexture)

BIFS_IMPLEMENT_NODE_START(SolidRep)
    BIFS_FIELD1(SolidRep, bboxSize, 0, 0, 0, 0, 11, 11, 0, FLT_MAX)
    BIFS_FIELD1(SolidRep, densityList, 1, 1, 1, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD(SolidRep, solidTree, 2, 2, 2, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(SolidRep)

BIFS_IMPLEMENT_NODE_START(SubdivisionSurface)
    BIFS_EVENT(SubdivisionSurface, set_colorIndex, 0, -1, 0, 0)
    BIFS_EVENT(SubdivisionSurface, set_coordIndex, 1, -1, 0, 0)
    BIFS_EVENT(SubdivisionSurface, set_cornerVertexIndex, 2, -1, 0, 0)
    BIFS_EVENT(SubdivisionSurface, set_creaseEdgeIndex, 3, -1, 0, 0)
    BIFS_EVENT(SubdivisionSurface, set_creaseVertexIndex, 4, -1, 0, 0)
    BIFS_EVENT(SubdivisionSurface, set_dartVertexIndex, 5, -1, 0, 0)
    BIFS_EVENT(SubdivisionSurface, set_texCoordIndex, 6, -1, 0, 0)
    BIFS_FIELD(SubdivisionSurface, color, 0, 7, 0, -1, 0, 0)
    BIFS_FIELD(SubdivisionSurface, coord, 1, 8, 1, -1, 0, 0)
    BIFS_FIELD(SubdivisionSurface, texCoord, 2, 9, 2, -1, 0, 0)
    BIFS_FIELD(SubdivisionSurface, sectors, 3, 10, 3, -1, 0, 0)
    BIFS_FIELD1(SubdivisionSurface, subdivisionLevel, 4, 11, 4, -1, 0, 0, -1, INT_MAX)
    BIFS_FIELD1_SQ(SubdivisionSurface, subdivisionType, 5, 12, 5, -1, 13, 2, 0, 0, 3)
    BIFS_FIELD1_SQ(SubdivisionSurface, subdivisionSubType, 6, 13, 6, -1, 13, 2, 0, 0, 3)
    BIFS_FIELD1(SubdivisionSurface, invisibleEdgeIndex, 7, -1, -1, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD(SubdivisionSurface, ccw, 8, -1, -1, -1, 0, 0)
    BIFS_FIELD1(SubdivisionSurface, colorIndex, 9, -1, -1, -1, 0, 0, -1, FLT_MAX)
    BIFS_FIELD(SubdivisionSurface, colorPerVertex, 10, -1, -1, -1, 0, 0)
    BIFS_FIELD(SubdivisionSurface, convex, 11, -1, -1, -1, 0, 0)
    BIFS_FIELD1(SubdivisionSurface, coordIndex, 12, -1, -1, -1, 0, 0, -1, FLT_MAX)
    BIFS_FIELD1(SubdivisionSurface, cornerVertexIndex, 13, -1, -1, -1, 0, 0, -1, FLT_MAX)
    BIFS_FIELD1(SubdivisionSurface, creaseEdgeIndex, 14, -1, -1, -1, 0, 0, -1, FLT_MAX)
    BIFS_FIELD1(SubdivisionSurface, creaseVertexIndex, 15, -1, -1, -1, 0, 0, -1, FLT_MAX)
    BIFS_FIELD1(SubdivisionSurface, dartVertexIndex, 16, -1, -1, -1, 0, 0, -1, FLT_MAX)
    BIFS_FIELD(SubdivisionSurface, solid, 17, -1, -1, -1, 0, 0)
    BIFS_FIELD1(SubdivisionSurface, texCoordIndex, 18, -1, -1, -1, 0, 0, -1, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(SubdivisionSurface)

BIFS_IMPLEMENT_NODE_START(SubdivSurfaceSector)
    BIFS_FIELD1(SubdivSurfaceSector, flatness, 0, 0, 0, -1, 7, 0, 0, 1)
    BIFS_FIELD(SubdivSurfaceSector, normal, 1, 1, 1, -1, 9, 0)
    BIFS_FIELD1(SubdivSurfaceSector, normalTension, 2, 2, 2, -1, 7, 0, 0, 1)
    BIFS_FIELD1_SQ(SubdivSurfaceSector, tag, 3, 3, 3, -1, 13, 2, 0, 0, 2)
    BIFS_FIELD1(SubdivSurfaceSector, theta, 4, 4, 4, -1, 6, 0, 0, 6.2831853)
    BIFS_FIELD(SubdivSurfaceSector, faceIndex, 5, -1, -1, -1, 14, 0)
    BIFS_FIELD(SubdivSurfaceSector, vertexIndex, 6, -1, -1, -1, 14, 0)
BIFS_IMPLEMENT_NODE_END(SubdivSurfaceSector)

BIFS_IMPLEMENT_NODE_START(WaveletSubdivisionSurface)
    BIFS_FIELD(WaveletSubdivisionSurface, baseMesh, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(WaveletSubdivisionSurface, fieldOfView, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD(WaveletSubdivisionSurface, frequency, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD(WaveletSubdivisionSurface, quality, 3, 3, 3, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(WaveletSubdivisionSurface)

BIFS_IMPLEMENT_NODE_START(Clipper2D)
    BIFS_EVENT(Clipper2D, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(Clipper2D, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(Clipper2D, children, 0, 2, 0, -1)
    BIFS_FIELD(Clipper2D, geometry, 1, 3, 1, -1, 0, 0)
    BIFS_FIELD(Clipper2D, inside, 2, 4, 2, -1, 0, 0)
    BIFS_FIELD(Clipper2D, transform, 3, 5, 3, -1, 0, 0)
    BIFS_FIELD(Clipper2D, XOR, 4, 6, 4, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Clipper2D)

BIFS_IMPLEMENT_NODE_START(ColorTransform)
    BIFS_EVENT(ColorTransform, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(ColorTransform, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(ColorTransform, children, 0, 2, 0, -1)
    BIFS_FIELD1(ColorTransform, mrr, 1, 3, 1, 0, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(ColorTransform, mrg, 2, 4, 2, 1, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(ColorTransform, mrb, 3, 5, 3, 2, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(ColorTransform, mra, 4, 6, 4, 3, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(ColorTransform, tr, 5, 7, 5, 4, 4, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(ColorTransform, mgr, 6, 8, 6, 5, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(ColorTransform, mgg, 7, 9, 7, 6, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(ColorTransform, mgb, 8, 10, 8, 7, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(ColorTransform, mga, 9, 11, 9, 8, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(ColorTransform, tg, 10, 12, 10, 9, 4, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(ColorTransform, mbr, 11, 13, 11, 10, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(ColorTransform, mbg, 12, 14, 12, 11, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(ColorTransform, mbb, 13, 15, 13, 12, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(ColorTransform, mba, 14, 16, 14, 13, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(ColorTransform, tb, 15, 17, 15, 14, 4, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(ColorTransform, mar, 16, 18, 16, 15, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(ColorTransform, mag, 17, 19, 17, 16, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(ColorTransform, mab, 18, 20, 18, 17, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(ColorTransform, maa, 19, 21, 19, 18, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(ColorTransform, ta, 20, 22, 20, 19, 4, 7, -FLT_MAX, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(ColorTransform)

BIFS_IMPLEMENT_NODE_START(XEllipse)
    BIFS_FIELD1(XEllipse, radius, 0, 0, 0, 0, 12, 2, 0, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(XEllipse)

BIFS_IMPLEMENT_NODE_START(LinearGradient)
    BIFS_FIELD1(LinearGradient, endPoint, 0, 0, 0, 0, 5, 2, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(LinearGradient, key, 1, 1, 1, -1, 8, 0, 0, 1)
    BIFS_FIELD1(LinearGradient, keyValue, 2, 2, 2, -1, 4, 0, 0, 1)
    BIFS_FIELD1(LinearGradient, opacity, 3, 3, 3, -1, 7, 0, 0, 1)
    BIFS_FIELD1_SQ(LinearGradient, spreadMethod, 4, 4, 4, -1, 13, 2, 0, 0, 2)
    BIFS_FIELD1(LinearGradient, startPoint, 5, 5, 5, 1, 5, 2, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(LinearGradient, transform, 6, 6, 6, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(LinearGradient)

BIFS_IMPLEMENT_NODE_START(PathLayout)
    BIFS_EVENT(PathLayout, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(PathLayout, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(PathLayout, children, 0, 2, 0, -1)
    BIFS_FIELD(PathLayout, geometry, 1, 3, 1, -1, 0, 0)
    BIFS_FIELD1_SQ(PathLayout, alignment, 2, 4, 2, -1, 13, 2, 0, -1, 1)
    BIFS_FIELD1(PathLayout, pathOffset, 3, 5, 3, 0, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PathLayout, spacing, 4, 6, 4, 1, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(PathLayout, reverseLayout, 5, 7, 5, -1, 0, 0)
    BIFS_FIELD1_SQ(PathLayout, wrapMode, 6, 8, 6, -1, 13, 2, 0, 0, 2)
    BIFS_FIELD(PathLayout, splitText, 7, 9, 7, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(PathLayout)

BIFS_IMPLEMENT_NODE_START(RadialGradient)
    BIFS_FIELD1(RadialGradient, center, 0, 0, 0, 0, 5, 2, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(RadialGradient, focalPoint, 1, 1, 1, 1, 5, 2, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(RadialGradient, key, 2, 2, 2, -1, 8, 0, 0, 1)
    BIFS_FIELD1(RadialGradient, keyValue, 3, 3, 3, -1, 4, 0, 0, 1)
    BIFS_FIELD1(RadialGradient, opacity, 4, 4, 4, -1, 7, 0, 0, 1)
    BIFS_FIELD1(RadialGradient, radius, 5, 5, 5, 2, 12, 7, 0, FLT_MAX)
    BIFS_FIELD1_SQ(RadialGradient, spreadMethod, 6, 6, 6, -1, 13, 2, 0, 0, 2)
    BIFS_FIELD(RadialGradient, transform, 7, 7, 7, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(RadialGradient)

BIFS_IMPLEMENT_NODE_START(SynthesizedTexture)
    BIFS_FIELD1(SynthesizedTexture, translation, 0, 0, 0, 0, 1, 1, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(SynthesizedTexture, rotation, 1, 1, 1, 1, 10, 10, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1_SQ(SynthesizedTexture, pixelWidth, 2, 2, 2, -1, 13, 16, 0, 0, 65535)
    BIFS_FIELD1_SQ(SynthesizedTexture, pixelHeight, 3, 3, 3, -1, 13, 16, 0, 0, 65535)
    BIFS_FIELD(SynthesizedTexture, loop, 4, 4, 4, -1, 0, 0)
    BIFS_FIELD1(SynthesizedTexture, speed, 5, 5, 5, 2, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(SynthesizedTexture, startTime, 6, 6, 6, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(SynthesizedTexture, stopTime, 7, 7, 7, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(SynthesizedTexture, url, 8, 8, 8, -1, 0, 0)
    BIFS_FIELD(SynthesizedTexture, duration_changed, -1, -1, 9, -1, 0, 0)
    BIFS_FIELD(SynthesizedTexture, isActive, -1, -1, 10, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(SynthesizedTexture)

BIFS_IMPLEMENT_NODE_START(TransformMatrix2D)
    BIFS_EVENT(TransformMatrix2D, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(TransformMatrix2D, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(TransformMatrix2D, children, 0, 2, 0, -1)
    BIFS_FIELD1(TransformMatrix2D, mxx, 1, 3, 1, 0, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(TransformMatrix2D, mxy, 2, 4, 2, 1, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(TransformMatrix2D, tx, 3, 5, 3, 2, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(TransformMatrix2D, myx, 4, 6, 4, 3, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(TransformMatrix2D, myy, 5, 7, 5, 4, 7, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(TransformMatrix2D, ty, 6, 8, 6, 5, 7, 7, -FLT_MAX, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(TransformMatrix2D)

BIFS_IMPLEMENT_NODE_START(Viewport)
    BIFS_EVENT(Viewport, set_bind, 0, -1, 0, 0)
    BIFS_FIELD1(Viewport, position, 0, 1, 0, 0, 1, 1, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(Viewport, size, 1, 2, 1, 1, 12, 12, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(Viewport, orientation, 2, 3, 2, 2, 6, 6, 0, 6.2831853)
    BIFS_FIELD1_SQ(Viewport, alignment, 3, 4, 3, -1, 13, 3, 0, -1, 1)
    BIFS_FIELD1_SQ(Viewport, fit, 4, 5, 4, -1, 13, 3, 0, 0, 2)
    BIFS_FIELD(Viewport, description, 5, -1, -1, -1, 0, 0)
    BIFS_FIELD(Viewport, bindTime, -1, -1, 5, -1, 0, 0)
    BIFS_FIELD(Viewport, isBound, -1, -1, 6, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Viewport)

BIFS_IMPLEMENT_NODE_START(XCurve2D)
    BIFS_FIELD(XCurve2D, point, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD1(XCurve2D, fineness, 1, 1, 1, 0, 0, 7, 0, 1)
    BIFS_FIELD1_SQ(XCurve2D, type, 2, 2, 2, -1, 13, 4, 0, 0, 15)
BIFS_IMPLEMENT_NODE_END(XCurve2D)

BIFS_IMPLEMENT_NODE_START(XFontStyle)
    BIFS_FIELD(XFontStyle, fontName, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(XFontStyle, horizontal, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD(XFontStyle, justify, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD(XFontStyle, language, 3, 3, 3, -1, 0, 0)
    BIFS_FIELD(XFontStyle, leftToRight, 4, 4, 4, -1, 0, 0)
    BIFS_FIELD1(XFontStyle, size, 5, 5, 5, -1, 11, 0, 0, FLT_MAX)
    BIFS_FIELD(XFontStyle, stretch, 6, 6, 6, -1, 0, 0)
    BIFS_FIELD1(XFontStyle, letterSpacing, 7, 7, 7, -1, 11, 0, 0, FLT_MAX)
    BIFS_FIELD1(XFontStyle, wordSpacing, 8, 8, 8, -1, 11, 0, 0, FLT_MAX)
    BIFS_FIELD(XFontStyle, weight, 9, 9, 9, -1, 0, 0)
    BIFS_FIELD(XFontStyle, fontKerning, 10, 10, 10, -1, 0, 0)
    BIFS_FIELD(XFontStyle, style, 11, 11, 11, -1, 0, 0)
    BIFS_FIELD(XFontStyle, topToBottom, 12, 12, 12, -1, 0, 0)
    BIFS_FIELD(XFontStyle, featureName, 13, 13, 13, -1, 0, 0)
    BIFS_FIELD1(XFontStyle, featureStartOffset, 14, 14, 14, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(XFontStyle, featureLength, 15, 15, 15, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(XFontStyle, featureValue, 16, 16, 16, -1, 0, 0, -FLT_MAX, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(XFontStyle)

BIFS_IMPLEMENT_NODE_START(XLineProperties)
    BIFS_FIELD1(XLineProperties, lineColor, 0, 0, 0, 0, 4, 4, 0, 1)
    BIFS_FIELD1_SQ(XLineProperties, lineStyle, 1, 1, 1, -1, 13, 3, 0, 0, 5)
    BIFS_FIELD(XLineProperties, isCenterAligned, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD(XLineProperties, isScalable, 3, 3, 3, -1, 0, 0)
    BIFS_FIELD1_SQ(XLineProperties, lineCap, 4, 4, 4, -1, 13, 3, 0, 0, 2)
    BIFS_FIELD1_SQ(XLineProperties, lineJoin, 5, 5, 5, -1, 13, 3, 0, 0, 2)
    BIFS_FIELD1(XLineProperties, miterLimit, 6, 6, 6, -1, 12, 0, 1, FLT_MAX)
    BIFS_FIELD1(XLineProperties, transparency, 7, 7, 7, 1, 4, 8, 0, 1)
    BIFS_FIELD1(XLineProperties, width, 8, 8, 8, 2, 12, 7, 0, FLT_MAX)
    BIFS_FIELD1(XLineProperties, dashOffset, 9, 9, 9, 3, 12, 7, 0, FLT_MAX)
    BIFS_FIELD1(XLineProperties, dashes, 10, 10, 10, 4, 12, 7, 0, FLT_MAX)
    BIFS_FIELD(XLineProperties, texture, 11, 11, 11, -1, 0, 0)
    BIFS_FIELD(XLineProperties, textureTransform, 12, 12, 12, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(XLineProperties)

BIFS_IMPLEMENT_NODE_START(AdvancedAudioBuffer)
    BIFS_EVENT(AdvancedAudioBuffer, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(AdvancedAudioBuffer, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(AdvancedAudioBuffer, children, 0, 2, 0, -1)
    BIFS_FIELD(AdvancedAudioBuffer, loop, 1, 3, 1, -1, 0, 0)
    BIFS_FIELD1(AdvancedAudioBuffer, pitch, 2, 4, 2, 0, 0, 7, 0, FLT_MAX)
    BIFS_FIELD1(AdvancedAudioBuffer, startTime, 3, 5, 3, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD1(AdvancedAudioBuffer, stopTime, 4, 6, 4, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD1(AdvancedAudioBuffer, startLoadTime, 5, 7, 5, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD1(AdvancedAudioBuffer, stopLoadTime, 6, 8, 6, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD1_SQ(AdvancedAudioBuffer, loadMode, 7, 9, 7, -1, 13, 3, 0, 0, 4)
    BIFS_FIELD1_SQ(AdvancedAudioBuffer, numAccumulatedBlocks, 8, 10, 8, -1, 13, 16, 0, 0, 65535)
    BIFS_FIELD1_SQ(AdvancedAudioBuffer, deleteBlock, 9, 11, 9, -1, 13, 17, 0, -65536, 0)
    BIFS_FIELD1_SQ(AdvancedAudioBuffer, playBlock, 10, 12, 10, -1, 13, 17, 0, -65536, 0)
    BIFS_FIELD1(AdvancedAudioBuffer, length, 11, 13, 11, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD1_SQ(AdvancedAudioBuffer, numChan, 12, -1, -1, -1, 13, 8, 0, 0, 255)
    BIFS_FIELD1_SQ(AdvancedAudioBuffer, phaseGroup, 13, -1, -1, -1, 13, 8, 0, 0, 255)
    BIFS_FIELD(AdvancedAudioBuffer, duration_changed, -1, -1, 12, -1, 0, 0)
    BIFS_FIELD(AdvancedAudioBuffer, isActive, -1, -1, 13, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(AdvancedAudioBuffer)

BIFS_IMPLEMENT_NODE_START(AudioChannelConfig)
    BIFS_EVENT(AudioChannelConfig, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(AudioChannelConfig, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(AudioChannelConfig, children, 0, 2, 0, -1)
    BIFS_FIELD1_SQ(AudioChannelConfig, generalChannelFormat, 1, 3, 1, -1, 13, 3, 0, 0, 4)
    BIFS_FIELD1_SQ(AudioChannelConfig, fixedPreset, 2, 4, 2, -1, 13, 4, 0, 0, 15)
    BIFS_FIELD(AudioChannelConfig, fixedPresetSubset, 3, 5, 3, -1, 0, 0)
    BIFS_FIELD1_SQ(AudioChannelConfig, fixedPresetAddInf, 4, 6, 4, -1, 13, 3, 0, 0, 2)
    BIFS_FIELD1_SQ(AudioChannelConfig, channelCoordinateSystems, 5, 7, 5, -1, 13, 3, 0, 0, 6)
    BIFS_FIELD1(AudioChannelConfig, channelSoundLocation, 6, 8, 6, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1_SQ(AudioChannelConfig, channelDirectionalPattern, 7, 9, 7, -1, 13, 3, 0, 0, 2)
    BIFS_FIELD(AudioChannelConfig, channelDirection, 8, 10, 8, -1, 0, 0)
    BIFS_FIELD1_SQ(AudioChannelConfig, ambResolution2D, 9, 11, 9, -1, 13, 7, 0, 0, 127)
    BIFS_FIELD1_SQ(AudioChannelConfig, ambResolution3D, 10, 12, 10, -1, 13, 4, 0, 0, 15)
    BIFS_FIELD1_SQ(AudioChannelConfig, ambEncodingConvention, 11, 13, 11, -1, 13, 3, 0, 0, 5)
    BIFS_FIELD1(AudioChannelConfig, ambNfcReferenceDistance, 12, 14, 12, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD1(AudioChannelConfig, ambSoundSpeed, 13, 15, 13, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD1_SQ(AudioChannelConfig, ambArrangementRule, 14, 16, 14, -1, 13, 3, 0, 0, 7)
    BIFS_FIELD1_SQ(AudioChannelConfig, ambRecombinationPreset, 15, 17, 15, -1, 13, 4, 0, 0, 15)
    BIFS_FIELD1_SQ(AudioChannelConfig, ambComponentIndex, 16, 18, 16, -1, 13, 8, 0, 0, 255)
    BIFS_FIELD1(AudioChannelConfig, ambBackwardMatrix, 17, 19, 17, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1_SQ(AudioChannelConfig, ambSoundfieldResolution, 18, 20, 18, -1, 13, 7, 0, 0, 127)
    BIFS_FIELD1_SQ(AudioChannelConfig, numChannel, 19, -1, -1, -1, 13, 8, 0, 0, 255)
BIFS_IMPLEMENT_NODE_END(AudioChannelConfig)

BIFS_IMPLEMENT_NODE_START(DepthImageV2)
    BIFS_FIELD(DepthImageV2, diTexture, 0, -1, -1, -1, 0, 0)
    BIFS_FIELD1(DepthImageV2, farPlane, 1, -1, -1, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD1(DepthImageV2, fieldOfView, 2, -1, -1, -1, 0, 0, 0, 3.1415927)
    BIFS_FIELD1(DepthImageV2, nearPlane, 3, -1, -1, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD(DepthImageV2, orientation, 4, -1, -1, -1, 0, 0)
    BIFS_FIELD(DepthImageV2, orthographic, 5, -1, -1, -1, 0, 0)
    BIFS_FIELD1(DepthImageV2, position, 6, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(DepthImageV2, splatMinMax, 7, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(DepthImageV2)

BIFS_IMPLEMENT_NODE_START(MorphShape)
    BIFS_FIELD(MorphShape, baseShape, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD1_SQ(MorphShape, morphID, 1, 1, 1, -1, 13, 7, 0, 0, 1023)
    BIFS_FIELD(MorphShape, targetShapes, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD(MorphShape, weights, 3, 3, 3, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(MorphShape)

BIFS_IMPLEMENT_NODE_START(MultiTexture)
    BIFS_FIELD1(MultiTexture, alpha, 0, 0, 0, -1, 0, 0, 0, 1)
    BIFS_FIELD1(MultiTexture, color, 1, 1, 1, -1, 0, 0, 0, 1)
    BIFS_FIELD(MultiTexture, function, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD(MultiTexture, mode, 3, 3, 3, -1, 0, 0)
    BIFS_FIELD(MultiTexture, source, 4, 4, 4, -1, 0, 0)
    BIFS_FIELD(MultiTexture, texture, 5, 5, 5, -1, 0, 0)
    BIFS_FIELD(MultiTexture, cameraVector, 6, 6, 6, -1, 0, 0)
    BIFS_FIELD(MultiTexture, transparent, 7, 7, 7, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(MultiTexture)

BIFS_IMPLEMENT_NODE_START(MultiTextureCoordinate)
    BIFS_FIELD(MultiTextureCoordinate, texCoord, 0, 0, 0, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(MultiTextureCoordinate)

BIFS_IMPLEMENT_NODE_START(PointTextureV2)
    BIFS_FIELD(PointTextureV2, color, 0, -1, -1, -1, 0, 0)
    BIFS_FIELD1(PointTextureV2, depth, 1, -1, -1, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD1_SQ(PointTextureV2, depthNbBits, 2, -1, -1, -1, 13, 5, 0, 0, 31)
    BIFS_FIELD1(PointTextureV2, height, 3, -1, -1, -1, 0, 0, 1, INT_MAX)
    BIFS_FIELD1(PointTextureV2, normal, 4, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PointTextureV2, splatU, 5, -1, -1, -1, 1, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PointTextureV2, splatV, 6, -1, -1, -1, 1, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PointTextureV2, width, 7, -1, -1, -1, 0, 0, 1, INT_MAX)
BIFS_IMPLEMENT_NODE_END(PointTextureV2)

BIFS_IMPLEMENT_NODE_START(SBVCAnimationV2)
    BIFS_FIELD(SBVCAnimationV2, activeUrlIndex, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(SBVCAnimationV2, loop, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD1(SBVCAnimationV2, speed, 2, 2, 2, 0, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(SBVCAnimationV2, startTime, 3, 3, 3, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(SBVCAnimationV2, stopTime, 4, 4, 4, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(SBVCAnimationV2, transitionTime, 5, 5, 5, 1, 0, 7, 0, FLT_MAX)
    BIFS_FIELD(SBVCAnimationV2, url, 6, 6, 6, -1, 0, 0)
    BIFS_FIELD(SBVCAnimationV2, virtualCharacters, 7, 7, 7, -1, 0, 0)
    BIFS_FIELD(SBVCAnimationV2, duration_changed, -1, -1, 8, -1, 0, 0)
    BIFS_FIELD(SBVCAnimationV2, isActive, -1, -1, 9, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(SBVCAnimationV2)

BIFS_IMPLEMENT_NODE_START(SimpleTextureV2)
    BIFS_FIELD(SimpleTextureV2, depth, 0, -1, -1, -1, 0, 0)
    BIFS_FIELD(SimpleTextureV2, normal, 1, -1, -1, -1, 0, 0)
    BIFS_FIELD(SimpleTextureV2, splatU, 2, -1, -1, -1, 0, 0)
    BIFS_FIELD(SimpleTextureV2, splatV, 3, -1, -1, -1, 0, 0)
    BIFS_FIELD(SimpleTextureV2, texture, 4, -1, -1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(SimpleTextureV2)

BIFS_IMPLEMENT_NODE_START(SurroundingSound)
    BIFS_FIELD(SurroundingSound, source, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD1(SurroundingSound, intensity, 1, 1, 1, 0, 0, 7, 0, 1)
    BIFS_FIELD1(SurroundingSound, distance, 2, 2, 2, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD1(SurroundingSound, location, 3, 3, 3, 1, 1, 1, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(SurroundingSound, distortionFactor, 4, 4, 4, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(SurroundingSound, orientation, 5, 5, 5, 2, 10, 10, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(SurroundingSound, isTransformable, 6, 6, 6, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(SurroundingSound)

BIFS_IMPLEMENT_NODE_START(Transform3DAudio)
    BIFS_EVENT(Transform3DAudio, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(Transform3DAudio, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(Transform3DAudio, children, 0, 2, 0, -1)
    BIFS_FIELD1(Transform3DAudio, thirdCenterCoordinate, 1, 3, 1, 0, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(Transform3DAudio, rotationVector, 2, 4, 2, 1, 7, 11, -PI, PI)
    BIFS_FIELD1(Transform3DAudio, thirdScaleCoordinate, 3, 5, 3, 2, 0, 7, 0, FLT_MAX)
    BIFS_FIELD1(Transform3DAudio, scaleOrientationVector, 4, 6, 4, 3, 7, 11, -1, 1)
    BIFS_FIELD1(Transform3DAudio, thirdTranslationCoordinate, 5, 7, 5, 4, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(Transform3DAudio, coordinateTransform, 6, 8, 6, -1, 10, 0, -PI, PI)
BIFS_IMPLEMENT_NODE_END(Transform3DAudio)

BIFS_IMPLEMENT_NODE_START(WideSound)
    BIFS_FIELD(WideSound, source, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD1(WideSound, intensity, 1, 1, 1, 0, 0, 7, 0, 1)
    BIFS_FIELD1(WideSound, location, 2, 2, 2, 1, 1, 1, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(WideSound, spatialize, 3, 3, 3, -1, 0, 0)
    BIFS_FIELD(WideSound, perceptualParameters, 4, 4, 4, -1, 0, 0)
    BIFS_FIELD(WideSound, roomEffect, 5, 5, 5, -1, 0, 0)
    BIFS_FIELD1_SQ(WideSound, shape, 6, 6, 6, -1, 13, 4, 0, 0, 4)
    BIFS_FIELD1(WideSound, size, 7, 7, 7, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(WideSound, direction, 8, 8, 8, 2, 9, 9, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(WideSound, density, 9, 9, 9, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD1(WideSound, diffuseSelect, 10, 10, 10, -1, 0, 0, 0, INT_MAX)
    BIFS_FIELD1(WideSound, decorrStrength, 11, 11, 11, -1, 0, 0, 0, 1)
    BIFS_FIELD1(WideSound, speedOfSound, 12, -1, -1, -1, 1, 0, 0, FLT_MAX)
    BIFS_FIELD1(WideSound, distance, 13, -1, -1, -1, 0, 0, 0, FLT_MAX)
    BIFS_FIELD(WideSound, useAirabs, 14, -1, -1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(WideSound)

BIFS_IMPLEMENT_NODE_START(FootPrintSet)
	BIFS_EVENT(FootPrintSet, addChildren, 0, -1, 0, 0)
   	BIFS_EVENT(FootPrintSet, removeChildren, 1, -1, 0, 0)
	BIFS_CHILDREN(FootPrintSet, children, 0, 2, 0, -1)
BIFS_IMPLEMENT_NODE_END(FootPrintSet)

BIFS_IMPLEMENT_NODE_START(FootPrint)
	BIFS_FIELD(FootPrint, index, 0, 0, 0, -1, 0, 0)
	BIFS_FIELD(FootPrint, footprint, 1, 1, 1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(FootPrint)

BIFS_IMPLEMENT_NODE_START(BuildingPart)
	BIFS_FIELD(BuildingPart, alternativeGeometry, 0, 0, 0, -1, 0, 0)
	BIFS_FIELD(BuildingPart, roofs, 1, 1, 1, -1, 0, 0)
	BIFS_FIELD(BuildingPart, facades, 2, 2, 2, -1, 0, 0)
	BIFS_FIELD1(BuildingPart, index, 3, 3, 3, -1, 0, 0, -1, INT_MAX)
	BIFS_FIELD(BuildingPart, footprint, 4, 4, 4, -1, 0, 0)
	BIFS_FIELD1(BuildingPart, buildingIndex, 5, 5, 5, -1, 0, 0, -1, INT_MAX)
	BIFS_FIELD1(BuildingPart, height, 6, 6, 6, -1, 0, 0, -FLT_MAX, FLT_MAX)
	BIFS_FIELD1(BuildingPart, altitude, 7, 7, 7, -1, 0, 0, -FLT_MAX, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(BuildingPart)

BIFS_IMPLEMENT_NODE_START(Roof)
	BIFS_FIELD1(Roof, Type, 0, 0, 0, -1, 0, 0, 0, INT_MAX)
	BIFS_FIELD1(Roof, Height, 1, 1, 1, -1, 0, 0, 0, FLT_MAX)
	BIFS_FIELD1(Roof, SlopeAngle, 2, 2, 2, -1, 0, 0, -PI, PI)
	BIFS_FIELD1(Roof, EaveProjection, 3, 3, 3, -1, 0, 0, 0, FLT_MAX)
	BIFS_FIELD1(Roof, EdgeSupportIndex, 4, 4, 4, -1, 0, 0, -1, INT_MAX)
	BIFS_FIELD(Roof, RoofTextureURL, 5, 5, 5, -1, 0, 0)
	BIFS_FIELD(Roof, IsGenericTexture, 6, 6, 6, -1, 0, 0)
	BIFS_FIELD1(Roof, TextureXScale, 7, 7, 7, -1, 0, 0, -FLT_MAX, FLT_MAX)
	BIFS_FIELD1(Roof, TextureYScale, 8, 8, 8, -1, 0, 0, -FLT_MAX, FLT_MAX)
	BIFS_FIELD1(Roof, TextureXPosition, 9, 9, 9, -1, 0, 0, -FLT_MAX, FLT_MAX)
	BIFS_FIELD1(Roof, TextureYPosition, 10, 10, 10, -1, 0, 0, -FLT_MAX, FLT_MAX)
	BIFS_FIELD1(Roof, TextureRotation, 11, 11, 11, -1, 0, 0, -PI, PI)
BIFS_IMPLEMENT_NODE_END(Roof)

BIFS_IMPLEMENT_NODE_START(Facade)
	BIFS_FIELD(Facade, FacadeCellsArray, 0, 0, 0, -1, 0, 0)
	BIFS_FIELD1(Facade, WidthRatio, 1, 1, 1, -1, 0, 0, 0, 1)
	BIFS_FIELD1(Facade, XScale, 2, 2, 2, -1, 0, 0, -FLT_MAX, FLT_MAX)
	BIFS_FIELD1(Facade, YScale, 3, 3, 3, -1, 0, 0, -FLT_MAX, FLT_MAX)
	BIFS_FIELD1(Facade, XPosition, 4, 4, 4, -1, 0, 0, -FLT_MAX, FLT_MAX)
	BIFS_FIELD1(Facade, YPosition, 5, 5, 5, -1, 0, 0, -FLT_MAX, FLT_MAX)
	BIFS_FIELD1(Facade, XRepeatInterval, 6, 6, 6, -1, 0, 0, -FLT_MAX, FLT_MAX)
	BIFS_FIELD1(Facade, YRepeatInterval, 7, 7, 7, -1, 0, 0, -FLT_MAX, FLT_MAX)
	BIFS_FIELD(Facade, Repeat, 8, 8, 8, -1, 0, 0)
	BIFS_FIELD(Facade, FacadePrimitive, 9, 9, 9, -1, 0, 0)
	BIFS_FIELD1(Facade, NbStories, 10, 10, 10, -1, 0, 0, 0, INT_MAX)
	BIFS_FIELD1(Facade, NbFacadeCellsByStorey, 11, 11, 11, -1, 0, 0, 0, INT_MAX)
	BIFS_FIELD1(Facade, StoryHeight, 12, 12, 12, -1, 0, 0, 0, 1)	
BIFS_IMPLEMENT_NODE_END(Facade)

BIFS_IMPLEMENT_NODE_START(Shadow)
    BIFS_EVENT(Shadow, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(Shadow, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(Shadow, children, 0, 2, 0, -1)
    BIFS_FIELD(Shadow, enabled, 1, 3, 1, -1, 0, 0)
    BIFS_FIELD(Shadow, cast, 2, 4, 2, -1, 0, 0)
    BIFS_FIELD(Shadow, receive, 3, 5, 3, -1, 0, 0)
    BIFS_FIELD1(Shadow, penumbra, 4, 6, 4, 0, 0, 7, 0, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(Shadow)


/* End of automatically generated file */
