<?xml version="1.0"?>

<!-- This XSLT file is courtesy of Lyndon Nixon/GMD FOKUS and should not be changed without
the authors permission; it may be used as long as the author is credited. Lyndon J 
Nixon can be contacted at nixon@fokus.gmd.de -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:import href = "XMT2MUX.xsl"/>

<xsl:output method="text" omit-xml-declaration="yes" indent="yes" />

   <xsl:template match="/">
   <xsl:apply-templates select="XMT-A/Body/*" />
   </xsl:template>
   
   <xsl:template name="IS">
   <xsl:for-each select="IS/connect"><xsl:value-of select="@nodeField"/> IS <xsl:value-of select="@protoField"/><xsl:text>
   </xsl:text>
   </xsl:for-each>
   </xsl:template>

  <!-- note on proper usage: this stylesheet will allow the XMT instance to omit the
 par/Replace/Scene tags which are required by the XMT schema to wrap the
 scene description.However only using par/Replace/Scene will ensure the
 transformation of the XMT scene in the correct order. -->
   
   <xsl:template match="par">
   AT  <xsl:value-of select="@begin" /> {
   <xsl:apply-templates select="Replace | Insert | Delete" /> 
   <xsl:apply-templates select="ObjectDescriptorUpdate|ObjectDescriptorRemove|
   ES_DescriptorUpdate|ES_DescriptorRemove|IPMP_DescriptorUpdate|
   IPMP_DescriptorRemove|IPMP_Message|OCI_Event|JavaStreamHeader" /> 
   <xsl:apply-templates select="par" /> 
   }
   </xsl:template>    
   
   <!-- the atES_ID attribute of the BIFS and Descriptor commands is not handled. It is assumed
   seperate Elementary Streams of type BIFS will be passed to the XSLT in seperate XMT instance files -->
   
   <xsl:template match="Insert">
   
   <xsl:for-each select="ROUTE">
   INSERT <xsl:apply-templates select="."/>
   </xsl:for-each>
   <xsl:choose>
   	 <xsl:when test="contains(@position,',')">
   	 <xsl:call-template name="InsertCommands">
	 <xsl:with-param name="first" select="substring-before(@position,',')" />
	 <xsl:with-param name="rest" select="substring-after(@position,',')" />
	 <xsl:with-param name="valueNow" select="substring-before(@value,',')" />
	 <xsl:with-param name="valueNext" select="substring-after(@value,',')" />
	 <xsl:with-param name="counter" select="2" />
	 </xsl:call-template>
	 </xsl:when>
	 <xsl:otherwise>
	 <xsl:call-template name="InsertCommands">
	 <xsl:with-param name="first" select="@position" />
	 <xsl:with-param name="valueNow" select="@value" />
	 <xsl:with-param name="counter" select="2" />
	 </xsl:call-template>
	 </xsl:otherwise>
</xsl:choose>	
	
	</xsl:template>
   
   <xsl:template name="InsertCommands">
	<xsl:param name="first" />
	<xsl:param name="rest" />
	<xsl:param name="valueNow" />
	<xsl:param name="valueNext" />
	<xsl:param name="counter" />
	<xsl:choose>
   <xsl:when test="$first='END' or not($first)">
   APPEND TO <xsl:value-of select="@atNode"/><xsl:choose>
   <xsl:when test="@atField">.<xsl:value-of select="@atField"/> </xsl:when>
   <xsl:otherwise>.children</xsl:otherwise>
   </xsl:choose>
   <xsl:if test="$valueNow">
   <xsl:text> </xsl:text> <xsl:value-of select="$valueNow"/> </xsl:if>
   <xsl:text> </xsl:text>
   <xsl:apply-templates select="node()[not(self::ROUTE) and position() = $counter]" />
   <xsl:if test="not($rest)">
   <xsl:text> </xsl:text>
   </xsl:if>
   </xsl:when>
   <xsl:when test="$first">
   INSERT AT <xsl:value-of select="@atNode"/> <xsl:choose>
   <xsl:when test="@atField">.<xsl:value-of select="@atField"/> </xsl:when>
   <xsl:otherwise>.children</xsl:otherwise>
   </xsl:choose>
   <xsl:choose>
   <xsl:when test="$first='BEGIN'">[0]</xsl:when>
   <xsl:otherwise>[<xsl:value-of select="$first"/>]</xsl:otherwise>
   </xsl:choose>
   <xsl:if test="$valueNow"><xsl:text> </xsl:text><xsl:value-of select="$valueNow"/><xsl:if test="contains($valueNow,' ')">"</xsl:if></xsl:if>
   <xsl:text> </xsl:text><xsl:apply-templates select="node()[not(self::ROUTE) and position() = $counter]" />
   <xsl:if test="not($rest)"><xsl:text> </xsl:text>
   </xsl:if>
   </xsl:when>
   </xsl:choose>
	<xsl:if test="$rest">
	<xsl:choose>
	<xsl:when test="contains($rest,',')">
		<xsl:call-template name="InsertCommands">
		<xsl:with-param name="first" select="substring-before($rest,',')" />
	  	<xsl:with-param name="rest" select="substring-after($rest,',')" />
	  	<xsl:with-param name="valueNow" select="substring-before($valueNext,',')" />
	  	<xsl:with-param name="valueNext" select="substring-after($valueNext,',')" />
	  	<xsl:with-param name="counter" select="$counter + 2" />
		</xsl:call-template>
	</xsl:when>
	<xsl:otherwise>
		<xsl:call-template name="InsertCommands">
		<xsl:with-param name="first" select="$rest" />
		<xsl:with-param name="valueNow" select="$valueNext" />
		<xsl:with-param name="counter" select="$counter + 2" />
		</xsl:call-template>
	</xsl:otherwise>
	</xsl:choose>
</xsl:if>
</xsl:template>
   
   <xsl:template match="Delete">
   
   <xsl:if test="@atRoute">
   DELETE ROUTE  <xsl:value-of select="@atRoute"/> </xsl:if>
   <xsl:choose>
   	 <xsl:when test="contains(@position,',')">
   	 <xsl:call-template name="DeleteCommands">
	 <xsl:with-param name="first" select="substring-before(@position,',')" />
	 <xsl:with-param name="rest" select="substring-after(@position,',')" />
	 </xsl:call-template>
	 </xsl:when>
	 <xsl:otherwise>
	 <xsl:call-template name="DeleteCommands">
	 <xsl:with-param name="first" select="@position" />
	 </xsl:call-template>
	 </xsl:otherwise>
	</xsl:choose>	
   </xsl:template>
   
   <xsl:template name="DeleteCommands">
	<xsl:param name="first" />
	<xsl:param name="rest" />
   <xsl:choose>
   <xsl:when test="$first='END'">	
   DELETE LAST  <xsl:value-of select="@atNode"/> <xsl:choose>
   <xsl:when test="@atField">.<xsl:value-of select="@atField"/> </xsl:when>
   <xsl:otherwise>.children</xsl:otherwise>
   </xsl:choose>
   </xsl:when>
   <xsl:otherwise>
   DELETE  <xsl:value-of select="@atNode"/> <xsl:choose>
   <xsl:when test="@atField">.<xsl:value-of select="@atField"/></xsl:when>
   <xsl:otherwise>.children</xsl:otherwise>
   </xsl:choose>
   <xsl:if test="$first">
   <xsl:choose>
   <xsl:when test="$first='BEGIN'">[0]</xsl:when>
   <xsl:otherwise>[<xsl:value-of select="$first"/>] </xsl:otherwise>
   </xsl:choose>
   </xsl:if>
   </xsl:otherwise>
   </xsl:choose>
	<xsl:if test="$rest">
	<xsl:choose>
	<xsl:when test="contains($rest,',')">
		<xsl:call-template name="DeleteCommands">
		<xsl:with-param name="first" select="substring-before($rest,',')" />
	  	<xsl:with-param name="rest" select="substring-after($rest,',')" />
		</xsl:call-template>
	</xsl:when>
	<xsl:otherwise>
		<xsl:call-template name="DeleteCommands">
		<xsl:with-param name="first" select="$rest" />
		</xsl:call-template>
	</xsl:otherwise>
	</xsl:choose>
</xsl:if>
</xsl:template>
   
   <xsl:template match="Replace">
   <xsl:if test="Scene">
   <xsl:apply-templates select="Scene" />
   </xsl:if>   
   <xsl:if test="@atRoute">
   REPLACE ROUTE  <xsl:value-of select="@atRoute"/> BY <xsl:value-of select="ROUTE/@fromNode"/>.<xsl:value-of select="ROUTE/@fromField"/> TO  <xsl:value-of select="ROUTE/@toNode"/>.<xsl:value-of select="ROUTE/@toField"/>
   </xsl:if>
   <xsl:if test="@atNode">
    <xsl:choose>
   	 <xsl:when test="contains(@position,',')">
   	 <xsl:call-template name="ReplaceCommands">
	 <xsl:with-param name="first" select="substring-before(@position,',')" />
	 <xsl:with-param name="rest" select="substring-after(@position,',')" />
	 <xsl:with-param name="valueNow" select="substring-before(@value,',')" />
	 <xsl:with-param name="valueNext" select="substring-after(@value,',')" />
	 <xsl:with-param name="counter" select="2" />
	 </xsl:call-template>
	 </xsl:when>
	 <xsl:otherwise>
	 <xsl:call-template name="ReplaceCommands">
	 <xsl:with-param name="first" select="@position" />
	 <xsl:with-param name="valueNow" select="@value" />
	 <xsl:with-param name="counter" select="2" />
	 </xsl:call-template>
	 </xsl:otherwise>
	</xsl:choose>	
   </xsl:if>
   
   </xsl:template>
   
   <xsl:template name="ReplaceCommands">
	<xsl:param name="first" />
	<xsl:param name="rest" />
	<xsl:param name="valueNow" />
	<xsl:param name="valueNext" />
	<xsl:param name="counter" />
	<xsl:choose>
	<xsl:when test="$first='END'">
   REPLACE LAST  <xsl:value-of select="@atNode"/> 
   <xsl:if test="@atField">.<xsl:value-of select="@atField"/> </xsl:if>
    BY <xsl:if test="$valueNow"><xsl:value-of select="$valueNow"/></xsl:if>
   <xsl:apply-templates select="node()[not(self::ROUTE) and not(self::Scene) and position() = $counter]" />
   </xsl:when>
   <xsl:otherwise>
   REPLACE  <xsl:value-of select="@atNode"/> 
   <xsl:if test="@atField">.<xsl:value-of select="@atField"/> </xsl:if>
   <xsl:if test="$first">
   <xsl:choose>
   <xsl:when test="$first='BEGIN'">[0]</xsl:when>
   <xsl:otherwise>[<xsl:value-of select="$first"/>] </xsl:otherwise>
   </xsl:choose></xsl:if> BY <xsl:choose>
   <xsl:when test="contains($valueNow,',') and not($first)">
   [<xsl:call-template name="MFFields"><xsl:with-param name="valueNow" select="substring-before($valueNow,',')" /><xsl:with-param name="valueNext" select="substring-after($valueNow,',')" /></xsl:call-template>]
   </xsl:when>
   <xsl:when test="$valueNow"><xsl:value-of select="$valueNow"/></xsl:when>
   </xsl:choose>
   <xsl:text> </xsl:text>
   <xsl:choose>
   <xsl:when test="count(string) &gt; 1">[<xsl:for-each select="string">"<xsl:value-of select="." />"<xsl:if test="position()!=last()">,</xsl:if><xsl:text>
   </xsl:text></xsl:for-each>]</xsl:when>
   <xsl:otherwise><xsl:apply-templates select="node()[not(self::ROUTE) and not(self::Scene) and position() = $counter]" /></xsl:otherwise>
   </xsl:choose>
   </xsl:otherwise>
   </xsl:choose>
	<xsl:if test="$rest">
	<xsl:choose>
	<xsl:when test="contains($rest,',')">
		<xsl:call-template name="ReplaceCommands">
		<xsl:with-param name="first" select="substring-before($rest,',')" />
	  	<xsl:with-param name="rest" select="substring-after($rest,',')" />
	  	<xsl:with-param name="valueNow" select="substring-before($valueNext,',')" />
	  	<xsl:with-param name="valueNext" select="substring-after($valueNext,',')" />
	  	<xsl:with-param name="counter" select="$counter + 2" />
		</xsl:call-template>
	</xsl:when>
	<xsl:otherwise>
		<xsl:call-template name="ReplaceCommands">
		<xsl:with-param name="first" select="$rest" />
		<xsl:with-param name="valueNow" select="$valueNext" />
		<xsl:with-param name="counter" select="$counter + 2" />
		</xsl:call-template>
	</xsl:otherwise>
	</xsl:choose>
	</xsl:if>
</xsl:template>
   
   <xsl:template match="Scene">
   REPLACE SCENE BY 
   <xsl:apply-templates select="ProtoDeclare" />
   <xsl:apply-templates select="Group|Layer2D|Layer3D|OrderedGroup|ProtoInstance" /> 
   <xsl:apply-templates select="ROUTE" />
   </xsl:template>
   
  <xsl:template name="MFFields">
  	<xsl:param name="valueNow" />
	<xsl:param name="valueNext" />
  <xsl:value-of select="$valueNow"/><xsl:if test="$valueNext">,<xsl:choose>
  <xsl:when test="contains($valueNext,',')"><xsl:call-template name="MFFields">
   		<xsl:with-param name="valueNow" select="substring-before($valueNext,',')" />
   		<xsl:with-param name="valueNext" select="substring-after($valueNext,',')" />
  </xsl:call-template></xsl:when>
  <xsl:otherwise><xsl:call-template name="MFFields">
  		<xsl:with-param name="valueNow" select="$valueNext"/>
  </xsl:call-template></xsl:otherwise>
  </xsl:choose></xsl:if>
  </xsl:template>

  <xsl:template match="string">
 <!-- will only translate string elements contained by the Insert and Replace commands.
 string elements in MFString/MFScript elements are handled by the templates of those
 elements calling the MFString or MFScript template. Insert and Replace on strings can be
 handled by using &quot; in the value attribute of those commands, hence this implementation
 of the string element seems to be currently superfluous. -->
 "<xsl:apply-templates/>"
 </xsl:template>

   <xsl:template match="ObjectDescriptorUpdate">
   UPDATE OD [
<xsl:apply-templates select="OD"/>
]
</xsl:template>

<xsl:template match="OD">
<xsl:apply-templates select="ObjectDescriptor|InitialObjectDescriptor"/>
</xsl:template>

<xsl:template match="ObjectDescriptorRemove">
REMOVE OD [
<xsl:choose>
<xsl:when test="contains(@objectDescriptorId,',')">
<xsl:call-template name="parseODIDlist">
	<xsl:with-param name="first" select="substring-before(@objectDescriptorId,',')" />
	<xsl:with-param name="rest" select="substring-after(@objectDescriptorId,',')" />
</xsl:call-template>
</xsl:when>
<xsl:otherwise>
<xsl:call-template name="parseODIDlist">
	<xsl:with-param name="first" select="@objectDescriptorId" />
</xsl:call-template>
</xsl:otherwise>
</xsl:choose>
]
</xsl:template>

<xsl:template name="parseODIDlist">
	<xsl:param name="first" />
	<xsl:param name="rest" />
<xsl:text> </xsl:text>
<xsl:value-of select="key('ODids',$first)/@binaryID"/>
<xsl:if test="$rest">
	<xsl:choose>
	<xsl:when test="contains($rest,',')">
		<xsl:call-template name="parseODIDlist">
		<xsl:with-param name="first" select="substring-before($rest,',')" />
	  	<xsl:with-param name="rest" select="substring-after($rest,',')" />
		</xsl:call-template>
	</xsl:when>
	<xsl:otherwise>
		<xsl:call-template name="parseODIDlist">
		<xsl:with-param name="first" select="$rest" />
		</xsl:call-template>
	</xsl:otherwise>
	</xsl:choose>
</xsl:if>
</xsl:template>

<xsl:template match="ES_DescriptorUpdate">
UPDATE ESD IN <xsl:if test="@objectDescriptorID"><xsl:value-of select="key('ODids',@objectDescriptorID)/@binaryID"/>
</xsl:if>
[
<xsl:apply-templates select="ES_Descriptor"/>
]
</xsl:template>

<xsl:template match="ES_DescriptorRemove">
REMOVE ESD FROM <xsl:if test="@objectDescriptorID"><xsl:value-of select="key('ODids',@objectDescriptorID)/@binaryID"/>
</xsl:if>
[
<xsl:choose>
<xsl:when test="contains(@ES_ID,',')">
<xsl:call-template name="parseESIDlist">
	<xsl:with-param name="first" select="substring-before(@ES_ID,',')" />
	<xsl:with-param name="rest" select="substring-after(@ES_ID,',')" />
</xsl:call-template>
</xsl:when>
<xsl:otherwise>
<xsl:call-template name="parseESIDlist">
	<xsl:with-param name="first" select="@ES_ID" />
</xsl:call-template>
</xsl:otherwise>
</xsl:choose>
]
</xsl:template>

<xsl:template name="parseESIDlist">
	<xsl:param name="first" />
	<xsl:param name="rest" />
<xsl:text> </xsl:text>
<xsl:value-of select="key('ESids',$first)/@binaryID"/>
<xsl:if test="$rest">
	<xsl:choose>
	<xsl:when test="contains($rest,',')">
		<xsl:call-template name="parseESIDlist">
		<xsl:with-param name="first" select="substring-before($rest,',')" />
	  	<xsl:with-param name="rest" select="substring-after($rest,',')" />
		</xsl:call-template>
	</xsl:when>
	<xsl:otherwise>
		<xsl:call-template name="parseESIDlist">
		<xsl:with-param name="first" select="$rest" />
		</xsl:call-template>
	</xsl:otherwise>
	</xsl:choose>
</xsl:if>
</xsl:template>

<xsl:template match="IPMP_DescriptorUpdate">
UPDATE IPMPD [
<xsl:apply-templates select="IPMP_Descriptor"/>
]
</xsl:template>

<xsl:template match="IPMP_DescriptorRemove">
REMOVE IPMPD [
<xsl:choose>
<xsl:when test="contains(@IPMP_DescriptorID,',')">
<xsl:call-template name="parseIPMPIDlist">
	<xsl:with-param name="first" select="substring-before(@IPMP_DescriptorID,',')" />
	<xsl:with-param name="rest" select="substring-after(@IPMP_DescriptorID,',')" />
</xsl:call-template>
</xsl:when>
<xsl:otherwise>
<xsl:call-template name="parseIPMPIDlist">
	<xsl:with-param name="first" select="@IPMP_DescriptorID" />
</xsl:call-template>
</xsl:otherwise>
</xsl:choose>
]
</xsl:template>

<xsl:template name="parseIPMPIDlist">
	<xsl:param name="first" />
	<xsl:param name="rest" />
<xsl:text> </xsl:text>
<xsl:value-of select="key('IPMPids',$first)/@binaryID"/>
<xsl:if test="$rest">
	<xsl:choose>
	<xsl:when test="contains($rest,',')">
		<xsl:call-template name="parseIPMPIDlist">
		<xsl:with-param name="first" select="substring-before($rest,',')" />
	  	<xsl:with-param name="rest" select="substring-after($rest,',')" />
		</xsl:call-template>
	</xsl:when>
	<xsl:otherwise>
		<xsl:call-template name="parseIPMPIDlist">
		<xsl:with-param name="first" select="$rest" />
		</xsl:call-template>
	</xsl:otherwise>
	</xsl:choose>
</xsl:if>
</xsl:template>

<!-- OCI_Event, IPMPMessage and JavaStreamHeader not supported in BIFSEnc  
<xsl:template match="OCI_Event">
OCI_EVENT [
<xsl:if test="@eventID">eventID  <xsl:value-of select="@eventID"/><xsl:text>
</xsl:text></xsl:if>
<xsl:if test="@absoluteTimeFlag">absoluteTimeFlag  <xsl:value-of select="@absoluteTimeFlag"/><xsl:text>
</xsl:text></xsl:if>
<xsl:if test="@startingTime">startingTime <xsl:value-of select="@startingTime"/><xsl:text>
</xsl:text></xsl:if>
<xsl:if test="@duration">duration <xsl:value-of select="@duration"/><xsl:text>
</xsl:text></xsl:if>
<xsl:apply-templates select="OCI_Descr"/>
] 
</xsl:template>
<xsl:template match="OCI_Descr">

<xsl:apply-templates select="ContentClassificationDescriptor|KeyWordDescriptor
|RatingDescriptor|LanguageDescriptor|ShortTextualDescriptor|ExpandedTextualDescriptor
|ContentCreatorNameDescriptor|ContentCreationDateDescriptor|OCICreatorNameDescriptor
|OCICreationDateDescriptor|SMPTECameraPositionDescriptor"/>


</xsl:template>
<xsl:template match="IPMP_Message">
IPMP_MESSAGE [

<xsl:apply-templates select="IPMPS_URL|IPMPS_data"/>

]

</xsl:template>

<xsl:template match="JavaStreamHeader">
JavaStreamHeader {

<xsl:if test="@url">url <xsl:value-of select="@url"/><xsl:text>
</xsl:text></xsl:if>
<xsl:if test="@version">version <xsl:value-of select="@version"/><xsl:text>
</xsl:text></xsl:if>
<xsl:if test="@isClassFlag">isClassFlag <xsl:value-of select="@isClassFlag"/><xsl:text>
</xsl:text></xsl:if>
<xsl:if test="@isPackaged">isPackaged <xsl:value-of select="@isPackaged"/><xsl:text>
</xsl:text></xsl:if>
<xsl:if test="@compressionScheme">compressionScheme <xsl:value-of select="@compressionScheme"/><xsl:text>
</xsl:text></xsl:if>
<xsl:apply-templates select="classID|reqClassID"/>
} 

</xsl:template>
<xsl:template match="classID">
classID JavaClassID {
<xsl:if test="@string">ID <xsl:value-of select="@string"/>
</xsl:if>
} 

</xsl:template>
<xsl:template match="reqClassID">
<xsl:for-each select="classID">
reqClassID JavaClassID{
<xsl:if test="@string">ID <xsl:value-of select="@string"/>
</xsl:if>
} 
</xsl:for-each>
</xsl:template>

-->

   <xsl:template match="children">
   children [ 
   <xsl:apply-templates />
   ]</xsl:template>

   <xsl:template match="choice">
   choice [ 
   <xsl:apply-templates />
   ]</xsl:template>

   <xsl:template match="material">
   material <xsl:apply-templates select="AcousticMaterial | Material | Material2D | MaterialKey | ProtoInstance" />
   </xsl:template>

   <xsl:template match="texture">
   texture <xsl:apply-templates select="CompositeTexture2D | CompositeTexture3D | ImageTexture | MovieTexture | PixelTexture | ProtoInstance" />
   </xsl:template>

   <xsl:template match="textureTransform">
   textureTransform  <xsl:apply-templates select="TextureTransform|ProtoInstance" />
   </xsl:template>

   <xsl:template match="proxy">
   proxy <xsl:apply-templates />
   </xsl:template>

   <xsl:template match="background">
   background  <xsl:apply-templates select="Background | Background2D|ProtoInstance" />
   </xsl:template>

   <xsl:template match="viewport">
   viewport  <xsl:apply-templates />
   </xsl:template>

   <xsl:template match="fog">
   fog  <xsl:apply-templates select="Fog|ProtoInstance" />
   </xsl:template>

   <xsl:template match="navigationInfo">
   navigationInfo  <xsl:apply-templates select="NavigationInfo|ProtoInstance" />
   </xsl:template>

   <xsl:template match="viewpoint">
   viewpoint  <xsl:apply-templates select="Viewpoint|ProtoInstance" />
   </xsl:template>

   <xsl:template match="point">
   point  <xsl:apply-templates select="Coordinate2D|ProtoInstance" />
   </xsl:template>

   <xsl:template match="color">
   color  <xsl:apply-templates select="Color|ProtoInstance" />
   </xsl:template>

   <xsl:template match="normal">
   normal  <xsl:apply-templates select="Normal|ProtoInstance" />
   </xsl:template>

   <xsl:template match="texCoord">
   texCoord  <xsl:apply-templates select="TextureCoordinate|ProtoInstance" />
   </xsl:template>

   <xsl:template match="fap">
   fap  <xsl:apply-templates select="FAP|ProtoInstance" />
   </xsl:template>

   <xsl:template match="fdp">
   fdp  <xsl:apply-templates select="FDP|ProtoInstance" />
   </xsl:template>

   <xsl:template match="fit">
   fit  <xsl:apply-templates select="FIT|ProtoInstance" />
   </xsl:template>

   <xsl:template match="ttsSource">
   ttsSource  <xsl:apply-templates select="AudioBuffer|AudioClip|AudioDelay|AudioFX|AudioMix|AudioSource|AudioSwitch|ProtoInstance" />
   </xsl:template>

   <xsl:template match="renderedFace">
   renderedFace [  
   <xsl:apply-templates />
   ]</xsl:template>

   <xsl:template match="faceSceneGraphNode">
   faceSceneGraphNode <xsl:apply-templates select="IndexedFaceSet|ProtoInstance" />
   </xsl:template>

   <xsl:template match="faceDefMesh">
   faceDefMesh [ 
   <xsl:apply-templates />

   ]</xsl:template>

   <xsl:template match="faceDefTransform">
   faceDefTransform [ 
   <xsl:apply-templates />

   ]</xsl:template>

   <xsl:template match="viseme">
   viseme  <xsl:apply-templates select="Viseme|ProtoInstance" />
   </xsl:template>

   <xsl:template match="expression">
   expression  <xsl:apply-templates select="Expression|ProtoInstance" />
   </xsl:template>

   <xsl:template match="featurePointsCoord">
   featurePointsCoord  <xsl:apply-templates select="Coordinate|ProtoInstance" />
   </xsl:template>

   <xsl:template match="textureCoord">
   textureCoord  <xsl:apply-templates select="Coordinate|ProtoInstance" />
   </xsl:template>

   <xsl:template match="faceDefTables">
   faceDefTables  <xsl:apply-templates select="FaceDefTables|ProtoInstance" />
   </xsl:template>

   <xsl:template match="faceSceneGraph">
   faceSceneGraph  <xsl:apply-templates select="Group|ProtoInstance" />
   </xsl:template>

   <xsl:template match="coord">
   coord <xsl:apply-templates select="Coordinate | Coordinate2D|ProtoInstance" />
   </xsl:template>

   <xsl:template match="level">
   level [ 
   <xsl:apply-templates />
   ]</xsl:template>

   <xsl:template match="lineProps">
   lineProps  <xsl:apply-templates select="LineProperties|ProtoInstance" />
   </xsl:template>

   <xsl:template match="appearance">
   appearance  <xsl:apply-templates select="Appearance|ProtoInstance" />
   </xsl:template>

   <xsl:template match="geometry">
   geometry  <xsl:apply-templates select="Text | Bitmap | Box | Circle | Cone | Curve2D | Cylinder | ElevationGrid | Extrusion | Hierarchical3DMesh | IndexedFaceSet | IndexedFaceSet2D | IndexedLineSet | IndexedLineSet2D | PointSet | PointSet2D | Rectangle | Sphere|ProtoInstance" />
   </xsl:template>

   <xsl:template match="source">
   source  <xsl:apply-templates select="AudioBuffer | AudioClip | AudioDelay | AudioFX | AudioMix | AudioSource | AudioSwitch|ProtoInstance" />
   </xsl:template>

   <xsl:template match="perceptualParameters">
   perceptualParameters   <xsl:apply-templates select="PerceptualParameters|ProtoInstance" />
   </xsl:template>

   <xsl:template match="fontStyle">
   fontStyle  <xsl:apply-templates select="FontStyle|ProtoInstance" />
   </xsl:template>

   <xsl:template match="bodyDefTables">
   bodyDefTables [ 
   <xsl:apply-templates />

   ]</xsl:template>

   <xsl:template match="bodySceneGraph">
   bodySceneGraph [ 
   <xsl:apply-templates />

   ]</xsl:template>

   <xsl:template match="bdp">
   bdp  <xsl:apply-templates select="BDP|ProtoInstance" />
   </xsl:template>

   <xsl:template match="bap">
   bap  <xsl:apply-templates select="BAP|ProtoInstance" />
   </xsl:template>

   <xsl:template match="renderedBody">
   renderedBody [ 
   <xsl:apply-templates />

   ]</xsl:template>
   
   
   <xsl:template match="buffer">
   buffer {
   <xsl:apply-templates select = "Replace|Insert|Delete" />
   }   
   </xsl:template>

   <!-- MFString fields -->
   <xsl:template name="MFString">
   <xsl:for-each select="string">" <xsl:value-of select="." />"<xsl:if test="position()!=last()">,</xsl:if><xsl:text>
   </xsl:text></xsl:for-each> 
   </xsl:template>

   <xsl:template match="parameter">
   
   <xsl:if test="@string">
   parameter [
	<xsl:call-template name="MFString" />
   ]
   </xsl:if>
   
   <xsl:if test="@id"> parameterID  <xsl:value-of select="@id"/><xsl:text>
   </xsl:text>
   </xsl:if>
   <xsl:if test="@value"> parameter  <xsl:value-of select="@value"/><xsl:text>
   </xsl:text>
   </xsl:if>
   
   </xsl:template>

   <xsl:template match="family">
   family [
	<xsl:call-template name="MFString" />
   ]
   </xsl:template>

   <xsl:template match="constraints">
   constraints [
	<xsl:call-template name="MFString" />
   ]
   </xsl:template>

   <xsl:template match="type">
   type [
	<xsl:call-template name="MFString" />
   ]
   </xsl:template>

   <xsl:template match="info">
   info [
	<xsl:call-template name="MFString" />
   ]
   </xsl:template>

   <xsl:template match="justify">
   <!-- treat JustifyType as a MFString -->
   justify [ <xsl:call-template name="MFString"/> ]
   </xsl:template>
   
   <!-- MFUrl and MFScript fields -->
   
   <xsl:template name="MFUrl">
   url [ <xsl:for-each select="url | od">" <xsl:value-of select="." />"<xsl:if test="position()!=last()">,</xsl:if><xsl:text>
   </xsl:text></xsl:for-each> ]
   </xsl:template>

   <xsl:template name="MFScript">
   url [<xsl:for-each select="string">"<xsl:value-of select="." />"<xsl:if test="position()!=last()">,</xsl:if><xsl:text>
   </xsl:text></xsl:for-each> ]
   </xsl:template>

   <xsl:template match="url">
   <xsl:choose>
   <xsl:when test="URLstring">
   URLstring  <xsl:value-of select="URLstring"/>
   </xsl:when>
   <xsl:when test="od | url"><xsl:call-template name="MFUrl" /></xsl:when> 
   <xsl:when test="string"><xsl:call-template name="MFScript" /></xsl:when>
   </xsl:choose>
   </xsl:template>

      
   <xsl:template match="ROUTE">
   <xsl:text> 
   </xsl:text><xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise>ROUTE <xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if><xsl:text> </xsl:text><xsl:value-of select="@fromNode" />.<xsl:value-of select="@fromField" /> TO  <xsl:value-of select="@toNode" />.<xsl:value-of select="@toField" /><xsl:text>
   </xsl:text></xsl:otherwise>
   </xsl:choose>
   </xsl:template>

   <xsl:template match="Anchor">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if>Anchor { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@description">
   description " <xsl:value-of select="@description" />"<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="parameter | url | children" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="AnimationStream">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> AnimationStream { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@loop">loop  <xsl:value-of select="@loop" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@speed">speed  <xsl:value-of select="@speed" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@startTime">startTime  <xsl:value-of select="@startTime" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@stopTime">stopTime  <xsl:value-of select="@stopTime" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="url" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Appearance">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Appearance { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:apply-templates />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="AudioBuffer">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> AudioBuffer { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@loop">loop  <xsl:value-of select="@loop" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@pitch">pitch  <xsl:value-of select="@pitch" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@startTime">startTime  <xsl:value-of select="@startTime" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@stopTime">stopTime  <xsl:value-of select="@stopTime" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@numChan">numChan  <xsl:value-of select="@numChan" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@phaseGroup">phaseGroup [ <xsl:value-of select="@phaseGroup" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@length">length  <xsl:value-of select="@length" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="children" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="AudioClip">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> AudioClip { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@description">description " <xsl:value-of select="@description" />"<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@loop">loop  <xsl:value-of select="@loop" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@pitch">pitch  <xsl:value-of select="@pitch" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@startTime">startTime  <xsl:value-of select="@startTime" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@stopTime">stopTime  <xsl:value-of select="@stopTime" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="url" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="AudioDelay">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> AudioDelay { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@delay">delay  <xsl:value-of select="@delay" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@numChan">numChan  <xsl:value-of select="@numChan" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@phaseGroup">phaseGroup [ <xsl:value-of select="@phaseGroup" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="children" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="AudioFX">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> AudioFX {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@orch">orch " <xsl:value-of select="@orch" />"<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@score">score " <xsl:value-of select="@score" />"<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@params">params [ <xsl:value-of select="@params" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@numChan">numChan  <xsl:value-of select="@numChan" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@phaseGroup">phaseGroup [ <xsl:value-of select="@phaseGroup" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="children" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="AudioMix">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> AudioMix {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@numInputs">numInputs  <xsl:value-of select="@numInputs" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@matrix">matrix [ <xsl:value-of select="@matrix" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@numChan">numChan  <xsl:value-of select="@numChan" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@phaseGroup">phaseGroup [ <xsl:value-of select="@phaseGroup" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="children" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="AudioSource">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if>  AudioSource {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    

   <xsl:if test="@pitch">pitch  <xsl:value-of select="@pitch" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@speed">speed  <xsl:value-of select="@speed" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@startTime">startTime  <xsl:value-of select="@startTime" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@stopTime">stopTime  <xsl:value-of select="@stopTime" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@numChan">numChan  <xsl:value-of select="@numChan" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@phaseGroup">phaseGroup [ <xsl:value-of select="@phaseGroup" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="url | children" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="AudioSwitch">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> AudioSwitch {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@whichChoice">whichChoice [ <xsl:value-of select="@whichChoice" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@numChan">numChan  <xsl:value-of select="@numChan" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@phaseGroup">phaseGroup [ <xsl:value-of select="@phaseGroup" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="children" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Background">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Background {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@groundAngle">groundAngle [ <xsl:value-of select="@groundAngle" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@groundColor">groundColor [ <xsl:value-of select="@groundColor" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@skyAngle">skyAngle [ <xsl:value-of select="@skyAngle" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@skyColor">skyColor [ <xsl:value-of select="@skyColor" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="backUrl | frontUrl | leftUrl | rightUrl | bottomUrl | topUrl" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Background2D">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Background2D {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@backColor">backColor  <xsl:value-of select="@backColor" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="url" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Billboard">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Billboard {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@axisOfRotation">axisOfRotation  <xsl:value-of select="@axisOfRotation" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="children" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Bitmap">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Bitmap {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@scale">scale  <xsl:value-of select="@scale" /><xsl:text>
   </xsl:text>

   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Box">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Box {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@size">size  <xsl:value-of select="@size" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Circle">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Circle {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@radius">radius  <xsl:value-of select="@radius" /><xsl:text>
   </xsl:text></xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Collision">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Collision {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@collide">collide  <xsl:value-of select="@collide" /><xsl:text>
   </xsl:text></xsl:if>

   <xsl:apply-templates select="children" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Color">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Color {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@color">color [ <xsl:value-of select="@color" />]<xsl:text>
   
   </xsl:text></xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="ColorInterpolator">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> ColorInterpolator {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@key">key [ <xsl:value-of select="@key" />]<xsl:text>
   </xsl:text></xsl:if>

   <xsl:if test="@keyValue">keyValue [ <xsl:value-of select="@keyValue" />]<xsl:text>
   </xsl:text></xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="CompositeTexture2D">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> CompositeTexture2D {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@pixelWidth">pixelWidth  <xsl:value-of select="@pixelWidth" /><xsl:text>
   </xsl:text></xsl:if>

   <xsl:if test="@pixelHeight">pixelHeight  <xsl:value-of select="@pixelHeight" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="background | viewport | children" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="CompositeTexture3D">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> CompositeTexture3D {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@pixelWidth">pixelWidth  <xsl:value-of select="@pixelWidth" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@pixelHeight">pixelHeight  <xsl:value-of select="@pixelHeight" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="background | fog | navigationInfo | viewpoint | children" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Conditional">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Conditional {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:apply-templates select="buffer" />
   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Cone">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Cone { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@bottomRadius">bottomRadius  <xsl:value-of select="@bottomRadius" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@height">height  <xsl:value-of select="@height" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@side">side  <xsl:value-of select="@side" /><xsl:text>
   </xsl:text></xsl:if>

   <xsl:if test="@bottom">bottom  <xsl:value-of select="@bottom" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Coordinate">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Coordinate { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@point">point [ <xsl:value-of select="@point" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Coordinate2D">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Coordinate2D { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@point">point [ <xsl:value-of select="@point" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="CoordinateInterpolator">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> CoordinateInterpolator {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@key">key [ <xsl:value-of select="@key" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@keyValue">keyValue [ <xsl:value-of select="@keyValue" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="CoordinateInterpolator2D">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> CoordinateInterpolator2D { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@key">key [ <xsl:value-of select="@key" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@keyValue">keyValue [ <xsl:value-of select="@keyValue" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Curve2D">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Curve2D { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@fineness">fineness  <xsl:value-of select="@fineness" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@type">type [ <xsl:value-of select="@type" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="point"/>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Cylinder">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Cylinder {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@bottom">bottom  <xsl:value-of select="@bottom" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@height">height  <xsl:value-of select="@height" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@radius">radius  <xsl:value-of select="@radius" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@side">side  <xsl:value-of select="@side" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@top">top  <xsl:value-of select="@top" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="CylinderSensor">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> CylinderSensor { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@autoOffset">autoOffset  <xsl:value-of select="@autoOffset" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@diskAngle">diskAngle  <xsl:value-of select="@diskAngle" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@enabled">enabled  <xsl:value-of select="@enabled" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@maxAngle">maxAngle  <xsl:value-of select="@maxAngle" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@minAngle">minAngle  <xsl:value-of select="@minAngle" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@offset">offset  <xsl:value-of select="@offset" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="DirectionalLight">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> DirectionalLight { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@ambientIntensity">ambientIntensity  <xsl:value-of select="@ambientIntensity" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@color">color  <xsl:value-of select="@color" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@direction">direction  <xsl:value-of select="@direction" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@intensity">intensity  <xsl:value-of select="@intensity" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@on">on  <xsl:value-of select="@on" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="DiscSensor">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> DiscSensor { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@autoOffset">autoOffset  <xsl:value-of select="@autoOffset" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@enabled">enabled  <xsl:value-of select="@enabled" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@maxAngle">maxAngle  <xsl:value-of select="@maxAngle" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@minAngle">minAngle  <xsl:value-of select="@minAngle" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@offset">offset  <xsl:value-of select="@offset" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="ElevationGrid">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> ElevationGrid { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@set_height">set_height  <xsl:value-of select="@set_height" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@height">height [ <xsl:value-of select="@height" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@ccw">ccw  <xsl:value-of select="@ccw" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@colorPerVertex">colorPerVertex  <xsl:value-of select="@colorPerVertex" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@creaseAngle">creaseAngle  <xsl:value-of select="@creaseAngle" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@normalPerVertex">normalPerVertex  <xsl:value-of select="@normalPerVertex" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@solid">solid  <xsl:value-of select="@solid" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@xDimension">xDimension  <xsl:value-of select="@xDimension" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@xSpacing">xSpacing  <xsl:value-of select="@xSpacing" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@zDimension">zDimension  <xsl:value-of select="@zDimension" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@zSpacing">zSpacing  <xsl:value-of select="@zSpacing" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="color | normak | texCoord" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Expression">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Expression {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@expression_select1">expression_select1  <xsl:value-of select="@expression_select1" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@expression_intensity1">expression_intensity1  <xsl:value-of select="@expression_intensity1" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@expression_select2">expression_select2  <xsl:value-of select="@expression_select2" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@expression_intensity2">expression_intensity2  <xsl:value-of select="@expression_intensity2" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@init_face">init_face  <xsl:value-of select="@init_face" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@expression_def">expression_def  <xsl:value-of select="@expression_def" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Extrusion">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Extrusion { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@beginCap">beginCap  <xsl:value-of select="@beginCap" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@ccw">ccw  <xsl:value-of select="@ccw" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@convex">convex  <xsl:value-of select="@convex" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@creaseAngle">creaseAngle  <xsl:value-of select="@creaseAngle" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@crossSection">crossSection [ <xsl:value-of select="@crossSection" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@endCap">endCap  <xsl:value-of select="@endCap" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@orientation">orientation [ <xsl:value-of select="@orientation" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@scale">scale [ <xsl:value-of select="@scale" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@solid">solid  <xsl:value-of select="@solid" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@spine">spine [ <xsl:value-of select="@spine" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Face">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Face { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:apply-templates />
   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="FaceDefMesh">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> FaceDefMesh { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@intervalBorders">intervalBorders [ <xsl:value-of select="@intervalBorders" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@coordIndex">coordIndex [ <xsl:value-of select="@coordIndex" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@displacements">displacements [ <xsl:value-of select="@displacements" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="FaceDefTables">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> FaceDefTables { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@fapID">fapID  <xsl:value-of select="@fapID" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@highLevelSelect">highLevelSelect  <xsl:value-of select="@highLevelSelect" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="FaceDefTransform">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> FaceDefTransform { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@fieldId">fieldId  <xsl:value-of select="@fieldId" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@rotationDef">rotationDef  <xsl:value-of select="@rotationDef" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@scaleDef">scaleDef  <xsl:value-of select="@scaleDef" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@translationDef">translationDef  <xsl:value-of select="@translationDef" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="FAP">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> FAP { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@open_jaw">open_jaw  <xsl:value-of select="@open_jaw" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@lower_t_midlip">lower_t_midlip  <xsl:value-of select="@lower_t_midlip" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@raise_b_midlip">raise_b_midlip  <xsl:value-of select="@raise_b_midlip" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@stretch_l_corner">stretch_l_corner  <xsl:value-of select="@stretch_l_corner" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@stretch_r_corner">stretch_r_corner  <xsl:value-of select="@stretch_r_corner" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@lower_t_lip_lm">lower_t_lip_lm  <xsl:value-of select="@lower_t_lip_lm" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@lower_t_lip_rm">lower_t_lip_rm  <xsl:value-of select="@lower_t_lip_rm" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@lower_b_lip_lm">lower_b_lip_lm  <xsl:value-of select="@lower_b_lip_lm" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@lower_b_lip_rm">lower_b_lip_rm  <xsl:value-of select="@lower_b_lip_rm" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@raise_l_cornerlip">raise_l_cornerlip  <xsl:value-of select="@raise_l_cornerlip" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@raise_r_cornerlip">raise_r_cornerlip  <xsl:value-of select="@raise_r_cornerlip" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@thrust_jaw">thrust_jaw  <xsl:value-of select="@thrust_jaw" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@shift_jaw">shift_jaw  <xsl:value-of select="@shift_jaw" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@push_b_lip">push_b_lip  <xsl:value-of select="@push_b_lip" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@push_t_lip">push_t_lip  <xsl:value-of select="@push_t_lip" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@depress_chin">depress_chin  <xsl:value-of select="@depress_chin" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@close_t_l_eyelid">close_t_l_eyelid  <xsl:value-of select="@close_t_l_eyelid" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@close_t_r_eyelid">close_t_r_eyelid  <xsl:value-of select="@close_t_r_eyelid" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@close_b_l_eyelid">close_b_l_eyelid  <xsl:value-of select="@close_b_l_eyelid" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@close_b_r_eyelid">close_b_r_eyelid  <xsl:value-of select="@close_b_r_eyelid" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@yaw_l_eyeball">yaw_l_eyeball  <xsl:value-of select="@yaw_l_eyeball" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@yaw_r_eyeball">yaw_r_eyeball  <xsl:value-of select="@yaw_r_eyeball" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@pitch_l_eyeball">pitch_l_eyeball  <xsl:value-of select="@pitch_l_eyeball" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@pitch_r_eyeball">pitch_r_eyeball  <xsl:value-of select="@pitch_r_eyeball" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@thrust_l_eyeball">thrust_l_eyeball  <xsl:value-of select="@thrust_l_eyeball" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@thrust_r_eyeball">thrust_r_eyeball  <xsl:value-of select="@thrust_r_eyeball" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@dilate_l_pupil">dilate_l_pupil  <xsl:value-of select="@dilate_l_pupil" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@dilate_r_pupil">dilate_r_pupil  <xsl:value-of select="@dilate_r_pupil" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@raise_l_i_eyebrow">raise_l_i_eyebrow  <xsl:value-of select="@raise_l_i_eyebrow" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@raise_r_i_eyebrow">raise_r_i_eyebrow  <xsl:value-of select="@raise_r_i_eyebrow" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@raise_l_m_eyebrow">raise_l_m_eyebrow  <xsl:value-of select="@raise_l_m_eyebrow" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@raise_r_m_eyebrow">raise_r_m_eyebrow  <xsl:value-of select="@raise_r_m_eyebrow" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@raise_l_o_eyebrow">raise_l_o_eyebrow  <xsl:value-of select="@raise_l_o_eyebrow" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@raise_r_o_eyebrow">raise_r_o_eyebrow  <xsl:value-of select="@raise_r_o_eyebrow" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@squeeze_l_eyebrow">squeeze_l_eyebrow  <xsl:value-of select="@squeeze_l_eyebrow" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@squeeze_r_eyebrow">squeeze_r_eyebrow  <xsl:value-of select="@squeeze_r_eyebrow" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@puff_l_cheek">puff_l_cheek  <xsl:value-of select="@puff_l_cheek" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@puff_r_cheek">puff_r_cheek  <xsl:value-of select="@puff_r_cheek" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@lift_l_cheek">lift_l_cheek  <xsl:value-of select="@lift_l_cheek" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@lift_r_cheek">lift_r_cheek  <xsl:value-of select="@lift_r_cheek" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@shift_tongue_tip">shift_tongue_tip  <xsl:value-of select="@shift_tongue_tip" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@raise_tongue_tip">raise_tongue_tip  <xsl:value-of select="@raise_tongue_tip" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@thrust_tongue_tip">thrust_tongue_tip  <xsl:value-of select="@thrust_tongue_tip" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@raise_tongue">raise_tongue  <xsl:value-of select="@raise_tongue" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@tongue_roll">tongue_roll  <xsl:value-of select="@tongue_roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@head_pitch">head_pitch  <xsl:value-of select="@head_pitch" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@head_yaw">head_yaw  <xsl:value-of select="@head_yaw" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@head_roll">head_roll  <xsl:value-of select="@head_roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@lower_t_midlip_o">lower_t_midlip_o  <xsl:value-of select="@lower_t_midlip_o" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@raise_b_midlip_o">raise_b_midlip_o  <xsl:value-of select="@raise_b_midlip_o" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@stretch_l_cornerlip">stretch_l_cornerlip  <xsl:value-of select="@stretch_l_cornerlip" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@stretch_r_cornerlip">stretch_r_cornerlip  <xsl:value-of select="@stretch_r_cornerlip" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@lower_t_lip_lm_o">lower_t_lip_lm_o  <xsl:value-of select="@lower_t_lip_lm_o" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@lower_t_lip_rm_o">lower_t_lip_rm_o  <xsl:value-of select="@lower_t_lip_rm_o" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@raise_b_lip_lm_o">raise_b_lip_lm_o  <xsl:value-of select="@raise_b_lip_lm_o" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@raise_b_lip_rm_o">raise_b_lip_rm_o  <xsl:value-of select="@raise_b_lip_rm_o" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@raise_l_cornerlip_o">raise_l_cornerlip_o  <xsl:value-of select="@raise_l_cornerlip_o" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@raise_r_cornerlip_o">raise_r_cornerlip_o  <xsl:value-of select="@raise_r_cornerlip_o" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@stretch_l_nose">stretch_l_nose  <xsl:value-of select="@stretch_l_nose" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@stretch_r_nose">stretch_r_nose  <xsl:value-of select="@stretch_r_nose" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@raise_nose">raise_nose  <xsl:value-of select="@raise_nose" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@bend_nose">bend_nose  <xsl:value-of select="@bend_nose" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@raise_l_ear">raise_l_ear  <xsl:value-of select="@raise_l_ear" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@raise_r_ear">raise_r_ear  <xsl:value-of select="@raise_r_ear" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@pull_l_ear">pull_l_ear  <xsl:value-of select="@pull_l_ear" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@pull_r_ear">pull_r_ear  <xsl:value-of select="@pull_r_ear" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="FDP">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> FDP { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@useOrthoTexture">useOrthoTexture  <xsl:value-of select="@useOrthoTexture" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="FIT">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> FIT { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@FAPs">FAPs [ <xsl:value-of select="@FAPs" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@Graph">Graph [ <xsl:value-of select="@Graph" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@numeratorExp">numeratorExp [ <xsl:value-of select="@numeratorExp" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@denominatorExp">denominatorExp [ <xsl:value-of select="@denominatorExp" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@numeratorImpulse">numeratorImpulse [ <xsl:value-of select="@numeratorImpulse" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@numeratorTerms">numeratorTerms [ <xsl:value-of select="@numeratorTerms" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@denominatorTerms">denominatorTerms [ <xsl:value-of select="@denominatorTerms" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@numeratorCoefs">numeratorCoefs [ <xsl:value-of select="@numeratorCoefs" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@denominatorCoefs">denominatorCoefs [ <xsl:value-of select="@denominatorCoefs" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Fog">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Fog { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@color">color  <xsl:value-of select="@color" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@fogType">fogType " <xsl:value-of select="@fogType" />"<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@visibilityRange">visibilityRange  <xsl:value-of select="@visibilityRange" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="FontStyle">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> FontStyle { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>

   <xsl:if test="@horizontal">horizontal  <xsl:value-of select="@horizontal" /><xsl:text>
   </xsl:text>
   </xsl:if>


   <xsl:if test="@language">language " <xsl:value-of select="@language" />"<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@leftToRight">leftToRight  <xsl:value-of select="@leftToRight" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@size">size  <xsl:value-of select="@size" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@spacing">spacing  <xsl:value-of select="@spacing" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@style">style  <xsl:value-of select="@style" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@topToBottom">topToBottom  <xsl:value-of select="@topToBottom" /><xsl:text>
   </xsl:text>
   </xsl:if>
   
   <xsl:apply-templates select="family | justify" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Form">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Form { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@size">size  <xsl:value-of select="@size" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@groups">groups [ <xsl:value-of select="@groups" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@groupsIndex">groupsIndex [ <xsl:value-of select="@groupsIndex" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="constraints | children" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Group">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Group { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:apply-templates select="children" />
   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="ImageTexture">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> ImageTexture { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   
   <xsl:if test="@repeatS">repeatS  <xsl:value-of select="@repeatS" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@repeatT">repeatT  <xsl:value-of select="@repeatT" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="url" />
   
   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="IndexedFaceSet">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> IndexedFaceSet { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@ccw">ccw  <xsl:value-of select="@ccw" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@colorIndex">colorIndex [ <xsl:value-of select="@colorIndex" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@colorPerVertex">colorPerVertex  <xsl:value-of select="@colorPerVertex" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@convex">convex  <xsl:value-of select="@convex" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@coordIndex">coordIndex [ <xsl:value-of select="@coordIndex" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@creaseAngle">creaseAngle  <xsl:value-of select="@creaseAngle" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@normalIndex">normalIndex [ <xsl:value-of select="@normalIndex" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@normalPerVertex">normalPerVertex  <xsl:value-of select="@normalPerVertex" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@solid">solid  <xsl:value-of select="@solid" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@texCoordIndex">texCoordIndex [ <xsl:value-of select="@texCoordIndex" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="IndexedFaceSet2D">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> IndexedFaceSet2D { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@colorIndex">colorIndex [ <xsl:value-of select="@colorIndex" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@colorPerVertex">colorPerVertex  <xsl:value-of select="@colorPerVertex" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@convex">convex  <xsl:value-of select="@convex" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@coordIndex">coordIndex [ <xsl:value-of select="@coordIndex" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@texCoordIndex">texCoordIndex [ <xsl:value-of select="@texCoordIndex" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="IndexedLineSet">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> IndexedLineSet { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@colorIndex">colorIndex [ <xsl:value-of select="@colorIndex" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@colorPerVertex">colorPerVertex  <xsl:value-of select="@colorPerVertex" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@coordIndex">coordIndex [ <xsl:value-of select="@coordIndex" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="IndexedLineSet2D">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> IndexedLineSet2D { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@colorIndex">colorIndex [ <xsl:value-of select="@colorIndex" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@colorPerVertex">colorPerVertex  <xsl:value-of select="@colorPerVertex" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@coordIndex">coordIndex [ <xsl:value-of select="@coordIndex" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Inline">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Inline { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@url">url  <xsl:value-of select="@url" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="LOD">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> LOD { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@center">center  <xsl:value-of select="@center" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@range">range [ <xsl:value-of select="@range" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Layer2D">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Layer2D { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@size">size  <xsl:value-of select="@size" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="children" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Layer3D">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Layer3D { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@size">size  <xsl:value-of select="@size" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="children" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Layout">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Layout { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@wrap">wrap  <xsl:value-of select="@wrap" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@size">size  <xsl:value-of select="@size" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@horizontal">horizontal  <xsl:value-of select="@horizontal" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@leftToRight">leftToRight  <xsl:value-of select="@leftToRight" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@topToBottom">topToBottom  <xsl:value-of select="@topToBottom" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@spacing">spacing  <xsl:value-of select="@spacing" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@smoothScroll">smoothScroll  <xsl:value-of select="@smoothScroll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@loop">loop  <xsl:value-of select="@loop" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@scrollVertical">scrollVertical  <xsl:value-of select="@scrollVertical" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@scrollRate">scrollRate  <xsl:value-of select="@scrollRate" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="justify | children" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="LineProperties">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> LineProperties { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@lineColor">lineColor  <xsl:value-of select="@lineColor" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@lineStyle">lineStyle  <xsl:value-of select="@lineStyle" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@width">width  <xsl:value-of select="@width" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="ListeningPoint">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> ListeningPoint { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@jump">jump  <xsl:value-of select="@jump" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@orientation">orientation  <xsl:value-of select="@orientation" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@position">position  <xsl:value-of select="@position" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@description">description " <xsl:value-of select="@description" />"<xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Material">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Material { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@ambientIntensity">ambientIntensity  <xsl:value-of select="@ambientIntensity" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@diffuseColor">diffuseColor  <xsl:value-of select="@diffuseColor" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@emissiveColor">emissiveColor  <xsl:value-of select="@emissiveColor" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@shininess">shininess  <xsl:value-of select="@shininess" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@specularColor">specularColor  <xsl:value-of select="@specularColor" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@transparency">transparency  <xsl:value-of select="@transparency" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Material2D">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Material2D { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@emissiveColor">emissiveColor  <xsl:value-of select="@emissiveColor" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@filled">filled  <xsl:value-of select="@filled" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@transparency">transparency  <xsl:value-of select="@transparency" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="MovieTexture">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> MovieTexture { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@loop">loop  <xsl:value-of select="@loop" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@speed">speed  <xsl:value-of select="@speed" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@startTime">startTime  <xsl:value-of select="@startTime" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@stopTime">stopTime  <xsl:value-of select="@stopTime" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@repeatS">repeatS  <xsl:value-of select="@repeatS" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@repeatT">repeatT  <xsl:value-of select="@repeatT" /><xsl:text>
   </xsl:text>
   </xsl:if>
   
   <xsl:apply-templates select="url" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="NavigationInfo">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> NavigationInfo { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@avatarSize">avatarSize [ <xsl:value-of select="@avatarSize" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@headlight">headlight  <xsl:value-of select="@headlight" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@speed">speed  <xsl:value-of select="@speed" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@visibilityLimit">visibilityLimit  <xsl:value-of select="@visibilityLimit" /><xsl:text>
   </xsl:text>
   </xsl:if>
   
   <xsl:apply-templates select="type" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Normal">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Normal { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@vector">vector [ <xsl:value-of select="@vector" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="NormalInterpolator">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> NormalInterpolator { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@key">key [ <xsl:value-of select="@key" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@keyValue">keyValue [ <xsl:value-of select="@keyValue" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="OrderedGroup">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> OrderedGroup { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@order">order [ <xsl:value-of select="@order" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="children" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="OrientationInterpolator">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> OrientationInterpolator { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@key">key [ <xsl:value-of select="@key" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@keyValue">keyValue [ <xsl:value-of select="@keyValue" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="PixelTexture">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> PixelTexture { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@image">image  <xsl:value-of select="@image" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@repeatS">repeatS  <xsl:value-of select="@repeatS" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@repeatT">repeatT  <xsl:value-of select="@repeatT" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="PlaneSensor">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> PlaneSensor { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@autoOffset">autoOffset  <xsl:value-of select="@autoOffset" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@enabled">enabled  <xsl:value-of select="@enabled" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@maxPosition">maxPosition  <xsl:value-of select="@maxPosition" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@minPosition">minPosition  <xsl:value-of select="@minPosition" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@offset">offset  <xsl:value-of select="@offset" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="PlaneSensor2D">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> PlaneSensor2D { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@autoOffset">autoOffset  <xsl:value-of select="@autoOffset" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@enabled">enabled  <xsl:value-of select="@enabled" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@maxPosition">maxPosition  <xsl:value-of select="@maxPosition" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@minPosition">minPosition  <xsl:value-of select="@minPosition" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@offset">offset  <xsl:value-of select="@offset" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="PointLight">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> PointLight { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@ambientIntensity">ambientIntensity  <xsl:value-of select="@ambientIntensity" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@attenuation">attenuation  <xsl:value-of select="@attenuation" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@color">color  <xsl:value-of select="@color" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@intensity">intensity  <xsl:value-of select="@intensity" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@location">location  <xsl:value-of select="@location" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@on">on  <xsl:value-of select="@on" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@radius">radius  <xsl:value-of select="@radius" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="PointSet">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> PointSet { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:apply-templates />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="PointSet2D">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> PointSet2D { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:apply-templates />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="PositionInterpolator">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> PositionInterpolator { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@key">key [ <xsl:value-of select="@key" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@keyValue">keyValue [ <xsl:value-of select="@keyValue" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="PositionInterpolator2D">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> PositionInterpolator2D {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@key">key [ <xsl:value-of select="@key" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@keyValue">keyValue [ <xsl:value-of select="@keyValue" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="ProximitySensor2D">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> ProximitySensor2D { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@center">center  <xsl:value-of select="@center" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@size">size  <xsl:value-of select="@size" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@enabled">enabled  <xsl:value-of select="@enabled" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="ProximitySensor">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> ProximitySensor {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@center">center  <xsl:value-of select="@center" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@size">size  <xsl:value-of select="@size" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@enabled">enabled  <xsl:value-of select="@enabled" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="QuantizationParameter">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> QuantizationParameter { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@isLocal">isLocal  <xsl:value-of select="@isLocal" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@position3DQuant">position3DQuant  <xsl:value-of select="@position3DQuant" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@position3DMin">position3DMin  <xsl:value-of select="@position3DMin" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@position3DMax">position3DMax  <xsl:value-of select="@position3DMax" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@position3DNbBits">position3DNbBits  <xsl:value-of select="@position3DNbBits" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@position2DQuant">position2DQuant  <xsl:value-of select="@position2DQuant" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@position2DMin">position2DMin  <xsl:value-of select="@position2DMin" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@position2DMax">position2DMax  <xsl:value-of select="@position2DMax" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@position2DNbBits">position2DNbBits  <xsl:value-of select="@position2DNbBits" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@drawOrderQuant">drawOrderQuant  <xsl:value-of select="@drawOrderQuant" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@drawOrderMin">drawOrderMin  <xsl:value-of select="@drawOrderMin" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@drawOrderMax">drawOrderMax  <xsl:value-of select="@drawOrderMax" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@drawOrderNbBits">drawOrderNbBits  <xsl:value-of select="@drawOrderNbBits" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@colorQuant">colorQuant  <xsl:value-of select="@colorQuant" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@colorMin">colorMin  <xsl:value-of select="@colorMin" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@colorMax">colorMax  <xsl:value-of select="@colorMax" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@colorNbBits">colorNbBits  <xsl:value-of select="@colorNbBits" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@textureCoordinateQuant">textureCoordinateQuant  <xsl:value-of select="@textureCoordinateQuant" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@textureCoordinateMin">textureCoordinateMin  <xsl:value-of select="@textureCoordinateMin" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@textureCoordinateMax">textureCoordinateMax  <xsl:value-of select="@textureCoordinateMax" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@textureCoordinateNbBits">textureCoordinateNbBits  <xsl:value-of select="@textureCoordinateNbBits" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@angleQuant">angleQuant  <xsl:value-of select="@angleQuant" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@angleMin">angleMin  <xsl:value-of select="@angleMin" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@angleMax">angleMax  <xsl:value-of select="@angleMax" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@angleNbBits">angleNbBits  <xsl:value-of select="@angleNbBits" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@scaleQuant">scaleQuant  <xsl:value-of select="@scaleQuant" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@scaleMin">scaleMin  <xsl:value-of select="@scaleMin" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@scaleMax">scaleMax  <xsl:value-of select="@scaleMax" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@scaleNbBits">scaleNbBits  <xsl:value-of select="@scaleNbBits" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@keyQuant">keyQuant  <xsl:value-of select="@keyQuant" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@keyMin">keyMin  <xsl:value-of select="@keyMin" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@keyMax">keyMax  <xsl:value-of select="@keyMax" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@keyNbBits">keyNbBits  <xsl:value-of select="@keyNbBits" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@normalQuant">normalQuant  <xsl:value-of select="@normalQuant" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@normalNbBits">normalNbBits  <xsl:value-of select="@normalNbBits" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@sizeQuant">sizeQuant  <xsl:value-of select="@sizeQuant" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@sizeMin">sizeMin  <xsl:value-of select="@sizeMin" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@sizeMax">sizeMax  <xsl:value-of select="@sizeMax" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@sizeNbBits">sizeNbBits  <xsl:value-of select="@sizeNbBits" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@useEfficientCoding">useEfficientCoding  <xsl:value-of select="@useEfficientCoding" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Rectangle">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Rectangle { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@size">size  <xsl:value-of select="@size" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="ScalarInterpolator">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> ScalarInterpolator { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@key">key [ <xsl:value-of select="@key" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@keyValue">keyValue [ <xsl:value-of select="@keyValue" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Script">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Script { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:apply-templates select="field" />

   <xsl:apply-templates select="url" />
 
   <xsl:if test="@directOutput">directOutput  <xsl:value-of select="@directOutput" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@mustEvaluate">mustEvaluate  <xsl:value-of select="@mustEvaluate" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="field">
   <xsl:choose>
   <xsl:when test="@vrml97Hint"> <xsl:value-of select="@vrml97Hint"/> </xsl:when>
   <xsl:otherwise>field </xsl:otherwise>
   </xsl:choose>
   <xsl:if test="@type">
   <xsl:choose>
   <xsl:when test="@type='Boolean'"> SFBool </xsl:when>
   <xsl:when test="@type='Booleans'"> MFBool </xsl:when>
   <xsl:when test="@type='Color'"> SFColor </xsl:when>
   <xsl:when test="@type='Colors'"> MFColor </xsl:when>
   <xsl:when test="@type='Float'"> SFFloat </xsl:when>
   <xsl:when test="@type='Floats'"> MFFloat </xsl:when>
   <xsl:when test="@type='Image'"> SFImage </xsl:when>
   <xsl:when test="@type='Images'"> MFImage </xsl:when>
   <xsl:when test="@type='Integer'"> SFInt32 </xsl:when>
   <xsl:when test="@type='Integers'"> MFInt32 </xsl:when>
   <xsl:when test="@type='Node'"> SFNode </xsl:when>
   <xsl:when test="@type='Nodes'"> MFNode </xsl:when>
   <xsl:when test="@type='Rotation'"> SFRotation </xsl:when>
   <xsl:when test="@type='Rotations'"> MFRotation </xsl:when>
   <xsl:when test="@type='String'"> SFString </xsl:when>
   <xsl:when test="@type='Strings'"> MFString </xsl:when>
   <xsl:when test="@type='Time'"> SFTime </xsl:when>
   <xsl:when test="@type='Times'"> MFTime </xsl:when>
   <xsl:when test="@type='Vector2'"> SFVec2f </xsl:when>
   <xsl:when test="@type='Vector2Array'"> MFVec2f </xsl:when>
   <xsl:when test="@type='Vector3'"> SFVec3f </xsl:when>
   <xsl:when test="@type='Vector3Array'"> MFVec3f </xsl:when>
   </xsl:choose>
   </xsl:if>
   <xsl:value-of select="@name" /><xsl:text> </xsl:text>
   <xsl:choose>
   <xsl:when test="IS"> IS <xsl:value-of select="IS/connect/@protoField"/></xsl:when>
   <xsl:when test="@USE"> USE <xsl:value-of select="@USE"/></xsl:when>
   <xsl:when test="@colorValue"> <xsl:value-of select="@colorValue"/></xsl:when>
   <xsl:when test="@colorArrayValue">[ <xsl:value-of select="@colorArrayValue"/>]</xsl:when>
   <xsl:when test="@stringValue">" <xsl:value-of select="@stringValue"/>"</xsl:when>
   <xsl:when test="@floatValue"> <xsl:value-of select="@floatValue"/></xsl:when>
   <xsl:when test="@floatArrayValue">[ <xsl:value-of select="@floatArrayValue"/>]</xsl:when>
   <xsl:when test="@intValue"> <xsl:value-of select="@intValue"/></xsl:when>
   <xsl:when test="@intArrayValue">[ <xsl:value-of select="@intArrayValue"/>]</xsl:when>
   <xsl:when test="@booleanValue"> <xsl:value-of select="@booleanValue"/></xsl:when>
   <xsl:when test="@booleanArrayValue">[ <xsl:value-of select="@booleanArrayValue"/>]</xsl:when>
   <xsl:when test="@timeValue"> <xsl:value-of select="@timeValue"/></xsl:when>
   <xsl:when test="@timeArrayValue">[ <xsl:value-of select="@timeArrayValue"/>]</xsl:when>
   <xsl:when test="@rotationValue"> <xsl:value-of select="@rotationValue"/></xsl:when>
   <xsl:when test="@rotationArrayValue">[ <xsl:value-of select="@rotationArrayValue"/>]</xsl:when>
   <xsl:when test="@vector2Value"> <xsl:value-of select="@vector2Value"/></xsl:when>
   <xsl:when test="@vector2ArrayValue">[ <xsl:value-of select="@vector2ArrayValue"/>]</xsl:when>
   <xsl:when test="@vector3Value"> <xsl:value-of select="@vector3Value"/></xsl:when>
   <xsl:when test="@vector3ArrayValue">[ <xsl:value-of select="@vector3ArrayValue"/>]</xsl:when>
   <xsl:when test="@imageValue"> <xsl:value-of select="@imageValue"/></xsl:when>
   <!-- imageArrayValue missing from Schema -->
   <xsl:when test="stringArrayValue">[ 
   <xsl:for-each select="stringArrayValue/string">" <xsl:value-of select="." />"<xsl:if test="position()!=last()">,</xsl:if><xsl:text>
   </xsl:text></xsl:for-each> ] </xsl:when>
   <xsl:when test="scriptArrayValue">[ 
   "<xsl:for-each select="scriptArrayValue/string"> <xsl:value-of select="." /><xsl:text>
   </xsl:text></xsl:for-each>"] </xsl:when>
   <xsl:when test="node"><xsl:apply-templates select="node/*" /></xsl:when>
   <xsl:when test="nodes">[<xsl:apply-templates select="nodes/*" />]</xsl:when>
   </xsl:choose><xsl:text>
   </xsl:text>
   </xsl:template>

   <xsl:template match="Shape">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Shape { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:apply-templates select="appearance|geometry"/>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Sound">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Sound { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@direction">direction  <xsl:value-of select="@direction" /><xsl:text>
   </xsl:text></xsl:if>

   <xsl:if test="@intensity">intensity  <xsl:value-of select="@intensity" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@location">location  <xsl:value-of select="@location" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@maxBack">maxBack  <xsl:value-of select="@maxBack" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@maxFront">maxFront  <xsl:value-of select="@maxFront" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@minBack">minBack  <xsl:value-of select="@minBack" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@minFront">minFront  <xsl:value-of select="@minFront" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@priority">priority  <xsl:value-of select="@priority" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@spatialize">spatialize  <xsl:value-of select="@spatialize" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Sound2D">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Sound2D { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@intensity">intensity  <xsl:value-of select="@intensity" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@location">location  <xsl:value-of select="@location" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@spatialize">spatialize  <xsl:value-of select="@spatialize" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Sphere">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Sphere { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@radius">radius  <xsl:value-of select="@radius" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="SphereSensor">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> SphereSensor { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@autoOffset">autoOffset  <xsl:value-of select="@autoOffset" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@enabled">enabled  <xsl:value-of select="@enabled" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@offset">offset  <xsl:value-of select="@offset" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="SpotLight">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> SpotLight { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@ambientIntensity">ambientIntensity  <xsl:value-of select="@ambientIntensity" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@attenuation">attenuation  <xsl:value-of select="@attenuation" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@beamWidth">beamWidth  <xsl:value-of select="@beamWidth" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@color">color  <xsl:value-of select="@color" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@cutOffAngle">cutOffAngle  <xsl:value-of select="@cutOffAngle" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@direction">direction  <xsl:value-of select="@direction" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@intensity">intensity  <xsl:value-of select="@intensity" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@location">location  <xsl:value-of select="@location" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@on">on  <xsl:value-of select="@on" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@radius">radius  <xsl:value-of select="@radius" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Switch">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Switch {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@whichChoice">whichChoice  <xsl:value-of select="@whichChoice" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="TermCap">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> TermCap { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@capability">capability  <xsl:value-of select="@capability" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Text">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Text {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@string">string  <xsl:value-of select="@string" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@length">length [ <xsl:value-of select="@length" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@maxExtent">maxExtent  <xsl:value-of select="@maxExtent" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="TextureCoordinate">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> TextureCoordinate {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@point">point [ <xsl:value-of select="@point" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="TextureTransform">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> TextureTransform { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@center">center  <xsl:value-of select="@center" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@rotation">rotation  <xsl:value-of select="@rotation" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@scale">scale  <xsl:value-of select="@scale" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@translation">translation  <xsl:value-of select="@translation" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="TimeSensor">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> TimeSensor { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@cycleInterval">cycleInterval  <xsl:value-of select="@cycleInterval" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@enabled">enabled  <xsl:value-of select="@enabled" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@loop">loop  <xsl:value-of select="@loop" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@startTime">startTime  <xsl:value-of select="@startTime" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@stopTime">stopTime  <xsl:value-of select="@stopTime" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="TouchSensor">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> TouchSensor { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@enabled">enabled  <xsl:value-of select="@enabled" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Transform">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Transform { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@center">center  <xsl:value-of select="@center" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@rotation">rotation  <xsl:value-of select="@rotation" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@scale">scale  <xsl:value-of select="@scale" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@scaleOrientation">scaleOrientation  <xsl:value-of select="@scaleOrientation" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@translation">translation  <xsl:value-of select="@translation" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="children" /><xsl:text>
   </xsl:text>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Transform2D">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Transform2D {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@center">center  <xsl:value-of select="@center" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@rotationAngle">rotationAngle  <xsl:value-of select="@rotationAngle" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@scale">scale  <xsl:value-of select="@scale" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@scaleOrientation">scaleOrientation  <xsl:value-of select="@scaleOrientation" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@translation">translation  <xsl:value-of select="@translation" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="children" /><xsl:text>
   </xsl:text>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Valuator">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Valuator { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@Factor1">Factor1  <xsl:value-of select="@Factor1" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@Factor2">Factor2  <xsl:value-of select="@Factor2" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@Factor3">Factor3  <xsl:value-of select="@Factor3" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@Factor4">Factor4  <xsl:value-of select="@Factor4" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@Offset1">Offset1  <xsl:value-of select="@Offset1" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@Offset2">Offset2  <xsl:value-of select="@Offset2" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@Offset3">Offset3  <xsl:value-of select="@Offset3" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@Offset4">Offset4  <xsl:value-of select="@Offset4" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@Sum">Sum  <xsl:value-of select="@Sum" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Viewpoint">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Viewpoint { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@fieldOfView">fieldOfView  <xsl:value-of select="@fieldOfView" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@jump">jump  <xsl:value-of select="@jump" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@orientation">orientation  <xsl:value-of select="@orientation" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@position">position  <xsl:value-of select="@position" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@description">description " <xsl:value-of select="@description" />"<xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="VisibilitySensor">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> VisibilitySensor { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@center">center  <xsl:value-of select="@center" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@enabled">enabled  <xsl:value-of select="@enabled" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@size">size  <xsl:value-of select="@size" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Viseme">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Viseme { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@viseme_select1">viseme_select1  <xsl:value-of select="@viseme_select1" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@viseme_select2">viseme_select2  <xsl:value-of select="@viseme_select2" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@viseme_blend">viseme_blend  <xsl:value-of select="@viseme_blend" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@viseme_def">viseme_def  <xsl:value-of select="@viseme_def" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="WorldInfo">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> WorldInfo { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   
   <xsl:if test="@title">title " <xsl:value-of select="@title" />" <xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="info" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="AcousticMaterial">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> AcousticMaterial { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@ambientIntensity">ambientIntensity  <xsl:value-of select="@ambientIntensity" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@diffuseColor">diffuseColor  <xsl:value-of select="@diffuseColor" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@emissiveColor">emissiveColor  <xsl:value-of select="@emissiveColor" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@shininess">shininess  <xsl:value-of select="@shininess" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@specularColor">specularColor  <xsl:value-of select="@specularColor" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@transparency">transparency  <xsl:value-of select="@transparency" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@reffunc">reffunc [ <xsl:value-of select="@reffunc" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@transfunc">transfunc [ <xsl:value-of select="@transfunc" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@refFrequency">refFrequency [ <xsl:value-of select="@refFrequency" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@transFrequency">transFrequency [ <xsl:value-of select="@transFrequency" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="AcousticScene">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> AcousticScene { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@center">center  <xsl:value-of select="@center" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@Size">Size  <xsl:value-of select="@Size" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@reverbTime">reverbTime [ <xsl:value-of select="@reverbTime" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@reverbFreq">reverbFreq [ <xsl:value-of select="@reverbFreq" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@reverbLevel">reverbLevel  <xsl:value-of select="@reverbLevel" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@reverbDelay">reverbDelay  <xsl:value-of select="@reverbDelay" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="ApplicationWindow">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> ApplicationWindow { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
    
   <xsl:if test="@isActive">isActive  <xsl:value-of select="@isActive" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@startTime">startTime  <xsl:value-of select="@startTime" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@stopTime">stopTime  <xsl:value-of select="@stopTime" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@description">description " <xsl:value-of select="@description" />"<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@size">size  <xsl:value-of select="@size" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="parameter | url" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="BAP">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> BAP { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@sacroiliac_tilt">sacroiliac_tilt  <xsl:value-of select="@sacroiliac_tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@sacroiliac_torsion">sacroiliac_torsion  <xsl:value-of select="@sacroiliac_torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@sacroiliac_roll">sacroiliac_roll  <xsl:value-of select="@sacroiliac_roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_hip_flexion">l_hip_flexion  <xsl:value-of select="@l_hip_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_hip_flexion">r_hip_flexion  <xsl:value-of select="@r_hip_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_hip_abduct">l_hip_abduct  <xsl:value-of select="@l_hip_abduct" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_hip_abduct">r_hip_abduct  <xsl:value-of select="@r_hip_abduct" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_hip_twisting">l_hip_twisting  <xsl:value-of select="@l_hip_twisting" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_hip_twisting">r_hip_twisting  <xsl:value-of select="@r_hip_twisting" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_knee_flexion">l_knee_flexion  <xsl:value-of select="@l_knee_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_knee_flexion">r_knee_flexion  <xsl:value-of select="@r_knee_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_knee_twisting">l_knee_twisting  <xsl:value-of select="@l_knee_twisting" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_knee_twisting">r_knee_twisting  <xsl:value-of select="@r_knee_twisting" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_ankle_flexion">l_ankle_flexion  <xsl:value-of select="@l_ankle_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_ankle_flexion">r_ankle_flexion  <xsl:value-of select="@r_ankle_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_ankle_twisting">l_ankle_twisting  <xsl:value-of select="@l_ankle_twisting" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_ankle_twisting">r_ankle_twisting  <xsl:value-of select="@r_ankle_twisting" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_subtalar_flexion">l_subtalar_flexion  <xsl:value-of select="@l_subtalar_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_subtalar_flexion">r_subtalar_flexion  <xsl:value-of select="@r_subtalar_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_midtarsal_flexion">l_midtarsal_flexion  <xsl:value-of select="@l_midtarsal_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_midtarsal_flexion">r_midtarsal_flexion  <xsl:value-of select="@r_midtarsal_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_metatarsal_flexion">l_metatarsal_flexion  <xsl:value-of select="@l_metatarsal_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_metatarsal_flexion">r_metatarsal_flexion  <xsl:value-of select="@r_metatarsal_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_sternoclavicular_abduct">l_sternoclavicular_abduct  <xsl:value-of select="@l_sternoclavicular_abduct" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_sternoclavicular_abduct">r_sternoclavicular_abduct  <xsl:value-of select="@r_sternoclavicular_abduct" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_sternoclavicular_rotate">l_sternoclavicular_rotate  <xsl:value-of select="@l_sternoclavicular_rotate" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_sternoclavicular_rotate">r_sternoclavicular_rotate  <xsl:value-of select="@r_sternoclavicular_rotate" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_acromioclavicular_abduct">l_acromioclavicular_abduct  <xsl:value-of select="@l_acromioclavicular_abduct" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_acromioclavicular_abduct">r_acromioclavicular_abduct  <xsl:value-of select="@r_acromioclavicular_abduct" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_acromioclavicular_rotate">l_acromioclavicular_rotate  <xsl:value-of select="@l_acromioclavicular_rotate" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_acromioclavicular_rotate">r_acromioclavicular_rotate  <xsl:value-of select="@r_acromioclavicular_rotate" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_shoulder_flexion">l_shoulder_flexion  <xsl:value-of select="@l_shoulder_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_shoulder_flexion">r_shoulder_flexion  <xsl:value-of select="@r_shoulder_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_shoulder_abduct">l_shoulder_abduct  <xsl:value-of select="@l_shoulder_abduct" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_shoulder_abduct">r_shoulder_abduct  <xsl:value-of select="@r_shoulder_abduct" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_shoulder_twisting">l_shoulder_twisting  <xsl:value-of select="@l_shoulder_twisting" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_shoulder_twisting">r_shoulder_twisting  <xsl:value-of select="@r_shoulder_twisting" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_elbow_flexion">l_elbow_flexion  <xsl:value-of select="@l_elbow_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_elbow_flexion">r_elbow_flexion  <xsl:value-of select="@r_elbow_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_elbow_twisting">l_elbow_twisting  <xsl:value-of select="@l_elbow_twisting" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_elbow_twisting">r_elbow_twisting  <xsl:value-of select="@r_elbow_twisting" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_wrist_flexion">l_wrist_flexion  <xsl:value-of select="@l_wrist_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_wrist_flexion">r_wrist_flexion  <xsl:value-of select="@r_wrist_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_wrist_pivot">l_wrist_pivot  <xsl:value-of select="@l_wrist_pivot" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_wrist_pivot">r_wrist_pivot   <xsl:value-of select="@r_wrist_pivot" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_wrist_twisting">l_wrist_twisting  <xsl:value-of select="@l_wrist_twisting" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_wrist_twisting">r_wrist_twisting  <xsl:value-of select="@r_wrist_twisting" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@skullbase_roll">skullbase_roll  <xsl:value-of select="@skullbase_roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@skullbase_torsion">skullbase_torsion  <xsl:value-of select="@skullbase_torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@skullbase_tilt">skullbase_tilt  <xsl:value-of select="@skullbase_tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vc1roll">vc1roll  <xsl:value-of select="@vc1roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vc1torsion">vc1torsion  <xsl:value-of select="@vc1torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vc1tilt">vc1tilt  <xsl:value-of select="@vc1tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vc2roll">vc2roll   <xsl:value-of select="@vc2roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vc2torsion">vc2torsion  <xsl:value-of select="@vc2torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vc2tilt">vc2tilt   <xsl:value-of select="@vc2tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vc3roll">vc3roll   <xsl:value-of select="@vc3roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vc3torsion">vc3torsion  <xsl:value-of select="@vc3torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vc3tilt">vc3tilt   <xsl:value-of select="@vc3tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vc4roll">vc4roll  <xsl:value-of select="@vc4roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vc4torsion">vc4torsion  <xsl:value-of select="@vc4torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vc4tilt">vc4tilt   <xsl:value-of select="@vc4tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vc5roll">vc5roll  <xsl:value-of select="@vc5roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vc5torsion">vc5torsion   <xsl:value-of select="@vc5torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vc5tilt">vc5tilt  <xsl:value-of select="@vc5tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vc6roll">vc6roll  <xsl:value-of select="@vc6roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vc6torsion">vc6torsion  <xsl:value-of select="@vc6torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vc6tilt">vc6tilt  <xsl:value-of select="@vc6tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vc7roll">vc7roll  <xsl:value-of select="@vc7roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vc7torsion">vc7torsion  <xsl:value-of select="@vc7torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vc7tilt">vc7tilt  <xsl:value-of select="@vc7tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt1roll">vt1roll  <xsl:value-of select="@vt1roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt1torsion">vt1torsion  <xsl:value-of select="@vt1torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt1tilt">vt1tilt   <xsl:value-of select="@vt1tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt2roll">vt2roll   <xsl:value-of select="@vt2roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt2torsion">vt2torsion  <xsl:value-of select="@vt2torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt2tilt">vt2tilt  <xsl:value-of select="@vt2tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt3roll">vt3roll  <xsl:value-of select="@vt3roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt3torsion">vt3torsion  <xsl:value-of select="@vt3torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt3tilt">vt3tilt  <xsl:value-of select="@vt3tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt4roll">vt4roll  <xsl:value-of select="@vt4roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt4torsion">vt4torsion  <xsl:value-of select="@vt4torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt4tilt">vt4tilt  <xsl:value-of select="@vt4tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt5roll">vt5roll  <xsl:value-of select="@vt5roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt5torsion">vt5torsion  <xsl:value-of select="@vt5torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt5tilt">vt5tilt  <xsl:value-of select="@vt5tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt6roll">vt6roll  <xsl:value-of select="@vt6roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt6torsion">vt6torsion  <xsl:value-of select="@vt6torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt6tilt">vt6tilt  <xsl:value-of select="@vt6tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt7roll">vt7roll   <xsl:value-of select="@vt7roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt7torsion">vt7torsion  <xsl:value-of select="@vt7torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt7tilt">vt7tilt  <xsl:value-of select="@vt7tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt8roll">vt8roll   <xsl:value-of select="@vt8roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt8torsion">vt8torsion  <xsl:value-of select="@vt8torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt8tilt">vt8tilt  <xsl:value-of select="@vt8tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt9roll">vt9roll  <xsl:value-of select="@vt9roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt9torsion">vt9torsion  <xsl:value-of select="@vt9torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt9tilt">vt9tilt  <xsl:value-of select="@vt9tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt10roll">vt10roll  <xsl:value-of select="@vt10roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt10torsion">vt10torsion  <xsl:value-of select="@vt10torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt10tilt">vt10tilt  <xsl:value-of select="@vt10tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt11roll">vt11roll  <xsl:value-of select="@vt11roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt11torsion">vt11torsion  <xsl:value-of select="@vt11torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt11tilt">vt11tilt  <xsl:value-of select="@vt11tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt12roll">vt12roll  <xsl:value-of select="@vt12roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt12torsion">vt12torsion  <xsl:value-of select="@vt12torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vt12tilt">vt12tilt  <xsl:value-of select="@vt12tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vl1roll">vl1roll  <xsl:value-of select="@vl1roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vl1torsion">vl1torsion  <xsl:value-of select="@vl1torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vl1tilt">vl1tilt   <xsl:value-of select="@vl1tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vl2roll">vl2roll  <xsl:value-of select="@vl2roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vl2torsion">vl2torsion  <xsl:value-of select="@vl2torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vl2tilt">vl2tilt  <xsl:value-of select="@vl2tilt" /><xsl:text>
   </xsl:text>  
   </xsl:if>

   <xsl:if test="@vl3roll">vl3roll  <xsl:value-of select="@vl3roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vl3torsion">vl3torsion  <xsl:value-of select="@vl3torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vl3tilt">vl3tilt  <xsl:value-of select="@vl3tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vl4roll">vl4roll  <xsl:value-of select="@vl4roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vl4torsion">vl4torsion  <xsl:value-of select="@vl4torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vl4tilt">vl4tilt  <xsl:value-of select="@vl4tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vl5roll">vl5roll  <xsl:value-of select="@vl5roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vl5torsion">vl5torsion  <xsl:value-of select="@vl5torsion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vl5tilt">vl5tilt  <xsl:value-of select="@vl5tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_pinky0_flexion">l_pinky0_flexion  <xsl:value-of select="@l_pinky0_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_pinky0_flexion">r_pinky0_flexion  <xsl:value-of select="@r_pinky0_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_pinky1_flexion">l_pinky1_flexion  <xsl:value-of select="@l_pinky1_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_pinky1_flexion">r_pinky1_flexion  <xsl:value-of select="@r_pinky1_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_pinky1_pivot">l_pinky1_pivot   <xsl:value-of select="@l_pinky1_pivot" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_pinky1_pivot">r_pinky1_pivot  <xsl:value-of select="@r_pinky1_pivot" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_pinky1_twisting">l_pinky1_twisting  <xsl:value-of select="@l_pinky1_twisting" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_pinky1_twisting">r_pinky1_twisting  <xsl:value-of select="@r_pinky1_twisting" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_pinky2_flexion">l_pinky2_flexion  <xsl:value-of select="@l_pinky2_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_pinky2_flexion">r_pinky2_flexion   <xsl:value-of select="@r_pinky2_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_pinky3_flexion">l_pinky3_flexion  <xsl:value-of select="@l_pinky3_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_pinky3_flexion">r_pinky3_flexion  <xsl:value-of select="@r_pinky3_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_ring0_flexion">l_ring0_flexion  <xsl:value-of select="@l_ring0_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_ring0_flexion">r_ring0_flexion  <xsl:value-of select="@r_ring0_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_ring1_flexion">l_ring1_flexion  <xsl:value-of select="@l_ring1_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_ring1_flexion">r_ring1_flexion  <xsl:value-of select="@r_ring1_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_ring1_pivot">l_ring1_pivot  <xsl:value-of select="@l_ring1_pivot" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_ring1_pivot">r_ring1_pivot  <xsl:value-of select="@r_ring1_pivot" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_ring1_twisting">l_ring1_twisting  <xsl:value-of select="@l_ring1_twisting" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_ring1_twisting">r_ring1_twisting  <xsl:value-of select="@r_ring1_twisting" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_ring2_flexion">l_ring2_flexion  <xsl:value-of select="@l_ring2_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_ring2_flexion">r_ring2_flexion  <xsl:value-of select="@r_ring2_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_ring3_flexion">l_ring3_flexion  <xsl:value-of select="@l_ring3_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_ring3_flexion">r_ring3_flexion  <xsl:value-of select="@r_ring3_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_middle0_flexion">l_middle0_flexion  <xsl:value-of select="@l_middle0_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_middle0_flexion">r_middle0_flexion  <xsl:value-of select="@r_middle0_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_middle1_flexion">l_middle1_flexion  <xsl:value-of select="@l_middle1_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_middle1_flexion">r_middle1_flexion  <xsl:value-of select="@r_middle1_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_middle1_pivot">l_middle1_pivot  <xsl:value-of select="@l_middle1_pivot" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_middle1_pivot">r_middle1_pivot  <xsl:value-of select="@r_middle1_pivot" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_middle1_twisting">l_middle1_twisting  <xsl:value-of select="@l_middle1_twisting" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_middle1_twisting">r_middle1_twisting  <xsl:value-of select="@r_middle1_twisting" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_middle2_flexion">l_middle2_flexion  <xsl:value-of select="@l_middle2_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_middle2_flexion">r_middle2_flexion  <xsl:value-of select="@r_middle2_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_middle3_flexion">l_middle3_flexion  <xsl:value-of select="@l_middle3_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_middle3_flexion">r_middle3_flexion  <xsl:value-of select="@r_middle3_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_index0_flexion">l_index0_flexion  <xsl:value-of select="@l_index0_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_index0_flexion">r_index0_flexion  <xsl:value-of select="@r_index0_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_index1_flexion">l_index1_flexion  <xsl:value-of select="@l_index1_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_index1_flexion">r_index1_flexion  <xsl:value-of select="@r_index1_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_index1_pivot">l_index1_pivot  <xsl:value-of select="@l_index1_pivot" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_index1_pivot">r_index1_pivot  <xsl:value-of select="@r_index1_pivot" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_index1_twisting">l_index1_twisting   <xsl:value-of select="@l_index1_twisting" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_index1_twisting">r_index1_twisting  <xsl:value-of select="@r_index1_twisting" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_index2_flexion">l_index2_flexion  <xsl:value-of select="@l_index2_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_index2_flexion">r_index2_flexion  <xsl:value-of select="@r_index2_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_index3_flexion">l_index3_flexion  <xsl:value-of select="@l_index3_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_index3_flexion">r_index3_flexion  <xsl:value-of select="@r_index3_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_thumb1_flexion">l_thumb1_flexion  <xsl:value-of select="@l_thumb1_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_thumb1_flexion">r_thumb1_flexion  <xsl:value-of select="@r_thumb1_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_thumb1_pivot">l_thumb1_pivot  <xsl:value-of select="@l_thumb1_pivot" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_thumb1_pivot">r_thumb1_pivot  <xsl:value-of select="@r_thumb1_pivot" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_thumb1_twisting">l_thumb1_twisting  <xsl:value-of select="@l_thumb1_twisting" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_thumb1_twisting">r_thumb1_twisting  <xsl:value-of select="@r_thumb1_twisting" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_thumb2_flexion">l_thumb2_flexion  <xsl:value-of select="@l_thumb2_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_thumb2_flexion">r_thumb2_flexion  <xsl:value-of select="@r_thumb2_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@l_thumb3_flexion">l_thumb3_flexion  <xsl:value-of select="@l_thumb3_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@r_thumb3_flexion">r_thumb3_flexion  <xsl:value-of select="@r_thumb3_flexion" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@HumanoidRoot_tr_vertical">HumanoidRoot_tr_vertical  <xsl:value-of select="@HumanoidRoot_tr_vertical" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@HumanoidRoot_tr_lateral">HumanoidRoot_tr_lateral  <xsl:value-of select="@HumanoidRoot_tr_lateral" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@HumanoidRoot_tr_frontal">HumanoidRoot_tr_frontal  <xsl:value-of select="@HumanoidRoot_tr_frontal" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@HumanoidRoot_rt_body_turn">HumanoidRoot_rt_body_turn  <xsl:value-of select="@HumanoidRoot_rt_body_turn" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@HumanoidRoot_rt_body_roll">HumanoidRoot_rt_body_roll  <xsl:value-of select="@HumanoidRoot_rt_body_roll" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@HumanoidRoot_rt_body_tilt">HumanoidRoot_rt_body_tilt  <xsl:value-of select="@HumanoidRoot_rt_body_tilt" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap187">extensionBap187  <xsl:value-of select="@extensionBap187" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap188">extensionBap188  <xsl:value-of select="@extensionBap188" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap189">extensionBap189  <xsl:value-of select="@extensionBap189" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap190">extensionBap190  <xsl:value-of select="@extensionBap190" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap191">extensionBap191  <xsl:value-of select="@extensionBap191" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap192">extensionBap192  <xsl:value-of select="@extensionBap192" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap193">extensionBap193  <xsl:value-of select="@extensionBap193" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap194">extensionBap194  <xsl:value-of select="@extensionBap194" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap195">extensionBap195  <xsl:value-of select="@extensionBap195" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap196">extensionBap196  <xsl:value-of select="@extensionBap196" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap197">extensionBap197  <xsl:value-of select="@extensionBap197" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap198">extensionBap198  <xsl:value-of select="@extensionBap198" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap199">extensionBap199  <xsl:value-of select="@extensionBap199" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap200">extensionBap200  <xsl:value-of select="@extensionBap200" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap201">extensionBap201  <xsl:value-of select="@extensionBap201" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap202">extensionBap202  <xsl:value-of select="@extensionBap202" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap203">extensionBap203  <xsl:value-of select="@extensionBap203" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap204">extensionBap204  <xsl:value-of select="@extensionBap204" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap205">extensionBap205   <xsl:value-of select="@extensionBap205" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap206">extensionBap206  <xsl:value-of select="@extensionBap206" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap207">extensionBap207  <xsl:value-of select="@extensionBap207" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap208">extensionBap208  <xsl:value-of select="@extensionBap208" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap209">extensionBap209  <xsl:value-of select="@extensionBap209" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap210">extensionBap210  <xsl:value-of select="@extensionBap210" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap211">extensionBap211  <xsl:value-of select="@extensionBap211" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap212">extensionBap212  <xsl:value-of select="@extensionBap212" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap213">extensionBap213   <xsl:value-of select="@extensionBap213" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap214">extensionBap214  <xsl:value-of select="@extensionBap214" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap215">extensionBap215   <xsl:value-of select="@extensionBap215" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap216">extensionBap216  <xsl:value-of select="@extensionBap216" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap217">extensionBap217  <xsl:value-of select="@extensionBap217" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap218">extensionBap218  <xsl:value-of select="@extensionBap218" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap219">extensionBap219  <xsl:value-of select="@extensionBap219" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap220">extensionBap220  <xsl:value-of select="@extensionBap220" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap221">extensionBap221  <xsl:value-of select="@extensionBap221" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap222">extensionBap222  <xsl:value-of select="@extensionBap222" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap223">extensionBap223  <xsl:value-of select="@extensionBap223" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap224">extensionBap224  <xsl:value-of select="@extensionBap224" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap225">extensionBap225  <xsl:value-of select="@extensionBap225" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap226">extensionBap226  <xsl:value-of select="@extensionBap226" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap227">extensionBap227  <xsl:value-of select="@extensionBap227" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap228">extensionBap228  <xsl:value-of select="@extensionBap228" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap229">extensionBap229  <xsl:value-of select="@extensionBap229" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap230">extensionBap230  <xsl:value-of select="@extensionBap230" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap231">extensionBap231  <xsl:value-of select="@extensionBap231" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap232">extensionBap232  <xsl:value-of select="@extensionBap232" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap233">extensionBap233  <xsl:value-of select="@extensionBap233" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap234">extensionBap234  <xsl:value-of select="@extensionBap234" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap235">extensionBap235  <xsl:value-of select="@extensionBap235" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap236">extensionBap236   <xsl:value-of select="@extensionBap236" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap237">extensionBap237  <xsl:value-of select="@extensionBap237" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap238">extensionBap238  <xsl:value-of select="@extensionBap238" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap239">extensionBap239  <xsl:value-of select="@extensionBap239" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap240">extensionBap240  <xsl:value-of select="@extensionBap240" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap241">extensionBap241  <xsl:value-of select="@extensionBap241" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap242">extensionBap242  <xsl:value-of select="@extensionBap242" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap243">extensionBap243  <xsl:value-of select="@extensionBap243" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap244">extensionBap244  <xsl:value-of select="@extensionBap244" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap245">extensionBap245  <xsl:value-of select="@extensionBap245" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap246">extensionBap246  <xsl:value-of select="@extensionBap246" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap247">extensionBap247   <xsl:value-of select="@extensionBap247" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap248">extensionBap248  <xsl:value-of select="@extensionBap248" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap249">extensionBap249  <xsl:value-of select="@extensionBap249" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap250">extensionBap250  <xsl:value-of select="@extensionBap250" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap251">extensionBap251  <xsl:value-of select="@extensionBap251" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap252">extensionBap252  <xsl:value-of select="@extensionBap252" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap253">extensionBap253  <xsl:value-of select="@extensionBap253" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap254">extensionBap254  <xsl:value-of select="@extensionBap254" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap255">extensionBap255  <xsl:value-of select="@extensionBap255" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap256">extensionBap256  <xsl:value-of select="@extensionBap256" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap257">extensionBap257  <xsl:value-of select="@extensionBap257" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap258">extensionBap258  <xsl:value-of select="@extensionBap258" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap259">extensionBap259  <xsl:value-of select="@extensionBap259" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap260">extensionBap260  <xsl:value-of select="@extensionBap260" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap261">extensionBap261  <xsl:value-of select="@extensionBap261" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap262">extensionBap262  <xsl:value-of select="@extensionBap262" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap263">extensionBap263   <xsl:value-of select="@extensionBap263" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap264">extensionBap264  <xsl:value-of select="@extensionBap264" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap265">extensionBap265  <xsl:value-of select="@extensionBap265" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap266">extensionBap266  <xsl:value-of select="@extensionBap266" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap267">extensionBap267   <xsl:value-of select="@extensionBap267" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap268">extensionBap268   <xsl:value-of select="@extensionBap268" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap269">extensionBap269   <xsl:value-of select="@extensionBap269" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap270">extensionBap270  <xsl:value-of select="@extensionBap270" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap271">extensionBap271  <xsl:value-of select="@extensionBap271" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap272">extensionBap272  <xsl:value-of select="@extensionBap272" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap273">extensionBap273  <xsl:value-of select="@extensionBap273" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap274">extensionBap274  <xsl:value-of select="@extensionBap274" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap275">extensionBap275  <xsl:value-of select="@extensionBap275" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap276">extensionBap276  <xsl:value-of select="@extensionBap276" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap277">extensionBap277  <xsl:value-of select="@extensionBap277" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap278">extensionBap278  <xsl:value-of select="@extensionBap278" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap279">extensionBap279  <xsl:value-of select="@extensionBap279" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap280">extensionBap280  <xsl:value-of select="@extensionBap280" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap281">extensionBap281  <xsl:value-of select="@extensionBap281" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap282">extensionBap282  <xsl:value-of select="@extensionBap282" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap283">extensionBap283   <xsl:value-of select="@extensionBap283" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap284">extensionBap284  <xsl:value-of select="@extensionBap284" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap285">extensionBap285  <xsl:value-of select="@extensionBap285" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap286">extensionBap286  <xsl:value-of select="@extensionBap286" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap287">extensionBap287   <xsl:value-of select="@extensionBap287" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap288">extensionBap288  <xsl:value-of select="@extensionBap288" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap289">extensionBap289  <xsl:value-of select="@extensionBap289" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap290">extensionBap290  <xsl:value-of select="@extensionBap290" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap291">extensionBap291  <xsl:value-of select="@extensionBap291" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap292">extensionBap292  <xsl:value-of select="@extensionBap292" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap293">extensionBap293  <xsl:value-of select="@extensionBap293" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap294">extensionBap294  <xsl:value-of select="@extensionBap294" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap295">extensionBap295  <xsl:value-of select="@extensionBap295" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@extensionBap296">extensionBap296  <xsl:value-of select="@extensionBap296" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="BDP">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> BDP { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:apply-templates />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Body">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Body { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:apply-templates />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="BodyDefTable">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> BodyDefTable { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@bodySceneGraphNodeName">bodySceneGraphNodeName " <xsl:value-of select="@bodySceneGraphNodeName" />"<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@bapIDs">bapIDs [ <xsl:value-of select="@bapIDs" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@vertexIds">vertexIds [ <xsl:value-of select="@vertexIds" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@bapCombinations">bapCombinations [ <xsl:value-of select="@bapCombinations" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@displacements">displacements [ <xsl:value-of select="@displacements" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@numInterpolateKeys">numInterpolateKeys  <xsl:value-of select="@numInterpolateKeys" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="BodySegmentConnectionHint">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> BodySegmentConnectionHint { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@firstSegmentNodeName">firstSegmentNodeName " <xsl:value-of select="@firstSegmentNodeName" />"<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@secondSegmentNodeName">secondSegmentNodeName " <xsl:value-of select="@secondSegmentNodeName" />"<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@firstVertexIdList">firstVertexIdList [ <xsl:value-of select="@firstVertexIdList" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@secondVertexIdList">secondVertexIdList [ <xsl:value-of select="@secondVertexIdList" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="DirectiveSound">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> DirectiveSound { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@direction">direction  <xsl:value-of select="@direction" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@intensity">intensity  <xsl:value-of select="@intensity" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@location">location  <xsl:value-of select="@location" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@roomEffect">roomEffect  <xsl:value-of select="@roomEffect" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@spatialize">spatialize  <xsl:value-of select="@spatialize" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@directivity">directivity [ <xsl:value-of select="@directivity" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@angles">angles [ <xsl:value-of select="@angles" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@frequency">frequency [ <xsl:value-of select="@frequency" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@speedOfSound">speedOfSound  <xsl:value-of select="@speedOfSound" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@distance">distance  <xsl:value-of select="@distance" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@useAirabs">useAirabs  <xsl:value-of select="@useAirabs" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="source | perceptualParameters" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="Hierarchical3DMesh">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> Hierarchical3DMesh { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@triangleBudget">triangleBudget  <xsl:value-of select="@triangleBudget" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@level">level  <xsl:value-of select="@level" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@doneLoading">doneLoading  <xsl:value-of select="@doneLoading" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="url" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="MaterialKey">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> MaterialKey { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@isKeyed">isKeyed  <xsl:value-of select="@isKeyed" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@isRGB">isRGB  <xsl:value-of select="@isRGB" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@keyColor">keyColor  <xsl:value-of select="@keyColor" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@lowThreshold">lowThreshold  <xsl:value-of select="@lowThreshold" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@highThreshold">highThreshold  <xsl:value-of select="@highThreshold" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@transparency">transparency  <xsl:value-of select="@transparency" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="PerceptualParameters">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> PerceptualParameters { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@sourcePresence">sourcePresence  <xsl:value-of select="@sourcePresence" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@sourceWarmth">sourceWarmth  <xsl:value-of select="@sourceWarmth" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@sourceBrilliance">sourceBrilliance  <xsl:value-of select="@sourceBrilliance" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@roomPresence">roomPresence  <xsl:value-of select="@roomPresence" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@runningReverberance">runningReverberance  <xsl:value-of select="@runningReverberance" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@envelopment">envelopment  <xsl:value-of select="@envelopment" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@lateReverberance">lateReverberance  <xsl:value-of select="@lateReverberance" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@heavyness">heavyness  <xsl:value-of select="@heavyness" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@liveness">liveness  <xsl:value-of select="@liveness" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@omniDirectivity">omniDirectivity [ <xsl:value-of select="@omniDirectivity" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@directFilterGains">directFilterGains [ <xsl:value-of select="@directFilterGains" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@inputFilterGains">inputFilterGains  [ <xsl:value-of select="@inputFilterGains" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@refDistance">refDistance  <xsl:value-of select="@refDistance" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@freqLow">freqLow  <xsl:value-of select="@freqLow" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@freqHigh">freqHigh  <xsl:value-of select="@freqHigh" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@timeLimit1">timeLimit1  <xsl:value-of select="@timeLimit1" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@timeLimit2">timeLimit2  <xsl:value-of select="@timeLimit2" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@timeLimit3">timeLimit3  <xsl:value-of select="@timeLimit3" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@modalDensity">modalDensity  <xsl:value-of select="@modalDensity" /><xsl:text>
   </xsl:text>
   </xsl:if>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="TemporalTransform">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> TemporalTransform { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   

   <xsl:if test="@startTime">startTime  <xsl:value-of select="@startTime" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@optimalDuration">optimalDuration  <xsl:value-of select="@optimalDuration" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@active">active  <xsl:value-of select="@active" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@speed">speed  <xsl:value-of select="@speed" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@scalability">scalability  <xsl:value-of select="@scalability" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@stretchMode">stretchMode [ <xsl:value-of select="@stretchMode" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@shrinkMode">shrinkMode [ <xsl:value-of select="@shrinkMode" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@maxDelay">maxDelay  <xsl:value-of select="@maxDelay" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@actualDuration">actualDuration  <xsl:value-of select="@actualDuration" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="url | children" />

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="TemporalGroup">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> TemporalGroup { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@costart">costart  <xsl:value-of select="@costart" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@coend">coend  <xsl:value-of select="@coend" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@meet">meet  <xsl:value-of select="@meet" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@priority">priority [ <xsl:value-of select="@priority" />]<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@isActive">isActive  <xsl:value-of select="@isActive" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@activeChild">activeChild  <xsl:value-of select="@activeChild" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="children" /><xsl:text>
   </xsl:text>

   }</xsl:otherwise></xsl:choose></xsl:template>

   <xsl:template match="ServerCommand">
   <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> ServerCommand { 
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@trigger">trigger  <xsl:value-of select="@trigger" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@command">command " <xsl:value-of select="@command" />"<xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:if test="@enable">enable  <xsl:value-of select="@enable" /><xsl:text>
   </xsl:text>
   </xsl:if>

   <xsl:apply-templates select="url" />

   }</xsl:otherwise></xsl:choose></xsl:template>
 
  <xsl:template match="ProtoDeclare">
  PROTO  <xsl:value-of select="@name"/> [
  <xsl:apply-templates select="field" />
  ] <xsl:text>
  </xsl:text> { <xsl:apply-templates select="ProtoDeclare" />
     <xsl:apply-templates select="node()[not(self::field) and not(self::ProtoDeclare) and not(self::ROUTE)]" />
     <xsl:apply-templates select="ROUTE" />
  } </xsl:template>

  <xsl:template match="ProtoInstance">
  <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> <xsl:value-of select="@name" /> {
  <xsl:apply-templates select="fieldValue" />
 }</xsl:otherwise></xsl:choose></xsl:template>

  <xsl:template match="fieldValue">
       <xsl:value-of select="@name" /><xsl:text> </xsl:text>
   <xsl:choose>
   <xsl:when test="IS"> IS <xsl:value-of select="IS/connect/@protoField"/></xsl:when>
   <xsl:when test="@USE"> USE <xsl:value-of select="@USE"/></xsl:when>
   <xsl:when test="@colorValue"> <xsl:value-of select="@colorValue"/></xsl:when>
   <xsl:when test="@colorArrayValue">[ <xsl:value-of select="@colorArrayValue"/>]</xsl:when>
   <xsl:when test="@stringValue">" <xsl:value-of select="@stringValue"/>"</xsl:when>
   <xsl:when test="@floatValue"> <xsl:value-of select="@floatValue"/></xsl:when>
   <xsl:when test="@floatArrayValue">[ <xsl:value-of select="@floatArrayValue"/>]</xsl:when>
   <xsl:when test="@intValue"> <xsl:value-of select="@intValue"/></xsl:when>
   <xsl:when test="@intArrayValue">[ <xsl:value-of select="@intArrayValue"/>]</xsl:when>
   <xsl:when test="@booleanValue"> <xsl:value-of select="@booleanValue"/></xsl:when>
   <xsl:when test="@booleanArrayValue">[ <xsl:value-of select="@booleanArrayValue"/>]</xsl:when>
   <xsl:when test="@timeValue"> <xsl:value-of select="@timeValue"/></xsl:when>
   <xsl:when test="@timeArrayValue">[ <xsl:value-of select="@timeArrayValue"/>]</xsl:when>
   <xsl:when test="@rotationValue"> <xsl:value-of select="@rotationValue"/></xsl:when>
   <xsl:when test="@rotationArrayValue">[ <xsl:value-of select="@rotationArrayValue"/>]</xsl:when>
   <xsl:when test="@vector2Value"> <xsl:value-of select="@vector2Value"/></xsl:when>
   <xsl:when test="@vector2ArrayValue">[ <xsl:value-of select="@vector2ArrayValue"/>]</xsl:when>
   <xsl:when test="@vector3Value"> <xsl:value-of select="@vector3Value"/></xsl:when>
   <xsl:when test="@vector3ArrayValue">[ <xsl:value-of select="@vector3ArrayValue"/>]</xsl:when>
   <xsl:when test="@imageValue"> <xsl:value-of select="@imageValue"/></xsl:when>
   <!-- imageArrayValue missing from Schema -->
   <xsl:when test="stringArrayValue">[ 
   <xsl:for-each select="stringArrayValue/string">" <xsl:value-of select="." />"<xsl:if test="position()!=last()">,</xsl:if><xsl:text>
   </xsl:text></xsl:for-each> ] </xsl:when>
   <xsl:when test="scriptArrayValue">[ 
   "<xsl:for-each select="scriptArrayValue/string"> <xsl:value-of select="." /><xsl:text>
   </xsl:text></xsl:for-each>"] </xsl:when>
   <xsl:when test="node"><xsl:apply-templates select="node/*" /></xsl:when>
   <xsl:when test="nodes">[<xsl:apply-templates select="nodes/*" />]</xsl:when>
   </xsl:choose><xsl:text>
   </xsl:text>
   </xsl:template>


   <xsl:template match="InputSensor">
    <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> InputSensor {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@enabled">enabled  <xsl:value-of select="@enabled" /><xsl:text>
   </xsl:text>
   </xsl:if>
   
   <xsl:if test="@url">url "<xsl:value-of select="@url" />"<xsl:text>
   </xsl:text>
   </xsl:if>
   
   <xsl:apply-templates select="buffer" />
   
   } </xsl:otherwise></xsl:choose></xsl:template>
   
   <xsl:template match="MediaSensor">
    <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> MediaSensor {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:apply-templates select="url" />
   }</xsl:otherwise></xsl:choose></xsl:template>

   
   <xsl:template match="MediaControl">
    <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> MediaControl {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@mediaStartTime">mediaStartTime  <xsl:value-of select="@mediaStartTime" /><xsl:text>
   </xsl:text>
   </xsl:if>
   
   <xsl:if test="@mediaStopTime">mediaStopTime  <xsl:value-of select="@mediaStopTime" /><xsl:text>
   </xsl:text>
   </xsl:if>
   
   <xsl:if test="@mediaSpeed">mediaSpeed  <xsl:value-of select="@mediaSpeed" /><xsl:text>
   </xsl:text>
   </xsl:if>
   
   <xsl:if test="@preRoll">preRoll  <xsl:value-of select="@preRoll" /><xsl:text>
   </xsl:text>
   </xsl:if>
   
   <xsl:if test="@mute">mute  <xsl:value-of select="@mute" /><xsl:text>
   </xsl:text>
   </xsl:if>
   
   <xsl:if test="@enabled">enabled  <xsl:value-of select="@enabled" /><xsl:text>
   </xsl:text>
   </xsl:if>
   
   <xsl:apply-templates select="url" />
   } </xsl:otherwise></xsl:choose></xsl:template>

   
   <xsl:template match="MediaBuffer">
    <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> MediaBuffer {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@mediaStartTime">mediaStartTime  <xsl:value-of select="@mediaStartTime" /><xsl:text>
   </xsl:text>
   </xsl:if>
   
   <xsl:if test="@mediaStopTime">mediaStopTime  <xsl:value-of select="@mediaStopTime" /><xsl:text>
   </xsl:text>
   </xsl:if>
   
   <xsl:if test="@bufferSize">bufferSize  <xsl:value-of select="@bufferSize" /><xsl:text>
   </xsl:text>
   </xsl:if>
   
   <xsl:if test="@enabled">enabled  <xsl:value-of select="@enabled" /><xsl:text>
   </xsl:text>
   </xsl:if>
   
   <xsl:apply-templates select="url" />

   } </xsl:otherwise></xsl:choose></xsl:template>

   
   <xsl:template match="MatteTexture">
    <xsl:choose>
   <xsl:when test="@USE">USE  <xsl:value-of select="@USE"/> </xsl:when>
   <xsl:otherwise><xsl:if test="@DEF">DEF  <xsl:value-of select="@DEF"/></xsl:if> MatteTexture {
   
   <xsl:if test="IS"><xsl:call-template name = "IS" /></xsl:if>
   
   <xsl:if test="@operation">operation "<xsl:value-of select="@operation" />"<xsl:text>
   </xsl:text>
   </xsl:if>
   
   <xsl:if test="@overwrite">overwrite  <xsl:value-of select="@overwrite" /><xsl:text>
   </xsl:text>
   </xsl:if>
   
   <xsl:if test="@fraction">fraction  <xsl:value-of select="@fraction" /><xsl:text>
   </xsl:text>
   </xsl:if>
   
   <xsl:if test="@parameter">parameter  <xsl:value-of select="@parameter" /><xsl:text>
   </xsl:text>
   </xsl:if>
   
   <xsl:apply-templates select="surface1 | surface2 | alphaSurface" />
   } </xsl:otherwise></xsl:choose></xsl:template>

   
   <xsl:template match="surface1">
   surface1 <xsl:apply-templates select="CompositeTexture2D | CompositeTexture3D | 
   ImageTexture | MovieTexture | PixelTexture | ProtoInstance" />
   </xsl:template>
   
   <xsl:template match="surface2">
   surface2 <xsl:apply-templates select="CompositeTexture2D | CompositeTexture3D | 
   ImageTexture | MovieTexture | PixelTexture | ProtoInstance" />
   </xsl:template>
   
   <xsl:template match="alphaSurface">
   alphaSurface <xsl:apply-templates select="CompositeTexture2D | CompositeTexture3D | 
   ImageTexture | MovieTexture | PixelTexture | ProtoInstance" />
   </xsl:template>
   
</xsl:stylesheet>

